/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var J=["require","exports","vs/base/common/lifecycle","vs/base/common/platform","vs/platform/instantiation/common/instantiation","vs/base/common/event","vs/platform/log/common/log","vs/base/common/uri","vs/base/common/path","vs/base/common/async","vs/base/common/network","vs/nls!vs/code/electron-main/main","vs/nls","vs/base/common/types","electron","vs/base/common/resources","vs/platform/configuration/common/configuration","vs/base/node/pfs","vs/platform/lifecycle/electron-main/lifecycleMainService","vs/base/common/errors","vs/base/common/buffer","vs/platform/files/common/files","vs/platform/product/common/productService","vs/base/common/strings","vs/platform/environment/electron-main/environmentMainService","vs/base/common/cancellation","os","vs/base/common/uuid","vs/platform/workspaces/common/workspaces","vs/base/common/extpath","fs","vs/platform/telemetry/common/telemetry","vs/base/common/process","vs/base/parts/ipc/common/ipc","vs/platform/windows/electron-main/windows","vs/base/common/arrays","vs/base/common/map","vs/platform/registry/common/platform","vs/platform/state/electron-main/state","vs/base/common/labels","child_process","vs/platform/update/common/update","vs/base/common/functional","vs/base/common/json","vs/base/common/objects","vs/platform/native/electron-main/nativeHostMainService","vs/base/common/decorators","vs/platform/product/common/product","vs/platform/configuration/common/configurationRegistry","vs/platform/request/common/request","vs/platform/backup/electron-main/backup","vs/platform/dialogs/electron-main/dialogMainService","vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/platform/environment/common/environment","vs/platform/environment/node/argvHelper","vs/platform/protocol/electron-main/protocol","vs/base/parts/ipc/node/ipc.net","vs/base/common/keyCodes","crypto","net","vs/platform/theme/electron-main/themeMainService","vs/platform/windows/common/windows","vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/base/common/iterator","vs/base/common/stream","vs/base/common/normalization","vs/base/node/id","vs/base/common/errorMessage","vs/base/node/processes","vs/platform/instantiation/common/descriptors","vs/platform/diagnostics/common/diagnostics","vs/platform/instantiation/common/serviceCollection","vs/base/common/performance","vs/platform/remote/common/remoteHosts","vs/platform/remote/common/tunnel","vs/platform/sign/common/sign","vs/platform/webview/common/webviewManagerService","vs/platform/update/electron-main/abstractUpdateService","vs/base/common/linkedList","vs/base/common/scanCode","vs/base/common/hash","vs/base/node/decoder","vs/base/node/extpath","vs/base/node/ps","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/electron-main/ipc.mp","vs/base/parts/storage/common/storage","vs/base/parts/ipc/node/ipc.cp","vs/platform/environment/node/argv","vs/platform/encryption/electron-main/encryptionMainService","vs/platform/externalTerminal/common/externalTerminal","vs/platform/environment/node/shellEnv","vs/platform/files/node/watcher/watcher","vs/platform/log/common/bufferLog","vs/platform/log/node/spdlogLog","vs/platform/files/common/io","vs/platform/storage/common/storage","vs/platform/telemetry/common/telemetryUtils","vs/platform/url/common/url","vs/platform/storage/electron-main/storageMainService","vs/platform/windows/electron-main/windowsFinder","vs/platform/launch/electron-main/launchMainService","vs/base/common/assert","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/processes","vs/base/common/keybindingParser","vs/base/common/stopwatch","vs/base/common/codicons","vs/base/common/console","vs/base/common/marshalling","vs/base/common/glob","vs/base/node/crypto","vs/base/node/macAddress","util","vs/base/node/ports","vs/base/node/powershell","vs/base/node/watcher","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/contextmenu/electron-main/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/ipc/electron-main/ipc.electron","vs/base/parts/storage/node/storage","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/keybindingLabels","vs/base/common/keybindingLabels","vs/nls!vs/base/node/processes","vs/base/node/shell","vs/nls!vs/code/electron-main/app","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/dialogs/electron-main/dialogMainService","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/issue/electron-main/issueMainService","vs/nls!vs/platform/menubar/electron-main/menubar","vs/nls!vs/platform/native/electron-main/nativeHostMainService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/update/common/update.config.contribution","vs/nls!vs/platform/windows/electron-main/window","vs/nls!vs/platform/windows/electron-main/windowsMainService","vs/nls!vs/platform/workspaces/common/workspaces","vs/nls!vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/nls!vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/driver/common/driverIpc","vs/platform/environment/common/environmentService","vs/platform/debug/electron-main/extensionHostDebugIpc","vs/platform/environment/node/userDataPath","path","vs/platform/environment/node/environmentService","vs/platform/environment/node/wait","vs/platform/extensions/common/extensionValidator","vs/platform/files/node/watcher/nsfw/watcherService","vs/platform/files/node/watcher/unix/watcherService","vs/platform/files/node/watcher/win32/csharpWatcherService","vs/platform/files/node/watcher/win32/watcherService","vs/platform/instantiation/common/graph","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/extensionUrlTrust","vs/platform/extensions/common/extensions","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/files/node/watcher/nodejs/watcherService","vs/platform/instantiation/common/instantiationService","vs/platform/keybinding/common/baseResolvedKeybinding","vs/platform/keybinding/common/usLayoutResolvedKeybinding","vs/platform/lifecycle/common/lifecycle","vs/platform/log/common/fileLog","vs/platform/log/common/logIpc","vs/platform/log/node/loggerService","vs/platform/menubar/common/menubar","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProvider","vs/platform/extensionManagement/node/extensionUrlTrustService","vs/platform/protocol/electron-main/protocolMainService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/configuration/common/configurationService","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteAgentConnection","vs/platform/request/node/proxy","url","vs/platform/serviceMachineId/common/serviceMachineId","vs/platform/sign/node/signService","vs/platform/keyboardLayout/electron-main/keyboardLayoutMainService","vs/platform/telemetry/common/commonProperties","vs/platform/diagnostics/node/diagnosticsService","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/telemetry/common/telemetryIpc","vs/platform/telemetry/common/telemetryService","vs/platform/theme/common/theme","vs/platform/theme/common/themeService","vs/platform/update/common/update.config.contribution","vs/platform/update/common/updateIpc","vs/platform/url/common/urlIpc","vs/platform/url/common/urlService","vs/platform/url/electron-main/electronUrlListener","vs/platform/webview/electron-main/webviewProtocolProvider","vs/platform/webview/electron-main/webviewMainService","vs/platform/windows/node/windowTracker","vs/platform/workspace/common/workspace","vs/platform/storage/electron-main/storageIpc","vs/platform/storage/electron-main/storageMain","vs/platform/windows/electron-main/windowsStateHandler","zlib","vs/platform/driver/node/driver","vs/platform/backup/electron-main/backupMainService","vs/code/electron-main/auth","vs/platform/driver/electron-main/driver","vs/platform/remote/node/nodeSocketFactory","vs/platform/remote/node/tunnelService","vs/platform/request/node/requestService","vs/platform/request/electron-main/requestMainService","vs/platform/sharedProcess/electron-main/sharedProcess","vs/platform/state/electron-main/stateMainService","vs/platform/update/electron-main/updateService.darwin","vs/platform/update/electron-main/updateService.linux","vs/platform/update/electron-main/updateService.snap","vs/platform/update/electron-main/updateService.win32","vs/platform/issue/electron-main/issueMainService","vs/platform/windows/electron-main/window","vs/platform/menubar/electron-main/menubar","vs/platform/menubar/electron-main/menubarMainService","vs/platform/windows/electron-main/windowsMainService","vs/platform/workspaces/electron-main/workspacesMainService","vs/code/electron-main/app","string_decoder","minimist","assert","vs/code/electron-main/main"],Z=function(z){for(var e=[],m=0,L=z.length;m<L;m++)e[m]=J[z[m]];return e};define(J[102],Z([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function m(L,A){if(!L)throw new Error(A?`Assertion failed (${A})`:"Assertion Failed")}e.ok=m}),define(J[46],Z([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function m(E){return(n,w,p)=>{let i=null,I=null;if(typeof p.value=="function"?(i="value",I=p.value):typeof p.get=="function"&&(i="get",I=p.get),!I)throw new Error("not supported");p[i]=E(I,w)}}e.createDecorator=m;function L(E,n,w){let p=null,i=null;if(typeof w.value=="function"?(p="value",i=w.value,i.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof w.get=="function"&&(p="get",i=w.get),!i)throw new Error("not supported");const I=`$memoize$${n}`;w[p]=function(...P){return this.hasOwnProperty(I)||Object.defineProperty(this,I,{configurable:!1,enumerable:!1,writable:!1,value:i.apply(this,P)}),this[I]}}e.memoize=L;function A(E,n,w){return m((p,i)=>{const I=`$debounce$${i}`,P=`$debounce$result$${i}`;return function(...y){this[P]||(this[P]=w?w():void 0),clearTimeout(this[I]),n&&(this[P]=n(this[P],...y),y=[this[P]]),this[I]=setTimeout(()=>{p.apply(this,y),this[P]=w?w():void 0},E)}})}e.debounce=A;function S(E,n,w){return m((p,i)=>{const I=`$throttle$timer$${i}`,P=`$throttle$result$${i}`,y=`$throttle$lastRun$${i}`,g=`$throttle$pending$${i}`;return function(...v){if(this[P]||(this[P]=w?w():void 0),(this[y]===null||this[y]===void 0)&&(this[y]=-Number.MAX_VALUE),n&&(this[P]=n(this[P],...v)),this[g])return;const D=this[y]+E;D<=Date.now()?(this[y]=Date.now(),p.apply(this,[this[P]]),this[P]=w?w():void 0):(this[g]=!0,this[I]=setTimeout(()=>{this[g]=!1,this[y]=Date.now(),p.apply(this,[this[P]]),this[P]=w?w():void 0},D-Date.now()))}})}e.throttle=S}),define(J[19],Z([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isPromiseCanceledError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class m{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(t){setTimeout(()=>{throw t.stack?new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.listeners.push(t),()=>{this._removeListener(t)}}emit(t){this.listeners.forEach(r=>{r(t)})}_removeListener(t){this.listeners.splice(this.listeners.indexOf(t),1)}setUnexpectedErrorHandler(t){this.unexpectedErrorHandler=t}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(t){this.unexpectedErrorHandler(t),this.emit(t)}onUnexpectedExternalError(t){this.unexpectedErrorHandler(t)}}e.ErrorHandler=m,e.errorHandler=new m;function L(a){e.errorHandler.setUnexpectedErrorHandler(a)}e.setUnexpectedErrorHandler=L;function A(a){w(a)||e.errorHandler.onUnexpectedError(a)}e.onUnexpectedError=A;function S(a){w(a)||e.errorHandler.onUnexpectedExternalError(a)}e.onUnexpectedExternalError=S;function E(a){if(a instanceof Error){let{name:t,message:r}=a;const s=a.stacktrace||a.stack;return{$isError:!0,name:t,message:r,stack:s}}return a}e.transformErrorForSerialization=E;const n="Canceled";function w(a){return a instanceof Error&&a.name===n&&a.message===n}e.isPromiseCanceledError=w;class p extends Error{constructor(){super(n);this.name=this.message}}e.CancellationError=p;function i(){const a=new Error(n);return a.name=a.message,a}e.canceled=i;function I(a){return a?new Error(`Illegal argument: ${a}`):new Error("Illegal argument")}e.illegalArgument=I;function P(a){return a?new Error(`Illegal state: ${a}`):new Error("Illegal state")}e.illegalState=P;function y(a){return a?new Error(`readonly property '${a} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=y;function g(a){const t=new Error(`${a} has been disposed`);return t.name="DISPOSED",t}e.disposed=g;function v(a){return a?a.message?a.message:a.stack?a.stack.split(`
`)[0]:String(a):"Error"}e.getErrorMessage=v;class D extends Error{constructor(t){super("NotImplemented");t&&(this.message=t)}}e.NotImplementedError=D;class b extends Error{constructor(t){super("NotSupported");t&&(this.message=t)}}e.NotSupportedError=b;class l extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=l;function u(a){const t=a;return t instanceof Error&&Array.isArray(t.actions)}e.isErrorWithActions=u;function c(a,t=Object.create(null)){const r=new Error(a);return t.actions&&(r.actions=t.actions),r}e.createErrorWithActions=c}),define(J[35],Z([0,1,19]),function(z,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.maxIndex=e.minIndex=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.uniqueFilter=e.distinctES6=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function L(N,F=0){return N[N.length-(1+F)]}e.tail=L;function A(N){if(N.length===0)throw new Error("Invalid tail call");return[N.slice(0,N.length-1),N[N.length-1]]}e.tail2=A;function S(N,F,R=(O,k)=>O===k){if(N===F)return!0;if(!N||!F||N.length!==F.length)return!1;for(let O=0,k=N.length;O<k;O++)if(!R(N[O],F[O]))return!1;return!0}e.equals=S;function E(N,F,R){let O=0,k=N.length-1;for(;O<=k;){const W=(O+k)/2|0,U=R(N[W],F);if(U<0)O=W+1;else if(U>0)k=W-1;else return W}return-(O+1)}e.binarySearch=E;function n(N,F){let R=0,O=N.length;if(O===0)return 0;for(;R<O;){const k=Math.floor((R+O)/2);F(N[k])?O=k:R=k+1}return R}e.findFirstInSorted=n;function w(N,F,R){if(N=N|0,N>=F.length)throw new TypeError("invalid index");let O=F[Math.floor(F.length*Math.random())],k=[],W=[],U=[];for(let q of F){const K=R(q,O);K<0?k.push(q):K>0?W.push(q):U.push(q)}return N<k.length?w(N,k,R):N<k.length+U.length?U[0]:w(N-(k.length+U.length),W,R)}e.quickSelect=w;function p(N,F){const R=[];let O;for(const k of N.slice(0).sort(F))!O||F(O[0],k)!==0?(O=[k],R.push(O)):O.push(k);return R}e.groupBy=p;function i(N,F,R){const O=[];function k(q,K,H){if(K===0&&H.length===0)return;const x=O[O.length-1];x&&x.start+x.deleteCount===q?(x.deleteCount+=K,x.toInsert.push(...H)):O.push({start:q,deleteCount:K,toInsert:H})}let W=0,U=0;for(;;){if(W===N.length){k(W,0,F.slice(U));break}if(U===F.length){k(W,N.length-W,[]);break}const q=N[W],K=F[U],H=R(q,K);H===0?(W+=1,U+=1):H<0?(k(W,1,[]),W+=1):H>0&&(k(W,0,[K]),U+=1)}return O}e.sortedDiff=i;function I(N,F,R){const O=i(N,F,R),k=[],W=[];for(const U of O)k.push(...N.slice(U.start,U.start+U.deleteCount)),W.push(...U.toInsert);return{removed:k,added:W}}e.delta=I;function P(N,F,R){if(R===0)return[];const O=N.slice(0,R).sort(F);return g(N,F,O,R,N.length),O}e.top=P;function y(N,F,R,O,k){return R===0?Promise.resolve([]):new Promise((W,U)=>{(async()=>{const q=N.length,K=N.slice(0,R).sort(F);for(let H=R,x=Math.min(R+O,q);H<q;H=x,x=Math.min(x+O,q)){if(H>R&&await new Promise(ne=>setTimeout(ne)),k&&k.isCancellationRequested)throw m.canceled();g(N,F,K,H,x)}return K})().then(W,U)})}e.topAsync=y;function g(N,F,R,O,k){for(const W=R.length;O<k;O++){const U=N[O];if(F(U,R[W-1])<0){R.pop();const q=n(R,K=>F(U,K)<0);R.splice(q,0,U)}}}function v(N){return N.filter(F=>!!F)}e.coalesce=v;function D(N){let F=0;for(let R=0;R<N.length;R++)N[R]&&(N[F]=N[R],F+=1);N.length=F}e.coalesceInPlace=D;function b(N,F,R){N.splice(R,0,N.splice(F,1)[0])}e.move=b;function l(N){return!Array.isArray(N)||N.length===0}e.isFalsyOrEmpty=l;function u(N){return Array.isArray(N)&&N.length>0}e.isNonEmptyArray=u;function c(N,F){if(!F)return N.filter((O,k)=>N.indexOf(O)===k);const R=Object.create(null);return N.filter(O=>{const k=F(O);return R[k]?!1:(R[k]=!0,!0)})}e.distinct=c;function a(N){const F=new Set;return N.filter(R=>F.has(R)?!1:(F.add(R),!0))}e.distinctES6=a;function t(N){const F=Object.create(null);return R=>{const O=N(R);return F[O]?!1:(F[O]=!0,!0)}}e.uniqueFilter=t;function r(N,F){for(let R=N.length-1;R>=0;R--){const O=N[R];if(F(O))return R}return-1}e.lastIndex=r;function s(N,F){return N.length>0?N[0]:F}e.firstOrDefault=s;function o(N,F,R=(O,k)=>O===k){let O=0;for(let k=0,W=Math.min(N.length,F.length);k<W&&R(N[k],F[k]);k++)O++;return O}e.commonPrefixLength=o;function h(N){return[].concat(...N)}e.flatten=h;function f(N,F){let R=typeof F=="number"?N:0;typeof F=="number"?R=N:(R=0,F=N);const O=[];if(R<=F)for(let k=R;k<F;k++)O.push(k);else for(let k=R;k>F;k--)O.push(k);return O}e.range=f;function d(N,F,R){return N.reduce((O,k)=>(O[F(k)]=R?R(k):k,O),Object.create(null))}e.index=d;function M(N,F){return N.push(F),()=>T(N,F)}e.insert=M;function T(N,F){const R=N.indexOf(F);if(R>-1)return N.splice(R,1),F}e.remove=T;function C(N,F,R){const O=N.slice(0,F),k=N.slice(F);return O.concat(R,k)}e.arrayInsert=C;function V(N,F){let R;if(typeof F=="number"){let O=F;R=()=>{const k=Math.sin(O++)*179426549;return k-Math.floor(k)}}else R=Math.random;for(let O=N.length-1;O>0;O-=1){const k=Math.floor(R()*(O+1)),W=N[O];N[O]=N[k],N[k]=W}}e.shuffle=V;function Q(N,F){const R=N.indexOf(F);R>-1&&(N.splice(R,1),N.unshift(F))}e.pushToStart=Q;function te(N,F){const R=N.indexOf(F);R>-1&&(N.splice(R,1),N.push(F))}e.pushToEnd=te;function B(N,F){return Array.isArray(N)?N.map(F):F(N)}e.mapArrayOrNot=B;function Y(N){return Array.isArray(N)?N:[N]}e.asArray=Y;function X(N){return N[Math.floor(Math.random()*N.length)]}e.getRandomElement=X;function _(N,F){for(const R of N){const O=F(R);if(O!==void 0)return O}}e.mapFind=_;function $(N,F){let R=Number.MAX_SAFE_INTEGER,O=0;return N.forEach((k,W)=>{const U=F(k);U<R&&(R=U,O=W)}),O}e.minIndex=$;function G(N,F){let R=Number.MIN_SAFE_INTEGER,O=0;return N.forEach((k,W)=>{const U=F(k);U>R&&(R=U,O=W)}),O}e.maxIndex=G}),define(J[42],Z([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function m(L){const A=this;let S=!1,E;return function(){return S||(S=!0,E=L.apply(A,arguments)),E}}e.once=m}),define(J[63],Z([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var m;(function(L){function A(a){return a&&typeof a=="object"&&typeof a[Symbol.iterator]=="function"}L.is=A;const S=Object.freeze([]);function E(){return S}L.empty=E;function*n(a){yield a}L.single=n;function w(a){return a||S}L.from=w;function p(a){return!a||a[Symbol.iterator]().next().done===!0}L.isEmpty=p;function i(a){return a[Symbol.iterator]().next().value}L.first=i;function I(a,t){for(const r of a)if(t(r))return!0;return!1}L.some=I;function P(a,t){for(const r of a)if(t(r))return r}L.find=P;function*y(a,t){for(const r of a)t(r)&&(yield r)}L.filter=y;function*g(a,t){let r=0;for(const s of a)yield t(s,r++)}L.map=g;function*v(...a){for(const t of a)for(const r of t)yield r}L.concat=v;function*D(a){for(const t of a)for(const r of t)yield r}L.concatNested=D;function b(a,t,r){let s=r;for(const o of a)s=t(s,o);return s}L.reduce=b;function*l(a,t,r=a.length){for(t<0&&(t+=a.length),r<0?r+=a.length:r>a.length&&(r=a.length);t<r;t++)yield a[t]}L.slice=l;function u(a,t=Number.POSITIVE_INFINITY){const r=[];if(t===0)return[r,a];const s=a[Symbol.iterator]();for(let o=0;o<t;o++){const h=s.next();if(h.done)return[r,L.empty()];r.push(h.value)}return[r,{[Symbol.iterator](){return s}}]}L.consume=u;function c(a,t,r=(s,o)=>s===o){const s=a[Symbol.iterator](),o=t[Symbol.iterator]();for(;;){const h=s.next(),f=o.next();if(h.done!==f.done)return!1;if(h.done)return!0;if(!r(h.value,f.value))return!1}}L.equals=c})(m=e.Iterable||(e.Iterable={}))}),define(J[43],Z([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var m;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(m=e.ScanError||(e.ScanError={}));var L;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(L=e.SyntaxKind||(e.SyntaxKind={}));var A;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(A=e.ParseErrorCode||(e.ParseErrorCode={}));var S;(function(t){t.DEFAULT={allowTrailingComma:!0}})(S=e.ParseOptions||(e.ParseOptions={}));function E(t,r=!1){let s=0,o=t.length,h="",f=0,d=16,M=0;function T(X){let _=0,$=0;for(;_<X;){const G=t.charCodeAt(s);if(G>=48&&G<=57)$=$*16+G-48;else if(G>=65&&G<=70)$=$*16+G-65+10;else if(G>=97&&G<=102)$=$*16+G-97+10;else break;s++,_++}return _<X&&($=-1),$}function C(X){s=X,h="",f=0,d=16,M=0}function V(){const X=s;if(t.charCodeAt(s)===48)s++;else for(s++;s<t.length&&p(t.charCodeAt(s));)s++;if(s<t.length&&t.charCodeAt(s)===46)if(s++,s<t.length&&p(t.charCodeAt(s)))for(s++;s<t.length&&p(t.charCodeAt(s));)s++;else return M=3,t.substring(X,s);let _=s;if(s<t.length&&(t.charCodeAt(s)===69||t.charCodeAt(s)===101))if(s++,(s<t.length&&t.charCodeAt(s)===43||t.charCodeAt(s)===45)&&s++,s<t.length&&p(t.charCodeAt(s))){for(s++;s<t.length&&p(t.charCodeAt(s));)s++;_=s}else M=3;return t.substring(X,_)}function Q(){let X="",_=s;for(;;){if(s>=o){X+=t.substring(_,s),M=2;break}const $=t.charCodeAt(s);if($===34){X+=t.substring(_,s),s++;break}if($===92){if(X+=t.substring(_,s),s++,s>=o){M=2;break}switch(t.charCodeAt(s++)){case 34:X+='"';break;case 92:X+="\\";break;case 47:X+="/";break;case 98:X+="\b";break;case 102:X+="\f";break;case 110:X+=`
`;break;case 114:X+="\r";break;case 116:X+="	";break;case 117:const N=T(4);N>=0?X+=String.fromCharCode(N):M=4;break;default:M=5}_=s;continue}if($>=0&&$<=31)if(w($)){X+=t.substring(_,s),M=2;break}else M=6;s++}return X}function te(){if(h="",M=0,f=s,s>=o)return f=o,d=17;let X=t.charCodeAt(s);if(n(X)){do s++,h+=String.fromCharCode(X),X=t.charCodeAt(s);while(n(X));return d=15}if(w(X))return s++,h+=String.fromCharCode(X),X===13&&t.charCodeAt(s)===10&&(s++,h+=`
`),d=14;switch(X){case 123:return s++,d=1;case 125:return s++,d=2;case 91:return s++,d=3;case 93:return s++,d=4;case 58:return s++,d=6;case 44:return s++,d=5;case 34:return s++,h=Q(),d=10;case 47:const _=s-1;if(t.charCodeAt(s+1)===47){for(s+=2;s<o&&!w(t.charCodeAt(s));)s++;return h=t.substring(_,s),d=12}if(t.charCodeAt(s+1)===42){s+=2;const $=o-1;let G=!1;for(;s<$;){if(t.charCodeAt(s)===42&&t.charCodeAt(s+1)===47){s+=2,G=!0;break}s++}return G||(s++,M=1),h=t.substring(_,s),d=13}return h+=String.fromCharCode(X),s++,d=16;case 45:if(h+=String.fromCharCode(X),s++,s===o||!p(t.charCodeAt(s)))return d=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return h+=V(),d=11;default:for(;s<o&&B(X);)s++,X=t.charCodeAt(s);if(f!==s){switch(h=t.substring(f,s),h){case"true":return d=8;case"false":return d=9;case"null":return d=7}return d=16}return h+=String.fromCharCode(X),s++,d=16}}function B(X){if(n(X)||w(X))return!1;switch(X){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function Y(){let X;do X=te();while(X>=12&&X<=15);return X}return{setPosition:C,getPosition:()=>s,scan:r?Y:te,getToken:()=>d,getTokenValue:()=>h,getTokenOffset:()=>f,getTokenLength:()=>s-f,getTokenError:()=>M}}e.createScanner=E;function n(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function w(t){return t===10||t===13||t===8232||t===8233}function p(t){return t>=48&&t<=57}var i;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(i||(i={}));function I(t,r){const s=[],o=new Object;let h;const f={value:{},offset:0,length:0,type:"object",parent:void 0};let d=!1;function M(T,C,V,Q){f.value=T,f.offset=C,f.length=V,f.type=Q,f.colonOffset=void 0,h=f}try{u(t,{onObjectBegin:(T,C)=>{if(r<=T)throw o;h=void 0,d=r>T,s.push("")},onObjectProperty:(T,C,V)=>{if(r<C||(M(T,C,V,"property"),s[s.length-1]=T,r<=C+V))throw o},onObjectEnd:(T,C)=>{if(r<=T)throw o;h=void 0,s.pop()},onArrayBegin:(T,C)=>{if(r<=T)throw o;h=void 0,s.push(0)},onArrayEnd:(T,C)=>{if(r<=T)throw o;h=void 0,s.pop()},onLiteralValue:(T,C,V)=>{if(r<C||(M(T,C,V,a(T)),r<=C+V))throw o},onSeparator:(T,C,V)=>{if(r<=C)throw o;if(T===":"&&h&&h.type==="property")h.colonOffset=C,d=!1,h=void 0;else if(T===","){const Q=s[s.length-1];typeof Q=="number"?s[s.length-1]=Q+1:(d=!0,s[s.length-1]=""),h=void 0}}})}catch(T){if(T!==o)throw T}return{path:s,previousNode:h,isAtPropertyKey:d,matches:T=>{let C=0;for(let V=0;C<T.length&&V<s.length;V++)if(T[C]===s[V]||T[C]==="*")C++;else if(T[C]!=="**")return!1;return C===T.length}}}e.getLocation=I;function P(t,r=[],s=S.DEFAULT){let o=null,h=[];const f=[];function d(T){Array.isArray(h)?h.push(T):o!==null&&(h[o]=T)}return u(t,{onObjectBegin:()=>{const T={};d(T),f.push(h),h=T,o=null},onObjectProperty:T=>{o=T},onObjectEnd:()=>{h=f.pop()},onArrayBegin:()=>{const T=[];d(T),f.push(h),h=T,o=null},onArrayEnd:()=>{h=f.pop()},onLiteralValue:d,onError:(T,C,V)=>{r.push({error:T,offset:C,length:V})}},s),h[0]}e.parse=P;function y(t,r=[],s=S.DEFAULT){let o={type:"array",offset:-1,length:-1,children:[],parent:void 0};function h(T){o.type==="property"&&(o.length=T-o.offset,o=o.parent)}function f(T){return o.children.push(T),T}u(t,{onObjectBegin:T=>{o=f({type:"object",offset:T,length:-1,parent:o,children:[]})},onObjectProperty:(T,C,V)=>{o=f({type:"property",offset:C,length:-1,parent:o,children:[]}),o.children.push({type:"string",value:T,offset:C,length:V,parent:o})},onObjectEnd:(T,C)=>{o.length=T+C-o.offset,o=o.parent,h(T+C)},onArrayBegin:(T,C)=>{o=f({type:"array",offset:T,length:-1,parent:o,children:[]})},onArrayEnd:(T,C)=>{o.length=T+C-o.offset,o=o.parent,h(T+C)},onLiteralValue:(T,C,V)=>{f({type:a(T),offset:C,length:V,parent:o,value:T}),h(C+V)},onSeparator:(T,C,V)=>{o.type==="property"&&(T===":"?o.colonOffset=C:T===","&&h(C))},onError:(T,C,V)=>{r.push({error:T,offset:C,length:V})}},s);const M=o.children[0];return M&&delete M.parent,M}e.parseTree=y;function g(t,r){if(!t)return;let s=t;for(let o of r)if(typeof o=="string"){if(s.type!=="object"||!Array.isArray(s.children))return;let h=!1;for(const f of s.children)if(Array.isArray(f.children)&&f.children[0].value===o){s=f.children[1],h=!0;break}if(!h)return}else{const h=o;if(s.type!=="array"||h<0||!Array.isArray(s.children)||h>=s.children.length)return;s=s.children[h]}return s}e.findNodeAtLocation=g;function v(t){if(!t.parent||!t.parent.children)return[];const r=v(t.parent);if(t.parent.type==="property"){const s=t.parent.children[0].value;r.push(s)}else if(t.parent.type==="array"){const s=t.parent.children.indexOf(t);s!==-1&&r.push(s)}return r}e.getNodePath=v;function D(t){switch(t.type){case"array":return t.children.map(D);case"object":const r=Object.create(null);for(let s of t.children){const o=s.children[1];o&&(r[s.children[0].value]=D(o))}return r;case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=D;function b(t,r,s=!1){return r>=t.offset&&r<t.offset+t.length||s&&r===t.offset+t.length}e.contains=b;function l(t,r,s=!1){if(b(t,r,s)){const o=t.children;if(Array.isArray(o))for(let h=0;h<o.length&&o[h].offset<=r;h++){const f=l(o[h],r,s);if(f)return f}return t}}e.findNodeAtOffset=l;function u(t,r,s=S.DEFAULT){const o=E(t,!1);function h(U){return U?()=>U(o.getTokenOffset(),o.getTokenLength()):()=>!0}function f(U){return U?q=>U(q,o.getTokenOffset(),o.getTokenLength()):()=>!0}const d=h(r.onObjectBegin),M=f(r.onObjectProperty),T=h(r.onObjectEnd),C=h(r.onArrayBegin),V=h(r.onArrayEnd),Q=f(r.onLiteralValue),te=f(r.onSeparator),B=h(r.onComment),Y=f(r.onError),X=s&&s.disallowComments,_=s&&s.allowTrailingComma;function $(){for(;;){const U=o.scan();switch(o.getTokenError()){case 4:G(14);break;case 5:G(15);break;case 3:G(13);break;case 1:X||G(11);break;case 2:G(12);break;case 6:G(16);break}switch(U){case 12:case 13:X?G(10):B();break;case 16:G(1);break;case 15:case 14:break;default:return U}}}function G(U,q=[],K=[]){if(Y(U),q.length+K.length>0){let H=o.getToken();for(;H!==17;){if(q.indexOf(H)!==-1){$();break}else if(K.indexOf(H)!==-1)break;H=$()}}}function N(U){const q=o.getTokenValue();return U?Q(q):M(q),$(),!0}function F(){switch(o.getToken()){case 11:let U=0;try{U=JSON.parse(o.getTokenValue()),typeof U!="number"&&(G(2),U=0)}catch(q){G(2)}Q(U);break;case 7:Q(null);break;case 8:Q(!0);break;case 9:Q(!1);break;default:return!1}return $(),!0}function R(){return o.getToken()!==10?(G(3,[],[2,5]),!1):(N(!1),o.getToken()===6?(te(":"),$(),W()||G(4,[],[2,5])):G(5,[],[2,5]),!0)}function O(){d(),$();let U=!1;for(;o.getToken()!==2&&o.getToken()!==17;){if(o.getToken()===5){if(U||G(4,[],[]),te(","),$(),o.getToken()===2&&_)break}else U&&G(6,[],[]);R()||G(4,[],[2,5]),U=!0}return T(),o.getToken()!==2?G(7,[2],[]):$(),!0}function k(){C(),$();let U=!1;for(;o.getToken()!==4&&o.getToken()!==17;){if(o.getToken()===5){if(U||G(4,[],[]),te(","),$(),o.getToken()===4&&_)break}else U&&G(6,[],[]);W()||G(4,[],[4,5]),U=!0}return V(),o.getToken()!==4?G(8,[4],[]):$(),!0}function W(){switch(o.getToken()){case 3:return k();case 1:return O();case 10:return N(!0);default:return F()}}return $(),o.getToken()===17?s.allowEmptyContent?!0:(G(4,[],[]),!1):W()?(o.getToken()!==17&&G(9,[],[]),!0):(G(4,[],[]),!1)}e.visit=u;function c(t,r){let s=E(t),o=[],h,f=0,d;do switch(d=s.getPosition(),h=s.scan(),h){case 12:case 13:case 17:f!==d&&o.push(t.substring(f,d)),r!==void 0&&o.push(s.getTokenValue().replace(/[^\r\n]/g,r)),f=s.getPosition();break}while(h!==17);return o.join("")}e.stripComments=c;function a(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=a}),define(J[103],Z([0,1,43]),function(z,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.format=void 0;function L(w,p,i){let I,P,y,g,v;if(p){for(g=p.offset,v=g+p.length,y=g;y>0&&!n(w,y-1);)y--;let f=v;for(;f<w.length&&!n(w,f);)f++;P=w.substring(y,f),I=S(P,i)}else P=w,I=0,y=0,g=0,v=w.length;const D=E(i,w);let b=!1,l=0,u;i.insertSpaces?u=A(" ",i.tabSize||4):u="	";const c=m.createScanner(P,!1);let a=!1;function t(){return D+A(u,I+l)}function r(){let f=c.scan();for(b=!1;f===15||f===14;)b=b||f===14,f=c.scan();return a=f===16||c.getTokenError()!==0,f}const s=[];function o(f,d,M){!a&&d<v&&M>g&&w.substring(d,M)!==f&&s.push({offset:d,length:M-d,content:f})}let h=r();if(h!==17){const f=c.getTokenOffset()+y,d=A(u,I);o(d,y,f)}for(;h!==17;){let f=c.getTokenOffset()+c.getTokenLength()+y,d=r(),M="";for(;!b&&(d===12||d===13);){const C=c.getTokenOffset()+y;o(" ",f,C),f=c.getTokenOffset()+c.getTokenLength()+y,M=d===12?t():"",d=r()}if(d===2)h!==1&&(l--,M=t());else if(d===4)h!==3&&(l--,M=t());else{switch(h){case 3:case 1:l++,M=t();break;case 5:case 12:M=t();break;case 13:b?M=t():M=" ";break;case 6:M=" ";break;case 10:if(d===6){M="";break}case 7:case 8:case 9:case 11:case 2:case 4:d===12||d===13?M=" ":d!==5&&d!==17&&(a=!0);break;case 16:a=!0;break}b&&(d===12||d===13)&&(M=t())}const T=c.getTokenOffset()+y;o(M,f,T),h=d}return s}e.format=L;function A(w,p){let i="";for(let I=0;I<p;I++)i+=w;return i}function S(w,p){let i=0,I=0;const P=p.tabSize||4;for(;i<w.length;){const y=w.charAt(i);if(y===" ")I++;else if(y==="	")I+=P;else break;i++}return Math.floor(I/P)}function E(w,p){for(let i=0;i<p.length;i++){const I=p.charAt(i);if(I==="\r")return i+1<p.length&&p.charAt(i+1)===`
`?`\r
`:"\r";if(I===`
`)return`
`}return w&&w.eol||`
`}e.getEOL=E;function n(w,p){return`\r
`.indexOf(w.charAt(p))!==-1}e.isEOL=n}),define(J[104],Z([0,1,43,103]),function(z,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function A(p,i,I){return S(p,i,void 0,I)}e.removeProperty=A;function S(p,i,I,P,y){const g=i.slice(),v=[],D=m.parseTree(p,v);let b,l;for(;g.length>0&&(l=g.pop(),b=m.findNodeAtLocation(D,g),b===void 0&&I!==void 0);)typeof l=="string"?I={[l]:I}:I=[I];if(b)if(b.type==="object"&&typeof l=="string"&&Array.isArray(b.children)){const u=m.findNodeAtLocation(b,[l]);if(u!==void 0)if(I===void 0){if(!u.parent)throw new Error("Malformed AST");const c=b.children.indexOf(u.parent);let a,t=u.parent.offset+u.parent.length;if(c>0){const r=b.children[c-1];a=r.offset+r.length}else a=b.offset+1,b.children.length>1&&(t=b.children[1].offset);return E(p,{offset:a,length:t-a,content:""},P)}else return E(p,{offset:u.offset,length:u.length,content:JSON.stringify(I)},P);else{if(I===void 0)return[];const c=`${JSON.stringify(l)}: ${JSON.stringify(I)}`,a=y?y(b.children.map(r=>r.children[0].value)):b.children.length;let t;if(a>0){const r=b.children[a-1];t={offset:r.offset+r.length,length:0,content:","+c}}else b.children.length===0?t={offset:b.offset+1,length:0,content:c}:t={offset:b.offset+1,length:0,content:c+","};return E(p,t,P)}}else if(b.type==="array"&&typeof l=="number"&&Array.isArray(b.children))if(I!==void 0){const u=`${JSON.stringify(I)}`;let c;if(b.children.length===0||l===0)c={offset:b.offset+1,length:0,content:b.children.length===0?u:u+","};else{const a=l===-1||l>b.children.length?b.children.length:l,t=b.children[a-1];c={offset:t.offset+t.length,length:0,content:","+u}}return E(p,c,P)}else{const u=l,c=b.children[u];let a;if(b.children.length===1)a={offset:b.offset+1,length:b.length-2,content:""};else if(b.children.length-1===u){const t=b.children[u-1],r=t.offset+t.length,s=b.offset+b.length;a={offset:r,length:s-2-r,content:""}}else a={offset:c.offset,length:b.children[u+1].offset-c.offset,content:""};return E(p,a,P)}else throw new Error(`Can not add ${typeof l!="number"?"index":"property"} to parent of type ${b.type}`);else{if(I===void 0)throw new Error("Can not delete in empty document");return E(p,{offset:D?D.offset:0,length:D?D.length:0,content:JSON.stringify(I)},P)}}e.setProperty=S;function E(p,i,I){let P=n(p,i),y=i.offset,g=i.offset+i.content.length;if(i.length===0||i.content.length===0){for(;y>0&&!L.isEOL(P,y-1);)y--;for(;g<P.length&&!L.isEOL(P,g);)g++}const v=L.format(P,{offset:y,length:g-y},I);for(let b=v.length-1;b>=0;b--){const l=v[b];P=n(P,l),y=Math.min(y,l.offset),g=Math.max(g,l.offset+l.length),g+=l.content.length-l.length}const D=p.length-(P.length-g)-y;return[{offset:y,length:D,content:P.substring(y,g)}]}e.withFormatting=E;function n(p,i){return p.substring(0,i.offset)+i.content+p.substring(i.offset+i.length)}e.applyEdit=n;function w(p,i){let I=i.slice(0).sort((y,g)=>{const v=y.offset-g.offset;return v===0?y.length-g.length:v}),P=p.length;for(let y=I.length-1;y>=0;y--){let g=I[y];if(g.offset+g.length<=P)p=n(p,g);else throw new Error("Overlapping edit");P=g.offset}return p}e.applyEdits=w}),define(J[57],Z([0,1,19]),function(z,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ResolvedKeybinding=e.ResolvedKeybindingPart=e.ChordKeybinding=e.SimpleKeybinding=e.createSimpleKeybinding=e.createKeybinding=e.KeyChord=e.KeyMod=e.KeyCodeUtils=e.KeyCode=void 0;var L;(function(l){l[l.DependsOnKbLayout=-1]="DependsOnKbLayout",l[l.Unknown=0]="Unknown",l[l.Backspace=1]="Backspace",l[l.Tab=2]="Tab",l[l.Enter=3]="Enter",l[l.Shift=4]="Shift",l[l.Ctrl=5]="Ctrl",l[l.Alt=6]="Alt",l[l.PauseBreak=7]="PauseBreak",l[l.CapsLock=8]="CapsLock",l[l.Escape=9]="Escape",l[l.Space=10]="Space",l[l.PageUp=11]="PageUp",l[l.PageDown=12]="PageDown",l[l.End=13]="End",l[l.Home=14]="Home",l[l.LeftArrow=15]="LeftArrow",l[l.UpArrow=16]="UpArrow",l[l.RightArrow=17]="RightArrow",l[l.DownArrow=18]="DownArrow",l[l.Insert=19]="Insert",l[l.Delete=20]="Delete",l[l.KEY_0=21]="KEY_0",l[l.KEY_1=22]="KEY_1",l[l.KEY_2=23]="KEY_2",l[l.KEY_3=24]="KEY_3",l[l.KEY_4=25]="KEY_4",l[l.KEY_5=26]="KEY_5",l[l.KEY_6=27]="KEY_6",l[l.KEY_7=28]="KEY_7",l[l.KEY_8=29]="KEY_8",l[l.KEY_9=30]="KEY_9",l[l.KEY_A=31]="KEY_A",l[l.KEY_B=32]="KEY_B",l[l.KEY_C=33]="KEY_C",l[l.KEY_D=34]="KEY_D",l[l.KEY_E=35]="KEY_E",l[l.KEY_F=36]="KEY_F",l[l.KEY_G=37]="KEY_G",l[l.KEY_H=38]="KEY_H",l[l.KEY_I=39]="KEY_I",l[l.KEY_J=40]="KEY_J",l[l.KEY_K=41]="KEY_K",l[l.KEY_L=42]="KEY_L",l[l.KEY_M=43]="KEY_M",l[l.KEY_N=44]="KEY_N",l[l.KEY_O=45]="KEY_O",l[l.KEY_P=46]="KEY_P",l[l.KEY_Q=47]="KEY_Q",l[l.KEY_R=48]="KEY_R",l[l.KEY_S=49]="KEY_S",l[l.KEY_T=50]="KEY_T",l[l.KEY_U=51]="KEY_U",l[l.KEY_V=52]="KEY_V",l[l.KEY_W=53]="KEY_W",l[l.KEY_X=54]="KEY_X",l[l.KEY_Y=55]="KEY_Y",l[l.KEY_Z=56]="KEY_Z",l[l.Meta=57]="Meta",l[l.ContextMenu=58]="ContextMenu",l[l.F1=59]="F1",l[l.F2=60]="F2",l[l.F3=61]="F3",l[l.F4=62]="F4",l[l.F5=63]="F5",l[l.F6=64]="F6",l[l.F7=65]="F7",l[l.F8=66]="F8",l[l.F9=67]="F9",l[l.F10=68]="F10",l[l.F11=69]="F11",l[l.F12=70]="F12",l[l.F13=71]="F13",l[l.F14=72]="F14",l[l.F15=73]="F15",l[l.F16=74]="F16",l[l.F17=75]="F17",l[l.F18=76]="F18",l[l.F19=77]="F19",l[l.NumLock=78]="NumLock",l[l.ScrollLock=79]="ScrollLock",l[l.US_SEMICOLON=80]="US_SEMICOLON",l[l.US_EQUAL=81]="US_EQUAL",l[l.US_COMMA=82]="US_COMMA",l[l.US_MINUS=83]="US_MINUS",l[l.US_DOT=84]="US_DOT",l[l.US_SLASH=85]="US_SLASH",l[l.US_BACKTICK=86]="US_BACKTICK",l[l.US_OPEN_SQUARE_BRACKET=87]="US_OPEN_SQUARE_BRACKET",l[l.US_BACKSLASH=88]="US_BACKSLASH",l[l.US_CLOSE_SQUARE_BRACKET=89]="US_CLOSE_SQUARE_BRACKET",l[l.US_QUOTE=90]="US_QUOTE",l[l.OEM_8=91]="OEM_8",l[l.OEM_102=92]="OEM_102",l[l.NUMPAD_0=93]="NUMPAD_0",l[l.NUMPAD_1=94]="NUMPAD_1",l[l.NUMPAD_2=95]="NUMPAD_2",l[l.NUMPAD_3=96]="NUMPAD_3",l[l.NUMPAD_4=97]="NUMPAD_4",l[l.NUMPAD_5=98]="NUMPAD_5",l[l.NUMPAD_6=99]="NUMPAD_6",l[l.NUMPAD_7=100]="NUMPAD_7",l[l.NUMPAD_8=101]="NUMPAD_8",l[l.NUMPAD_9=102]="NUMPAD_9",l[l.NUMPAD_MULTIPLY=103]="NUMPAD_MULTIPLY",l[l.NUMPAD_ADD=104]="NUMPAD_ADD",l[l.NUMPAD_SEPARATOR=105]="NUMPAD_SEPARATOR",l[l.NUMPAD_SUBTRACT=106]="NUMPAD_SUBTRACT",l[l.NUMPAD_DECIMAL=107]="NUMPAD_DECIMAL",l[l.NUMPAD_DIVIDE=108]="NUMPAD_DIVIDE",l[l.KEY_IN_COMPOSITION=109]="KEY_IN_COMPOSITION",l[l.ABNT_C1=110]="ABNT_C1",l[l.ABNT_C2=111]="ABNT_C2",l[l.MAX_VALUE=112]="MAX_VALUE"})(L=e.KeyCode||(e.KeyCode={}));class A{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(u,c){this._keyCodeToStr[u]=c,this._strToKeyCode[c.toLowerCase()]=u}keyCodeToStr(u){return this._keyCodeToStr[u]}strToKeyCode(u){return this._strToKeyCode[u.toLowerCase()]||0}}const S=new A,E=new A,n=new A;(function(){function l(u,c,a=c,t=a){S.define(u,c),E.define(u,a),n.define(u,t)}l(0,"unknown"),l(1,"Backspace"),l(2,"Tab"),l(3,"Enter"),l(4,"Shift"),l(5,"Ctrl"),l(6,"Alt"),l(7,"PauseBreak"),l(8,"CapsLock"),l(9,"Escape"),l(10,"Space"),l(11,"PageUp"),l(12,"PageDown"),l(13,"End"),l(14,"Home"),l(15,"LeftArrow","Left"),l(16,"UpArrow","Up"),l(17,"RightArrow","Right"),l(18,"DownArrow","Down"),l(19,"Insert"),l(20,"Delete"),l(21,"0"),l(22,"1"),l(23,"2"),l(24,"3"),l(25,"4"),l(26,"5"),l(27,"6"),l(28,"7"),l(29,"8"),l(30,"9"),l(31,"A"),l(32,"B"),l(33,"C"),l(34,"D"),l(35,"E"),l(36,"F"),l(37,"G"),l(38,"H"),l(39,"I"),l(40,"J"),l(41,"K"),l(42,"L"),l(43,"M"),l(44,"N"),l(45,"O"),l(46,"P"),l(47,"Q"),l(48,"R"),l(49,"S"),l(50,"T"),l(51,"U"),l(52,"V"),l(53,"W"),l(54,"X"),l(55,"Y"),l(56,"Z"),l(57,"Meta"),l(58,"ContextMenu"),l(59,"F1"),l(60,"F2"),l(61,"F3"),l(62,"F4"),l(63,"F5"),l(64,"F6"),l(65,"F7"),l(66,"F8"),l(67,"F9"),l(68,"F10"),l(69,"F11"),l(70,"F12"),l(71,"F13"),l(72,"F14"),l(73,"F15"),l(74,"F16"),l(75,"F17"),l(76,"F18"),l(77,"F19"),l(78,"NumLock"),l(79,"ScrollLock"),l(80,";",";","OEM_1"),l(81,"=","=","OEM_PLUS"),l(82,",",",","OEM_COMMA"),l(83,"-","-","OEM_MINUS"),l(84,".",".","OEM_PERIOD"),l(85,"/","/","OEM_2"),l(86,"`","`","OEM_3"),l(110,"ABNT_C1"),l(111,"ABNT_C2"),l(87,"[","[","OEM_4"),l(88,"\\","\\","OEM_5"),l(89,"]","]","OEM_6"),l(90,"'","'","OEM_7"),l(91,"OEM_8"),l(92,"OEM_102"),l(93,"NumPad0"),l(94,"NumPad1"),l(95,"NumPad2"),l(96,"NumPad3"),l(97,"NumPad4"),l(98,"NumPad5"),l(99,"NumPad6"),l(100,"NumPad7"),l(101,"NumPad8"),l(102,"NumPad9"),l(103,"NumPad_Multiply"),l(104,"NumPad_Add"),l(105,"NumPad_Separator"),l(106,"NumPad_Subtract"),l(107,"NumPad_Decimal"),l(108,"NumPad_Divide")})();var w;(function(l){function u(s){return S.keyCodeToStr(s)}l.toString=u;function c(s){return S.strToKeyCode(s)}l.fromString=c;function a(s){return E.keyCodeToStr(s)}l.toUserSettingsUS=a;function t(s){return n.keyCodeToStr(s)}l.toUserSettingsGeneral=t;function r(s){return E.strToKeyCode(s)||n.strToKeyCode(s)}l.fromUserSettings=r})(w=e.KeyCodeUtils||(e.KeyCodeUtils={}));var p;(function(l){l[l.CtrlCmd=2048]="CtrlCmd",l[l.Shift=1024]="Shift",l[l.Alt=512]="Alt",l[l.WinCtrl=256]="WinCtrl",l[l.KeyCode=255]="KeyCode"})(p||(p={}));var i;(function(l){l[l.CtrlCmd=2048]="CtrlCmd",l[l.Shift=1024]="Shift",l[l.Alt=512]="Alt",l[l.WinCtrl=256]="WinCtrl"})(i=e.KeyMod||(e.KeyMod={}));function I(l,u){const c=(u&65535)<<16>>>0;return(l|c)>>>0}e.KeyChord=I;function P(l,u){if(l===0)return null;const c=(l&65535)>>>0,a=(l&4294901760)>>>16;return a!==0?new v([y(c,u),y(a,u)]):new v([y(c,u)])}e.createKeybinding=P;function y(l,u){const c=!!(l&2048),a=!!(l&256),t=u===2?a:c,r=!!(l&1024),s=!!(l&512),o=u===2?c:a,h=l&255;return new g(t,r,s,o,h)}e.createSimpleKeybinding=y;class g{constructor(u,c,a,t,r){this.ctrlKey=u,this.shiftKey=c,this.altKey=a,this.metaKey=t,this.keyCode=r}equals(u){return this.ctrlKey===u.ctrlKey&&this.shiftKey===u.shiftKey&&this.altKey===u.altKey&&this.metaKey===u.metaKey&&this.keyCode===u.keyCode}getHashCode(){const u=this.ctrlKey?"1":"0",c=this.shiftKey?"1":"0",a=this.altKey?"1":"0",t=this.metaKey?"1":"0";return`${u}${c}${a}${t}${this.keyCode}`}isModifierKey(){return this.keyCode===0||this.keyCode===5||this.keyCode===57||this.keyCode===6||this.keyCode===4}toChord(){return new v([this])}isDuplicateModifierCase(){return this.ctrlKey&&this.keyCode===5||this.shiftKey&&this.keyCode===4||this.altKey&&this.keyCode===6||this.metaKey&&this.keyCode===57}}e.SimpleKeybinding=g;class v{constructor(u){if(u.length===0)throw m.illegalArgument("parts");this.parts=u}getHashCode(){let u="";for(let c=0,a=this.parts.length;c<a;c++)c!==0&&(u+=";"),u+=this.parts[c].getHashCode();return u}equals(u){if(u===null||this.parts.length!==u.parts.length)return!1;for(let c=0;c<this.parts.length;c++)if(!this.parts[c].equals(u.parts[c]))return!1;return!0}}e.ChordKeybinding=v;class D{constructor(u,c,a,t,r,s){this.ctrlKey=u,this.shiftKey=c,this.altKey=a,this.metaKey=t,this.keyLabel=r,this.keyAriaLabel=s}}e.ResolvedKeybindingPart=D;class b{}e.ResolvedKeybinding=b}),define(J[2],Z([0,1,42,63]),function(z,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.trackDisposable=e.setDisposableTracker=void 0;const A=!1;let S=null;function E(c){S=c}if(e.setDisposableTracker=E,A){const c="__is_disposable_tracked__";S=new class{trackDisposable(a){const t=new Error("Potentially leaked disposable").stack;setTimeout(()=>{a[c]||console.log(t)},3e3)}markTracked(a){if(a&&a!==v.None)try{a[c]=!0}catch(t){}}}}function n(c){!S||S.markTracked(c)}function w(c){return S&&S.trackDisposable(c),c}e.trackDisposable=w;class p extends Error{constructor(a){super(`Encountered errors while disposing of store. Errors: [${a.join(", ")}]`);this.errors=a}}e.MultiDisposeError=p;function i(c){return typeof c.dispose=="function"&&c.dispose.length===0}e.isDisposable=i;function I(c){if(L.Iterable.is(c)){let a=[];for(const t of c)if(t){n(t);try{t.dispose()}catch(r){a.push(r)}}if(a.length===1)throw a[0];if(a.length>1)throw new p(a);return Array.isArray(c)?[]:c}else if(c)return n(c),c.dispose(),c}e.dispose=I;function P(...c){return c.forEach(n),y(()=>I(c))}e.combinedDisposable=P;function y(c){const a=w({dispose:()=>{n(a),c()}});return a}e.toDisposable=y;class g{constructor(){this._toDispose=new Set,this._isDisposed=!1}dispose(){this._isDisposed||(n(this),this._isDisposed=!0,this.clear())}clear(){try{I(this._toDispose.values())}finally{this._toDispose.clear()}}add(a){if(!a)return a;if(a===this)throw new Error("Cannot register a disposable on itself!");return n(a),this._isDisposed?g.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(a),a}}e.DisposableStore=g,g.DISABLE_DISPOSED_WARNING=!1;class v{constructor(){this._store=new g,w(this)}dispose(){n(this),this._store.dispose()}_register(a){if(a===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(a)}}e.Disposable=v,v.None=Object.freeze({dispose(){}});class D{constructor(){this._isDisposed=!1,w(this)}get value(){return this._isDisposed?void 0:this._value}set value(a){var t;this._isDisposed||a===this._value||((t=this._value)===null||t===void 0||t.dispose(),a&&n(a),this._value=a)}clear(){this.value=void 0}dispose(){var a;this._isDisposed=!0,n(this),(a=this._value)===null||a===void 0||a.dispose(),this._value=void 0}}e.MutableDisposable=D;class b{constructor(){this.references=new Map}acquire(a,...t){let r=this.references.get(a);r||(r={counter:0,object:this.createReferencedObject(a,...t)},this.references.set(a,r));const{object:s}=r,o=m.once(()=>{--r.counter==0&&(this.destroyReferencedObject(a,r.object),this.references.delete(a))});return r.counter++,{object:s,dispose:o}}}e.ReferenceCollection=b;class l{constructor(a){this.referenceCollection=a}async acquire(a,...t){const r=this.referenceCollection.acquire(a,...t);try{return{object:await r.object,dispose:()=>r.dispose()}}catch(s){throw r.dispose(),s}}}e.AsyncReferenceCollection=l;class u{constructor(a){this.object=a}dispose(){}}e.ImmortalReference=u}),define(J[78],Z([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class m{constructor(S){this.element=S,this.next=m.Undefined,this.prev=m.Undefined}}m.Undefined=new m(void 0);class L{constructor(){this._first=m.Undefined,this._last=m.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===m.Undefined}clear(){let S=this._first;for(;S!==m.Undefined;){const E=S.next;S.prev=m.Undefined,S.next=m.Undefined,S=E}this._first=m.Undefined,this._last=m.Undefined,this._size=0}unshift(S){return this._insert(S,!1)}push(S){return this._insert(S,!0)}_insert(S,E){const n=new m(S);if(this._first===m.Undefined)this._first=n,this._last=n;else if(E){const p=this._last;this._last=n,n.prev=p,p.next=n}else{const p=this._first;this._first=n,n.next=p,p.prev=n}this._size+=1;let w=!1;return()=>{w||(w=!0,this._remove(n))}}shift(){if(this._first!==m.Undefined){const S=this._first.element;return this._remove(this._first),S}}pop(){if(this._last!==m.Undefined){const S=this._last.element;return this._remove(this._last),S}}_remove(S){if(S.prev!==m.Undefined&&S.next!==m.Undefined){const E=S.prev;E.next=S.next,S.next.prev=E}else S.prev===m.Undefined&&S.next===m.Undefined?(this._first=m.Undefined,this._last=m.Undefined):S.next===m.Undefined?(this._last=this._last.prev,this._last.next=m.Undefined):S.prev===m.Undefined&&(this._first=this._first.next,this._first.prev=m.Undefined);this._size-=1}*[Symbol.iterator](){let S=this._first;for(;S!==m.Undefined;)yield S.element,S=S.next}}e.LinkedList=L}),function(){function z(A){const S=[];typeof A=="number"&&S.push("code/timeOrigin",A);function E(w){S.push(w,Date.now())}function n(){const w=[];for(let p=0;p<S.length;p+=2)w.push({name:S[p],startTime:S[p+1]});return w}return{mark:E,getMarks:n}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?z():{mark(A){performance.mark(A)},getMarks(){let A=performance.timeOrigin;typeof A!="number"&&(A=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const S=[{name:"code/timeOrigin",startTime:Math.round(A)}];for(const E of performance.getEntriesByType("mark"))S.push({name:E.name,startTime:Math.round(A+E.startTime)});return S}};if(typeof process=="object"){const A=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return z(A)}else return console.trace("perf-util loaded in UNKNOWN environment"),z()}function m(A){return A.MonacoPerformanceMarks||(A.MonacoPerformanceMarks=e()),A.MonacoPerformanceMarks}var L;typeof global=="object"?L=global:typeof self=="object"?L=self:L={},typeof define=="function"?define("vs/base/common/performance",[],function(){return m(L)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=m(L):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),L.perf=m(L))}(),define(J[3],Z([0,1]),function(z,e){"use strict";var m;Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setImmediate=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isPreferringBrowserCodeLoad=e.browserCodeLoadingCacheStrategy=e.isElectronSandboxed=e.globals=void 0;const L="en";let A=!1,S=!1,E=!1,n=!1,w=!1,p=!1,i=!1,I,P=L,y,g;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let v;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?v=e.globals.vscode.process:typeof process!="undefined"&&(v=process);const D=typeof((m=v==null?void 0:v.versions)===null||m===void 0?void 0:m.electron)=="string"&&v.type==="renderer";if(e.isElectronSandboxed=D&&(v==null?void 0:v.sandboxed),e.browserCodeLoadingCacheStrategy=(()=>{if(e.isElectronSandboxed)return"bypassHeatCheck";const o=v==null?void 0:v.env.VSCODE_BROWSER_CODE_LOADING;if(typeof o=="string")return o==="none"||o==="code"||o==="bypassHeatCheck"||o==="bypassHeatCheckAndEagerCompile"?o:"bypassHeatCheck"})(),e.isPreferringBrowserCodeLoad=typeof e.browserCodeLoadingCacheStrategy=="string",typeof navigator=="object"&&!D)g=navigator.userAgent,A=g.indexOf("Windows")>=0,S=g.indexOf("Macintosh")>=0,i=(g.indexOf("Macintosh")>=0||g.indexOf("iPad")>=0||g.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,E=g.indexOf("Linux")>=0,p=!0,I=navigator.language,P=I;else if(typeof v=="object"){A=v.platform==="win32",S=v.platform==="darwin",E=v.platform==="linux",n=E&&!!v.env.SNAP&&!!v.env.SNAP_REVISION,I=L,P=L;const o=v.env.VSCODE_NLS_CONFIG;if(o)try{const h=JSON.parse(o),f=h.availableLanguages["*"];I=h.locale,P=f||L,y=h._translationsConfigFile}catch(h){}w=!0}else console.error("Unable to resolve platform.");var b;(function(o){o[o.Web=0]="Web",o[o.Mac=1]="Mac",o[o.Linux=2]="Linux",o[o.Windows=3]="Windows"})(b=e.Platform||(e.Platform={}));function l(o){switch(o){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=l;let u=0;S?u=1:A?u=3:E&&(u=2),e.isWindows=A,e.isMacintosh=S,e.isLinux=E,e.isLinuxSnap=n,e.isNative=w,e.isWeb=p,e.isIOS=i,e.platform=u,e.userAgent=g,e.language=P;var c;(function(o){function h(){return e.language}o.value=h;function f(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}o.isDefaultVariant=f;function d(){return e.language==="en"}o.isDefault=d})(c=e.Language||(e.Language={})),e.locale=I,e.translationsConfigFile=y,e.setImmediate=function(){if(e.globals.setImmediate)return e.globals.setImmediate.bind(e.globals);if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let f=[];e.globals.addEventListener("message",M=>{if(M.data&&M.data.vscodeSetImmediateId)for(let T=0,C=f.length;T<C;T++){const V=f[T];if(V.id===M.data.vscodeSetImmediateId){f.splice(T,1),V.callback();return}}});let d=0;return M=>{const T=++d;f.push({id:T,callback:M}),e.globals.postMessage({vscodeSetImmediateId:T},"*")}}if(typeof(v==null?void 0:v.nextTick)=="function")return v.nextTick.bind(v);const h=Promise.resolve();return f=>h.then(f)}();var a;(function(o){o[o.Windows=1]="Windows",o[o.Macintosh=2]="Macintosh",o[o.Linux=3]="Linux"})(a=e.OperatingSystem||(e.OperatingSystem={})),e.OS=S||i?2:A?1:3;let t=!0,r=!1;function s(){if(!r){r=!0;const o=new Uint8Array(2);o[0]=1,o[1]=2,t=new Uint16Array(o.buffer)[0]===(2<<8)+1}return t}e.isLittleEndian=s}),define(J[32],Z([0,1,3]),function(z,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nextTick=e.platform=e.env=e.cwd=void 0;let L;if(typeof m.globals.vscode!="undefined"&&typeof m.globals.vscode.process!="undefined"){const A=m.globals.vscode.process;L={get platform(){return A.platform},get env(){return A.env},cwd(){return A.cwd()},nextTick(S){return m.setImmediate(S)}}}else typeof process!="undefined"?L={get platform(){return process.platform},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()},nextTick(A){return process.nextTick(A)}}:L={get platform(){return m.isWindows?"win32":m.isMacintosh?"darwin":"linux"},nextTick(A){return m.setImmediate(A)},get env(){return{}},cwd(){return"/"}};e.cwd=L.cwd,e.env=L.env,e.platform=L.platform,e.nextTick=L.nextTick}),define(J[8],Z([0,1,32]),function(z,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const L=65,A=97,S=90,E=122,n=46,w=47,p=92,i=58,I=63;class P extends Error{constructor(c,a,t){let r;typeof a=="string"&&a.indexOf("not ")===0?(r="must not be",a=a.replace(/^not /,"")):r="must be";const s=c.indexOf(".")!==-1?"property":"argument";let o=`The "${c}" ${s} ${r} of type ${a}`;o+=`. Received type ${typeof t}`,super(o),this.code="ERR_INVALID_ARG_TYPE"}}function y(u,c){if(typeof u!="string")throw new P(c,"string",u)}function g(u){return u===w||u===p}function v(u){return u===w}function D(u){return u>=L&&u<=S||u>=A&&u<=E}function b(u,c,a,t){let r="",s=0,o=-1,h=0,f=0;for(let d=0;d<=u.length;++d){if(d<u.length)f=u.charCodeAt(d);else{if(t(f))break;f=w}if(t(f)){if(!(o===d-1||h===1))if(h===2){if(r.length<2||s!==2||r.charCodeAt(r.length-1)!==n||r.charCodeAt(r.length-2)!==n){if(r.length>2){const M=r.lastIndexOf(a);M===-1?(r="",s=0):(r=r.slice(0,M),s=r.length-1-r.lastIndexOf(a)),o=d,h=0;continue}else if(r.length!==0){r="",s=0,o=d,h=0;continue}}c&&(r+=r.length>0?`${a}..`:"..",s=2)}else r.length>0?r+=`${a}${u.slice(o+1,d)}`:r=u.slice(o+1,d),s=d-o-1;o=d,h=0}else f===n&&h!==-1?++h:h=-1}return r}function l(u,c){if(c===null||typeof c!="object")throw new P("pathObject","Object",c);const a=c.dir||c.root,t=c.base||`${c.name||""}${c.ext||""}`;return a?a===c.root?`${a}${t}`:`${a}${u}${t}`:t}e.win32={resolve(...u){let c="",a="",t=!1;for(let r=u.length-1;r>=-1;r--){let s;if(r>=0){if(s=u[r],y(s,"path"),s.length===0)continue}else c.length===0?s=m.cwd():(s=m.env[`=${c}`]||m.cwd(),(s===void 0||s.slice(0,2).toLowerCase()!==c.toLowerCase()&&s.charCodeAt(2)===p)&&(s=`${c}\\`));const o=s.length;let h=0,f="",d=!1;const M=s.charCodeAt(0);if(o===1)g(M)&&(h=1,d=!0);else if(g(M))if(d=!0,g(s.charCodeAt(1))){let T=2,C=T;for(;T<o&&!g(s.charCodeAt(T));)T++;if(T<o&&T!==C){const V=s.slice(C,T);for(C=T;T<o&&g(s.charCodeAt(T));)T++;if(T<o&&T!==C){for(C=T;T<o&&!g(s.charCodeAt(T));)T++;(T===o||T!==C)&&(f=`\\\\${V}\\${s.slice(C,T)}`,h=T)}}}else h=1;else D(M)&&s.charCodeAt(1)===i&&(f=s.slice(0,2),h=2,o>2&&g(s.charCodeAt(2))&&(d=!0,h=3));if(f.length>0)if(c.length>0){if(f.toLowerCase()!==c.toLowerCase())continue}else c=f;if(t){if(c.length>0)break}else if(a=`${s.slice(h)}\\${a}`,t=d,d&&c.length>0)break}return a=b(a,!t,"\\",g),t?`${c}\\${a}`:`${c}${a}`||"."},normalize(u){y(u,"path");const c=u.length;if(c===0)return".";let a=0,t,r=!1;const s=u.charCodeAt(0);if(c===1)return v(s)?"\\":u;if(g(s))if(r=!0,g(u.charCodeAt(1))){let h=2,f=h;for(;h<c&&!g(u.charCodeAt(h));)h++;if(h<c&&h!==f){const d=u.slice(f,h);for(f=h;h<c&&g(u.charCodeAt(h));)h++;if(h<c&&h!==f){for(f=h;h<c&&!g(u.charCodeAt(h));)h++;if(h===c)return`\\\\${d}\\${u.slice(f)}\\`;h!==f&&(t=`\\\\${d}\\${u.slice(f,h)}`,a=h)}}}else a=1;else D(s)&&u.charCodeAt(1)===i&&(t=u.slice(0,2),a=2,c>2&&g(u.charCodeAt(2))&&(r=!0,a=3));let o=a<c?b(u.slice(a),!r,"\\",g):"";return o.length===0&&!r&&(o="."),o.length>0&&g(u.charCodeAt(c-1))&&(o+="\\"),t===void 0?r?`\\${o}`:o:r?`${t}\\${o}`:`${t}${o}`},isAbsolute(u){y(u,"path");const c=u.length;if(c===0)return!1;const a=u.charCodeAt(0);return g(a)||c>2&&D(a)&&u.charCodeAt(1)===i&&g(u.charCodeAt(2))},join(...u){if(u.length===0)return".";let c,a;for(let s=0;s<u.length;++s){const o=u[s];y(o,"path"),o.length>0&&(c===void 0?c=a=o:c+=`\\${o}`)}if(c===void 0)return".";let t=!0,r=0;if(typeof a=="string"&&g(a.charCodeAt(0))){++r;const s=a.length;s>1&&g(a.charCodeAt(1))&&(++r,s>2&&(g(a.charCodeAt(2))?++r:t=!1))}if(t){for(;r<c.length&&g(c.charCodeAt(r));)r++;r>=2&&(c=`\\${c.slice(r)}`)}return e.win32.normalize(c)},relative(u,c){if(y(u,"from"),y(c,"to"),u===c)return"";const a=e.win32.resolve(u),t=e.win32.resolve(c);if(a===t||(u=a.toLowerCase(),c=t.toLowerCase(),u===c))return"";let r=0;for(;r<u.length&&u.charCodeAt(r)===p;)r++;let s=u.length;for(;s-1>r&&u.charCodeAt(s-1)===p;)s--;const o=s-r;let h=0;for(;h<c.length&&c.charCodeAt(h)===p;)h++;let f=c.length;for(;f-1>h&&c.charCodeAt(f-1)===p;)f--;const d=f-h,M=o<d?o:d;let T=-1,C=0;for(;C<M;C++){const Q=u.charCodeAt(r+C);if(Q!==c.charCodeAt(h+C))break;Q===p&&(T=C)}if(C!==M){if(T===-1)return t}else{if(d>M){if(c.charCodeAt(h+C)===p)return t.slice(h+C+1);if(C===2)return t.slice(h+C)}o>M&&(u.charCodeAt(r+C)===p?T=C:C===2&&(T=3)),T===-1&&(T=0)}let V="";for(C=r+T+1;C<=s;++C)(C===s||u.charCodeAt(C)===p)&&(V+=V.length===0?"..":"\\..");return h+=T,V.length>0?`${V}${t.slice(h,f)}`:(t.charCodeAt(h)===p&&++h,t.slice(h,f))},toNamespacedPath(u){if(typeof u!="string")return u;if(u.length===0)return"";const c=e.win32.resolve(u);if(c.length<=2)return u;if(c.charCodeAt(0)===p){if(c.charCodeAt(1)===p){const a=c.charCodeAt(2);if(a!==I&&a!==n)return`\\\\?\\UNC\\${c.slice(2)}`}}else if(D(c.charCodeAt(0))&&c.charCodeAt(1)===i&&c.charCodeAt(2)===p)return`\\\\?\\${c}`;return u},dirname(u){y(u,"path");const c=u.length;if(c===0)return".";let a=-1,t=0;const r=u.charCodeAt(0);if(c===1)return g(r)?u:".";if(g(r)){if(a=t=1,g(u.charCodeAt(1))){let h=2,f=h;for(;h<c&&!g(u.charCodeAt(h));)h++;if(h<c&&h!==f){for(f=h;h<c&&g(u.charCodeAt(h));)h++;if(h<c&&h!==f){for(f=h;h<c&&!g(u.charCodeAt(h));)h++;if(h===c)return u;h!==f&&(a=t=h+1)}}}}else D(r)&&u.charCodeAt(1)===i&&(a=c>2&&g(u.charCodeAt(2))?3:2,t=a);let s=-1,o=!0;for(let h=c-1;h>=t;--h)if(g(u.charCodeAt(h))){if(!o){s=h;break}}else o=!1;if(s===-1){if(a===-1)return".";s=a}return u.slice(0,s)},basename(u,c){c!==void 0&&y(c,"ext"),y(u,"path");let a=0,t=-1,r=!0,s;if(u.length>=2&&D(u.charCodeAt(0))&&u.charCodeAt(1)===i&&(a=2),c!==void 0&&c.length>0&&c.length<=u.length){if(c===u)return"";let o=c.length-1,h=-1;for(s=u.length-1;s>=a;--s){const f=u.charCodeAt(s);if(g(f)){if(!r){a=s+1;break}}else h===-1&&(r=!1,h=s+1),o>=0&&(f===c.charCodeAt(o)?--o==-1&&(t=s):(o=-1,t=h))}return a===t?t=h:t===-1&&(t=u.length),u.slice(a,t)}for(s=u.length-1;s>=a;--s)if(g(u.charCodeAt(s))){if(!r){a=s+1;break}}else t===-1&&(r=!1,t=s+1);return t===-1?"":u.slice(a,t)},extname(u){y(u,"path");let c=0,a=-1,t=0,r=-1,s=!0,o=0;u.length>=2&&u.charCodeAt(1)===i&&D(u.charCodeAt(0))&&(c=t=2);for(let h=u.length-1;h>=c;--h){const f=u.charCodeAt(h);if(g(f)){if(!s){t=h+1;break}continue}r===-1&&(s=!1,r=h+1),f===n?a===-1?a=h:o!==1&&(o=1):a!==-1&&(o=-1)}return a===-1||r===-1||o===0||o===1&&a===r-1&&a===t+1?"":u.slice(a,r)},format:l.bind(null,"\\"),parse(u){y(u,"path");const c={root:"",dir:"",base:"",ext:"",name:""};if(u.length===0)return c;const a=u.length;let t=0,r=u.charCodeAt(0);if(a===1)return g(r)?(c.root=c.dir=u,c):(c.base=c.name=u,c);if(g(r)){if(t=1,g(u.charCodeAt(1))){let T=2,C=T;for(;T<a&&!g(u.charCodeAt(T));)T++;if(T<a&&T!==C){for(C=T;T<a&&g(u.charCodeAt(T));)T++;if(T<a&&T!==C){for(C=T;T<a&&!g(u.charCodeAt(T));)T++;T===a?t=T:T!==C&&(t=T+1)}}}}else if(D(r)&&u.charCodeAt(1)===i){if(a<=2)return c.root=c.dir=u,c;if(t=2,g(u.charCodeAt(2))){if(a===3)return c.root=c.dir=u,c;t=3}}t>0&&(c.root=u.slice(0,t));let s=-1,o=t,h=-1,f=!0,d=u.length-1,M=0;for(;d>=t;--d){if(r=u.charCodeAt(d),g(r)){if(!f){o=d+1;break}continue}h===-1&&(f=!1,h=d+1),r===n?s===-1?s=d:M!==1&&(M=1):s!==-1&&(M=-1)}return h!==-1&&(s===-1||M===0||M===1&&s===h-1&&s===o+1?c.base=c.name=u.slice(o,h):(c.name=u.slice(o,s),c.base=u.slice(o,h),c.ext=u.slice(s,h))),o>0&&o!==t?c.dir=u.slice(0,o-1):c.dir=c.root,c},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...u){let c="",a=!1;for(let t=u.length-1;t>=-1&&!a;t--){const r=t>=0?u[t]:m.cwd();y(r,"path"),r.length!==0&&(c=`${r}/${c}`,a=r.charCodeAt(0)===w)}return c=b(c,!a,"/",v),a?`/${c}`:c.length>0?c:"."},normalize(u){if(y(u,"path"),u.length===0)return".";const c=u.charCodeAt(0)===w,a=u.charCodeAt(u.length-1)===w;return u=b(u,!c,"/",v),u.length===0?c?"/":a?"./":".":(a&&(u+="/"),c?`/${u}`:u)},isAbsolute(u){return y(u,"path"),u.length>0&&u.charCodeAt(0)===w},join(...u){if(u.length===0)return".";let c;for(let a=0;a<u.length;++a){const t=u[a];y(t,"path"),t.length>0&&(c===void 0?c=t:c+=`/${t}`)}return c===void 0?".":e.posix.normalize(c)},relative(u,c){if(y(u,"from"),y(c,"to"),u===c||(u=e.posix.resolve(u),c=e.posix.resolve(c),u===c))return"";const a=1,t=u.length,r=t-a,s=1,o=c.length-s,h=r<o?r:o;let f=-1,d=0;for(;d<h;d++){const T=u.charCodeAt(a+d);if(T!==c.charCodeAt(s+d))break;T===w&&(f=d)}if(d===h)if(o>h){if(c.charCodeAt(s+d)===w)return c.slice(s+d+1);if(d===0)return c.slice(s+d)}else r>h&&(u.charCodeAt(a+d)===w?f=d:d===0&&(f=0));let M="";for(d=a+f+1;d<=t;++d)(d===t||u.charCodeAt(d)===w)&&(M+=M.length===0?"..":"/..");return`${M}${c.slice(s+f)}`},toNamespacedPath(u){return u},dirname(u){if(y(u,"path"),u.length===0)return".";const c=u.charCodeAt(0)===w;let a=-1,t=!0;for(let r=u.length-1;r>=1;--r)if(u.charCodeAt(r)===w){if(!t){a=r;break}}else t=!1;return a===-1?c?"/":".":c&&a===1?"//":u.slice(0,a)},basename(u,c){c!==void 0&&y(c,"ext"),y(u,"path");let a=0,t=-1,r=!0,s;if(c!==void 0&&c.length>0&&c.length<=u.length){if(c===u)return"";let o=c.length-1,h=-1;for(s=u.length-1;s>=0;--s){const f=u.charCodeAt(s);if(f===w){if(!r){a=s+1;break}}else h===-1&&(r=!1,h=s+1),o>=0&&(f===c.charCodeAt(o)?--o==-1&&(t=s):(o=-1,t=h))}return a===t?t=h:t===-1&&(t=u.length),u.slice(a,t)}for(s=u.length-1;s>=0;--s)if(u.charCodeAt(s)===w){if(!r){a=s+1;break}}else t===-1&&(r=!1,t=s+1);return t===-1?"":u.slice(a,t)},extname(u){y(u,"path");let c=-1,a=0,t=-1,r=!0,s=0;for(let o=u.length-1;o>=0;--o){const h=u.charCodeAt(o);if(h===w){if(!r){a=o+1;break}continue}t===-1&&(r=!1,t=o+1),h===n?c===-1?c=o:s!==1&&(s=1):c!==-1&&(s=-1)}return c===-1||t===-1||s===0||s===1&&c===t-1&&c===a+1?"":u.slice(c,t)},format:l.bind(null,"/"),parse(u){y(u,"path");const c={root:"",dir:"",base:"",ext:"",name:""};if(u.length===0)return c;const a=u.charCodeAt(0)===w;let t;a?(c.root="/",t=1):t=0;let r=-1,s=0,o=-1,h=!0,f=u.length-1,d=0;for(;f>=t;--f){const M=u.charCodeAt(f);if(M===w){if(!h){s=f+1;break}continue}o===-1&&(h=!1,o=f+1),M===n?r===-1?r=f:d!==1&&(d=1):r!==-1&&(d=-1)}if(o!==-1){const M=s===0&&a?1:s;r===-1||d===0||d===1&&r===o-1&&r===s+1?c.base=c.name=u.slice(M,o):(c.name=u.slice(M,r),c.base=u.slice(M,o),c.ext=u.slice(r,o))}return s>0?c.dir=u.slice(0,s-1):a&&(c.dir="/"),c},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=m.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=m.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=m.platform==="win32"?e.win32.join:e.posix.join,e.resolve=m.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=m.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=m.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=m.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=m.platform==="win32"?e.win32.extname:e.posix.extname,e.format=m.platform==="win32"?e.win32.format:e.posix.format,e.parse=m.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=m.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=m.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=m.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(J[105],Z([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var m;(function(S){S[S.stdout=0]="stdout",S[S.stderr=1]="stderr"})(m=e.Source||(e.Source={}));var L;(function(S){S[S.Success=0]="Success",S[S.Unknown=1]="Unknown",S[S.AccessDenied=2]="AccessDenied",S[S.ProcessNotFound=3]="ProcessNotFound"})(L=e.TerminateResponseCode||(e.TerminateResponseCode={}));function A(S,...E){const n=E.reduce((i,I)=>(i[I]=!0,i),{}),w=[/^ELECTRON_.+$/,/^VSCODE_.+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(S).filter(i=>!n[i]).forEach(i=>{for(let I=0;I<w.length;I++)if(i.search(w[I])!==-1){delete S[i];break}})}e.sanitizeProcessEnvironment=A}),define(J[79],Z([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ScanCodeBinding=e.IMMUTABLE_KEY_CODE_TO_CODE=e.IMMUTABLE_CODE_TO_KEY_CODE=e.ScanCodeUtils=e.ScanCode=void 0;var m;(function(n){n[n.DependsOnKbLayout=-1]="DependsOnKbLayout",n[n.None=0]="None",n[n.Hyper=1]="Hyper",n[n.Super=2]="Super",n[n.Fn=3]="Fn",n[n.FnLock=4]="FnLock",n[n.Suspend=5]="Suspend",n[n.Resume=6]="Resume",n[n.Turbo=7]="Turbo",n[n.Sleep=8]="Sleep",n[n.WakeUp=9]="WakeUp",n[n.KeyA=10]="KeyA",n[n.KeyB=11]="KeyB",n[n.KeyC=12]="KeyC",n[n.KeyD=13]="KeyD",n[n.KeyE=14]="KeyE",n[n.KeyF=15]="KeyF",n[n.KeyG=16]="KeyG",n[n.KeyH=17]="KeyH",n[n.KeyI=18]="KeyI",n[n.KeyJ=19]="KeyJ",n[n.KeyK=20]="KeyK",n[n.KeyL=21]="KeyL",n[n.KeyM=22]="KeyM",n[n.KeyN=23]="KeyN",n[n.KeyO=24]="KeyO",n[n.KeyP=25]="KeyP",n[n.KeyQ=26]="KeyQ",n[n.KeyR=27]="KeyR",n[n.KeyS=28]="KeyS",n[n.KeyT=29]="KeyT",n[n.KeyU=30]="KeyU",n[n.KeyV=31]="KeyV",n[n.KeyW=32]="KeyW",n[n.KeyX=33]="KeyX",n[n.KeyY=34]="KeyY",n[n.KeyZ=35]="KeyZ",n[n.Digit1=36]="Digit1",n[n.Digit2=37]="Digit2",n[n.Digit3=38]="Digit3",n[n.Digit4=39]="Digit4",n[n.Digit5=40]="Digit5",n[n.Digit6=41]="Digit6",n[n.Digit7=42]="Digit7",n[n.Digit8=43]="Digit8",n[n.Digit9=44]="Digit9",n[n.Digit0=45]="Digit0",n[n.Enter=46]="Enter",n[n.Escape=47]="Escape",n[n.Backspace=48]="Backspace",n[n.Tab=49]="Tab",n[n.Space=50]="Space",n[n.Minus=51]="Minus",n[n.Equal=52]="Equal",n[n.BracketLeft=53]="BracketLeft",n[n.BracketRight=54]="BracketRight",n[n.Backslash=55]="Backslash",n[n.IntlHash=56]="IntlHash",n[n.Semicolon=57]="Semicolon",n[n.Quote=58]="Quote",n[n.Backquote=59]="Backquote",n[n.Comma=60]="Comma",n[n.Period=61]="Period",n[n.Slash=62]="Slash",n[n.CapsLock=63]="CapsLock",n[n.F1=64]="F1",n[n.F2=65]="F2",n[n.F3=66]="F3",n[n.F4=67]="F4",n[n.F5=68]="F5",n[n.F6=69]="F6",n[n.F7=70]="F7",n[n.F8=71]="F8",n[n.F9=72]="F9",n[n.F10=73]="F10",n[n.F11=74]="F11",n[n.F12=75]="F12",n[n.PrintScreen=76]="PrintScreen",n[n.ScrollLock=77]="ScrollLock",n[n.Pause=78]="Pause",n[n.Insert=79]="Insert",n[n.Home=80]="Home",n[n.PageUp=81]="PageUp",n[n.Delete=82]="Delete",n[n.End=83]="End",n[n.PageDown=84]="PageDown",n[n.ArrowRight=85]="ArrowRight",n[n.ArrowLeft=86]="ArrowLeft",n[n.ArrowDown=87]="ArrowDown",n[n.ArrowUp=88]="ArrowUp",n[n.NumLock=89]="NumLock",n[n.NumpadDivide=90]="NumpadDivide",n[n.NumpadMultiply=91]="NumpadMultiply",n[n.NumpadSubtract=92]="NumpadSubtract",n[n.NumpadAdd=93]="NumpadAdd",n[n.NumpadEnter=94]="NumpadEnter",n[n.Numpad1=95]="Numpad1",n[n.Numpad2=96]="Numpad2",n[n.Numpad3=97]="Numpad3",n[n.Numpad4=98]="Numpad4",n[n.Numpad5=99]="Numpad5",n[n.Numpad6=100]="Numpad6",n[n.Numpad7=101]="Numpad7",n[n.Numpad8=102]="Numpad8",n[n.Numpad9=103]="Numpad9",n[n.Numpad0=104]="Numpad0",n[n.NumpadDecimal=105]="NumpadDecimal",n[n.IntlBackslash=106]="IntlBackslash",n[n.ContextMenu=107]="ContextMenu",n[n.Power=108]="Power",n[n.NumpadEqual=109]="NumpadEqual",n[n.F13=110]="F13",n[n.F14=111]="F14",n[n.F15=112]="F15",n[n.F16=113]="F16",n[n.F17=114]="F17",n[n.F18=115]="F18",n[n.F19=116]="F19",n[n.F20=117]="F20",n[n.F21=118]="F21",n[n.F22=119]="F22",n[n.F23=120]="F23",n[n.F24=121]="F24",n[n.Open=122]="Open",n[n.Help=123]="Help",n[n.Select=124]="Select",n[n.Again=125]="Again",n[n.Undo=126]="Undo",n[n.Cut=127]="Cut",n[n.Copy=128]="Copy",n[n.Paste=129]="Paste",n[n.Find=130]="Find",n[n.AudioVolumeMute=131]="AudioVolumeMute",n[n.AudioVolumeUp=132]="AudioVolumeUp",n[n.AudioVolumeDown=133]="AudioVolumeDown",n[n.NumpadComma=134]="NumpadComma",n[n.IntlRo=135]="IntlRo",n[n.KanaMode=136]="KanaMode",n[n.IntlYen=137]="IntlYen",n[n.Convert=138]="Convert",n[n.NonConvert=139]="NonConvert",n[n.Lang1=140]="Lang1",n[n.Lang2=141]="Lang2",n[n.Lang3=142]="Lang3",n[n.Lang4=143]="Lang4",n[n.Lang5=144]="Lang5",n[n.Abort=145]="Abort",n[n.Props=146]="Props",n[n.NumpadParenLeft=147]="NumpadParenLeft",n[n.NumpadParenRight=148]="NumpadParenRight",n[n.NumpadBackspace=149]="NumpadBackspace",n[n.NumpadMemoryStore=150]="NumpadMemoryStore",n[n.NumpadMemoryRecall=151]="NumpadMemoryRecall",n[n.NumpadMemoryClear=152]="NumpadMemoryClear",n[n.NumpadMemoryAdd=153]="NumpadMemoryAdd",n[n.NumpadMemorySubtract=154]="NumpadMemorySubtract",n[n.NumpadClear=155]="NumpadClear",n[n.NumpadClearEntry=156]="NumpadClearEntry",n[n.ControlLeft=157]="ControlLeft",n[n.ShiftLeft=158]="ShiftLeft",n[n.AltLeft=159]="AltLeft",n[n.MetaLeft=160]="MetaLeft",n[n.ControlRight=161]="ControlRight",n[n.ShiftRight=162]="ShiftRight",n[n.AltRight=163]="AltRight",n[n.MetaRight=164]="MetaRight",n[n.BrightnessUp=165]="BrightnessUp",n[n.BrightnessDown=166]="BrightnessDown",n[n.MediaPlay=167]="MediaPlay",n[n.MediaRecord=168]="MediaRecord",n[n.MediaFastForward=169]="MediaFastForward",n[n.MediaRewind=170]="MediaRewind",n[n.MediaTrackNext=171]="MediaTrackNext",n[n.MediaTrackPrevious=172]="MediaTrackPrevious",n[n.MediaStop=173]="MediaStop",n[n.Eject=174]="Eject",n[n.MediaPlayPause=175]="MediaPlayPause",n[n.MediaSelect=176]="MediaSelect",n[n.LaunchMail=177]="LaunchMail",n[n.LaunchApp2=178]="LaunchApp2",n[n.LaunchApp1=179]="LaunchApp1",n[n.SelectTask=180]="SelectTask",n[n.LaunchScreenSaver=181]="LaunchScreenSaver",n[n.BrowserSearch=182]="BrowserSearch",n[n.BrowserHome=183]="BrowserHome",n[n.BrowserBack=184]="BrowserBack",n[n.BrowserForward=185]="BrowserForward",n[n.BrowserStop=186]="BrowserStop",n[n.BrowserRefresh=187]="BrowserRefresh",n[n.BrowserFavorites=188]="BrowserFavorites",n[n.ZoomToggle=189]="ZoomToggle",n[n.MailReply=190]="MailReply",n[n.MailForward=191]="MailForward",n[n.MailSend=192]="MailSend",n[n.MAX_VALUE=193]="MAX_VALUE"})(m=e.ScanCode||(e.ScanCode={}));const L=[],A=Object.create(null),S=Object.create(null);e.ScanCodeUtils={lowerCaseToEnum:n=>S[n]||0,toEnum:n=>A[n]||0,toString:n=>L[n]||"None"},e.IMMUTABLE_CODE_TO_KEY_CODE=[],e.IMMUTABLE_KEY_CODE_TO_CODE=[];class E{constructor(w,p,i,I,P){this.ctrlKey=w,this.shiftKey=p,this.altKey=i,this.metaKey=I,this.scanCode=P}equals(w){return this.ctrlKey===w.ctrlKey&&this.shiftKey===w.shiftKey&&this.altKey===w.altKey&&this.metaKey===w.metaKey&&this.scanCode===w.scanCode}isDuplicateModifierCase(){return this.ctrlKey&&(this.scanCode===157||this.scanCode===161)||this.shiftKey&&(this.scanCode===158||this.scanCode===162)||this.altKey&&(this.scanCode===159||this.scanCode===163)||this.metaKey&&(this.scanCode===160||this.scanCode===164)}}e.ScanCodeBinding=E,function(){function n(w,p){L[w]=p,A[p]=w,S[p.toLowerCase()]=w}n(0,"None"),n(1,"Hyper"),n(2,"Super"),n(3,"Fn"),n(4,"FnLock"),n(5,"Suspend"),n(6,"Resume"),n(7,"Turbo"),n(8,"Sleep"),n(9,"WakeUp"),n(10,"KeyA"),n(11,"KeyB"),n(12,"KeyC"),n(13,"KeyD"),n(14,"KeyE"),n(15,"KeyF"),n(16,"KeyG"),n(17,"KeyH"),n(18,"KeyI"),n(19,"KeyJ"),n(20,"KeyK"),n(21,"KeyL"),n(22,"KeyM"),n(23,"KeyN"),n(24,"KeyO"),n(25,"KeyP"),n(26,"KeyQ"),n(27,"KeyR"),n(28,"KeyS"),n(29,"KeyT"),n(30,"KeyU"),n(31,"KeyV"),n(32,"KeyW"),n(33,"KeyX"),n(34,"KeyY"),n(35,"KeyZ"),n(36,"Digit1"),n(37,"Digit2"),n(38,"Digit3"),n(39,"Digit4"),n(40,"Digit5"),n(41,"Digit6"),n(42,"Digit7"),n(43,"Digit8"),n(44,"Digit9"),n(45,"Digit0"),n(46,"Enter"),n(47,"Escape"),n(48,"Backspace"),n(49,"Tab"),n(50,"Space"),n(51,"Minus"),n(52,"Equal"),n(53,"BracketLeft"),n(54,"BracketRight"),n(55,"Backslash"),n(56,"IntlHash"),n(57,"Semicolon"),n(58,"Quote"),n(59,"Backquote"),n(60,"Comma"),n(61,"Period"),n(62,"Slash"),n(63,"CapsLock"),n(64,"F1"),n(65,"F2"),n(66,"F3"),n(67,"F4"),n(68,"F5"),n(69,"F6"),n(70,"F7"),n(71,"F8"),n(72,"F9"),n(73,"F10"),n(74,"F11"),n(75,"F12"),n(76,"PrintScreen"),n(77,"ScrollLock"),n(78,"Pause"),n(79,"Insert"),n(80,"Home"),n(81,"PageUp"),n(82,"Delete"),n(83,"End"),n(84,"PageDown"),n(85,"ArrowRight"),n(86,"ArrowLeft"),n(87,"ArrowDown"),n(88,"ArrowUp"),n(89,"NumLock"),n(90,"NumpadDivide"),n(91,"NumpadMultiply"),n(92,"NumpadSubtract"),n(93,"NumpadAdd"),n(94,"NumpadEnter"),n(95,"Numpad1"),n(96,"Numpad2"),n(97,"Numpad3"),n(98,"Numpad4"),n(99,"Numpad5"),n(100,"Numpad6"),n(101,"Numpad7"),n(102,"Numpad8"),n(103,"Numpad9"),n(104,"Numpad0"),n(105,"NumpadDecimal"),n(106,"IntlBackslash"),n(107,"ContextMenu"),n(108,"Power"),n(109,"NumpadEqual"),n(110,"F13"),n(111,"F14"),n(112,"F15"),n(113,"F16"),n(114,"F17"),n(115,"F18"),n(116,"F19"),n(117,"F20"),n(118,"F21"),n(119,"F22"),n(120,"F23"),n(121,"F24"),n(122,"Open"),n(123,"Help"),n(124,"Select"),n(125,"Again"),n(126,"Undo"),n(127,"Cut"),n(128,"Copy"),n(129,"Paste"),n(130,"Find"),n(131,"AudioVolumeMute"),n(132,"AudioVolumeUp"),n(133,"AudioVolumeDown"),n(134,"NumpadComma"),n(135,"IntlRo"),n(136,"KanaMode"),n(137,"IntlYen"),n(138,"Convert"),n(139,"NonConvert"),n(140,"Lang1"),n(141,"Lang2"),n(142,"Lang3"),n(143,"Lang4"),n(144,"Lang5"),n(145,"Abort"),n(146,"Props"),n(147,"NumpadParenLeft"),n(148,"NumpadParenRight"),n(149,"NumpadBackspace"),n(150,"NumpadMemoryStore"),n(151,"NumpadMemoryRecall"),n(152,"NumpadMemoryClear"),n(153,"NumpadMemoryAdd"),n(154,"NumpadMemorySubtract"),n(155,"NumpadClear"),n(156,"NumpadClearEntry"),n(157,"ControlLeft"),n(158,"ShiftLeft"),n(159,"AltLeft"),n(160,"MetaLeft"),n(161,"ControlRight"),n(162,"ShiftRight"),n(163,"AltRight"),n(164,"MetaRight"),n(165,"BrightnessUp"),n(166,"BrightnessDown"),n(167,"MediaPlay"),n(168,"MediaRecord"),n(169,"MediaFastForward"),n(170,"MediaRewind"),n(171,"MediaTrackNext"),n(172,"MediaTrackPrevious"),n(173,"MediaStop"),n(174,"Eject"),n(175,"MediaPlayPause"),n(176,"MediaSelect"),n(177,"LaunchMail"),n(178,"LaunchApp2"),n(179,"LaunchApp1"),n(180,"SelectTask"),n(181,"LaunchScreenSaver"),n(182,"BrowserSearch"),n(183,"BrowserHome"),n(184,"BrowserBack"),n(185,"BrowserForward"),n(186,"BrowserStop"),n(187,"BrowserRefresh"),n(188,"BrowserFavorites"),n(189,"ZoomToggle"),n(190,"MailReply"),n(191,"MailForward"),n(192,"MailSend")}(),function(){for(let w=0;w<=193;w++)e.IMMUTABLE_CODE_TO_KEY_CODE[w]=-1;for(let w=0;w<=112;w++)e.IMMUTABLE_KEY_CODE_TO_CODE[w]=-1;function n(w,p){e.IMMUTABLE_CODE_TO_KEY_CODE[w]=p,p!==0&&p!==3&&p!==5&&p!==4&&p!==6&&p!==57&&(e.IMMUTABLE_KEY_CODE_TO_CODE[p]=w)}e.IMMUTABLE_KEY_CODE_TO_CODE[3]=46,n(0,0),n(1,0),n(2,0),n(3,0),n(4,0),n(5,0),n(6,0),n(7,0),n(8,0),n(9,0),n(46,3),n(47,9),n(48,1),n(49,2),n(50,10),n(63,8),n(64,59),n(65,60),n(66,61),n(67,62),n(68,63),n(69,64),n(70,65),n(71,66),n(72,67),n(73,68),n(74,69),n(75,70),n(76,0),n(77,79),n(78,7),n(79,19),n(80,14),n(81,11),n(82,20),n(83,13),n(84,12),n(85,17),n(86,15),n(87,18),n(88,16),n(89,78),n(90,108),n(91,103),n(92,106),n(93,104),n(94,3),n(95,94),n(96,95),n(97,96),n(98,97),n(99,98),n(100,99),n(101,100),n(102,101),n(103,102),n(104,93),n(105,107),n(107,58),n(108,0),n(109,0),n(110,71),n(111,72),n(112,73),n(113,74),n(114,75),n(115,76),n(116,77),n(117,0),n(118,0),n(119,0),n(120,0),n(121,0),n(122,0),n(123,0),n(124,0),n(125,0),n(126,0),n(127,0),n(128,0),n(129,0),n(130,0),n(131,0),n(132,0),n(133,0),n(134,105),n(136,0),n(138,0),n(139,0),n(140,0),n(141,0),n(142,0),n(143,0),n(144,0),n(145,0),n(146,0),n(147,0),n(148,0),n(149,0),n(150,0),n(151,0),n(152,0),n(153,0),n(154,0),n(155,0),n(156,0),n(157,5),n(158,4),n(159,6),n(160,57),n(161,5),n(162,4),n(163,6),n(164,57),n(165,0),n(166,0),n(167,0),n(168,0),n(169,0),n(170,0),n(171,0),n(172,0),n(173,0),n(174,0),n(175,0),n(176,0),n(177,0),n(178,0),n(179,0),n(180,0),n(181,0),n(182,0),n(183,0),n(184,0),n(185,0),n(186,0),n(187,0),n(188,0),n(189,0),n(190,0),n(191,0),n(192,0)}()}),define(J[106],Z([0,1,57,79]),function(z,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeybindingParser=void 0;class A{static _readModifiers(E){E=E.toLowerCase().trim();let n=!1,w=!1,p=!1,i=!1,I;do I=!1,/^ctrl(\+|\-)/.test(E)&&(n=!0,E=E.substr("ctrl-".length),I=!0),/^shift(\+|\-)/.test(E)&&(w=!0,E=E.substr("shift-".length),I=!0),/^alt(\+|\-)/.test(E)&&(p=!0,E=E.substr("alt-".length),I=!0),/^meta(\+|\-)/.test(E)&&(i=!0,E=E.substr("meta-".length),I=!0),/^win(\+|\-)/.test(E)&&(i=!0,E=E.substr("win-".length),I=!0),/^cmd(\+|\-)/.test(E)&&(i=!0,E=E.substr("cmd-".length),I=!0);while(I);let P;const y=E.indexOf(" ");return y>0?(P=E.substring(0,y),E=E.substring(y)):(P=E,E=""),{remains:E,ctrl:n,shift:w,alt:p,meta:i,key:P}}static parseSimpleKeybinding(E){const n=this._readModifiers(E),w=m.KeyCodeUtils.fromUserSettings(n.key);return[new m.SimpleKeybinding(n.ctrl,n.shift,n.alt,n.meta,w),n.remains]}static parseKeybinding(E,n){if(!E)return null;const w=[];let p;do[p,E]=this.parseSimpleKeybinding(E),w.push(p);while(E.length>0);return new m.ChordKeybinding(w)}static parseSimpleUserBinding(E){const n=this._readModifiers(E),w=n.key.match(/^\[([^\]]+)\]$/);if(w){const i=w[1],I=L.ScanCodeUtils.lowerCaseToEnum(i);return[new L.ScanCodeBinding(n.ctrl,n.shift,n.alt,n.meta,I),n.remains]}const p=m.KeyCodeUtils.fromUserSettings(n.key);return[new m.SimpleKeybinding(n.ctrl,n.shift,n.alt,n.meta,p),n.remains]}static parseUserBinding(E){if(!E)return[];const n=[];let w;for(;E.length>0;)[w,E]=this.parseSimpleUserBinding(E),n.push(w);return n}}e.KeybindingParser=A}),define(J[107],Z([0,1,3]),function(z,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const L=m.globals.performance&&typeof m.globals.performance.now=="function";class A{constructor(E){this._highResolution=L&&E,this._startTime=this._now(),this._stopTime=-1}static create(E=!0){return new A(E)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?m.globals.performance.now():Date.now()}}e.StopWatch=A}),define(J[5],Z([0,1,19,42,2,78,107]),function(z,e,m,L,A,S,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.PauseableEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var n;(function(b){b.None=()=>A.Disposable.None;function l(X){return(_,$=null,G)=>{let N=!1,F;return F=X(R=>{if(!N)return F?F.dispose():N=!0,_.call($,R)},null,G),N&&F.dispose(),F}}b.once=l;function u(X,_){return o(($,G=null,N)=>X(F=>$.call(G,_(F)),null,N))}b.map=u;function c(X,_){return o(($,G=null,N)=>X(F=>{_(F),$.call(G,F)},null,N))}b.forEach=c;function a(X,_){return o(($,G=null,N)=>X(F=>_(F)&&$.call(G,F),null,N))}b.filter=a;function t(X){return X}b.signal=t;function r(...X){return(_,$=null,G)=>A.combinedDisposable(...X.map(N=>N(F=>_.call($,F),null,G)))}b.any=r;function s(X,_,$){let G=$;return u(X,N=>(G=_(G,N),G))}b.reduce=s;function o(X){let _;const $=new P({onFirstListenerAdd(){_=X($.fire,$)},onLastListenerRemove(){_.dispose()}});return $.event}b.snapshot=o;function h(X,_,$=100,G=!1,N){let F,R,O,k=0;const W=new P({leakWarningThreshold:N,onFirstListenerAdd(){F=X(U=>{k++,R=_(R,U),G&&!O&&(W.fire(R),R=void 0),clearTimeout(O),O=setTimeout(()=>{const q=R;R=void 0,O=void 0,(!G||k>1)&&W.fire(q),k=0},$)})},onLastListenerRemove(){F.dispose()}});return W.event}b.debounce=h;function f(X){const _=new Date().getTime();return u(l(X),$=>new Date().getTime()-_)}b.stopwatch=f;function d(X,_=($,G)=>$===G){let $=!0,G;return a(X,N=>{const F=$||!_(N,G);return $=!1,G=N,F})}b.latch=d;function M(X,_){return[b.filter(X,_),b.filter(X,$=>!_($))]}b.split=M;function T(X,_=!1,$=[]){let G=$.slice(),N=X(O=>{G?G.push(O):R.fire(O)});const F=()=>{G&&G.forEach(O=>R.fire(O)),G=null},R=new P({onFirstListenerAdd(){N||(N=X(O=>R.fire(O)))},onFirstListenerDidAdd(){G&&(_?setTimeout(F):F())},onLastListenerRemove(){N&&N.dispose(),N=null}});return R.event}b.buffer=T;class C{constructor(_){this.event=_}map(_){return new C(u(this.event,_))}forEach(_){return new C(c(this.event,_))}filter(_){return new C(a(this.event,_))}reduce(_,$){return new C(s(this.event,_,$))}latch(){return new C(d(this.event))}debounce(_,$=100,G=!1,N){return new C(h(this.event,_,$,G,N))}on(_,$,G){return this.event(_,$,G)}once(_,$,G){return l(this.event)(_,$,G)}}function V(X){return new C(X)}b.chain=V;function Q(X,_,$=G=>G){const G=(...O)=>R.fire($(...O)),N=()=>X.on(_,G),F=()=>X.removeListener(_,G),R=new P({onFirstListenerAdd:N,onLastListenerRemove:F});return R.event}b.fromNodeEventEmitter=Q;function te(X,_,$=G=>G){const G=(...O)=>R.fire($(...O)),N=()=>X.addEventListener(_,G),F=()=>X.removeEventListener(_,G),R=new P({onFirstListenerAdd:N,onLastListenerRemove:F});return R.event}b.fromDOMEventEmitter=te;function B(X){const _=new P;let $=!1;return X.then(void 0,()=>null).then(()=>{$?_.fire(void 0):setTimeout(()=>_.fire(void 0),0)}),$=!0,_.event}b.fromPromise=B;function Y(X){return new Promise(_=>l(X)(_))}b.toPromise=Y})(n=e.Event||(e.Event={}));class w{constructor(l){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${l}_${w._idPool++}`}start(l){this._stopWatch=new E.StopWatch(!0),this._listenerCount=l}stop(){if(this._stopWatch){const l=this._stopWatch.elapsed();this._elapsedOverall+=l,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${l.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}w._idPool=0;let p=-1;function i(b){const l=p;return p=b,{dispose(){p=l}}}e.setGlobalLeakWarningThreshold=i;class I{constructor(l,u=Math.random().toString(18).slice(2,5)){this.customThreshold=l,this.name=u,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(l){let u=p;if(typeof this.customThreshold=="number"&&(u=this.customThreshold),u<=0||l<u)return;this._stacks||(this._stacks=new Map);const c=new Error().stack.split(`
`).slice(3).join(`
`),a=this._stacks.get(c)||0;if(this._stacks.set(c,a+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=u*.5;let t,r=0;for(const[s,o]of this._stacks)(!t||r<o)&&(t=s,r=o);console.warn(`[${this.name}] potential listener LEAK detected, having ${l} listeners already. MOST frequent listener (${r}):`),console.warn(t)}return()=>{const t=this._stacks.get(c)||0;this._stacks.set(c,t-1)}}}class P{constructor(l){var u;this._disposed=!1,this._options=l,this._leakageMon=p>0?new I(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=((u=this._options)===null||u===void 0?void 0:u._profName)?new w(this._options._profName):void 0}get event(){return this._event||(this._event=(l,u,c)=>{var a;this._listeners||(this._listeners=new S.LinkedList);const t=this._listeners.isEmpty();t&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const r=this._listeners.push(u?[l,u]:l);t&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,l,u);const s=(a=this._leakageMon)===null||a===void 0?void 0:a.check(this._listeners.size);let o;return o={dispose:()=>{s&&s(),o.dispose=P._noop,this._disposed||(r(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))}},c instanceof A.DisposableStore?c.add(o):Array.isArray(c)&&c.push(o),o}),this._event}fire(l){var u,c;if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new S.LinkedList);for(let a of this._listeners)this._deliveryQueue.push([a,l]);for((u=this._perfMon)===null||u===void 0||u.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[a,t]=this._deliveryQueue.shift();try{typeof a=="function"?a.call(void 0,t):a[0].call(a[1],t)}catch(r){m.onUnexpectedError(r)}}(c=this._perfMon)===null||c===void 0||c.stop()}}dispose(){var l,u,c,a,t;this._disposed||(this._disposed=!0,(l=this._listeners)===null||l===void 0||l.clear(),(u=this._deliveryQueue)===null||u===void 0||u.clear(),(a=(c=this._options)===null||c===void 0?void 0:c.onLastListenerRemove)===null||a===void 0||a.call(c),(t=this._leakageMon)===null||t===void 0||t.dispose())}}e.Emitter=P,P._noop=function(){};class y extends P{constructor(l){super(l);this._isPaused=0,this._eventQueue=new S.LinkedList,this._mergeFn=l==null?void 0:l.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const l=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(l))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(l){this._listeners&&(this._isPaused!==0?this._eventQueue.push(l):super.fire(l))}}e.PauseableEmitter=y;class g{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new P({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(l){const u={event:l,listener:null};this.events.push(u),this.hasListeners&&this.hook(u);const c=()=>{this.hasListeners&&this.unhook(u);const a=this.events.indexOf(u);this.events.splice(a,1)};return A.toDisposable(L.once(c))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(l=>this.hook(l))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(l=>this.unhook(l))}hook(l){l.listener=l.event(u=>this.emitter.fire(u))}unhook(l){l.listener&&l.listener.dispose(),l.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=g;class v{constructor(){this.buffers=[]}wrapEvent(l){return(u,c,a)=>l(t=>{const r=this.buffers[this.buffers.length-1];r?r.push(()=>u.call(c,t)):u.call(c,t)},void 0,a)}bufferEvents(l){const u=[];this.buffers.push(u);const c=l();return this.buffers.pop(),u.forEach(a=>a()),c}}e.EventBufferer=v;class D{constructor(){this.listening=!1,this.inputEvent=n.None,this.inputEventListener=A.Disposable.None,this.emitter=new P({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(l){this.inputEvent=l,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=l(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=D}),define(J[25],Z([0,1,5]),function(z,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const L=Object.freeze(function(n,w){const p=setTimeout(n.bind(w),0);return{dispose(){clearTimeout(p)}}});var A;(function(n){function w(p){return p===n.None||p===n.Cancelled||p instanceof S?!0:!p||typeof p!="object"?!1:typeof p.isCancellationRequested=="boolean"&&typeof p.onCancellationRequested=="function"}n.isCancellationToken=w,n.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:m.Event.None}),n.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:L})})(A=e.CancellationToken||(e.CancellationToken={}));class S{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?L:(this._emitter||(this._emitter=new m.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class E{constructor(w){this._token=void 0,this._parentListener=void 0,this._parentListener=w&&w.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new S),this._token}cancel(){this._token?this._token instanceof S&&this._token.cancel():this._token=A.Cancelled}dispose(w=!1){w&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof S&&this._token.dispose():this._token=A.None}}e.CancellationTokenSource=E}),define(J[108],Z([0,1,5]),function(z,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=e.registerCodicon=e.iconRegistry=void 0;class L{constructor(){this._icons=new Map,this._onDidRegister=new m.Emitter}add(I){const P=this._icons.get(I.id);P?I.description?P.description=I.description:console.error(`Duplicate registration of codicon ${I.id}`):(this._icons.set(I.id,I),this._onDidRegister.fire(I))}get(I){return this._icons.get(I)}get all(){return this._icons.values()}get onDidRegister(){return this._onDidRegister.event}}const A=new L;e.iconRegistry=A;function S(i,I){return new n(i,I)}e.registerCodicon=S;function E(i){return i?i.replace(/\$\((.*?)\)/g,(I,P)=>` ${P} `).trim():""}e.getCodiconAriaLabel=E;class n{constructor(I,P,y){this.id=I,this.definition=P,this.description=y,A.add(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}}e.Codicon=n;function w(i,I){const P=["codicon","codicon-"+i];return I&&P.push("codicon-modifier-"+I),P}e.getClassNamesArray=w;var p;(function(i){i.iconNameSegment="[A-Za-z0-9]+",i.iconNameExpression="[A-Za-z0-9\\-]+",i.iconModifierExpression="~[A-Za-z]+";const I=new RegExp(`^(${i.iconNameExpression})(${i.iconModifierExpression})?$`);function P(v){if(v instanceof n)return["codicon","codicon-"+v.id];const D=I.exec(v.id);if(!D)return P(n.error);let[,b,l]=D;const u=["codicon","codicon-"+b];return l&&u.push("codicon-modifier-"+l.substr(1)),u}i.asClassNameArray=P;function y(v){return P(v).join(" ")}i.asClassName=y;function g(v){return"."+P(v).join(".")}i.asCSSSelector=g})(p=e.CSSIcon||(e.CSSIcon={})),function(i){i.add=new i("add",{fontCharacter:"\\ea60"}),i.plus=new i("plus",{fontCharacter:"\\ea60"}),i.gistNew=new i("gist-new",{fontCharacter:"\\ea60"}),i.repoCreate=new i("repo-create",{fontCharacter:"\\ea60"}),i.lightbulb=new i("lightbulb",{fontCharacter:"\\ea61"}),i.lightBulb=new i("light-bulb",{fontCharacter:"\\ea61"}),i.repo=new i("repo",{fontCharacter:"\\ea62"}),i.repoDelete=new i("repo-delete",{fontCharacter:"\\ea62"}),i.gistFork=new i("gist-fork",{fontCharacter:"\\ea63"}),i.repoForked=new i("repo-forked",{fontCharacter:"\\ea63"}),i.gitPullRequest=new i("git-pull-request",{fontCharacter:"\\ea64"}),i.gitPullRequestAbandoned=new i("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),i.recordKeys=new i("record-keys",{fontCharacter:"\\ea65"}),i.keyboard=new i("keyboard",{fontCharacter:"\\ea65"}),i.tag=new i("tag",{fontCharacter:"\\ea66"}),i.tagAdd=new i("tag-add",{fontCharacter:"\\ea66"}),i.tagRemove=new i("tag-remove",{fontCharacter:"\\ea66"}),i.person=new i("person",{fontCharacter:"\\ea67"}),i.personFollow=new i("person-follow",{fontCharacter:"\\ea67"}),i.personOutline=new i("person-outline",{fontCharacter:"\\ea67"}),i.personFilled=new i("person-filled",{fontCharacter:"\\ea67"}),i.gitBranch=new i("git-branch",{fontCharacter:"\\ea68"}),i.gitBranchCreate=new i("git-branch-create",{fontCharacter:"\\ea68"}),i.gitBranchDelete=new i("git-branch-delete",{fontCharacter:"\\ea68"}),i.sourceControl=new i("source-control",{fontCharacter:"\\ea68"}),i.mirror=new i("mirror",{fontCharacter:"\\ea69"}),i.mirrorPublic=new i("mirror-public",{fontCharacter:"\\ea69"}),i.star=new i("star",{fontCharacter:"\\ea6a"}),i.starAdd=new i("star-add",{fontCharacter:"\\ea6a"}),i.starDelete=new i("star-delete",{fontCharacter:"\\ea6a"}),i.starEmpty=new i("star-empty",{fontCharacter:"\\ea6a"}),i.comment=new i("comment",{fontCharacter:"\\ea6b"}),i.commentAdd=new i("comment-add",{fontCharacter:"\\ea6b"}),i.alert=new i("alert",{fontCharacter:"\\ea6c"}),i.warning=new i("warning",{fontCharacter:"\\ea6c"}),i.search=new i("search",{fontCharacter:"\\ea6d"}),i.searchSave=new i("search-save",{fontCharacter:"\\ea6d"}),i.logOut=new i("log-out",{fontCharacter:"\\ea6e"}),i.signOut=new i("sign-out",{fontCharacter:"\\ea6e"}),i.logIn=new i("log-in",{fontCharacter:"\\ea6f"}),i.signIn=new i("sign-in",{fontCharacter:"\\ea6f"}),i.eye=new i("eye",{fontCharacter:"\\ea70"}),i.eyeUnwatch=new i("eye-unwatch",{fontCharacter:"\\ea70"}),i.eyeWatch=new i("eye-watch",{fontCharacter:"\\ea70"}),i.circleFilled=new i("circle-filled",{fontCharacter:"\\ea71"}),i.primitiveDot=new i("primitive-dot",{fontCharacter:"\\ea71"}),i.closeDirty=new i("close-dirty",{fontCharacter:"\\ea71"}),i.debugBreakpoint=new i("debug-breakpoint",{fontCharacter:"\\ea71"}),i.debugBreakpointDisabled=new i("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),i.debugHint=new i("debug-hint",{fontCharacter:"\\ea71"}),i.primitiveSquare=new i("primitive-square",{fontCharacter:"\\ea72"}),i.edit=new i("edit",{fontCharacter:"\\ea73"}),i.pencil=new i("pencil",{fontCharacter:"\\ea73"}),i.info=new i("info",{fontCharacter:"\\ea74"}),i.issueOpened=new i("issue-opened",{fontCharacter:"\\ea74"}),i.gistPrivate=new i("gist-private",{fontCharacter:"\\ea75"}),i.gitForkPrivate=new i("git-fork-private",{fontCharacter:"\\ea75"}),i.lock=new i("lock",{fontCharacter:"\\ea75"}),i.mirrorPrivate=new i("mirror-private",{fontCharacter:"\\ea75"}),i.close=new i("close",{fontCharacter:"\\ea76"}),i.removeClose=new i("remove-close",{fontCharacter:"\\ea76"}),i.x=new i("x",{fontCharacter:"\\ea76"}),i.repoSync=new i("repo-sync",{fontCharacter:"\\ea77"}),i.sync=new i("sync",{fontCharacter:"\\ea77"}),i.clone=new i("clone",{fontCharacter:"\\ea78"}),i.desktopDownload=new i("desktop-download",{fontCharacter:"\\ea78"}),i.beaker=new i("beaker",{fontCharacter:"\\ea79"}),i.microscope=new i("microscope",{fontCharacter:"\\ea79"}),i.vm=new i("vm",{fontCharacter:"\\ea7a"}),i.deviceDesktop=new i("device-desktop",{fontCharacter:"\\ea7a"}),i.file=new i("file",{fontCharacter:"\\ea7b"}),i.fileText=new i("file-text",{fontCharacter:"\\ea7b"}),i.more=new i("more",{fontCharacter:"\\ea7c"}),i.ellipsis=new i("ellipsis",{fontCharacter:"\\ea7c"}),i.kebabHorizontal=new i("kebab-horizontal",{fontCharacter:"\\ea7c"}),i.mailReply=new i("mail-reply",{fontCharacter:"\\ea7d"}),i.reply=new i("reply",{fontCharacter:"\\ea7d"}),i.organization=new i("organization",{fontCharacter:"\\ea7e"}),i.organizationFilled=new i("organization-filled",{fontCharacter:"\\ea7e"}),i.organizationOutline=new i("organization-outline",{fontCharacter:"\\ea7e"}),i.newFile=new i("new-file",{fontCharacter:"\\ea7f"}),i.fileAdd=new i("file-add",{fontCharacter:"\\ea7f"}),i.newFolder=new i("new-folder",{fontCharacter:"\\ea80"}),i.fileDirectoryCreate=new i("file-directory-create",{fontCharacter:"\\ea80"}),i.trash=new i("trash",{fontCharacter:"\\ea81"}),i.trashcan=new i("trashcan",{fontCharacter:"\\ea81"}),i.history=new i("history",{fontCharacter:"\\ea82"}),i.clock=new i("clock",{fontCharacter:"\\ea82"}),i.folder=new i("folder",{fontCharacter:"\\ea83"}),i.fileDirectory=new i("file-directory",{fontCharacter:"\\ea83"}),i.symbolFolder=new i("symbol-folder",{fontCharacter:"\\ea83"}),i.logoGithub=new i("logo-github",{fontCharacter:"\\ea84"}),i.markGithub=new i("mark-github",{fontCharacter:"\\ea84"}),i.github=new i("github",{fontCharacter:"\\ea84"}),i.terminal=new i("terminal",{fontCharacter:"\\ea85"}),i.console=new i("console",{fontCharacter:"\\ea85"}),i.repl=new i("repl",{fontCharacter:"\\ea85"}),i.zap=new i("zap",{fontCharacter:"\\ea86"}),i.symbolEvent=new i("symbol-event",{fontCharacter:"\\ea86"}),i.error=new i("error",{fontCharacter:"\\ea87"}),i.stop=new i("stop",{fontCharacter:"\\ea87"}),i.variable=new i("variable",{fontCharacter:"\\ea88"}),i.symbolVariable=new i("symbol-variable",{fontCharacter:"\\ea88"}),i.array=new i("array",{fontCharacter:"\\ea8a"}),i.symbolArray=new i("symbol-array",{fontCharacter:"\\ea8a"}),i.symbolModule=new i("symbol-module",{fontCharacter:"\\ea8b"}),i.symbolPackage=new i("symbol-package",{fontCharacter:"\\ea8b"}),i.symbolNamespace=new i("symbol-namespace",{fontCharacter:"\\ea8b"}),i.symbolObject=new i("symbol-object",{fontCharacter:"\\ea8b"}),i.symbolMethod=new i("symbol-method",{fontCharacter:"\\ea8c"}),i.symbolFunction=new i("symbol-function",{fontCharacter:"\\ea8c"}),i.symbolConstructor=new i("symbol-constructor",{fontCharacter:"\\ea8c"}),i.symbolBoolean=new i("symbol-boolean",{fontCharacter:"\\ea8f"}),i.symbolNull=new i("symbol-null",{fontCharacter:"\\ea8f"}),i.symbolNumeric=new i("symbol-numeric",{fontCharacter:"\\ea90"}),i.symbolNumber=new i("symbol-number",{fontCharacter:"\\ea90"}),i.symbolStructure=new i("symbol-structure",{fontCharacter:"\\ea91"}),i.symbolStruct=new i("symbol-struct",{fontCharacter:"\\ea91"}),i.symbolParameter=new i("symbol-parameter",{fontCharacter:"\\ea92"}),i.symbolTypeParameter=new i("symbol-type-parameter",{fontCharacter:"\\ea92"}),i.symbolKey=new i("symbol-key",{fontCharacter:"\\ea93"}),i.symbolText=new i("symbol-text",{fontCharacter:"\\ea93"}),i.symbolReference=new i("symbol-reference",{fontCharacter:"\\ea94"}),i.goToFile=new i("go-to-file",{fontCharacter:"\\ea94"}),i.symbolEnum=new i("symbol-enum",{fontCharacter:"\\ea95"}),i.symbolValue=new i("symbol-value",{fontCharacter:"\\ea95"}),i.symbolRuler=new i("symbol-ruler",{fontCharacter:"\\ea96"}),i.symbolUnit=new i("symbol-unit",{fontCharacter:"\\ea96"}),i.activateBreakpoints=new i("activate-breakpoints",{fontCharacter:"\\ea97"}),i.archive=new i("archive",{fontCharacter:"\\ea98"}),i.arrowBoth=new i("arrow-both",{fontCharacter:"\\ea99"}),i.arrowDown=new i("arrow-down",{fontCharacter:"\\ea9a"}),i.arrowLeft=new i("arrow-left",{fontCharacter:"\\ea9b"}),i.arrowRight=new i("arrow-right",{fontCharacter:"\\ea9c"}),i.arrowSmallDown=new i("arrow-small-down",{fontCharacter:"\\ea9d"}),i.arrowSmallLeft=new i("arrow-small-left",{fontCharacter:"\\ea9e"}),i.arrowSmallRight=new i("arrow-small-right",{fontCharacter:"\\ea9f"}),i.arrowSmallUp=new i("arrow-small-up",{fontCharacter:"\\eaa0"}),i.arrowUp=new i("arrow-up",{fontCharacter:"\\eaa1"}),i.bell=new i("bell",{fontCharacter:"\\eaa2"}),i.bold=new i("bold",{fontCharacter:"\\eaa3"}),i.book=new i("book",{fontCharacter:"\\eaa4"}),i.bookmark=new i("bookmark",{fontCharacter:"\\eaa5"}),i.debugBreakpointConditionalUnverified=new i("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),i.debugBreakpointConditional=new i("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),i.debugBreakpointConditionalDisabled=new i("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),i.debugBreakpointDataUnverified=new i("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),i.debugBreakpointData=new i("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),i.debugBreakpointDataDisabled=new i("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),i.debugBreakpointLogUnverified=new i("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),i.debugBreakpointLog=new i("debug-breakpoint-log",{fontCharacter:"\\eaab"}),i.debugBreakpointLogDisabled=new i("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),i.briefcase=new i("briefcase",{fontCharacter:"\\eaac"}),i.broadcast=new i("broadcast",{fontCharacter:"\\eaad"}),i.browser=new i("browser",{fontCharacter:"\\eaae"}),i.bug=new i("bug",{fontCharacter:"\\eaaf"}),i.calendar=new i("calendar",{fontCharacter:"\\eab0"}),i.caseSensitive=new i("case-sensitive",{fontCharacter:"\\eab1"}),i.check=new i("check",{fontCharacter:"\\eab2"}),i.checklist=new i("checklist",{fontCharacter:"\\eab3"}),i.chevronDown=new i("chevron-down",{fontCharacter:"\\eab4"}),i.chevronLeft=new i("chevron-left",{fontCharacter:"\\eab5"}),i.chevronRight=new i("chevron-right",{fontCharacter:"\\eab6"}),i.chevronUp=new i("chevron-up",{fontCharacter:"\\eab7"}),i.chromeClose=new i("chrome-close",{fontCharacter:"\\eab8"}),i.chromeMaximize=new i("chrome-maximize",{fontCharacter:"\\eab9"}),i.chromeMinimize=new i("chrome-minimize",{fontCharacter:"\\eaba"}),i.chromeRestore=new i("chrome-restore",{fontCharacter:"\\eabb"}),i.circleOutline=new i("circle-outline",{fontCharacter:"\\eabc"}),i.debugBreakpointUnverified=new i("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),i.circleSlash=new i("circle-slash",{fontCharacter:"\\eabd"}),i.circuitBoard=new i("circuit-board",{fontCharacter:"\\eabe"}),i.clearAll=new i("clear-all",{fontCharacter:"\\eabf"}),i.clippy=new i("clippy",{fontCharacter:"\\eac0"}),i.closeAll=new i("close-all",{fontCharacter:"\\eac1"}),i.cloudDownload=new i("cloud-download",{fontCharacter:"\\eac2"}),i.cloudUpload=new i("cloud-upload",{fontCharacter:"\\eac3"}),i.code=new i("code",{fontCharacter:"\\eac4"}),i.collapseAll=new i("collapse-all",{fontCharacter:"\\eac5"}),i.colorMode=new i("color-mode",{fontCharacter:"\\eac6"}),i.commentDiscussion=new i("comment-discussion",{fontCharacter:"\\eac7"}),i.compareChanges=new i("compare-changes",{fontCharacter:"\\eafd"}),i.creditCard=new i("credit-card",{fontCharacter:"\\eac9"}),i.dash=new i("dash",{fontCharacter:"\\eacc"}),i.dashboard=new i("dashboard",{fontCharacter:"\\eacd"}),i.database=new i("database",{fontCharacter:"\\eace"}),i.debugContinue=new i("debug-continue",{fontCharacter:"\\eacf"}),i.debugDisconnect=new i("debug-disconnect",{fontCharacter:"\\ead0"}),i.debugPause=new i("debug-pause",{fontCharacter:"\\ead1"}),i.debugRestart=new i("debug-restart",{fontCharacter:"\\ead2"}),i.debugStart=new i("debug-start",{fontCharacter:"\\ead3"}),i.debugStepInto=new i("debug-step-into",{fontCharacter:"\\ead4"}),i.debugStepOut=new i("debug-step-out",{fontCharacter:"\\ead5"}),i.debugStepOver=new i("debug-step-over",{fontCharacter:"\\ead6"}),i.debugStop=new i("debug-stop",{fontCharacter:"\\ead7"}),i.debug=new i("debug",{fontCharacter:"\\ead8"}),i.deviceCameraVideo=new i("device-camera-video",{fontCharacter:"\\ead9"}),i.deviceCamera=new i("device-camera",{fontCharacter:"\\eada"}),i.deviceMobile=new i("device-mobile",{fontCharacter:"\\eadb"}),i.diffAdded=new i("diff-added",{fontCharacter:"\\eadc"}),i.diffIgnored=new i("diff-ignored",{fontCharacter:"\\eadd"}),i.diffModified=new i("diff-modified",{fontCharacter:"\\eade"}),i.diffRemoved=new i("diff-removed",{fontCharacter:"\\eadf"}),i.diffRenamed=new i("diff-renamed",{fontCharacter:"\\eae0"}),i.diff=new i("diff",{fontCharacter:"\\eae1"}),i.discard=new i("discard",{fontCharacter:"\\eae2"}),i.editorLayout=new i("editor-layout",{fontCharacter:"\\eae3"}),i.emptyWindow=new i("empty-window",{fontCharacter:"\\eae4"}),i.exclude=new i("exclude",{fontCharacter:"\\eae5"}),i.extensions=new i("extensions",{fontCharacter:"\\eae6"}),i.eyeClosed=new i("eye-closed",{fontCharacter:"\\eae7"}),i.fileBinary=new i("file-binary",{fontCharacter:"\\eae8"}),i.fileCode=new i("file-code",{fontCharacter:"\\eae9"}),i.fileMedia=new i("file-media",{fontCharacter:"\\eaea"}),i.filePdf=new i("file-pdf",{fontCharacter:"\\eaeb"}),i.fileSubmodule=new i("file-submodule",{fontCharacter:"\\eaec"}),i.fileSymlinkDirectory=new i("file-symlink-directory",{fontCharacter:"\\eaed"}),i.fileSymlinkFile=new i("file-symlink-file",{fontCharacter:"\\eaee"}),i.fileZip=new i("file-zip",{fontCharacter:"\\eaef"}),i.files=new i("files",{fontCharacter:"\\eaf0"}),i.filter=new i("filter",{fontCharacter:"\\eaf1"}),i.flame=new i("flame",{fontCharacter:"\\eaf2"}),i.foldDown=new i("fold-down",{fontCharacter:"\\eaf3"}),i.foldUp=new i("fold-up",{fontCharacter:"\\eaf4"}),i.fold=new i("fold",{fontCharacter:"\\eaf5"}),i.folderActive=new i("folder-active",{fontCharacter:"\\eaf6"}),i.folderOpened=new i("folder-opened",{fontCharacter:"\\eaf7"}),i.gear=new i("gear",{fontCharacter:"\\eaf8"}),i.gift=new i("gift",{fontCharacter:"\\eaf9"}),i.gistSecret=new i("gist-secret",{fontCharacter:"\\eafa"}),i.gist=new i("gist",{fontCharacter:"\\eafb"}),i.gitCommit=new i("git-commit",{fontCharacter:"\\eafc"}),i.gitCompare=new i("git-compare",{fontCharacter:"\\eafd"}),i.gitMerge=new i("git-merge",{fontCharacter:"\\eafe"}),i.githubAction=new i("github-action",{fontCharacter:"\\eaff"}),i.githubAlt=new i("github-alt",{fontCharacter:"\\eb00"}),i.globe=new i("globe",{fontCharacter:"\\eb01"}),i.grabber=new i("grabber",{fontCharacter:"\\eb02"}),i.graph=new i("graph",{fontCharacter:"\\eb03"}),i.gripper=new i("gripper",{fontCharacter:"\\eb04"}),i.heart=new i("heart",{fontCharacter:"\\eb05"}),i.home=new i("home",{fontCharacter:"\\eb06"}),i.horizontalRule=new i("horizontal-rule",{fontCharacter:"\\eb07"}),i.hubot=new i("hubot",{fontCharacter:"\\eb08"}),i.inbox=new i("inbox",{fontCharacter:"\\eb09"}),i.issueClosed=new i("issue-closed",{fontCharacter:"\\eb0a"}),i.issueReopened=new i("issue-reopened",{fontCharacter:"\\eb0b"}),i.issues=new i("issues",{fontCharacter:"\\eb0c"}),i.italic=new i("italic",{fontCharacter:"\\eb0d"}),i.jersey=new i("jersey",{fontCharacter:"\\eb0e"}),i.json=new i("json",{fontCharacter:"\\eb0f"}),i.kebabVertical=new i("kebab-vertical",{fontCharacter:"\\eb10"}),i.key=new i("key",{fontCharacter:"\\eb11"}),i.law=new i("law",{fontCharacter:"\\eb12"}),i.lightbulbAutofix=new i("lightbulb-autofix",{fontCharacter:"\\eb13"}),i.linkExternal=new i("link-external",{fontCharacter:"\\eb14"}),i.link=new i("link",{fontCharacter:"\\eb15"}),i.listOrdered=new i("list-ordered",{fontCharacter:"\\eb16"}),i.listUnordered=new i("list-unordered",{fontCharacter:"\\eb17"}),i.liveShare=new i("live-share",{fontCharacter:"\\eb18"}),i.loading=new i("loading",{fontCharacter:"\\eb19"}),i.location=new i("location",{fontCharacter:"\\eb1a"}),i.mailRead=new i("mail-read",{fontCharacter:"\\eb1b"}),i.mail=new i("mail",{fontCharacter:"\\eb1c"}),i.markdown=new i("markdown",{fontCharacter:"\\eb1d"}),i.megaphone=new i("megaphone",{fontCharacter:"\\eb1e"}),i.mention=new i("mention",{fontCharacter:"\\eb1f"}),i.milestone=new i("milestone",{fontCharacter:"\\eb20"}),i.mortarBoard=new i("mortar-board",{fontCharacter:"\\eb21"}),i.move=new i("move",{fontCharacter:"\\eb22"}),i.multipleWindows=new i("multiple-windows",{fontCharacter:"\\eb23"}),i.mute=new i("mute",{fontCharacter:"\\eb24"}),i.noNewline=new i("no-newline",{fontCharacter:"\\eb25"}),i.note=new i("note",{fontCharacter:"\\eb26"}),i.octoface=new i("octoface",{fontCharacter:"\\eb27"}),i.openPreview=new i("open-preview",{fontCharacter:"\\eb28"}),i.package_=new i("package",{fontCharacter:"\\eb29"}),i.paintcan=new i("paintcan",{fontCharacter:"\\eb2a"}),i.pin=new i("pin",{fontCharacter:"\\eb2b"}),i.play=new i("play",{fontCharacter:"\\eb2c"}),i.run=new i("run",{fontCharacter:"\\eb2c"}),i.plug=new i("plug",{fontCharacter:"\\eb2d"}),i.preserveCase=new i("preserve-case",{fontCharacter:"\\eb2e"}),i.preview=new i("preview",{fontCharacter:"\\eb2f"}),i.project=new i("project",{fontCharacter:"\\eb30"}),i.pulse=new i("pulse",{fontCharacter:"\\eb31"}),i.question=new i("question",{fontCharacter:"\\eb32"}),i.quote=new i("quote",{fontCharacter:"\\eb33"}),i.radioTower=new i("radio-tower",{fontCharacter:"\\eb34"}),i.reactions=new i("reactions",{fontCharacter:"\\eb35"}),i.references=new i("references",{fontCharacter:"\\eb36"}),i.refresh=new i("refresh",{fontCharacter:"\\eb37"}),i.regex=new i("regex",{fontCharacter:"\\eb38"}),i.remoteExplorer=new i("remote-explorer",{fontCharacter:"\\eb39"}),i.remote=new i("remote",{fontCharacter:"\\eb3a"}),i.remove=new i("remove",{fontCharacter:"\\eb3b"}),i.replaceAll=new i("replace-all",{fontCharacter:"\\eb3c"}),i.replace=new i("replace",{fontCharacter:"\\eb3d"}),i.repoClone=new i("repo-clone",{fontCharacter:"\\eb3e"}),i.repoForcePush=new i("repo-force-push",{fontCharacter:"\\eb3f"}),i.repoPull=new i("repo-pull",{fontCharacter:"\\eb40"}),i.repoPush=new i("repo-push",{fontCharacter:"\\eb41"}),i.report=new i("report",{fontCharacter:"\\eb42"}),i.requestChanges=new i("request-changes",{fontCharacter:"\\eb43"}),i.rocket=new i("rocket",{fontCharacter:"\\eb44"}),i.rootFolderOpened=new i("root-folder-opened",{fontCharacter:"\\eb45"}),i.rootFolder=new i("root-folder",{fontCharacter:"\\eb46"}),i.rss=new i("rss",{fontCharacter:"\\eb47"}),i.ruby=new i("ruby",{fontCharacter:"\\eb48"}),i.saveAll=new i("save-all",{fontCharacter:"\\eb49"}),i.saveAs=new i("save-as",{fontCharacter:"\\eb4a"}),i.save=new i("save",{fontCharacter:"\\eb4b"}),i.screenFull=new i("screen-full",{fontCharacter:"\\eb4c"}),i.screenNormal=new i("screen-normal",{fontCharacter:"\\eb4d"}),i.searchStop=new i("search-stop",{fontCharacter:"\\eb4e"}),i.server=new i("server",{fontCharacter:"\\eb50"}),i.settingsGear=new i("settings-gear",{fontCharacter:"\\eb51"}),i.settings=new i("settings",{fontCharacter:"\\eb52"}),i.shield=new i("shield",{fontCharacter:"\\eb53"}),i.smiley=new i("smiley",{fontCharacter:"\\eb54"}),i.sortPrecedence=new i("sort-precedence",{fontCharacter:"\\eb55"}),i.splitHorizontal=new i("split-horizontal",{fontCharacter:"\\eb56"}),i.splitVertical=new i("split-vertical",{fontCharacter:"\\eb57"}),i.squirrel=new i("squirrel",{fontCharacter:"\\eb58"}),i.starFull=new i("star-full",{fontCharacter:"\\eb59"}),i.starHalf=new i("star-half",{fontCharacter:"\\eb5a"}),i.symbolClass=new i("symbol-class",{fontCharacter:"\\eb5b"}),i.symbolColor=new i("symbol-color",{fontCharacter:"\\eb5c"}),i.symbolConstant=new i("symbol-constant",{fontCharacter:"\\eb5d"}),i.symbolEnumMember=new i("symbol-enum-member",{fontCharacter:"\\eb5e"}),i.symbolField=new i("symbol-field",{fontCharacter:"\\eb5f"}),i.symbolFile=new i("symbol-file",{fontCharacter:"\\eb60"}),i.symbolInterface=new i("symbol-interface",{fontCharacter:"\\eb61"}),i.symbolKeyword=new i("symbol-keyword",{fontCharacter:"\\eb62"}),i.symbolMisc=new i("symbol-misc",{fontCharacter:"\\eb63"}),i.symbolOperator=new i("symbol-operator",{fontCharacter:"\\eb64"}),i.symbolProperty=new i("symbol-property",{fontCharacter:"\\eb65"}),i.wrench=new i("wrench",{fontCharacter:"\\eb65"}),i.wrenchSubaction=new i("wrench-subaction",{fontCharacter:"\\eb65"}),i.symbolSnippet=new i("symbol-snippet",{fontCharacter:"\\eb66"}),i.tasklist=new i("tasklist",{fontCharacter:"\\eb67"}),i.telescope=new i("telescope",{fontCharacter:"\\eb68"}),i.textSize=new i("text-size",{fontCharacter:"\\eb69"}),i.threeBars=new i("three-bars",{fontCharacter:"\\eb6a"}),i.thumbsdown=new i("thumbsdown",{fontCharacter:"\\eb6b"}),i.thumbsup=new i("thumbsup",{fontCharacter:"\\eb6c"}),i.tools=new i("tools",{fontCharacter:"\\eb6d"}),i.triangleDown=new i("triangle-down",{fontCharacter:"\\eb6e"}),i.triangleLeft=new i("triangle-left",{fontCharacter:"\\eb6f"}),i.triangleRight=new i("triangle-right",{fontCharacter:"\\eb70"}),i.triangleUp=new i("triangle-up",{fontCharacter:"\\eb71"}),i.twitter=new i("twitter",{fontCharacter:"\\eb72"}),i.unfold=new i("unfold",{fontCharacter:"\\eb73"}),i.unlock=new i("unlock",{fontCharacter:"\\eb74"}),i.unmute=new i("unmute",{fontCharacter:"\\eb75"}),i.unverified=new i("unverified",{fontCharacter:"\\eb76"}),i.verified=new i("verified",{fontCharacter:"\\eb77"}),i.versions=new i("versions",{fontCharacter:"\\eb78"}),i.vmActive=new i("vm-active",{fontCharacter:"\\eb79"}),i.vmOutline=new i("vm-outline",{fontCharacter:"\\eb7a"}),i.vmRunning=new i("vm-running",{fontCharacter:"\\eb7b"}),i.watch=new i("watch",{fontCharacter:"\\eb7c"}),i.whitespace=new i("whitespace",{fontCharacter:"\\eb7d"}),i.wholeWord=new i("whole-word",{fontCharacter:"\\eb7e"}),i.window=new i("window",{fontCharacter:"\\eb7f"}),i.wordWrap=new i("word-wrap",{fontCharacter:"\\eb80"}),i.zoomIn=new i("zoom-in",{fontCharacter:"\\eb81"}),i.zoomOut=new i("zoom-out",{fontCharacter:"\\eb82"}),i.listFilter=new i("list-filter",{fontCharacter:"\\eb83"}),i.listFlat=new i("list-flat",{fontCharacter:"\\eb84"}),i.listSelection=new i("list-selection",{fontCharacter:"\\eb85"}),i.selection=new i("selection",{fontCharacter:"\\eb85"}),i.listTree=new i("list-tree",{fontCharacter:"\\eb86"}),i.debugBreakpointFunctionUnverified=new i("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),i.debugBreakpointFunction=new i("debug-breakpoint-function",{fontCharacter:"\\eb88"}),i.debugBreakpointFunctionDisabled=new i("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),i.debugStackframeActive=new i("debug-stackframe-active",{fontCharacter:"\\eb89"}),i.debugStackframeDot=new i("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),i.debugStackframe=new i("debug-stackframe",{fontCharacter:"\\eb8b"}),i.debugStackframeFocused=new i("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),i.debugBreakpointUnsupported=new i("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),i.symbolString=new i("symbol-string",{fontCharacter:"\\eb8d"}),i.debugReverseContinue=new i("debug-reverse-continue",{fontCharacter:"\\eb8e"}),i.debugStepBack=new i("debug-step-back",{fontCharacter:"\\eb8f"}),i.debugRestartFrame=new i("debug-restart-frame",{fontCharacter:"\\eb90"}),i.callIncoming=new i("call-incoming",{fontCharacter:"\\eb92"}),i.callOutgoing=new i("call-outgoing",{fontCharacter:"\\eb93"}),i.menu=new i("menu",{fontCharacter:"\\eb94"}),i.expandAll=new i("expand-all",{fontCharacter:"\\eb95"}),i.feedback=new i("feedback",{fontCharacter:"\\eb96"}),i.groupByRefType=new i("group-by-ref-type",{fontCharacter:"\\eb97"}),i.ungroupByRefType=new i("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),i.account=new i("account",{fontCharacter:"\\eb99"}),i.bellDot=new i("bell-dot",{fontCharacter:"\\eb9a"}),i.debugConsole=new i("debug-console",{fontCharacter:"\\eb9b"}),i.library=new i("library",{fontCharacter:"\\eb9c"}),i.output=new i("output",{fontCharacter:"\\eb9d"}),i.runAll=new i("run-all",{fontCharacter:"\\eb9e"}),i.syncIgnored=new i("sync-ignored",{fontCharacter:"\\eb9f"}),i.pinned=new i("pinned",{fontCharacter:"\\eba0"}),i.githubInverted=new i("github-inverted",{fontCharacter:"\\eba1"}),i.debugAlt=new i("debug-alt",{fontCharacter:"\\eb91"}),i.serverProcess=new i("server-process",{fontCharacter:"\\eba2"}),i.serverEnvironment=new i("server-environment",{fontCharacter:"\\eba3"}),i.pass=new i("pass",{fontCharacter:"\\eba4"}),i.stopCircle=new i("stop-circle",{fontCharacter:"\\eba5"}),i.playCircle=new i("play-circle",{fontCharacter:"\\eba6"}),i.record=new i("record",{fontCharacter:"\\eba7"}),i.debugAltSmall=new i("debug-alt-small",{fontCharacter:"\\eba8"}),i.vmConnect=new i("vm-connect",{fontCharacter:"\\eba9"}),i.cloud=new i("cloud",{fontCharacter:"\\ebaa"}),i.merge=new i("merge",{fontCharacter:"\\ebab"}),i.exportIcon=new i("export",{fontCharacter:"\\ebac"}),i.graphLeft=new i("graph-left",{fontCharacter:"\\ebad"}),i.magnet=new i("magnet",{fontCharacter:"\\ebae"}),i.notebook=new i("notebook",{fontCharacter:"\\ebaf"}),i.redo=new i("redo",{fontCharacter:"\\ebb0"}),i.checkAll=new i("check-all",{fontCharacter:"\\ebb1"}),i.pinnedDirty=new i("pinned-dirty",{fontCharacter:"\\ebb2"}),i.passFilled=new i("pass-filled",{fontCharacter:"\\ebb3"}),i.circleLargeFilled=new i("circle-large-filled",{fontCharacter:"\\ebb4"}),i.circleLargeOutline=new i("circle-large-outline",{fontCharacter:"\\ebb5"}),i.combine=new i("combine",{fontCharacter:"\\ebb6"}),i.gather=new i("gather",{fontCharacter:"\\ebb6"}),i.table=new i("table",{fontCharacter:"\\ebb7"}),i.variableGroup=new i("variable-group",{fontCharacter:"\\ebb8"}),i.typeHierarchy=new i("type-hierarchy",{fontCharacter:"\\ebb9"}),i.typeHierarchySub=new i("type-hierarchy-sub",{fontCharacter:"\\ebba"}),i.typeHierarchySuper=new i("type-hierarchy-super",{fontCharacter:"\\ebbb"}),i.gitPullRequestCreate=new i("git-pull-request-create",{fontCharacter:"\\ebbc"}),i.runAbove=new i("run-above",{fontCharacter:"\\ebbd"}),i.runBelow=new i("run-below",{fontCharacter:"\\ebbe"}),i.notebookTemplate=new i("notebook-template",{fontCharacter:"\\ebbf"}),i.debugRerun=new i("debug-rerun",{fontCharacter:"\\ebc0"}),i.workspaceTrusted=new i("workspace-trusted",{fontCharacter:"\\ebc1"}),i.workspaceUntrusted=new i("workspace-untrusted",{fontCharacter:"\\ebc2"}),i.workspaceUnspecified=new i("workspace-unspecified",{fontCharacter:"\\ebc3"}),i.terminalCmd=new i("terminal-cmd",{fontCharacter:"\\ebc4"}),i.terminalDebian=new i("terminal-debian",{fontCharacter:"\\ebc5"}),i.terminalLinux=new i("terminal-linux",{fontCharacter:"\\ebc6"}),i.terminalPowershell=new i("terminal-powershell",{fontCharacter:"\\ebc7"}),i.terminalTmux=new i("terminal-tmux",{fontCharacter:"\\ebc8"}),i.terminalUbuntu=new i("terminal-ubuntu",{fontCharacter:"\\ebc9"}),i.terminalBash=new i("terminal-bash",{fontCharacter:"\\ebca"}),i.arrowSwap=new i("arrow-swap",{fontCharacter:"\\ebcb"}),i.copy=new i("copy",{fontCharacter:"\\ebcc"}),i.personAdd=new i("person-add",{fontCharacter:"\\ebcd"}),i.filterFilled=new i("filter-filled",{fontCharacter:"\\ebce"}),i.wand=new i("wand",{fontCharacter:"\\ebcf"}),i.debugLineByLine=new i("debug-line-by-line",{fontCharacter:"\\ebd0"}),i.inspect=new i("inspect",{fontCharacter:"\\ebd1"}),i.dropDownButton=new i("drop-down-button",i.chevronDown.definition)}(n=e.Codicon||(e.Codicon={}))}),define(J[64],Z([0,1,19,2]),function(z,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function A(u){const c=u;return c?[c.on,c.pause,c.resume,c.destroy].every(a=>typeof a=="function"):!1}e.isReadableStream=A;function S(u){const c=u;return c?A(c.stream)&&Array.isArray(c.buffer)&&typeof c.ended=="boolean":!1}e.isReadableBufferedStream=S;function E(u,c){return new n(u,c)}e.newWriteableStream=E;class n{constructor(c,a){this.reducer=c,this.options=a,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(c){var a;if(!this.state.destroyed){if(this.state.flowing)this.emitData(c);else if(this.buffer.data.push(c),typeof((a=this.options)===null||a===void 0?void 0:a.highWaterMark)=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(t=>this.pendingWritePromises.push(t))}}error(c){this.state.destroyed||(this.state.flowing?this.emitError(c):this.buffer.error.push(c))}end(c){this.state.destroyed||(typeof c!="undefined"&&this.write(c),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(c){this.listeners.data.slice(0).forEach(a=>a(c))}emitError(c){this.listeners.error.length===0?m.onUnexpectedError(c):this.listeners.error.slice(0).forEach(a=>a(c))}emitEnd(){this.listeners.end.slice(0).forEach(c=>c())}on(c,a){if(!this.state.destroyed)switch(c){case"data":this.listeners.data.push(a),this.resume();break;case"end":this.listeners.end.push(a),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(a),this.state.flowing&&this.flowErrors();break}}removeListener(c,a){if(this.state.destroyed)return;let t;switch(c){case"data":t=this.listeners.data;break;case"end":t=this.listeners.end;break;case"error":t=this.listeners.error;break}if(t){const r=t.indexOf(a);r>=0&&t.splice(r,1)}}flowData(){if(this.buffer.data.length>0){const c=this.reducer(this.buffer.data);this.emitData(c),this.buffer.data.length=0;const a=[...this.pendingWritePromises];this.pendingWritePromises.length=0,a.forEach(t=>t())}}flowErrors(){if(this.listeners.error.length>0){for(const c of this.buffer.error)this.emitError(c);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function w(u,c){const a=[];let t;for(;(t=u.read())!==null;)a.push(t);return c(a)}e.consumeReadable=w;function p(u,c,a){const t=[];let r;for(;(r=u.read())!==null&&t.length<a;)t.push(r);return r===null&&t.length>0?c(t):{read:()=>{if(t.length>0)return t.shift();if(typeof r!="undefined"){const s=r;return r=void 0,s}return u.read()}}}e.peekReadable=p;function i(u,c){return new Promise((a,t)=>{const r=[];I(u,{onData:s=>{c&&r.push(s)},onError:s=>{c?t(s):a(void 0)},onEnd:()=>{a(c?c(r):void 0)}})})}e.consumeStream=i;function I(u,c){u.on("error",a=>c.onError(a)),u.on("end",()=>c.onEnd()),u.on("data",a=>c.onData(a))}e.listenStream=I;function P(u,c){return new Promise((a,t)=>{const r=new L.DisposableStore,s=[],o=d=>{if(s.push(d),s.length>c)return r.dispose(),u.pause(),a({stream:u,buffer:s,ended:!1})},h=d=>t(d),f=()=>a({stream:u,buffer:s,ended:!0});r.add(L.toDisposable(()=>u.removeListener("error",h))),u.on("error",h),r.add(L.toDisposable(()=>u.removeListener("end",f))),u.on("end",f),r.add(L.toDisposable(()=>u.removeListener("data",o))),u.on("data",o)})}e.peekStream=P;function y(u,c){const a=E(c);return a.end(u),a}e.toStream=y;function g(){const u=E(()=>{throw new Error("not supported")});return u.end(),u}e.emptyStream=g;function v(u){let c=!1;return{read:()=>c?null:(c=!0,u)}}e.toReadable=v;function D(u,c,a){const t=E(a);return I(u,{onData:r=>t.write(c.data(r)),onError:r=>t.error(c.error?c.error(r):r),onEnd:()=>t.end()}),t}e.transform=D;function b(u,c,a){let t=!1;return{read:()=>{const r=c.read();return t?r:(t=!0,r!==null?a([u,r]):u)}}}e.prefixedReadable=b;function l(u,c,a){let t=!1;const r=E(a);return I(c,{onData:s=>t?r.write(s):(t=!0,r.write(a([u,s]))),onError:s=>r.error(s),onEnd:()=>{t||(t=!0,r.write(u)),r.end()}}),r}e.prefixedStream=l}),define(J[23],Z([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLeftDeleteOffset=e.GraphemeBreakType=e.breakBetweenGraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsEmoji=e.containsRTL=e.decodeUTF8=e.encodeUTF8=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format=e.isFalsyOrWhitespace=void 0;function m(j){return!j||typeof j!="string"?!0:j.trim().length===0}e.isFalsyOrWhitespace=m;const L=/{(\d+)}/g;function A(j,...ie){return ie.length===0?j:j.replace(L,function(ae,ce){const fe=parseInt(ce,10);return isNaN(fe)||fe<0||fe>=ie.length?ae:ie[fe]})}e.format=A;function S(j){return j.replace(/[<>&]/g,function(ie){switch(ie){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return ie}})}e.escape=S;function E(j){return j.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=E;function n(j,ie){let ae=0;const ce=ie.charCodeAt(0);for(let fe=j.length-1;fe>=0;fe--)j.charCodeAt(fe)===ce&&ae++;return ae}e.count=n;function w(j,ie,ae="\u2026"){return j.length<=ie?j:`${j.substr(0,ie)}${ae}`}e.truncate=w;function p(j,ie=" "){const ae=i(j,ie);return I(ae,ie)}e.trim=p;function i(j,ie){if(!j||!ie)return j;const ae=ie.length;if(ae===0||j.length===0)return j;let ce=0;for(;j.indexOf(ie,ce)===ce;)ce=ce+ae;return j.substring(ce)}e.ltrim=i;function I(j,ie){if(!j||!ie)return j;const ae=ie.length,ce=j.length;if(ae===0||ce===0)return j;let fe=ce,be=-1;for(;be=j.lastIndexOf(ie,fe-1),!(be===-1||be+ae!==fe);){if(be===0)return"";fe=be}return j.substring(0,fe)}e.rtrim=I;function P(j){return j.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=P;function y(j){return j.replace(/\*/g,"")}e.stripWildcards=y;function g(j,ie,ae={}){if(!j)throw new Error("Cannot create regex from empty string");ie||(j=E(j)),ae.wholeWord&&(/\B/.test(j.charAt(0))||(j="\\b"+j),/\B/.test(j.charAt(j.length-1))||(j=j+"\\b"));let ce="";return ae.global&&(ce+="g"),ae.matchCase||(ce+="i"),ae.multiline&&(ce+="m"),ae.unicode&&(ce+="u"),new RegExp(j,ce)}e.createRegExp=g;function v(j){return j.source==="^"||j.source==="^$"||j.source==="$"||j.source==="^\\s*$"?!1:!!(j.exec("")&&j.lastIndex===0)}e.regExpLeadsToEndlessLoop=v;function D(j){return!!j.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=D;function b(j){return(j.global?"g":"")+(j.ignoreCase?"i":"")+(j.multiline?"m":"")+(j.unicode?"u":"")}e.regExpFlags=b;function l(j){return j.split(/\r\n|\r|\n/)}e.splitLines=l;function u(j){for(let ie=0,ae=j.length;ie<ae;ie++){const ce=j.charCodeAt(ie);if(ce!==32&&ce!==9)return ie}return-1}e.firstNonWhitespaceIndex=u;function c(j,ie=0,ae=j.length){for(let ce=ie;ce<ae;ce++){const fe=j.charCodeAt(ce);if(fe!==32&&fe!==9)return j.substring(ie,ce)}return j.substring(ie,ae)}e.getLeadingWhitespace=c;function a(j,ie=j.length-1){for(let ae=ie;ae>=0;ae--){const ce=j.charCodeAt(ae);if(ce!==32&&ce!==9)return ae}return-1}e.lastNonWhitespaceIndex=a;function t(j,ie){return j<ie?-1:j>ie?1:0}e.compare=t;function r(j,ie,ae=0,ce=j.length,fe=0,be=ie.length){for(;ae<ce&&fe<be;ae++,fe++){let Ue=j.charCodeAt(ae),ze=ie.charCodeAt(fe);if(Ue<ze)return-1;if(Ue>ze)return 1}const Me=ce-ae,Fe=be-fe;return Me<Fe?-1:Me>Fe?1:0}e.compareSubstring=r;function s(j,ie){return o(j,ie,0,j.length,0,ie.length)}e.compareIgnoreCase=s;function o(j,ie,ae=0,ce=j.length,fe=0,be=ie.length){for(;ae<ce&&fe<be;ae++,fe++){let Ue=j.charCodeAt(ae),ze=ie.charCodeAt(fe);if(Ue===ze)continue;const de=Ue-ze;if(!(de===32&&f(ze))&&!(de===-32&&f(Ue)))return h(Ue)&&h(ze)?de:r(j.toLowerCase(),ie.toLowerCase(),ae,ce,fe,be)}const Me=ce-ae,Fe=be-fe;return Me<Fe?-1:Me>Fe?1:0}e.compareSubstringIgnoreCase=o;function h(j){return j>=97&&j<=122}e.isLowerAsciiLetter=h;function f(j){return j>=65&&j<=90}e.isUpperAsciiLetter=f;function d(j){return h(j)||f(j)}function M(j,ie){return j.length===ie.length&&T(j,ie)}e.equalsIgnoreCase=M;function T(j,ie,ae=j.length){for(let ce=0;ce<ae;ce++){const fe=j.charCodeAt(ce),be=ie.charCodeAt(ce);if(fe!==be){if(d(fe)&&d(be)){const Me=Math.abs(fe-be);if(Me!==0&&Me!==32)return!1}else if(String.fromCharCode(fe).toLowerCase()!==String.fromCharCode(be).toLowerCase())return!1}}return!0}function C(j,ie){const ae=ie.length;return ie.length>j.length?!1:T(j,ie,ae)}e.startsWithIgnoreCase=C;function V(j,ie){let ae,ce=Math.min(j.length,ie.length);for(ae=0;ae<ce;ae++)if(j.charCodeAt(ae)!==ie.charCodeAt(ae))return ae;return ce}e.commonPrefixLength=V;function Q(j,ie){let ae,ce=Math.min(j.length,ie.length);const fe=j.length-1,be=ie.length-1;for(ae=0;ae<ce;ae++)if(j.charCodeAt(fe-ae)!==ie.charCodeAt(be-ae))return ae;return ce}e.commonSuffixLength=Q;function te(j){return 55296<=j&&j<=56319}e.isHighSurrogate=te;function B(j){return 56320<=j&&j<=57343}e.isLowSurrogate=B;function Y(j,ie){return(j-55296<<10)+(ie-56320)+65536}e.computeCodePoint=Y;function X(j,ie,ae){const ce=j.charCodeAt(ae);if(te(ce)&&ae+1<ie){const fe=j.charCodeAt(ae+1);if(B(fe))return Y(ce,fe)}return ce}e.getNextCodePoint=X;function _(j,ie){const ae=j.charCodeAt(ie-1);if(B(ae)&&ie>1){const ce=j.charCodeAt(ie-2);if(te(ce))return Y(ce,ae)}return ae}function $(j,ie){const ae=Be.getInstance(),ce=ie,fe=j.length,be=X(j,fe,ie);ie+=be>=65536?2:1;let Me=ae.getGraphemeBreakType(be);for(;ie<fe;){const Fe=X(j,fe,ie),Ue=ae.getGraphemeBreakType(Fe);if(He(Me,Ue))break;ie+=Fe>=65536?2:1,Me=Ue}return ie-ce}e.nextCharLength=$;function G(j,ie){const ae=Be.getInstance(),ce=ie,fe=_(j,ie);ie-=fe>=65536?2:1;let be=ae.getGraphemeBreakType(fe);for(;ie>0;){const Me=_(j,ie),Fe=ae.getGraphemeBreakType(Me);if(He(Fe,be))break;ie-=Me>=65536?2:1,be=Fe}return ce-ie}e.prevCharLength=G;function N(j,ie){const ae=Be.getInstance(),ce=j.length,fe=ie,be=X(j,ce,ie),Me=ae.getGraphemeBreakType(be);ie+=be>=65536?2:1;let Fe=Me;for(;ie<ce;){const ze=X(j,ce,ie),de=ae.getGraphemeBreakType(ze);if(He(Fe,de))break;ie+=ze>=65536?2:1,Fe=de}const Ue=ie;for(ie=fe,Fe=Me;ie>0;){const ze=_(j,ie),de=ae.getGraphemeBreakType(ze);if(He(de,Fe))break;ie-=ze>=65536?2:1,Fe=de}return[ie,Ue]}function F(j,ie){return ie>0&&B(j.charCodeAt(ie))?N(j,ie-1):N(j,ie)}e.getCharContainingOffset=F;function R(j){const ie=j.length;let ae=0,ce=0;for(;ce<ie;){const Me=X(j,ie,ce);ce+=Me>=65536?2:1,Me<128?ae+=1:Me<2048?ae+=2:Me<65536?ae+=3:ae+=4}const fe=new Uint8Array(ae);ce=0;let be=0;for(;ce<ie;){const Me=X(j,ie,ce);ce+=Me>=65536?2:1,Me<128?fe[be++]=Me:Me<2048?(fe[be++]=192|(Me&1984)>>>6,fe[be++]=128|(Me&63)>>>0):Me<65536?(fe[be++]=224|(Me&61440)>>>12,fe[be++]=128|(Me&4032)>>>6,fe[be++]=128|(Me&63)>>>0):(fe[be++]=240|(Me&1835008)>>>18,fe[be++]=128|(Me&258048)>>>12,fe[be++]=128|(Me&4032)>>>6,fe[be++]=128|(Me&63)>>>0)}return fe}e.encodeUTF8=R;function O(j){const ie=j.byteLength,ae=[];let ce=0;for(;ce<ie;){const fe=j[ce];let be;if(fe>=240&&ce+3<ie?be=(j[ce++]&7)<<18>>>0|(j[ce++]&63)<<12>>>0|(j[ce++]&63)<<6>>>0|(j[ce++]&63)<<0>>>0:fe>=224&&ce+2<ie?be=(j[ce++]&15)<<12>>>0|(j[ce++]&63)<<6>>>0|(j[ce++]&63)<<0>>>0:fe>=192&&ce+1<ie?be=(j[ce++]&31)<<6>>>0|(j[ce++]&63)<<0>>>0:be=j[ce++],be>=0&&be<=55295||be>=57344&&be<=65535)ae.push(String.fromCharCode(be));else if(be>=65536&&be<=1114111){const Me=be-65536,Fe=55296+((Me&1047552)>>>10),Ue=56320+((Me&1023)>>>0);ae.push(String.fromCharCode(Fe)),ae.push(String.fromCharCode(Ue))}else ae.push(String.fromCharCode(65533))}return ae.join("")}e.decodeUTF8=O;const k=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u08BD\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE33\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDCFF]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD50-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function W(j){return k.test(j)}e.containsRTL=W;const U=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD00-\uDDFF\uDE70-\uDED6])/;function q(j){return U.test(j)}e.containsEmoji=q;const K=/^[\t\n\r\x20-\x7E]*$/;function H(j){return K.test(j)}e.isBasicASCII=H,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function x(j){return e.UNUSUAL_LINE_TERMINATORS.test(j)}e.containsUnusualLineTerminators=x;function ne(j){for(let ie=0,ae=j.length;ie<ae;ie++)if(re(j.charCodeAt(ie)))return!0;return!1}e.containsFullWidthCharacter=ne;function re(j){return j=+j,j>=11904&&j<=55215||j>=63744&&j<=64255||j>=65281&&j<=65374}e.isFullWidthCharacter=re;function se(j){return j>=127462&&j<=127487||j===8986||j===8987||j===9200||j===9203||j>=9728&&j<=10175||j===11088||j===11093||j>=127744&&j<=128591||j>=128640&&j<=128764||j>=128992&&j<=129003||j>=129280&&j<=129535||j>=129648&&j<=129750}e.isEmojiImprecise=se;function le(j,ie){if(j.length<ie)return j;const ae=/\b/g;let ce=0;for(;ae.test(j)&&!(j.length-ae.lastIndex<ie);)ce=ae.lastIndex,ae.lastIndex+=1;return j.substring(ce).replace(/^\s/,"")}e.lcut=le;const oe=/\x1B\x5B[12]?K/g,ue=/\x1b\[\d+m/g,me=/\x1b\[0?m/g;function Se(j){return j&&(j=j.replace(oe,""),j=j.replace(ue,""),j=j.replace(me,"")),j}e.removeAnsiEscapeCodes=Se,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function De(j){return!!(j&&j.length>0&&j.charCodeAt(0)===65279)}e.startsWithUTF8BOM=De;function Ie(j){return De(j)?j.substr(1):j}e.stripUTF8BOM=Ie;function we(j,ie){if(!j||!ie||j.length<ie.length)return!1;const ae=ie.length,ce=j.toLowerCase();let fe=0,be=-1;for(;fe<ae;){const Me=ce.indexOf(ie[fe],be+1);if(Me<0)return!1;be=Me,fe++}return!0}e.fuzzyContains=we;function ye(j,ie=!1){return j?(ie&&(j=j.replace(/\\./g,"")),j.toLowerCase()!==j):!1}e.containsUppercaseCharacter=ye;function Ae(j){return j.charAt(0).toUpperCase()+j.slice(1)}e.uppercaseFirstLetter=Ae;function Te(j,ie=1){if(ie===0)return"";let ae=-1;do ae=j.indexOf(`
`,ae+1),ie--;while(ie>0&&ae>=0);return ae===-1?j:(j[ae-1]==="\r"&&ae--,j.substr(0,ae))}e.getNLines=Te;function $e(j){const ie=90-65+1;return j=j%(2*ie),j<ie?String.fromCharCode(97+j):String.fromCharCode(65+j-ie)}e.singleLetterHash=$e;function Ne(j){return Be.getInstance().getGraphemeBreakType(j)}e.getGraphemeBreakType=Ne;function He(j,ie){return j===0?ie!==5&&ie!==7:j===2&&ie===3?!1:j===4||j===2||j===3||ie===4||ie===2||ie===3?!0:!(j===8&&(ie===8||ie===9||ie===11||ie===12)||(j===11||j===9)&&(ie===9||ie===10)||(j===12||j===10)&&ie===10||ie===5||ie===13||ie===7||j===1||j===13&&ie===14||j===6&&ie===6)}e.breakBetweenGraphemeBreakType=He;var it;(function(j){j[j.Other=0]="Other",j[j.Prepend=1]="Prepend",j[j.CR=2]="CR",j[j.LF=3]="LF",j[j.Control=4]="Control",j[j.Extend=5]="Extend",j[j.Regional_Indicator=6]="Regional_Indicator",j[j.SpacingMark=7]="SpacingMark",j[j.L=8]="L",j[j.V=9]="V",j[j.T=10]="T",j[j.LV=11]="LV",j[j.LVT=12]="LVT",j[j.ZWJ=13]="ZWJ",j[j.Extended_Pictographic=14]="Extended_Pictographic"})(it=e.GraphemeBreakType||(e.GraphemeBreakType={}));class Be{constructor(){this._data=at()}static getInstance(){return Be._INSTANCE||(Be._INSTANCE=new Be),Be._INSTANCE}getGraphemeBreakType(ie){if(ie<32)return ie===10?3:ie===13?2:4;if(ie<127)return 0;const ae=this._data,ce=ae.length/3;let fe=1;for(;fe<=ce;)if(ie<ae[3*fe])fe=2*fe;else if(ie>ae[3*fe+1])fe=2*fe+1;else return ae[3*fe+2];return 0}}Be._INSTANCE=null;function at(){return JSON.parse("[0,0,0,51592,51592,11,44424,44424,11,72251,72254,5,7150,7150,7,48008,48008,11,55176,55176,11,128420,128420,14,3276,3277,5,9979,9980,14,46216,46216,11,49800,49800,11,53384,53384,11,70726,70726,5,122915,122916,5,129320,129327,14,2558,2558,5,5906,5908,5,9762,9763,14,43360,43388,8,45320,45320,11,47112,47112,11,48904,48904,11,50696,50696,11,52488,52488,11,54280,54280,11,70082,70083,1,71350,71350,7,73111,73111,5,127892,127893,14,128726,128727,14,129473,129474,14,2027,2035,5,2901,2902,5,3784,3789,5,6754,6754,5,8418,8420,5,9877,9877,14,11088,11088,14,44008,44008,5,44872,44872,11,45768,45768,11,46664,46664,11,47560,47560,11,48456,48456,11,49352,49352,11,50248,50248,11,51144,51144,11,52040,52040,11,52936,52936,11,53832,53832,11,54728,54728,11,69811,69814,5,70459,70460,5,71096,71099,7,71998,71998,5,72874,72880,5,119149,119149,7,127374,127374,14,128335,128335,14,128482,128482,14,128765,128767,14,129399,129400,14,129680,129685,14,1476,1477,5,2377,2380,7,2759,2760,5,3137,3140,7,3458,3459,7,4153,4154,5,6432,6434,5,6978,6978,5,7675,7679,5,9723,9726,14,9823,9823,14,9919,9923,14,10035,10036,14,42736,42737,5,43596,43596,5,44200,44200,11,44648,44648,11,45096,45096,11,45544,45544,11,45992,45992,11,46440,46440,11,46888,46888,11,47336,47336,11,47784,47784,11,48232,48232,11,48680,48680,11,49128,49128,11,49576,49576,11,50024,50024,11,50472,50472,11,50920,50920,11,51368,51368,11,51816,51816,11,52264,52264,11,52712,52712,11,53160,53160,11,53608,53608,11,54056,54056,11,54504,54504,11,54952,54952,11,68108,68111,5,69933,69940,5,70197,70197,7,70498,70499,7,70845,70845,5,71229,71229,5,71727,71735,5,72154,72155,5,72344,72345,5,73023,73029,5,94095,94098,5,121403,121452,5,126981,127182,14,127538,127546,14,127990,127990,14,128391,128391,14,128445,128449,14,128500,128505,14,128752,128752,14,129160,129167,14,129356,129356,14,129432,129442,14,129648,129651,14,129751,131069,14,173,173,4,1757,1757,1,2274,2274,1,2494,2494,5,2641,2641,5,2876,2876,5,3014,3016,7,3262,3262,7,3393,3396,5,3570,3571,7,3968,3972,5,4228,4228,7,6086,6086,5,6679,6680,5,6912,6915,5,7080,7081,5,7380,7392,5,8252,8252,14,9096,9096,14,9748,9749,14,9784,9786,14,9833,9850,14,9890,9894,14,9938,9938,14,9999,9999,14,10085,10087,14,12349,12349,14,43136,43137,7,43454,43456,7,43755,43755,7,44088,44088,11,44312,44312,11,44536,44536,11,44760,44760,11,44984,44984,11,45208,45208,11,45432,45432,11,45656,45656,11,45880,45880,11,46104,46104,11,46328,46328,11,46552,46552,11,46776,46776,11,47000,47000,11,47224,47224,11,47448,47448,11,47672,47672,11,47896,47896,11,48120,48120,11,48344,48344,11,48568,48568,11,48792,48792,11,49016,49016,11,49240,49240,11,49464,49464,11,49688,49688,11,49912,49912,11,50136,50136,11,50360,50360,11,50584,50584,11,50808,50808,11,51032,51032,11,51256,51256,11,51480,51480,11,51704,51704,11,51928,51928,11,52152,52152,11,52376,52376,11,52600,52600,11,52824,52824,11,53048,53048,11,53272,53272,11,53496,53496,11,53720,53720,11,53944,53944,11,54168,54168,11,54392,54392,11,54616,54616,11,54840,54840,11,55064,55064,11,65438,65439,5,69633,69633,5,69837,69837,1,70018,70018,7,70188,70190,7,70368,70370,7,70465,70468,7,70712,70719,5,70835,70840,5,70850,70851,5,71132,71133,5,71340,71340,7,71458,71461,5,71985,71989,7,72002,72002,7,72193,72202,5,72281,72283,5,72766,72766,7,72885,72886,5,73104,73105,5,92912,92916,5,113824,113827,4,119173,119179,5,121505,121519,5,125136,125142,5,127279,127279,14,127489,127490,14,127570,127743,14,127900,127901,14,128254,128254,14,128369,128370,14,128400,128400,14,128425,128432,14,128468,128475,14,128489,128494,14,128715,128720,14,128745,128745,14,128759,128760,14,129004,129023,14,129296,129304,14,129340,129342,14,129388,129392,14,129404,129407,14,129454,129455,14,129485,129487,14,129659,129663,14,129719,129727,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2363,2363,7,2402,2403,5,2507,2508,7,2622,2624,7,2691,2691,7,2786,2787,5,2881,2884,5,3006,3006,5,3072,3072,5,3170,3171,5,3267,3268,7,3330,3331,7,3406,3406,1,3538,3540,5,3655,3662,5,3897,3897,5,4038,4038,5,4184,4185,5,4352,4447,8,6068,6069,5,6155,6157,5,6448,6449,7,6742,6742,5,6783,6783,5,6966,6970,5,7042,7042,7,7143,7143,7,7212,7219,5,7412,7412,5,8206,8207,4,8294,8303,4,8596,8601,14,9410,9410,14,9742,9742,14,9757,9757,14,9770,9770,14,9794,9794,14,9828,9828,14,9855,9855,14,9882,9882,14,9900,9903,14,9929,9933,14,9963,9967,14,9987,9988,14,10006,10006,14,10062,10062,14,10175,10175,14,11744,11775,5,42607,42607,5,43043,43044,7,43263,43263,5,43444,43445,7,43569,43570,5,43698,43700,5,43766,43766,5,44032,44032,11,44144,44144,11,44256,44256,11,44368,44368,11,44480,44480,11,44592,44592,11,44704,44704,11,44816,44816,11,44928,44928,11,45040,45040,11,45152,45152,11,45264,45264,11,45376,45376,11,45488,45488,11,45600,45600,11,45712,45712,11,45824,45824,11,45936,45936,11,46048,46048,11,46160,46160,11,46272,46272,11,46384,46384,11,46496,46496,11,46608,46608,11,46720,46720,11,46832,46832,11,46944,46944,11,47056,47056,11,47168,47168,11,47280,47280,11,47392,47392,11,47504,47504,11,47616,47616,11,47728,47728,11,47840,47840,11,47952,47952,11,48064,48064,11,48176,48176,11,48288,48288,11,48400,48400,11,48512,48512,11,48624,48624,11,48736,48736,11,48848,48848,11,48960,48960,11,49072,49072,11,49184,49184,11,49296,49296,11,49408,49408,11,49520,49520,11,49632,49632,11,49744,49744,11,49856,49856,11,49968,49968,11,50080,50080,11,50192,50192,11,50304,50304,11,50416,50416,11,50528,50528,11,50640,50640,11,50752,50752,11,50864,50864,11,50976,50976,11,51088,51088,11,51200,51200,11,51312,51312,11,51424,51424,11,51536,51536,11,51648,51648,11,51760,51760,11,51872,51872,11,51984,51984,11,52096,52096,11,52208,52208,11,52320,52320,11,52432,52432,11,52544,52544,11,52656,52656,11,52768,52768,11,52880,52880,11,52992,52992,11,53104,53104,11,53216,53216,11,53328,53328,11,53440,53440,11,53552,53552,11,53664,53664,11,53776,53776,11,53888,53888,11,54000,54000,11,54112,54112,11,54224,54224,11,54336,54336,11,54448,54448,11,54560,54560,11,54672,54672,11,54784,54784,11,54896,54896,11,55008,55008,11,55120,55120,11,64286,64286,5,66272,66272,5,68900,68903,5,69762,69762,7,69817,69818,5,69927,69931,5,70003,70003,5,70070,70078,5,70094,70094,7,70194,70195,7,70206,70206,5,70400,70401,5,70463,70463,7,70475,70477,7,70512,70516,5,70722,70724,5,70832,70832,5,70842,70842,5,70847,70848,5,71088,71089,7,71102,71102,7,71219,71226,5,71231,71232,5,71342,71343,7,71453,71455,5,71463,71467,5,71737,71738,5,71995,71996,5,72000,72000,7,72145,72147,7,72160,72160,5,72249,72249,7,72273,72278,5,72330,72342,5,72752,72758,5,72850,72871,5,72882,72883,5,73018,73018,5,73031,73031,5,73109,73109,5,73461,73462,7,94031,94031,5,94192,94193,7,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,126976,126979,14,127184,127231,14,127344,127345,14,127405,127461,14,127514,127514,14,127561,127567,14,127778,127779,14,127896,127896,14,127985,127986,14,127995,127999,5,128326,128328,14,128360,128366,14,128378,128378,14,128394,128397,14,128405,128406,14,128422,128423,14,128435,128443,14,128453,128464,14,128479,128480,14,128484,128487,14,128496,128498,14,128640,128709,14,128723,128724,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129096,129103,14,129292,129292,14,129311,129311,14,129329,129330,14,129344,129349,14,129360,129374,14,129394,129394,14,129402,129402,14,129413,129425,14,129445,129450,14,129466,129471,14,129483,129483,14,129511,129535,14,129653,129655,14,129667,129670,14,129705,129711,14,129731,129743,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2307,2307,7,2366,2368,7,2382,2383,7,2434,2435,7,2497,2500,5,2519,2519,5,2563,2563,7,2631,2632,5,2677,2677,5,2750,2752,7,2763,2764,7,2817,2817,5,2879,2879,5,2891,2892,7,2914,2915,5,3008,3008,5,3021,3021,5,3076,3076,5,3146,3149,5,3202,3203,7,3264,3265,7,3271,3272,7,3298,3299,5,3390,3390,5,3402,3404,7,3426,3427,5,3535,3535,5,3544,3550,7,3635,3635,7,3763,3763,7,3893,3893,5,3953,3966,5,3981,3991,5,4145,4145,7,4157,4158,5,4209,4212,5,4237,4237,5,4520,4607,10,5970,5971,5,6071,6077,5,6089,6099,5,6277,6278,5,6439,6440,5,6451,6456,7,6683,6683,5,6744,6750,5,6765,6770,7,6846,6846,5,6964,6964,5,6972,6972,5,7019,7027,5,7074,7077,5,7083,7085,5,7146,7148,7,7154,7155,7,7222,7223,5,7394,7400,5,7416,7417,5,8204,8204,5,8233,8233,4,8288,8292,4,8413,8416,5,8482,8482,14,8986,8987,14,9193,9203,14,9654,9654,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9775,14,9792,9792,14,9800,9811,14,9825,9826,14,9831,9831,14,9852,9853,14,9872,9873,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9936,9936,14,9941,9960,14,9974,9974,14,9982,9985,14,9992,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10145,10145,14,11013,11015,14,11503,11505,5,12334,12335,5,12951,12951,14,42612,42621,5,43014,43014,5,43047,43047,7,43204,43205,5,43335,43345,5,43395,43395,7,43450,43451,7,43561,43566,5,43573,43574,5,43644,43644,5,43710,43711,5,43758,43759,7,44005,44005,5,44012,44012,7,44060,44060,11,44116,44116,11,44172,44172,11,44228,44228,11,44284,44284,11,44340,44340,11,44396,44396,11,44452,44452,11,44508,44508,11,44564,44564,11,44620,44620,11,44676,44676,11,44732,44732,11,44788,44788,11,44844,44844,11,44900,44900,11,44956,44956,11,45012,45012,11,45068,45068,11,45124,45124,11,45180,45180,11,45236,45236,11,45292,45292,11,45348,45348,11,45404,45404,11,45460,45460,11,45516,45516,11,45572,45572,11,45628,45628,11,45684,45684,11,45740,45740,11,45796,45796,11,45852,45852,11,45908,45908,11,45964,45964,11,46020,46020,11,46076,46076,11,46132,46132,11,46188,46188,11,46244,46244,11,46300,46300,11,46356,46356,11,46412,46412,11,46468,46468,11,46524,46524,11,46580,46580,11,46636,46636,11,46692,46692,11,46748,46748,11,46804,46804,11,46860,46860,11,46916,46916,11,46972,46972,11,47028,47028,11,47084,47084,11,47140,47140,11,47196,47196,11,47252,47252,11,47308,47308,11,47364,47364,11,47420,47420,11,47476,47476,11,47532,47532,11,47588,47588,11,47644,47644,11,47700,47700,11,47756,47756,11,47812,47812,11,47868,47868,11,47924,47924,11,47980,47980,11,48036,48036,11,48092,48092,11,48148,48148,11,48204,48204,11,48260,48260,11,48316,48316,11,48372,48372,11,48428,48428,11,48484,48484,11,48540,48540,11,48596,48596,11,48652,48652,11,48708,48708,11,48764,48764,11,48820,48820,11,48876,48876,11,48932,48932,11,48988,48988,11,49044,49044,11,49100,49100,11,49156,49156,11,49212,49212,11,49268,49268,11,49324,49324,11,49380,49380,11,49436,49436,11,49492,49492,11,49548,49548,11,49604,49604,11,49660,49660,11,49716,49716,11,49772,49772,11,49828,49828,11,49884,49884,11,49940,49940,11,49996,49996,11,50052,50052,11,50108,50108,11,50164,50164,11,50220,50220,11,50276,50276,11,50332,50332,11,50388,50388,11,50444,50444,11,50500,50500,11,50556,50556,11,50612,50612,11,50668,50668,11,50724,50724,11,50780,50780,11,50836,50836,11,50892,50892,11,50948,50948,11,51004,51004,11,51060,51060,11,51116,51116,11,51172,51172,11,51228,51228,11,51284,51284,11,51340,51340,11,51396,51396,11,51452,51452,11,51508,51508,11,51564,51564,11,51620,51620,11,51676,51676,11,51732,51732,11,51788,51788,11,51844,51844,11,51900,51900,11,51956,51956,11,52012,52012,11,52068,52068,11,52124,52124,11,52180,52180,11,52236,52236,11,52292,52292,11,52348,52348,11,52404,52404,11,52460,52460,11,52516,52516,11,52572,52572,11,52628,52628,11,52684,52684,11,52740,52740,11,52796,52796,11,52852,52852,11,52908,52908,11,52964,52964,11,53020,53020,11,53076,53076,11,53132,53132,11,53188,53188,11,53244,53244,11,53300,53300,11,53356,53356,11,53412,53412,11,53468,53468,11,53524,53524,11,53580,53580,11,53636,53636,11,53692,53692,11,53748,53748,11,53804,53804,11,53860,53860,11,53916,53916,11,53972,53972,11,54028,54028,11,54084,54084,11,54140,54140,11,54196,54196,11,54252,54252,11,54308,54308,11,54364,54364,11,54420,54420,11,54476,54476,11,54532,54532,11,54588,54588,11,54644,54644,11,54700,54700,11,54756,54756,11,54812,54812,11,54868,54868,11,54924,54924,11,54980,54980,11,55036,55036,11,55092,55092,11,55148,55148,11,55216,55238,9,65056,65071,5,65529,65531,4,68097,68099,5,68159,68159,5,69446,69456,5,69688,69702,5,69808,69810,7,69815,69816,7,69821,69821,1,69888,69890,5,69932,69932,7,69957,69958,7,70016,70017,5,70067,70069,7,70079,70080,7,70089,70092,5,70095,70095,5,70191,70193,5,70196,70196,5,70198,70199,5,70367,70367,5,70371,70378,5,70402,70403,7,70462,70462,5,70464,70464,5,70471,70472,7,70487,70487,5,70502,70508,5,70709,70711,7,70720,70721,7,70725,70725,7,70750,70750,5,70833,70834,7,70841,70841,7,70843,70844,7,70846,70846,7,70849,70849,7,71087,71087,5,71090,71093,5,71100,71101,5,71103,71104,5,71216,71218,7,71227,71228,7,71230,71230,7,71339,71339,5,71341,71341,5,71344,71349,5,71351,71351,5,71456,71457,7,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123628,123631,5,125252,125258,5,126980,126980,14,127183,127183,14,127245,127247,14,127340,127343,14,127358,127359,14,127377,127386,14,127462,127487,6,127491,127503,14,127535,127535,14,127548,127551,14,127568,127569,14,127744,127777,14,127780,127891,14,127894,127895,14,127897,127899,14,127902,127984,14,127987,127989,14,127991,127994,14,128000,128253,14,128255,128317,14,128329,128334,14,128336,128359,14,128367,128368,14,128371,128377,14,128379,128390,14,128392,128393,14,128398,128399,14,128401,128404,14,128407,128419,14,128421,128421,14,128424,128424,14,128433,128434,14,128444,128444,14,128450,128452,14,128465,128467,14,128476,128478,14,128481,128481,14,128483,128483,14,128488,128488,14,128495,128495,14,128499,128499,14,128506,128591,14,128710,128714,14,128721,128722,14,128725,128725,14,128728,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129664,129666,14,129671,129679,14,129686,129704,14,129712,129718,14,129728,129730,14,129744,129750,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2259,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3134,3136,5,3142,3144,5,3157,3158,5,3201,3201,5,3260,3260,5,3263,3263,5,3266,3266,5,3270,3270,5,3274,3275,7,3285,3286,5,3328,3329,5,3387,3388,5,3391,3392,7,3398,3400,7,3405,3405,5,3415,3415,5,3457,3457,5,3530,3530,5,3536,3537,7,3542,3542,5,3551,3551,5,3633,3633,5,3636,3642,5,3761,3761,5,3764,3772,5,3864,3865,5,3895,3895,5,3902,3903,7,3967,3967,7,3974,3975,5,3993,4028,5,4141,4144,5,4146,4151,5,4155,4156,7,4182,4183,7,4190,4192,5,4226,4226,5,4229,4230,5,4253,4253,5,4448,4519,9,4957,4959,5,5938,5940,5,6002,6003,5,6070,6070,7,6078,6085,7,6087,6088,7,6109,6109,5,6158,6158,4,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6848,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7673,5,8203,8203,4,8205,8205,13,8232,8232,4,8234,8238,4,8265,8265,14,8293,8293,4,8400,8412,5,8417,8417,5,8421,8432,5,8505,8505,14,8617,8618,14,9000,9000,14,9167,9167,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9776,9783,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9935,14,9937,9937,14,9939,9940,14,9961,9962,14,9968,9973,14,9975,9978,14,9981,9981,14,9986,9986,14,9989,9989,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10084,14,10133,10135,14,10160,10160,14,10548,10549,14,11035,11036,14,11093,11093,14,11647,11647,5,12330,12333,5,12336,12336,14,12441,12442,5,12953,12953,14,42608,42610,5,42654,42655,5,43010,43010,5,43019,43019,5,43045,43046,5,43052,43052,5,43188,43203,7,43232,43249,5,43302,43309,5,43346,43347,7,43392,43394,5,43443,43443,5,43446,43449,5,43452,43453,5,43493,43493,5,43567,43568,7,43571,43572,7,43587,43587,5,43597,43597,7,43696,43696,5,43703,43704,5,43713,43713,5,43756,43757,5,43765,43765,7,44003,44004,7,44006,44007,7,44009,44010,7,44013,44013,5,44033,44059,12,44061,44087,12,44089,44115,12,44117,44143,12,44145,44171,12,44173,44199,12,44201,44227,12,44229,44255,12,44257,44283,12,44285,44311,12,44313,44339,12,44341,44367,12,44369,44395,12,44397,44423,12,44425,44451,12,44453,44479,12,44481,44507,12,44509,44535,12,44537,44563,12,44565,44591,12,44593,44619,12,44621,44647,12,44649,44675,12,44677,44703,12,44705,44731,12,44733,44759,12,44761,44787,12,44789,44815,12,44817,44843,12,44845,44871,12,44873,44899,12,44901,44927,12,44929,44955,12,44957,44983,12,44985,45011,12,45013,45039,12,45041,45067,12,45069,45095,12,45097,45123,12,45125,45151,12,45153,45179,12,45181,45207,12,45209,45235,12,45237,45263,12,45265,45291,12,45293,45319,12,45321,45347,12,45349,45375,12,45377,45403,12,45405,45431,12,45433,45459,12,45461,45487,12,45489,45515,12,45517,45543,12,45545,45571,12,45573,45599,12,45601,45627,12,45629,45655,12,45657,45683,12,45685,45711,12,45713,45739,12,45741,45767,12,45769,45795,12,45797,45823,12,45825,45851,12,45853,45879,12,45881,45907,12,45909,45935,12,45937,45963,12,45965,45991,12,45993,46019,12,46021,46047,12,46049,46075,12,46077,46103,12,46105,46131,12,46133,46159,12,46161,46187,12,46189,46215,12,46217,46243,12,46245,46271,12,46273,46299,12,46301,46327,12,46329,46355,12,46357,46383,12,46385,46411,12,46413,46439,12,46441,46467,12,46469,46495,12,46497,46523,12,46525,46551,12,46553,46579,12,46581,46607,12,46609,46635,12,46637,46663,12,46665,46691,12,46693,46719,12,46721,46747,12,46749,46775,12,46777,46803,12,46805,46831,12,46833,46859,12,46861,46887,12,46889,46915,12,46917,46943,12,46945,46971,12,46973,46999,12,47001,47027,12,47029,47055,12,47057,47083,12,47085,47111,12,47113,47139,12,47141,47167,12,47169,47195,12,47197,47223,12,47225,47251,12,47253,47279,12,47281,47307,12,47309,47335,12,47337,47363,12,47365,47391,12,47393,47419,12,47421,47447,12,47449,47475,12,47477,47503,12,47505,47531,12,47533,47559,12,47561,47587,12,47589,47615,12,47617,47643,12,47645,47671,12,47673,47699,12,47701,47727,12,47729,47755,12,47757,47783,12,47785,47811,12,47813,47839,12,47841,47867,12,47869,47895,12,47897,47923,12,47925,47951,12,47953,47979,12,47981,48007,12,48009,48035,12,48037,48063,12,48065,48091,12,48093,48119,12,48121,48147,12,48149,48175,12,48177,48203,12,48205,48231,12,48233,48259,12,48261,48287,12,48289,48315,12,48317,48343,12,48345,48371,12,48373,48399,12,48401,48427,12,48429,48455,12,48457,48483,12,48485,48511,12,48513,48539,12,48541,48567,12,48569,48595,12,48597,48623,12,48625,48651,12,48653,48679,12,48681,48707,12,48709,48735,12,48737,48763,12,48765,48791,12,48793,48819,12,48821,48847,12,48849,48875,12,48877,48903,12,48905,48931,12,48933,48959,12,48961,48987,12,48989,49015,12,49017,49043,12,49045,49071,12,49073,49099,12,49101,49127,12,49129,49155,12,49157,49183,12,49185,49211,12,49213,49239,12,49241,49267,12,49269,49295,12,49297,49323,12,49325,49351,12,49353,49379,12,49381,49407,12,49409,49435,12,49437,49463,12,49465,49491,12,49493,49519,12,49521,49547,12,49549,49575,12,49577,49603,12,49605,49631,12,49633,49659,12,49661,49687,12,49689,49715,12,49717,49743,12,49745,49771,12,49773,49799,12,49801,49827,12,49829,49855,12,49857,49883,12,49885,49911,12,49913,49939,12,49941,49967,12,49969,49995,12,49997,50023,12,50025,50051,12,50053,50079,12,50081,50107,12,50109,50135,12,50137,50163,12,50165,50191,12,50193,50219,12,50221,50247,12,50249,50275,12,50277,50303,12,50305,50331,12,50333,50359,12,50361,50387,12,50389,50415,12,50417,50443,12,50445,50471,12,50473,50499,12,50501,50527,12,50529,50555,12,50557,50583,12,50585,50611,12,50613,50639,12,50641,50667,12,50669,50695,12,50697,50723,12,50725,50751,12,50753,50779,12,50781,50807,12,50809,50835,12,50837,50863,12,50865,50891,12,50893,50919,12,50921,50947,12,50949,50975,12,50977,51003,12,51005,51031,12,51033,51059,12,51061,51087,12,51089,51115,12,51117,51143,12,51145,51171,12,51173,51199,12,51201,51227,12,51229,51255,12,51257,51283,12,51285,51311,12,51313,51339,12,51341,51367,12,51369,51395,12,51397,51423,12,51425,51451,12,51453,51479,12,51481,51507,12,51509,51535,12,51537,51563,12,51565,51591,12,51593,51619,12,51621,51647,12,51649,51675,12,51677,51703,12,51705,51731,12,51733,51759,12,51761,51787,12,51789,51815,12,51817,51843,12,51845,51871,12,51873,51899,12,51901,51927,12,51929,51955,12,51957,51983,12,51985,52011,12,52013,52039,12,52041,52067,12,52069,52095,12,52097,52123,12,52125,52151,12,52153,52179,12,52181,52207,12,52209,52235,12,52237,52263,12,52265,52291,12,52293,52319,12,52321,52347,12,52349,52375,12,52377,52403,12,52405,52431,12,52433,52459,12,52461,52487,12,52489,52515,12,52517,52543,12,52545,52571,12,52573,52599,12,52601,52627,12,52629,52655,12,52657,52683,12,52685,52711,12,52713,52739,12,52741,52767,12,52769,52795,12,52797,52823,12,52825,52851,12,52853,52879,12,52881,52907,12,52909,52935,12,52937,52963,12,52965,52991,12,52993,53019,12,53021,53047,12,53049,53075,12,53077,53103,12,53105,53131,12,53133,53159,12,53161,53187,12,53189,53215,12,53217,53243,12,53245,53271,12,53273,53299,12,53301,53327,12,53329,53355,12,53357,53383,12,53385,53411,12,53413,53439,12,53441,53467,12,53469,53495,12,53497,53523,12,53525,53551,12,53553,53579,12,53581,53607,12,53609,53635,12,53637,53663,12,53665,53691,12,53693,53719,12,53721,53747,12,53749,53775,12,53777,53803,12,53805,53831,12,53833,53859,12,53861,53887,12,53889,53915,12,53917,53943,12,53945,53971,12,53973,53999,12,54001,54027,12,54029,54055,12,54057,54083,12,54085,54111,12,54113,54139,12,54141,54167,12,54169,54195,12,54197,54223,12,54225,54251,12,54253,54279,12,54281,54307,12,54309,54335,12,54337,54363,12,54365,54391,12,54393,54419,12,54421,54447,12,54449,54475,12,54477,54503,12,54505,54531,12,54533,54559,12,54561,54587,12,54589,54615,12,54617,54643,12,54645,54671,12,54673,54699,12,54701,54727,12,54729,54755,12,54757,54783,12,54785,54811,12,54813,54839,12,54841,54867,12,54869,54895,12,54897,54923,12,54925,54951,12,54953,54979,12,54981,55007,12,55009,55035,12,55037,55063,12,55065,55091,12,55093,55119,12,55121,55147,12,55149,55175,12,55177,55203,12,55243,55291,10,65024,65039,5,65279,65279,4,65520,65528,4,66045,66045,5,66422,66426,5,68101,68102,5,68152,68154,5,68325,68326,5,69291,69292,5,69632,69632,7,69634,69634,7,69759,69761,5]")}function nt(j,ie){if(j===0)return 0;const ae=dt(j,ie);if(ae!==void 0)return ae;const ce=_(ie,j);return j-=Xe(ce),j}e.getLeftDeleteOffset=nt;function dt(j,ie){let ae=_(ie,j);for(j-=Xe(ae);ft(ae)||ae===65039||ae===8419;){if(j===0)return;ae=_(ie,j),j-=Xe(ae)}if(!!se(ae)){if(j>=0){const ce=_(ie,j);ce===8205&&(j-=Xe(ce))}return j}}function Xe(j){return j>=65536?2:1}function ft(j){return 127995<=j&&j<=127999}var lt;(function(j){j[j.zwj=8205]="zwj",j[j.emojiVariantSelector=65039]="emojiVariantSelector",j[j.enclosingKeyCap=8419]="enclosingKeyCap"})(lt||(lt={}))}),define(J[20],Z([0,1,23,64]),function(z,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const A=typeof Buffer!="undefined",S=typeof TextEncoder!="undefined",E=typeof TextDecoder!="undefined";let n,w;class p{constructor(d){this.buffer=d,this.byteLength=this.buffer.byteLength}static alloc(d){return A?new p(Buffer.allocUnsafe(d)):new p(new Uint8Array(d))}static wrap(d){return A&&!Buffer.isBuffer(d)&&(d=Buffer.from(d.buffer,d.byteOffset,d.byteLength)),new p(d)}static fromString(d,M){return!((M==null?void 0:M.dontUseNodeBuffer)||!1)&&A?new p(Buffer.from(d)):S?(n||(n=new TextEncoder),new p(n.encode(d))):new p(m.encodeUTF8(d))}static concat(d,M){if(typeof M=="undefined"){M=0;for(let V=0,Q=d.length;V<Q;V++)M+=d[V].byteLength}const T=p.alloc(M);let C=0;for(let V=0,Q=d.length;V<Q;V++){const te=d[V];T.set(te,C),C+=te.byteLength}return T}toString(){return A?this.buffer.toString():E?(w||(w=new TextDecoder),w.decode(this.buffer)):m.decodeUTF8(this.buffer)}slice(d,M){return new p(this.buffer.subarray(d,M))}set(d,M){d instanceof p?this.buffer.set(d.buffer,M):this.buffer.set(d,M)}readUInt32BE(d){return P(this.buffer,d)}writeUInt32BE(d,M){y(this.buffer,d,M)}readUInt32LE(d){return g(this.buffer,d)}writeUInt32LE(d,M){v(this.buffer,d,M)}readUInt8(d){return D(this.buffer,d)}writeUInt8(d,M){b(this.buffer,d,M)}}e.VSBuffer=p;function i(f,d){return f[d+0]<<0>>>0|f[d+1]<<8>>>0}e.readUInt16LE=i;function I(f,d,M){f[M+0]=d&255,d=d>>>8,f[M+1]=d&255}e.writeUInt16LE=I;function P(f,d){return f[d]*2**24+f[d+1]*2**16+f[d+2]*2**8+f[d+3]}e.readUInt32BE=P;function y(f,d,M){f[M+3]=d,d=d>>>8,f[M+2]=d,d=d>>>8,f[M+1]=d,d=d>>>8,f[M]=d}e.writeUInt32BE=y;function g(f,d){return f[d+0]<<0>>>0|f[d+1]<<8>>>0|f[d+2]<<16>>>0|f[d+3]<<24>>>0}e.readUInt32LE=g;function v(f,d,M){f[M+0]=d&255,d=d>>>8,f[M+1]=d&255,d=d>>>8,f[M+2]=d&255,d=d>>>8,f[M+3]=d&255}e.writeUInt32LE=v;function D(f,d){return f[d]}e.readUInt8=D;function b(f,d,M){f[M]=d}e.writeUInt8=b;function l(f){return L.consumeReadable(f,d=>p.concat(d))}e.readableToBuffer=l;function u(f){return L.toReadable(f)}e.bufferToReadable=u;function c(f){return L.consumeStream(f,d=>p.concat(d))}e.streamToBuffer=c;async function a(f){return f.ended?p.concat(f.buffer):p.concat([...f.buffer,await c(f.stream)])}e.bufferedStreamToBuffer=a;function t(f){return L.toStream(f,d=>p.concat(d))}e.bufferToStream=t;function r(f){return L.transform(f,{data:d=>typeof d=="string"?p.fromString(d):p.wrap(d)},d=>p.concat(d))}e.streamToBufferReadableStream=r;function s(f){return L.newWriteableStream(d=>p.concat(d),f)}e.newWriteableBufferStream=s;function o(f,d){return L.prefixedReadable(f,d,M=>p.concat(M))}e.prefixedBufferReadable=o;function h(f,d){return L.prefixedStream(f,d,M=>p.concat(M))}e.prefixedBufferStream=h}),define(J[80],Z([0,1,23]),function(z,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.doHash=e.hash=void 0;function L(b){return A(b,0)}e.hash=L;function A(b,l){switch(typeof b){case"object":return b===null?S(349,l):Array.isArray(b)?w(b,l):p(b,l);case"string":return n(b,l);case"boolean":return E(b,l);case"number":return S(b,l);case"undefined":return S(937,l);default:return S(617,l)}}e.doHash=A;function S(b,l){return(l<<5)-l+b|0}function E(b,l){return S(b?433:863,l)}function n(b,l){l=S(149417,l);for(let u=0,c=b.length;u<c;u++)l=S(b.charCodeAt(u),l);return l}e.stringHash=n;function w(b,l){return l=S(104579,l),b.reduce((u,c)=>A(c,u),l)}function p(b,l){return l=S(181387,l),Object.keys(b).sort().reduce((u,c)=>(u=n(c,u),A(b[c],u)),l)}class i{constructor(){this._value=0}get value(){return this._value}hash(l){return this._value=A(l,this._value),this._value}}e.Hasher=i;var I;(function(b){b[b.BLOCK_SIZE=64]="BLOCK_SIZE",b[b.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(I||(I={}));function P(b,l,u=32){const c=u-l,a=~((1<<c)-1);return(b<<l|(a&b)>>>c)>>>0}function y(b,l=0,u=b.byteLength,c=0){for(let a=0;a<u;a++)b[l+a]=c}function g(b,l,u="0"){for(;b.length<l;)b=u+b;return b}function v(b,l=32){return b instanceof ArrayBuffer?Array.from(new Uint8Array(b)).map(u=>u.toString(16).padStart(2,"0")).join(""):g((b>>>0).toString(16),l/4)}e.toHexString=v;class D{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(l){const u=l.length;if(u===0)return;const c=this._buff;let a=this._buffLen,t=this._leftoverHighSurrogate,r,s;for(t!==0?(r=t,s=-1,t=0):(r=l.charCodeAt(0),s=0);;){let o=r;if(m.isHighSurrogate(r))if(s+1<u){const h=l.charCodeAt(s+1);m.isLowSurrogate(h)?(s++,o=m.computeCodePoint(r,h)):o=65533}else{t=r;break}else m.isLowSurrogate(r)&&(o=65533);if(a=this._push(c,a,o),s++,s<u)r=l.charCodeAt(s);else break}this._buffLen=a,this._leftoverHighSurrogate=t}_push(l,u,c){return c<128?l[u++]=c:c<2048?(l[u++]=192|(c&1984)>>>6,l[u++]=128|(c&63)>>>0):c<65536?(l[u++]=224|(c&61440)>>>12,l[u++]=128|(c&4032)>>>6,l[u++]=128|(c&63)>>>0):(l[u++]=240|(c&1835008)>>>18,l[u++]=128|(c&258048)>>>12,l[u++]=128|(c&4032)>>>6,l[u++]=128|(c&63)>>>0),u>=64&&(this._step(),u-=64,this._totalLen+=64,l[0]=l[64+0],l[1]=l[64+1],l[2]=l[64+2]),u}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),v(this._h0)+v(this._h1)+v(this._h2)+v(this._h3)+v(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,y(this._buff,this._buffLen),this._buffLen>56&&(this._step(),y(this._buff));const l=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(l/4294967296),!1),this._buffDV.setUint32(60,l%4294967296,!1),this._step()}_step(){const l=D._bigBlock32,u=this._buffDV;for(let d=0;d<64;d+=4)l.setUint32(d,u.getUint32(d,!1),!1);for(let d=64;d<320;d+=4)l.setUint32(d,P(l.getUint32(d-12,!1)^l.getUint32(d-32,!1)^l.getUint32(d-56,!1)^l.getUint32(d-64,!1),1),!1);let c=this._h0,a=this._h1,t=this._h2,r=this._h3,s=this._h4,o,h,f;for(let d=0;d<80;d++)d<20?(o=a&t|~a&r,h=1518500249):d<40?(o=a^t^r,h=1859775393):d<60?(o=a&t|a&r|t&r,h=2400959708):(o=a^t^r,h=3395469782),f=P(c,5)+o+s+h+l.getUint32(d*4,!1)&4294967295,s=r,r=t,t=P(a,30),a=c,c=f;this._h0=this._h0+c&4294967295,this._h1=this._h1+a&4294967295,this._h2=this._h2+t&4294967295,this._h3=this._h3+r&4294967295,this._h4=this._h4+s&4294967295}}e.StringSHA1=D,D._bigBlock32=new DataView(new ArrayBuffer(320))}),define(J[13],Z([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.assertNever=e.NotImplementedProxy=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function m(d){return Array.isArray(d)}e.isArray=m;function L(d){return typeof d=="string"}e.isString=L;function A(d){return Array.isArray(d)&&d.every(M=>L(M))}e.isStringArray=A;function S(d){return typeof d=="object"&&d!==null&&!Array.isArray(d)&&!(d instanceof RegExp)&&!(d instanceof Date)}e.isObject=S;function E(d){return typeof d=="number"&&!isNaN(d)}e.isNumber=E;function n(d){return!!d&&typeof d[Symbol.iterator]=="function"}e.isIterable=n;function w(d){return d===!0||d===!1}e.isBoolean=w;function p(d){return typeof d=="undefined"}e.isUndefined=p;function i(d){return!I(d)}e.isDefined=i;function I(d){return p(d)||d===null}e.isUndefinedOrNull=I;function P(d,M){if(!d)throw new Error(M?`Unexpected type, expected '${M}'`:"Unexpected type")}e.assertType=P;function y(d){if(I(d))throw new Error("Assertion Failed: argument is undefined or null");return d}e.assertIsDefined=y;function g(...d){const M=[];for(let T=0;T<d.length;T++){const C=d[T];if(I(C))throw new Error(`Assertion Failed: argument at index ${T} is undefined or null`);M.push(C)}return M}e.assertAllDefined=g;const v=Object.prototype.hasOwnProperty;function D(d){if(!S(d))return!1;for(let M in d)if(v.call(d,M))return!1;return!0}e.isEmptyObject=D;function b(d){return typeof d=="function"}e.isFunction=b;function l(...d){return d.length>0&&d.every(b)}e.areFunctions=l;function u(d,M){const T=Math.min(d.length,M.length);for(let C=0;C<T;C++)c(d[C],M[C])}e.validateConstraints=u;function c(d,M){if(L(M)){if(typeof d!==M)throw new Error(`argument does not match constraint: typeof ${M}`)}else if(b(M)){try{if(d instanceof M)return}catch(T){}if(!I(d)&&d.constructor===M||M.length===1&&M.call(void 0,d)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=c;function a(d){let M=[],T=Object.getPrototypeOf(d);for(;Object.prototype!==T;)M=M.concat(Object.getOwnPropertyNames(T)),T=Object.getPrototypeOf(T);return M}e.getAllPropertyNames=a;function t(d){const M=[];for(const T of a(d))typeof d[T]=="function"&&M.push(T);return M}e.getAllMethodNames=t;function r(d,M){const T=V=>function(){const Q=Array.prototype.slice.call(arguments,0);return M(V,Q)};let C={};for(const V of d)C[V]=T(V);return C}e.createProxyObject=r;function s(d){return d===null?void 0:d}e.withNullAsUndefined=s;function o(d){return typeof d=="undefined"?null:d}e.withUndefinedAsNull=o;function h(d){return class{constructor(){return new Proxy({},{get(M,T){if(M[T])return M[T];throw new Error(`Not Implemented: ${d}->${String(T)}`)}})}}}e.NotImplementedProxy=h;function f(d){throw new Error("Unreachable")}e.assertNever=f}),define(J[29],Z([0,1,3,23,8,13]),function(z,e,m,L,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function E(s){return s===47||s===92}e.isPathSeparator=E;function n(s){return s.replace(/[\\/]/g,A.posix.sep)}e.toSlashes=n;function w(s){return s.indexOf("/")===-1&&(s=n(s)),/^[a-zA-Z]:(\/|$)/.test(s)&&(s="/"+s),s}e.toPosixPath=w;function p(s,o=A.posix.sep){if(!s)return"";const h=s.length,f=s.charCodeAt(0);if(E(f)){if(E(s.charCodeAt(1))&&!E(s.charCodeAt(2))){let M=3;const T=M;for(;M<h&&!E(s.charCodeAt(M));M++);if(T!==M&&!E(s.charCodeAt(M+1))){for(M+=1;M<h;M++)if(E(s.charCodeAt(M)))return s.slice(0,M+1).replace(/[\\/]/g,o)}}return o}else if(b(f)&&s.charCodeAt(1)===58)return E(s.charCodeAt(2))?s.slice(0,2)+o:s.slice(0,2);let d=s.indexOf("://");if(d!==-1){for(d+=3;d<h;d++)if(E(s.charCodeAt(d)))return s.slice(0,d+1)}return""}e.getRoot=p;function i(s){if(!m.isWindows||!s||s.length<5)return!1;let o=s.charCodeAt(0);if(o!==92||(o=s.charCodeAt(1),o!==92))return!1;let h=2;const f=h;for(;h<s.length&&(o=s.charCodeAt(h),o!==92);h++);return!(f===h||(o=s.charCodeAt(h+1),isNaN(o)||o===92))}e.isUNC=i;const I=/[\\/:\*\?"<>\|]/g,P=/[\\/]/g,y=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function g(s,o=m.isWindows){const h=o?I:P;return!(!s||s.length===0||/^\s+$/.test(s)||(h.lastIndex=0,h.test(s))||o&&y.test(s)||s==="."||s===".."||o&&s[s.length-1]==="."||o&&s.length!==s.trim().length||s.length>255)}e.isValidBasename=g;function v(s,o,h){const f=s===o;return!h||f?f:!s||!o?!1:L.equalsIgnoreCase(s,o)}e.isEqual=v;function D(s,o,h,f=A.sep){if(s===o)return!0;if(!s||!o||o.length>s.length)return!1;if(h){if(!L.startsWithIgnoreCase(s,o))return!1;if(o.length===s.length)return!0;let M=o.length;return o.charAt(o.length-1)===f&&M--,s.charAt(M)===f}return o.charAt(o.length-1)!==f&&(o+=f),s.indexOf(o)===0}e.isEqualOrParent=D;function b(s){return s>=65&&s<=90||s>=97&&s<=122}e.isWindowsDriveLetter=b;function l(s,o){return m.isWindows&&s.endsWith(":")&&(s+=A.sep),A.isAbsolute(s)||(s=A.join(o,s)),s=A.normalize(s),m.isWindows?(s=L.rtrim(s,A.sep),s.endsWith(":")&&(s+=A.sep)):(s=L.rtrim(s,A.sep),s||(s=A.sep)),s}e.sanitizeFilePath=l;function u(s){const o=A.normalize(s);return m.isWindows?s.length>3?!1:c(o)&&(s.length===2||o.charCodeAt(2)===92):o===A.posix.sep}e.isRootOrDriveLetter=u;function c(s){return m.isWindows?b(s.charCodeAt(0))&&s.charCodeAt(1)===58:!1}e.hasDriveLetter=c;function a(s){return c(s)?s[0]:void 0}e.getDriveLetter=a;function t(s,o,h){return o.length>s.length?-1:s===o?0:(h&&(s=s.toLowerCase(),o=o.toLowerCase()),s.indexOf(o))}e.indexOfPath=t;function r(s){const o=s.split(":");let h,f,d;if(o.forEach(M=>{const T=Number(M);S.isNumber(T)?f===void 0?f=T:d===void 0&&(d=T):h=h?[h,M].join(":"):M}),!h)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:h,line:f!==void 0?f:void 0,column:d!==void 0?d:f!==void 0?1:void 0}}e.parseLineAndColumnAware=r}),define(J[44],Z([0,1,13]),function(z,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function L(v){if(!v||typeof v!="object"||v instanceof RegExp)return v;const D=Array.isArray(v)?[]:{};return Object.keys(v).forEach(b=>{v[b]&&typeof v[b]=="object"?D[b]=L(v[b]):D[b]=v[b]}),D}e.deepClone=L;function A(v){if(!v||typeof v!="object")return v;const D=[v];for(;D.length>0;){const b=D.shift();Object.freeze(b);for(const l in b)if(S.call(b,l)){const u=b[l];typeof u=="object"&&!Object.isFrozen(u)&&D.push(u)}}return v}e.deepFreeze=A;const S=Object.prototype.hasOwnProperty;function E(v,D){return n(v,D,new Set)}e.cloneAndChange=E;function n(v,D,b){if(m.isUndefinedOrNull(v))return v;const l=D(v);if(typeof l!="undefined")return l;if(m.isArray(v)){const u=[];for(const c of v)u.push(n(c,D,b));return u}if(m.isObject(v)){if(b.has(v))throw new Error("Cannot clone recursive data-structure");b.add(v);const u={};for(let c in v)S.call(v,c)&&(u[c]=n(v[c],D,b));return b.delete(v),u}return v}function w(v,D,b=!0){return m.isObject(v)?(m.isObject(D)&&Object.keys(D).forEach(l=>{l in v?b&&(m.isObject(v[l])&&m.isObject(D[l])?w(v[l],D[l],b):v[l]=D[l]):v[l]=D[l]}),v):D}e.mixin=w;function p(v,D){if(v===D)return!0;if(v==null||D===null||D===void 0||typeof v!=typeof D||typeof v!="object"||Array.isArray(v)!==Array.isArray(D))return!1;let b,l;if(Array.isArray(v)){if(v.length!==D.length)return!1;for(b=0;b<v.length;b++)if(!p(v[b],D[b]))return!1}else{const u=[];for(l in v)u.push(l);u.sort();const c=[];for(l in D)c.push(l);if(c.sort(),!p(u,c))return!1;for(b=0;b<u.length;b++)if(!p(v[u[b]],D[u[b]]))return!1}return!0}e.equals=p;function i(v){const D=new Set;return JSON.stringify(v,(b,l)=>{if(m.isObject(l)||Array.isArray(l)){if(D.has(l))return"[Circular]";D.add(l)}return l})}e.safeStringify=i;function I(v,D,b){const l=D(v);return typeof l=="undefined"?b:l}e.getOrDefault=I;function P(v,D){const b=Object.create(null);return!v||!D||Object.keys(D).forEach(u=>{const c=v[u],a=D[u];p(c,a)||(b[u]=a)}),b}e.distinct=P;function y(v,D){const b=D.toLowerCase(),l=Object.keys(v).find(u=>u.toLowerCase()===b);return l?v[l]:v[D]}e.getCaseInsensitive=y;function g(v,D){const b=Object.create(null);for(const l of Object.keys(v))D(l,v[l])&&(b[l]=v[l]);return b}e.filter=g}),define(J[7],Z([0,1,3,8]),function(z,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const A=/^\w[\w\d+.-]*$/,S=/^\//,E=/^\/\//;function n(s,o){if(!s.scheme&&o)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${s.authority}", path: "${s.path}", query: "${s.query}", fragment: "${s.fragment}"}`);if(s.scheme&&!A.test(s.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(s.path){if(s.authority){if(!S.test(s.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(E.test(s.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function w(s,o){return!s&&!o?"file":s}function p(s,o){switch(s){case"https":case"http":case"file":o?o[0]!==I&&(o=I+o):o=I;break}return o}const i="",I="/",P=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class y{constructor(o,h,f,d,M,T=!1){typeof o=="object"?(this.scheme=o.scheme||i,this.authority=o.authority||i,this.path=o.path||i,this.query=o.query||i,this.fragment=o.fragment||i):(this.scheme=w(o,T),this.authority=h||i,this.path=p(this.scheme,f||i),this.query=d||i,this.fragment=M||i,n(this,T))}static isUri(o){return o instanceof y?!0:o?typeof o.authority=="string"&&typeof o.fragment=="string"&&typeof o.path=="string"&&typeof o.query=="string"&&typeof o.scheme=="string"&&typeof o.fsPath=="string"&&typeof o.with=="function"&&typeof o.toString=="function":!1}get fsPath(){return u(this,!1)}with(o){if(!o)return this;let{scheme:h,authority:f,path:d,query:M,fragment:T}=o;return h===void 0?h=this.scheme:h===null&&(h=i),f===void 0?f=this.authority:f===null&&(f=i),d===void 0?d=this.path:d===null&&(d=i),M===void 0?M=this.query:M===null&&(M=i),T===void 0?T=this.fragment:T===null&&(T=i),h===this.scheme&&f===this.authority&&d===this.path&&M===this.query&&T===this.fragment?this:new v(h,f,d,M,T)}static parse(o,h=!1){const f=P.exec(o);return f?new v(f[2]||i,r(f[4]||i),r(f[5]||i),r(f[7]||i),r(f[9]||i),h):new v(i,i,i,i,i)}static file(o){let h=i;if(m.isWindows&&(o=o.replace(/\\/g,I)),o[0]===I&&o[1]===I){const f=o.indexOf(I,2);f===-1?(h=o.substring(2),o=I):(h=o.substring(2,f),o=o.substring(f)||I)}return new v("file",h,o,i,i)}static from(o){const h=new v(o.scheme,o.authority,o.path,o.query,o.fragment);return n(h,!0),h}static joinPath(o,...h){if(!o.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let f;return m.isWindows&&o.scheme==="file"?f=y.file(L.win32.join(u(o,!0),...h)).path:f=L.posix.join(o.path,...h),o.with({path:f})}toString(o=!1){return c(this,o)}toJSON(){return this}static revive(o){if(o){if(o instanceof y)return o;{const h=new v(o);return h._formatted=o.external,h._fsPath=o._sep===g?o.fsPath:null,h}}else return o}}e.URI=y;const g=m.isWindows?1:void 0;class v extends y{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=u(this,!1)),this._fsPath}toString(o=!1){return o?c(this,!0):(this._formatted||(this._formatted=c(this,!1)),this._formatted)}toJSON(){const o={$mid:1};return this._fsPath&&(o.fsPath=this._fsPath,o._sep=g),this._formatted&&(o.external=this._formatted),this.path&&(o.path=this.path),this.scheme&&(o.scheme=this.scheme),this.authority&&(o.authority=this.authority),this.query&&(o.query=this.query),this.fragment&&(o.fragment=this.fragment),o}}const D={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function b(s,o){let h,f=-1;for(let d=0;d<s.length;d++){const M=s.charCodeAt(d);if(M>=97&&M<=122||M>=65&&M<=90||M>=48&&M<=57||M===45||M===46||M===95||M===126||o&&M===47)f!==-1&&(h+=encodeURIComponent(s.substring(f,d)),f=-1),h!==void 0&&(h+=s.charAt(d));else{h===void 0&&(h=s.substr(0,d));const T=D[M];T!==void 0?(f!==-1&&(h+=encodeURIComponent(s.substring(f,d)),f=-1),h+=T):f===-1&&(f=d)}}return f!==-1&&(h+=encodeURIComponent(s.substring(f))),h!==void 0?h:s}function l(s){let o;for(let h=0;h<s.length;h++){const f=s.charCodeAt(h);f===35||f===63?(o===void 0&&(o=s.substr(0,h)),o+=D[f]):o!==void 0&&(o+=s[h])}return o!==void 0?o:s}function u(s,o){let h;return s.authority&&s.path.length>1&&s.scheme==="file"?h=`//${s.authority}${s.path}`:s.path.charCodeAt(0)===47&&(s.path.charCodeAt(1)>=65&&s.path.charCodeAt(1)<=90||s.path.charCodeAt(1)>=97&&s.path.charCodeAt(1)<=122)&&s.path.charCodeAt(2)===58?o?h=s.path.substr(1):h=s.path[1].toLowerCase()+s.path.substr(2):h=s.path,m.isWindows&&(h=h.replace(/\//g,"\\")),h}e.uriToFsPath=u;function c(s,o){const h=o?l:b;let f="",{scheme:d,authority:M,path:T,query:C,fragment:V}=s;if(d&&(f+=d,f+=":"),(M||d==="file")&&(f+=I,f+=I),M){let Q=M.indexOf("@");if(Q!==-1){const te=M.substr(0,Q);M=M.substr(Q+1),Q=te.indexOf(":"),Q===-1?f+=h(te,!1):(f+=h(te.substr(0,Q),!1),f+=":",f+=h(te.substr(Q+1),!1)),f+="@"}M=M.toLowerCase(),Q=M.indexOf(":"),Q===-1?f+=h(M,!1):(f+=h(M.substr(0,Q),!1),f+=M.substr(Q))}if(T){if(T.length>=3&&T.charCodeAt(0)===47&&T.charCodeAt(2)===58){const Q=T.charCodeAt(1);Q>=65&&Q<=90&&(T=`/${String.fromCharCode(Q+32)}:${T.substr(3)}`)}else if(T.length>=2&&T.charCodeAt(1)===58){const Q=T.charCodeAt(0);Q>=65&&Q<=90&&(T=`${String.fromCharCode(Q+32)}:${T.substr(2)}`)}f+=h(T,!0)}return C&&(f+="?",f+=h(C,!1)),V&&(f+="#",f+=o?V:b(V,!1)),f}function a(s){try{return decodeURIComponent(s)}catch(o){return s.length>3?s.substr(0,3)+a(s.substr(3)):s}}const t=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function r(s){return s.match(t)?s.replace(t,o=>a(o)):s}}),define(J[109],Z([0,1,7]),function(z,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function L(p){const i=p;return i&&typeof i.type=="string"&&typeof i.severity=="string"}e.isRemoteConsoleLog=L;function A(p){const i=[];let I;try{const P=JSON.parse(p.arguments),y=P[P.length-1];y&&y.__$stack&&(P.pop(),I=y.__$stack),i.push(...P)}catch(P){i.push("Unable to log remote console arguments",p.arguments)}return{args:i,stack:I}}e.parse=A;function S(p){if(typeof p!="string")return S(A(p).stack);const i=p;if(i){const I=E(i),P=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(I||"");if(P&&P.length===4)return{uri:m.URI.file(P[1]),line:Number(P[2]),column:Number(P[3])}}}e.getFirstFrame=S;function E(p){if(!p)return p;const i=p.indexOf(`
`);return i===-1?p:p.substring(0,i)}function n(p,i){const{args:I,stack:P}=A(p),y=typeof I[0]=="string"&&I.length===1;let g=E(P);g&&(g=`(${g.trim()})`);let v=[];if(typeof I[0]=="string"?g&&y?v=[`%c[${i}] %c${I[0]} %c${g}`,w("blue"),w(""),w("grey")]:v=[`%c[${i}] %c${I[0]}`,w("blue"),w(""),...I.slice(1)]:v=[`%c[${i}]%`,w("blue"),...I],g&&!y&&v.push(g),typeof console[p.severity]!="function")throw new Error("Unknown console method");console[p.severity].apply(console,v)}e.log=n;function w(p){return`color: ${p}`}});var kt=this&&this.__classPrivateFieldSet||function(z,e,m,L,A){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!A)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?z!==e||!A:!e.has(z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?A.call(z,m):A?A.value=m:e.set(z,m),m},Ye=this&&this.__classPrivateFieldGet||function(z,e,m,L){if(m==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?z!==e||!L:!e.has(z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?L:m==="a"?L.call(z):L?L.value:e.get(z)};define(J[36],Z([0,1,7,23]),function(z,e,m,L){"use strict";var A,S,E;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function n(t,r,s){let o=t.get(r);return o===void 0&&(o=s,t.set(r,o)),o}e.getOrSet=n;function w(t){const r=[];return t.forEach((s,o)=>{r.push(`${o} => ${s}`)}),`Map(${t.size}) {${r.join(", ")}}`}e.mapToString=w;function p(t){const r=[];return t.forEach(s=>{r.push(s)}),`Set(${t.size}) {${r.join(", ")}}`}e.setToString=p;class i{constructor(){this._value="",this._pos=0}reset(r){return this._value=r,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(r){const s=r.charCodeAt(0),o=this._value.charCodeAt(this._pos);return s-o}value(){return this._value[this._pos]}}e.StringIterator=i;class I{constructor(r=!0){this._caseSensitive=r}reset(r){return this._value=r,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let r=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(r)this._from++;else break;else r=!1;return this}cmp(r){return this._caseSensitive?L.compareSubstring(r,this._value,0,r.length,this._from,this._to):L.compareSubstringIgnoreCase(r,this._value,0,r.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=I;class P{constructor(r=!0,s=!0){this._splitOnBackslash=r,this._caseSensitive=s}reset(r){return this._value=r.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let r=!0;for(;this._to<this._value.length;this._to++){const s=this._value.charCodeAt(this._to);if(s===47||this._splitOnBackslash&&s===92)if(r)this._from++;else break;else r=!1}return this}cmp(r){return this._caseSensitive?L.compareSubstring(r,this._value,0,r.length,this._from,this._to):L.compareSubstringIgnoreCase(r,this._value,0,r.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=P;var y;(function(t){t[t.Scheme=1]="Scheme",t[t.Authority=2]="Authority",t[t.Path=3]="Path",t[t.Query=4]="Query",t[t.Fragment=5]="Fragment"})(y||(y={}));class g{constructor(r){this._ignorePathCasing=r,this._states=[],this._stateIdx=0}reset(r){return this._value=r,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new P(!1,!this._ignorePathCasing(r)),this._pathIterator.reset(r.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(r){if(this._states[this._stateIdx]===1)return L.compareIgnoreCase(r,this._value.scheme);if(this._states[this._stateIdx]===2)return L.compareIgnoreCase(r,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(r);if(this._states[this._stateIdx]===4)return L.compare(r,this._value.query);if(this._states[this._stateIdx]===5)return L.compare(r,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=g;class v{isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}}class D{constructor(r){this._iter=r}static forUris(r=()=>!1){return new D(new g(r))}static forPaths(){return new D(new P)}static forStrings(){return new D(new i)}static forConfigKeys(){return new D(new I)}clear(){this._root=void 0}set(r,s){const o=this._iter.reset(r);let h;for(this._root||(this._root=new v,this._root.segment=o.value()),h=this._root;;){const d=o.cmp(h.segment);if(d>0)h.left||(h.left=new v,h.left.segment=o.value()),h=h.left;else if(d<0)h.right||(h.right=new v,h.right.segment=o.value()),h=h.right;else if(o.hasNext())o.next(),h.mid||(h.mid=new v,h.mid.segment=o.value()),h=h.mid;else break}const f=h.value;return h.value=s,h.key=r,f}get(r){var s;return(s=this._getNode(r))===null||s===void 0?void 0:s.value}_getNode(r){const s=this._iter.reset(r);let o=this._root;for(;o;){const h=s.cmp(o.segment);if(h>0)o=o.left;else if(h<0)o=o.right;else if(s.hasNext())s.next(),o=o.mid;else break}return o}has(r){const s=this._getNode(r);return!((s==null?void 0:s.value)===void 0&&(s==null?void 0:s.mid)===void 0)}delete(r){return this._delete(r,!1)}deleteSuperstr(r){return this._delete(r,!0)}_delete(r,s){const o=this._iter.reset(r),h=[];let f=this._root;for(;f;){const d=o.cmp(f.segment);if(d>0)h.push([1,f]),f=f.left;else if(d<0)h.push([-1,f]),f=f.right;else if(o.hasNext())o.next(),h.push([0,f]),f=f.mid;else{for(s?(f.left=void 0,f.mid=void 0,f.right=void 0):f.value=void 0;h.length>0&&f.isEmpty();){let[M,T]=h.pop();switch(M){case 1:T.left=void 0;break;case 0:T.mid=void 0;break;case-1:T.right=void 0;break}f=T}break}}}findSubstr(r){const s=this._iter.reset(r);let o=this._root,h;for(;o;){const f=s.cmp(o.segment);if(f>0)o=o.left;else if(f<0)o=o.right;else if(s.hasNext())s.next(),h=o.value||h,o=o.mid;else break}return o&&o.value||h}findSuperstr(r){const s=this._iter.reset(r);let o=this._root;for(;o;){const h=s.cmp(o.segment);if(h>0)o=o.left;else if(h<0)o=o.right;else if(s.hasNext())s.next(),o=o.mid;else return o.mid?this._entries(o.mid):void 0}}forEach(r){for(const[s,o]of this)r(o,s)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(r){if(!r)return;const s=[r];for(;s.length>0;){const o=s.pop();o&&(o.value&&(yield[o.key,o.value]),o.left&&s.push(o.left),o.mid&&s.push(o.mid),o.right&&s.push(o.right))}}}e.TernarySearchTree=D;class b{constructor(r,s){this[A]="ResourceMap",r instanceof b?(this.map=new Map(r.map),this.toKey=s??b.defaultToKey):(this.map=new Map,this.toKey=r??b.defaultToKey)}set(r,s){return this.map.set(this.toKey(r),s),this}get(r){return this.map.get(this.toKey(r))}has(r){return this.map.has(this.toKey(r))}get size(){return this.map.size}clear(){this.map.clear()}delete(r){return this.map.delete(this.toKey(r))}forEach(r,s){typeof s!="undefined"&&(r=r.bind(s));for(let[o,h]of this.map)r(h,m.URI.parse(o),this)}values(){return this.map.values()}*keys(){for(let r of this.map.keys())yield m.URI.parse(r)}*entries(){for(let r of this.map.entries())yield[m.URI.parse(r[0]),r[1]]}*[(A=Symbol.toStringTag,Symbol.iterator)](){for(let r of this.map)yield[m.URI.parse(r[0]),r[1]]}}e.ResourceMap=b,b.defaultToKey=t=>t.toString();var l;(function(t){t[t.None=0]="None",t[t.AsOld=1]="AsOld",t[t.AsNew=2]="AsNew"})(l=e.Touch||(e.Touch={}));class u{constructor(){this[S]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){var r;return(r=this._head)===null||r===void 0?void 0:r.value}get last(){var r;return(r=this._tail)===null||r===void 0?void 0:r.value}has(r){return this._map.has(r)}get(r,s=0){const o=this._map.get(r);if(!!o)return s!==0&&this.touch(o,s),o.value}set(r,s,o=0){let h=this._map.get(r);if(h)h.value=s,o!==0&&this.touch(h,o);else{switch(h={key:r,value:s,next:void 0,previous:void 0},o){case 0:this.addItemLast(h);break;case 1:this.addItemFirst(h);break;case 2:this.addItemLast(h);break;default:this.addItemLast(h);break}this._map.set(r,h),this._size++}return this}delete(r){return!!this.remove(r)}remove(r){const s=this._map.get(r);if(!!s)return this._map.delete(r),this.removeItem(s),this._size--,s.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const r=this._head;return this._map.delete(r.key),this.removeItem(r),this._size--,r.value}forEach(r,s){const o=this._state;let h=this._head;for(;h;){if(s?r.bind(s)(h.value,h.key,this):r(h.value,h.key,this),this._state!==o)throw new Error("LinkedMap got modified during iteration.");h=h.next}}keys(){const r=this,s=this._state;let o=this._head;const h={[Symbol.iterator](){return h},next(){if(r._state!==s)throw new Error("LinkedMap got modified during iteration.");if(o){const f={value:o.key,done:!1};return o=o.next,f}else return{value:void 0,done:!0}}};return h}values(){const r=this,s=this._state;let o=this._head;const h={[Symbol.iterator](){return h},next(){if(r._state!==s)throw new Error("LinkedMap got modified during iteration.");if(o){const f={value:o.value,done:!1};return o=o.next,f}else return{value:void 0,done:!0}}};return h}entries(){const r=this,s=this._state;let o=this._head;const h={[Symbol.iterator](){return h},next(){if(r._state!==s)throw new Error("LinkedMap got modified during iteration.");if(o){const f={value:[o.key,o.value],done:!1};return o=o.next,f}else return{value:void 0,done:!0}}};return h}[(S=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(r){if(r>=this.size)return;if(r===0){this.clear();return}let s=this._head,o=this.size;for(;s&&o>r;)this._map.delete(s.key),s=s.next,o--;this._head=s,this._size=o,s&&(s.previous=void 0),this._state++}addItemFirst(r){if(!this._head&&!this._tail)this._tail=r;else if(this._head)r.next=this._head,this._head.previous=r;else throw new Error("Invalid list");this._head=r,this._state++}addItemLast(r){if(!this._head&&!this._tail)this._head=r;else if(this._tail)r.previous=this._tail,this._tail.next=r;else throw new Error("Invalid list");this._tail=r,this._state++}removeItem(r){if(r===this._head&&r===this._tail)this._head=void 0,this._tail=void 0;else if(r===this._head){if(!r.next)throw new Error("Invalid list");r.next.previous=void 0,this._head=r.next}else if(r===this._tail){if(!r.previous)throw new Error("Invalid list");r.previous.next=void 0,this._tail=r.previous}else{const s=r.next,o=r.previous;if(!s||!o)throw new Error("Invalid list");s.previous=o,o.next=s}r.next=void 0,r.previous=void 0,this._state++}touch(r,s){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(s!==1&&s!==2)){if(s===1){if(r===this._head)return;const o=r.next,h=r.previous;r===this._tail?(h.next=void 0,this._tail=h):(o.previous=h,h.next=o),r.previous=void 0,r.next=this._head,this._head.previous=r,this._head=r,this._state++}else if(s===2){if(r===this._tail)return;const o=r.next,h=r.previous;r===this._head?(o.previous=void 0,this._head=o):(o.previous=h,h.next=o),r.next=void 0,r.previous=this._tail,this._tail.next=r,this._tail=r,this._state++}}}toJSON(){const r=[];return this.forEach((s,o)=>{r.push([o,s])}),r}fromJSON(r){this.clear();for(const[s,o]of r)this.set(s,o)}}e.LinkedMap=u;class c extends u{constructor(r,s=1){super();this._limit=r,this._ratio=Math.min(Math.max(0,s),1)}get limit(){return this._limit}set limit(r){this._limit=r,this.checkTrim()}get ratio(){return this._ratio}set ratio(r){this._ratio=Math.min(Math.max(0,r),1),this.checkTrim()}get(r,s=2){return super.get(r,s)}peek(r){return super.get(r,0)}set(r,s){return super.set(r,s,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=c;class a{constructor(r){E.set(this,void 0),kt(this,E,r,"f")}get size(){return Ye(this,E,"f").size}forEach(r,s){Ye(this,E,"f").forEach(r,s)}get(r){return Ye(this,E,"f").get(r)}has(r){return Ye(this,E,"f").has(r)}entries(){return Ye(this,E,"f").entries()}keys(){return Ye(this,E,"f").keys()}values(){return Ye(this,E,"f").values()}[(E=new WeakMap,Symbol.iterator)](){return Ye(this,E,"f").entries()}}e.ReadonlyMapView=a}),define(J[110],Z([0,1,20,23,7]),function(z,e,m,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function S(p){return JSON.stringify(p,n)}e.stringify=S;function E(p){let i=JSON.parse(p);return i=w(i),i}e.parse=E;function n(p,i){return i instanceof RegExp?{$mid:2,source:i.source,flags:L.regExpFlags(i)}:i}function w(p,i=0){if(!p||i>200)return p;if(typeof p=="object"){switch(p.$mid){case 1:return A.URI.revive(p);case 2:return new RegExp(p.source,p.flags)}if(p instanceof m.VSBuffer||p instanceof Uint8Array)return p;if(Array.isArray(p))for(let I=0;I<p.length;++I)p[I]=w(p[I],i+1);else for(const I in p)Object.hasOwnProperty.call(p,I)&&(p[I]=w(p[I],i+1))}return p}e.revive=w}),define(J[10],Z([0,1,7,3]),function(z,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var A;(function(n){n.inMemory="inmemory",n.vscode="vscode",n.internal="private",n.walkThrough="walkThrough",n.walkThroughSnippet="walkThroughSnippet",n.http="http",n.https="https",n.file="file",n.mailto="mailto",n.untitled="untitled",n.data="data",n.command="command",n.vscodeRemote="vscode-remote",n.vscodeRemoteResource="vscode-remote-resource",n.userData="vscode-userdata",n.vscodeCustomEditor="vscode-custom-editor",n.vscodeNotebook="vscode-notebook",n.vscodeNotebookCell="vscode-notebook-cell",n.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",n.vscodeNotebookCellOutput="vscode-notebook-cell-output",n.vscodeSettings="vscode-settings",n.vscodeWorkspaceTrust="vscode-workspace-trust",n.vscodeTerminal="vscode-terminal",n.webviewPanel="webview-panel",n.vscodeWebview="vscode-webview",n.extension="extension",n.vscodeFileResource="vscode-file",n.tmp="tmp"})(A=e.Schemas||(e.Schemas={}));class S{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(w){this._preferredWebSchema=w}setDelegate(w){this._delegate=w}set(w,p,i){this._hosts[w]=p,this._ports[w]=i}setConnectionToken(w,p){this._connectionTokens[w]=p}rewrite(w){if(this._delegate)return this._delegate(w);const p=w.authority;let i=this._hosts[p];i&&i.indexOf(":")!==-1&&(i=`[${i}]`);const I=this._ports[p],P=this._connectionTokens[p];let y=`path=${encodeURIComponent(w.path)}`;return typeof P=="string"&&(y+=`&tkn=${encodeURIComponent(P)}`),m.URI.from({scheme:L.isWeb?this._preferredWebSchema:A.vscodeRemoteResource,authority:`${i}:${I}`,path:"/vscode-remote-resource",query:y})}}e.RemoteAuthorities=new S;class E{constructor(){this.FALLBACK_AUTHORITY="vscode-app"}asBrowserUri(w,p,i){const I=this.toUri(w,p);return I.scheme===A.vscodeRemote?e.RemoteAuthorities.rewrite(I):L.isNative&&(i||L.isPreferringBrowserCodeLoad)&&I.scheme===A.file?I.with({scheme:A.vscodeFileResource,authority:I.authority||this.FALLBACK_AUTHORITY,query:null,fragment:null}):I}asFileUri(w,p){const i=this.toUri(w,p);return i.scheme===A.vscodeFileResource?i.with({scheme:A.file,authority:i.authority!==this.FALLBACK_AUTHORITY?i.authority:null,query:null,fragment:null}):i}toUri(w,p){return m.URI.isUri(w)?w:m.URI.parse(p.toUrl(w))}}e.FileAccess=new E}),define(J[65],Z([0,1,36]),function(z,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=e.canNormalize=void 0,e.canNormalize=typeof String.prototype.normalize=="function";const L=new m.LRUCache(1e4);function A(p){return w(p,"NFC",L)}e.normalizeNFC=A;const S=new m.LRUCache(1e4);function E(p){return w(p,"NFD",S)}e.normalizeNFD=E;const n=/[^\u0000-\u0080]/;function w(p,i,I){if(!e.canNormalize||!p)return p;const P=I.get(p);if(P)return P;let y;return n.test(p)?y=p.normalize(i):y=p,I.set(p,y),y}e.removeAccents=function(){if(e.canNormalize){const p=/[\u0300-\u036f]/g;return function(i){return E(i).replace(p,"")}}else return function(p){return p}}()}),define(J[15],Z([0,1,29,8,7,23,10,3]),function(z,e,m,L,A,S,E,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function w(y){return A.uriToFsPath(y,!0)}e.originalFSPath=w;class p{constructor(g){this._ignorePathCasing=g}compare(g,v,D=!1){return g===v?0:S.compare(this.getComparisonKey(g,D),this.getComparisonKey(v,D))}isEqual(g,v,D=!1){return g===v?!0:!g||!v?!1:this.getComparisonKey(g,D)===this.getComparisonKey(v,D)}getComparisonKey(g,v=!1){return g.with({path:this._ignorePathCasing(g)?g.path.toLowerCase():void 0,fragment:v?null:void 0}).toString()}ignorePathCasing(g){return this._ignorePathCasing(g)}isEqualOrParent(g,v,D=!1){if(g.scheme===v.scheme){if(g.scheme===E.Schemas.file)return m.isEqualOrParent(w(g),w(v),this._ignorePathCasing(g))&&g.query===v.query&&(D||g.fragment===v.fragment);if(e.isEqualAuthority(g.authority,v.authority))return m.isEqualOrParent(g.path,v.path,this._ignorePathCasing(g),"/")&&g.query===v.query&&(D||g.fragment===v.fragment)}return!1}joinPath(g,...v){return A.URI.joinPath(g,...v)}basenameOrAuthority(g){return e.basename(g)||g.authority}basename(g){return L.posix.basename(g.path)}extname(g){return L.posix.extname(g.path)}dirname(g){if(g.path.length===0)return g;let v;return g.scheme===E.Schemas.file?v=A.URI.file(L.dirname(w(g))).path:(v=L.posix.dirname(g.path),g.authority&&v.length&&v.charCodeAt(0)!==47&&(console.error(`dirname("${g.toString})) resulted in a relative path`),v="/")),g.with({path:v})}normalizePath(g){if(!g.path.length)return g;let v;return g.scheme===E.Schemas.file?v=A.URI.file(L.normalize(w(g))).path:v=L.posix.normalize(g.path),g.with({path:v})}relativePath(g,v){if(g.scheme!==v.scheme||!e.isEqualAuthority(g.authority,v.authority))return;if(g.scheme===E.Schemas.file){const l=L.relative(w(g),w(v));return n.isWindows?m.toSlashes(l):l}let D=g.path||"/",b=v.path||"/";if(this._ignorePathCasing(g)){let l=0;for(const u=Math.min(D.length,b.length);l<u&&!(D.charCodeAt(l)!==b.charCodeAt(l)&&D.charAt(l).toLowerCase()!==b.charAt(l).toLowerCase());l++);D=b.substr(0,l)+D.substr(l)}return L.posix.relative(D,b)}resolvePath(g,v){if(g.scheme===E.Schemas.file){const D=A.URI.file(L.resolve(w(g),v));return g.with({authority:D.authority,path:D.path})}return v=m.toPosixPath(v),g.with({path:L.posix.resolve(g.path,v)})}isAbsolutePath(g){return!!g.path&&g.path[0]==="/"}isEqualAuthority(g,v){return g===v||S.equalsIgnoreCase(g,v)}hasTrailingPathSeparator(g,v=L.sep){if(g.scheme===E.Schemas.file){const D=w(g);return D.length>m.getRoot(D).length&&D[D.length-1]===v}else{const D=g.path;return D.length>1&&D.charCodeAt(D.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(g.fsPath)}}removeTrailingPathSeparator(g,v=L.sep){return e.hasTrailingPathSeparator(g,v)?g.with({path:g.path.substr(0,g.path.length-1)}):g}addTrailingPathSeparator(g,v=L.sep){let D=!1;if(g.scheme===E.Schemas.file){const b=w(g);D=b!==void 0&&b.length===m.getRoot(b).length&&b[b.length-1]===v}else{v="/";const b=g.path;D=b.length===1&&b.charCodeAt(b.length-1)===47}return!D&&!e.hasTrailingPathSeparator(g,v)?g.with({path:g.path+"/"}):g}}e.ExtUri=p,e.extUri=new p(()=>!1),e.extUriBiasedIgnorePathCase=new p(y=>y.scheme===E.Schemas.file?!n.isLinux:!0),e.extUriIgnorePathCase=new p(y=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function i(y,g){const v=[];for(let D=0;D<y.length;D++){const b=g(y[D]);y.some((l,u)=>u===D?!1:e.isEqualOrParent(b,g(l)))||v.push(y[D])}return v}e.distinctParents=i;var I;(function(y){y.META_DATA_LABEL="label",y.META_DATA_DESCRIPTION="description",y.META_DATA_SIZE="size",y.META_DATA_MIME="mime";function g(v){const D=new Map;v.path.substring(v.path.indexOf(";")+1,v.path.lastIndexOf(";")).split(";").forEach(u=>{const[c,a]=u.split(":");c&&a&&D.set(c,a)});const l=v.path.substring(0,v.path.indexOf(";"));return l&&D.set(y.META_DATA_MIME,l),D}y.parseMetaData=g})(I=e.DataUri||(e.DataUri={}));function P(y,g,v){if(g){let D=y.path;return D&&D[0]!==L.posix.sep&&(D=L.posix.sep+D),y.with({scheme:v,authority:g,path:D})}return y.with({scheme:v})}e.toLocalResource=P}),define(J[9],Z([0,1,25,19,5,2,78,15]),function(z,e,m,L,A,S,E,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.AsyncEmitter=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.RunOnceWorker=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.ignoreErrors=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function w(N){return!!N&&typeof N.then=="function"}e.isThenable=w;function p(N){const F=new m.CancellationTokenSource,R=N(F.token),O=new Promise((k,W)=>{F.token.onCancellationRequested(()=>{W(L.canceled())}),Promise.resolve(R).then(U=>{F.dispose(),k(U)},U=>{F.dispose(),W(U)})});return new class{cancel(){F.cancel()}then(k,W){return O.then(k,W)}catch(k){return this.then(void 0,k)}finally(k){return O.finally(k)}}}e.createCancelablePromise=p;function i(N,F,R){return Promise.race([N,new Promise(O=>F.onCancellationRequested(()=>O(R)))])}e.raceCancellation=i;async function I(N){let F=-1;const R=N.map((k,W)=>k.then(U=>(F=W,U))),O=await Promise.race(R);return N.forEach((k,W)=>{W!==F&&k.cancel()}),O}e.raceCancellablePromises=I;function P(N,F,R){let O;const k=setTimeout(()=>{O==null||O(void 0),R==null||R()},F);return Promise.race([N.finally(()=>clearTimeout(k)),new Promise(W=>O=W)])}e.raceTimeout=P;function y(N){return new Promise((F,R)=>{const O=N();w(O)?O.then(F,R):F(O)})}e.asPromise=y;class g{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(F){if(this.activePromise){if(this.queuedPromiseFactory=F,!this.queuedPromise){const R=()=>{this.queuedPromise=null;const O=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,O};this.queuedPromise=new Promise(O=>{this.activePromise.then(R,R).then(O)})}return new Promise((R,O)=>{this.queuedPromise.then(R,O)})}return this.activePromise=F(),new Promise((R,O)=>{this.activePromise.then(k=>{this.activePromise=null,R(k)},k=>{this.activePromise=null,O(k)})})}}e.Throttler=g;class v{constructor(){this.current=Promise.resolve(null)}queue(F){return this.current=this.current.then(()=>F(),()=>F())}}e.Sequencer=v;class D{constructor(){this.promiseMap=new Map}queue(F,R){var O;const W=((O=this.promiseMap.get(F))!==null&&O!==void 0?O:Promise.resolve()).catch(()=>{}).then(R).finally(()=>{this.promiseMap.get(F)===W&&this.promiseMap.delete(F)});return this.promiseMap.set(F,W),W}}e.SequencerByKey=D;class b{constructor(F){this.defaultDelay=F,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(F,R=this.defaultDelay){return this.task=F,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((O,k)=>{this.doResolve=O,this.doReject=k}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const O=this.task;return this.task=null,O()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},R),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject(L.canceled()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancel()}}e.Delayer=b;class l{constructor(F){this.delayer=new b(F),this.throttler=new g}trigger(F,R){return this.delayer.trigger(()=>this.throttler.queue(F),R)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=l;class u{constructor(){this._isOpen=!1,this._promise=new Promise((F,R)=>{this._completePromise=F})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=u;class c extends u{constructor(F){super();this._timeout=setTimeout(()=>this.open(),F)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=c;function a(N,F){return F?new Promise((R,O)=>{const k=setTimeout(R,N);F.onCancellationRequested(()=>{clearTimeout(k),O(L.canceled())})}):p(R=>a(N,R))}e.timeout=a;function t(N,F=0){const R=setTimeout(N,F);return S.toDisposable(()=>clearTimeout(R))}e.disposableTimeout=t;function r(N){return N.then(void 0,F=>{})}e.ignoreErrors=r;function s(N){const F=[];let R=0;const O=N.length;function k(){return R<O?N[R++]():null}function W(U){U!=null&&F.push(U);const q=k();return q?q.then(W):Promise.resolve(F)}return Promise.resolve(null).then(W)}e.sequence=s;function o(N,F=O=>!!O,R=null){let O=0;const k=N.length,W=()=>{if(O>=k)return Promise.resolve(R);const U=N[O++];return Promise.resolve(U()).then(K=>F(K)?Promise.resolve(K):W())};return W()}e.first=o;function h(N,F=O=>!!O,R=null){if(N.length===0)return Promise.resolve(R);let O=N.length;const k=()=>{var W,U;O=-1;for(const q of N)(U=(W=q).cancel)===null||U===void 0||U.call(W)};return new Promise((W,U)=>{for(const q of N)q.then(K=>{--O>=0&&F(K)?(k(),W(K)):O===0&&W(R)}).catch(K=>{--O>=0&&(k(),U(K))})})}e.firstParallel=h;class f{constructor(F){this._size=0,this.maxDegreeOfParalellism=F,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new A.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(F){return this._size++,new Promise((R,O)=>{this.outstandingPromises.push({factory:F,c:R,e:O}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const F=this.outstandingPromises.shift();this.runningPromises++;const R=F.factory();R.then(F.c,F.e),R.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=f;class d extends f{constructor(){super(1)}}e.Queue=d;class M{constructor(){this.queues=new Map}queueFor(F,R=n.extUri){const O=R.getComparisonKey(F);let k=this.queues.get(O);return k||(k=new d,A.Event.once(k.onFinished)(()=>{k==null||k.dispose(),this.queues.delete(O)}),this.queues.set(O,k)),k}dispose(){this.queues.forEach(F=>F.dispose()),this.queues.clear()}}e.ResourceQueue=M;class T{constructor(F,R){this._token=-1,typeof F=="function"&&typeof R=="number"&&this.setIfNotSet(F,R)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(F,R){this.cancel(),this._token=setTimeout(()=>{this._token=-1,F()},R)}setIfNotSet(F,R){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,F()},R))}}e.TimeoutTimer=T;class C{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(F,R){this.cancel(),this._token=setInterval(()=>{F()},R)}}e.IntervalTimer=C;class V{constructor(F,R){this.timeoutToken=-1,this.runner=F,this.timeout=R,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(F=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,F)}get delay(){return this.timeout}set delay(F){this.timeout=F}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=V;class Q extends V{constructor(F,R){super(F,R);this.units=[]}work(F){this.units.push(F),this.isScheduled()||this.schedule()}doRun(){const F=this.units;this.units=[],this.runner&&this.runner(F)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=Q,function(){if(typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"){const N=Object.freeze({didTimeout:!0,timeRemaining(){return 15}});e.runWhenIdle=F=>{const R=setTimeout(()=>F(N));let O=!1;return{dispose(){O||(O=!0,clearTimeout(R))}}}}else e.runWhenIdle=(N,F)=>{const R=requestIdleCallback(N,typeof F=="number"?{timeout:F}:void 0);let O=!1;return{dispose(){O||(O=!0,cancelIdleCallback(R))}}}}();class te{constructor(F){this._didRun=!1,this._executor=()=>{try{this._value=F()}catch(R){this._error=R}finally{this._didRun=!0}},this._handle=e.runWhenIdle(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}}e.IdleValue=te;async function B(N,F,R){let O;for(let k=0;k<R;k++)try{return await N()}catch(W){O=W,await a(F)}throw O}e.retry=B;class Y{hasPending(F){return this._pending?typeof F=="number"?this._pending.taskId===F:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){var F;(F=this._pending)===null||F===void 0||F.cancel()}setPending(F,R,O){return this._pending={taskId:F,cancel:()=>O==null?void 0:O(),promise:R},R.then(()=>this.donePending(F),()=>this.donePending(F)),R}donePending(F){this._pending&&F===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const F=this._next;this._next=void 0,F.run().then(F.promiseResolve,F.promiseReject)}}setNext(F){if(this._next)this._next.run=F;else{let R,O;const k=new Promise((W,U)=>{R=W,O=U});this._next={run:F,promise:k,promiseResolve:R,promiseReject:O}}return this._next.promise}}e.TaskSequentializer=Y;class X{constructor(F){this.interval=F,this.lastIncrementTime=0,this.value=0}increment(){const F=Date.now();return F-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=F,this.value=0),this.value++,this.value}}e.IntervalCounter=X;class _{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((F,R)=>{this.completeCallback=F,this.errorCallback=R})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(F){return new Promise(R=>{this.completeCallback(F),this.resolved=!0,R()})}error(F){return new Promise(R=>{this.errorCallback(F),this.rejected=!0,R()})}cancel(){new Promise(F=>{this.errorCallback(L.canceled()),this.rejected=!0,F()})}}e.DeferredPromise=_;class $ extends A.Emitter{async fireAsync(F,R,O){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new E.LinkedList);for(const k of this._listeners)this._asyncDeliveryQueue.push([k,F]);for(;this._asyncDeliveryQueue.size>0&&!R.isCancellationRequested;){const[k,W]=this._asyncDeliveryQueue.shift(),U=[],q=Object.assign(Object.assign({},W),{waitUntil:K=>{if(Object.isFrozen(U))throw new Error("waitUntil can NOT be called asynchronous");O&&(K=O(K,typeof k=="function"?k:k[0])),U.push(K)}});try{typeof k=="function"?k.call(void 0,q):k[0].call(k[1],q)}catch(K){L.onUnexpectedError(K);continue}Object.freeze(U),await G.settled(U).catch(K=>L.onUnexpectedError(K))}}}}e.AsyncEmitter=$;var G;(function(N){async function F(W){return typeof Promise.allSettled=="function"?R(W):O(W)}N.allSettled=F;async function R(W){return Promise.allSettled(W)}async function O(W){return Promise.all(W.map(U=>U.then(q=>({status:"fulfilled",value:q}),q=>({status:"rejected",reason:q}))))}async function k(W){let U;const q=await Promise.all(W.map(K=>K.then(H=>H,H=>{U||(U=H)})));if(typeof U!="undefined")throw U;return q}N.settled=k})(G=e.Promises||(e.Promises={}))}),define(J[111],Z([0,1,23,29,8,36,9]),function(z,e,m,L,A,S,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function n(){return Object.create(null)}e.getEmptyExpression=n;const w="**",p="/",i="[/\\\\]",I="[^/\\\\]",P=/\//g;function y(R){switch(R){case 0:return"";case 1:return`${I}*?`;default:return`(?:${i}|${I}+${i}|${i}${I}+)*?`}}function g(R,O){if(!R)return[];const k=[];let W=!1,U=!1,q="";for(const K of R){switch(K){case O:if(!W&&!U){k.push(q),q="";continue}break;case"{":W=!0;break;case"}":W=!1;break;case"[":U=!0;break;case"]":U=!1;break}q+=K}return q&&k.push(q),k}e.splitGlobAware=g;function v(R){if(!R)return"";let O="";const k=g(R,p);if(k.every(W=>W===w))O=".*";else{let W=!1;k.forEach((U,q)=>{if(U===w){W||(O+=y(2),W=!0);return}let K=!1,H="",x=!1,ne="";for(const re of U){if(re!=="}"&&K){H+=re;continue}if(x&&(re!=="]"||!ne)){let se;re==="-"?se=re:(re==="^"||re==="!")&&!ne?se="^":re===p?se="":se=m.escapeRegExpCharacters(re),ne+=se;continue}switch(re){case"{":K=!0;continue;case"[":x=!0;continue;case"}":O+=`(?:${g(H,",").map(oe=>v(oe)).join("|")})`,K=!1,H="";break;case"]":O+="["+ne+"]",x=!1,ne="";break;case"?":O+=I;continue;case"*":O+=y(1);continue;default:O+=m.escapeRegExpCharacters(re)}}q<k.length-1&&(k[q+1]!==w||q+2<k.length)&&(O+=i),W=!1})}return O}const D=/^\*\*\/\*\.[\w\.-]+$/,b=/^\*\*\/([\w\.-]+)\/?$/,l=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,u=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,c=/^\*\*((\/[\w\.-]+)+)\/?$/,a=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new S.LRUCache(1e4),r=function(){return!1},s=function(){return null};function o(R,O){if(!R)return s;let k;typeof R!="string"?k=R.pattern:k=R,k=k.trim();const W=`${k}_${!!O.trimForExclusions}`;let U=t.get(W);if(U)return h(U,R);let q;if(D.test(k)){const K=k.substr(4);U=function(H,x){return typeof H=="string"&&H.endsWith(K)?k:null}}else(q=b.exec(f(k,O)))?U=d(q[1],k):(O.trimForExclusions?u:l).test(k)?U=M(k,O):(q=c.exec(f(k,O)))?U=T(q[1].substr(1),k,!0):(q=a.exec(f(k,O)))?U=T(q[1],k,!1):U=C(k);return t.set(W,U),h(U,R)}function h(R,O){return typeof O=="string"?R:function(k,W){return L.isEqualOrParent(k,O.base)?R(A.relative(O.base,k),W):null}}function f(R,O){return O.trimForExclusions&&R.endsWith("/**")?R.substr(0,R.length-2):R}function d(R,O){const k=`/${R}`,W=`\\${R}`,U=function(K,H){return typeof K!="string"?null:H?H===R?O:null:K===R||K.endsWith(k)||K.endsWith(W)?O:null},q=[R];return U.basenames=q,U.patterns=[O],U.allBasenames=q,U}function M(R,O){const k=F(R.slice(1,-1).split(",").map(H=>o(H,O)).filter(H=>H!==s),R),W=k.length;if(!W)return s;if(W===1)return k[0];const U=function(H,x){for(let ne=0,re=k.length;ne<re;ne++)if(k[ne](H,x))return R;return null},q=k.find(H=>!!H.allBasenames);q&&(U.allBasenames=q.allBasenames);const K=k.reduce((H,x)=>x.allPaths?H.concat(x.allPaths):H,[]);return K.length&&(U.allPaths=K),U}function T(R,O,k){const W=A.sep===A.posix.sep,U=W?R:R.replace(P,A.sep),q=A.sep+U,K=A.posix.sep+R,H=k?function(x,ne){return typeof x=="string"&&(x===U||x.endsWith(q)||!W&&(x===R||x.endsWith(K)))?O:null}:function(x,ne){return typeof x=="string"&&(x===U||!W&&x===R)?O:null};return H.allPaths=[(k?"*/":"./")+R],H}function C(R){try{const O=new RegExp(`^${v(R)}$`);return function(k){return O.lastIndex=0,typeof k=="string"&&O.test(k)?R:null}}catch(O){return s}}function V(R,O,k){return!R||typeof O!="string"?!1:Q(R)(O,void 0,k)}e.match=V;function Q(R,O={}){if(!R)return r;if(typeof R=="string"||X(R)){const k=o(R,O);if(k===s)return r;const W=function(U,q){return!!k(U,q)};return k.allBasenames&&(W.allBasenames=k.allBasenames),k.allPaths&&(W.allPaths=k.allPaths),W}return G(R,O)}e.parse=Q;function te(R){if(!R)return;let O;return k=>(O||(O=(R()||Promise.resolve([])).then(W=>W?Y(W):{})),O.then(W=>!!W[k]))}e.hasSiblingPromiseFn=te;function B(R){if(!R)return;let O;return k=>{if(!O){const W=R();O=W?Y(W):{}}return!!O[k]}}e.hasSiblingFn=B;function Y(R){const O={};for(const k of R)O[k]=!0;return O}function X(R){const O=R;return O&&typeof O.base=="string"&&typeof O.pattern=="string"}e.isRelativePattern=X;function _(R){return R.allBasenames||[]}e.getBasenameTerms=_;function $(R){return R.allPaths||[]}e.getPathTerms=$;function G(R,O){const k=F(Object.getOwnPropertyNames(R).map(H=>N(H,R[H],O)).filter(H=>H!==s)),W=k.length;if(!W)return s;if(!k.some(H=>!!H.requiresSiblings)){if(W===1)return k[0];const H=function(re,se){for(let le=0,oe=k.length;le<oe;le++){const ue=k[le](re,se);if(ue)return ue}return null},x=k.find(re=>!!re.allBasenames);x&&(H.allBasenames=x.allBasenames);const ne=k.reduce((re,se)=>se.allPaths?re.concat(se.allPaths):re,[]);return ne.length&&(H.allPaths=ne),H}const U=function(H,x,ne){let re;for(let se=0,le=k.length;se<le;se++){const oe=k[se];oe.requiresSiblings&&ne&&(x||(x=A.basename(H)),re||(re=x.substr(0,x.length-A.extname(H).length)));const ue=oe(H,x,re,ne);if(ue)return ue}return null},q=k.find(H=>!!H.allBasenames);q&&(U.allBasenames=q.allBasenames);const K=k.reduce((H,x)=>x.allPaths?H.concat(x.allPaths):H,[]);return K.length&&(U.allPaths=K),U}function N(R,O,k){if(O===!1)return s;const W=o(R,k);if(W===s)return s;if(typeof O=="boolean")return W;if(O){const U=O.when;if(typeof U=="string"){const q=(K,H,x,ne)=>{if(!ne||!W(K,H))return null;const re=U.replace("$(basename)",x),se=ne(re);return E.isThenable(se)?se.then(le=>le?R:null):se?R:null};return q.requiresSiblings=!0,q}}return W}function F(R,O){const k=R.filter(H=>!!H.basenames);if(k.length<2)return R;const W=k.reduce((H,x)=>{const ne=x.basenames;return ne?H.concat(ne):H},[]);let U;if(O){U=[];for(let H=0,x=W.length;H<x;H++)U.push(O)}else U=k.reduce((H,x)=>{const ne=x.patterns;return ne?H.concat(ne):H},[]);const q=function(H,x){if(typeof H!="string")return null;if(!x){let re;for(re=H.length;re>0;re--){const se=H.charCodeAt(re-1);if(se===47||se===92)break}x=H.substr(re)}const ne=W.indexOf(x);return ne!==-1?U[ne]:null};q.basenames=W,q.patterns=U,q.allBasenames=W;const K=R.filter(H=>!H.basenames);return K.push(q),K}}),define(J[39],Z([0,1,7,8,23,10,3,15,29]),function(z,e,m,L,A,S,E,n,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function p(o,h,f){if(typeof o=="string"&&(o=m.URI.file(o)),f){const M=f.getWorkspaceFolder(o);if(M){const T=f.getWorkspace().folders.length>1;let C;if(n.isEqual(M.uri,o)?C="":C=n.relativePath(M.uri,o),T){const V=M.name?M.name:n.basename(M.uri);C=C?V+" \u2022 "+C:V}return C}}if(o.scheme!==S.Schemas.file&&o.scheme!==S.Schemas.untitled)return o.with({query:null,fragment:null}).toString(!0);if(w.hasDriveLetter(o.fsPath))return L.normalize(I(o.fsPath));let d=L.normalize(o.fsPath);return!E.isWindows&&(h==null?void 0:h.userHome)&&(d=y(d,h.userHome.fsPath)),d}e.getPathLabel=p;function i(o){if(!o)return;typeof o=="string"&&(o=m.URI.file(o));const h=n.basename(o)||(o.scheme===S.Schemas.file?o.fsPath:o.path);return E.isWindows&&w.isRootOrDriveLetter(h)?I(h):h}e.getBaseLabel=i;function I(o){return w.hasDriveLetter(o)?o.charAt(0).toUpperCase()+o.slice(1):o}e.normalizeDriveLetter=I;let P=Object.create(null);function y(o,h){if(E.isWindows||!o||!h)return o;let f=P.original===h?P.normalized:void 0;return f||(f=`${A.rtrim(h,L.posix.sep)}${L.posix.sep}`,P={original:h,normalized:f}),(E.isLinux?o.startsWith(f):A.startsWithIgnoreCase(o,f))&&(o=`~/${o.substr(f.length)}`),o}e.tildify=y;function g(o,h){return o.replace(/^~($|\/|\\)/,`${h}$1`)}e.untildify=g;const v="\u2026",D="\\\\",b="~";function l(o,h=L.sep){const f=new Array(o.length);let d=!1;for(let M=0;M<o.length;M++){let T=o[M];if(T===""){f[M]=`.${h}`;continue}if(!T){f[M]=T;continue}d=!0;let C="";T.indexOf(D)===0?(C=T.substr(0,T.indexOf(D)+D.length),T=T.substr(T.indexOf(D)+D.length)):T.indexOf(h)===0?(C=T.substr(0,T.indexOf(h)+h.length),T=T.substr(T.indexOf(h)+h.length)):T.indexOf(b)===0&&(C=T.substr(0,T.indexOf(b)+b.length),T=T.substr(T.indexOf(b)+b.length));const V=T.split(h);for(let Q=1;d&&Q<=V.length;Q++)for(let te=V.length-Q;d&&te>=0;te--){d=!1;let B=V.slice(te,te+Q).join(h);for(let Y=0;!d&&Y<o.length;Y++)if(Y!==M&&o[Y]&&o[Y].indexOf(B)>-1){const X=te+Q===V.length,_=te>0&&o[Y].indexOf(h)>-1?h+B:B,$=o[Y].endsWith(_);d=!X||$}if(!d){let Y="";(V[0].endsWith(":")||C!=="")&&(te===1&&(te=0,Q++,B=V[0]+h+B),te>0&&(Y=V[0]+h),Y=C+Y),te>0&&(Y=Y+v+h),Y=Y+B,te+Q<V.length&&(Y=Y+h+v),f[M]=Y}}d&&(f[M]=T)}return f}e.shorten=l;var u;(function(o){o[o.TEXT=0]="TEXT",o[o.VARIABLE=1]="VARIABLE",o[o.SEPARATOR=2]="SEPARATOR"})(u||(u={}));function c(o,h=Object.create(null)){const f=[];let d=!1,M="";for(const T of o)if(T==="$"||d&&T==="{")M&&f.push({value:M,type:u.TEXT}),M="",d=!0;else if(T==="}"&&d){const C=h[M];if(typeof C=="string")C.length&&f.push({value:C,type:u.VARIABLE});else if(C){const V=f[f.length-1];(!V||V.type!==u.SEPARATOR)&&f.push({value:C.label,type:u.SEPARATOR})}M="",d=!1}else M+=T;return M&&!d&&f.push({value:M,type:u.TEXT}),f.filter((T,C)=>{if(T.type===u.SEPARATOR){const V=f[C-1],Q=f[C+1];return[V,Q].every(te=>te&&(te.type===u.VARIABLE||te.type===u.TEXT)&&te.value.length>0)}return!0}).map(T=>T.value).join("")}e.template=c;function a(o,h){return E.isMacintosh||h?o.replace(/\(&&\w\)|&&/g,"").replace(/&/g,E.isMacintosh?"&":"&&"):o.replace(/&&|&/g,f=>f==="&"?"&&":"&")}e.mnemonicMenuLabel=a;function t(o,h){return E.isMacintosh||h?o.replace(/\(&&\w\)|&&/g,""):E.isWindows?o.replace(/&&|&/g,f=>f==="&"?"&&":"&"):o.replace(/&&/g,"_")}e.mnemonicButtonLabel=t;function r(o){return o.replace(/&/g,"&&")}e.unmnemonicLabel=r;function s(o){const h=o.indexOf("/")!==-1?L.posix:L.win32,f=h.basename(o),d=h.dirname(o);return f.length?{name:f,parentPath:d}:{name:d,parentPath:""}}e.splitName=s}),define(J[27],Z([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const m=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function L(w){return m.test(w)}e.isUUID=L;const A=new Uint8Array(16),S=[];for(let w=0;w<256;w++)S.push(w.toString(16).padStart(2,"0"));let E;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?E=crypto.getRandomValues.bind(crypto):E=function(w){for(let p=0;p<w.length;p++)w[p]=Math.floor(Math.random()*256);return w};function n(){E(A),A[6]=A[6]&15|64,A[8]=A[8]&63|128;let w=0,p="";return p+=S[A[w++]],p+=S[A[w++]],p+=S[A[w++]],p+=S[A[w++]],p+="-",p+=S[A[w++]],p+=S[A[w++]],p+="-",p+=S[A[w++]],p+=S[A[w++]],p+="-",p+=S[A[w++]],p+=S[A[w++]],p+="-",p+=S[A[w++]],p+=S[A[w++]],p+=S[A[w++]],p+=S[A[w++]],p+=S[A[w++]],p+=S[A[w++]],p}e.generateUuid=n}),define(J[112],Z([0,1,30,58,42]),function(z,e,m,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checksum=void 0;async function S(E,n){if(await new Promise((i,I)=>{const P=m.createReadStream(E),y=L.createHash("sha1");P.pipe(y);const g=A.once((v,D)=>{P.removeAllListeners(),y.removeAllListeners(),v?I(v):i(D)});P.once("error",g),P.once("end",g),y.once("error",g),y.once("data",v=>g(void 0,v.toString("hex")))})!==n)throw new Error("Hash mismatch")}e.checksum=S}),define(J[81],Z([0,1,237]),function(z,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class L{constructor(S="utf8"){this.stringDecoder=new m.StringDecoder(S),this.remaining=null}write(S){const E=[],n=this.remaining?this.remaining+this.stringDecoder.write(S):this.stringDecoder.write(S);if(n.length<1)return E;let w=0,p,i=w;for(;i<n.length;)if(p=n.charCodeAt(i),p===13||p===10){if(E.push(n.substring(w,i)),i++,i<n.length){const I=p;p=n.charCodeAt(i),(I===13&&p===10||I===10&&p===13)&&i++}w=i}else i++;return this.remaining=w<n.length?n.substr(w):null,E}end(){return this.remaining}}e.LineDecoder=L}),define(J[113],Z([0,1,26]),function(z,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const L=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function A(n){const w=n.replace(/\-/g,":").toLowerCase();return!L.has(w)}function S(){return new Promise(async(n,w)=>{const p=setTimeout(()=>w("Unable to retrieve mac address (timeout after 10s)"),1e4);try{n(await E())}catch(i){w(i)}finally{clearTimeout(p)}})}e.getMac=S;function E(){return new Promise((n,w)=>{try{const p=m.networkInterfaces();for(let i in p){const I=p[i];if(I){for(const{mac:P}of I)if(A(P))return n(P)}}w("Unable to retrieve mac address (unexpected format)")}catch(p){w(p)}})}}),define(J[66],Z([0,1,19,27,26,36,113]),function(z,e,m,L,A,S,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{_isVirtualMachineMacAdress(i){return this._virtualMachineOUIs||(this._virtualMachineOUIs=S.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(i)}value(){if(this._value===void 0){let i=0,I=0;const P=A.networkInterfaces();for(let y in P){const g=P[y];if(g)for(const{mac:v,internal:D}of g)D||(I+=1,this._isVirtualMachineMacAdress(v.toUpperCase())&&(i+=1))}this._value=I>0?i/I:0}return this._value}};let n;async function w(){return n||(n=(async()=>await p()||L.generateUuid())()),n}e.getMachineId=w;async function p(){try{const i=await new Promise((P,y)=>{z(["crypto"],P,y)}),I=await E.getMac();return i.createHash("sha256").update(I,"utf8").digest("hex")}catch(i){m.onUnexpectedError(i);return}}}),define(J[17],Z([0,1,30,26,114,8,9,3,29,27,65,15,7]),function(z,e,m,L,A,S,E,n,w,p,i,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var y;(function(_){_[_.UNLINK=0]="UNLINK",_[_.MOVE=1]="MOVE"})(y=e.RimRafMode||(e.RimRafMode={}));async function g(_,$=y.UNLINK){if(w.isRootOrDriveLetter(_))throw new Error("rimraf - will refuse to recursively delete root");return $===y.UNLINK?D(_):v(_)}async function v(_){try{const $=S.join(L.tmpdir(),p.generateUuid());try{await e.Promises.rename(_,$)}catch(G){return D(_)}D($).catch(G=>{})}catch($){if($.code!=="ENOENT")throw $}}async function D(_){return e.Promises.rmdir(_,{recursive:!0,maxRetries:3})}function b(_){if(w.isRootOrDriveLetter(_))throw new Error("rimraf - will refuse to recursively delete root");m.rmdirSync(_,{recursive:!0})}e.rimrafSync=b;async function l(_,$){return a(await($?u(_):A.promisify(m.readdir)(_)))}async function u(_){try{return await A.promisify(m.readdir)(_,{withFileTypes:!0})}catch(N){console.warn("[node.js fs] readdir with filetypes failed with error: ",N)}const $=[],G=await l(_);for(const N of G){let F=!1,R=!1,O=!1;try{const k=await e.Promises.lstat(S.join(_,N));F=k.isFile(),R=k.isDirectory(),O=k.isSymbolicLink()}catch(k){console.warn("[node.js fs] unexpected error from lstat after readdir: ",k)}$.push({name:N,isFile:()=>F,isDirectory:()=>R,isSymbolicLink:()=>O})}return $}function c(_){return a(m.readdirSync(_))}e.readdirSync=c;function a(_){return _.map($=>typeof $=="string"?n.isMacintosh?i.normalizeNFC($):$:($.name=n.isMacintosh?i.normalizeNFC($.name):$.name,$))}async function t(_){const $=await l(_),G=[];for(const N of $)await s.existsDirectory(S.join(_,N))&&G.push(N);return G}function r(_,$=1e3){return new Promise(G=>{let N=!1;const F=setInterval(()=>{N||(N=!0,m.access(_,R=>{N=!1,R&&(clearInterval(F),G(void 0))}))},$)})}e.whenDeleted=r;var s;(function(_){async function $(F){let R;try{if(R=await e.Promises.lstat(F),!R.isSymbolicLink())return{stat:R}}catch(O){}try{return{stat:await e.Promises.stat(F),symbolicLink:(R==null?void 0:R.isSymbolicLink())?{dangling:!1}:void 0}}catch(O){if(O.code==="ENOENT"&&R)return{stat:R,symbolicLink:{dangling:!0}};if(n.isWindows&&O.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(F)),symbolicLink:{dangling:!1}}}catch(k){if(k.code==="ENOENT"&&R)return{stat:R,symbolicLink:{dangling:!0}};throw k}throw O}}_.stat=$;async function G(F){try{const{stat:R,symbolicLink:O}=await _.stat(F);return R.isFile()&&(O==null?void 0:O.dangling)!==!0}catch(R){}return!1}_.existsFile=G;async function N(F){try{const{stat:R,symbolicLink:O}=await _.stat(F);return R.isDirectory()&&(O==null?void 0:O.dangling)!==!0}catch(R){}return!1}_.existsDirectory=N})(s=e.SymlinkSupport||(e.SymlinkSupport={}));const o=new E.ResourceQueue;function h(_,$,G){return o.queueFor(P.URI.file(_),I.extUriBiasedIgnorePathCase).queue(()=>{const N=T(G);return new Promise((F,R)=>d(_,$,N,O=>O?R(O):F()))})}let f=!0;function d(_,$,G,N){if(!f)return m.writeFile(_,$,{mode:G.mode,flag:G.flag},N);m.open(_,G.flag,G.mode,(F,R)=>{if(F)return N(F);m.writeFile(R,$,O=>{if(O)return m.close(R,()=>N(O));m.fdatasync(R,k=>(k&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",k),f=!1),m.close(R,W=>N(W))))})})}function M(_,$,G){const N=T(G);if(!f)return m.writeFileSync(_,$,{mode:N.mode,flag:N.flag});const F=m.openSync(_,N.flag,N.mode);try{m.writeFileSync(F,$);try{m.fdatasyncSync(F)}catch(R){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",R),f=!1}}finally{m.closeSync(F)}}e.writeFileSync=M;function T(_){return _?{mode:typeof _.mode=="number"?_.mode:438,flag:typeof _.flag=="string"?_.flag:"w"}:{mode:438,flag:"w"}}async function C(_,$){if(_===$)return;async function G(N){try{const F=await e.Promises.lstat(N);if(F.isDirectory()||F.isSymbolicLink())return;await e.Promises.utimes(N,F.atime,new Date)}catch(F){}}try{await e.Promises.rename(_,$),await G($)}catch(N){if(_.toLowerCase()!==$.toLowerCase()&&N.code==="EXDEV"||_.endsWith("."))await V(_,$,{preserveSymlinks:!1}),await g(_,y.MOVE),await G($);else throw N}}async function V(_,$,G){return te(_,$,{root:{source:_,target:$},options:G,handledSourcePaths:new Set})}const Q=511;async function te(_,$,G){if(G.handledSourcePaths.has(_))return;G.handledSourcePaths.add(_);const{stat:N,symbolicLink:F}=await s.stat(_);if(F){if(G.options.preserveSymlinks)try{return await X(_,$,G)}catch(R){console.warn("[node.js fs] copy of symlink failed: ",R)}if(F.dangling)return}return N.isDirectory()?B(_,$,N.mode&Q,G):Y(_,$,N.mode&Q)}async function B(_,$,G,N){await e.Promises.mkdir($,{recursive:!0,mode:G});const F=await l(_);for(const R of F)await te(S.join(_,R),S.join($,R),N)}async function Y(_,$,G){await e.Promises.copyFile(_,$),await e.Promises.chmod($,G)}async function X(_,$,G){let N=await e.Promises.readlink(_);w.isEqualOrParent(N,G.root.source,!n.isLinux)&&(N=S.join(G.root.target,N.substr(G.root.source.length+1))),await e.Promises.symlink(N,$)}e.Promises=new class{get access(){return A.promisify(m.access)}get stat(){return A.promisify(m.stat)}get lstat(){return A.promisify(m.lstat)}get utimes(){return A.promisify(m.utimes)}get read(){return A.promisify(m.read)}get readFile(){return A.promisify(m.readFile)}get write(){return A.promisify(m.write)}get appendFile(){return A.promisify(m.appendFile)}get fdatasync(){return A.promisify(m.fdatasync)}get truncate(){return A.promisify(m.truncate)}get rename(){return A.promisify(m.rename)}get copyFile(){return A.promisify(m.copyFile)}get open(){return A.promisify(m.open)}get close(){return A.promisify(m.close)}get symlink(){return A.promisify(m.symlink)}get readlink(){return A.promisify(m.readlink)}get chmod(){return A.promisify(m.chmod)}get mkdir(){return A.promisify(m.mkdir)}get unlink(){return A.promisify(m.unlink)}get rmdir(){return A.promisify(m.rmdir)}get realpath(){return A.promisify(m.realpath)}async exists(_){try{return await e.Promises.access(_),!0}catch($){return!1}}get readdir(){return l}get readDirsInDir(){return t}get writeFile(){return h}get rm(){return g}get move(){return C}get copy(){return V}}}),define(J[82],Z([0,1,30,23,8,17]),function(z,e,m,L,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcaseSync=void 0;function E(i){const I=A.dirname(i);if(i===I)return i;const P=(A.basename(i)||i).toLowerCase();try{const g=S.readdirSync(I).filter(v=>v.toLowerCase()===P);if(g.length===1){const v=E(I);if(v)return A.join(v,g[0])}else if(g.length>1){const v=g.indexOf(P);if(v>=0){const D=E(I);if(D)return A.join(D,g[v])}}}catch(y){}return null}e.realcaseSync=E;async function n(i){try{return await S.Promises.realpath(i)}catch(I){const P=p(i);return await S.Promises.access(P,m.constants.R_OK),P}}e.realpath=n;function w(i){try{return m.realpathSync(i)}catch(I){const P=p(i);return m.accessSync(P,m.constants.R_OK),P}}e.realpathSync=w;function p(i){return L.rtrim(A.normalize(i),A.sep)}}),define(J[115],Z([0,1,59]),function(z,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.findFreePort=void 0;function L(n,w,p){let i=!1;return new Promise(I=>{const P=setTimeout(()=>{if(!i)return i=!0,I(0)},p);A(n,w,y=>{if(!i)return i=!0,clearTimeout(P),I(y)})})}e.findFreePort=L;function A(n,w,p){if(w===0)return p(0);const i=new m.Socket;i.once("connect",()=>(E(i),A(n+1,w-1,p))),i.once("data",()=>{}),i.once("error",I=>(E(i),I.code!=="ECONNREFUSED"?A(n+1,w-1,p):p(n))),i.connect(n,"127.0.0.1")}function S(n,w,p){let i=!1,I,P=1;const y=m.createServer({pauseOnConnect:!0});function g(v,D){i||(i=!0,y.removeAllListeners(),y.close(),I&&clearTimeout(I),D(v))}return new Promise(v=>{I=setTimeout(()=>{g(0,v)},p),y.on("listening",()=>{g(n,v)}),y.on("error",D=>{D&&(D.code==="EADDRINUSE"||D.code==="EACCES")&&P<w?(n++,P++,y.listen(n,"127.0.0.1")):g(0,v)}),y.on("close",()=>{g(0,v)}),y.listen(n,"127.0.0.1")})}e.findFreePortFaster=S;function E(n){try{n.removeAllListeners("connect"),n.removeAllListeners("error"),n.end(),n.destroy(),n.unref()}catch(w){console.error(w)}}});var Oe=this&&this.__await||function(z){return this instanceof Oe?(this.v=z,this):new Oe(z)},yt=this&&this.__asyncGenerator||function(z,e,m){if(!Symbol.asyncIterator)throw new TypeError("Symbol.asyncIterator is not defined.");var L=m.apply(z,e||[]),A,S=[];return A={},E("next"),E("throw"),E("return"),A[Symbol.asyncIterator]=function(){return this},A;function E(P){L[P]&&(A[P]=function(y){return new Promise(function(g,v){S.push([P,y,g,v])>1||n(P,y)})})}function n(P,y){try{w(L[P](y))}catch(g){I(S[0][3],g)}}function w(P){P.value instanceof Oe?Promise.resolve(P.value.v).then(p,i):I(S[0][2],P)}function p(P){n("next",P)}function i(P){n("throw",P)}function I(P,y){P(y),S.shift(),S.length&&n(S[0][0],S[0][1])}},St=this&&this.__asyncValues||function(z){if(!Symbol.asyncIterator)throw new TypeError("Symbol.asyncIterator is not defined.");var e=z[Symbol.asyncIterator],m;return e?e.call(z):(z=typeof __values=="function"?__values(z):z[Symbol.iterator](),m={},L("next"),L("throw"),L("return"),m[Symbol.asyncIterator]=function(){return this},m);function L(S){m[S]=z[S]&&function(E){return new Promise(function(n,w){E=z[S](E),A(n,w,E.done,E.value)})}}function A(S,E,n,w){Promise.resolve(w).then(function(p){S({value:p,done:n})},E)}};define(J[116],Z([0,1,17,26,8]),function(z,e,m,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const S=/^\d+$/,E=/^Microsoft.PowerShell_.*/,n=/^Microsoft.PowerShellPreview_.*/;var w;(function(c){c[c.x64=0]="x64",c[c.x86=1]="x86",c[c.ARM=2]="ARM"})(w||(w={}));let p;switch(process.arch){case"ia32":case"x32":p=1;break;case"arm":case"arm64":p=2;break;default:p=0;break}let i;process.env.PROCESSOR_ARCHITEW6432?i=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?i=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?i=1:i=0;class I{constructor(a,t,r){this.exePath=a,this.displayName=t,this.knownToExist=r}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await m.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function P({useAlternateBitness:c=!1}={}){return c?p===0?process.env["ProgramFiles(x86)"]||null:i===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function y({useAlternateBitness:c=!1,findPreview:a=!1}={}){const t=P({useAlternateBitness:c});if(!t)return null;const r=A.join(t,"PowerShell");if(!await m.SymlinkSupport.existsDirectory(r))return null;let s=-1,o=null;for(const d of await m.Promises.readdir(r)){let M=-1;if(a){const C=d.indexOf("-");if(C<0)continue;const V=d.substring(0,C);if(!S.test(V)||d.substring(C+1)!=="preview")continue;M=parseInt(V,10)}else{if(!S.test(d))continue;M=parseInt(d,10)}if(M<=s)continue;const T=A.join(r,d,"pwsh.exe");!await m.SymlinkSupport.existsFile(T)||(o=T,s=M)}if(!o)return null;const h=t.includes("x86")?" (x86)":"",f=a?" Preview":"";return new I(o,`PowerShell${f}${h}`,!0)}async function g({findPreview:c}={}){if(!process.env.LOCALAPPDATA)return null;const a=A.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await m.SymlinkSupport.existsDirectory(a))return null;const{pwshMsixDirRegex:t,pwshMsixName:r}=c?{pwshMsixDirRegex:n,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:E,pwshMsixName:"PowerShell (Store)"};for(const s of await m.Promises.readdir(a))if(t.test(s)){const o=A.join(a,s,"pwsh.exe");return new I(o,r)}return null}function v(){const c=A.join(L.homedir(),".dotnet","tools","pwsh.exe");return new I(c,".NET Core PowerShell Global Tool")}function D(){const c=A.join(process.env.windir,p===1&&i!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new I(c,"Windows PowerShell",!0)}function b(){return yt(this,arguments,function*(){let a=yield Oe(y());a&&(yield yield Oe(a)),a=yield Oe(y({useAlternateBitness:!0})),a&&(yield yield Oe(a)),a=yield Oe(g()),a&&(yield yield Oe(a)),a=v(),a&&(yield yield Oe(a)),a=yield Oe(y({findPreview:!0})),a&&(yield yield Oe(a)),a=yield Oe(g({findPreview:!0})),a&&(yield yield Oe(a)),a=yield Oe(y({useAlternateBitness:!0,findPreview:!0})),a&&(yield yield Oe(a)),a=D(),a&&(yield yield Oe(a))})}function l(){return yt(this,arguments,function*(){var a,t;try{for(var r=St(b()),s;s=yield Oe(r.next()),!s.done;){const o=s.value;(yield Oe(o.exists()))&&(yield yield Oe(o))}}catch(o){a={error:o}}finally{try{s&&!s.done&&(t=r.return)&&(yield Oe(t.call(r)))}finally{if(a)throw a.error}}})}e.enumeratePowerShellInstallations=l;async function u(){var c,a;try{for(var t=St(l()),r;r=await t.next(),!r.done;)return r.value}catch(s){c={error:s}}finally{try{r&&!r.done&&(a=t.return)&&await a.call(t)}finally{if(c)throw c.error}}return null}e.getFirstAvailablePowerShellInstallation=u}),define(J[83],Z([0,1,40,10]),function(z,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function A(E){return new Promise((n,w)=>{let p;const i=new Map;function I(y,g,v,D,b){const l=i.get(g);if(y===E||l){const u={name:P(v),cmd:v,pid:y,ppid:g,load:D,mem:b};i.set(y,u),y===E&&(p=u),l&&(l.children||(l.children=[]),l.children.push(u),l.children.length>1&&(l.children=l.children.sort((c,a)=>c.pid-a.pid)))}}function P(y){const g=/--disable-blink-features=Auxclick/,v=/\\watcher\\win32\\CodeHelper\.exe/,D=/--crashes-directory/,b=/\\pipe\\winpty-control/,l=/conhost\.exe/,u=/--type=([a-zA-Z-]+)/;if(v.exec(y))return"watcherService ";if(D.exec(y))return"electron-crash-reporter";if(b.exec(y))return"winpty-process";if(l.exec(y))return"console-window-host (Windows internal process)";let c=u.exec(y);if(c&&c.length===2)return c[1]==="renderer"?g.exec(y)?"shared-process":"window":c[1];const a=/[a-zA-Z-]+\.js/g;let t="";do c=a.exec(y),c&&(t+=c+" ");while(c);return t&&y.indexOf("node ")<0&&y.indexOf("node.exe")<0?`electron_node ${t}`:y}if(process.platform==="win32"){const y=g=>g.indexOf("\\\\?\\")===0||g.indexOf("\\??\\")===0?g.substr(4):g.indexOf('"\\\\?\\')===0||g.indexOf('"\\??\\')===0?'"'+g.substr(5):g;new Promise((g,v)=>{z(["windows-process-tree"],g,v)}).then(g=>{g.getProcessList(E,v=>{g.getProcessCpuUsage(v,D=>{const b=new Map;D.forEach(l=>{const u=y(l.commandLine||"");b.set(l.pid,{name:P(u),cmd:u,pid:l.pid,ppid:l.ppid,load:l.cpu||0,mem:l.memory||0})}),p=b.get(E),p?(b.forEach(l=>{const u=b.get(l.ppid);u&&(u.children||(u.children=[]),u.children.push(l))}),b.forEach(l=>{l.children&&(l.children=l.children.sort((u,c)=>u.pid-c.pid))}),n(p)):w(new Error(`Root process ${E} not found`))})},g.ProcessDataFlag.CommandLine|g.ProcessDataFlag.Memory)})}else{let y=function(){let g=[p];const v=[];for(;g.length;){const b=g.shift();b&&(v.push(b.pid),b.children&&(g=g.concat(b.children)))}let D=JSON.stringify(L.FileAccess.asFileUri("vs/base/node/cpuUsage.sh",z).fsPath);D+=" "+v.join(" "),m.exec(D,{},(b,l,u)=>{if(b||u)w(b||new Error(u.toString()));else{const c=l.toString().split(`
`);for(let a=0;a<v.length;a++){const t=i.get(v[a]);t.load=parseFloat(c[a])}if(!p){w(new Error(`Root process ${E} not found`));return}n(p)}})};m.exec("which ps",{},(g,v,D)=>{if(g||D)if(process.platform!=="linux")w(g||new Error(D.toString()));else{const b=JSON.stringify(L.FileAccess.asFileUri("vs/base/node/ps.sh",z).fsPath);m.exec(b,{},(l,u,c)=>{l||c?w(l||new Error(c.toString())):(S(u,I),y())})}else{const b=v.toString().trim(),l="-ax -o pid=,ppid=,pcpu=,pmem=,command=";m.exec(`${b} ${l}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(u,c,a)=>{u||a&&!a.includes("screen size is bogus")?w(u||new Error(a.toString())):(S(c,I),process.platform==="linux"?y():p?n(p):w(new Error(`Root process ${E} not found`)))})}})}})}e.listProcesses=A;function S(E,n){const w=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,p=E.toString().split(`
`);for(const i of p){const I=w.exec(i.trim());I&&I.length===6&&n(parseInt(I[1]),parseInt(I[2]),I[5],parseFloat(I[3]),parseFloat(I[4]))}}}),define(J[117],Z([0,1,8,30,3,65,2,17]),function(z,e,m,L,A,S,E,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CHANGE_BUFFER_DELAY=e.watchFolder=e.watchFile=void 0;function w(I,P,y){return i({path:I,isDirectory:!1},P,y)}e.watchFile=w;function p(I,P,y){return i({path:I,isDirectory:!0},P,y)}e.watchFolder=p,e.CHANGE_BUFFER_DELAY=100;function i(I,P,y){const g=m.basename(I.path),v=new Map;let D=!1,b=[E.toDisposable(()=>{v.forEach(l=>E.dispose(l)),v.clear()})];try{const l=L.watch(I.path);b.push(E.toDisposable(()=>{l.removeAllListeners(),l.close()}));const u=new Set;I.isDirectory&&n.Promises.readdir(I.path).then(c=>c.forEach(a=>u.add(a))),l.on("error",(c,a)=>{D||y(`Failed to watch ${I.path} for changes using fs.watch() (${c}, ${a})`)}),l.on("change",(c,a)=>{if(D)return;let t="";if(a&&(t=a.toString(),A.isMacintosh&&(t=S.normalizeNFC(t))),!t||c!=="change"&&c!=="rename")return;const r=I.isDirectory?m.join(I.path,t):I.path;if(I.isDirectory)if(c==="rename"){const s=v.get(r);s&&E.dispose(s);const o=setTimeout(async()=>{v.delete(r);const h=await n.Promises.exists(r);if(D)return;let f;h?u.has(t)?f="changed":(f="added",u.add(t)):(u.delete(t),f="deleted"),P(f,r)},e.CHANGE_BUFFER_DELAY);v.set(r,E.toDisposable(()=>clearTimeout(o)))}else{let s;u.has(t)?s="changed":(s="added",u.add(t)),P(s,r)}else if(c==="rename"||t!==g){const s=setTimeout(async()=>{const o=await n.Promises.exists(r);D||(o?(P("changed",r),b=[i(I,P,y)]):P("deleted",r))},e.CHANGE_BUFFER_DELAY);E.dispose(b),b=[E.toDisposable(()=>clearTimeout(s))]}else P("changed",r)})}catch(l){n.Promises.exists(I.path).then(u=>{u&&!D&&y(`Failed to watch ${I.path} for changes using fs.watch() (${l.toString()})`)})}return E.toDisposable(()=>{D=!0,b=E.dispose(b)})}}),define(J[118],Z([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_MENU_CLOSE_CHANNEL=e.CONTEXT_MENU_CHANNEL=void 0,e.CONTEXT_MENU_CHANNEL="vscode:contextmenu",e.CONTEXT_MENU_CLOSE_CHANNEL="vscode:onCloseContextMenu"}),define(J[119],Z([0,1,14,118,13]),function(z,e,m,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerContextMenuListener=void 0;function S(){m.ipcMain.on(L.CONTEXT_MENU_CHANNEL,(n,w,p,i,I)=>{const P=E(n,i,p);P.popup({window:A.withNullAsUndefined(m.BrowserWindow.fromWebContents(n.sender)),x:I?I.x:void 0,y:I?I.y:void 0,positioningItem:I?I.positioningItem:void 0,callback:()=>{P&&n.sender.send(L.CONTEXT_MENU_CLOSE_CHANNEL,w)}})})}e.registerContextMenuListener=S;function E(n,w,p){const i=new m.Menu;return p.forEach(I=>{let P;I.type==="separator"?P=new m.MenuItem({type:I.type}):Array.isArray(I.submenu)?P=new m.MenuItem({submenu:E(n,w,I.submenu),label:I.label}):P=new m.MenuItem({label:I.label,type:I.type,accelerator:I.accelerator,checked:I.checked,enabled:I.enabled,visible:I.visible,click:(y,g,v)=>n.sender.send(w,I.id,v)}),i.append(P)}),i}});var he=this&&this.__decorate||function(z,e,m,L){var A=arguments.length,S=A<3?e:L===null?L=Object.getOwnPropertyDescriptor(e,m):L,E;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")S=Reflect.decorate(z,e,m,L);else for(var n=z.length-1;n>=0;n--)(E=z[n])&&(S=(A<3?E(S):A>3?E(e,m,S):E(e,m))||S);return A>3&&S&&Object.defineProperty(e,m,S),S};define(J[33],Z([0,1,5,2,9,25,19,20,35,13,110,23,46]),function(z,e,m,L,A,S,E,n,w,p,i,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var y;(function(F){F[F.Promise=100]="Promise",F[F.PromiseCancel=101]="PromiseCancel",F[F.EventListen=102]="EventListen",F[F.EventDispose=103]="EventDispose"})(y=e.RequestType||(e.RequestType={}));function g(F){switch(F){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var v;(function(F){F[F.Initialize=200]="Initialize",F[F.PromiseSuccess=201]="PromiseSuccess",F[F.PromiseError=202]="PromiseError",F[F.PromiseErrorObj=203]="PromiseErrorObj",F[F.EventFire=204]="EventFire"})(v=e.ResponseType||(e.ResponseType={}));function D(F){switch(F){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var b;(function(F){F[F.Uninitialized=0]="Uninitialized",F[F.Idle=1]="Idle"})(b||(b={}));class l{constructor(R){this.buffer=R,this.pos=0}read(R){const O=this.buffer.slice(this.pos,this.pos+R);return this.pos+=O.byteLength,O}}class u{constructor(){this.buffers=[]}get buffer(){return n.VSBuffer.concat(this.buffers)}write(R){this.buffers.push(R)}}var c;(function(F){F[F.Undefined=0]="Undefined",F[F.String=1]="String",F[F.Buffer=2]="Buffer",F[F.VSBuffer=3]="VSBuffer",F[F.Array=4]="Array",F[F.Object=5]="Object"})(c||(c={}));function a(F){const R=n.VSBuffer.alloc(4);return R.writeUInt32BE(F,0),R}function t(F){return F.read(4).readUInt32BE(0)}function r(F){const R=n.VSBuffer.alloc(1);return R.writeUInt8(F,0),R}const s={Undefined:r(c.Undefined),String:r(c.String),Buffer:r(c.Buffer),VSBuffer:r(c.VSBuffer),Array:r(c.Array),Object:r(c.Object)},o=typeof Buffer!="undefined";function h(F,R){if(typeof R=="undefined")F.write(s.Undefined);else if(typeof R=="string"){const O=n.VSBuffer.fromString(R);F.write(s.String),F.write(a(O.byteLength)),F.write(O)}else if(o&&Buffer.isBuffer(R)){const O=n.VSBuffer.wrap(R);F.write(s.Buffer),F.write(a(O.byteLength)),F.write(O)}else if(R instanceof n.VSBuffer)F.write(s.VSBuffer),F.write(a(R.byteLength)),F.write(R);else if(Array.isArray(R)){F.write(s.Array),F.write(a(R.length));for(const O of R)h(F,O)}else{const O=n.VSBuffer.fromString(JSON.stringify(R));F.write(s.Object),F.write(a(O.byteLength)),F.write(O)}}function f(F){switch(F.read(1).readUInt8(0)){case c.Undefined:return;case c.String:return F.read(t(F)).toString();case c.Buffer:return F.read(t(F)).buffer;case c.VSBuffer:return F.read(t(F));case c.Array:{const O=t(F),k=[];for(let W=0;W<O;W++)k.push(f(F));return k}case c.Object:return JSON.parse(F.read(t(F)).toString())}}class d{constructor(R,O,k=null,W=1e3){this.protocol=R,this.ctx=O,this.logger=k,this.timeoutDelay=W,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(U=>this.onRawMessage(U)),this.sendResponse({type:200})}registerChannel(R,O){this.channels.set(R,O),setTimeout(()=>this.flushPendingRequests(R),0)}sendResponse(R){switch(R.type){case 200:{const O=this.send([R.type]);this.logger&&this.logger.logOutgoing(O,0,1,D(R.type));return}case 201:case 202:case 204:case 203:{const O=this.send([R.type,R.id],R.data);this.logger&&this.logger.logOutgoing(O,R.id,1,D(R.type),R.data);return}}}send(R,O=void 0){const k=new u;return h(k,R),h(k,O),this.sendBuffer(k.buffer)}sendBuffer(R){try{return this.protocol.send(R),R.byteLength}catch(O){return 0}}onRawMessage(R){const O=new l(R),k=f(O),W=f(O),U=k[0];switch(U){case 100:return this.logger&&this.logger.logIncoming(R.byteLength,k[1],1,`${g(U)}: ${k[2]}.${k[3]}`,W),this.onPromise({type:U,id:k[1],channelName:k[2],name:k[3],arg:W});case 102:return this.logger&&this.logger.logIncoming(R.byteLength,k[1],1,`${g(U)}: ${k[2]}.${k[3]}`,W),this.onEventListen({type:U,id:k[1],channelName:k[2],name:k[3],arg:W});case 101:return this.logger&&this.logger.logIncoming(R.byteLength,k[1],1,`${g(U)}`),this.disposeActiveRequest({type:U,id:k[1]});case 103:return this.logger&&this.logger.logIncoming(R.byteLength,k[1],1,`${g(U)}`),this.disposeActiveRequest({type:U,id:k[1]})}}onPromise(R){const O=this.channels.get(R.channelName);if(!O){this.collectPendingRequest(R);return}const k=new S.CancellationTokenSource;let W;try{W=O.call(this.ctx,R.name,R.arg,k.token)}catch(K){W=Promise.reject(K)}const U=R.id;W.then(K=>{this.sendResponse({id:U,data:K,type:201}),this.activeRequests.delete(R.id)},K=>{K instanceof Error?this.sendResponse({id:U,data:{message:K.message,name:K.name,stack:K.stack?K.stack.split?K.stack.split(`
`):K.stack:void 0},type:202}):this.sendResponse({id:U,data:K,type:203}),this.activeRequests.delete(R.id)});const q=L.toDisposable(()=>k.cancel());this.activeRequests.set(R.id,q)}onEventListen(R){const O=this.channels.get(R.channelName);if(!O){this.collectPendingRequest(R);return}const k=R.id,U=O.listen(this.ctx,R.name,R.arg)(q=>this.sendResponse({id:k,data:q,type:204}));this.activeRequests.set(R.id,U)}disposeActiveRequest(R){const O=this.activeRequests.get(R.id);O&&(O.dispose(),this.activeRequests.delete(R.id))}collectPendingRequest(R){let O=this.pendingRequests.get(R.channelName);O||(O=[],this.pendingRequests.set(R.channelName,O));const k=setTimeout(()=>{console.error(`Unknown channel: ${R.channelName}`),R.type===100&&this.sendResponse({id:R.id,data:{name:"Unknown channel",message:`Channel name '${R.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);O.push({request:R,timeoutTimer:k})}flushPendingRequests(R){const O=this.pendingRequests.get(R);if(O){for(const k of O)switch(clearTimeout(k.timeoutTimer),k.request.type){case 100:this.onPromise(k.request);break;case 102:this.onEventListen(k.request);break}this.pendingRequests.delete(R)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(R=>R.dispose()),this.activeRequests.clear()}}e.ChannelServer=d;var M;(function(F){F[F.LocalSide=0]="LocalSide",F[F.OtherSide=1]="OtherSide"})(M=e.RequestInitiator||(e.RequestInitiator={}));class T{constructor(R,O=null){this.protocol=R,this.isDisposed=!1,this.state=b.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new m.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(k=>this.onBuffer(k)),this.logger=O}getChannel(R){const O=this;return{call(k,W,U){return O.isDisposed?Promise.reject(E.canceled()):O.requestPromise(R,k,W,U)},listen(k,W){return O.isDisposed?Promise.reject(E.canceled()):O.requestEvent(R,k,W)}}}requestPromise(R,O,k,W=S.CancellationToken.None){const U=this.lastRequestId++,K={id:U,type:100,channelName:R,name:O,arg:k};if(W.isCancellationRequested)return Promise.reject(E.canceled());let H;return new Promise((ne,re)=>{if(W.isCancellationRequested)return re(E.canceled());const se=()=>{const me=Se=>{switch(Se.type){case 201:this.handlers.delete(U),ne(Se.data);break;case 202:this.handlers.delete(U);const De=new Error(Se.data.message);De.stack=Se.data.stack,De.name=Se.data.name,re(De);break;case 203:this.handlers.delete(U),re(Se.data);break}};this.handlers.set(U,me),this.sendRequest(K)};let le=null;this.state===b.Idle?se():(le=A.createCancelablePromise(me=>this.whenInitialized()),le.then(()=>{le=null,se()}));const oe=()=>{le?(le.cancel(),le=null):this.sendRequest({id:U,type:101}),re(E.canceled())},ue=W.onCancellationRequested(oe);H=L.combinedDisposable(L.toDisposable(oe),ue),this.activeRequests.add(H)}).finally(()=>{this.activeRequests.delete(H)})}requestEvent(R,O,k){const W=this.lastRequestId++,q={id:W,type:102,channelName:R,name:O,arg:k};let K=null;const H=new m.Emitter({onFirstListenerAdd:()=>{K=A.createCancelablePromise(ne=>this.whenInitialized()),K.then(()=>{K=null,this.activeRequests.add(H),this.sendRequest(q)})},onLastListenerRemove:()=>{K?(K.cancel(),K=null):(this.activeRequests.delete(H),this.sendRequest({id:W,type:103}))}}),x=ne=>H.fire(ne.data);return this.handlers.set(W,x),H.event}sendRequest(R){switch(R.type){case 100:case 102:{const O=this.send([R.type,R.id,R.channelName,R.name],R.arg);this.logger&&this.logger.logOutgoing(O,R.id,0,`${g(R.type)}: ${R.channelName}.${R.name}`,R.arg);return}case 101:case 103:{const O=this.send([R.type,R.id]);this.logger&&this.logger.logOutgoing(O,R.id,0,g(R.type));return}}}send(R,O=void 0){const k=new u;return h(k,R),h(k,O),this.sendBuffer(k.buffer)}sendBuffer(R){try{return this.protocol.send(R),R.byteLength}catch(O){return 0}}onBuffer(R){const O=new l(R),k=f(O),W=f(O),U=k[0];switch(U){case 200:return this.logger&&this.logger.logIncoming(R.byteLength,0,0,D(U)),this.onResponse({type:k[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(R.byteLength,k[1],0,D(U),W),this.onResponse({type:k[0],id:k[1],data:W})}}onResponse(R){if(R.type===200){this.state=b.Idle,this._onDidInitialize.fire();return}const O=this.handlers.get(R.id);O&&O(R)}get onDidInitializePromise(){return m.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===b.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(R=>R.dispose()),this.activeRequests.clear()}}he([P.memoize],T.prototype,"onDidInitializePromise",null),e.ChannelClient=T;class C{constructor(R){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new m.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new m.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,R(({protocol:O,onDidClientDisconnect:k})=>{m.Event.once(O.onMessage)(U=>{const q=new l(U),K=f(q),H=new d(O,K),x=new T(O);this.channels.forEach((re,se)=>H.registerChannel(se,re));const ne={channelServer:H,channelClient:x,ctx:K};this._connections.add(ne),this._onDidAddConnection.fire(ne),k(()=>{H.dispose(),x.dispose(),this._connections.delete(ne),this._onDidRemoveConnection.fire(ne)})})})}get connections(){const R=[];return this._connections.forEach(O=>R.push(O)),R}getChannel(R,O){const k=this;return{call(W,U,q){let K;if(p.isFunction(O)){let x=w.getRandomElement(k.connections.filter(O));K=x?Promise.resolve(x):m.Event.toPromise(m.Event.filter(k.onDidAddConnection,O))}else K=O.routeCall(k,W,U);const H=K.then(x=>x.channelClient.getChannel(R));return Q(H).call(W,U,q)},listen(W,U){if(p.isFunction(O))return k.getMulticastEvent(R,O,W,U);const q=O.routeEvent(k,W,U).then(K=>K.channelClient.getChannel(R));return Q(q).listen(W,U)}}}getMulticastEvent(R,O,k,W){const U=this;let q=new L.DisposableStore;const K=new m.Emitter({onFirstListenerAdd:()=>{q=new L.DisposableStore;const H=new m.EventMultiplexer,x=new Map,ne=se=>{const oe=se.channelClient.getChannel(R).listen(k,W),ue=H.add(oe);x.set(se,ue)},re=se=>{const le=x.get(se);!le||(le.dispose(),x.delete(se))};U.connections.filter(O).forEach(ne),m.Event.filter(U.onDidAddConnection,O)(ne,void 0,q),U.onDidRemoveConnection(re,void 0,q),H.event(K.fire,K,q),q.add(H)},onLastListenerRemove:()=>{q.dispose()}});return K.event}registerChannel(R,O){this.channels.set(R,O),this._connections.forEach(k=>{k.channelServer.registerChannel(R,O)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=C;class V{constructor(R,O,k=null){const W=new u;h(W,O),R.send(W.buffer),this.channelClient=new T(R,k),this.channelServer=new d(R,O,k)}getChannel(R){return this.channelClient.getChannel(R)}registerChannel(R,O){this.channelServer.registerChannel(R,O)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=V;function Q(F){return{call(R,O,k){return F.then(W=>W.call(R,O,k))},listen(R,O){const k=new m.Relay;return F.then(W=>k.input=W.listen(R,O)),k.event}}}e.getDelayedChannel=Q;function te(F){let R=!1;return{call(O,k,W){return R?F.call(O,k,W):A.timeout(0).then(()=>R=!0).then(()=>F.call(O,k,W))},listen(O,k){if(R)return F.listen(O,k);const W=new m.Relay;return A.timeout(0).then(()=>R=!0).then(()=>W.input=F.listen(O,k)),W.event}}}e.getNextTickChannel=te;class B{constructor(R){this.fn=R}routeCall(R){return this.route(R)}routeEvent(R){return this.route(R)}async route(R){for(const O of R.connections)if(await Promise.resolve(this.fn(O.ctx)))return Promise.resolve(O);return await m.Event.toPromise(R.onDidAddConnection),await this.route(R)}}e.StaticRouter=B;var Y;(function(F){function R(W,U){const q=W,K=U&&U.disableMarshalling,H=new Map;for(const x in q)k(x)&&H.set(x,m.Event.buffer(q[x],!0));return new class{listen(x,ne){const re=H.get(ne);if(re)return re;throw new Error(`Event not found: ${ne}`)}call(x,ne,re){const se=q[ne];if(typeof se=="function"){if(!K&&Array.isArray(re))for(let le=0;le<re.length;le++)re[le]=i.revive(re[le]);return se.apply(q,re)}throw new Error(`Method not found: ${ne}`)}}}F.fromService=R;function O(W,U){const q=U&&U.disableMarshalling;return new Proxy({},{get(K,H){var x;if(typeof H=="string")return((x=U==null?void 0:U.properties)===null||x===void 0?void 0:x.has(H))?U.properties.get(H):k(H)?W.listen(H):async function(...ne){let re;U&&!p.isUndefinedOrNull(U.context)?re=[U.context,...ne]:re=ne;const se=await W.call(H,re);return q?se:i.revive(se)};throw new Error(`Property not found: ${String(H)}`)}})}F.toService=O;function k(W){return W[0]==="o"&&W[1]==="n"&&I.isUpperAsciiLetter(W.charCodeAt(2))}})(Y=e.ProxyChannel||(e.ProxyChannel={}));const X=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function _(F){if(Array.isArray(F))return F;if(F&&typeof F=="object"&&typeof F.toString=="function"){let R=F.toString();if(R!=="[object Object]")return R}return F}function $(F){return Array.isArray(F)?F.map(_):_(F)}function G(F,R,O,k,W,U,q){q=$(q);const K=X[W],H=K[k%K.length];let x=[`%c[${F}]%c[${String(R).padStart(7," ")}]%c[len: ${String(O).padStart(5," ")}]%c${String(k).padStart(5," ")} - ${U}`,"color: darkgreen","color: grey","color: grey",`color: ${H}`];/\($/.test(U)?(x=x.concat(q),x.push(")")):x.push(q),console.log.apply(console,x)}e.logWithColors=G;class N{constructor(R,O){this._outgoingPrefix=R,this._incomingPrefix=O,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(R,O,k,W,U){this._totalOutgoing+=R,G(this._outgoingPrefix,this._totalOutgoing,R,O,k,W,U)}logIncoming(R,O,k,W,U){this._totalIncoming+=R,G(this._incomingPrefix,this._totalIncoming,R,O,k,W,U)}}e.IPCLogger=N}),define(J[120],Z([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Protocol=void 0;class m{constructor(A,S){this.sender=A,this.onMessage=S}send(A){try{this.sender.send("vscode:message",A.buffer)}catch(S){}}disconnect(){this.sender.send("vscode:disconnect",null)}}e.Protocol=m}),define(J[121],Z([0,1,5,33,20]),function(z,e,m,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class S{constructor(w){this.port=w,this.onMessage=m.Event.fromDOMEventEmitter(this.port,"message",p=>A.VSBuffer.wrap(p.data)),w.start()}send(w){this.port.postMessage(w.buffer)}disconnect(){this.port.close()}}e.Protocol=S;class E extends L.IPCClient{constructor(w,p){const i=new S(w);super(i,p);this.protocol=i}dispose(){this.protocol.disconnect()}}e.Client=E}),define(J[84],Z([0,1,5,33,2,20,3,32]),function(z,e,m,L,A,S,E,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=void 0;var w;(function(s){s[s.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",s[s.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(w=e.SocketCloseEventType||(e.SocketCloseEventType={}));let p=null;function i(){return p||(p=S.VSBuffer.alloc(0)),p}class I{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(o){this._chunks.push(o),this._totalLength+=o.byteLength}read(o){return this._read(o,!0)}peek(o){return this._read(o,!1)}_read(o,h){if(o===0)return i();if(o>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===o){const T=this._chunks[0];return h&&(this._chunks.shift(),this._totalLength-=o),T}if(this._chunks[0].byteLength>o){const T=this._chunks[0].slice(0,o);return h&&(this._chunks[0]=this._chunks[0].slice(o),this._totalLength-=o),T}let f=S.VSBuffer.alloc(o),d=0,M=0;for(;o>0;){const T=this._chunks[M];if(T.byteLength>o){const C=T.slice(0,o);f.set(C,d),d+=o,h&&(this._chunks[M]=T.slice(o),this._totalLength-=o),o-=o}else f.set(T,d),d+=T.byteLength,h?(this._chunks.shift(),this._totalLength-=T.byteLength):M++,o-=T.byteLength}return f}}e.ChunkStream=I;var P;(function(s){s[s.None=0]="None",s[s.Regular=1]="Regular",s[s.Control=2]="Control",s[s.Ack=3]="Ack",s[s.KeepAlive=4]="KeepAlive",s[s.Disconnect=5]="Disconnect",s[s.ReplayRequest=6]="ReplayRequest"})(P||(P={}));var y;(function(s){s[s.HeaderLength=13]="HeaderLength",s[s.AcknowledgeTime=2e3]="AcknowledgeTime",s[s.AcknowledgeTimeoutTime=2e4]="AcknowledgeTimeoutTime",s[s.KeepAliveTime=5e3]="KeepAliveTime",s[s.KeepAliveTimeoutTime=2e4]="KeepAliveTimeoutTime",s[s.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",s[s.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(y=e.ProtocolConstants||(e.ProtocolConstants={}));class g{constructor(o,h,f,d){this.type=o,this.id=h,this.ack=f,this.data=d,this.writtenTime=0}get size(){return this.data.byteLength}}class v extends A.Disposable{constructor(o){super();this._onMessage=this._register(new m.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=o,this._isDisposed=!1,this._incomingData=new I,this._register(this._socket.onData(h=>this.acceptChunk(h))),this.lastReadTime=Date.now()}acceptChunk(o){if(!(!o||o.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(o);this._incomingData.byteLength>=this._state.readLen;){const h=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=h.readUInt32BE(9),this._state.messageType=h.readUInt8(0),this._state.id=h.readUInt32BE(1),this._state.ack=h.readUInt32BE(5);else{const f=this._state.messageType,d=this._state.id,M=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._onMessage.fire(new g(f,d,M,h)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class D{constructor(o){this._isDisposed=!1,this._socket=o,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch(o){}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}write(o){if(this._isDisposed)return;o.writtenTime=Date.now(),this.lastWriteTime=Date.now();const h=S.VSBuffer.alloc(13);h.writeUInt8(o.type,0),h.writeUInt32BE(o.id,1),h.writeUInt32BE(o.ack,5),h.writeUInt32BE(o.data.byteLength,9),this._writeSoon(h,o.data)}_bufferAdd(o,h){const f=this._totalLength===0;return this._data.push(o,h),this._totalLength+=o.byteLength+h.byteLength,f}_bufferTake(){const o=S.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,o}_writeSoon(o,h){this._bufferAdd(o,h)&&E.setImmediate(()=>{this._writeNow()})}_writeNow(){this._totalLength!==0&&this._socket.write(this._bufferTake())}}class b extends A.Disposable{constructor(o){super();this._onMessage=new m.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new m.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=o,this._socketWriter=this._register(new D(this._socket)),this._socketReader=this._register(new v(this._socket)),this._register(this._socketReader.onMessage(h=>{h.type===1&&this._onMessage.fire(h.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(o){this._socketWriter.write(new g(1,0,0,o))}}e.Protocol=b;class l extends L.IPCClient{constructor(o,h,f=null){super(o,h,f);this.protocol=o}static fromSocket(o,h){return new l(new b(o),h)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const o=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),o.end()}}e.Client=l;class u{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new m.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,n.nextTick(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(o){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(o):this._emitter.fire(o):this._bufferedMessages.push(o)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=u;class c{constructor(o){this.data=o,this.next=null}}class a{constructor(){this._first=null,this._last=null}peek(){return this._first?this._first.data:null}toArray(){let o=[],h=0,f=this._first;for(;f;)o[h++]=f.data,f=f.next;return o}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(o){const h=new c(o);if(!this._first){this._first=h,this._last=h;return}this._last.next=h,this._last=h}}class t{constructor(){this.lastRuns=[];const o=Date.now();for(let h=0;h<t._HISTORY_LENGTH;h++)this.lastRuns[h]=o-1e3*h;setInterval(()=>{for(let h=t._HISTORY_LENGTH;h>=1;h--)this.lastRuns[h]=this.lastRuns[h-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return t._INSTANCE||(t._INSTANCE=new t),t._INSTANCE}load(){const o=Date.now(),h=(1+t._HISTORY_LENGTH)*1e3;let f=0;for(let d=0;d<t._HISTORY_LENGTH;d++)o-this.lastRuns[d]<=h&&f++;return 1-f/t._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}t._HISTORY_LENGTH=10,t._INSTANCE=null;class r{constructor(o,h=null){this._loadEstimator=t.getInstance(),this._onControlMessage=new u,this.onControlMessage=this._onControlMessage.event,this._onMessage=new u,this.onMessage=this._onMessage.event,this._onDidDispose=new u,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new u,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new u,this.onSocketTimeout=this._onSocketTimeout.event,this._isReconnecting=!1,this._outgoingUnackMsg=new a,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._outgoingKeepAliveTimeout=null,this._incomingKeepAliveTimeout=null,this._lastReplayRequestTime=0,this._socketDisposables=[],this._socket=o,this._socketWriter=new D(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new v(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(f=>this._receiveMessage(f))),this._socketDisposables.push(this._socket.onClose(f=>this._onSocketClose.fire(f))),h&&this._socketReader.acceptChunk(h),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._outgoingKeepAliveTimeout&&(clearTimeout(this._outgoingKeepAliveTimeout),this._outgoingKeepAliveTimeout=null),this._incomingKeepAliveTimeout&&(clearTimeout(this._incomingKeepAliveTimeout),this._incomingKeepAliveTimeout=null),this._socketDisposables=A.dispose(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const o=new g(5,0,0,i());this._socketWriter.write(o),this._socketWriter.flush()}_sendKeepAliveCheck(){if(this._outgoingKeepAliveTimeout)return;const o=Date.now()-this._socketWriter.lastWriteTime;if(o>=5e3){const h=new g(4,0,0,i());this._socketWriter.write(h),this._sendKeepAliveCheck();return}this._outgoingKeepAliveTimeout=setTimeout(()=>{this._outgoingKeepAliveTimeout=null,this._sendKeepAliveCheck()},5e3-o+5)}_recvKeepAliveCheck(){if(this._incomingKeepAliveTimeout)return;const o=Date.now()-this._socketReader.lastReadTime;if(o>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._incomingKeepAliveTimeout=setTimeout(()=>{this._incomingKeepAliveTimeout=null,this._recvKeepAliveCheck()},Math.max(2e4-o,0)+5)}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(o,h){this._isReconnecting=!0,this._socketDisposables=A.dispose(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._socket=o,this._socketWriter=new D(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new v(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(f=>this._receiveMessage(f))),this._socketDisposables.push(this._socket.onClose(f=>this._onSocketClose.fire(f))),this._socketReader.acceptChunk(h)}endAcceptReconnection(){this._isReconnecting=!1;const o=this._outgoingUnackMsg.toArray();for(let h=0,f=o.length;h<f;h++)this._socketWriter.write(o[h]);this._recvAckCheck(),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(o){if(o.ack>this._outgoingAckId){this._outgoingAckId=o.ack;do{const h=this._outgoingUnackMsg.peek();if(h&&h.id<=o.ack)this._outgoingUnackMsg.pop();else break}while(!0)}if(o.type===1){if(o.id>this._incomingMsgId)if(o.id!==this._incomingMsgId+1){const h=Date.now();h-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=h,this._socketWriter.write(new g(6,0,0,i())))}else this._incomingMsgId=o.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(o.data)}else if(o.type===2)this._onControlMessage.fire(o.data);else if(o.type===5)this._onDidDispose.fire();else if(o.type===6){const h=this._outgoingUnackMsg.toArray();for(let f=0,d=h.length;f<d;f++)this._socketWriter.write(h[f]);this._recvAckCheck()}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(o){const h=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const f=new g(1,h,this._incomingAckId,o);this._outgoingUnackMsg.push(f),this._isReconnecting||(this._socketWriter.write(f),this._recvAckCheck())}sendControl(o){const h=new g(2,0,0,o);this._socketWriter.write(h)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const o=Date.now()-this._incomingMsgLastTime;if(o>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-o+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout)return;const o=this._outgoingUnackMsg.peek(),h=Date.now()-o.writtenTime;if(h>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},Math.max(2e4-h,0)+5)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const o=new g(3,0,this._incomingAckId,i());this._socketWriter.write(o)}}e.PersistentProtocol=r}),define(J[122],Z([0,1,14,5,33,120,2,20]),function(z,e,m,L,A,S,E,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;function w(i,I){const P=L.Event.fromNodeEventEmitter(m.ipcMain,I,(g,v)=>({event:g,message:v})),y=L.Event.filter(P,({event:g})=>g.sender.id===i);return L.Event.map(y,({message:g})=>g&&n.VSBuffer.wrap(g))}class p extends A.IPCServer{constructor(){super(p.getOnDidClientConnect())}static getOnDidClientConnect(){const I=L.Event.fromNodeEventEmitter(m.ipcMain,"vscode:hello",({sender:P})=>P);return L.Event.map(I,P=>{const y=P.id,g=p.Clients.get(y);g&&g.dispose();const v=new L.Emitter;p.Clients.set(y,E.toDisposable(()=>v.fire()));const D=w(y,"vscode:message"),b=L.Event.any(L.Event.signal(w(y,"vscode:disconnect")),v.event);return{protocol:new S.Protocol(P,D),onDidClientDisconnect:b}})}}e.Server=p,p.Clients=new Map}),define(J[85],Z([0,1,14,5,27,121]),function(z,e,m,L,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.Client=void 0;class E extends S.Client{constructor(p,i){super({addEventListener:(I,P)=>p.addListener(I,P),removeEventListener:(I,P)=>p.removeListener(I,P),postMessage:I=>p.postMessage(I),start:()=>p.start(),close:()=>p.close()},i)}}e.Client=E;async function n(w){if(w.isDestroyed()||w.webContents.isDestroyed())throw new Error("ipc.mp#connect: Cannot talk to window because it is closed or destroyed");const p=A.generateUuid();w.webContents.send("vscode:createMessageChannel",p);const i=L.Event.fromNodeEventEmitter(m.ipcMain,"vscode:createMessageChannelResult",(P,y)=>({nonce:y,port:P.ports[0]})),{port:I}=await L.Event.toPromise(L.Event.once(L.Event.filter(i,P=>P.nonce===p)));return I}e.connect=n}),define(J[86],Z([0,1,2,5,9,13]),function(z,e,m,L,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageHint=void 0;var E;(function(i){i[i.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(E=e.StorageHint||(e.StorageHint={}));var n;(function(i){i[i.None=0]="None",i[i.Initialized=1]="Initialized",i[i.Closed=2]="Closed"})(n||(n={}));class w extends m.Disposable{constructor(I,P=Object.create(null)){super();this.database=I,this.options=P,this._onDidChangeStorage=this._register(new L.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=n.None,this.cache=new Map,this.flushDelayer=new A.ThrottledDelayer(w.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(I=>this.onDidChangeItemsExternal(I)))}onDidChangeItemsExternal(I){var P,y;(P=I.changed)===null||P===void 0||P.forEach((g,v)=>this.accept(v,g)),(y=I.deleted)===null||y===void 0||y.forEach(g=>this.accept(g,void 0))}accept(I,P){if(this.state===n.Closed)return;let y=!1;S.isUndefinedOrNull(P)?y=this.cache.delete(I):this.cache.get(I)!==P&&(this.cache.set(I,P),y=!0),y&&this._onDidChangeStorage.fire(I)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===n.None&&(this.state=n.Initialized,this.options.hint!==E.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(I,P){const y=this.cache.get(I);return S.isUndefinedOrNull(y)?P:y}getBoolean(I,P){const y=this.get(I);return S.isUndefinedOrNull(y)?P:y==="true"}getNumber(I,P){const y=this.get(I);return S.isUndefinedOrNull(y)?P:parseInt(y,10)}async set(I,P){if(this.state===n.Closed)return;if(S.isUndefinedOrNull(P))return this.delete(I);const y=String(P);if(this.cache.get(I)!==y)return this.cache.set(I,y),this.pendingInserts.set(I,y),this.pendingDeletes.delete(I),this._onDidChangeStorage.fire(I),this.flushDelayer.trigger(()=>this.flushPending())}async delete(I){if(!(this.state===n.Closed||!this.cache.delete(I)))return this.pendingDeletes.has(I)||this.pendingDeletes.add(I),this.pendingInserts.delete(I),this._onDidChangeStorage.fire(I),this.flushDelayer.trigger(()=>this.flushPending())}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=n.Closed;try{await this.flushDelayer.trigger(()=>this.flushPending(),0)}catch(I){}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const I={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(I).finally(()=>{var P;if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)(P=this.whenFlushedCallbacks.pop())===null||P===void 0||P()})}async whenFlushed(){if(!!this.hasPending)return new Promise(I=>this.whenFlushedCallbacks.push(I))}dispose(){this.flushDelayer.cancel(),this.flushDelayer.dispose(),super.dispose()}}e.Storage=w,w.DEFAULT_FLUSH_DELAY=100;class p{constructor(){this.onDidChangeItemsExternal=L.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(I){I.insert&&I.insert.forEach((P,y)=>this.items.set(y,P)),I.delete&&I.delete.forEach(P=>this.items.delete(P))}async close(){}}e.InMemoryStorageDatabase=p}),define(J[123],Z([0,1,5,9,36,8,17]),function(z,e,m,L,A,S,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SQLiteStorageDatabase=void 0;class n{constructor(i,I=Object.create(null)){this.path=i,this.options=I,this.name=S.basename(this.path),this.logger=new w(this.options.logging),this.whenConnected=this.connect(this.path)}get onDidChangeItemsExternal(){return m.Event.None}async getItems(){const i=await this.whenConnected,I=new Map;return(await this.all(i,"SELECT * FROM ItemTable")).forEach(y=>I.set(y.key,y.value)),this.logger.isTracing&&this.logger.trace(`[storage ${this.name}] getItems(): ${I.size} rows`),I}async updateItems(i){const I=await this.whenConnected;return this.doUpdateItems(I,i)}doUpdateItems(i,I){return this.logger.isTracing&&this.logger.trace(`[storage ${this.name}] updateItems(): insert(${I.insert?A.mapToString(I.insert):"0"}), delete(${I.delete?A.setToString(I.delete):"0"})`),this.transaction(i,()=>{const P=I.insert,y=I.delete;if(P&&P.size>0){const g=[];g.push([]);let v=0;P.forEach((D,b)=>{let l=g[v];l.length>n.MAX_HOST_PARAMETERS&&(v++,l=[],g.push(l)),l.push(b,D)}),g.forEach(D=>{this.prepare(i,`INSERT INTO ItemTable VALUES ${new Array(D.length/2).fill("(?,?)").join(",")}`,b=>b.run(D),()=>{const b=[];let l=0;return P.forEach((u,c)=>{b.push(c),l+=u.length}),`Keys: ${b.join(", ")} Length: ${l}`})})}if(y&&y.size){const g=[];g.push([]);let v=0;y.forEach(D=>{let b=g[v];b.length>n.MAX_HOST_PARAMETERS&&(v++,b=[],g.push(b)),b.push(D)}),g.forEach(D=>{this.prepare(i,`DELETE FROM ItemTable WHERE key IN (${new Array(D.length).fill("?").join(",")})`,b=>b.run(D),()=>{const b=[];return y.forEach(l=>{b.push(l)}),`Keys: ${b.join(", ")}`})})}})}async close(i){this.logger.trace(`[storage ${this.name}] close()`);const I=await this.whenConnected;return this.doClose(I,i)}doClose(i,I){return new Promise((P,y)=>{i.db.close(g=>(g&&this.handleSQLiteError(i,`[storage ${this.name}] close(): ${g}`),this.path===n.IN_MEMORY_PATH?P():!i.isErroneous&&!i.isInMemory?this.backup().then(P,v=>(this.logger.error(`[storage ${this.name}] backup(): ${v}`),P())):typeof I=="function"?E.Promises.unlink(this.path).then(()=>this.doConnect(this.path).then(v=>{const D=()=>this.doClose(v,void 0);return this.doUpdateItems(v,{insert:I()}).then(()=>D(),b=>(D(),Promise.reject(b)))})).then(P,y):y(g||new Error("Database has errors or is in-memory without recovery option"))))})}backup(){const i=this.toBackupPath(this.path);return E.Promises.copy(this.path,i,{preserveSymlinks:!1})}toBackupPath(i){return`${i}.backup`}async checkIntegrity(i){this.logger.trace(`[storage ${this.name}] checkIntegrity(full: ${i})`);const I=await this.whenConnected,P=await this.get(I,i?"PRAGMA integrity_check":"PRAGMA quick_check"),y=i?P.integrity_check:P.quick_check;return I.isErroneous?`${y} (last error: ${I.lastError})`:I.isInMemory?`${y} (in-memory!)`:y}async connect(i,I=!0){this.logger.trace(`[storage ${this.name}] open(${i}, retryOnBusy: ${I})`);try{return await this.doConnect(i)}catch(P){if(this.logger.error(`[storage ${this.name}] open(): Unable to open DB due to ${P}`),P.code==="SQLITE_BUSY"&&I)return await L.timeout(n.BUSY_OPEN_TIMEOUT),this.connect(i,!1);try{await E.Promises.unlink(i);try{await E.Promises.rename(this.toBackupPath(i),i)}catch(y){}return await this.doConnect(i)}catch(y){return this.logger.error(`[storage ${this.name}] open(): Unable to use backup due to ${y}`),this.doConnect(n.IN_MEMORY_PATH)}}}handleSQLiteError(i,I){i.isErroneous=!0,i.lastError=I,this.logger.error(I)}doConnect(i){return new Promise((I,P)=>{new Promise((y,g)=>{z(["vscode-sqlite3"],y,g)}).then(y=>{const g={db:new(this.logger.isTracing?y.verbose().Database:y.Database)(i,v=>v?g.db?g.db.close(()=>P(v)):P(v):this.exec(g,["PRAGMA user_version = 1;","CREATE TABLE IF NOT EXISTS ItemTable (key TEXT UNIQUE ON CONFLICT REPLACE, value BLOB)"].join("")).then(()=>I(g),D=>g.db.close(()=>P(D)))),isInMemory:i===n.IN_MEMORY_PATH};g.db.on("error",v=>this.handleSQLiteError(g,`[storage ${this.name}] Error (event): ${v}`)),this.logger.isTracing&&g.db.on("trace",v=>this.logger.trace(`[storage ${this.name}] Trace (event): ${v}`))},P)})}exec(i,I){return new Promise((P,y)=>{i.db.exec(I,g=>g?(this.handleSQLiteError(i,`[storage ${this.name}] exec(): ${g}`),y(g)):P())})}get(i,I){return new Promise((P,y)=>{i.db.get(I,(g,v)=>g?(this.handleSQLiteError(i,`[storage ${this.name}] get(): ${g}`),y(g)):P(v))})}all(i,I){return new Promise((P,y)=>{i.db.all(I,(g,v)=>g?(this.handleSQLiteError(i,`[storage ${this.name}] all(): ${g}`),y(g)):P(v))})}transaction(i,I){return new Promise((P,y)=>{i.db.serialize(()=>{i.db.run("BEGIN TRANSACTION"),I(),i.db.run("END TRANSACTION",g=>g?(this.handleSQLiteError(i,`[storage ${this.name}] transaction(): ${g}`),y(g)):P())})})}prepare(i,I,P,y){const g=i.db.prepare(I),v=D=>{this.handleSQLiteError(i,`[storage ${this.name}] prepare(): ${D} (${I}). Details: ${y()}`)};g.on("error",v),P(g),g.finalize(D=>{D&&v(D),g.removeListener("error",v)})}}e.SQLiteStorageDatabase=n,n.IN_MEMORY_PATH=":memory:",n.BUSY_OPEN_TIMEOUT=2e3,n.MAX_HOST_PARAMETERS=256;class w{constructor(i){i&&typeof i.logTrace=="function"&&process.env[w.VSCODE_TRACE_STORAGE]&&(this.logTrace=i.logTrace),i&&typeof i.logError=="function"&&(this.logError=i.logError)}get isTracing(){return!!this.logTrace}trace(i){this.logTrace&&this.logTrace(i)}error(i){this.logError&&this.logError(i)}}w.VSCODE_TRACE_STORAGE="VSCODE_TRACE_STORAGE"}),define(J[124],Z([12,11]),function(z,e){return z.create("vs/base/common/date",e)}),define(J[125],Z([0,1,124]),function(z,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const L=60,A=L*60,S=A*24,E=S*7,n=S*30,w=S*365;function p(I,P){typeof I!="number"&&(I=I.getTime());const y=Math.round((new Date().getTime()-I)/1e3);if(y<-30)return m.localize(0,null,p(new Date().getTime()+y*1e3,!1));if(y<30)return m.localize(1,null);let g;return y<L?(g=y,P?g===1?m.localize(2,null,g):m.localize(3,null,g):g===1?m.localize(4,null,g):m.localize(5,null,g)):y<A?(g=Math.floor(y/L),P?g===1?m.localize(6,null,g):m.localize(7,null,g):g===1?m.localize(8,null,g):m.localize(9,null,g)):y<S?(g=Math.floor(y/A),P?g===1?m.localize(10,null,g):m.localize(11,null,g):g===1?m.localize(12,null,g):m.localize(13,null,g)):y<E?(g=Math.floor(y/S),P?g===1?m.localize(14,null,g):m.localize(15,null,g):g===1?m.localize(16,null,g):m.localize(17,null,g)):y<n?(g=Math.floor(y/E),P?g===1?m.localize(18,null,g):m.localize(19,null,g):g===1?m.localize(20,null,g):m.localize(21,null,g)):y<w?(g=Math.floor(y/n),P?g===1?m.localize(22,null,g):m.localize(23,null,g):g===1?m.localize(24,null,g):m.localize(25,null,g)):(g=Math.floor(y/w),P?g===1?m.localize(26,null,g):m.localize(27,null,g):g===1?m.localize(28,null,g):m.localize(29,null,g))}e.fromNow=p;function i(I){return I.getFullYear()+"-"+String(I.getMonth()+1).padStart(2,"0")+"-"+String(I.getDate()).padStart(2,"0")+"T"+String(I.getHours()).padStart(2,"0")+":"+String(I.getMinutes()).padStart(2,"0")+":"+String(I.getSeconds()).padStart(2,"0")+"."+(I.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=i}),define(J[126],Z([12,11]),function(z,e){return z.create("vs/base/common/errorMessage",e)}),define(J[67],Z([0,1,126,13,35]),function(z,e,m,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function S(p,i){return i&&(p.stack||p.stacktrace)?m.localize(0,null,n(p),E(p.stack)||E(p.stacktrace)):n(p)}function E(p){return Array.isArray(p)?p.join(`
`):p}function n(p){return typeof p.code=="string"&&typeof p.errno=="number"&&typeof p.syscall=="string"?m.localize(1,null,p.message):p.message||m.localize(2,null)}function w(p=null,i=!1){if(!p)return m.localize(3,null);if(Array.isArray(p)){const I=A.coalesce(p),P=w(I[0],i);return I.length>1?m.localize(4,null,P,I.length):P}if(L.isString(p))return p;if(p.detail){const I=p.detail;if(I.error)return S(I.error,i);if(I.exception)return S(I.exception,i)}return p.stack?S(p,i):p.message?p.message:m.localize(5,null)}e.toErrorMessage=w}),define(J[127],Z([12,11]),function(z,e){return z.create("vs/base/common/keybindingLabels",e)}),define(J[128],Z([0,1,127]),function(z,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserSettingsLabelProvider=e.ElectronAcceleratorLabelProvider=e.AriaLabelProvider=e.UILabelProvider=e.ModifierLabelProvider=void 0;class L{constructor(E,n,w=n){this.modifierLabels=[null],this.modifierLabels[2]=E,this.modifierLabels[1]=n,this.modifierLabels[3]=w}toLabel(E,n,w){if(n.length===0)return null;const p=[];for(let i=0,I=n.length;i<I;i++){const P=n[i],y=w(P);if(y===null)return null;p[i]=A(P,y,this.modifierLabels[E])}return p.join(" ")}}e.ModifierLabelProvider=L,e.UILabelProvider=new L({ctrlKey:"\u2303",shiftKey:"\u21E7",altKey:"\u2325",metaKey:"\u2318",separator:""},{ctrlKey:m.localize(0,null),shiftKey:m.localize(1,null),altKey:m.localize(2,null),metaKey:m.localize(3,null),separator:"+"},{ctrlKey:m.localize(4,null),shiftKey:m.localize(5,null),altKey:m.localize(6,null),metaKey:m.localize(7,null),separator:"+"}),e.AriaLabelProvider=new L({ctrlKey:m.localize(8,null),shiftKey:m.localize(9,null),altKey:m.localize(10,null),metaKey:m.localize(11,null),separator:"+"},{ctrlKey:m.localize(12,null),shiftKey:m.localize(13,null),altKey:m.localize(14,null),metaKey:m.localize(15,null),separator:"+"},{ctrlKey:m.localize(16,null),shiftKey:m.localize(17,null),altKey:m.localize(18,null),metaKey:m.localize(19,null),separator:"+"}),e.ElectronAcceleratorLabelProvider=new L({ctrlKey:"Ctrl",shiftKey:"Shift",altKey:"Alt",metaKey:"Cmd",separator:"+"},{ctrlKey:"Ctrl",shiftKey:"Shift",altKey:"Alt",metaKey:"Super",separator:"+"}),e.UserSettingsLabelProvider=new L({ctrlKey:"ctrl",shiftKey:"shift",altKey:"alt",metaKey:"cmd",separator:"+"},{ctrlKey:"ctrl",shiftKey:"shift",altKey:"alt",metaKey:"win",separator:"+"},{ctrlKey:"ctrl",shiftKey:"shift",altKey:"alt",metaKey:"meta",separator:"+"});function A(S,E,n){if(E===null)return"";const w=[];return S.ctrlKey&&w.push(n.ctrlKey),S.shiftKey&&w.push(n.shiftKey),S.altKey&&w.push(n.altKey),S.metaKey&&w.push(n.metaKey),E!==""&&w.push(E),w.join(n.separator)}}),define(J[129],Z([12,11]),function(z,e){return z.create("vs/base/node/processes",e)}),define(J[68],Z([0,1,8,17,40,129,32,13,44,29,3,81,10]),function(z,e,m,L,A,S,E,n,w,p,i,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0;function y(c){switch(c){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function g(c,a){if(i.isWindows)try{const t={stdio:["pipe","pipe","ignore"]};a&&(t.cwd=a);const r=A.execFile("taskkill",["/T","/F","/PID",c.pid.toString()],t);return new Promise(s=>{r.once("error",o=>{s({success:!1,error:o})}),r.once("exit",(o,h)=>{s(o===0?{success:!0}:{success:!1,code:o!==null?o:1})})})}catch(t){return Promise.resolve({success:!1,error:t,code:t.status?y(t.status):1})}else if(i.isLinux||i.isMacintosh)try{const t=P.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",z).fsPath;return new Promise(r=>{A.execFile(t,[c.pid.toString()],{encoding:"utf8",shell:!0},(s,o,h)=>{r(s?{success:!1,error:s}:{success:!0})})})}catch(t){return Promise.resolve({success:!1,error:t})}else c.kill("SIGKILL");return Promise.resolve({success:!0})}function v(c=E.env){return c.comspec||"cmd.exe"}e.getWindowsShell=v;class D{constructor(a,t,r,s){if(t!==void 0&&r!==void 0&&s!==void 0)this.cmd=a,this.args=t,this.shell=r,this.options=s;else{const o=a;this.cmd=o.command,this.shell=o.isShellCommand,this.args=o.args.slice(0),this.options=o.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const o=Object.create(null);Object.keys(E.env).forEach(h=>{o[h]=E.env[h]}),Object.keys(this.options.env).forEach(h=>{o[h]=this.options.env[h]}),this.options.env=o}}getSanitizedCommand(){let a=this.cmd.toLowerCase();const t=a.lastIndexOf(m.sep);return t!==-1&&(a=a.substring(t+1)),D.WellKnowCommands[a]?a:"other"}start(a){return i.isWindows&&(this.options&&this.options.cwd&&p.isUNC(this.options.cwd)||!this.options&&p.isUNC(E.cwd()))?Promise.reject(new Error(S.localize(0,null))):this.useExec().then(t=>{let r,s;const o=new Promise((h,f)=>{r=h,s=f});if(t){let h=this.cmd;this.args&&(h=h+" "+this.args.join(" ")),this.childProcess=A.exec(h,this.options,(f,d,M)=>{this.childProcess=null;const T=f;T&&T.killed?s({killed:this.terminateRequested,stdout:d.toString(),stderr:M.toString()}):this.handleExec(r,a,f,d,M)})}else{let h=null;const f=d=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(d,r,a,s);const M={terminated:this.terminateRequested};n.isNumber(d)&&(M.cmdCode=d),r(M)};if(this.shell&&i.isWindows){const d=w.deepClone(this.options);d.windowsVerbatimArguments=!0,d.detached=!1;let M=!1,T=!1;const C=[];let V=this.ensureQuotes(this.cmd);C.push(V.value),M=V.quoted,this.args&&this.args.forEach(te=>{V=this.ensureQuotes(te),C.push(V.value),T=T&&V.quoted});const Q=["/s","/c"];M?T?Q.push('"'+C.join(" ")+'"'):C.length>1?Q.push('"'+C[0]+'" '+C.slice(1).join(" ")):Q.push('"'+C[0]+'"'):Q.push(C.join(" ")),h=A.spawn(v(),Q,d)}else this.cmd&&(h=A.spawn(this.cmd,this.args,this.options));h&&(this.childProcess=h,this.childProcessPromise=Promise.resolve(h),this.pidResolve&&(this.pidResolve(n.isNumber(h.pid)?h.pid:-1),this.pidResolve=void 0),h.on("error",d=>{this.childProcess=null,s({terminated:this.terminateRequested,error:d})}),h.pid&&(this.childProcess.on("close",f),this.handleSpawn(h,r,a,s,!0)))}return o})}handleClose(a,t,r,s){}ensureQuotes(a){return D.regexp.test(a)?{value:'"'+a+'"',quoted:!0}:{value:a,quoted:a.length>0&&a[0]==='"'&&a[a.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(a=>a.pid,a=>-1):new Promise(a=>{this.pidResolve=a})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(a=>(this.terminateRequested=!0,g(a,this.options.cwd).then(t=>(t.success&&(this.childProcess=null),t))),a=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(a=>{if(!this.shell||!i.isWindows)return a(!1);const t=A.spawn(v(),["/s","/c"]);t.on("error",r=>a(!0)),t.on("exit",r=>a(!1))})}}e.AbstractProcess=D,D.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},D.regexp=/^[^"].* .*[^"]/;class b extends D{constructor(a,t,r,s){super(a,t,r,s);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(a,t,r,s,o){[s,o].forEach((h,f)=>{const d=new I.LineDecoder;d.write(h).forEach(C=>{t({line:C,source:f===0?0:1})});const T=d.end();T&&t({line:T,source:f===0?0:1})}),a({terminated:this.terminateRequested,error:r})}handleSpawn(a,t,r,s,o){const h=new I.LineDecoder,f=new I.LineDecoder;a.stdout.on("data",d=>{h.write(d).forEach(T=>r({line:T,source:0}))}),a.stderr.on("data",d=>{f.write(d).forEach(T=>r({line:T,source:1}))}),this.stdoutLineDecoder=h,this.stderrLineDecoder=f}handleClose(a,t,r,s){const o=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;o&&r({line:o,source:0});const h=this.stderrLineDecoder?this.stderrLineDecoder.end():null;h&&r({line:h,source:1})}}e.LineProcess=b;function l(c){let a=[],t=!1;const r=function(s){if(t){a.push(s);return}(!c.send(s,h=>{if(h&&console.error(h),t=!1,a.length>0){const f=a.slice(0);a=[],f.forEach(d=>r(d))}})||i.isWindows)&&(t=!0)};return{send:r}}e.createQueuedSender=l;var u;(function(c){async function a(t,r,s){if(m.isAbsolute(t))return t;if(r===void 0&&(r=E.cwd()),m.dirname(t)!=="."||(s===void 0&&n.isString(E.env.PATH)&&(s=E.env.PATH.split(m.delimiter)),s===void 0||s.length===0))return m.join(r,t);async function h(f){return await L.Promises.exists(f)?!(await L.Promises.stat(f)).isDirectory():!1}for(let f of s){let d;if(m.isAbsolute(f)?d=m.join(f,t):d=m.join(r,f,t),await h(d))return d;let M=d+".com";if(await h(M)||(M=d+".exe",await h(M)))return M}return m.join(r,t)}c.findExecutable=a})(u=e.win32||(e.win32={}))}),define(J[130],Z([0,1,26,3,116,68]),function(z,e,m,L,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShellSync=e.getSystemShell=void 0;async function E(y,g){return y===1?L.isWindows?I():S.getWindowsShell(g):p(y,g)}e.getSystemShell=E;function n(y,g){return y===1?L.isWindows?P(g):S.getWindowsShell(g):p(y,g)}e.getSystemShellSync=n;let w=null;function p(y,g){if(L.isLinux&&y===2||L.isMacintosh&&y===3)return"/bin/bash";if(!w){let v;if(L.isWindows)v="/bin/bash";else{if(v=g.SHELL,!v)try{v=m.userInfo().shell}catch(D){}v||(v="sh"),v==="/bin/false"&&(v="/bin/bash")}w=v}return w}let i=null;async function I(){return i||(i=(await A.getFirstAvailablePowerShellInstallation()).exePath),i}function P(y){if(i)return i;const g=L.isWindows&&parseFloat(m.release())>=10,v=y.hasOwnProperty("PROCESSOR_ARCHITEW6432"),D=`${y.windir}\\${v?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return g?D:S.getWindowsShell(y)}}),define(J[87],Z([0,1,40,2,9,44,5,68,33,109,25,19,20,3]),function(z,e,m,L,A,S,E,n,w,p,i,I,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class g extends w.ChannelServer{constructor(b){super({send:l=>{try{process.send&&process.send(l.buffer.toString("base64"))}catch(u){}},onMessage:E.Event.fromNodeEventEmitter(process,"message",l=>P.VSBuffer.wrap(Buffer.from(l,"base64")))},b);process.once("disconnect",()=>this.dispose())}}e.Server=g;class v{constructor(b,l){this.modulePath=b,this.options=l,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new E.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const u=l&&l.timeout?l.timeout:6e4;this.disposeDelayer=new A.Delayer(u),this.child=null,this._client=null}getChannel(b){const l=this;return{call(u,c,a){return l.requestPromise(b,u,c,a)},listen(u,c){return l.requestEvent(b,u,c)}}}requestPromise(b,l,u,c=i.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(c.isCancellationRequested)return Promise.reject(I.canceled());this.disposeDelayer.cancel();const a=this.getCachedChannel(b),t=A.createCancelablePromise(o=>a.call(l,u,o)),r=c.onCancellationRequested(()=>t.cancel()),s=L.toDisposable(()=>t.cancel());return this.activeRequests.add(s),t.finally(()=>{r.dispose(),this.activeRequests.delete(s),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),t}requestEvent(b,l,u){if(!this.disposeDelayer)return E.Event.None;this.disposeDelayer.cancel();let c;const a=new E.Emitter({onFirstListenerAdd:()=>{c=this.getCachedChannel(b).listen(l,u)(a.fire,a),this.activeRequests.add(c)},onLastListenerRemove:()=>{this.activeRequests.delete(c),c.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return a.event}get client(){if(!this._client){const b=this.options&&this.options.args?this.options.args:[],l=Object.create(null);l.env=Object.assign(Object.assign({},S.deepClone(process.env)),{VSCODE_PARENT_PID:String(process.pid)}),this.options&&this.options.env&&(l.env=Object.assign(Object.assign({},l.env),this.options.env)),this.options&&this.options.freshExecArgv&&(l.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(l.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(l.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),l.execArgv===void 0&&(l.execArgv=process.execArgv.filter(h=>!/^--inspect(-brk)?=/.test(h))),y.isMacintosh&&l.env&&delete l.env.DYLD_LIBRARY_PATH,this.child=m.fork(this.modulePath,b,l);const u=new E.Emitter;E.Event.fromNodeEventEmitter(this.child,"message",h=>h)(h=>{if(p.isRemoteConsoleLog(h)){p.log(h,`IPC Library: ${this.options.serverName}`);return}u.fire(P.VSBuffer.wrap(Buffer.from(h,"base64")))});const a=this.options.useQueue?n.createQueuedSender(this.child):this.child,t=h=>this.child&&this.child.connected&&a.send(h.buffer.toString("base64")),r=u.event,s={send:t,onMessage:r};this._client=new w.ChannelClient(s);const o=()=>this.disposeClient();process.once("exit",o),this.child.on("error",h=>console.warn('IPC "'+this.options.serverName+'" errored with '+h)),this.child.on("exit",(h,f)=>{process.removeListener("exit",o),this.activeRequests.forEach(d=>L.dispose(d)),this.activeRequests.clear(),h!==0&&f!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+h+" and signal "+f),this.disposeDelayer&&this.disposeDelayer.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:h,signal:f})})}return this._client}getCachedChannel(b){let l=this.channels.get(b);return l||(l=this.client.getChannel(b),this.channels.set(b,l)),l}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}e.Client=v}),define(J[131],Z([12,11]),function(z,e){return z.create("vs/code/electron-main/app",e)}),define(J[132],Z([12,11]),function(z,e){return z.create("vs/platform/configuration/common/configurationRegistry",e)}),define(J[133],Z([12,11]),function(z,e){return z.create("vs/platform/dialogs/electron-main/dialogMainService",e)}),define(J[134],Z([12,11]),function(z,e){return z.create("vs/platform/environment/node/argv",e)}),define(J[135],Z([12,11]),function(z,e){return z.create("vs/platform/environment/node/argvHelper",e)}),define(J[136],Z([12,11]),function(z,e){return z.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(J[137],Z([12,11]),function(z,e){return z.create("vs/platform/extensions/common/extensionValidator",e)}),define(J[138],Z([12,11]),function(z,e){return z.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(J[139],Z([12,11]),function(z,e){return z.create("vs/platform/files/common/fileService",e)}),define(J[140],Z([12,11]),function(z,e){return z.create("vs/platform/files/common/files",e)}),define(J[141],Z([12,11]),function(z,e){return z.create("vs/platform/files/common/io",e)}),define(J[142],Z([12,11]),function(z,e){return z.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(J[143],Z([12,11]),function(z,e){return z.create("vs/platform/issue/electron-main/issueMainService",e)}),define(J[144],Z([12,11]),function(z,e){return z.create("vs/platform/menubar/electron-main/menubar",e)}),define(J[145],Z([12,11]),function(z,e){return z.create("vs/platform/native/electron-main/nativeHostMainService",e)}),define(J[146],Z([12,11]),function(z,e){return z.create("vs/platform/request/common/request",e)}),define(J[147],Z([12,11]),function(z,e){return z.create("vs/platform/telemetry/common/telemetryService",e)}),define(J[148],Z([12,11]),function(z,e){return z.create("vs/platform/update/common/update.config.contribution",e)}),define(J[149],Z([12,11]),function(z,e){return z.create("vs/platform/windows/electron-main/window",e)}),define(J[150],Z([12,11]),function(z,e){return z.create("vs/platform/windows/electron-main/windowsMainService",e)}),define(J[151],Z([12,11]),function(z,e){return z.create("vs/platform/workspaces/common/workspaces",e)}),define(J[152],Z([12,11]),function(z,e){return z.create("vs/platform/workspaces/electron-main/workspacesHistoryMainService",e)}),define(J[153],Z([12,11]),function(z,e){return z.create("vs/platform/workspaces/electron-main/workspacesManagementMainService",e)}),define(J[154],Z([0,1,5,2]),function(z,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostDebugChannelClient=e.ExtensionHostDebugBroadcastChannel=void 0;class A{constructor(){this._onCloseEmitter=new m.Emitter,this._onReloadEmitter=new m.Emitter,this._onTerminateEmitter=new m.Emitter,this._onAttachEmitter=new m.Emitter}call(n,w,p){switch(w){case"close":return Promise.resolve(this._onCloseEmitter.fire({sessionId:p[0]}));case"reload":return Promise.resolve(this._onReloadEmitter.fire({sessionId:p[0]}));case"terminate":return Promise.resolve(this._onTerminateEmitter.fire({sessionId:p[0]}));case"attach":return Promise.resolve(this._onAttachEmitter.fire({sessionId:p[0],port:p[1],subId:p[2]}))}throw new Error("Method not implemented.")}listen(n,w,p){switch(w){case"close":return this._onCloseEmitter.event;case"reload":return this._onReloadEmitter.event;case"terminate":return this._onTerminateEmitter.event;case"attach":return this._onAttachEmitter.event}throw new Error("Method not implemented.")}}e.ExtensionHostDebugBroadcastChannel=A,A.ChannelName="extensionhostdebugservice";class S extends L.Disposable{constructor(n){super();this.channel=n}reload(n){this.channel.call("reload",[n])}get onReload(){return this.channel.listen("reload")}close(n){this.channel.call("close",[n])}get onClose(){return this.channel.listen("close")}attachSession(n,w,p){this.channel.call("attach",[n,w,p])}get onAttachSession(){return this.channel.listen("attach")}terminateSession(n,w){this.channel.call("terminate",[n,w])}get onTerminateSession(){return this.channel.listen("terminate")}openExtensionDevelopmentHostWindow(n,w,p){return this.channel.call("openExtensionDevelopmentHostWindow",[n,w||{},p])}}e.ExtensionHostDebugChannelClient=S}),define(J[155],Z([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowDriverRegistryChannelClient=e.WindowDriverChannelClient=e.WindowDriverChannel=void 0;class m{constructor(E){this.driver=E}listen(E,n){throw new Error(`No event found: ${n}`)}call(E,n,w){switch(n){case"click":return this.driver.click(w[0],w[1],w[2]);case"doubleClick":return this.driver.doubleClick(w);case"setValue":return this.driver.setValue(w[0],w[1]);case"getTitle":return this.driver.getTitle();case"isActiveElement":return this.driver.isActiveElement(w);case"getElements":return this.driver.getElements(w[0],w[1]);case"getElementXY":return this.driver.getElementXY(w[0],w[1],w[2]);case"typeInEditor":return this.driver.typeInEditor(w[0],w[1]);case"getTerminalBuffer":return this.driver.getTerminalBuffer(w);case"writeInTerminal":return this.driver.writeInTerminal(w[0],w[1])}throw new Error(`Call not found: ${n}`)}}e.WindowDriverChannel=m;class L{constructor(E){this.channel=E}click(E,n,w){return this.channel.call("click",[E,n,w])}doubleClick(E){return this.channel.call("doubleClick",E)}setValue(E,n){return this.channel.call("setValue",[E,n])}getTitle(){return this.channel.call("getTitle")}isActiveElement(E){return this.channel.call("isActiveElement",E)}getElements(E,n){return this.channel.call("getElements",[E,n])}getElementXY(E,n,w){return this.channel.call("getElementXY",[E,n,w])}typeInEditor(E,n){return this.channel.call("typeInEditor",[E,n])}getTerminalBuffer(E){return this.channel.call("getTerminalBuffer",E)}writeInTerminal(E,n){return this.channel.call("writeInTerminal",[E,n])}}e.WindowDriverChannelClient=L;class A{constructor(E){this.channel=E}registerWindowDriver(E){return this.channel.call("registerWindowDriver",E)}reloadWindowDriver(E){return this.channel.call("reloadWindowDriver",E)}}e.WindowDriverRegistryChannelClient=A}),define(J[156],Z([0,1,8,15,46,125,10,7,32]),function(z,e,m,L,A,S,E,n,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseSearchPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=void 0;class p{constructor(g,v,D){this._args=g,this.paths=v,this.productService=D}get appRoot(){return m.dirname(E.FileAccess.asFileUri("",z).fsPath)}get userHome(){return n.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return n.URI.file(m.join(this.userDataPath,"User"))}get tmpDir(){return n.URI.file(this.paths.tmpDir)}get userRoamingDataHome(){return this.appSettingsHome}get settingsResource(){return L.joinPath(this.userRoamingDataHome,"settings.json")}get userDataSyncHome(){return L.joinPath(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const g=S.toLocalISOString(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=m.join(this.userDataPath,"logs",g)}return this.args.logsPath}get userDataSyncLogResource(){return n.URI.file(m.join(this.logsPath,"userDataSync.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return L.joinPath(n.URI.file(m.join(this.userDataPath,"Machine")),"settings.json")}get globalStorageHome(){return n.URI.joinPath(this.appSettingsHome,"globalStorage")}get workspaceStorageHome(){return n.URI.joinPath(this.appSettingsHome,"workspaceStorage")}get keybindingsResource(){return L.joinPath(this.userRoamingDataHome,"keybindings.json")}get keyboardLayoutResource(){return L.joinPath(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const g=w.env.VSCODE_PORTABLE;return g?n.URI.file(m.join(g,"argv.json")):L.joinPath(this.userHome,this.productService.dataFolderName,"argv.json")}get snippetsHome(){return L.joinPath(this.userRoamingDataHome,"snippets")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return n.URI.file(m.join(this.userDataPath,"Workspaces"))}get installSourcePath(){return m.join(this.userDataPath,"installSource")}get builtinExtensionsPath(){const g=this.args["builtin-extensions-dir"];return g?m.resolve(g):m.normalize(m.join(E.FileAccess.asFileUri("",z).fsPath,"..","extensions"))}get extensionsDownloadPath(){const g=this.args["extensions-download-dir"];return g?m.resolve(g):m.join(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const g=this.args["extensions-dir"];if(g)return m.resolve(g);const v=w.env.VSCODE_EXTENSIONS;if(v)return v;const D=w.env.VSCODE_PORTABLE;return D?m.join(D,"extensions"):L.joinPath(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const g=this.args.extensionDevelopmentPath;if(Array.isArray(g))return g.map(v=>/^[^:/?#]+?:\/\//.test(v)?n.URI.parse(v):n.URI.file(m.normalize(v)))}get extensionDevelopmentKind(){var g;return(g=this.args.extensionDevelopmentKind)===null||g===void 0?void 0:g.map(v=>v==="ui"||v==="workspace"||v==="web"?v:"workspace")}get extensionTestsLocationURI(){const g=this.args.extensionTestsPath;if(g)return/^[^:/?#]+?:\/\//.test(g)?n.URI.parse(g):n.URI.file(m.normalize(g))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const g=this.args["disable-extension"];if(g){if(typeof g=="string")return[g];if(Array.isArray(g)&&g.length>0)return g}return!1}get debugExtensionHost(){return i(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!w.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return L.joinPath(n.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get driverHandle(){return this.args.driver}get telemetryLogResource(){return n.URI.file(m.join(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get args(){return this._args}}he([A.memoize],p.prototype,"appRoot",null),he([A.memoize],p.prototype,"userHome",null),he([A.memoize],p.prototype,"userDataPath",null),he([A.memoize],p.prototype,"appSettingsHome",null),he([A.memoize],p.prototype,"tmpDir",null),he([A.memoize],p.prototype,"userRoamingDataHome",null),he([A.memoize],p.prototype,"settingsResource",null),he([A.memoize],p.prototype,"userDataSyncHome",null),he([A.memoize],p.prototype,"userDataSyncLogResource",null),he([A.memoize],p.prototype,"sync",null),he([A.memoize],p.prototype,"machineSettingsResource",null),he([A.memoize],p.prototype,"globalStorageHome",null),he([A.memoize],p.prototype,"workspaceStorageHome",null),he([A.memoize],p.prototype,"keybindingsResource",null),he([A.memoize],p.prototype,"keyboardLayoutResource",null),he([A.memoize],p.prototype,"argvResource",null),he([A.memoize],p.prototype,"snippetsHome",null),he([A.memoize],p.prototype,"isExtensionDevelopment",null),he([A.memoize],p.prototype,"untitledWorkspacesHome",null),he([A.memoize],p.prototype,"installSourcePath",null),he([A.memoize],p.prototype,"builtinExtensionsPath",null),he([A.memoize],p.prototype,"extensionsPath",null),he([A.memoize],p.prototype,"extensionDevelopmentLocationURI",null),he([A.memoize],p.prototype,"extensionDevelopmentKind",null),he([A.memoize],p.prototype,"extensionTestsLocationURI",null),he([A.memoize],p.prototype,"debugExtensionHost",null),he([A.memoize],p.prototype,"serviceMachineIdResource",null),he([A.memoize],p.prototype,"telemetryLogResource",null),he([A.memoize],p.prototype,"disableWorkspaceTrust",null),e.AbstractNativeEnvironmentService=p;function i(y,g){return P(y["inspect-extensions"],y["inspect-brk-extensions"],5870,g,y.debugId)}e.parseExtensionHostPort=i;function I(y,g){return P(y["inspect-search"],y["inspect-brk-search"],5876,g)}e.parseSearchPort=I;function P(y,g,v,D,b){const u=Number(g||y)||(D?null:v),c=u?Boolean(!!g):!1;return{port:u,break:c,debugId:b}}}),define(J[88],Z([0,1,238,134,3]),function(z,e,m,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const S={o:L.localize(0,null),e:L.localize(1,null),t:L.localize(2,null)};e.OPTIONS={diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:L.localize(3,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:L.localize(4,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:L.localize(5,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:L.localize(6,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:L.localize(7,null)},wait:{type:"boolean",cat:"o",alias:"w",description:L.localize(8,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:L.localize(9,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:L.localize(10,null)},help:{type:"boolean",cat:"o",alias:"h",description:L.localize(11,null)},"extensions-dir":{type:"string",deprecates:"extensionHomePath",cat:"e",args:"dir",description:L.localize(12,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:L.localize(13,null)},"show-versions":{type:"boolean",cat:"e",description:L.localize(14,null)},category:{type:"string",cat:"e",description:L.localize(15,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"extension-id[@version] | path-to-vsix",description:L.localize(16,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"extension-id",description:L.localize(17,null)},"enable-proposed-api":{type:"string[]",cat:"e",args:"extension-id",description:L.localize(18,null)},version:{type:"boolean",cat:"t",alias:"v",description:L.localize(19,null)},verbose:{type:"boolean",cat:"t",description:L.localize(20,null)},log:{type:"string",cat:"t",args:"level",description:L.localize(21,null)},status:{type:"boolean",alias:"s",cat:"t",description:L.localize(22,null)},"prof-startup":{type:"boolean",cat:"t",description:L.localize(23,null)},"prof-append-timers":{type:"string"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:"disableExtensions",cat:"t",description:L.localize(24,null)},"disable-extension":{type:"string[]",cat:"t",args:"extension-id",description:L.localize(25,null)},sync:{type:"string",cat:"t",description:L.localize(26,null),args:["on","off"]},"inspect-extensions":{type:"string",deprecates:"debugPluginHost",args:"port",cat:"t",description:L.localize(27,null)},"inspect-brk-extensions":{type:"string",deprecates:"debugBrkPluginHost",args:"port",cat:"t",description:L.localize(28,null)},"disable-gpu":{type:"boolean",cat:"t",description:L.localize(29,null)},"max-memory":{type:"string",cat:"t",description:L.localize(30,null),args:"memory"},telemetry:{type:"boolean",cat:"t",description:L.localize(31,null)},remote:{type:"string"},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-search":{type:"string",deprecates:"debugSearch"},"inspect-brk-search":{type:"string",deprecates:"debugBrkSearch"},"export-default-configuration":{type:"string"},"install-source":{type:"string"},driver:{type:"string"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"driver-verbose":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},__sandbox:{type:"boolean"},logsPath:{type:"string"},"no-proxy-server":{type:"boolean"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string"},"inspect-brk":{type:"string"},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},_:{type:"string[]"}};const E={onUnknownOption:()=>{},onMultipleValues:()=>{}};function n(g,v,D=E){const b={},l=[],u=[];for(let r in v){const s=v[r];s.alias&&(b[r]=s.alias),s.type==="string"||s.type==="string[]"?(l.push(r),s.deprecates&&l.push(s.deprecates)):s.type==="boolean"&&(u.push(r),s.deprecates&&u.push(s.deprecates))}const c=m(g,{string:l,boolean:u,alias:b}),a={},t=c;a._=c._.map(r=>String(r)).filter(r=>r.length>0),delete t._;for(let r in v){const s=v[r];s.alias&&delete t[s.alias];let o=t[r];s.deprecates&&t.hasOwnProperty(s.deprecates)&&(o||(o=t[s.deprecates]),delete t[s.deprecates]),typeof o!="undefined"&&(s.type==="string[]"?o&&!Array.isArray(o)&&(o=[o]):s.type==="string"&&Array.isArray(o)&&(o=o.pop(),D.onMultipleValues(r,o)),a[r]=o),delete t[r]}for(let r in t)D.onUnknownOption(r);return a}e.parseArgs=n;function w(g,v){let D="";return v.args&&(Array.isArray(v.args)?D=` <${v.args.join("> <")}>`:D=` <${v.args}>`),v.alias?`-${v.alias} --${g}${D}`:`--${g}${D}`}function p(g,v){let D=0,b=[];for(const a in g){const t=g[a],r=w(a,t);D=Math.max(D,r.length),b.push([r,t.description])}let l=D+2+1;if(v-l<25)return b.reduce((a,t)=>a.concat([`  ${t[0]}`,`      ${t[1]}`]),[]);let u=v-l-1,c=[];for(const a of b){let t=a[0],r=I(a[1],u),s=i(l-t.length-2);c.push("  "+t+s+r[0]);for(let o=1;o<r.length;o++)c.push(i(l)+r[o])}return c}e.formatOptions=p;function i(g){return" ".repeat(g)}function I(g,v){let D=[];for(;g.length;){let b=g.length<v?g.length:g.lastIndexOf(" ",v),l=g.slice(0,b).trim();g=g.slice(b),D.push(l)}return D}function P(g,v,D,b,l=!0){const u=process.stdout.isTTY&&process.stdout.columns||80;let c=[`${g} ${D}`];c.push(""),c.push(`${L.localize(32,null)}: ${v} [${L.localize(33,null)}][${L.localize(34,null)}...]`),c.push(""),l&&(A.isWindows?c.push(L.localize(35,null,v)):c.push(L.localize(36,null,v)),c.push(""));const a={};for(const t in b){const r=b[t];if(r.description&&r.cat){let s=a[r.cat];s||(a[r.cat]=s={}),s[t]=r}}for(let t in a){const r=t;let s=a[r];s&&(c.push(S[r]),c.push(...p(s,u)),c.push(""))}return c.join(`
`)}e.buildHelpMessage=P;function y(g,v){return`${g||L.localize(37,null)}
${v||L.localize(38,null)}
${process.arch}`}e.buildVersionMessage=y}),define(J[157],Z([0,1,88,59,154]),function(z,e,m,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronExtensionHostDebugBroadcastChannel=void 0;class S extends A.ExtensionHostDebugBroadcastChannel{constructor(n){super();this.windowsMainService=n}call(n,w,p){return w==="openExtensionDevelopmentHostWindow"?this.openExtensionDevelopmentHostWindow(p[0],p[1],p[2]):super.call(n,w,p)}async openExtensionDevelopmentHostWindow(n,w,p){const i=m.parseArgs(n,m.OPTIONS);i.debugRenderer=p;const I=i.extensionDevelopmentPath;if(!I)return{success:!1};let P;const y=Object.keys(w);for(let u of y){let c=w[u];c===null||(P||(P=Object.create(null)),P[u]=c)}const[g]=this.windowsMainService.openExtensionDevelopmentHostWindow(I,{context:5,cli:i,userEnv:P});if(!p)return{success:!0};const v=g.win;if(!v)return{success:!0};const D=v.webContents.debugger;let b=D.isAttached()?Infinity:0;const l=L.createServer(u=>{b++==0&&D.attach();let c=!1;const a=s=>{c||u.write(JSON.stringify(s)+"\0")},t=(s,o,h,f)=>a({method:o,params:h,sessionId:f});v.on("close",()=>{D.removeListener("message",t),u.end(),c=!0}),D.addListener("message",t);let r=Buffer.alloc(0);u.on("data",s=>{r=Buffer.concat([r,s]);for(let o=r.indexOf(0);o!==-1;o=r.indexOf(0)){let h;try{const f=r.slice(0,o).toString("utf8");r=r.slice(o+1),h=JSON.parse(f)}catch(f){console.error("error reading cdp line",f)}D.sendCommand(h.method,h.params,h.sessionId).then(f=>a({id:h.id,sessionId:h.sessionId,result:f})).catch(f=>a({id:h.id,sessionId:h.sessionId,error:{code:0,message:f.message}}))}}),u.on("error",s=>{console.error("error on cdp pipe:",s)}),u.on("close",()=>{c=!0,--b==0&&D.detach()})});return await new Promise(u=>l.listen(0,u)),v.on("close",()=>l.close()),{rendererDebugPort:l.address().port,success:!0}}}e.ElectronExtensionHostDebugBroadcastChannel=S}),function(){"use strict";function z(e,m,L,A){function S(n){const w=E(n),p=[w];return e.isAbsolute(w)||p.unshift(A),e.resolve(...p)}function E(n){const w=process.env.VSCODE_PORTABLE;if(w)return e.join(w,"user-data");const p=n["user-data-dir"];if(p)return p;let i=process.env.VSCODE_APPDATA;if(!i)switch(process.platform){case"win32":if(i=process.env.APPDATA,!i){const I=process.env.USERPROFILE;if(typeof I!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");i=e.join(I,"AppData","Roaming")}break;case"darwin":i=e.join(m.homedir(),"Library","Application Support");break;case"linux":i=process.env.XDG_CONFIG_HOME||e.join(m.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(i,L)}return{getUserDataPath:S}}if(typeof define=="function")define(J[158],Z([0,159,26,10,15,32]),function(e,m,L,A,S,E){const n=S.dirname(A.FileAccess.asFileUri("",e)),w=e.__$__nodeRequire(S.joinPath(n,"package.json").fsPath);return z(m,L,w.name,E.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("../../../../../package.json"),m=require("path"),L=require("os");module.exports=z(m,L,e.name,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(J[160],Z([0,1,26,158,156]),function(z,e,m,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class S extends A.AbstractNativeEnvironmentService{constructor(n,w){super(n,{homeDir:m.homedir(),tmpDir:m.tmpdir(),userDataDir:L.getUserDataPath(n)},w)}}e.NativeEnvironmentService=S}),define(J[161],Z([0,1,30,26,8]),function(z,e,m,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createWaitMarkerFile=void 0;function S(E){const n=A.join(L.tmpdir(),Math.random().toString(36).replace(/[^a-z]+/g,"").substr(0,10));try{return m.writeFileSync(n,""),E&&console.log(`Marker file for --wait created: ${n}`),n}catch(w){E&&console.error(`Failed to create marker file for --wait: ${w}`);return}}e.createWaitMarkerFile=S}),define(J[162],Z([0,1,137]),function(z,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const L=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,A=/^-(\d{4})(\d{2})(\d{2})$/;function S(P){return P=P.trim(),P==="*"||L.test(P)}e.isValidVersionStr=S;function E(P){if(!S(P))return null;if(P=P.trim(),P==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let y=P.match(L);return y?{hasCaret:y[1]==="^",hasGreaterEquals:y[1]===">=",majorBase:y[2]==="x"?0:parseInt(y[2],10),majorMustEqual:y[2]!=="x",minorBase:y[4]==="x"?0:parseInt(y[4],10),minorMustEqual:y[4]!=="x",patchBase:y[6]==="x"?0:parseInt(y[6],10),patchMustEqual:y[6]!=="x",preRelease:y[8]||null}:null}e.parseVersion=E;function n(P){if(!P)return null;let y=P.majorBase,g=P.majorMustEqual,v=P.minorBase,D=P.minorMustEqual,b=P.patchBase,l=P.patchMustEqual;P.hasCaret&&(y===0||(D=!1),l=!1);let u=0;if(P.preRelease){const c=A.exec(P.preRelease);if(c){const[,a,t,r]=c;u=Date.UTC(Number(a),Number(t)-1,Number(r))}}return{majorBase:y,majorMustEqual:g,minorBase:v,minorMustEqual:D,patchBase:b,patchMustEqual:l,isMinimum:P.hasGreaterEquals,notBefore:u}}e.normalizeVersion=n;function w(P,y,g){let v;typeof P=="string"?v=n(E(P)):v=P;let D;y instanceof Date?D=y.getTime():typeof y=="string"&&(D=new Date(y).getTime());let b;if(typeof g=="string"?b=n(E(g)):b=g,!v||!b)return!1;let l=v.majorBase,u=v.minorBase,c=v.patchBase,a=b.majorBase,t=b.minorBase,r=b.patchBase,s=b.notBefore,o=b.majorMustEqual,h=b.minorMustEqual,f=b.patchMustEqual;return b.isMinimum?l>a?!0:l<a?!1:u>t?!0:u<t||D&&D<s?!1:c>=r:(l===1&&a===0&&(!o||!h||!f)&&(a=1,t=0,r=0,o=!0,h=!1,f=!1),l<a?!1:l>a?!o:u<t?!1:u>t?!h:c<r?!1:c>r?!f:!(D&&D<s))}e.isValidVersion=w;function p(P,y,g,v){return g.isBuiltin||typeof g.main=="undefined"?!0:I(P,y,g.engines.vscode,v)}e.isValidExtensionVersion=p;function i(P,y,g){return P==="*"||I(y,g,P)}e.isEngineValid=i;function I(P,y,g,v=[]){let D=n(E(g));if(!D)return v.push(m.localize(0,null,g)),!1;if(D.majorBase===0){if(!D.majorMustEqual||!D.minorMustEqual)return v.push(m.localize(1,null,g)),!1}else if(!D.majorMustEqual)return v.push(m.localize(2,null,g)),!1;return w(P,y,D)?!0:(v.push(m.localize(3,null,P,g)),!1)}}),define(J[163],Z([0,1,33,87,2,10]),function(z,e,m,L,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class E extends A.Disposable{constructor(w,p,i,I){super();this.folders=w,this.onDidFilesChange=p,this.onLogMessage=i,this.verboseLogging=I,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const w=this._register(new L.Client(S.FileAccess.asFileUri("bootstrap-fork",z).fsPath,{serverName:"File Watcher (nsfw)",args:["--type=watcherService"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/nsfw/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(w.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=E.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=m.ProxyChannel.toService(m.getNextTickChannel(w.getChannel("watcher"))),this.service.setVerboseLogging(this.verboseLogging),this._register(this.service.onDidChangeFile(p=>!this.isDisposed&&this.onDidFilesChange(p))),this._register(this.service.onDidLogMessage(p=>this.onLogMessage(p))),this.setFolders(this.folders)}setVerboseLogging(w){this.verboseLogging=w,!this.isDisposed&&this.service&&this.service.setVerboseLogging(w)}error(w){this.onLogMessage({type:"error",message:`[File Watcher (nsfw)] ${w}`})}setFolders(w){this.folders=w,this.service&&this.service.setRoots(w)}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=E,E.MAX_RESTARTS=5}),define(J[164],Z([0,1,33,87,2,10]),function(z,e,m,L,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class E extends A.Disposable{constructor(w,p,i,I,P={}){super();this.folders=w,this.onDidFilesChange=p,this.onLogMessage=i,this.verboseLogging=I,this.watcherOptions=P,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const w=this._register(new L.Client(S.FileAccess.asFileUri("bootstrap-fork",z).fsPath,{serverName:"File Watcher (chokidar)",args:["--type=watcherService"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/unix/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(w.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=E.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=m.ProxyChannel.toService(m.getNextTickChannel(w.getChannel("watcher"))),this.service.init(Object.assign(Object.assign({},this.watcherOptions),{verboseLogging:this.verboseLogging})),this._register(this.service.onDidChangeFile(p=>!this.isDisposed&&this.onDidFilesChange(p))),this._register(this.service.onDidLogMessage(p=>this.onLogMessage(p))),this.service.setRoots(this.folders)}error(w){this.onLogMessage({type:"error",message:`[File Watcher (chokidar)] ${w}`})}setVerboseLogging(w){this.verboseLogging=w,this.service&&this.service.setVerboseLogging(w)}setFolders(w){this.folders=w,this.service&&this.service.setRoots(w)}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=E,E.MAX_RESTARTS=5}),define(J[165],Z([0,1,40,81,111,10]),function(z,e,m,L,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutOfProcessWin32FolderWatcher=void 0;class E{constructor(w,p,i,I,P){this.watchedFolder=w,this.eventCallback=i,this.logCallback=I,this.verboseLogging=P,this.restartCounter=0,Array.isArray(p)?this.ignored=p.map(y=>A.parse(y)):this.ignored=[],this.verboseLogging&&this.log(`Start watching: ${w}`),this.startWatcher()}startWatcher(){const w=[this.watchedFolder];this.verboseLogging&&w.push("-verbose"),this.handle=m.spawn(S.FileAccess.asFileUri("vs/platform/files/node/watcher/win32/CodeHelper.exe",z).fsPath,w);const p=new L.LineDecoder;this.handle.stdout.on("data",i=>{const I=[];p.write(i).forEach(P=>{const y=P.split("|");if(y.length===2){const g=Number(y[0]),v=y[1];if(g>=0&&g<3){if(this.ignored&&this.ignored.some(D=>D(v))){this.verboseLogging&&this.log(v);return}I.push({type:E.changeTypeMap[g],path:v})}else this.log(y[1])}}),I.length>0&&this.eventCallback(I)}),this.handle.on("error",i=>this.onError(i)),this.handle.stderr.on("data",i=>this.onError(i)),this.handle.on("exit",(i,I)=>this.onExit(i,I))}onError(w){this.error("process error: "+w.toString())}onExit(w,p){this.handle&&(this.error(`terminated unexpectedly (code: ${w}, signal: ${p})`),this.restartCounter<=E.MAX_RESTARTS?(this.error("is restarted again..."),this.restartCounter++,this.startWatcher()):this.error("Watcher failed to start after retrying for some time, giving up. Please report this as a bug report!"))}error(w){this.logCallback({type:"error",message:`[File Watcher (C#)] ${w}`})}log(w){this.logCallback({type:"trace",message:`[File Watcher (C#)] ${w}`})}dispose(){this.handle&&(this.handle.kill(),this.handle=void 0)}}e.OutOfProcessWin32FolderWatcher=E,E.MAX_RESTARTS=5,E.changeTypeMap=[0,1,2]}),define(J[166],Z([0,1,165,8,23]),function(z,e,m,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class S{constructor(n,w,p,i){this.onDidFilesChange=w,this.onLogMessage=p,this.verboseLogging=i,this.service=void 0,this.folder=n[0],this.folder.path.indexOf("\\\\")===0&&this.folder.path.endsWith(L.posix.sep)&&(this.folder.path=A.rtrim(this.folder.path,L.posix.sep)),this.service=this.startWatching()}get isDisposed(){return!this.service}startWatching(){return new m.OutOfProcessWin32FolderWatcher(this.folder.path,this.folder.excludes,n=>this.onFileEvents(n),n=>this.onLogMessage(n),this.verboseLogging)}setVerboseLogging(n){this.verboseLogging=n,this.service&&(this.service.dispose(),this.service=this.startWatching())}onFileEvents(n){this.isDisposed||n.length>0&&this.onDidFilesChange(n)}dispose(){this.service&&(this.service.dispose(),this.service=void 0)}}e.FileWatcher=S}),define(J[69],Z([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createSyncDescriptor=e.SyncDescriptor=void 0;class m{constructor(S,E=[],n=!1){this.ctor=S,this.staticArguments=E,this.supportsDelayedInstantiation=n}}e.SyncDescriptor=m;const L=(A,...S)=>new m(A,S);e.createSyncDescriptor=L}),define(J[167],Z([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class m{constructor(S){this.incoming=new Map,this.outgoing=new Map,this.data=S}}e.Node=m;class L{constructor(S){this._hashFn=S,this._nodes=new Map}roots(){const S=[];for(let E of this._nodes.values())E.outgoing.size===0&&S.push(E);return S}insertEdge(S,E){const n=this.lookupOrInsertNode(S),w=this.lookupOrInsertNode(E);n.outgoing.set(this._hashFn(E),w),w.incoming.set(this._hashFn(S),n)}removeNode(S){const E=this._hashFn(S);this._nodes.delete(E);for(let n of this._nodes.values())n.outgoing.delete(E),n.incoming.delete(E)}lookupOrInsertNode(S){const E=this._hashFn(S);let n=this._nodes.get(E);return n||(n=new m(S),this._nodes.set(E,n)),n}lookup(S){return this._nodes.get(this._hashFn(S))}isEmpty(){return this._nodes.size===0}toString(){let S=[];for(let[E,n]of this._nodes)S.push(`${E}, (incoming)[${[...n.incoming.keys()].join(", ")}], (outgoing)[${[...n.outgoing.keys()].join(",")}]`);return S.join(`
`)}findCycleSlow(){for(let[S,E]of this._nodes){const n=new Set([S]),w=this._findCycle(E,n);if(w)return w}}_findCycle(S,E){for(let[n,w]of S.outgoing){if(E.has(n))return[...E,n].join(" -> ");E.add(n);const p=this._findCycle(w,E);if(p)return p;E.delete(n)}}}e.Graph=L}),define(J[4],Z([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.optional=e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var m;(function(n){n.serviceIds=new Map,n.DI_TARGET="$di$target",n.DI_DEPENDENCIES="$di$dependencies";function w(p){return p[n.DI_DEPENDENCIES]||[]}n.getServiceDependencies=w})(m=e._util||(e._util={})),e.IInstantiationService=A("instantiationService");function L(n,w,p,i){w[m.DI_TARGET]===w?w[m.DI_DEPENDENCIES].push({id:n,index:p,optional:i}):(w[m.DI_DEPENDENCIES]=[{id:n,index:p,optional:i}],w[m.DI_TARGET]=w)}function A(n){if(m.serviceIds.has(n))return m.serviceIds.get(n);const w=function(p,i,I){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");L(w,p,I,!1)};return w.toString=()=>n,m.serviceIds.set(n,w),w}e.createDecorator=A;function S(n){return n}e.refineServiceDecorator=S;function E(n){return function(w,p,i){if(arguments.length!==3)throw new Error("@optional-decorator can only be used to decorate a parameter");L(n,w,i,!0)}}e.optional=E}),define(J[70],Z([0,1,4]),function(z,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=m.createDecorator(e.ID);function L(A){return!!A.hostName&&!!A.errorMessage}e.isRemoteDiagnosticError=L}),define(J[89],Z([0,1,4]),function(z,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EncryptionMainService=e.IEncryptionMainService=void 0,e.IEncryptionMainService=m.createDecorator("encryptionMainService");class L{constructor(S){this.machineId=S}encryption(){return new Promise((S,E)=>z(["vscode-encrypt"],S,E))}async encrypt(S){try{return(await this.encryption()).encrypt(this.machineId,S)}catch(E){return S}}async decrypt(S){try{return(await this.encryption()).decrypt(this.machineId,S)}catch(E){return S}}}e.EncryptionMainService=L}),define(J[53],Z([0,1,4]),function(z,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=m.createDecorator("environmentService"),e.INativeEnvironmentService=m.refineServiceDecorator(e.IEnvironmentService)}),define(J[168],Z([0,1,136,4,10]),function(z,e,m,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.DefaultIconPath=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.INSTALL_ERROR_INCOMPATIBLE=e.INSTALL_ERROR_MALICIOUS=e.INSTALL_ERROR_NOT_SUPPORTED=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN);function S(I){return I&&typeof I=="object"&&typeof I.id=="string"&&(!I.uuid||typeof I.uuid=="string")}e.isIExtensionIdentifier=S;var E;(function(I){I[I.NoneOrRelevance=0]="NoneOrRelevance",I[I.LastUpdatedDate=1]="LastUpdatedDate",I[I.Title=2]="Title",I[I.PublisherName=3]="PublisherName",I[I.InstallCount=4]="InstallCount",I[I.PublishedDate=5]="PublishedDate",I[I.AverageRating=6]="AverageRating",I[I.WeightedRating=12]="WeightedRating"})(E=e.SortBy||(e.SortBy={}));var n;(function(I){I[I.Default=0]="Default",I[I.Ascending=1]="Ascending",I[I.Descending=2]="Descending"})(n=e.SortOrder||(e.SortOrder={}));var w;(function(I){I.Uninstall="uninstall"})(w=e.StatisticType||(e.StatisticType={}));var p;(function(I){I[I.None=0]="None",I[I.Install=1]="Install",I[I.Update=2]="Update"})(p=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=L.createDecorator("extensionGalleryService"),e.INSTALL_ERROR_NOT_SUPPORTED="notsupported",e.INSTALL_ERROR_MALICIOUS="malicious",e.INSTALL_ERROR_INCOMPATIBLE="incompatible";class i extends Error{constructor(P,y){super(P);this.code=y}}e.ExtensionManagementError=i,e.IExtensionManagementService=L.createDecorator("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=L.createDecorator("IGlobalExtensionEnablementService"),e.IExtensionTipsService=L.createDecorator("IExtensionTipsService"),e.DefaultIconPath=A.FileAccess.asBrowserUri("./media/defaultIcon.png",z).toString(!0),e.ExtensionsLabel=m.localize(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=m.localize(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=L.createDecorator("IExtensionManagementCLIService")}),define(J[169],Z([0,1,4]),function(z,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionUrlTrustService=void 0,e.IExtensionUrlTrustService=m.createDecorator("extensionUrlTrustService")}),define(J[170],Z([0,1,23,4]),function(z,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isAuthenticaionProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkpaceSupportTypeMessage=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin";function A(i){if(typeof i=="object"&&i!==null&&i.supported!==!0)return i.description}e.getWorkpaceSupportTypeMessage=A;function S(i){return i&&typeof i=="object"&&typeof i.id=="string"&&(!i.uuid||typeof i.uuid=="string")}e.isIExtensionIdentifier=S,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var E;(function(i){i[i.System=0]="System",i[i.User=1]="User"})(E=e.ExtensionType||(e.ExtensionType={}));class n{constructor(I){this.value=I,this._lower=I.toLowerCase()}static equals(I,P){if(typeof I=="undefined"||I===null)return typeof P=="undefined"||P===null;if(typeof P=="undefined"||P===null)return!1;if(typeof I=="string"||typeof P=="string"){let y=typeof I=="string"?I:I.value,g=typeof P=="string"?P:P.value;return m.equalsIgnoreCase(y,g)}return I._lower===P._lower}static toKey(I){return typeof I=="string"?I.toLowerCase():I._lower}}e.ExtensionIdentifier=n;function w(i){return i.contributes&&i.contributes.localizations?i.contributes.localizations.length>0:!1}e.isLanguagePackExtension=w;function p(i){return i.contributes&&i.contributes.authentication?i.contributes.authentication.length>0:!1}e.isAuthenticaionProviderExtension=p,e.IBuiltinExtensionsScannerService=L.createDecorator("IBuiltinExtensionsScannerService")}),define(J[171],Z([0,1,23,170]),function(z,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function A(y,g){return y.uuid&&g.uuid?y.uuid===g.uuid:y.id===g.id?!0:m.compareIgnoreCase(y.id,g.id)===0}e.areSameExtensions=A;class S{constructor(g,v){this.version=v,this.id=g.id,this.uuid=g.uuid}key(){return`${this.id}-${this.version}`}equals(g){return g instanceof S?A(this,g)&&this.version===g.version:!1}}e.ExtensionIdentifierWithVersion=S;function E(y,g){return`${y}.${g}`}e.getExtensionId=E;function n(y){return y.toLocaleLowerCase()}e.adoptToGalleryExtensionId=n;function w(y,g){return n(E(y,g))}e.getGalleryExtensionId=w;function p(y,g){const v=[],D=b=>{for(const l of v)if(l.some(u=>A(g(u),g(b))))return l;return null};for(const b of y){const l=D(b);l?l.push(b):v.push([b])}return v}e.groupByExtension=p;function i(y){return{id:y.identifier.id,name:y.manifest.name,galleryId:null,publisherId:y.publisherId,publisherName:y.manifest.publisher,publisherDisplayName:y.publisherDisplayName,dependencies:y.manifest.extensionDependencies&&y.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=i;function I(y){return Object.assign({id:y.identifier.id,name:y.name,galleryId:y.identifier.uuid,publisherId:y.publisherId,publisherName:y.publisher,publisherDisplayName:y.publisherDisplayName,dependencies:!!(y.properties.dependencies&&y.properties.dependencies.length>0)},y.telemetryData)}e.getGalleryExtensionTelemetryData=I,e.BetterMergeId=new L.ExtensionIdentifier("pprice.better-merge");function P(y){const g=new Set;for(const v of y)v.malicious&&g.add(v.id.id);return g}e.getMaliciousExtensionsSet=P}),define(J[90],Z([0,1,4]),function(z,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=m.createDecorator("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app",e.IExternalTerminalMainService=m.createDecorator("externalTerminal")}),define(J[21],Z([0,1,140,8,7,4,23,13,36]),function(z,e,m,L,A,S,E,n,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=S.createDecorator("fileService");function p(_){return _.create===!0}e.isFileOpenForWriteOptions=p;var i;(function(_){_[_.Unknown=0]="Unknown",_[_.File=1]="File",_[_.Directory=2]="Directory",_[_.SymbolicLink=64]="SymbolicLink"})(i=e.FileType||(e.FileType={}));var I;(function(_){_[_.Readonly=1]="Readonly"})(I=e.FilePermission||(e.FilePermission={}));var P;(function(_){_[_.FileReadWrite=2]="FileReadWrite",_[_.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",_[_.FileReadStream=16]="FileReadStream",_[_.FileFolderCopy=8]="FileFolderCopy",_[_.PathCaseSensitive=1024]="PathCaseSensitive",_[_.Readonly=2048]="Readonly",_[_.Trash=4096]="Trash",_[_.FileWriteUnlock=8192]="FileWriteUnlock"})(P=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function y(_){return!!(_.capabilities&2)}e.hasReadWriteCapability=y;function g(_){return!!(_.capabilities&8)}e.hasFileFolderCopyCapability=g;function v(_){return!!(_.capabilities&4)}e.hasOpenReadWriteCloseCapability=v;function D(_){return!!(_.capabilities&16)}e.hasFileReadStreamCapability=D;var b;(function(_){_.FileExists="EntryExists",_.FileNotFound="EntryNotFound",_.FileNotADirectory="EntryNotADirectory",_.FileIsADirectory="EntryIsADirectory",_.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",_.FileTooLarge="EntryTooLarge",_.FileWriteLocked="EntryWriteLocked",_.NoPermissions="NoPermissions",_.Unavailable="Unavailable",_.Unknown="Unknown"})(b=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class l extends Error{constructor($,G){super($);this.code=G}}e.FileSystemProviderError=l;function u(_,$){const G=new l(_.toString(),$);return a(G,$),G}e.createFileSystemProviderError=u;function c(_){return _||u(m.localize(0,null),b.Unknown)}e.ensureFileSystemProviderError=c;function a(_,$){return _.name=$?`${$} (FileSystemError)`:"FileSystemError",_}e.markAsFileSystemProviderError=a;function t(_){if(!_)return b.Unknown;if(_ instanceof l)return _.code;const $=/^(.+) \(FileSystemError\)$/.exec(_.name);if(!$)return b.Unknown;switch($[1]){case b.FileExists:return b.FileExists;case b.FileIsADirectory:return b.FileIsADirectory;case b.FileNotADirectory:return b.FileNotADirectory;case b.FileNotFound:return b.FileNotFound;case b.FileExceedsMemoryLimit:return b.FileExceedsMemoryLimit;case b.FileTooLarge:return b.FileTooLarge;case b.FileWriteLocked:return b.FileWriteLocked;case b.NoPermissions:return b.NoPermissions;case b.Unavailable:return b.Unavailable}return b.Unknown}e.toFileSystemProviderErrorCode=t;function r(_){if(_ instanceof M)return _.fileOperationResult;switch(t(_)){case b.FileNotFound:return 1;case b.FileIsADirectory:return 0;case b.FileNotADirectory:return 10;case b.FileWriteLocked:return 5;case b.NoPermissions:return 6;case b.FileExists:return 4;case b.FileExceedsMemoryLimit:return 9;case b.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=r;var s;(function(_){_[_.CREATE=0]="CREATE",_[_.DELETE=1]="DELETE",_[_.MOVE=2]="MOVE",_[_.COPY=3]="COPY"})(s=e.FileOperation||(e.FileOperation={}));class o{constructor($,G,N){this.resource=$,this.operation=G,this.target=N}isOperation($){return this.operation===$}}e.FileOperationEvent=o;var h;(function(_){_[_.UPDATED=0]="UPDATED",_[_.ADDED=1]="ADDED",_[_.DELETED=2]="DELETED"})(h=e.FileChangeType||(e.FileChangeType={}));class f{constructor($,G){this.changes=$,this.added=void 0,this.updated=void 0,this.deleted=void 0;for(const N of $)switch(N.type){case 1:this.added||(this.added=w.TernarySearchTree.forUris(()=>G)),this.added.set(N.resource,N);break;case 0:this.updated||(this.updated=w.TernarySearchTree.forUris(()=>G)),this.updated.set(N.resource,N);break;case 2:this.deleted||(this.deleted=w.TernarySearchTree.forUris(()=>G)),this.deleted.set(N.resource,N);break}}contains($,...G){return this.doContains($,{includeChildren:!1},...G)}affects($,...G){return this.doContains($,{includeChildren:!0},...G)}doContains($,G,...N){var F,R,O,k,W,U;if(!$)return!1;const q=N.length>0;return!!((!q||N.includes(1))&&(((F=this.added)===null||F===void 0?void 0:F.get($))||G.includeChildren&&((R=this.added)===null||R===void 0?void 0:R.findSuperstr($)))||(!q||N.includes(0))&&(((O=this.updated)===null||O===void 0?void 0:O.get($))||G.includeChildren&&((k=this.updated)===null||k===void 0?void 0:k.findSuperstr($)))||(!q||N.includes(2))&&(((W=this.deleted)===null||W===void 0?void 0:W.findSubstr($))||G.includeChildren&&((U=this.deleted)===null||U===void 0?void 0:U.findSuperstr($))))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}get raw(){return this.changes}get rawAdded(){return this.added}get rawDeleted(){return this.deleted}}e.FileChangesEvent=f;function d(_,$,G){return!_||!$||_===$||$.length>_.length?!1:($.charAt($.length-1)!==L.sep&&($+=L.sep),G?E.startsWithIgnoreCase(_,$):_.indexOf($)===0)}e.isParent=d;class M extends Error{constructor($,G,N){super($);this.fileOperationResult=G,this.options=N}}e.FileOperationError=M;class T extends M{constructor($,G,N){super($,2,N);this.stat=G}}e.NotModifiedSinceFileOperationError=T;var C;(function(_){_[_.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",_[_.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",_[_.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",_[_.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",_[_.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",_[_.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",_[_.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",_[_.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",_[_.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",_[_.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",_[_.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",_[_.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(C=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var V;(function(_){_[_.FILE=0]="FILE",_[_.FOLDER=1]="FOLDER",_[_.ROOT_FOLDER=2]="ROOT_FOLDER"})(V=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function Q(_){if(!(typeof _.size!="number"||typeof _.mtime!="number"))return _.mtime.toString(29)+_.size.toString(31)}e.etag=Q;async function te(_,$){if(!$.canHandleResource(A.URI.from({scheme:_.scheme})))return new Promise(G=>{const N=$.onDidChangeFileSystemProviderRegistrations(F=>{F.scheme===_.scheme&&F.added&&(N.dispose(),G())})})}e.whenProviderRegistered=te,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class B{static formatSize($){return n.isNumber($)||($=0),$<B.KB?m.localize(1,null,$.toFixed(0)):$<B.MB?m.localize(2,null,($/B.KB).toFixed(2)):$<B.GB?m.localize(3,null,($/B.MB).toFixed(2)):$<B.TB?m.localize(4,null,($/B.GB).toFixed(2)):m.localize(5,null,($/B.TB).toFixed(2))}}e.ByteSize=B,B.KB=1024,B.MB=B.KB*B.KB,B.GB=B.MB*B.KB,B.TB=B.GB*B.KB;var Y;(function(_){_[_.IA32=0]="IA32",_[_.OTHER=1]="OTHER"})(Y=e.Arch||(e.Arch={}));function X(_){return{maxFileSize:_===0?300*B.MB:16*B.GB,maxHeapSize:_===0?700*B.MB:2*700*B.MB}}e.getPlatformLimits=X}),define(J[54],Z([0,1,239,135,21,88]),function(z,e,m,L,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;function E(P,y){const g={onUnknownOption:D=>{console.warn(L.localize(0,null,D))},onMultipleValues:(D,b)=>{console.warn(L.localize(1,null,D,b))}},v=S.parseArgs(P,S.OPTIONS,y?g:void 0);return v.goto&&v._.forEach(D=>m(/^(\w:)?[^:]+(:\d*){0,2}$/.test(D),L.localize(2,null))),v["max-memory"]&&m(parseInt(v["max-memory"])>=A.MIN_MAX_MEMORY_SIZE_MB,`The max-memory argument cannot be specified lower than ${A.MIN_MAX_MEMORY_SIZE_MB} MB.`),v}function n(P){const y=P.findIndex(g=>!/^-/.test(g));if(y>-1)return[...P.slice(0,y),...P.slice(y+1)]}function w(P){let[,...y]=P;process.env.VSCODE_DEV&&(y=n(y)||[]);const g=!I(process.env);return E(y,g)}e.parseMainProcessArgv=w;function p(P){const[,,...y]=P;return E(y,!0)}e.parseCLIProcessArgv=p;function i(P,...y){const g=P.indexOf("--");return g===-1?P.push(...y):P.splice(g,0,...y),P}e.addArg=i;function I(P){return P.VSCODE_CLI==="1"}e.isLaunchedFromCli=I}),define(J[91],Z([0,1,159,40,27,3,54,67,130]),function(z,e,m,L,A,S,E,n,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveShellEnv=void 0;async function p(P,y,g){return y["force-disable-user-env"]?(P.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):S.isWindows?(P.trace("resolveShellEnv(): skipped (Windows)"),{}):E.isLaunchedFromCli(g)&&!y["force-user-env"]?(P.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):(E.isLaunchedFromCli(g)?P.trace("resolveShellEnv(): running (--force-user-env)"):P.trace("resolveShellEnv(): running (macOS/Linux)"),i||(i=I(P)),i)}e.resolveShellEnv=p;let i;async function I(P){const y=new Promise(async(g,v)=>{const D=process.env.ELECTRON_RUN_AS_NODE;P.trace("getUnixShellEnvironment#runAsNode",D);const b=process.env.ELECTRON_NO_ATTACH_CONSOLE;P.trace("getUnixShellEnvironment#noAttach",b);const l=A.generateUuid().replace(/-/g,"").substr(0,12),u=new RegExp(l+"(.*)"+l),c=Object.assign(Object.assign({},process.env),{ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"});P.trace("getUnixShellEnvironment#env",c);const a=await w.getSystemShell(S.OS,c);P.trace("getUnixShellEnvironment#shell",a);const t=m.basename(a);let r,s;/^pwsh(-preview)?$/.test(t)?(r=`& '${process.execPath}' -p '''${l}'' + JSON.stringify(process.env) + ''${l}'''`,s=["-Login","-Command"]):(r=`'${process.execPath}' -p '"${l}" + JSON.stringify(process.env) + "${l}"'`,s=["-ilc"]),P.trace("getUnixShellEnvironment#spawn",JSON.stringify(s),r);const o=L.spawn(a,[...s,r],{detached:!0,stdio:["ignore","pipe","pipe"],env:c});o.on("error",d=>{P.error("getUnixShellEnvironment#errorChildProcess",n.toErrorMessage(d)),g({})});const h=[];o.stdout.on("data",d=>h.push(d));const f=[];o.stderr.on("data",d=>f.push(d)),o.on("close",(d,M)=>{const T=Buffer.concat(h).toString("utf8");P.trace("getUnixShellEnvironment#raw",T);const C=Buffer.concat(f).toString("utf8");if(C.trim()&&P.trace("getUnixShellEnvironment#stderr",C),d||M)return v(new Error(`Failed to get environment (code ${d}, signal ${M})`));const V=u.exec(T),Q=V?V[1]:"{}";try{const te=JSON.parse(Q);D?te.ELECTRON_RUN_AS_NODE=D:delete te.ELECTRON_RUN_AS_NODE,b?te.ELECTRON_NO_ATTACH_CONSOLE=b:delete te.ELECTRON_NO_ATTACH_CONSOLE,delete te.XDG_RUNTIME_DIR,P.trace("getUnixShellEnvironment#result",te),g(te)}catch(te){P.error("getUnixShellEnvironment#errorCaught",n.toErrorMessage(te)),v(te)}})});try{return await y}catch(g){return P.error("getUnixShellEnvironment#error",n.toErrorMessage(g)),{}}}}),define(J[92],Z([0,1,7,21,3]),function(z,e,m,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeFileChanges=e.toFileChanges=void 0;function S(w){return w.map(p=>({type:p.type,resource:m.URI.file(p.path)}))}e.toFileChanges=S;function E(w){const p=new n;for(const i of w)p.processEvent(i);return p.normalize()}e.normalizeFileChanges=E;class n{constructor(){this.normalized=[],this.mapPathToChange=new Map}processEvent(p){const i=this.mapPathToChange.get(p.path);if(i){const I=i.type,P=p.type;I===1&&P===2?(this.mapPathToChange.delete(p.path),this.normalized.splice(this.normalized.indexOf(i),1)):I===2&&P===1?i.type=0:I===1&&P===0||(i.type=P)}else this.normalized.push(p),this.mapPathToChange.set(p.path,p)}normalize(){const p=[],i=[];return this.normalized.filter(I=>I.type!==2?(p.push(I),!1):!0).sort((I,P)=>I.path.length-P.path.length).filter(I=>i.some(P=>L.isParent(I.path,P,!A.isLinux))?!1:(i.push(I.path),!0)).concat(p)}}}),define(J[172],Z([0,1,92,2,17,82,117,9,8]),function(z,e,m,L,A,S,E,n,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class p extends L.Disposable{constructor(I,P,y,g){super();this.path=I,this.onDidFilesChange=P,this.onLogMessage=y,this.verboseLogging=g,this.fileChangesDelayer=this._register(new n.ThrottledDelayer(E.CHANGE_BUFFER_DELAY*2)),this.fileChangesBuffer=[],this.startWatching()}setVerboseLogging(I){this.verboseLogging=I}async startWatching(){try{const{stat:I,symbolicLink:P}=await A.SymlinkSupport.stat(this.path);if(this.isDisposed)return;let y=this.path;if(P)try{y=await S.realpath(y)}catch(g){if(this.onError(g),P.dangling)return}I.isDirectory()?this._register(E.watchFolder(y,(g,v)=>{this.onFileChange({type:g==="changed"?0:g==="added"?1:2,path:w.join(this.path,w.basename(v))})},g=>this.onError(g))):this._register(E.watchFile(y,g=>{this.onFileChange({type:g==="changed"?0:2,path:this.path})},g=>this.onError(g)))}catch(I){I.code!=="ENOENT"&&this.onError(I)}}onFileChange(I){this.fileChangesBuffer.push(I),this.verboseLogging&&this.onVerbose(`${I.type===1?"[ADDED]":I.type===2?"[DELETED]":"[CHANGED]"} ${I.path}`),this.fileChangesDelayer.trigger(async()=>{const P=this.fileChangesBuffer;this.fileChangesBuffer=[];const y=m.normalizeFileChanges(P);this.verboseLogging&&y.forEach(g=>{this.onVerbose(`>> normalized ${g.type===1?"[ADDED]":g.type===2?"[DELETED]":"[CHANGED]"} ${g.path}`)}),y.length>0&&this.onDidFilesChange(y)})}onError(I){this.isDisposed||this.onLogMessage({type:"error",message:`[File Watcher (node.js)] ${I}`})}onVerbose(I){this.isDisposed||this.onLogMessage({type:"trace",message:`[File Watcher (node.js)] ${I}`})}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=p}),define(J[71],Z([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class m{constructor(...A){this._entries=new Map;for(let[S,E]of A)this.set(S,E)}set(A,S){const E=this._entries.get(A);return this._entries.set(A,S),E}has(A){return this._entries.has(A)}get(A){return this._entries.get(A)}}e.ServiceCollection=m}),define(J[173],Z([0,1,19,167,69,4,71,9]),function(z,e,m,L,A,S,E,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const w=!1;class p extends Error{constructor(g){var v;super("cyclic dependency between services");this.message=(v=g.findCycleSlow())!==null&&v!==void 0?v:`UNABLE to detect cycle, dumping graph: 
${g.toString()}`}}class i{constructor(g=new E.ServiceCollection,v=!1,D){this._activeInstantiations=new Set,this._services=g,this._strict=v,this._parent=D,this._services.set(S.IInstantiationService,this)}createChild(g){return new i(g,this._strict,this)}invokeFunction(g,...v){let D=P.traceInvocation(g),b=!1;try{return g({get:(u,c)=>{if(b)throw m.illegalState("service accessor is only valid during the invocation of its target method");const a=this._getOrCreateServiceInstance(u,D);if(!a&&c!==S.optional)throw new Error(`[invokeFunction] unknown service '${u}'`);return a}},...v)}finally{b=!0,D.stop()}}createInstance(g,...v){let D,b;return g instanceof A.SyncDescriptor?(D=P.traceCreation(g.ctor),b=this._createInstance(g.ctor,g.staticArguments.concat(v),D)):(D=P.traceCreation(g),b=this._createInstance(g,v,D)),D.stop(),b}_createInstance(g,v=[],D){let b=S._util.getServiceDependencies(g).sort((c,a)=>c.index-a.index),l=[];for(const c of b){let a=this._getOrCreateServiceInstance(c.id,D);if(!a&&this._strict&&!c.optional)throw new Error(`[createInstance] ${g.name} depends on UNKNOWN service ${c.id}.`);l.push(a)}let u=b.length>0?b[0].index:v.length;if(v.length!==u){console.warn(`[createInstance] First service dependency of ${g.name} at position ${u+1} conflicts with ${v.length} static arguments`);let c=u-v.length;c>0?v=v.concat(new Array(c)):v=v.slice(0,u)}return new g(...[...v,...l])}_setServiceInstance(g,v){if(this._services.get(g)instanceof A.SyncDescriptor)this._services.set(g,v);else if(this._parent)this._parent._setServiceInstance(g,v);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(g){let v=this._services.get(g);return!v&&this._parent?this._parent._getServiceInstanceOrDescriptor(g):v}_getOrCreateServiceInstance(g,v){let D=this._getServiceInstanceOrDescriptor(g);return D instanceof A.SyncDescriptor?this._safeCreateAndCacheServiceInstance(g,D,v.branch(g,!0)):(v.branch(g,!1),D)}_safeCreateAndCacheServiceInstance(g,v,D){if(this._activeInstantiations.has(g))throw new Error(`illegal state - RECURSIVELY instantiating service '${g}'`);this._activeInstantiations.add(g);try{return this._createAndCacheServiceInstance(g,v,D)}finally{this._activeInstantiations.delete(g)}}_createAndCacheServiceInstance(g,v,D){const b=new L.Graph(c=>c.id.toString());let l=0;const u=[{id:g,desc:v,_trace:D}];for(;u.length;){const c=u.pop();if(b.lookupOrInsertNode(c),l++>1e3)throw new p(b);for(let a of S._util.getServiceDependencies(c.desc.ctor)){let t=this._getServiceInstanceOrDescriptor(a.id);if(!t&&!a.optional&&console.warn(`[createInstance] ${g} depends on ${a.id} which is NOT registered.`),t instanceof A.SyncDescriptor){const r={id:a.id,desc:t,_trace:c._trace.branch(a.id,!0)};b.insertEdge(c,r),u.push(r)}}}for(;;){const c=b.roots();if(c.length===0){if(!b.isEmpty())throw new p(b);break}for(const{data:a}of c){if(this._getServiceInstanceOrDescriptor(a.id)instanceof A.SyncDescriptor){const r=this._createServiceInstanceWithOwner(a.id,a.desc.ctor,a.desc.staticArguments,a.desc.supportsDelayedInstantiation,a._trace);this._setServiceInstance(a.id,r)}b.removeNode(a)}}return this._getServiceInstanceOrDescriptor(g)}_createServiceInstanceWithOwner(g,v,D=[],b,l){if(this._services.get(g)instanceof A.SyncDescriptor)return this._createServiceInstance(v,D,b,l);if(this._parent)return this._parent._createServiceInstanceWithOwner(g,v,D,b,l);throw new Error(`illegalState - creating UNKNOWN service instance ${v.name}`)}_createServiceInstance(g,v=[],D,b){if(D){const l=new n.IdleValue(()=>this._createInstance(g,v,b));return new Proxy(Object.create(null),{get(u,c){if(c in u)return u[c];let a=l.value,t=a[c];return typeof t!="function"||(t=t.bind(a),u[c]=t),t},set(u,c,a){return l.value[c]=a,!0}})}else return this._createInstance(g,v,b)}}e.InstantiationService=i;var I;(function(y){y[y.Creation=0]="Creation",y[y.Invocation=1]="Invocation",y[y.Branch=2]="Branch"})(I||(I={}));class P{constructor(g,v){this.type=g,this.name=v,this._start=Date.now(),this._dep=[]}static traceInvocation(g){return w?new P(1,g.name||g.toString().substring(0,42).replace(/\n/g,"")):P._None}static traceCreation(g){return w?new P(0,g.name):P._None}branch(g,v){let D=new P(2,g.toString());return this._dep.push([g,v,D]),D}stop(){let g=Date.now()-this._start;P._totals+=g;let v=!1;function D(l,u){let c=[],a=new Array(l+1).join("	");for(const[t,r,s]of u._dep)if(r&&s){v=!0,c.push(`${a}CREATES -> ${t}`);let o=D(l+1,s);o&&c.push(o)}else c.push(`${a}uses -> ${t}`);return c.join(`
`)}let b=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${D(1,this)}`,`DONE, took ${g.toFixed(2)}ms (grand total ${P._totals.toFixed(2)}ms)`];(g>2||v)&&console.log(b.join(`
`))}}P._None=new class extends P{constructor(){super(-1,null)}stop(){}branch(){return this}},P._totals=0}),define(J[174],Z([0,1,19,128,57]),function(z,e,m,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BaseResolvedKeybinding=void 0;class S extends A.ResolvedKeybinding{constructor(n,w){super();if(w.length===0)throw m.illegalArgument("parts");this._os=n,this._parts=w}getLabel(){return L.UILabelProvider.toLabel(this._os,this._parts,n=>this._getLabel(n))}getAriaLabel(){return L.AriaLabelProvider.toLabel(this._os,this._parts,n=>this._getAriaLabel(n))}getElectronAccelerator(){return this._parts.length>1?null:L.ElectronAcceleratorLabelProvider.toLabel(this._os,this._parts,n=>this._getElectronAccelerator(n))}getUserSettingsLabel(){return L.UserSettingsLabelProvider.toLabel(this._os,this._parts,n=>this._getUserSettingsLabel(n))}isWYSIWYG(){return this._parts.every(n=>this._isWYSIWYG(n))}isChord(){return this._parts.length>1}getParts(){return this._parts.map(n=>this._getPart(n))}_getPart(n){return new A.ResolvedKeybindingPart(n.ctrlKey,n.shiftKey,n.altKey,n.metaKey,this._getLabel(n),this._getAriaLabel(n))}getDispatchParts(){return this._parts.map(n=>this._getDispatchPart(n))}getSingleModifierDispatchParts(){return this._parts.map(n=>this._getSingleModifierDispatchPart(n))}}e.BaseResolvedKeybinding=S}),define(J[175],Z([0,1,57,174]),function(z,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USLayoutResolvedKeybinding=void 0;class A extends L.BaseResolvedKeybinding{constructor(E,n){super(n,E.parts)}_keyCodeToUILabel(E){if(this._os===2)switch(E){case 15:return"\u2190";case 16:return"\u2191";case 17:return"\u2192";case 18:return"\u2193"}return m.KeyCodeUtils.toString(E)}_getLabel(E){return E.isDuplicateModifierCase()?"":this._keyCodeToUILabel(E.keyCode)}_getAriaLabel(E){return E.isDuplicateModifierCase()?"":m.KeyCodeUtils.toString(E.keyCode)}_keyCodeToElectronAccelerator(E){if(E>=93&&E<=108)return null;switch(E){case 16:return"Up";case 18:return"Down";case 15:return"Left";case 17:return"Right"}return m.KeyCodeUtils.toString(E)}_getElectronAccelerator(E){return E.isDuplicateModifierCase()?null:this._keyCodeToElectronAccelerator(E.keyCode)}_getUserSettingsLabel(E){if(E.isDuplicateModifierCase())return"";const n=m.KeyCodeUtils.toUserSettingsUS(E.keyCode);return n&&n.toLowerCase()}_isWYSIWYG(){return!0}_getDispatchPart(E){return A.getDispatchStr(E)}static getDispatchStr(E){if(E.isModifierKey())return null;let n="";return E.ctrlKey&&(n+="ctrl+"),E.shiftKey&&(n+="shift+"),E.altKey&&(n+="alt+"),E.metaKey&&(n+="meta+"),n+=m.KeyCodeUtils.toString(E.keyCode),n}_getSingleModifierDispatchPart(E){return E.keyCode===5&&!E.shiftKey&&!E.altKey&&!E.metaKey?"ctrl":E.keyCode===4&&!E.ctrlKey&&!E.altKey&&!E.metaKey?"shift":E.keyCode===6&&!E.ctrlKey&&!E.shiftKey&&!E.metaKey?"alt":E.keyCode===57&&!E.ctrlKey&&!E.shiftKey&&!E.altKey?"meta":null}}e.USLayoutResolvedKeybinding=A}),define(J[176],Z([0,1,9]),function(z,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.handleVetos=void 0;function L(A,S){if(A.length===0)return Promise.resolve(!1);const E=[];let n=!1;for(let w of A){if(w===!0)return Promise.resolve(!0);m.isThenable(w)&&E.push(w.then(p=>{p&&(n=!0)},p=>{S(p),n=!0}))}return m.Promises.settled(E).then(()=>n)}e.handleVetos=L}),define(J[6],Z([0,1,4,2,3,5,67]),function(z,e,m,L,A,S,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=m.createDecorator("logService"),e.ILoggerService=m.createDecorator("loggerService");function n(){return new Date().toISOString()}var w;(function(a){a[a.Trace=0]="Trace",a[a.Debug=1]="Debug",a[a.Info=2]="Info",a[a.Warning=3]="Warning",a[a.Error=4]="Error",a[a.Critical=5]="Critical",a[a.Off=6]="Off"})(w=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=w.Info;class p extends L.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new S.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(t){this.level!==t&&(this.level=t,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=p;class i extends p{constructor(t){super();this.logAlways=t}checkLogLevel(t){return this.logAlways||this.getLevel()<=t}trace(t,...r){this.checkLogLevel(w.Trace)&&this.log(w.Trace,this.format([t,...r]))}debug(t,...r){this.checkLogLevel(w.Debug)&&this.log(w.Debug,this.format([t,...r]))}info(t,...r){this.checkLogLevel(w.Info)&&this.log(w.Info,this.format([t,...r]))}warn(t,...r){this.checkLogLevel(w.Warning)&&this.log(w.Warning,this.format([t,...r]))}error(t,...r){if(this.checkLogLevel(w.Error))if(t instanceof Error){const s=Array.prototype.slice.call(arguments);s[0]=t.stack,this.log(w.Error,this.format(s))}else this.log(w.Error,this.format([t,...r]))}critical(t,...r){this.checkLogLevel(w.Critical)&&this.log(w.Critical,this.format([t,...r]))}flush(){}format(t){let r="";for(let s=0;s<t.length;s++){let o=t[s];if(typeof o=="object")try{o=JSON.stringify(o)}catch(h){}r+=(s>0?" ":"")+o}return r}}e.AbstractMessageLogger=i;class I extends p{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t),this.useColors=!A.isWindows}trace(t,...r){this.getLevel()<=w.Trace&&(this.useColors?console.log(`[90m[main ${n()}][0m`,t,...r):console.log(`[main ${n()}]`,t,...r))}debug(t,...r){this.getLevel()<=w.Debug&&(this.useColors?console.log(`[90m[main ${n()}][0m`,t,...r):console.log(`[main ${n()}]`,t,...r))}info(t,...r){this.getLevel()<=w.Info&&(this.useColors?console.log(`[90m[main ${n()}][0m`,t,...r):console.log(`[main ${n()}]`,t,...r))}warn(t,...r){this.getLevel()<=w.Warning&&(this.useColors?console.warn(`[93m[main ${n()}][0m`,t,...r):console.warn(`[main ${n()}]`,t,...r))}error(t,...r){this.getLevel()<=w.Error&&(this.useColors?console.error(`[91m[main ${n()}][0m`,t,...r):console.error(`[main ${n()}]`,t,...r))}critical(t,...r){this.getLevel()<=w.Critical&&(this.useColors?console.error(`[90m[main ${n()}][0m`,t,...r):console.error(`[main ${n()}]`,t,...r))}dispose(){}flush(){}}e.ConsoleMainLogger=I;class P extends p{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t)}trace(t,...r){this.getLevel()<=w.Trace&&console.log("%cTRACE","color: #888",t,...r)}debug(t,...r){this.getLevel()<=w.Debug&&console.log("%cDEBUG","background: #eee; color: #888",t,...r)}info(t,...r){this.getLevel()<=w.Info&&console.log("%c INFO","color: #33f",t,...r)}warn(t,...r){this.getLevel()<=w.Warning&&console.log("%c WARN","color: #993",t,...r)}error(t,...r){this.getLevel()<=w.Error&&console.log("%c  ERR","color: #f33",t,...r)}critical(t,...r){this.getLevel()<=w.Critical&&console.log("%cCRITI","background: #f33; color: white",t,...r)}dispose(){}flush(){}}e.ConsoleLogger=P;class y extends p{constructor(t,r=e.DEFAULT_LOG_LEVEL){super();this.adapter=t,this.setLevel(r)}trace(t,...r){this.getLevel()<=w.Trace&&this.adapter.log(w.Trace,[this.extractMessage(t),...r])}debug(t,...r){this.getLevel()<=w.Debug&&this.adapter.log(w.Debug,[this.extractMessage(t),...r])}info(t,...r){this.getLevel()<=w.Info&&this.adapter.log(w.Info,[this.extractMessage(t),...r])}warn(t,...r){this.getLevel()<=w.Warning&&this.adapter.log(w.Warning,[this.extractMessage(t),...r])}error(t,...r){this.getLevel()<=w.Error&&this.adapter.log(w.Error,[this.extractMessage(t),...r])}critical(t,...r){this.getLevel()<=w.Critical&&this.adapter.log(w.Critical,[this.extractMessage(t),...r])}extractMessage(t){return typeof t=="string"?t:E.toErrorMessage(t,this.getLevel()<=w.Trace)}dispose(){}flush(){}}e.AdapterLogger=y;class g extends p{constructor(t){super();this.logServices=t,t.length&&this.setLevel(t[0].getLevel())}setLevel(t){for(const r of this.logServices)r.setLevel(t);super.setLevel(t)}trace(t,...r){for(const s of this.logServices)s.trace(t,...r)}debug(t,...r){for(const s of this.logServices)s.debug(t,...r)}info(t,...r){for(const s of this.logServices)s.info(t,...r)}warn(t,...r){for(const s of this.logServices)s.warn(t,...r)}error(t,...r){for(const s of this.logServices)s.error(t,...r)}critical(t,...r){for(const s of this.logServices)s.critical(t,...r)}flush(){for(const t of this.logServices)t.flush()}dispose(){for(const t of this.logServices)t.dispose()}}e.MultiplexLogService=g;class v extends L.Disposable{constructor(t){super();this.logger=t,this._register(t)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(t){this.logger.setLevel(t)}getLevel(){return this.logger.getLevel()}trace(t,...r){this.logger.trace(t,...r)}debug(t,...r){this.logger.debug(t,...r)}info(t,...r){this.logger.info(t,...r)}warn(t,...r){this.logger.warn(t,...r)}error(t,...r){this.logger.error(t,...r)}critical(t,...r){this.logger.critical(t,...r)}flush(){this.logger.flush()}}e.LogService=v;class D extends L.Disposable{constructor(t,r){super();this.logLevel=t,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(r(s=>{this.logLevel=s,this.logLevelChangeableLoggers.forEach(o=>o.setLevel(s))}))}createLogger(t,r){let s=this.loggers.get(t.toString());return s||(s=this.doCreateLogger(t,(r==null?void 0:r.always)?w.Trace:this.logLevel,r),this.loggers.set(t.toString(),s),(r==null?void 0:r.always)||this.logLevelChangeableLoggers.push(s)),s}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(t=>t.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=D;class b{constructor(){this.onDidChangeLogLevel=new S.Emitter().event}setLevel(t){}getLevel(){return w.Info}trace(t,...r){}debug(t,...r){}info(t,...r){}warn(t,...r){}error(t,...r){}critical(t,...r){}dispose(){}flush(){}}e.NullLogService=b;function l(a){if(a.verbose)return w.Trace;if(typeof a.logLevel=="string"){const t=u(a.logLevel.toLowerCase());if(t!==void 0)return t}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=l;function u(a){switch(a){case"trace":return w.Trace;case"debug":return w.Debug;case"info":return w.Info;case"warn":return w.Warning;case"error":return w.Error;case"critical":return w.Critical;case"off":return w.Off}}e.parseLogLevel=u;function c(a){switch(a){case w.Trace:return"trace";case w.Debug:return"debug";case w.Info:return"info";case w.Warning:return"warn";case w.Error:return"error";case w.Critical:return"critical";case w.Off:return"off"}}e.LogLevelToString=c}),define(J[93],Z([0,1,6]),function(z,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BufferLogService=void 0;function L(S,E){switch(E){case m.LogLevel.Trace:return S.trace;case m.LogLevel.Debug:return S.debug;case m.LogLevel.Info:return S.info;case m.LogLevel.Warning:return S.warn;case m.LogLevel.Error:return S.error;case m.LogLevel.Critical:return S.critical;default:throw new Error("Invalid log level")}}class A extends m.AbstractLogger{constructor(E=m.DEFAULT_LOG_LEVEL){super();this.buffer=[],this._logger=void 0,this.setLevel(E),this._register(this.onDidChangeLogLevel(n=>{this._logger&&this._logger.setLevel(n)}))}set logger(E){this._logger=E;for(const{level:n,args:w}of this.buffer)L(E,n).apply(E,w);this.buffer=[]}_log(E,...n){this._logger?L(this._logger,E).apply(this._logger,n):this.getLevel()<=E&&this.buffer.push({level:E,args:n})}trace(E,...n){this._log(m.LogLevel.Trace,E,...n)}debug(E,...n){this._log(m.LogLevel.Debug,E,...n)}info(E,...n){this._log(m.LogLevel.Info,E,...n)}warn(E,...n){this._log(m.LogLevel.Warning,E,...n)}error(E,...n){this._log(m.LogLevel.Error,E,...n)}critical(E,...n){this._log(m.LogLevel.Critical,E,...n)}dispose(){this._logger&&this._logger.dispose()}flush(){this._logger&&this._logger.flush()}}e.BufferLogService=A});var ee=this&&this.__param||function(z,e){return function(m,L){e(m,L,z)}};define(J[177],Z([0,1,6,21,9,20,15,4,93]),function(z,e,m,L,A,S,E,n,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileLoggerService=e.FileLogger=void 0;const p=5*L.ByteSize.MB;let i=class extends m.AbstractLogger{constructor(y,g,v,D){super();this.name=y,this.resource=g,this.fileService=D,this.backupIndex=1,this.setLevel(v),this.queue=this._register(new A.Queue),this.initializePromise=this.initialize()}trace(){this.getLevel()<=m.LogLevel.Trace&&this._log(m.LogLevel.Trace,this.format(arguments))}debug(){this.getLevel()<=m.LogLevel.Debug&&this._log(m.LogLevel.Debug,this.format(arguments))}info(){this.getLevel()<=m.LogLevel.Info&&this._log(m.LogLevel.Info,this.format(arguments))}warn(){this.getLevel()<=m.LogLevel.Warning&&this._log(m.LogLevel.Warning,this.format(arguments))}error(){if(this.getLevel()<=m.LogLevel.Error){const y=arguments[0];if(y instanceof Error){const g=Array.prototype.slice.call(arguments);g[0]=y.stack,this._log(m.LogLevel.Error,this.format(g))}else this._log(m.LogLevel.Error,this.format(arguments))}}critical(){this.getLevel()<=m.LogLevel.Critical&&this._log(m.LogLevel.Critical,this.format(arguments))}flush(){}log(y,g){this._log(y,this.format(g))}async initialize(){try{await this.fileService.createFile(this.resource)}catch(y){if(y.fileOperationResult!==3)throw y}}_log(y,g){this.queue.queue(async()=>{await this.initializePromise;let v=await this.loadContent();v.length>p&&(await this.fileService.writeFile(this.getBackupResource(),S.VSBuffer.fromString(v)),v=""),v+=`[${this.getCurrentTimestamp()}] [${this.name}] [${this.stringifyLogLevel(y)}] ${g}
`,await this.fileService.writeFile(this.resource,S.VSBuffer.fromString(v))})}getCurrentTimestamp(){const y=D=>D<10?`0${D}`:D,g=D=>D<10?`00${D}`:D<100?`0${D}`:D,v=new Date;return`${v.getFullYear()}-${y(v.getMonth()+1)}-${y(v.getDate())} ${y(v.getHours())}:${y(v.getMinutes())}:${y(v.getSeconds())}.${g(v.getMilliseconds())}`}getBackupResource(){return this.backupIndex=this.backupIndex>5?1:this.backupIndex,E.joinPath(E.dirname(this.resource),`${E.basename(this.resource)}_${this.backupIndex++}`)}async loadContent(){try{return(await this.fileService.readFile(this.resource)).value.toString()}catch(y){return""}}stringifyLogLevel(y){switch(y){case m.LogLevel.Critical:return"critical";case m.LogLevel.Debug:return"debug";case m.LogLevel.Error:return"error";case m.LogLevel.Info:return"info";case m.LogLevel.Trace:return"trace";case m.LogLevel.Warning:return"warning"}return""}format(y){let g="";for(let v=0;v<y.length;v++){let D=y[v];if(typeof D=="object")try{D=JSON.stringify(D)}catch(b){}g+=(v>0?" ":"")+D}return g}};i=he([ee(3,L.IFileService)],i),e.FileLogger=i;let I=class extends m.AbstractLoggerService{constructor(y,g,v){super(y.getLevel(),y.onDidChangeLogLevel);this.instantiationService=g,this.fileService=v}doCreateLogger(y,g){const v=new w.BufferLogService(g);return L.whenProviderRegistered(y,this.fileService).then(()=>v.logger=this.instantiationService.createInstance(i,E.basename(y),y,v.getLevel())),v}};I=he([ee(0,m.ILogService),ee(1,n.IInstantiationService),ee(2,L.IFileService)],I),e.FileLoggerService=I}),define(J[178],Z([0,1,6,5,7]),function(z,e,m,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FollowerLogService=e.LoggerChannelClient=e.LoggerChannel=e.LogLevelChannelClient=e.LogLevelChannel=void 0;class S{constructor(P){this.service=P,this.onDidChangeLogLevel=L.Event.buffer(P.onDidChangeLogLevel,!0)}listen(P,y){switch(y){case"onDidChangeLogLevel":return this.onDidChangeLogLevel}throw new Error(`Event not found: ${y}`)}async call(P,y,g){switch(y){case"setLevel":return this.service.setLevel(g)}throw new Error(`Call not found: ${y}`)}}e.LogLevelChannel=S;class E{constructor(P){this.channel=P}get onDidChangeLogLevel(){return this.channel.listen("onDidChangeLogLevel")}setLevel(P){E.setLevel(this.channel,P)}static setLevel(P,y){return P.call("setLevel",y)}}e.LogLevelChannelClient=E;class n{constructor(P){this.loggerService=P,this.loggers=new Map}listen(P,y){throw new Error(`Event not found: ${y}`)}async call(P,y,g){switch(y){case"createLogger":this.createLogger(A.URI.revive(g[0]),g[1]);return;case"log":return this.log(A.URI.revive(g[0]),g[1]);case"consoleLog":return this.consoleLog(g[0],g[1])}throw new Error(`Call not found: ${y}`)}createLogger(P,y){this.loggers.set(P.toString(),this.loggerService.createLogger(P,y))}consoleLog(P,y){let g=console.log;switch(P){case m.LogLevel.Error:g=console.error;break;case m.LogLevel.Warning:g=console.warn;break;case m.LogLevel.Info:g=console.info;break}g.call(console,...y)}log(P,y){const g=this.loggers.get(P.toString());if(!g)throw new Error("Create the logger before logging");for(const[v,D]of y)switch(v){case m.LogLevel.Trace:g.trace(D);break;case m.LogLevel.Debug:g.debug(D);break;case m.LogLevel.Info:g.info(D);break;case m.LogLevel.Warning:g.warn(D);break;case m.LogLevel.Error:g.error(D);break;case m.LogLevel.Critical:g.critical(D);break;default:throw new Error("Invalid log level")}}}e.LoggerChannel=n;class w extends m.AbstractLoggerService{constructor(P,y,g){super(P,y);this.channel=g}createConsoleMainLogger(){return new m.AdapterLogger({log:(P,y)=>{this.channel.call("consoleLog",[P,y])}})}doCreateLogger(P,y,g){return new p(this.channel,P,y,g)}}e.LoggerChannelClient=w;class p extends m.AbstractMessageLogger{constructor(P,y,g,v){super(v==null?void 0:v.always);this.channel=P,this.file=y,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(g),this.channel.call("createLogger",[y,v]).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(P,y){const g=[[P,y]];this.isLoggerCreated?this.doLog(g):this.buffer.push(...g)}doLog(P){this.channel.call("log",[this.file,P])}}class i extends m.LogService{constructor(P,y){super(y);this.parent=P,this._register(P.onDidChangeLogLevel(g=>y.setLevel(g)))}setLevel(P){super.setLevel(P),this.parent.setLevel(P)}}e.FollowerLogService=i}),define(J[94],Z([0,1,6,21]),function(z,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=e.createRotatingLogger=void 0;async function A(w,p,i,I){try{const P=await new Promise((y,g)=>{z(["spdlog"],y,g)});return P.setFlushOn(m.LogLevel.Trace),P.createAsyncRotatingLogger(w,p,i,I)}catch(P){console.error(P)}return null}function S(w,p,i,I){const P=z.__$__nodeRequire("spdlog");return P.setFlushOn(m.LogLevel.Trace),P.createRotatingLogger(w,p,i,I)}e.createRotatingLogger=S;function E(w,p,i){switch(p){case m.LogLevel.Trace:w.trace(i);break;case m.LogLevel.Debug:w.debug(i);break;case m.LogLevel.Info:w.info(i);break;case m.LogLevel.Warning:w.warn(i);break;case m.LogLevel.Error:w.error(i);break;case m.LogLevel.Critical:w.critical(i);break;default:throw new Error("Invalid log level")}}class n extends m.AbstractMessageLogger{constructor(p,i,I,P){super();this.name=p,this.filepath=i,this.rotating=I,this.buffer=[],this.setLevel(P),this._loggerCreationPromise=this._createSpdLogLogger(),this._register(this.onDidChangeLogLevel(y=>{this._logger&&this._logger.setLevel(y)}))}_createSpdLogLogger(){const p=this.rotating?6:1,i=30/p*L.ByteSize.MB;return A(this.name,this.filepath,i,p).then(I=>{if(I){this._logger=I,this._logger.setLevel(this.getLevel());for(const{level:P,message:y}of this.buffer)E(this._logger,P,y);this.buffer=[]}})}log(p,i){this._logger?E(this._logger,p,i):this.getLevel()<=p&&this.buffer.push({level:p,message:i})}clearFormatters(){this._logger?this._logger.clearFormatters():this._loggerCreationPromise.then(()=>this.clearFormatters())}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=n}),define(J[179],Z([0,1,6,15,10,177,94,21,27]),function(z,e,m,L,A,S,E,n,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoggerService=void 0;let p=class extends m.AbstractLoggerService{constructor(I,P){super(I.getLevel(),I.onDidChangeLogLevel);this.fileService=P}doCreateLogger(I,P,y){var g;if(I.scheme===A.Schemas.file){const v=new E.SpdLogLogger((y==null?void 0:y.name)||w.generateUuid(),I.fsPath,!(y==null?void 0:y.donotRotate),P);return(y==null?void 0:y.donotUseFormatters)&&v.clearFormatters(),v}else return new S.FileLogger((g=y==null?void 0:y.name)!==null&&g!==void 0?g:L.basename(I),I,P,this.fileService)}};p=he([ee(0,m.ILogService),ee(1,n.IFileService)],p),e.LoggerService=p}),define(J[180],Z([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMenubarMenuItemAction=e.isMenubarMenuItemRecentAction=e.isMenubarMenuItemSeparator=e.isMenubarMenuItemSubmenu=void 0;function m(E){return E.submenu!==void 0}e.isMenubarMenuItemSubmenu=m;function L(E){return E.id==="vscode.menubar.separator"}e.isMenubarMenuItemSeparator=L;function A(E){return E.uri!==void 0}e.isMenubarMenuItemRecentAction=A;function S(E){return!m(E)&&!L(E)&&!A(E)}e.isMenubarMenuItemAction=S}),define(J[47],Z([0,1,10,3,32,15]),function(z,e,m,L,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let E;if(typeof L.globals.vscode!="undefined"&&typeof L.globals.vscode.context!="undefined"){const n=L.globals.vscode.context.configuration();if(n)E=n.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof(z==null?void 0:z.__$__nodeRequire)=="function"){const n=S.dirname(m.FileAccess.asFileUri("",z));E=z.__$__nodeRequire(S.joinPath(n,"product.json").fsPath);const w=z.__$__nodeRequire(S.joinPath(n,"package.json").fsPath);A.env.VSCODE_DEV&&Object.assign(E,{nameShort:`${E.nameShort} Dev`,nameLong:`${E.nameLong} Dev`,dataFolderName:`${E.dataFolderName}-dev`}),Object.assign(E,{version:w.version})}else E={},Object.keys(E).length===0&&Object.assign(E,{version:"1.58.0-dev",nameShort:L.isWeb?"Code Web - OSS Dev":"Code - OSS Dev",nameLong:L.isWeb?"Code Web - OSS Dev":"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",extensionAllowedProposedApi:["ms-vscode.vscode-js-profile-flame","ms-vscode.vscode-js-profile-table","ms-vscode.remotehub","ms-vscode.remotehub-insiders","GitHub.remotehub","GitHub.remotehub-insiders"]});e.default=E}),define(J[95],Z([0,1,141,20,21,19,47]),function(z,e,m,L,A,S,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function n(I,P,y,g,v,D){let b;try{await w(I,P,y,g,v,D)}catch(l){b=l}finally{b&&v.errorTransformer&&(b=v.errorTransformer(b)),typeof b!="undefined"&&y.error(b),y.end()}}e.readFileIntoStream=n;async function w(I,P,y,g,v,D){p(D);const b=await I.open(P,{create:!1});try{p(D);let l=0,u=0,c=v&&typeof v.length=="number"?v.length:void 0,a=L.VSBuffer.alloc(Math.min(v.bufferSize,typeof c=="number"?c:v.bufferSize)),t=v&&typeof v.position=="number"?v.position:0,r=0;do u=await I.read(b,t,a.buffer,r,a.byteLength-r),t+=u,r+=u,l+=u,typeof c=="number"&&(c-=u),r===a.byteLength&&(await y.write(g(a)),a=L.VSBuffer.alloc(Math.min(v.bufferSize,typeof c=="number"?c:v.bufferSize)),r=0);while(u>0&&(typeof c!="number"||c>0)&&p(D)&&i(l,v));if(r>0){let s=r;typeof c=="number"&&(s=Math.min(r,c)),y.write(g(a.slice(0,s)))}}catch(l){throw A.ensureFileSystemProviderError(l)}finally{await I.close(b)}}function p(I){if(I.isCancellationRequested)throw S.canceled();return!0}function i(I,P){if(P==null?void 0:P.limits){if(typeof P.limits.memory=="number"&&I>P.limits.memory)throw A.createFileSystemProviderError(m.localize(0,null,E.default.nameShort),A.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof P.limits.size=="number"&&I>P.limits.size)throw A.createFileSystemProviderError(m.localize(1,null),A.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(J[181],Z([0,1,139,72,2,21,5,15,36,35,6,20,64,9,25,10,95,63]),function(z,e,m,L,A,S,E,n,w,p,i,I,P,y,g,v,D,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let l=class extends A.Disposable{constructor(c){super();this.logService=c,this.BUFFER_SIZE=64*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new E.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new E.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new E.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new E.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onError=this._register(new E.Emitter),this.onError=this._onError.event,this._onDidFilesChange=this._register(new E.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this.activeWatchers=new Map,this.writeQueue=this._register(new y.ResourceQueue)}registerProvider(c,a){if(this.provider.has(c))throw new Error(`A filesystem provider for the scheme '${c}' is already registered.`);L.mark(`code/registerFilesystem/${c}`),this.provider.set(c,a),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:c,provider:a});const t=new A.DisposableStore;return t.add(a.onDidChangeFile(r=>this._onDidFilesChange.fire(new S.FileChangesEvent(r,!this.isPathCaseSensitive(a))))),t.add(a.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:a,scheme:c}))),typeof a.onDidErrorOccur=="function"&&t.add(a.onDidErrorOccur(r=>this._onError.fire(new Error(r)))),A.toDisposable(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:c,provider:a}),this.provider.delete(c),A.dispose(t)})}getProvider(c){return this.provider.get(c)}async activateProvider(c){const a=[];this._onWillActivateFileSystemProvider.fire({scheme:c,join(t){a.push(t)}}),!this.provider.has(c)&&await y.Promises.settled(a)}canHandleResource(c){return this.provider.has(c.scheme)}hasCapability(c,a){const t=this.provider.get(c.scheme);return!!(t&&t.capabilities&a)}listCapabilities(){return b.Iterable.map(this.provider,([c,a])=>({scheme:c,capabilities:a.capabilities}))}async withProvider(c){if(!n.isAbsolutePath(c))throw new S.FileOperationError(m.localize(0,null,this.resourceForError(c)),8);await this.activateProvider(c.scheme);const a=this.provider.get(c.scheme);if(!a){const t=new Error;throw t.name="ENOPRO",t.message=m.localize(1,null,c.toString()),t}return a}async withReadProvider(c){const a=await this.withProvider(c);if(S.hasOpenReadWriteCloseCapability(a)||S.hasReadWriteCapability(a)||S.hasFileReadStreamCapability(a))return a;throw new Error(`Filesystem provider for scheme '${c.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(c){const a=await this.withProvider(c);if(S.hasOpenReadWriteCloseCapability(a)||S.hasReadWriteCapability(a))return a;throw new Error(`Filesystem provider for scheme '${c.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(c,a){try{return await this.doResolveFile(c,a)}catch(t){throw S.toFileSystemProviderErrorCode(t)===S.FileSystemProviderErrorCode.FileNotFound?new S.FileOperationError(m.localize(2,null,this.resourceForError(c)),1):S.ensureFileSystemProviderError(t)}}async doResolveFile(c,a){const t=await this.withProvider(c),r=this.isPathCaseSensitive(t),s=a==null?void 0:a.resolveTo,o=a==null?void 0:a.resolveSingleChildDescendants,h=a==null?void 0:a.resolveMetadata,f=await t.stat(c);let d;return this.toFileStat(t,c,f,void 0,!!h,(M,T)=>(d||(d=w.TernarySearchTree.forUris(()=>!r),d.set(c,!0),p.isNonEmptyArray(s)&&s.forEach(C=>d.set(C,!0))),Boolean(d.findSuperstr(M.resource)||d.get(M.resource))?!0:M.isDirectory&&o?T===1:!1))}async toFileStat(c,a,t,r,s,o){var h;const{providerExtUri:f}=this.getExtUri(c),d={resource:a,name:f.basename(a),isFile:(t.type&S.FileType.File)!=0,isDirectory:(t.type&S.FileType.Directory)!=0,isSymbolicLink:(t.type&S.FileType.SymbolicLink)!=0,mtime:t.mtime,ctime:t.ctime,size:t.size,readonly:Boolean(((h=t.permissions)!==null&&h!==void 0?h:0)&S.FilePermission.Readonly)||Boolean(c.capabilities&2048),etag:S.etag({mtime:t.mtime,size:t.size})};if(d.isDirectory&&o(d,r)){try{const M=await c.readdir(a),T=await y.Promises.settled(M.map(async([C,V])=>{try{const Q=f.joinPath(a,C),te=s?await c.stat(Q):{type:V};return await this.toFileStat(c,Q,te,M.length,s,o)}catch(Q){return this.logService.trace(Q),null}}));d.children=p.coalesce(T)}catch(M){this.logService.trace(M),d.children=[]}return d}return d}async resolveAll(c){return y.Promises.settled(c.map(async a=>{try{return{stat:await this.doResolveFile(a.resource,a.options),success:!0}}catch(t){return this.logService.trace(t),{stat:void 0,success:!1}}}))}async exists(c){const a=await this.withProvider(c);try{return!!await a.stat(c)}catch(t){return!1}}async canCreateFile(c,a){try{await this.doValidateCreateFile(c,a)}catch(t){return t}return!0}async doValidateCreateFile(c,a){if(!(a==null?void 0:a.overwrite)&&await this.exists(c))throw new S.FileOperationError(m.localize(3,null,this.resourceForError(c)),3,a)}async createFile(c,a=I.VSBuffer.fromString(""),t){await this.doValidateCreateFile(c,t);const r=await this.writeFile(c,a);return this._onDidRunOperation.fire(new S.FileOperationEvent(c,0,r)),r}async writeFile(c,a,t){const r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(c),c),{providerExtUri:s}=this.getExtUri(r);try{await this.validateWriteFile(r,c,t)||await this.mkdirp(r,s.dirname(c));let h;if(S.hasReadWriteCapability(r)&&!(a instanceof I.VSBuffer))if(P.isReadableStream(a)){const f=await P.peekStream(a,3);f.ended?h=I.VSBuffer.concat(f.buffer):h=f}else h=P.peekReadable(a,f=>I.VSBuffer.concat(f),3);else h=a;!S.hasOpenReadWriteCloseCapability(r)||S.hasReadWriteCapability(r)&&h instanceof I.VSBuffer?await this.doWriteUnbuffered(r,c,t,h):await this.doWriteBuffered(r,c,t,h instanceof I.VSBuffer?I.bufferToReadable(h):h)}catch(o){throw new S.FileOperationError(m.localize(4,null,this.resourceForError(c),S.ensureFileSystemProviderError(o).toString()),S.toFileOperationResult(o),t)}return this.resolve(c,{resolveMetadata:!0})}async validateWriteFile(c,a,t){if(!!(t==null?void 0:t.unlock)&&!(c.capabilities&8192))throw new Error(m.localize(5,null,this.resourceForError(a)));let s;try{s=await c.stat(a)}catch(o){return}if((s.type&S.FileType.Directory)!=0)throw new S.FileOperationError(m.localize(6,null,this.resourceForError(a)),0,t);if(this.throwIfFileIsReadonly(a,s),t&&typeof t.mtime=="number"&&typeof t.etag=="string"&&t.etag!==S.ETAG_DISABLED&&typeof s.mtime=="number"&&typeof s.size=="number"&&t.mtime<s.mtime&&t.etag!==S.etag({mtime:t.mtime,size:s.size}))throw new S.FileOperationError(m.localize(7,null),3,t);return s}async readFile(c,a){const t=await this.withReadProvider(c);return(a==null?void 0:a.atomic)?this.doReadFileAtomic(t,c,a):this.doReadFile(t,c,a)}async doReadFileAtomic(c,a,t){return new Promise((r,s)=>{this.writeQueue.queueFor(a,this.getExtUri(c).providerExtUri).queue(async()=>{try{const o=await this.doReadFile(c,a,t);r(o)}catch(o){s(o)}})})}async doReadFile(c,a,t){const r=await this.doReadFileStream(c,a,Object.assign(Object.assign({},t),{preferUnbuffered:!0}));return Object.assign(Object.assign({},r),{value:await I.streamToBuffer(r.value)})}async readFileStream(c,a){const t=await this.withReadProvider(c);return this.doReadFileStream(t,c,a)}async doReadFileStream(c,a,t){const r=new g.CancellationTokenSource,s=this.validateReadFile(a,t).then(h=>h,h=>{throw r.cancel(),h});let o;try{t&&typeof t.etag=="string"&&t.etag!==S.ETAG_DISABLED&&await s,!(S.hasOpenReadWriteCloseCapability(c)||S.hasFileReadStreamCapability(c))||S.hasReadWriteCapability(c)&&(t==null?void 0:t.preferUnbuffered)?o=this.readFileUnbuffered(c,a,t):S.hasFileReadStreamCapability(c)?o=this.readFileStreamed(c,a,r.token,t):o=this.readFileBuffered(c,a,r.token,t);const h=await s;return Object.assign(Object.assign({},h),{value:o})}catch(h){o&&await P.consumeStream(o);const f=m.localize(8,null,this.resourceForError(a),S.ensureFileSystemProviderError(h).toString());throw h instanceof S.NotModifiedSinceFileOperationError?new S.NotModifiedSinceFileOperationError(f,h.stat,t):new S.FileOperationError(f,S.toFileOperationResult(h),t)}}readFileStreamed(c,a,t,r=Object.create(null)){const s=c.readFileStream(a,r,t);return P.transform(s,{data:o=>o instanceof I.VSBuffer?o:I.VSBuffer.wrap(o),error:o=>new S.FileOperationError(m.localize(9,null,this.resourceForError(a),S.ensureFileSystemProviderError(o).toString()),S.toFileOperationResult(o),r)},o=>I.VSBuffer.concat(o))}readFileBuffered(c,a,t,r=Object.create(null)){const s=I.newWriteableBufferStream();return D.readFileIntoStream(c,a,s,o=>o,Object.assign(Object.assign({},r),{bufferSize:this.BUFFER_SIZE,errorTransformer:o=>new S.FileOperationError(m.localize(10,null,this.resourceForError(a),S.ensureFileSystemProviderError(o).toString()),S.toFileOperationResult(o),r)}),t),s}readFileUnbuffered(c,a,t){const r=P.newWriteableStream(s=>I.VSBuffer.concat(s));return(async()=>{try{let s=await c.readFile(a);t&&typeof t.position=="number"&&(s=s.slice(t.position)),t&&typeof t.length=="number"&&(s=s.slice(0,t.length)),this.validateReadFileLimits(a,s.byteLength,t),r.end(I.VSBuffer.wrap(s))}catch(s){r.error(s),r.end()}})(),r}async validateReadFile(c,a){const t=await this.resolve(c,{resolveMetadata:!0});if(t.isDirectory)throw new S.FileOperationError(m.localize(11,null,this.resourceForError(c)),0,a);if(a&&typeof a.etag=="string"&&a.etag!==S.ETAG_DISABLED&&a.etag===t.etag)throw new S.NotModifiedSinceFileOperationError(m.localize(12,null),t,a);return this.validateReadFileLimits(c,t.size,a),t}validateReadFileLimits(c,a,t){if(t==null?void 0:t.limits){let r;if(typeof t.limits.memory=="number"&&a>t.limits.memory&&(r=9),typeof t.limits.size=="number"&&a>t.limits.size&&(r=7),typeof r=="number")throw new S.FileOperationError(m.localize(13,null,this.resourceForError(c)),r)}}async canMove(c,a,t){return this.doCanMoveCopy(c,a,"move",t)}async canCopy(c,a,t){return this.doCanMoveCopy(c,a,"copy",t)}async doCanMoveCopy(c,a,t,r){if(c.toString()!==a.toString())try{const s=t==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(c),c):await this.withReadProvider(c),o=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(a),a);await this.doValidateMoveCopy(s,c,o,a,t,r)}catch(s){return s}return!0}async move(c,a,t){const r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(c),c),s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(a),a),o=await this.doMoveCopy(r,c,s,a,"move",!!t),h=await this.resolve(a,{resolveMetadata:!0});return this._onDidRunOperation.fire(new S.FileOperationEvent(c,o==="move"?2:3,h)),h}async copy(c,a,t){const r=await this.withReadProvider(c),s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(a),a),o=await this.doMoveCopy(r,c,s,a,"copy",!!t),h=await this.resolve(a,{resolveMetadata:!0});return this._onDidRunOperation.fire(new S.FileOperationEvent(c,o==="copy"?3:2,h)),h}async doMoveCopy(c,a,t,r,s,o){if(a.toString()===r.toString())return s;const{exists:h,isSameResourceWithDifferentPathCase:f}=await this.doValidateMoveCopy(c,a,t,r,s,o);if(h&&!f&&o&&await this.del(r,{recursive:!0}),await this.mkdirp(t,this.getExtUri(t).providerExtUri.dirname(r)),s==="copy"){if(c===t&&S.hasFileFolderCopyCapability(c))await c.copy(a,r,{overwrite:o});else{const d=await this.resolve(a);d.isDirectory?await this.doCopyFolder(c,d,t,r):await this.doCopyFile(c,a,t,r)}return s}else return c===t?(await c.rename(a,r,{overwrite:o}),s):(await this.doMoveCopy(c,a,t,r,"copy",o),await this.del(a,{recursive:!0}),"copy")}async doCopyFile(c,a,t,r){if(S.hasOpenReadWriteCloseCapability(c)&&S.hasOpenReadWriteCloseCapability(t))return this.doPipeBuffered(c,a,t,r);if(S.hasOpenReadWriteCloseCapability(c)&&S.hasReadWriteCapability(t))return this.doPipeBufferedToUnbuffered(c,a,t,r);if(S.hasReadWriteCapability(c)&&S.hasOpenReadWriteCloseCapability(t))return this.doPipeUnbufferedToBuffered(c,a,t,r);if(S.hasReadWriteCapability(c)&&S.hasReadWriteCapability(t))return this.doPipeUnbuffered(c,a,t,r)}async doCopyFolder(c,a,t,r){await t.mkdir(r),Array.isArray(a.children)&&await y.Promises.settled(a.children.map(async s=>{const o=this.getExtUri(t).providerExtUri.joinPath(r,s.name);return s.isDirectory?this.doCopyFolder(c,await this.resolve(s.resource),t,o):this.doCopyFile(c,s.resource,t,o)}))}async doValidateMoveCopy(c,a,t,r,s,o){let h=!1;if(c===t){const{providerExtUri:d,isPathCaseSensitive:M}=this.getExtUri(c);if(M||(h=d.isEqual(a,r)),h&&s==="copy")throw new Error(m.localize(14,null,this.resourceForError(a),this.resourceForError(r)));if(!h&&d.isEqualOrParent(r,a))throw new Error(m.localize(15,null,this.resourceForError(a),this.resourceForError(r)))}const f=await this.exists(r);if(f&&!h){if(!o)throw new S.FileOperationError(m.localize(16,null,this.resourceForError(a),this.resourceForError(r)),4);if(c===t){const{providerExtUri:d}=this.getExtUri(c);if(d.isEqualOrParent(a,r))throw new Error(m.localize(17,null,this.resourceForError(a),this.resourceForError(r)))}}return{exists:f,isSameResourceWithDifferentPathCase:h}}getExtUri(c){const a=this.isPathCaseSensitive(c);return{providerExtUri:a?n.extUri:n.extUriIgnorePathCase,isPathCaseSensitive:a}}isPathCaseSensitive(c){return!!(c.capabilities&1024)}async createFolder(c){const a=this.throwIfFileSystemIsReadonly(await this.withProvider(c),c);await this.mkdirp(a,c);const t=await this.resolve(c,{resolveMetadata:!0});return this._onDidRunOperation.fire(new S.FileOperationEvent(c,0,t)),t}async mkdirp(c,a){const t=[],{providerExtUri:r}=this.getExtUri(c);for(;!r.isEqual(a,r.dirname(a));)try{if(((await c.stat(a)).type&S.FileType.Directory)==0)throw new Error(m.localize(18,null,this.resourceForError(a)));break}catch(s){if(S.toFileSystemProviderErrorCode(s)!==S.FileSystemProviderErrorCode.FileNotFound)throw s;t.push(r.basename(a)),a=r.dirname(a)}for(let s=t.length-1;s>=0;s--){a=r.joinPath(a,t[s]);try{await c.mkdir(a)}catch(o){if(S.toFileSystemProviderErrorCode(o)!==S.FileSystemProviderErrorCode.FileExists)throw o}}}async canDelete(c,a){try{await this.doValidateDelete(c,a)}catch(t){return t}return!0}async doValidateDelete(c,a){const t=this.throwIfFileSystemIsReadonly(await this.withProvider(c),c);if(!!(a==null?void 0:a.useTrash)&&!(t.capabilities&4096))throw new Error(m.localize(19,null,this.resourceForError(c)));let s;try{s=await t.stat(c)}catch(h){}if(s)this.throwIfFileIsReadonly(c,s);else throw new S.FileOperationError(m.localize(20,null,this.resourceForError(c)),1);if(!!!(a==null?void 0:a.recursive)){const h=await this.resolve(c);if(h.isDirectory&&Array.isArray(h.children)&&h.children.length>0)throw new Error(m.localize(21,null,this.resourceForError(c)))}return t}async del(c,a){const t=await this.doValidateDelete(c,a),r=!!(a==null?void 0:a.useTrash),s=!!(a==null?void 0:a.recursive);await t.delete(c,{recursive:s,useTrash:r}),this._onDidRunOperation.fire(new S.FileOperationEvent(c,1))}watch(c,a={recursive:!1,excludes:[]}){let t=!1,r=()=>{t=!0};return this.doWatch(c,a).then(s=>{t?A.dispose(s):r=()=>A.dispose(s)},s=>this.logService.error(s)),A.toDisposable(()=>r())}async doWatch(c,a){const t=await this.withProvider(c),r=this.toWatchKey(t,c,a),s=this.activeWatchers.get(r)||{count:0,disposable:t.watch(c,a)};return this.activeWatchers.has(r)||this.activeWatchers.set(r,s),s.count+=1,A.toDisposable(()=>{s.count--,s.count===0&&(A.dispose(s.disposable),this.activeWatchers.delete(r))})}toWatchKey(c,a,t){const{providerExtUri:r}=this.getExtUri(c);return[r.getComparisonKey(a),String(t.recursive),t.excludes.join()].join()}dispose(){super.dispose(),this.activeWatchers.forEach(c=>A.dispose(c.disposable)),this.activeWatchers.clear()}async doWriteBuffered(c,a,t,r){return this.writeQueue.queueFor(a,this.getExtUri(c).providerExtUri).queue(async()=>{var s;const o=await c.open(a,{create:!0,unlock:(s=t==null?void 0:t.unlock)!==null&&s!==void 0?s:!1});try{P.isReadableStream(r)||P.isReadableBufferedStream(r)?await this.doWriteStreamBufferedQueued(c,o,r):await this.doWriteReadableBufferedQueued(c,o,r)}catch(h){throw S.ensureFileSystemProviderError(h)}finally{await c.close(o)}})}async doWriteStreamBufferedQueued(c,a,t){let r=0,s;if(P.isReadableBufferedStream(t)){if(t.buffer.length>0){const o=I.VSBuffer.concat(t.buffer);await this.doWriteBuffer(c,a,o,o.byteLength,r,0),r+=o.byteLength}if(t.ended)return;s=t.stream}else s=t;return new Promise(async(o,h)=>{P.listenStream(s,{onData:async f=>{s.pause();try{await this.doWriteBuffer(c,a,f,f.byteLength,r,0)}catch(d){return h(d)}r+=f.byteLength,setTimeout(()=>s.resume())},onError:f=>h(f),onEnd:()=>o()})})}async doWriteReadableBufferedQueued(c,a,t){let r=0,s;for(;(s=t.read())!==null;)await this.doWriteBuffer(c,a,s,s.byteLength,r,0),r+=s.byteLength}async doWriteBuffer(c,a,t,r,s,o){let h=0;for(;h<r;)h+=await c.write(a,s+h,t.buffer,o+h,r-h)}async doWriteUnbuffered(c,a,t,r){return this.writeQueue.queueFor(a,this.getExtUri(c).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(c,a,t,r))}async doWriteUnbufferedQueued(c,a,t,r){var s;let o;r instanceof I.VSBuffer?o=r:P.isReadableStream(r)?o=await I.streamToBuffer(r):P.isReadableBufferedStream(r)?o=await I.bufferedStreamToBuffer(r):o=I.readableToBuffer(r),await c.writeFile(a,o.buffer,{create:!0,overwrite:!0,unlock:(s=t==null?void 0:t.unlock)!==null&&s!==void 0?s:!1})}async doPipeBuffered(c,a,t,r){return this.writeQueue.queueFor(r,this.getExtUri(t).providerExtUri).queue(()=>this.doPipeBufferedQueued(c,a,t,r))}async doPipeBufferedQueued(c,a,t,r){let s,o;try{s=await c.open(a,{create:!1}),o=await t.open(r,{create:!0,unlock:!1});const h=I.VSBuffer.alloc(this.BUFFER_SIZE);let f=0,d=0,M=0;do M=await c.read(s,f,h.buffer,d,h.byteLength-d),await this.doWriteBuffer(t,o,h,M,f,d),f+=M,d+=M,d===h.byteLength&&(d=0);while(M>0)}catch(h){throw S.ensureFileSystemProviderError(h)}finally{await y.Promises.settled([typeof s=="number"?c.close(s):Promise.resolve(),typeof o=="number"?t.close(o):Promise.resolve()])}}async doPipeUnbuffered(c,a,t,r){return this.writeQueue.queueFor(r,this.getExtUri(t).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(c,a,t,r))}async doPipeUnbufferedQueued(c,a,t,r){return t.writeFile(r,await c.readFile(a),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(c,a,t,r){return this.writeQueue.queueFor(r,this.getExtUri(t).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(c,a,t,r))}async doPipeUnbufferedToBufferedQueued(c,a,t,r){const s=await t.open(r,{create:!0,unlock:!1});try{const o=await c.readFile(a);await this.doWriteBuffer(t,s,I.VSBuffer.wrap(o),o.byteLength,0,0)}catch(o){throw S.ensureFileSystemProviderError(o)}finally{await t.close(s)}}async doPipeBufferedToUnbuffered(c,a,t,r){const s=await I.streamToBuffer(this.readFileBuffered(c,a,g.CancellationToken.None));await this.doWriteUnbuffered(t,r,void 0,s)}throwIfFileSystemIsReadonly(c,a){if(c.capabilities&2048)throw new S.FileOperationError(m.localize(22,null,this.resourceForError(a)),6);return c}throwIfFileIsReadonly(c,a){var t;if(((t=a.permissions)!==null&&t!==void 0?t:0)&S.FilePermission.Readonly)throw new S.FileOperationError(m.localize(23,null,this.resourceForError(c)),6)}resourceForError(c){return c.scheme===v.Schemas.file?c.fsPath:c.toString(!0)}};l=he([ee(0,i.ILogService)],l),e.FileService=l}),define(J[182],Z([0,1,2,21,5,3,17,8,15,29,9,6,142,92,164,166,163,172,64,95,35,20]),function(z,e,m,L,A,S,E,n,w,p,i,I,P,y,g,v,D,b,l,u,c,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0;class t extends m.Disposable{constructor(s,o){var h;super();this.logService=s,this.options=o,this.BUFFER_SIZE=((h=this.options)===null||h===void 0?void 0:h.bufferSize)||64*1024,this.onDidChangeCapabilities=A.Event.None,this.mapHandleToPos=new Map,this.writeHandles=new Map,this.canFlush=!0,this._onDidWatchErrorOccur=this._register(new A.Emitter),this.onDidErrorOccur=this._onDidWatchErrorOccur.event,this._onDidChangeFile=this._register(new A.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this.recursiveFoldersToWatch=[],this.recursiveWatchRequestDelayer=this._register(new i.ThrottledDelayer(0))}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192,S.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(s){try{const{stat:o,symbolicLink:h}=await E.SymlinkSupport.stat(this.toFilePath(s));return{type:this.toType(o,h),ctime:o.birthtime.getTime(),mtime:o.mtime.getTime(),size:o.size}}catch(o){throw this.toFileSystemProviderError(o)}}async readdir(s){try{const o=await E.Promises.readdir(this.toFilePath(s),{withFileTypes:!0}),h=[];return await Promise.all(o.map(async f=>{try{let d;f.isSymbolicLink()?d=(await this.stat(w.joinPath(s,f.name))).type:d=this.toType(f),h.push([f.name,d])}catch(d){this.logService.trace(d)}})),h}catch(o){throw this.toFileSystemProviderError(o)}}toType(s,o){let h;return(o==null?void 0:o.dangling)?h=L.FileType.Unknown:s.isFile()?h=L.FileType.File:s.isDirectory()?h=L.FileType.Directory:h=L.FileType.Unknown,o&&(h|=L.FileType.SymbolicLink),h}async readFile(s){try{const o=this.toFilePath(s);return await E.Promises.readFile(o)}catch(o){throw this.toFileSystemProviderError(o)}}readFileStream(s,o,h){const f=l.newWriteableStream(d=>a.VSBuffer.concat(d.map(M=>a.VSBuffer.wrap(M))).buffer);return u.readFileIntoStream(this,s,f,d=>d.buffer,Object.assign(Object.assign({},o),{bufferSize:this.BUFFER_SIZE}),h),f}async writeFile(s,o,h){let f;try{const d=this.toFilePath(s);if(!h.create||!h.overwrite){if(await E.Promises.exists(d)){if(!h.overwrite)throw L.createFileSystemProviderError(P.localize(0,null),L.FileSystemProviderErrorCode.FileExists)}else if(!h.create)throw L.createFileSystemProviderError(P.localize(1,null),L.FileSystemProviderErrorCode.FileNotFound)}f=await this.open(s,{create:!0,unlock:h.unlock}),await this.write(f,0,o,0,o.byteLength)}catch(d){throw await this.toFileSystemProviderWriteError(s,d)}finally{typeof f=="number"&&await this.close(f)}}async open(s,o){try{const h=this.toFilePath(s);if(L.isFileOpenForWriteOptions(o)&&o.unlock)try{const{stat:M}=await E.SymlinkSupport.stat(h);M.mode&128||await E.Promises.chmod(h,M.mode|128)}catch(M){this.logService.trace(M)}let f;if(L.isFileOpenForWriteOptions(o)){if(S.isWindows)try{await E.Promises.truncate(h,0),f="r+"}catch(M){M.code!=="ENOENT"&&this.logService.trace(M)}f||(f="w")}else f="r";const d=await E.Promises.open(h,f);return this.mapHandleToPos.set(d,0),L.isFileOpenForWriteOptions(o)&&this.writeHandles.set(d,s),d}catch(h){throw L.isFileOpenForWriteOptions(o)?await this.toFileSystemProviderWriteError(s,h):this.toFileSystemProviderError(h)}}async close(s){try{if(this.mapHandleToPos.delete(s),this.writeHandles.delete(s)&&this.canFlush)try{await E.Promises.fdatasync(s)}catch(o){this.canFlush=!1,this.logService.error(o)}return await E.Promises.close(s)}catch(o){throw this.toFileSystemProviderError(o)}}async read(s,o,h,f,d){const M=this.normalizePos(s,o);let T=null;try{const C=await E.Promises.read(s,h,f,d,M);return typeof C=="number"?T=C:T=C.bytesRead,T}catch(C){throw this.toFileSystemProviderError(C)}finally{this.updatePos(s,M,T)}}normalizePos(s,o){return o===this.mapHandleToPos.get(s)?null:o}updatePos(s,o,h){const f=this.mapHandleToPos.get(s);typeof f=="number"&&(typeof o=="number"||(typeof h=="number"?this.mapHandleToPos.set(s,f+h):this.mapHandleToPos.delete(s)))}async write(s,o,h,f,d){return i.retry(()=>this.doWrite(s,o,h,f,d),100,3)}async doWrite(s,o,h,f,d){const M=this.normalizePos(s,o);let T=null;try{const C=await E.Promises.write(s,h,f,d,M);return typeof C=="number"?T=C:T=C.bytesWritten,T}catch(C){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(s),C)}finally{this.updatePos(s,M,T)}}async mkdir(s){try{await E.Promises.mkdir(this.toFilePath(s))}catch(o){throw this.toFileSystemProviderError(o)}}async delete(s,o){try{const h=this.toFilePath(s);await this.doDelete(h,o)}catch(h){throw this.toFileSystemProviderError(h)}}async doDelete(s,o){o.recursive?await E.Promises.rm(s,E.RimRafMode.MOVE):await E.Promises.unlink(s)}async rename(s,o,h){const f=this.toFilePath(s),d=this.toFilePath(o);if(f!==d)try{await this.validateTargetDeleted(s,o,"move",h.overwrite),await E.Promises.move(f,d)}catch(M){throw(M.code==="EINVAL"||M.code==="EBUSY"||M.code==="ENAMETOOLONG")&&(M=new Error(P.localize(2,null,n.basename(f),n.basename(n.dirname(d)),M.toString()))),this.toFileSystemProviderError(M)}}async copy(s,o,h){const f=this.toFilePath(s),d=this.toFilePath(o);if(f!==d)try{await this.validateTargetDeleted(s,o,"copy",h.overwrite),await E.Promises.copy(f,d,{preserveSymlinks:!0})}catch(M){throw(M.code==="EINVAL"||M.code==="EBUSY"||M.code==="ENAMETOOLONG")&&(M=new Error(P.localize(3,null,n.basename(f),n.basename(n.dirname(d)),M.toString()))),this.toFileSystemProviderError(M)}}async validateTargetDeleted(s,o,h,f){const d=this.toFilePath(s),M=this.toFilePath(o);let T=!1;if(!!(this.capabilities&1024)||(T=p.isEqual(d,M,!0)),T&&h==="copy")throw L.createFileSystemProviderError(P.localize(4,null),L.FileSystemProviderErrorCode.FileExists);if(!T&&await E.Promises.exists(M)){if(!f)throw L.createFileSystemProviderError(P.localize(5,null),L.FileSystemProviderErrorCode.FileExists);await this.delete(o,{recursive:!0,useTrash:!1})}}watch(s,o){return o.recursive?this.watchRecursive(s,o.excludes):this.watchNonRecursive(s)}watchRecursive(s,o){const h={path:this.toFilePath(s),excludes:o},f=c.insert(this.recursiveFoldersToWatch,h);return this.refreshRecursiveWatchers(),m.toDisposable(()=>{f(),this.refreshRecursiveWatchers()})}refreshRecursiveWatchers(){this.recursiveWatchRequestDelayer.trigger(async()=>{this.doRefreshRecursiveWatchers()})}doRefreshRecursiveWatchers(){var s,o,h;if(this.recursiveWatcher instanceof D.FileWatcher)this.recursiveWatcher.setFolders(this.recursiveFoldersToWatch);else if(m.dispose(this.recursiveWatcher),this.recursiveWatcher=void 0,this.recursiveFoldersToWatch.length>0){let f,d;((o=(s=this.options)===null||s===void 0?void 0:s.watcher)===null||o===void 0?void 0:o.usePolling)?(f=g.FileWatcher,d=(h=this.options)===null||h===void 0?void 0:h.watcher):this.recursiveFoldersToWatch.length===1?S.isWindows?f=v.FileWatcher:f=g.FileWatcher:f=D.FileWatcher,this.recursiveWatcher=new f(this.recursiveFoldersToWatch,M=>this._onDidChangeFile.fire(y.toFileChanges(M)),M=>{M.type==="error"&&this._onDidWatchErrorOccur.fire(M.message),this.logService[M.type](M.message)},this.logService.getLevel()===I.LogLevel.Trace,d),this.recursiveWatcherLogLevelListener||(this.recursiveWatcherLogLevelListener=this.logService.onDidChangeLogLevel(()=>{this.recursiveWatcher&&this.recursiveWatcher.setVerboseLogging(this.logService.getLevel()===I.LogLevel.Trace)}))}}watchNonRecursive(s){const o=new b.FileWatcher(this.toFilePath(s),f=>this._onDidChangeFile.fire(y.toFileChanges(f)),f=>{f.type==="error"&&this._onDidWatchErrorOccur.fire(f.message),this.logService[f.type](f.message)},this.logService.getLevel()===I.LogLevel.Trace),h=this.logService.onDidChangeLogLevel(()=>{o.setVerboseLogging(this.logService.getLevel()===I.LogLevel.Trace)});return m.combinedDisposable(o,h)}toFilePath(s){return n.normalize(s.fsPath)}toFileSystemProviderError(s){if(s instanceof L.FileSystemProviderError)return s;let o;switch(s.code){case"ENOENT":o=L.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":o=L.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":o=L.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":o=L.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":o=L.FileSystemProviderErrorCode.NoPermissions;break;default:o=L.FileSystemProviderErrorCode.Unknown}return L.createFileSystemProviderError(s,o)}async toFileSystemProviderWriteError(s,o){let h=this.toFileSystemProviderError(o);if(s&&h.code===L.FileSystemProviderErrorCode.NoPermissions)try{const{stat:f}=await E.SymlinkSupport.stat(this.toFilePath(s));f.mode&128||(h=L.createFileSystemProviderError(o,L.FileSystemProviderErrorCode.FileWriteLocked))}catch(f){this.logService.trace(f)}return h}dispose(){super.dispose(),m.dispose(this.recursiveWatcher),this.recursiveWatcher=void 0,m.dispose(this.recursiveWatcherLogLevelListener),this.recursiveWatcherLogLevelListener=void 0}}e.DiskFileSystemProvider=t}),define(J[22],Z([0,1,4]),function(z,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProductService=void 0,e.IProductService=m.createDecorator("productService")}),define(J[183],Z([0,1,58,6,22]),function(z,e,m,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionUrlTrustService=void 0;let S=class{constructor(n,w){this.productService=n,this.logService=w,this.trustedExtensionUrlPublicKeys=new Map}async isExtensionUrlTrusted(n,w){if(!this.productService.trustedExtensionUrlPublicKeys)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","There are no configured trusted keys"),!1;const p=/^(.*)#([^#]+)$/.exec(w);if(!p)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri has no fragment",w),!1;const[,i,I]=p;let P=this.trustedExtensionUrlPublicKeys.get(n);if(!P){if(P=this.productService.trustedExtensionUrlPublicKeys[n],!P||P.length===0)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Extension doesn't have any trusted keys",n),!1;this.trustedExtensionUrlPublicKeys.set(n,[...P])}const y=Buffer.from(decodeURIComponent(I),"base64");if(y.length<=6)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri fragment is not a signature",w),!1;const g=y.slice(0,6),v=y.readUIntBE(0,6),D=Date.now()-v;if(D<0||D>36e5)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri has expired",w),!1;const b=y.slice(6),l=m.createVerify("SHA256");l.write(g),l.write(Buffer.from(i)),l.end();for(let u=0;u<P.length;u++){let c=P[u];if(c!==null){if(typeof c=="string")try{c=m.createPublicKey({key:Buffer.from(c,"base64"),format:"der",type:"spki"}),P[u]=c}catch(a){this.logService.warn("ExtensionUrlTrustService#isExtensionUrlTrusted",`Failed to parse trusted extension uri public key #${u+1} for ${n}:`,a),P[u]=null;continue}if(l.verify(c,b))return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri is valid",w),!0}}return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri could not be verified",w),!1}};S=he([ee(0,A.IProductService),ee(1,L.ILogService)],S),e.ExtensionUrlTrustService=S}),define(J[55],Z([0,1,4]),function(z,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProtocolMainService=void 0,e.IProtocolMainService=m.createDecorator("protocolMainService")}),define(J[184],Z([0,1,2,10,7,53,14,6,36,3,15,27]),function(z,e,m,L,A,S,E,n,w,p,i,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProtocolMainService=void 0;let P=class extends m.Disposable{constructor(g,v){super();this.logService=v,this.validRoots=w.TernarySearchTree.forUris(()=>!p.isLinux),this.validExtensions=new Set([".svg",".png",".jpg",".jpeg",".gif",".bmp"]),this.addValidFileRoot(A.URI.file(g.appRoot)),this.addValidFileRoot(A.URI.file(g.extensionsPath)),this.addValidFileRoot(g.globalStorageHome),this.addValidFileRoot(g.workspaceStorageHome),this.handleProtocols()}handleProtocols(){const{defaultSession:g}=E.session;g.protocol.registerFileProtocol(L.Schemas.vscodeFileResource,(v,D)=>this.handleResourceRequest(v,D)),g.protocol.interceptFileProtocol(L.Schemas.file,(v,D)=>this.handleFileRequest(v,D)),this._register(m.toDisposable(()=>{g.protocol.unregisterProtocol(L.Schemas.vscodeFileResource),g.protocol.uninterceptProtocol(L.Schemas.file)}))}addValidFileRoot(g){return this.validRoots.get(g)?m.Disposable.None:(this.validRoots.set(g,!0),m.toDisposable(()=>this.validRoots.delete(g)))}handleFileRequest(g,v){const D=A.URI.parse(g.url);return p.isPreferringBrowserCodeLoad?(this.logService.error(`Refused to load resource ${D.fsPath} from ${L.Schemas.file}: protocol (original URL: ${g.url})`),v({error:-3})):this.validRoots.findSubstr(D)?v({path:D.fsPath}):this.validExtensions.has(i.extname(D))?v({path:D.fsPath}):(this.logService.error(`${L.Schemas.file}: Refused to load resource ${D.fsPath} from ${L.Schemas.file}: protocol (original URL: ${g.url})`),v({error:-3}))}handleResourceRequest(g,v){const D=A.URI.parse(g.url),b=L.FileAccess.asFileUri(D);return this.validRoots.findSubstr(b)?v({path:b.fsPath}):this.validExtensions.has(i.extname(b))?v({path:b.fsPath}):(this.logService.error(`${L.Schemas.vscodeFileResource}: Refused to load resource ${b.fsPath} from ${L.Schemas.vscodeFileResource}: protocol (original URL: ${g.url})`),v({error:-3}))}createIPCObjectUrl(){let g;const v=A.URI.from({scheme:"vscode",path:I.generateUuid()}),D=v.toString(),b=async()=>g;return E.ipcMain.handle(D,b),this.logService.trace(`IPC Object URL: Registered new channel ${D}.`),{resource:v,update:l=>g=l,dispose:()=>{this.logService.trace(`IPC Object URL: Removed channel ${D}.`),E.ipcMain.removeHandler(D)}}}};P=he([ee(0,S.INativeEnvironmentService),ee(1,n.ILogService)],P),e.ProtocolMainService=P}),define(J[37],Z([0,1,13,102]),function(z,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class A{constructor(){this.data=new Map}add(E,n){L.ok(m.isString(E)),L.ok(m.isObject(n)),L.ok(!this.data.has(E),"There is already an extension with this id"),this.data.set(E,n)}knows(E){return this.data.has(E)}as(E){return this.data.get(E)||null}}e.Registry=new A}),define(J[185],Z([0,1,37,5]),function(z,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function A(n){return n.length>0&&n.charAt(n.length-1)==="#"?n.substring(0,n.length-1):n}class S{constructor(){this._onDidChangeSchema=new L.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(w,p){this.schemasById[A(w)]=p,this._onDidChangeSchema.fire(w)}notifySchemaChanged(w){this._onDidChangeSchema.fire(w)}getSchemaContributions(){return{schemas:this.schemasById}}}const E=new S;m.Registry.add(e.Extensions.JSONContribution,E)}),define(J[48],Z([0,1,132,5,37,13,185]),function(z,e,m,L,A,S,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.overrideIdentifierFromKey=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=void 0,e.Extensions={Configuration:"base.contributions.configuration"};var n;(function(D){D[D.APPLICATION=1]="APPLICATION",D[D.MACHINE=2]="MACHINE",D[D.WINDOW=3]="WINDOW",D[D.RESOURCE=4]="RESOURCE",D[D.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",D[D.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(n=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const w=A.Registry.as(E.Extensions.JSONContribution);class p{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new L.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new L.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:m.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},w.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(b,l=!0){this.registerConfigurations([b],l)}registerConfigurations(b,l=!0){const u=[];b.forEach(c=>{u.push(...this.validateAndRegisterProperties(c,l,c.extensionInfo)),this.configurationContributors.push(c),this.registerJSONConfiguration(c)}),w.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(u)}deregisterConfigurations(b){const l=[],u=c=>{if(c.properties)for(const a in c.properties)l.push(a),delete this.configurationProperties[a],this.removeFromSchema(a,c.properties[a]);c.allOf&&c.allOf.forEach(a=>u(a))};for(const c of b){u(c);const a=this.configurationContributors.indexOf(c);a!==-1&&this.configurationContributors.splice(a,1)}w.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(l)}registerDefaultConfigurations(b){const l=[],u=[];for(const c of b)for(const a in c)if(l.push(a),e.OVERRIDE_PROPERTY_PATTERN.test(a)){this.defaultValues[a]=Object.assign(Object.assign({},this.defaultValues[a]||{}),c[a]);const t={type:"object",default:this.defaultValues[a],description:m.localize(1,null,a),$ref:e.resourceLanguageSettingsSchemaId};u.push(I(a)),this.configurationProperties[a]=t,this.defaultLanguageConfigurationOverridesNode.properties[a]=t}else{this.defaultValues[a]=c[a];const t=this.configurationProperties[a];t&&(this.updatePropertyDefaultValue(a,t),this.updateSchema(a,t))}this.registerOverrideIdentifiers(u),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(l)}deregisterDefaultConfigurations(b){const l=[];for(const u of b)for(const c in u)if(l.push(c),delete this.defaultValues[c],e.OVERRIDE_PROPERTY_PATTERN.test(c))delete this.configurationProperties[c],delete this.defaultLanguageConfigurationOverridesNode.properties[c];else{const a=this.configurationProperties[c];a&&(this.updatePropertyDefaultValue(c,a),this.updateSchema(c,a))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(l)}notifyConfigurationSchemaUpdated(...b){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(b){for(const l of b)this.overrideIdentifiers.add(l);this.updateOverridePropertyPatternKey()}validateAndRegisterProperties(b,l=!0,u,c=3){var a;c=S.isUndefinedOrNull(b.scope)?c:b.scope;let t=[],r=b.properties;if(r)for(let o in r){if(l&&g(o)){delete r[o];continue}const h=r[o];if(this.updatePropertyDefaultValue(o,h),e.OVERRIDE_PROPERTY_PATTERN.test(o)?h.scope=void 0:(h.scope=S.isUndefinedOrNull(h.scope)?c:h.scope,h.restricted=S.isUndefinedOrNull(h.restricted)?!!((a=u==null?void 0:u.restrictedConfigurations)===null||a===void 0?void 0:a.includes(o)):h.restricted),r[o].hasOwnProperty("included")&&!r[o].included){this.excludedConfigurationProperties[o]=r[o],delete r[o];continue}else this.configurationProperties[o]=r[o];!r[o].deprecationMessage&&r[o].markdownDeprecationMessage&&(r[o].deprecationMessage=r[o].markdownDeprecationMessage),t.push(o)}let s=b.allOf;if(s)for(let o of s)t.push(...this.validateAndRegisterProperties(o,l,u,c));return t}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(b){const l=u=>{let c=u.properties;if(c)for(const t in c)this.updateSchema(t,c[t]);let a=u.allOf;a&&a.forEach(l)};l(b)}updateSchema(b,l){switch(e.allSettings.properties[b]=l,l.scope){case 1:e.applicationSettings.properties[b]=l;break;case 2:e.machineSettings.properties[b]=l;break;case 6:e.machineOverridableSettings.properties[b]=l;break;case 3:e.windowSettings.properties[b]=l;break;case 4:e.resourceSettings.properties[b]=l;break;case 5:e.resourceSettings.properties[b]=l,this.resourceLanguageSettingsSchema.properties[b]=l;break}}removeFromSchema(b,l){switch(delete e.allSettings.properties[b],l.scope){case 1:delete e.applicationSettings.properties[b];break;case 2:delete e.machineSettings.properties[b];break;case 6:delete e.machineOverridableSettings.properties[b];break;case 3:delete e.windowSettings.properties[b];break;case 4:case 5:delete e.resourceSettings.properties[b];break}}updateOverridePropertyPatternKey(){for(const b of this.overrideIdentifiers.values()){const l=`[${b}]`,u={type:"object",description:m.localize(2,null),errorMessage:m.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(l,u),e.allSettings.properties[l]=u,e.applicationSettings.properties[l]=u,e.machineSettings.properties[l]=u,e.machineOverridableSettings.properties[l]=u,e.windowSettings.properties[l]=u,e.resourceSettings.properties[l]=u}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(b,l){let u=this.defaultValues[b];S.isUndefined(u)&&(u=l.default),S.isUndefined(u)&&(u=P(l.type)),l.default=u}}const i="\\[.*\\]$";e.OVERRIDE_PROPERTY_PATTERN=new RegExp(i);function I(D){return D.substring(1,D.length-1)}e.overrideIdentifierFromKey=I;function P(D){switch(Array.isArray(D)?D[0]:D){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=P;const y=new p;A.Registry.add(e.Extensions.Configuration,y);function g(D){return D.trim()?e.OVERRIDE_PROPERTY_PATTERN.test(D)?m.localize(5,null,D):y.getConfigurationProperties()[D]!==void 0?m.localize(6,null,D):null:m.localize(4,null)}e.validateProperty=g;function v(){const D=[],b=y.getConfigurationProperties();for(const l of Object.keys(b))D.push([l,b[l].scope]);return D.push(["launch",4]),D.push(["task",4]),D}e.getScopes=v}),define(J[16],Z([0,1,44,13,7,37,4,48]),function(z,e,m,L,A,S,E,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.keyFromOverrideIdentifier=e.getDefaultValues=e.getConfigurationKeys=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.toOverrides=e.compare=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=E.createDecorator("configurationService");function w(r){return r&&typeof r=="object"&&(!r.overrideIdentifier||typeof r.overrideIdentifier=="string")&&(!r.resource||r.resource instanceof A.URI)}e.isConfigurationOverrides=w;var p;(function(r){r[r.USER=1]="USER",r[r.USER_LOCAL=2]="USER_LOCAL",r[r.USER_REMOTE=3]="USER_REMOTE",r[r.WORKSPACE=4]="WORKSPACE",r[r.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",r[r.DEFAULT=6]="DEFAULT",r[r.MEMORY=7]="MEMORY"})(p=e.ConfigurationTarget||(e.ConfigurationTarget={}));function i(r){switch(r){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=i;function I(r,s){const o=s?r?s.keys.filter(V=>r.keys.indexOf(V)===-1):[...s.keys]:[],h=r?s?r.keys.filter(V=>s.keys.indexOf(V)===-1):[...r.keys]:[],f=[];if(s&&r){for(const V of r.keys)if(s.keys.indexOf(V)!==-1){const Q=b(r.contents,V),te=b(s.contents,V);m.equals(Q,te)||f.push(V)}}const d=[],M=V=>{const Q={};for(const te of V)for(const B of te.identifiers)Q[a(B)]=te;return Q},T=s?M(s.overrides):{},C=r?M(r.overrides):{};if(Object.keys(T).length)for(const V of o){const Q=T[V];Q&&d.push([n.overrideIdentifierFromKey(V),Q.keys])}if(Object.keys(C).length)for(const V of h){const Q=C[V];Q&&d.push([n.overrideIdentifierFromKey(V),Q.keys])}if(Object.keys(T).length&&Object.keys(C).length)for(const V of f){const Q=C[V],te=T[V];if(Q&&te){const B=I({contents:Q.contents,keys:Q.keys,overrides:[]},{contents:te.contents,keys:te.keys,overrides:[]});d.push([n.overrideIdentifierFromKey(V),[...B.added,...B.removed,...B.updated]])}}return{added:o,removed:h,updated:f,overrides:d}}e.compare=I;function P(r,s){const o=[];for(const h of Object.keys(r))if(n.OVERRIDE_PROPERTY_PATTERN.test(h)){const f={};for(const d in r[h])f[d]=r[h][d];o.push({identifiers:[n.overrideIdentifierFromKey(h).trim()],keys:Object.keys(f),contents:y(f,s)})}return o}e.toOverrides=P;function y(r,s){const o=Object.create(null);for(let h in r)g(o,h,r[h],s);return o}e.toValuesTree=y;function g(r,s,o,h){const f=s.split("."),d=f.pop();let M=r;for(let T=0;T<f.length;T++){let C=f[T],V=M[C];switch(typeof V){case"undefined":V=M[C]=Object.create(null);break;case"object":break;default:h(`Ignoring ${s} as ${f.slice(0,T+1).join(".")} is ${JSON.stringify(V)}`);return}M=V}if(typeof M=="object"&&M!==null)try{M[d]=o}catch(T){h(`Ignoring ${s} as ${f.join(".")} is ${JSON.stringify(M)}`)}else h(`Ignoring ${s} as ${f.join(".")} is ${JSON.stringify(M)}`)}e.addToValueTree=g;function v(r,s){const o=s.split(".");D(r,o)}e.removeFromValueTree=v;function D(r,s){const o=s.shift();if(s.length===0){delete r[o];return}if(Object.keys(r).indexOf(o)!==-1){const h=r[o];typeof h=="object"&&!Array.isArray(h)&&(D(h,s),Object.keys(h).length===0&&delete r[o])}}function b(r,s,o){function h(M,T){let C=M;for(const V of T){if(typeof C!="object"||C===null)return;C=C[V]}return C}const f=s.split("."),d=h(r,f);return typeof d=="undefined"?o:d}e.getConfigurationValue=b;function l(r,s,o){Object.keys(s).forEach(h=>{h!=="__proto__"&&(h in r?L.isObject(r[h])&&L.isObject(s[h])?l(r[h],s[h],o):o&&(r[h]=s[h]):r[h]=s[h])})}e.merge=l;function u(){const r=S.Registry.as(n.Extensions.Configuration).getConfigurationProperties();return Object.keys(r)}e.getConfigurationKeys=u;function c(){const r=Object.create(null),s=S.Registry.as(n.Extensions.Configuration).getConfigurationProperties();for(let o in s){let h=s[o].default;g(r,o,h,f=>console.error(`Conflict in default settings: ${f}`))}return r}e.getDefaultValues=c;function a(r){return`[${r}]`}e.keyFromOverrideIdentifier=a;function t(r,s,o){const h=r.inspect(s),f=r.inspect(o);return typeof h.userValue!="undefined"||typeof h.workspaceValue!="undefined"||typeof h.workspaceFolderValue!="undefined"?h.value:typeof f.userValue!="undefined"||typeof f.workspaceValue!="undefined"||typeof f.workspaceFolderValue!="undefined"?f.value:h.defaultValue}e.getMigratedSettingValue=t}),define(J[186],Z([0,1,43,36,35,13,44,7,48,16,37,2,5]),function(z,e,m,L,A,S,E,n,w,p,i,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class y{constructor(t={},r=[],s=[]){this._contents=t,this._keys=r,this._overrides=s,this.isFrozen=!1}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(t){return t?p.getConfigurationValue(this.contents,t):this.contents}getOverrideValue(t,r){const s=this.getContentsForOverrideIdentifer(r);return s?t?p.getConfigurationValue(s,t):s:void 0}getKeysForOverrideIdentifier(t){for(const r of this.overrides)if(r.identifiers.indexOf(t)!==-1)return r.keys;return[]}override(t){const r=this.getContentsForOverrideIdentifer(t);if(!r||typeof r!="object"||!Object.keys(r).length)return this;let s={};for(const o of A.distinct([...Object.keys(this.contents),...Object.keys(r)])){let h=this.contents[o],f=r[o];f&&(typeof h=="object"&&typeof f=="object"?(h=E.deepClone(h),this.mergeContents(h,f)):h=f),s[o]=h}return new y(s,this.keys,this.overrides)}merge(...t){const r=E.deepClone(this.contents),s=E.deepClone(this.overrides),o=[...this.keys];for(const h of t){this.mergeContents(r,h.contents);for(const f of h.overrides){const[d]=s.filter(M=>A.equals(M.identifiers,f.identifiers));d?this.mergeContents(d.contents,f.contents):s.push(E.deepClone(f))}for(const f of h.keys)o.indexOf(f)===-1&&o.push(f)}return new y(r,o,s)}freeze(){return this.isFrozen=!0,this}mergeContents(t,r){for(const s of Object.keys(r)){if(s in t&&S.isObject(t[s])&&S.isObject(r[s])){this.mergeContents(t[s],r[s]);continue}t[s]=E.deepClone(r[s])}}checkAndFreeze(t){return this.isFrozen&&!Object.isFrozen(t)?E.deepFreeze(t):t}getContentsForOverrideIdentifer(t){for(const r of this.overrides)if(r.identifiers.indexOf(t)!==-1)return r.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(t,r){this.addKey(t),p.addToValueTree(this.contents,t,r,s=>{throw new Error(s)})}removeValue(t){this.removeKey(t)&&p.removeFromValueTree(this.contents,t)}addKey(t){let r=this.keys.length;for(let s=0;s<r;s++)t.indexOf(this.keys[s])===0&&(r=s);this.keys.splice(r,1,t)}removeKey(t){let r=this.keys.indexOf(t);return r!==-1?(this.keys.splice(r,1),!0):!1}}e.ConfigurationModel=y;class g extends y{constructor(){const t=p.getDefaultValues(),r=p.getConfigurationKeys(),s=[];for(const o of Object.keys(t))w.OVERRIDE_PROPERTY_PATTERN.test(o)&&s.push({identifiers:[w.overrideIdentifierFromKey(o).trim()],keys:Object.keys(t[o]),contents:p.toValuesTree(t[o],h=>console.error(`Conflict in default settings file: ${h}`))});super(t,r,s)}}e.DefaultConfigurationModel=g;class v{constructor(t){this._name=t,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new y}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(t,r){if(!S.isUndefinedOrNull(t)){const s=this.doParseContent(t);this.parseRaw(s,r)}}reparse(t){this._raw&&this.parseRaw(this._raw,t)}parseRaw(t,r){this._raw=t;const{contents:s,keys:o,overrides:h,restricted:f}=this.doParseRaw(t,r);this._configurationModel=new y(s,o,h),this._restrictedConfigurations=f||[]}doParseContent(t){let r={},s=null,o=[],h=[],f=[];function d(T){Array.isArray(o)?o.push(T):s&&(o[s]=T)}let M={onObjectBegin:()=>{let T={};d(T),h.push(o),o=T,s=null},onObjectProperty:T=>{s=T},onObjectEnd:()=>{o=h.pop()},onArrayBegin:()=>{let T=[];d(T),h.push(o),o=T,s=null},onArrayEnd:()=>{o=h.pop()},onLiteralValue:d,onError:(T,C,V)=>{f.push({error:T,offset:C,length:V})}};if(t)try{m.visit(t,M),r=o[0]||{}}catch(T){console.error(`Error while parsing settings file ${this._name}: ${T}`),this._parseErrors=[T]}return r}doParseRaw(t,r){const s=i.Registry.as(w.Extensions.Configuration).getConfigurationProperties(),o=this.filter(t,s,!0,r);t=o.raw;const h=p.toValuesTree(t,M=>console.error(`Conflict in settings file ${this._name}: ${M}`)),f=Object.keys(t),d=p.toOverrides(t,M=>console.error(`Conflict in settings file ${this._name}: ${M}`));return{contents:h,keys:f,overrides:d,restricted:o.restricted}}filter(t,r,s,o){if(!(o==null?void 0:o.scopes)&&!(o==null?void 0:o.skipRestricted))return{raw:t,restricted:[]};const h={},f=[];for(let d in t)if(w.OVERRIDE_PROPERTY_PATTERN.test(d)&&s){const M=this.filter(t[d],r,!1,o);h[d]=M.raw,f.push(...M.restricted)}else{const M=r[d],T=M?typeof M.scope!="undefined"?M.scope:3:void 0;(M==null?void 0:M.restricted)&&f.push(d),(T===void 0||o.scopes===void 0||o.scopes.includes(T))&&(o.skipRestricted&&(M==null?void 0:M.restricted)||(h[d]=t[d]))}return{raw:h,restricted:f}}}e.ConfigurationModelParser=v;class D extends I.Disposable{constructor(t,r,s,o){super();this.userSettingsResource=t,this.scopes=r,this.fileService=o,this._onDidChange=this._register(new P.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new v(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(s.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(P.Event.filter(this.fileService.onDidFilesChange,h=>h.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const t=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(t.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(t){return new y}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=D;class b{constructor(t,r,s=new y,o=new y,h=new L.ResourceMap,f=new y,d=new L.ResourceMap,M=!0){this._defaultConfiguration=t,this._localUserConfiguration=r,this._remoteUserConfiguration=s,this._workspaceConfiguration=o,this._folderConfigurations=h,this._memoryConfiguration=f,this._memoryConfigurationByResource=d,this._freeze=M,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new L.ResourceMap,this._userConfiguration=null}getValue(t,r,s){return this.getConsolidateConfigurationModel(r,s).getValue(t)}updateValue(t,r,s={}){let o;s.resource?(o=this._memoryConfigurationByResource.get(s.resource),o||(o=new y,this._memoryConfigurationByResource.set(s.resource,o))):o=this._memoryConfiguration,r===void 0?o.removeValue(t):o.setValue(t,r),s.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(t,r,s){const o=this.getConsolidateConfigurationModel(r,s),h=this.getFolderConfigurationModelForResource(r.resource,s),f=r.resource?this._memoryConfigurationByResource.get(r.resource)||this._memoryConfiguration:this._memoryConfiguration,d=r.overrideIdentifier?this._defaultConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this._defaultConfiguration.freeze().getValue(t),M=r.overrideIdentifier?this.userConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this.userConfiguration.freeze().getValue(t),T=r.overrideIdentifier?this.localUserConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this.localUserConfiguration.freeze().getValue(t),C=r.overrideIdentifier?this.remoteUserConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this.remoteUserConfiguration.freeze().getValue(t),V=s?r.overrideIdentifier?this._workspaceConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this._workspaceConfiguration.freeze().getValue(t):void 0,Q=h?r.overrideIdentifier?h.freeze().override(r.overrideIdentifier).getValue(t):h.freeze().getValue(t):void 0,te=r.overrideIdentifier?f.override(r.overrideIdentifier).getValue(t):f.getValue(t),B=o.getValue(t),Y=A.distinct(A.flatten(o.overrides.map(X=>X.identifiers))).filter(X=>o.getOverrideValue(t,X)!==void 0);return{defaultValue:d,userValue:M,userLocalValue:T,userRemoteValue:C,workspaceValue:V,workspaceFolderValue:Q,memoryValue:te,value:B,default:d!==void 0?{value:this._defaultConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,user:M!==void 0?{value:this.userConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,userLocal:T!==void 0?{value:this.localUserConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,userRemote:C!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,workspace:V!==void 0?{value:this._workspaceConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,workspaceFolder:Q!==void 0?{value:h==null?void 0:h.freeze().getValue(t),override:r.overrideIdentifier?h==null?void 0:h.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,memory:te!==void 0?{value:f.getValue(t),override:r.overrideIdentifier?f.getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,overrideIdentifiers:Y.length?Y:void 0}}keys(t){const r=this.getFolderConfigurationModelForResource(void 0,t);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:r?r.freeze().keys:[]}}updateDefaultConfiguration(t){this._defaultConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(t){this._localUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(t){this._remoteUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(t){this._workspaceConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(t,r){this._folderConfigurations.set(t,r),this._foldersConsolidatedConfigurations.delete(t)}deleteFolderConfiguration(t){this.folderConfigurations.delete(t),this._foldersConsolidatedConfigurations.delete(t)}compareAndUpdateDefaultConfiguration(t,r){const s=r.filter(o=>w.OVERRIDE_PROPERTY_PATTERN.test(o)).map(o=>{const h=w.overrideIdentifierFromKey(o),f=this._defaultConfiguration.getKeysForOverrideIdentifier(h),d=t.getKeysForOverrideIdentifier(h),M=[...d.filter(T=>f.indexOf(T)===-1),...f.filter(T=>d.indexOf(T)===-1),...f.filter(T=>!E.equals(this._defaultConfiguration.override(h).getValue(T),t.override(h).getValue(T)))];return[h,M]});return this.updateDefaultConfiguration(t),{keys:r,overrides:s}}compareAndUpdateLocalUserConfiguration(t){const{added:r,updated:s,removed:o,overrides:h}=p.compare(this.localUserConfiguration,t),f=[...r,...s,...o];return f.length&&this.updateLocalUserConfiguration(t),{keys:f,overrides:h}}compareAndUpdateRemoteUserConfiguration(t){const{added:r,updated:s,removed:o,overrides:h}=p.compare(this.remoteUserConfiguration,t);let f=[...r,...s,...o];return f.length&&this.updateRemoteUserConfiguration(t),{keys:f,overrides:h}}compareAndUpdateWorkspaceConfiguration(t){const{added:r,updated:s,removed:o,overrides:h}=p.compare(this.workspaceConfiguration,t);let f=[...r,...s,...o];return f.length&&this.updateWorkspaceConfiguration(t),{keys:f,overrides:h}}compareAndUpdateFolderConfiguration(t,r){const s=this.folderConfigurations.get(t),{added:o,updated:h,removed:f,overrides:d}=p.compare(s,r);let M=[...o,...h,...f];return(M.length||!s)&&this.updateFolderConfiguration(t,r),{keys:M,overrides:d}}compareAndDeleteFolderConfiguration(t){const r=this.folderConfigurations.get(t);if(!r)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:s,updated:o,removed:h,overrides:f}=p.compare(r,void 0);return{keys:[...s,...o,...h],overrides:f}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(t,r){let s=this.getConsolidatedConfigurationModelForResource(t,r);return t.overrideIdentifier?s.override(t.overrideIdentifier):s}getConsolidatedConfigurationModelForResource({resource:t},r){let s=this.getWorkspaceConsolidatedConfiguration();if(r&&t){const o=r.getFolder(t);o&&(s=this.getFolderConsolidatedConfiguration(o.uri)||s);const h=this._memoryConfigurationByResource.get(t);h&&(s=s.merge(h))}return s}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(t){let r=this._foldersConsolidatedConfigurations.get(t);if(!r){const s=this.getWorkspaceConsolidatedConfiguration(),o=this._folderConfigurations.get(t);o?(r=s.merge(o),this._freeze&&(r=r.freeze()),this._foldersConsolidatedConfigurations.set(t,r)):r=s}return r}getFolderConfigurationModelForResource(t,r){if(r&&t){const s=r.getFolder(t);if(s)return this._folderConfigurations.get(s.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((t,r)=>{const{contents:s,overrides:o,keys:h}=this._folderConfigurations.get(r);return t.push([r,{contents:s,overrides:o,keys:h}]),t},[])}}allKeys(){const t=new Set;return this._defaultConfiguration.freeze().keys.forEach(r=>t.add(r)),this.userConfiguration.freeze().keys.forEach(r=>t.add(r)),this._workspaceConfiguration.freeze().keys.forEach(r=>t.add(r)),this._folderConfigurations.forEach(r=>r.freeze().keys.forEach(s=>t.add(s))),[...t.values()]}getAllKeysForOverrideIdentifier(t){const r=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(t).forEach(s=>r.add(s)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(s=>r.add(s)),this._workspaceConfiguration.getKeysForOverrideIdentifier(t).forEach(s=>r.add(s)),this._folderConfigurations.forEach(s=>s.getKeysForOverrideIdentifier(t).forEach(o=>r.add(o))),[...r.values()]}static parse(t){const r=this.parseConfigurationModel(t.defaults),s=this.parseConfigurationModel(t.user),o=this.parseConfigurationModel(t.workspace),h=t.folders.reduce((f,d)=>(f.set(n.URI.revive(d[0]),this.parseConfigurationModel(d[1])),f),new L.ResourceMap);return new b(r,s,new y,o,h,new y,new L.ResourceMap,!1)}static parseConfigurationModel(t){return new y(t.contents,t.keys,t.overrides).freeze()}}e.Configuration=b;function l(...a){if(a.length===0)return{keys:[],overrides:[]};if(a.length===1)return a[0];const t=new Set,r=new Map;for(const o of a)o.keys.forEach(h=>t.add(h)),o.overrides.forEach(([h,f])=>{const d=L.getOrSet(r,h,new Set);f.forEach(M=>d.add(M))});const s=[];return r.forEach((o,h)=>s.push([h,[...o.values()]])),{keys:[...t.values()],overrides:s}}e.mergeChanges=l;class u{constructor(t,r,s,o){this.change=t,this.previous=r,this.currentConfiguraiton=s,this.currentWorkspace=o,this._previousConfiguration=void 0;const h=new Set;t.keys.forEach(d=>h.add(d)),t.overrides.forEach(([,d])=>d.forEach(M=>h.add(M))),this.affectedKeys=[...h.values()];const f=new y;this.affectedKeys.forEach(d=>f.setValue(d,{})),this.affectedKeysTree=f.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=b.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(t,r){var s;if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,t)){if(r){const o=this.previousConfiguration?this.previousConfiguration.getValue(t,r,(s=this.previous)===null||s===void 0?void 0:s.workspace):void 0,h=this.currentConfiguraiton.getValue(t,r,this.currentWorkspace);return!E.equals(o,h)}return!0}return!1}doesAffectedKeysTreeContains(t,r){let s=p.toValuesTree({[r]:!0},()=>{}),o;for(;typeof s=="object"&&(o=Object.keys(s)[0]);){if(t=t[o],!t)return!1;s=s[o]}return!0}}e.ConfigurationChangeEvent=u;class c extends u{constructor(t,r,s,o){super({keys:t.allKeys(),overrides:[]},void 0,t,r);this.source=s,this.sourceConfig=o}}e.AllKeysConfigurationChangeEvent=c}),define(J[187],Z([0,1,37,48,2,16,186,5,9,15]),function(z,e,m,L,A,S,E,n,w,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class i extends A.Disposable{constructor(P,y){super();this.settingsResource=P,this._onDidChangeConfiguration=this._register(new n.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.userConfiguration=this._register(new E.UserSettings(this.settingsResource,void 0,p.extUriBiasedIgnorePathCase,y)),this.configuration=new E.Configuration(new E.DefaultConfigurationModel,new E.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new w.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(m.Registry.as(L.Extensions.Configuration).onDidUpdateConfiguration(g=>this.onDidDefaultConfigurationChange(g))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const P=await this.userConfiguration.loadConfiguration();this.configuration=new E.Configuration(new E.DefaultConfigurationModel,P)}getConfigurationData(){return this.configuration.toData()}getValue(P,y){const g=typeof P=="string"?P:void 0,v=S.isConfigurationOverrides(P)?P:S.isConfigurationOverrides(y)?y:{};return this.configuration.getValue(g,v,void 0)}updateValue(P,y,g,v){return Promise.reject(new Error("not supported"))}inspect(P){return this.configuration.inspect(P,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const P=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(P)}onDidChangeUserConfiguration(P){const y=this.configuration.toData(),g=this.configuration.compareAndUpdateLocalUserConfiguration(P);this.trigger(g,y,1)}onDidDefaultConfigurationChange(P){const y=this.configuration.toData(),g=this.configuration.compareAndUpdateDefaultConfiguration(new E.DefaultConfigurationModel,P);this.trigger(g,y,6)}trigger(P,y,g){const v=new E.ConfigurationChangeEvent(P,{data:y},this.configuration);v.source=g,v.sourceConfig=this.getTargetConfiguration(g),this._onDidChangeConfiguration.fire(v)}getTargetConfiguration(P){switch(P){case 6:return this.configuration.defaults.contents;case 1:return this.configuration.localUserConfiguration.contents}return{}}}e.ConfigurationService=i}),define(J[188],Z([0,1,40,8,68,138,17,3,90,16,4,10,105]),function(z,e,m,L,A,S,E,n,w,p,i,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const y=S.localize(0,null);class g{async getDefaultTerminalForPlatforms(){const t=await b.getDefaultTerminalLinuxReady();return{windows:v.getDefaultTerminalWindows(),linux:t,osx:"xterm"}}}let v=class Ze extends g{constructor(t){super();this._configurationService=t}openTerminal(t){const r=this._configurationService.getValue();return this.spawnTerminal(m,r,A.getWindowsShell(),t)}spawnTerminal(t,r,s,o){const h=r.terminal.external,f=(h==null?void 0:h.windowsExec)||Ze.getDefaultTerminalWindows();o&&o[1]===":"&&(o=o[0].toUpperCase()+o.substr(1));const d=L.basename(f).toLowerCase();if(d==="cmder"||d==="cmder.exe")return t.spawn(f,o?[o]:void 0),Promise.resolve(void 0);const M=["/c","start","/wait"];return f.indexOf(" ")>=0&&M.push('""'),M.push(f),(d==="wt"||d==="wt.exe")&&M.push("-d ."),new Promise((T,C)=>{const V=l(process),Q=t.spawn(s,M,{cwd:o,env:V});Q.on("error",C),Q.on("exit",()=>T())})}runInTerminal(t,r,s,o,h){const f="windowsExec"in h&&h.windowsExec?h.windowsExec:Ze.getDefaultTerminalWindows();return new Promise((d,M)=>{const T=`"${r} - ${y}"`,C=`""${s.join('" "')}" & pause"`,V=["/c","start",T,"/wait",f,"/c",C],Q=Object.assign({},l(process),o);Object.keys(Q).filter(Y=>Q[Y]===null).forEach(Y=>delete Q[Y]);const te={cwd:r,env:Q,windowsVerbatimArguments:!0};m.spawn(Ze.CMD,V,te).on("error",Y=>{M(u(Y))}),d(void 0)})}static getDefaultTerminalWindows(){if(!Ze._DEFAULT_TERMINAL_WINDOWS){const t=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");Ze._DEFAULT_TERMINAL_WINDOWS=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${t?"Sysnative":"System32"}\\cmd.exe`}return Ze._DEFAULT_TERMINAL_WINDOWS}};v.CMD="cmd.exe",v=he([ee(0,i.optional(p.IConfigurationService))],v),e.WindowsExternalTerminalService=v;let D=class It extends g{constructor(t){super();this._configurationService=t}openTerminal(t){const r=this._configurationService.getValue();return this.spawnTerminal(m,r,t)}runInTerminal(t,r,s,o,h){const f=h.osxExec||w.DEFAULT_TERMINAL_OSX;return new Promise((d,M)=>{if(f===w.DEFAULT_TERMINAL_OSX||f==="iTerm.app"){const T=f===w.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",V=[I.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${T}.scpt`,z).fsPath,"-t",t||y,"-w",r];for(let B of s)V.push("-a"),V.push(B);if(o)for(let B in o){const Y=o[B];Y===null?(V.push("-u"),V.push(B)):(V.push("-e"),V.push(`${B}=${Y}`))}let Q="";const te=m.spawn(It.OSASCRIPT,V);te.on("error",B=>{M(u(B))}),te.stderr.on("data",B=>{Q+=B.toString()}),te.on("exit",B=>{if(B===0)d(void 0);else if(Q){const Y=Q.split(`
`,1);M(new Error(Y[0]))}else M(new Error(S.localize(1,null,T,B)))})}else M(new Error(S.localize(2,null,f)))})}spawnTerminal(t,r,s){const o=r.terminal.external,h=(o==null?void 0:o.osxExec)||w.DEFAULT_TERMINAL_OSX;return new Promise((f,d)=>{const M=["-a",h];s&&M.push(s);const T=t.spawn("/usr/bin/open",M);T.on("error",d),T.on("exit",()=>f())})}};D.OSASCRIPT="/usr/bin/osascript",D=he([ee(0,i.optional(p.IConfigurationService))],D),e.MacExternalTerminalService=D;let b=class xe extends g{constructor(t){super();this._configurationService=t}openTerminal(t){const r=this._configurationService.getValue();return this.spawnTerminal(m,r,t)}runInTerminal(t,r,s,o,h){const f=h.linuxExec?Promise.resolve(h.linuxExec):xe.getDefaultTerminalLinuxReady();return new Promise((d,M)=>{let T=[];f.then(C=>{C.indexOf("gnome-terminal")>=0?T.push("-x"):T.push("-e"),T.push("bash"),T.push("-c");const V=`${c(s)}; echo; read -p "${xe.WAIT_MESSAGE}" -n1;`;T.push(`''${V}''`);const Q=Object.assign({},process.env,o);Object.keys(Q).filter(X=>Q[X]===null).forEach(X=>delete Q[X]);const te={cwd:r,env:Q};let B="";const Y=m.spawn(C,T,te);Y.on("error",X=>{M(u(X))}),Y.stderr.on("data",X=>{B+=X.toString()}),Y.on("exit",X=>{if(X===0)d(void 0);else if(B){const _=B.split(`
`,1);M(new Error(_[0]))}else M(new Error(S.localize(4,null,C,X)))})})})}static async getDefaultTerminalLinuxReady(){return xe._DEFAULT_TERMINAL_LINUX_READY||(xe._DEFAULT_TERMINAL_LINUX_READY=new Promise(async t=>{n.isLinux?await E.Promises.exists("/etc/debian_version")?t("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?t("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?t("konsole"):process.env.COLORTERM?t(process.env.COLORTERM):process.env.TERM?t(process.env.TERM):t("xterm"):t("xterm")})),xe._DEFAULT_TERMINAL_LINUX_READY}spawnTerminal(t,r,s){const o=r.terminal.external,h=(o==null?void 0:o.linuxExec)?Promise.resolve(o.linuxExec):xe.getDefaultTerminalLinuxReady();return new Promise((f,d)=>{h.then(M=>{const T=l(process),C=t.spawn(M,[],{cwd:s,env:T});C.on("error",d),C.on("exit",()=>f())})})}};b.WAIT_MESSAGE=S.localize(3,null),b=he([ee(0,i.optional(p.IConfigurationService))],b),e.LinuxExternalTerminalService=b;function l(a){const t=a.env;return P.sanitizeProcessEnvironment(t),t}function u(a){return"errno"in a&&a.errno==="ENOENT"&&"path"in a&&typeof a.path=="string"?new Error(S.localize(5,null,a.path)):a}function c(a){let t="";for(let r of a)r.indexOf(" ")>=0?t+='"'+r+'"':t+=r,t+=" ";return t}}),define(J[189],Z([0,1,4]),function(z,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=m.createDecorator("remoteAuthorityResolverService");var L;(function(S){S.Unknown="Unknown",S.NotAvailable="NotAvailable",S.TemporarilyNotAvailable="TemporarilyNotAvailable",S.NoResolverFound="NoResolverFound"})(L=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class A extends Error{constructor(E,n=L.Unknown,w){super(E);this._message=E,this._code=n,this._detail=w,this.isHandled=n===L.NotAvailable&&w===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,A.prototype)}static isTemporarilyNotAvailable(E){return E instanceof A&&E._code===L.TemporarilyNotAvailable}static isNoResolverFound(E){return E instanceof A&&E._code===L.NoResolverFound}static isHandled(E){return E instanceof A&&E.isHandled}}e.RemoteAuthorityResolverError=A}),define(J[190],Z([0,1,84,27,2,20,5,189,19,9,25]),function(z,e,m,L,A,S,E,n,w,p,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostPersistentConnection=e.ManagementPersistentConnection=e.ReconnectionPermanentFailureEvent=e.ConnectionGainEvent=e.ReconnectionRunningEvent=e.ReconnectionWaitEvent=e.ConnectionLostEvent=e.PersistentConnectionEventType=e.connectRemoteAgentTunnel=e.connectRemoteAgentExtensionHost=e.connectRemoteAgentManagement=e.ConnectionType=void 0;const I=30*1e3;var P;(function(k){k[k.Management=1]="Management",k[k.ExtensionHost=2]="ExtensionHost",k[k.Tunnel=3]="Tunnel"})(P=e.ConnectionType||(e.ConnectionType={}));function y(k){switch(k){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function g(k){const W=new i.CancellationTokenSource;return setTimeout(()=>W.cancel(),k),W.token}function v(k,W){if(k.isCancellationRequested||W.isCancellationRequested)return i.CancellationToken.Cancelled;const U=new i.CancellationTokenSource;return k.onCancellationRequested(()=>U.cancel()),W.onCancellationRequested(()=>U.cancel()),U.token}class D{constructor(W){this._state="pending",this._disposables=new A.DisposableStore,this.promise=new Promise((U,q)=>{this._resolvePromise=U,this._rejectPromise=q}),W.isCancellationRequested?this._timeout():this._disposables.add(W.onCancellationRequested(()=>this._timeout()))}get didTimeout(){return this._state==="timedout"}registerDisposable(W){this._state==="pending"?this._disposables.add(W):W.dispose()}_timeout(){this._state==="pending"&&(this._disposables.dispose(),this._state="timedout",this._rejectPromise(this._createTimeoutError()))}_createTimeoutError(){const W=new Error("Time limit reached");return W.code="ETIMEDOUT",W.syscall="connect",W}resolve(W){this._state==="pending"&&(this._disposables.dispose(),this._state="resolved",this._resolvePromise(W))}reject(W){this._state==="pending"&&(this._disposables.dispose(),this._state="rejected",this._rejectPromise(W))}}function b(k,W){const U=new D(W);return U.registerDisposable(k.onControlMessage(q=>{const K=JSON.parse(q.toString()),H=G(K);H?U.reject(H):U.resolve(K)})),U.promise}function l(k,W,U,q,K,H){const x=new D(H);return W.connect(U,q,K,(ne,re)=>{x.didTimeout?(ne&&k.error(ne),re==null||re.dispose()):ne||!re?x.reject(ne):x.resolve(re)}),x.promise}function u(k,W){const U=new D(W);return k.then(q=>{U.didTimeout||U.resolve(q)},q=>{U.didTimeout||U.reject(q)}),U.promise}async function c(k,W,U,q){const K=R(k,W);k.logService.trace(`${K} 1/6. invoking socketFactory.connect().`);let H;try{H=await l(k.logService,k.socketFactory,k.host,k.port,`reconnectionToken=${k.reconnectionToken}&reconnection=${k.reconnectionProtocol?"true":"false"}`,q)}catch(se){throw k.logService.error(`${K} socketFactory.connect() failed or timed out. Error:`),k.logService.error(se),se}k.logService.trace(`${K} 2/6. socketFactory.connect() was successful.`);let x,ne;k.reconnectionProtocol?(k.reconnectionProtocol.beginAcceptReconnection(H,null),x=k.reconnectionProtocol,ne=!1):(x=new m.PersistentProtocol(H,null),ne=!0),k.logService.trace(`${K} 3/6. sending AuthRequest control message.`);const re={type:"auth",auth:k.connectionToken||"00000000000000000000"};x.sendControl(S.VSBuffer.fromString(JSON.stringify(re)));try{const se=await b(x,v(q,g(1e4)));if(se.type!=="sign"||typeof se.data!="string"){const ue=new Error("Unexpected handshake message");throw ue.code="VSCODE_CONNECTION_ERROR",ue}k.logService.trace(`${K} 4/6. received SignRequest control message.`);const le=await u(k.signService.sign(se.data),q),oe={type:"connectionType",commit:k.commit,signedData:le,desiredConnectionType:W};return U&&(oe.args=U),k.logService.trace(`${K} 5/6. sending ConnectionTypeRequest control message.`),x.sendControl(S.VSBuffer.fromString(JSON.stringify(oe))),{protocol:x,ownsProtocol:ne}}catch(se){throw se&&se.code==="ETIMEDOUT"&&(k.logService.error(`${K} the handshake timed out. Error:`),k.logService.error(se)),se&&se.code==="VSCODE_CONNECTION_ERROR"&&(k.logService.error(`${K} received error control message when negotiating connection. Error:`),k.logService.error(se)),ne&&$(x),se}}async function a(k,W,U,q){const K=Date.now(),H=R(k,W),{protocol:x,ownsProtocol:ne}=await c(k,W,U,q),re=new D(q);return re.registerDisposable(x.onControlMessage(se=>{const le=JSON.parse(se.toString()),oe=G(le);oe?(k.logService.error(`${H} received error control message when negotiating connection. Error:`),k.logService.error(oe),ne&&$(x),re.reject(oe)):(k.reconnectionProtocol&&k.reconnectionProtocol.endAcceptReconnection(),k.logService.trace(`${H} 6/6. handshake finished, connection is up and running after ${O(K)}!`),re.resolve({protocol:x,firstMessage:le}))})),re.promise}async function t(k,W){const{protocol:U}=await a(k,1,void 0,W);return{protocol:U}}async function r(k,W,U){const{protocol:q,firstMessage:K}=await a(k,2,W,U),H=K&&K.debugPort;return{protocol:q,debugPort:H}}async function s(k,W,U){const q=Date.now(),K=R(k,3),{protocol:H}=await c(k,3,W,U);return k.logService.trace(`${K} 6/6. handshake finished, connection is up and running after ${O(q)}!`),H}async function o(k,W,U){const{host:q,port:K,connectionToken:H}=await k.addressProvider.getAddress();return{commit:k.commit,host:q,port:K,connectionToken:H,reconnectionToken:W,reconnectionProtocol:U,socketFactory:k.socketFactory,signService:k.signService,logService:k.logService}}async function h(k,W,U){try{const q=L.generateUuid(),K=await o(k,q,null),{protocol:H}=await t(K,i.CancellationToken.None);return new X(k,W,U,q,H)}catch(q){throw k.logService.error("[remote-connection] An error occurred in the very first connect attempt, it will be treated as a permanent error! Error:"),k.logService.error(q),Y.triggerPermanentFailure(0,0,n.RemoteAuthorityResolverError.isHandled(q)),q}}e.connectRemoteAgentManagement=h;async function f(k,W){try{const U=L.generateUuid(),q=await o(k,U,null),{protocol:K,debugPort:H}=await r(q,W,i.CancellationToken.None);return new _(k,W,U,K,H)}catch(U){throw k.logService.error("[remote-connection] An error occurred in the very first connect attempt, it will be treated as a permanent error! Error:"),k.logService.error(U),Y.triggerPermanentFailure(0,0,n.RemoteAuthorityResolverError.isHandled(U)),U}}e.connectRemoteAgentExtensionHost=f;async function d(k,W){const U=await o(k,L.generateUuid(),null);return await s(U,{port:W},i.CancellationToken.None)}e.connectRemoteAgentTunnel=d;function M(k){return p.createCancelablePromise(W=>new Promise((U,q)=>{const K=setTimeout(U,k*1e3);W.onCancellationRequested(()=>{clearTimeout(K),U()})}))}var T;(function(k){k[k.ConnectionLost=0]="ConnectionLost",k[k.ReconnectionWait=1]="ReconnectionWait",k[k.ReconnectionRunning=2]="ReconnectionRunning",k[k.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",k[k.ConnectionGain=4]="ConnectionGain"})(T=e.PersistentConnectionEventType||(e.PersistentConnectionEventType={}));class C{constructor(W,U){this.reconnectionToken=W,this.millisSinceLastIncomingData=U,this.type=0}}e.ConnectionLostEvent=C;class V{constructor(W,U,q,K){this.reconnectionToken=W,this.millisSinceLastIncomingData=U,this.durationSeconds=q,this.cancellableTimer=K,this.type=1}skipWait(){this.cancellableTimer.cancel()}}e.ReconnectionWaitEvent=V;class Q{constructor(W,U,q){this.reconnectionToken=W,this.millisSinceLastIncomingData=U,this.attempt=q,this.type=2}}e.ReconnectionRunningEvent=Q;class te{constructor(W,U,q){this.reconnectionToken=W,this.millisSinceLastIncomingData=U,this.attempt=q,this.type=4}}e.ConnectionGainEvent=te;class B{constructor(W,U,q,K){this.reconnectionToken=W,this.millisSinceLastIncomingData=U,this.attempt=q,this.handled=K,this.type=3}}e.ReconnectionPermanentFailureEvent=B;class Y extends A.Disposable{constructor(W,U,q,K){super();this._connectionType=W,this._onDidStateChange=this._register(new E.Emitter),this.onDidStateChange=this._onDidStateChange.event,this._options=U,this.reconnectionToken=q,this.protocol=K,this._isReconnecting=!1,this._onDidStateChange.fire(new te(this.reconnectionToken,0,0)),this._register(K.onSocketClose(H=>{const x=F(this._connectionType,this.reconnectionToken,!0);H?H.type===0?(this._options.logService.info(`${x} received socket close event (hadError: ${H.hadError}).`),H.error&&this._options.logService.error(H.error)):(this._options.logService.info(`${x} received socket close event (wasClean: ${H.wasClean}, code: ${H.code}, reason: ${H.reason}).`),H.event&&this._options.logService.error(H.event)):this._options.logService.info(`${x} received socket close event.`),this._beginReconnecting()})),this._register(K.onSocketTimeout(()=>{const H=F(this._connectionType,this.reconnectionToken,!0);this._options.logService.trace(`${H} received socket timeout event.`),this._beginReconnecting()})),Y._instances.push(this),Y._permanentFailure&&this._gotoPermanentFailure(Y._permanentFailureMillisSinceLastIncomingData,Y._permanentFailureAttempt,Y._permanentFailureHandled)}static triggerPermanentFailure(W,U,q){this._permanentFailure=!0,this._permanentFailureMillisSinceLastIncomingData=W,this._permanentFailureAttempt=U,this._permanentFailureHandled=q,this._instances.forEach(K=>K._gotoPermanentFailure(this._permanentFailureMillisSinceLastIncomingData,this._permanentFailureAttempt,this._permanentFailureHandled))}async _beginReconnecting(){if(!this._isReconnecting)try{this._isReconnecting=!0,await this._runReconnectingLoop()}finally{this._isReconnecting=!1}}async _runReconnectingLoop(){if(Y._permanentFailure)return;const W=F(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${W} starting reconnecting loop. You can get more information with the trace log level.`),this._onDidStateChange.fire(new C(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const U=[0,5,5,10,10,10,10,10,30];let q=-1;do{q++;const K=q<U.length?U[q]:U[U.length-1];try{if(K>0){const x=M(K);this._onDidStateChange.fire(new V(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),K,x)),this._options.logService.info(`${W} waiting for ${K} seconds before reconnecting...`);try{await x}catch(ne){}}if(Y._permanentFailure){this._options.logService.error(`${W} permanent failure occurred while running the reconnecting loop.`);break}this._onDidStateChange.fire(new Q(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),q+1)),this._options.logService.info(`${W} resolving connection...`);const H=await o(this._options,this.reconnectionToken,this.protocol);this._options.logService.info(`${W} connecting to ${H.host}:${H.port}...`),await this._reconnect(H,g(I)),this._options.logService.info(`${W} reconnected!`),this._onDidStateChange.fire(new te(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),q+1));break}catch(H){if(H.code==="VSCODE_CONNECTION_ERROR"){this._options.logService.error(`${W} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this._options.logService.error(H),Y.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),q+1,!1);break}if(q>360){this._options.logService.error(`${W} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this._options.logService.error(H),Y.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),q+1,!1);break}if(n.RemoteAuthorityResolverError.isTemporarilyNotAvailable(H)){this._options.logService.info(`${W} A temporarily not available error occurred while trying to reconnect, will try again...`),this._options.logService.trace(H);continue}if((H.code==="ETIMEDOUT"||H.code==="ENETUNREACH"||H.code==="ECONNREFUSED"||H.code==="ECONNRESET")&&H.syscall==="connect"){this._options.logService.info(`${W} A network error occurred while trying to reconnect, will try again...`),this._options.logService.trace(H);continue}if(w.isPromiseCanceledError(H)){this._options.logService.info(`${W} A promise cancelation error occurred while trying to reconnect, will try again...`),this._options.logService.trace(H);continue}if(H instanceof n.RemoteAuthorityResolverError){this._options.logService.error(`${W} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this._options.logService.error(H),Y.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),q+1,n.RemoteAuthorityResolverError.isHandled(H));break}this._options.logService.error(`${W} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this._options.logService.error(H),Y.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),q+1,!1);break}}while(!Y._permanentFailure)}_gotoPermanentFailure(W,U,q){this._onDidStateChange.fire(new B(this.reconnectionToken,W,U,q)),$(this.protocol)}}Y._permanentFailure=!1,Y._permanentFailureMillisSinceLastIncomingData=0,Y._permanentFailureAttempt=0,Y._permanentFailureHandled=!1,Y._instances=[];class X extends Y{constructor(W,U,q,K,H){super(1,W,K,H);this.client=this._register(new m.Client(H,{remoteAuthority:U,clientId:q},W.ipcLogger))}async _reconnect(W,U){await t(W,U)}}e.ManagementPersistentConnection=X;class _ extends Y{constructor(W,U,q,K,H){super(2,W,q,K);this._startArguments=U,this.debugPort=H}async _reconnect(W,U){await r(W,this._startArguments,U)}}e.ExtensionHostPersistentConnection=_;function $(k){try{k.acceptDisconnect();const W=k.getSocket();k.dispose(),W.dispose()}catch(W){w.onUnexpectedError(W)}}function G(k){if(k&&k.type==="error"){const W=new Error(`Connection error: ${k.reason}`);return W.code="VSCODE_CONNECTION_ERROR",W}return null}function N(k,W){for(;k.length<W;)k+=" ";return k}function F(k,W,U){return`[remote-connection][${N(y(k),13)}][${W.substr(0,5)}\u2026][${U?"reconnect":"initial"}]`}function R(k,W){return`${F(W,k.reconnectionToken,!!k.reconnectionProtocol)}[${k.host}:${k.port}]`}function O(k){return`${Date.now()-k} ms`}}),define(J[73],Z([0,1,10]),function(z,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=e.getRemoteName=e.getRemoteAuthority=void 0;function L(p){return p.scheme===m.Schemas.vscodeRemote?p.authority:void 0}e.getRemoteAuthority=L;function A(p){if(!p)return;const i=p.indexOf("+");return i<0?p:p.substr(0,i)}e.getRemoteName=A;function S(p){return p.scheme!==m.Schemas.file&&p.scheme!==m.Schemas.vscodeRemote}e.isVirtualResource=S;function E(p){if(p.folders.length)return p.folders.every(i=>S(i.uri))?p.folders[0].uri:void 0;if(p.configuration&&S(p.configuration))return p.configuration}e.getVirtualWorkspaceLocation=E;function n(p){var i;return(i=E(p))===null||i===void 0?void 0:i.scheme}e.getVirtualWorkspaceScheme=n;function w(p){return E(p)!==void 0}e.isVirtualWorkspace=w}),define(J[74],Z([0,1,5,3,4,6]),function(z,e,m,L,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.ITunnelService=void 0,e.ITunnelService=A.createDecorator("tunnelService");var E;(function(P){P[P.Notify=1]="Notify",P[P.OpenBrowser=2]="OpenBrowser",P[P.OpenPreview=3]="OpenPreview",P[P.Silent=4]="Silent",P[P.Ignore=5]="Ignore"})(E=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function n(P){if(P.scheme!=="http"&&P.scheme!=="https")return;const y=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(P.authority);if(!!y)return{address:y[1],port:+y[2]}}e.extractLocalHostUriMetaDataForPortMapping=n,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function w(P){return e.LOCALHOST_ADDRESSES.indexOf(P)>=0}e.isLocalhost=w,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function p(P){return e.ALL_INTERFACES_ADDRESSES.indexOf(P)>=0}e.isAllInterfaces=p;function i(P,y){return y?y!==1&&P<1024:!L.isWindows&&P<1024}e.isPortPrivileged=i;let I=class{constructor(y){this.logService=y,this._onTunnelOpened=new m.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new m.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._tunnels=new Map,this._canElevate=!1,this._canMakePublic=!1}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(y,g){return this._tunnelProvider=y,y?(this._canElevate=g.elevation,this._canMakePublic=g.public,{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._canMakePublic=!1}}):(this._canElevate=!1,this._canMakePublic=!1,{dispose:()=>{}})}get canElevate(){return this._canElevate}get canMakePublic(){return this._canMakePublic}get tunnels(){return new Promise(async y=>{const g=[],v=Array.from(this._tunnels.values());for(let D of v){const b=Array.from(D.values());for(let l of b){const u=await l.value;u&&g.push(u)}}y(g)})}async dispose(){for(const y of this._tunnels.values()){for(const{value:g}of y.values())await g.then(v=>v==null?void 0:v.dispose());y.clear()}this._tunnels.clear()}openTunnel(y,g,v,D,b=!1,l=!1){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${g}:${v} on local port ${D}.`),!y)return;g||(g="localhost");const u=this.retainOrCreateTunnel(y,g,v,D,b,l);return u?u.then(c=>{if(!c){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(g,v);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const a=this.makeTunnel(c);return(c.tunnelRemoteHost!==g||c.tunnelRemotePort!==v)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(a),a}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),u)}makeTunnel(y){return{tunnelRemotePort:y.tunnelRemotePort,tunnelRemoteHost:y.tunnelRemoteHost,tunnelLocalPort:y.tunnelLocalPort,localAddress:y.localAddress,public:y.public,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${y.tunnelRemoteHost}:${y.tunnelRemotePort} `);const g=this._tunnels.get(y.tunnelRemoteHost);if(g){const v=g.get(y.tunnelRemotePort);v&&(v.refcount--,await this.tryDisposeTunnel(y.tunnelRemoteHost,y.tunnelRemotePort,v))}}}}async tryDisposeTunnel(y,g,v){if(v.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${y}:${g}.`);const D=v.value.then(async b=>{b&&(await b.dispose(!0),this._onTunnelClosed.fire({host:b.tunnelRemoteHost,port:b.tunnelRemotePort}))});return this._tunnels.has(y)&&this._tunnels.get(y).delete(g),D}}async closeTunnel(y,g){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${y}:${g} `);const v=this._tunnels.get(y);if(v&&v.has(g)){const D=v.get(g);D.refcount=0,await this.tryDisposeTunnel(y,g,D)}}addTunnelToMap(y,g,v){this._tunnels.has(y)||this._tunnels.set(y,new Map),this._tunnels.get(y).set(g,{refcount:1,value:v})}async removeEmptyTunnelFromMap(y,g){const v=this._tunnels.get(y);v&&(await v.get(g)||v.delete(g),v.size===0&&this._tunnels.delete(y))}getTunnelFromMap(y,g){let v=[y];w(y)?(v.push(...e.LOCALHOST_ADDRESSES),v.push(...e.ALL_INTERFACES_ADDRESSES)):p(y)&&v.push(...e.ALL_INTERFACES_ADDRESSES);const D=v.map(b=>this._tunnels.get(b));for(const b of D){const l=b==null?void 0:b.get(g);if(l)return l}}canTunnel(y){return!!n(y)}createWithProvider(y,g,v,D,b,l){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${g}:${v} on local port ${D}.`);const c={elevationRequired:b?i(D===void 0?v:D):!1},a={remoteAddress:{host:g,port:v},localAddressPort:D,public:l},t=y.forwardPort(a,c);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),t&&this.addTunnelToMap(g,v,t),t}};I=he([ee(0,S.ILogService)],I),e.AbstractTunnelService=I}),define(J[49],Z([0,1,146,4,48,37,20]),function(z,e,m,L,A,S,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=L.createDecorator("requestService");function n(g){return g.res.statusCode&&g.res.statusCode>=200&&g.res.statusCode<300||g.res.statusCode===1223}e.isSuccess=n;function w(g){return g.res.statusCode===204}async function p(g){if(!n(g))throw new Error("Server returned "+g.res.statusCode);return w(g)?null:(await E.streamToBuffer(g.stream)).toString()}e.asText=p;async function i(g){if(!n(g))throw new Error("Server returned "+g.res.statusCode);if(w(g))return null;const D=(await E.streamToBuffer(g.stream)).toString();try{return JSON.parse(D)}catch(b){throw b.message+=`:
`+D,b}}e.asJson=i;function I(g){y(g)}e.updateProxyConfigurationsScope=I;let P;function y(g){const v=S.Registry.as(A.Extensions.Configuration);P&&v.deregisterConfigurations([P]),P={id:"http",order:15,title:m.localize(0,null),type:"object",scope:g,properties:{"http.proxy":{type:"string",pattern:"^https?://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:m.localize(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:m.localize(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:m.localize(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[m.localize(4,null),m.localize(5,null),m.localize(6,null),m.localize(7,null)],default:"override",description:m.localize(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:m.localize(9,null),restricted:!0}}},v.registerConfiguration(P)}y(2)}),define(J[191],Z([0,1,192,13]),function(z,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getProxyAgent=void 0;function A(E,n){return E.protocol==="http:"?n.HTTP_PROXY||n.http_proxy||null:E.protocol==="https:"&&(n.HTTPS_PROXY||n.https_proxy||n.HTTP_PROXY||n.http_proxy)||null}async function S(E,n,w={}){const p=m.parse(E),i=w.proxyUrl||A(p,n);if(!i)return null;const I=m.parse(i);if(!/^https?:$/.test(I.protocol||""))return null;const P={host:I.hostname||"",port:I.port||(I.protocol==="https"?"443":"80"),auth:I.auth,rejectUnauthorized:L.isBoolean(w.strictSSL)?w.strictSSL:!0};return p.protocol==="http:"?new(await new Promise((y,g)=>{z(["http-proxy-agent"],y,g)}))(P):new(await new Promise((y,g)=>{z(["https-proxy-agent"],y,g)}))(P)}e.getProxyAgent=S}),define(J[193],Z([0,1,27,20]),function(z,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function A(S,E,n){let w=n&&n.get("storage.serviceMachineId",0)||null;if(w)return w;try{const i=(await E.readFile(S.serviceMachineIdResource)).value.toString();w=m.isUUID(i)?i:null}catch(p){w=null}if(!w){w=m.generateUuid();try{await E.writeFile(S.serviceMachineIdResource,L.VSBuffer.fromString(w))}catch(p){}}return n&&n.store("storage.serviceMachineId",w,0,1),w}e.getServiceMachineId=A}),define(J[75],Z([0,1,4]),function(z,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISignService=e.SIGN_SERVICE_ID=void 0,e.SIGN_SERVICE_ID="signService",e.ISignService=m.createDecorator(e.SIGN_SERVICE_ID)}),define(J[194],Z([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class m{vsda(){return new Promise((A,S)=>z(["vsda"],A,S))}async sign(A){try{const S=await this.vsda(),E=new S.signer;if(E)return E.sign(A)}catch(S){}return A}}e.SignService=m}),define(J[38],Z([0,1,4]),function(z,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IStateMainService=void 0,e.IStateMainService=m.createDecorator("stateMainService")}),define(J[18],Z([0,1,14,6,38,5,4,176,3,2,9,13,32]),function(z,e,m,L,A,S,E,n,w,p,i,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LifecycleMainService=e.LifecycleMainPhase=e.UnloadReason=e.ILifecycleMainService=void 0,e.ILifecycleMainService=E.createDecorator("lifecycleMainService");var y;(function(D){D[D.CLOSE=1]="CLOSE",D[D.QUIT=2]="QUIT",D[D.RELOAD=3]="RELOAD",D[D.LOAD=4]="LOAD"})(y=e.UnloadReason||(e.UnloadReason={}));var g;(function(D){D[D.Starting=1]="Starting",D[D.Ready=2]="Ready",D[D.AfterWindowOpen=3]="AfterWindowOpen"})(g=e.LifecycleMainPhase||(e.LifecycleMainPhase={}));let v=class ut extends p.Disposable{constructor(b,l){super();this.logService=b,this.stateMainService=l,this._onBeforeShutdown=this._register(new S.Emitter),this.onBeforeShutdown=this._onBeforeShutdown.event,this._onWillShutdown=this._register(new S.Emitter),this.onWillShutdown=this._onWillShutdown.event,this._onWillLoadWindow=this._register(new S.Emitter),this.onWillLoadWindow=this._onWillLoadWindow.event,this._onBeforeCloseWindow=this._register(new S.Emitter),this.onBeforeCloseWindow=this._onBeforeCloseWindow.event,this._onBeforeUnloadWindow=this._register(new S.Emitter),this.onBeforeUnloadWindow=this._onBeforeUnloadWindow.event,this._quitRequested=!1,this._wasRestarted=!1,this._phase=1,this.windowToCloseRequest=new Set,this.oneTimeListenerTokenGenerator=0,this.windowCounter=0,this.pendingQuitPromise=void 0,this.pendingQuitPromiseResolve=void 0,this.pendingWillShutdownPromise=void 0,this.phaseWhen=new Map,this.resolveRestarted(),this.when(2).then(()=>this.registerListeners())}get quitRequested(){return this._quitRequested}get wasRestarted(){return this._wasRestarted}get phase(){return this._phase}resolveRestarted(){this._wasRestarted=!!this.stateMainService.getItem(ut.QUIT_AND_RESTART_KEY),this._wasRestarted&&this.stateMainService.removeItem(ut.QUIT_AND_RESTART_KEY)}registerListeners(){const b=()=>{this._quitRequested||(this.logService.trace("Lifecycle#app.on(before-quit)"),this._quitRequested=!0,this.logService.trace("Lifecycle#onBeforeShutdown.fire()"),this._onBeforeShutdown.fire(),w.isMacintosh&&this.windowCounter===0&&this.beginOnWillShutdown())};m.app.addListener("before-quit",b);const l=()=>{this.logService.trace("Lifecycle#app.on(window-all-closed)"),(this._quitRequested||!w.isMacintosh)&&m.app.quit()};m.app.addListener("window-all-closed",l),m.app.once("will-quit",u=>{this.logService.trace("Lifecycle#app.on(will-quit)"),u.preventDefault(),this.beginOnWillShutdown().finally(()=>{this.resolvePendingQuitPromise(!1),m.app.removeListener("before-quit",b),m.app.removeListener("window-all-closed",l),m.app.quit()})})}beginOnWillShutdown(){if(this.pendingWillShutdownPromise)return this.pendingWillShutdownPromise;this.logService.trace("Lifecycle#onWillShutdown.fire()");const b=[];return this._onWillShutdown.fire({join(l){b.push(l)}}),this.pendingWillShutdownPromise=(async()=>{try{await i.Promises.settled(b)}catch(l){this.logService.error(l)}try{await this.stateMainService.close()}catch(l){this.logService.error(l)}})(),this.pendingWillShutdownPromise}set phase(b){if(b<this.phase)throw new Error("Lifecycle cannot go backwards");if(this._phase===b)return;this.logService.trace(`lifecycle (main): phase changed (value: ${b})`),this._phase=b;const l=this.phaseWhen.get(this._phase);l&&(l.open(),this.phaseWhen.delete(this._phase))}async when(b){if(b<=this._phase)return;let l=this.phaseWhen.get(b);l||(l=new i.Barrier,this.phaseWhen.set(b,l)),await l.wait()}registerWindow(b){const l=new p.DisposableStore;this.windowCounter++,l.add(b.onWillLoad(c=>this._onWillLoadWindow.fire({window:b,workspace:c.workspace})));const u=I.assertIsDefined(b.win);u.on("close",c=>{const a=b.id;if(this.windowToCloseRequest.has(a)){this.windowToCloseRequest.delete(a);return}this.logService.trace(`Lifecycle#window.on('close') - window ID ${b.id}`),c.preventDefault(),this.unload(b,1).then(t=>{if(t){this.windowToCloseRequest.delete(a);return}this.windowToCloseRequest.add(a),this.logService.trace(`Lifecycle#onBeforeCloseWindow.fire() - window ID ${a}`),this._onBeforeCloseWindow.fire(b),b.close()})}),u.on("closed",()=>{this.logService.trace(`Lifecycle#window.on('closed') - window ID ${b.id}`),this.windowCounter--,l.dispose(),this.windowCounter===0&&(!w.isMacintosh||this._quitRequested)&&this.beginOnWillShutdown()})}async reload(b,l){await this.unload(b,3)||b.reload(l)}async unload(b,l){if(!b.isReady)return!1;this.logService.trace(`Lifecycle#unload() - window ID ${b.id}`);const u=this._quitRequested?2:l;let c=await this.onBeforeUnloadWindowInRenderer(b,u);return c?(this.logService.trace(`Lifecycle#unload() - veto in renderer (window ID ${b.id})`),this.handleWindowUnloadVeto(c)):(c=await this.onBeforeUnloadWindowInMain(b,u),c?(this.logService.trace(`Lifecycle#unload() - veto in main (window ID ${b.id})`),this.handleWindowUnloadVeto(c)):(this.logService.trace(`Lifecycle#unload() - no veto (window ID ${b.id})`),await this.onWillUnloadWindowInRenderer(b,u),!1))}handleWindowUnloadVeto(b){return b?(this.resolvePendingQuitPromise(!0),this._quitRequested=!1,!0):!1}resolvePendingQuitPromise(b){this.pendingQuitPromiseResolve&&(this.pendingQuitPromiseResolve(b),this.pendingQuitPromiseResolve=void 0,this.pendingQuitPromise=void 0)}onBeforeUnloadWindowInRenderer(b,l){return new Promise(u=>{const c=this.oneTimeListenerTokenGenerator++,a=`vscode:ok${c}`,t=`vscode:cancel${c}`;m.ipcMain.once(a,()=>{u(!1)}),m.ipcMain.once(t,()=>{u(!0)}),b.send("vscode:onBeforeUnload",{okChannel:a,cancelChannel:t,reason:l})})}onBeforeUnloadWindowInMain(b,l){const u=[];return this._onBeforeUnloadWindow.fire({reason:l,window:b,veto(c){u.push(c)}}),n.handleVetos(u,c=>this.logService.error(c))}onWillUnloadWindowInRenderer(b,l){return new Promise(u=>{const a=`vscode:reply${this.oneTimeListenerTokenGenerator++}`;m.ipcMain.once(a,()=>u()),b.send("vscode:onWillUnload",{replyChannel:a,reason:l})})}quit(b){return this.pendingQuitPromise?this.pendingQuitPromise:(this.logService.trace(`Lifecycle#quit() - will restart: ${b}`),b&&this.stateMainService.setItem(ut.QUIT_AND_RESTART_KEY,!0),this.pendingQuitPromise=new Promise(l=>{this.pendingQuitPromiseResolve=l,this.logService.trace("Lifecycle#quit() - calling app.quit()"),m.app.quit()}),this.pendingQuitPromise)}async relaunch(b){this.logService.trace("Lifecycle#relaunch()");const l=process.argv.slice(1);if((b==null?void 0:b.addArgs)&&l.push(...b.addArgs),b==null?void 0:b.removeArgs)for(const a of b.removeArgs){const t=l.indexOf(a);t>=0&&l.splice(t,1)}const u=()=>{try{if(w.isWindows){const a=P.cwd();a!==process.cwd()&&process.chdir(a)}}catch(a){this.logService.error(a)}this.logService.trace("Lifecycle#relaunch() - calling app.relaunch()"),m.app.relaunch({args:l})};m.app.once("quit",u),await this.quit(!0)&&m.app.removeListener("quit",u)}async kill(b){this.logService.trace("Lifecycle#kill()"),await Promise.race([i.timeout(1e3),(async()=>{for(const l of m.BrowserWindow.getAllWindows())if(l&&!l.isDestroyed()){let u;l.webContents&&!l.webContents.isDestroyed()?u=new Promise(c=>l.once("closed",c)):u=Promise.resolve(),l.destroy(),await u}})()]),m.app.exit(b)}};v.QUIT_AND_RESTART_KEY="lifecycle.quitAndRestart",v=he([ee(0,L.ILogService),ee(1,A.IStateMainService)],v),e.LifecycleMainService=v}),define(J[195],Z([0,1,4,5,2,18]),function(z,e,m,L,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeyboardLayoutMainService=e.IKeyboardLayoutMainService=void 0,e.IKeyboardLayoutMainService=m.createDecorator("keyboardLayoutMainService");let E=class extends A.Disposable{constructor(p){super();this._onDidChangeKeyboardLayout=this._register(new L.Emitter),this.onDidChangeKeyboardLayout=this._onDidChangeKeyboardLayout.event,this._initPromise=null,this._keyboardLayoutData=null,p.when(3).then(()=>this._initialize())}_initialize(){return this._initPromise||(this._initPromise=this._doInitialize()),this._initPromise}async _doInitialize(){const p=await new Promise((i,I)=>{z(["native-keymap"],i,I)});this._keyboardLayoutData=n(p),p.onDidChangeKeyboardLayout(()=>{this._keyboardLayoutData=n(p),this._onDidChangeKeyboardLayout.fire(this._keyboardLayoutData)})}async getKeyboardLayoutData(){return await this._initialize(),this._keyboardLayoutData}};E=he([ee(0,S.ILifecycleMainService)],E),e.KeyboardLayoutMainService=E;function n(w){const p=w.getKeyMap(),i=w.getCurrentKeyboardLayout();return{keyboardMapping:p,keyboardLayoutInfo:i}}}),define(J[96],Z([0,1,4,5,2,13,86,9]),function(z,e,m,L,A,S,E,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.AbstractStorageService=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker";const w="__$__targetStorageMarker";e.IStorageService=m.createDecorator("storageService");var p;(function(v){v[v.NONE=0]="NONE",v[v.SHUTDOWN=1]="SHUTDOWN"})(p=e.WillSaveStateReason||(e.WillSaveStateReason={}));var i;(function(v){v[v.GLOBAL=0]="GLOBAL",v[v.WORKSPACE=1]="WORKSPACE"})(i=e.StorageScope||(e.StorageScope={}));var I;(function(v){v[v.USER=0]="USER",v[v.MACHINE=1]="MACHINE"})(I=e.StorageTarget||(e.StorageTarget={}));class P extends A.Disposable{constructor(D={flushInterval:P.DEFAULT_FLUSH_INTERVAL}){super();this.options=D,this._onDidChangeValue=this._register(new L.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new L.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new L.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new n.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new A.MutableDisposable),this._workspaceKeyTargets=void 0,this._globalKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=n.runWhenIdle(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){A.dispose([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{await this.doInitialize(),this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(D,b){b===w?(D===0?this._globalKeyTargets=void 0:D===1&&(this._workspaceKeyTargets=void 0),this._onDidChangeTarget.fire({scope:D})):this._onDidChangeValue.fire({scope:D,key:b,target:this.getKeyTargets(D)[b]})}emitWillSaveState(D){this._onWillSaveState.fire({reason:D})}get(D,b,l){var u;return(u=this.getStorage(b))===null||u===void 0?void 0:u.get(D,l)}getBoolean(D,b,l){var u;return(u=this.getStorage(b))===null||u===void 0?void 0:u.getBoolean(D,l)}getNumber(D,b,l){var u;return(u=this.getStorage(b))===null||u===void 0?void 0:u.getNumber(D,l)}store(D,b,l,u){if(S.isUndefinedOrNull(b)){this.remove(D,l);return}this.withPausedEmitters(()=>{var c;this.updateKeyTarget(D,l,u),(c=this.getStorage(l))===null||c===void 0||c.set(D,b)})}remove(D,b){this.withPausedEmitters(()=>{var l;this.updateKeyTarget(D,b,void 0),(l=this.getStorage(b))===null||l===void 0||l.delete(D)})}withPausedEmitters(D){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{D()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(D,b){const l=[],u=this.getKeyTargets(D);for(const c of Object.keys(u))u[c]===b&&l.push(c);return l}updateKeyTarget(D,b,l){var u,c;const a=this.getKeyTargets(b);typeof l=="number"?a[D]!==l&&(a[D]=l,(u=this.getStorage(b))===null||u===void 0||u.set(w,JSON.stringify(a))):typeof a[D]=="number"&&(delete a[D],(c=this.getStorage(b))===null||c===void 0||c.set(w,JSON.stringify(a)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get globalKeyTargets(){return this._globalKeyTargets||(this._globalKeyTargets=this.loadKeyTargets(0)),this._globalKeyTargets}getKeyTargets(D){return D===0?this.globalKeyTargets:this.workspaceKeyTargets}loadKeyTargets(D){const b=this.get(w,D);if(b)try{return JSON.parse(b)}catch(l){}return Object.create(null)}isNew(D){return this.getBoolean(e.IS_NEW_KEY,D)===!0}async flush(){var D,b,l,u;this._onWillSaveState.fire({reason:p.NONE}),await n.Promises.settled([(b=(D=this.getStorage(0))===null||D===void 0?void 0:D.whenFlushed())!==null&&b!==void 0?b:Promise.resolve(),(u=(l=this.getStorage(1))===null||l===void 0?void 0:l.whenFlushed())!==null&&u!==void 0?u:Promise.resolve()])}async logStorage(){var D,b,l,u,c,a;const t=(b=(D=this.getStorage(0))===null||D===void 0?void 0:D.items)!==null&&b!==void 0?b:new Map,r=(u=(l=this.getStorage(1))===null||l===void 0?void 0:l.items)!==null&&u!==void 0?u:new Map;return g(t,r,(c=this.getLogDetails(0))!==null&&c!==void 0?c:"",(a=this.getLogDetails(1))!==null&&a!==void 0?a:"")}}e.AbstractStorageService=P,P.DEFAULT_FLUSH_INTERVAL=60*1e3;class y extends P{constructor(){super();this.globalStorage=new E.Storage(new E.InMemoryStorageDatabase),this.workspaceStorage=new E.Storage(new E.InMemoryStorageDatabase),this._register(this.workspaceStorage.onDidChangeStorage(D=>this.emitDidChangeValue(1,D))),this._register(this.globalStorage.onDidChangeStorage(D=>this.emitDidChangeValue(0,D)))}getStorage(D){return D===0?this.globalStorage:this.workspaceStorage}getLogDetails(D){return D===0?"inMemory (global)":"inMemory (workspace)"}async doInitialize(){}async migrate(D){}}e.InMemoryStorageService=y;async function g(v,D,b,l){const u=h=>{try{return JSON.parse(h)}catch(f){return h}},c=new Map,a=new Map;v.forEach((h,f)=>{c.set(f,h),a.set(f,u(h))});const t=new Map,r=new Map;D.forEach((h,f)=>{t.set(f,h),r.set(f,u(h))}),console.group(`Storage: Global (path: ${b})`);let s=[];c.forEach((h,f)=>{s.push({key:f,value:h})}),console.table(s),console.groupEnd(),console.log(a),console.group(`Storage: Workspace (path: ${l})`);let o=[];t.forEach((h,f)=>{o.push({key:f,value:h})}),console.table(o),console.groupEnd(),console.log(r)}e.logStorage=g}),define(J[196],Z([0,1,3,32,27,7]),function(z,e,m,L,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function E(p){if(m.platform===2&&/^penguin(\.|$)/i.test(p))return"chromebook"}async function n(p,i,I,P,y,g,v,D,b,l){const u=Object.create(null);u["common.machineId"]=v,u.sessionID=A.generateUuid()+Date.now(),u.commitHash=y,u.version=g,u["common.platformVersion"]=(i||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),u["common.platform"]=m.PlatformToString(m.platform),u["common.nodePlatform"]=L.platform,u["common.nodeArch"]=P,u["common.product"]=l||"desktop";const c=w(D||[]);c&&(u["common.msftInternal"]=c);let a=0;const t=Date.now();Object.defineProperties(u,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-t,enumerable:!0},"common.sequence":{get:()=>a++,enumerable:!0}}),m.isLinuxSnap&&(u["common.snap"]="true");const r=E(I);r&&(u["common.platformDetail"]=r);try{const s=await p.readFile(S.URI.file(b));u["common.source"]=s.value.toString().slice(0,30)}catch(s){}return u}e.resolveCommonProperties=n;function w(p){const i=L.env.USERDNSDOMAIN;if(!i)return!1;const I=i.toLowerCase();return p.some(P=>I===P)}e.verifyMicrosoftInternalDomain=w}),define(J[31],Z([0,1,4]),function(z,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.instanceStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=m.createDecorator("telemetryService"),e.ICustomEndpointTelemetryService=m.createDecorator("customEndpointTelemetryService"),e.instanceStorageKey="telemetry.instanceId",e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId"}),define(J[197],Z([0,1,26,66,70,8,43,83,22,3,7,31,63,10,21,17]),function(z,e,m,L,A,S,E,n,w,p,i,I,P,y,g,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;async function D(a,t){const r=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.yml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i}],s=new Map,o=new Map,h=2e4;function f(T,C,V,Q){const te=C.substring(T.length+1);return new Promise(async B=>{var Y,X,_;let $;try{$=await v.Promises.readdir(C,{withFileTypes:!0})}catch(F){B();return}if(Q.count>=h){Q.count+=$.length,Q.maxReached=!0,B();return}let G=$.length;if(G===0){B();return}let N=$;Q.count+$.length>h&&(Q.maxReached=!0,G=h-Q.count,N=$.slice(0,G)),Q.count+=$.length;for(const F of N)if(F.isDirectory()){if(V.includes(F.name)||await f(T,S.join(C,F.name),V,Q),--G==0){B();return}}else{const R=F.name.lastIndexOf(".");if(R>=0){const O=F.name.substring(R+1);O&&s.set(O,((Y=s.get(O))!==null&&Y!==void 0?Y:0)+1)}for(const O of r)((X=O.relativePathPattern)===null||X===void 0?void 0:X.test(te))!==!1&&O.filePattern.test(F.name)&&o.set(O.tag,((_=o.get(O.tag))!==null&&_!==void 0?_:0)+1);if(--G==0){B();return}}})}const d={count:0,maxReached:!1};await f(a,a,t,d);const M=await u(a);return{configFiles:b(o),fileTypes:b(s),fileCount:d.count,maxFilesReached:d.maxReached,launchConfigFiles:M}}e.collectWorkspaceStats=D;function b(a){return[...P.Iterable.map(a.entries(),([t,r])=>({name:t,count:r}))].sort((t,r)=>r.count-t.count)}function l(){const a={os:`${m.type()} ${m.arch()} ${m.release()}`,memory:`${(m.totalmem()/g.ByteSize.GB).toFixed(2)}GB (${(m.freemem()/g.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(L.virtualMachineHint.value()*100)}%`},t=m.cpus();return t&&t.length>0&&(a.cpus=`${t[0].model} (${t.length} x ${t[0].speed})`),a}e.getMachineInfo=l;async function u(a){try{const t=new Map,r=S.join(a,".vscode","launch.json"),s=await v.Promises.readFile(r),o=[],h=E.parse(s.toString(),o);if(o.length)return console.log(`Unable to parse ${r}`),[];if(E.getNodeType(h)==="object"&&h.configurations)for(const f of h.configurations){const d=f.type;d&&(t.has(d)?t.set(d,t.get(d)+1):t.set(d,1))}return b(t)}catch(t){return[]}}e.collectLaunchConfigs=u;let c=class{constructor(t,r){this.telemetryService=t,this.productService=r}formatMachineInfo(t){const r=[];return r.push(`OS Version:       ${t.os}`),r.push(`CPUs:             ${t.cpus}`),r.push(`Memory (System):  ${t.memory}`),r.push(`VM:               ${t.vmHint}`),r.join(`
`)}formatEnvironment(t){const r=[];r.push(`Version:          ${this.productService.nameShort} ${this.productService.version} (${this.productService.commit||"Commit unknown"}, ${this.productService.date||"Date unknown"})`),r.push(`OS Version:       ${m.type()} ${m.arch()} ${m.release()}`);const s=m.cpus();return s&&s.length>0&&r.push(`CPUs:             ${s[0].model} (${s.length} x ${s[0].speed})`),r.push(`Memory (System):  ${(m.totalmem()/g.ByteSize.GB).toFixed(2)}GB (${(m.freemem()/g.ByteSize.GB).toFixed(2)}GB free)`),p.isWindows||r.push(`Load (avg):       ${m.loadavg().map(o=>Math.round(o)).join(", ")}`),r.push(`VM:               ${Math.round(L.virtualMachineHint.value()*100)}%`),r.push(`Screen Reader:    ${t.screenReader?"yes":"no"}`),r.push(`Process Argv:     ${t.mainArguments.join(" ")}`),r.push(`GPU Status:       ${this.expandGPUFeatures(t.gpuFeatureStatus)}`),r.join(`
`)}async getPerformanceInfo(t,r){return Promise.all([n.listProcesses(t.mainPID),this.formatWorkspaceMetadata(t)]).then(async s=>{let[o,h]=s,f=this.formatProcessList(t,o);return r.forEach(d=>{if(A.isRemoteDiagnosticError(d))f+=`
${d.errorMessage}`,h+=`
${d.errorMessage}`;else if(f+=`

Remote: ${d.hostName}`,d.processes&&(f+=`
${this.formatProcessList(t,d.processes)}`),d.workspaceMetadata){h+=`
|  Remote: ${d.hostName}`;for(const M of Object.keys(d.workspaceMetadata)){const T=d.workspaceMetadata[M];let C=`${T.fileCount} files`;T.maxFilesReached&&(C=`more than ${C}`),h+=`|    Folder (${M}): ${C}`,h+=this.formatWorkspaceStats(T)}}}),{processInfo:f,workspaceInfo:h}})}async getSystemInfo(t,r){const{memory:s,vmHint:o,os:h,cpus:f}=l(),d={os:h,memory:s,cpus:f,vmHint:o,processArgs:`${t.mainArguments.join(" ")}`,gpuStatus:t.gpuFeatureStatus,screenReader:`${t.screenReader?"yes":"no"}`,remoteData:r};return p.isWindows||(d.load=`${m.loadavg().map(M=>Math.round(M)).join(", ")}`),p.isLinux&&(d.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(d)}async getDiagnostics(t,r){const s=[];return n.listProcesses(t.mainPID).then(async o=>(s.push(""),s.push(this.formatEnvironment(t)),s.push(""),s.push(this.formatProcessList(t,o)),t.windows.some(h=>h.folderURIs&&h.folderURIs.length>0&&!h.remoteAuthority)&&(s.push(""),s.push("Workspace Stats: "),s.push(await this.formatWorkspaceMetadata(t))),r.forEach(h=>{if(A.isRemoteDiagnosticError(h))s.push(`
${h.errorMessage}`);else if(s.push(`

`),s.push(`Remote:           ${h.hostName}`),s.push(this.formatMachineInfo(h.machineInfo)),h.processes&&s.push(this.formatProcessList(t,h.processes)),h.workspaceMetadata)for(const f of Object.keys(h.workspaceMetadata)){const d=h.workspaceMetadata[f];let M=`${d.fileCount} files`;d.maxFilesReached&&(M=`more than ${M}`),s.push(`Folder (${f}): ${M}`),s.push(this.formatWorkspaceStats(d))}}),s.push(""),s.push(""),s.join(`
`)))}formatWorkspaceStats(t){const r=[],s=60;let o=0;const h=(T,C)=>{const V=` ${T}(${C})`;o+V.length>s?(r.push(f),f="|                 ",o=f.length):o+=V.length,f+=V};let f="|      File types:";const d=10;let M=t.fileTypes.length>d?d:t.fileTypes.length;for(let T=0;T<M;T++){const C=t.fileTypes[T];h(C.name,C.count)}if(r.push(f),t.configFiles.length>=0&&(f="|      Conf files:",o=0,t.configFiles.forEach(T=>{h(T.name,T.count)}),r.push(f)),t.launchConfigFiles.length>0){let T="|      Launch Configs:";t.launchConfigFiles.forEach(C=>{T+=C.count>1?` ${C.name}(${C.count})`:` ${C.name}`}),r.push(T)}return r.join(`
`)}expandGPUFeatures(t){const r=Math.max(...Object.keys(t).map(s=>s.length));return Object.keys(t).map(s=>`${s}:  ${" ".repeat(r-s.length)}  ${t[s]}`).join(`
                  `)}formatWorkspaceMetadata(t){const r=[],s=[];return t.windows.forEach(o=>{o.folderURIs.length===0||!!o.remoteAuthority||(r.push(`|  Window (${o.title})`),o.folderURIs.forEach(h=>{const f=i.URI.revive(h);if(f.scheme===y.Schemas.file){const d=f.fsPath;s.push(D(d,["node_modules",".git"]).then(M=>{let T=`${M.fileCount} files`;M.maxFilesReached&&(T=`more than ${T}`),r.push(`|    Folder (${S.basename(d)}): ${T}`),r.push(this.formatWorkspaceStats(M))}).catch(M=>{r.push(`|      Error: Unable to collect workspace stats for folder ${d} (${M.toString()})`)}))}else r.push(`|    Folder (${f.toString()}): Workspace stats not available.`)}))}),Promise.all(s).then(o=>r.join(`
`)).catch(o=>`Unable to collect workspace stats: ${o}`)}formatProcessList(t,r){const s=new Map;t.windows.forEach(h=>s.set(h.pid,h.title));const o=[];return o.push("CPU %	Mem MB	   PID	Process"),r&&this.formatProcessItem(t.mainPID,s,o,r,0),o.join(`
`)}formatProcessItem(t,r,s,o,h){const f=h===0;let d;f?d=o.pid===t?`${this.productService.applicationName} main`:"remote agent":(d=`${"  ".repeat(h)} ${o.name}`,o.name==="window"&&(d=`${d} (${r.get(o.pid)})`));const M=process.platform==="win32"?o.mem:m.totalmem()*(o.mem/100);s.push(`${o.load.toFixed(0).padStart(5," ")}	${(M/g.ByteSize.MB).toFixed(0).padStart(6," ")}	${o.pid.toFixed(0).padStart(6," ")}	${d}`),Array.isArray(o.children)&&o.children.forEach(T=>this.formatProcessItem(t,r,s,T,h+1))}async reportWorkspaceStats(t){for(const{uri:r}of t.folders){const s=i.URI.revive(r);if(s.scheme!==y.Schemas.file)continue;const o=s.fsPath;try{const h=await D(o,["node_modules",".git"]);this.telemetryService.publicLog2("workspace.stats",{"workspace.id":t.telemetryId,rendererSessionId:t.rendererSessionId}),h.fileTypes.forEach(f=>{this.telemetryService.publicLog2("workspace.stats.file",{rendererSessionId:t.rendererSessionId,type:f.name,count:f.count})}),h.launchConfigFiles.forEach(f=>{this.telemetryService.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:t.rendererSessionId,type:f.name,count:f.count})}),h.configFiles.forEach(f=>{this.telemetryService.publicLog2("workspace.stats.configFiles",{rendererSessionId:t.rendererSessionId,type:f.name,count:f.count})})}catch(h){}}}};c=he([ee(0,I.ITelemetryService),ee(1,w.IProductService)],c),e.DiagnosticsService=c}),define(J[198],Z([0,1,19,168,171,44,31,49,162,53,25,6,21,7,22,96,193,4,15]),function(z,e,m,L,A,S,E,n,w,p,i,I,P,y,g,v,D,b,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=e.ExtensionGalleryService=void 0;var u;(function(F){F[F.None=0]="None",F[F.IncludeVersions=1]="IncludeVersions",F[F.IncludeFiles=2]="IncludeFiles",F[F.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",F[F.IncludeSharedAccounts=8]="IncludeSharedAccounts",F[F.IncludeVersionProperties=16]="IncludeVersionProperties",F[F.ExcludeNonValidated=32]="ExcludeNonValidated",F[F.IncludeInstallationTargets=64]="IncludeInstallationTargets",F[F.IncludeAssetUri=128]="IncludeAssetUri",F[F.IncludeStatistics=256]="IncludeStatistics",F[F.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",F[F.Unpublished=4096]="Unpublished"})(u||(u={}));function c(...F){return String(F.reduce((R,O)=>R|O,0))}var a;(function(F){F[F.Tag=1]="Tag",F[F.ExtensionId=4]="ExtensionId",F[F.Category=5]="Category",F[F.ExtensionName=7]="ExtensionName",F[F.Target=8]="Target",F[F.Featured=9]="Featured",F[F.SearchText=10]="SearchText",F[F.ExcludeWithFlags=12]="ExcludeWithFlags"})(a||(a={}));const t={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},r={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension"},o={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:u.None,criteria:[],assetTypes:[]};class h{constructor(R=o){this.state=R}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}withPage(R,O=this.state.pageSize){return new h(Object.assign(Object.assign({},this.state),{pageNumber:R,pageSize:O}))}withFilter(R,...O){const k=[...this.state.criteria,...O.length?O.map(W=>({filterType:R,value:W})):[{filterType:R}]];return new h(Object.assign(Object.assign({},this.state),{criteria:k}))}withSortBy(R){return new h(Object.assign(Object.assign({},this.state),{sortBy:R}))}withSortOrder(R){return new h(Object.assign(Object.assign({},this.state),{sortOrder:R}))}withFlags(...R){return new h(Object.assign(Object.assign({},this.state),{flags:R.reduce((O,k)=>O|k,0)}))}withAssetTypes(...R){return new h(Object.assign(Object.assign({},this.state),{assetTypes:R}))}get raw(){const{criteria:R,pageNumber:O,pageSize:k,sortBy:W,sortOrder:U,flags:q,assetTypes:K}=this.state;return{filters:[{criteria:R,pageNumber:O,pageSize:k,sortBy:W,sortOrder:U}],assetTypes:K,flags:q}}get searchText(){const R=this.state.criteria.filter(O=>O.filterType===a.SearchText)[0];return R&&R.value?R.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(R=>String(R.filterType)),sortBy:String(this.sortBy),sortOrder:String(this.sortOrder)}}}function f(F,R){const O=(F||[]).filter(k=>k.statisticName===R)[0];return O?O.value:0}function d(F){const R="Microsoft.VisualStudio.Code.Translation.";return F.files.filter(k=>k.assetType.indexOf(R)===0).reduce((k,W)=>{const U=V(F,W.assetType);return U&&k.push([W.assetType.substring(R.length),U]),k},[])}function M(F){if(F.properties){const R=F.properties.filter(W=>W.key===t.Repository),O=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),k=R.filter(W=>O.test(W.value))[0];return k?{uri:k.value,fallbackUri:k.value}:null}return V(F,t.Repository)}function T(F){return{uri:`${F.fallbackAssetUri}/${t.VSIX}?redirect=true`,fallbackUri:`${F.fallbackAssetUri}/${t.VSIX}`}}function C(F){const R=V(F,t.Icon);if(R)return R;const O=L.DefaultIconPath;return{uri:O,fallbackUri:O}}function V(F,R){return F.files.filter(k=>k.assetType===R)[0]?{uri:`${F.assetUri}/${R}`,fallbackUri:`${F.fallbackAssetUri}/${R}`}:null}function Q(F,R){const O=F.properties?F.properties.filter(W=>W.key===R):[],k=O.length>0&&O[0].value;return k?k.split(",").map(W=>A.adoptToGalleryExtensionId(W)):[]}function te(F){const R=F.properties?F.properties.filter(O=>O.key===r.Engine):[];return R.length>0&&R[0].value||""}function B(F){const R=F.properties?F.properties.filter(k=>k.key===r.LocalizedLanguages):[],O=R.length>0&&R[0].value||"";return O?O.split(","):[]}function Y(F){return F.indexOf("preview")!==-1}function X(F){const R=F.properties?F.properties.find(O=>O.key===r.WebExtension):void 0;return!!R&&R.value==="true"}function _(F){return F.files.some(R=>R.assetType.startsWith("Microsoft.VisualStudio.Code.WebResources"))?l.joinPath(y.URI.parse(F.assetUri),"Microsoft.VisualStudio.Code.WebResources","extension"):void 0}function $(F,R,O,k,W){const U={manifest:V(R,t.Manifest),readme:V(R,t.Details),changelog:V(R,t.Changelog),license:V(R,t.License),repository:M(R),download:T(R),icon:C(R),coreTranslations:d(R)};return{identifier:{id:A.getGalleryExtensionId(F.publisher.publisherName,F.extensionName),uuid:F.extensionId},name:F.extensionName,version:R.version,date:R.lastUpdated,displayName:F.displayName,publisherId:F.publisher.publisherId,publisher:F.publisher.publisherName,publisherDisplayName:F.publisher.displayName,description:F.shortDescription||"",installCount:f(F.statistics,"install"),rating:f(F.statistics,"averagerating"),ratingCount:f(F.statistics,"ratingcount"),assetUri:y.URI.parse(R.assetUri),webResource:_(R),assetTypes:R.files.map(({assetType:q})=>q),assets:U,properties:{dependencies:Q(R,r.Dependency),extensionPack:Q(R,r.ExtensionPack),engine:te(R),localizedLanguages:B(R),webExtension:X(R)},telemetryData:{index:(k.pageNumber-1)*k.pageSize+O,querySource:W},preview:Y(F.flags)}}let G=class{constructor(R,O,k,W,U,q,K){this.requestService=R,this.logService=O,this.environmentService=k,this.telemetryService=W,this.fileService=U,this.productService=q;const H=q.extensionsGallery;this.extensionsGalleryUrl=H&&H.serviceUrl,this.extensionsControlUrl=H&&H.controlUrl,this.commonHeadersPromise=N(q.version,this.environmentService,this.fileService,K)}api(R=""){return`${this.extensionsGalleryUrl}${R}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(R,O){const k=[];let{total:W,firstPage:U,getPage:q}=await this.query({names:R,pageSize:R.length},O);k.push(...U);for(let K=1;k.length<W&&(U=await q(K,O),U.length);K++)k.push(...U);return k}async getCompatibleExtension(R,O){const k=await this.getCompatibleExtensionByEngine(R,O);return(k==null?void 0:k.properties.webExtension)?k.webResource?k:null:k}async getCompatibleExtensionByEngine(R,O){const k=L.isIExtensionIdentifier(R)?null:R;if(k&&k.properties.engine&&w.isEngineValid(k.properties.engine,this.productService.version,this.productService.date))return k;const{id:W,uuid:U}=k?k.identifier:R;let q=new h().withFlags(u.IncludeAssetUri,u.IncludeStatistics,u.IncludeFiles,u.IncludeVersionProperties).withPage(1,1).withFilter(a.Target,"Microsoft.VisualStudio.Code");U?q=q.withFilter(a.ExtensionId,U):q=q.withFilter(a.ExtensionName,W);const{galleryExtensions:K}=await this.queryGallery(q,i.CancellationToken.None),[H]=K;if(!H||!H.versions.length)return null;if(O){const ne=H.versions.filter(re=>re.version===O)[0];if(ne){const re=$(H,ne,0,q);if(re.properties.engine&&w.isEngineValid(re.properties.engine,this.productService.version,this.productService.date))return re}return null}const x=await this.getLastValidExtensionVersion(H,H.versions);return x?$(H,x,0,q):null}async query(R,O){const k=i.CancellationToken.isCancellationToken(R)?{}:R,W=i.CancellationToken.isCancellationToken(R)?R:O;if(!this.isEnabled())throw new Error("No extension gallery service configured.");let U=k.text||"";const q=S.getOrDefault(k,se=>se.pageSize,50);let K=new h().withFlags(u.IncludeLatestVersionOnly,u.IncludeAssetUri,u.IncludeStatistics,u.IncludeFiles,u.IncludeVersionProperties).withPage(1,q).withFilter(a.Target,"Microsoft.VisualStudio.Code");U?(U=U.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(se,le,oe)=>(K=K.withFilter(a.Category,oe||le),"")),U=U.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(se,le,oe)=>(K=K.withFilter(a.Tag,oe||le),"")),U=U.replace(/\bfeatured(\s+|\b|$)/g,()=>(K=K.withFilter(a.Featured),"")),U=U.trim(),U&&(U=U.length<200?U:U.substring(0,200),K=K.withFilter(a.SearchText,U)),K=K.withSortBy(0)):k.ids?K=K.withFilter(a.ExtensionId,...k.ids):k.names?K=K.withFilter(a.ExtensionName,...k.names):K=K.withSortBy(4),typeof k.sortBy=="number"&&(K=K.withSortBy(k.sortBy)),typeof k.sortOrder=="number"&&(K=K.withSortOrder(k.sortOrder));const{galleryExtensions:H,total:x}=await this.queryGallery(K,W),ne=H.map((se,le)=>$(se,se.versions[0],le,K,k.source)),re=async(se,le)=>{if(le.isCancellationRequested)throw m.canceled();const oe=K.withPage(se+1),{galleryExtensions:ue}=await this.queryGallery(oe,le);return ue.map((me,Se)=>$(me,me.versions[0],Se,oe,k.source))};return{firstPage:ne,total:x,pageSize:K.pageSize,getPage:re}}async queryGallery(R,O){if(!this.isEnabled())throw new Error("No extension gallery service configured.");R=R.withFlags(R.flags,u.ExcludeNonValidated).withFilter(a.ExcludeWithFlags,c(u.Unpublished));const k=await this.commonHeadersPromise,W=JSON.stringify(R.raw),U=Object.assign(Object.assign({},k),{"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(W.length)}),q=new Date().getTime();let K,H,x=0;try{if(K=await this.requestService.request({type:"POST",url:this.api("/extensionquery"),data:W,headers:U},O),K.res.statusCode&&K.res.statusCode>=400&&K.res.statusCode<500)return{galleryExtensions:[],total:x};const ne=await n.asJson(K);if(ne){const re=ne.results[0],se=re.extensions,le=re.resultMetadata&&re.resultMetadata.filter(oe=>oe.metadataType==="ResultCount")[0];return x=le&&le.metadataItems.filter(oe=>oe.name==="TotalCount")[0].count||0,{galleryExtensions:se,total:x}}return{galleryExtensions:[],total:x}}catch(ne){throw H=ne,ne}finally{this.telemetryService.publicLog2("galleryService:query",Object.assign(Object.assign({},R.telemetryData),{requestBodySize:String(W.length),duration:new Date().getTime()-q,success:!!K&&n.isSuccess(K),responseBodySize:K==null?void 0:K.res.headers["Content-Length"],statusCode:K?String(K.res.statusCode):void 0,errorCode:H?m.isPromiseCanceledError(H)?"canceled":m.getErrorMessage(H).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(x)}))}}async reportStatistic(R,O,k,W){if(!this.isEnabled())return;const U=await this.commonHeadersPromise,q=Object.assign(Object.assign({},U),{Accept:"*/*;api-version=4.0-preview.1"});try{await this.requestService.request({type:"POST",url:this.api(`/publishers/${R}/extensions/${O}/${k}/stats?statType=${W}`),headers:q},i.CancellationToken.None)}catch(K){}}async download(R,O,k){this.logService.trace("ExtensionGalleryService#download",R.identifier.id);const W=A.getGalleryExtensionTelemetryData(R),U=new Date().getTime(),q=ne=>this.telemetryService.publicLog("galleryService:downloadVSIX",Object.assign(Object.assign({},W),{duration:ne})),K=k===1?"install":k===2?"update":"",H=K?{uri:`${R.assets.download.uri}&${K}=true`,fallbackUri:`${R.assets.download.fallbackUri}?${K}=true`}:R.assets.download,x=await this.getAsset(H);await this.fileService.writeFile(O,x.stream),q(new Date().getTime()-U)}async getReadme(R,O){if(R.assets.readme){const k=await this.getAsset(R.assets.readme,{},O);return await n.asText(k)||""}return""}async getManifest(R,O){if(R.assets.manifest){const k=await this.getAsset(R.assets.manifest,{},O),W=await n.asText(k);return W?JSON.parse(W):null}return null}async getCoreTranslation(R,O){const k=R.assets.coreTranslations.filter(W=>W[0]===O.toUpperCase())[0];if(k){const W=await this.getAsset(k[1]),U=await n.asText(W);return U?JSON.parse(U):null}return null}async getChangelog(R,O){if(R.assets.changelog){const k=await this.getAsset(R.assets.changelog,{},O);return await n.asText(k)||""}return""}async getAllVersions(R,O){let k=new h().withFlags(u.IncludeVersions,u.IncludeFiles,u.IncludeVersionProperties).withPage(1,1).withFilter(a.Target,"Microsoft.VisualStudio.Code");R.identifier.uuid?k=k.withFilter(a.ExtensionId,R.identifier.uuid):k=k.withFilter(a.ExtensionName,R.identifier.id);const W=[],{galleryExtensions:U}=await this.queryGallery(k,i.CancellationToken.None);return U.length&&(O?await Promise.all(U[0].versions.map(async q=>{let K;try{K=await this.getEngine(q)}catch(H){}K&&w.isEngineValid(K,this.productService.version,this.productService.date)&&W.push({version:q.version,date:q.lastUpdated})})):W.push(...U[0].versions.map(q=>({version:q.version,date:q.lastUpdated})))),W}async getAsset(R,O={},k=i.CancellationToken.None){const W=await this.commonHeadersPromise,U={type:"GET"},q=Object.assign(Object.assign({},W),O.headers||{});O=Object.assign(Object.assign(Object.assign({},O),U),{headers:q});const K=R.uri,H=R.fallbackUri,x=Object.assign(Object.assign({},O),{url:K});try{const ne=await this.requestService.request(x,k);if(ne.res.statusCode===200)return ne;const re=await n.asText(ne);throw new Error(`Expected 200, got back ${ne.res.statusCode} instead.

${re}`)}catch(ne){if(m.isPromiseCanceledError(ne))throw ne;const re=m.getErrorMessage(ne);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:K,message:re});const se=Object.assign(Object.assign({},O),{url:H});return this.requestService.request(se,k)}}async getLastValidExtensionVersion(R,O){const k=this.getLastValidExtensionVersionFromProperties(R,O);return k||this.getLastValidExtensionVersionRecursively(R,O)}getLastValidExtensionVersionFromProperties(R,O){for(const k of O){const W=te(k);if(!W)return null;if(w.isEngineValid(W,this.productService.version,this.productService.date))return k}return null}async getEngine(R){const O=te(R);if(O)return O;const k=V(R,t.Manifest);if(!k)throw new Error("Manifest was not found");const W={"Accept-Encoding":"gzip"},U=await this.getAsset(k,{headers:W}),q=await n.asJson(U);if(q)return q.engines.vscode;throw new Error("Error while reading manifest")}async getLastValidExtensionVersionRecursively(R,O){if(!O.length)return null;const k=O[0],W=await this.getEngine(k);return w.isEngineValid(W,this.productService.version,this.productService.date)?Object.assign(Object.assign({},k),{properties:[...k.properties||[],{key:r.Engine,value:W}]}):this.getLastValidExtensionVersionRecursively(R,O.slice(1))}async getExtensionsReport(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return[];const R=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},i.CancellationToken.None);if(R.res.statusCode!==200)throw new Error("Could not get extensions report.");const O=await n.asJson(R),k=new Map;if(O)for(const W of O.malicious){const U=k.get(W)||{id:{id:W},malicious:!0,slow:!1};U.malicious=!0,k.set(W,U)}return[...k.values()]}};G=he([ee(0,n.IRequestService),ee(1,I.ILogService),ee(2,p.IEnvironmentService),ee(3,E.ITelemetryService),ee(4,P.IFileService),ee(5,g.IProductService),ee(6,b.optional(v.IStorageService))],G),e.ExtensionGalleryService=G;async function N(F,R,O,k){const W={"X-Market-Client-Id":`VSCode ${F}`,"User-Agent":`VSCode ${F}`},U=await D.getServiceMachineId(R,O,k);return W["X-Market-User-Id"]=U,W}e.resolveMarketplaceHeaders=N}),define(J[199],Z([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class m{constructor(S){this.appender=S}listen(S,E){throw new Error(`Event not found: ${E}`)}call(S,E,{eventName:n,data:w}){return this.appender.log(n,w),Promise.resolve(null)}}e.TelemetryAppenderChannel=m;class L{constructor(S){this.channel=S}log(S,E){return this.channel.call("log",{eventName:S,data:E}).then(void 0,n=>`Failed to log telemetry: ${console.warn(n)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=L}),define(J[200],Z([0,1,47,147,23,4,16,48,2,44,37]),function(z,e,m,L,A,S,E,n,w,p,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let I=class{constructor(g,v){this._configurationService=v,this._experimentProperties={},this._disposables=new w.DisposableStore,this._cleanupPatterns=[],this._appender=g.appender,this._commonProperties=g.commonProperties||Promise.resolve({}),this._piiPaths=g.piiPaths||[],this._userOptIn=!0,this._enabled=!0,this.sendErrorTelemetry=!!g.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(let D of this._piiPaths)this._cleanupPatterns.push(new RegExp(A.escapeRegExpCharacters(D),"gi"));this._configurationService&&(this._updateUserOptIn(),this._configurationService.onDidChangeConfiguration(this._updateUserOptIn,this,this._disposables),this.publicLog2("optInStatus",{optIn:this._userOptIn}),this._commonProperties.then(D=>{const b=/^[a-f0-9]+$/i.test(D["common.machineId"]);this.publicLog2("machineIdFallback",{usingFallbackGuid:!b})}))}setExperimentProperty(g,v){this._experimentProperties[g]=v}setEnabled(g){this._enabled=g}_updateUserOptIn(){var g;const v=(g=this._configurationService)===null||g===void 0?void 0:g.getValue(P);this._userOptIn=v?v.enableTelemetry:this._userOptIn}get isOptedIn(){return this._userOptIn&&this._enabled}async getTelemetryInfo(){const g=await this._commonProperties;let v=g.sessionID,D=g["common.instanceId"],b=g["common.machineId"],l=g["common.firstSessionDate"],u=g["common.msftInternal"];return{sessionId:v,instanceId:D,machineId:b,firstSessionDate:l,msftInternal:u}}dispose(){this._disposables.dispose()}publicLog(g,v,D){return this.isOptedIn?this._commonProperties.then(b=>{v=p.mixin(v,b),v=p.mixin(v,this._experimentProperties),v=p.cloneAndChange(v,l=>{if(typeof l=="string")return this._cleanupInfo(l,D)}),this._appender.log(g,v)},b=>{console.error(b)}):Promise.resolve(void 0)}publicLog2(g,v,D){return this.publicLog(g,v,D)}publicLogError(g,v){return this.sendErrorTelemetry?this.publicLog(g,v,!0):Promise.resolve(void 0)}publicLogError2(g,v){return this.publicLogError(g,v)}_cleanupInfo(g,v){let D=g;if(v){const b=[];for(let a of this._cleanupPatterns)for(;;){const t=a.exec(g);if(!t)break;b.push([t.index,a.lastIndex])}const l=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,u=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let c=0;for(D="";;){const a=u.exec(g);if(!a)break;!l.test(a[0])&&b.every(([t,r])=>a.index<t||a.index>=r)&&(D+=g.substring(c,a.index)+"<REDACTED: user-file-path>",c=u.lastIndex)}c<g.length&&(D+=g.substr(c))}for(let b of this._cleanupPatterns)D=D.replace(b,"");return D}};I.IDLE_START_EVENT_NAME="UserIdleStart",I.IDLE_STOP_EVENT_NAME="UserIdleStop",I=he([ee(1,S.optional(E.IConfigurationService))],I),e.TelemetryService=I;const P="telemetry";i.Registry.as(n.Extensions.Configuration).registerConfiguration({id:P,order:110,type:"object",title:L.localize(0,null),properties:{"telemetry.enableTelemetry":{type:"boolean",markdownDescription:m.default.privacyStatementUrl?L.localize(2,null,m.default.privacyStatementUrl):L.localize(1,null),default:!0,restricted:!0,scope:1,tags:["usesOnlineServices"]}}})}),define(J[97],Z([0,1,16,44,13,9]),function(z,e,m,L,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanRemoteAuthority=e.validateTelemetryData=e.configurationTelemetry=e.NullAppender=e.combinedAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=void 0,e.NullTelemetryService=new class{constructor(){this.sendErrorTelemetry=!1,this.isOptedIn=!0}publicLog(g,v){return Promise.resolve(void 0)}publicLog2(g,v){return this.publicLog(g,v)}publicLogError(g,v){return Promise.resolve(void 0)}publicLogError2(g,v){return this.publicLogError(g,v)}setExperimentProperty(){}setEnabled(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}};class E{async publicLog(v,D,b){}async publicLogError(v,D,b){}}e.NullEndpointTelemetryService=E;function n(...g){return{log:(v,D)=>g.forEach(b=>b.log(v,D)),flush:()=>S.Promises.settled(g.map(v=>v.flush()))}}e.combinedAppender=n,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function w(g,v){return v.onDidChangeConfiguration(D=>{D.source!==6&&g.publicLog2("updateConfiguration",{configurationSource:m.ConfigurationTargetToString(D.source),configurationKeys:P(D.sourceConfig)})})}e.configurationTelemetry=w;function p(g){const v=Object.create(null),D=Object.create(null),b=Object.create(null);I(g,b);for(let l in b){l=l.length>150?l.substr(l.length-149):l;const u=b[l];typeof u=="number"?D[l]=u:typeof u=="boolean"?D[l]=u?1:0:typeof u=="string"?v[l]=u.substring(0,1023):typeof u!="undefined"&&u!==null&&(v[l]=u)}return{properties:v,measurements:D}}e.validateTelemetryData=p;function i(g){if(!g)return"none";let v="other";return["ssh-remote","dev-container","attached-container","wsl"].forEach(b=>{g.indexOf(`${b}+`)===0&&(v=b)}),v}e.cleanRemoteAuthority=i;function I(g,v,D=0,b){if(!!g)for(let l of Object.getOwnPropertyNames(g)){const u=g[l],c=b?b+l:l;Array.isArray(u)?v[c]=L.safeStringify(u):u instanceof Date?v[c]=u.toISOString():A.isObject(u)?D<2?I(u,v,D+1,c+"."):v[c]=L.safeStringify(u):v[c]=u}}function P(g){if(!g)return[];const v=[];return y(v,"",g),v}function y(g,v,D){D&&typeof D=="object"&&!Array.isArray(D)?Object.keys(D).forEach(b=>y(g,v?`${v}.${b}`:b,D[b])):g.push(v)}}),define(J[201],Z([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var m;(function(L){L.DARK="dark",L.LIGHT="light",L.HIGH_CONTRAST="hc"})(m=e.ColorScheme||(e.ColorScheme={}))}),define(J[202],Z([0,1,4,2,37,5,201,108]),function(z,e,m,L,A,S,E,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=m.createDecorator("themeService");var w;(function(D){function b(l){return l&&typeof l=="object"&&typeof l.id=="string"}D.isThemeColor=b})(w=e.ThemeColor||(e.ThemeColor={}));function p(D){return{id:D}}e.themeColorFromId=p;var i;(function(D){function b(r){return r&&typeof r=="object"&&typeof r.id=="string"&&(typeof r.color=="undefined"||w.isThemeColor(r.color))}D.isThemeIcon=b;const l=new RegExp(`^\\$\\((${n.CSSIcon.iconNameExpression}(?:${n.CSSIcon.iconModifierExpression})?)\\)$`);function u(r){const s=l.exec(r);if(!s)return;let[,o]=s;return{id:o}}D.fromString=u;function c(r,s){let o=r.id;const h=o.lastIndexOf("~");return h!==-1&&(o=o.substring(0,h)),s&&(o=`${o}~${s}`),{id:o}}D.modify=c;function a(r,s){var o,h;return r.id===s.id&&((o=r.color)===null||o===void 0?void 0:o.id)===((h=s.color)===null||h===void 0?void 0:h.id)}D.isEqual=a;function t(r){return{id:r.id}}D.asThemeIcon=t,D.asClassNameArray=n.CSSIcon.asClassNameArray,D.asClassName=n.CSSIcon.asClassName,D.asCSSSelector=n.CSSIcon.asCSSSelector})(i=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=n.Codicon.file,e.FolderThemeIcon=n.Codicon.folder;function I(D){switch(D){case E.ColorScheme.DARK:return"vs-dark";case E.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=I,e.Extensions={ThemingContribution:"base.contributions.theming"};class P{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new S.Emitter}onColorThemeChange(b){return this.themingParticipants.push(b),this.onThemingParticipantAddedEmitter.fire(b),L.toDisposable(()=>{const l=this.themingParticipants.indexOf(b);this.themingParticipants.splice(l,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let y=new P;A.Registry.add(e.Extensions.ThemingContribution,y);function g(D){return y.onColorThemeChange(D)}e.registerThemingParticipant=g;class v extends L.Disposable{constructor(b){super();this.themeService=b,this.theme=b.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(l=>this.onThemeChange(l)))}onThemeChange(b){this.theme=b,this.updateStyles()}updateStyles(){}getColor(b,l){let u=this.theme.getColor(b);return u&&l&&(u=l(u,this.theme)),u?u.toString():null}}e.Themable=v}),define(J[60],Z([0,1,14,3,38,4]),function(z,e,m,L,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeMainService=e.IThemeMainService=void 0;const E="#FFFFFF",n="#1E1E1E",w="#000000",p="theme",i="themeBackground",I="windowSplash";e.IThemeMainService=S.createDecorator("themeMainService");let P=class{constructor(g){this.stateMainService=g}getBackgroundColor(){if((L.isWindows||L.isMacintosh)&&m.nativeTheme.shouldUseInvertedColorScheme)return w;let g=this.stateMainService.getItem(i,null);if(!g){let v;(L.isWindows||L.isMacintosh)&&m.nativeTheme.shouldUseInvertedColorScheme?v="hc-black":v=this.stateMainService.getItem(p,"vs-dark").split(" ")[0],g=v==="hc-black"?w:v==="vs"?E:n}return L.isMacintosh&&g.toUpperCase()===n&&(g="#171717"),g}saveWindowSplash(g,v){this.stateMainService.setItems([{key:p,data:v.baseTheme},{key:i,data:v.colorInfo.background},{key:I,data:v}]),typeof g=="number"&&this.updateBackgroundColor(g,v)}updateBackgroundColor(g,v){for(const D of m.BrowserWindow.getAllWindows())if(D.id===g){D.setBackgroundColor(v.colorInfo.background);break}}getWindowSplash(){return this.stateMainService.getItem(I)}};P=he([ee(0,A.IStateMainService)],P),e.ThemeMainService=P}),define(J[41],Z([0,1,4]),function(z,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUpdateService=e.State=e.UpdateType=e.StateType=void 0;var L;(function(S){S.Uninitialized="uninitialized",S.Idle="idle",S.CheckingForUpdates="checking for updates",S.AvailableForDownload="available for download",S.Downloading="downloading",S.Downloaded="downloaded",S.Updating="updating",S.Ready="ready"})(L=e.StateType||(e.StateType={}));var A;(function(S){S[S.Setup=0]="Setup",S[S.Archive=1]="Archive",S[S.Snap=2]="Snap"})(A=e.UpdateType||(e.UpdateType={})),e.State={Uninitialized:{type:"uninitialized"},Idle:(S,E)=>({type:"idle",updateType:S,error:E}),CheckingForUpdates:S=>({type:"checking for updates",explicit:S}),AvailableForDownload:S=>({type:"available for download",update:S}),Downloading:S=>({type:"downloading",update:S}),Downloaded:S=>({type:"downloaded",update:S}),Updating:S=>({type:"updating",update:S}),Ready:S=>({type:"ready",update:S})},e.IUpdateService=m.createDecorator("updateService")}),define(J[203],Z([0,1,37,48,148,3]),function(z,e,m,L,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),m.Registry.as(L.Extensions.Configuration).registerConfiguration({id:"update",order:15,title:A.localize(0,null),type:"object",properties:{"update.mode":{type:"string",enum:["none","manual","start","default"],default:"default",scope:1,description:A.localize(1,null),tags:["usesOnlineServices"],enumDescriptions:[A.localize(2,null),A.localize(3,null),A.localize(4,null),A.localize(5,null)]},"update.channel":{type:"string",default:"default",scope:1,description:A.localize(6,null),deprecationMessage:A.localize(7,null,"update.mode")},"update.enableWindowsBackgroundUpdates":{type:"boolean",default:!0,scope:1,title:A.localize(8,null),description:A.localize(9,null),included:S.isWindows&&!S.isWeb},"update.showReleaseNotes":{type:"boolean",default:!0,scope:1,description:A.localize(10,null),tags:["usesOnlineServices"]}}})}),define(J[204],Z([0,1,5,41]),function(z,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UpdateChannelClient=e.UpdateChannel=void 0;class A{constructor(n){this.service=n}listen(n,w){switch(w){case"onStateChange":return this.service.onStateChange}throw new Error(`Event not found: ${w}`)}call(n,w,p){switch(w){case"checkForUpdates":return this.service.checkForUpdates(p);case"downloadUpdate":return this.service.downloadUpdate();case"applyUpdate":return this.service.applyUpdate();case"quitAndInstall":return this.service.quitAndInstall();case"_getInitialState":return Promise.resolve(this.service.state);case"isLatestVersion":return this.service.isLatestVersion()}throw new Error(`Call not found: ${w}`)}}e.UpdateChannel=A;class S{constructor(n){this.channel=n,this._onStateChange=new m.Emitter,this.onStateChange=this._onStateChange.event,this._state=L.State.Uninitialized,this.channel.listen("onStateChange")(w=>this.state=w),this.channel.call("_getInitialState").then(w=>this.state=w)}get state(){return this._state}set state(n){this._state=n,this._onStateChange.fire(n)}checkForUpdates(n){return this.channel.call("checkForUpdates",n)}downloadUpdate(){return this.channel.call("downloadUpdate")}applyUpdate(){return this.channel.call("applyUpdate")}quitAndInstall(){return this.channel.call("quitAndInstall")}isLatestVersion(){return this.channel.call("isLatestVersion")}}e.UpdateChannelClient=S}),define(J[98],Z([0,1,4]),function(z,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IURLService=void 0,e.IURLService=m.createDecorator("urlService")}),define(J[205],Z([0,1,7]),function(z,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URLHandlerRouter=e.URLHandlerChannelClient=e.URLHandlerChannel=void 0;class L{constructor(n){this.handler=n}listen(n,w){throw new Error(`Event not found: ${w}`)}call(n,w,p){switch(w){case"handleURL":return this.handler.handleURL(m.URI.revive(p[0]),p[1])}throw new Error(`Call not found: ${w}`)}}e.URLHandlerChannel=L;class A{constructor(n){this.channel=n}handleURL(n,w){return this.channel.call("handleURL",[n.toJSON(),w])}}e.URLHandlerChannelClient=A;class S{constructor(n){this.next=n}async routeCall(n,w,p,i){if(w!=="handleURL")throw new Error(`Call not found: ${w}`);if(p){const I=m.URI.revive(p);if(I&&I.query){const P=/\bwindowId=(\d+)/.exec(I.query);if(P){const y=P[1],g=new RegExp(`window:${y}`),v=n.connections.find(D=>g.test(D.ctx));if(v)return v}}}return this.next.routeCall(n,w,p,i)}routeEvent(n,w){throw new Error(`Event not found: ${w}`)}}e.URLHandlerRouter=S}),define(J[206],Z([0,1,7,9,2,22]),function(z,e,m,L,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeURLService=e.AbstractURLService=void 0;class E extends A.Disposable{constructor(){super(...arguments);this.handlers=new Set}open(p,i){const I=[...this.handlers.values()];return L.first(I.map(P=>()=>P.handleURL(p,i)),void 0,!1).then(P=>P||!1)}registerHandler(p){return this.handlers.add(p),A.toDisposable(()=>this.handlers.delete(p))}}e.AbstractURLService=E;let n=class extends E{constructor(p){super();this.productService=p}create(p){let{authority:i,path:I,query:P,fragment:y}=p||{authority:void 0,path:void 0,query:void 0,fragment:void 0};return i&&I&&I.indexOf("/")!==0&&(I=`/${I}`),m.URI.from({scheme:this.productService.urlProtocol,authority:i,path:I,query:P,fragment:y})}};n=he([ee(0,S.IProductService)],n),e.NativeURLService=n}),define(J[207],Z([0,1,5,14,7,2,3,9]),function(z,e,m,L,A,S,E,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronURLListener=void 0;function w(i){try{return A.URI.parse(i)}catch(I){return null}}class p{constructor(I,P,y,g,v){if(this.urlService=P,this.uris=[],this.retryCount=0,this.flushDisposable=S.Disposable.None,this.disposables=new S.DisposableStore,this.uris=I,E.isWindows){const l=g.isBuilt?[]:[`"${g.appRoot}"`];l.push("--open-url","--"),L.app.setAsDefaultProtocolClient(v.urlProtocol,process.execPath,l)}const D=m.Event.map(m.Event.fromNodeEventEmitter(L.app,"open-url",(l,u)=>({event:l,url:u})),({event:l,url:u})=>(l.preventDefault(),u));this.disposables.add(D(l=>{const u=w(l);!u||this.urlService.open(u,{originalUrl:l})})),y.getWindows().filter(l=>l.isReady).length>0?this.flush():m.Event.once(y.onDidSignalReadyWindow)(this.flush,this,this.disposables)}async flush(){if(this.retryCount++>10)return;const I=[];for(const P of this.uris)await this.urlService.open(P.uri,{originalUrl:P.url})||I.push(P);I.length!==0&&(this.uris=I,this.flushDisposable=n.disposableTimeout(()=>this.flush(),500))}dispose(){this.disposables.dispose(),this.flushDisposable.dispose()}}e.ElectronURLListener=p}),define(J[76],Z([0,1,4]),function(z,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.webviewPartitionId=e.IWebviewManagerService=void 0,e.IWebviewManagerService=m.createDecorator("webviewManagerService"),e.webviewPartitionId="webview"}),define(J[208],Z([0,1,14,2,10,7,76]),function(z,e,m,L,A,S,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewProtocolProvider=void 0;class n extends L.Disposable{constructor(){super();const p=m.session.fromPartition(E.webviewPartitionId),i=this.handleWebviewRequest.bind(this);m.protocol.registerFileProtocol(A.Schemas.vscodeWebview,i),p.protocol.registerFileProtocol(A.Schemas.vscodeWebview,i)}async handleWebviewRequest(p,i){try{const I=S.URI.parse(p.url),P=n.validWebviewFilePaths.get(I.path);if(typeof P=="string"){const y=I.path.startsWith("/electron-browser")?`vs/workbench/contrib/webview/electron-browser/pre/${P}`:`vs/workbench/contrib/webview/browser/pre/${P}`,g=A.FileAccess.asFileUri(y,z);return i(decodeURIComponent(g.fsPath))}}catch(I){}i({error:-10})}}e.WebviewProtocolProvider=n,n.validWebviewFilePaths=new Map([["/index.html","index.html"],["/fake.html","fake.html"],["/electron-browser-index.html","index.html"],["/main.js","main.js"],["/host.js","host.js"],["/service-worker.js","service-worker.js"]])}),define(J[61],Z([0,1,3]),function(z,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.zoomLevelToZoomFactor=e.getTitleBarStyle=e.getMenuBarVisibility=e.isFileToOpen=e.isFolderToOpen=e.isWorkspaceToOpen=e.WindowMinimumSize=void 0,e.WindowMinimumSize={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function L(p){return!!p.workspaceUri}e.isWorkspaceToOpen=L;function A(p){return!!p.folderUri}e.isFolderToOpen=A;function S(p){return!!p.fileUri}e.isFileToOpen=S;function E(p){const i=n(p),I=p.getValue("window.menuBarVisibility");return I==="default"||i==="native"&&I==="compact"||m.isMacintosh&&m.isNative?"classic":I}e.getMenuBarVisibility=E;function n(p){if(m.isWeb)return"custom";const i=p.getValue("window");if(i){if(m.isMacintosh&&i.nativeTabs===!0||m.isMacintosh&&i.nativeFullScreen===!1)return"native";const y=i.titleBarStyle;if(y==="native"||y==="custom")return y}return m.isLinux?"native":"custom"}e.getTitleBarStyle=n;function w(p=0){return Math.pow(1.2,p)}e.zoomLevelToZoomFactor=w}),define(J[34],Z([0,1,4]),function(z,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWindowsMainService=e.WindowError=e.WindowMode=e.defaultWindowState=e.OpenContext=void 0;var L;(function(n){n[n.CLI=0]="CLI",n[n.DOCK=1]="DOCK",n[n.MENU=2]="MENU",n[n.DIALOG=3]="DIALOG",n[n.DESKTOP=4]="DESKTOP",n[n.API=5]="API"})(L=e.OpenContext||(e.OpenContext={}));const A=function(n=1){return{width:1024,height:768,mode:n}};e.defaultWindowState=A;var S;(function(n){n[n.Maximized=0]="Maximized",n[n.Normal=1]="Normal",n[n.Minimized=2]="Minimized",n[n.Fullscreen=3]="Fullscreen"})(S=e.WindowMode||(e.WindowMode={}));var E;(function(n){n[n.UNRESPONSIVE=1]="UNRESPONSIVE",n[n.CRASHED=2]="CRASHED",n[n.LOAD=3]="LOAD"})(E=e.WindowError||(e.WindowError={})),e.IWindowsMainService=m.createDecorator("windowsMainService")}),define(J[209],Z([0,1,14,2,74,76,208,34]),function(z,e,m,L,A,S,E,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewMainService=void 0;let w=class extends L.Disposable{constructor(i,I){super();this.windowsMainService=I,this._register(new E.WebviewProtocolProvider);const P=m.session.fromPartition(S.webviewPartitionId);P.setPermissionRequestHandler((y,g,v)=>v(g==="clipboard-read")),P.setPermissionCheckHandler((y,g)=>g==="clipboard-read")}async setIgnoreMenuShortcuts(i,I){let P;if(typeof i.windowId=="number"){const{windowId:y}=i,g=this.windowsMainService.getWindowById(y);if(!(g==null?void 0:g.win))throw new Error(`Invalid windowId: ${y}`);P=g.win.webContents}else{const{webContentsId:y}=i;if(P=m.webContents.fromId(y),!P)throw new Error(`Invalid webContentsId: ${y}`)}P.isDestroyed()||P.setIgnoreMenuShortcuts(I)}};w=he([ee(0,A.ITunnelService),ee(1,n.IWindowsMainService)],w),e.WebviewMainService=w}),define(J[210],Z([0,1,5,2,9]),function(z,e,m,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class S extends L.Disposable{constructor({onDidOpenWindow:n,onDidFocusWindow:w,getActiveWindowId:p}){super();this.disposables=this._register(new L.DisposableStore),m.Event.latch(m.Event.any(n,w))(this.setActiveWindow,this,this.disposables),this.firstActiveWindowIdPromise=A.createCancelablePromise(()=>p()),(async()=>{try{const I=await this.firstActiveWindowIdPromise;this.activeWindowId=typeof this.activeWindowId=="number"?this.activeWindowId:I}catch(I){}finally{this.firstActiveWindowIdPromise=void 0}})()}setActiveWindow(n){this.firstActiveWindowIdPromise&&(this.firstActiveWindowIdPromise.cancel(),this.firstActiveWindowIdPromise=void 0),this.activeWindowId=n}async getActiveClientId(){return`window:${this.firstActiveWindowIdPromise?await this.firstActiveWindowIdPromise:this.activeWindowId}`}}e.ActiveWindowManager=S}),define(J[211],Z([0,1,7,15,4,36]),function(z,e,m,L,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=A.createDecorator("contextService");var E;(function(P){P[P.EMPTY=1]="EMPTY",P[P.FOLDER=2]="FOLDER",P[P.WORKSPACE=3]="WORKSPACE"})(E=e.WorkbenchState||(e.WorkbenchState={}));function n(P){const y=P;return!!(y&&typeof y=="object"&&typeof y.id=="string"&&Array.isArray(y.folders))}e.isWorkspace=n;function w(P){const y=P;return!!(y&&typeof y=="object"&&m.URI.isUri(y.uri)&&typeof y.name=="string"&&typeof y.toResource=="function")}e.isWorkspaceFolder=w;class p{constructor(y,g,v,D){this._id=y,this._configuration=v,this._ignorePathCasing=D,this._foldersMap=S.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=g}update(y){this._id=y.id,this._configuration=y.configuration,this._ignorePathCasing=y._ignorePathCasing,this.folders=y.folders}get folders(){return this._folders}set folders(y){this._folders=y,this.updateFoldersMap()}get id(){return this._id}get configuration(){return this._configuration}set configuration(y){this._configuration=y}getFolder(y){return y&&this._foldersMap.findSubstr(y.with({scheme:y.scheme,authority:y.authority,path:y.path}))||null}updateFoldersMap(){this._foldersMap=S.TernarySearchTree.forUris(this._ignorePathCasing);for(const y of this.folders)this._foldersMap.set(y.uri,y)}toJSON(){return{id:this.id,folders:this.folders,configuration:this.configuration}}}e.Workspace=p;class i{constructor(y,g){this.raw=g,this.uri=y.uri,this.index=y.index,this.name=y.name}toResource(y){return L.joinPath(this.uri,y)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=i;function I(P){return new i({uri:P,index:0,name:L.basenameOrAuthority(P)},{uri:P.toString()})}e.toWorkspaceFolder=I}),define(J[28],Z([0,1,4,151,211,7,3,8,15,104,43,10,39,29,73]),function(z,e,m,L,A,S,E,n,w,p,i,I,P,y,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.useSlashForPath=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isRawUriWorkspaceFolder=e.isRawFileWorkspaceFolder=e.isStoredWorkspaceFolder=e.isUntitledWorkspace=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=e.hasWorkspaceFileExtension=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_EXTENSION=void 0,e.WORKSPACE_EXTENSION="code-workspace";const v=`.${e.WORKSPACE_EXTENSION}`;e.WORKSPACE_FILTER=[{name:L.localize(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function D(_){return(typeof _=="string"?n.extname(_):w.extname(_))===v}e.hasWorkspaceFileExtension=D,e.IWorkspacesService=m.createDecorator("workspacesService");function b(_){return _.hasOwnProperty("workspace")}e.isRecentWorkspace=b;function l(_){return _.hasOwnProperty("folderUri")}e.isRecentFolder=l;function u(_){return _.hasOwnProperty("fileUri")}e.isRecentFile=u;function c(_){const $=_;return typeof($==null?void 0:$.id)=="string"&&S.URI.isUri($.uri)}e.isSingleFolderWorkspaceIdentifier=c;function a(_){if(_.configuration)return{id:_.id,configPath:_.configuration};if(_.folders.length===1)return{id:_.id,uri:_.folders[0].uri}}e.toWorkspaceIdentifier=a;function t(_){const $=_;return typeof($==null?void 0:$.id)=="string"&&S.URI.isUri($.configPath)}e.isWorkspaceIdentifier=t;function r(_){const $=_;if($==null?void 0:$.uri)return{id:$.id,uri:S.URI.revive($.uri)};const G=_;if(G==null?void 0:G.configPath)return{id:G.id,configPath:S.URI.revive(G.configPath)};if(_==null?void 0:_.id)return{id:_.id}}e.reviveIdentifier=r;function s(_,$){return w.extUriBiasedIgnorePathCase.isEqualOrParent(_,$.untitledWorkspacesHome)}e.isUntitledWorkspace=s;function o(_){return h(_)||f(_)}e.isStoredWorkspaceFolder=o;function h(_){const $=_;return typeof($==null?void 0:$.path)=="string"&&(!$.name||typeof $.name=="string")}e.isRawFileWorkspaceFolder=h;function f(_){const $=_;return typeof($==null?void 0:$.uri)=="string"&&(!$.name||typeof $.name=="string")}e.isRawUriWorkspaceFolder=f;function d(_,$,G,N,F=!E.isWindows,R){if(_.scheme!==N.scheme)return{name:G,uri:_.toString(!0)};let O=$?void 0:R.relativePath(N,_);if(O!==void 0)O.length===0?O=".":E.isWindows&&_.scheme===I.Schemas.file&&!F&&(O=O.replace(/\//g,"\\"));else if(_.scheme===I.Schemas.file)O=_.fsPath,E.isWindows&&(O=P.normalizeDriveLetter(O),F&&(O=y.toSlashes(O)));else{if(!R.isEqualAuthority(_.authority,N.authority))return{name:G,uri:_.toString(!0)};O=_.path}return{name:G,path:O}}e.getStoredWorkspaceFolder=d;function M(_,$,G){let N=[],F=new Set;const R=G.dirname($);for(let O of _){let k;if(h(O))O.path&&(k=G.resolvePath(R,O.path));else if(f(O))try{k=S.URI.parse(O.uri),k.path[0]!=="/"&&(k=k.with({path:"/"+k.path}))}catch(W){console.warn(W)}if(k){let W=G.getComparisonKey(k);if(!F.has(W)){F.add(W);const U=O.name||G.basenameOrAuthority(k);N.push(new A.WorkspaceFolder({uri:k,name:U,index:N.length},O))}}}return N}e.toWorkspaceFolders=M;function T(_,$,G,N,F){let R=C($,_);const O=F.dirname($),k=F.dirname(N),W=[],U=V(R.folders);for(const x of R.folders){const ne=h(x)?F.resolvePath(O,x.path):S.URI.parse(x.uri);let re;G?re=!1:re=!h(x)||n.isAbsolute(x.path),W.push(d(ne,re,x.name,k,U,F))}const q={insertSpaces:!1,tabSize:4,eol:E.isLinux||E.isMacintosh?`
`:`\r
`},K=p.setProperty(_,["folders"],W,q);let H=p.applyEdits(_,K);return R.remoteAuthority===g.getRemoteAuthority(N)&&(H=p.applyEdits(H,p.removeProperty(H,["remoteAuthority"],q))),H}e.rewriteWorkspaceFileForNewLocation=T;function C(_,$){let G=i.parse($);if(G&&Array.isArray(G.folders))G.folders=G.folders.filter(N=>o(N));else throw new Error(`${_} looks like an invalid workspace file.`);return G}function V(_){return E.isWindows?_.some($=>h($)&&$.path.indexOf("/")>=0):!0}e.useSlashForPath=V;function Q(_){return _.workspace&&typeof _.workspace=="object"&&typeof _.workspace.id=="string"&&typeof _.workspace.configPath=="string"}function te(_){return typeof _.folderUri=="string"}function B(_){return typeof _.fileUri=="string"}function Y(_,$){const G={workspaces:[],files:[]};if(_){const N=function(R,O){for(let k=0;k<R.length;k++)try{O(R[k],k)}catch(W){$.warn(`Error restoring recent entry ${JSON.stringify(R[k])}: ${W.toString()}. Skip entry.`)}},F=_;if(Array.isArray(F.entries))N(F.entries,R=>{const O=R.label,k=R.remoteAuthority;Q(R)?G.workspaces.push({label:O,remoteAuthority:k,workspace:{id:R.workspace.id,configPath:S.URI.parse(R.workspace.configPath)}}):te(R)?G.workspaces.push({label:O,remoteAuthority:k,folderUri:S.URI.parse(R.folderUri)}):B(R)&&G.files.push({label:O,remoteAuthority:k,fileUri:S.URI.parse(R.fileUri)})});else{const R=_;Array.isArray(R.workspaces3)&&N(R.workspaces3,(O,k)=>{const W=Array.isArray(R.workspaceLabels)&&R.workspaceLabels[k]||void 0;typeof O=="object"&&typeof O.id=="string"&&typeof O.configURIPath=="string"?G.workspaces.push({label:W,workspace:{id:O.id,configPath:S.URI.parse(O.configURIPath)}}):typeof O=="string"&&G.workspaces.push({label:W,folderUri:S.URI.parse(O)})}),Array.isArray(R.files2)&&N(R.files2,(O,k)=>{const W=Array.isArray(R.fileLabels)&&R.fileLabels[k]||void 0;typeof O=="string"&&G.files.push({label:W,fileUri:S.URI.parse(O)})})}}return G}e.restoreRecentlyOpened=Y;function X(_){const $={entries:[]};for(const G of _.workspaces)l(G)?$.entries.push({folderUri:G.folderUri.toString(),label:G.label,remoteAuthority:G.remoteAuthority}):$.entries.push({workspace:{id:G.workspace.id,configPath:G.workspace.configPath.toString()},label:G.label,remoteAuthority:G.remoteAuthority});for(const G of _.files)$.entries.push({fileUri:G.fileUri.toString(),label:G.label,remoteAuthority:G.remoteAuthority});return $}e.toStoreData=X}),define(J[50],Z([0,1,4,28]),function(z,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isWorkspaceBackupInfo=e.IBackupMainService=void 0,e.IBackupMainService=m.createDecorator("backupMainService");function A(S){const E=S;return E&&L.isWorkspaceIdentifier(E.workspace)}e.isWorkspaceBackupInfo=A}),define(J[51],Z([0,1,4,14,9,38,3,8,65,17,13,133,28,39,2,80]),function(z,e,m,L,A,S,E,n,w,p,i,I,P,y,g,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DialogMainService=e.IDialogMainService=void 0,e.IDialogMainService=m.createDecorator("dialogMainService");let D=class vt{constructor(l){this.stateMainService=l,this.windowFileDialogLocks=new Map,this.windowDialogQueues=new Map,this.noWindowDialogueQueue=new A.Queue}pickFileFolder(l,u){return this.doPick(Object.assign(Object.assign({},l),{pickFolders:!0,pickFiles:!0,title:I.localize(0,null)}),u)}pickFolder(l,u){return this.doPick(Object.assign(Object.assign({},l),{pickFolders:!0,title:I.localize(1,null)}),u)}pickFile(l,u){return this.doPick(Object.assign(Object.assign({},l),{pickFiles:!0,title:I.localize(2,null)}),u)}pickWorkspace(l,u){const c=I.localize(3,null),a=y.mnemonicButtonLabel(I.localize(4,null)),t=P.WORKSPACE_FILTER;return this.doPick(Object.assign(Object.assign({},l),{pickFiles:!0,title:c,filters:t,buttonLabel:a}),u)}async doPick(l,u){const c={title:l.title,buttonLabel:l.buttonLabel,filters:l.filters};c.defaultPath=l.defaultPath||this.stateMainService.getItem(vt.workingDirPickerStorageKey),(typeof l.pickFiles=="boolean"||typeof l.pickFolders=="boolean")&&(c.properties=void 0,l.pickFiles&&l.pickFolders&&(c.properties=["multiSelections","openDirectory","openFile","createDirectory"])),c.properties||(c.properties=["multiSelections",l.pickFolders?"openDirectory":"openFile","createDirectory"]),E.isMacintosh&&c.properties.push("treatPackageAsDirectory");const a=u||L.BrowserWindow.getFocusedWindow(),t=await this.showOpenDialog(c,i.withNullAsUndefined(a));if(t&&t.filePaths&&t.filePaths.length>0)return this.stateMainService.setItem(vt.workingDirPickerStorageKey,n.dirname(t.filePaths[0])),t.filePaths}getWindowDialogQueue(l){if(l){let u=this.windowDialogQueues.get(l.id);return u||(u=new A.Queue,this.windowDialogQueues.set(l.id,u)),u}else return this.noWindowDialogueQueue}showMessageBox(l,u){return this.getWindowDialogQueue(u).queue(async()=>u?L.dialog.showMessageBox(u,l):L.dialog.showMessageBox(l))}async showSaveDialog(l,u){const c=this.acquireFileDialogLock(l,u);if(!c)throw new Error("A file save dialog is already or will be showing for the window with the same configuration");try{return await this.getWindowDialogQueue(u).queue(async()=>{let a;return u?a=await L.dialog.showSaveDialog(u,l):a=await L.dialog.showSaveDialog(l),a.filePath=this.normalizePath(a.filePath),a})}finally{g.dispose(c)}}normalizePath(l){return l&&E.isMacintosh&&(l=w.normalizeNFC(l)),l}normalizePaths(l){return l.map(u=>this.normalizePath(u))}async showOpenDialog(l,u){l.defaultPath&&(await p.Promises.exists(l.defaultPath)||(l.defaultPath=void 0));const c=this.acquireFileDialogLock(l,u);if(!c)throw new Error("A file open dialog is already or will be showing for the window with the same configuration");try{return await this.getWindowDialogQueue(u).queue(async()=>{let a;return u?a=await L.dialog.showOpenDialog(u,l):a=await L.dialog.showOpenDialog(l),a.filePaths=this.normalizePaths(a.filePaths),a})}finally{g.dispose(c)}}acquireFileDialogLock(l,u){if(!u)return g.Disposable.None;let c=this.windowFileDialogLocks.get(u.id);c||(c=new Set,this.windowFileDialogLocks.set(u.id,c));const a=v.hash(l);if(!c.has(a))return c.add(a),g.toDisposable(()=>{c==null||c.delete(a),(c==null?void 0:c.size)===0&&this.windowFileDialogLocks.delete(u.id)})}};D.workingDirPickerStorageKey="pickerWorkingDir",D=he([ee(0,S.IStateMainService)],D),e.DialogMainService=D}),define(J[212],Z([0,1,5,2,28]),function(z,e,m,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDatabaseChannel=void 0;class S extends L.Disposable{constructor(n,w){super();this.logService=n,this.storageMainService=w,this._onDidChangeGlobalStorage=this._register(new m.Emitter),this.onDidChangeGlobalStorage=this._onDidChangeGlobalStorage.event,this.registerGlobalStorageListeners()}registerGlobalStorageListeners(){this._register(m.Event.debounce(this.storageMainService.globalStorage.onDidChangeStorage,(n,w)=>(n?n.push(w):n=[w],n),S.STORAGE_CHANGE_DEBOUNCE_TIME)(n=>{n.length&&this._onDidChangeGlobalStorage.fire(this.serializeGlobalStorageEvents(n))}))}serializeGlobalStorageEvents(n){const w=new Map,p=new Set;return n.forEach(i=>{const I=this.storageMainService.globalStorage.get(i.key);typeof I=="string"?w.set(i.key,I):p.add(i.key)}),{changed:Array.from(w.entries()),deleted:Array.from(p.values())}}listen(n,w){switch(w){case"onDidChangeGlobalStorage":return this.onDidChangeGlobalStorage}throw new Error(`Event not found: ${w}`)}async call(n,w,p){const i=A.reviveIdentifier(p.workspace),I=await this.withStorageInitialized(i);switch(w){case"getItems":return Array.from(I.items.entries());case"updateItems":{const P=p;if(P.insert)for(const[y,g]of P.insert)I.set(y,g);P.delete&&P.delete.forEach(y=>I.delete(y));break}case"close":{if(i)return I.close();break}default:throw new Error(`Call not found: ${w}`)}}async withStorageInitialized(n){const w=n?this.storageMainService.workspaceStorage(n):this.storageMainService.globalStorage;try{await w.init()}catch(p){this.logService.error(`StorageIPC#init: Unable to init ${n?"workspace":"global"} storage due to ${p}`)}return w}}e.StorageDatabaseChannel=S,S.STORAGE_CHANGE_DEBOUNCE_TIME=100}),define(J[213],Z([0,1,17,5,2,6,123,86,8,96,31,27,28]),function(z,e,m,L,A,S,E,n,w,p,i,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspaceStorageMain=e.GlobalStorageMain=void 0;class y extends A.Disposable{constructor(b){super();this.logService=b,this._onDidChangeStorage=this._register(new L.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this._onDidCloseStorage=this._register(new L.Emitter),this.onDidCloseStorage=this._onDidCloseStorage.event,this.storage=new n.Storage(new n.InMemoryStorageDatabase),this.initializePromise=void 0}init(){return this.initializePromise||(this.initializePromise=(async()=>{try{const b=await this.doCreate();this.storage.dispose(),this.storage=b,this._register(b.onDidChangeStorage(u=>this._onDidChangeStorage.fire({key:u}))),await this.doInit(b);const l=b.getBoolean(p.IS_NEW_KEY);l===void 0?b.set(p.IS_NEW_KEY,!0):l&&b.set(p.IS_NEW_KEY,!1)}catch(b){this.logService.error(`StorageMain#initialize(): Unable to init storage due to ${b}`)}})()),this.initializePromise}createLogginOptions(){return{logTrace:this.logService.getLevel()===S.LogLevel.Trace?b=>this.logService.trace(b):void 0,logError:b=>this.logService.error(b)}}doInit(b){return b.init()}get items(){return this.storage.items}get(b,l){return this.storage.get(b,l)}set(b,l){return this.storage.set(b,l)}delete(b){return this.storage.delete(b)}async close(){this.initializePromise&&await this.initializePromise,await this.storage.close(),this._onDidCloseStorage.fire()}}class g extends y{constructor(b,l,u){super(l);this.options=b,this.environmentService=u}async doCreate(){let b;return this.options.useInMemoryStorage?b=E.SQLiteStorageDatabase.IN_MEMORY_PATH:b=w.join(this.environmentService.globalStorageHome.fsPath,g.STORAGE_NAME),new n.Storage(new E.SQLiteStorageDatabase(b,{logging:this.createLogginOptions()}))}async doInit(b){await super.doInit(b),this.updateTelemetryState(b)}updateTelemetryState(b){b.get(i.instanceStorageKey,void 0)===void 0&&b.set(i.instanceStorageKey,I.generateUuid()),b.get(i.firstSessionDateStorageKey,void 0)===void 0&&b.set(i.firstSessionDateStorageKey,new Date().toUTCString());const c=b.get(i.currentSessionDateStorageKey,void 0),a=new Date().toUTCString();b.set(i.lastSessionDateStorageKey,typeof c=="undefined"?null:c),b.set(i.currentSessionDateStorageKey,a)}}e.GlobalStorageMain=g,g.STORAGE_NAME="state.vscdb";class v extends y{constructor(b,l,u,c){super(u);this.workspace=b,this.options=l,this.environmentService=c}async doCreate(){const{storageFilePath:b,wasCreated:l}=await this.prepareWorkspaceStorageFolder();return new n.Storage(new E.SQLiteStorageDatabase(b,{logging:this.createLogginOptions()}),{hint:l?n.StorageHint.STORAGE_DOES_NOT_EXIST:void 0})}async prepareWorkspaceStorageFolder(){if(this.options.useInMemoryStorage)return{storageFilePath:E.SQLiteStorageDatabase.IN_MEMORY_PATH,wasCreated:!0};const b=w.join(this.environmentService.workspaceStorageHome.fsPath,this.workspace.id),l=w.join(b,v.WORKSPACE_STORAGE_NAME);return await m.Promises.exists(b)?{storageFilePath:l,wasCreated:!1}:(await m.Promises.mkdir(b,{recursive:!0}),this.ensureWorkspaceStorageFolderMeta(b),{storageFilePath:l,wasCreated:!0})}async ensureWorkspaceStorageFolderMeta(b){let l;if(P.isSingleFolderWorkspaceIdentifier(this.workspace)?l={folder:this.workspace.uri.toString()}:P.isWorkspaceIdentifier(this.workspace)&&(l={workspace:this.workspace.configPath.toString()}),l)try{const u=w.join(b,v.WORKSPACE_META_NAME);await m.Promises.exists(u)||await m.Promises.writeFile(u,JSON.stringify(l,void 0,2))}catch(u){this.logService.error(`StorageMain#ensureWorkspaceStorageFolderMeta(): Unable to create workspace storage metadata due to ${u}`)}}}e.WorkspaceStorageMain=v,v.WORKSPACE_STORAGE_NAME="state.vscdb",v.WORKSPACE_META_NAME="workspace.json"}),define(J[99],Z([0,1,42,2,53,4,18,6,213]),function(z,e,m,L,A,S,E,n,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageMainService=e.IStorageMainService=void 0,e.IStorageMainService=S.createDecorator("storageMainService");let p=class extends L.Disposable{constructor(I,P,y){super();this.logService=I,this.environmentService=P,this.lifecycleMainService=y,this.globalStorage=this.createGlobalStorage(),this.mapWorkspaceToStorage=new Map,this.registerListeners()}getStorageOptions(){return{useInMemoryStorage:!!this.environmentService.extensionTestsLocationURI}}registerListeners(){(async()=>{await this.lifecycleMainService.when(3),this.globalStorage.init()})(),this._register(this.lifecycleMainService.onWillLoadWindow(async I=>{I.workspace&&this.workspaceStorage(I.workspace).init()})),this._register(this.lifecycleMainService.onWillShutdown(I=>{I.join(this.globalStorage.close());for(const[,P]of this.mapWorkspaceToStorage)I.join(P.close())}))}createGlobalStorage(){if(this.globalStorage)return this.globalStorage;this.logService.trace("StorageMainService: creating global storage");const I=new w.GlobalStorageMain(this.getStorageOptions(),this.logService,this.environmentService);return m.once(I.onDidCloseStorage)(()=>{this.logService.trace("StorageMainService: closed global storage")}),I}createWorkspaceStorage(I){return new w.WorkspaceStorageMain(I,this.getStorageOptions(),this.logService,this.environmentService)}workspaceStorage(I){let P=this.mapWorkspaceToStorage.get(I.id);return P||(this.logService.trace(`StorageMainService: creating workspace storage (${I.id})`),P=this.createWorkspaceStorage(I),this.mapWorkspaceToStorage.set(I.id,P),m.once(P.onDidCloseStorage)(()=>{this.logService.trace(`StorageMainService: closed workspace storage (${I.id})`),this.mapWorkspaceToStorage.delete(I.id)})),P}};p=he([ee(0,n.ILogService),ee(1,A.IEnvironmentService),ee(2,E.ILifecycleMainService)],p),e.StorageMainService=p}),define(J[100],Z([0,1,7,28,15]),function(z,e,m,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findWindowOnExtensionDevelopmentPath=e.findWindowOnWorkspaceOrFolder=e.findWindowOnFile=void 0;function S(w,p,i){for(const P of w){const y=P.openedWorkspace;if(L.isWorkspaceIdentifier(y)){const g=i(y);if(g){if(g.folders.some(v=>A.extUriBiasedIgnorePathCase.isEqualOrParent(p,v.uri)))return P}else if(A.extUriBiasedIgnorePathCase.isEqualOrParent(p,y.configPath))return P}}const I=w.filter(P=>L.isSingleFolderWorkspaceIdentifier(P.openedWorkspace)&&A.extUriBiasedIgnorePathCase.isEqualOrParent(p,P.openedWorkspace.uri));if(I.length)return I.sort((P,y)=>-(P.openedWorkspace.uri.path.length-y.openedWorkspace.uri.path.length))[0]}e.findWindowOnFile=S;function E(w,p){for(const i of w)if(L.isWorkspaceIdentifier(i.openedWorkspace)&&A.extUriBiasedIgnorePathCase.isEqual(i.openedWorkspace.configPath,p)||L.isSingleFolderWorkspaceIdentifier(i.openedWorkspace)&&A.extUriBiasedIgnorePathCase.isEqual(i.openedWorkspace.uri,p))return i}e.findWindowOnWorkspaceOrFolder=E;function n(w,p){var i,I;const P=y=>p.some(g=>A.extUriBiasedIgnorePathCase.isEqual(m.URI.file(g),m.URI.file(y)));for(const y of w)if((I=(i=y.config)===null||i===void 0?void 0:i.extensionDevelopmentPath)===null||I===void 0?void 0:I.some(g=>P(g)))return y}e.findWindowOnExtensionDevelopmentPath=n}),define(J[214],Z([0,1,14,2,3,15,7,16,18,6,38,34,28]),function(z,e,m,L,A,S,E,n,w,p,i,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWindowsStateStoreData=e.restoreWindowsState=e.WindowsStateHandler=void 0;let y=class wt extends L.Disposable{constructor(u,c,a,t,r){super();this.windowsMainService=u,this.stateMainService=c,this.lifecycleMainService=a,this.logService=t,this.configurationService=r,this._state=g(this.stateMainService.getItem(wt.windowsStateStorageKey)),this.lastClosedState=void 0,this.shuttingDown=!1,this.registerListeners()}get state(){return this._state}registerListeners(){m.app.on("browser-window-blur",()=>{this.shuttingDown||this.saveWindowsState()}),this.lifecycleMainService.onBeforeCloseWindow(u=>this.onBeforeCloseWindow(u)),this.lifecycleMainService.onBeforeShutdown(()=>this.onBeforeShutdown()),this.windowsMainService.onDidChangeWindowsCount(u=>{u.newCount-u.oldCount>0&&(this.lastClosedState=void 0)}),this.windowsMainService.onDidDestroyWindow(u=>this.onBeforeCloseWindow(u))}onBeforeShutdown(){this.shuttingDown=!0,this.saveWindowsState()}saveWindowsState(){const u={openedWindows:[],lastPluginDevelopmentHostWindow:this._state.lastPluginDevelopmentHostWindow,lastActiveWindow:this.lastClosedState};if(!u.lastActiveWindow){let t=this.windowsMainService.getLastActiveWindow();(!t||t.isExtensionDevelopmentHost)&&(t=this.windowsMainService.getWindows().find(r=>!r.isExtensionDevelopmentHost)),t&&(u.lastActiveWindow=this.toWindowState(t))}const c=this.windowsMainService.getWindows().find(t=>t.isExtensionDevelopmentHost&&!t.isExtensionTestHost);c&&(u.lastPluginDevelopmentHostWindow=this.toWindowState(c)),this.windowsMainService.getWindowCount()>1&&(u.openedWindows=this.windowsMainService.getWindows().filter(t=>!t.isExtensionDevelopmentHost).map(t=>this.toWindowState(t)));const a=D(u);this.stateMainService.setItem(wt.windowsStateStorageKey,a),this.shuttingDown&&this.logService.trace("[WindowsStateHandler] onBeforeShutdown",a)}onBeforeCloseWindow(u){if(this.lifecycleMainService.quitRequested)return;const c=this.toWindowState(u);u.isExtensionDevelopmentHost&&!u.isExtensionTestHost?this._state.lastPluginDevelopmentHostWindow=c:!u.isExtensionDevelopmentHost&&u.openedWorkspace&&this._state.openedWindows.forEach(a=>{var t;const r=P.isWorkspaceIdentifier(u.openedWorkspace)&&((t=a.workspace)===null||t===void 0?void 0:t.id)===u.openedWorkspace.id,s=P.isSingleFolderWorkspaceIdentifier(u.openedWorkspace)&&a.folderUri&&S.extUriBiasedIgnorePathCase.isEqual(a.folderUri,u.openedWorkspace.uri);(r||s)&&(a.uiState=c.uiState)}),this.windowsMainService.getWindowCount()===1&&(this.lastClosedState=c)}toWindowState(u){return{workspace:P.isWorkspaceIdentifier(u.openedWorkspace)?u.openedWorkspace:void 0,folderUri:P.isSingleFolderWorkspaceIdentifier(u.openedWorkspace)?u.openedWorkspace.uri:void 0,backupPath:u.backupPath,remoteAuthority:u.remoteAuthority,uiState:u.serializeWindowState()}}getNewWindowState(u){const c=this.doGetNewWindowState(u),a=this.configurationService.getValue("window");let t;return c.hasDefaultState?t=!!((a==null?void 0:a.newWindowDimensions)&&["fullscreen","inherit","offset"].indexOf(a.newWindowDimensions)>=0)||A.isMacintosh&&(a==null?void 0:a.nativeFullScreen)!==!1:(t=!!(this.lifecycleMainService.wasRestarted||(a==null?void 0:a.restoreFullscreen)),t&&A.isMacintosh&&this.windowsMainService.getWindows().some(r=>r.isFullScreen)&&(t=!1)),c.mode===3&&!t&&(c.mode=1),c}doGetNewWindowState(u){const c=this.windowsMainService.getLastActiveWindow();if(!u.extensionTestsPath){if(!!u.extensionDevelopmentPath&&this.state.lastPluginDevelopmentHostWindow)return this.state.lastPluginDevelopmentHostWindow.uiState;const h=u.workspace;if(P.isWorkspaceIdentifier(h)){const d=this.state.openedWindows.filter(M=>M.workspace&&M.workspace.id===h.id).map(M=>M.uiState);if(d.length)return d[0]}if(P.isSingleFolderWorkspaceIdentifier(h)){const d=this.state.openedWindows.filter(M=>M.folderUri&&S.extUriBiasedIgnorePathCase.isEqual(M.folderUri,h.uri)).map(M=>M.uiState);if(d.length)return d[0]}else if(u.backupPath){const d=this.state.openedWindows.filter(M=>M.backupPath===u.backupPath).map(M=>M.uiState);if(d.length)return d[0]}const f=this.lastClosedState||this.state.lastActiveWindow;if(!c&&f)return f.uiState}let a;const t=m.screen.getAllDisplays();if(t.length===1)a=t[0];else{if(A.isMacintosh){const h=m.screen.getCursorScreenPoint();a=m.screen.getDisplayNearestPoint(h)}!a&&c&&(a=m.screen.getDisplayMatching(c.getBounds())),a||(a=m.screen.getPrimaryDisplay()||t[0])}let r=I.defaultWindowState();r.x=Math.round(a.bounds.x+a.bounds.width/2-r.width/2),r.y=Math.round(a.bounds.y+a.bounds.height/2-r.height/2);const s=this.configurationService.getValue("window");let o=!0;if(A.isMacintosh&&(s==null?void 0:s.nativeFullScreen)!==!1&&(c==null?void 0:c.isFullScreen))r.mode=3;else if(s==null?void 0:s.newWindowDimensions){if(s.newWindowDimensions==="maximized")r.mode=0,o=!1;else if(s.newWindowDimensions==="fullscreen")r.mode=3,o=!1;else if((s.newWindowDimensions==="inherit"||s.newWindowDimensions==="offset")&&c){const h=c.serializeWindowState();h.mode===3?r.mode=3:r=h,o=r.mode!==3&&s.newWindowDimensions==="offset"}}return o&&(r=this.ensureNoOverlap(r)),r.hasDefaultState=!0,r}ensureNoOverlap(u){if(this.windowsMainService.getWindows().length===0)return u;u.x=typeof u.x=="number"?u.x:0,u.y=typeof u.y=="number"?u.y:0;const c=this.windowsMainService.getWindows().map(a=>a.getBounds());for(;c.some(a=>a.x===u.x||a.y===u.y);)u.x+=30,u.y+=30;return u}};y.windowsStateStorageKey="windowsState",y=he([ee(0,I.IWindowsMainService),ee(1,i.IStateMainService),ee(2,w.ILifecycleMainService),ee(3,p.ILogService),ee(4,n.IConfigurationService)],y),e.WindowsStateHandler=y;function g(l){const u={openedWindows:[]},c=l||{openedWindows:[]};return c.lastActiveWindow&&(u.lastActiveWindow=v(c.lastActiveWindow)),c.lastPluginDevelopmentHostWindow&&(u.lastPluginDevelopmentHostWindow=v(c.lastPluginDevelopmentHostWindow)),Array.isArray(c.openedWindows)&&(u.openedWindows=c.openedWindows.map(a=>v(a))),u}e.restoreWindowsState=g;function v(l){const u={uiState:l.uiState};return l.backupPath&&(u.backupPath=l.backupPath),l.remoteAuthority&&(u.remoteAuthority=l.remoteAuthority),l.folder&&(u.folderUri=E.URI.parse(l.folder)),l.workspaceIdentifier&&(u.workspace={id:l.workspaceIdentifier.id,configPath:E.URI.parse(l.workspaceIdentifier.configURIPath)}),u}function D(l){return{lastActiveWindow:l.lastActiveWindow&&b(l.lastActiveWindow),lastPluginDevelopmentHostWindow:l.lastPluginDevelopmentHostWindow&&b(l.lastPluginDevelopmentHostWindow),openedWindows:l.openedWindows.map(u=>b(u))}}e.getWindowsStateStoreData=D;function b(l){return{workspaceIdentifier:l.workspace&&{id:l.workspace.id,configURIPath:l.workspace.configPath.toString()},folder:l.folderUri&&l.folderUri.toString(),backupPath:l.backupPath,remoteAuthority:l.remoteAuthority,uiState:l.uiState}}}),define(J[56],Z([0,1,58,59,215,5,33,8,26,27,2,20,84,19,3]),function(z,e,m,L,A,S,E,n,w,p,i,I,P,y,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class v{constructor(d){this.socket=d,this._errorListener=M=>{if(M){if(M.code==="EPIPE")return;y.onUnexpectedError(M)}},this.socket.on("error",this._errorListener)}dispose(){this.socket.off("error",this._errorListener),this.socket.destroy()}onData(d){const M=T=>d(I.VSBuffer.wrap(T));return this.socket.on("data",M),{dispose:()=>this.socket.off("data",M)}}onClose(d){const M=T=>{d({type:0,hadError:T,error:void 0})};return this.socket.on("close",M),{dispose:()=>this.socket.off("close",M)}}onEnd(d){return this.socket.on("end",d),{dispose:()=>this.socket.off("end",d)}}write(d){if(!this.socket.destroyed)try{this.socket.write(d.buffer,M=>{if(M){if(M.code==="EPIPE")return;y.onUnexpectedError(M)}})}catch(M){if(M.code==="EPIPE")return;y.onUnexpectedError(M)}}end(){this.socket.end()}drain(){return new Promise((d,M)=>{if(this.socket.bufferSize===0){d();return}const T=()=>{this.socket.off("close",T),this.socket.off("end",T),this.socket.off("error",T),this.socket.off("timeout",T),this.socket.off("drain",T),d()};this.socket.on("close",T),this.socket.on("end",T),this.socket.on("error",T),this.socket.on("timeout",T),this.socket.on("drain",T)})}}e.NodeSocket=v;var D;(function(f){f[f.MinHeaderByteSize=2]="MinHeaderByteSize"})(D||(D={}));var b;(function(f){f[f.PeekHeader=1]="PeekHeader",f[f.ReadHeader=2]="ReadHeader",f[f.ReadBody=3]="ReadBody",f[f.Fin=4]="Fin"})(b||(b={}));class l extends i.Disposable{constructor(d,M,T,C){super();this._onDidZlibFlush=this._register(new S.Emitter),this._recordedInflateBytes=[],this._pendingInflateData=[],this._pendingDeflateData=[],this._onData=this._register(new S.Emitter),this._onClose=this._register(new S.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,mask:0},this.socket=d,this._totalIncomingWireBytes=0,this._totalIncomingDataBytes=0,this._totalOutgoingWireBytes=0,this._totalOutgoingDataBytes=0,this.permessageDeflate=M,this._recordInflateBytes=C,M?(this._zlibInflate=A.createInflateRaw({windowBits:15}),this._zlibInflate.on("error",V=>{console.error(V),y.onUnexpectedError(V),this._onClose.fire({type:0,hadError:!0,error:V})}),this._zlibInflate.on("data",V=>{this._pendingInflateData.push(V)}),T&&(this._zlibInflate.write(T.buffer),this._zlibInflate.flush(()=>{this._pendingInflateData.length=0})),this._zlibDeflate=A.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",V=>{console.error(V),y.onUnexpectedError(V),this._onClose.fire({type:0,hadError:!0,error:V})}),this._zlibDeflate.on("data",V=>{this._pendingDeflateData.push(V)})):(this._zlibInflate=null,this._zlibDeflate=null),this._zlibDeflateFlushWaitingCount=0,this._incomingData=new P.ChunkStream,this._register(this.socket.onData(V=>this._acceptChunk(V))),this._register(this.socket.onClose(V=>this._onClose.fire(V)))}get totalIncomingWireBytes(){return this._totalIncomingWireBytes}get totalIncomingDataBytes(){return this._totalIncomingDataBytes}get totalOutgoingWireBytes(){return this._totalOutgoingWireBytes}get totalOutgoingDataBytes(){return this._totalOutgoingDataBytes}get recordedInflateBytes(){return this._recordInflateBytes?I.VSBuffer.wrap(Buffer.concat(this._recordedInflateBytes)):I.VSBuffer.alloc(0)}dispose(){this._zlibDeflateFlushWaitingCount>0?this._register(this._onDidZlibFlush.event(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(d){return this._onData.event(d)}onClose(d){return this._onClose.event(d)}onEnd(d){return this.socket.onEnd(d)}write(d){this._totalOutgoingDataBytes+=d.byteLength,this._zlibDeflate?(this._zlibDeflate.write(d.buffer),this._zlibDeflateFlushWaitingCount++,this._zlibDeflate.flush(2,()=>{this._zlibDeflateFlushWaitingCount--;let M=Buffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,M=M.slice(0,M.length-4),this._isEnded||this._write(I.VSBuffer.wrap(M),!0),this._zlibDeflateFlushWaitingCount===0&&this._onDidZlibFlush.fire()})):this._write(d,!1)}_write(d,M){let T=2;d.byteLength<126?T+=0:d.byteLength<2**16?T+=2:T+=8;const C=I.VSBuffer.alloc(T);if(M?C.writeUInt8(194,0):C.writeUInt8(130,0),d.byteLength<126)C.writeUInt8(d.byteLength,1);else if(d.byteLength<2**16){C.writeUInt8(126,1);let V=1;C.writeUInt8(d.byteLength>>>8&255,++V),C.writeUInt8(d.byteLength>>>0&255,++V)}else{C.writeUInt8(127,1);let V=1;C.writeUInt8(0,++V),C.writeUInt8(0,++V),C.writeUInt8(0,++V),C.writeUInt8(0,++V),C.writeUInt8(d.byteLength>>>24&255,++V),C.writeUInt8(d.byteLength>>>16&255,++V),C.writeUInt8(d.byteLength>>>8&255,++V),C.writeUInt8(d.byteLength>>>0&255,++V)}this._totalOutgoingWireBytes+=C.byteLength+d.byteLength,this.socket.write(I.VSBuffer.concat([C,d]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(d){if(d.byteLength!==0){for(this._totalIncomingWireBytes+=d.byteLength,this._incomingData.acceptChunk(d);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const M=this._incomingData.peek(this._state.readLen),C=(M.readUInt8(0)&128)>>>7,V=M.readUInt8(1),Q=(V&128)>>>7,te=V&127;this._state.state=2,this._state.readLen=2+(Q?4:0)+(te===126?2:0)+(te===127?8:0),this._state.fin=C,this._state.mask=0}else if(this._state.state===2){const M=this._incomingData.read(this._state.readLen),T=M.readUInt8(1),C=(T&128)>>>7;let V=T&127,Q=1;V===126?V=M.readUInt8(++Q)*2**8+M.readUInt8(++Q):V===127&&(V=M.readUInt8(++Q)*0+M.readUInt8(++Q)*0+M.readUInt8(++Q)*0+M.readUInt8(++Q)*0+M.readUInt8(++Q)*2**24+M.readUInt8(++Q)*2**16+M.readUInt8(++Q)*2**8+M.readUInt8(++Q));let te=0;C&&(te=M.readUInt8(++Q)*2**24+M.readUInt8(++Q)*2**16+M.readUInt8(++Q)*2**8+M.readUInt8(++Q)),this._state.state=3,this._state.readLen=V,this._state.mask=te}else if(this._state.state===3){const M=this._incomingData.read(this._state.readLen);u(M,this._state.mask),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._zlibInflate?(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from(M.buffer)),this._zlibInflate.write(M.buffer),this._state.fin&&(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from([0,0,255,255])),this._zlibInflate.write(Buffer.from([0,0,255,255]))),this._zlibInflate.flush(()=>{const T=Buffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,this._totalIncomingDataBytes+=T.length,this._onData.fire(I.VSBuffer.wrap(T))})):(this._totalIncomingDataBytes+=M.byteLength,this._onData.fire(M))}}}async drain(){this._zlibDeflateFlushWaitingCount>0&&await S.Event.toPromise(this._onDidZlibFlush.event),await this.socket.drain()}}e.WebSocketNodeSocket=l;function u(f,d){if(d===0)return;let M=f.byteLength>>>2;for(let B=0;B<M;B++){const Y=f.readUInt32BE(B*4);f.writeUInt32BE(Y^d,B*4)}let T=M*4,C=f.byteLength-T;const V=d>>>24&255,Q=d>>>16&255,te=d>>>8&255;C>=1&&f.writeUInt8(f.readUInt8(T)^V,T),C>=2&&f.writeUInt8(f.readUInt8(T+1)^Q,T+1),C>=3&&f.writeUInt8(f.readUInt8(T+2)^te,T+2)}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const c={[2]:107,[1]:103};function a(){const f=p.generateUuid();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${f}-sock`;let d;return e.XDG_RUNTIME_DIR?d=n.join(e.XDG_RUNTIME_DIR,`vscode-ipc-${f}.sock`):d=n.join(w.tmpdir(),`vscode-ipc-${f}.sock`),r(d),d}e.createRandomIPCHandle=a;function t(f,d,M){const T=m.createHash("md5").update(f).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${T}-${M}-${d}-sock`;let C;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?C=n.join(e.XDG_RUNTIME_DIR,`vscode-${T.substr(0,8)}-${M}-${d}.sock`):C=n.join(f,`${M}-${d}.sock`),r(C),C}e.createStaticIPCHandle=t;function r(f){const d=c[g.platform];typeof d=="number"&&f.length>=d&&console.warn(`WARNING: IPC handle "${f}" is longer than ${d} chars, try a shorter --user-data-dir`)}class s extends E.IPCServer{constructor(d){super(s.toClientConnectionEvent(d));this.server=d}static toClientConnectionEvent(d){const M=S.Event.fromNodeEventEmitter(d,"connection");return S.Event.map(M,T=>({protocol:new P.Protocol(new v(T)),onDidClientDisconnect:S.Event.once(S.Event.fromNodeEventEmitter(T,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=s;function o(f){return new Promise((d,M)=>{const T=L.createServer();T.on("error",M),T.listen(f,()=>{T.removeListener("error",M),d(new s(T))})})}e.serve=o;function h(f,d){return new Promise((M,T)=>{const C=L.createConnection(f,()=>{C.removeListener("error",T),M(P.Client.fromSocket(new v(C),d))});C.once("error",T)})}e.connect=h}),define(J[216],Z([0,1,56]),function(z,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.WindowDriverRegistryChannel=e.DriverChannelClient=e.DriverChannel=void 0;class L{constructor(w){this.driver=w}listen(w,p){throw new Error("No event found")}call(w,p,i){switch(p){case"getWindowIds":return this.driver.getWindowIds();case"capturePage":return this.driver.capturePage(i);case"reloadWindow":return this.driver.reloadWindow(i);case"exitApplication":return this.driver.exitApplication();case"dispatchKeybinding":return this.driver.dispatchKeybinding(i[0],i[1]);case"click":return this.driver.click(i[0],i[1],i[2],i[3]);case"doubleClick":return this.driver.doubleClick(i[0],i[1]);case"setValue":return this.driver.setValue(i[0],i[1],i[2]);case"getTitle":return this.driver.getTitle(i[0]);case"isActiveElement":return this.driver.isActiveElement(i[0],i[1]);case"getElements":return this.driver.getElements(i[0],i[1],i[2]);case"getElementXY":return this.driver.getElementXY(i[0],i[1],i[2]);case"typeInEditor":return this.driver.typeInEditor(i[0],i[1],i[2]);case"getTerminalBuffer":return this.driver.getTerminalBuffer(i[0],i[1]);case"writeInTerminal":return this.driver.writeInTerminal(i[0],i[1],i[2])}throw new Error(`Call not found: ${p}`)}}e.DriverChannel=L;class A{constructor(w){this.channel=w}getWindowIds(){return this.channel.call("getWindowIds")}capturePage(w){return this.channel.call("capturePage",w)}reloadWindow(w){return this.channel.call("reloadWindow",w)}exitApplication(){return this.channel.call("exitApplication")}dispatchKeybinding(w,p){return this.channel.call("dispatchKeybinding",[w,p])}click(w,p,i,I){return this.channel.call("click",[w,p,i,I])}doubleClick(w,p){return this.channel.call("doubleClick",[w,p])}setValue(w,p,i){return this.channel.call("setValue",[w,p,i])}getTitle(w){return this.channel.call("getTitle",[w])}isActiveElement(w,p){return this.channel.call("isActiveElement",[w,p])}getElements(w,p,i){return this.channel.call("getElements",[w,p,i])}getElementXY(w,p,i,I){return this.channel.call("getElementXY",[w,p,i,I])}typeInEditor(w,p,i){return this.channel.call("typeInEditor",[w,p,i])}getTerminalBuffer(w,p){return this.channel.call("getTerminalBuffer",[w,p])}writeInTerminal(w,p,i){return this.channel.call("writeInTerminal",[w,p,i])}}e.DriverChannelClient=A;class S{constructor(w){this.registry=w}listen(w,p){throw new Error(`Event not found: ${p}`)}call(w,p,i){switch(p){case"registerWindowDriver":return this.registry.registerWindowDriver(i);case"reloadWindowDriver":return this.registry.reloadWindowDriver(i)}throw new Error(`Call not found: ${p}`)}}e.WindowDriverRegistryChannel=S;async function E(n){const w=await m.connect(n,"driverClient"),p=w.getChannel("driver"),i=new A(p);return{client:w,driver:i}}e.connect=E}),define(J[24],Z([0,1,8,46,4,53,160,56]),function(z,e,m,L,A,S,E,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentMainService=e.IEnvironmentMainService=void 0,e.IEnvironmentMainService=A.refineServiceDecorator(S.IEnvironmentService);class w extends E.NativeEnvironmentService{get cachedLanguagesPath(){return m.join(this.userDataPath,"clp")}get backupHome(){return m.join(this.userDataPath,"Backups")}get backupWorkspacesPath(){return m.join(this.backupHome,"workspaces.json")}get mainIPCHandle(){return n.createStaticIPCHandle(this.userDataPath,"main",this.productService.version)}get sandbox(){return!!this.args.__sandbox}get driverVerbose(){return!!this.args["driver-verbose"]}get disableUpdates(){return!!this.args["disable-updates"]}get disableKeytar(){return!!this.args["disable-keytar"]}get codeCachePath(){return process.env.VSCODE_CODE_CACHE_PATH||void 0}}he([L.memoize],w.prototype,"cachedLanguagesPath",null),he([L.memoize],w.prototype,"backupHome",null),he([L.memoize],w.prototype,"backupWorkspacesPath",null),he([L.memoize],w.prototype,"mainIPCHandle",null),he([L.memoize],w.prototype,"sandbox",null),he([L.memoize],w.prototype,"driverVerbose",null),he([L.memoize],w.prototype,"disableUpdates",null),he([L.memoize],w.prototype,"disableKeytar",null),he([L.memoize],w.prototype,"codeCachePath",null),e.EnvironmentMainService=w}),define(J[217],Z([0,1,30,58,8,3,17,50,24,16,21,6,28,7,29,10,15]),function(z,e,m,L,A,S,E,n,w,p,i,I,P,y,g,v,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BackupMainService=void 0;let b=class{constructor(u,c,a){this.configurationService=c,this.logService=a,this.workspaces=[],this.folders=[],this.emptyWindows=[],this.backupUriComparer=D.extUriBiasedIgnorePathCase,this.backupPathComparer={isEqual:(t,r)=>g.isEqual(t,r,!S.isLinux)},this.backupHome=u.backupHome,this.workspacesJsonPath=u.backupWorkspacesPath}async initialize(){let u;try{u=JSON.parse(await E.Promises.readFile(this.workspacesJsonPath,"utf8"))}catch(t){u=Object.create(null)}this.emptyWindows=await this.validateEmptyWorkspaces(u.emptyWorkspaceInfos);let c=[];try{Array.isArray(u.rootURIWorkspaces)&&(c=u.rootURIWorkspaces.map(t=>({workspace:{id:t.id,configPath:y.URI.parse(t.configURIPath)},remoteAuthority:t.remoteAuthority})))}catch(t){}this.workspaces=await this.validateWorkspaces(c);let a=[];try{Array.isArray(u.folderURIWorkspaces)&&(a=u.folderURIWorkspaces.map(t=>y.URI.parse(t)))}catch(t){}this.folders=await this.validateFolders(a),await this.save()}getWorkspaceBackups(){return this.isHotExitOnExitAndWindowClose()?[]:this.workspaces.slice(0)}getFolderBackupPaths(){return this.isHotExitOnExitAndWindowClose()?[]:this.folders.slice(0)}isHotExitEnabled(){return this.getHotExitConfig()!==i.HotExitConfiguration.OFF}isHotExitOnExitAndWindowClose(){return this.getHotExitConfig()===i.HotExitConfiguration.ON_EXIT_AND_WINDOW_CLOSE}getHotExitConfig(){var u;const c=this.configurationService.getValue();return((u=c==null?void 0:c.files)===null||u===void 0?void 0:u.hotExit)||i.HotExitConfiguration.ON_EXIT}getEmptyWindowBackupPaths(){return this.emptyWindows.slice(0)}registerWorkspaceBackupSync(u,c){this.workspaces.some(t=>u.workspace.id===t.workspace.id)||(this.workspaces.push(u),this.saveSync());const a=this.getBackupPath(u.workspace.id);return c&&this.moveBackupFolderSync(a,c),a}moveBackupFolderSync(u,c){if(m.existsSync(u)&&this.convertToEmptyWindowBackupSync(u),m.existsSync(c))try{m.renameSync(c,u)}catch(a){this.logService.error(`Backup: Could not move backup folder to new location: ${a.toString()}`)}}unregisterWorkspaceBackupSync(u){const c=u.id,a=this.workspaces.findIndex(t=>t.workspace.id===c);a!==-1&&(this.workspaces.splice(a,1),this.saveSync())}registerFolderBackupSync(u){return this.folders.some(c=>this.backupUriComparer.isEqual(u,c))||(this.folders.push(u),this.saveSync()),this.getBackupPath(this.getFolderHash(u))}unregisterFolderBackupSync(u){const c=this.folders.findIndex(a=>this.backupUriComparer.isEqual(u,a));c!==-1&&(this.folders.splice(c,1),this.saveSync())}registerEmptyWindowBackupSync(u,c){const a=u||this.getRandomEmptyWindowId();return this.emptyWindows.some(t=>!!t.backupFolder&&this.backupPathComparer.isEqual(t.backupFolder,a))||(this.emptyWindows.push({backupFolder:a,remoteAuthority:c}),this.saveSync()),this.getBackupPath(a)}unregisterEmptyWindowBackupSync(u){const c=this.emptyWindows.findIndex(a=>!!a.backupFolder&&this.backupPathComparer.isEqual(a.backupFolder,u));c!==-1&&(this.emptyWindows.splice(c,1),this.saveSync())}getBackupPath(u){return A.join(this.backupHome,u)}async validateWorkspaces(u){if(!Array.isArray(u))return[];const c=new Set,a=[];for(let t of u){const r=t.workspace;if(!P.isWorkspaceIdentifier(r))return[];if(!c.has(r.id)){c.add(r.id);const s=this.getBackupPath(r.id);await this.doHasBackups(s)?r.configPath.scheme!==v.Schemas.file||await E.Promises.exists(r.configPath.fsPath)?a.push(t):await this.convertToEmptyWindowBackup(s):await this.deleteStaleBackup(s)}}return a}async validateFolders(u){if(!Array.isArray(u))return[];const c=[],a=new Set;for(let t of u){const r=this.backupUriComparer.getComparisonKey(t);if(!a.has(r)){a.add(r);const s=this.getBackupPath(this.getFolderHash(t));await this.doHasBackups(s)?t.scheme!==v.Schemas.file||await E.Promises.exists(t.fsPath)?c.push(t):await this.convertToEmptyWindowBackup(s):await this.deleteStaleBackup(s)}}return c}async validateEmptyWorkspaces(u){if(!Array.isArray(u))return[];const c=[],a=new Set;for(let t of u){const r=t.backupFolder;if(typeof r!="string")return[];if(!a.has(r)){a.add(r);const s=this.getBackupPath(r);await this.doHasBackups(s)?c.push(t):await this.deleteStaleBackup(s)}}return c}async deleteStaleBackup(u){try{await E.Promises.exists(u)&&await E.Promises.rm(u,E.RimRafMode.MOVE)}catch(c){this.logService.error(`Backup: Could not delete stale backup: ${c.toString()}`)}}async convertToEmptyWindowBackup(u){let c=this.getRandomEmptyWindowId();for(;this.emptyWindows.some(t=>!!t.backupFolder&&this.backupPathComparer.isEqual(t.backupFolder,c));)c=this.getRandomEmptyWindowId();const a=this.getBackupPath(c);try{await E.Promises.rename(u,a)}catch(t){return this.logService.error(`Backup: Could not rename backup folder: ${t.toString()}`),!1}return this.emptyWindows.push({backupFolder:c}),!0}convertToEmptyWindowBackupSync(u){let c=this.getRandomEmptyWindowId();for(;this.emptyWindows.some(t=>!!t.backupFolder&&this.backupPathComparer.isEqual(t.backupFolder,c));)c=this.getRandomEmptyWindowId();const a=this.getBackupPath(c);try{m.renameSync(u,a)}catch(t){return this.logService.error(`Backup: Could not rename backup folder: ${t.toString()}`),!1}return this.emptyWindows.push({backupFolder:c}),!0}async getDirtyWorkspaces(){const u=[];for(const c of this.workspaces)await this.hasBackups(c)&&u.push(c.workspace);for(const c of this.folders)await this.hasBackups(c)&&u.push(c);return u}hasBackups(u){let c;return y.URI.isUri(u)?c=this.getBackupPath(this.getFolderHash(u)):n.isWorkspaceBackupInfo(u)?c=this.getBackupPath(u.workspace.id):c=u.backupFolder,this.doHasBackups(c)}async doHasBackups(u){try{const c=await E.Promises.readdir(u);for(const a of c)try{if((await E.Promises.readdir(A.join(u,a))).length>0)return!0}catch(t){}}catch(c){}return!1}saveSync(){try{E.writeFileSync(this.workspacesJsonPath,JSON.stringify(this.serializeBackups()))}catch(u){this.logService.error(`Backup: Could not save workspaces.json: ${u.toString()}`)}}async save(){try{await E.Promises.writeFile(this.workspacesJsonPath,JSON.stringify(this.serializeBackups()))}catch(u){this.logService.error(`Backup: Could not save workspaces.json: ${u.toString()}`)}}serializeBackups(){return{rootURIWorkspaces:this.workspaces.map(u=>({id:u.workspace.id,configURIPath:u.workspace.configPath.toString(),remoteAuthority:u.remoteAuthority})),folderURIWorkspaces:this.folders.map(u=>u.toString()),emptyWorkspaceInfos:this.emptyWindows}}getRandomEmptyWindowId(){return(Date.now()+Math.round(Math.random()*1e3)).toString()}getFolderHash(u){let c;return u.scheme===v.Schemas.file?c=S.isLinux?u.fsPath:u.fsPath.toLowerCase():c=u.toString().toLowerCase(),L.createHash("md5").update(c).digest("hex")}};b=he([ee(0,w.IEnvironmentMainService),ee(1,p.IConfigurationService),ee(2,I.ILogService)],b),e.BackupMainService=b}),define(J[45],Z([0,1,40,114,145,82,5,34,14,18,3,24,51,17,7,31,4,26,66,6,8,22,46,2,60]),function(z,e,m,L,A,S,E,n,w,p,i,I,P,y,g,v,D,b,l,u,c,a,t,r,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeHostMainService=e.INativeHostMainService=void 0,e.INativeHostMainService=D.createDecorator("nativeHostMainService");let o=class ht extends r.Disposable{constructor(f,d,M,T,C,V,Q,te,B){super();this.sharedProcess=f,this.windowsMainService=d,this.dialogMainService=M,this.lifecycleMainService=T,this.environmentMainService=C,this.telemetryService=V,this.logService=Q,this.productService=te,this.themeMainService=B,this.onDidOpenWindow=E.Event.map(this.windowsMainService.onDidOpenWindow,Y=>Y.id),this.onDidMaximizeWindow=E.Event.filter(E.Event.fromNodeEventEmitter(w.app,"browser-window-maximize",(Y,X)=>X.id),Y=>!!this.windowsMainService.getWindowById(Y)),this.onDidUnmaximizeWindow=E.Event.filter(E.Event.fromNodeEventEmitter(w.app,"browser-window-unmaximize",(Y,X)=>X.id),Y=>!!this.windowsMainService.getWindowById(Y)),this.onDidBlurWindow=E.Event.filter(E.Event.fromNodeEventEmitter(w.app,"browser-window-blur",(Y,X)=>X.id),Y=>!!this.windowsMainService.getWindowById(Y)),this.onDidFocusWindow=E.Event.any(E.Event.map(E.Event.filter(E.Event.map(this.windowsMainService.onDidChangeWindowsCount,()=>this.windowsMainService.getLastActiveWindow()),Y=>!!Y),Y=>Y.id),E.Event.filter(E.Event.fromNodeEventEmitter(w.app,"browser-window-focus",(Y,X)=>X.id),Y=>!!this.windowsMainService.getWindowById(Y))),this.onDidResumeOS=E.Event.fromNodeEventEmitter(w.powerMonitor,"resume"),this._onDidChangeColorScheme=this._register(new E.Emitter),this.onDidChangeColorScheme=this._onDidChangeColorScheme.event,this._onDidChangePassword=this._register(new E.Emitter),this.onDidChangePassword=this._onDidChangePassword.event,this.onDidChangeDisplay=E.Event.debounce(E.Event.any(E.Event.filter(E.Event.fromNodeEventEmitter(w.screen,"display-metrics-changed",(Y,X,_)=>_),Y=>!(Array.isArray(Y)&&Y.length===1&&Y[0]==="workArea")),E.Event.fromNodeEventEmitter(w.screen,"display-added"),E.Event.fromNodeEventEmitter(w.screen,"display-removed")),()=>{},100),this.registerListeners()}registerListeners(){w.nativeTheme.on("updated",()=>{this._onDidChangeColorScheme.fire({highContrast:w.nativeTheme.shouldUseInvertedColorScheme||w.nativeTheme.shouldUseHighContrastColors,dark:w.nativeTheme.shouldUseDarkColors})})}get windowId(){throw new Error("Not implemented in electron-main")}async getWindows(){return this.windowsMainService.getWindows().map(d=>{var M,T;return{id:d.id,workspace:d.openedWorkspace,title:(T=(M=d.win)===null||M===void 0?void 0:M.getTitle())!==null&&T!==void 0?T:"",filename:d.getRepresentedFilename(),dirty:d.isDocumentEdited()}})}async getWindowCount(f){return this.windowsMainService.getWindowCount()}async getActiveWindowId(f){const d=w.BrowserWindow.getFocusedWindow()||this.windowsMainService.getLastActiveWindow();if(d)return d.id}openWindow(f,d,M){return Array.isArray(d)?this.doOpenWindow(f,d,M):this.doOpenEmptyWindow(f,d)}async doOpenWindow(f,d,M=Object.create(null)){d.length>0&&this.windowsMainService.open({context:5,contextWindowId:f,urisToOpen:d,cli:this.environmentMainService.args,forceNewWindow:M.forceNewWindow,forceReuseWindow:M.forceReuseWindow,preferNewWindow:M.preferNewWindow,diffMode:M.diffMode,addMode:M.addMode,gotoLineMode:M.gotoLineMode,noRecentEntry:M.noRecentEntry,waitMarkerFileURI:M.waitMarkerFileURI,remoteAuthority:M.remoteAuthority||void 0})}async doOpenEmptyWindow(f,d){this.windowsMainService.openEmptyWindow({context:5,contextWindowId:f},d)}async toggleFullScreen(f){const d=this.windowById(f);d&&d.toggleFullScreen()}async handleTitleDoubleClick(f){const d=this.windowById(f);d&&d.handleTitleDoubleClick()}async isMaximized(f){const d=this.windowById(f);return(d==null?void 0:d.win)?d.win.isMaximized():!1}async maximizeWindow(f){const d=this.windowById(f);(d==null?void 0:d.win)&&d.win.maximize()}async unmaximizeWindow(f){const d=this.windowById(f);(d==null?void 0:d.win)&&d.win.unmaximize()}async minimizeWindow(f){const d=this.windowById(f);(d==null?void 0:d.win)&&d.win.minimize()}async focusWindow(f,d){var M;d&&typeof d.windowId=="number"&&(f=d.windowId);const T=this.windowById(f);T&&T.focus({force:(M=d==null?void 0:d.force)!==null&&M!==void 0?M:!1})}async setMinimumSize(f,d,M){const T=this.windowById(f);if(T==null?void 0:T.win){const[C,V]=T.win.getSize(),[Q,te]=T.win.getMinimumSize(),[B,Y]=[d??Q,M??te],[X,_]=[Math.max(C,B),Math.max(V,Y)];(Q!==B||te!==Y)&&T.win.setMinimumSize(B,Y),(C!==X||V!==_)&&T.win.setSize(X,_)}}async saveWindowSplash(f,d){this.themeMainService.saveWindowSplash(f,d)}async installShellCommand(f){const{source:d,target:M}=await this.getShellCommandLink();try{const{symbolicLink:T}=await y.SymlinkSupport.stat(d);if(T&&!T.dangling){const C=await S.realpath(d);if(M===C)return}await y.Promises.unlink(d)}catch(T){if(T.code!=="ENOENT")throw T}try{await y.Promises.symlink(M,d)}catch(T){if(T.code!=="EACCES"&&T.code!=="ENOENT")throw T;const{response:C}=await this.showMessageBox(f,{type:"info",message:A.localize(0,null,this.productService.nameShort),buttons:[A.localize(1,null),A.localize(2,null)],cancelId:1});if(C===0)try{const V=`osascript -e "do shell script \\"mkdir -p /usr/local/bin && ln -sf '${M}' '${d}'\\" with administrator privileges"`;await L.promisify(m.exec)(V)}catch(V){throw new Error(A.localize(3,null,d))}}}async uninstallShellCommand(f){const{source:d}=await this.getShellCommandLink();try{await y.Promises.unlink(d)}catch(M){switch(M.code){case"EACCES":const{response:T}=await this.showMessageBox(f,{type:"info",message:A.localize(4,null,this.productService.nameShort),buttons:[A.localize(5,null),A.localize(6,null)],cancelId:1});if(T===0)try{const C=`osascript -e "do shell script \\"rm '${d}'\\" with administrator privileges"`;await L.promisify(m.exec)(C)}catch(C){throw new Error(A.localize(7,null,d))}break;case"ENOENT":break;default:throw M}}}async getShellCommandLink(){const f=c.resolve(this.environmentMainService.appRoot,"bin","code"),d=`/usr/local/bin/${this.productService.applicationName}`;if(!await y.Promises.exists(f))throw new Error(A.localize(8,null,f));return{source:d,target:f}}async showMessageBox(f,d){return this.dialogMainService.showMessageBox(d,this.toBrowserWindow(f))}async showSaveDialog(f,d){return this.dialogMainService.showSaveDialog(d,this.toBrowserWindow(f))}async showOpenDialog(f,d){return this.dialogMainService.showOpenDialog(d,this.toBrowserWindow(f))}toBrowserWindow(f){const d=this.windowById(f);if(d==null?void 0:d.win)return d.win}async pickFileFolderAndOpen(f,d){const M=await this.dialogMainService.pickFileFolder(d);M&&(this.sendPickerTelemetry(M,d.telemetryEventName||"openFileFolder",d.telemetryExtraData),this.doOpenPicked(await Promise.all(M.map(async T=>await y.SymlinkSupport.existsDirectory(T)?{folderUri:g.URI.file(T)}:{fileUri:g.URI.file(T)})),d,f))}async pickFolderAndOpen(f,d){const M=await this.dialogMainService.pickFolder(d);M&&(this.sendPickerTelemetry(M,d.telemetryEventName||"openFolder",d.telemetryExtraData),this.doOpenPicked(M.map(T=>({folderUri:g.URI.file(T)})),d,f))}async pickFileAndOpen(f,d){const M=await this.dialogMainService.pickFile(d);M&&(this.sendPickerTelemetry(M,d.telemetryEventName||"openFile",d.telemetryExtraData),this.doOpenPicked(M.map(T=>({fileUri:g.URI.file(T)})),d,f))}async pickWorkspaceAndOpen(f,d){const M=await this.dialogMainService.pickWorkspace(d);M&&(this.sendPickerTelemetry(M,d.telemetryEventName||"openWorkspace",d.telemetryExtraData),this.doOpenPicked(M.map(T=>({workspaceUri:g.URI.file(T)})),d,f))}doOpenPicked(f,d,M){this.windowsMainService.open({context:3,contextWindowId:M,cli:this.environmentMainService.args,urisToOpen:f,forceNewWindow:d.forceNewWindow})}sendPickerTelemetry(f,d,M){const T=f?f.length:0;this.telemetryService.publicLog(d,Object.assign(Object.assign({},M),{outcome:T?"success":"canceled",numberOfPaths:T}))}async showItemInFolder(f,d){w.shell.showItemInFolder(d)}async setRepresentedFilename(f,d){const M=this.windowById(f);M&&M.setRepresentedFilename(d)}async setDocumentEdited(f,d){const M=this.windowById(f);M&&M.setDocumentEdited(d)}async openExternal(f,d){return i.isLinuxSnap?this.safeSnapOpenExternal(d):w.shell.openExternal(d),!0}safeSnapOpenExternal(f){const d=process.env.GDK_PIXBUF_MODULE_FILE,M=process.env.GDK_PIXBUF_MODULEDIR;delete process.env.GDK_PIXBUF_MODULE_FILE,delete process.env.GDK_PIXBUF_MODULEDIR,w.shell.openExternal(f),process.env.GDK_PIXBUF_MODULE_FILE=d,process.env.GDK_PIXBUF_MODULEDIR=M}moveItemToTrash(f,d){return w.shell.trashItem(d)}async isAdmin(){let f;return i.isWindows?f=(await new Promise((d,M)=>{z(["native-is-elevated"],d,M)}))():f=process.getuid()===0,f}async writeElevated(f,d,M,T){const C=await new Promise((V,Q)=>{z(["sudo-prompt"],V,Q)});return new Promise((V,Q)=>{const te=[`"${this.cliPath}"`];(T==null?void 0:T.unlock)&&te.push("--file-chmod"),te.push("--file-write",`"${d.fsPath}"`,`"${M.fsPath}"`);const B={name:this.productService.nameLong.replace("-",""),icns:i.isMacintosh&&this.environmentMainService.isBuilt?c.join(c.dirname(this.environmentMainService.appRoot),`${this.productService.nameShort}.icns`):void 0};C.exec(te.join(" "),B,(Y,X,_)=>{X&&this.logService.trace(`[sudo-prompt] received stdout: ${X}`),_&&this.logService.trace(`[sudo-prompt] received stderr: ${_}`),Y?Q(Y):V(void 0)})})}get cliPath(){return i.isWindows?this.environmentMainService.isBuilt?c.join(c.dirname(process.execPath),"bin",`${this.productService.applicationName}.cmd`):c.join(this.environmentMainService.appRoot,"scripts","code-cli.bat"):i.isLinux?this.environmentMainService.isBuilt?c.join(c.dirname(process.execPath),"bin",`${this.productService.applicationName}`):c.join(this.environmentMainService.appRoot,"scripts","code-cli.sh"):this.environmentMainService.isBuilt?c.join(this.environmentMainService.appRoot,"bin","code"):c.join(this.environmentMainService.appRoot,"scripts","code-cli.sh")}async getOSStatistics(){return{totalmem:b.totalmem(),freemem:b.freemem(),loadavg:b.loadavg()}}async getOSProperties(){return{arch:b.arch(),platform:b.platform(),release:b.release(),type:b.type(),cpus:b.cpus()}}async getOSVirtualMachineHint(){return l.virtualMachineHint.value()}async killProcess(f,d,M){process.kill(d,M)}async readClipboardText(f,d){return w.clipboard.readText(d)}async writeClipboardText(f,d,M){return w.clipboard.writeText(d,M)}async readClipboardFindText(f){return w.clipboard.readFindText()}async writeClipboardFindText(f,d){return w.clipboard.writeFindText(d)}async writeClipboardBuffer(f,d,M,T){return w.clipboard.writeBuffer(d,Buffer.from(M),T)}async readClipboardBuffer(f,d){return w.clipboard.readBuffer(d)}async hasClipboard(f,d,M){return w.clipboard.has(d,M)}async newWindowTab(){this.windowsMainService.open({context:5,cli:this.environmentMainService.args,forceNewTabbedWindow:!0,forceEmpty:!0,remoteAuthority:this.environmentMainService.args.remote||void 0})}async showPreviousWindowTab(){w.Menu.sendActionToFirstResponder("selectPreviousTab:")}async showNextWindowTab(){w.Menu.sendActionToFirstResponder("selectNextTab:")}async moveWindowTabToNewWindow(){w.Menu.sendActionToFirstResponder("moveTabToNewWindow:")}async mergeAllWindowTabs(){w.Menu.sendActionToFirstResponder("mergeAllWindows:")}async toggleWindowTabsBar(){w.Menu.sendActionToFirstResponder("toggleTabBar:")}async updateTouchBar(f,d){const M=this.windowById(f);M&&M.updateTouchBar(d)}async notifyReady(f){const d=this.windowById(f);d&&d.setReady()}async relaunch(f,d){return this.lifecycleMainService.relaunch(d)}async reload(f,d){const M=this.windowById(f);if(M)return this.lifecycleMainService.reload(M,(d==null?void 0:d.disableExtensions)!==void 0?{_:[],"disable-extensions":d==null?void 0:d.disableExtensions}:void 0)}async closeWindow(f){this.closeWindowById(f,f)}async closeWindowById(f,d){const M=this.windowById(d);if(M==null?void 0:M.win)return M.win.close()}async quit(f){const d=this.windowsMainService.getLastActiveWindow();(d==null?void 0:d.isExtensionDevelopmentHost)&&this.windowsMainService.getWindowCount()>1&&d.win?d.win.close():this.lifecycleMainService.quit()}async exit(f,d){await this.lifecycleMainService.kill(d)}async resolveProxy(f,d){var M,T;const C=this.windowById(f),V=(T=(M=C==null?void 0:C.win)===null||M===void 0?void 0:M.webContents)===null||T===void 0?void 0:T.session;if(V)return V.resolveProxy(d)}async openDevTools(f,d){const M=this.windowById(f);(M==null?void 0:M.win)&&M.win.webContents.openDevTools(d)}async toggleDevTools(f){const d=this.windowById(f);(d==null?void 0:d.win)&&d.win.webContents.toggleDevTools()}async sendInputEvent(f,d){const M=this.windowById(f);(M==null?void 0:M.win)&&(d.type==="mouseDown"||d.type==="mouseUp")&&M.win.webContents.sendInputEvent(d)}async toggleSharedProcessWindow(){return this.sharedProcess.toggle()}async windowsGetStringRegKey(f,d,M,T){if(!i.isWindows)return;const C=await new Promise((V,Q)=>{z(["vscode-windows-registry"],V,Q)});try{return C.GetStringRegKey(d,M,T)}catch(V){return}}async getPassword(f,d,M){const T=await this.withKeytar(),C=await T.getPassword(d,M);if(C)try{let{content:V,hasNextChunk:Q}=JSON.parse(C);if(!V||!Q)return C;let te=1;for(;Q;){const B=await T.getPassword(d,`${M}-${te}`),Y=JSON.parse(B);V+=Y.content,Q=Y.hasNextChunk}return V}catch(V){return C}return C}async setPassword(f,d,M,T){const C=await this.withKeytar(),V=3,Q=async(te,B,Y)=>{let X=0,_;for(;X<V;)try{await C.setPassword(te,B,Y);return}catch($){_=$,this.logService.warn("Error attempting to set a password: ",$),X++,await new Promise(G=>setTimeout(G,200))}throw _};if(i.isWindows&&T.length>ht.MAX_PASSWORD_LENGTH){let te=0,B=0,Y=!0;for(;Y;){const X=T.substring(te,te+ht.PASSWORD_CHUNK_SIZE);te+=ht.PASSWORD_CHUNK_SIZE,Y=T.length-te>0;const _={content:X,hasNextChunk:Y};await Q(d,B?`${M}-${B}`:M,JSON.stringify(_)),B++}}else await Q(d,M,T);this._onDidChangePassword.fire({service:d,account:M})}async deletePassword(f,d,M){const C=await(await this.withKeytar()).deletePassword(d,M);return C&&this._onDidChangePassword.fire({service:d,account:M}),C}async findPassword(f,d){return(await this.withKeytar()).findPassword(d)}async findCredentials(f,d){return(await this.withKeytar()).findCredentials(d)}async withKeytar(){if(this.environmentMainService.disableKeytar)throw new Error("keytar has been disabled via --disable-keytar option");return await new Promise((f,d)=>{z(["keytar"],f,d)})}windowById(f){if(typeof f=="number")return this.windowsMainService.getWindowById(f)}};o.MAX_PASSWORD_LENGTH=2500,o.PASSWORD_CHUNK_SIZE=o.MAX_PASSWORD_LENGTH-100,he([t.memoize],o.prototype,"cliPath",null),o=he([ee(1,n.IWindowsMainService),ee(2,P.IDialogMainService),ee(3,p.ILifecycleMainService),ee(4,I.IEnvironmentMainService),ee(5,v.ITelemetryService),ee(6,u.ILogService),ee(7,a.IProductService),ee(8,s.IThemeMainService)],o),e.NativeHostMainService=o}),define(J[218],Z([0,1,2,5,80,14,6,34,45,89,27,22,25]),function(z,e,m,L,A,S,E,n,w,p,i,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProxyAuthHandler=void 0;var y;(function(v){v[v.Initial=1]="Initial",v[v.StoredCredentialsUsed=2]="StoredCredentialsUsed",v[v.LoginDialogShown=3]="LoginDialogShown"})(y||(y={}));let g=class extends m.Disposable{constructor(D,b,l,u,c){super();this.logService=D,this.windowsMainService=b,this.nativeHostMainService=l,this.encryptionMainService=u,this.productService=c,this.PROXY_CREDENTIALS_SERVICE_KEY=`${this.productService.urlProtocol}.proxy-credentials`,this.pendingProxyResolve=void 0,this.state=y.Initial,this.sessionCredentials=void 0,this.registerListeners()}registerListeners(){const D=L.Event.fromNodeEventEmitter(S.app,"login",(b,l,u,c,a)=>({event:b,webContents:l,req:u,authInfo:c,callback:a}));this._register(D(this.onLogin,this))}async onLogin({event:D,authInfo:b,req:l,callback:u}){if(!b.isProxy)return;if(!this.pendingProxyResolve&&this.state===y.LoginDialogShown&&l.firstAuthAttempt){this.logService.trace("auth#onLogin (proxy) - exit - proxy dialog already shown");return}D.preventDefault();let c;if(this.pendingProxyResolve)this.logService.trace("auth#onLogin (proxy) - pending proxy handling found"),c=await this.pendingProxyResolve;else{this.logService.trace("auth#onLogin (proxy) - no pending proxy handling found, starting new"),this.pendingProxyResolve=this.resolveProxyCredentials(b);try{c=await this.pendingProxyResolve}finally{this.pendingProxyResolve=void 0}}u(c==null?void 0:c.username,c==null?void 0:c.password)}async resolveProxyCredentials(D){this.logService.trace("auth#resolveProxyCredentials (proxy) - enter");try{const b=await this.doResolveProxyCredentials(D);if(b)return this.logService.trace("auth#resolveProxyCredentials (proxy) - got credentials"),b;this.logService.trace("auth#resolveProxyCredentials (proxy) - did not get credentials")}finally{this.logService.trace("auth#resolveProxyCredentials (proxy) - exit")}}async doResolveProxyCredentials(D){var b,l,u,c;this.logService.trace("auth#doResolveProxyCredentials - enter",D);const a=String(A.hash({scheme:D.scheme,host:D.host,port:D.port}));let t,r;try{const f=await this.nativeHostMainService.getPassword(void 0,this.PROXY_CREDENTIALS_SERVICE_KEY,a);if(f){const d=JSON.parse(await this.encryptionMainService.decrypt(f));t=d.username,r=d.password}}catch(f){this.logService.error(f)}if(this.state!==y.StoredCredentialsUsed&&typeof t=="string"&&typeof r=="string")return this.logService.trace("auth#doResolveProxyCredentials (proxy) - exit - found stored credentials to use"),this.state=y.StoredCredentialsUsed,{username:t,password:r};const s=this.windowsMainService.getFocusedWindow()||this.windowsMainService.getLastActiveWindow();if(!s){this.logService.trace("auth#doResolveProxyCredentials (proxy) - exit - no opened window found to show dialog in");return}this.logService.trace(`auth#doResolveProxyCredentials (proxy) - asking window ${s.id} to handle proxy login`);const o={authInfo:D,username:(l=(b=this.sessionCredentials)===null||b===void 0?void 0:b.username)!==null&&l!==void 0?l:t,password:(c=(u=this.sessionCredentials)===null||u===void 0?void 0:u.password)!==null&&c!==void 0?c:r,replyChannel:`vscode:proxyAuthResponse:${i.generateUuid()}`};s.sendWhenReady("vscode:openProxyAuthenticationDialog",P.CancellationToken.None,o),this.state=y.LoginDialogShown;const h=await new Promise(f=>{var d;const M=async(T,C,V)=>{var Q;if(C===o.replyChannel)if(this.logService.trace(`auth#doResolveProxyCredentials - exit - received credentials from window ${s.id}`),(Q=s.win)===null||Q===void 0||Q.webContents.off("ipc-message",M),V){const te={username:V.username,password:V.password};try{if(V.remember){const B=await this.encryptionMainService.encrypt(JSON.stringify(te));await this.nativeHostMainService.setPassword(void 0,this.PROXY_CREDENTIALS_SERVICE_KEY,a,B)}else await this.nativeHostMainService.deletePassword(void 0,this.PROXY_CREDENTIALS_SERVICE_KEY,a)}catch(B){this.logService.error(B)}f({username:te.username,password:te.password})}else f(void 0)};(d=s.win)===null||d===void 0||d.webContents.on("ipc-message",M)});return this.sessionCredentials=h,h}};g=he([ee(0,E.ILogService),ee(1,n.IWindowsMainService),ee(2,w.INativeHostMainService),ee(3,p.IEncryptionMainService),ee(4,I.IProductService)],g),e.ProxyAuthHandler=g}),define(J[219],Z([0,1,216,155,34,56,2,33,57,175,3,5,79,106,9,18,45]),function(z,e,m,L,A,S,E,n,w,p,i,I,P,y,g,v,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.serve=e.Driver=void 0;function b(c){return c<21}let l=class{constructor(a,t,r,s,o){this.windowServer=a,this.options=t,this.windowsMainService=r,this.lifecycleMainService=s,this.nativeHostMainService=o,this.registeredWindowIds=new Set,this.reloadingWindowIds=new Set,this.onDidReloadingChange=new I.Emitter}async registerWindowDriver(a){return this.registeredWindowIds.add(a),this.reloadingWindowIds.delete(a),this.onDidReloadingChange.fire(),this.options}async reloadWindowDriver(a){this.reloadingWindowIds.add(a)}async getWindowIds(){return this.windowsMainService.getWindows().map(a=>a.id).filter(a=>this.registeredWindowIds.has(a)&&!this.reloadingWindowIds.has(a))}async capturePage(a){await this.whenUnfrozen(a);const t=this.windowsMainService.getWindowById(a);if(!(t==null?void 0:t.win))throw new Error("Invalid window");return(await t.win.webContents.capturePage()).toPNG().toString("base64")}async reloadWindow(a){await this.whenUnfrozen(a);const t=this.windowsMainService.getWindowById(a);if(!t)throw new Error("Invalid window");this.reloadingWindowIds.add(a),this.lifecycleMainService.reload(t)}async exitApplication(){return this.nativeHostMainService.quit(void 0)}async dispatchKeybinding(a,t){await this.whenUnfrozen(a);const r=y.KeybindingParser.parseUserBinding(t);for(let s of r)await this._dispatchKeybinding(a,s)}async _dispatchKeybinding(a,t){if(t instanceof P.ScanCodeBinding)throw new Error("ScanCodeBindings not supported");const r=this.windowsMainService.getWindowById(a);if(!(r==null?void 0:r.win))throw new Error("Invalid window");const s=r.win.webContents,o=new w.SimpleKeybinding(!1,!1,!1,!1,t.keyCode),f=new p.USLayoutResolvedKeybinding(o.toChord(),i.OS).getElectronAccelerator(),d=[];t.ctrlKey&&d.push("ctrl"),t.metaKey&&d.push("meta"),t.shiftKey&&d.push("shift"),t.altKey&&d.push("alt"),s.sendInputEvent({type:"keyDown",keyCode:f,modifiers:d}),b(t.keyCode)||s.sendInputEvent({type:"char",keyCode:f,modifiers:d}),s.sendInputEvent({type:"keyUp",keyCode:f,modifiers:d}),await g.timeout(100)}async click(a,t,r,s){await(await this.getWindowDriver(a)).click(t,r,s)}async doubleClick(a,t){await(await this.getWindowDriver(a)).doubleClick(t)}async setValue(a,t,r){await(await this.getWindowDriver(a)).setValue(t,r)}async getTitle(a){return await(await this.getWindowDriver(a)).getTitle()}async isActiveElement(a,t){return await(await this.getWindowDriver(a)).isActiveElement(t)}async getElements(a,t,r){return await(await this.getWindowDriver(a)).getElements(t,r)}async getElementXY(a,t,r,s){return await(await this.getWindowDriver(a)).getElementXY(t,r,s)}async typeInEditor(a,t,r){await(await this.getWindowDriver(a)).typeInEditor(t,r)}async getTerminalBuffer(a,t){return await(await this.getWindowDriver(a)).getTerminalBuffer(t)}async writeInTerminal(a,t,r){await(await this.getWindowDriver(a)).writeInTerminal(t,r)}async getWindowDriver(a){await this.whenUnfrozen(a);const t=`window:${a}`,r=new n.StaticRouter(o=>o===t),s=this.windowServer.getChannel("windowDriver",r);return new L.WindowDriverChannelClient(s)}async whenUnfrozen(a){for(;this.reloadingWindowIds.has(a);)await I.Event.toPromise(this.onDidReloadingChange.event)}};l=he([ee(2,A.IWindowsMainService),ee(3,v.ILifecycleMainService),ee(4,D.INativeHostMainService)],l),e.Driver=l;async function u(c,a,t,r){const s=t.driverVerbose,o=r.createInstance(l,c,{verbose:s}),h=new m.WindowDriverRegistryChannel(o);c.registerChannel("windowDriverRegistry",h);const f=await S.serve(a),d=new m.DriverChannel(o);return f.registerChannel("driver",d),E.combinedDisposable(f,c)}e.serve=u}),define(J[220],Z([0,1,59,56]),function(z,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeSocketFactory=void 0,e.nodeSocketFactory=new class{connect(A,S,E,n){const w=i=>n(i,void 0),p=m.createConnection({host:A,port:S},()=>{p.removeListener("error",w);const i=Buffer.alloc(16);for(let g=0;g<16;g++)i[g]=Math.round(Math.random()*256);const I=i.toString("base64");let P=[`GET ws://${/:/.test(A)?`[${A}]`:A}:${S}/?${E}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${I}`];p.write(P.join(`\r
`)+`\r
\r
`);const y=g=>{g.toString().indexOf(`\r
\r
`)>=0&&(p.off("data",y),n(void 0,new L.NodeSocket(p)))};p.on("data",y)});p.once("error",w)}}}),define(J[221],Z([0,1,59,9,2,115,16,6,22,190,74,220,75]),function(z,e,m,L,A,S,E,n,w,p,i,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TunnelService=e.BaseTunnelService=void 0;async function y(b,l,u,c,a){return new g(b,l,u,c,a).waitForReady()}class g extends A.Disposable{constructor(l,u,c,a,t){super();this.defaultTunnelHost=u,this.suggestedLocalPort=t,this.public=!1,this._socketsDispose=new Map,this._options=l,this._server=m.createServer(),this._barrier=new L.Barrier,this._listeningListener=()=>this._barrier.open(),this._server.on("listening",this._listeningListener),this._connectionListener=r=>this._onConnection(r),this._server.on("connection",this._connectionListener),this._errorListener=()=>{},this._server.on("error",this._errorListener),this.tunnelRemotePort=a,this.tunnelRemoteHost=c}async dispose(){super.dispose(),this._server.removeListener("listening",this._listeningListener),this._server.removeListener("connection",this._connectionListener),this._server.removeListener("error",this._errorListener),this._server.close(),Array.from(this._socketsDispose.values()).forEach(u=>{u()})}async waitForReady(){var l;let u=await S.findFreePortFaster((l=this.suggestedLocalPort)!==null&&l!==void 0?l:this.tunnelRemotePort,2,1e3),c=null;return this._server.listen(u,this.defaultTunnelHost),await this._barrier.wait(),c=this._server.address(),c||(u=0,this._server.listen(u,this.defaultTunnelHost),await this._barrier.wait(),c=this._server.address()),this.tunnelLocalPort=c.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${c.port}`,this}async _onConnection(l){l.pause();const u=await p.connectRemoteAgentTunnel(this._options,this.tunnelRemotePort),c=u.getSocket().socket,a=u.readEntireBuffer();u.dispose(),a.byteLength>0&&l.write(a.buffer),l.on("end",()=>{this._socketsDispose.delete(l.localAddress),c.end()}),l.on("close",()=>c.end()),l.on("error",()=>{this._socketsDispose.delete(l.localAddress),c.destroy()}),c.on("end",()=>l.end()),c.on("close",()=>l.end()),c.on("error",()=>{l.destroy()}),l.pipe(c),c.pipe(l),this._socketsDispose.set(l.localAddress,()=>{l.end(),c.end()})}}let v=class extends i.AbstractTunnelService{constructor(l,u,c,a,t){super(u);this.socketFactory=l,this.signService=c,this.productService=a,this.configurationService=t}get defaultTunnelHost(){return this.configurationService.getValue("remote.localPortHost")==="localhost"?"127.0.0.1":"0.0.0.0"}retainOrCreateTunnel(l,u,c,a,t,r){const s=this.getTunnelFromMap(u,c);if(s)return++s.refcount,s.value;if(this._tunnelProvider)return this.createWithProvider(this._tunnelProvider,u,c,a,t,r);{this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${u}:${c} on local port ${a}.`);const o={commit:this.productService.commit,socketFactory:this.socketFactory,addressProvider:l,signService:this.signService,logService:this.logService,ipcLogger:null},h=y(o,this.defaultTunnelHost,u,c,a);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.addTunnelToMap(u,c,h),h}}};v=he([ee(1,n.ILogService),ee(2,P.ISignService),ee(3,w.IProductService),ee(4,E.IConfigurationService)],v),e.BaseTunnelService=v;let D=class extends v{constructor(l,u,c,a){super(I.nodeSocketFactory,l,u,c,a)}};D=he([ee(0,n.ILogService),ee(1,P.ISignService),ee(2,w.IProductService),ee(3,E.IConfigurationService)],D),e.TunnelService=D}),define(J[222],Z([0,1,215,192,2,13,19,191,16,6,20,53,91]),function(z,e,m,L,A,S,E,n,w,p,i,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let y=class extends A.Disposable{constructor(v,D,b){super();this.environmentService=D,this.logService=b,this.configure(v.getValue()),this._register(v.onDidChangeConfiguration(()=>this.configure(v.getValue()),this))}configure(v){this.proxyUrl=v.http&&v.http.proxy,this.strictSSL=!!(v.http&&v.http.proxyStrictSSL),this.authorization=v.http&&v.http.proxyAuthorization}async request(v,D){this.logService.trace("RequestService#request",v.url);const{proxyUrl:b,strictSSL:l}=this,u=Object.assign(Object.assign({},process.env),await P.resolveShellEnv(this.logService,this.environmentService.args,process.env)),c=v.agent?v.agent:await n.getProxyAgent(v.url||"",u,{proxyUrl:b,strictSSL:l});return v.agent=c,v.strictSSL=l,this.authorization&&(v.headers=Object.assign(Object.assign({},v.headers||{}),{"Proxy-Authorization":this.authorization})),this._request(v,D)}async getNodeRequest(v){return(L.parse(v.url).protocol==="https:"?await new Promise((l,u)=>{z(["https"],l,u)}):await new Promise((l,u)=>{z(["http"],l,u)})).request}_request(v,D){return new Promise(async(b,l)=>{let u;const c=L.parse(v.url),a=v.getRawRequest?v.getRawRequest(v):await this.getNodeRequest(v),t={hostname:c.hostname,port:c.port?parseInt(c.port):c.protocol==="https:"?443:80,protocol:c.protocol,path:c.path,method:v.type||"GET",headers:v.headers,agent:v.agent,rejectUnauthorized:S.isBoolean(v.strictSSL)?v.strictSSL:!0};v.user&&v.password&&(t.auth=v.user+":"+v.password),u=a(t,r=>{const s=S.isNumber(v.followRedirects)?v.followRedirects:3;if(r.statusCode&&r.statusCode>=300&&r.statusCode<400&&s>0&&r.headers.location)this._request(Object.assign(Object.assign({},v),{url:r.headers.location,followRedirects:s-1}),D).then(b,l);else{let o=r;r.headers["content-encoding"]==="gzip"&&(o=r.pipe(m.createGunzip())),b({res:r,stream:i.streamToBufferReadableStream(o)})}}),u.on("error",l),v.timeout&&u.setTimeout(v.timeout),v.data&&typeof v.data=="string"&&u.write(v.data),u.end(),D.onCancellationRequested(()=>{u.abort(),l(E.canceled())})})}async resolveProxy(v){}};y=he([ee(0,w.IConfigurationService),ee(1,I.INativeEnvironmentService),ee(2,p.ILogService)],y),e.RequestService=y}),define(J[223],Z([0,1,222,14]),function(z,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestMainService=void 0;function A(E){return L.net.request}class S extends m.RequestService{request(n,w){return super.request(Object.assign(Object.assign({},n||{}),{getRawRequest:A}),w)}}e.RequestMainService=S}),define(J[224],Z([0,1,47,14,24,9,6,18,60,10,3,2,85,13,5,55]),function(z,e,m,L,A,S,E,n,w,p,i,I,P,y,g,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcess=void 0;let D=class extends I.Disposable{constructor(l,u,c,a,t,r,s){super();this.machineId=l,this.userEnv=u,this.environmentMainService=c,this.lifecycleMainService=a,this.logService=t,this.themeMainService=r,this.protocolMainService=s,this.firstWindowConnectionBarrier=new S.Barrier,this.window=void 0,this.windowCloseListener=void 0,this._onDidError=this._register(new g.Emitter),this.onDidError=g.Event.buffer(this._onDidError.event),this._whenReady=void 0,this._whenIpcReady=void 0,this.registerListeners()}registerListeners(){this._register(this.lifecycleMainService.onWillShutdown(()=>this.onWillShutdown())),L.ipcMain.on("vscode:createSharedProcessMessageChannel",async(l,u)=>this.onWindowConnection(l,u))}async onWindowConnection(l,u){this.logService.trace("SharedProcess: on vscode:createSharedProcessMessageChannel"),this.firstWindowConnectionBarrier.isOpen()||this.firstWindowConnectionBarrier.open(),await this.whenReady();const c=await this.connect();if(l.sender.isDestroyed())return c.close();l.sender.postMessage("vscode:createSharedProcessMessageChannelResult",u,[c])}onWillShutdown(){const l=this.window;!l||(!l.isDestroyed()&&!l.webContents.isDestroyed()&&l.webContents.send("vscode:electron-main->shared-process=exit"),this.windowCloseListener&&(l.removeListener("close",this.windowCloseListener),this.windowCloseListener=void 0),setTimeout(()=>{try{l.close()}catch(u){}this.window=void 0},0))}whenReady(){return this._whenReady||(this._whenReady=new Promise(l=>L.ipcMain.once("vscode:shared-process->electron-main=init-done",()=>{this.logService.trace("SharedProcess: Overall ready"),l()}))),this._whenReady}get whenIpcReady(){return this._whenIpcReady||(this._whenIpcReady=(async()=>{await this.firstWindowConnectionBarrier.wait(),this.createWindow(),this.registerWindowListeners(),await new Promise(l=>L.ipcMain.once("vscode:shared-process->electron-main=ipc-ready",()=>{this.logService.trace("SharedProcess: IPC ready"),l()}))})()),this._whenIpcReady}createWindow(){const l=this._register(this.protocolMainService.createIPCObjectUrl());this.window=new L.BrowserWindow({show:!1,backgroundColor:this.themeMainService.getBackgroundColor(),webPreferences:{preload:p.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",z).fsPath,additionalArguments:[`--vscode-window-config=${l.resource.toString()}`],v8CacheOptions:i.browserCodeLoadingCacheStrategy,nodeIntegration:!0,contextIsolation:!1,enableWebSQL:!1,spellcheck:!1,nativeWindowOpen:!0,images:!1,webgl:!1,disableBlinkFeatures:"Auxclick"}}),l.update({machineId:this.machineId,windowId:this.window.id,appRoot:this.environmentMainService.appRoot,codeCachePath:this.environmentMainService.codeCachePath,backupWorkspacesPath:this.environmentMainService.backupWorkspacesPath,userEnv:this.userEnv,args:this.environmentMainService.args,logLevel:this.logService.getLevel(),product:m.default}),this.window.loadURL(p.FileAccess.asBrowserUri("vs/code/electron-browser/sharedProcess/sharedProcess.html",z).toString(!0))}registerWindowListeners(){!this.window||(this.windowCloseListener=l=>{var u;this.logService.trace("SharedProcess#close prevented"),l.preventDefault(),((u=this.window)===null||u===void 0?void 0:u.isVisible())&&this.window.hide()},this.window.on("close",this.windowCloseListener),this.window.webContents.on("render-process-gone",(l,u)=>this._onDidError.fire({type:2,details:u})),this.window.on("unresponsive",()=>this._onDidError.fire({type:1})),this.window.webContents.on("did-fail-load",(l,u,c)=>this._onDidError.fire({type:3,details:{reason:c,exitCode:u}})))}async connect(){await this.whenIpcReady;const l=y.assertIsDefined(this.window);return P.connect(l)}async toggle(){await this.whenIpcReady,!!this.window&&(this.window.isVisible()?(this.window.webContents.closeDevTools(),this.window.hide()):(this.window.show(),this.window.webContents.openDevTools()))}isVisible(){var l,u;return(u=(l=this.window)===null||l===void 0?void 0:l.isVisible())!==null&&u!==void 0?u:!1}};D=he([ee(2,A.IEnvironmentMainService),ee(3,n.ILifecycleMainService),ee(4,E.ILogService),ee(5,w.IThemeMainService),ee(6,v.IProtocolMainService)],D),e.SharedProcess=D}),define(J[225],Z([0,1,7,8,13,6,24,9,21,20]),function(z,e,m,L,A,S,E,n,w,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StateMainService=e.FileStorage=void 0;class i{constructor(y,g,v){this.storagePath=y,this.logService=g,this.fileService=v,this.storage=Object.create(null),this.lastSavedStorageContents="",this.flushDelayer=new n.ThrottledDelayer(100),this.initializing=void 0,this.closing=void 0}init(){return this.initializing||(this.initializing=this.doInit()),this.initializing}async doInit(){try{this.lastSavedStorageContents=(await this.fileService.readFile(this.storagePath)).value.toString(),this.storage=JSON.parse(this.lastSavedStorageContents)}catch(y){y.fileOperationResult!==1&&this.logService.error(y)}}getItem(y,g){const v=this.storage[y];return A.isUndefinedOrNull(v)?g:v}setItem(y,g){this.setItems([{key:y,data:g}])}setItems(y){let g=!1;for(const{key:v,data:D}of y)this.storage[v]!==D&&(A.isUndefinedOrNull(D)?A.isUndefined(this.storage[v])||(this.storage[v]=void 0,g=!0):(this.storage[v]=D,g=!0));g&&this.save()}removeItem(y){A.isUndefined(this.storage[y])||(this.storage[y]=void 0,this.save())}async save(y){if(!this.closing)return this.flushDelayer.trigger(()=>this.doSave(),y)}async doSave(){if(!this.initializing)return;await this.initializing;const y=JSON.stringify(this.storage,null,4);if(y!==this.lastSavedStorageContents)try{await this.fileService.writeFile(this.storagePath,p.VSBuffer.fromString(y)),this.lastSavedStorageContents=y}catch(g){this.logService.error(g)}}async close(){return this.closing||(this.closing=this.flushDelayer.trigger(()=>this.doSave(),0)),this.closing}}e.FileStorage=i;let I=class Pt{constructor(y,g,v){this.fileStorage=new i(m.URI.file(L.join(y.userDataPath,Pt.STATE_FILE)),g,v)}async init(){return this.fileStorage.init()}getItem(y,g){return this.fileStorage.getItem(y,g)}setItem(y,g){this.fileStorage.setItem(y,g)}setItems(y){this.fileStorage.setItems(y)}removeItem(y){this.fileStorage.removeItem(y)}close(){return this.fileStorage.close()}};I.STATE_FILE="storage.json",I=he([ee(0,E.IEnvironmentMainService),ee(1,S.ILogService),ee(2,w.IFileService)],I),e.StateMainService=I}),define(J[77],Z([0,1,5,9,16,18,22,41,24,6,49,25]),function(z,e,m,L,A,S,E,n,w,p,i,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractUpdateService=e.createUpdateURL=void 0;function P(g,v,D){return`${D.updateUrl}/api/update/${g}/${v}/${D.commit}`}e.createUpdateURL=P;let y=class{constructor(v,D,b,l,u,c){this.lifecycleMainService=v,this.configurationService=D,this.environmentMainService=b,this.requestService=l,this.logService=u,this.productService=c,this._state=n.State.Uninitialized,this._onStateChange=new m.Emitter,this.onStateChange=this._onStateChange.event}get state(){return this._state}setState(v){this.logService.info("update#setState",v.type),this._state=v,this._onStateChange.fire(v)}initialize(){if(!this.environmentMainService.isBuilt)return;if(this.environmentMainService.disableUpdates){this.logService.info("update#ctor - updates are disabled by the environment");return}if(!this.productService.updateUrl||!this.productService.commit){this.logService.info("update#ctor - updates are disabled as there is no update URL");return}const v=A.getMigratedSettingValue(this.configurationService,"update.mode","update.channel"),D=this.getProductQuality(v);if(!D){this.logService.info("update#ctor - updates are disabled by user preference");return}if(this.url=this.buildUpdateFeedUrl(D),!this.url){this.logService.info("update#ctor - updates are disabled as the update URL is badly formed");return}if(this.setState(n.State.Idle(this.getUpdateType())),v==="manual"){this.logService.info("update#ctor - manual checks only; automatic updates are disabled by user preference");return}v==="start"?(this.logService.info("update#ctor - startup checks only; automatic updates are disabled by user preference"),setTimeout(()=>this.checkForUpdates(!1),30*1e3)):this.scheduleCheckForUpdates(30*1e3).then(void 0,b=>this.logService.error(b))}getProductQuality(v){return v==="none"?void 0:this.productService.quality}scheduleCheckForUpdates(v=60*60*1e3){return L.timeout(v).then(()=>this.checkForUpdates(!1)).then(()=>this.scheduleCheckForUpdates(60*60*1e3))}async checkForUpdates(v){this.logService.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.doCheckForUpdates(v)}async downloadUpdate(){this.logService.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.doDownloadUpdate(this.state)}async doDownloadUpdate(v){}async applyUpdate(){this.logService.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.doApplyUpdate()}async doApplyUpdate(){}quitAndInstall(){return this.logService.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.logService.trace("update#quitAndInstall(): before lifecycle quit()"),this.lifecycleMainService.quit(!0).then(v=>{this.logService.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${v}`),!v&&(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.doQuitAndInstall())})),Promise.resolve(void 0)}isLatestVersion(){return this.url?this.requestService.request({url:this.url},I.CancellationToken.None).then(v=>v.res.statusCode===204):Promise.resolve(void 0)}getUpdateType(){return 1}doQuitAndInstall(){}};y=he([ee(0,S.ILifecycleMainService),ee(1,A.IConfigurationService),ee(2,w.IEnvironmentMainService),ee(3,i.IRequestService),ee(4,p.ILogService),ee(5,E.IProductService)],y),e.AbstractUpdateService=y}),define(J[226],Z([0,1,14,2,5,46,16,18,41,31,24,6,77,49,22]),function(z,e,m,L,A,S,E,n,w,p,i,I,P,y,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DarwinUpdateService=void 0;let v=class extends P.AbstractUpdateService{constructor(b,l,u,c,a,t,r){super(b,l,c,a,t,r);this.telemetryService=u,this.disposables=new L.DisposableStore}get onRawError(){return A.Event.fromNodeEventEmitter(m.autoUpdater,"error",(b,l)=>l)}get onRawUpdateNotAvailable(){return A.Event.fromNodeEventEmitter(m.autoUpdater,"update-not-available")}get onRawUpdateAvailable(){return A.Event.fromNodeEventEmitter(m.autoUpdater,"update-available",(b,l,u)=>({url:l,version:u,productVersion:u}))}get onRawUpdateDownloaded(){return A.Event.fromNodeEventEmitter(m.autoUpdater,"update-downloaded",(b,l,u,c)=>({releaseNotes:l,version:u,productVersion:u,date:c}))}initialize(){super.initialize(),this.onRawError(this.onError,this,this.disposables),this.onRawUpdateAvailable(this.onUpdateAvailable,this,this.disposables),this.onRawUpdateDownloaded(this.onUpdateDownloaded,this,this.disposables),this.onRawUpdateNotAvailable(this.onUpdateNotAvailable,this,this.disposables)}onError(b){this.logService.error("UpdateService error:",b);const u=(this.state.type==="checking for updates"?this.state.explicit:!0)?b:void 0;this.setState(w.State.Idle(1,u))}buildUpdateFeedUrl(b){let l;this.productService.darwinUniversalAssetId?l=this.productService.darwinUniversalAssetId:l=process.arch==="x64"?"darwin":"darwin-arm64";const u=P.createUpdateURL(l,b,this.productService);try{m.autoUpdater.setFeedURL({url:u})}catch(c){this.logService.error("Failed to set update feed URL",c);return}return u}doCheckForUpdates(b){this.setState(w.State.CheckingForUpdates(b)),m.autoUpdater.checkForUpdates()}onUpdateAvailable(b){this.state.type==="checking for updates"&&this.setState(w.State.Downloading(b))}onUpdateDownloaded(b){this.state.type==="downloading"&&(this.telemetryService.publicLog2("update:downloaded",{version:b.version}),this.setState(w.State.Ready(b)))}onUpdateNotAvailable(){this.state.type==="checking for updates"&&(this.telemetryService.publicLog2("update:notAvailable",{explicit:this.state.explicit}),this.setState(w.State.Idle(1)))}doQuitAndInstall(){this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),m.autoUpdater.quitAndInstall()}dispose(){this.disposables.dispose()}};he([S.memoize],v.prototype,"onRawError",null),he([S.memoize],v.prototype,"onRawUpdateNotAvailable",null),he([S.memoize],v.prototype,"onRawUpdateAvailable",null),he([S.memoize],v.prototype,"onRawUpdateDownloaded",null),v=he([ee(0,n.ILifecycleMainService),ee(1,E.IConfigurationService),ee(2,p.ITelemetryService),ee(3,i.IEnvironmentMainService),ee(4,y.IRequestService),ee(5,I.ILogService),ee(6,g.IProductService)],v),e.DarwinUpdateService=v}),define(J[227],Z([0,1,22,16,18,41,31,24,6,77,49,25,45]),function(z,e,m,L,A,S,E,n,w,p,i,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxUpdateService=void 0;let y=class extends p.AbstractUpdateService{constructor(v,D,b,l,u,c,a,t){super(v,D,l,u,c,t);this.telemetryService=b,this.nativeHostMainService=a}buildUpdateFeedUrl(v){return p.createUpdateURL(`linux-${process.arch}`,v,this.productService)}doCheckForUpdates(v){!this.url||(this.setState(S.State.CheckingForUpdates(v)),this.requestService.request({url:this.url},I.CancellationToken.None).then(i.asJson).then(D=>{!D||!D.url||!D.version||!D.productVersion?(this.telemetryService.publicLog2("update:notAvailable",{explicit:!!v}),this.setState(S.State.Idle(1))):this.setState(S.State.AvailableForDownload(D))}).then(void 0,D=>{this.logService.error(D),this.telemetryService.publicLog2("update:notAvailable",{explicit:!!v});const b=v?D.message||D:void 0;this.setState(S.State.Idle(1,b))}))}async doDownloadUpdate(v){this.productService.downloadUrl&&this.productService.downloadUrl.length>0?this.nativeHostMainService.openExternal(void 0,this.productService.downloadUrl):v.update.url&&this.nativeHostMainService.openExternal(void 0,v.update.url),this.setState(S.State.Idle(1))}};y=he([ee(0,A.ILifecycleMainService),ee(1,L.IConfigurationService),ee(2,E.ITelemetryService),ee(3,n.IEnvironmentMainService),ee(4,i.IRequestService),ee(5,w.ILogService),ee(6,P.INativeHostMainService),ee(7,m.IProductService)],y),e.LinuxUpdateService=y}),define(J[228],Z([0,1,5,9,18,41,24,6,8,30,40,31]),function(z,e,m,L,A,S,E,n,w,p,i,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnapUpdateService=void 0;let P=class{constructor(v,D,b){if(this.lifecycleMainService=v,this.logService=b,this._state=S.State.Uninitialized,this._onStateChange=new m.Emitter,this.onStateChange=this._onStateChange.event,D.disableUpdates){this.logService.info("update#ctor - updates are disabled");return}this.setState(S.State.Idle(this.getUpdateType())),this.scheduleCheckForUpdates(30*1e3).then(void 0,l=>this.logService.error(l))}get state(){return this._state}setState(v){this.logService.info("update#setState",v.type),this._state=v,this._onStateChange.fire(v)}scheduleCheckForUpdates(v=60*60*1e3){return L.timeout(v).then(()=>this.checkForUpdates(!1)).then(()=>this.scheduleCheckForUpdates(60*60*1e3))}async checkForUpdates(v){this.logService.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.doCheckForUpdates(v)}async downloadUpdate(){this.logService.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.doDownloadUpdate(this.state)}doDownloadUpdate(v){return Promise.resolve(void 0)}async applyUpdate(){this.logService.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.doApplyUpdate()}doApplyUpdate(){return Promise.resolve(void 0)}quitAndInstall(){return this.logService.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.logService.trace("update#quitAndInstall(): before lifecycle quit()"),this.lifecycleMainService.quit(!0).then(v=>{this.logService.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${v}`),!v&&(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.doQuitAndInstall())})),Promise.resolve(void 0)}getUpdateType(){return 2}doQuitAndInstall(){}};P=he([ee(0,A.ILifecycleMainService),ee(1,E.IEnvironmentMainService),ee(2,n.ILogService)],P);let y=class extends P{constructor(v,D,b,l,u,c){super(b,l,u);this.snap=v,this.snapRevision=D,this.telemetryService=c;const a=p.watch(w.dirname(this.snap)),t=m.Event.fromNodeEventEmitter(a,"change",(h,f)=>f),r=m.Event.filter(t,h=>h==="current"),o=m.Event.debounce(r,(h,f)=>f,2e3)(()=>this.checkForUpdates(!1));b.onWillShutdown(()=>{o.dispose(),a.close()})}doCheckForUpdates(){this.setState(S.State.CheckingForUpdates(!1)),this.isUpdateAvailable().then(v=>{v?this.setState(S.State.Ready({version:"something",productVersion:"something"})):(this.telemetryService.publicLog2("update:notAvailable",{explicit:!1}),this.setState(S.State.Idle(2)))},v=>{this.logService.error(v),this.telemetryService.publicLog2("update:notAvailable",{explicit:!1}),this.setState(S.State.Idle(2,v.message||v))})}doQuitAndInstall(){this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),i.spawn("sleep 3 && "+w.basename(process.argv[0]),{shell:!0,detached:!0,stdio:"ignore"})}async isUpdateAvailable(){const v=await new Promise((b,l)=>p.realpath(`${w.dirname(this.snap)}/current`,(u,c)=>u?l(u):b(c))),D=w.basename(v);return this.snapRevision!==D}isLatestVersion(){return this.isUpdateAvailable().then(void 0,v=>{this.logService.error("update#checkForSnapUpdate(): Could not get realpath of application.")})}};y=he([ee(2,A.ILifecycleMainService),ee(3,E.IEnvironmentMainService),ee(4,n.ILogService),ee(5,I.ITelemetryService)],y),e.SnapUpdateService=y}),define(J[229],Z([0,1,30,8,17,46,16,18,22,41,31,24,6,77,49,112,26,40,25,9,21,7,45]),function(z,e,m,L,A,S,E,n,w,p,i,I,P,y,g,v,D,b,l,u,c,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Win32UpdateService=void 0;async function r(f,d=1e3){for(;!f();)await u.timeout(d)}let s;function o(){return typeof s=="undefined"&&(s=m.existsSync(L.join(L.dirname(process.execPath),"unins000.exe"))?0:1),s}let h=class extends y.AbstractUpdateService{constructor(d,M,T,C,V,Q,te,B,Y){super(d,M,C,V,Q,Y);this.telemetryService=T,this.fileService=te,this.nativeHostMainService=B}get cachePath(){const d=L.join(D.tmpdir(),`vscode-update-${this.productService.target}-${process.arch}`);return A.Promises.mkdir(d,{recursive:!0}).then(()=>d)}initialize(){super.initialize(),o()===0&&this.telemetryService.publicLog("update:win32SetupTarget",{target:this.productService.target})}buildUpdateFeedUrl(d){let M="win32";return process.arch!=="ia32"&&(M+=`-${process.arch}`),o()===1?M+="-archive":this.productService.target==="user"&&(M+="-user"),y.createUpdateURL(M,d,this.productService)}doCheckForUpdates(d){!this.url||(this.setState(p.State.CheckingForUpdates(d)),this.requestService.request({url:this.url},l.CancellationToken.None).then(g.asJson).then(M=>{const T=o();return!M||!M.url||!M.version||!M.productVersion?(this.telemetryService.publicLog2("update:notAvailable",{explicit:!!d}),this.setState(p.State.Idle(T)),Promise.resolve(null)):T===1?(this.setState(p.State.AvailableForDownload(M)),Promise.resolve(null)):(this.setState(p.State.Downloading(M)),this.cleanup(M.version).then(()=>this.getUpdatePackagePath(M.version).then(C=>A.Promises.exists(C).then(V=>{if(V)return Promise.resolve(C);const Q=M.url,te=M.hash,B=`${C}.tmp`;return this.requestService.request({url:Q},l.CancellationToken.None).then(Y=>this.fileService.writeFile(a.URI.file(B),Y.stream)).then(te?()=>v.checksum(B,M.hash):()=>{}).then(()=>A.Promises.rename(B,C)).then(()=>C)})).then(C=>{const V=this.configurationService.getValue("update.enableWindowsBackgroundUpdates");this.availableUpdate={packagePath:C},V&&M.supportsFastUpdate?this.productService.target==="user"?this.doApplyUpdate():this.setState(p.State.Downloaded(M)):this.setState(p.State.Ready(M))})))}).then(void 0,M=>{this.logService.error(M),this.telemetryService.publicLog2("update:notAvailable",{explicit:!!d});const T=d?M.message||M:void 0;this.setState(p.State.Idle(o(),T))}))}async doDownloadUpdate(d){d.update.url&&this.nativeHostMainService.openExternal(void 0,d.update.url),this.setState(p.State.Idle(o()))}async getUpdatePackagePath(d){const M=await this.cachePath;return L.join(M,`CodeSetup-${this.productService.quality}-${d}.exe`)}async cleanup(d=null){const M=d?Q=>!new RegExp(`${this.productService.quality}-${d}\\.exe$`).test(Q):()=>!0,T=await this.cachePath,V=(await A.Promises.readdir(T)).filter(M).map(async Q=>{try{await A.Promises.unlink(L.join(T,Q))}catch(te){}});await Promise.all(V)}async doApplyUpdate(){if(this.state.type!=="downloaded"&&this.state.type!=="downloading"||!this.availableUpdate)return Promise.resolve(void 0);const d=this.state.update;this.setState(p.State.Updating(d));const M=await this.cachePath;this.availableUpdate.updateFilePath=L.join(M,`CodeSetup-${this.productService.quality}-${d.version}.flag`),await A.Promises.writeFile(this.availableUpdate.updateFilePath,"flag"),b.spawn(this.availableUpdate.packagePath,["/verysilent",`/update="${this.availableUpdate.updateFilePath}"`,"/nocloseapplications","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"],windowsVerbatimArguments:!0}).once("exit",()=>{this.availableUpdate=void 0,this.setState(p.State.Idle(o()))});const C=`${this.productService.win32MutexName}-ready`,V=await new Promise((Q,te)=>{z(["windows-mutex"],Q,te)});r(()=>V.isActive(C)).then(()=>this.setState(p.State.Ready(d)))}doQuitAndInstall(){this.state.type!=="ready"||!this.availableUpdate||(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.state.update.supportsFastUpdate&&this.availableUpdate.updateFilePath?m.unlinkSync(this.availableUpdate.updateFilePath):b.spawn(this.availableUpdate.packagePath,["/silent","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"]}))}getUpdateType(){return o()}};he([S.memoize],h.prototype,"cachePath",null),h=he([ee(0,n.ILifecycleMainService),ee(1,E.IConfigurationService),ee(2,i.ITelemetryService),ee(3,I.IEnvironmentMainService),ee(4,g.IRequestService),ee(5,P.ILogService),ee(6,c.IFileService),ee(7,t.INativeHostMainService),ee(8,w.IProductService)],h),e.Win32UpdateService=h}),define(J[52],Z([0,1,28,24,8,17,30,3,5,6,58,43,10,2,15,4,153,22,14,13,50,51,100]),function(z,e,m,L,A,S,E,n,w,p,i,I,P,y,g,v,D,b,l,u,c,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingleFolderWorkspaceIdentifier=e.getWorkspaceIdentifier=e.WorkspacesManagementMainService=e.IWorkspacesManagementMainService=void 0,e.IWorkspacesManagementMainService=v.createDecorator("workspacesManagementMainService");let r=class extends y.Disposable{constructor(f,d,M,T,C){super();this.environmentMainService=f,this.logService=d,this.backupMainService=M,this.dialogMainService=T,this.productService=C,this.untitledWorkspacesHome=this.environmentMainService.untitledWorkspacesHome,this._onDidDeleteUntitledWorkspace=this._register(new w.Emitter),this.onDidDeleteUntitledWorkspace=this._onDidDeleteUntitledWorkspace.event,this._onDidEnterWorkspace=this._register(new w.Emitter),this.onDidEnterWorkspace=this._onDidEnterWorkspace.event}resolveLocalWorkspaceSync(f){if(!this.isWorkspacePath(f)||f.scheme!==P.Schemas.file)return;let d;try{d=E.readFileSync(f.fsPath,"utf8")}catch(M){return}return this.doResolveWorkspace(f,d)}isWorkspacePath(f){return m.isUntitledWorkspace(f,this.environmentMainService)||m.hasWorkspaceFileExtension(f)}doResolveWorkspace(f,d){try{const M=this.doParseStoredWorkspace(f,d),T=s(f);return{id:T.id,configPath:T.configPath,folders:m.toWorkspaceFolders(M.folders,T.configPath,g.extUriBiasedIgnorePathCase),remoteAuthority:M.remoteAuthority}}catch(M){this.logService.warn(M.toString())}}doParseStoredWorkspace(f,d){const M=I.parse(d);if(M&&Array.isArray(M.folders))M.folders=M.folders.filter(T=>m.isStoredWorkspaceFolder(T));else throw new Error(`${f.toString(!0)} looks like an invalid workspace file.`);return M}async createUntitledWorkspace(f,d){const{workspace:M,storedWorkspace:T}=this.newUntitledWorkspace(f,d),C=M.configPath.fsPath;return await S.Promises.mkdir(A.dirname(C),{recursive:!0}),await S.Promises.writeFile(C,JSON.stringify(T,null,"	")),M}createUntitledWorkspaceSync(f,d){const{workspace:M,storedWorkspace:T}=this.newUntitledWorkspace(f,d),C=M.configPath.fsPath;return E.mkdirSync(A.dirname(C),{recursive:!0}),S.writeFileSync(C,JSON.stringify(T,null,"	")),M}newUntitledWorkspace(f=[],d){const M=(Date.now()+Math.round(Math.random()*1e3)).toString(),T=g.joinPath(this.untitledWorkspacesHome,M),C=g.joinPath(T,m.UNTITLED_WORKSPACE_NAME),V=[];for(const Q of f)V.push(m.getStoredWorkspaceFolder(Q.uri,!0,Q.name,T,!n.isWindows,g.extUriBiasedIgnorePathCase));return{workspace:s(C),storedWorkspace:{folders:V,remoteAuthority:d}}}async getWorkspaceIdentifier(f){return s(f)}isUntitledWorkspace(f){return m.isUntitledWorkspace(f.configPath,this.environmentMainService)}deleteUntitledWorkspaceSync(f){!this.isUntitledWorkspace(f)||(this.doDeleteUntitledWorkspaceSync(f),this._onDidDeleteUntitledWorkspace.fire(f))}async deleteUntitledWorkspace(f){this.deleteUntitledWorkspaceSync(f)}doDeleteUntitledWorkspaceSync(f){const d=g.originalFSPath(f.configPath);try{S.rimrafSync(A.dirname(d));const M=A.join(this.environmentMainService.workspaceStorageHome.fsPath,f.id);E.existsSync(M)&&S.writeFileSync(A.join(M,"obsolete"),"")}catch(M){this.logService.warn(`Unable to delete untitled workspace ${d} (${M}).`)}}getUntitledWorkspacesSync(){const f=[];try{const d=S.readdirSync(this.untitledWorkspacesHome.fsPath).map(M=>g.joinPath(this.untitledWorkspacesHome,M,m.UNTITLED_WORKSPACE_NAME));for(const M of d){const T=s(M),C=this.resolveLocalWorkspaceSync(M);C?f.push({workspace:T,remoteAuthority:C.remoteAuthority}):this.doDeleteUntitledWorkspaceSync(T)}}catch(d){d.code!=="ENOENT"&&this.logService.warn(`Unable to read folders in ${this.untitledWorkspacesHome} (${d}).`)}return f}async enterWorkspace(f,d,M){if(!f||!f.win||!f.isReady||!await this.isValidTargetWorkspacePath(f,d,M))return;const C=this.doEnterWorkspace(f,s(M));if(!!C)return this._onDidEnterWorkspace.fire({window:f,workspace:C.workspace}),C}async isValidTargetWorkspacePath(f,d,M){if(!M)return!0;if(m.isWorkspaceIdentifier(f.openedWorkspace)&&g.extUriBiasedIgnorePathCase.isEqual(f.openedWorkspace.configPath,M))return!1;if(t.findWindowOnWorkspaceOrFolder(d,M)){const T={title:this.productService.nameLong,type:"info",buttons:[D.localize(0,null)],message:D.localize(1,null,g.basename(M)),detail:D.localize(2,null),noLink:!0};return await this.dialogMainService.showMessageBox(T,u.withNullAsUndefined(l.BrowserWindow.getFocusedWindow())),!1}return!0}doEnterWorkspace(f,d){if(!f.config)return;f.focus();let M;return f.config.extensionDevelopmentPath||(M=this.backupMainService.registerWorkspaceBackupSync({workspace:d,remoteAuthority:f.remoteAuthority},f.config.backupPath)),m.isWorkspaceIdentifier(f.openedWorkspace)&&this.isUntitledWorkspace(f.openedWorkspace)&&this.deleteUntitledWorkspaceSync(f.openedWorkspace),f.config.workspace=d,f.config.backupPath=M,{workspace:d,backupPath:M}}};r=he([ee(0,L.IEnvironmentMainService),ee(1,p.ILogService),ee(2,c.IBackupMainService),ee(3,a.IDialogMainService),ee(4,b.IProductService)],r),e.WorkspacesManagementMainService=r;function s(h){function f(){let d=h.scheme===P.Schemas.file?g.originalFSPath(h):h.toString();return n.isLinux||(d=d.toLowerCase()),i.createHash("md5").update(d).digest("hex")}return{id:f(),configPath:h}}e.getWorkspaceIdentifier=s;function o(h,f){function d(){if(h.scheme!==P.Schemas.file)return i.createHash("md5").update(h.toString()).digest("hex");if(!f)try{f=E.statSync(h.fsPath)}catch(C){return}let T;return n.isLinux?T=f.ino:n.isMacintosh?T=f.birthtime.getTime():n.isWindows&&(typeof f.birthtimeMs=="number"?T=Math.floor(f.birthtimeMs):T=f.birthtime.getTime()),i.createHash("md5").update(h.fsPath).update(T?String(T):"").digest("hex")}const M=d();if(typeof M=="string")return{id:M,uri:h}}e.getSingleFolderWorkspaceIdentifier=o}),define(J[101],Z([0,1,6,98,3,4,34,17,52,16,7,14,35,54,25,28,13]),function(z,e,m,L,A,S,E,n,w,p,i,I,P,y,g,v,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LaunchMainService=e.ILaunchMainService=e.ID=void 0,e.ID="launchMainService",e.ILaunchMainService=S.createDecorator(e.ID);let b=class{constructor(u,c,a,t,r){this.logService=u,this.windowsMainService=c,this.urlService=a,this.workspacesManagementMainService=t,this.configurationService=r}async start(u,c){this.logService.trace("Received data from other instance: ",u,c),A.isMacintosh&&I.app.focus({steal:!0});const a=this.parseOpenUrl(u);if(a.length){let t=Promise.resolve();this.windowsMainService.getWindowCount()===0&&(t=this.windowsMainService.openEmptyWindow({context:4})[0].ready()),t.then(()=>{for(const{uri:r,url:s}of a)this.urlService.open(r,{originalUrl:s})})}else return this.startOpenWindow(u,c)}parseOpenUrl(u){return u["open-url"]&&u._urls&&u._urls.length>0?P.coalesce(u._urls.map(c=>{try{return{uri:i.URI.parse(c),url:c}}catch(a){return null}})):[]}async startOpenWindow(u,c){const a=y.isLaunchedFromCli(c)?0:4;let t=[];const r=u.wait&&u.waitMarkerFilePath?i.URI.file(u.waitMarkerFilePath):void 0,s=u.remote||void 0;if(u.extensionDevelopmentPath)this.windowsMainService.openExtensionDevelopmentHostWindow(u.extensionDevelopmentPath,{context:a,cli:u,userEnv:c,waitMarkerFileURI:r,remoteAuthority:s});else if(!u._.length&&!u["folder-uri"]&&!u["file-uri"]){let o=!1;if(u["new-window"]||u["unity-launch"])o=!0;else if(u["reuse-window"])o=!1;else{const h=this.configurationService.getValue("window");switch((h==null?void 0:h.openWithoutArgumentsInNewWindow)||"default"){case"on":o=!0;break;case"off":o=!1;break;default:o=!A.isMacintosh}}if(o)t=this.windowsMainService.open({context:a,cli:u,userEnv:c,forceNewWindow:!0,forceEmpty:!0,waitMarkerFileURI:r,remoteAuthority:s});else{const h=this.windowsMainService.getLastActiveWindow();h?(h.focus(),t=[h]):t=this.windowsMainService.open({context:a,cli:u,forceEmpty:!0,remoteAuthority:s})}}else t=this.windowsMainService.open({context:a,cli:u,userEnv:c,forceNewWindow:u["new-window"],preferNewWindow:!u["reuse-window"]&&!u.wait,forceReuseWindow:u["reuse-window"],diffMode:u.diff,addMode:u.add,noRecentEntry:!!u["skip-add-to-recently-opened"],waitMarkerFileURI:r,gotoLineMode:u.goto,remoteAuthority:s});if(r&&t.length===1&&t[0])return Promise.race([t[0].whenClosedOrLoaded,n.whenDeleted(r.fsPath)]).then(()=>{},()=>{})}async getMainProcessId(){return this.logService.trace("Received request for process ID from other instance."),process.pid}async getMainProcessInfo(){this.logService.trace("Received request for main process info from other instance.");const u=[];return I.BrowserWindow.getAllWindows().forEach(c=>{const a=this.windowsMainService.getWindowById(c.id);a?u.push(this.codeWindowToInfo(a)):u.push(this.browserWindowToInfo(c))}),{mainPID:process.pid,mainArguments:process.argv.slice(1),windows:u,screenReader:!!I.app.accessibilitySupportEnabled,gpuFeatureStatus:I.app.getGPUFeatureStatus()}}async getRemoteDiagnostics(u){const c=this.windowsMainService.getWindows();return(await Promise.all(c.map(t=>new Promise(r=>{const s=t.remoteAuthority;if(s){const o=`vscode:getDiagnosticInfoResponse${t.id}`,h={includeProcesses:u.includeProcesses,folders:u.includeWorkspaceMetadata?this.getFolderURIs(t):void 0};t.sendWhenReady("vscode:getDiagnosticInfo",g.CancellationToken.None,{replyChannel:o,args:h}),I.ipcMain.once(o,(f,d)=>{d||r({hostName:s,errorMessage:`Unable to resolve connection to '${s}'.`}),r(d)}),setTimeout(()=>{r({hostName:s,errorMessage:`Fetching remote diagnostics for '${s}' timed out.`})},5e3)}else r(void 0)})))).filter(t=>!!t)}getFolderURIs(u){const c=[],a=u.openedWorkspace;if(v.isSingleFolderWorkspaceIdentifier(a))c.push(a.uri);else if(v.isWorkspaceIdentifier(a)){const t=this.workspacesManagementMainService.resolveLocalWorkspaceSync(a.configPath);t&&t.folders.forEach(s=>{c.push(s.uri)})}return c}codeWindowToInfo(u){const c=this.getFolderURIs(u),a=D.assertIsDefined(u.win);return this.browserWindowToInfo(a,c,u.remoteAuthority)}browserWindowToInfo(u,c=[],a){return{pid:u.webContents.getOSProcessId(),title:u.getTitle(),folderURIs:c,remoteAuthority:a}}};b=he([ee(0,m.ILogService),ee(1,E.IWindowsMainService),ee(2,L.IURLService),ee(3,w.IWorkspacesManagementMainService),ee(4,p.IConfigurationService)],b),e.LaunchMainService=b}),define(J[230],Z([0,1,143,26,47,14,101,70,24,3,6,83,51,4,61,10,45,55,2]),function(z,e,m,L,A,S,E,n,w,p,i,I,P,y,g,v,D,b,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IssueMainService=e.IIssueMainService=void 0,e.IIssueMainService=y.createDecorator("issueMainService");let u=class Mt{constructor(a,t,r,s,o,h,f,d){this.userEnv=a,this.environmentMainService=t,this.launchMainService=r,this.logService=s,this.diagnosticsService=o,this.dialogMainService=h,this.nativeHostMainService=f,this.protocolMainService=d,this.issueReporterWindow=null,this.issueReporterParentWindow=null,this.processExplorerWindow=null,this.processExplorerParentWindow=null,this.registerListeners()}registerListeners(){S.ipcMain.on("vscode:issueSystemInfoRequest",async a=>{const[t,r]=await Promise.all([this.launchMainService.getMainProcessInfo(),this.launchMainService.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]),s=await this.diagnosticsService.getSystemInfo(t,r);this.safeSend(a,"vscode:issueSystemInfoResponse",s)}),S.ipcMain.on("vscode:listProcesses",async a=>{const t=[];try{const r=await this.launchMainService.getMainProcessId();t.push({name:m.localize(0,null),rootProcess:await I.listProcesses(r)}),(await this.launchMainService.getRemoteDiagnostics({includeProcesses:!0})).forEach(o=>{n.isRemoteDiagnosticError(o)?t.push({name:o.hostName,rootProcess:o}):o.processes&&t.push({name:o.hostName,rootProcess:o.processes})})}catch(r){this.logService.error(`Listing processes failed: ${r}`)}this.safeSend(a,"vscode:listProcessesResponse",t)}),S.ipcMain.on("vscode:issueReporterClipboard",async a=>{const t={message:m.localize(1,null),type:"warning",buttons:[m.localize(2,null),m.localize(3,null)]};if(this.issueReporterWindow){const r=await this.dialogMainService.showMessageBox(t,this.issueReporterWindow);this.safeSend(a,"vscode:issueReporterClipboardResponse",r.response===0)}}),S.ipcMain.on("vscode:issuePerformanceInfoRequest",async a=>{const t=await this.getPerformanceInfo();this.safeSend(a,"vscode:issuePerformanceInfoResponse",t)}),S.ipcMain.on("vscode:issueReporterConfirmClose",async()=>{const a={message:m.localize(4,null),type:"warning",buttons:[m.localize(5,null),m.localize(6,null)]};this.issueReporterWindow&&(await this.dialogMainService.showMessageBox(a,this.issueReporterWindow)).response===0&&this.issueReporterWindow&&(this.issueReporterWindow.destroy(),this.issueReporterWindow=null)}),S.ipcMain.on("vscode:workbenchCommand",(a,t)=>{const{id:r,from:s,args:o}=t;let h;switch(s){case"issueReporter":h=this.issueReporterParentWindow;break;case"processExplorer":h=this.processExplorerParentWindow;break;default:throw new Error(`Unexpected command source: ${s}`)}h&&h.webContents.send("vscode:runAction",{id:r,from:s,args:o})}),S.ipcMain.on("vscode:openExternal",(a,t)=>{this.nativeHostMainService.openExternal(void 0,t)}),S.ipcMain.on("vscode:closeIssueReporter",a=>{this.issueReporterWindow&&this.issueReporterWindow.close()}),S.ipcMain.on("vscode:closeProcessExplorer",a=>{this.processExplorerWindow&&this.processExplorerWindow.close()}),S.ipcMain.on("vscode:windowsInfoRequest",async a=>{const t=await this.launchMainService.getMainProcessInfo();this.safeSend(a,"vscode:windowsInfoResponse",t.windows)})}safeSend(a,t,...r){a.sender.isDestroyed()||a.sender.send(t,...r)}async openReporter(a){var t;if(!this.issueReporterWindow&&(this.issueReporterParentWindow=S.BrowserWindow.getFocusedWindow(),this.issueReporterParentWindow)){const r=new l.DisposableStore,s=r.add(this.protocolMainService.createIPCObjectUrl()),o=this.getWindowPosition(this.issueReporterParentWindow,700,800);this.issueReporterWindow=this.createBrowserWindow(o,s,{backgroundColor:a.styles.backgroundColor,title:m.localize(7,null),zoomLevel:a.zoomLevel,alwaysOnTop:!1}),s.update({appRoot:this.environmentMainService.appRoot,windowId:this.issueReporterWindow.id,userEnv:this.userEnv,data:a,disableExtensions:!!this.environmentMainService.disableExtensions,os:{type:L.type(),arch:L.arch(),release:L.release()},product:A.default}),this.issueReporterWindow.loadURL(v.FileAccess.asBrowserUri("vs/code/electron-sandbox/issue/issueReporter.html",z,!0).toString(!0)),this.issueReporterWindow.on("close",()=>{this.issueReporterWindow=null,r.dispose()}),this.issueReporterParentWindow.on("closed",()=>{this.issueReporterWindow&&(this.issueReporterWindow.close(),this.issueReporterWindow=null,r.dispose())})}(t=this.issueReporterWindow)===null||t===void 0||t.focus()}async openProcessExplorer(a){var t;if(!this.processExplorerWindow&&(this.processExplorerParentWindow=S.BrowserWindow.getFocusedWindow(),this.processExplorerParentWindow)){const r=new l.DisposableStore,s=r.add(this.protocolMainService.createIPCObjectUrl()),o=this.getWindowPosition(this.processExplorerParentWindow,800,500);this.processExplorerWindow=this.createBrowserWindow(o,s,{backgroundColor:a.styles.backgroundColor,title:m.localize(8,null),zoomLevel:a.zoomLevel,alwaysOnTop:!0}),s.update({appRoot:this.environmentMainService.appRoot,windowId:this.processExplorerWindow.id,userEnv:this.userEnv,data:a,product:A.default}),this.processExplorerWindow.loadURL(v.FileAccess.asBrowserUri("vs/code/electron-sandbox/processExplorer/processExplorer.html",z,!0).toString(!0)),this.processExplorerWindow.on("close",()=>{this.processExplorerWindow=null,r.dispose()}),this.processExplorerParentWindow.on("close",()=>{this.processExplorerWindow&&(this.processExplorerWindow.close(),this.processExplorerWindow=null,r.dispose())})}(t=this.processExplorerWindow)===null||t===void 0||t.focus()}createBrowserWindow(a,t,r){const s=new S.BrowserWindow({fullscreen:!1,skipTaskbar:!0,resizable:!0,width:a.width,height:a.height,minWidth:300,minHeight:200,x:a.x,y:a.y,title:r.title,backgroundColor:r.backgroundColor||Mt.DEFAULT_BACKGROUND_COLOR,webPreferences:{preload:v.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",z).fsPath,additionalArguments:[`--vscode-window-config=${t.resource.toString()}`,"--context-isolation"],v8CacheOptions:p.browserCodeLoadingCacheStrategy,enableWebSQL:!1,spellcheck:!1,nativeWindowOpen:!0,zoomFactor:g.zoomLevelToZoomFactor(r.zoomLevel),sandbox:!0,contextIsolation:!0},alwaysOnTop:r.alwaysOnTop});return s.setMenuBarVisibility(!1),s}async getSystemStatus(){const[a,t]=await Promise.all([this.launchMainService.getMainProcessInfo(),this.launchMainService.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return this.diagnosticsService.getDiagnostics(a,t)}getWindowPosition(a,t,r){let s;const o=S.screen.getAllDisplays();if(o.length===1)s=o[0];else{if(p.isMacintosh){const d=S.screen.getCursorScreenPoint();s=S.screen.getDisplayNearestPoint(d)}!s&&a&&(s=S.screen.getDisplayMatching(a.getBounds())),s||(s=S.screen.getPrimaryDisplay()||o[0])}const h={width:t,height:r},f=s.bounds;return h.x=f.x+f.width/2-h.width/2,h.y=f.y+f.height/2-h.height/2,f.width>0&&f.height>0&&(h.x<f.x&&(h.x=f.x),h.y<f.y&&(h.y=f.y),h.x>f.x+f.width&&(h.x=f.x),h.y>f.y+f.height&&(h.y=f.y),h.width>f.width&&(h.width=f.width),h.height>f.height&&(h.height=f.height)),h}async getPerformanceInfo(){try{const[a,t]=await Promise.all([this.launchMainService.getMainProcessInfo(),this.launchMainService.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0})]);return await this.diagnosticsService.getPerformanceInfo(a,t)}catch(a){throw this.logService.warn("issueService#getPerformanceInfo ",a.message),a}}};u.DEFAULT_BACKGROUND_COLOR="#1E1E1E",u=he([ee(1,w.IEnvironmentMainService),ee(2,E.ILaunchMainService),ee(3,i.ILogService),ee(4,n.IDiagnosticsService),ee(5,P.IDialogMainService),ee(6,D.INativeHostMainService),ee(7,b.IProtocolMainService)],u),e.IssueMainService=u}),define(J[231],Z([0,1,8,149,72,5,7,14,24,6,16,22,61,2,3,34,28,52,50,198,60,31,51,39,202,18,99,21,10,54,25,55]),function(z,e,m,L,A,S,E,n,w,p,i,I,P,y,g,v,D,b,l,u,c,a,t,r,s,o,h,f,d,M,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeWindow=void 0;var V;(function(te){te[te.NONE=0]="NONE",te[te.LOADING=1]="LOADING",te[te.NAVIGATING=2]="NAVIGATING",te[te.READY=3]="READY"})(V||(V={}));let Q=class extends y.Disposable{constructor(B,Y,X,_,$,G,N,F,R,O,k,W,U,q){super();this.logService=Y,this.environmentMainService=X,this.fileService=_,this.configurationService=G,this.themeMainService=N,this.workspacesManagementMainService=F,this.backupMainService=R,this.telemetryService=O,this.dialogMainService=k,this.lifecycleMainService=W,this.productService=U,this.protocolMainService=q,this._onWillLoad=this._register(new S.Emitter),this.onWillLoad=this._onWillLoad.event,this._onDidSignalReady=this._register(new S.Emitter),this.onDidSignalReady=this._onDidSignalReady.event,this._onDidClose=this._register(new S.Emitter),this.onDidClose=this._onDidClose.event,this._onDidDestroy=this._register(new S.Emitter),this.onDidDestroy=this._onDidDestroy.event,this.whenReadyCallbacks=[],this.touchBarGroups=[],this.currentHttpProxy=void 0,this.currentNoProxy=void 0,this._lastFocusTime=-1,this.configObjectUrl=this._register(this.protocolMainService.createIPCObjectUrl()),this.readyState=0;{const[K,H]=this.restoreWindowState(B.state);this.windowState=K,this.logService.trace("window#ctor: using window state",K);const x=this.windowState.mode===0||this.windowState.mode===3,ne=this.configurationService.getValue("window"),re={width:this.windowState.width,height:this.windowState.height,x:this.windowState.x,y:this.windowState.y,backgroundColor:this.themeMainService.getBackgroundColor(),minWidth:P.WindowMinimumSize.WIDTH,minHeight:P.WindowMinimumSize.HEIGHT,show:!x,title:this.productService.nameLong,webPreferences:Object.assign({preload:d.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",z).fsPath,additionalArguments:this.environmentMainService.sandbox?[`--vscode-window-config=${this.configObjectUrl.resource.toString()}`,"--context-isolation"]:[`--vscode-window-config=${this.configObjectUrl.resource.toString()}`],v8CacheOptions:g.browserCodeLoadingCacheStrategy,enableWebSQL:!1,spellcheck:!1,nativeWindowOpen:!0,webviewTag:!0,zoomFactor:P.zoomLevelToZoomFactor(ne==null?void 0:ne.zoomLevel)},this.environmentMainService.sandbox?{sandbox:!0}:{nodeIntegration:!0,contextIsolation:!1})};g.browserCodeLoadingCacheStrategy?this.logService.info(`window: using vscode-file:// protocol and V8 cache options: ${g.browserCodeLoadingCacheStrategy}`):this.logService.info("window: vscode-file:// protocol is explicitly disabled"),g.isLinux?re.icon=m.join(this.environmentMainService.appRoot,"resources/linux/code.png"):g.isWindows&&!this.environmentMainService.isBuilt&&(re.icon=m.join(this.environmentMainService.appRoot,"resources/win32/code_150x150.png")),g.isMacintosh&&!this.useNativeFullScreen()&&(re.fullscreenable=!1),g.isMacintosh&&(re.acceptFirstMouse=!0,(ne==null?void 0:ne.clickThroughInactive)===!1&&(re.acceptFirstMouse=!1));const se=g.isMacintosh&&(ne==null?void 0:ne.nativeTabs)===!0;se&&(re.tabbingIdentifier=this.productService.nameShort);const le=P.getTitleBarStyle(this.configurationService)==="custom";if(le&&(re.titleBarStyle="hidden",this.hiddenTitleBarStyle=!0,g.isMacintosh||(re.frame=!1)),A.mark("code/willCreateCodeBrowserWindow"),this._win=new n.BrowserWindow(re),A.mark("code/didCreateCodeBrowserWindow"),this._id=this._win.id,this.environmentMainService.args["open-devtools"]===!0&&this._win.webContents.openDevTools(),g.isMacintosh&&le&&this._win.setSheetOffset(22),g.isMacintosh&&H&&(!se||n.BrowserWindow.getAllWindows().length===1)&&[this.windowState.width,this.windowState.height,this.windowState.x,this.windowState.y].every(oe=>typeof oe=="number")){const oe=this.windowState;this._win.setBounds({width:oe.width,height:oe.height,x:oe.x,y:oe.y})}x&&(A.mark("code/willMaximizeCodeWindow"),this._win.maximize(),this.windowState.mode===3&&this.setFullScreen(!0),this._win.isVisible()||this._win.show(),A.mark("code/didMaximizeCodeWindow")),this._lastFocusTime=Date.now()}this.onConfigurationUpdated(),this.createTouchBar(),this.marketplaceHeadersPromise=u.resolveMarketplaceHeaders(this.productService.version,this.environmentMainService,this.fileService,{get:K=>$.globalStorage.get(K),store:(K,H)=>$.globalStorage.set(K,H)}),this.registerListeners()}get id(){return this._id}get win(){return this._win}get lastFocusTime(){return this._lastFocusTime}get backupPath(){var B;return(B=this.currentConfig)===null||B===void 0?void 0:B.backupPath}get openedWorkspace(){var B;return(B=this.currentConfig)===null||B===void 0?void 0:B.workspace}get remoteAuthority(){var B;return(B=this.currentConfig)===null||B===void 0?void 0:B.remoteAuthority}get config(){return this.currentConfig}get hasHiddenTitleBarStyle(){return!!this.hiddenTitleBarStyle}get isExtensionDevelopmentHost(){var B;return!!((B=this.currentConfig)===null||B===void 0?void 0:B.extensionDevelopmentPath)}get isExtensionTestHost(){var B;return!!((B=this.currentConfig)===null||B===void 0?void 0:B.extensionTestsPath)}get isExtensionDevelopmentTestFromCli(){var B;return this.isExtensionDevelopmentHost&&this.isExtensionTestHost&&!((B=this.currentConfig)===null||B===void 0?void 0:B.debugId)}setRepresentedFilename(B){g.isMacintosh?this._win.setRepresentedFilename(B):this.representedFilename=B}getRepresentedFilename(){return g.isMacintosh?this._win.getRepresentedFilename():this.representedFilename}setDocumentEdited(B){g.isMacintosh&&this._win.setDocumentEdited(B),this.documentEdited=B}isDocumentEdited(){return g.isMacintosh?this._win.isDocumentEdited():!!this.documentEdited}focus(B){g.isMacintosh&&(B==null?void 0:B.force)&&n.app.focus({steal:!0}),!!this._win&&(this._win.isMinimized()&&this._win.restore(),this._win.focus())}setReady(){for(this.readyState=3;this.whenReadyCallbacks.length;)this.whenReadyCallbacks.pop()(this);this._onDidSignalReady.fire()}ready(){return new Promise(B=>{if(this.isReady)return B(this);this.whenReadyCallbacks.push(B)})}get isReady(){return this.readyState===3}get whenClosedOrLoaded(){return new Promise(B=>{function Y(){X.dispose(),_.dispose(),B()}const X=this.onDidClose(()=>Y()),_=this.onWillLoad(()=>Y())})}registerListeners(){this._win.on("unresponsive",()=>this.onWindowError(1)),this._win.webContents.on("render-process-gone",($,G)=>this.onWindowError(2,G)),this._win.webContents.on("did-fail-load",($,G,N)=>this.onWindowError(3,{reason:N,exitCode:G})),this._win.webContents.on("will-prevent-unload",$=>{$.preventDefault()}),this._win.on("closed",()=>{this._onDidClose.fire(),this.dispose()});const B=new Set([d.Schemas.file,d.Schemas.vscodeFileResource,d.Schemas.vscodeRemoteResource,"devtools"]),Y=$=>{for(let G=$;G;G=G.parent)if(G.url.startsWith(`${d.Schemas.vscodeWebview}://`))return!0;return!1},X=$=>$.resourceType==="xhr"||Y($.frame);this._win.webContents.session.webRequest.onBeforeRequest(($,G)=>{const N=E.URI.parse($.url);return N.path.endsWith(".svg")&&!(B.has(N.scheme)||N.path.includes(d.Schemas.vscodeRemoteResource))?G({cancel:!X($)}):G({cancel:!1})}),this._win.webContents.session.webRequest.onHeadersReceived(($,G)=>{const N=$.responseHeaders,F=N["content-type"]||N["Content-Type"];if(F&&Array.isArray(F)){const R=E.URI.parse($.url);if(R.path.endsWith(".svg")&&B.has(R.scheme))return N["Content-Type"]=["image/svg+xml"],G({cancel:!1,responseHeaders:N});if(!R.path.includes(d.Schemas.vscodeRemoteResource)&&F.some(O=>O.toLowerCase().includes("image/svg")))return G({cancel:!X($)})}return G({cancel:!1})}),this._win.webContents.on("did-finish-load",()=>{this.readyState=1,this.pendingLoadConfig&&(this.currentConfig=this.pendingLoadConfig,this.pendingLoadConfig=void 0)}),this._win.on("focus",()=>{this._lastFocusTime=Date.now()}),this._win.on("maximize",$=>{this.currentConfig&&(this.currentConfig.maximized=!0),n.app.emit("browser-window-maximize",$,this._win)}),this._win.on("unmaximize",$=>{this.currentConfig&&(this.currentConfig.maximized=!1),n.app.emit("browser-window-unmaximize",$,this._win)}),this._win.on("enter-full-screen",()=>{this.sendWhenReady("vscode:enterFullScreen",T.CancellationToken.None)}),this._win.on("leave-full-screen",()=>{this.sendWhenReady("vscode:leaveFullScreen",T.CancellationToken.None)}),this._register(this.configurationService.onDidChangeConfiguration(()=>this.onConfigurationUpdated())),this._register(this.workspacesManagementMainService.onDidDeleteUntitledWorkspace($=>this.onDidDeleteUntitledWorkspace($)));const _=["https://marketplace.visualstudio.com/*","https://*.vsassets.io/*"];this._win.webContents.session.webRequest.onBeforeSendHeaders({urls:_},async($,G)=>{const N=await this.marketplaceHeadersPromise;G({cancel:!1,requestHeaders:Object.assign($.requestHeaders,N)})})}async onWindowError(B,Y){var X;switch(B){case 2:this.logService.error(`CodeWindow: renderer process crashed (reason: ${(Y==null?void 0:Y.reason)||"<unknown>"}, code: ${(Y==null?void 0:Y.exitCode)||"<unknown>"})`);break;case 1:this.logService.error("CodeWindow: detected unresponsive");break;case 3:this.logService.error(`CodeWindow: failed to load workbench window (reason: ${(Y==null?void 0:Y.reason)||"<unknown>"}, code: ${(Y==null?void 0:Y.exitCode)||"<unknown>"})`);break}if(this.isExtensionDevelopmentTestFromCli){this.lifecycleMainService.kill(1);return}if(this.telemetryService.publicLog2("windowerror",{type:B,reason:Y==null?void 0:Y.reason,code:Y==null?void 0:Y.exitCode}),B===1){if(this.isExtensionDevelopmentHost||this.isExtensionTestHost||this._win&&this._win.webContents&&this._win.webContents.isDevToolsOpened())return;const _=await this.dialogMainService.showMessageBox({title:this.productService.nameLong,type:"warning",buttons:[r.mnemonicButtonLabel(L.localize(0,null)),r.mnemonicButtonLabel(L.localize(1,null)),r.mnemonicButtonLabel(L.localize(2,null))],message:L.localize(3,null),detail:L.localize(4,null),noLink:!0},this._win);if(!this._win)return;_.response===0?(this._win.webContents.forcefullyCrashRenderer(),this.reload()):_.response===2&&this.destroyWindow()}else if(B===2){let _;Y?_=L.localize(6,null,Y.reason,(X=Y.exitCode)!==null&&X!==void 0?X:"<unknown>"):_=L.localize(5,null);const $=await this.dialogMainService.showMessageBox({title:this.productService.nameLong,type:"warning",buttons:[r.mnemonicButtonLabel(L.localize(7,null)),r.mnemonicButtonLabel(L.localize(8,null))],message:_,detail:L.localize(9,null),noLink:!0},this._win);if(!this._win)return;$.response===0?this.reload():$.response===1&&this.destroyWindow()}}destroyWindow(){this._onDidDestroy.fire(),this._win.destroy()}onDidDeleteUntitledWorkspace(B){var Y;((Y=this.openedWorkspace)===null||Y===void 0?void 0:Y.id)===B.id&&this.currentConfig&&(this.currentConfig.workspace=void 0)}onConfigurationUpdated(){const B=this.getMenuBarVisibility();B!==this.currentMenuBarVisibility&&(this.currentMenuBarVisibility=B,this.setMenuBarVisibility(B));let Y=(this.configurationService.getValue("http.proxy")||"").trim()||(process.env.https_proxy||process.env.HTTPS_PROXY||process.env.http_proxy||process.env.HTTP_PROXY||"").trim()||void 0;(Y==null?void 0:Y.endsWith("/"))&&(Y=Y.substr(0,Y.length-1));const X=(process.env.no_proxy||process.env.NO_PROXY||"").trim()||void 0;if((Y||"").indexOf("@")===-1&&(Y!==this.currentHttpProxy||X!==this.currentNoProxy)){this.currentHttpProxy=Y,this.currentNoProxy=X;const _=Y||"",$=X?`${X},<local>`:"<local>";this.logService.trace(`Setting proxy to '${_}', bypassing '${$}'`),this._win.webContents.session.setProxy({proxyRules:_,proxyBypassRules:$,pacScript:""})}}addTabbedWindow(B){g.isMacintosh&&B.win&&this._win.addTabbedWindow(B.win)}load(B,Y=Object.create(null)){this.isDocumentEdited()&&(!Y.isReload||!this.backupMainService.isHotExitEnabled())&&this.setDocumentEdited(!1),Y.isReload||(this.getRepresentedFilename()&&this.setRepresentedFilename(""),this._win.setTitle(this.productService.nameLong)),this.updateConfiguration(B,Y),this.readyState===0?this.currentConfig=B:(this.pendingLoadConfig=B,this.readyState=2),this._win.loadURL(d.FileAccess.asBrowserUri(this.environmentMainService.sandbox?"vs/code/electron-sandbox/workbench/workbench.html":"vs/code/electron-browser/workbench/workbench.html",z).toString(!0)),!this.environmentMainService.isBuilt&&!this.environmentMainService.extensionTestsLocationURI&&(this.showTimeoutHandle=setTimeout(()=>{this._win&&!this._win.isVisible()&&!this._win.isMinimized()&&(this._win.show(),this.focus({force:!0}),this._win.webContents.openDevTools())},1e4)),this._onWillLoad.fire({workspace:B.workspace})}updateConfiguration(B,Y){var X,_;const $=(_=(X=this.currentConfig)!==null&&X!==void 0?X:this.pendingLoadConfig)===null||_===void 0?void 0:_.userEnv;$&&M.isLaunchedFromCli($)&&!M.isLaunchedFromCli(B.userEnv)&&(B.userEnv=Object.assign(Object.assign({},$),B.userEnv)),process.env.CHROME_CRASHPAD_PIPE_NAME&&Object.assign(B.userEnv,{CHROME_CRASHPAD_PIPE_NAME:process.env.CHROME_CRASHPAD_PIPE_NAME}),Y.disableExtensions!==void 0&&(B["disable-extensions"]=Y.disableExtensions),B.fullscreen=this.isFullScreen,B.maximized=this._win.isMaximized(),B.partsSplash=this.themeMainService.getWindowSplash(),A.mark("code/willOpenNewWindow"),B.perfMarks=A.getMarks(),this.configObjectUrl.update(B)}async reload(B){const Y=Object.assign({},this.currentConfig);Y.workspace=await this.validateWorkspace(Y),delete Y.filesToOpenOrCreate,delete Y.filesToDiff,delete Y.filesToWait,this.isExtensionDevelopmentHost&&B&&(Y.verbose=B.verbose,Y.debugId=B.debugId,Y["inspect-extensions"]=B["inspect-extensions"],Y["inspect-brk-extensions"]=B["inspect-brk-extensions"],Y["extensions-dir"]=B["extensions-dir"]),Y.isInitialStartup=!1,this.load(Y,{isReload:!0,disableExtensions:B==null?void 0:B["disable-extensions"]})}async validateWorkspace(B){if(D.isWorkspaceIdentifier(B.workspace)){const Y=B.workspace.configPath;if(Y.scheme===d.Schemas.file&&!await this.fileService.exists(Y))return}else if(D.isSingleFolderWorkspaceIdentifier(B.workspace)){const Y=B.workspace.uri;if(Y.scheme===d.Schemas.file&&!await this.fileService.exists(Y))return}return B.workspace}serializeWindowState(){if(!this._win)return v.defaultWindowState();if(this.isFullScreen){let X;try{X=n.screen.getDisplayMatching(this.getBounds())}catch(G){}const _=v.defaultWindowState();return{mode:3,display:X?X.id:void 0,width:this.windowState.width||_.width,height:this.windowState.height||_.height,x:this.windowState.x||0,y:this.windowState.y||0}}const B=Object.create(null);let Y;if(!g.isMacintosh&&this._win.isMaximized()?Y=0:Y=1,Y===0?B.mode=0:B.mode=1,Y===1||Y===0){let X;Y===1?X=this.getBounds():X=this._win.getNormalBounds(),B.x=X.x,B.y=X.y,B.width=X.width,B.height=X.height}return B}restoreWindowState(B){A.mark("code/willRestoreCodeWindowState");let Y=!1;if(B)try{const X=n.screen.getAllDisplays();Y=X.length>1,B=this.validateWindowState(B,X)}catch(X){this.logService.warn(`Unexpected error validating window state: ${X}
${X.stack}`)}return A.mark("code/didRestoreCodeWindowState"),[B||v.defaultWindowState(),Y]}validateWindowState(B,Y){var X,_;if(this.logService.trace(`window#validateWindowState: validating window state on ${Y.length} display(s)`,B),typeof B.x!="number"||typeof B.y!="number"||typeof B.width!="number"||typeof B.height!="number"){this.logService.trace("window#validateWindowState: unexpected type of state values");return}if(B.width<=0||B.height<=0){this.logService.trace("window#validateWindowState: unexpected negative values");return}if(Y.length===1){const N=this.getWorkingArea(Y[0]);if(N){let F=function(){!B||typeof B.x!="number"||typeof B.y!="number"||!N||(B.x<N.x&&(B.x=N.x),B.y<N.y&&(B.y=N.y))};this.logService.trace("window#validateWindowState: 1 monitor working area",N),F(),B.width>N.width&&(B.width=N.width),B.height>N.height&&(B.height=N.height),B.x>N.x+N.width-128&&(B.x=N.x+N.width-B.width),B.y>N.y+N.height-128&&(B.y=N.y+N.height-B.height),F()}return B}if(B.display&&B.mode===3){const N=Y.find(F=>F.id===B.display);if(N&&typeof((X=N.bounds)===null||X===void 0?void 0:X.x)=="number"&&typeof((_=N.bounds)===null||_===void 0?void 0:_.y)=="number"){this.logService.trace("window#validateWindowState: restoring fullscreen to previous display");const F=v.defaultWindowState(3);return F.x=N.bounds.x,F.y=N.bounds.y,F}}let $,G;try{$=n.screen.getDisplayMatching({x:B.x,y:B.y,width:B.width,height:B.height}),G=this.getWorkingArea($)}catch(N){}if($&&G&&B.x+B.width>G.x&&B.y+B.height>G.y&&B.x<G.x+G.width&&B.y<G.y+G.height)return this.logService.trace("window#validateWindowState: multi-monitor working area",G),B}getWorkingArea(B){if(B.workArea.width>0&&B.workArea.height>0)return B.workArea;if(B.bounds.width>0&&B.bounds.height>0)return B.bounds}getBounds(){const[B,Y]=this._win.getPosition(),[X,_]=this._win.getSize();return{x:B,y:Y,width:X,height:_}}toggleFullScreen(){this.setFullScreen(!this.isFullScreen)}setFullScreen(B){this.useNativeFullScreen()?this.setNativeFullScreen(B):this.setSimpleFullScreen(B),this.sendWhenReady(B?"vscode:enterFullScreen":"vscode:leaveFullScreen",T.CancellationToken.None),this.currentMenuBarVisibility&&this.setMenuBarVisibility(this.currentMenuBarVisibility,!1)}get isFullScreen(){return this._win.isFullScreen()||this._win.isSimpleFullScreen()}setNativeFullScreen(B){this._win.isSimpleFullScreen()&&this._win.setSimpleFullScreen(!1),this._win.setFullScreen(B)}setSimpleFullScreen(B){this._win.isFullScreen()&&this._win.setFullScreen(!1),this._win.setSimpleFullScreen(B),this._win.webContents.focus()}useNativeFullScreen(){const B=this.configurationService.getValue("window");return!B||typeof B.nativeFullScreen!="boolean"||B.nativeTabs?!0:B.nativeFullScreen!==!1}isMinimized(){return this._win.isMinimized()}getMenuBarVisibility(){let B=P.getMenuBarVisibility(this.configurationService);return["visible","toggle","hidden"].indexOf(B)<0&&(B="classic"),B}setMenuBarVisibility(B,Y=!0){g.isMacintosh||(B==="toggle"&&Y&&this.send("vscode:showInfoMessage",L.localize(10,null)),B==="hidden"?setTimeout(()=>{this.doSetMenuBarVisibility(B)}):this.doSetMenuBarVisibility(B))}doSetMenuBarVisibility(B){const Y=this.isFullScreen;switch(B){case"classic":this._win.setMenuBarVisibility(!Y),this._win.autoHideMenuBar=Y;break;case"visible":this._win.setMenuBarVisibility(!0),this._win.autoHideMenuBar=!1;break;case"toggle":this._win.setMenuBarVisibility(!1),this._win.autoHideMenuBar=!0;break;case"hidden":this._win.setMenuBarVisibility(!1),this._win.autoHideMenuBar=!1;break}}handleTitleDoubleClick(){if(g.isMacintosh)switch(n.systemPreferences.getUserDefault("AppleActionOnDoubleClick","string")){case"Minimize":this._win.minimize();break;case"None":break;case"Maximize":default:this._win.isMaximized()?this._win.unmaximize():this._win.maximize()}else this._win.isMaximized()?this._win.unmaximize():this._win.maximize()}close(){this._win&&this._win.close()}sendWhenReady(B,Y,...X){this.isReady?this.send(B,...X):this.ready().then(()=>{Y.isCancellationRequested||this.send(B,...X)})}send(B,...Y){if(this._win){if(this._win.isDestroyed()||this._win.webContents.isDestroyed()){this.logService.warn(`Sending IPC message to channel ${B} for window that is destroyed`);return}this._win.webContents.send(B,...Y)}}updateTouchBar(B){!g.isMacintosh||this.touchBarGroups.forEach((Y,X)=>{const _=B[X];Y.segments=this.createTouchBarGroupSegments(_)})}createTouchBar(){if(!!g.isMacintosh){for(let B=0;B<10;B++){const Y=this.createTouchBarGroup();this.touchBarGroups.push(Y)}this._win.setTouchBar(new n.TouchBar({items:this.touchBarGroups}))}}createTouchBarGroup(B=[]){const Y=this.createTouchBarGroupSegments(B),X=new n.TouchBar.TouchBarSegmentedControl({segments:Y,mode:"buttons",segmentStyle:"automatic",change:_=>{this.sendWhenReady("vscode:runAction",T.CancellationToken.None,{id:X.segments[_].id,from:"touchbar"})}});return X}createTouchBarGroupSegments(B=[]){return B.map(X=>{var _,$;let G;X.icon&&!s.ThemeIcon.isThemeIcon(X.icon)&&(($=(_=X.icon)===null||_===void 0?void 0:_.dark)===null||$===void 0?void 0:$.scheme)===d.Schemas.file&&(G=n.nativeImage.createFromPath(E.URI.revive(X.icon.dark).fsPath),G.isEmpty()&&(G=void 0));let N;return typeof X.title=="string"?N=X.title:N=X.title.value,{id:X.id,label:G?void 0:N,icon:G}})}dispose(){super.dispose(),this.showTimeoutHandle&&clearTimeout(this.showTimeoutHandle),this._win=null}};Q=he([ee(1,p.ILogService),ee(2,w.IEnvironmentMainService),ee(3,f.IFileService),ee(4,h.IStorageMainService),ee(5,i.IConfigurationService),ee(6,c.IThemeMainService),ee(7,b.IWorkspacesManagementMainService),ee(8,l.IBackupMainService),ee(9,a.ITelemetryService),ee(10,t.IDialogMainService),ee(11,o.ILifecycleMainService),ee(12,I.IProductService),ee(13,C.IProtocolMainService)],Q),e.CodeWindow=Q}),define(J[62],Z([0,1,152,35,38,14,6,39,5,3,28,52,9,15,7,10,17,18,4,2]),function(z,e,m,L,A,S,E,n,w,p,i,I,P,y,g,v,D,b,l,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesHistoryMainService=e.IWorkspacesHistoryMainService=void 0,e.IWorkspacesHistoryMainService=l.createDecorator("workspacesHistoryMainService");let c=class Ke extends u.Disposable{constructor(f,d,M,T){super();this.stateMainService=f,this.logService=d,this.workspacesManagementMainService=M,this.lifecycleMainService=T,this._onDidChangeRecentlyOpened=this._register(new w.Emitter),this.onDidChangeRecentlyOpened=this._onDidChangeRecentlyOpened.event,this.macOSRecentDocumentsUpdater=this._register(new P.ThrottledDelayer(800)),this.registerListeners()}registerListeners(){this.lifecycleMainService.when(3).then(()=>this.handleWindowsJumpList()),this._register(this.workspacesManagementMainService.onDidEnterWorkspace(f=>this.addRecentlyOpened([{workspace:f.workspace}])))}handleWindowsJumpList(){!p.isWindows||(this.updateWindowsJumpList(),this._register(this.onDidChangeRecentlyOpened(()=>this.updateWindowsJumpList())))}addRecentlyOpened(f){const d=[],M=[];for(let T of f)if(i.isRecentWorkspace(T))!this.workspacesManagementMainService.isUntitledWorkspace(T.workspace)&&r(d,T.workspace)===-1&&d.push(T);else if(i.isRecentFolder(T))s(d,T.folderUri)===-1&&d.push(T);else{const C=o(M,T.fileUri)>=0,V=T.fileUri.scheme===v.Schemas.file&&Ke.COMMON_FILES_FILTER.indexOf(y.basename(T.fileUri))>=0;!C&&!V&&(M.push(T),p.isWindows&&T.fileUri.scheme===v.Schemas.file&&S.app.addRecentDocument(T.fileUri.fsPath))}this.addEntriesFromStorage(d,M),d.length>Ke.MAX_TOTAL_RECENT_ENTRIES&&(d.length=Ke.MAX_TOTAL_RECENT_ENTRIES),M.length>Ke.MAX_TOTAL_RECENT_ENTRIES&&(M.length=Ke.MAX_TOTAL_RECENT_ENTRIES),this.saveRecentlyOpened({workspaces:d,files:M}),this._onDidChangeRecentlyOpened.fire(),p.isMacintosh&&this.macOSRecentDocumentsUpdater.trigger(()=>this.updateMacOSRecentDocuments())}removeRecentlyOpened(f){const d=V=>{const Q=t(V);for(const te of f)if(y.extUriBiasedIgnorePathCase.isEqual(te,Q))return!1;return!0},M=this.getRecentlyOpened(),T=M.workspaces.filter(d),C=M.files.filter(d);(T.length!==M.workspaces.length||C.length!==M.files.length)&&(this.saveRecentlyOpened({files:C,workspaces:T}),this._onDidChangeRecentlyOpened.fire(),p.isMacintosh&&this.macOSRecentDocumentsUpdater.trigger(()=>this.updateMacOSRecentDocuments()))}async updateMacOSRecentDocuments(){if(!p.isMacintosh)return;S.app.clearRecentDocuments();const f=this.getRecentlyOpened(),d=[];let M=0;for(let C=0;C<f.workspaces.length&&M<Ke.MAX_MACOS_DOCK_RECENT_WORKSPACES;C++){const V=t(f.workspaces[C]);if(V.scheme===v.Schemas.file){const Q=y.originalFSPath(V);await D.Promises.exists(Q)&&(d.push(Q),M++)}}const T=[];for(let C=0;C<f.files.length&&M<Ke.MAX_MACOS_DOCK_RECENT_ENTRIES_TOTAL;C++){const V=t(f.files[C]);if(V.scheme===v.Schemas.file){const Q=y.originalFSPath(V);if(Ke.COMMON_FILES_FILTER.includes(y.basename(V))||d.includes(Q))continue;await D.Promises.exists(Q)&&(T.push(Q),M++)}}T.reverse().forEach(C=>S.app.addRecentDocument(C)),d.reverse().forEach(C=>S.app.addRecentDocument(C))}clearRecentlyOpened(){this.saveRecentlyOpened({workspaces:[],files:[]}),S.app.clearRecentDocuments(),this._onDidChangeRecentlyOpened.fire()}getRecentlyOpened(f){var d,M;const T=[],C=[],V=(d=f==null?void 0:f.config)===null||d===void 0?void 0:d.workspace;i.isWorkspaceIdentifier(V)&&!this.workspacesManagementMainService.isUntitledWorkspace(V)?T.push({workspace:V}):i.isSingleFolderWorkspaceIdentifier(V)&&T.push({folderUri:V.uri});const Q=(M=f==null?void 0:f.config)===null||M===void 0?void 0:M.filesToOpenOrCreate;if(Q)for(let te of Q){const B=te.fileUri;B&&o(C,B)===-1&&C.push({fileUri:B})}return this.addEntriesFromStorage(T,C),{workspaces:T,files:C}}addEntriesFromStorage(f,d){let M=this.getRecentlyOpenedFromStorage();for(let T of M.workspaces){let C=i.isRecentFolder(T)?s(f,T.folderUri):r(f,T.workspace);C>=0?f[C].label=f[C].label||T.label:f.push(T)}for(let T of M.files){let C=o(d,T.fileUri);C>=0?d[C].label=d[C].label||T.label:d.push(T)}}getRecentlyOpenedFromStorage(){const f=this.stateMainService.getItem(Ke.recentlyOpenedStorageKey);return i.restoreRecentlyOpened(f,this.logService)}saveRecentlyOpened(f){const d=i.toStoreData(f);this.stateMainService.setItem(Ke.recentlyOpenedStorageKey,d)}updateWindowsJumpList(){if(!p.isWindows)return;const f=[];if(f.push({type:"tasks",items:[{type:"task",title:m.localize(0,null),description:m.localize(1,null),program:process.execPath,args:"-n",iconPath:process.execPath,iconIndex:0}]}),this.getRecentlyOpened().workspaces.length>0){let d=[];for(let C of S.app.getJumpListSettings().removedItems){const V=C.args;if(V){const Q=/^--(folder|file)-uri\s+"([^"]+)"$/.exec(V);Q&&d.push(g.URI.parse(Q[2]))}}this.removeRecentlyOpened(d);let M=!1;const T=L.coalesce(this.getRecentlyOpened().workspaces.slice(0,7).map(C=>{const V=i.isRecentWorkspace(C)?C.workspace:C.folderUri,{title:Q,description:te}=this.getWindowsJumpListLabel(V,C.label);let B;return g.URI.isUri(V)?B=`--folder-uri "${V.toString()}"`:(M=!0,B=`--file-uri "${V.configPath.toString()}"`),{type:"task",title:Q.substr(0,255),description:te.substr(0,255),program:process.execPath,args:B,iconPath:"explorer.exe",iconIndex:0}}));T.length>0&&f.push({type:"custom",name:M?m.localize(2,null):m.localize(3,null),items:T})}f.push({type:"recent"});try{S.app.setJumpList(f)}catch(d){this.logService.warn("updateWindowsJumpList#setJumpList",d)}}getWindowsJumpListLabel(f,d){if(d)return{title:n.splitName(d).name,description:d};if(g.URI.isUri(f))return{title:y.basename(f),description:a(f)};if(this.workspacesManagementMainService.isUntitledWorkspace(f))return{title:m.localize(4,null),description:""};let M=y.basename(f.configPath);return M.endsWith(i.WORKSPACE_EXTENSION)&&(M=M.substr(0,M.length-i.WORKSPACE_EXTENSION.length-1)),{title:m.localize(5,null,M),description:a(f.configPath)}}};c.MAX_TOTAL_RECENT_ENTRIES=100,c.MAX_MACOS_DOCK_RECENT_WORKSPACES=7,c.MAX_MACOS_DOCK_RECENT_ENTRIES_TOTAL=10,c.COMMON_FILES_FILTER=["COMMIT_EDITMSG","MERGE_MSG"],c.recentlyOpenedStorageKey="openedPathsList",c=he([ee(0,A.IStateMainService),ee(1,E.ILogService),ee(2,I.IWorkspacesManagementMainService),ee(3,b.ILifecycleMainService)],c),e.WorkspacesHistoryMainService=c;function a(h){return h.scheme==="file"?n.normalizeDriveLetter(h.fsPath):h.toString()}function t(h){return i.isRecentFolder(h)?h.folderUri:i.isRecentFile(h)?h.fileUri:h.workspace.configPath}function r(h,f){return h.findIndex(d=>i.isRecentWorkspace(d)&&d.workspace.id===f.id)}function s(h,f){return h.findIndex(d=>i.isRecentFolder(d)&&y.extUriBiasedIgnorePathCase.isEqual(d.folderUri,f))}function o(h,f){return h.findIndex(d=>y.extUriBiasedIgnorePathCase.isEqual(d.fileUri,f))}}),define(J[232],Z([0,1,144,3,24,14,61,16,31,41,22,9,6,39,34,62,180,7,38,18,45,25]),function(z,e,m,L,A,S,E,n,w,p,i,I,P,y,g,v,D,b,l,u,c,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Menubar=void 0;const t="menu";let r=class pt{constructor(h,f,d,M,T,C,V,Q,te,B,Y){this.updateService=h,this.configurationService=f,this.windowsMainService=d,this.environmentMainService=M,this.telemetryService=T,this.workspacesHistoryMainService=C,this.stateMainService=V,this.lifecycleMainService=Q,this.logService=te,this.nativeHostMainService=B,this.productService=Y,this.fallbackMenuHandlers=Object.create(null),this.menuUpdater=new I.RunOnceScheduler(()=>this.doUpdateMenu(),0),this.menuGC=new I.RunOnceScheduler(()=>{this.oldMenus=[]},1e4),this.menubarMenus=Object.create(null),this.keybindings=Object.create(null),(L.isMacintosh||E.getTitleBarStyle(this.configurationService)==="native")&&this.restoreCachedMenubarData(),this.addFallbackHandlers(),this.closedLastWindow=!1,this.noActiveWindow=!1,this.oldMenus=[],this.install(),this.registerListeners()}restoreCachedMenubarData(){const h=this.stateMainService.getItem(pt.lastKnownMenubarStorageKey);h&&(h.menus&&(this.menubarMenus=h.menus),h.keybindings&&(this.keybindings=h.keybindings))}addFallbackHandlers(){this.fallbackMenuHandlers["workbench.action.files.newUntitledFile"]=(C,V,Q)=>this.windowsMainService.openEmptyWindow({context:2,contextWindowId:V==null?void 0:V.id}),this.fallbackMenuHandlers["workbench.action.newWindow"]=(C,V,Q)=>this.windowsMainService.openEmptyWindow({context:2,contextWindowId:V==null?void 0:V.id}),this.fallbackMenuHandlers["workbench.action.files.openFileFolder"]=(C,V,Q)=>this.nativeHostMainService.pickFileFolderAndOpen(void 0,{forceNewWindow:this.isOptionClick(Q),telemetryExtraData:{from:t}}),this.fallbackMenuHandlers["workbench.action.openWorkspace"]=(C,V,Q)=>this.nativeHostMainService.pickWorkspaceAndOpen(void 0,{forceNewWindow:this.isOptionClick(Q),telemetryExtraData:{from:t}}),this.fallbackMenuHandlers["workbench.action.clearRecentFiles"]=()=>this.workspacesHistoryMainService.clearRecentlyOpened();const h=this.productService.twitterUrl;h&&(this.fallbackMenuHandlers["workbench.action.openTwitterUrl"]=()=>this.openUrl(h,"openTwitterUrl"));const f=this.productService.requestFeatureUrl;f&&(this.fallbackMenuHandlers["workbench.action.openRequestFeatureUrl"]=()=>this.openUrl(f,"openUserVoiceUrl"));const d=this.productService.reportIssueUrl;d&&(this.fallbackMenuHandlers["workbench.action.openIssueReporter"]=()=>this.openUrl(d,"openReportIssues"));const M=this.productService.licenseUrl;M&&(this.fallbackMenuHandlers["workbench.action.openLicenseUrl"]=()=>{if(L.language){const C=M.indexOf("?")>0?"&":"?";this.openUrl(`${M}${C}lang=${L.language}`,"openLicenseUrl")}else this.openUrl(M,"openLicenseUrl")});const T=this.productService.privacyStatementUrl;T&&M&&(this.fallbackMenuHandlers["workbench.action.openPrivacyStatementUrl"]=()=>{if(L.language){const C=M.indexOf("?")>0?"&":"?";this.openUrl(`${T}${C}lang=${L.language}`,"openPrivacyStatement")}else this.openUrl(T,"openPrivacyStatement")})}registerListeners(){this.lifecycleMainService.onWillShutdown(()=>this.willShutdown=!0),this.windowsMainService.onDidChangeWindowsCount(h=>this.onDidChangeWindowsCount(h)),this.nativeHostMainService.onDidBlurWindow(()=>this.onDidChangeWindowFocus()),this.nativeHostMainService.onDidFocusWindow(()=>this.onDidChangeWindowFocus())}get currentEnableMenuBarMnemonics(){let h=this.configurationService.getValue("window.enableMenuBarMnemonics");return typeof h!="boolean"&&(h=!0),h}get currentEnableNativeTabs(){if(!L.isMacintosh)return!1;let h=this.configurationService.getValue("window.nativeTabs");return typeof h!="boolean"&&(h=!1),h}updateMenu(h,f){this.menubarMenus=h.menus,this.keybindings=h.keybindings,this.stateMainService.setItem(pt.lastKnownMenubarStorageKey,h),this.scheduleUpdateMenu()}scheduleUpdateMenu(){this.menuUpdater.schedule()}doUpdateMenu(){this.willShutdown||setTimeout(()=>{this.willShutdown||this.install()},10)}onDidChangeWindowsCount(h){!L.isMacintosh||(h.oldCount===0&&h.newCount>0||h.oldCount>0&&h.newCount===0)&&(this.closedLastWindow=h.newCount===0,this.scheduleUpdateMenu())}onDidChangeWindowFocus(){!L.isMacintosh||(this.noActiveWindow=!S.BrowserWindow.getFocusedWindow(),this.scheduleUpdateMenu())}install(){const h=S.Menu.getApplicationMenu();if(h&&this.oldMenus.push(h),Object.keys(this.menubarMenus).length===0){S.Menu.setApplicationMenu(L.isMacintosh?new S.Menu:null);return}const f=new S.Menu;let d;if(L.isMacintosh){const T=new S.Menu;d=new S.MenuItem({label:this.productService.nameShort,submenu:T}),this.setMacApplicationMenu(T),f.append(d)}if(L.isMacintosh&&!this.appMenuInstalled){this.appMenuInstalled=!0;const T=new S.Menu;T.append(new S.MenuItem({label:this.mnemonicLabel(m.localize(0,null)),click:()=>this.windowsMainService.openEmptyWindow({context:1})})),S.app.dock.setMenu(T)}if(this.shouldDrawMenu("File")){const T=new S.Menu,C=new S.MenuItem({label:this.mnemonicLabel(m.localize(1,null)),submenu:T});this.setMenuById(T,"File"),f.append(C)}if(this.shouldDrawMenu("Edit")){const T=new S.Menu,C=new S.MenuItem({label:this.mnemonicLabel(m.localize(2,null)),submenu:T});this.setMenuById(T,"Edit"),f.append(C)}if(this.shouldDrawMenu("Selection")){const T=new S.Menu,C=new S.MenuItem({label:this.mnemonicLabel(m.localize(3,null)),submenu:T});this.setMenuById(T,"Selection"),f.append(C)}if(this.shouldDrawMenu("View")){const T=new S.Menu,C=new S.MenuItem({label:this.mnemonicLabel(m.localize(4,null)),submenu:T});this.setMenuById(T,"View"),f.append(C)}if(this.shouldDrawMenu("Go")){const T=new S.Menu,C=new S.MenuItem({label:this.mnemonicLabel(m.localize(5,null)),submenu:T});this.setMenuById(T,"Go"),f.append(C)}if(this.shouldDrawMenu("Run")){const T=new S.Menu,C=new S.MenuItem({label:this.mnemonicLabel(m.localize(6,null)),submenu:T});this.setMenuById(T,"Run"),f.append(C)}if(this.shouldDrawMenu("Terminal")){const T=new S.Menu,C=new S.MenuItem({label:this.mnemonicLabel(m.localize(7,null)),submenu:T});this.setMenuById(T,"Terminal"),f.append(C)}let M;if(this.shouldDrawMenu("Window")){const T=new S.Menu;M=new S.MenuItem({label:this.mnemonicLabel(m.localize(8,null)),submenu:T,role:"window"}),this.setMacWindowMenu(T)}if(M&&f.append(M),this.shouldDrawMenu("Help")){const T=new S.Menu,C=new S.MenuItem({label:this.mnemonicLabel(m.localize(9,null)),submenu:T,role:"help"});this.setMenuById(T,"Help"),f.append(C)}f.items&&f.items.length>0?S.Menu.setApplicationMenu(f):S.Menu.setApplicationMenu(null),this.menuGC.schedule()}setMacApplicationMenu(h){const f=this.createMenuItem(m.localize(10,null,this.productService.nameLong),"workbench.action.showAboutDialog"),d=this.getUpdateMenuItems();let M;if(this.shouldDrawMenu("Preferences")){const X=new S.Menu;this.setMenuById(X,"Preferences"),M=new S.MenuItem({label:this.mnemonicLabel(m.localize(11,null)),submenu:X})}const T=new S.Menu,C=new S.MenuItem({label:m.localize(12,null),role:"services",submenu:T}),V=new S.MenuItem({label:m.localize(13,null,this.productService.nameLong),role:"hide",accelerator:"Command+H"}),Q=new S.MenuItem({label:m.localize(14,null),role:"hideOthers",accelerator:"Command+Alt+H"}),te=new S.MenuItem({label:m.localize(15,null),role:"unhide"}),B=new S.MenuItem(this.likeAction("workbench.action.quit",{label:m.localize(16,null,this.productService.nameLong),click:()=>{const X=this.windowsMainService.getLastActiveWindow();(this.windowsMainService.getWindowCount()===0||!!S.BrowserWindow.getFocusedWindow()||(X==null?void 0:X.isMinimized()))&&this.nativeHostMainService.quit(void 0)}})),Y=[f];Y.push(...d),M&&Y.push(s(),M),Y.push(s(),C,s(),V,Q,te,s(),B),Y.forEach(X=>h.append(X))}shouldDrawMenu(h){if(!L.isMacintosh&&E.getTitleBarStyle(this.configurationService)==="custom")return!1;switch(h){case"File":case"Help":if(L.isMacintosh)return this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow||!!this.menubarMenus&&!!this.menubarMenus[h];case"Window":if(L.isMacintosh)return this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow||!!this.menubarMenus;default:return this.windowsMainService.getWindowCount()>0&&!!this.menubarMenus&&!!this.menubarMenus[h]}}setMenu(h,f){f.forEach(d=>{if(D.isMenubarMenuItemSeparator(d))h.append(s());else if(D.isMenubarMenuItemSubmenu(d)){const M=new S.Menu,T=new S.MenuItem({label:this.mnemonicLabel(d.label),submenu:M});this.setMenu(M,d.submenu.items),h.append(T)}else D.isMenubarMenuItemRecentAction(d)?h.append(this.createOpenRecentMenuItem(d)):D.isMenubarMenuItemAction(d)&&(d.id==="workbench.action.showAboutDialog"&&this.insertCheckForUpdatesItems(h),L.isMacintosh?this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow?this.fallbackMenuHandlers[d.id]?h.append(new S.MenuItem(this.likeAction(d.id,{label:this.mnemonicLabel(d.label),click:this.fallbackMenuHandlers[d.id]}))):h.append(this.createMenuItem(d.label,d.id,!1,d.checked)):h.append(this.createMenuItem(d.label,d.id,d.enabled!==!1,!!d.checked)):h.append(this.createMenuItem(d.label,d.id,d.enabled!==!1,!!d.checked)))})}setMenuById(h,f){this.menubarMenus&&this.menubarMenus[f]&&this.setMenu(h,this.menubarMenus[f].items)}insertCheckForUpdatesItems(h){const f=this.getUpdateMenuItems();f.length&&(f.forEach(d=>h.append(d)),h.append(s()))}createOpenRecentMenuItem(h){const f=b.URI.revive(h.uri),d=h.id,M=d==="openRecentFile"?{fileUri:f}:d==="openRecentWorkspace"?{workspaceUri:f}:{folderUri:f};return new S.MenuItem(this.likeAction(d,{label:h.label,click:(T,C,V)=>{const Q=this.isOptionClick(V);this.windowsMainService.open({context:2,cli:this.environmentMainService.args,urisToOpen:[M],forceNewWindow:Q,gotoLineMode:!1,remoteAuthority:h.remoteAuthority}).length>0||this.workspacesHistoryMainService.removeRecentlyOpened([f])}},!1))}isOptionClick(h){return!!(h&&(!L.isMacintosh&&(h.ctrlKey||h.shiftKey)||L.isMacintosh&&(h.metaKey||h.altKey)))}createRoleMenuItem(h,f,d){const M={label:this.mnemonicLabel(h),role:d,enabled:!0};return new S.MenuItem(this.withKeybinding(f,M))}setMacWindowMenu(h){const f=new S.MenuItem({label:m.localize(17,null),role:"minimize",accelerator:"Command+M",enabled:this.windowsMainService.getWindowCount()>0}),d=new S.MenuItem({label:m.localize(18,null),role:"zoom",enabled:this.windowsMainService.getWindowCount()>0}),M=new S.MenuItem({label:m.localize(19,null),role:"front",enabled:this.windowsMainService.getWindowCount()>0}),T=this.createMenuItem(m.localize(20,null),"workbench.action.switchWindow"),C=[];this.currentEnableNativeTabs&&(C.push(s()),C.push(this.createMenuItem(m.localize(21,null),"workbench.action.newWindowTab")),C.push(this.createRoleMenuItem(m.localize(22,null),"workbench.action.showPreviousWindowTab","selectPreviousTab")),C.push(this.createRoleMenuItem(m.localize(23,null),"workbench.action.showNextWindowTab","selectNextTab")),C.push(this.createRoleMenuItem(m.localize(24,null),"workbench.action.moveWindowTabToNewWindow","moveTabToNewWindow")),C.push(this.createRoleMenuItem(m.localize(25,null),"workbench.action.mergeAllWindowTabs","mergeAllWindows"))),[f,d,s(),T,...C,s(),M].forEach(V=>h.append(V))}getUpdateMenuItems(){switch(this.updateService.state.type){case"uninitialized":return[];case"idle":return[new S.MenuItem({label:this.mnemonicLabel(m.localize(26,null)),click:()=>setTimeout(()=>{this.reportMenuActionTelemetry("CheckForUpdate"),this.updateService.checkForUpdates(!0)},0)})];case"checking for updates":return[new S.MenuItem({label:m.localize(27,null),enabled:!1})];case"available for download":return[new S.MenuItem({label:this.mnemonicLabel(m.localize(28,null)),click:()=>{this.updateService.downloadUpdate()}})];case"downloading":return[new S.MenuItem({label:m.localize(29,null),enabled:!1})];case"downloaded":return[new S.MenuItem({label:this.mnemonicLabel(m.localize(30,null)),click:()=>{this.reportMenuActionTelemetry("InstallUpdate"),this.updateService.applyUpdate()}})];case"updating":return[new S.MenuItem({label:m.localize(31,null),enabled:!1})];case"ready":return[new S.MenuItem({label:this.mnemonicLabel(m.localize(32,null)),click:()=>{this.reportMenuActionTelemetry("RestartToUpdate"),this.updateService.quitAndInstall()}})]}}createMenuItem(h,f,d,M){const T=this.mnemonicLabel(h),C=typeof f=="function"?f:(Y,X,_)=>{const $=Y?Y.userSettingsLabel:null;let G=f;Array.isArray(f)&&(G=this.isOptionClick(_)?f[1]:f[0]),$&&_.triggeredByAccelerator?this.runActionInRenderer({type:"keybinding",userSettingsLabel:$}):this.runActionInRenderer({type:"commandId",commandId:G})},V=typeof d=="boolean"?d:this.windowsMainService.getWindowCount()>0,Q=typeof M=="boolean"?M:!1,te={label:T,click:C,enabled:V};Q&&(te.type="checkbox",te.checked=Q);let B;return typeof f=="string"?B=f:Array.isArray(f)&&(B=f[0]),L.isMacintosh&&(B==="editor.action.clipboardCutAction"?te.role="cut":B==="editor.action.clipboardCopyAction"?te.role="copy":B==="editor.action.clipboardPasteAction"&&(te.role="paste"),B==="undo"?te.click=this.makeContextAwareClickHandler(C,{inDevTools:Y=>Y.undo(),inNoWindow:()=>S.Menu.sendActionToFirstResponder("undo:")}):B==="redo"?te.click=this.makeContextAwareClickHandler(C,{inDevTools:Y=>Y.redo(),inNoWindow:()=>S.Menu.sendActionToFirstResponder("redo:")}):B==="editor.action.selectAll"&&(te.click=this.makeContextAwareClickHandler(C,{inDevTools:Y=>Y.selectAll(),inNoWindow:()=>S.Menu.sendActionToFirstResponder("selectAll:")}))),new S.MenuItem(this.withKeybinding(B,te))}makeContextAwareClickHandler(h,f){return(d,M,T)=>{const C=S.BrowserWindow.getFocusedWindow();if(!C)return f.inNoWindow();if(C.webContents.isDevToolsFocused()&&C.webContents.devToolsWebContents)return f.inDevTools(C.webContents.devToolsWebContents);h(d,M||C,T)}}runActionInRenderer(h){let f=S.BrowserWindow.getFocusedWindow();if(!f){const M=this.windowsMainService.getLastActiveWindow();(M==null?void 0:M.isMinimized())&&(f=M.win)}const d=f?this.windowsMainService.getWindowById(f.id):void 0;if(d){if(this.logService.trace("menubar#runActionInRenderer",h),L.isMacintosh&&!this.environmentMainService.isBuilt&&!d.isReady&&(h.type==="commandId"&&h.commandId==="workbench.action.toggleDevTools"||h.type!=="commandId"&&h.userSettingsLabel==="alt+cmd+i"))return;if(h.type==="commandId"){const M={id:h.commandId,from:"menu"};d.sendWhenReady("vscode:runAction",a.CancellationToken.None,M)}else{const M={userSettingsLabel:h.userSettingsLabel};d.sendWhenReady("vscode:runKeybinding",a.CancellationToken.None,M)}}else this.logService.trace("menubar#runActionInRenderer: no active window found",h)}withKeybinding(h,f){const d=typeof h=="string"?this.keybindings[h]:void 0;if(d==null?void 0:d.label){if(d.isNative!==!1)f.accelerator=d.label,f.userSettingsLabel=d.userSettingsLabel;else if(typeof f.label=="string"){const M=f.label.indexOf("[");M>=0?f.label=`${f.label.substr(0,M)} [${d.label}]`:f.label=`${f.label} [${d.label}]`}}else f.accelerator=void 0;return f}likeAction(h,f,d=!f.accelerator){d&&(f=this.withKeybinding(h,f));const M=f.click;return f.click=(T,C,V)=>{this.reportMenuActionTelemetry(h),M&&M(T,C,V)},f}openUrl(h,f){this.nativeHostMainService.openExternal(void 0,h),this.reportMenuActionTelemetry(f)}reportMenuActionTelemetry(h){this.telemetryService.publicLog2("workbenchActionExecuted",{id:h,from:t})}mnemonicLabel(h){return y.mnemonicMenuLabel(h,!this.currentEnableMenuBarMnemonics)}};r.lastKnownMenubarStorageKey="lastKnownMenubarData",r=he([ee(0,p.IUpdateService),ee(1,n.IConfigurationService),ee(2,g.IWindowsMainService),ee(3,A.IEnvironmentMainService),ee(4,w.ITelemetryService),ee(5,v.IWorkspacesHistoryMainService),ee(6,l.IStateMainService),ee(7,u.ILifecycleMainService),ee(8,P.ILogService),ee(9,c.INativeHostMainService),ee(10,i.IProductService)],r),e.Menubar=r;function s(){return new S.MenuItem({type:"separator"})}}),define(J[233],Z([0,1,232,6,4,18]),function(z,e,m,L,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MenubarMainService=e.IMenubarMainService=void 0,e.IMenubarMainService=A.createDecorator("menubarMainService");let E=class{constructor(w,p,i){this.instantiationService=w,this.lifecycleMainService=p,this.logService=i,this.menubar=this.installMenuBarAfterWindowOpen()}async installMenuBarAfterWindowOpen(){return await this.lifecycleMainService.when(3),this.instantiationService.createInstance(m.Menubar)}async updateMenubar(w,p){this.logService.trace("menubarService#updateMenubar",w),(await this.menubar).updateMenu(p,w)}};E=he([ee(0,A.IInstantiationService),ee(1,S.ILifecycleMainService),ee(2,L.ILogService)],E),e.MenubarMainService=E}),define(J[234],Z([0,1,30,26,47,72,8,150,35,50,24,38,231,14,18,16,6,61,100,5,22,62,3,28,4,10,7,15,73,214,52,42,2,51,13,29,39,25,21,32,55]),function(z,e,m,L,A,S,E,n,w,p,i,I,P,y,g,v,D,b,l,u,c,a,t,r,s,o,h,f,d,M,T,C,V,Q,te,B,Y,X,_,$,G){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowsMainService=void 0;function N(O){return r.isWorkspaceIdentifier(O==null?void 0:O.workspace)}function F(O){return r.isSingleFolderWorkspaceIdentifier(O==null?void 0:O.workspace)}let R=class tt extends V.Disposable{constructor(k,W,U,q,K,H,x,ne,re,se,le,oe,ue,me,Se){super();this.machineId=k,this.initialUserEnv=W,this.logService=U,this.stateMainService=q,this.environmentMainService=K,this.lifecycleMainService=H,this.backupMainService=x,this.configurationService=ne,this.workspacesHistoryMainService=re,this.workspacesManagementMainService=se,this.instantiationService=le,this.dialogMainService=oe,this.fileService=ue,this.productService=me,this.protocolMainService=Se,this._onDidOpenWindow=this._register(new u.Emitter),this.onDidOpenWindow=this._onDidOpenWindow.event,this._onDidSignalReadyWindow=this._register(new u.Emitter),this.onDidSignalReadyWindow=this._onDidSignalReadyWindow.event,this._onDidDestroyWindow=this._register(new u.Emitter),this.onDidDestroyWindow=this._onDidDestroyWindow.event,this._onDidChangeWindowsCount=this._register(new u.Emitter),this.onDidChangeWindowsCount=this._onDidChangeWindowsCount.event,this.windowsStateHandler=this._register(new M.WindowsStateHandler(this,this.stateMainService,this.lifecycleMainService,this.logService,this.configurationService)),this.registerListeners()}registerListeners(){this._register(this.workspacesManagementMainService.onDidEnterWorkspace(k=>this._onDidSignalReadyWindow.fire(k.window))),this._register(this.onDidSignalReadyWindow(k=>{var W,U;if(((W=k.config)===null||W===void 0?void 0:W.extensionDevelopmentPath)||((U=k.config)===null||U===void 0?void 0:U.extensionTestsPath)){const q=new V.DisposableStore;if(q.add(u.Event.any(k.onDidClose,k.onDidDestroy)(()=>q.dispose())),k.config.extensionDevelopmentPath)for(const K of k.config.extensionDevelopmentPath)q.add(this.protocolMainService.addValidFileRoot(h.URI.file(K)));k.config.extensionTestsPath&&q.add(this.protocolMainService.addValidFileRoot(h.URI.file(k.config.extensionTestsPath)))}}))}openEmptyWindow(k,W){let U=this.environmentMainService.args;const q=(W==null?void 0:W.remoteAuthority)||void 0,K=!0,H=W==null?void 0:W.forceReuseWindow,x=!H;return this.open(Object.assign(Object.assign({},k),{cli:U,forceEmpty:K,forceNewWindow:x,forceReuseWindow:H,remoteAuthority:q}))}open(k){this.logService.trace("windowsManager#open"),k.addMode&&(k.initialStartup||!this.getLastActiveWindow())&&(k.addMode=!1);const W=[],U=[],q=[],K=[],H=[];let x,ne=0;const re=this.getPathsToOpen(k);this.logService.trace("windowsManager#open pathsToOpen",re);for(const me of re)F(me)?k.addMode?W.push(me):U.push(me):N(me)?q.push(me):me.fileUri?(x||(x={filesToOpenOrCreate:[],filesToDiff:[],remoteAuthority:me.remoteAuthority}),x.filesToOpenOrCreate.push(me)):me.backupPath?H.push({backupFolder:E.basename(me.backupPath),remoteAuthority:me.remoteAuthority}):ne++;k.diffMode&&(x==null?void 0:x.filesToOpenOrCreate.length)===2&&(x.filesToDiff=x.filesToOpenOrCreate,x.filesToOpenOrCreate=[]),x&&k.waitMarkerFileURI&&(x.filesToWait={paths:[...x.filesToDiff,...x.filesToOpenOrCreate],waitMarkerFileUri:k.waitMarkerFileURI}),k.initialStartup?(K.push(...this.workspacesManagementMainService.getUntitledWorkspacesSync()),q.push(...K),H.push(...this.backupMainService.getEmptyWindowBackupPaths())):H.length=0;const{windows:se,filesOpenedInWindow:le}=this.doOpen(k,q,U,H,ne,x,W);if(this.logService.trace(`windowsManager#open used window count ${se.length} (workspacesToOpen: ${q.length}, foldersToOpen: ${U.length}, emptyToRestore: ${H.length}, emptyToOpen: ${ne})`),se.length>1)if(le)le.focus();else{const me=this.windowsStateHandler.state.lastActiveWindow&&!k.forceEmpty&&!k.cli._.length&&!k.cli["file-uri"]&&!k.cli["folder-uri"]&&!(k.urisToOpen&&k.urisToOpen.length);let Se=!0,De=!0;if(me){const Ie=se.filter(we=>this.windowsStateHandler.state.lastActiveWindow&&we.backupPath===this.windowsStateHandler.state.lastActiveWindow.backupPath);Ie.length&&(Ie[0].focus(),Se=!1,De=!1)}if(Se)for(let Ie=se.length-1;Ie>=0;Ie--){const we=se[Ie];if(!(we.openedWorkspace&&K.some(ye=>we.openedWorkspace&&ye.workspace.id===we.openedWorkspace.id)||we.backupPath&&H.some(ye=>we.backupPath&&ye.backupFolder===E.basename(we.backupPath)))){we.focus(),De=!1;break}}De&&se[se.length-1].focus()}const oe=x&&x.filesToDiff.length>0;if(!se.some(me=>me.isExtensionDevelopmentHost)&&!oe&&!k.noRecentEntry){const me=[];for(const Se of re)N(Se)?me.push({label:Se.label,workspace:Se.workspace,remoteAuthority:Se.remoteAuthority}):F(Se)?me.push({label:Se.label,folderUri:Se.workspace.uri,remoteAuthority:Se.remoteAuthority}):Se.fileUri&&me.push({label:Se.label,fileUri:Se.fileUri,remoteAuthority:Se.remoteAuthority});this.workspacesHistoryMainService.addRecentlyOpened(me)}const ue=k.waitMarkerFileURI;return k.context===0&&ue&&se.length===1&&se[0]&&(async()=>{await se[0].whenClosedOrLoaded;try{await this.fileService.del(ue)}catch(me){}})(),se}doOpen(k,W,U,q,K,H,x){const ne=[];let re;function se(Ie,we){ne.push(Ie),we&&(re=Ie,H=void 0)}let{openFolderInNewWindow:le,openFilesInNewWindow:oe}=this.shouldOpenNewWindow(k);if(!k.initialStartup&&x.length>0){const Ie=x[0].remoteAuthority,we=this.getLastActiveWindowForAuthority(Ie);we&&se(this.doAddFoldersToExistingWindow(we,x.map(ye=>ye.workspace.uri)))}const ue=U.length+W.length+q.length;if(H&&ue===0){const Ie=H.filesToOpenOrCreate[0]||H.filesToDiff[0],we=this.getWindows().filter(Ae=>H&&Ae.remoteAuthority===H.remoteAuthority);let ye;(Ie==null?void 0:Ie.fileUri)&&!oe&&((k.context===4||k.context===0||k.context===1)&&(ye=l.findWindowOnFile(we,Ie.fileUri,Ae=>Ae.configPath.scheme===o.Schemas.file?this.workspacesManagementMainService.resolveLocalWorkspaceSync(Ae.configPath):void 0)),ye||(ye=this.doGetLastActiveWindow(we))),ye?r.isWorkspaceIdentifier(ye.openedWorkspace)?W.push({workspace:ye.openedWorkspace,remoteAuthority:ye.remoteAuthority}):r.isSingleFolderWorkspaceIdentifier(ye.openedWorkspace)?U.push({workspace:ye.openedWorkspace,remoteAuthority:ye.remoteAuthority}):se(this.doOpenFilesInExistingWindow(k,ye,H),!0):se(this.openInBrowserWindow({userEnv:k.userEnv,cli:k.cli,initialStartup:k.initialStartup,filesToOpen:H,forceNewWindow:!0,remoteAuthority:H.remoteAuthority,forceNewTabbedWindow:k.forceNewTabbedWindow}),!0)}const me=w.distinct(W,Ie=>Ie.workspace.id);if(me.length>0){const Ie=w.coalesce(me.map(we=>l.findWindowOnWorkspaceOrFolder(this.getWindows(),we.workspace.configPath)));if(Ie.length>0){const we=Ie[0],ye=(H==null?void 0:H.remoteAuthority)===we.remoteAuthority?H:void 0;se(this.doOpenFilesInExistingWindow(k,we,ye),!!ye),le=!0}me.forEach(we=>{if(Ie.some(Te=>Te.openedWorkspace&&Te.openedWorkspace.id===we.workspace.id))return;const ye=we.remoteAuthority,Ae=(H==null?void 0:H.remoteAuthority)===ye?H:void 0;se(this.doOpenFolderOrWorkspace(k,we,le,Ae),!!Ae),le=!0})}const Se=w.distinct(U,Ie=>f.extUriBiasedIgnorePathCase.getComparisonKey(Ie.workspace.uri));if(Se.length>0){const Ie=w.coalesce(Se.map(we=>l.findWindowOnWorkspaceOrFolder(this.getWindows(),we.workspace.uri)));if(Ie.length>0){const we=Ie[0],ye=(H==null?void 0:H.remoteAuthority)===we.remoteAuthority?H:void 0;se(this.doOpenFilesInExistingWindow(k,we,ye),!!ye),le=!0}Se.forEach(we=>{if(Ie.some(Te=>r.isSingleFolderWorkspaceIdentifier(Te.openedWorkspace)&&f.extUriBiasedIgnorePathCase.isEqual(Te.openedWorkspace.uri,we.workspace.uri)))return;const ye=we.remoteAuthority,Ae=(H==null?void 0:H.remoteAuthority)===ye?H:void 0;se(this.doOpenFolderOrWorkspace(k,we,le,Ae),!!Ae),le=!0})}const De=w.distinct(q,Ie=>Ie.backupFolder);if(De.length>0&&De.forEach(Ie=>{const we=Ie.remoteAuthority,ye=(H==null?void 0:H.remoteAuthority)===we?H:void 0;se(this.openInBrowserWindow({userEnv:k.userEnv,cli:k.cli,initialStartup:k.initialStartup,filesToOpen:ye,remoteAuthority:we,forceNewWindow:!0,forceNewTabbedWindow:k.forceNewTabbedWindow,emptyWindowBackupInfo:Ie}),!!ye),le=!0}),ne.length===0||H){H&&!K&&K++;const Ie=H?H.remoteAuthority:k.remoteAuthority;for(let we=0;we<K;we++)se(this.doOpenEmpty(k,le,Ie,H),!!H),le=!0}return{windows:w.distinct(ne),filesOpenedInWindow:re}}doOpenFilesInExistingWindow(k,W,U){var q;this.logService.trace("windowsManager#doOpenFilesInExistingWindow"),W.focus();const K={filesToOpenOrCreate:U==null?void 0:U.filesToOpenOrCreate,filesToDiff:U==null?void 0:U.filesToDiff,filesToWait:U==null?void 0:U.filesToWait,termProgram:(q=k==null?void 0:k.userEnv)===null||q===void 0?void 0:q.TERM_PROGRAM};return W.sendWhenReady("vscode:openFiles",X.CancellationToken.None,K),W}doAddFoldersToExistingWindow(k,W){this.logService.trace("windowsManager#doAddFoldersToExistingWindow"),k.focus();const U={foldersToAdd:W};return k.sendWhenReady("vscode:addFolders",X.CancellationToken.None,U),k}doOpenEmpty(k,W,U,q,K){return!W&&!K&&typeof k.contextWindowId=="number"&&(K=this.getWindowById(k.contextWindowId)),this.openInBrowserWindow({userEnv:k.userEnv,cli:k.cli,initialStartup:k.initialStartup,remoteAuthority:U,forceNewWindow:W,forceNewTabbedWindow:k.forceNewTabbedWindow,filesToOpen:q,windowToUse:K})}doOpenFolderOrWorkspace(k,W,U,q,K){return!U&&!K&&typeof k.contextWindowId=="number"&&(K=this.getWindowById(k.contextWindowId)),this.openInBrowserWindow({workspace:W.workspace,userEnv:k.userEnv,cli:k.cli,initialStartup:k.initialStartup,remoteAuthority:W.remoteAuthority,forceNewWindow:U,forceNewTabbedWindow:k.forceNewTabbedWindow,filesToOpen:q,windowToUse:K})}getPathsToOpen(k){var W;let U,q=!1,K=!1;if(k.urisToOpen&&k.urisToOpen.length>0?(U=this.doExtractPathsFromAPI(k),q=!0):k.forceEmpty?U=[Object.create(null)]:k.cli._.length||k.cli["folder-uri"]||k.cli["file-uri"]?(U=this.doExtractPathsFromCLI(k.cli),U.length===0&&U.push(Object.create(null)),q=!0):(U=this.doGetPathsFromLastSession(),U.length===0&&U.push(Object.create(null)),K=!0),!k.addMode&&q){const H=U.filter(x=>F(x));if(H.length>1){const x=H[0].remoteAuthority;if(H.every(ne=>ne.remoteAuthority===x)){const ne=this.workspacesManagementMainService.createUntitledWorkspaceSync(H.map(re=>({uri:re.workspace.uri})));U.push({workspace:ne,remoteAuthority:x}),U=U.filter(re=>!F(re))}}}return k.initialStartup&&!K&&((W=this.configurationService.getValue("window"))===null||W===void 0?void 0:W.restoreWindows)==="preserve"&&U.unshift(...this.doGetPathsFromLastSession().filter(H=>N(H)||F(H)||H.backupPath)),U}doExtractPathsFromAPI(k){const W=[],U={gotoLineMode:k.gotoLineMode,remoteAuthority:k.remoteAuthority};for(const q of w.coalesce(k.urisToOpen||[])){const K=this.resolveOpenable(q,U);if(K)K.label=q.label,W.push(K);else{const H=this.resourceFromOpenable(q),x={title:this.productService.nameLong,type:"info",buttons:[n.localize(0,null)],message:H.scheme===o.Schemas.file?n.localize(1,null):n.localize(2,null),detail:H.scheme===o.Schemas.file?n.localize(3,null,Y.getPathLabel(H.fsPath,this.environmentMainService)):n.localize(4,null,H.toString()),noLink:!0};this.dialogMainService.showMessageBox(x,te.withNullAsUndefined(y.BrowserWindow.getFocusedWindow()))}}return W}doExtractPathsFromCLI(k){const W=[],U={ignoreFileNotFound:!0,gotoLineMode:k.goto,remoteAuthority:k.remote||void 0,forceOpenWorkspaceAsFile:!1},q=k["folder-uri"];if(q)for(const x of q){const ne=this.cliArgToUri(x);if(ne){const re=this.resolveOpenable({folderUri:ne},U);re&&W.push(re)}}const K=k["file-uri"];if(K)for(const x of K){const ne=this.cliArgToUri(x);if(ne){const re=this.resolveOpenable(r.hasWorkspaceFileExtension(x)?{workspaceUri:ne}:{fileUri:ne},U);re&&W.push(re)}}const H=k._;for(const x of H){const ne=U.remoteAuthority?this.doResolvePathRemote(x,U):this.doResolveFilePath(x,U);ne&&W.push(ne)}return W}cliArgToUri(k){try{const W=h.URI.parse(k);if(!W.scheme){this.logService.error(`Invalid URI input string, scheme missing: ${k}`);return}return W}catch(W){this.logService.error(`Invalid URI input string: ${k}, ${W.message}`)}}doGetPathsFromLastSession(){const k=this.getRestoreWindowsSetting();switch(k){case"none":return[];case"one":case"all":case"preserve":case"folders":const W=[];k!=="one"&&W.push(...this.windowsStateHandler.state.openedWindows),this.windowsStateHandler.state.lastActiveWindow&&W.push(this.windowsStateHandler.state.lastActiveWindow);const U=[];for(const q of W)if(q.workspace){const K=this.resolveOpenable({workspaceUri:q.workspace.configPath},{remoteAuthority:q.remoteAuthority});N(K)&&U.push(K)}else if(q.folderUri){const K=this.resolveOpenable({folderUri:q.folderUri},{remoteAuthority:q.remoteAuthority});F(K)&&U.push(K)}else k!=="folders"&&q.backupPath&&U.push({backupPath:q.backupPath,remoteAuthority:q.remoteAuthority});return U}}getRestoreWindowsSetting(){let k;if(this.lifecycleMainService.wasRestarted)k="all";else{const W=this.configurationService.getValue("window");k=(W==null?void 0:W.restoreWindows)||"all",["preserve","all","folders","one","none"].includes(k)||(k="all")}return k}resolveOpenable(k,W={}){let U=this.resourceFromOpenable(k);return U.scheme===o.Schemas.file?(b.isFileToOpen(k)&&(W=Object.assign(Object.assign({},W),{forceOpenWorkspaceAsFile:!0})),this.doResolveFilePath(U.fsPath,W)):this.doResolveRemoteOpenable(k,W)}doResolveRemoteOpenable(k,W){let U=this.resourceFromOpenable(k);const q=d.getRemoteAuthority(U)||W.remoteAuthority;if(U=f.removeTrailingPathSeparator(f.normalizePath(U)),b.isFileToOpen(k)){if(W.gotoLineMode){const{path:K,line:H,column:x}=B.parseLineAndColumnAware(U.path);return{fileUri:U.with({path:K}),lineNumber:H,columnNumber:x,remoteAuthority:q}}return{fileUri:U,remoteAuthority:q}}else if(b.isWorkspaceToOpen(k))return{workspace:T.getWorkspaceIdentifier(U),remoteAuthority:q};return{workspace:T.getSingleFolderWorkspaceIdentifier(U),remoteAuthority:q}}resourceFromOpenable(k){return b.isWorkspaceToOpen(k)?k.workspaceUri:b.isFolderToOpen(k)?k.folderUri:k.fileUri}doResolveFilePath(k,W){let U,q;W.gotoLineMode&&({path:k,line:U,column:q}=B.parseLineAndColumnAware(k)),k=B.sanitizeFilePath(E.normalize(k),$.cwd());try{const K=m.statSync(k);if(K.isFile()){if(!W.forceOpenWorkspaceAsFile){const H=this.workspacesManagementMainService.resolveLocalWorkspaceSync(h.URI.file(k));if(H)return{workspace:{id:H.id,configPath:H.configPath},remoteAuthority:H.remoteAuthority,exists:!0}}return{fileUri:h.URI.file(k),lineNumber:U,columnNumber:q,exists:!0}}else if(K.isDirectory())return{workspace:T.getSingleFolderWorkspaceIdentifier(h.URI.file(k),K),exists:!0}}catch(K){const H=h.URI.file(k);if(this.workspacesHistoryMainService.removeRecentlyOpened([H]),W.ignoreFileNotFound)return{fileUri:H,exists:!1}}}doResolvePathRemote(k,W){const U=k.charCodeAt(0),q=W.remoteAuthority;let K,H;W.gotoLineMode&&({path:k,line:K,column:H}=B.parseLineAndColumnAware(k)),U!==47&&(B.isWindowsDriveLetter(U)&&k.charCodeAt(k.charCodeAt(1))===58&&(k=B.toSlashes(k)),k=`/${k}`);const x=h.URI.from({scheme:o.Schemas.vscodeRemote,authority:q,path:k});if(k.charCodeAt(k.length-1)!==47){if(r.hasWorkspaceFileExtension(k))return W.forceOpenWorkspaceAsFile?{fileUri:x,lineNumber:K,columnNumber:H,remoteAuthority:W.remoteAuthority}:{workspace:T.getWorkspaceIdentifier(x),remoteAuthority:q};if(W.gotoLineMode||E.posix.basename(k).indexOf(".")!==-1)return{fileUri:x,lineNumber:K,columnNumber:H,remoteAuthority:q}}return{workspace:T.getSingleFolderWorkspaceIdentifier(x),remoteAuthority:q}}shouldOpenNewWindow(k){const W=this.configurationService.getValue("window"),U=(W==null?void 0:W.openFoldersInNewWindow)||"default",q=(W==null?void 0:W.openFilesInNewWindow)||"off";let K=(k.preferNewWindow||k.forceNewWindow)&&!k.forceReuseWindow;!k.forceNewWindow&&!k.forceReuseWindow&&(U==="on"||U==="off")&&(K=U==="on");let H=!1;return k.forceNewWindow||k.forceReuseWindow?H=!!k.forceNewWindow&&!k.forceReuseWindow:(t.isMacintosh?k.context===1&&(H=!0):k.context!==3&&k.context!==2&&!(k.userEnv&&k.userEnv.TERM_PROGRAM==="vscode")&&(H=!0),!k.cli.extensionDevelopmentPath&&(q==="on"||q==="off")&&(H=q==="on")),{openFolderInNewWindow:!!K,openFilesInNewWindow:H}}openExtensionDevelopmentHostWindow(k,W){const U=l.findWindowOnExtensionDevelopmentPath(this.getWindows(),k);if(U)return this.lifecycleMainService.reload(U,W.cli),U.focus(),[U];let q=W.cli["folder-uri"]||[],K=W.cli["file-uri"]||[],H=W.cli._;if(!H.length&&!q.length&&!K.length&&!W.cli.extensionTestsPath){const se=this.windowsStateHandler.state.lastPluginDevelopmentHostWindow,le=se&&(se.workspace||se.folderUri);le&&(h.URI.isUri(le)?le.scheme===o.Schemas.file?H=[le.fsPath]:q=[le.toString()]:le.configPath.scheme===o.Schemas.file?H=[f.originalFSPath(le.configPath)]:K=[le.configPath.toString()])}let x=W.remoteAuthority;for(const se of k)if(se.match(/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/)){const le=h.URI.parse(se),oe=d.getRemoteAuthority(le);oe&&(x?oe!==x&&this.logService.error("more than one extension development path authority"):x=oe)}H=H.filter(se=>{const le=h.URI.file(se);return l.findWindowOnWorkspaceOrFolder(this.getWindows(),le)?!1:d.getRemoteAuthority(le)===x}),q=q.filter(se=>{const le=this.cliArgToUri(se);return le&&!!l.findWindowOnWorkspaceOrFolder(this.getWindows(),le)?!1:le?d.getRemoteAuthority(le)===x:!1}),K=K.filter(se=>{const le=this.cliArgToUri(se);return le&&!!l.findWindowOnWorkspaceOrFolder(this.getWindows(),le)?!1:le?d.getRemoteAuthority(le)===x:!1}),W.cli._=H,W.cli["folder-uri"]=q,W.cli["file-uri"]=K;const ne=!H.length&&!q.length&&!K.length,re={context:W.context,cli:W.cli,forceNewWindow:!0,forceEmpty:ne,userEnv:W.userEnv,noRecentEntry:!0,waitMarkerFileURI:W.waitMarkerFileURI,remoteAuthority:x};return this.open(re)}openInBrowserWindow(k){var W,U,q,K,H;const x=this.configurationService.getValue("window"),ne=Object.assign(Object.assign(Object.assign({},this.environmentMainService.args),k.cli),{machineId:this.machineId,windowId:-1,mainPid:process.pid,appRoot:this.environmentMainService.appRoot,execPath:process.execPath,codeCachePath:this.environmentMainService.codeCachePath,backupPath:k.emptyWindowBackupInfo?E.join(this.environmentMainService.backupHome,k.emptyWindowBackupInfo.backupFolder):void 0,homeDir:this.environmentMainService.userHome.fsPath,tmpDir:this.environmentMainService.tmpDir.fsPath,userDataDir:this.environmentMainService.userDataPath,remoteAuthority:k.remoteAuthority,workspace:k.workspace,userEnv:Object.assign(Object.assign({},this.initialUserEnv),k.userEnv),filesToOpenOrCreate:(W=k.filesToOpen)===null||W===void 0?void 0:W.filesToOpenOrCreate,filesToDiff:(U=k.filesToOpen)===null||U===void 0?void 0:U.filesToDiff,filesToWait:(q=k.filesToOpen)===null||q===void 0?void 0:q.filesToWait,logLevel:this.logService.getLevel(),logsPath:this.environmentMainService.logsPath,product:A.default,isInitialStartup:k.initialStartup,perfMarks:S.getMarks(),os:{release:L.release(),hostname:L.hostname()},zoomLevel:typeof(x==null?void 0:x.zoomLevel)=="number"?x.zoomLevel:void 0,autoDetectHighContrast:(K=x==null?void 0:x.autoDetectHighContrast)!==null&&K!==void 0?K:!0,accessibilitySupport:y.app.accessibilitySupportEnabled,colorScheme:{dark:y.nativeTheme.shouldUseDarkColors,highContrast:y.nativeTheme.shouldUseInvertedColorScheme||y.nativeTheme.shouldUseHighContrastColors}});let re;if(!k.forceNewWindow&&!k.forceNewTabbedWindow&&(re=k.windowToUse||this.getLastActiveWindow(),re&&re.focus()),re){const se=re.config;!ne.extensionDevelopmentPath&&se&&!!se.extensionDevelopmentPath&&(ne.extensionDevelopmentPath=se.extensionDevelopmentPath,ne.verbose=se.verbose,ne["inspect-brk-extensions"]=se["inspect-brk-extensions"],ne.debugId=se.debugId,ne["inspect-extensions"]=se["inspect-extensions"],ne["extensions-dir"]=se["extensions-dir"])}else{const se=this.windowsStateHandler.getNewWindowState(ne);S.mark("code/willCreateCodeWindow");const le=re=this.instantiationService.createInstance(P.CodeWindow,{state:se,extensionDevelopmentPath:ne.extensionDevelopmentPath,isExtensionTestHost:!!ne.extensionTestsPath});if(S.mark("code/didCreateCodeWindow"),k.forceNewTabbedWindow){const ue=this.getLastActiveWindow();ue&&ue.addTabbedWindow(le)}tt.WINDOWS.push(le),this._onDidOpenWindow.fire(le),this._onDidChangeWindowsCount.fire({oldCount:this.getWindowCount()-1,newCount:this.getWindowCount()}),C.once(le.onDidSignalReady)(()=>this._onDidSignalReadyWindow.fire(le)),C.once(le.onDidClose)(()=>this.onWindowClosed(le)),C.once(le.onDidDestroy)(()=>this._onDidDestroyWindow.fire(le));const oe=te.assertIsDefined((H=le.win)===null||H===void 0?void 0:H.webContents);oe.removeAllListeners("devtools-reload-page"),oe.on("devtools-reload-page",()=>this.lifecycleMainService.reload(le)),this.lifecycleMainService.registerWindow(le)}return ne.windowId=re.id,re.isReady?this.lifecycleMainService.unload(re,4).then(se=>{se||this.doOpenInBrowserWindow(re,ne,k)}):this.doOpenInBrowserWindow(re,ne,k),re}doOpenInBrowserWindow(k,W,U){if(!W.extensionDevelopmentPath)if(r.isWorkspaceIdentifier(W.workspace))W.backupPath=this.backupMainService.registerWorkspaceBackupSync({workspace:W.workspace,remoteAuthority:W.remoteAuthority});else if(r.isSingleFolderWorkspaceIdentifier(W.workspace))W.backupPath=this.backupMainService.registerFolderBackupSync(W.workspace.uri);else{const q=U.emptyWindowBackupInfo&&U.emptyWindowBackupInfo.backupFolder;W.backupPath=this.backupMainService.registerEmptyWindowBackupSync(q,W.remoteAuthority)}k.load(W)}onWindowClosed(k){const W=tt.WINDOWS.indexOf(k);tt.WINDOWS.splice(W,1),this._onDidChangeWindowsCount.fire({oldCount:this.getWindowCount()+1,newCount:this.getWindowCount()})}getFocusedWindow(){const k=y.BrowserWindow.getFocusedWindow();if(k)return this.getWindowById(k.id)}getLastActiveWindow(){return this.doGetLastActiveWindow(this.getWindows())}getLastActiveWindowForAuthority(k){return this.doGetLastActiveWindow(this.getWindows().filter(W=>W.remoteAuthority===k))}doGetLastActiveWindow(k){const W=Math.max.apply(Math,k.map(U=>U.lastFocusTime));return k.find(U=>U.lastFocusTime===W)}sendToFocused(k,...W){const U=this.getFocusedWindow()||this.getLastActiveWindow();U&&U.sendWhenReady(k,X.CancellationToken.None,...W)}sendToAll(k,W,U){for(const q of this.getWindows())U&&U.indexOf(q.id)>=0||q.sendWhenReady(k,X.CancellationToken.None,W)}getWindows(){return tt.WINDOWS}getWindowCount(){return tt.WINDOWS.length}getWindowById(k){const W=this.getWindows().filter(U=>U.id===k);return w.firstOrDefault(W)}getWindowByWebContents(k){const W=y.BrowserWindow.fromWebContents(k);if(!!W)return this.getWindowById(W.id)}};R.WINDOWS=[],R=he([ee(2,D.ILogService),ee(3,I.IStateMainService),ee(4,i.IEnvironmentMainService),ee(5,g.ILifecycleMainService),ee(6,p.IBackupMainService),ee(7,v.IConfigurationService),ee(8,a.IWorkspacesHistoryMainService),ee(9,T.IWorkspacesManagementMainService),ee(10,s.IInstantiationService),ee(11,Q.IDialogMainService),ee(12,_.IFileService),ee(13,c.IProductService),ee(14,G.IProtocolMainService)],R),e.WindowsMainService=R}),define(J[235],Z([0,1,52,34,62,50]),function(z,e,m,L,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesMainService=void 0;let E=class{constructor(w,p,i,I){this.workspacesManagementMainService=w,this.windowsMainService=p,this.workspacesHistoryMainService=i,this.backupMainService=I,this.onDidChangeRecentlyOpened=this.workspacesHistoryMainService.onDidChangeRecentlyOpened}async enterWorkspace(w,p){const i=this.windowsMainService.getWindowById(w);if(i)return this.workspacesManagementMainService.enterWorkspace(i,this.windowsMainService.getWindows(),p)}createUntitledWorkspace(w,p,i){return this.workspacesManagementMainService.createUntitledWorkspace(p,i)}deleteUntitledWorkspace(w,p){return this.workspacesManagementMainService.deleteUntitledWorkspace(p)}getWorkspaceIdentifier(w,p){return this.workspacesManagementMainService.getWorkspaceIdentifier(p)}async getRecentlyOpened(w){return this.workspacesHistoryMainService.getRecentlyOpened(this.windowsMainService.getWindowById(w))}async addRecentlyOpened(w,p){return this.workspacesHistoryMainService.addRecentlyOpened(p)}async removeRecentlyOpened(w,p){return this.workspacesHistoryMainService.removeRecentlyOpened(p)}async clearRecentlyOpened(w){return this.workspacesHistoryMainService.clearRecentlyOpened()}async getDirtyWorkspaces(){return this.backupMainService.getDirtyWorkspaces()}};E=he([ee(0,m.IWorkspacesManagementMainService),ee(1,L.IWindowsMainService),ee(2,A.IWorkspacesHistoryMainService),ee(3,S.IBackupMainService)],E),e.WorkspacesMainService=E}),define(J[236],Z([0,1,26,30,14,3,234,18,91,41,204,33,122,85,224,101,4,71,69,6,38,24,16,98,205,31,97,199,200,196,22,218,2,34,7,28,235,66,229,227,226,230,178,19,207,219,233,119,8,15,131,10,228,99,212,217,50,62,206,52,70,157,45,51,13,39,209,76,21,43,27,20,89,210,195,54,29,9,169,183,42,73,75,90,188]),function(z,e,m,L,A,S,E,n,w,p,i,I,P,y,g,v,D,b,l,u,c,a,t,r,s,o,h,f,d,M,T,C,V,Q,te,B,Y,X,_,$,G,N,F,R,O,k,W,U,q,K,H,x,ne,re,se,le,oe,ue,me,Se,De,Ie,we,ye,Ae,Te,$e,Ne,He,it,Be,at,nt,dt,Xe,ft,lt,j,ie,ae,ce,fe,be,Me,Fe){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeApplication=void 0;let Ue=class extends V.Disposable{constructor(de,pe,ve,ge,Ee,ke,Re,Le,Pe,Ce){super();this.mainProcessNodeIpcServer=de,this.userEnv=pe,this.mainInstantiationService=ve,this.logService=ge,this.environmentMainService=Ee,this.lifecycleMainService=ke,this.configurationService=Re,this.stateMainService=Le,this.fileService=Pe,this.productService=Ce,this.configureSession(),this.registerListeners()}configureSession(){const de=ve=>ve.startsWith(`${x.Schemas.vscodeWebview}://`);A.session.defaultSession.setPermissionRequestHandler((ve,ge,Ee,ke)=>de(ke.requestingUrl)?Ee(ge==="clipboard-read"):Ee(!1)),A.session.defaultSession.setPermissionCheckHandler((ve,ge,Ee,ke)=>de(ke.requestingUrl)?ge==="clipboard-read":!1);const pe=A.session.defaultSession;typeof pe.setCodeCachePath=="function"&&this.environmentMainService.codeCachePath&&pe.setCodeCachePath(q.join(this.environmentMainService.codeCachePath,"chrome"))}registerListeners(){R.setUnexpectedErrorHandler(ve=>this.onUnexpectedError(ve)),process.on("uncaughtException",ve=>this.onUnexpectedError(ve)),process.on("unhandledRejection",ve=>R.onUnexpectedError(ve)),this.lifecycleMainService.onWillShutdown(()=>this.dispose()),U.registerContextMenuListener(),A.app.on("accessibility-support-changed",(ve,ge)=>{var Ee;(Ee=this.windowsMainService)===null||Ee===void 0||Ee.sendToAll("vscode:accessibilitySupportChanged",ge)}),A.app.on("activate",(ve,ge)=>{var Ee;this.logService.trace("app#activate"),ge||(Ee=this.windowsMainService)===null||Ee===void 0||Ee.openEmptyWindow({context:1})}),A.app.on("web-contents-created",(ve,ge)=>{ge.on("will-attach-webview",(Ee,ke,Re)=>{const Le=Pe=>{if(!Pe)return!1;const Ce=te.URI.parse(Pe);if(Ce.scheme===x.Schemas.vscodeWebview)return Ce.path==="/index.html"||Ce.path==="/electron-browser-index.html";const je=Ce.fsPath.toLowerCase(),qe=te.URI.file(this.environmentMainService.appRoot).fsPath.toLowerCase();return je.startsWith(qe+q.sep)};delete ke.preload,ke.nodeIntegration=!1,!(Le(Re.src)&&Le(ke.preloadURL))&&(delete ke.preloadURL,this.logService.error("webContents#web-contents-created: Prevented webview attach"),Ee.preventDefault())}),ge.on("will-navigate",Ee=>{this.logService.error("webContents#will-navigate: Prevented webcontent navigation"),Ee.preventDefault()}),ge.setWindowOpenHandler(({url:Ee})=>{var ke;return(ke=this.nativeHostMainService)===null||ke===void 0||ke.openExternal(void 0,Ee),{action:"deny"}})});let de=[],pe;A.app.on("open-file",(ve,ge)=>{this.logService.trace("app#open-file: ",ge),ve.preventDefault(),de.push(this.getWindowOpenableFromPathSync(ge)),pe!==void 0&&(clearTimeout(pe),pe=void 0),pe=setTimeout(()=>{var Ee;(Ee=this.windowsMainService)===null||Ee===void 0||Ee.open({context:1,cli:this.environmentMainService.args,urisToOpen:de,gotoLineMode:!1,preferNewWindow:!0}),de=[],pe=void 0},100)}),A.app.on("new-window-for-tab",()=>{var ve;(ve=this.windowsMainService)===null||ve===void 0||ve.openEmptyWindow({context:4})}),A.ipcMain.handle("vscode:fetchShellEnv",ve=>{var ge;const Ee=(ge=this.windowsMainService)===null||ge===void 0?void 0:ge.getWindowByWebContents(ve.sender);let ke,Re;return(Ee==null?void 0:Ee.config)?(ke=Ee.config,Re=Object.assign(Object.assign({},process.env),Ee.config.userEnv)):(ke=this.environmentMainService.args,Re=process.env),w.resolveShellEnv(this.logService,ke,Re)}),A.ipcMain.handle("vscode:writeNlsFile",(ve,ge,Ee)=>{const ke=this.validateNlsPath([ge]);if(!ke||typeof Ee!="string")throw new Error("Invalid operation (vscode:writeNlsFile)");return this.fileService.writeFile(ke,at.VSBuffer.fromString(Ee))}),A.ipcMain.handle("vscode:readNlsFile",async(ve,...ge)=>{const Ee=this.validateNlsPath(ge);if(!Ee)throw new Error("Invalid operation (vscode:readNlsFile)");return(await this.fileService.readFile(Ee)).value.toString()}),A.ipcMain.on("vscode:toggleDevTools",ve=>ve.sender.toggleDevTools()),A.ipcMain.on("vscode:openDevTools",ve=>ve.sender.openDevTools()),A.ipcMain.on("vscode:reloadWindow",ve=>ve.sender.reload())}validateNlsPath(de){let pe;for(const ve of de)typeof ve=="string"&&(typeof pe!="string"?pe=ve:pe=q.join(pe,ve));if(!(typeof pe!="string"||!q.isAbsolute(pe)||!lt.isEqualOrParent(pe,this.environmentMainService.cachedLanguagesPath,!S.isLinux)))return te.URI.file(pe)}onUnexpectedError(de){var pe;if(de){const ve={message:`[uncaught exception in main]: ${de.message}`,stack:de.stack};(pe=this.windowsMainService)===null||pe===void 0||pe.sendToFocused("vscode:reportError",JSON.stringify(ve))}this.logService.error(`[uncaught exception in main]: ${de}`),de.stack&&this.logService.error(de.stack)}async startup(){this.logService.debug("Starting VS Code"),this.logService.debug(`from: ${this.environmentMainService.appRoot}`),this.logService.debug("args:",this.environmentMainService.args);const de=this.productService.win32AppUserModelId;S.isWindows&&de&&A.app.setAppUserModelId(de);try{S.isMacintosh&&this.configurationService.getValue("window.nativeTabs")===!0&&!A.systemPreferences.getUserDefault("NSUseImprovedLayoutPass","boolean")&&A.systemPreferences.setUserDefault("NSUseImprovedLayoutPass","boolean",!0)}catch(Pe){this.logService.error(Pe)}const pe=new P.Server;this.logService.trace("Resolving machine identifier...");const ve=await this.resolveMachineId();this.logService.trace(`Resolved machine identifier: ${ve}`);const{sharedProcess:ge,sharedProcessReady:Ee,sharedProcessClient:ke}=this.setupSharedProcess(ve),Re=await this.initServices(ve,ge,Ee);if(this.environmentMainService.driverHandle){const Pe=await k.serve(pe,this.environmentMainService.driverHandle,this.environmentMainService,Re);this.logService.info("Driver started at:",this.environmentMainService.driverHandle),this._register(Pe)}this._register(Re.createInstance(C.ProxyAuthHandler)),Re.invokeFunction(Pe=>this.initChannels(Pe,pe,ke));const Le=Re.invokeFunction(Pe=>this.openFirstWindow(Pe,pe));Re.invokeFunction(Pe=>this.afterWindowOpen(Pe,ge)),this.environmentMainService.args.trace&&Re.invokeFunction(Pe=>this.stopTracingEventually(Pe,Le))}async resolveMachineId(){let de=this.stateMainService.getItem(o.machineIdKey);return(!de||S.isMacintosh&&de==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(de=await X.getMachineId(),this.stateMainService.setItem(o.machineIdKey,de)),de}setupSharedProcess(de){const pe=this._register(this.mainInstantiationService.createInstance(g.SharedProcess,de,this.userEnv)),ve=(async()=>{this.logService.trace("Main->SharedProcess#connect");const Ee=await pe.connect();return this.logService.trace("Main->SharedProcess#connect: connection established"),new y.Client(Ee,"main")})(),ge=(async()=>(await pe.whenReady(),ve))();return{sharedProcess:pe,sharedProcessReady:ge,sharedProcessClient:ve}}async initServices(de,pe,ve){const ge=new b.ServiceCollection;switch(process.platform){case"win32":ge.set(p.IUpdateService,new l.SyncDescriptor(_.Win32UpdateService));break;case"linux":S.isLinuxSnap?ge.set(p.IUpdateService,new l.SyncDescriptor(ne.SnapUpdateService,[process.env.SNAP,process.env.SNAP_REVISION])):ge.set(p.IUpdateService,new l.SyncDescriptor($.LinuxUpdateService));break;case"darwin":ge.set(p.IUpdateService,new l.SyncDescriptor(G.DarwinUpdateService));break}ge.set(Q.IWindowsMainService,new l.SyncDescriptor(E.WindowsMainService,[de,this.userEnv])),ge.set(ye.IDialogMainService,new l.SyncDescriptor(ye.DialogMainService)),ge.set(v.ILaunchMainService,new l.SyncDescriptor(v.LaunchMainService)),ge.set(De.IDiagnosticsService,I.ProxyChannel.toService(I.getDelayedChannel(ve.then(ke=>ke.getChannel("diagnostics"))))),ge.set(N.IIssueMainService,new l.SyncDescriptor(N.IssueMainService,[this.userEnv])),ge.set(nt.IEncryptionMainService,new l.SyncDescriptor(nt.EncryptionMainService,[de])),ge.set(Xe.IKeyboardLayoutMainService,new l.SyncDescriptor(Xe.KeyboardLayoutMainService)),ge.set(we.INativeHostMainService,new l.SyncDescriptor(we.NativeHostMainService,[pe])),ge.set(Ne.IWebviewManagerService,new l.SyncDescriptor($e.WebviewMainService)),ge.set(B.IWorkspacesService,new l.SyncDescriptor(Y.WorkspacesMainService)),ge.set(Se.IWorkspacesManagementMainService,new l.SyncDescriptor(Se.WorkspacesManagementMainService)),ge.set(ue.IWorkspacesHistoryMainService,new l.SyncDescriptor(ue.WorkspacesHistoryMainService)),ge.set(W.IMenubarMainService,new l.SyncDescriptor(W.MenubarMainService)),ge.set(ie.IExtensionUrlTrustService,new l.SyncDescriptor(ae.ExtensionUrlTrustService)),ge.set(re.IStorageMainService,new l.SyncDescriptor(re.StorageMainService)),S.isWindows?ge.set(Me.IExternalTerminalMainService,new l.SyncDescriptor(Fe.WindowsExternalTerminalService)):S.isMacintosh?ge.set(Me.IExternalTerminalMainService,new l.SyncDescriptor(Fe.MacExternalTerminalService)):S.isLinux&&ge.set(Me.IExternalTerminalMainService,new l.SyncDescriptor(Fe.LinuxExternalTerminalService));const Ee=new le.BackupMainService(this.environmentMainService,this.configurationService,this.logService);if(ge.set(oe.IBackupMainService,Ee),ge.set(r.IURLService,new l.SyncDescriptor(me.NativeURLService)),!this.environmentMainService.isExtensionDevelopment&&!this.environmentMainService.args["disable-telemetry"]&&!!this.productService.enableTelemetry){const ke=I.getDelayedChannel(ve.then(je=>je.getChannel("telemetryAppender"))),Re=new f.TelemetryAppenderClient(ke),Le=M.resolveCommonProperties(this.fileService,m.release(),m.hostname(),process.arch,this.productService.commit,this.productService.version,de,this.productService.msftInternalDomains,this.environmentMainService.installSourcePath),Pe=[this.environmentMainService.appRoot,this.environmentMainService.extensionsPath],Ce={appender:Re,commonProperties:Le,piiPaths:Pe,sendErrorTelemetry:!0};ge.set(o.ITelemetryService,new l.SyncDescriptor(d.TelemetryService,[Ce]))}else ge.set(o.ITelemetryService,h.NullTelemetryService);return await Ee.initialize(),this.mainInstantiationService.createChild(ge)}initChannels(de,pe,ve){const ge=I.ProxyChannel.fromService(de.get(v.ILaunchMainService),{disableMarshalling:!0});this.mainProcessNodeIpcServer.registerChannel("launch",ge);const Ee=new i.UpdateChannel(de.get(p.IUpdateService));pe.registerChannel("update",Ee);const ke=I.ProxyChannel.fromService(de.get(N.IIssueMainService));pe.registerChannel("issue",ke);const Re=I.ProxyChannel.fromService(de.get(nt.IEncryptionMainService));pe.registerChannel("encryption",Re);const Le=I.ProxyChannel.fromService(de.get(be.ISignService));pe.registerChannel("sign",Le);const Pe=I.ProxyChannel.fromService(de.get(Xe.IKeyboardLayoutMainService));pe.registerChannel("keyboardLayout",Pe),this.nativeHostMainService=de.get(we.INativeHostMainService);const Ce=I.ProxyChannel.fromService(this.nativeHostMainService);pe.registerChannel("nativeHost",Ce),ve.then(Ve=>Ve.registerChannel("nativeHost",Ce));const je=I.ProxyChannel.fromService(de.get(B.IWorkspacesService));pe.registerChannel("workspaces",je);const qe=I.ProxyChannel.fromService(de.get(W.IMenubarMainService));pe.registerChannel("menubar",qe);const Ge=I.ProxyChannel.fromService(de.get(r.IURLService));pe.registerChannel("url",Ge);const Qe=I.ProxyChannel.fromService(de.get(ie.IExtensionUrlTrustService));pe.registerChannel("extensionUrlTrust",Qe);const _e=I.ProxyChannel.fromService(de.get(Ne.IWebviewManagerService));pe.registerChannel("webview",_e);const rt=this._register(new se.StorageDatabaseChannel(this.logService,de.get(re.IStorageMainService)));pe.registerChannel("storage",rt),ve.then(Ve=>Ve.registerChannel("storage",rt));const st=I.ProxyChannel.fromService(de.get(Me.IExternalTerminalMainService));pe.registerChannel("externalTerminal",st);const et=new F.LogLevelChannel(de.get(u.ILogService));pe.registerChannel("logLevel",et),ve.then(Ve=>Ve.registerChannel("logLevel",et));const ot=new F.LoggerChannel(de.get(u.ILoggerService));pe.registerChannel("logger",ot),ve.then(Ve=>Ve.registerChannel("logger",ot));const ct=new Ie.ElectronExtensionHostDebugBroadcastChannel(de.get(Q.IWindowsMainService));pe.registerChannel("extensionhostdebugservice",ct)}openFirstWindow(de,pe){const ve=this.windowsMainService=de.get(Q.IWindowsMainService),ge=de.get(r.IURLService),Ee=de.get(we.INativeHostMainService);this.lifecycleMainService.phase=2;const ke=[],Re=[...this.environmentMainService.args["open-url"]?this.environmentMainService.args._urls||[]:[],...global.getOpenUrls()||[]].map(We=>{try{return{uri:te.URI.parse(We),url:We}}catch(Je){return}}).filter(We=>{if(!We||this.shouldBlockURI(We.uri))return!1;const Je=this.getWindowOpenableFromProtocolLink(We.uri);return Je?(ke.push(Je),!1):!0}),Le=this,Pe=this.environmentMainService,Ce=this.productService;ge.registerHandler({async handleURL(We,Je){if(We.scheme===Ce.urlProtocol&&We.path==="workspace"&&(We=We.with({authority:"file",path:te.URI.parse(We.query).path,query:""})),Le.shouldBlockURI(We))return!0;const Et=Le.getWindowOpenableFromProtocolLink(We);if(Et){const[mt]=ve.open({context:5,cli:Object.assign({},Pe.args),urisToOpen:[Et],gotoLineMode:!0});return mt.focus(),!0}if(S.isMacintosh&&ve.getWindowCount()===0){const[mt]=ve.open({context:5,cli:Object.assign({},Pe.args),forceEmpty:!0,gotoLineMode:!0,remoteAuthority:fe.getRemoteAuthority(We)});return await mt.ready(),ge.open(We,Je)}return!1}});const je=this._register(new dt.ActiveWindowManager({onDidOpenWindow:Ee.onDidOpenWindow,onDidFocusWindow:Ee.onDidFocusWindow,getActiveWindowId:()=>Ee.getActiveWindowId(-1)})),qe=new I.StaticRouter(We=>je.getActiveClientId().then(Je=>We===Je)),Ge=new s.URLHandlerRouter(qe),Qe=pe.getChannel("urlHandler",Ge);ge.registerHandler(new s.URLHandlerChannelClient(Qe)),this._register(new O.ElectronURLListener(Re,ge,ve,this.environmentMainService,this.productService));const _e=this.environmentMainService.args,rt=global.macOpenFiles,st=ft.isLaunchedFromCli(process.env)?0:4,et=_e._.length,ot=!!_e["folder-uri"],ct=!!_e["file-uri"],Ve=_e["skip-add-to-recently-opened"]===!0,gt=_e.wait&&_e.waitMarkerFilePath?te.URI.file(_e.waitMarkerFilePath):void 0,bt=_e.remote||void 0;return ke.length>0?ve.open({context:st,cli:_e,urisToOpen:ke,gotoLineMode:!0,initialStartup:!0}):_e["new-window"]&&!et&&!ot&&!ct?ve.open({context:st,cli:_e,forceNewWindow:!0,forceEmpty:!0,noRecentEntry:Ve,waitMarkerFileURI:gt,initialStartup:!0,remoteAuthority:bt}):rt.length&&!et&&!ot&&!ct?ve.open({context:1,cli:_e,urisToOpen:rt.map(We=>this.getWindowOpenableFromPathSync(We)),noRecentEntry:Ve,waitMarkerFileURI:gt,initialStartup:!0}):ve.open({context:st,cli:_e,forceNewWindow:_e["new-window"]||!et&&_e["unity-launch"],diffMode:_e.diff,noRecentEntry:Ve,waitMarkerFileURI:gt,gotoLineMode:_e.goto,initialStartup:!0,remoteAuthority:bt})}shouldBlockURI(de){return!!(de.authority===x.Schemas.file&&S.isWindows&&A.dialog.showMessageBoxSync({title:this.productService.nameLong,type:"question",buttons:[Te.mnemonicButtonLabel(H.localize(0,null)),Te.mnemonicButtonLabel(H.localize(1,null))],cancelId:1,message:H.localize(2,null,Te.getPathLabel(de.fsPath,this.environmentMainService),this.productService.nameShort),detail:H.localize(3,null),noLink:!0})===1)}getWindowOpenableFromProtocolLink(de){if(!!de.path){if(de.authority===x.Schemas.file)return{fileUri:te.URI.file(de.fsPath)};if(de.authority===x.Schemas.vscodeRemote){const pe=de.path.indexOf(q.posix.sep,1);if(pe!==-1){const ve=de.path.substring(1,pe),ge=de.path.substring(pe),Ee=te.URI.from({scheme:x.Schemas.vscodeRemote,authority:ve,path:ge,query:de.query,fragment:de.fragment});return B.hasWorkspaceFileExtension(ge)?{workspaceUri:Ee}:/:[\d]+$/.test(ge)?{fileUri:Ee}:{folderUri:Ee}}}}}getWindowOpenableFromPathSync(de){try{if(L.statSync(de).isDirectory())return{folderUri:te.URI.file(de)};if(B.hasWorkspaceFileExtension(de))return{workspaceUri:te.URI.file(de)}}catch(pe){}return{fileUri:te.URI.file(de)}}async afterWindowOpen(de,pe){var ve;this.lifecycleMainService.phase=3;let ge=!1;ce.once(this.lifecycleMainService.onWillShutdown)(()=>ge=!0);const Ee=de.get(o.ITelemetryService);this._register(pe.onDidError(({type:Le,details:Pe})=>{var Ce,je,qe,Ge;let Qe;switch(Le){case 1:Qe="SharedProcess: detected unresponsive window";break;case 2:Qe=`SharedProcess: crashed (detail: ${(Ce=Pe==null?void 0:Pe.reason)!==null&&Ce!==void 0?Ce:"<unknown>"}, code: ${(je=Pe==null?void 0:Pe.exitCode)!==null&&je!==void 0?je:"<unknown>"})`;break;case 3:Qe=`SharedProcess: failed to load (detail: ${(qe=Pe==null?void 0:Pe.reason)!==null&&qe!==void 0?qe:"<unknown>"}, code: ${(Ge=Pe==null?void 0:Pe.exitCode)!==null&&Ge!==void 0?Ge:"<unknown>"})`;break}R.onUnexpectedError(new Error(Qe)),Ee.publicLog2("sharedprocesserror",{type:Le,reason:Pe==null?void 0:Pe.reason,code:Pe==null?void 0:Pe.exitCode,visible:pe.isVisible(),shuttingdown:ge})}));const ke=this.productService.win32MutexName;if(S.isWindows&&ke)try{const Le=z.__$__nodeRequire("windows-mutex").Mutex,Pe=new Le(ke);ce.once(this.lifecycleMainService.onWillShutdown)(()=>Pe.release())}catch(Le){this.logService.error(Le)}A.protocol.registerHttpProtocol(x.Schemas.vscodeRemoteResource,(Le,Pe)=>{Pe({url:Le.url.replace(/^vscode-remote-resource:/,"http:"),method:Le.method})});const Re=de.get(p.IUpdateService);(Re instanceof _.Win32UpdateService||Re instanceof $.LinuxUpdateService||Re instanceof G.DarwinUpdateService)&&Re.initialize(),(async()=>{const Le=this._register(new j.RunOnceScheduler(()=>this.logService.warn("Resolving your shell environment is taking more than 10s. Please review your shell configuration. Learn more at https://go.microsoft.com/fwlink/?linkid=2149667."),1e4));Le.schedule(),await w.resolveShellEnv(this.logService,this.environmentMainService.args,process.env),Le.dispose()})();try{const Pe=(await this.fileService.readFile(this.environmentMainService.argvResource)).value.toString();if(JSON.parse(it.stripComments(Pe))["enable-crash-reporter"]===void 0){const je=(ve=this.configurationService.getValue("telemetry.enableCrashReporter"))!==null&&ve!==void 0?ve:!0,qe=["","	// Allows to disable crash reporting.","	// Should restart the app if the value is changed.",`	"enable-crash-reporter": ${je},`,"","	// Unique id used for correlating crash reports sent from this instance.","	// Do not edit this value.",`	"crash-reporter-id": "${Be.generateUuid()}"`,"}"],Ge=Pe.substring(0,Pe.length-2).concat(`,
`,qe.join(`
`));await this.fileService.writeFile(this.environmentMainService.argvResource,at.VSBuffer.fromString(Ge))}}catch(Le){this.logService.error(Le)}}stopTracingEventually(de,pe){this.logService.info("Tracing: waiting for windows to get ready...");const ve=de.get(ye.IDialogMainService);let ge=!1;const Ee=async Re=>{if(ge)return;ge=!0;const Le=await A.contentTracing.stopRecording(K.joinPath(this.environmentMainService.userHome,`${this.productService.applicationName}-${Math.random().toString(16).slice(-4)}.trace.txt`).fsPath);Re?this.logService.info(`Tracing: data recorded (after 30s timeout) to ${Le}`):ve.showMessageBox({type:"info",message:H.localize(4,null),detail:H.localize(5,null,Le),buttons:[H.localize(6,null)]},Ae.withNullAsUndefined(A.BrowserWindow.getFocusedWindow()))},ke=setTimeout(()=>Ee(!0),3e4);Promise.all(pe.map(Re=>Re.ready())).then(()=>{clearTimeout(ke),Ee(!1)})}};Ue=he([ee(2,D.IInstantiationService),ee(3,u.ILogService),ee(4,a.IEnvironmentMainService),ee(5,n.ILifecycleMainService),ee(6,t.IConfigurationService),ee(7,c.IStateMainService),ee(8,He.IFileService),ee(9,T.IProductService)],Ue),e.CodeApplication=Ue}),define(J[240],Z([0,1,14,30,17,11,3,72,47,54,161,18,33,56,173,71,69,6,225,38,16,187,49,223,236,39,94,93,19,60,42,75,194,197,181,182,10,21,74,221,22,29,23,8,35,24,67,97,179,32,55,184,9,203]),function(z,e,m,L,A,S,E,n,w,p,i,I,P,y,g,v,D,b,l,u,c,a,t,r,s,o,h,f,d,M,T,C,V,Q,te,B,Y,X,_,$,G,N,F,R,O,k,W,U,q,K,H,x,ne){"use strict";Object.defineProperty(e,"__esModule",{value:!0});class re{main(){try{this.startup()}catch(oe){console.error(oe.message),m.app.exit(1)}}async startup(){d.setUnexpectedErrorHandler(ye=>console.error(ye));const[oe,ue,me,Se,De,Ie,we]=this.createServices();try{try{await this.initServices(me,Se,De)}catch(ye){throw this.handleStartupDataDirError(me,we.nameLong,ye),ye}await oe.invokeFunction(async ye=>{const Ae=ye.get(b.ILogService),Te=ye.get(I.ILifecycleMainService),$e=ye.get(X.IFileService),Ne=await this.claimInstance(Ae,me,Te,oe,we,!0);return Ie.logger=new h.SpdLogLogger("main",R.join(me.logsPath,"main.log"),!0,Ie.getLevel()),T.once(Te.onWillShutdown)(()=>{$e.dispose(),Se.dispose()}),oe.createInstance(s.CodeApplication,Ne,ue).startup()})}catch(ye){oe.invokeFunction(this.quit,ye)}}createServices(){const oe=new v.ServiceCollection,ue=Object.assign({_serviceBrand:void 0},w.default);oe.set(G.IProductService,ue);const me=new k.EnvironmentMainService(this.resolveArgs(),ue),Se=this.patchEnvironment(me);oe.set(k.IEnvironmentMainService,me);const De=new f.BufferLogService,Ie=new b.MultiplexLogService([new b.ConsoleMainLogger(b.getLogLevel(me)),De]);process.once("exit",()=>Ie.dispose()),oe.set(b.ILogService,Ie);const we=new te.FileService(Ie);oe.set(X.IFileService,we);const ye=new B.DiskFileSystemProvider(Ie);we.registerProvider(Y.Schemas.file,ye),oe.set(b.ILoggerService,new q.LoggerService(Ie,we));const Ae=new a.ConfigurationService(me.settingsResource,we);oe.set(c.IConfigurationService,Ae),oe.set(I.ILifecycleMainService,new D.SyncDescriptor(I.LifecycleMainService));const Te=new l.StateMainService(me,Ie,we);return oe.set(u.IStateMainService,Te),oe.set(t.IRequestService,new D.SyncDescriptor(r.RequestMainService)),oe.set(M.IThemeMainService,new D.SyncDescriptor(M.ThemeMainService)),oe.set(C.ISignService,new D.SyncDescriptor(V.SignService)),oe.set(_.ITunnelService,new D.SyncDescriptor($.TunnelService)),oe.set(H.IProtocolMainService,new D.SyncDescriptor(x.ProtocolMainService)),[new g.InstantiationService(oe,!0),Se,me,Ae,Te,De,ue]}patchEnvironment(oe){const ue={VSCODE_IPC_HOOK:oe.mainIPCHandle};return["VSCODE_NLS_CONFIG","VSCODE_PORTABLE"].forEach(me=>{const Se=process.env[me];typeof Se=="string"&&(ue[me]=Se)}),Object.assign(process.env,ue),ue}initServices(oe,ue,me){return ne.Promises.settled([Promise.all([oe.extensionsPath,oe.codeCachePath,oe.logsPath,oe.globalStorageHome.fsPath,oe.workspaceStorageHome.fsPath,oe.backupHome].map(Se=>Se?A.Promises.mkdir(Se,{recursive:!0}):void 0)),ue.initialize(),me.init()])}async claimInstance(oe,ue,me,Se,De,Ie){let we;try{n.mark("code/willStartMainServer"),we=await y.serve(ue.mainIPCHandle),n.mark("code/didStartMainServer"),T.once(me.onWillShutdown)(()=>we.dispose())}catch(ye){if(ye.code!=="EADDRINUSE")throw this.handleStartupDataDirError(ue,De.nameLong,ye),ye;let Ae;try{Ae=await y.connect(ue.mainIPCHandle,"main")}catch(Ne){if(!Ie||E.isWindows||Ne.code!=="ECONNREFUSED")throw Ne.code==="EPERM"&&this.showStartupWarningDialog(S.localize(0,null,De.nameShort),S.localize(1,null),De.nameLong),Ne;try{L.unlinkSync(ue.mainIPCHandle)}catch(He){throw oe.warn("Could not delete obsolete instance handle",He),He}return this.claimInstance(oe,ue,me,Se,De,!1)}if(ue.extensionTestsLocationURI&&!ue.debugExtensionHost.break){const Ne="Running extension tests from the command line is currently only supported if no other instance of Code is running.";throw oe.error(Ne),Ae.dispose(),new Error(Ne)}let Te;!ue.args.wait&&!ue.args.status&&(Te=setTimeout(()=>{this.showStartupWarningDialog(S.localize(2,null,De.nameShort),S.localize(3,null),De.nameLong)},1e4));const $e=P.ProxyChannel.toService(Ae.getChannel("launch"),{disableMarshalling:!0});if(ue.args.status)return Se.invokeFunction(async()=>{const Ne=new Q.DiagnosticsService(U.NullTelemetryService,De),He=await $e.getMainProcessInfo(),it=await $e.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0}),Be=await Ne.getDiagnostics(He,it);throw console.log(Be),new d.ExpectedError});throw E.isWindows&&await this.windowsAllowSetForegroundWindow($e,oe),oe.trace("Sending env to running instance..."),await $e.start(ue.args,process.env),Ae.dispose(),Te&&clearTimeout(Te),new d.ExpectedError("Sent env to running instance. Terminating...")}if(ue.args.status)throw oe.warn("Warning: The --status argument can only be used if Code is already running. Please run it again after Code has started."),new d.ExpectedError("Terminating...");return process.env.VSCODE_PID=String(process.pid),we}handleStartupDataDirError(oe,ue,me){if(me.code==="EACCES"||me.code==="EPERM"){const Se=O.coalesce([oe.userDataPath,oe.extensionsPath,y.XDG_RUNTIME_DIR]).map(De=>o.getPathLabel(De,oe));this.showStartupWarningDialog(S.localize(4,null),S.localize(5,null,W.toErrorMessage(me),Se.join(`
`)),ue)}}showStartupWarningDialog(oe,ue,me){m.dialog.showMessageBoxSync({title:me,type:"warning",buttons:[o.mnemonicButtonLabel(S.localize(6,null))],message:oe,detail:ue,noLink:!0})}async windowsAllowSetForegroundWindow(oe,ue){if(E.isWindows){const me=await oe.getMainProcessId();ue.trace("Sending some foreground love to the running instance:",me);try{(await new Promise((Se,De)=>{z(["windows-foreground-love"],Se,De)})).allowSetForegroundWindow(me)}catch(Se){ue.error(Se)}}}quit(oe,ue){const me=oe.get(b.ILogService),Se=oe.get(I.ILifecycleMainService);let De=0;ue&&(ue.isExpected?ue.message&&me.trace(ue.message):(De=1,ue.stack?me.error(ue.stack):me.error(`Startup error: ${ue.toString()}`))),Se.kill(De)}resolveArgs(){const oe=this.validatePaths(p.parseMainProcessArgv(process.argv));if(oe.wait&&!oe.waitMarkerFilePath){const ue=i.createWaitMarkerFile(oe.verbose);ue&&(p.addArg(process.argv,"--waitMarkerFilePath",ue),oe.waitMarkerFilePath=ue)}return oe}validatePaths(oe){if(oe["open-url"]&&(oe._urls=oe._,oe._=[]),!oe.remote){const ue=this.doValidatePaths(oe._,oe.goto);oe._=ue}return oe}doValidatePaths(oe,ue){const me=K.cwd(),Se=oe.map(we=>{let ye=String(we),Ae;ue&&(Ae=N.parseLineAndColumnAware(ye),ye=Ae.path),ye&&(ye=this.preparePath(me,ye));const Te=N.sanitizeFilePath(ye,me),$e=R.basename(Te);return $e&&!N.isValidBasename($e)?null:ue&&Ae?(Ae.path=Te,this.toPath(Ae)):Te}),De=E.isWindows||E.isMacintosh,Ie=O.distinct(Se,we=>we&&De?we.toLowerCase():we||"");return O.coalesce(Ie)}preparePath(oe,ue){return E.isWindows&&(ue=F.rtrim(ue,'"')),ue=F.trim(F.trim(ue," "),"	"),E.isWindows&&(ue=R.resolve(oe,ue),ue=F.rtrim(ue,".")),ue}toPath(oe){const ue=[oe.path];return typeof oe.line=="number"&&ue.push(String(oe.line)),typeof oe.column=="number"&&ue.push(String(oe.column)),ue.join(":")}}new re().main()})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/012b14606f75ec4fed90d7ab4154f63dffab9503/core/vs/code/electron-main/main.js.map
