/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ge=["require","exports","vs/base/common/uri","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/base/common/strings","vs/base/common/path","vs/base/common/network","vs/base/common/platform","vs/platform/log/common/log","vs/workbench/api/common/extHostRpcService","vs/base/common/errors","vs/base/common/types","vs/base/common/async","vs/workbench/api/common/extHostTypeConverters","vs/base/common/arrays","vs/nls","vs/nls!vs/workbench/services/extensions/node/extensionHostProcess","vs/base/common/cancellation","vs/base/common/buffer","vs/base/common/map","vs/base/common/resources","vs/base/common/objects","vs/platform/extensions/common/extensions","vs/workbench/api/common/extHostInitDataService","vs/base/node/pfs","vs/base/common/extpath","vs/base/common/glob","vs/workbench/services/search/common/search","vs/base/common/uuid","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostWorkspace","vs/workbench/services/extensions/common/extensions","vs/workbench/api/common/extHostConfiguration","vs/base/common/process","child_process","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostExtensionService","vs/editor/common/core/range","vs/platform/files/common/files","vs/base/common/stopwatch","vs/editor/common/core/position","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostCommands","vs/workbench/api/common/extHostDebugService","vs/base/common/assert","vs/base/common/decorators","vs/base/common/json","vs/base/common/severity","vs/base/common/marshalling","fs","vs/base/common/errorMessage","vs/platform/registry/common/platform","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostOutput","vs/workbench/api/common/extHostWebview","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/base/common/performance","vs/workbench/api/common/extHostSearch","vs/base/common/collections","vs/base/common/functional","vs/base/common/idGenerator","vs/base/common/iterator","vs/base/common/linkedList","vs/base/common/numbers","vs/base/common/hash","vs/base/common/normalization","vs/base/common/labels","vs/editor/common/modes/languageSelector","vs/platform/instantiation/common/extensions","vs/editor/common/modes","vs/platform/instantiation/common/serviceCollection","vs/platform/configuration/common/configurationRegistry","vs/platform/configuration/common/configuration","vs/platform/remote/common/remoteHosts","vs/workbench/api/common/cache","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/api/common/shared/webview","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/api/common/exHostSecretState","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostStorage","vs/workbench/api/common/extHostStoragePaths","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/common/codicons","vs/base/common/stream","vs/base/common/uint","vs/base/common/filters","vs/base/common/htmlContent","vs/base/common/comparers","vs/base/common/fuzzyScorer","vs/base/common/mime","vs/base/common/uriIpc","string_decoder","os","vs/base/node/extpath","vs/base/parts/ipc/common/ipc","vs/base/parts/ipc/common/ipc.net","vs/editor/common/core/characterClassifier","vs/editor/common/model","vs/editor/common/model/wordHelper","vs/editor/common/services/semanticTokensDto","vs/editor/common/viewModel/prefixSumComputer","vs/base/node/processes","vs/platform/instantiation/common/descriptors","vs/platform/contextkey/common/contextkey","vs/platform/log/node/spdlogLog","vs/platform/markers/common/markers","vs/platform/progress/common/progress","vs/platform/remote/common/remoteAuthorityResolver","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostDocumentData","vs/workbench/contrib/debug/common/abstractDebugAdapter","net","vs/workbench/contrib/testing/common/testCollection","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTextEditor","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostWindow","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/parts/ipc/node/ipc.net","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/lazy","vs/base/common/processes","vs/base/common/iconLabels","vs/base/node/decoder","vs/editor/common/controller/wordCharacterClassifier","vs/editor/common/core/selection","vs/editor/common/model/textModelSearch","vs/editor/common/modes/languageConfiguration","vs/editor/common/modes/linkComputer","vs/editor/common/modes/tokenizationRegistry","vs/editor/common/model/mirrorTextModel","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/node/processes","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/workspaces/common/workspaces","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/api/node/extHostDebugService","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/node/debugAdapter","vs/nls!vs/workbench/contrib/search/common/queryBuilder","vs/nls!vs/workbench/contrib/tasks/common/taskService","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/platform/editor/common/editor","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/editor/common/services/modelService","vs/editor/common/modes/languageFeatureRegistry","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/externalTerminal/common/externalTerminal","vs/platform/instantiation/common/instantiationService","vs/platform/notification/common/notification","vs/platform/opener/common/opener","vs/platform/product/common/product","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/sign/node/signService","vs/platform/terminal/common/terminalDataBuffering","vs/platform/workspaces/common/workspaces","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostNotebookConcatDocument","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/common/extHostCodeInsets","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","vs/workbench/contrib/debug/node/terminals","vs/workbench/contrib/tasks/common/taskService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/editor/common/editorService","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostTreeViews","vs/workbench/contrib/testing/common/ownedTestCollection","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/node/extHostLogService","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostOutputService","vs/workbench/api/node/extHostTerminalService","vs/workbench/api/node/extHostTunnelService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/api/common/extHostTesting","vs/workbench/contrib/search/common/queryBuilder","vs/workbench/api/common/shared/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/node/extHostDebugService","vs/workbench/api/node/extHostTask","vs/workbench/services/extensions/common/extensionHostMain","vs/workbench/services/search/common/fileSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/services/textfile/common/encoding","vs/workbench/services/extensions/node/proxyResolver","http","vs/workbench/services/search/node/ripgrepFileSearch","vscode-ripgrep","vs/workbench/services/search/node/fileSearch","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/workbench/api/node/extHostCLIServer","vs/workbench/api/node/extHostExtensionService","vs/workbench/api/node/extHost.node.services","vs/workbench/services/extensions/node/extensionHostProcessSetup","util","vs/base/common/marked/marked","https","tls","vscode-proxy-agent","events","vscode-regexpp","graceful-fs","crypto","zlib","minimist","vs/workbench/services/extensions/node/extensionHostProcess"],pe=function(Q){for(var e=[],v=0,R=Q.length;v<R;v++)e[v]=ge[Q[v]];return e};define(ge[50],pe([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function v(R,k){if(!R)throw new Error(k?`Assertion failed (${k})`:"Assertion Failed")}e.ok=v}),define(ge[67],pe([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const v=Object.prototype.hasOwnProperty;function R(s){const I=[];for(let l in s)v.call(s,l)&&I.push(s[l]);return I}e.values=R;function k(s,I){for(let l in s)if(v.call(s,l)&&I({key:l,value:s[l]},function(){delete s[l]})===!1)return}e.forEach=k;function D(s,I){const l=Object.create(null);for(const m of s){const c=I(m);let h=l[c];h||(h=l[c]=[]),h.push(m)}return l}e.groupBy=D;function A(s){const I=Object.create(null);return s&&s.forEach((l,m)=>{I[m]=l}),I}e.fromMap=A;function P(s,I){const l=[],m=[];for(let c of s)I.has(c)||l.push(c);for(let c of I)s.has(c)||m.push(c);return{removed:l,added:m}}e.diffSets=P;function _(s,I){const l=[],m=[];for(let[c,h]of s)I.has(c)||l.push(h);for(let[c,h]of I)s.has(c)||m.push(h);return{removed:l,added:m}}e.diffMaps=_;class C{constructor(){this.map=new Map}add(I,l){let m=this.map.get(I);m||(m=new Set,this.map.set(I,m)),m.add(l)}delete(I,l){const m=this.map.get(I);!m||(m.delete(l),m.size===0&&this.map.delete(I))}forEach(I,l){const m=this.map.get(I);!m||m.forEach(l)}}e.SetMap=C}),define(ge[51],pe([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function v(A){return(P,_,C)=>{let s=null,I=null;if(typeof C.value=="function"?(s="value",I=C.value):typeof C.get=="function"&&(s="get",I=C.get),!I)throw new Error("not supported");C[s]=A(I,_)}}e.createDecorator=v;function R(A,P,_){let C=null,s=null;if(typeof _.value=="function"?(C="value",s=_.value,s.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof _.get=="function"&&(C="get",s=_.get),!s)throw new Error("not supported");const I=`$memoize$${P}`;_[C]=function(...l){return this.hasOwnProperty(I)||Object.defineProperty(this,I,{configurable:!1,enumerable:!1,writable:!1,value:s.apply(this,l)}),this[I]}}e.memoize=R;function k(A,P,_){return v((C,s)=>{const I=`$debounce$${s}`,l=`$debounce$result$${s}`;return function(...m){this[l]||(this[l]=_?_():void 0),clearTimeout(this[I]),P&&(this[l]=P(this[l],...m),m=[this[l]]),this[I]=setTimeout(()=>{C.apply(this,m),this[l]=_?_():void 0},A)}})}e.debounce=k;function D(A,P,_){return v((C,s)=>{const I=`$throttle$timer$${s}`,l=`$throttle$result$${s}`,m=`$throttle$lastRun$${s}`,c=`$throttle$pending$${s}`;return function(...h){if(this[l]||(this[l]=_?_():void 0),(this[m]===null||this[m]===void 0)&&(this[m]=-Number.MAX_VALUE),P&&(this[l]=P(this[l],...h)),this[c])return;const S=this[m]+A;S<=Date.now()?(this[m]=Date.now(),C.apply(this,[this[l]]),this[l]=_?_():void 0):(this[c]=!0,this[I]=setTimeout(()=>{this[c]=!1,this[m]=Date.now(),C.apply(this,[this[l]]),this[l]=_?_():void 0},S-Date.now()))}})}e.throttle=D}),define(ge[14],pe([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isPromiseCanceledError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class v{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(t){setTimeout(()=>{throw t.stack?new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.listeners.push(t),()=>{this._removeListener(t)}}emit(t){this.listeners.forEach(i=>{i(t)})}_removeListener(t){this.listeners.splice(this.listeners.indexOf(t),1)}setUnexpectedErrorHandler(t){this.unexpectedErrorHandler=t}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(t){this.unexpectedErrorHandler(t),this.emit(t)}onUnexpectedExternalError(t){this.unexpectedErrorHandler(t)}}e.ErrorHandler=v,e.errorHandler=new v;function R(p){e.errorHandler.setUnexpectedErrorHandler(p)}e.setUnexpectedErrorHandler=R;function k(p){_(p)||e.errorHandler.onUnexpectedError(p)}e.onUnexpectedError=k;function D(p){_(p)||e.errorHandler.onUnexpectedExternalError(p)}e.onUnexpectedExternalError=D;function A(p){if(p instanceof Error){let{name:t,message:i}=p;const r=p.stacktrace||p.stack;return{$isError:!0,name:t,message:i,stack:r}}return p}e.transformErrorForSerialization=A;const P="Canceled";function _(p){return p instanceof Error&&p.name===P&&p.message===P}e.isPromiseCanceledError=_;class C extends Error{constructor(){super(P);this.name=this.message}}e.CancellationError=C;function s(){const p=new Error(P);return p.name=p.message,p}e.canceled=s;function I(p){return p?new Error(`Illegal argument: ${p}`):new Error("Illegal argument")}e.illegalArgument=I;function l(p){return p?new Error(`Illegal state: ${p}`):new Error("Illegal state")}e.illegalState=l;function m(p){return p?new Error(`readonly property '${p} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=m;function c(p){const t=new Error(`${p} has been disposed`);return t.name="DISPOSED",t}e.disposed=c;function h(p){return p?p.message?p.message:p.stack?p.stack.split(`
`)[0]:String(p):"Error"}e.getErrorMessage=h;class S extends Error{constructor(t){super("NotImplemented");t&&(this.message=t)}}e.NotImplementedError=S;class w extends Error{constructor(t){super("NotSupported");t&&(this.message=t)}}e.NotSupportedError=w;class b extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=b;function u(p){const t=p;return t instanceof Error&&Array.isArray(t.actions)}e.isErrorWithActions=u;function d(p,t=Object.create(null)){const i=new Error(p);return t.actions&&(i.actions=t.actions),i}e.createErrorWithActions=d}),define(ge[18],pe([0,1,14]),function(Q,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.maxIndex=e.minIndex=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.uniqueFilter=e.distinctES6=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function R(U,F=0){return U[U.length-(1+F)]}e.tail=R;function k(U){if(U.length===0)throw new Error("Invalid tail call");return[U.slice(0,U.length-1),U[U.length-1]]}e.tail2=k;function D(U,F,M=(x,$)=>x===$){if(U===F)return!0;if(!U||!F||U.length!==F.length)return!1;for(let x=0,$=U.length;x<$;x++)if(!M(U[x],F[x]))return!1;return!0}e.equals=D;function A(U,F,M){let x=0,$=U.length-1;for(;x<=$;){const X=(x+$)/2|0,le=M(U[X],F);if(le<0)x=X+1;else if(le>0)$=X-1;else return X}return-(x+1)}e.binarySearch=A;function P(U,F){let M=0,x=U.length;if(x===0)return 0;for(;M<x;){const $=Math.floor((M+x)/2);F(U[$])?x=$:M=$+1}return M}e.findFirstInSorted=P;function _(U,F,M){if(U=U|0,U>=F.length)throw new TypeError("invalid index");let x=F[Math.floor(F.length*Math.random())],$=[],X=[],le=[];for(let be of F){const Re=M(be,x);Re<0?$.push(be):Re>0?X.push(be):le.push(be)}return U<$.length?_(U,$,M):U<$.length+le.length?le[0]:_(U-($.length+le.length),X,M)}e.quickSelect=_;function C(U,F){const M=[];let x;for(const $ of U.slice(0).sort(F))!x||F(x[0],$)!==0?(x=[$],M.push(x)):x.push($);return M}e.groupBy=C;function s(U,F,M){const x=[];function $(be,Re,Ce){if(Re===0&&Ce.length===0)return;const Me=x[x.length-1];Me&&Me.start+Me.deleteCount===be?(Me.deleteCount+=Re,Me.toInsert.push(...Ce)):x.push({start:be,deleteCount:Re,toInsert:Ce})}let X=0,le=0;for(;;){if(X===U.length){$(X,0,F.slice(le));break}if(le===F.length){$(X,U.length-X,[]);break}const be=U[X],Re=F[le],Ce=M(be,Re);Ce===0?(X+=1,le+=1):Ce<0?($(X,1,[]),X+=1):Ce>0&&($(X,0,[Re]),le+=1)}return x}e.sortedDiff=s;function I(U,F,M){const x=s(U,F,M),$=[],X=[];for(const le of x)$.push(...U.slice(le.start,le.start+le.deleteCount)),X.push(...le.toInsert);return{removed:$,added:X}}e.delta=I;function l(U,F,M){if(M===0)return[];const x=U.slice(0,M).sort(F);return c(U,F,x,M,U.length),x}e.top=l;function m(U,F,M,x,$){return M===0?Promise.resolve([]):new Promise((X,le)=>{(async()=>{const be=U.length,Re=U.slice(0,M).sort(F);for(let Ce=M,Me=Math.min(M+x,be);Ce<be;Ce=Me,Me=Math.min(Me+x,be)){if(Ce>M&&await new Promise(je=>setTimeout(je)),$&&$.isCancellationRequested)throw v.canceled();c(U,F,Re,Ce,Me)}return Re})().then(X,le)})}e.topAsync=m;function c(U,F,M,x,$){for(const X=M.length;x<$;x++){const le=U[x];if(F(le,M[X-1])<0){M.pop();const be=P(M,Re=>F(le,Re)<0);M.splice(be,0,le)}}}function h(U){return U.filter(F=>!!F)}e.coalesce=h;function S(U){let F=0;for(let M=0;M<U.length;M++)U[M]&&(U[F]=U[M],F+=1);U.length=F}e.coalesceInPlace=S;function w(U,F,M){U.splice(M,0,U.splice(F,1)[0])}e.move=w;function b(U){return!Array.isArray(U)||U.length===0}e.isFalsyOrEmpty=b;function u(U){return Array.isArray(U)&&U.length>0}e.isNonEmptyArray=u;function d(U,F){if(!F)return U.filter((x,$)=>U.indexOf(x)===$);const M=Object.create(null);return U.filter(x=>{const $=F(x);return M[$]?!1:(M[$]=!0,!0)})}e.distinct=d;function p(U){const F=new Set;return U.filter(M=>F.has(M)?!1:(F.add(M),!0))}e.distinctES6=p;function t(U){const F=Object.create(null);return M=>{const x=U(M);return F[x]?!1:(F[x]=!0,!0)}}e.uniqueFilter=t;function i(U,F){for(let M=U.length-1;M>=0;M--){const x=U[M];if(F(x))return M}return-1}e.lastIndex=i;function r(U,F){return U.length>0?U[0]:F}e.firstOrDefault=r;function n(U,F,M=(x,$)=>x===$){let x=0;for(let $=0,X=Math.min(U.length,F.length);$<X&&M(U[$],F[$]);$++)x++;return x}e.commonPrefixLength=n;function o(U){return[].concat(...U)}e.flatten=o;function g(U,F){let M=typeof F=="number"?U:0;typeof F=="number"?M=U:(M=0,F=U);const x=[];if(M<=F)for(let $=M;$<F;$++)x.push($);else for(let $=M;$>F;$--)x.push($);return x}e.range=g;function f(U,F,M){return U.reduce((x,$)=>(x[F($)]=M?M($):$,x),Object.create(null))}e.index=f;function E(U,F){return U.push(F),()=>y(U,F)}e.insert=E;function y(U,F){const M=U.indexOf(F);if(M>-1)return U.splice(M,1),F}e.remove=y;function a(U,F,M){const x=U.slice(0,F),$=U.slice(F);return x.concat(M,$)}e.arrayInsert=a;function L(U,F){let M;if(typeof F=="number"){let x=F;M=()=>{const $=Math.sin(x++)*179426549;return $-Math.floor($)}}else M=Math.random;for(let x=U.length-1;x>0;x-=1){const $=Math.floor(M()*(x+1)),X=U[x];U[x]=U[$],U[$]=X}}e.shuffle=L;function O(U,F){const M=U.indexOf(F);M>-1&&(U.splice(M,1),U.unshift(F))}e.pushToStart=O;function W(U,F){const M=U.indexOf(F);M>-1&&(U.splice(M,1),U.push(F))}e.pushToEnd=W;function J(U,F){return Array.isArray(U)?U.map(F):F(U)}e.mapArrayOrNot=J;function se(U){return Array.isArray(U)?U:[U]}e.asArray=se;function q(U){return U[Math.floor(Math.random()*U.length)]}e.getRandomElement=q;function N(U,F){for(const M of U){const x=F(M);if(x!==void 0)return x}}e.mapFind=N;function H(U,F){let M=Number.MAX_SAFE_INTEGER,x=0;return U.forEach(($,X)=>{const le=F($);le<M&&(M=le,x=X)}),x}e.minIndex=H;function T(U,F){let M=Number.MIN_SAFE_INTEGER,x=0;return U.forEach(($,X)=>{const le=F($);le>M&&(M=le,x=X)}),x}e.maxIndex=T}),define(ge[68],pe([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function v(R){const k=this;let D=!1,A;return function(){return D||(D=!0,A=R.apply(k,arguments)),A}}e.once=v}),define(ge[69],pe([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class v{constructor(k){this._prefix=k,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=v,e.defaultGenerator=new v("id#")}),define(ge[70],pe([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var v;(function(R){function k(p){return p&&typeof p=="object"&&typeof p[Symbol.iterator]=="function"}R.is=k;const D=Object.freeze([]);function A(){return D}R.empty=A;function*P(p){yield p}R.single=P;function _(p){return p||D}R.from=_;function C(p){return!p||p[Symbol.iterator]().next().done===!0}R.isEmpty=C;function s(p){return p[Symbol.iterator]().next().value}R.first=s;function I(p,t){for(const i of p)if(t(i))return!0;return!1}R.some=I;function l(p,t){for(const i of p)if(t(i))return i}R.find=l;function*m(p,t){for(const i of p)t(i)&&(yield i)}R.filter=m;function*c(p,t){let i=0;for(const r of p)yield t(r,i++)}R.map=c;function*h(...p){for(const t of p)for(const i of t)yield i}R.concat=h;function*S(p){for(const t of p)for(const i of t)yield i}R.concatNested=S;function w(p,t,i){let r=i;for(const n of p)r=t(r,n);return r}R.reduce=w;function*b(p,t,i=p.length){for(t<0&&(t+=p.length),i<0?i+=p.length:i>p.length&&(i=p.length);t<i;t++)yield p[t]}R.slice=b;function u(p,t=Number.POSITIVE_INFINITY){const i=[];if(t===0)return[i,p];const r=p[Symbol.iterator]();for(let n=0;n<t;n++){const o=r.next();if(o.done)return[i,R.empty()];i.push(o.value)}return[i,{[Symbol.iterator](){return r}}]}R.consume=u;function d(p,t,i=(r,n)=>r===n){const r=p[Symbol.iterator](),n=t[Symbol.iterator]();for(;;){const o=r.next(),g=n.next();if(o.done!==g.done)return!1;if(o.done)return!0;if(!i(o.value,g.value))return!1}}R.equals=d})(v=e.Iterable||(e.Iterable={}))}),define(ge[52],pe([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var v;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(v=e.ScanError||(e.ScanError={}));var R;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(R=e.SyntaxKind||(e.SyntaxKind={}));var k;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(k=e.ParseErrorCode||(e.ParseErrorCode={}));var D;(function(t){t.DEFAULT={allowTrailingComma:!0}})(D=e.ParseOptions||(e.ParseOptions={}));function A(t,i=!1){let r=0,n=t.length,o="",g=0,f=16,E=0;function y(q){let N=0,H=0;for(;N<q;){const T=t.charCodeAt(r);if(T>=48&&T<=57)H=H*16+T-48;else if(T>=65&&T<=70)H=H*16+T-65+10;else if(T>=97&&T<=102)H=H*16+T-97+10;else break;r++,N++}return N<q&&(H=-1),H}function a(q){r=q,o="",g=0,f=16,E=0}function L(){const q=r;if(t.charCodeAt(r)===48)r++;else for(r++;r<t.length&&C(t.charCodeAt(r));)r++;if(r<t.length&&t.charCodeAt(r)===46)if(r++,r<t.length&&C(t.charCodeAt(r)))for(r++;r<t.length&&C(t.charCodeAt(r));)r++;else return E=3,t.substring(q,r);let N=r;if(r<t.length&&(t.charCodeAt(r)===69||t.charCodeAt(r)===101))if(r++,(r<t.length&&t.charCodeAt(r)===43||t.charCodeAt(r)===45)&&r++,r<t.length&&C(t.charCodeAt(r))){for(r++;r<t.length&&C(t.charCodeAt(r));)r++;N=r}else E=3;return t.substring(q,N)}function O(){let q="",N=r;for(;;){if(r>=n){q+=t.substring(N,r),E=2;break}const H=t.charCodeAt(r);if(H===34){q+=t.substring(N,r),r++;break}if(H===92){if(q+=t.substring(N,r),r++,r>=n){E=2;break}switch(t.charCodeAt(r++)){case 34:q+='"';break;case 92:q+="\\";break;case 47:q+="/";break;case 98:q+="\b";break;case 102:q+="\f";break;case 110:q+=`
`;break;case 114:q+="\r";break;case 116:q+="	";break;case 117:const U=y(4);U>=0?q+=String.fromCharCode(U):E=4;break;default:E=5}N=r;continue}if(H>=0&&H<=31)if(_(H)){q+=t.substring(N,r),E=2;break}else E=6;r++}return q}function W(){if(o="",E=0,g=r,r>=n)return g=n,f=17;let q=t.charCodeAt(r);if(P(q)){do r++,o+=String.fromCharCode(q),q=t.charCodeAt(r);while(P(q));return f=15}if(_(q))return r++,o+=String.fromCharCode(q),q===13&&t.charCodeAt(r)===10&&(r++,o+=`
`),f=14;switch(q){case 123:return r++,f=1;case 125:return r++,f=2;case 91:return r++,f=3;case 93:return r++,f=4;case 58:return r++,f=6;case 44:return r++,f=5;case 34:return r++,o=O(),f=10;case 47:const N=r-1;if(t.charCodeAt(r+1)===47){for(r+=2;r<n&&!_(t.charCodeAt(r));)r++;return o=t.substring(N,r),f=12}if(t.charCodeAt(r+1)===42){r+=2;const H=n-1;let T=!1;for(;r<H;){if(t.charCodeAt(r)===42&&t.charCodeAt(r+1)===47){r+=2,T=!0;break}r++}return T||(r++,E=1),o=t.substring(N,r),f=13}return o+=String.fromCharCode(q),r++,f=16;case 45:if(o+=String.fromCharCode(q),r++,r===n||!C(t.charCodeAt(r)))return f=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return o+=L(),f=11;default:for(;r<n&&J(q);)r++,q=t.charCodeAt(r);if(g!==r){switch(o=t.substring(g,r),o){case"true":return f=8;case"false":return f=9;case"null":return f=7}return f=16}return o+=String.fromCharCode(q),r++,f=16}}function J(q){if(P(q)||_(q))return!1;switch(q){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function se(){let q;do q=W();while(q>=12&&q<=15);return q}return{setPosition:a,getPosition:()=>r,scan:i?se:W,getToken:()=>f,getTokenValue:()=>o,getTokenOffset:()=>g,getTokenLength:()=>r-g,getTokenError:()=>E}}e.createScanner=A;function P(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function _(t){return t===10||t===13||t===8232||t===8233}function C(t){return t>=48&&t<=57}var s;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(s||(s={}));function I(t,i){const r=[],n=new Object;let o;const g={value:{},offset:0,length:0,type:"object",parent:void 0};let f=!1;function E(y,a,L,O){g.value=y,g.offset=a,g.length=L,g.type=O,g.colonOffset=void 0,o=g}try{u(t,{onObjectBegin:(y,a)=>{if(i<=y)throw n;o=void 0,f=i>y,r.push("")},onObjectProperty:(y,a,L)=>{if(i<a||(E(y,a,L,"property"),r[r.length-1]=y,i<=a+L))throw n},onObjectEnd:(y,a)=>{if(i<=y)throw n;o=void 0,r.pop()},onArrayBegin:(y,a)=>{if(i<=y)throw n;o=void 0,r.push(0)},onArrayEnd:(y,a)=>{if(i<=y)throw n;o=void 0,r.pop()},onLiteralValue:(y,a,L)=>{if(i<a||(E(y,a,L,p(y)),i<=a+L))throw n},onSeparator:(y,a,L)=>{if(i<=a)throw n;if(y===":"&&o&&o.type==="property")o.colonOffset=a,f=!1,o=void 0;else if(y===","){const O=r[r.length-1];typeof O=="number"?r[r.length-1]=O+1:(f=!0,r[r.length-1]=""),o=void 0}}})}catch(y){if(y!==n)throw y}return{path:r,previousNode:o,isAtPropertyKey:f,matches:y=>{let a=0;for(let L=0;a<y.length&&L<r.length;L++)if(y[a]===r[L]||y[a]==="*")a++;else if(y[a]!=="**")return!1;return a===y.length}}}e.getLocation=I;function l(t,i=[],r=D.DEFAULT){let n=null,o=[];const g=[];function f(y){Array.isArray(o)?o.push(y):n!==null&&(o[n]=y)}return u(t,{onObjectBegin:()=>{const y={};f(y),g.push(o),o=y,n=null},onObjectProperty:y=>{n=y},onObjectEnd:()=>{o=g.pop()},onArrayBegin:()=>{const y=[];f(y),g.push(o),o=y,n=null},onArrayEnd:()=>{o=g.pop()},onLiteralValue:f,onError:(y,a,L)=>{i.push({error:y,offset:a,length:L})}},r),o[0]}e.parse=l;function m(t,i=[],r=D.DEFAULT){let n={type:"array",offset:-1,length:-1,children:[],parent:void 0};function o(y){n.type==="property"&&(n.length=y-n.offset,n=n.parent)}function g(y){return n.children.push(y),y}u(t,{onObjectBegin:y=>{n=g({type:"object",offset:y,length:-1,parent:n,children:[]})},onObjectProperty:(y,a,L)=>{n=g({type:"property",offset:a,length:-1,parent:n,children:[]}),n.children.push({type:"string",value:y,offset:a,length:L,parent:n})},onObjectEnd:(y,a)=>{n.length=y+a-n.offset,n=n.parent,o(y+a)},onArrayBegin:(y,a)=>{n=g({type:"array",offset:y,length:-1,parent:n,children:[]})},onArrayEnd:(y,a)=>{n.length=y+a-n.offset,n=n.parent,o(y+a)},onLiteralValue:(y,a,L)=>{g({type:p(y),offset:a,length:L,parent:n,value:y}),o(a+L)},onSeparator:(y,a,L)=>{n.type==="property"&&(y===":"?n.colonOffset=a:y===","&&o(a))},onError:(y,a,L)=>{i.push({error:y,offset:a,length:L})}},r);const E=n.children[0];return E&&delete E.parent,E}e.parseTree=m;function c(t,i){if(!t)return;let r=t;for(let n of i)if(typeof n=="string"){if(r.type!=="object"||!Array.isArray(r.children))return;let o=!1;for(const g of r.children)if(Array.isArray(g.children)&&g.children[0].value===n){r=g.children[1],o=!0;break}if(!o)return}else{const o=n;if(r.type!=="array"||o<0||!Array.isArray(r.children)||o>=r.children.length)return;r=r.children[o]}return r}e.findNodeAtLocation=c;function h(t){if(!t.parent||!t.parent.children)return[];const i=h(t.parent);if(t.parent.type==="property"){const r=t.parent.children[0].value;i.push(r)}else if(t.parent.type==="array"){const r=t.parent.children.indexOf(t);r!==-1&&i.push(r)}return i}e.getNodePath=h;function S(t){switch(t.type){case"array":return t.children.map(S);case"object":const i=Object.create(null);for(let r of t.children){const n=r.children[1];n&&(i[r.children[0].value]=S(n))}return i;case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=S;function w(t,i,r=!1){return i>=t.offset&&i<t.offset+t.length||r&&i===t.offset+t.length}e.contains=w;function b(t,i,r=!1){if(w(t,i,r)){const n=t.children;if(Array.isArray(n))for(let o=0;o<n.length&&n[o].offset<=i;o++){const g=b(n[o],i,r);if(g)return g}return t}}e.findNodeAtOffset=b;function u(t,i,r=D.DEFAULT){const n=A(t,!1);function o(le){return le?()=>le(n.getTokenOffset(),n.getTokenLength()):()=>!0}function g(le){return le?be=>le(be,n.getTokenOffset(),n.getTokenLength()):()=>!0}const f=o(i.onObjectBegin),E=g(i.onObjectProperty),y=o(i.onObjectEnd),a=o(i.onArrayBegin),L=o(i.onArrayEnd),O=g(i.onLiteralValue),W=g(i.onSeparator),J=o(i.onComment),se=g(i.onError),q=r&&r.disallowComments,N=r&&r.allowTrailingComma;function H(){for(;;){const le=n.scan();switch(n.getTokenError()){case 4:T(14);break;case 5:T(15);break;case 3:T(13);break;case 1:q||T(11);break;case 2:T(12);break;case 6:T(16);break}switch(le){case 12:case 13:q?T(10):J();break;case 16:T(1);break;case 15:case 14:break;default:return le}}}function T(le,be=[],Re=[]){if(se(le),be.length+Re.length>0){let Ce=n.getToken();for(;Ce!==17;){if(be.indexOf(Ce)!==-1){H();break}else if(Re.indexOf(Ce)!==-1)break;Ce=H()}}}function U(le){const be=n.getTokenValue();return le?O(be):E(be),H(),!0}function F(){switch(n.getToken()){case 11:let le=0;try{le=JSON.parse(n.getTokenValue()),typeof le!="number"&&(T(2),le=0)}catch(be){T(2)}O(le);break;case 7:O(null);break;case 8:O(!0);break;case 9:O(!1);break;default:return!1}return H(),!0}function M(){return n.getToken()!==10?(T(3,[],[2,5]),!1):(U(!1),n.getToken()===6?(W(":"),H(),X()||T(4,[],[2,5])):T(5,[],[2,5]),!0)}function x(){f(),H();let le=!1;for(;n.getToken()!==2&&n.getToken()!==17;){if(n.getToken()===5){if(le||T(4,[],[]),W(","),H(),n.getToken()===2&&N)break}else le&&T(6,[],[]);M()||T(4,[],[2,5]),le=!0}return y(),n.getToken()!==2?T(7,[2],[]):H(),!0}function $(){a(),H();let le=!1;for(;n.getToken()!==4&&n.getToken()!==17;){if(n.getToken()===5){if(le||T(4,[],[]),W(","),H(),n.getToken()===4&&N)break}else le&&T(6,[],[]);X()||T(4,[],[4,5]),le=!0}return L(),n.getToken()!==4?T(8,[4],[]):H(),!0}function X(){switch(n.getToken()){case 3:return $();case 1:return x();case 10:return U(!0);default:return F()}}return H(),n.getToken()===17?r.allowEmptyContent?!0:(T(4,[],[]),!1):X()?(n.getToken()!==17&&T(9,[],[]),!0):(T(4,[],[]),!1)}e.visit=u;function d(t,i){let r=A(t),n=[],o,g=0,f;do switch(f=r.getPosition(),o=r.scan(),o){case 12:case 13:case 17:g!==f&&n.push(t.substring(g,f)),i!==void 0&&n.push(r.getTokenValue().replace(/[^\r\n]/g,i)),g=r.getPosition();break}while(o!==17);return n.join("")}e.stripComments=d;function p(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=p}),define(ge[132],pe([0,1,52]),function(Q,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.format=void 0;function R(_,C,s){let I,l,m,c,h;if(C){for(c=C.offset,h=c+C.length,m=c;m>0&&!P(_,m-1);)m--;let g=h;for(;g<_.length&&!P(_,g);)g++;l=_.substring(m,g),I=D(l,s)}else l=_,I=0,m=0,c=0,h=_.length;const S=A(s,_);let w=!1,b=0,u;s.insertSpaces?u=k(" ",s.tabSize||4):u="	";const d=v.createScanner(l,!1);let p=!1;function t(){return S+k(u,I+b)}function i(){let g=d.scan();for(w=!1;g===15||g===14;)w=w||g===14,g=d.scan();return p=g===16||d.getTokenError()!==0,g}const r=[];function n(g,f,E){!p&&f<h&&E>c&&_.substring(f,E)!==g&&r.push({offset:f,length:E-f,content:g})}let o=i();if(o!==17){const g=d.getTokenOffset()+m,f=k(u,I);n(f,m,g)}for(;o!==17;){let g=d.getTokenOffset()+d.getTokenLength()+m,f=i(),E="";for(;!w&&(f===12||f===13);){const a=d.getTokenOffset()+m;n(" ",g,a),g=d.getTokenOffset()+d.getTokenLength()+m,E=f===12?t():"",f=i()}if(f===2)o!==1&&(b--,E=t());else if(f===4)o!==3&&(b--,E=t());else{switch(o){case 3:case 1:b++,E=t();break;case 5:case 12:E=t();break;case 13:w?E=t():E=" ";break;case 6:E=" ";break;case 10:if(f===6){E="";break}case 7:case 8:case 9:case 11:case 2:case 4:f===12||f===13?E=" ":f!==5&&f!==17&&(p=!0);break;case 16:p=!0;break}w&&(f===12||f===13)&&(E=t())}const y=d.getTokenOffset()+m;n(E,g,y),o=f}return r}e.format=R;function k(_,C){let s="";for(let I=0;I<C;I++)s+=_;return s}function D(_,C){let s=0,I=0;const l=C.tabSize||4;for(;s<_.length;){const m=_.charAt(s);if(m===" ")I++;else if(m==="	")I+=l;else break;s++}return Math.floor(I/l)}function A(_,C){for(let s=0;s<C.length;s++){const I=C.charAt(s);if(I==="\r")return s+1<C.length&&C.charAt(s+1)===`
`?`\r
`:"\r";if(I===`
`)return`
`}return _&&_.eol||`
`}e.getEOL=A;function P(_,C){return`\r
`.indexOf(_.charAt(C))!==-1}e.isEOL=P}),define(ge[133],pe([0,1,52,132]),function(Q,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function k(C,s,I){return D(C,s,void 0,I)}e.removeProperty=k;function D(C,s,I,l,m){const c=s.slice(),h=[],S=v.parseTree(C,h);let w,b;for(;c.length>0&&(b=c.pop(),w=v.findNodeAtLocation(S,c),w===void 0&&I!==void 0);)typeof b=="string"?I={[b]:I}:I=[I];if(w)if(w.type==="object"&&typeof b=="string"&&Array.isArray(w.children)){const u=v.findNodeAtLocation(w,[b]);if(u!==void 0)if(I===void 0){if(!u.parent)throw new Error("Malformed AST");const d=w.children.indexOf(u.parent);let p,t=u.parent.offset+u.parent.length;if(d>0){const i=w.children[d-1];p=i.offset+i.length}else p=w.offset+1,w.children.length>1&&(t=w.children[1].offset);return A(C,{offset:p,length:t-p,content:""},l)}else return A(C,{offset:u.offset,length:u.length,content:JSON.stringify(I)},l);else{if(I===void 0)return[];const d=`${JSON.stringify(b)}: ${JSON.stringify(I)}`,p=m?m(w.children.map(i=>i.children[0].value)):w.children.length;let t;if(p>0){const i=w.children[p-1];t={offset:i.offset+i.length,length:0,content:","+d}}else w.children.length===0?t={offset:w.offset+1,length:0,content:d}:t={offset:w.offset+1,length:0,content:d+","};return A(C,t,l)}}else if(w.type==="array"&&typeof b=="number"&&Array.isArray(w.children))if(I!==void 0){const u=`${JSON.stringify(I)}`;let d;if(w.children.length===0||b===0)d={offset:w.offset+1,length:0,content:w.children.length===0?u:u+","};else{const p=b===-1||b>w.children.length?w.children.length:b,t=w.children[p-1];d={offset:t.offset+t.length,length:0,content:","+u}}return A(C,d,l)}else{const u=b,d=w.children[u];let p;if(w.children.length===1)p={offset:w.offset+1,length:w.length-2,content:""};else if(w.children.length-1===u){const t=w.children[u-1],i=t.offset+t.length,r=w.offset+w.length;p={offset:i,length:r-2-i,content:""}}else p={offset:d.offset,length:w.children[u+1].offset-d.offset,content:""};return A(C,p,l)}else throw new Error(`Can not add ${typeof b!="number"?"index":"property"} to parent of type ${w.type}`);else{if(I===void 0)throw new Error("Can not delete in empty document");return A(C,{offset:S?S.offset:0,length:S?S.length:0,content:JSON.stringify(I)},l)}}e.setProperty=D;function A(C,s,I){let l=P(C,s),m=s.offset,c=s.offset+s.content.length;if(s.length===0||s.content.length===0){for(;m>0&&!R.isEOL(l,m-1);)m--;for(;c<l.length&&!R.isEOL(l,c);)c++}const h=R.format(l,{offset:m,length:c-m},I);for(let w=h.length-1;w>=0;w--){const b=h[w];l=P(l,b),m=Math.min(m,b.offset),c=Math.max(c,b.offset+b.length),c+=b.content.length-b.length}const S=C.length-(l.length-c)-m;return[{offset:m,length:S,content:l.substring(m,c)}]}e.withFormatting=A;function P(C,s){return C.substring(0,s.offset)+s.content+C.substring(s.offset+s.length)}e.applyEdit=P;function _(C,s){let I=s.slice(0).sort((m,c)=>{const h=m.offset-c.offset;return h===0?m.length-c.length:h}),l=C.length;for(let m=I.length-1;m>=0;m--){let c=I[m];if(c.offset+c.length<=l)C=P(C,c);else throw new Error("Overlapping edit");l=c.offset}return C}e.applyEdits=_}),define(ge[134],pe([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class v{constructor(k){this.executor=k,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(k){this._error=k}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(k){return new v(()=>k(this.getValue()))}}e.Lazy=v}),define(ge[6],pe([0,1,68,70]),function(Q,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.trackDisposable=e.setDisposableTracker=void 0;const k=!1;let D=null;function A(d){D=d}if(e.setDisposableTracker=A,k){const d="__is_disposable_tracked__";D=new class{trackDisposable(p){const t=new Error("Potentially leaked disposable").stack;setTimeout(()=>{p[d]||console.log(t)},3e3)}markTracked(p){if(p&&p!==h.None)try{p[d]=!0}catch(t){}}}}function P(d){!D||D.markTracked(d)}function _(d){return D&&D.trackDisposable(d),d}e.trackDisposable=_;class C extends Error{constructor(p){super(`Encountered errors while disposing of store. Errors: [${p.join(", ")}]`);this.errors=p}}e.MultiDisposeError=C;function s(d){return typeof d.dispose=="function"&&d.dispose.length===0}e.isDisposable=s;function I(d){if(R.Iterable.is(d)){let p=[];for(const t of d)if(t){P(t);try{t.dispose()}catch(i){p.push(i)}}if(p.length===1)throw p[0];if(p.length>1)throw new C(p);return Array.isArray(d)?[]:d}else if(d)return P(d),d.dispose(),d}e.dispose=I;function l(...d){return d.forEach(P),m(()=>I(d))}e.combinedDisposable=l;function m(d){const p=_({dispose:()=>{P(p),d()}});return p}e.toDisposable=m;class c{constructor(){this._toDispose=new Set,this._isDisposed=!1}dispose(){this._isDisposed||(P(this),this._isDisposed=!0,this.clear())}clear(){try{I(this._toDispose.values())}finally{this._toDispose.clear()}}add(p){if(!p)return p;if(p===this)throw new Error("Cannot register a disposable on itself!");return P(p),this._isDisposed?c.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(p),p}}e.DisposableStore=c,c.DISABLE_DISPOSED_WARNING=!1;class h{constructor(){this._store=new c,_(this)}dispose(){P(this),this._store.dispose()}_register(p){if(p===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(p)}}e.Disposable=h,h.None=Object.freeze({dispose(){}});class S{constructor(){this._isDisposed=!1,_(this)}get value(){return this._isDisposed?void 0:this._value}set value(p){var t;this._isDisposed||p===this._value||((t=this._value)===null||t===void 0||t.dispose(),p&&P(p),this._value=p)}clear(){this.value=void 0}dispose(){var p;this._isDisposed=!0,P(this),(p=this._value)===null||p===void 0||p.dispose(),this._value=void 0}}e.MutableDisposable=S;class w{constructor(){this.references=new Map}acquire(p,...t){let i=this.references.get(p);i||(i={counter:0,object:this.createReferencedObject(p,...t)},this.references.set(p,i));const{object:r}=i,n=v.once(()=>{--i.counter==0&&(this.destroyReferencedObject(p,i.object),this.references.delete(p))});return i.counter++,{object:r,dispose:n}}}e.ReferenceCollection=w;class b{constructor(p){this.referenceCollection=p}async acquire(p,...t){const i=this.referenceCollection.acquire(p,...t);try{return{object:await i.object,dispose:()=>i.dispose()}}catch(r){throw i.dispose(),r}}}e.AsyncReferenceCollection=b;class u{constructor(p){this.object=p}dispose(){}}e.ImmortalReference=u}),define(ge[71],pe([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class v{constructor(D){this.element=D,this.next=v.Undefined,this.prev=v.Undefined}}v.Undefined=new v(void 0);class R{constructor(){this._first=v.Undefined,this._last=v.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===v.Undefined}clear(){let D=this._first;for(;D!==v.Undefined;){const A=D.next;D.prev=v.Undefined,D.next=v.Undefined,D=A}this._first=v.Undefined,this._last=v.Undefined,this._size=0}unshift(D){return this._insert(D,!1)}push(D){return this._insert(D,!0)}_insert(D,A){const P=new v(D);if(this._first===v.Undefined)this._first=P,this._last=P;else if(A){const C=this._last;this._last=P,P.prev=C,C.next=P}else{const C=this._first;this._first=P,P.next=C,C.prev=P}this._size+=1;let _=!1;return()=>{_||(_=!0,this._remove(P))}}shift(){if(this._first!==v.Undefined){const D=this._first.element;return this._remove(this._first),D}}pop(){if(this._last!==v.Undefined){const D=this._last.element;return this._remove(this._last),D}}_remove(D){if(D.prev!==v.Undefined&&D.next!==v.Undefined){const A=D.prev;A.next=D.next,D.next.prev=A}else D.prev===v.Undefined&&D.next===v.Undefined?(this._first=v.Undefined,this._last=v.Undefined):D.next===v.Undefined?(this._last=this._last.prev,this._last.next=v.Undefined):D.prev===v.Undefined&&(this._first=this._first.next,this._first.prev=v.Undefined);this._size-=1}*[Symbol.iterator](){let D=this._first;for(;D!==v.Undefined;)yield D.element,D=D.next}}e.LinkedList=R}),function(Q,e){typeof exports=="object"&&typeof module!="undefined"?module.exports=e():typeof define=="function"&&define.amd?define("vs/base/common/marked/marked",e):(Q=typeof globalThis!="undefined"?globalThis:Q||self,Q.marked=e())}(this,function(){"use strict";function Q(De,Se){for(var Pe=0;Pe<Se.length;Pe++){var ae=Se[Pe];ae.enumerable=ae.enumerable||!1,ae.configurable=!0,"value"in ae&&(ae.writable=!0),Object.defineProperty(De,ae.key,ae)}}function e(De,Se,Pe){return Se&&Q(De.prototype,Se),Pe&&Q(De,Pe),De}function v(De,Se){if(!!De){if(typeof De=="string")return R(De,Se);var Pe=Object.prototype.toString.call(De).slice(8,-1);if(Pe==="Object"&&De.constructor&&(Pe=De.constructor.name),Pe==="Map"||Pe==="Set")return Array.from(De);if(Pe==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(Pe))return R(De,Se)}}function R(De,Se){(Se==null||Se>De.length)&&(Se=De.length);for(var Pe=0,ae=new Array(Se);Pe<Se;Pe++)ae[Pe]=De[Pe];return ae}function k(De,Se){var Pe;if(typeof Symbol=="undefined"||De[Symbol.iterator]==null){if(Array.isArray(De)||(Pe=v(De))||Se&&De&&typeof De.length=="number"){Pe&&(De=Pe);var ae=0;return function(){return ae>=De.length?{done:!0}:{done:!1,value:De[ae++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}return Pe=De[Symbol.iterator](),Pe.next.bind(Pe)}function D(De){var Se={exports:{}};return De(Se,Se.exports),Se.exports}var A=D(function(De){function Se(){return{baseUrl:null,breaks:!1,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}function Pe(ae){De.exports.defaults=ae}De.exports={defaults:Se(),getDefaults:Se,changeDefaults:Pe}}),P=/[&<>"']/,_=/[&<>"']/g,C=/[<>"']|&(?!#?\w+;)/,s=/[<>"']|&(?!#?\w+;)/g,I={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},l=function(Se){return I[Se]};function m(De,Se){if(Se){if(P.test(De))return De.replace(_,l)}else if(C.test(De))return De.replace(s,l);return De}var c=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function h(De){return De.replace(c,function(Se,Pe){return Pe=Pe.toLowerCase(),Pe==="colon"?":":Pe.charAt(0)==="#"?Pe.charAt(1)==="x"?String.fromCharCode(parseInt(Pe.substring(2),16)):String.fromCharCode(+Pe.substring(1)):""})}var S=/(^|[^\[])\^/g;function w(De,Se){De=De.source||De,Se=Se||"";var Pe={replace:function(he,z){return z=z.source||z,z=z.replace(S,"$1"),De=De.replace(he,z),Pe},getRegex:function(){return new RegExp(De,Se)}};return Pe}var b=/[^\w:]/g,u=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function d(De,Se,Pe){if(De){var ae;try{ae=decodeURIComponent(h(Pe)).replace(b,"").toLowerCase()}catch(he){return null}if(ae.indexOf("javascript:")===0||ae.indexOf("vbscript:")===0||ae.indexOf("data:")===0)return null}Se&&!u.test(Pe)&&(Pe=n(Se,Pe));try{Pe=encodeURI(Pe).replace(/%25/g,"%")}catch(he){return null}return Pe}var p={},t=/^[^:]+:\/*[^/]*$/,i=/^([^:]+:)[\s\S]*$/,r=/^([^:]+:\/*[^/]*)[\s\S]*$/;function n(De,Se){p[" "+De]||(t.test(De)?p[" "+De]=De+"/":p[" "+De]=E(De,"/",!0)),De=p[" "+De];var Pe=De.indexOf(":")===-1;return Se.substring(0,2)==="//"?Pe?Se:De.replace(i,"$1")+Se:Se.charAt(0)==="/"?Pe?Se:De.replace(r,"$1")+Se:De+Se}var o={exec:function(){}};function g(De){for(var Se=1,Pe,ae;Se<arguments.length;Se++){Pe=arguments[Se];for(ae in Pe)Object.prototype.hasOwnProperty.call(Pe,ae)&&(De[ae]=Pe[ae])}return De}function f(De,Se){var Pe=De.replace(/\|/g,function(z,ee,ue){for(var Ie=!1,Te=ee;--Te>=0&&ue[Te]==="\\";)Ie=!Ie;return Ie?"|":" |"}),ae=Pe.split(/ \|/),he=0;if(ae.length>Se)ae.splice(Se);else for(;ae.length<Se;)ae.push("");for(;he<ae.length;he++)ae[he]=ae[he].trim().replace(/\\\|/g,"|");return ae}function E(De,Se,Pe){var ae=De.length;if(ae===0)return"";for(var he=0;he<ae;){var z=De.charAt(ae-he-1);if(z===Se&&!Pe)he++;else if(z!==Se&&Pe)he++;else break}return De.substr(0,ae-he)}function y(De,Se){if(De.indexOf(Se[1])===-1)return-1;for(var Pe=De.length,ae=0,he=0;he<Pe;he++)if(De[he]==="\\")he++;else if(De[he]===Se[0])ae++;else if(De[he]===Se[1]&&(ae--,ae<0))return he;return-1}function a(De){De&&De.sanitize&&!De.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function L(De,Se){if(Se<1)return"";for(var Pe="";Se>1;)Se&1&&(Pe+=De),Se>>=1,De+=De;return Pe+De}var O={escape:m,unescape:h,edit:w,cleanUrl:d,resolveUrl:n,noopTest:o,merge:g,splitCells:f,rtrim:E,findClosingBracket:y,checkSanitizeDeprecation:a,repeatString:L},W=A.defaults,J=O.rtrim,se=O.splitCells,q=O.escape,N=O.findClosingBracket;function H(De,Se,Pe){var ae=Se.href,he=Se.title?q(Se.title):null,z=De[1].replace(/\\([\[\]])/g,"$1");return De[0].charAt(0)!=="!"?{type:"link",raw:Pe,href:ae,title:he,text:z}:{type:"image",raw:Pe,href:ae,title:he,text:q(z)}}function T(De,Se){var Pe=De.match(/^(\s+)(?:```)/);if(Pe===null)return Se;var ae=Pe[1];return Se.split(`
`).map(function(he){var z=he.match(/^\s+/);if(z===null)return he;var ee=z[0];return ee.length>=ae.length?he.slice(ae.length):he}).join(`
`)}var U=function(){function De(Pe){this.options=Pe||W}var Se=De.prototype;return Se.space=function(ae){var he=this.rules.block.newline.exec(ae);if(he)return he[0].length>1?{type:"space",raw:he[0]}:{raw:`
`}},Se.code=function(ae){var he=this.rules.block.code.exec(ae);if(he){var z=he[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:he[0],codeBlockStyle:"indented",text:this.options.pedantic?z:J(z,`
`)}}},Se.fences=function(ae){var he=this.rules.block.fences.exec(ae);if(he){var z=he[0],ee=T(z,he[3]||"");return{type:"code",raw:z,lang:he[2]?he[2].trim():he[2],text:ee}}},Se.heading=function(ae){var he=this.rules.block.heading.exec(ae);if(he){var z=he[2].trim();if(/#$/.test(z)){var ee=J(z,"#");(this.options.pedantic||!ee||/ $/.test(ee))&&(z=ee.trim())}return{type:"heading",raw:he[0],depth:he[1].length,text:z}}},Se.nptable=function(ae){var he=this.rules.block.nptable.exec(ae);if(he){var z={type:"table",header:se(he[1].replace(/^ *| *\| *$/g,"")),align:he[2].replace(/^ *|\| *$/g,"").split(/ *\| */),cells:he[3]?he[3].replace(/\n$/,"").split(`
`):[],raw:he[0]};if(z.header.length===z.align.length){var ee=z.align.length,ue;for(ue=0;ue<ee;ue++)/^ *-+: *$/.test(z.align[ue])?z.align[ue]="right":/^ *:-+: *$/.test(z.align[ue])?z.align[ue]="center":/^ *:-+ *$/.test(z.align[ue])?z.align[ue]="left":z.align[ue]=null;for(ee=z.cells.length,ue=0;ue<ee;ue++)z.cells[ue]=se(z.cells[ue],z.header.length);return z}}},Se.hr=function(ae){var he=this.rules.block.hr.exec(ae);if(he)return{type:"hr",raw:he[0]}},Se.blockquote=function(ae){var he=this.rules.block.blockquote.exec(ae);if(he){var z=he[0].replace(/^ *> ?/gm,"");return{type:"blockquote",raw:he[0],text:z}}},Se.list=function(ae){var he=this.rules.block.list.exec(ae);if(he){var z=he[0],ee=he[2],ue=ee.length>1,Ie={type:"list",raw:z,ordered:ue,start:ue?+ee.slice(0,-1):"",loose:!1,items:[]},Te=he[0].match(this.rules.block.item),xe=!1,He,Ze,Ye,Xe,nt,pt,_e,ye,de=Te.length;Ye=this.rules.block.listItemStart.exec(Te[0]);for(var K=0;K<de;K++){if(He=Te[K],z=He,K!==de-1){if(Xe=this.rules.block.listItemStart.exec(Te[K+1]),this.options.pedantic?Xe[1].length>Ye[1].length:Xe[1].length>Ye[0].length||Xe[1].length>3){Te.splice(K,2,Te[K]+`
`+Te[K+1]),K--,de--;continue}else(!this.options.pedantic||this.options.smartLists?Xe[2][Xe[2].length-1]!==ee[ee.length-1]:ue===(Xe[2].length===1))&&(nt=Te.slice(K+1).join(`
`),Ie.raw=Ie.raw.substring(0,Ie.raw.length-nt.length),K=de-1);Ye=Xe}Ze=He.length,He=He.replace(/^ *([*+-]|\d+[.)]) ?/,""),~He.indexOf(`
 `)&&(Ze-=He.length,He=this.options.pedantic?He.replace(/^ {1,4}/gm,""):He.replace(new RegExp("^ {1,"+Ze+"}","gm"),"")),pt=xe||/\n\n(?!\s*$)/.test(He),K!==de-1&&(xe=He.charAt(He.length-1)===`
`,pt||(pt=xe)),pt&&(Ie.loose=!0),this.options.gfm&&(_e=/^\[[ xX]\] /.test(He),ye=void 0,_e&&(ye=He[1]!==" ",He=He.replace(/^\[[ xX]\] +/,""))),Ie.items.push({type:"list_item",raw:z,task:_e,checked:ye,loose:pt,text:He})}return Ie}},Se.html=function(ae){var he=this.rules.block.html.exec(ae);if(he)return{type:this.options.sanitize?"paragraph":"html",raw:he[0],pre:!this.options.sanitizer&&(he[1]==="pre"||he[1]==="script"||he[1]==="style"),text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(he[0]):q(he[0]):he[0]}},Se.def=function(ae){var he=this.rules.block.def.exec(ae);if(he){he[3]&&(he[3]=he[3].substring(1,he[3].length-1));var z=he[1].toLowerCase().replace(/\s+/g," ");return{tag:z,raw:he[0],href:he[2],title:he[3]}}},Se.table=function(ae){var he=this.rules.block.table.exec(ae);if(he){var z={type:"table",header:se(he[1].replace(/^ *| *\| *$/g,"")),align:he[2].replace(/^ *|\| *$/g,"").split(/ *\| */),cells:he[3]?he[3].replace(/\n$/,"").split(`
`):[]};if(z.header.length===z.align.length){z.raw=he[0];var ee=z.align.length,ue;for(ue=0;ue<ee;ue++)/^ *-+: *$/.test(z.align[ue])?z.align[ue]="right":/^ *:-+: *$/.test(z.align[ue])?z.align[ue]="center":/^ *:-+ *$/.test(z.align[ue])?z.align[ue]="left":z.align[ue]=null;for(ee=z.cells.length,ue=0;ue<ee;ue++)z.cells[ue]=se(z.cells[ue].replace(/^ *\| *| *\| *$/g,""),z.header.length);return z}}},Se.lheading=function(ae){var he=this.rules.block.lheading.exec(ae);if(he)return{type:"heading",raw:he[0],depth:he[2].charAt(0)==="="?1:2,text:he[1]}},Se.paragraph=function(ae){var he=this.rules.block.paragraph.exec(ae);if(he)return{type:"paragraph",raw:he[0],text:he[1].charAt(he[1].length-1)===`
`?he[1].slice(0,-1):he[1]}},Se.text=function(ae){var he=this.rules.block.text.exec(ae);if(he)return{type:"text",raw:he[0],text:he[0]}},Se.escape=function(ae){var he=this.rules.inline.escape.exec(ae);if(he)return{type:"escape",raw:he[0],text:q(he[1])}},Se.tag=function(ae,he,z){var ee=this.rules.inline.tag.exec(ae);if(ee)return!he&&/^<a /i.test(ee[0])?he=!0:he&&/^<\/a>/i.test(ee[0])&&(he=!1),!z&&/^<(pre|code|kbd|script)(\s|>)/i.test(ee[0])?z=!0:z&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(ee[0])&&(z=!1),{type:this.options.sanitize?"text":"html",raw:ee[0],inLink:he,inRawBlock:z,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ee[0]):q(ee[0]):ee[0]}},Se.link=function(ae){var he=this.rules.inline.link.exec(ae);if(he){var z=he[2].trim();if(!this.options.pedantic&&/^</.test(z)){if(!/>$/.test(z))return;var ee=J(z.slice(0,-1),"\\");if((z.length-ee.length)%2==0)return}else{var ue=N(he[2],"()");if(ue>-1){var Ie=he[0].indexOf("!")===0?5:4,Te=Ie+he[1].length+ue;he[2]=he[2].substring(0,ue),he[0]=he[0].substring(0,Te).trim(),he[3]=""}}var xe=he[2],He="";if(this.options.pedantic){var Ze=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(xe);Ze&&(xe=Ze[1],He=Ze[3])}else He=he[3]?he[3].slice(1,-1):"";return xe=xe.trim(),/^</.test(xe)&&(this.options.pedantic&&!/>$/.test(z)?xe=xe.slice(1):xe=xe.slice(1,-1)),H(he,{href:xe&&xe.replace(this.rules.inline._escapes,"$1"),title:He&&He.replace(this.rules.inline._escapes,"$1")},he[0])}},Se.reflink=function(ae,he){var z;if((z=this.rules.inline.reflink.exec(ae))||(z=this.rules.inline.nolink.exec(ae))){var ee=(z[2]||z[1]).replace(/\s+/g," ");if(ee=he[ee.toLowerCase()],!ee||!ee.href){var ue=z[0].charAt(0);return{type:"text",raw:ue,text:ue}}return H(z,ee,z[0])}},Se.emStrong=function(ae,he,z){z===void 0&&(z="");var ee=this.rules.inline.emStrong.lDelim.exec(ae);if(!!ee&&!(ee[3]&&z.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u08A0-\u08B4\u08B6-\u08C7\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u170C\u170E-\u1711\u1720-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4B\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2C2E\u2C30-\u2C5E\u2C60-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\u9FFC\uA000-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7BF\uA7C2-\uA7CA\uA7F5-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEC0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82C[\uDC00-\uDD1E\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDD\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF34\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var ue=ee[1]||ee[2]||"";if(!ue||ue&&(z===""||this.rules.inline.punctuation.exec(z))){var Ie=ee[0].length-1,Te,xe,He=Ie,Ze=0,Ye=ee[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(Ye.lastIndex=0,he=he.slice(-1*ae.length+Ie);(ee=Ye.exec(he))!=null;)if(Te=ee[1]||ee[2]||ee[3]||ee[4]||ee[5]||ee[6],!!Te){if(xe=Te.length,ee[3]||ee[4]){He+=xe;continue}else if((ee[5]||ee[6])&&Ie%3&&!((Ie+xe)%3)){Ze+=xe;continue}if(He-=xe,!(He>0)){if(He+Ze-xe<=0&&!he.slice(Ye.lastIndex).match(Ye)&&(xe=Math.min(xe,xe+He+Ze)),Math.min(Ie,xe)%2)return{type:"em",raw:ae.slice(0,Ie+ee.index+xe+1),text:ae.slice(1,Ie+ee.index+xe)};if(Math.min(Ie,xe)%2==0)return{type:"strong",raw:ae.slice(0,Ie+ee.index+xe+1),text:ae.slice(2,Ie+ee.index+xe-1)}}}}}},Se.codespan=function(ae){var he=this.rules.inline.code.exec(ae);if(he){var z=he[2].replace(/\n/g," "),ee=/[^ ]/.test(z),ue=/^ /.test(z)&&/ $/.test(z);return ee&&ue&&(z=z.substring(1,z.length-1)),z=q(z,!0),{type:"codespan",raw:he[0],text:z}}},Se.br=function(ae){var he=this.rules.inline.br.exec(ae);if(he)return{type:"br",raw:he[0]}},Se.del=function(ae){var he=this.rules.inline.del.exec(ae);if(he)return{type:"del",raw:he[0],text:he[2]}},Se.autolink=function(ae,he){var z=this.rules.inline.autolink.exec(ae);if(z){var ee,ue;return z[2]==="@"?(ee=q(this.options.mangle?he(z[1]):z[1]),ue="mailto:"+ee):(ee=q(z[1]),ue=ee),{type:"link",raw:z[0],text:ee,href:ue,tokens:[{type:"text",raw:ee,text:ee}]}}},Se.url=function(ae,he){var z;if(z=this.rules.inline.url.exec(ae)){var ee,ue;if(z[2]==="@")ee=q(this.options.mangle?he(z[0]):z[0]),ue="mailto:"+ee;else{var Ie;do Ie=z[0],z[0]=this.rules.inline._backpedal.exec(z[0])[0];while(Ie!==z[0]);ee=q(z[0]),z[1]==="www."?ue="http://"+ee:ue=ee}return{type:"link",raw:z[0],text:ee,href:ue,tokens:[{type:"text",raw:ee,text:ee}]}}},Se.inlineText=function(ae,he,z){var ee=this.rules.inline.text.exec(ae);if(ee){var ue;return he?ue=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ee[0]):q(ee[0]):ee[0]:ue=q(this.options.smartypants?z(ee[0]):ee[0]),{type:"text",raw:ee[0],text:ue}}},De}(),F=O.noopTest,M=O.edit,x=O.merge,$={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?:\n+|$)|$)/,hr:/^ {0,3}((?:- *){3,}|(?:_ *){3,}|(?:\* *){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3})(bull) [\s\S]+?(?:hr|def|\n{2,}(?! )(?! {0,3}bull )\n*|\s*$)/,html:"^ {0,3}(?:<(script|pre|style)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:\\n{2,}|$)|<(?!script|pre|style)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:\\n{2,}|$)|</(?!script|pre|style)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:\\n{2,}|$))",def:/^ {0,3}\[(label)\]: *\n? *<?([^\s>]+)>?(?:(?: +\n? *| *\n *)(title))? *(?:\n+|$)/,nptable:F,table:F,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html| +\n)[^\n]+)*)/,text:/^[^\n]+/};$._label=/(?!\s*\])(?:\\[\[\]]|[^\[\]])+/,$._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,$.def=M($.def).replace("label",$._label).replace("title",$._title).getRegex(),$.bullet=/(?:[*+-]|\d{1,9}[.)])/,$.item=/^( *)(bull) ?[^\n]*(?:\n(?! *bull ?)[^\n]*)*/,$.item=M($.item,"gm").replace(/bull/g,$.bullet).getRegex(),$.listItemStart=M(/^( *)(bull)/).replace("bull",$.bullet).getRegex(),$.list=M($.list).replace(/bull/g,$.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+$.def.source+")").getRegex(),$._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",$._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,$.html=M($.html,"i").replace("comment",$._comment).replace("tag",$._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),$.paragraph=M($._paragraph).replace("hr",$.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",$._tag).getRegex(),$.blockquote=M($.blockquote).replace("paragraph",$.paragraph).getRegex(),$.normal=x({},$),$.gfm=x({},$.normal,{nptable:"^ *([^|\\n ].*\\|.*)\\n {0,3}([-:]+ *\\|[-| :]*)(?:\\n((?:(?!\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)",table:"^ *\\|(.+)\\n {0,3}\\|?( *[-:]+[-| :]*)(?:\\n *((?:(?!\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),$.gfm.nptable=M($.gfm.nptable).replace("hr",$.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",$._tag).getRegex(),$.gfm.table=M($.gfm.table).replace("hr",$.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",$._tag).getRegex(),$.pedantic=x({},$.normal,{html:M(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",$._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:F,paragraph:M($.normal._paragraph).replace("hr",$.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",$.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var X={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:F,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(?!\s*\])((?:\\[\[\]]?|[^\[\]\\])+)\]/,nolink:/^!?\[(?!\s*\])((?:\[[^\[\]]*\]|\\[\[\]]|[^\[\]])*)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/\_\_[^_]*?\*[^_]*?\_\_|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/\*\*[^*]*?\_[^*]*?\*\*|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:F,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};X._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",X.punctuation=M(X.punctuation).replace(/punctuation/g,X._punctuation).getRegex(),X.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,X.escapedEmSt=/\\\*|\\_/g,X._comment=M($._comment).replace("(?:-->|$)","-->").getRegex(),X.emStrong.lDelim=M(X.emStrong.lDelim).replace(/punct/g,X._punctuation).getRegex(),X.emStrong.rDelimAst=M(X.emStrong.rDelimAst,"g").replace(/punct/g,X._punctuation).getRegex(),X.emStrong.rDelimUnd=M(X.emStrong.rDelimUnd,"g").replace(/punct/g,X._punctuation).getRegex(),X._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,X._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,X._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,X.autolink=M(X.autolink).replace("scheme",X._scheme).replace("email",X._email).getRegex(),X._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,X.tag=M(X.tag).replace("comment",X._comment).replace("attribute",X._attribute).getRegex(),X._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,X._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,X._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,X.link=M(X.link).replace("label",X._label).replace("href",X._href).replace("title",X._title).getRegex(),X.reflink=M(X.reflink).replace("label",X._label).getRegex(),X.reflinkSearch=M(X.reflinkSearch,"g").replace("reflink",X.reflink).replace("nolink",X.nolink).getRegex(),X.normal=x({},X),X.pedantic=x({},X.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:M(/^!?\[(label)\]\((.*?)\)/).replace("label",X._label).getRegex(),reflink:M(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",X._label).getRegex()}),X.gfm=x({},X.normal,{escape:M(X.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@))|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@))/}),X.gfm.url=M(X.gfm.url,"i").replace("email",X.gfm._extended_email).getRegex(),X.breaks=x({},X.gfm,{br:M(X.br).replace("{2,}","*").getRegex(),text:M(X.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});var le={block:$,inline:X},be=A.defaults,Re=le.block,Ce=le.inline,Me=O.repeatString;function je(De){return De.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function ze(De){var Se="",Pe,ae,he=De.length;for(Pe=0;Pe<he;Pe++)ae=De.charCodeAt(Pe),Math.random()>.5&&(ae="x"+ae.toString(16)),Se+="&#"+ae+";";return Se}var qe=function(){function De(Pe){this.tokens=[],this.tokens.links=Object.create(null),this.options=Pe||be,this.options.tokenizer=this.options.tokenizer||new U,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options;var ae={block:Re.normal,inline:Ce.normal};this.options.pedantic?(ae.block=Re.pedantic,ae.inline=Ce.pedantic):this.options.gfm&&(ae.block=Re.gfm,this.options.breaks?ae.inline=Ce.breaks:ae.inline=Ce.gfm),this.tokenizer.rules=ae}De.lex=function(ae,he){var z=new De(he);return z.lex(ae)},De.lexInline=function(ae,he){var z=new De(he);return z.inlineTokens(ae)};var Se=De.prototype;return Se.lex=function(ae){return ae=ae.replace(/\r\n|\r/g,`
`).replace(/\t/g,"    "),this.blockTokens(ae,this.tokens,!0),this.inline(this.tokens),this.tokens},Se.blockTokens=function(ae,he,z){he===void 0&&(he=[]),z===void 0&&(z=!0),this.options.pedantic&&(ae=ae.replace(/^ +$/gm,""));for(var ee,ue,Ie,Te;ae;){if(ee=this.tokenizer.space(ae)){ae=ae.substring(ee.raw.length),ee.type&&he.push(ee);continue}if(ee=this.tokenizer.code(ae)){ae=ae.substring(ee.raw.length),Te=he[he.length-1],Te&&Te.type==="paragraph"?(Te.raw+=`
`+ee.raw,Te.text+=`
`+ee.text):he.push(ee);continue}if(ee=this.tokenizer.fences(ae)){ae=ae.substring(ee.raw.length),he.push(ee);continue}if(ee=this.tokenizer.heading(ae)){ae=ae.substring(ee.raw.length),he.push(ee);continue}if(ee=this.tokenizer.nptable(ae)){ae=ae.substring(ee.raw.length),he.push(ee);continue}if(ee=this.tokenizer.hr(ae)){ae=ae.substring(ee.raw.length),he.push(ee);continue}if(ee=this.tokenizer.blockquote(ae)){ae=ae.substring(ee.raw.length),ee.tokens=this.blockTokens(ee.text,[],z),he.push(ee);continue}if(ee=this.tokenizer.list(ae)){for(ae=ae.substring(ee.raw.length),Ie=ee.items.length,ue=0;ue<Ie;ue++)ee.items[ue].tokens=this.blockTokens(ee.items[ue].text,[],!1);he.push(ee);continue}if(ee=this.tokenizer.html(ae)){ae=ae.substring(ee.raw.length),he.push(ee);continue}if(z&&(ee=this.tokenizer.def(ae))){ae=ae.substring(ee.raw.length),this.tokens.links[ee.tag]||(this.tokens.links[ee.tag]={href:ee.href,title:ee.title});continue}if(ee=this.tokenizer.table(ae)){ae=ae.substring(ee.raw.length),he.push(ee);continue}if(ee=this.tokenizer.lheading(ae)){ae=ae.substring(ee.raw.length),he.push(ee);continue}if(z&&(ee=this.tokenizer.paragraph(ae))){ae=ae.substring(ee.raw.length),he.push(ee);continue}if(ee=this.tokenizer.text(ae)){ae=ae.substring(ee.raw.length),Te=he[he.length-1],Te&&Te.type==="text"?(Te.raw+=`
`+ee.raw,Te.text+=`
`+ee.text):he.push(ee);continue}if(ae){var xe="Infinite loop on byte: "+ae.charCodeAt(0);if(this.options.silent){console.error(xe);break}else throw new Error(xe)}}return he},Se.inline=function(ae){var he,z,ee,ue,Ie,Te,xe=ae.length;for(he=0;he<xe;he++)switch(Te=ae[he],Te.type){case"paragraph":case"text":case"heading":{Te.tokens=[],this.inlineTokens(Te.text,Te.tokens);break}case"table":{for(Te.tokens={header:[],cells:[]},ue=Te.header.length,z=0;z<ue;z++)Te.tokens.header[z]=[],this.inlineTokens(Te.header[z],Te.tokens.header[z]);for(ue=Te.cells.length,z=0;z<ue;z++)for(Ie=Te.cells[z],Te.tokens.cells[z]=[],ee=0;ee<Ie.length;ee++)Te.tokens.cells[z][ee]=[],this.inlineTokens(Ie[ee],Te.tokens.cells[z][ee]);break}case"blockquote":{this.inline(Te.tokens);break}case"list":{for(ue=Te.items.length,z=0;z<ue;z++)this.inline(Te.items[z].tokens);break}}return ae},Se.inlineTokens=function(ae,he,z,ee){he===void 0&&(he=[]),z===void 0&&(z=!1),ee===void 0&&(ee=!1);var ue,Ie,Te=ae,xe,He,Ze;if(this.tokens.links){var Ye=Object.keys(this.tokens.links);if(Ye.length>0)for(;(xe=this.tokenizer.rules.inline.reflinkSearch.exec(Te))!=null;)Ye.includes(xe[0].slice(xe[0].lastIndexOf("[")+1,-1))&&(Te=Te.slice(0,xe.index)+"["+Me("a",xe[0].length-2)+"]"+Te.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(xe=this.tokenizer.rules.inline.blockSkip.exec(Te))!=null;)Te=Te.slice(0,xe.index)+"["+Me("a",xe[0].length-2)+"]"+Te.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(xe=this.tokenizer.rules.inline.escapedEmSt.exec(Te))!=null;)Te=Te.slice(0,xe.index)+"++"+Te.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;ae;){if(He||(Ze=""),He=!1,ue=this.tokenizer.escape(ae)){ae=ae.substring(ue.raw.length),he.push(ue);continue}if(ue=this.tokenizer.tag(ae,z,ee)){ae=ae.substring(ue.raw.length),z=ue.inLink,ee=ue.inRawBlock;var Xe=he[he.length-1];Xe&&ue.type==="text"&&Xe.type==="text"?(Xe.raw+=ue.raw,Xe.text+=ue.text):he.push(ue);continue}if(ue=this.tokenizer.link(ae)){ae=ae.substring(ue.raw.length),ue.type==="link"&&(ue.tokens=this.inlineTokens(ue.text,[],!0,ee)),he.push(ue);continue}if(ue=this.tokenizer.reflink(ae,this.tokens.links)){ae=ae.substring(ue.raw.length);var nt=he[he.length-1];ue.type==="link"?(ue.tokens=this.inlineTokens(ue.text,[],!0,ee),he.push(ue)):nt&&ue.type==="text"&&nt.type==="text"?(nt.raw+=ue.raw,nt.text+=ue.text):he.push(ue);continue}if(ue=this.tokenizer.emStrong(ae,Te,Ze)){ae=ae.substring(ue.raw.length),ue.tokens=this.inlineTokens(ue.text,[],z,ee),he.push(ue);continue}if(ue=this.tokenizer.codespan(ae)){ae=ae.substring(ue.raw.length),he.push(ue);continue}if(ue=this.tokenizer.br(ae)){ae=ae.substring(ue.raw.length),he.push(ue);continue}if(ue=this.tokenizer.del(ae)){ae=ae.substring(ue.raw.length),ue.tokens=this.inlineTokens(ue.text,[],z,ee),he.push(ue);continue}if(ue=this.tokenizer.autolink(ae,ze)){ae=ae.substring(ue.raw.length),he.push(ue);continue}if(!z&&(ue=this.tokenizer.url(ae,ze))){ae=ae.substring(ue.raw.length),he.push(ue);continue}if(ue=this.tokenizer.inlineText(ae,ee,je)){ae=ae.substring(ue.raw.length),ue.raw.slice(-1)!=="_"&&(Ze=ue.raw.slice(-1)),He=!0,Ie=he[he.length-1],Ie&&Ie.type==="text"?(Ie.raw+=ue.raw,Ie.text+=ue.text):he.push(ue);continue}if(ae){var pt="Infinite loop on byte: "+ae.charCodeAt(0);if(this.options.silent){console.error(pt);break}else throw new Error(pt)}}return he},e(De,null,[{key:"rules",get:function(){return{block:Re,inline:Ce}}}]),De}(),j=A.defaults,Z=O.cleanUrl,ne=O.escape,oe=function(){function De(Pe){this.options=Pe||j}var Se=De.prototype;return Se.code=function(ae,he,z){var ee=(he||"").match(/\S*/)[0];if(this.options.highlight){var ue=this.options.highlight(ae,ee);ue!=null&&ue!==ae&&(z=!0,ae=ue)}return ae=ae.replace(/\n$/,"")+`
`,ee?'<pre><code class="'+this.options.langPrefix+ne(ee,!0)+'">'+(z?ae:ne(ae,!0))+`</code></pre>
`:"<pre><code>"+(z?ae:ne(ae,!0))+`</code></pre>
`},Se.blockquote=function(ae){return`<blockquote>
`+ae+`</blockquote>
`},Se.html=function(ae){return ae},Se.heading=function(ae,he,z,ee){return this.options.headerIds?"<h"+he+' id="'+this.options.headerPrefix+ee.slug(z)+'">'+ae+"</h"+he+`>
`:"<h"+he+">"+ae+"</h"+he+`>
`},Se.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},Se.list=function(ae,he,z){var ee=he?"ol":"ul",ue=he&&z!==1?' start="'+z+'"':"";return"<"+ee+ue+`>
`+ae+"</"+ee+`>
`},Se.listitem=function(ae){return"<li>"+ae+`</li>
`},Se.checkbox=function(ae){return"<input "+(ae?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},Se.paragraph=function(ae){return"<p>"+ae+`</p>
`},Se.table=function(ae,he){return he&&(he="<tbody>"+he+"</tbody>"),`<table>
<thead>
`+ae+`</thead>
`+he+`</table>
`},Se.tablerow=function(ae){return`<tr>
`+ae+`</tr>
`},Se.tablecell=function(ae,he){var z=he.header?"th":"td",ee=he.align?"<"+z+' align="'+he.align+'">':"<"+z+">";return ee+ae+"</"+z+`>
`},Se.strong=function(ae){return"<strong>"+ae+"</strong>"},Se.em=function(ae){return"<em>"+ae+"</em>"},Se.codespan=function(ae){return"<code>"+ae+"</code>"},Se.br=function(){return this.options.xhtml?"<br/>":"<br>"},Se.del=function(ae){return"<del>"+ae+"</del>"},Se.link=function(ae,he,z){if(ae=Z(this.options.sanitize,this.options.baseUrl,ae),ae===null)return z;var ee='<a href="'+ne(ae)+'"';return he&&(ee+=' title="'+he+'"'),ee+=">"+z+"</a>",ee},Se.image=function(ae,he,z){if(ae=Z(this.options.sanitize,this.options.baseUrl,ae),ae===null)return z;var ee='<img src="'+ae+'" alt="'+z+'"';return he&&(ee+=' title="'+he+'"'),ee+=this.options.xhtml?"/>":">",ee},Se.text=function(ae){return ae},De}(),Y=function(){function De(){}var Se=De.prototype;return Se.strong=function(ae){return ae},Se.em=function(ae){return ae},Se.codespan=function(ae){return ae},Se.del=function(ae){return ae},Se.html=function(ae){return ae},Se.text=function(ae){return ae},Se.link=function(ae,he,z){return""+z},Se.image=function(ae,he,z){return""+z},Se.br=function(){return""},De}(),ce=function(){function De(){this.seen={}}var Se=De.prototype;return Se.serialize=function(ae){return ae.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},Se.getNextSafeSlug=function(ae,he){var z=ae,ee=0;if(this.seen.hasOwnProperty(z)){ee=this.seen[ae];do ee++,z=ae+"-"+ee;while(this.seen.hasOwnProperty(z))}return he||(this.seen[ae]=ee,this.seen[z]=0),z},Se.slug=function(ae,he){he===void 0&&(he={});var z=this.serialize(ae);return this.getNextSafeSlug(z,he.dryrun)},De}(),me=A.defaults,Le=O.unescape,We=function(){function De(Pe){this.options=Pe||me,this.options.renderer=this.options.renderer||new oe,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new Y,this.slugger=new ce}De.parse=function(ae,he){var z=new De(he);return z.parse(ae)},De.parseInline=function(ae,he){var z=new De(he);return z.parseInline(ae)};var Se=De.prototype;return Se.parse=function(ae,he){he===void 0&&(he=!0);var z="",ee,ue,Ie,Te,xe,He,Ze,Ye,Xe,nt,pt,_e,ye,de,K,Ue,we,Je,et=ae.length;for(ee=0;ee<et;ee++)switch(nt=ae[ee],nt.type){case"space":continue;case"hr":{z+=this.renderer.hr();continue}case"heading":{z+=this.renderer.heading(this.parseInline(nt.tokens),nt.depth,Le(this.parseInline(nt.tokens,this.textRenderer)),this.slugger);continue}case"code":{z+=this.renderer.code(nt.text,nt.lang,nt.escaped);continue}case"table":{for(Ye="",Ze="",Te=nt.header.length,ue=0;ue<Te;ue++)Ze+=this.renderer.tablecell(this.parseInline(nt.tokens.header[ue]),{header:!0,align:nt.align[ue]});for(Ye+=this.renderer.tablerow(Ze),Xe="",Te=nt.cells.length,ue=0;ue<Te;ue++){for(He=nt.tokens.cells[ue],Ze="",xe=He.length,Ie=0;Ie<xe;Ie++)Ze+=this.renderer.tablecell(this.parseInline(He[Ie]),{header:!1,align:nt.align[Ie]});Xe+=this.renderer.tablerow(Ze)}z+=this.renderer.table(Ye,Xe);continue}case"blockquote":{Xe=this.parse(nt.tokens),z+=this.renderer.blockquote(Xe);continue}case"list":{for(pt=nt.ordered,_e=nt.start,ye=nt.loose,Te=nt.items.length,Xe="",ue=0;ue<Te;ue++)K=nt.items[ue],Ue=K.checked,we=K.task,de="",K.task&&(Je=this.renderer.checkbox(Ue),ye?K.tokens.length>0&&K.tokens[0].type==="text"?(K.tokens[0].text=Je+" "+K.tokens[0].text,K.tokens[0].tokens&&K.tokens[0].tokens.length>0&&K.tokens[0].tokens[0].type==="text"&&(K.tokens[0].tokens[0].text=Je+" "+K.tokens[0].tokens[0].text)):K.tokens.unshift({type:"text",text:Je}):de+=Je),de+=this.parse(K.tokens,ye),Xe+=this.renderer.listitem(de,we,Ue);z+=this.renderer.list(Xe,pt,_e);continue}case"html":{z+=this.renderer.html(nt.text);continue}case"paragraph":{z+=this.renderer.paragraph(this.parseInline(nt.tokens));continue}case"text":{for(Xe=nt.tokens?this.parseInline(nt.tokens):nt.text;ee+1<et&&ae[ee+1].type==="text";)nt=ae[++ee],Xe+=`
`+(nt.tokens?this.parseInline(nt.tokens):nt.text);z+=he?this.renderer.paragraph(Xe):Xe;continue}default:{var rt='Token with "'+nt.type+'" type was not found.';if(this.options.silent){console.error(rt);return}else throw new Error(rt)}}return z},Se.parseInline=function(ae,he){he=he||this.renderer;var z="",ee,ue,Ie=ae.length;for(ee=0;ee<Ie;ee++)switch(ue=ae[ee],ue.type){case"escape":{z+=he.text(ue.text);break}case"html":{z+=he.html(ue.text);break}case"link":{z+=he.link(ue.href,ue.title,this.parseInline(ue.tokens,he));break}case"image":{z+=he.image(ue.href,ue.title,ue.text);break}case"strong":{z+=he.strong(this.parseInline(ue.tokens,he));break}case"em":{z+=he.em(this.parseInline(ue.tokens,he));break}case"codespan":{z+=he.codespan(ue.text);break}case"br":{z+=he.br();break}case"del":{z+=he.del(this.parseInline(ue.tokens,he));break}case"text":{z+=he.text(ue.text);break}default:{var Te='Token with "'+ue.type+'" type was not found.';if(this.options.silent){console.error(Te);return}else throw new Error(Te)}}return z},De}(),Ee=O.merge,Ke=O.checkSanitizeDeprecation,G=O.escape,ie=A.getDefaults,ve=A.changeDefaults,Fe=A.defaults;function Ne(De,Se,Pe){if(typeof De=="undefined"||De===null)throw new Error("marked(): input parameter is undefined or null");if(typeof De!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(De)+", string expected");if(typeof Se=="function"&&(Pe=Se,Se=null),Se=Ee({},Ne.defaults,Se||{}),Ke(Se),Pe){var ae=Se.highlight,he;try{he=qe.lex(De,Se)}catch(Ie){return Pe(Ie)}var z=function(Te){var xe;if(!Te)try{xe=We.parse(he,Se)}catch(He){Te=He}return Se.highlight=ae,Te?Pe(Te):Pe(null,xe)};if(!ae||ae.length<3||(delete Se.highlight,!he.length))return z();var ee=0;Ne.walkTokens(he,function(Ie){Ie.type==="code"&&(ee++,setTimeout(function(){ae(Ie.text,Ie.lang,function(Te,xe){if(Te)return z(Te);xe!=null&&xe!==Ie.text&&(Ie.text=xe,Ie.escaped=!0),ee--,ee===0&&z()})},0))}),ee===0&&z();return}try{var ue=qe.lex(De,Se);return Se.walkTokens&&Ne.walkTokens(ue,Se.walkTokens),We.parse(ue,Se)}catch(Ie){if(Ie.message+=`
Please report this to https://github.com/markedjs/marked.`,Se.silent)return"<p>An error occurred:</p><pre>"+G(Ie.message+"",!0)+"</pre>";throw Ie}}Ne.options=Ne.setOptions=function(De){return Ee(Ne.defaults,De),ve(Ne.defaults),Ne},Ne.getDefaults=ie,Ne.defaults=Fe,Ne.use=function(De){var Se=Ee({},De);if(De.renderer&&function(){var ae=Ne.defaults.renderer||new oe,he=function(ue){var Ie=ae[ue];ae[ue]=function(){for(var Te=arguments.length,xe=new Array(Te),He=0;He<Te;He++)xe[He]=arguments[He];var Ze=De.renderer[ue].apply(ae,xe);return Ze===!1&&(Ze=Ie.apply(ae,xe)),Ze}};for(var z in De.renderer)he(z);Se.renderer=ae}(),De.tokenizer&&function(){var ae=Ne.defaults.tokenizer||new U,he=function(ue){var Ie=ae[ue];ae[ue]=function(){for(var Te=arguments.length,xe=new Array(Te),He=0;He<Te;He++)xe[He]=arguments[He];var Ze=De.tokenizer[ue].apply(ae,xe);return Ze===!1&&(Ze=Ie.apply(ae,xe)),Ze}};for(var z in De.tokenizer)he(z);Se.tokenizer=ae}(),De.walkTokens){var Pe=Ne.defaults.walkTokens;Se.walkTokens=function(ae){De.walkTokens(ae),Pe&&Pe(ae)}}Ne.setOptions(Se)},Ne.walkTokens=function(De,Se){for(var Pe=k(De),ae;!(ae=Pe()).done;){var he=ae.value;switch(Se(he),he.type){case"table":{for(var z=k(he.tokens.header),ee;!(ee=z()).done;){var ue=ee.value;Ne.walkTokens(ue,Se)}for(var Ie=k(he.tokens.cells),Te;!(Te=Ie()).done;)for(var xe=Te.value,He=k(xe),Ze;!(Ze=He()).done;){var Ye=Ze.value;Ne.walkTokens(Ye,Se)}break}case"list":{Ne.walkTokens(he.items,Se);break}default:he.tokens&&Ne.walkTokens(he.tokens,Se)}}},Ne.parseInline=function(De,Se){if(typeof De=="undefined"||De===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof De!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(De)+", string expected");Se=Ee({},Ne.defaults,Se||{}),Ke(Se);try{var Pe=qe.lexInline(De,Se);return Se.walkTokens&&Ne.walkTokens(Pe,Se.walkTokens),We.parseInline(Pe,Se)}catch(ae){if(ae.message+=`
Please report this to https://github.com/markedjs/marked.`,Se.silent)return"<p>An error occurred:</p><pre>"+G(ae.message+"",!0)+"</pre>";throw ae}},Ne.Parser=We,Ne.parser=We.parse,Ne.Renderer=oe,Ne.TextRenderer=Y,Ne.Lexer=qe,Ne.lexer=qe.lex,Ne.Tokenizer=U,Ne.Slugger=ce,Ne.parse=Ne;var Qe=Ne;return Qe}),define(ge[72],pe([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function v(A,P,_){return Math.min(Math.max(A,P),_)}e.clamp=v;function R(A,P){return(P+A%P)%P}e.rot=R;class k{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=k;class D{constructor(){this._n=1,this._val=0}update(P){return this._val=this._val+(P-this._val)/this._n,this._n+=1,this}get value(){return this._val}}e.MovingAverage=D}),function(){function Q(k){const D=[];typeof k=="number"&&D.push("code/timeOrigin",k);function A(_){D.push(_,Date.now())}function P(){const _=[];for(let C=0;C<D.length;C+=2)_.push({name:D[C],startTime:D[C+1]});return _}return{mark:A,getMarks:P}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?Q():{mark(k){performance.mark(k)},getMarks(){let k=performance.timeOrigin;typeof k!="number"&&(k=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const D=[{name:"code/timeOrigin",startTime:Math.round(k)}];for(const A of performance.getEntriesByType("mark"))D.push({name:A.name,startTime:Math.round(k+A.startTime)});return D}};if(typeof process=="object"){const k=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return Q(k)}else return console.trace("perf-util loaded in UNKNOWN environment"),Q()}function v(k){return k.MonacoPerformanceMarks||(k.MonacoPerformanceMarks=e()),k.MonacoPerformanceMarks}var R;typeof global=="object"?R=global:typeof self=="object"?R=self:R={},typeof define=="function"?define("vs/base/common/performance",[],function(){return v(R)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=v(R):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),R.perf=v(R))}(),define(ge[11],pe([0,1]),function(Q,e){"use strict";var v;Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setImmediate=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isPreferringBrowserCodeLoad=e.browserCodeLoadingCacheStrategy=e.isElectronSandboxed=e.globals=void 0;const R="en";let k=!1,D=!1,A=!1,P=!1,_=!1,C=!1,s=!1,I,l=R,m,c;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let h;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?h=e.globals.vscode.process:typeof process!="undefined"&&(h=process);const S=typeof((v=h==null?void 0:h.versions)===null||v===void 0?void 0:v.electron)=="string"&&h.type==="renderer";if(e.isElectronSandboxed=S&&(h==null?void 0:h.sandboxed),e.browserCodeLoadingCacheStrategy=(()=>{if(e.isElectronSandboxed)return"bypassHeatCheck";const n=h==null?void 0:h.env.VSCODE_BROWSER_CODE_LOADING;if(typeof n=="string")return n==="none"||n==="code"||n==="bypassHeatCheck"||n==="bypassHeatCheckAndEagerCompile"?n:"bypassHeatCheck"})(),e.isPreferringBrowserCodeLoad=typeof e.browserCodeLoadingCacheStrategy=="string",typeof navigator=="object"&&!S)c=navigator.userAgent,k=c.indexOf("Windows")>=0,D=c.indexOf("Macintosh")>=0,s=(c.indexOf("Macintosh")>=0||c.indexOf("iPad")>=0||c.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,A=c.indexOf("Linux")>=0,C=!0,I=navigator.language,l=I;else if(typeof h=="object"){k=h.platform==="win32",D=h.platform==="darwin",A=h.platform==="linux",P=A&&!!h.env.SNAP&&!!h.env.SNAP_REVISION,I=R,l=R;const n=h.env.VSCODE_NLS_CONFIG;if(n)try{const o=JSON.parse(n),g=o.availableLanguages["*"];I=o.locale,l=g||R,m=o._translationsConfigFile}catch(o){}_=!0}else console.error("Unable to resolve platform.");var w;(function(n){n[n.Web=0]="Web",n[n.Mac=1]="Mac",n[n.Linux=2]="Linux",n[n.Windows=3]="Windows"})(w=e.Platform||(e.Platform={}));function b(n){switch(n){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=b;let u=0;D?u=1:k?u=3:A&&(u=2),e.isWindows=k,e.isMacintosh=D,e.isLinux=A,e.isLinuxSnap=P,e.isNative=_,e.isWeb=C,e.isIOS=s,e.platform=u,e.userAgent=c,e.language=l;var d;(function(n){function o(){return e.language}n.value=o;function g(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}n.isDefaultVariant=g;function f(){return e.language==="en"}n.isDefault=f})(d=e.Language||(e.Language={})),e.locale=I,e.translationsConfigFile=m,e.setImmediate=function(){if(e.globals.setImmediate)return e.globals.setImmediate.bind(e.globals);if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let g=[];e.globals.addEventListener("message",E=>{if(E.data&&E.data.vscodeSetImmediateId)for(let y=0,a=g.length;y<a;y++){const L=g[y];if(L.id===E.data.vscodeSetImmediateId){g.splice(y,1),L.callback();return}}});let f=0;return E=>{const y=++f;g.push({id:y,callback:E}),e.globals.postMessage({vscodeSetImmediateId:y},"*")}}if(typeof(h==null?void 0:h.nextTick)=="function")return h.nextTick.bind(h);const o=Promise.resolve();return g=>o.then(g)}();var p;(function(n){n[n.Windows=1]="Windows",n[n.Macintosh=2]="Macintosh",n[n.Linux=3]="Linux"})(p=e.OperatingSystem||(e.OperatingSystem={})),e.OS=D||s?2:k?1:3;let t=!0,i=!1;function r(){if(!i){i=!0;const n=new Uint8Array(2);n[0]=1,n[1]=2,t=new Uint16Array(n.buffer)[0]===(2<<8)+1}return t}e.isLittleEndian=r}),define(ge[37],pe([0,1,11]),function(Q,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nextTick=e.platform=e.env=e.cwd=void 0;let R;if(typeof v.globals.vscode!="undefined"&&typeof v.globals.vscode.process!="undefined"){const k=v.globals.vscode.process;R={get platform(){return k.platform},get env(){return k.env},cwd(){return k.cwd()},nextTick(D){return v.setImmediate(D)}}}else typeof process!="undefined"?R={get platform(){return process.platform},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()},nextTick(k){return process.nextTick(k)}}:R={get platform(){return v.isWindows?"win32":v.isMacintosh?"darwin":"linux"},nextTick(k){return v.setImmediate(k)},get env(){return{}},cwd(){return"/"}};e.cwd=R.cwd,e.env=R.env,e.platform=R.platform,e.nextTick=R.nextTick}),define(ge[9],pe([0,1,37]),function(Q,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const R=65,k=97,D=90,A=122,P=46,_=47,C=92,s=58,I=63;class l extends Error{constructor(d,p,t){let i;typeof p=="string"&&p.indexOf("not ")===0?(i="must not be",p=p.replace(/^not /,"")):i="must be";const r=d.indexOf(".")!==-1?"property":"argument";let n=`The "${d}" ${r} ${i} of type ${p}`;n+=`. Received type ${typeof t}`,super(n),this.code="ERR_INVALID_ARG_TYPE"}}function m(u,d){if(typeof u!="string")throw new l(d,"string",u)}function c(u){return u===_||u===C}function h(u){return u===_}function S(u){return u>=R&&u<=D||u>=k&&u<=A}function w(u,d,p,t){let i="",r=0,n=-1,o=0,g=0;for(let f=0;f<=u.length;++f){if(f<u.length)g=u.charCodeAt(f);else{if(t(g))break;g=_}if(t(g)){if(!(n===f-1||o===1))if(o===2){if(i.length<2||r!==2||i.charCodeAt(i.length-1)!==P||i.charCodeAt(i.length-2)!==P){if(i.length>2){const E=i.lastIndexOf(p);E===-1?(i="",r=0):(i=i.slice(0,E),r=i.length-1-i.lastIndexOf(p)),n=f,o=0;continue}else if(i.length!==0){i="",r=0,n=f,o=0;continue}}d&&(i+=i.length>0?`${p}..`:"..",r=2)}else i.length>0?i+=`${p}${u.slice(n+1,f)}`:i=u.slice(n+1,f),r=f-n-1;n=f,o=0}else g===P&&o!==-1?++o:o=-1}return i}function b(u,d){if(d===null||typeof d!="object")throw new l("pathObject","Object",d);const p=d.dir||d.root,t=d.base||`${d.name||""}${d.ext||""}`;return p?p===d.root?`${p}${t}`:`${p}${u}${t}`:t}e.win32={resolve(...u){let d="",p="",t=!1;for(let i=u.length-1;i>=-1;i--){let r;if(i>=0){if(r=u[i],m(r,"path"),r.length===0)continue}else d.length===0?r=v.cwd():(r=v.env[`=${d}`]||v.cwd(),(r===void 0||r.slice(0,2).toLowerCase()!==d.toLowerCase()&&r.charCodeAt(2)===C)&&(r=`${d}\\`));const n=r.length;let o=0,g="",f=!1;const E=r.charCodeAt(0);if(n===1)c(E)&&(o=1,f=!0);else if(c(E))if(f=!0,c(r.charCodeAt(1))){let y=2,a=y;for(;y<n&&!c(r.charCodeAt(y));)y++;if(y<n&&y!==a){const L=r.slice(a,y);for(a=y;y<n&&c(r.charCodeAt(y));)y++;if(y<n&&y!==a){for(a=y;y<n&&!c(r.charCodeAt(y));)y++;(y===n||y!==a)&&(g=`\\\\${L}\\${r.slice(a,y)}`,o=y)}}}else o=1;else S(E)&&r.charCodeAt(1)===s&&(g=r.slice(0,2),o=2,n>2&&c(r.charCodeAt(2))&&(f=!0,o=3));if(g.length>0)if(d.length>0){if(g.toLowerCase()!==d.toLowerCase())continue}else d=g;if(t){if(d.length>0)break}else if(p=`${r.slice(o)}\\${p}`,t=f,f&&d.length>0)break}return p=w(p,!t,"\\",c),t?`${d}\\${p}`:`${d}${p}`||"."},normalize(u){m(u,"path");const d=u.length;if(d===0)return".";let p=0,t,i=!1;const r=u.charCodeAt(0);if(d===1)return h(r)?"\\":u;if(c(r))if(i=!0,c(u.charCodeAt(1))){let o=2,g=o;for(;o<d&&!c(u.charCodeAt(o));)o++;if(o<d&&o!==g){const f=u.slice(g,o);for(g=o;o<d&&c(u.charCodeAt(o));)o++;if(o<d&&o!==g){for(g=o;o<d&&!c(u.charCodeAt(o));)o++;if(o===d)return`\\\\${f}\\${u.slice(g)}\\`;o!==g&&(t=`\\\\${f}\\${u.slice(g,o)}`,p=o)}}}else p=1;else S(r)&&u.charCodeAt(1)===s&&(t=u.slice(0,2),p=2,d>2&&c(u.charCodeAt(2))&&(i=!0,p=3));let n=p<d?w(u.slice(p),!i,"\\",c):"";return n.length===0&&!i&&(n="."),n.length>0&&c(u.charCodeAt(d-1))&&(n+="\\"),t===void 0?i?`\\${n}`:n:i?`${t}\\${n}`:`${t}${n}`},isAbsolute(u){m(u,"path");const d=u.length;if(d===0)return!1;const p=u.charCodeAt(0);return c(p)||d>2&&S(p)&&u.charCodeAt(1)===s&&c(u.charCodeAt(2))},join(...u){if(u.length===0)return".";let d,p;for(let r=0;r<u.length;++r){const n=u[r];m(n,"path"),n.length>0&&(d===void 0?d=p=n:d+=`\\${n}`)}if(d===void 0)return".";let t=!0,i=0;if(typeof p=="string"&&c(p.charCodeAt(0))){++i;const r=p.length;r>1&&c(p.charCodeAt(1))&&(++i,r>2&&(c(p.charCodeAt(2))?++i:t=!1))}if(t){for(;i<d.length&&c(d.charCodeAt(i));)i++;i>=2&&(d=`\\${d.slice(i)}`)}return e.win32.normalize(d)},relative(u,d){if(m(u,"from"),m(d,"to"),u===d)return"";const p=e.win32.resolve(u),t=e.win32.resolve(d);if(p===t||(u=p.toLowerCase(),d=t.toLowerCase(),u===d))return"";let i=0;for(;i<u.length&&u.charCodeAt(i)===C;)i++;let r=u.length;for(;r-1>i&&u.charCodeAt(r-1)===C;)r--;const n=r-i;let o=0;for(;o<d.length&&d.charCodeAt(o)===C;)o++;let g=d.length;for(;g-1>o&&d.charCodeAt(g-1)===C;)g--;const f=g-o,E=n<f?n:f;let y=-1,a=0;for(;a<E;a++){const O=u.charCodeAt(i+a);if(O!==d.charCodeAt(o+a))break;O===C&&(y=a)}if(a!==E){if(y===-1)return t}else{if(f>E){if(d.charCodeAt(o+a)===C)return t.slice(o+a+1);if(a===2)return t.slice(o+a)}n>E&&(u.charCodeAt(i+a)===C?y=a:a===2&&(y=3)),y===-1&&(y=0)}let L="";for(a=i+y+1;a<=r;++a)(a===r||u.charCodeAt(a)===C)&&(L+=L.length===0?"..":"\\..");return o+=y,L.length>0?`${L}${t.slice(o,g)}`:(t.charCodeAt(o)===C&&++o,t.slice(o,g))},toNamespacedPath(u){if(typeof u!="string")return u;if(u.length===0)return"";const d=e.win32.resolve(u);if(d.length<=2)return u;if(d.charCodeAt(0)===C){if(d.charCodeAt(1)===C){const p=d.charCodeAt(2);if(p!==I&&p!==P)return`\\\\?\\UNC\\${d.slice(2)}`}}else if(S(d.charCodeAt(0))&&d.charCodeAt(1)===s&&d.charCodeAt(2)===C)return`\\\\?\\${d}`;return u},dirname(u){m(u,"path");const d=u.length;if(d===0)return".";let p=-1,t=0;const i=u.charCodeAt(0);if(d===1)return c(i)?u:".";if(c(i)){if(p=t=1,c(u.charCodeAt(1))){let o=2,g=o;for(;o<d&&!c(u.charCodeAt(o));)o++;if(o<d&&o!==g){for(g=o;o<d&&c(u.charCodeAt(o));)o++;if(o<d&&o!==g){for(g=o;o<d&&!c(u.charCodeAt(o));)o++;if(o===d)return u;o!==g&&(p=t=o+1)}}}}else S(i)&&u.charCodeAt(1)===s&&(p=d>2&&c(u.charCodeAt(2))?3:2,t=p);let r=-1,n=!0;for(let o=d-1;o>=t;--o)if(c(u.charCodeAt(o))){if(!n){r=o;break}}else n=!1;if(r===-1){if(p===-1)return".";r=p}return u.slice(0,r)},basename(u,d){d!==void 0&&m(d,"ext"),m(u,"path");let p=0,t=-1,i=!0,r;if(u.length>=2&&S(u.charCodeAt(0))&&u.charCodeAt(1)===s&&(p=2),d!==void 0&&d.length>0&&d.length<=u.length){if(d===u)return"";let n=d.length-1,o=-1;for(r=u.length-1;r>=p;--r){const g=u.charCodeAt(r);if(c(g)){if(!i){p=r+1;break}}else o===-1&&(i=!1,o=r+1),n>=0&&(g===d.charCodeAt(n)?--n==-1&&(t=r):(n=-1,t=o))}return p===t?t=o:t===-1&&(t=u.length),u.slice(p,t)}for(r=u.length-1;r>=p;--r)if(c(u.charCodeAt(r))){if(!i){p=r+1;break}}else t===-1&&(i=!1,t=r+1);return t===-1?"":u.slice(p,t)},extname(u){m(u,"path");let d=0,p=-1,t=0,i=-1,r=!0,n=0;u.length>=2&&u.charCodeAt(1)===s&&S(u.charCodeAt(0))&&(d=t=2);for(let o=u.length-1;o>=d;--o){const g=u.charCodeAt(o);if(c(g)){if(!r){t=o+1;break}continue}i===-1&&(r=!1,i=o+1),g===P?p===-1?p=o:n!==1&&(n=1):p!==-1&&(n=-1)}return p===-1||i===-1||n===0||n===1&&p===i-1&&p===t+1?"":u.slice(p,i)},format:b.bind(null,"\\"),parse(u){m(u,"path");const d={root:"",dir:"",base:"",ext:"",name:""};if(u.length===0)return d;const p=u.length;let t=0,i=u.charCodeAt(0);if(p===1)return c(i)?(d.root=d.dir=u,d):(d.base=d.name=u,d);if(c(i)){if(t=1,c(u.charCodeAt(1))){let y=2,a=y;for(;y<p&&!c(u.charCodeAt(y));)y++;if(y<p&&y!==a){for(a=y;y<p&&c(u.charCodeAt(y));)y++;if(y<p&&y!==a){for(a=y;y<p&&!c(u.charCodeAt(y));)y++;y===p?t=y:y!==a&&(t=y+1)}}}}else if(S(i)&&u.charCodeAt(1)===s){if(p<=2)return d.root=d.dir=u,d;if(t=2,c(u.charCodeAt(2))){if(p===3)return d.root=d.dir=u,d;t=3}}t>0&&(d.root=u.slice(0,t));let r=-1,n=t,o=-1,g=!0,f=u.length-1,E=0;for(;f>=t;--f){if(i=u.charCodeAt(f),c(i)){if(!g){n=f+1;break}continue}o===-1&&(g=!1,o=f+1),i===P?r===-1?r=f:E!==1&&(E=1):r!==-1&&(E=-1)}return o!==-1&&(r===-1||E===0||E===1&&r===o-1&&r===n+1?d.base=d.name=u.slice(n,o):(d.name=u.slice(n,r),d.base=u.slice(n,o),d.ext=u.slice(r,o))),n>0&&n!==t?d.dir=u.slice(0,n-1):d.dir=d.root,d},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...u){let d="",p=!1;for(let t=u.length-1;t>=-1&&!p;t--){const i=t>=0?u[t]:v.cwd();m(i,"path"),i.length!==0&&(d=`${i}/${d}`,p=i.charCodeAt(0)===_)}return d=w(d,!p,"/",h),p?`/${d}`:d.length>0?d:"."},normalize(u){if(m(u,"path"),u.length===0)return".";const d=u.charCodeAt(0)===_,p=u.charCodeAt(u.length-1)===_;return u=w(u,!d,"/",h),u.length===0?d?"/":p?"./":".":(p&&(u+="/"),d?`/${u}`:u)},isAbsolute(u){return m(u,"path"),u.length>0&&u.charCodeAt(0)===_},join(...u){if(u.length===0)return".";let d;for(let p=0;p<u.length;++p){const t=u[p];m(t,"path"),t.length>0&&(d===void 0?d=t:d+=`/${t}`)}return d===void 0?".":e.posix.normalize(d)},relative(u,d){if(m(u,"from"),m(d,"to"),u===d||(u=e.posix.resolve(u),d=e.posix.resolve(d),u===d))return"";const p=1,t=u.length,i=t-p,r=1,n=d.length-r,o=i<n?i:n;let g=-1,f=0;for(;f<o;f++){const y=u.charCodeAt(p+f);if(y!==d.charCodeAt(r+f))break;y===_&&(g=f)}if(f===o)if(n>o){if(d.charCodeAt(r+f)===_)return d.slice(r+f+1);if(f===0)return d.slice(r+f)}else i>o&&(u.charCodeAt(p+f)===_?g=f:f===0&&(g=0));let E="";for(f=p+g+1;f<=t;++f)(f===t||u.charCodeAt(f)===_)&&(E+=E.length===0?"..":"/..");return`${E}${d.slice(r+g)}`},toNamespacedPath(u){return u},dirname(u){if(m(u,"path"),u.length===0)return".";const d=u.charCodeAt(0)===_;let p=-1,t=!0;for(let i=u.length-1;i>=1;--i)if(u.charCodeAt(i)===_){if(!t){p=i;break}}else t=!1;return p===-1?d?"/":".":d&&p===1?"//":u.slice(0,p)},basename(u,d){d!==void 0&&m(d,"ext"),m(u,"path");let p=0,t=-1,i=!0,r;if(d!==void 0&&d.length>0&&d.length<=u.length){if(d===u)return"";let n=d.length-1,o=-1;for(r=u.length-1;r>=0;--r){const g=u.charCodeAt(r);if(g===_){if(!i){p=r+1;break}}else o===-1&&(i=!1,o=r+1),n>=0&&(g===d.charCodeAt(n)?--n==-1&&(t=r):(n=-1,t=o))}return p===t?t=o:t===-1&&(t=u.length),u.slice(p,t)}for(r=u.length-1;r>=0;--r)if(u.charCodeAt(r)===_){if(!i){p=r+1;break}}else t===-1&&(i=!1,t=r+1);return t===-1?"":u.slice(p,t)},extname(u){m(u,"path");let d=-1,p=0,t=-1,i=!0,r=0;for(let n=u.length-1;n>=0;--n){const o=u.charCodeAt(n);if(o===_){if(!i){p=n+1;break}continue}t===-1&&(i=!1,t=n+1),o===P?d===-1?d=n:r!==1&&(r=1):d!==-1&&(r=-1)}return d===-1||t===-1||r===0||r===1&&d===t-1&&d===p+1?"":u.slice(d,t)},format:b.bind(null,"/"),parse(u){m(u,"path");const d={root:"",dir:"",base:"",ext:"",name:""};if(u.length===0)return d;const p=u.charCodeAt(0)===_;let t;p?(d.root="/",t=1):t=0;let i=-1,r=0,n=-1,o=!0,g=u.length-1,f=0;for(;g>=t;--g){const E=u.charCodeAt(g);if(E===_){if(!o){r=g+1;break}continue}n===-1&&(o=!1,n=g+1),E===P?i===-1?i=g:f!==1&&(f=1):i!==-1&&(f=-1)}if(n!==-1){const E=r===0&&p?1:r;i===-1||f===0||f===1&&i===n-1&&i===r+1?d.base=d.name=u.slice(E,n):(d.name=u.slice(E,i),d.base=u.slice(E,n),d.ext=u.slice(i,n))}return r>0?d.dir=u.slice(0,r-1):p&&(d.dir="/"),d},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=v.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=v.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=v.platform==="win32"?e.win32.join:e.posix.join,e.resolve=v.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=v.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=v.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=v.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=v.platform==="win32"?e.win32.extname:e.posix.extname,e.format=v.platform==="win32"?e.win32.format:e.posix.format,e.parse=v.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=v.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=v.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=v.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(ge[135],pe([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var v;(function(D){D[D.stdout=0]="stdout",D[D.stderr=1]="stderr"})(v=e.Source||(e.Source={}));var R;(function(D){D[D.Success=0]="Success",D[D.Unknown=1]="Unknown",D[D.AccessDenied=2]="AccessDenied",D[D.ProcessNotFound=3]="ProcessNotFound"})(R=e.TerminateResponseCode||(e.TerminateResponseCode={}));function k(D,...A){const P=A.reduce((s,I)=>(s[I]=!0,s),{}),_=[/^ELECTRON_.+$/,/^VSCODE_.+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(D).filter(s=>!P[s]).forEach(s=>{for(let I=0;I<_.length;I++)if(s.search(_[I])!==-1){delete D[s];break}})}e.sanitizeProcessEnvironment=k}),define(ge[43],pe([0,1,11]),function(Q,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const R=v.globals.performance&&typeof v.globals.performance.now=="function";class k{constructor(A){this._highResolution=R&&A,this._startTime=this._now(),this._stopTime=-1}static create(A=!0){return new k(A)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?v.globals.performance.now():Date.now()}}e.StopWatch=k}),define(ge[3],pe([0,1,14,68,6,71,43]),function(Q,e,v,R,k,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.PauseableEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var P;(function(w){w.None=()=>k.Disposable.None;function b(q){return(N,H=null,T)=>{let U=!1,F;return F=q(M=>{if(!U)return F?F.dispose():U=!0,N.call(H,M)},null,T),U&&F.dispose(),F}}w.once=b;function u(q,N){return n((H,T=null,U)=>q(F=>H.call(T,N(F)),null,U))}w.map=u;function d(q,N){return n((H,T=null,U)=>q(F=>{N(F),H.call(T,F)},null,U))}w.forEach=d;function p(q,N){return n((H,T=null,U)=>q(F=>N(F)&&H.call(T,F),null,U))}w.filter=p;function t(q){return q}w.signal=t;function i(...q){return(N,H=null,T)=>k.combinedDisposable(...q.map(U=>U(F=>N.call(H,F),null,T)))}w.any=i;function r(q,N,H){let T=H;return u(q,U=>(T=N(T,U),T))}w.reduce=r;function n(q){let N;const H=new l({onFirstListenerAdd(){N=q(H.fire,H)},onLastListenerRemove(){N.dispose()}});return H.event}w.snapshot=n;function o(q,N,H=100,T=!1,U){let F,M,x,$=0;const X=new l({leakWarningThreshold:U,onFirstListenerAdd(){F=q(le=>{$++,M=N(M,le),T&&!x&&(X.fire(M),M=void 0),clearTimeout(x),x=setTimeout(()=>{const be=M;M=void 0,x=void 0,(!T||$>1)&&X.fire(be),$=0},H)})},onLastListenerRemove(){F.dispose()}});return X.event}w.debounce=o;function g(q){const N=new Date().getTime();return u(b(q),H=>new Date().getTime()-N)}w.stopwatch=g;function f(q,N=(H,T)=>H===T){let H=!0,T;return p(q,U=>{const F=H||!N(U,T);return H=!1,T=U,F})}w.latch=f;function E(q,N){return[w.filter(q,N),w.filter(q,H=>!N(H))]}w.split=E;function y(q,N=!1,H=[]){let T=H.slice(),U=q(x=>{T?T.push(x):M.fire(x)});const F=()=>{T&&T.forEach(x=>M.fire(x)),T=null},M=new l({onFirstListenerAdd(){U||(U=q(x=>M.fire(x)))},onFirstListenerDidAdd(){T&&(N?setTimeout(F):F())},onLastListenerRemove(){U&&U.dispose(),U=null}});return M.event}w.buffer=y;class a{constructor(N){this.event=N}map(N){return new a(u(this.event,N))}forEach(N){return new a(d(this.event,N))}filter(N){return new a(p(this.event,N))}reduce(N,H){return new a(r(this.event,N,H))}latch(){return new a(f(this.event))}debounce(N,H=100,T=!1,U){return new a(o(this.event,N,H,T,U))}on(N,H,T){return this.event(N,H,T)}once(N,H,T){return b(this.event)(N,H,T)}}function L(q){return new a(q)}w.chain=L;function O(q,N,H=T=>T){const T=(...x)=>M.fire(H(...x)),U=()=>q.on(N,T),F=()=>q.removeListener(N,T),M=new l({onFirstListenerAdd:U,onLastListenerRemove:F});return M.event}w.fromNodeEventEmitter=O;function W(q,N,H=T=>T){const T=(...x)=>M.fire(H(...x)),U=()=>q.addEventListener(N,T),F=()=>q.removeEventListener(N,T),M=new l({onFirstListenerAdd:U,onLastListenerRemove:F});return M.event}w.fromDOMEventEmitter=W;function J(q){const N=new l;let H=!1;return q.then(void 0,()=>null).then(()=>{H?N.fire(void 0):setTimeout(()=>N.fire(void 0),0)}),H=!0,N.event}w.fromPromise=J;function se(q){return new Promise(N=>b(q)(N))}w.toPromise=se})(P=e.Event||(e.Event={}));class _{constructor(b){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${b}_${_._idPool++}`}start(b){this._stopWatch=new A.StopWatch(!0),this._listenerCount=b}stop(){if(this._stopWatch){const b=this._stopWatch.elapsed();this._elapsedOverall+=b,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${b.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}_._idPool=0;let C=-1;function s(w){const b=C;return C=w,{dispose(){C=b}}}e.setGlobalLeakWarningThreshold=s;class I{constructor(b,u=Math.random().toString(18).slice(2,5)){this.customThreshold=b,this.name=u,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(b){let u=C;if(typeof this.customThreshold=="number"&&(u=this.customThreshold),u<=0||b<u)return;this._stacks||(this._stacks=new Map);const d=new Error().stack.split(`
`).slice(3).join(`
`),p=this._stacks.get(d)||0;if(this._stacks.set(d,p+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=u*.5;let t,i=0;for(const[r,n]of this._stacks)(!t||i<n)&&(t=r,i=n);console.warn(`[${this.name}] potential listener LEAK detected, having ${b} listeners already. MOST frequent listener (${i}):`),console.warn(t)}return()=>{const t=this._stacks.get(d)||0;this._stacks.set(d,t-1)}}}class l{constructor(b){var u;this._disposed=!1,this._options=b,this._leakageMon=C>0?new I(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=((u=this._options)===null||u===void 0?void 0:u._profName)?new _(this._options._profName):void 0}get event(){return this._event||(this._event=(b,u,d)=>{var p;this._listeners||(this._listeners=new D.LinkedList);const t=this._listeners.isEmpty();t&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const i=this._listeners.push(u?[b,u]:b);t&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,b,u);const r=(p=this._leakageMon)===null||p===void 0?void 0:p.check(this._listeners.size);let n;return n={dispose:()=>{r&&r(),n.dispose=l._noop,this._disposed||(i(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))}},d instanceof k.DisposableStore?d.add(n):Array.isArray(d)&&d.push(n),n}),this._event}fire(b){var u,d;if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new D.LinkedList);for(let p of this._listeners)this._deliveryQueue.push([p,b]);for((u=this._perfMon)===null||u===void 0||u.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[p,t]=this._deliveryQueue.shift();try{typeof p=="function"?p.call(void 0,t):p[0].call(p[1],t)}catch(i){v.onUnexpectedError(i)}}(d=this._perfMon)===null||d===void 0||d.stop()}}dispose(){var b,u,d,p,t;this._disposed||(this._disposed=!0,(b=this._listeners)===null||b===void 0||b.clear(),(u=this._deliveryQueue)===null||u===void 0||u.clear(),(p=(d=this._options)===null||d===void 0?void 0:d.onLastListenerRemove)===null||p===void 0||p.call(d),(t=this._leakageMon)===null||t===void 0||t.dispose())}}e.Emitter=l,l._noop=function(){};class m extends l{constructor(b){super(b);this._isPaused=0,this._eventQueue=new D.LinkedList,this._mergeFn=b==null?void 0:b.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const b=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(b))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(b){this._listeners&&(this._isPaused!==0?this._eventQueue.push(b):super.fire(b))}}e.PauseableEmitter=m;class c{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new l({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(b){const u={event:b,listener:null};this.events.push(u),this.hasListeners&&this.hook(u);const d=()=>{this.hasListeners&&this.unhook(u);const p=this.events.indexOf(u);this.events.splice(p,1)};return k.toDisposable(R.once(d))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(b=>this.hook(b))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(b=>this.unhook(b))}hook(b){b.listener=b.event(u=>this.emitter.fire(u))}unhook(b){b.listener&&b.listener.dispose(),b.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=c;class h{constructor(){this.buffers=[]}wrapEvent(b){return(u,d,p)=>b(t=>{const i=this.buffers[this.buffers.length-1];i?i.push(()=>u.call(d,t)):u.call(d,t)},void 0,p)}bufferEvents(b){const u=[];this.buffers.push(u);const d=b();return this.buffers.pop(),u.forEach(p=>p()),d}}e.EventBufferer=h;class S{constructor(){this.listening=!1,this.inputEvent=P.None,this.inputEventListener=k.Disposable.None,this.emitter=new l({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(b){this.inputEvent=b,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=b(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=S}),define(ge[21],pe([0,1,3]),function(Q,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const R=Object.freeze(function(P,_){const C=setTimeout(P.bind(_),0);return{dispose(){clearTimeout(C)}}});var k;(function(P){function _(C){return C===P.None||C===P.Cancelled||C instanceof D?!0:!C||typeof C!="object"?!1:typeof C.isCancellationRequested=="boolean"&&typeof C.onCancellationRequested=="function"}P.isCancellationToken=_,P.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:v.Event.None}),P.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:R})})(k=e.CancellationToken||(e.CancellationToken={}));class D{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?R:(this._emitter||(this._emitter=new v.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class A{constructor(_){this._token=void 0,this._parentListener=void 0,this._parentListener=_&&_.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new D),this._token}cancel(){this._token?this._token instanceof D&&this._token.cancel():this._token=k.Cancelled}dispose(_=!1){_&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof D&&this._token.dispose():this._token=k.None}}e.CancellationTokenSource=A}),define(ge[92],pe([0,1,3]),function(Q,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=e.registerCodicon=e.iconRegistry=void 0;class R{constructor(){this._icons=new Map,this._onDidRegister=new v.Emitter}add(I){const l=this._icons.get(I.id);l?I.description?l.description=I.description:console.error(`Duplicate registration of codicon ${I.id}`):(this._icons.set(I.id,I),this._onDidRegister.fire(I))}get(I){return this._icons.get(I)}get all(){return this._icons.values()}get onDidRegister(){return this._onDidRegister.event}}const k=new R;e.iconRegistry=k;function D(s,I){return new P(s,I)}e.registerCodicon=D;function A(s){return s?s.replace(/\$\((.*?)\)/g,(I,l)=>` ${l} `).trim():""}e.getCodiconAriaLabel=A;class P{constructor(I,l,m){this.id=I,this.definition=l,this.description=m,k.add(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}}e.Codicon=P;function _(s,I){const l=["codicon","codicon-"+s];return I&&l.push("codicon-modifier-"+I),l}e.getClassNamesArray=_;var C;(function(s){s.iconNameSegment="[A-Za-z0-9]+",s.iconNameExpression="[A-Za-z0-9\\-]+",s.iconModifierExpression="~[A-Za-z]+";const I=new RegExp(`^(${s.iconNameExpression})(${s.iconModifierExpression})?$`);function l(h){if(h instanceof P)return["codicon","codicon-"+h.id];const S=I.exec(h.id);if(!S)return l(P.error);let[,w,b]=S;const u=["codicon","codicon-"+w];return b&&u.push("codicon-modifier-"+b.substr(1)),u}s.asClassNameArray=l;function m(h){return l(h).join(" ")}s.asClassName=m;function c(h){return"."+l(h).join(".")}s.asCSSSelector=c})(C=e.CSSIcon||(e.CSSIcon={})),function(s){s.add=new s("add",{fontCharacter:"\\ea60"}),s.plus=new s("plus",{fontCharacter:"\\ea60"}),s.gistNew=new s("gist-new",{fontCharacter:"\\ea60"}),s.repoCreate=new s("repo-create",{fontCharacter:"\\ea60"}),s.lightbulb=new s("lightbulb",{fontCharacter:"\\ea61"}),s.lightBulb=new s("light-bulb",{fontCharacter:"\\ea61"}),s.repo=new s("repo",{fontCharacter:"\\ea62"}),s.repoDelete=new s("repo-delete",{fontCharacter:"\\ea62"}),s.gistFork=new s("gist-fork",{fontCharacter:"\\ea63"}),s.repoForked=new s("repo-forked",{fontCharacter:"\\ea63"}),s.gitPullRequest=new s("git-pull-request",{fontCharacter:"\\ea64"}),s.gitPullRequestAbandoned=new s("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),s.recordKeys=new s("record-keys",{fontCharacter:"\\ea65"}),s.keyboard=new s("keyboard",{fontCharacter:"\\ea65"}),s.tag=new s("tag",{fontCharacter:"\\ea66"}),s.tagAdd=new s("tag-add",{fontCharacter:"\\ea66"}),s.tagRemove=new s("tag-remove",{fontCharacter:"\\ea66"}),s.person=new s("person",{fontCharacter:"\\ea67"}),s.personFollow=new s("person-follow",{fontCharacter:"\\ea67"}),s.personOutline=new s("person-outline",{fontCharacter:"\\ea67"}),s.personFilled=new s("person-filled",{fontCharacter:"\\ea67"}),s.gitBranch=new s("git-branch",{fontCharacter:"\\ea68"}),s.gitBranchCreate=new s("git-branch-create",{fontCharacter:"\\ea68"}),s.gitBranchDelete=new s("git-branch-delete",{fontCharacter:"\\ea68"}),s.sourceControl=new s("source-control",{fontCharacter:"\\ea68"}),s.mirror=new s("mirror",{fontCharacter:"\\ea69"}),s.mirrorPublic=new s("mirror-public",{fontCharacter:"\\ea69"}),s.star=new s("star",{fontCharacter:"\\ea6a"}),s.starAdd=new s("star-add",{fontCharacter:"\\ea6a"}),s.starDelete=new s("star-delete",{fontCharacter:"\\ea6a"}),s.starEmpty=new s("star-empty",{fontCharacter:"\\ea6a"}),s.comment=new s("comment",{fontCharacter:"\\ea6b"}),s.commentAdd=new s("comment-add",{fontCharacter:"\\ea6b"}),s.alert=new s("alert",{fontCharacter:"\\ea6c"}),s.warning=new s("warning",{fontCharacter:"\\ea6c"}),s.search=new s("search",{fontCharacter:"\\ea6d"}),s.searchSave=new s("search-save",{fontCharacter:"\\ea6d"}),s.logOut=new s("log-out",{fontCharacter:"\\ea6e"}),s.signOut=new s("sign-out",{fontCharacter:"\\ea6e"}),s.logIn=new s("log-in",{fontCharacter:"\\ea6f"}),s.signIn=new s("sign-in",{fontCharacter:"\\ea6f"}),s.eye=new s("eye",{fontCharacter:"\\ea70"}),s.eyeUnwatch=new s("eye-unwatch",{fontCharacter:"\\ea70"}),s.eyeWatch=new s("eye-watch",{fontCharacter:"\\ea70"}),s.circleFilled=new s("circle-filled",{fontCharacter:"\\ea71"}),s.primitiveDot=new s("primitive-dot",{fontCharacter:"\\ea71"}),s.closeDirty=new s("close-dirty",{fontCharacter:"\\ea71"}),s.debugBreakpoint=new s("debug-breakpoint",{fontCharacter:"\\ea71"}),s.debugBreakpointDisabled=new s("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),s.debugHint=new s("debug-hint",{fontCharacter:"\\ea71"}),s.primitiveSquare=new s("primitive-square",{fontCharacter:"\\ea72"}),s.edit=new s("edit",{fontCharacter:"\\ea73"}),s.pencil=new s("pencil",{fontCharacter:"\\ea73"}),s.info=new s("info",{fontCharacter:"\\ea74"}),s.issueOpened=new s("issue-opened",{fontCharacter:"\\ea74"}),s.gistPrivate=new s("gist-private",{fontCharacter:"\\ea75"}),s.gitForkPrivate=new s("git-fork-private",{fontCharacter:"\\ea75"}),s.lock=new s("lock",{fontCharacter:"\\ea75"}),s.mirrorPrivate=new s("mirror-private",{fontCharacter:"\\ea75"}),s.close=new s("close",{fontCharacter:"\\ea76"}),s.removeClose=new s("remove-close",{fontCharacter:"\\ea76"}),s.x=new s("x",{fontCharacter:"\\ea76"}),s.repoSync=new s("repo-sync",{fontCharacter:"\\ea77"}),s.sync=new s("sync",{fontCharacter:"\\ea77"}),s.clone=new s("clone",{fontCharacter:"\\ea78"}),s.desktopDownload=new s("desktop-download",{fontCharacter:"\\ea78"}),s.beaker=new s("beaker",{fontCharacter:"\\ea79"}),s.microscope=new s("microscope",{fontCharacter:"\\ea79"}),s.vm=new s("vm",{fontCharacter:"\\ea7a"}),s.deviceDesktop=new s("device-desktop",{fontCharacter:"\\ea7a"}),s.file=new s("file",{fontCharacter:"\\ea7b"}),s.fileText=new s("file-text",{fontCharacter:"\\ea7b"}),s.more=new s("more",{fontCharacter:"\\ea7c"}),s.ellipsis=new s("ellipsis",{fontCharacter:"\\ea7c"}),s.kebabHorizontal=new s("kebab-horizontal",{fontCharacter:"\\ea7c"}),s.mailReply=new s("mail-reply",{fontCharacter:"\\ea7d"}),s.reply=new s("reply",{fontCharacter:"\\ea7d"}),s.organization=new s("organization",{fontCharacter:"\\ea7e"}),s.organizationFilled=new s("organization-filled",{fontCharacter:"\\ea7e"}),s.organizationOutline=new s("organization-outline",{fontCharacter:"\\ea7e"}),s.newFile=new s("new-file",{fontCharacter:"\\ea7f"}),s.fileAdd=new s("file-add",{fontCharacter:"\\ea7f"}),s.newFolder=new s("new-folder",{fontCharacter:"\\ea80"}),s.fileDirectoryCreate=new s("file-directory-create",{fontCharacter:"\\ea80"}),s.trash=new s("trash",{fontCharacter:"\\ea81"}),s.trashcan=new s("trashcan",{fontCharacter:"\\ea81"}),s.history=new s("history",{fontCharacter:"\\ea82"}),s.clock=new s("clock",{fontCharacter:"\\ea82"}),s.folder=new s("folder",{fontCharacter:"\\ea83"}),s.fileDirectory=new s("file-directory",{fontCharacter:"\\ea83"}),s.symbolFolder=new s("symbol-folder",{fontCharacter:"\\ea83"}),s.logoGithub=new s("logo-github",{fontCharacter:"\\ea84"}),s.markGithub=new s("mark-github",{fontCharacter:"\\ea84"}),s.github=new s("github",{fontCharacter:"\\ea84"}),s.terminal=new s("terminal",{fontCharacter:"\\ea85"}),s.console=new s("console",{fontCharacter:"\\ea85"}),s.repl=new s("repl",{fontCharacter:"\\ea85"}),s.zap=new s("zap",{fontCharacter:"\\ea86"}),s.symbolEvent=new s("symbol-event",{fontCharacter:"\\ea86"}),s.error=new s("error",{fontCharacter:"\\ea87"}),s.stop=new s("stop",{fontCharacter:"\\ea87"}),s.variable=new s("variable",{fontCharacter:"\\ea88"}),s.symbolVariable=new s("symbol-variable",{fontCharacter:"\\ea88"}),s.array=new s("array",{fontCharacter:"\\ea8a"}),s.symbolArray=new s("symbol-array",{fontCharacter:"\\ea8a"}),s.symbolModule=new s("symbol-module",{fontCharacter:"\\ea8b"}),s.symbolPackage=new s("symbol-package",{fontCharacter:"\\ea8b"}),s.symbolNamespace=new s("symbol-namespace",{fontCharacter:"\\ea8b"}),s.symbolObject=new s("symbol-object",{fontCharacter:"\\ea8b"}),s.symbolMethod=new s("symbol-method",{fontCharacter:"\\ea8c"}),s.symbolFunction=new s("symbol-function",{fontCharacter:"\\ea8c"}),s.symbolConstructor=new s("symbol-constructor",{fontCharacter:"\\ea8c"}),s.symbolBoolean=new s("symbol-boolean",{fontCharacter:"\\ea8f"}),s.symbolNull=new s("symbol-null",{fontCharacter:"\\ea8f"}),s.symbolNumeric=new s("symbol-numeric",{fontCharacter:"\\ea90"}),s.symbolNumber=new s("symbol-number",{fontCharacter:"\\ea90"}),s.symbolStructure=new s("symbol-structure",{fontCharacter:"\\ea91"}),s.symbolStruct=new s("symbol-struct",{fontCharacter:"\\ea91"}),s.symbolParameter=new s("symbol-parameter",{fontCharacter:"\\ea92"}),s.symbolTypeParameter=new s("symbol-type-parameter",{fontCharacter:"\\ea92"}),s.symbolKey=new s("symbol-key",{fontCharacter:"\\ea93"}),s.symbolText=new s("symbol-text",{fontCharacter:"\\ea93"}),s.symbolReference=new s("symbol-reference",{fontCharacter:"\\ea94"}),s.goToFile=new s("go-to-file",{fontCharacter:"\\ea94"}),s.symbolEnum=new s("symbol-enum",{fontCharacter:"\\ea95"}),s.symbolValue=new s("symbol-value",{fontCharacter:"\\ea95"}),s.symbolRuler=new s("symbol-ruler",{fontCharacter:"\\ea96"}),s.symbolUnit=new s("symbol-unit",{fontCharacter:"\\ea96"}),s.activateBreakpoints=new s("activate-breakpoints",{fontCharacter:"\\ea97"}),s.archive=new s("archive",{fontCharacter:"\\ea98"}),s.arrowBoth=new s("arrow-both",{fontCharacter:"\\ea99"}),s.arrowDown=new s("arrow-down",{fontCharacter:"\\ea9a"}),s.arrowLeft=new s("arrow-left",{fontCharacter:"\\ea9b"}),s.arrowRight=new s("arrow-right",{fontCharacter:"\\ea9c"}),s.arrowSmallDown=new s("arrow-small-down",{fontCharacter:"\\ea9d"}),s.arrowSmallLeft=new s("arrow-small-left",{fontCharacter:"\\ea9e"}),s.arrowSmallRight=new s("arrow-small-right",{fontCharacter:"\\ea9f"}),s.arrowSmallUp=new s("arrow-small-up",{fontCharacter:"\\eaa0"}),s.arrowUp=new s("arrow-up",{fontCharacter:"\\eaa1"}),s.bell=new s("bell",{fontCharacter:"\\eaa2"}),s.bold=new s("bold",{fontCharacter:"\\eaa3"}),s.book=new s("book",{fontCharacter:"\\eaa4"}),s.bookmark=new s("bookmark",{fontCharacter:"\\eaa5"}),s.debugBreakpointConditionalUnverified=new s("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),s.debugBreakpointConditional=new s("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),s.debugBreakpointConditionalDisabled=new s("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),s.debugBreakpointDataUnverified=new s("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),s.debugBreakpointData=new s("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),s.debugBreakpointDataDisabled=new s("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),s.debugBreakpointLogUnverified=new s("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),s.debugBreakpointLog=new s("debug-breakpoint-log",{fontCharacter:"\\eaab"}),s.debugBreakpointLogDisabled=new s("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),s.briefcase=new s("briefcase",{fontCharacter:"\\eaac"}),s.broadcast=new s("broadcast",{fontCharacter:"\\eaad"}),s.browser=new s("browser",{fontCharacter:"\\eaae"}),s.bug=new s("bug",{fontCharacter:"\\eaaf"}),s.calendar=new s("calendar",{fontCharacter:"\\eab0"}),s.caseSensitive=new s("case-sensitive",{fontCharacter:"\\eab1"}),s.check=new s("check",{fontCharacter:"\\eab2"}),s.checklist=new s("checklist",{fontCharacter:"\\eab3"}),s.chevronDown=new s("chevron-down",{fontCharacter:"\\eab4"}),s.chevronLeft=new s("chevron-left",{fontCharacter:"\\eab5"}),s.chevronRight=new s("chevron-right",{fontCharacter:"\\eab6"}),s.chevronUp=new s("chevron-up",{fontCharacter:"\\eab7"}),s.chromeClose=new s("chrome-close",{fontCharacter:"\\eab8"}),s.chromeMaximize=new s("chrome-maximize",{fontCharacter:"\\eab9"}),s.chromeMinimize=new s("chrome-minimize",{fontCharacter:"\\eaba"}),s.chromeRestore=new s("chrome-restore",{fontCharacter:"\\eabb"}),s.circleOutline=new s("circle-outline",{fontCharacter:"\\eabc"}),s.debugBreakpointUnverified=new s("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),s.circleSlash=new s("circle-slash",{fontCharacter:"\\eabd"}),s.circuitBoard=new s("circuit-board",{fontCharacter:"\\eabe"}),s.clearAll=new s("clear-all",{fontCharacter:"\\eabf"}),s.clippy=new s("clippy",{fontCharacter:"\\eac0"}),s.closeAll=new s("close-all",{fontCharacter:"\\eac1"}),s.cloudDownload=new s("cloud-download",{fontCharacter:"\\eac2"}),s.cloudUpload=new s("cloud-upload",{fontCharacter:"\\eac3"}),s.code=new s("code",{fontCharacter:"\\eac4"}),s.collapseAll=new s("collapse-all",{fontCharacter:"\\eac5"}),s.colorMode=new s("color-mode",{fontCharacter:"\\eac6"}),s.commentDiscussion=new s("comment-discussion",{fontCharacter:"\\eac7"}),s.compareChanges=new s("compare-changes",{fontCharacter:"\\eafd"}),s.creditCard=new s("credit-card",{fontCharacter:"\\eac9"}),s.dash=new s("dash",{fontCharacter:"\\eacc"}),s.dashboard=new s("dashboard",{fontCharacter:"\\eacd"}),s.database=new s("database",{fontCharacter:"\\eace"}),s.debugContinue=new s("debug-continue",{fontCharacter:"\\eacf"}),s.debugDisconnect=new s("debug-disconnect",{fontCharacter:"\\ead0"}),s.debugPause=new s("debug-pause",{fontCharacter:"\\ead1"}),s.debugRestart=new s("debug-restart",{fontCharacter:"\\ead2"}),s.debugStart=new s("debug-start",{fontCharacter:"\\ead3"}),s.debugStepInto=new s("debug-step-into",{fontCharacter:"\\ead4"}),s.debugStepOut=new s("debug-step-out",{fontCharacter:"\\ead5"}),s.debugStepOver=new s("debug-step-over",{fontCharacter:"\\ead6"}),s.debugStop=new s("debug-stop",{fontCharacter:"\\ead7"}),s.debug=new s("debug",{fontCharacter:"\\ead8"}),s.deviceCameraVideo=new s("device-camera-video",{fontCharacter:"\\ead9"}),s.deviceCamera=new s("device-camera",{fontCharacter:"\\eada"}),s.deviceMobile=new s("device-mobile",{fontCharacter:"\\eadb"}),s.diffAdded=new s("diff-added",{fontCharacter:"\\eadc"}),s.diffIgnored=new s("diff-ignored",{fontCharacter:"\\eadd"}),s.diffModified=new s("diff-modified",{fontCharacter:"\\eade"}),s.diffRemoved=new s("diff-removed",{fontCharacter:"\\eadf"}),s.diffRenamed=new s("diff-renamed",{fontCharacter:"\\eae0"}),s.diff=new s("diff",{fontCharacter:"\\eae1"}),s.discard=new s("discard",{fontCharacter:"\\eae2"}),s.editorLayout=new s("editor-layout",{fontCharacter:"\\eae3"}),s.emptyWindow=new s("empty-window",{fontCharacter:"\\eae4"}),s.exclude=new s("exclude",{fontCharacter:"\\eae5"}),s.extensions=new s("extensions",{fontCharacter:"\\eae6"}),s.eyeClosed=new s("eye-closed",{fontCharacter:"\\eae7"}),s.fileBinary=new s("file-binary",{fontCharacter:"\\eae8"}),s.fileCode=new s("file-code",{fontCharacter:"\\eae9"}),s.fileMedia=new s("file-media",{fontCharacter:"\\eaea"}),s.filePdf=new s("file-pdf",{fontCharacter:"\\eaeb"}),s.fileSubmodule=new s("file-submodule",{fontCharacter:"\\eaec"}),s.fileSymlinkDirectory=new s("file-symlink-directory",{fontCharacter:"\\eaed"}),s.fileSymlinkFile=new s("file-symlink-file",{fontCharacter:"\\eaee"}),s.fileZip=new s("file-zip",{fontCharacter:"\\eaef"}),s.files=new s("files",{fontCharacter:"\\eaf0"}),s.filter=new s("filter",{fontCharacter:"\\eaf1"}),s.flame=new s("flame",{fontCharacter:"\\eaf2"}),s.foldDown=new s("fold-down",{fontCharacter:"\\eaf3"}),s.foldUp=new s("fold-up",{fontCharacter:"\\eaf4"}),s.fold=new s("fold",{fontCharacter:"\\eaf5"}),s.folderActive=new s("folder-active",{fontCharacter:"\\eaf6"}),s.folderOpened=new s("folder-opened",{fontCharacter:"\\eaf7"}),s.gear=new s("gear",{fontCharacter:"\\eaf8"}),s.gift=new s("gift",{fontCharacter:"\\eaf9"}),s.gistSecret=new s("gist-secret",{fontCharacter:"\\eafa"}),s.gist=new s("gist",{fontCharacter:"\\eafb"}),s.gitCommit=new s("git-commit",{fontCharacter:"\\eafc"}),s.gitCompare=new s("git-compare",{fontCharacter:"\\eafd"}),s.gitMerge=new s("git-merge",{fontCharacter:"\\eafe"}),s.githubAction=new s("github-action",{fontCharacter:"\\eaff"}),s.githubAlt=new s("github-alt",{fontCharacter:"\\eb00"}),s.globe=new s("globe",{fontCharacter:"\\eb01"}),s.grabber=new s("grabber",{fontCharacter:"\\eb02"}),s.graph=new s("graph",{fontCharacter:"\\eb03"}),s.gripper=new s("gripper",{fontCharacter:"\\eb04"}),s.heart=new s("heart",{fontCharacter:"\\eb05"}),s.home=new s("home",{fontCharacter:"\\eb06"}),s.horizontalRule=new s("horizontal-rule",{fontCharacter:"\\eb07"}),s.hubot=new s("hubot",{fontCharacter:"\\eb08"}),s.inbox=new s("inbox",{fontCharacter:"\\eb09"}),s.issueClosed=new s("issue-closed",{fontCharacter:"\\eb0a"}),s.issueReopened=new s("issue-reopened",{fontCharacter:"\\eb0b"}),s.issues=new s("issues",{fontCharacter:"\\eb0c"}),s.italic=new s("italic",{fontCharacter:"\\eb0d"}),s.jersey=new s("jersey",{fontCharacter:"\\eb0e"}),s.json=new s("json",{fontCharacter:"\\eb0f"}),s.kebabVertical=new s("kebab-vertical",{fontCharacter:"\\eb10"}),s.key=new s("key",{fontCharacter:"\\eb11"}),s.law=new s("law",{fontCharacter:"\\eb12"}),s.lightbulbAutofix=new s("lightbulb-autofix",{fontCharacter:"\\eb13"}),s.linkExternal=new s("link-external",{fontCharacter:"\\eb14"}),s.link=new s("link",{fontCharacter:"\\eb15"}),s.listOrdered=new s("list-ordered",{fontCharacter:"\\eb16"}),s.listUnordered=new s("list-unordered",{fontCharacter:"\\eb17"}),s.liveShare=new s("live-share",{fontCharacter:"\\eb18"}),s.loading=new s("loading",{fontCharacter:"\\eb19"}),s.location=new s("location",{fontCharacter:"\\eb1a"}),s.mailRead=new s("mail-read",{fontCharacter:"\\eb1b"}),s.mail=new s("mail",{fontCharacter:"\\eb1c"}),s.markdown=new s("markdown",{fontCharacter:"\\eb1d"}),s.megaphone=new s("megaphone",{fontCharacter:"\\eb1e"}),s.mention=new s("mention",{fontCharacter:"\\eb1f"}),s.milestone=new s("milestone",{fontCharacter:"\\eb20"}),s.mortarBoard=new s("mortar-board",{fontCharacter:"\\eb21"}),s.move=new s("move",{fontCharacter:"\\eb22"}),s.multipleWindows=new s("multiple-windows",{fontCharacter:"\\eb23"}),s.mute=new s("mute",{fontCharacter:"\\eb24"}),s.noNewline=new s("no-newline",{fontCharacter:"\\eb25"}),s.note=new s("note",{fontCharacter:"\\eb26"}),s.octoface=new s("octoface",{fontCharacter:"\\eb27"}),s.openPreview=new s("open-preview",{fontCharacter:"\\eb28"}),s.package_=new s("package",{fontCharacter:"\\eb29"}),s.paintcan=new s("paintcan",{fontCharacter:"\\eb2a"}),s.pin=new s("pin",{fontCharacter:"\\eb2b"}),s.play=new s("play",{fontCharacter:"\\eb2c"}),s.run=new s("run",{fontCharacter:"\\eb2c"}),s.plug=new s("plug",{fontCharacter:"\\eb2d"}),s.preserveCase=new s("preserve-case",{fontCharacter:"\\eb2e"}),s.preview=new s("preview",{fontCharacter:"\\eb2f"}),s.project=new s("project",{fontCharacter:"\\eb30"}),s.pulse=new s("pulse",{fontCharacter:"\\eb31"}),s.question=new s("question",{fontCharacter:"\\eb32"}),s.quote=new s("quote",{fontCharacter:"\\eb33"}),s.radioTower=new s("radio-tower",{fontCharacter:"\\eb34"}),s.reactions=new s("reactions",{fontCharacter:"\\eb35"}),s.references=new s("references",{fontCharacter:"\\eb36"}),s.refresh=new s("refresh",{fontCharacter:"\\eb37"}),s.regex=new s("regex",{fontCharacter:"\\eb38"}),s.remoteExplorer=new s("remote-explorer",{fontCharacter:"\\eb39"}),s.remote=new s("remote",{fontCharacter:"\\eb3a"}),s.remove=new s("remove",{fontCharacter:"\\eb3b"}),s.replaceAll=new s("replace-all",{fontCharacter:"\\eb3c"}),s.replace=new s("replace",{fontCharacter:"\\eb3d"}),s.repoClone=new s("repo-clone",{fontCharacter:"\\eb3e"}),s.repoForcePush=new s("repo-force-push",{fontCharacter:"\\eb3f"}),s.repoPull=new s("repo-pull",{fontCharacter:"\\eb40"}),s.repoPush=new s("repo-push",{fontCharacter:"\\eb41"}),s.report=new s("report",{fontCharacter:"\\eb42"}),s.requestChanges=new s("request-changes",{fontCharacter:"\\eb43"}),s.rocket=new s("rocket",{fontCharacter:"\\eb44"}),s.rootFolderOpened=new s("root-folder-opened",{fontCharacter:"\\eb45"}),s.rootFolder=new s("root-folder",{fontCharacter:"\\eb46"}),s.rss=new s("rss",{fontCharacter:"\\eb47"}),s.ruby=new s("ruby",{fontCharacter:"\\eb48"}),s.saveAll=new s("save-all",{fontCharacter:"\\eb49"}),s.saveAs=new s("save-as",{fontCharacter:"\\eb4a"}),s.save=new s("save",{fontCharacter:"\\eb4b"}),s.screenFull=new s("screen-full",{fontCharacter:"\\eb4c"}),s.screenNormal=new s("screen-normal",{fontCharacter:"\\eb4d"}),s.searchStop=new s("search-stop",{fontCharacter:"\\eb4e"}),s.server=new s("server",{fontCharacter:"\\eb50"}),s.settingsGear=new s("settings-gear",{fontCharacter:"\\eb51"}),s.settings=new s("settings",{fontCharacter:"\\eb52"}),s.shield=new s("shield",{fontCharacter:"\\eb53"}),s.smiley=new s("smiley",{fontCharacter:"\\eb54"}),s.sortPrecedence=new s("sort-precedence",{fontCharacter:"\\eb55"}),s.splitHorizontal=new s("split-horizontal",{fontCharacter:"\\eb56"}),s.splitVertical=new s("split-vertical",{fontCharacter:"\\eb57"}),s.squirrel=new s("squirrel",{fontCharacter:"\\eb58"}),s.starFull=new s("star-full",{fontCharacter:"\\eb59"}),s.starHalf=new s("star-half",{fontCharacter:"\\eb5a"}),s.symbolClass=new s("symbol-class",{fontCharacter:"\\eb5b"}),s.symbolColor=new s("symbol-color",{fontCharacter:"\\eb5c"}),s.symbolConstant=new s("symbol-constant",{fontCharacter:"\\eb5d"}),s.symbolEnumMember=new s("symbol-enum-member",{fontCharacter:"\\eb5e"}),s.symbolField=new s("symbol-field",{fontCharacter:"\\eb5f"}),s.symbolFile=new s("symbol-file",{fontCharacter:"\\eb60"}),s.symbolInterface=new s("symbol-interface",{fontCharacter:"\\eb61"}),s.symbolKeyword=new s("symbol-keyword",{fontCharacter:"\\eb62"}),s.symbolMisc=new s("symbol-misc",{fontCharacter:"\\eb63"}),s.symbolOperator=new s("symbol-operator",{fontCharacter:"\\eb64"}),s.symbolProperty=new s("symbol-property",{fontCharacter:"\\eb65"}),s.wrench=new s("wrench",{fontCharacter:"\\eb65"}),s.wrenchSubaction=new s("wrench-subaction",{fontCharacter:"\\eb65"}),s.symbolSnippet=new s("symbol-snippet",{fontCharacter:"\\eb66"}),s.tasklist=new s("tasklist",{fontCharacter:"\\eb67"}),s.telescope=new s("telescope",{fontCharacter:"\\eb68"}),s.textSize=new s("text-size",{fontCharacter:"\\eb69"}),s.threeBars=new s("three-bars",{fontCharacter:"\\eb6a"}),s.thumbsdown=new s("thumbsdown",{fontCharacter:"\\eb6b"}),s.thumbsup=new s("thumbsup",{fontCharacter:"\\eb6c"}),s.tools=new s("tools",{fontCharacter:"\\eb6d"}),s.triangleDown=new s("triangle-down",{fontCharacter:"\\eb6e"}),s.triangleLeft=new s("triangle-left",{fontCharacter:"\\eb6f"}),s.triangleRight=new s("triangle-right",{fontCharacter:"\\eb70"}),s.triangleUp=new s("triangle-up",{fontCharacter:"\\eb71"}),s.twitter=new s("twitter",{fontCharacter:"\\eb72"}),s.unfold=new s("unfold",{fontCharacter:"\\eb73"}),s.unlock=new s("unlock",{fontCharacter:"\\eb74"}),s.unmute=new s("unmute",{fontCharacter:"\\eb75"}),s.unverified=new s("unverified",{fontCharacter:"\\eb76"}),s.verified=new s("verified",{fontCharacter:"\\eb77"}),s.versions=new s("versions",{fontCharacter:"\\eb78"}),s.vmActive=new s("vm-active",{fontCharacter:"\\eb79"}),s.vmOutline=new s("vm-outline",{fontCharacter:"\\eb7a"}),s.vmRunning=new s("vm-running",{fontCharacter:"\\eb7b"}),s.watch=new s("watch",{fontCharacter:"\\eb7c"}),s.whitespace=new s("whitespace",{fontCharacter:"\\eb7d"}),s.wholeWord=new s("whole-word",{fontCharacter:"\\eb7e"}),s.window=new s("window",{fontCharacter:"\\eb7f"}),s.wordWrap=new s("word-wrap",{fontCharacter:"\\eb80"}),s.zoomIn=new s("zoom-in",{fontCharacter:"\\eb81"}),s.zoomOut=new s("zoom-out",{fontCharacter:"\\eb82"}),s.listFilter=new s("list-filter",{fontCharacter:"\\eb83"}),s.listFlat=new s("list-flat",{fontCharacter:"\\eb84"}),s.listSelection=new s("list-selection",{fontCharacter:"\\eb85"}),s.selection=new s("selection",{fontCharacter:"\\eb85"}),s.listTree=new s("list-tree",{fontCharacter:"\\eb86"}),s.debugBreakpointFunctionUnverified=new s("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),s.debugBreakpointFunction=new s("debug-breakpoint-function",{fontCharacter:"\\eb88"}),s.debugBreakpointFunctionDisabled=new s("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),s.debugStackframeActive=new s("debug-stackframe-active",{fontCharacter:"\\eb89"}),s.debugStackframeDot=new s("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),s.debugStackframe=new s("debug-stackframe",{fontCharacter:"\\eb8b"}),s.debugStackframeFocused=new s("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),s.debugBreakpointUnsupported=new s("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),s.symbolString=new s("symbol-string",{fontCharacter:"\\eb8d"}),s.debugReverseContinue=new s("debug-reverse-continue",{fontCharacter:"\\eb8e"}),s.debugStepBack=new s("debug-step-back",{fontCharacter:"\\eb8f"}),s.debugRestartFrame=new s("debug-restart-frame",{fontCharacter:"\\eb90"}),s.callIncoming=new s("call-incoming",{fontCharacter:"\\eb92"}),s.callOutgoing=new s("call-outgoing",{fontCharacter:"\\eb93"}),s.menu=new s("menu",{fontCharacter:"\\eb94"}),s.expandAll=new s("expand-all",{fontCharacter:"\\eb95"}),s.feedback=new s("feedback",{fontCharacter:"\\eb96"}),s.groupByRefType=new s("group-by-ref-type",{fontCharacter:"\\eb97"}),s.ungroupByRefType=new s("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),s.account=new s("account",{fontCharacter:"\\eb99"}),s.bellDot=new s("bell-dot",{fontCharacter:"\\eb9a"}),s.debugConsole=new s("debug-console",{fontCharacter:"\\eb9b"}),s.library=new s("library",{fontCharacter:"\\eb9c"}),s.output=new s("output",{fontCharacter:"\\eb9d"}),s.runAll=new s("run-all",{fontCharacter:"\\eb9e"}),s.syncIgnored=new s("sync-ignored",{fontCharacter:"\\eb9f"}),s.pinned=new s("pinned",{fontCharacter:"\\eba0"}),s.githubInverted=new s("github-inverted",{fontCharacter:"\\eba1"}),s.debugAlt=new s("debug-alt",{fontCharacter:"\\eb91"}),s.serverProcess=new s("server-process",{fontCharacter:"\\eba2"}),s.serverEnvironment=new s("server-environment",{fontCharacter:"\\eba3"}),s.pass=new s("pass",{fontCharacter:"\\eba4"}),s.stopCircle=new s("stop-circle",{fontCharacter:"\\eba5"}),s.playCircle=new s("play-circle",{fontCharacter:"\\eba6"}),s.record=new s("record",{fontCharacter:"\\eba7"}),s.debugAltSmall=new s("debug-alt-small",{fontCharacter:"\\eba8"}),s.vmConnect=new s("vm-connect",{fontCharacter:"\\eba9"}),s.cloud=new s("cloud",{fontCharacter:"\\ebaa"}),s.merge=new s("merge",{fontCharacter:"\\ebab"}),s.exportIcon=new s("export",{fontCharacter:"\\ebac"}),s.graphLeft=new s("graph-left",{fontCharacter:"\\ebad"}),s.magnet=new s("magnet",{fontCharacter:"\\ebae"}),s.notebook=new s("notebook",{fontCharacter:"\\ebaf"}),s.redo=new s("redo",{fontCharacter:"\\ebb0"}),s.checkAll=new s("check-all",{fontCharacter:"\\ebb1"}),s.pinnedDirty=new s("pinned-dirty",{fontCharacter:"\\ebb2"}),s.passFilled=new s("pass-filled",{fontCharacter:"\\ebb3"}),s.circleLargeFilled=new s("circle-large-filled",{fontCharacter:"\\ebb4"}),s.circleLargeOutline=new s("circle-large-outline",{fontCharacter:"\\ebb5"}),s.combine=new s("combine",{fontCharacter:"\\ebb6"}),s.gather=new s("gather",{fontCharacter:"\\ebb6"}),s.table=new s("table",{fontCharacter:"\\ebb7"}),s.variableGroup=new s("variable-group",{fontCharacter:"\\ebb8"}),s.typeHierarchy=new s("type-hierarchy",{fontCharacter:"\\ebb9"}),s.typeHierarchySub=new s("type-hierarchy-sub",{fontCharacter:"\\ebba"}),s.typeHierarchySuper=new s("type-hierarchy-super",{fontCharacter:"\\ebbb"}),s.gitPullRequestCreate=new s("git-pull-request-create",{fontCharacter:"\\ebbc"}),s.runAbove=new s("run-above",{fontCharacter:"\\ebbd"}),s.runBelow=new s("run-below",{fontCharacter:"\\ebbe"}),s.notebookTemplate=new s("notebook-template",{fontCharacter:"\\ebbf"}),s.debugRerun=new s("debug-rerun",{fontCharacter:"\\ebc0"}),s.workspaceTrusted=new s("workspace-trusted",{fontCharacter:"\\ebc1"}),s.workspaceUntrusted=new s("workspace-untrusted",{fontCharacter:"\\ebc2"}),s.workspaceUnspecified=new s("workspace-unspecified",{fontCharacter:"\\ebc3"}),s.terminalCmd=new s("terminal-cmd",{fontCharacter:"\\ebc4"}),s.terminalDebian=new s("terminal-debian",{fontCharacter:"\\ebc5"}),s.terminalLinux=new s("terminal-linux",{fontCharacter:"\\ebc6"}),s.terminalPowershell=new s("terminal-powershell",{fontCharacter:"\\ebc7"}),s.terminalTmux=new s("terminal-tmux",{fontCharacter:"\\ebc8"}),s.terminalUbuntu=new s("terminal-ubuntu",{fontCharacter:"\\ebc9"}),s.terminalBash=new s("terminal-bash",{fontCharacter:"\\ebca"}),s.arrowSwap=new s("arrow-swap",{fontCharacter:"\\ebcb"}),s.copy=new s("copy",{fontCharacter:"\\ebcc"}),s.personAdd=new s("person-add",{fontCharacter:"\\ebcd"}),s.filterFilled=new s("filter-filled",{fontCharacter:"\\ebce"}),s.wand=new s("wand",{fontCharacter:"\\ebcf"}),s.debugLineByLine=new s("debug-line-by-line",{fontCharacter:"\\ebd0"}),s.inspect=new s("inspect",{fontCharacter:"\\ebd1"}),s.dropDownButton=new s("drop-down-button",s.chevronDown.definition)}(P=e.Codicon||(e.Codicon={}))}),define(ge[93],pe([0,1,14,6]),function(Q,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function k(u){const d=u;return d?[d.on,d.pause,d.resume,d.destroy].every(p=>typeof p=="function"):!1}e.isReadableStream=k;function D(u){const d=u;return d?k(d.stream)&&Array.isArray(d.buffer)&&typeof d.ended=="boolean":!1}e.isReadableBufferedStream=D;function A(u,d){return new P(u,d)}e.newWriteableStream=A;class P{constructor(d,p){this.reducer=d,this.options=p,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(d){var p;if(!this.state.destroyed){if(this.state.flowing)this.emitData(d);else if(this.buffer.data.push(d),typeof((p=this.options)===null||p===void 0?void 0:p.highWaterMark)=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(t=>this.pendingWritePromises.push(t))}}error(d){this.state.destroyed||(this.state.flowing?this.emitError(d):this.buffer.error.push(d))}end(d){this.state.destroyed||(typeof d!="undefined"&&this.write(d),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(d){this.listeners.data.slice(0).forEach(p=>p(d))}emitError(d){this.listeners.error.length===0?v.onUnexpectedError(d):this.listeners.error.slice(0).forEach(p=>p(d))}emitEnd(){this.listeners.end.slice(0).forEach(d=>d())}on(d,p){if(!this.state.destroyed)switch(d){case"data":this.listeners.data.push(p),this.resume();break;case"end":this.listeners.end.push(p),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(p),this.state.flowing&&this.flowErrors();break}}removeListener(d,p){if(this.state.destroyed)return;let t;switch(d){case"data":t=this.listeners.data;break;case"end":t=this.listeners.end;break;case"error":t=this.listeners.error;break}if(t){const i=t.indexOf(p);i>=0&&t.splice(i,1)}}flowData(){if(this.buffer.data.length>0){const d=this.reducer(this.buffer.data);this.emitData(d),this.buffer.data.length=0;const p=[...this.pendingWritePromises];this.pendingWritePromises.length=0,p.forEach(t=>t())}}flowErrors(){if(this.listeners.error.length>0){for(const d of this.buffer.error)this.emitError(d);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function _(u,d){const p=[];let t;for(;(t=u.read())!==null;)p.push(t);return d(p)}e.consumeReadable=_;function C(u,d,p){const t=[];let i;for(;(i=u.read())!==null&&t.length<p;)t.push(i);return i===null&&t.length>0?d(t):{read:()=>{if(t.length>0)return t.shift();if(typeof i!="undefined"){const r=i;return i=void 0,r}return u.read()}}}e.peekReadable=C;function s(u,d){return new Promise((p,t)=>{const i=[];I(u,{onData:r=>{d&&i.push(r)},onError:r=>{d?t(r):p(void 0)},onEnd:()=>{p(d?d(i):void 0)}})})}e.consumeStream=s;function I(u,d){u.on("error",p=>d.onError(p)),u.on("end",()=>d.onEnd()),u.on("data",p=>d.onData(p))}e.listenStream=I;function l(u,d){return new Promise((p,t)=>{const i=new R.DisposableStore,r=[],n=f=>{if(r.push(f),r.length>d)return i.dispose(),u.pause(),p({stream:u,buffer:r,ended:!1})},o=f=>t(f),g=()=>p({stream:u,buffer:r,ended:!0});i.add(R.toDisposable(()=>u.removeListener("error",o))),u.on("error",o),i.add(R.toDisposable(()=>u.removeListener("end",g))),u.on("end",g),i.add(R.toDisposable(()=>u.removeListener("data",n))),u.on("data",n)})}e.peekStream=l;function m(u,d){const p=A(d);return p.end(u),p}e.toStream=m;function c(){const u=A(()=>{throw new Error("not supported")});return u.end(),u}e.emptyStream=c;function h(u){let d=!1;return{read:()=>d?null:(d=!0,u)}}e.toReadable=h;function S(u,d,p){const t=A(p);return I(u,{onData:i=>t.write(d.data(i)),onError:i=>t.error(d.error?d.error(i):i),onEnd:()=>t.end()}),t}e.transform=S;function w(u,d,p){let t=!1;return{read:()=>{const i=d.read();return t?i:(t=!0,i!==null?p([u,i]):u)}}}e.prefixedReadable=w;function b(u,d,p){let t=!1;const i=A(p);return I(d,{onData:r=>t?i.write(r):(t=!0,i.write(p([u,r]))),onError:r=>i.error(r),onEnd:()=>{t||(t=!0,i.write(u)),i.end()}}),i}e.prefixedStream=b}),define(ge[8],pe([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLeftDeleteOffset=e.GraphemeBreakType=e.breakBetweenGraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsEmoji=e.containsRTL=e.decodeUTF8=e.encodeUTF8=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format=e.isFalsyOrWhitespace=void 0;function v(z){return!z||typeof z!="string"?!0:z.trim().length===0}e.isFalsyOrWhitespace=v;const R=/{(\d+)}/g;function k(z,...ee){return ee.length===0?z:z.replace(R,function(ue,Ie){const Te=parseInt(Ie,10);return isNaN(Te)||Te<0||Te>=ee.length?ue:ee[Te]})}e.format=k;function D(z){return z.replace(/[<>&]/g,function(ee){switch(ee){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return ee}})}e.escape=D;function A(z){return z.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=A;function P(z,ee){let ue=0;const Ie=ee.charCodeAt(0);for(let Te=z.length-1;Te>=0;Te--)z.charCodeAt(Te)===Ie&&ue++;return ue}e.count=P;function _(z,ee,ue="\u2026"){return z.length<=ee?z:`${z.substr(0,ee)}${ue}`}e.truncate=_;function C(z,ee=" "){const ue=s(z,ee);return I(ue,ee)}e.trim=C;function s(z,ee){if(!z||!ee)return z;const ue=ee.length;if(ue===0||z.length===0)return z;let Ie=0;for(;z.indexOf(ee,Ie)===Ie;)Ie=Ie+ue;return z.substring(Ie)}e.ltrim=s;function I(z,ee){if(!z||!ee)return z;const ue=ee.length,Ie=z.length;if(ue===0||Ie===0)return z;let Te=Ie,xe=-1;for(;xe=z.lastIndexOf(ee,Te-1),!(xe===-1||xe+ue!==Te);){if(xe===0)return"";Te=xe}return z.substring(0,Te)}e.rtrim=I;function l(z){return z.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=l;function m(z){return z.replace(/\*/g,"")}e.stripWildcards=m;function c(z,ee,ue={}){if(!z)throw new Error("Cannot create regex from empty string");ee||(z=A(z)),ue.wholeWord&&(/\B/.test(z.charAt(0))||(z="\\b"+z),/\B/.test(z.charAt(z.length-1))||(z=z+"\\b"));let Ie="";return ue.global&&(Ie+="g"),ue.matchCase||(Ie+="i"),ue.multiline&&(Ie+="m"),ue.unicode&&(Ie+="u"),new RegExp(z,Ie)}e.createRegExp=c;function h(z){return z.source==="^"||z.source==="^$"||z.source==="$"||z.source==="^\\s*$"?!1:!!(z.exec("")&&z.lastIndex===0)}e.regExpLeadsToEndlessLoop=h;function S(z){return!!z.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=S;function w(z){return(z.global?"g":"")+(z.ignoreCase?"i":"")+(z.multiline?"m":"")+(z.unicode?"u":"")}e.regExpFlags=w;function b(z){return z.split(/\r\n|\r|\n/)}e.splitLines=b;function u(z){for(let ee=0,ue=z.length;ee<ue;ee++){const Ie=z.charCodeAt(ee);if(Ie!==32&&Ie!==9)return ee}return-1}e.firstNonWhitespaceIndex=u;function d(z,ee=0,ue=z.length){for(let Ie=ee;Ie<ue;Ie++){const Te=z.charCodeAt(Ie);if(Te!==32&&Te!==9)return z.substring(ee,Ie)}return z.substring(ee,ue)}e.getLeadingWhitespace=d;function p(z,ee=z.length-1){for(let ue=ee;ue>=0;ue--){const Ie=z.charCodeAt(ue);if(Ie!==32&&Ie!==9)return ue}return-1}e.lastNonWhitespaceIndex=p;function t(z,ee){return z<ee?-1:z>ee?1:0}e.compare=t;function i(z,ee,ue=0,Ie=z.length,Te=0,xe=ee.length){for(;ue<Ie&&Te<xe;ue++,Te++){let Ye=z.charCodeAt(ue),Xe=ee.charCodeAt(Te);if(Ye<Xe)return-1;if(Ye>Xe)return 1}const He=Ie-ue,Ze=xe-Te;return He<Ze?-1:He>Ze?1:0}e.compareSubstring=i;function r(z,ee){return n(z,ee,0,z.length,0,ee.length)}e.compareIgnoreCase=r;function n(z,ee,ue=0,Ie=z.length,Te=0,xe=ee.length){for(;ue<Ie&&Te<xe;ue++,Te++){let Ye=z.charCodeAt(ue),Xe=ee.charCodeAt(Te);if(Ye===Xe)continue;const nt=Ye-Xe;if(!(nt===32&&g(Xe))&&!(nt===-32&&g(Ye)))return o(Ye)&&o(Xe)?nt:i(z.toLowerCase(),ee.toLowerCase(),ue,Ie,Te,xe)}const He=Ie-ue,Ze=xe-Te;return He<Ze?-1:He>Ze?1:0}e.compareSubstringIgnoreCase=n;function o(z){return z>=97&&z<=122}e.isLowerAsciiLetter=o;function g(z){return z>=65&&z<=90}e.isUpperAsciiLetter=g;function f(z){return o(z)||g(z)}function E(z,ee){return z.length===ee.length&&y(z,ee)}e.equalsIgnoreCase=E;function y(z,ee,ue=z.length){for(let Ie=0;Ie<ue;Ie++){const Te=z.charCodeAt(Ie),xe=ee.charCodeAt(Ie);if(Te!==xe){if(f(Te)&&f(xe)){const He=Math.abs(Te-xe);if(He!==0&&He!==32)return!1}else if(String.fromCharCode(Te).toLowerCase()!==String.fromCharCode(xe).toLowerCase())return!1}}return!0}function a(z,ee){const ue=ee.length;return ee.length>z.length?!1:y(z,ee,ue)}e.startsWithIgnoreCase=a;function L(z,ee){let ue,Ie=Math.min(z.length,ee.length);for(ue=0;ue<Ie;ue++)if(z.charCodeAt(ue)!==ee.charCodeAt(ue))return ue;return Ie}e.commonPrefixLength=L;function O(z,ee){let ue,Ie=Math.min(z.length,ee.length);const Te=z.length-1,xe=ee.length-1;for(ue=0;ue<Ie;ue++)if(z.charCodeAt(Te-ue)!==ee.charCodeAt(xe-ue))return ue;return Ie}e.commonSuffixLength=O;function W(z){return 55296<=z&&z<=56319}e.isHighSurrogate=W;function J(z){return 56320<=z&&z<=57343}e.isLowSurrogate=J;function se(z,ee){return(z-55296<<10)+(ee-56320)+65536}e.computeCodePoint=se;function q(z,ee,ue){const Ie=z.charCodeAt(ue);if(W(Ie)&&ue+1<ee){const Te=z.charCodeAt(ue+1);if(J(Te))return se(Ie,Te)}return Ie}e.getNextCodePoint=q;function N(z,ee){const ue=z.charCodeAt(ee-1);if(J(ue)&&ee>1){const Ie=z.charCodeAt(ee-2);if(W(Ie))return se(Ie,ue)}return ue}function H(z,ee){const ue=Ne.getInstance(),Ie=ee,Te=z.length,xe=q(z,Te,ee);ee+=xe>=65536?2:1;let He=ue.getGraphemeBreakType(xe);for(;ee<Te;){const Ze=q(z,Te,ee),Ye=ue.getGraphemeBreakType(Ze);if(ve(He,Ye))break;ee+=Ze>=65536?2:1,He=Ye}return ee-Ie}e.nextCharLength=H;function T(z,ee){const ue=Ne.getInstance(),Ie=ee,Te=N(z,ee);ee-=Te>=65536?2:1;let xe=ue.getGraphemeBreakType(Te);for(;ee>0;){const He=N(z,ee),Ze=ue.getGraphemeBreakType(He);if(ve(Ze,xe))break;ee-=He>=65536?2:1,xe=Ze}return Ie-ee}e.prevCharLength=T;function U(z,ee){const ue=Ne.getInstance(),Ie=z.length,Te=ee,xe=q(z,Ie,ee),He=ue.getGraphemeBreakType(xe);ee+=xe>=65536?2:1;let Ze=He;for(;ee<Ie;){const Xe=q(z,Ie,ee),nt=ue.getGraphemeBreakType(Xe);if(ve(Ze,nt))break;ee+=Xe>=65536?2:1,Ze=nt}const Ye=ee;for(ee=Te,Ze=He;ee>0;){const Xe=N(z,ee),nt=ue.getGraphemeBreakType(Xe);if(ve(nt,Ze))break;ee-=Xe>=65536?2:1,Ze=nt}return[ee,Ye]}function F(z,ee){return ee>0&&J(z.charCodeAt(ee))?U(z,ee-1):U(z,ee)}e.getCharContainingOffset=F;function M(z){const ee=z.length;let ue=0,Ie=0;for(;Ie<ee;){const He=q(z,ee,Ie);Ie+=He>=65536?2:1,He<128?ue+=1:He<2048?ue+=2:He<65536?ue+=3:ue+=4}const Te=new Uint8Array(ue);Ie=0;let xe=0;for(;Ie<ee;){const He=q(z,ee,Ie);Ie+=He>=65536?2:1,He<128?Te[xe++]=He:He<2048?(Te[xe++]=192|(He&1984)>>>6,Te[xe++]=128|(He&63)>>>0):He<65536?(Te[xe++]=224|(He&61440)>>>12,Te[xe++]=128|(He&4032)>>>6,Te[xe++]=128|(He&63)>>>0):(Te[xe++]=240|(He&1835008)>>>18,Te[xe++]=128|(He&258048)>>>12,Te[xe++]=128|(He&4032)>>>6,Te[xe++]=128|(He&63)>>>0)}return Te}e.encodeUTF8=M;function x(z){const ee=z.byteLength,ue=[];let Ie=0;for(;Ie<ee;){const Te=z[Ie];let xe;if(Te>=240&&Ie+3<ee?xe=(z[Ie++]&7)<<18>>>0|(z[Ie++]&63)<<12>>>0|(z[Ie++]&63)<<6>>>0|(z[Ie++]&63)<<0>>>0:Te>=224&&Ie+2<ee?xe=(z[Ie++]&15)<<12>>>0|(z[Ie++]&63)<<6>>>0|(z[Ie++]&63)<<0>>>0:Te>=192&&Ie+1<ee?xe=(z[Ie++]&31)<<6>>>0|(z[Ie++]&63)<<0>>>0:xe=z[Ie++],xe>=0&&xe<=55295||xe>=57344&&xe<=65535)ue.push(String.fromCharCode(xe));else if(xe>=65536&&xe<=1114111){const He=xe-65536,Ze=55296+((He&1047552)>>>10),Ye=56320+((He&1023)>>>0);ue.push(String.fromCharCode(Ze)),ue.push(String.fromCharCode(Ye))}else ue.push(String.fromCharCode(65533))}return ue.join("")}e.decodeUTF8=x;const $=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u08BD\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE33\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDCFF]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD50-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function X(z){return $.test(z)}e.containsRTL=X;const le=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD00-\uDDFF\uDE70-\uDED6])/;function be(z){return le.test(z)}e.containsEmoji=be;const Re=/^[\t\n\r\x20-\x7E]*$/;function Ce(z){return Re.test(z)}e.isBasicASCII=Ce,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function Me(z){return e.UNUSUAL_LINE_TERMINATORS.test(z)}e.containsUnusualLineTerminators=Me;function je(z){for(let ee=0,ue=z.length;ee<ue;ee++)if(ze(z.charCodeAt(ee)))return!0;return!1}e.containsFullWidthCharacter=je;function ze(z){return z=+z,z>=11904&&z<=55215||z>=63744&&z<=64255||z>=65281&&z<=65374}e.isFullWidthCharacter=ze;function qe(z){return z>=127462&&z<=127487||z===8986||z===8987||z===9200||z===9203||z>=9728&&z<=10175||z===11088||z===11093||z>=127744&&z<=128591||z>=128640&&z<=128764||z>=128992&&z<=129003||z>=129280&&z<=129535||z>=129648&&z<=129750}e.isEmojiImprecise=qe;function j(z,ee){if(z.length<ee)return z;const ue=/\b/g;let Ie=0;for(;ue.test(z)&&!(z.length-ue.lastIndex<ee);)Ie=ue.lastIndex,ue.lastIndex+=1;return z.substring(Ie).replace(/^\s/,"")}e.lcut=j;const Z=/\x1B\x5B[12]?K/g,ne=/\x1b\[\d+m/g,oe=/\x1b\[0?m/g;function Y(z){return z&&(z=z.replace(Z,""),z=z.replace(ne,""),z=z.replace(oe,"")),z}e.removeAnsiEscapeCodes=Y,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function ce(z){return!!(z&&z.length>0&&z.charCodeAt(0)===65279)}e.startsWithUTF8BOM=ce;function me(z){return ce(z)?z.substr(1):z}e.stripUTF8BOM=me;function Le(z,ee){if(!z||!ee||z.length<ee.length)return!1;const ue=ee.length,Ie=z.toLowerCase();let Te=0,xe=-1;for(;Te<ue;){const He=Ie.indexOf(ee[Te],xe+1);if(He<0)return!1;xe=He,Te++}return!0}e.fuzzyContains=Le;function We(z,ee=!1){return z?(ee&&(z=z.replace(/\\./g,"")),z.toLowerCase()!==z):!1}e.containsUppercaseCharacter=We;function Ee(z){return z.charAt(0).toUpperCase()+z.slice(1)}e.uppercaseFirstLetter=Ee;function Ke(z,ee=1){if(ee===0)return"";let ue=-1;do ue=z.indexOf(`
`,ue+1),ee--;while(ee>0&&ue>=0);return ue===-1?z:(z[ue-1]==="\r"&&ue--,z.substr(0,ue))}e.getNLines=Ke;function G(z){const ee=90-65+1;return z=z%(2*ee),z<ee?String.fromCharCode(97+z):String.fromCharCode(65+z-ee)}e.singleLetterHash=G;function ie(z){return Ne.getInstance().getGraphemeBreakType(z)}e.getGraphemeBreakType=ie;function ve(z,ee){return z===0?ee!==5&&ee!==7:z===2&&ee===3?!1:z===4||z===2||z===3||ee===4||ee===2||ee===3?!0:!(z===8&&(ee===8||ee===9||ee===11||ee===12)||(z===11||z===9)&&(ee===9||ee===10)||(z===12||z===10)&&ee===10||ee===5||ee===13||ee===7||z===1||z===13&&ee===14||z===6&&ee===6)}e.breakBetweenGraphemeBreakType=ve;var Fe;(function(z){z[z.Other=0]="Other",z[z.Prepend=1]="Prepend",z[z.CR=2]="CR",z[z.LF=3]="LF",z[z.Control=4]="Control",z[z.Extend=5]="Extend",z[z.Regional_Indicator=6]="Regional_Indicator",z[z.SpacingMark=7]="SpacingMark",z[z.L=8]="L",z[z.V=9]="V",z[z.T=10]="T",z[z.LV=11]="LV",z[z.LVT=12]="LVT",z[z.ZWJ=13]="ZWJ",z[z.Extended_Pictographic=14]="Extended_Pictographic"})(Fe=e.GraphemeBreakType||(e.GraphemeBreakType={}));class Ne{constructor(){this._data=Qe()}static getInstance(){return Ne._INSTANCE||(Ne._INSTANCE=new Ne),Ne._INSTANCE}getGraphemeBreakType(ee){if(ee<32)return ee===10?3:ee===13?2:4;if(ee<127)return 0;const ue=this._data,Ie=ue.length/3;let Te=1;for(;Te<=Ie;)if(ee<ue[3*Te])Te=2*Te;else if(ee>ue[3*Te+1])Te=2*Te+1;else return ue[3*Te+2];return 0}}Ne._INSTANCE=null;function Qe(){return JSON.parse("[0,0,0,51592,51592,11,44424,44424,11,72251,72254,5,7150,7150,7,48008,48008,11,55176,55176,11,128420,128420,14,3276,3277,5,9979,9980,14,46216,46216,11,49800,49800,11,53384,53384,11,70726,70726,5,122915,122916,5,129320,129327,14,2558,2558,5,5906,5908,5,9762,9763,14,43360,43388,8,45320,45320,11,47112,47112,11,48904,48904,11,50696,50696,11,52488,52488,11,54280,54280,11,70082,70083,1,71350,71350,7,73111,73111,5,127892,127893,14,128726,128727,14,129473,129474,14,2027,2035,5,2901,2902,5,3784,3789,5,6754,6754,5,8418,8420,5,9877,9877,14,11088,11088,14,44008,44008,5,44872,44872,11,45768,45768,11,46664,46664,11,47560,47560,11,48456,48456,11,49352,49352,11,50248,50248,11,51144,51144,11,52040,52040,11,52936,52936,11,53832,53832,11,54728,54728,11,69811,69814,5,70459,70460,5,71096,71099,7,71998,71998,5,72874,72880,5,119149,119149,7,127374,127374,14,128335,128335,14,128482,128482,14,128765,128767,14,129399,129400,14,129680,129685,14,1476,1477,5,2377,2380,7,2759,2760,5,3137,3140,7,3458,3459,7,4153,4154,5,6432,6434,5,6978,6978,5,7675,7679,5,9723,9726,14,9823,9823,14,9919,9923,14,10035,10036,14,42736,42737,5,43596,43596,5,44200,44200,11,44648,44648,11,45096,45096,11,45544,45544,11,45992,45992,11,46440,46440,11,46888,46888,11,47336,47336,11,47784,47784,11,48232,48232,11,48680,48680,11,49128,49128,11,49576,49576,11,50024,50024,11,50472,50472,11,50920,50920,11,51368,51368,11,51816,51816,11,52264,52264,11,52712,52712,11,53160,53160,11,53608,53608,11,54056,54056,11,54504,54504,11,54952,54952,11,68108,68111,5,69933,69940,5,70197,70197,7,70498,70499,7,70845,70845,5,71229,71229,5,71727,71735,5,72154,72155,5,72344,72345,5,73023,73029,5,94095,94098,5,121403,121452,5,126981,127182,14,127538,127546,14,127990,127990,14,128391,128391,14,128445,128449,14,128500,128505,14,128752,128752,14,129160,129167,14,129356,129356,14,129432,129442,14,129648,129651,14,129751,131069,14,173,173,4,1757,1757,1,2274,2274,1,2494,2494,5,2641,2641,5,2876,2876,5,3014,3016,7,3262,3262,7,3393,3396,5,3570,3571,7,3968,3972,5,4228,4228,7,6086,6086,5,6679,6680,5,6912,6915,5,7080,7081,5,7380,7392,5,8252,8252,14,9096,9096,14,9748,9749,14,9784,9786,14,9833,9850,14,9890,9894,14,9938,9938,14,9999,9999,14,10085,10087,14,12349,12349,14,43136,43137,7,43454,43456,7,43755,43755,7,44088,44088,11,44312,44312,11,44536,44536,11,44760,44760,11,44984,44984,11,45208,45208,11,45432,45432,11,45656,45656,11,45880,45880,11,46104,46104,11,46328,46328,11,46552,46552,11,46776,46776,11,47000,47000,11,47224,47224,11,47448,47448,11,47672,47672,11,47896,47896,11,48120,48120,11,48344,48344,11,48568,48568,11,48792,48792,11,49016,49016,11,49240,49240,11,49464,49464,11,49688,49688,11,49912,49912,11,50136,50136,11,50360,50360,11,50584,50584,11,50808,50808,11,51032,51032,11,51256,51256,11,51480,51480,11,51704,51704,11,51928,51928,11,52152,52152,11,52376,52376,11,52600,52600,11,52824,52824,11,53048,53048,11,53272,53272,11,53496,53496,11,53720,53720,11,53944,53944,11,54168,54168,11,54392,54392,11,54616,54616,11,54840,54840,11,55064,55064,11,65438,65439,5,69633,69633,5,69837,69837,1,70018,70018,7,70188,70190,7,70368,70370,7,70465,70468,7,70712,70719,5,70835,70840,5,70850,70851,5,71132,71133,5,71340,71340,7,71458,71461,5,71985,71989,7,72002,72002,7,72193,72202,5,72281,72283,5,72766,72766,7,72885,72886,5,73104,73105,5,92912,92916,5,113824,113827,4,119173,119179,5,121505,121519,5,125136,125142,5,127279,127279,14,127489,127490,14,127570,127743,14,127900,127901,14,128254,128254,14,128369,128370,14,128400,128400,14,128425,128432,14,128468,128475,14,128489,128494,14,128715,128720,14,128745,128745,14,128759,128760,14,129004,129023,14,129296,129304,14,129340,129342,14,129388,129392,14,129404,129407,14,129454,129455,14,129485,129487,14,129659,129663,14,129719,129727,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2363,2363,7,2402,2403,5,2507,2508,7,2622,2624,7,2691,2691,7,2786,2787,5,2881,2884,5,3006,3006,5,3072,3072,5,3170,3171,5,3267,3268,7,3330,3331,7,3406,3406,1,3538,3540,5,3655,3662,5,3897,3897,5,4038,4038,5,4184,4185,5,4352,4447,8,6068,6069,5,6155,6157,5,6448,6449,7,6742,6742,5,6783,6783,5,6966,6970,5,7042,7042,7,7143,7143,7,7212,7219,5,7412,7412,5,8206,8207,4,8294,8303,4,8596,8601,14,9410,9410,14,9742,9742,14,9757,9757,14,9770,9770,14,9794,9794,14,9828,9828,14,9855,9855,14,9882,9882,14,9900,9903,14,9929,9933,14,9963,9967,14,9987,9988,14,10006,10006,14,10062,10062,14,10175,10175,14,11744,11775,5,42607,42607,5,43043,43044,7,43263,43263,5,43444,43445,7,43569,43570,5,43698,43700,5,43766,43766,5,44032,44032,11,44144,44144,11,44256,44256,11,44368,44368,11,44480,44480,11,44592,44592,11,44704,44704,11,44816,44816,11,44928,44928,11,45040,45040,11,45152,45152,11,45264,45264,11,45376,45376,11,45488,45488,11,45600,45600,11,45712,45712,11,45824,45824,11,45936,45936,11,46048,46048,11,46160,46160,11,46272,46272,11,46384,46384,11,46496,46496,11,46608,46608,11,46720,46720,11,46832,46832,11,46944,46944,11,47056,47056,11,47168,47168,11,47280,47280,11,47392,47392,11,47504,47504,11,47616,47616,11,47728,47728,11,47840,47840,11,47952,47952,11,48064,48064,11,48176,48176,11,48288,48288,11,48400,48400,11,48512,48512,11,48624,48624,11,48736,48736,11,48848,48848,11,48960,48960,11,49072,49072,11,49184,49184,11,49296,49296,11,49408,49408,11,49520,49520,11,49632,49632,11,49744,49744,11,49856,49856,11,49968,49968,11,50080,50080,11,50192,50192,11,50304,50304,11,50416,50416,11,50528,50528,11,50640,50640,11,50752,50752,11,50864,50864,11,50976,50976,11,51088,51088,11,51200,51200,11,51312,51312,11,51424,51424,11,51536,51536,11,51648,51648,11,51760,51760,11,51872,51872,11,51984,51984,11,52096,52096,11,52208,52208,11,52320,52320,11,52432,52432,11,52544,52544,11,52656,52656,11,52768,52768,11,52880,52880,11,52992,52992,11,53104,53104,11,53216,53216,11,53328,53328,11,53440,53440,11,53552,53552,11,53664,53664,11,53776,53776,11,53888,53888,11,54000,54000,11,54112,54112,11,54224,54224,11,54336,54336,11,54448,54448,11,54560,54560,11,54672,54672,11,54784,54784,11,54896,54896,11,55008,55008,11,55120,55120,11,64286,64286,5,66272,66272,5,68900,68903,5,69762,69762,7,69817,69818,5,69927,69931,5,70003,70003,5,70070,70078,5,70094,70094,7,70194,70195,7,70206,70206,5,70400,70401,5,70463,70463,7,70475,70477,7,70512,70516,5,70722,70724,5,70832,70832,5,70842,70842,5,70847,70848,5,71088,71089,7,71102,71102,7,71219,71226,5,71231,71232,5,71342,71343,7,71453,71455,5,71463,71467,5,71737,71738,5,71995,71996,5,72000,72000,7,72145,72147,7,72160,72160,5,72249,72249,7,72273,72278,5,72330,72342,5,72752,72758,5,72850,72871,5,72882,72883,5,73018,73018,5,73031,73031,5,73109,73109,5,73461,73462,7,94031,94031,5,94192,94193,7,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,126976,126979,14,127184,127231,14,127344,127345,14,127405,127461,14,127514,127514,14,127561,127567,14,127778,127779,14,127896,127896,14,127985,127986,14,127995,127999,5,128326,128328,14,128360,128366,14,128378,128378,14,128394,128397,14,128405,128406,14,128422,128423,14,128435,128443,14,128453,128464,14,128479,128480,14,128484,128487,14,128496,128498,14,128640,128709,14,128723,128724,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129096,129103,14,129292,129292,14,129311,129311,14,129329,129330,14,129344,129349,14,129360,129374,14,129394,129394,14,129402,129402,14,129413,129425,14,129445,129450,14,129466,129471,14,129483,129483,14,129511,129535,14,129653,129655,14,129667,129670,14,129705,129711,14,129731,129743,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2307,2307,7,2366,2368,7,2382,2383,7,2434,2435,7,2497,2500,5,2519,2519,5,2563,2563,7,2631,2632,5,2677,2677,5,2750,2752,7,2763,2764,7,2817,2817,5,2879,2879,5,2891,2892,7,2914,2915,5,3008,3008,5,3021,3021,5,3076,3076,5,3146,3149,5,3202,3203,7,3264,3265,7,3271,3272,7,3298,3299,5,3390,3390,5,3402,3404,7,3426,3427,5,3535,3535,5,3544,3550,7,3635,3635,7,3763,3763,7,3893,3893,5,3953,3966,5,3981,3991,5,4145,4145,7,4157,4158,5,4209,4212,5,4237,4237,5,4520,4607,10,5970,5971,5,6071,6077,5,6089,6099,5,6277,6278,5,6439,6440,5,6451,6456,7,6683,6683,5,6744,6750,5,6765,6770,7,6846,6846,5,6964,6964,5,6972,6972,5,7019,7027,5,7074,7077,5,7083,7085,5,7146,7148,7,7154,7155,7,7222,7223,5,7394,7400,5,7416,7417,5,8204,8204,5,8233,8233,4,8288,8292,4,8413,8416,5,8482,8482,14,8986,8987,14,9193,9203,14,9654,9654,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9775,14,9792,9792,14,9800,9811,14,9825,9826,14,9831,9831,14,9852,9853,14,9872,9873,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9936,9936,14,9941,9960,14,9974,9974,14,9982,9985,14,9992,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10145,10145,14,11013,11015,14,11503,11505,5,12334,12335,5,12951,12951,14,42612,42621,5,43014,43014,5,43047,43047,7,43204,43205,5,43335,43345,5,43395,43395,7,43450,43451,7,43561,43566,5,43573,43574,5,43644,43644,5,43710,43711,5,43758,43759,7,44005,44005,5,44012,44012,7,44060,44060,11,44116,44116,11,44172,44172,11,44228,44228,11,44284,44284,11,44340,44340,11,44396,44396,11,44452,44452,11,44508,44508,11,44564,44564,11,44620,44620,11,44676,44676,11,44732,44732,11,44788,44788,11,44844,44844,11,44900,44900,11,44956,44956,11,45012,45012,11,45068,45068,11,45124,45124,11,45180,45180,11,45236,45236,11,45292,45292,11,45348,45348,11,45404,45404,11,45460,45460,11,45516,45516,11,45572,45572,11,45628,45628,11,45684,45684,11,45740,45740,11,45796,45796,11,45852,45852,11,45908,45908,11,45964,45964,11,46020,46020,11,46076,46076,11,46132,46132,11,46188,46188,11,46244,46244,11,46300,46300,11,46356,46356,11,46412,46412,11,46468,46468,11,46524,46524,11,46580,46580,11,46636,46636,11,46692,46692,11,46748,46748,11,46804,46804,11,46860,46860,11,46916,46916,11,46972,46972,11,47028,47028,11,47084,47084,11,47140,47140,11,47196,47196,11,47252,47252,11,47308,47308,11,47364,47364,11,47420,47420,11,47476,47476,11,47532,47532,11,47588,47588,11,47644,47644,11,47700,47700,11,47756,47756,11,47812,47812,11,47868,47868,11,47924,47924,11,47980,47980,11,48036,48036,11,48092,48092,11,48148,48148,11,48204,48204,11,48260,48260,11,48316,48316,11,48372,48372,11,48428,48428,11,48484,48484,11,48540,48540,11,48596,48596,11,48652,48652,11,48708,48708,11,48764,48764,11,48820,48820,11,48876,48876,11,48932,48932,11,48988,48988,11,49044,49044,11,49100,49100,11,49156,49156,11,49212,49212,11,49268,49268,11,49324,49324,11,49380,49380,11,49436,49436,11,49492,49492,11,49548,49548,11,49604,49604,11,49660,49660,11,49716,49716,11,49772,49772,11,49828,49828,11,49884,49884,11,49940,49940,11,49996,49996,11,50052,50052,11,50108,50108,11,50164,50164,11,50220,50220,11,50276,50276,11,50332,50332,11,50388,50388,11,50444,50444,11,50500,50500,11,50556,50556,11,50612,50612,11,50668,50668,11,50724,50724,11,50780,50780,11,50836,50836,11,50892,50892,11,50948,50948,11,51004,51004,11,51060,51060,11,51116,51116,11,51172,51172,11,51228,51228,11,51284,51284,11,51340,51340,11,51396,51396,11,51452,51452,11,51508,51508,11,51564,51564,11,51620,51620,11,51676,51676,11,51732,51732,11,51788,51788,11,51844,51844,11,51900,51900,11,51956,51956,11,52012,52012,11,52068,52068,11,52124,52124,11,52180,52180,11,52236,52236,11,52292,52292,11,52348,52348,11,52404,52404,11,52460,52460,11,52516,52516,11,52572,52572,11,52628,52628,11,52684,52684,11,52740,52740,11,52796,52796,11,52852,52852,11,52908,52908,11,52964,52964,11,53020,53020,11,53076,53076,11,53132,53132,11,53188,53188,11,53244,53244,11,53300,53300,11,53356,53356,11,53412,53412,11,53468,53468,11,53524,53524,11,53580,53580,11,53636,53636,11,53692,53692,11,53748,53748,11,53804,53804,11,53860,53860,11,53916,53916,11,53972,53972,11,54028,54028,11,54084,54084,11,54140,54140,11,54196,54196,11,54252,54252,11,54308,54308,11,54364,54364,11,54420,54420,11,54476,54476,11,54532,54532,11,54588,54588,11,54644,54644,11,54700,54700,11,54756,54756,11,54812,54812,11,54868,54868,11,54924,54924,11,54980,54980,11,55036,55036,11,55092,55092,11,55148,55148,11,55216,55238,9,65056,65071,5,65529,65531,4,68097,68099,5,68159,68159,5,69446,69456,5,69688,69702,5,69808,69810,7,69815,69816,7,69821,69821,1,69888,69890,5,69932,69932,7,69957,69958,7,70016,70017,5,70067,70069,7,70079,70080,7,70089,70092,5,70095,70095,5,70191,70193,5,70196,70196,5,70198,70199,5,70367,70367,5,70371,70378,5,70402,70403,7,70462,70462,5,70464,70464,5,70471,70472,7,70487,70487,5,70502,70508,5,70709,70711,7,70720,70721,7,70725,70725,7,70750,70750,5,70833,70834,7,70841,70841,7,70843,70844,7,70846,70846,7,70849,70849,7,71087,71087,5,71090,71093,5,71100,71101,5,71103,71104,5,71216,71218,7,71227,71228,7,71230,71230,7,71339,71339,5,71341,71341,5,71344,71349,5,71351,71351,5,71456,71457,7,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123628,123631,5,125252,125258,5,126980,126980,14,127183,127183,14,127245,127247,14,127340,127343,14,127358,127359,14,127377,127386,14,127462,127487,6,127491,127503,14,127535,127535,14,127548,127551,14,127568,127569,14,127744,127777,14,127780,127891,14,127894,127895,14,127897,127899,14,127902,127984,14,127987,127989,14,127991,127994,14,128000,128253,14,128255,128317,14,128329,128334,14,128336,128359,14,128367,128368,14,128371,128377,14,128379,128390,14,128392,128393,14,128398,128399,14,128401,128404,14,128407,128419,14,128421,128421,14,128424,128424,14,128433,128434,14,128444,128444,14,128450,128452,14,128465,128467,14,128476,128478,14,128481,128481,14,128483,128483,14,128488,128488,14,128495,128495,14,128499,128499,14,128506,128591,14,128710,128714,14,128721,128722,14,128725,128725,14,128728,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129664,129666,14,129671,129679,14,129686,129704,14,129712,129718,14,129728,129730,14,129744,129750,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2259,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3134,3136,5,3142,3144,5,3157,3158,5,3201,3201,5,3260,3260,5,3263,3263,5,3266,3266,5,3270,3270,5,3274,3275,7,3285,3286,5,3328,3329,5,3387,3388,5,3391,3392,7,3398,3400,7,3405,3405,5,3415,3415,5,3457,3457,5,3530,3530,5,3536,3537,7,3542,3542,5,3551,3551,5,3633,3633,5,3636,3642,5,3761,3761,5,3764,3772,5,3864,3865,5,3895,3895,5,3902,3903,7,3967,3967,7,3974,3975,5,3993,4028,5,4141,4144,5,4146,4151,5,4155,4156,7,4182,4183,7,4190,4192,5,4226,4226,5,4229,4230,5,4253,4253,5,4448,4519,9,4957,4959,5,5938,5940,5,6002,6003,5,6070,6070,7,6078,6085,7,6087,6088,7,6109,6109,5,6158,6158,4,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6848,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7673,5,8203,8203,4,8205,8205,13,8232,8232,4,8234,8238,4,8265,8265,14,8293,8293,4,8400,8412,5,8417,8417,5,8421,8432,5,8505,8505,14,8617,8618,14,9000,9000,14,9167,9167,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9776,9783,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9935,14,9937,9937,14,9939,9940,14,9961,9962,14,9968,9973,14,9975,9978,14,9981,9981,14,9986,9986,14,9989,9989,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10084,14,10133,10135,14,10160,10160,14,10548,10549,14,11035,11036,14,11093,11093,14,11647,11647,5,12330,12333,5,12336,12336,14,12441,12442,5,12953,12953,14,42608,42610,5,42654,42655,5,43010,43010,5,43019,43019,5,43045,43046,5,43052,43052,5,43188,43203,7,43232,43249,5,43302,43309,5,43346,43347,7,43392,43394,5,43443,43443,5,43446,43449,5,43452,43453,5,43493,43493,5,43567,43568,7,43571,43572,7,43587,43587,5,43597,43597,7,43696,43696,5,43703,43704,5,43713,43713,5,43756,43757,5,43765,43765,7,44003,44004,7,44006,44007,7,44009,44010,7,44013,44013,5,44033,44059,12,44061,44087,12,44089,44115,12,44117,44143,12,44145,44171,12,44173,44199,12,44201,44227,12,44229,44255,12,44257,44283,12,44285,44311,12,44313,44339,12,44341,44367,12,44369,44395,12,44397,44423,12,44425,44451,12,44453,44479,12,44481,44507,12,44509,44535,12,44537,44563,12,44565,44591,12,44593,44619,12,44621,44647,12,44649,44675,12,44677,44703,12,44705,44731,12,44733,44759,12,44761,44787,12,44789,44815,12,44817,44843,12,44845,44871,12,44873,44899,12,44901,44927,12,44929,44955,12,44957,44983,12,44985,45011,12,45013,45039,12,45041,45067,12,45069,45095,12,45097,45123,12,45125,45151,12,45153,45179,12,45181,45207,12,45209,45235,12,45237,45263,12,45265,45291,12,45293,45319,12,45321,45347,12,45349,45375,12,45377,45403,12,45405,45431,12,45433,45459,12,45461,45487,12,45489,45515,12,45517,45543,12,45545,45571,12,45573,45599,12,45601,45627,12,45629,45655,12,45657,45683,12,45685,45711,12,45713,45739,12,45741,45767,12,45769,45795,12,45797,45823,12,45825,45851,12,45853,45879,12,45881,45907,12,45909,45935,12,45937,45963,12,45965,45991,12,45993,46019,12,46021,46047,12,46049,46075,12,46077,46103,12,46105,46131,12,46133,46159,12,46161,46187,12,46189,46215,12,46217,46243,12,46245,46271,12,46273,46299,12,46301,46327,12,46329,46355,12,46357,46383,12,46385,46411,12,46413,46439,12,46441,46467,12,46469,46495,12,46497,46523,12,46525,46551,12,46553,46579,12,46581,46607,12,46609,46635,12,46637,46663,12,46665,46691,12,46693,46719,12,46721,46747,12,46749,46775,12,46777,46803,12,46805,46831,12,46833,46859,12,46861,46887,12,46889,46915,12,46917,46943,12,46945,46971,12,46973,46999,12,47001,47027,12,47029,47055,12,47057,47083,12,47085,47111,12,47113,47139,12,47141,47167,12,47169,47195,12,47197,47223,12,47225,47251,12,47253,47279,12,47281,47307,12,47309,47335,12,47337,47363,12,47365,47391,12,47393,47419,12,47421,47447,12,47449,47475,12,47477,47503,12,47505,47531,12,47533,47559,12,47561,47587,12,47589,47615,12,47617,47643,12,47645,47671,12,47673,47699,12,47701,47727,12,47729,47755,12,47757,47783,12,47785,47811,12,47813,47839,12,47841,47867,12,47869,47895,12,47897,47923,12,47925,47951,12,47953,47979,12,47981,48007,12,48009,48035,12,48037,48063,12,48065,48091,12,48093,48119,12,48121,48147,12,48149,48175,12,48177,48203,12,48205,48231,12,48233,48259,12,48261,48287,12,48289,48315,12,48317,48343,12,48345,48371,12,48373,48399,12,48401,48427,12,48429,48455,12,48457,48483,12,48485,48511,12,48513,48539,12,48541,48567,12,48569,48595,12,48597,48623,12,48625,48651,12,48653,48679,12,48681,48707,12,48709,48735,12,48737,48763,12,48765,48791,12,48793,48819,12,48821,48847,12,48849,48875,12,48877,48903,12,48905,48931,12,48933,48959,12,48961,48987,12,48989,49015,12,49017,49043,12,49045,49071,12,49073,49099,12,49101,49127,12,49129,49155,12,49157,49183,12,49185,49211,12,49213,49239,12,49241,49267,12,49269,49295,12,49297,49323,12,49325,49351,12,49353,49379,12,49381,49407,12,49409,49435,12,49437,49463,12,49465,49491,12,49493,49519,12,49521,49547,12,49549,49575,12,49577,49603,12,49605,49631,12,49633,49659,12,49661,49687,12,49689,49715,12,49717,49743,12,49745,49771,12,49773,49799,12,49801,49827,12,49829,49855,12,49857,49883,12,49885,49911,12,49913,49939,12,49941,49967,12,49969,49995,12,49997,50023,12,50025,50051,12,50053,50079,12,50081,50107,12,50109,50135,12,50137,50163,12,50165,50191,12,50193,50219,12,50221,50247,12,50249,50275,12,50277,50303,12,50305,50331,12,50333,50359,12,50361,50387,12,50389,50415,12,50417,50443,12,50445,50471,12,50473,50499,12,50501,50527,12,50529,50555,12,50557,50583,12,50585,50611,12,50613,50639,12,50641,50667,12,50669,50695,12,50697,50723,12,50725,50751,12,50753,50779,12,50781,50807,12,50809,50835,12,50837,50863,12,50865,50891,12,50893,50919,12,50921,50947,12,50949,50975,12,50977,51003,12,51005,51031,12,51033,51059,12,51061,51087,12,51089,51115,12,51117,51143,12,51145,51171,12,51173,51199,12,51201,51227,12,51229,51255,12,51257,51283,12,51285,51311,12,51313,51339,12,51341,51367,12,51369,51395,12,51397,51423,12,51425,51451,12,51453,51479,12,51481,51507,12,51509,51535,12,51537,51563,12,51565,51591,12,51593,51619,12,51621,51647,12,51649,51675,12,51677,51703,12,51705,51731,12,51733,51759,12,51761,51787,12,51789,51815,12,51817,51843,12,51845,51871,12,51873,51899,12,51901,51927,12,51929,51955,12,51957,51983,12,51985,52011,12,52013,52039,12,52041,52067,12,52069,52095,12,52097,52123,12,52125,52151,12,52153,52179,12,52181,52207,12,52209,52235,12,52237,52263,12,52265,52291,12,52293,52319,12,52321,52347,12,52349,52375,12,52377,52403,12,52405,52431,12,52433,52459,12,52461,52487,12,52489,52515,12,52517,52543,12,52545,52571,12,52573,52599,12,52601,52627,12,52629,52655,12,52657,52683,12,52685,52711,12,52713,52739,12,52741,52767,12,52769,52795,12,52797,52823,12,52825,52851,12,52853,52879,12,52881,52907,12,52909,52935,12,52937,52963,12,52965,52991,12,52993,53019,12,53021,53047,12,53049,53075,12,53077,53103,12,53105,53131,12,53133,53159,12,53161,53187,12,53189,53215,12,53217,53243,12,53245,53271,12,53273,53299,12,53301,53327,12,53329,53355,12,53357,53383,12,53385,53411,12,53413,53439,12,53441,53467,12,53469,53495,12,53497,53523,12,53525,53551,12,53553,53579,12,53581,53607,12,53609,53635,12,53637,53663,12,53665,53691,12,53693,53719,12,53721,53747,12,53749,53775,12,53777,53803,12,53805,53831,12,53833,53859,12,53861,53887,12,53889,53915,12,53917,53943,12,53945,53971,12,53973,53999,12,54001,54027,12,54029,54055,12,54057,54083,12,54085,54111,12,54113,54139,12,54141,54167,12,54169,54195,12,54197,54223,12,54225,54251,12,54253,54279,12,54281,54307,12,54309,54335,12,54337,54363,12,54365,54391,12,54393,54419,12,54421,54447,12,54449,54475,12,54477,54503,12,54505,54531,12,54533,54559,12,54561,54587,12,54589,54615,12,54617,54643,12,54645,54671,12,54673,54699,12,54701,54727,12,54729,54755,12,54757,54783,12,54785,54811,12,54813,54839,12,54841,54867,12,54869,54895,12,54897,54923,12,54925,54951,12,54953,54979,12,54981,55007,12,55009,55035,12,55037,55063,12,55065,55091,12,55093,55119,12,55121,55147,12,55149,55175,12,55177,55203,12,55243,55291,10,65024,65039,5,65279,65279,4,65520,65528,4,66045,66045,5,66422,66426,5,68101,68102,5,68152,68154,5,68325,68326,5,69291,69292,5,69632,69632,7,69634,69634,7,69759,69761,5]")}function De(z,ee){if(z===0)return 0;const ue=Se(z,ee);if(ue!==void 0)return ue;const Ie=N(ee,z);return z-=Pe(Ie),z}e.getLeftDeleteOffset=De;function Se(z,ee){let ue=N(ee,z);for(z-=Pe(ue);ae(ue)||ue===65039||ue===8419;){if(z===0)return;ue=N(ee,z),z-=Pe(ue)}if(!!qe(ue)){if(z>=0){const Ie=N(ee,z);Ie===8205&&(z-=Pe(Ie))}return z}}function Pe(z){return z>=65536?2:1}function ae(z){return 127995<=z&&z<=127999}var he;(function(z){z[z.zwj=8205]="zwj",z[z.emojiVariantSelector=65039]="emojiVariantSelector",z[z.enclosingKeyCap=8419]="enclosingKeyCap"})(he||(he={}))}),define(ge[22],pe([0,1,8,93]),function(Q,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const k=typeof Buffer!="undefined",D=typeof TextEncoder!="undefined",A=typeof TextDecoder!="undefined";let P,_;class C{constructor(f){this.buffer=f,this.byteLength=this.buffer.byteLength}static alloc(f){return k?new C(Buffer.allocUnsafe(f)):new C(new Uint8Array(f))}static wrap(f){return k&&!Buffer.isBuffer(f)&&(f=Buffer.from(f.buffer,f.byteOffset,f.byteLength)),new C(f)}static fromString(f,E){return!((E==null?void 0:E.dontUseNodeBuffer)||!1)&&k?new C(Buffer.from(f)):D?(P||(P=new TextEncoder),new C(P.encode(f))):new C(v.encodeUTF8(f))}static concat(f,E){if(typeof E=="undefined"){E=0;for(let L=0,O=f.length;L<O;L++)E+=f[L].byteLength}const y=C.alloc(E);let a=0;for(let L=0,O=f.length;L<O;L++){const W=f[L];y.set(W,a),a+=W.byteLength}return y}toString(){return k?this.buffer.toString():A?(_||(_=new TextDecoder),_.decode(this.buffer)):v.decodeUTF8(this.buffer)}slice(f,E){return new C(this.buffer.subarray(f,E))}set(f,E){f instanceof C?this.buffer.set(f.buffer,E):this.buffer.set(f,E)}readUInt32BE(f){return l(this.buffer,f)}writeUInt32BE(f,E){m(this.buffer,f,E)}readUInt32LE(f){return c(this.buffer,f)}writeUInt32LE(f,E){h(this.buffer,f,E)}readUInt8(f){return S(this.buffer,f)}writeUInt8(f,E){w(this.buffer,f,E)}}e.VSBuffer=C;function s(g,f){return g[f+0]<<0>>>0|g[f+1]<<8>>>0}e.readUInt16LE=s;function I(g,f,E){g[E+0]=f&255,f=f>>>8,g[E+1]=f&255}e.writeUInt16LE=I;function l(g,f){return g[f]*2**24+g[f+1]*2**16+g[f+2]*2**8+g[f+3]}e.readUInt32BE=l;function m(g,f,E){g[E+3]=f,f=f>>>8,g[E+2]=f,f=f>>>8,g[E+1]=f,f=f>>>8,g[E]=f}e.writeUInt32BE=m;function c(g,f){return g[f+0]<<0>>>0|g[f+1]<<8>>>0|g[f+2]<<16>>>0|g[f+3]<<24>>>0}e.readUInt32LE=c;function h(g,f,E){g[E+0]=f&255,f=f>>>8,g[E+1]=f&255,f=f>>>8,g[E+2]=f&255,f=f>>>8,g[E+3]=f&255}e.writeUInt32LE=h;function S(g,f){return g[f]}e.readUInt8=S;function w(g,f,E){g[E]=f}e.writeUInt8=w;function b(g){return R.consumeReadable(g,f=>C.concat(f))}e.readableToBuffer=b;function u(g){return R.toReadable(g)}e.bufferToReadable=u;function d(g){return R.consumeStream(g,f=>C.concat(f))}e.streamToBuffer=d;async function p(g){return g.ended?C.concat(g.buffer):C.concat([...g.buffer,await d(g.stream)])}e.bufferedStreamToBuffer=p;function t(g){return R.toStream(g,f=>C.concat(f))}e.bufferToStream=t;function i(g){return R.transform(g,{data:f=>typeof f=="string"?C.fromString(f):C.wrap(f)},f=>C.concat(f))}e.streamToBufferReadableStream=i;function r(g){return R.newWriteableStream(f=>C.concat(f),g)}e.newWriteableBufferStream=r;function n(g,f){return R.prefixedReadable(g,f,E=>C.concat(E))}e.prefixedBufferReadable=n;function o(g,f){return R.prefixedStream(g,f,E=>C.concat(E))}e.prefixedBufferStream=o}),define(ge[73],pe([0,1,8]),function(Q,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.doHash=e.hash=void 0;function R(w){return k(w,0)}e.hash=R;function k(w,b){switch(typeof w){case"object":return w===null?D(349,b):Array.isArray(w)?_(w,b):C(w,b);case"string":return P(w,b);case"boolean":return A(w,b);case"number":return D(w,b);case"undefined":return D(937,b);default:return D(617,b)}}e.doHash=k;function D(w,b){return(b<<5)-b+w|0}function A(w,b){return D(w?433:863,b)}function P(w,b){b=D(149417,b);for(let u=0,d=w.length;u<d;u++)b=D(w.charCodeAt(u),b);return b}e.stringHash=P;function _(w,b){return b=D(104579,b),w.reduce((u,d)=>k(d,u),b)}function C(w,b){return b=D(181387,b),Object.keys(w).sort().reduce((u,d)=>(u=P(d,u),k(w[d],u)),b)}class s{constructor(){this._value=0}get value(){return this._value}hash(b){return this._value=k(b,this._value),this._value}}e.Hasher=s;var I;(function(w){w[w.BLOCK_SIZE=64]="BLOCK_SIZE",w[w.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(I||(I={}));function l(w,b,u=32){const d=u-b,p=~((1<<d)-1);return(w<<b|(p&w)>>>d)>>>0}function m(w,b=0,u=w.byteLength,d=0){for(let p=0;p<u;p++)w[b+p]=d}function c(w,b,u="0"){for(;w.length<b;)w=u+w;return w}function h(w,b=32){return w instanceof ArrayBuffer?Array.from(new Uint8Array(w)).map(u=>u.toString(16).padStart(2,"0")).join(""):c((w>>>0).toString(16),b/4)}e.toHexString=h;class S{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(b){const u=b.length;if(u===0)return;const d=this._buff;let p=this._buffLen,t=this._leftoverHighSurrogate,i,r;for(t!==0?(i=t,r=-1,t=0):(i=b.charCodeAt(0),r=0);;){let n=i;if(v.isHighSurrogate(i))if(r+1<u){const o=b.charCodeAt(r+1);v.isLowSurrogate(o)?(r++,n=v.computeCodePoint(i,o)):n=65533}else{t=i;break}else v.isLowSurrogate(i)&&(n=65533);if(p=this._push(d,p,n),r++,r<u)i=b.charCodeAt(r);else break}this._buffLen=p,this._leftoverHighSurrogate=t}_push(b,u,d){return d<128?b[u++]=d:d<2048?(b[u++]=192|(d&1984)>>>6,b[u++]=128|(d&63)>>>0):d<65536?(b[u++]=224|(d&61440)>>>12,b[u++]=128|(d&4032)>>>6,b[u++]=128|(d&63)>>>0):(b[u++]=240|(d&1835008)>>>18,b[u++]=128|(d&258048)>>>12,b[u++]=128|(d&4032)>>>6,b[u++]=128|(d&63)>>>0),u>=64&&(this._step(),u-=64,this._totalLen+=64,b[0]=b[64+0],b[1]=b[64+1],b[2]=b[64+2]),u}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),h(this._h0)+h(this._h1)+h(this._h2)+h(this._h3)+h(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,m(this._buff,this._buffLen),this._buffLen>56&&(this._step(),m(this._buff));const b=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(b/4294967296),!1),this._buffDV.setUint32(60,b%4294967296,!1),this._step()}_step(){const b=S._bigBlock32,u=this._buffDV;for(let f=0;f<64;f+=4)b.setUint32(f,u.getUint32(f,!1),!1);for(let f=64;f<320;f+=4)b.setUint32(f,l(b.getUint32(f-12,!1)^b.getUint32(f-32,!1)^b.getUint32(f-56,!1)^b.getUint32(f-64,!1),1),!1);let d=this._h0,p=this._h1,t=this._h2,i=this._h3,r=this._h4,n,o,g;for(let f=0;f<80;f++)f<20?(n=p&t|~p&i,o=1518500249):f<40?(n=p^t^i,o=1859775393):f<60?(n=p&t|p&i|t&i,o=2400959708):(n=p^t^i,o=3395469782),g=l(d,5)+n+r+o+b.getUint32(f*4,!1)&4294967295,r=i,i=t,t=l(p,30),p=d,d=g;this._h0=this._h0+d&4294967295,this._h1=this._h1+p&4294967295,this._h2=this._h2+t&4294967295,this._h3=this._h3+i&4294967295,this._h4=this._h4+r&4294967295}}e.StringSHA1=S,S._bigBlock32=new DataView(new ArrayBuffer(320))}),define(ge[53],pe([0,1,8]),function(Q,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var R;(function(k){k[k.Ignore=0]="Ignore",k[k.Info=1]="Info",k[k.Warning=2]="Warning",k[k.Error=3]="Error"})(R||(R={})),function(k){const D="error",A="warning",P="warn",_="info",C="ignore";function s(l){return l?v.equalsIgnoreCase(D,l)?k.Error:v.equalsIgnoreCase(A,l)||v.equalsIgnoreCase(P,l)?k.Warning:v.equalsIgnoreCase(_,l)?k.Info:k.Ignore:k.Ignore}k.fromValue=s;function I(l){switch(l){case k.Error:return D;case k.Warning:return A;case k.Info:return _;default:return C}}k.toString=I}(R||(R={})),e.default=R}),define(ge[15],pe([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.assertNever=e.NotImplementedProxy=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function v(f){return Array.isArray(f)}e.isArray=v;function R(f){return typeof f=="string"}e.isString=R;function k(f){return Array.isArray(f)&&f.every(E=>R(E))}e.isStringArray=k;function D(f){return typeof f=="object"&&f!==null&&!Array.isArray(f)&&!(f instanceof RegExp)&&!(f instanceof Date)}e.isObject=D;function A(f){return typeof f=="number"&&!isNaN(f)}e.isNumber=A;function P(f){return!!f&&typeof f[Symbol.iterator]=="function"}e.isIterable=P;function _(f){return f===!0||f===!1}e.isBoolean=_;function C(f){return typeof f=="undefined"}e.isUndefined=C;function s(f){return!I(f)}e.isDefined=s;function I(f){return C(f)||f===null}e.isUndefinedOrNull=I;function l(f,E){if(!f)throw new Error(E?`Unexpected type, expected '${E}'`:"Unexpected type")}e.assertType=l;function m(f){if(I(f))throw new Error("Assertion Failed: argument is undefined or null");return f}e.assertIsDefined=m;function c(...f){const E=[];for(let y=0;y<f.length;y++){const a=f[y];if(I(a))throw new Error(`Assertion Failed: argument at index ${y} is undefined or null`);E.push(a)}return E}e.assertAllDefined=c;const h=Object.prototype.hasOwnProperty;function S(f){if(!D(f))return!1;for(let E in f)if(h.call(f,E))return!1;return!0}e.isEmptyObject=S;function w(f){return typeof f=="function"}e.isFunction=w;function b(...f){return f.length>0&&f.every(w)}e.areFunctions=b;function u(f,E){const y=Math.min(f.length,E.length);for(let a=0;a<y;a++)d(f[a],E[a])}e.validateConstraints=u;function d(f,E){if(R(E)){if(typeof f!==E)throw new Error(`argument does not match constraint: typeof ${E}`)}else if(w(E)){try{if(f instanceof E)return}catch(y){}if(!I(f)&&f.constructor===E||E.length===1&&E.call(void 0,f)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=d;function p(f){let E=[],y=Object.getPrototypeOf(f);for(;Object.prototype!==y;)E=E.concat(Object.getOwnPropertyNames(y)),y=Object.getPrototypeOf(y);return E}e.getAllPropertyNames=p;function t(f){const E=[];for(const y of p(f))typeof f[y]=="function"&&E.push(y);return E}e.getAllMethodNames=t;function i(f,E){const y=L=>function(){const O=Array.prototype.slice.call(arguments,0);return E(L,O)};let a={};for(const L of f)a[L]=y(L);return a}e.createProxyObject=i;function r(f){return f===null?void 0:f}e.withNullAsUndefined=r;function n(f){return typeof f=="undefined"?null:f}e.withUndefinedAsNull=n;function o(f){return class{constructor(){return new Proxy({},{get(E,y){if(E[y])return E[y];throw new Error(`Not Implemented: ${f}->${String(y)}`)}})}}}e.NotImplementedProxy=o;function g(f){throw new Error("Unreachable")}e.assertNever=g}),define(ge[29],pe([0,1,11,8,9,15]),function(Q,e,v,R,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function A(r){return r===47||r===92}e.isPathSeparator=A;function P(r){return r.replace(/[\\/]/g,k.posix.sep)}e.toSlashes=P;function _(r){return r.indexOf("/")===-1&&(r=P(r)),/^[a-zA-Z]:(\/|$)/.test(r)&&(r="/"+r),r}e.toPosixPath=_;function C(r,n=k.posix.sep){if(!r)return"";const o=r.length,g=r.charCodeAt(0);if(A(g)){if(A(r.charCodeAt(1))&&!A(r.charCodeAt(2))){let E=3;const y=E;for(;E<o&&!A(r.charCodeAt(E));E++);if(y!==E&&!A(r.charCodeAt(E+1))){for(E+=1;E<o;E++)if(A(r.charCodeAt(E)))return r.slice(0,E+1).replace(/[\\/]/g,n)}}return n}else if(w(g)&&r.charCodeAt(1)===58)return A(r.charCodeAt(2))?r.slice(0,2)+n:r.slice(0,2);let f=r.indexOf("://");if(f!==-1){for(f+=3;f<o;f++)if(A(r.charCodeAt(f)))return r.slice(0,f+1)}return""}e.getRoot=C;function s(r){if(!v.isWindows||!r||r.length<5)return!1;let n=r.charCodeAt(0);if(n!==92||(n=r.charCodeAt(1),n!==92))return!1;let o=2;const g=o;for(;o<r.length&&(n=r.charCodeAt(o),n!==92);o++);return!(g===o||(n=r.charCodeAt(o+1),isNaN(n)||n===92))}e.isUNC=s;const I=/[\\/:\*\?"<>\|]/g,l=/[\\/]/g,m=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function c(r,n=v.isWindows){const o=n?I:l;return!(!r||r.length===0||/^\s+$/.test(r)||(o.lastIndex=0,o.test(r))||n&&m.test(r)||r==="."||r===".."||n&&r[r.length-1]==="."||n&&r.length!==r.trim().length||r.length>255)}e.isValidBasename=c;function h(r,n,o){const g=r===n;return!o||g?g:!r||!n?!1:R.equalsIgnoreCase(r,n)}e.isEqual=h;function S(r,n,o,g=k.sep){if(r===n)return!0;if(!r||!n||n.length>r.length)return!1;if(o){if(!R.startsWithIgnoreCase(r,n))return!1;if(n.length===r.length)return!0;let E=n.length;return n.charAt(n.length-1)===g&&E--,r.charAt(E)===g}return n.charAt(n.length-1)!==g&&(n+=g),r.indexOf(n)===0}e.isEqualOrParent=S;function w(r){return r>=65&&r<=90||r>=97&&r<=122}e.isWindowsDriveLetter=w;function b(r,n){return v.isWindows&&r.endsWith(":")&&(r+=k.sep),k.isAbsolute(r)||(r=k.join(n,r)),r=k.normalize(r),v.isWindows?(r=R.rtrim(r,k.sep),r.endsWith(":")&&(r+=k.sep)):(r=R.rtrim(r,k.sep),r||(r=k.sep)),r}e.sanitizeFilePath=b;function u(r){const n=k.normalize(r);return v.isWindows?r.length>3?!1:d(n)&&(r.length===2||n.charCodeAt(2)===92):n===k.posix.sep}e.isRootOrDriveLetter=u;function d(r){return v.isWindows?w(r.charCodeAt(0))&&r.charCodeAt(1)===58:!1}e.hasDriveLetter=d;function p(r){return d(r)?r[0]:void 0}e.getDriveLetter=p;function t(r,n,o){return n.length>r.length?-1:r===n?0:(o&&(r=r.toLowerCase(),n=n.toLowerCase()),r.indexOf(n))}e.indexOfPath=t;function i(r){const n=r.split(":");let o,g,f;if(n.forEach(E=>{const y=Number(E);D.isNumber(y)?g===void 0?g=y:f===void 0&&(f=y):o=o?[o,E].join(":"):E}),!o)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:o,line:g!==void 0?g:void 0,column:f!==void 0?f:g!==void 0?1:void 0}}e.parseLineAndColumnAware=i}),define(ge[25],pe([0,1,15]),function(Q,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function R(h){if(!h||typeof h!="object"||h instanceof RegExp)return h;const S=Array.isArray(h)?[]:{};return Object.keys(h).forEach(w=>{h[w]&&typeof h[w]=="object"?S[w]=R(h[w]):S[w]=h[w]}),S}e.deepClone=R;function k(h){if(!h||typeof h!="object")return h;const S=[h];for(;S.length>0;){const w=S.shift();Object.freeze(w);for(const b in w)if(D.call(w,b)){const u=w[b];typeof u=="object"&&!Object.isFrozen(u)&&S.push(u)}}return h}e.deepFreeze=k;const D=Object.prototype.hasOwnProperty;function A(h,S){return P(h,S,new Set)}e.cloneAndChange=A;function P(h,S,w){if(v.isUndefinedOrNull(h))return h;const b=S(h);if(typeof b!="undefined")return b;if(v.isArray(h)){const u=[];for(const d of h)u.push(P(d,S,w));return u}if(v.isObject(h)){if(w.has(h))throw new Error("Cannot clone recursive data-structure");w.add(h);const u={};for(let d in h)D.call(h,d)&&(u[d]=P(h[d],S,w));return w.delete(h),u}return h}function _(h,S,w=!0){return v.isObject(h)?(v.isObject(S)&&Object.keys(S).forEach(b=>{b in h?w&&(v.isObject(h[b])&&v.isObject(S[b])?_(h[b],S[b],w):h[b]=S[b]):h[b]=S[b]}),h):S}e.mixin=_;function C(h,S){if(h===S)return!0;if(h==null||S===null||S===void 0||typeof h!=typeof S||typeof h!="object"||Array.isArray(h)!==Array.isArray(S))return!1;let w,b;if(Array.isArray(h)){if(h.length!==S.length)return!1;for(w=0;w<h.length;w++)if(!C(h[w],S[w]))return!1}else{const u=[];for(b in h)u.push(b);u.sort();const d=[];for(b in S)d.push(b);if(d.sort(),!C(u,d))return!1;for(w=0;w<u.length;w++)if(!C(h[u[w]],S[u[w]]))return!1}return!0}e.equals=C;function s(h){const S=new Set;return JSON.stringify(h,(w,b)=>{if(v.isObject(b)||Array.isArray(b)){if(S.has(b))return"[Circular]";S.add(b)}return b})}e.safeStringify=s;function I(h,S,w){const b=S(h);return typeof b=="undefined"?w:b}e.getOrDefault=I;function l(h,S){const w=Object.create(null);return!h||!S||Object.keys(S).forEach(u=>{const d=h[u],p=S[u];C(d,p)||(w[u]=p)}),w}e.distinct=l;function m(h,S){const w=S.toLowerCase(),b=Object.keys(h).find(u=>u.toLowerCase()===w);return b?h[b]:h[S]}e.getCaseInsensitive=m;function c(h,S){const w=Object.create(null);for(const b of Object.keys(h))S(b,h[b])&&(w[b]=h[b]);return w}e.filter=c}),define(ge[94],pe([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toUint32=e.toUint8=e.Constants=void 0;var v;(function(D){D[D.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",D[D.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",D[D.MAX_UINT_8=255]="MAX_UINT_8",D[D.MAX_UINT_16=65535]="MAX_UINT_16",D[D.MAX_UINT_32=4294967295]="MAX_UINT_32",D[D.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(v=e.Constants||(e.Constants={}));function R(D){return D<0?0:D>255?255:D|0}e.toUint8=R;function k(D){return D<0?0:D>4294967295?4294967295:D|0}e.toUint32=k}),define(ge[2],pe([0,1,11,9]),function(Q,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const k=/^\w[\w\d+.-]*$/,D=/^\//,A=/^\/\//;function P(r,n){if(!r.scheme&&n)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${r.authority}", path: "${r.path}", query: "${r.query}", fragment: "${r.fragment}"}`);if(r.scheme&&!k.test(r.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(r.path){if(r.authority){if(!D.test(r.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(A.test(r.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function _(r,n){return!r&&!n?"file":r}function C(r,n){switch(r){case"https":case"http":case"file":n?n[0]!==I&&(n=I+n):n=I;break}return n}const s="",I="/",l=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class m{constructor(n,o,g,f,E,y=!1){typeof n=="object"?(this.scheme=n.scheme||s,this.authority=n.authority||s,this.path=n.path||s,this.query=n.query||s,this.fragment=n.fragment||s):(this.scheme=_(n,y),this.authority=o||s,this.path=C(this.scheme,g||s),this.query=f||s,this.fragment=E||s,P(this,y))}static isUri(n){return n instanceof m?!0:n?typeof n.authority=="string"&&typeof n.fragment=="string"&&typeof n.path=="string"&&typeof n.query=="string"&&typeof n.scheme=="string"&&typeof n.fsPath=="string"&&typeof n.with=="function"&&typeof n.toString=="function":!1}get fsPath(){return u(this,!1)}with(n){if(!n)return this;let{scheme:o,authority:g,path:f,query:E,fragment:y}=n;return o===void 0?o=this.scheme:o===null&&(o=s),g===void 0?g=this.authority:g===null&&(g=s),f===void 0?f=this.path:f===null&&(f=s),E===void 0?E=this.query:E===null&&(E=s),y===void 0?y=this.fragment:y===null&&(y=s),o===this.scheme&&g===this.authority&&f===this.path&&E===this.query&&y===this.fragment?this:new h(o,g,f,E,y)}static parse(n,o=!1){const g=l.exec(n);return g?new h(g[2]||s,i(g[4]||s),i(g[5]||s),i(g[7]||s),i(g[9]||s),o):new h(s,s,s,s,s)}static file(n){let o=s;if(v.isWindows&&(n=n.replace(/\\/g,I)),n[0]===I&&n[1]===I){const g=n.indexOf(I,2);g===-1?(o=n.substring(2),n=I):(o=n.substring(2,g),n=n.substring(g)||I)}return new h("file",o,n,s,s)}static from(n){const o=new h(n.scheme,n.authority,n.path,n.query,n.fragment);return P(o,!0),o}static joinPath(n,...o){if(!n.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let g;return v.isWindows&&n.scheme==="file"?g=m.file(R.win32.join(u(n,!0),...o)).path:g=R.posix.join(n.path,...o),n.with({path:g})}toString(n=!1){return d(this,n)}toJSON(){return this}static revive(n){if(n){if(n instanceof m)return n;{const o=new h(n);return o._formatted=n.external,o._fsPath=n._sep===c?n.fsPath:null,o}}else return n}}e.URI=m;const c=v.isWindows?1:void 0;class h extends m{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=u(this,!1)),this._fsPath}toString(n=!1){return n?d(this,!0):(this._formatted||(this._formatted=d(this,!1)),this._formatted)}toJSON(){const n={$mid:1};return this._fsPath&&(n.fsPath=this._fsPath,n._sep=c),this._formatted&&(n.external=this._formatted),this.path&&(n.path=this.path),this.scheme&&(n.scheme=this.scheme),this.authority&&(n.authority=this.authority),this.query&&(n.query=this.query),this.fragment&&(n.fragment=this.fragment),n}}const S={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function w(r,n){let o,g=-1;for(let f=0;f<r.length;f++){const E=r.charCodeAt(f);if(E>=97&&E<=122||E>=65&&E<=90||E>=48&&E<=57||E===45||E===46||E===95||E===126||n&&E===47)g!==-1&&(o+=encodeURIComponent(r.substring(g,f)),g=-1),o!==void 0&&(o+=r.charAt(f));else{o===void 0&&(o=r.substr(0,f));const y=S[E];y!==void 0?(g!==-1&&(o+=encodeURIComponent(r.substring(g,f)),g=-1),o+=y):g===-1&&(g=f)}}return g!==-1&&(o+=encodeURIComponent(r.substring(g))),o!==void 0?o:r}function b(r){let n;for(let o=0;o<r.length;o++){const g=r.charCodeAt(o);g===35||g===63?(n===void 0&&(n=r.substr(0,o)),n+=S[g]):n!==void 0&&(n+=r[o])}return n!==void 0?n:r}function u(r,n){let o;return r.authority&&r.path.length>1&&r.scheme==="file"?o=`//${r.authority}${r.path}`:r.path.charCodeAt(0)===47&&(r.path.charCodeAt(1)>=65&&r.path.charCodeAt(1)<=90||r.path.charCodeAt(1)>=97&&r.path.charCodeAt(1)<=122)&&r.path.charCodeAt(2)===58?n?o=r.path.substr(1):o=r.path[1].toLowerCase()+r.path.substr(2):o=r.path,v.isWindows&&(o=o.replace(/\//g,"\\")),o}e.uriToFsPath=u;function d(r,n){const o=n?b:w;let g="",{scheme:f,authority:E,path:y,query:a,fragment:L}=r;if(f&&(g+=f,g+=":"),(E||f==="file")&&(g+=I,g+=I),E){let O=E.indexOf("@");if(O!==-1){const W=E.substr(0,O);E=E.substr(O+1),O=W.indexOf(":"),O===-1?g+=o(W,!1):(g+=o(W.substr(0,O),!1),g+=":",g+=o(W.substr(O+1),!1)),g+="@"}E=E.toLowerCase(),O=E.indexOf(":"),O===-1?g+=o(E,!1):(g+=o(E.substr(0,O),!1),g+=E.substr(O))}if(y){if(y.length>=3&&y.charCodeAt(0)===47&&y.charCodeAt(2)===58){const O=y.charCodeAt(1);O>=65&&O<=90&&(y=`/${String.fromCharCode(O+32)}:${y.substr(3)}`)}else if(y.length>=2&&y.charCodeAt(1)===58){const O=y.charCodeAt(0);O>=65&&O<=90&&(y=`${String.fromCharCode(O+32)}:${y.substr(2)}`)}g+=o(y,!0)}return a&&(g+="?",g+=o(a,!1)),L&&(g+="#",g+=n?L:w(L,!1)),g}function p(r){try{return decodeURIComponent(r)}catch(n){return r.length>3?r.substr(0,3)+p(r.substr(3)):r}}const t=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function i(r){return r.match(t)?r.replace(t,n=>p(n)):r}});var it=this&&this.__classPrivateFieldSet||function(Q,e,v,R,k){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Q!==e||!k:!e.has(Q))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?k.call(Q,v):k?k.value=v:e.set(Q,v),v},Be=this&&this.__classPrivateFieldGet||function(Q,e,v,R){if(v==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Q!==e||!R:!e.has(Q))throw new TypeError("Cannot read private member from an object whose class did not declare it");return v==="m"?R:v==="a"?R.call(Q):R?R.value:e.get(Q)};define(ge[23],pe([0,1,2,8]),function(Q,e,v,R){"use strict";var k,D,A;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function P(t,i,r){let n=t.get(i);return n===void 0&&(n=r,t.set(i,n)),n}e.getOrSet=P;function _(t){const i=[];return t.forEach((r,n)=>{i.push(`${n} => ${r}`)}),`Map(${t.size}) {${i.join(", ")}}`}e.mapToString=_;function C(t){const i=[];return t.forEach(r=>{i.push(r)}),`Set(${t.size}) {${i.join(", ")}}`}e.setToString=C;class s{constructor(){this._value="",this._pos=0}reset(i){return this._value=i,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(i){const r=i.charCodeAt(0),n=this._value.charCodeAt(this._pos);return r-n}value(){return this._value[this._pos]}}e.StringIterator=s;class I{constructor(i=!0){this._caseSensitive=i}reset(i){return this._value=i,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let i=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(i)this._from++;else break;else i=!1;return this}cmp(i){return this._caseSensitive?R.compareSubstring(i,this._value,0,i.length,this._from,this._to):R.compareSubstringIgnoreCase(i,this._value,0,i.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=I;class l{constructor(i=!0,r=!0){this._splitOnBackslash=i,this._caseSensitive=r}reset(i){return this._value=i.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let i=!0;for(;this._to<this._value.length;this._to++){const r=this._value.charCodeAt(this._to);if(r===47||this._splitOnBackslash&&r===92)if(i)this._from++;else break;else i=!1}return this}cmp(i){return this._caseSensitive?R.compareSubstring(i,this._value,0,i.length,this._from,this._to):R.compareSubstringIgnoreCase(i,this._value,0,i.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=l;var m;(function(t){t[t.Scheme=1]="Scheme",t[t.Authority=2]="Authority",t[t.Path=3]="Path",t[t.Query=4]="Query",t[t.Fragment=5]="Fragment"})(m||(m={}));class c{constructor(i){this._ignorePathCasing=i,this._states=[],this._stateIdx=0}reset(i){return this._value=i,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new l(!1,!this._ignorePathCasing(i)),this._pathIterator.reset(i.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(i){if(this._states[this._stateIdx]===1)return R.compareIgnoreCase(i,this._value.scheme);if(this._states[this._stateIdx]===2)return R.compareIgnoreCase(i,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(i);if(this._states[this._stateIdx]===4)return R.compare(i,this._value.query);if(this._states[this._stateIdx]===5)return R.compare(i,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=c;class h{isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}}class S{constructor(i){this._iter=i}static forUris(i=()=>!1){return new S(new c(i))}static forPaths(){return new S(new l)}static forStrings(){return new S(new s)}static forConfigKeys(){return new S(new I)}clear(){this._root=void 0}set(i,r){const n=this._iter.reset(i);let o;for(this._root||(this._root=new h,this._root.segment=n.value()),o=this._root;;){const f=n.cmp(o.segment);if(f>0)o.left||(o.left=new h,o.left.segment=n.value()),o=o.left;else if(f<0)o.right||(o.right=new h,o.right.segment=n.value()),o=o.right;else if(n.hasNext())n.next(),o.mid||(o.mid=new h,o.mid.segment=n.value()),o=o.mid;else break}const g=o.value;return o.value=r,o.key=i,g}get(i){var r;return(r=this._getNode(i))===null||r===void 0?void 0:r.value}_getNode(i){const r=this._iter.reset(i);let n=this._root;for(;n;){const o=r.cmp(n.segment);if(o>0)n=n.left;else if(o<0)n=n.right;else if(r.hasNext())r.next(),n=n.mid;else break}return n}has(i){const r=this._getNode(i);return!((r==null?void 0:r.value)===void 0&&(r==null?void 0:r.mid)===void 0)}delete(i){return this._delete(i,!1)}deleteSuperstr(i){return this._delete(i,!0)}_delete(i,r){const n=this._iter.reset(i),o=[];let g=this._root;for(;g;){const f=n.cmp(g.segment);if(f>0)o.push([1,g]),g=g.left;else if(f<0)o.push([-1,g]),g=g.right;else if(n.hasNext())n.next(),o.push([0,g]),g=g.mid;else{for(r?(g.left=void 0,g.mid=void 0,g.right=void 0):g.value=void 0;o.length>0&&g.isEmpty();){let[E,y]=o.pop();switch(E){case 1:y.left=void 0;break;case 0:y.mid=void 0;break;case-1:y.right=void 0;break}g=y}break}}}findSubstr(i){const r=this._iter.reset(i);let n=this._root,o;for(;n;){const g=r.cmp(n.segment);if(g>0)n=n.left;else if(g<0)n=n.right;else if(r.hasNext())r.next(),o=n.value||o,n=n.mid;else break}return n&&n.value||o}findSuperstr(i){const r=this._iter.reset(i);let n=this._root;for(;n;){const o=r.cmp(n.segment);if(o>0)n=n.left;else if(o<0)n=n.right;else if(r.hasNext())r.next(),n=n.mid;else return n.mid?this._entries(n.mid):void 0}}forEach(i){for(const[r,n]of this)i(n,r)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(i){if(!i)return;const r=[i];for(;r.length>0;){const n=r.pop();n&&(n.value&&(yield[n.key,n.value]),n.left&&r.push(n.left),n.mid&&r.push(n.mid),n.right&&r.push(n.right))}}}e.TernarySearchTree=S;class w{constructor(i,r){this[k]="ResourceMap",i instanceof w?(this.map=new Map(i.map),this.toKey=r??w.defaultToKey):(this.map=new Map,this.toKey=i??w.defaultToKey)}set(i,r){return this.map.set(this.toKey(i),r),this}get(i){return this.map.get(this.toKey(i))}has(i){return this.map.has(this.toKey(i))}get size(){return this.map.size}clear(){this.map.clear()}delete(i){return this.map.delete(this.toKey(i))}forEach(i,r){typeof r!="undefined"&&(i=i.bind(r));for(let[n,o]of this.map)i(o,v.URI.parse(n),this)}values(){return this.map.values()}*keys(){for(let i of this.map.keys())yield v.URI.parse(i)}*entries(){for(let i of this.map.entries())yield[v.URI.parse(i[0]),i[1]]}*[(k=Symbol.toStringTag,Symbol.iterator)](){for(let i of this.map)yield[v.URI.parse(i[0]),i[1]]}}e.ResourceMap=w,w.defaultToKey=t=>t.toString();var b;(function(t){t[t.None=0]="None",t[t.AsOld=1]="AsOld",t[t.AsNew=2]="AsNew"})(b=e.Touch||(e.Touch={}));class u{constructor(){this[D]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){var i;return(i=this._head)===null||i===void 0?void 0:i.value}get last(){var i;return(i=this._tail)===null||i===void 0?void 0:i.value}has(i){return this._map.has(i)}get(i,r=0){const n=this._map.get(i);if(!!n)return r!==0&&this.touch(n,r),n.value}set(i,r,n=0){let o=this._map.get(i);if(o)o.value=r,n!==0&&this.touch(o,n);else{switch(o={key:i,value:r,next:void 0,previous:void 0},n){case 0:this.addItemLast(o);break;case 1:this.addItemFirst(o);break;case 2:this.addItemLast(o);break;default:this.addItemLast(o);break}this._map.set(i,o),this._size++}return this}delete(i){return!!this.remove(i)}remove(i){const r=this._map.get(i);if(!!r)return this._map.delete(i),this.removeItem(r),this._size--,r.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const i=this._head;return this._map.delete(i.key),this.removeItem(i),this._size--,i.value}forEach(i,r){const n=this._state;let o=this._head;for(;o;){if(r?i.bind(r)(o.value,o.key,this):i(o.value,o.key,this),this._state!==n)throw new Error("LinkedMap got modified during iteration.");o=o.next}}keys(){const i=this,r=this._state;let n=this._head;const o={[Symbol.iterator](){return o},next(){if(i._state!==r)throw new Error("LinkedMap got modified during iteration.");if(n){const g={value:n.key,done:!1};return n=n.next,g}else return{value:void 0,done:!0}}};return o}values(){const i=this,r=this._state;let n=this._head;const o={[Symbol.iterator](){return o},next(){if(i._state!==r)throw new Error("LinkedMap got modified during iteration.");if(n){const g={value:n.value,done:!1};return n=n.next,g}else return{value:void 0,done:!0}}};return o}entries(){const i=this,r=this._state;let n=this._head;const o={[Symbol.iterator](){return o},next(){if(i._state!==r)throw new Error("LinkedMap got modified during iteration.");if(n){const g={value:[n.key,n.value],done:!1};return n=n.next,g}else return{value:void 0,done:!0}}};return o}[(D=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(i){if(i>=this.size)return;if(i===0){this.clear();return}let r=this._head,n=this.size;for(;r&&n>i;)this._map.delete(r.key),r=r.next,n--;this._head=r,this._size=n,r&&(r.previous=void 0),this._state++}addItemFirst(i){if(!this._head&&!this._tail)this._tail=i;else if(this._head)i.next=this._head,this._head.previous=i;else throw new Error("Invalid list");this._head=i,this._state++}addItemLast(i){if(!this._head&&!this._tail)this._head=i;else if(this._tail)i.previous=this._tail,this._tail.next=i;else throw new Error("Invalid list");this._tail=i,this._state++}removeItem(i){if(i===this._head&&i===this._tail)this._head=void 0,this._tail=void 0;else if(i===this._head){if(!i.next)throw new Error("Invalid list");i.next.previous=void 0,this._head=i.next}else if(i===this._tail){if(!i.previous)throw new Error("Invalid list");i.previous.next=void 0,this._tail=i.previous}else{const r=i.next,n=i.previous;if(!r||!n)throw new Error("Invalid list");r.previous=n,n.next=r}i.next=void 0,i.previous=void 0,this._state++}touch(i,r){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(r!==1&&r!==2)){if(r===1){if(i===this._head)return;const n=i.next,o=i.previous;i===this._tail?(o.next=void 0,this._tail=o):(n.previous=o,o.next=n),i.previous=void 0,i.next=this._head,this._head.previous=i,this._head=i,this._state++}else if(r===2){if(i===this._tail)return;const n=i.next,o=i.previous;i===this._head?(n.previous=void 0,this._head=n):(n.previous=o,o.next=n),i.next=void 0,i.previous=this._tail,this._tail.next=i,this._tail=i,this._state++}}}toJSON(){const i=[];return this.forEach((r,n)=>{i.push([n,r])}),i}fromJSON(i){this.clear();for(const[r,n]of i)this.set(r,n)}}e.LinkedMap=u;class d extends u{constructor(i,r=1){super();this._limit=i,this._ratio=Math.min(Math.max(0,r),1)}get limit(){return this._limit}set limit(i){this._limit=i,this.checkTrim()}get ratio(){return this._ratio}set ratio(i){this._ratio=Math.min(Math.max(0,i),1),this.checkTrim()}get(i,r=2){return super.get(i,r)}peek(i){return super.get(i,0)}set(i,r){return super.set(i,r,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=d;class p{constructor(i){A.set(this,void 0),it(this,A,i,"f")}get size(){return Be(this,A,"f").size}forEach(i,r){Be(this,A,"f").forEach(i,r)}get(i){return Be(this,A,"f").get(i)}has(i){return Be(this,A,"f").has(i)}entries(){return Be(this,A,"f").entries()}keys(){return Be(this,A,"f").keys()}values(){return Be(this,A,"f").values()}[(A=new WeakMap,Symbol.iterator)](){return Be(this,A,"f").entries()}}e.ReadonlyMapView=p}),define(ge[95],pe([0,1,23,8]),function(Q,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function k(...Y){return function(ce,me){for(let Le=0,We=Y.length;Le<We;Le++){const Ee=Y[Le](ce,me);if(Ee)return Ee}return null}}e.or=k,e.matchesStrictPrefix=D.bind(void 0,!1),e.matchesPrefix=D.bind(void 0,!0);function D(Y,ce,me){if(!me||me.length<ce.length)return null;let Le;return Y?Le=R.startsWithIgnoreCase(me,ce):Le=me.indexOf(ce)===0,Le?ce.length>0?[{start:0,end:ce.length}]:[]:null}function A(Y,ce){const me=ce.toLowerCase().indexOf(Y.toLowerCase());return me===-1?null:[{start:me,end:me+Y.length}]}e.matchesContiguousSubString=A;function P(Y,ce){return _(Y.toLowerCase(),ce.toLowerCase(),0,0)}e.matchesSubString=P;function _(Y,ce,me,Le){if(me===Y.length)return[];if(Le===ce.length)return null;if(Y[me]===ce[Le]){let We=null;return(We=_(Y,ce,me+1,Le+1))?w({start:Le,end:Le+1},We):null}return _(Y,ce,me,Le+1)}function C(Y){return 97<=Y&&Y<=122}function s(Y){return 65<=Y&&Y<=90}e.isUpper=s;function I(Y){return 48<=Y&&Y<=57}function l(Y){return Y===32||Y===9||Y===10||Y===13}const m=new Set;"`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?".split("").forEach(Y=>m.add(Y.charCodeAt(0)));function c(Y){return l(Y)||m.has(Y)}function h(Y,ce){return Y===ce||c(Y)&&c(ce)}function S(Y){return C(Y)||s(Y)||I(Y)}function w(Y,ce){return ce.length===0?ce=[Y]:Y.end===ce[0].start?ce[0].start=Y.start:ce.unshift(Y),ce}function b(Y,ce){for(let me=ce;me<Y.length;me++){const Le=Y.charCodeAt(me);if(s(Le)||I(Le)||me>0&&!S(Y.charCodeAt(me-1)))return me}return Y.length}function u(Y,ce,me,Le){if(me===Y.length)return[];if(Le===ce.length)return null;if(Y[me]!==ce[Le].toLowerCase())return null;{let We=null,Ee=Le+1;for(We=u(Y,ce,me+1,Le+1);!We&&(Ee=b(ce,Ee))<ce.length;)We=u(Y,ce,me+1,Ee),Ee++;return We===null?null:w({start:Le,end:Le+1},We)}}function d(Y){let ce=0,me=0,Le=0,We=0,Ee=0;for(let Fe=0;Fe<Y.length;Fe++)Ee=Y.charCodeAt(Fe),s(Ee)&&ce++,C(Ee)&&me++,S(Ee)&&Le++,I(Ee)&&We++;const Ke=ce/Y.length,G=me/Y.length,ie=Le/Y.length,ve=We/Y.length;return{upperPercent:Ke,lowerPercent:G,alphaPercent:ie,numericPercent:ve}}function p(Y){const{upperPercent:ce,lowerPercent:me}=Y;return me===0&&ce>.6}function t(Y){const{upperPercent:ce,lowerPercent:me,alphaPercent:Le,numericPercent:We}=Y;return me>.2&&ce<.8&&Le>.6&&We<.2}function i(Y){let ce=0,me=0,Le=0,We=0;for(let Ee=0;Ee<Y.length;Ee++)Le=Y.charCodeAt(Ee),s(Le)&&ce++,C(Le)&&me++,l(Le)&&We++;return(ce===0||me===0)&&We===0?Y.length<=30:ce<=5}function r(Y,ce){if(!ce||(ce=ce.trim(),ce.length===0)||!i(Y)||ce.length>60)return null;const me=d(ce);if(!t(me)){if(!p(me))return null;ce=ce.toLowerCase()}let Le=null,We=0;for(Y=Y.toLowerCase();We<ce.length&&(Le=u(Y,ce,0,We))===null;)We=b(ce,We+1);return Le}e.matchesCamelCase=r;function n(Y,ce,me=!1){if(!ce||ce.length===0)return null;let Le=null,We=0;for(Y=Y.toLowerCase(),ce=ce.toLowerCase();We<ce.length&&(Le=o(Y,ce,0,We,me))===null;)We=g(ce,We+1);return Le}e.matchesWords=n;function o(Y,ce,me,Le,We){if(me===Y.length)return[];if(Le===ce.length)return null;if(h(Y.charCodeAt(me),ce.charCodeAt(Le))){let Ee=null,Ke=Le+1;if(Ee=o(Y,ce,me+1,Le+1,We),!We)for(;!Ee&&(Ke=g(ce,Ke))<ce.length;)Ee=o(Y,ce,me+1,Ke,We),Ke++;return Ee===null?null:w({start:Le,end:Le+1},Ee)}else return null}function g(Y,ce){for(let me=ce;me<Y.length;me++)if(c(Y.charCodeAt(me))||me>0&&c(Y.charCodeAt(me-1)))return me;return Y.length}const f=k(e.matchesPrefix,r,A),E=k(e.matchesPrefix,r,P),y=new v.LRUCache(1e4);function a(Y,ce,me=!1){if(typeof Y!="string"||typeof ce!="string")return null;let Le=y.get(Y);Le||(Le=new RegExp(R.convertSimple2RegExpPattern(Y),"i"),y.set(Y,Le));const We=Le.exec(ce);return We?[{start:We.index,end:We.index+We[0].length}]:me?E(Y,ce):f(Y,ce)}e.matchesFuzzy=a;function L(Y,ce){const me=je(Y,Y.toLowerCase(),0,ce,ce.toLowerCase(),0,!0);return me?W(me):null}e.matchesFuzzy2=L;function O(Y,ce,me,Le,We,Ee){const Ke=Math.min(13,Y.length);for(;me<Ke;me++){const G=je(Y,ce,me,Le,We,Ee,!1);if(G)return G}return[0,Ee]}e.anyScore=O;function W(Y){if(typeof Y=="undefined")return[];const ce=[],me=Y[1];for(let Le=Y.length-1;Le>1;Le--){const We=Y[Le]+me,Ee=ce[ce.length-1];Ee&&Ee.end===We?Ee.end=We+1:ce.push({start:We,end:We+1})}return ce}e.createMatches=W;const J=128;function se(){const Y=[],ce=[];for(let me=0;me<=J;me++)ce[me]=0;for(let me=0;me<=J;me++)Y.push(ce.slice(0));return Y}function q(Y){const ce=[];for(let me=0;me<=Y;me++)ce[me]=0;return ce}const N=q(2*J),H=q(2*J),T=se(),U=se(),F=se(),M=!1;function x(Y,ce,me,Le,We){function Ee(G,ie,ve=" "){for(;G.length<ie;)G=ve+G;return G}let Ke=` |   |${Le.split("").map(G=>Ee(G,3)).join("|")}
`;for(let G=0;G<=me;G++)G===0?Ke+=" |":Ke+=`${ce[G-1]}|`,Ke+=Y[G].slice(0,We+1).map(ie=>Ee(ie.toString(),3)).join("|")+`
`;return Ke}function $(Y,ce,me,Le){Y=Y.substr(ce),me=me.substr(Le),console.log(x(U,Y,Y.length,me,me.length)),console.log(x(F,Y,Y.length,me,me.length)),console.log(x(T,Y,Y.length,me,me.length))}function X(Y,ce){if(ce<0||ce>=Y.length)return!1;const me=Y.codePointAt(ce);switch(me){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 40:case 91:return!0;case void 0:return!1;default:return!!R.isEmojiImprecise(me)}}function le(Y,ce){if(ce<0||ce>=Y.length)return!1;switch(Y.charCodeAt(ce)){case 32:case 9:return!0;default:return!1}}function be(Y,ce,me){return ce[Y]!==me[Y]}function Re(Y,ce,me,Le,We,Ee,Ke=!1){for(;ce<me&&We<Ee;)Y[ce]===Le[We]&&(Ke&&(N[ce]=We),ce+=1),We+=1;return ce===me}e.isPatternInWord=Re;var Ce;(function(Y){Y[Y.Diag=1]="Diag",Y[Y.Left=2]="Left",Y[Y.LeftLeft=3]="LeftLeft"})(Ce||(Ce={}));var Me;(function(Y){Y.Default=[-100,0];function ce(me){return!me||me.length===2&&me[0]===-100&&me[1]===0}Y.isDefault=ce})(Me=e.FuzzyScore||(e.FuzzyScore={}));function je(Y,ce,me,Le,We,Ee,Ke){const G=Y.length>J?J:Y.length,ie=Le.length>J?J:Le.length;if(me>=G||Ee>=ie||G-me>ie-Ee||!Re(ce,me,G,We,Ee,ie,!0))return;ze(G,ie,me,Ee,ce,We);let ve=1,Fe=1,Ne=me,Qe=Ee;const De=[!1];for(ve=1,Ne=me;Ne<G;ve++,Ne++){const z=N[Ne],ee=H[Ne],ue=Ne+1<G?H[Ne+1]:ie;for(Fe=z-Ee+1,Qe=z;Qe<ue;Fe++,Qe++){let Ie=Number.MIN_SAFE_INTEGER,Te=!1;Qe<=ee&&(Ie=qe(Y,ce,Ne,me,Le,We,Qe,ie,Ee,T[ve-1][Fe-1]===0,De));let xe=0;Ie!==Number.MAX_SAFE_INTEGER&&(Te=!0,xe=Ie+U[ve-1][Fe-1]);const He=Qe>z,Ze=He?U[ve][Fe-1]+(T[ve][Fe-1]>0?-5:0):0,Ye=Qe>z+1&&T[ve][Fe-1]>0,Xe=Ye?U[ve][Fe-2]+(T[ve][Fe-2]>0?-5:0):0;if(Ye&&(!He||Xe>=Ze)&&(!Te||Xe>=xe))U[ve][Fe]=Xe,F[ve][Fe]=3,T[ve][Fe]=0;else if(He&&(!Te||Ze>=xe))U[ve][Fe]=Ze,F[ve][Fe]=2,T[ve][Fe]=0;else if(Te)U[ve][Fe]=xe,F[ve][Fe]=1,T[ve][Fe]=T[ve-1][Fe-1]+1;else throw new Error("not possible")}}if(M&&$(Y,me,Le,Ee),!De[0]&&!Ke)return;ve--,Fe--;const Se=[U[ve][Fe],Ee];let Pe=0,ae=0;for(;ve>=1;){let z=Fe;do{const ee=F[ve][z];if(ee===3)z=z-2;else if(ee===2)z=z-1;else break}while(z>=1);Pe>1&&ce[me+ve-1]===We[Ee+Fe-1]&&!be(z+Ee-1,Le,We)&&Pe+1>T[ve][z]&&(z=Fe),z===Fe?Pe++:Pe=1,ae||(ae=z),ve--,Fe=z-1,Se.push(Fe)}ie===G&&(Se[0]+=2);const he=ae-G;return Se[0]-=he,Se}e.fuzzyScore=je;function ze(Y,ce,me,Le,We,Ee){let Ke=Y-1,G=ce-1;for(;Ke>=me&&G>=Le;)We[Ke]===Ee[G]&&(H[Ke]=G,Ke--),G--}function qe(Y,ce,me,Le,We,Ee,Ke,G,ie,ve,Fe){if(ce[me]!==Ee[Ke])return Number.MIN_SAFE_INTEGER;let Ne=1,Qe=!1;return Ke===me-Le?Ne=Y[me]===We[Ke]?7:5:be(Ke,We,Ee)&&(Ke===0||!be(Ke-1,We,Ee))?(Ne=Y[me]===We[Ke]?7:5,Qe=!0):X(Ee,Ke)&&(Ke===0||!X(Ee,Ke-1))?Ne=5:(X(Ee,Ke-1)||le(Ee,Ke-1))&&(Ne=5,Qe=!0),Ne>1&&me===Le&&(Fe[0]=!0),Qe||(Qe=be(Ke,We,Ee)||X(Ee,Ke-1)||le(Ee,Ke-1)),me===Le?Ke>ie&&(Ne-=Qe?3:5):ve?Ne+=Qe?2:0:Ne+=Qe?0:1,Ke+1===G&&(Ne-=Qe?3:5),Ne}function j(Y,ce,me,Le,We,Ee,Ke){return ne(Y,ce,me,Le,We,Ee,!0,Ke)}e.fuzzyScoreGracefulAggressive=j;function Z(Y,ce,me,Le,We,Ee,Ke){return ne(Y,ce,me,Le,We,Ee,!1,Ke)}e.fuzzyScoreGraceful=Z;function ne(Y,ce,me,Le,We,Ee,Ke,G){let ie=je(Y,ce,me,Le,We,Ee,G);if(ie&&!Ke)return ie;if(Y.length>=3){const ve=Math.min(7,Y.length-1);for(let Fe=me+1;Fe<ve;Fe++){const Ne=oe(Y,Fe);if(Ne){const Qe=je(Ne,Ne.toLowerCase(),me,Le,We,Ee,G);Qe&&(Qe[0]-=3,(!ie||Qe[0]>ie[0])&&(ie=Qe))}}}return ie}function oe(Y,ce){if(ce+1>=Y.length)return;const me=Y[ce],Le=Y[ce+1];if(me!==Le)return Y.slice(0,ce)+Le+me+Y.slice(ce+2)}}),define(ge[136],pe([0,1,92,95,8]),function(Q,e,v,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=e.iconStartMarker=void 0,e.iconStartMarker="$(";const D=new RegExp(`\\$\\(${v.CSSIcon.iconNameExpression}(?:${v.CSSIcon.iconModifierExpression})?\\)`,"g"),A=new RegExp(`(\\\\)?${D.source}`,"g");function P(h){return h.replace(A,(S,w)=>w?S:`\\${S}`)}e.escapeIcons=P;const _=new RegExp(`\\\\${D.source}`,"g");function C(h){return h.replace(_,S=>`\\${S}`)}e.markdownEscapeEscapedIcons=C;const s=new RegExp(`(\\s)?(\\\\)?${D.source}(\\s)?`,"g");function I(h){return h.indexOf(e.iconStartMarker)===-1?h:h.replace(s,(S,w,b,u)=>b?S:w||u||"")}e.stripIcons=I;function l(h){const S=h.indexOf(e.iconStartMarker);return S===-1?{text:h}:m(h,S)}e.parseLabelWithIcons=l;function m(h,S){const w=[];let b="";function u(g){if(g){b+=g;for(const f of g)w.push(t)}}let d=-1,p="",t=0,i,r,n=S;const o=h.length;for(u(h.substr(0,S));n<o;)i=h[n],r=h[n+1],i===e.iconStartMarker[0]&&r===e.iconStartMarker[1]?(d=n,u(p),p=e.iconStartMarker,n++):i===")"&&d!==-1?(t+=n-d+1,d=-1,p=""):d!==-1?/^[a-z0-9\-]$/i.test(i)?p+=i:(u(p),d=-1,p=""):u(i),n++;return u(p),{text:b,iconOffsets:w}}function c(h,S,w=!1){const{text:b,iconOffsets:u}=S;if(!u||u.length===0)return R.matchesFuzzy(h,b,w);const d=k.ltrim(b," "),p=b.length-d.length,t=R.matchesFuzzy(h,d,w);if(t)for(const i of t){const r=u[i.start+p]+p;i.start+=r,i.end+=r}return t}e.matchesFuzzyIconAware=c}),define(ge[96],pe([0,1,136,14]),function(Q,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var k;(function(l){l[l.Paragraph=0]="Paragraph",l[l.Break=1]="Break"})(k=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class D{constructor(m="",c=!1){var h,S;if(this.value=m,typeof this.value!="string")throw R.illegalArgument("value");typeof c=="boolean"?(this.isTrusted=c,this.supportThemeIcons=!1):(this.isTrusted=(h=c.isTrusted)!==null&&h!==void 0?h:void 0,this.supportThemeIcons=(S=c.supportThemeIcons)!==null&&S!==void 0?S:!1)}appendText(m,c=0){return this.value+=C(this.supportThemeIcons?v.escapeIcons(m):m).replace(/([ \t]+)/g,(h,S)=>"&nbsp;".repeat(S.length)).replace(/^>/gm,"\\>").replace(/\n/g,c===1?`\\
`:`

`),this}appendMarkdown(m){return this.value+=m,this}appendCodeblock(m,c){return this.value+="\n```",this.value+=m,this.value+=`
`,this.value+=c,this.value+="\n```\n",this}}e.MarkdownString=D;function A(l){return P(l)?!l.value:Array.isArray(l)?l.every(A):!0}e.isEmptyMarkdownString=A;function P(l){return l instanceof D?!0:l&&typeof l=="object"?typeof l.value=="string"&&(typeof l.isTrusted=="boolean"||l.isTrusted===void 0)&&(typeof l.supportThemeIcons=="boolean"||l.supportThemeIcons===void 0):!1}e.isMarkdownString=P;function _(l,m){return l===m?!0:!l||!m?!1:l.value===m.value&&l.isTrusted===m.isTrusted&&l.supportThemeIcons===m.supportThemeIcons}e.markdownStringEqual=_;function C(l){return l.replace(/[\\`*_{}[\]()#+\-.!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=C;function s(l){return l&&l.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=s;function I(l){const m=[],c=l.split("|").map(S=>S.trim());l=c[0];const h=c[1];if(h){const S=/height=(\d+)/.exec(h),w=/width=(\d+)/.exec(h),b=S?S[1]:"",u=w?w[1]:"",d=isFinite(parseInt(u)),p=isFinite(parseInt(b));d&&m.push(`width="${u}"`),p&&m.push(`height="${b}"`)}return{href:l,dimensions:m}}e.parseHrefAndDimensions=I}),define(ge[54],pe([0,1,22,8,2]),function(Q,e,v,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function D(C){return JSON.stringify(C,P)}e.stringify=D;function A(C){let s=JSON.parse(C);return s=_(s),s}e.parse=A;function P(C,s){return s instanceof RegExp?{$mid:2,source:s.source,flags:R.regExpFlags(s)}:s}function _(C,s=0){if(!C||s>200)return C;if(typeof C=="object"){switch(C.$mid){case 1:return k.URI.revive(C);case 2:return new RegExp(C.source,C.flags)}if(C instanceof v.VSBuffer||C instanceof Uint8Array)return C;if(Array.isArray(C))for(let I=0;I<C.length;++I)C[I]=_(C[I],s+1);else for(const I in C)Object.hasOwnProperty.call(C,I)&&(C[I]=_(C[I],s+1))}return C}e.revive=_}),define(ge[10],pe([0,1,2,11]),function(Q,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var k;(function(P){P.inMemory="inmemory",P.vscode="vscode",P.internal="private",P.walkThrough="walkThrough",P.walkThroughSnippet="walkThroughSnippet",P.http="http",P.https="https",P.file="file",P.mailto="mailto",P.untitled="untitled",P.data="data",P.command="command",P.vscodeRemote="vscode-remote",P.vscodeRemoteResource="vscode-remote-resource",P.userData="vscode-userdata",P.vscodeCustomEditor="vscode-custom-editor",P.vscodeNotebook="vscode-notebook",P.vscodeNotebookCell="vscode-notebook-cell",P.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",P.vscodeNotebookCellOutput="vscode-notebook-cell-output",P.vscodeSettings="vscode-settings",P.vscodeWorkspaceTrust="vscode-workspace-trust",P.vscodeTerminal="vscode-terminal",P.webviewPanel="webview-panel",P.vscodeWebview="vscode-webview",P.extension="extension",P.vscodeFileResource="vscode-file",P.tmp="tmp"})(k=e.Schemas||(e.Schemas={}));class D{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(_){this._preferredWebSchema=_}setDelegate(_){this._delegate=_}set(_,C,s){this._hosts[_]=C,this._ports[_]=s}setConnectionToken(_,C){this._connectionTokens[_]=C}rewrite(_){if(this._delegate)return this._delegate(_);const C=_.authority;let s=this._hosts[C];s&&s.indexOf(":")!==-1&&(s=`[${s}]`);const I=this._ports[C],l=this._connectionTokens[C];let m=`path=${encodeURIComponent(_.path)}`;return typeof l=="string"&&(m+=`&tkn=${encodeURIComponent(l)}`),v.URI.from({scheme:R.isWeb?this._preferredWebSchema:k.vscodeRemoteResource,authority:`${s}:${I}`,path:"/vscode-remote-resource",query:m})}}e.RemoteAuthorities=new D;class A{constructor(){this.FALLBACK_AUTHORITY="vscode-app"}asBrowserUri(_,C,s){const I=this.toUri(_,C);return I.scheme===k.vscodeRemote?e.RemoteAuthorities.rewrite(I):R.isNative&&(s||R.isPreferringBrowserCodeLoad)&&I.scheme===k.file?I.with({scheme:k.vscodeFileResource,authority:I.authority||this.FALLBACK_AUTHORITY,query:null,fragment:null}):I}asFileUri(_,C){const s=this.toUri(_,C);return s.scheme===k.vscodeFileResource?s.with({scheme:k.file,authority:s.authority!==this.FALLBACK_AUTHORITY?s.authority:null,query:null,fragment:null}):s}toUri(_,C){return v.URI.isUri(_)?_:v.URI.parse(C.toUrl(_))}}e.FileAccess=new A}),define(ge[74],pe([0,1,23]),function(Q,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=e.canNormalize=void 0,e.canNormalize=typeof String.prototype.normalize=="function";const R=new v.LRUCache(1e4);function k(C){return _(C,"NFC",R)}e.normalizeNFC=k;const D=new v.LRUCache(1e4);function A(C){return _(C,"NFD",D)}e.normalizeNFD=A;const P=/[^\u0000-\u0080]/;function _(C,s,I){if(!e.canNormalize||!C)return C;const l=I.get(C);if(l)return l;let m;return P.test(C)?m=C.normalize(s):m=C,I.set(C,m),m}e.removeAccents=function(){if(e.canNormalize){const C=/[\u0300-\u036f]/g;return function(s){return A(s).replace(C,"")}}else return function(C){return C}}()}),define(ge[24],pe([0,1,29,9,2,8,10,11]),function(Q,e,v,R,k,D,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function _(m){return k.uriToFsPath(m,!0)}e.originalFSPath=_;class C{constructor(c){this._ignorePathCasing=c}compare(c,h,S=!1){return c===h?0:D.compare(this.getComparisonKey(c,S),this.getComparisonKey(h,S))}isEqual(c,h,S=!1){return c===h?!0:!c||!h?!1:this.getComparisonKey(c,S)===this.getComparisonKey(h,S)}getComparisonKey(c,h=!1){return c.with({path:this._ignorePathCasing(c)?c.path.toLowerCase():void 0,fragment:h?null:void 0}).toString()}ignorePathCasing(c){return this._ignorePathCasing(c)}isEqualOrParent(c,h,S=!1){if(c.scheme===h.scheme){if(c.scheme===A.Schemas.file)return v.isEqualOrParent(_(c),_(h),this._ignorePathCasing(c))&&c.query===h.query&&(S||c.fragment===h.fragment);if(e.isEqualAuthority(c.authority,h.authority))return v.isEqualOrParent(c.path,h.path,this._ignorePathCasing(c),"/")&&c.query===h.query&&(S||c.fragment===h.fragment)}return!1}joinPath(c,...h){return k.URI.joinPath(c,...h)}basenameOrAuthority(c){return e.basename(c)||c.authority}basename(c){return R.posix.basename(c.path)}extname(c){return R.posix.extname(c.path)}dirname(c){if(c.path.length===0)return c;let h;return c.scheme===A.Schemas.file?h=k.URI.file(R.dirname(_(c))).path:(h=R.posix.dirname(c.path),c.authority&&h.length&&h.charCodeAt(0)!==47&&(console.error(`dirname("${c.toString})) resulted in a relative path`),h="/")),c.with({path:h})}normalizePath(c){if(!c.path.length)return c;let h;return c.scheme===A.Schemas.file?h=k.URI.file(R.normalize(_(c))).path:h=R.posix.normalize(c.path),c.with({path:h})}relativePath(c,h){if(c.scheme!==h.scheme||!e.isEqualAuthority(c.authority,h.authority))return;if(c.scheme===A.Schemas.file){const b=R.relative(_(c),_(h));return P.isWindows?v.toSlashes(b):b}let S=c.path||"/",w=h.path||"/";if(this._ignorePathCasing(c)){let b=0;for(const u=Math.min(S.length,w.length);b<u&&!(S.charCodeAt(b)!==w.charCodeAt(b)&&S.charAt(b).toLowerCase()!==w.charAt(b).toLowerCase());b++);S=w.substr(0,b)+S.substr(b)}return R.posix.relative(S,w)}resolvePath(c,h){if(c.scheme===A.Schemas.file){const S=k.URI.file(R.resolve(_(c),h));return c.with({authority:S.authority,path:S.path})}return h=v.toPosixPath(h),c.with({path:R.posix.resolve(c.path,h)})}isAbsolutePath(c){return!!c.path&&c.path[0]==="/"}isEqualAuthority(c,h){return c===h||D.equalsIgnoreCase(c,h)}hasTrailingPathSeparator(c,h=R.sep){if(c.scheme===A.Schemas.file){const S=_(c);return S.length>v.getRoot(S).length&&S[S.length-1]===h}else{const S=c.path;return S.length>1&&S.charCodeAt(S.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(c.fsPath)}}removeTrailingPathSeparator(c,h=R.sep){return e.hasTrailingPathSeparator(c,h)?c.with({path:c.path.substr(0,c.path.length-1)}):c}addTrailingPathSeparator(c,h=R.sep){let S=!1;if(c.scheme===A.Schemas.file){const w=_(c);S=w!==void 0&&w.length===v.getRoot(w).length&&w[w.length-1]===h}else{h="/";const w=c.path;S=w.length===1&&w.charCodeAt(w.length-1)===47}return!S&&!e.hasTrailingPathSeparator(c,h)?c.with({path:c.path+"/"}):c}}e.ExtUri=C,e.extUri=new C(()=>!1),e.extUriBiasedIgnorePathCase=new C(m=>m.scheme===A.Schemas.file?!P.isLinux:!0),e.extUriIgnorePathCase=new C(m=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function s(m,c){const h=[];for(let S=0;S<m.length;S++){const w=c(m[S]);m.some((b,u)=>u===S?!1:e.isEqualOrParent(w,c(b)))||h.push(m[S])}return h}e.distinctParents=s;var I;(function(m){m.META_DATA_LABEL="label",m.META_DATA_DESCRIPTION="description",m.META_DATA_SIZE="size",m.META_DATA_MIME="mime";function c(h){const S=new Map;h.path.substring(h.path.indexOf(";")+1,h.path.lastIndexOf(";")).split(";").forEach(u=>{const[d,p]=u.split(":");d&&p&&S.set(d,p)});const b=h.path.substring(0,h.path.indexOf(";"));return b&&S.set(m.META_DATA_MIME,b),S}m.parseMetaData=c})(I=e.DataUri||(e.DataUri={}));function l(m,c,h){if(c){let S=m.path;return S&&S[0]!==R.posix.sep&&(S=R.posix.sep+S),m.with({scheme:h,authority:c,path:S})}return m.with({scheme:h})}e.toLocalResource=l}),define(ge[16],pe([0,1,21,14,3,6,71,24]),function(Q,e,v,R,k,D,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.AsyncEmitter=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.RunOnceWorker=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.ignoreErrors=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function _(U){return!!U&&typeof U.then=="function"}e.isThenable=_;function C(U){const F=new v.CancellationTokenSource,M=U(F.token),x=new Promise(($,X)=>{F.token.onCancellationRequested(()=>{X(R.canceled())}),Promise.resolve(M).then(le=>{F.dispose(),$(le)},le=>{F.dispose(),X(le)})});return new class{cancel(){F.cancel()}then($,X){return x.then($,X)}catch($){return this.then(void 0,$)}finally($){return x.finally($)}}}e.createCancelablePromise=C;function s(U,F,M){return Promise.race([U,new Promise(x=>F.onCancellationRequested(()=>x(M)))])}e.raceCancellation=s;async function I(U){let F=-1;const M=U.map(($,X)=>$.then(le=>(F=X,le))),x=await Promise.race(M);return U.forEach(($,X)=>{X!==F&&$.cancel()}),x}e.raceCancellablePromises=I;function l(U,F,M){let x;const $=setTimeout(()=>{x==null||x(void 0),M==null||M()},F);return Promise.race([U.finally(()=>clearTimeout($)),new Promise(X=>x=X)])}e.raceTimeout=l;function m(U){return new Promise((F,M)=>{const x=U();_(x)?x.then(F,M):F(x)})}e.asPromise=m;class c{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(F){if(this.activePromise){if(this.queuedPromiseFactory=F,!this.queuedPromise){const M=()=>{this.queuedPromise=null;const x=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,x};this.queuedPromise=new Promise(x=>{this.activePromise.then(M,M).then(x)})}return new Promise((M,x)=>{this.queuedPromise.then(M,x)})}return this.activePromise=F(),new Promise((M,x)=>{this.activePromise.then($=>{this.activePromise=null,M($)},$=>{this.activePromise=null,x($)})})}}e.Throttler=c;class h{constructor(){this.current=Promise.resolve(null)}queue(F){return this.current=this.current.then(()=>F(),()=>F())}}e.Sequencer=h;class S{constructor(){this.promiseMap=new Map}queue(F,M){var x;const X=((x=this.promiseMap.get(F))!==null&&x!==void 0?x:Promise.resolve()).catch(()=>{}).then(M).finally(()=>{this.promiseMap.get(F)===X&&this.promiseMap.delete(F)});return this.promiseMap.set(F,X),X}}e.SequencerByKey=S;class w{constructor(F){this.defaultDelay=F,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(F,M=this.defaultDelay){return this.task=F,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((x,$)=>{this.doResolve=x,this.doReject=$}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const x=this.task;return this.task=null,x()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},M),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject(R.canceled()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancel()}}e.Delayer=w;class b{constructor(F){this.delayer=new w(F),this.throttler=new c}trigger(F,M){return this.delayer.trigger(()=>this.throttler.queue(F),M)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=b;class u{constructor(){this._isOpen=!1,this._promise=new Promise((F,M)=>{this._completePromise=F})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=u;class d extends u{constructor(F){super();this._timeout=setTimeout(()=>this.open(),F)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=d;function p(U,F){return F?new Promise((M,x)=>{const $=setTimeout(M,U);F.onCancellationRequested(()=>{clearTimeout($),x(R.canceled())})}):C(M=>p(U,M))}e.timeout=p;function t(U,F=0){const M=setTimeout(U,F);return D.toDisposable(()=>clearTimeout(M))}e.disposableTimeout=t;function i(U){return U.then(void 0,F=>{})}e.ignoreErrors=i;function r(U){const F=[];let M=0;const x=U.length;function $(){return M<x?U[M++]():null}function X(le){le!=null&&F.push(le);const be=$();return be?be.then(X):Promise.resolve(F)}return Promise.resolve(null).then(X)}e.sequence=r;function n(U,F=x=>!!x,M=null){let x=0;const $=U.length,X=()=>{if(x>=$)return Promise.resolve(M);const le=U[x++];return Promise.resolve(le()).then(Re=>F(Re)?Promise.resolve(Re):X())};return X()}e.first=n;function o(U,F=x=>!!x,M=null){if(U.length===0)return Promise.resolve(M);let x=U.length;const $=()=>{var X,le;x=-1;for(const be of U)(le=(X=be).cancel)===null||le===void 0||le.call(X)};return new Promise((X,le)=>{for(const be of U)be.then(Re=>{--x>=0&&F(Re)?($(),X(Re)):x===0&&X(M)}).catch(Re=>{--x>=0&&($(),le(Re))})})}e.firstParallel=o;class g{constructor(F){this._size=0,this.maxDegreeOfParalellism=F,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new k.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(F){return this._size++,new Promise((M,x)=>{this.outstandingPromises.push({factory:F,c:M,e:x}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const F=this.outstandingPromises.shift();this.runningPromises++;const M=F.factory();M.then(F.c,F.e),M.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=g;class f extends g{constructor(){super(1)}}e.Queue=f;class E{constructor(){this.queues=new Map}queueFor(F,M=P.extUri){const x=M.getComparisonKey(F);let $=this.queues.get(x);return $||($=new f,k.Event.once($.onFinished)(()=>{$==null||$.dispose(),this.queues.delete(x)}),this.queues.set(x,$)),$}dispose(){this.queues.forEach(F=>F.dispose()),this.queues.clear()}}e.ResourceQueue=E;class y{constructor(F,M){this._token=-1,typeof F=="function"&&typeof M=="number"&&this.setIfNotSet(F,M)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(F,M){this.cancel(),this._token=setTimeout(()=>{this._token=-1,F()},M)}setIfNotSet(F,M){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,F()},M))}}e.TimeoutTimer=y;class a{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(F,M){this.cancel(),this._token=setInterval(()=>{F()},M)}}e.IntervalTimer=a;class L{constructor(F,M){this.timeoutToken=-1,this.runner=F,this.timeout=M,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(F=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,F)}get delay(){return this.timeout}set delay(F){this.timeout=F}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=L;class O extends L{constructor(F,M){super(F,M);this.units=[]}work(F){this.units.push(F),this.isScheduled()||this.schedule()}doRun(){const F=this.units;this.units=[],this.runner&&this.runner(F)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=O,function(){if(typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"){const U=Object.freeze({didTimeout:!0,timeRemaining(){return 15}});e.runWhenIdle=F=>{const M=setTimeout(()=>F(U));let x=!1;return{dispose(){x||(x=!0,clearTimeout(M))}}}}else e.runWhenIdle=(U,F)=>{const M=requestIdleCallback(U,typeof F=="number"?{timeout:F}:void 0);let x=!1;return{dispose(){x||(x=!0,cancelIdleCallback(M))}}}}();class W{constructor(F){this._didRun=!1,this._executor=()=>{try{this._value=F()}catch(M){this._error=M}finally{this._didRun=!0}},this._handle=e.runWhenIdle(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}}e.IdleValue=W;async function J(U,F,M){let x;for(let $=0;$<M;$++)try{return await U()}catch(X){x=X,await p(F)}throw x}e.retry=J;class se{hasPending(F){return this._pending?typeof F=="number"?this._pending.taskId===F:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){var F;(F=this._pending)===null||F===void 0||F.cancel()}setPending(F,M,x){return this._pending={taskId:F,cancel:()=>x==null?void 0:x(),promise:M},M.then(()=>this.donePending(F),()=>this.donePending(F)),M}donePending(F){this._pending&&F===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const F=this._next;this._next=void 0,F.run().then(F.promiseResolve,F.promiseReject)}}setNext(F){if(this._next)this._next.run=F;else{let M,x;const $=new Promise((X,le)=>{M=X,x=le});this._next={run:F,promise:$,promiseResolve:M,promiseReject:x}}return this._next.promise}}e.TaskSequentializer=se;class q{constructor(F){this.interval=F,this.lastIncrementTime=0,this.value=0}increment(){const F=Date.now();return F-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=F,this.value=0),this.value++,this.value}}e.IntervalCounter=q;class N{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((F,M)=>{this.completeCallback=F,this.errorCallback=M})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(F){return new Promise(M=>{this.completeCallback(F),this.resolved=!0,M()})}error(F){return new Promise(M=>{this.errorCallback(F),this.rejected=!0,M()})}cancel(){new Promise(F=>{this.errorCallback(R.canceled()),this.rejected=!0,F()})}}e.DeferredPromise=N;class H extends k.Emitter{async fireAsync(F,M,x){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new A.LinkedList);for(const $ of this._listeners)this._asyncDeliveryQueue.push([$,F]);for(;this._asyncDeliveryQueue.size>0&&!M.isCancellationRequested;){const[$,X]=this._asyncDeliveryQueue.shift(),le=[],be=Object.assign(Object.assign({},X),{waitUntil:Re=>{if(Object.isFrozen(le))throw new Error("waitUntil can NOT be called asynchronous");x&&(Re=x(Re,typeof $=="function"?$:$[0])),le.push(Re)}});try{typeof $=="function"?$.call(void 0,be):$[0].call($[1],be)}catch(Re){R.onUnexpectedError(Re);continue}Object.freeze(le),await T.settled(le).catch(Re=>R.onUnexpectedError(Re))}}}}e.AsyncEmitter=H;var T;(function(U){async function F(X){return typeof Promise.allSettled=="function"?M(X):x(X)}U.allSettled=F;async function M(X){return Promise.allSettled(X)}async function x(X){return Promise.all(X.map(le=>le.then(be=>({status:"fulfilled",value:be}),be=>({status:"rejected",reason:be}))))}async function $(X){let le;const be=await Promise.all(X.map(Re=>Re.then(Ce=>Ce,Ce=>{le||(le=Ce)})));if(typeof le!="undefined")throw le;return be}U.settled=$})(T=e.Promises||(e.Promises={}))}),define(ge[97],pe([0,1,9,16]),function(Q,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.noIntlCompareFileNames=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const k=new R.IdleValue(()=>{const y=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:y,collatorIsNumeric:y.resolvedOptions().numeric}}),D=new R.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),A=new R.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function P(y,a,L=!1){const O=y||"",W=a||"",J=k.value.collator.compare(O,W);return k.value.collatorIsNumeric&&J===0&&O!==W?O<W?-1:1:J}e.compareFileNames=P;function _(y,a){const L=D.value.collator;return y=y||"",a=a||"",p(L,y,a)}e.compareFileNamesDefault=_;function C(y,a){const L=D.value.collator;return y=y||"",a=a||"",n(y,a)||p(L,y,a)}e.compareFileNamesUpper=C;function s(y,a){const L=D.value.collator;return y=y||"",a=a||"",r(y,a)||p(L,y,a)}e.compareFileNamesLower=s;function I(y,a){return y=y||"",a=a||"",y===a?0:y<a?-1:1}e.compareFileNamesUnicode=I;function l(y,a,L=!1){L||(y=y&&y.toLowerCase(),a=a&&a.toLowerCase());const[O,W]=u(y),[J,se]=u(a);return O!==J?O<J?-1:1:W===se?0:W<se?-1:1}e.noIntlCompareFileNames=l;function m(y,a){const[L,O]=u(y),[W,J]=u(a);let se=k.value.collator.compare(O,J);if(se===0){if(k.value.collatorIsNumeric&&O!==J)return O<J?-1:1;if(se=k.value.collator.compare(L,W),k.value.collatorIsNumeric&&se===0&&L!==W)return L<W?-1:1}return se}e.compareFileExtensions=m;function c(y,a){y=y||"",a=a||"";const L=d(y),O=d(a),W=D.value.collator,J=A.value.collator;return p(J,L,O)||p(W,y,a)}e.compareFileExtensionsDefault=c;function h(y,a){y=y||"",a=a||"";const L=d(y),O=d(a),W=D.value.collator,J=A.value.collator;return p(J,L,O)||n(y,a)||p(W,y,a)}e.compareFileExtensionsUpper=h;function S(y,a){y=y||"",a=a||"";const L=d(y),O=d(a),W=D.value.collator,J=A.value.collator;return p(J,L,O)||r(y,a)||p(W,y,a)}e.compareFileExtensionsLower=S;function w(y,a){y=y||"",a=a||"";const L=d(y).toLowerCase(),O=d(a).toLowerCase();return L!==O?L<O?-1:1:y!==a?y<a?-1:1:0}e.compareFileExtensionsUnicode=w;const b=/^(.*?)(\.([^.]*))?$/;function u(y,a=!1){const L=y?b.exec(y):[];let O=[L&&L[1]||"",L&&L[3]||""];return a&&(!O[0]&&O[1]||O[0]&&O[0].charAt(0)===".")&&(O=[O[0]+"."+O[1],""]),O}function d(y){const a=y?b.exec(y):[];return a&&a[1]&&a[1].charAt(0)!=="."&&a[3]||""}function p(y,a,L){let O=y.compare(a,L);return O!==0?O:a.length!==L.length?a.length<L.length?-1:1:0}function t(y){const a=y.charAt(0);return a.toLocaleUpperCase()!==a}function i(y){const a=y.charAt(0);return a.toLocaleLowerCase()!==a}function r(y,a){return t(y)&&i(a)?-1:i(y)&&t(a)?1:0}function n(y,a){return i(y)&&t(a)?-1:t(y)&&i(a)?1:0}function o(y,a,L=!1){return L||(y=y&&y.toLowerCase(),a=a&&a.toLowerCase()),y===a?0:y<a?-1:1}function g(y,a,L=!1){const O=y.split(v.sep),W=a.split(v.sep),J=O.length-1,se=W.length-1;let q,N;for(let H=0;;H++){if(q=J===H,N=se===H,q&&N)return P(O[H],W[H],L);if(q)return-1;if(N)return 1;const T=o(O[H],W[H],L);if(T!==0)return T}}e.comparePaths=g;function f(y,a,L){const O=y.toLowerCase(),W=a.toLowerCase(),J=E(y,a,L);if(J)return J;const se=O.endsWith(L),q=W.endsWith(L);if(se!==q)return se?-1:1;const N=P(O,W);return N!==0?N:O.localeCompare(W)}e.compareAnything=f;function E(y,a,L){const O=y.toLowerCase(),W=a.toLowerCase(),J=O.startsWith(L),se=W.startsWith(L);if(J!==se)return J?-1:1;if(J&&se){if(O.length<W.length)return-1;if(O.length>W.length)return 1}return 0}e.compareByPrefix=E}),define(ge[98],pe([0,1,97,95,9,11,8]),function(Q,e,v,R,k,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.pieceToQuery=e.prepareQuery=e.compareItemsByFuzzyScore=e.scoreItemFuzzy=e.scoreFuzzy2=e.scoreFuzzy=void 0;const P=0,_=[P,[]];function C(q,N,H,T){if(!q||!N)return _;const U=q.length,F=N.length;if(U<F)return _;const M=q.toLowerCase();return!T&&!M.includes(H)?_:s(N,H,F,q,M,U)}e.scoreFuzzy=C;function s(q,N,H,T,U,F){const M=[],x=[];for(let be=0;be<H;be++){const Re=be*F,Ce=Re-F,Me=be>0,je=q[be],ze=N[be];for(let qe=0;qe<F;qe++){const j=qe>0,Z=Re+qe,ne=Z-1,oe=Ce+qe-1,Y=j?M[ne]:0,ce=Me&&j?M[oe]:0,me=Me&&j?x[oe]:0;let Le;!ce&&Me?Le=0:Le=I(je,ze,T,U,qe,me),Le&&ce+Le>=Y?(x[Z]=me+1,M[Z]=ce+Le):(x[Z]=P,M[Z]=Y)}}const $=[];let X=H-1,le=F-1;for(;X>=0&&le>=0;){const be=X*F+le;x[be]===P||($.push(le),X--),le--}return[M[H*F-1],$.reverse()]}function I(q,N,H,T,U,F){let M=0;if(!l(N,T[U]))return M;if(M+=1,F>0&&(M+=F*5),q===H[U]&&(M+=1),U===0)M+=8;else{const x=m(H.charCodeAt(U-1));x?M+=x:R.isUpper(H.charCodeAt(U))&&(M+=2)}return M}function l(q,N){return q===N?!0:q==="/"||q==="\\"?N==="/"||N==="\\":!1}function m(q){switch(q){case 47:case 92:return 5;case 95:case 45:case 46:case 32:case 39:case 34:case 58:return 4;default:return 0}}const c=[void 0,[]];function h(q,N,H=0,T=0){const U=N;return U.values&&U.values.length>1?S(q,U.values,H,T):w(q,N,H,T)}e.scoreFuzzy2=h;function S(q,N,H,T){let U=0;const F=[];for(const M of N){const[x,$]=w(q,M,H,T);if(typeof x!="number")return c;U+=x,F.push(...$)}return[U,g(F)]}function w(q,N,H,T){const U=R.fuzzyScore(N.original,N.originalLowercase,H,q,q.toLowerCase(),T,!0);return U?[U[0],R.createMatches(U)]:c}const b=Object.freeze({score:0}),u=1<<18,d=1<<17,p=1<<16;function t(q,N,H,T,U){if(!q||!N.normalized)return b;const F=T.getItemLabel(q);if(!F)return b;const M=T.getItemDescription(q);let x;M?x=`${F}${M}${N.normalized}${Array.isArray(N.values)?N.values.length:""}${H}`:x=`${F}${N.normalized}${Array.isArray(N.values)?N.values.length:""}${H}`;const $=U[x];if($)return $;const X=i(F,M,T.getItemPath(q),N,H);return U[x]=X,X}e.scoreItemFuzzy=t;function i(q,N,H,T,U){const F=!H||!T.containsPathSeparator;return H&&(D.isLinux?T.pathNormalized===H:A.equalsIgnoreCase(T.pathNormalized,H))?{score:u,labelMatch:[{start:0,end:q.length}],descriptionMatch:N?[{start:0,end:N.length}]:void 0}:T.values&&T.values.length>1?r(q,N,H,T.values,F,U):n(q,N,H,T,F,U)}function r(q,N,H,T,U,F){let M=0;const x=[],$=[];for(const X of T){const{score:le,labelMatch:be,descriptionMatch:Re}=n(q,N,H,X,U,F);if(le===P)return b;M+=le,be&&x.push(...be),Re&&$.push(...Re)}return{score:M,labelMatch:g(x),descriptionMatch:g($)}}function n(q,N,H,T,U,F){if(U||!N){const[M,x]=C(q,T.normalized,T.normalizedLowercase,F);if(M){const $=R.matchesPrefix(T.normalized,q);let X;return $?(X=d,X+=Math.round(T.normalized.length/q.length*100)):X=p,{score:X+M,labelMatch:$||o(x)}}}if(N){let M=N;H&&(M=`${N}${k.sep}`);const x=M.length,$=`${M}${q}`,[X,le]=C($,T.normalized,T.normalizedLowercase,F);if(X){const be=o(le),Re=[],Ce=[];return be.forEach(Me=>{Me.start<x&&Me.end>x?(Re.push({start:0,end:Me.end-x}),Ce.push({start:Me.start,end:x})):Me.start>=x?Re.push({start:Me.start-x,end:Me.end-x}):Ce.push(Me)}),{score:X,labelMatch:Re,descriptionMatch:Ce}}}return b}function o(q){const N=[];if(!q)return N;let H;for(const T of q)H&&H.end===T?H.end+=1:(H={start:T,end:T+1},N.push(H));return N}function g(q){const N=q.sort((U,F)=>U.start-F.start),H=[];let T;for(const U of N)!T||!f(T,U)?(T=U,H.push(U)):(T.start=Math.min(T.start,U.start),T.end=Math.max(T.end,U.end));return H}function f(q,N){return!(q.end<N.start||N.end<q.start)}function E(q,N,H,T,U,F){const M=t(q,H,T,U,F),x=t(N,H,T,U,F),$=M.score,X=x.score;if(($===u||X===u)&&$!==X)return $===u?-1:1;if($>p||X>p){if($!==X)return $>X?-1:1;if($<d&&X<d){const ze=a(M.labelMatch,x.labelMatch);if(ze!==0)return ze}const Me=U.getItemLabel(q)||"",je=U.getItemLabel(N)||"";if(Me.length!==je.length)return Me.length-je.length}if($!==X)return $>X?-1:1;const le=Array.isArray(M.labelMatch)&&M.labelMatch.length>0,be=Array.isArray(x.labelMatch)&&x.labelMatch.length>0;if(le&&!be)return-1;if(be&&!le)return 1;const Re=y(q,M,U),Ce=y(N,x,U);return Re&&Ce&&Re!==Ce?Ce>Re?-1:1:L(q,N,H,U)}e.compareItemsByFuzzyScore=E;function y(q,N,H){let T=-1,U=-1;if(N.descriptionMatch&&N.descriptionMatch.length?T=N.descriptionMatch[0].start:N.labelMatch&&N.labelMatch.length&&(T=N.labelMatch[0].start),N.labelMatch&&N.labelMatch.length){if(U=N.labelMatch[N.labelMatch.length-1].end,N.descriptionMatch&&N.descriptionMatch.length){const F=H.getItemDescription(q);F&&(U+=F.length)}}else N.descriptionMatch&&N.descriptionMatch.length&&(U=N.descriptionMatch[N.descriptionMatch.length-1].end);return U-T}function a(q,N){if(!q&&!N||(!q||!q.length)&&(!N||!N.length))return 0;if(!N||!N.length)return-1;if(!q||!q.length)return 1;const H=q[0].start,U=q[q.length-1].end-H,F=N[0].start,x=N[N.length-1].end-F;return U===x?0:x<U?1:-1}function L(q,N,H,T){const U=T.getItemLabel(q)||"",F=T.getItemLabel(N)||"",M=T.getItemDescription(q),x=T.getItemDescription(N),$=U.length+(M?M.length:0),X=F.length+(x?x.length:0);if($!==X)return $-X;const le=T.getItemPath(q),be=T.getItemPath(N);return le&&be&&le.length!==be.length?le.length-be.length:U!==F?v.compareAnything(U,F,H.normalized):M&&x&&M!==x?v.compareAnything(M,x,H.normalized):le&&be&&le!==be?v.compareAnything(le,be,H.normalized):0}const O=" ";function W(q){typeof q!="string"&&(q="");const N=q.toLowerCase(),{pathNormalized:H,normalized:T,normalizedLowercase:U}=J(q),F=H.indexOf(k.sep)>=0;let M;const x=q.split(O);if(x.length>1)for(const $ of x){const{pathNormalized:X,normalized:le,normalizedLowercase:be}=J($);le&&(M||(M=[]),M.push({original:$,originalLowercase:$.toLowerCase(),pathNormalized:X,normalized:le,normalizedLowercase:be}))}return{original:q,originalLowercase:N,pathNormalized:H,normalized:T,normalizedLowercase:U,values:M,containsPathSeparator:F}}e.prepareQuery=W;function J(q){let N;D.isWindows?N=q.replace(/\//g,k.sep):N=q.replace(/\\/g,k.sep);const H=A.stripWildcards(N).replace(/\s/g,"");return{pathNormalized:N,normalized:H,normalizedLowercase:H.toLowerCase()}}function se(q){return Array.isArray(q)?W(q.map(N=>N.original).join(O)):W(q.original)}e.pieceToQuery=se}),define(ge[30],pe([0,1,8,29,9,23,16]),function(Q,e,v,R,k,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function P(){return Object.create(null)}e.getEmptyExpression=P;const _="**",C="/",s="[/\\\\]",I="[^/\\\\]",l=/\//g;function m(M){switch(M){case 0:return"";case 1:return`${I}*?`;default:return`(?:${s}|${I}+${s}|${s}${I}+)*?`}}function c(M,x){if(!M)return[];const $=[];let X=!1,le=!1,be="";for(const Re of M){switch(Re){case x:if(!X&&!le){$.push(be),be="";continue}break;case"{":X=!0;break;case"}":X=!1;break;case"[":le=!0;break;case"]":le=!1;break}be+=Re}return be&&$.push(be),$}e.splitGlobAware=c;function h(M){if(!M)return"";let x="";const $=c(M,C);if($.every(X=>X===_))x=".*";else{let X=!1;$.forEach((le,be)=>{if(le===_){X||(x+=m(2),X=!0);return}let Re=!1,Ce="",Me=!1,je="";for(const ze of le){if(ze!=="}"&&Re){Ce+=ze;continue}if(Me&&(ze!=="]"||!je)){let qe;ze==="-"?qe=ze:(ze==="^"||ze==="!")&&!je?qe="^":ze===C?qe="":qe=v.escapeRegExpCharacters(ze),je+=qe;continue}switch(ze){case"{":Re=!0;continue;case"[":Me=!0;continue;case"}":x+=`(?:${c(Ce,",").map(Z=>h(Z)).join("|")})`,Re=!1,Ce="";break;case"]":x+="["+je+"]",Me=!1,je="";break;case"?":x+=I;continue;case"*":x+=m(1);continue;default:x+=v.escapeRegExpCharacters(ze)}}be<$.length-1&&($[be+1]!==_||be+2<$.length)&&(x+=s),X=!1})}return x}const S=/^\*\*\/\*\.[\w\.-]+$/,w=/^\*\*\/([\w\.-]+)\/?$/,b=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,u=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,d=/^\*\*((\/[\w\.-]+)+)\/?$/,p=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new D.LRUCache(1e4),i=function(){return!1},r=function(){return null};function n(M,x){if(!M)return r;let $;typeof M!="string"?$=M.pattern:$=M,$=$.trim();const X=`${$}_${!!x.trimForExclusions}`;let le=t.get(X);if(le)return o(le,M);let be;if(S.test($)){const Re=$.substr(4);le=function(Ce,Me){return typeof Ce=="string"&&Ce.endsWith(Re)?$:null}}else(be=w.exec(g($,x)))?le=f(be[1],$):(x.trimForExclusions?u:b).test($)?le=E($,x):(be=d.exec(g($,x)))?le=y(be[1].substr(1),$,!0):(be=p.exec(g($,x)))?le=y(be[1],$,!1):le=a($);return t.set(X,le),o(le,M)}function o(M,x){return typeof x=="string"?M:function($,X){return R.isEqualOrParent($,x.base)?M(k.relative(x.base,$),X):null}}function g(M,x){return x.trimForExclusions&&M.endsWith("/**")?M.substr(0,M.length-2):M}function f(M,x){const $=`/${M}`,X=`\\${M}`,le=function(Re,Ce){return typeof Re!="string"?null:Ce?Ce===M?x:null:Re===M||Re.endsWith($)||Re.endsWith(X)?x:null},be=[M];return le.basenames=be,le.patterns=[x],le.allBasenames=be,le}function E(M,x){const $=F(M.slice(1,-1).split(",").map(Ce=>n(Ce,x)).filter(Ce=>Ce!==r),M),X=$.length;if(!X)return r;if(X===1)return $[0];const le=function(Ce,Me){for(let je=0,ze=$.length;je<ze;je++)if($[je](Ce,Me))return M;return null},be=$.find(Ce=>!!Ce.allBasenames);be&&(le.allBasenames=be.allBasenames);const Re=$.reduce((Ce,Me)=>Me.allPaths?Ce.concat(Me.allPaths):Ce,[]);return Re.length&&(le.allPaths=Re),le}function y(M,x,$){const X=k.sep===k.posix.sep,le=X?M:M.replace(l,k.sep),be=k.sep+le,Re=k.posix.sep+M,Ce=$?function(Me,je){return typeof Me=="string"&&(Me===le||Me.endsWith(be)||!X&&(Me===M||Me.endsWith(Re)))?x:null}:function(Me,je){return typeof Me=="string"&&(Me===le||!X&&Me===M)?x:null};return Ce.allPaths=[($?"*/":"./")+M],Ce}function a(M){try{const x=new RegExp(`^${h(M)}$`);return function($){return x.lastIndex=0,typeof $=="string"&&x.test($)?M:null}}catch(x){return r}}function L(M,x,$){return!M||typeof x!="string"?!1:O(M)(x,void 0,$)}e.match=L;function O(M,x={}){if(!M)return i;if(typeof M=="string"||q(M)){const $=n(M,x);if($===r)return i;const X=function(le,be){return!!$(le,be)};return $.allBasenames&&(X.allBasenames=$.allBasenames),$.allPaths&&(X.allPaths=$.allPaths),X}return T(M,x)}e.parse=O;function W(M){if(!M)return;let x;return $=>(x||(x=(M()||Promise.resolve([])).then(X=>X?se(X):{})),x.then(X=>!!X[$]))}e.hasSiblingPromiseFn=W;function J(M){if(!M)return;let x;return $=>{if(!x){const X=M();x=X?se(X):{}}return!!x[$]}}e.hasSiblingFn=J;function se(M){const x={};for(const $ of M)x[$]=!0;return x}function q(M){const x=M;return x&&typeof x.base=="string"&&typeof x.pattern=="string"}e.isRelativePattern=q;function N(M){return M.allBasenames||[]}e.getBasenameTerms=N;function H(M){return M.allPaths||[]}e.getPathTerms=H;function T(M,x){const $=F(Object.getOwnPropertyNames(M).map(Ce=>U(Ce,M[Ce],x)).filter(Ce=>Ce!==r)),X=$.length;if(!X)return r;if(!$.some(Ce=>!!Ce.requiresSiblings)){if(X===1)return $[0];const Ce=function(ze,qe){for(let j=0,Z=$.length;j<Z;j++){const ne=$[j](ze,qe);if(ne)return ne}return null},Me=$.find(ze=>!!ze.allBasenames);Me&&(Ce.allBasenames=Me.allBasenames);const je=$.reduce((ze,qe)=>qe.allPaths?ze.concat(qe.allPaths):ze,[]);return je.length&&(Ce.allPaths=je),Ce}const le=function(Ce,Me,je){let ze;for(let qe=0,j=$.length;qe<j;qe++){const Z=$[qe];Z.requiresSiblings&&je&&(Me||(Me=k.basename(Ce)),ze||(ze=Me.substr(0,Me.length-k.extname(Ce).length)));const ne=Z(Ce,Me,ze,je);if(ne)return ne}return null},be=$.find(Ce=>!!Ce.allBasenames);be&&(le.allBasenames=be.allBasenames);const Re=$.reduce((Ce,Me)=>Me.allPaths?Ce.concat(Me.allPaths):Ce,[]);return Re.length&&(le.allPaths=Re),le}function U(M,x,$){if(x===!1)return r;const X=n(M,$);if(X===r)return r;if(typeof x=="boolean")return X;if(x){const le=x.when;if(typeof le=="string"){const be=(Re,Ce,Me,je)=>{if(!je||!X(Re,Ce))return null;const ze=le.replace("$(basename)",Me),qe=je(ze);return A.isThenable(qe)?qe.then(j=>j?M:null):qe?M:null};return be.requiresSiblings=!0,be}}return X}function F(M,x){const $=M.filter(Ce=>!!Ce.basenames);if($.length<2)return M;const X=$.reduce((Ce,Me)=>{const je=Me.basenames;return je?Ce.concat(je):Ce},[]);let le;if(x){le=[];for(let Ce=0,Me=X.length;Ce<Me;Ce++)le.push(x)}else le=$.reduce((Ce,Me)=>{const je=Me.patterns;return je?Ce.concat(je):Ce},[]);const be=function(Ce,Me){if(typeof Ce!="string")return null;if(!Me){let ze;for(ze=Ce.length;ze>0;ze--){const qe=Ce.charCodeAt(ze-1);if(qe===47||qe===92)break}Me=Ce.substr(ze)}const je=X.indexOf(Me);return je!==-1?le[je]:null};be.basenames=X,be.patterns=le,be.allBasenames=X;const Re=M.filter(Ce=>!Ce.basenames);return Re.push(be),Re}}),define(ge[75],pe([0,1,2,9,8,10,11,24,29]),function(Q,e,v,R,k,D,A,P,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function C(n,o,g){if(typeof n=="string"&&(n=v.URI.file(n)),g){const E=g.getWorkspaceFolder(n);if(E){const y=g.getWorkspace().folders.length>1;let a;if(P.isEqual(E.uri,n)?a="":a=P.relativePath(E.uri,n),y){const L=E.name?E.name:P.basename(E.uri);a=a?L+" \u2022 "+a:L}return a}}if(n.scheme!==D.Schemas.file&&n.scheme!==D.Schemas.untitled)return n.with({query:null,fragment:null}).toString(!0);if(_.hasDriveLetter(n.fsPath))return R.normalize(I(n.fsPath));let f=R.normalize(n.fsPath);return!A.isWindows&&(o==null?void 0:o.userHome)&&(f=m(f,o.userHome.fsPath)),f}e.getPathLabel=C;function s(n){if(!n)return;typeof n=="string"&&(n=v.URI.file(n));const o=P.basename(n)||(n.scheme===D.Schemas.file?n.fsPath:n.path);return A.isWindows&&_.isRootOrDriveLetter(o)?I(o):o}e.getBaseLabel=s;function I(n){return _.hasDriveLetter(n)?n.charAt(0).toUpperCase()+n.slice(1):n}e.normalizeDriveLetter=I;let l=Object.create(null);function m(n,o){if(A.isWindows||!n||!o)return n;let g=l.original===o?l.normalized:void 0;return g||(g=`${k.rtrim(o,R.posix.sep)}${R.posix.sep}`,l={original:o,normalized:g}),(A.isLinux?n.startsWith(g):k.startsWithIgnoreCase(n,g))&&(n=`~/${n.substr(g.length)}`),n}e.tildify=m;function c(n,o){return n.replace(/^~($|\/|\\)/,`${o}$1`)}e.untildify=c;const h="\u2026",S="\\\\",w="~";function b(n,o=R.sep){const g=new Array(n.length);let f=!1;for(let E=0;E<n.length;E++){let y=n[E];if(y===""){g[E]=`.${o}`;continue}if(!y){g[E]=y;continue}f=!0;let a="";y.indexOf(S)===0?(a=y.substr(0,y.indexOf(S)+S.length),y=y.substr(y.indexOf(S)+S.length)):y.indexOf(o)===0?(a=y.substr(0,y.indexOf(o)+o.length),y=y.substr(y.indexOf(o)+o.length)):y.indexOf(w)===0&&(a=y.substr(0,y.indexOf(w)+w.length),y=y.substr(y.indexOf(w)+w.length));const L=y.split(o);for(let O=1;f&&O<=L.length;O++)for(let W=L.length-O;f&&W>=0;W--){f=!1;let J=L.slice(W,W+O).join(o);for(let se=0;!f&&se<n.length;se++)if(se!==E&&n[se]&&n[se].indexOf(J)>-1){const q=W+O===L.length,N=W>0&&n[se].indexOf(o)>-1?o+J:J,H=n[se].endsWith(N);f=!q||H}if(!f){let se="";(L[0].endsWith(":")||a!=="")&&(W===1&&(W=0,O++,J=L[0]+o+J),W>0&&(se=L[0]+o),se=a+se),W>0&&(se=se+h+o),se=se+J,W+O<L.length&&(se=se+o+h),g[E]=se}}f&&(g[E]=y)}return g}e.shorten=b;var u;(function(n){n[n.TEXT=0]="TEXT",n[n.VARIABLE=1]="VARIABLE",n[n.SEPARATOR=2]="SEPARATOR"})(u||(u={}));function d(n,o=Object.create(null)){const g=[];let f=!1,E="";for(const y of n)if(y==="$"||f&&y==="{")E&&g.push({value:E,type:u.TEXT}),E="",f=!0;else if(y==="}"&&f){const a=o[E];if(typeof a=="string")a.length&&g.push({value:a,type:u.VARIABLE});else if(a){const L=g[g.length-1];(!L||L.type!==u.SEPARATOR)&&g.push({value:a.label,type:u.SEPARATOR})}E="",f=!1}else E+=y;return E&&!f&&g.push({value:E,type:u.TEXT}),g.filter((y,a)=>{if(y.type===u.SEPARATOR){const L=g[a-1],O=g[a+1];return[L,O].every(W=>W&&(W.type===u.VARIABLE||W.type===u.TEXT)&&W.value.length>0)}return!0}).map(y=>y.value).join("")}e.template=d;function p(n,o){return A.isMacintosh||o?n.replace(/\(&&\w\)|&&/g,"").replace(/&/g,A.isMacintosh?"&":"&&"):n.replace(/&&|&/g,g=>g==="&"?"&&":"&")}e.mnemonicMenuLabel=p;function t(n,o){return A.isMacintosh||o?n.replace(/\(&&\w\)|&&/g,""):A.isWindows?n.replace(/&&|&/g,g=>g==="&"?"&&":"&"):n.replace(/&&/g,"_")}e.mnemonicButtonLabel=t;function i(n){return n.replace(/&/g,"&&")}e.unmnemonicLabel=i;function r(n){const o=n.indexOf("/")!==-1?R.posix:R.win32,g=o.basename(n),f=o.dirname(n);return g.length?{name:g,parentPath:f}:{name:f,parentPath:""}}e.splitName=r}),define(ge[99],pe([0,1,9,8,30,10,24]),function(Q,e,v,R,k,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.isUnspecific=e.guessMimeTypes=e.clearTextMimes=e.registerTextMime=e.Mimes=void 0;var P;(function(i){i.text="text/plain",i.binary="application/octet-stream",i.unknown="application/unknown",i.markdown="text/markdown"})(P=e.Mimes||(e.Mimes={}));let _=[],C=[],s=[];function I(i,r=!1){const n=l(i);_.push(n),n.userConfigured?s.push(n):C.push(n),r&&!n.userConfigured&&_.forEach(o=>{o.mime===n.mime||o.userConfigured||(n.extension&&o.extension===n.extension&&console.warn(`Overwriting extension <<${n.extension}>> to now point to mime <<${n.mime}>>`),n.filename&&o.filename===n.filename&&console.warn(`Overwriting filename <<${n.filename}>> to now point to mime <<${n.mime}>>`),n.filepattern&&o.filepattern===n.filepattern&&console.warn(`Overwriting filepattern <<${n.filepattern}>> to now point to mime <<${n.mime}>>`),n.firstline&&o.firstline===n.firstline&&console.warn(`Overwriting firstline <<${n.firstline}>> to now point to mime <<${n.mime}>>`))})}e.registerTextMime=I;function l(i){return{id:i.id,mime:i.mime,filename:i.filename,extension:i.extension,filepattern:i.filepattern,firstline:i.firstline,userConfigured:i.userConfigured,filenameLowercase:i.filename?i.filename.toLowerCase():void 0,extensionLowercase:i.extension?i.extension.toLowerCase():void 0,filepatternLowercase:i.filepattern?i.filepattern.toLowerCase():void 0,filepatternOnPath:i.filepattern?i.filepattern.indexOf(v.posix.sep)>=0:!1}}function m(i){i?(_=_.filter(r=>!r.userConfigured),s=[]):(_=[],C=[],s=[])}e.clearTextMimes=m;function c(i,r){let n;if(i)switch(i.scheme){case D.Schemas.file:n=i.fsPath;break;case D.Schemas.data:n=A.DataUri.parseMetaData(i).get(A.DataUri.META_DATA_LABEL);break;default:n=i.path}if(!n)return[P.unknown];n=n.toLowerCase();const o=v.basename(n),g=h(n,o,s);if(g)return[g,P.text];const f=h(n,o,C);if(f)return[f,P.text];if(r){const E=S(r);if(E)return[E,P.text]}return[P.unknown]}e.guessMimeTypes=c;function h(i,r,n){let o=null,g=null,f=null;for(let E=n.length-1;E>=0;E--){const y=n[E];if(r===y.filenameLowercase){o=y;break}if(y.filepattern&&(!g||y.filepattern.length>g.filepattern.length)){const a=y.filepatternOnPath?i:r;k.match(y.filepatternLowercase,a)&&(g=y)}y.extension&&(!f||y.extension.length>f.extension.length)&&r.endsWith(y.extensionLowercase)&&(f=y)}return o?o.mime:g?g.mime:f?f.mime:null}function S(i){if(R.startsWithUTF8BOM(i)&&(i=i.substr(1)),i.length>0)for(let r=_.length-1;r>=0;r--){const n=_[r];if(!n.firstline)continue;const o=i.match(n.firstline);if(o&&o.length>0)return n.mime}return null}function w(i){return i?typeof i=="string"?i===P.binary||i===P.text||i===P.unknown:i.length===1&&w(i[0]):!0}e.isUnspecific=w;const b={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function u(i){const r=v.extname(i);return b[r.toLowerCase()]}e.getMediaMime=u;function d(i){for(const r in b)if(b[r]===i)return r}e.getExtensionForMimeType=d;const p=/^(.+)\/(.+?)(;.+)?$/;function t(i,r){var n;const o=p.exec(i);return o?`${o[1].toLowerCase()}/${o[2].toLowerCase()}${(n=o[3])!==null&&n!==void 0?n:""}`:r?void 0:i}e.normalizeMimeType=t}),define(ge[100],pe([0,1,2]),function(Q,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function R(s){return s.toJSON()}class k{constructor(I){this._uriTransformer=I}transformIncoming(I){const l=this._uriTransformer.transformIncoming(I);return l===I?I:R(v.URI.from(l))}transformOutgoing(I){const l=this._uriTransformer.transformOutgoing(I);return l===I?I:R(v.URI.from(l))}transformOutgoingURI(I){const l=this._uriTransformer.transformOutgoing(I);return l===I?I:v.URI.from(l)}transformOutgoingScheme(I){return this._uriTransformer.transformOutgoingScheme(I)}}e.URITransformer=k,e.DefaultURITransformer=new class{transformIncoming(s){return s}transformOutgoing(s){return s}transformOutgoingURI(s){return s}transformOutgoingScheme(s){return s}};function D(s,I,l){if(!s||l>200)return null;if(typeof s=="object"){if(s instanceof v.URI)return I.transformOutgoing(s);for(let m in s)if(Object.hasOwnProperty.call(s,m)){const c=D(s[m],I,l+1);c!==null&&(s[m]=c)}}return null}function A(s,I){const l=D(s,I,0);return l===null?s:l}e.transformOutgoingURIs=A;function P(s,I,l,m){if(!s||m>200)return null;if(typeof s=="object"){if(s.$mid===1)return l?v.URI.revive(I.transformIncoming(s)):I.transformIncoming(s);for(let c in s)if(Object.hasOwnProperty.call(s,c)){const h=P(s[c],I,l,m+1);h!==null&&(s[c]=h)}}return null}function _(s,I){const l=P(s,I,!1,0);return l===null?s:l}e.transformIncomingURIs=_;function C(s,I){const l=P(s,I,!0,0);return l===null?s:l}e.transformAndReviveIncomingURIs=C}),define(ge[32],pe([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const v=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function R(_){return v.test(_)}e.isUUID=R;const k=new Uint8Array(16),D=[];for(let _=0;_<256;_++)D.push(_.toString(16).padStart(2,"0"));let A;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?A=crypto.getRandomValues.bind(crypto):A=function(_){for(let C=0;C<_.length;C++)_[C]=Math.floor(Math.random()*256);return _};function P(){A(k),k[6]=k[6]&15|64,k[8]=k[8]&63|128;let _=0,C="";return C+=D[k[_++]],C+=D[k[_++]],C+=D[k[_++]],C+=D[k[_++]],C+="-",C+=D[k[_++]],C+=D[k[_++]],C+="-",C+=D[k[_++]],C+=D[k[_++]],C+="-",C+=D[k[_++]],C+=D[k[_++]],C+="-",C+=D[k[_++]],C+=D[k[_++]],C+=D[k[_++]],C+=D[k[_++]],C+=D[k[_++]],C+=D[k[_++]],C}e.generateUuid=P}),define(ge[137],pe([0,1,101]),function(Q,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class R{constructor(D="utf8"){this.stringDecoder=new v.StringDecoder(D),this.remaining=null}write(D){const A=[],P=this.remaining?this.remaining+this.stringDecoder.write(D):this.stringDecoder.write(D);if(P.length<1)return A;let _=0,C,s=_;for(;s<P.length;)if(C=P.charCodeAt(s),C===13||C===10){if(A.push(P.substring(_,s)),s++,s<P.length){const I=C;C=P.charCodeAt(s),(I===13&&C===10||I===10&&C===13)&&s++}_=s}else s++;return this.remaining=_<P.length?P.substr(_):null,A}end(){return this.remaining}}e.LineDecoder=R}),define(ge[28],pe([0,1,55,102,276,9,16,11,29,32,74,24,2]),function(Q,e,v,R,k,D,A,P,_,C,s,I,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var m;(function(N){N[N.UNLINK=0]="UNLINK",N[N.MOVE=1]="MOVE"})(m=e.RimRafMode||(e.RimRafMode={}));async function c(N,H=m.UNLINK){if(_.isRootOrDriveLetter(N))throw new Error("rimraf - will refuse to recursively delete root");return H===m.UNLINK?S(N):h(N)}async function h(N){try{const H=D.join(R.tmpdir(),C.generateUuid());try{await e.Promises.rename(N,H)}catch(T){return S(N)}S(H).catch(T=>{})}catch(H){if(H.code!=="ENOENT")throw H}}async function S(N){return e.Promises.rmdir(N,{recursive:!0,maxRetries:3})}function w(N){if(_.isRootOrDriveLetter(N))throw new Error("rimraf - will refuse to recursively delete root");v.rmdirSync(N,{recursive:!0})}e.rimrafSync=w;async function b(N,H){return p(await(H?u(N):k.promisify(v.readdir)(N)))}async function u(N){try{return await k.promisify(v.readdir)(N,{withFileTypes:!0})}catch(U){console.warn("[node.js fs] readdir with filetypes failed with error: ",U)}const H=[],T=await b(N);for(const U of T){let F=!1,M=!1,x=!1;try{const $=await e.Promises.lstat(D.join(N,U));F=$.isFile(),M=$.isDirectory(),x=$.isSymbolicLink()}catch($){console.warn("[node.js fs] unexpected error from lstat after readdir: ",$)}H.push({name:U,isFile:()=>F,isDirectory:()=>M,isSymbolicLink:()=>x})}return H}function d(N){return p(v.readdirSync(N))}e.readdirSync=d;function p(N){return N.map(H=>typeof H=="string"?P.isMacintosh?s.normalizeNFC(H):H:(H.name=P.isMacintosh?s.normalizeNFC(H.name):H.name,H))}async function t(N){const H=await b(N),T=[];for(const U of H)await r.existsDirectory(D.join(N,U))&&T.push(U);return T}function i(N,H=1e3){return new Promise(T=>{let U=!1;const F=setInterval(()=>{U||(U=!0,v.access(N,M=>{U=!1,M&&(clearInterval(F),T(void 0))}))},H)})}e.whenDeleted=i;var r;(function(N){async function H(F){let M;try{if(M=await e.Promises.lstat(F),!M.isSymbolicLink())return{stat:M}}catch(x){}try{return{stat:await e.Promises.stat(F),symbolicLink:(M==null?void 0:M.isSymbolicLink())?{dangling:!1}:void 0}}catch(x){if(x.code==="ENOENT"&&M)return{stat:M,symbolicLink:{dangling:!0}};if(P.isWindows&&x.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(F)),symbolicLink:{dangling:!1}}}catch($){if($.code==="ENOENT"&&M)return{stat:M,symbolicLink:{dangling:!0}};throw $}throw x}}N.stat=H;async function T(F){try{const{stat:M,symbolicLink:x}=await N.stat(F);return M.isFile()&&(x==null?void 0:x.dangling)!==!0}catch(M){}return!1}N.existsFile=T;async function U(F){try{const{stat:M,symbolicLink:x}=await N.stat(F);return M.isDirectory()&&(x==null?void 0:x.dangling)!==!0}catch(M){}return!1}N.existsDirectory=U})(r=e.SymlinkSupport||(e.SymlinkSupport={}));const n=new A.ResourceQueue;function o(N,H,T){return n.queueFor(l.URI.file(N),I.extUriBiasedIgnorePathCase).queue(()=>{const U=y(T);return new Promise((F,M)=>f(N,H,U,x=>x?M(x):F()))})}let g=!0;function f(N,H,T,U){if(!g)return v.writeFile(N,H,{mode:T.mode,flag:T.flag},U);v.open(N,T.flag,T.mode,(F,M)=>{if(F)return U(F);v.writeFile(M,H,x=>{if(x)return v.close(M,()=>U(x));v.fdatasync(M,$=>($&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",$),g=!1),v.close(M,X=>U(X))))})})}function E(N,H,T){const U=y(T);if(!g)return v.writeFileSync(N,H,{mode:U.mode,flag:U.flag});const F=v.openSync(N,U.flag,U.mode);try{v.writeFileSync(F,H);try{v.fdatasyncSync(F)}catch(M){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",M),g=!1}}finally{v.closeSync(F)}}e.writeFileSync=E;function y(N){return N?{mode:typeof N.mode=="number"?N.mode:438,flag:typeof N.flag=="string"?N.flag:"w"}:{mode:438,flag:"w"}}async function a(N,H){if(N===H)return;async function T(U){try{const F=await e.Promises.lstat(U);if(F.isDirectory()||F.isSymbolicLink())return;await e.Promises.utimes(U,F.atime,new Date)}catch(F){}}try{await e.Promises.rename(N,H),await T(H)}catch(U){if(N.toLowerCase()!==H.toLowerCase()&&U.code==="EXDEV"||N.endsWith("."))await L(N,H,{preserveSymlinks:!1}),await c(N,m.MOVE),await T(H);else throw U}}async function L(N,H,T){return W(N,H,{root:{source:N,target:H},options:T,handledSourcePaths:new Set})}const O=511;async function W(N,H,T){if(T.handledSourcePaths.has(N))return;T.handledSourcePaths.add(N);const{stat:U,symbolicLink:F}=await r.stat(N);if(F){if(T.options.preserveSymlinks)try{return await q(N,H,T)}catch(M){console.warn("[node.js fs] copy of symlink failed: ",M)}if(F.dangling)return}return U.isDirectory()?J(N,H,U.mode&O,T):se(N,H,U.mode&O)}async function J(N,H,T,U){await e.Promises.mkdir(H,{recursive:!0,mode:T});const F=await b(N);for(const M of F)await W(D.join(N,M),D.join(H,M),U)}async function se(N,H,T){await e.Promises.copyFile(N,H),await e.Promises.chmod(H,T)}async function q(N,H,T){let U=await e.Promises.readlink(N);_.isEqualOrParent(U,T.root.source,!P.isLinux)&&(U=D.join(T.root.target,U.substr(T.root.source.length+1))),await e.Promises.symlink(U,H)}e.Promises=new class{get access(){return k.promisify(v.access)}get stat(){return k.promisify(v.stat)}get lstat(){return k.promisify(v.lstat)}get utimes(){return k.promisify(v.utimes)}get read(){return k.promisify(v.read)}get readFile(){return k.promisify(v.readFile)}get write(){return k.promisify(v.write)}get appendFile(){return k.promisify(v.appendFile)}get fdatasync(){return k.promisify(v.fdatasync)}get truncate(){return k.promisify(v.truncate)}get rename(){return k.promisify(v.rename)}get copyFile(){return k.promisify(v.copyFile)}get open(){return k.promisify(v.open)}get close(){return k.promisify(v.close)}get symlink(){return k.promisify(v.symlink)}get readlink(){return k.promisify(v.readlink)}get chmod(){return k.promisify(v.chmod)}get mkdir(){return k.promisify(v.mkdir)}get unlink(){return k.promisify(v.unlink)}get rmdir(){return k.promisify(v.rmdir)}get realpath(){return k.promisify(v.realpath)}async exists(N){try{return await e.Promises.access(N),!0}catch(H){return!1}}get readdir(){return b}get readDirsInDir(){return t}get writeFile(){return o}get rm(){return c}get move(){return a}get copy(){return L}}}),define(ge[103],pe([0,1,55,8,9,28]),function(Q,e,v,R,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcaseSync=void 0;function A(s){const I=k.dirname(s);if(s===I)return s;const l=(k.basename(s)||s).toLowerCase();try{const c=D.readdirSync(I).filter(h=>h.toLowerCase()===l);if(c.length===1){const h=A(I);if(h)return k.join(h,c[0])}else if(c.length>1){const h=c.indexOf(l);if(h>=0){const S=A(I);if(S)return k.join(S,c[h])}}}catch(m){}return null}e.realcaseSync=A;async function P(s){try{return await D.Promises.realpath(s)}catch(I){const l=C(s);return await D.Promises.access(l,v.constants.R_OK),l}}e.realpath=P;function _(s){try{return v.realpathSync(s)}catch(I){const l=C(s);return v.accessSync(l,v.constants.R_OK),l}}e.realpathSync=_;function C(s){return R.rtrim(k.normalize(s),k.sep)}});var Ve=this&&this.__decorate||function(Q,e,v,R){var k=arguments.length,D=k<3?e:R===null?R=Object.getOwnPropertyDescriptor(e,v):R,A;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")D=Reflect.decorate(Q,e,v,R);else for(var P=Q.length-1;P>=0;P--)(A=Q[P])&&(D=(k<3?A(D):k>3?A(e,v,D):A(e,v))||D);return k>3&&D&&Object.defineProperty(e,v,D),D};define(ge[104],pe([0,1,3,6,16,21,14,22,18,15,54,8,51]),function(Q,e,v,R,k,D,A,P,_,C,s,I,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var m;(function(F){F[F.Promise=100]="Promise",F[F.PromiseCancel=101]="PromiseCancel",F[F.EventListen=102]="EventListen",F[F.EventDispose=103]="EventDispose"})(m=e.RequestType||(e.RequestType={}));function c(F){switch(F){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var h;(function(F){F[F.Initialize=200]="Initialize",F[F.PromiseSuccess=201]="PromiseSuccess",F[F.PromiseError=202]="PromiseError",F[F.PromiseErrorObj=203]="PromiseErrorObj",F[F.EventFire=204]="EventFire"})(h=e.ResponseType||(e.ResponseType={}));function S(F){switch(F){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var w;(function(F){F[F.Uninitialized=0]="Uninitialized",F[F.Idle=1]="Idle"})(w||(w={}));class b{constructor(M){this.buffer=M,this.pos=0}read(M){const x=this.buffer.slice(this.pos,this.pos+M);return this.pos+=x.byteLength,x}}class u{constructor(){this.buffers=[]}get buffer(){return P.VSBuffer.concat(this.buffers)}write(M){this.buffers.push(M)}}var d;(function(F){F[F.Undefined=0]="Undefined",F[F.String=1]="String",F[F.Buffer=2]="Buffer",F[F.VSBuffer=3]="VSBuffer",F[F.Array=4]="Array",F[F.Object=5]="Object"})(d||(d={}));function p(F){const M=P.VSBuffer.alloc(4);return M.writeUInt32BE(F,0),M}function t(F){return F.read(4).readUInt32BE(0)}function i(F){const M=P.VSBuffer.alloc(1);return M.writeUInt8(F,0),M}const r={Undefined:i(d.Undefined),String:i(d.String),Buffer:i(d.Buffer),VSBuffer:i(d.VSBuffer),Array:i(d.Array),Object:i(d.Object)},n=typeof Buffer!="undefined";function o(F,M){if(typeof M=="undefined")F.write(r.Undefined);else if(typeof M=="string"){const x=P.VSBuffer.fromString(M);F.write(r.String),F.write(p(x.byteLength)),F.write(x)}else if(n&&Buffer.isBuffer(M)){const x=P.VSBuffer.wrap(M);F.write(r.Buffer),F.write(p(x.byteLength)),F.write(x)}else if(M instanceof P.VSBuffer)F.write(r.VSBuffer),F.write(p(M.byteLength)),F.write(M);else if(Array.isArray(M)){F.write(r.Array),F.write(p(M.length));for(const x of M)o(F,x)}else{const x=P.VSBuffer.fromString(JSON.stringify(M));F.write(r.Object),F.write(p(x.byteLength)),F.write(x)}}function g(F){switch(F.read(1).readUInt8(0)){case d.Undefined:return;case d.String:return F.read(t(F)).toString();case d.Buffer:return F.read(t(F)).buffer;case d.VSBuffer:return F.read(t(F));case d.Array:{const x=t(F),$=[];for(let X=0;X<x;X++)$.push(g(F));return $}case d.Object:return JSON.parse(F.read(t(F)).toString())}}class f{constructor(M,x,$=null,X=1e3){this.protocol=M,this.ctx=x,this.logger=$,this.timeoutDelay=X,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(le=>this.onRawMessage(le)),this.sendResponse({type:200})}registerChannel(M,x){this.channels.set(M,x),setTimeout(()=>this.flushPendingRequests(M),0)}sendResponse(M){switch(M.type){case 200:{const x=this.send([M.type]);this.logger&&this.logger.logOutgoing(x,0,1,S(M.type));return}case 201:case 202:case 204:case 203:{const x=this.send([M.type,M.id],M.data);this.logger&&this.logger.logOutgoing(x,M.id,1,S(M.type),M.data);return}}}send(M,x=void 0){const $=new u;return o($,M),o($,x),this.sendBuffer($.buffer)}sendBuffer(M){try{return this.protocol.send(M),M.byteLength}catch(x){return 0}}onRawMessage(M){const x=new b(M),$=g(x),X=g(x),le=$[0];switch(le){case 100:return this.logger&&this.logger.logIncoming(M.byteLength,$[1],1,`${c(le)}: ${$[2]}.${$[3]}`,X),this.onPromise({type:le,id:$[1],channelName:$[2],name:$[3],arg:X});case 102:return this.logger&&this.logger.logIncoming(M.byteLength,$[1],1,`${c(le)}: ${$[2]}.${$[3]}`,X),this.onEventListen({type:le,id:$[1],channelName:$[2],name:$[3],arg:X});case 101:return this.logger&&this.logger.logIncoming(M.byteLength,$[1],1,`${c(le)}`),this.disposeActiveRequest({type:le,id:$[1]});case 103:return this.logger&&this.logger.logIncoming(M.byteLength,$[1],1,`${c(le)}`),this.disposeActiveRequest({type:le,id:$[1]})}}onPromise(M){const x=this.channels.get(M.channelName);if(!x){this.collectPendingRequest(M);return}const $=new D.CancellationTokenSource;let X;try{X=x.call(this.ctx,M.name,M.arg,$.token)}catch(Re){X=Promise.reject(Re)}const le=M.id;X.then(Re=>{this.sendResponse({id:le,data:Re,type:201}),this.activeRequests.delete(M.id)},Re=>{Re instanceof Error?this.sendResponse({id:le,data:{message:Re.message,name:Re.name,stack:Re.stack?Re.stack.split?Re.stack.split(`
`):Re.stack:void 0},type:202}):this.sendResponse({id:le,data:Re,type:203}),this.activeRequests.delete(M.id)});const be=R.toDisposable(()=>$.cancel());this.activeRequests.set(M.id,be)}onEventListen(M){const x=this.channels.get(M.channelName);if(!x){this.collectPendingRequest(M);return}const $=M.id,le=x.listen(this.ctx,M.name,M.arg)(be=>this.sendResponse({id:$,data:be,type:204}));this.activeRequests.set(M.id,le)}disposeActiveRequest(M){const x=this.activeRequests.get(M.id);x&&(x.dispose(),this.activeRequests.delete(M.id))}collectPendingRequest(M){let x=this.pendingRequests.get(M.channelName);x||(x=[],this.pendingRequests.set(M.channelName,x));const $=setTimeout(()=>{console.error(`Unknown channel: ${M.channelName}`),M.type===100&&this.sendResponse({id:M.id,data:{name:"Unknown channel",message:`Channel name '${M.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);x.push({request:M,timeoutTimer:$})}flushPendingRequests(M){const x=this.pendingRequests.get(M);if(x){for(const $ of x)switch(clearTimeout($.timeoutTimer),$.request.type){case 100:this.onPromise($.request);break;case 102:this.onEventListen($.request);break}this.pendingRequests.delete(M)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(M=>M.dispose()),this.activeRequests.clear()}}e.ChannelServer=f;var E;(function(F){F[F.LocalSide=0]="LocalSide",F[F.OtherSide=1]="OtherSide"})(E=e.RequestInitiator||(e.RequestInitiator={}));class y{constructor(M,x=null){this.protocol=M,this.isDisposed=!1,this.state=w.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new v.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage($=>this.onBuffer($)),this.logger=x}getChannel(M){const x=this;return{call($,X,le){return x.isDisposed?Promise.reject(A.canceled()):x.requestPromise(M,$,X,le)},listen($,X){return x.isDisposed?Promise.reject(A.canceled()):x.requestEvent(M,$,X)}}}requestPromise(M,x,$,X=D.CancellationToken.None){const le=this.lastRequestId++,Re={id:le,type:100,channelName:M,name:x,arg:$};if(X.isCancellationRequested)return Promise.reject(A.canceled());let Ce;return new Promise((je,ze)=>{if(X.isCancellationRequested)return ze(A.canceled());const qe=()=>{const oe=Y=>{switch(Y.type){case 201:this.handlers.delete(le),je(Y.data);break;case 202:this.handlers.delete(le);const ce=new Error(Y.data.message);ce.stack=Y.data.stack,ce.name=Y.data.name,ze(ce);break;case 203:this.handlers.delete(le),ze(Y.data);break}};this.handlers.set(le,oe),this.sendRequest(Re)};let j=null;this.state===w.Idle?qe():(j=k.createCancelablePromise(oe=>this.whenInitialized()),j.then(()=>{j=null,qe()}));const Z=()=>{j?(j.cancel(),j=null):this.sendRequest({id:le,type:101}),ze(A.canceled())},ne=X.onCancellationRequested(Z);Ce=R.combinedDisposable(R.toDisposable(Z),ne),this.activeRequests.add(Ce)}).finally(()=>{this.activeRequests.delete(Ce)})}requestEvent(M,x,$){const X=this.lastRequestId++,be={id:X,type:102,channelName:M,name:x,arg:$};let Re=null;const Ce=new v.Emitter({onFirstListenerAdd:()=>{Re=k.createCancelablePromise(je=>this.whenInitialized()),Re.then(()=>{Re=null,this.activeRequests.add(Ce),this.sendRequest(be)})},onLastListenerRemove:()=>{Re?(Re.cancel(),Re=null):(this.activeRequests.delete(Ce),this.sendRequest({id:X,type:103}))}}),Me=je=>Ce.fire(je.data);return this.handlers.set(X,Me),Ce.event}sendRequest(M){switch(M.type){case 100:case 102:{const x=this.send([M.type,M.id,M.channelName,M.name],M.arg);this.logger&&this.logger.logOutgoing(x,M.id,0,`${c(M.type)}: ${M.channelName}.${M.name}`,M.arg);return}case 101:case 103:{const x=this.send([M.type,M.id]);this.logger&&this.logger.logOutgoing(x,M.id,0,c(M.type));return}}}send(M,x=void 0){const $=new u;return o($,M),o($,x),this.sendBuffer($.buffer)}sendBuffer(M){try{return this.protocol.send(M),M.byteLength}catch(x){return 0}}onBuffer(M){const x=new b(M),$=g(x),X=g(x),le=$[0];switch(le){case 200:return this.logger&&this.logger.logIncoming(M.byteLength,0,0,S(le)),this.onResponse({type:$[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(M.byteLength,$[1],0,S(le),X),this.onResponse({type:$[0],id:$[1],data:X})}}onResponse(M){if(M.type===200){this.state=w.Idle,this._onDidInitialize.fire();return}const x=this.handlers.get(M.id);x&&x(M)}get onDidInitializePromise(){return v.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===w.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(M=>M.dispose()),this.activeRequests.clear()}}Ve([l.memoize],y.prototype,"onDidInitializePromise",null),e.ChannelClient=y;class a{constructor(M){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new v.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new v.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,M(({protocol:x,onDidClientDisconnect:$})=>{v.Event.once(x.onMessage)(le=>{const be=new b(le),Re=g(be),Ce=new f(x,Re),Me=new y(x);this.channels.forEach((ze,qe)=>Ce.registerChannel(qe,ze));const je={channelServer:Ce,channelClient:Me,ctx:Re};this._connections.add(je),this._onDidAddConnection.fire(je),$(()=>{Ce.dispose(),Me.dispose(),this._connections.delete(je),this._onDidRemoveConnection.fire(je)})})})}get connections(){const M=[];return this._connections.forEach(x=>M.push(x)),M}getChannel(M,x){const $=this;return{call(X,le,be){let Re;if(C.isFunction(x)){let Me=_.getRandomElement($.connections.filter(x));Re=Me?Promise.resolve(Me):v.Event.toPromise(v.Event.filter($.onDidAddConnection,x))}else Re=x.routeCall($,X,le);const Ce=Re.then(Me=>Me.channelClient.getChannel(M));return O(Ce).call(X,le,be)},listen(X,le){if(C.isFunction(x))return $.getMulticastEvent(M,x,X,le);const be=x.routeEvent($,X,le).then(Re=>Re.channelClient.getChannel(M));return O(be).listen(X,le)}}}getMulticastEvent(M,x,$,X){const le=this;let be=new R.DisposableStore;const Re=new v.Emitter({onFirstListenerAdd:()=>{be=new R.DisposableStore;const Ce=new v.EventMultiplexer,Me=new Map,je=qe=>{const Z=qe.channelClient.getChannel(M).listen($,X),ne=Ce.add(Z);Me.set(qe,ne)},ze=qe=>{const j=Me.get(qe);!j||(j.dispose(),Me.delete(qe))};le.connections.filter(x).forEach(je),v.Event.filter(le.onDidAddConnection,x)(je,void 0,be),le.onDidRemoveConnection(ze,void 0,be),Ce.event(Re.fire,Re,be),be.add(Ce)},onLastListenerRemove:()=>{be.dispose()}});return Re.event}registerChannel(M,x){this.channels.set(M,x),this._connections.forEach($=>{$.channelServer.registerChannel(M,x)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=a;class L{constructor(M,x,$=null){const X=new u;o(X,x),M.send(X.buffer),this.channelClient=new y(M,$),this.channelServer=new f(M,x,$)}getChannel(M){return this.channelClient.getChannel(M)}registerChannel(M,x){this.channelServer.registerChannel(M,x)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=L;function O(F){return{call(M,x,$){return F.then(X=>X.call(M,x,$))},listen(M,x){const $=new v.Relay;return F.then(X=>$.input=X.listen(M,x)),$.event}}}e.getDelayedChannel=O;function W(F){let M=!1;return{call(x,$,X){return M?F.call(x,$,X):k.timeout(0).then(()=>M=!0).then(()=>F.call(x,$,X))},listen(x,$){if(M)return F.listen(x,$);const X=new v.Relay;return k.timeout(0).then(()=>M=!0).then(()=>X.input=F.listen(x,$)),X.event}}}e.getNextTickChannel=W;class J{constructor(M){this.fn=M}routeCall(M){return this.route(M)}routeEvent(M){return this.route(M)}async route(M){for(const x of M.connections)if(await Promise.resolve(this.fn(x.ctx)))return Promise.resolve(x);return await v.Event.toPromise(M.onDidAddConnection),await this.route(M)}}e.StaticRouter=J;var se;(function(F){function M(X,le){const be=X,Re=le&&le.disableMarshalling,Ce=new Map;for(const Me in be)$(Me)&&Ce.set(Me,v.Event.buffer(be[Me],!0));return new class{listen(Me,je){const ze=Ce.get(je);if(ze)return ze;throw new Error(`Event not found: ${je}`)}call(Me,je,ze){const qe=be[je];if(typeof qe=="function"){if(!Re&&Array.isArray(ze))for(let j=0;j<ze.length;j++)ze[j]=s.revive(ze[j]);return qe.apply(be,ze)}throw new Error(`Method not found: ${je}`)}}}F.fromService=M;function x(X,le){const be=le&&le.disableMarshalling;return new Proxy({},{get(Re,Ce){var Me;if(typeof Ce=="string")return((Me=le==null?void 0:le.properties)===null||Me===void 0?void 0:Me.has(Ce))?le.properties.get(Ce):$(Ce)?X.listen(Ce):async function(...je){let ze;le&&!C.isUndefinedOrNull(le.context)?ze=[le.context,...je]:ze=je;const qe=await X.call(Ce,ze);return be?qe:s.revive(qe)};throw new Error(`Property not found: ${String(Ce)}`)}})}F.toService=x;function $(X){return X[0]==="o"&&X[1]==="n"&&I.isUpperAsciiLetter(X.charCodeAt(2))}})(se=e.ProxyChannel||(e.ProxyChannel={}));const q=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function N(F){if(Array.isArray(F))return F;if(F&&typeof F=="object"&&typeof F.toString=="function"){let M=F.toString();if(M!=="[object Object]")return M}return F}function H(F){return Array.isArray(F)?F.map(N):N(F)}function T(F,M,x,$,X,le,be){be=H(be);const Re=q[X],Ce=Re[$%Re.length];let Me=[`%c[${F}]%c[${String(M).padStart(7," ")}]%c[len: ${String(x).padStart(5," ")}]%c${String($).padStart(5," ")} - ${le}`,"color: darkgreen","color: grey","color: grey",`color: ${Ce}`];/\($/.test(le)?(Me=Me.concat(be),Me.push(")")):Me.push(be),console.log.apply(console,Me)}e.logWithColors=T;class U{constructor(M,x){this._outgoingPrefix=M,this._incomingPrefix=x,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(M,x,$,X,le){this._totalOutgoing+=M,T(this._outgoingPrefix,this._totalOutgoing,M,x,$,X,le)}logIncoming(M,x,$,X,le){this._totalIncoming+=M,T(this._incomingPrefix,this._totalIncoming,M,x,$,X,le)}}e.IPCLogger=U}),define(ge[105],pe([0,1,3,104,6,22,11,37]),function(Q,e,v,R,k,D,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=void 0;var _;(function(r){r[r.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",r[r.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(_=e.SocketCloseEventType||(e.SocketCloseEventType={}));let C=null;function s(){return C||(C=D.VSBuffer.alloc(0)),C}class I{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(n){this._chunks.push(n),this._totalLength+=n.byteLength}read(n){return this._read(n,!0)}peek(n){return this._read(n,!1)}_read(n,o){if(n===0)return s();if(n>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===n){const y=this._chunks[0];return o&&(this._chunks.shift(),this._totalLength-=n),y}if(this._chunks[0].byteLength>n){const y=this._chunks[0].slice(0,n);return o&&(this._chunks[0]=this._chunks[0].slice(n),this._totalLength-=n),y}let g=D.VSBuffer.alloc(n),f=0,E=0;for(;n>0;){const y=this._chunks[E];if(y.byteLength>n){const a=y.slice(0,n);g.set(a,f),f+=n,o&&(this._chunks[E]=y.slice(n),this._totalLength-=n),n-=n}else g.set(y,f),f+=y.byteLength,o?(this._chunks.shift(),this._totalLength-=y.byteLength):E++,n-=y.byteLength}return g}}e.ChunkStream=I;var l;(function(r){r[r.None=0]="None",r[r.Regular=1]="Regular",r[r.Control=2]="Control",r[r.Ack=3]="Ack",r[r.KeepAlive=4]="KeepAlive",r[r.Disconnect=5]="Disconnect",r[r.ReplayRequest=6]="ReplayRequest"})(l||(l={}));var m;(function(r){r[r.HeaderLength=13]="HeaderLength",r[r.AcknowledgeTime=2e3]="AcknowledgeTime",r[r.AcknowledgeTimeoutTime=2e4]="AcknowledgeTimeoutTime",r[r.KeepAliveTime=5e3]="KeepAliveTime",r[r.KeepAliveTimeoutTime=2e4]="KeepAliveTimeoutTime",r[r.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",r[r.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(m=e.ProtocolConstants||(e.ProtocolConstants={}));class c{constructor(n,o,g,f){this.type=n,this.id=o,this.ack=g,this.data=f,this.writtenTime=0}get size(){return this.data.byteLength}}class h extends k.Disposable{constructor(n){super();this._onMessage=this._register(new v.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=n,this._isDisposed=!1,this._incomingData=new I,this._register(this._socket.onData(o=>this.acceptChunk(o))),this.lastReadTime=Date.now()}acceptChunk(n){if(!(!n||n.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(n);this._incomingData.byteLength>=this._state.readLen;){const o=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=o.readUInt32BE(9),this._state.messageType=o.readUInt8(0),this._state.id=o.readUInt32BE(1),this._state.ack=o.readUInt32BE(5);else{const g=this._state.messageType,f=this._state.id,E=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._onMessage.fire(new c(g,f,E,o)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class S{constructor(n){this._isDisposed=!1,this._socket=n,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch(n){}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}write(n){if(this._isDisposed)return;n.writtenTime=Date.now(),this.lastWriteTime=Date.now();const o=D.VSBuffer.alloc(13);o.writeUInt8(n.type,0),o.writeUInt32BE(n.id,1),o.writeUInt32BE(n.ack,5),o.writeUInt32BE(n.data.byteLength,9),this._writeSoon(o,n.data)}_bufferAdd(n,o){const g=this._totalLength===0;return this._data.push(n,o),this._totalLength+=n.byteLength+o.byteLength,g}_bufferTake(){const n=D.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,n}_writeSoon(n,o){this._bufferAdd(n,o)&&A.setImmediate(()=>{this._writeNow()})}_writeNow(){this._totalLength!==0&&this._socket.write(this._bufferTake())}}class w extends k.Disposable{constructor(n){super();this._onMessage=new v.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new v.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=n,this._socketWriter=this._register(new S(this._socket)),this._socketReader=this._register(new h(this._socket)),this._register(this._socketReader.onMessage(o=>{o.type===1&&this._onMessage.fire(o.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(n){this._socketWriter.write(new c(1,0,0,n))}}e.Protocol=w;class b extends R.IPCClient{constructor(n,o,g=null){super(n,o,g);this.protocol=n}static fromSocket(n,o){return new b(new w(n),o)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const n=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),n.end()}}e.Client=b;class u{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new v.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,P.nextTick(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(n){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(n):this._emitter.fire(n):this._bufferedMessages.push(n)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=u;class d{constructor(n){this.data=n,this.next=null}}class p{constructor(){this._first=null,this._last=null}peek(){return this._first?this._first.data:null}toArray(){let n=[],o=0,g=this._first;for(;g;)n[o++]=g.data,g=g.next;return n}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(n){const o=new d(n);if(!this._first){this._first=o,this._last=o;return}this._last.next=o,this._last=o}}class t{constructor(){this.lastRuns=[];const n=Date.now();for(let o=0;o<t._HISTORY_LENGTH;o++)this.lastRuns[o]=n-1e3*o;setInterval(()=>{for(let o=t._HISTORY_LENGTH;o>=1;o--)this.lastRuns[o]=this.lastRuns[o-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return t._INSTANCE||(t._INSTANCE=new t),t._INSTANCE}load(){const n=Date.now(),o=(1+t._HISTORY_LENGTH)*1e3;let g=0;for(let f=0;f<t._HISTORY_LENGTH;f++)n-this.lastRuns[f]<=o&&g++;return 1-g/t._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}t._HISTORY_LENGTH=10,t._INSTANCE=null;class i{constructor(n,o=null){this._loadEstimator=t.getInstance(),this._onControlMessage=new u,this.onControlMessage=this._onControlMessage.event,this._onMessage=new u,this.onMessage=this._onMessage.event,this._onDidDispose=new u,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new u,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new u,this.onSocketTimeout=this._onSocketTimeout.event,this._isReconnecting=!1,this._outgoingUnackMsg=new p,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._outgoingKeepAliveTimeout=null,this._incomingKeepAliveTimeout=null,this._lastReplayRequestTime=0,this._socketDisposables=[],this._socket=n,this._socketWriter=new S(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new h(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(g=>this._receiveMessage(g))),this._socketDisposables.push(this._socket.onClose(g=>this._onSocketClose.fire(g))),o&&this._socketReader.acceptChunk(o),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._outgoingKeepAliveTimeout&&(clearTimeout(this._outgoingKeepAliveTimeout),this._outgoingKeepAliveTimeout=null),this._incomingKeepAliveTimeout&&(clearTimeout(this._incomingKeepAliveTimeout),this._incomingKeepAliveTimeout=null),this._socketDisposables=k.dispose(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const n=new c(5,0,0,s());this._socketWriter.write(n),this._socketWriter.flush()}_sendKeepAliveCheck(){if(this._outgoingKeepAliveTimeout)return;const n=Date.now()-this._socketWriter.lastWriteTime;if(n>=5e3){const o=new c(4,0,0,s());this._socketWriter.write(o),this._sendKeepAliveCheck();return}this._outgoingKeepAliveTimeout=setTimeout(()=>{this._outgoingKeepAliveTimeout=null,this._sendKeepAliveCheck()},5e3-n+5)}_recvKeepAliveCheck(){if(this._incomingKeepAliveTimeout)return;const n=Date.now()-this._socketReader.lastReadTime;if(n>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._incomingKeepAliveTimeout=setTimeout(()=>{this._incomingKeepAliveTimeout=null,this._recvKeepAliveCheck()},Math.max(2e4-n,0)+5)}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(n,o){this._isReconnecting=!0,this._socketDisposables=k.dispose(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._socket=n,this._socketWriter=new S(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new h(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(g=>this._receiveMessage(g))),this._socketDisposables.push(this._socket.onClose(g=>this._onSocketClose.fire(g))),this._socketReader.acceptChunk(o)}endAcceptReconnection(){this._isReconnecting=!1;const n=this._outgoingUnackMsg.toArray();for(let o=0,g=n.length;o<g;o++)this._socketWriter.write(n[o]);this._recvAckCheck(),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(n){if(n.ack>this._outgoingAckId){this._outgoingAckId=n.ack;do{const o=this._outgoingUnackMsg.peek();if(o&&o.id<=n.ack)this._outgoingUnackMsg.pop();else break}while(!0)}if(n.type===1){if(n.id>this._incomingMsgId)if(n.id!==this._incomingMsgId+1){const o=Date.now();o-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=o,this._socketWriter.write(new c(6,0,0,s())))}else this._incomingMsgId=n.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(n.data)}else if(n.type===2)this._onControlMessage.fire(n.data);else if(n.type===5)this._onDidDispose.fire();else if(n.type===6){const o=this._outgoingUnackMsg.toArray();for(let g=0,f=o.length;g<f;g++)this._socketWriter.write(o[g]);this._recvAckCheck()}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(n){const o=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const g=new c(1,o,this._incomingAckId,n);this._outgoingUnackMsg.push(g),this._isReconnecting||(this._socketWriter.write(g),this._recvAckCheck())}sendControl(n){const o=new c(2,0,0,n);this._socketWriter.write(o)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const n=Date.now()-this._incomingMsgLastTime;if(n>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-n+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout)return;const n=this._outgoingUnackMsg.peek(),o=Date.now()-n.writtenTime;if(o>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},Math.max(2e4-o,0)+5)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const n=new c(3,0,this._incomingAckId,s());this._socketWriter.write(n)}}e.PersistentProtocol=i}),define(ge[106],pe([0,1,94]),function(Q,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharacterSet=e.CharacterClassifier=void 0;class R{constructor(P){let _=v.toUint8(P);this._defaultValue=_,this._asciiMap=R._createAsciiMap(_),this._map=new Map}static _createAsciiMap(P){let _=new Uint8Array(256);for(let C=0;C<256;C++)_[C]=P;return _}set(P,_){let C=v.toUint8(_);P>=0&&P<256?this._asciiMap[P]=C:this._map.set(P,C)}get(P){return P>=0&&P<256?this._asciiMap[P]:this._map.get(P)||this._defaultValue}}e.CharacterClassifier=R;var k;(function(A){A[A.False=0]="False",A[A.True=1]="True"})(k||(k={}));class D{constructor(){this._actual=new R(0)}add(P){this._actual.set(P,1)}has(P){return this._actual.get(P)===1}}e.CharacterSet=D}),define(ge[138],pe([0,1,106]),function(Q,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMapForWordSeparators=e.WordCharacterClassifier=e.WordCharacterClass=void 0;var R;(function(A){A[A.Regular=0]="Regular",A[A.Whitespace=1]="Whitespace",A[A.WordSeparator=2]="WordSeparator"})(R=e.WordCharacterClass||(e.WordCharacterClass={}));class k extends v.CharacterClassifier{constructor(P){super(0);for(let _=0,C=P.length;_<C;_++)this.set(P.charCodeAt(_),2);this.set(32,1),this.set(9,1)}}e.WordCharacterClassifier=k;function D(A){let P={};return _=>(P.hasOwnProperty(_)||(P[_]=A(_)),P[_])}e.getMapForWordSeparators=D(A=>new k(A))}),define(ge[44],pe([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Position=void 0;class v{constructor(k,D){this.lineNumber=k,this.column=D}with(k=this.lineNumber,D=this.column){return k===this.lineNumber&&D===this.column?this:new v(k,D)}delta(k=0,D=0){return this.with(this.lineNumber+k,this.column+D)}equals(k){return v.equals(this,k)}static equals(k,D){return!k&&!D?!0:!!k&&!!D&&k.lineNumber===D.lineNumber&&k.column===D.column}isBefore(k){return v.isBefore(this,k)}static isBefore(k,D){return k.lineNumber<D.lineNumber?!0:D.lineNumber<k.lineNumber?!1:k.column<D.column}isBeforeOrEqual(k){return v.isBeforeOrEqual(this,k)}static isBeforeOrEqual(k,D){return k.lineNumber<D.lineNumber?!0:D.lineNumber<k.lineNumber?!1:k.column<=D.column}static compare(k,D){let A=k.lineNumber|0,P=D.lineNumber|0;if(A===P){let _=k.column|0,C=D.column|0;return _-C}return A-P}clone(){return new v(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(k){return new v(k.lineNumber,k.column)}static isIPosition(k){return k&&typeof k.lineNumber=="number"&&typeof k.column=="number"}}e.Position=v}),define(ge[41],pe([0,1,44]),function(Q,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=void 0;class R{constructor(D,A,P,_){D>P||D===P&&A>_?(this.startLineNumber=P,this.startColumn=_,this.endLineNumber=D,this.endColumn=A):(this.startLineNumber=D,this.startColumn=A,this.endLineNumber=P,this.endColumn=_)}isEmpty(){return R.isEmpty(this)}static isEmpty(D){return D.startLineNumber===D.endLineNumber&&D.startColumn===D.endColumn}containsPosition(D){return R.containsPosition(this,D)}static containsPosition(D,A){return!(A.lineNumber<D.startLineNumber||A.lineNumber>D.endLineNumber||A.lineNumber===D.startLineNumber&&A.column<D.startColumn||A.lineNumber===D.endLineNumber&&A.column>D.endColumn)}containsRange(D){return R.containsRange(this,D)}static containsRange(D,A){return!(A.startLineNumber<D.startLineNumber||A.endLineNumber<D.startLineNumber||A.startLineNumber>D.endLineNumber||A.endLineNumber>D.endLineNumber||A.startLineNumber===D.startLineNumber&&A.startColumn<D.startColumn||A.endLineNumber===D.endLineNumber&&A.endColumn>D.endColumn)}strictContainsRange(D){return R.strictContainsRange(this,D)}static strictContainsRange(D,A){return!(A.startLineNumber<D.startLineNumber||A.endLineNumber<D.startLineNumber||A.startLineNumber>D.endLineNumber||A.endLineNumber>D.endLineNumber||A.startLineNumber===D.startLineNumber&&A.startColumn<=D.startColumn||A.endLineNumber===D.endLineNumber&&A.endColumn>=D.endColumn)}plusRange(D){return R.plusRange(this,D)}static plusRange(D,A){let P,_,C,s;return A.startLineNumber<D.startLineNumber?(P=A.startLineNumber,_=A.startColumn):A.startLineNumber===D.startLineNumber?(P=A.startLineNumber,_=Math.min(A.startColumn,D.startColumn)):(P=D.startLineNumber,_=D.startColumn),A.endLineNumber>D.endLineNumber?(C=A.endLineNumber,s=A.endColumn):A.endLineNumber===D.endLineNumber?(C=A.endLineNumber,s=Math.max(A.endColumn,D.endColumn)):(C=D.endLineNumber,s=D.endColumn),new R(P,_,C,s)}intersectRanges(D){return R.intersectRanges(this,D)}static intersectRanges(D,A){let P=D.startLineNumber,_=D.startColumn,C=D.endLineNumber,s=D.endColumn,I=A.startLineNumber,l=A.startColumn,m=A.endLineNumber,c=A.endColumn;return P<I?(P=I,_=l):P===I&&(_=Math.max(_,l)),C>m?(C=m,s=c):C===m&&(s=Math.min(s,c)),P>C||P===C&&_>s?null:new R(P,_,C,s)}equalsRange(D){return R.equalsRange(this,D)}static equalsRange(D,A){return!!D&&!!A&&D.startLineNumber===A.startLineNumber&&D.startColumn===A.startColumn&&D.endLineNumber===A.endLineNumber&&D.endColumn===A.endColumn}getEndPosition(){return R.getEndPosition(this)}static getEndPosition(D){return new v.Position(D.endLineNumber,D.endColumn)}getStartPosition(){return R.getStartPosition(this)}static getStartPosition(D){return new v.Position(D.startLineNumber,D.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(D,A){return new R(this.startLineNumber,this.startColumn,D,A)}setStartPosition(D,A){return new R(D,A,this.endLineNumber,this.endColumn)}collapseToStart(){return R.collapseToStart(this)}static collapseToStart(D){return new R(D.startLineNumber,D.startColumn,D.startLineNumber,D.startColumn)}static fromPositions(D,A=D){return new R(D.lineNumber,D.column,A.lineNumber,A.column)}static lift(D){return D?new R(D.startLineNumber,D.startColumn,D.endLineNumber,D.endColumn):null}static isIRange(D){return D&&typeof D.startLineNumber=="number"&&typeof D.startColumn=="number"&&typeof D.endLineNumber=="number"&&typeof D.endColumn=="number"}static areIntersectingOrTouching(D,A){return!(D.endLineNumber<A.startLineNumber||D.endLineNumber===A.startLineNumber&&D.endColumn<A.startColumn||A.endLineNumber<D.startLineNumber||A.endLineNumber===D.startLineNumber&&A.endColumn<D.startColumn)}static areIntersecting(D,A){return!(D.endLineNumber<A.startLineNumber||D.endLineNumber===A.startLineNumber&&D.endColumn<=A.startColumn||A.endLineNumber<D.startLineNumber||A.endLineNumber===D.startLineNumber&&A.endColumn<=D.startColumn)}static compareRangesUsingStarts(D,A){if(D&&A){const C=D.startLineNumber|0,s=A.startLineNumber|0;if(C===s){const I=D.startColumn|0,l=A.startColumn|0;if(I===l){const m=D.endLineNumber|0,c=A.endLineNumber|0;if(m===c){const h=D.endColumn|0,S=A.endColumn|0;return h-S}return m-c}return I-l}return C-s}return(D?1:0)-(A?1:0)}static compareRangesUsingEnds(D,A){return D.endLineNumber===A.endLineNumber?D.endColumn===A.endColumn?D.startLineNumber===A.startLineNumber?D.startColumn-A.startColumn:D.startLineNumber-A.startLineNumber:D.endColumn-A.endColumn:D.endLineNumber-A.endLineNumber}static spansMultipleLines(D){return D.endLineNumber>D.startLineNumber}}e.Range=R}),define(ge[139],pe([0,1,44,41]),function(Q,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Selection=e.SelectionDirection=void 0;var k;(function(A){A[A.LTR=0]="LTR",A[A.RTL=1]="RTL"})(k=e.SelectionDirection||(e.SelectionDirection={}));class D extends R.Range{constructor(P,_,C,s){super(P,_,C,s);this.selectionStartLineNumber=P,this.selectionStartColumn=_,this.positionLineNumber=C,this.positionColumn=s}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(P){return D.selectionsEqual(this,P)}static selectionsEqual(P,_){return P.selectionStartLineNumber===_.selectionStartLineNumber&&P.selectionStartColumn===_.selectionStartColumn&&P.positionLineNumber===_.positionLineNumber&&P.positionColumn===_.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(P,_){return this.getDirection()===0?new D(this.startLineNumber,this.startColumn,P,_):new D(P,_,this.startLineNumber,this.startColumn)}getPosition(){return new v.Position(this.positionLineNumber,this.positionColumn)}setStartPosition(P,_){return this.getDirection()===0?new D(P,_,this.endLineNumber,this.endColumn):new D(this.endLineNumber,this.endColumn,P,_)}static fromPositions(P,_=P){return new D(P.lineNumber,P.column,_.lineNumber,_.column)}static liftSelection(P){return new D(P.selectionStartLineNumber,P.selectionStartColumn,P.positionLineNumber,P.positionColumn)}static selectionsArrEqual(P,_){if(P&&!_||!P&&_)return!1;if(!P&&!_)return!0;if(P.length!==_.length)return!1;for(let C=0,s=P.length;C<s;C++)if(!this.selectionsEqual(P[C],_[C]))return!1;return!0}static isISelection(P){return P&&typeof P.selectionStartLineNumber=="number"&&typeof P.selectionStartColumn=="number"&&typeof P.positionLineNumber=="number"&&typeof P.positionColumn=="number"}static createWithDirection(P,_,C,s,I){return I===0?new D(P,_,C,s):new D(C,s,P,_)}}e.Selection=D}),define(ge[107],pe([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApplyEditsResult=e.ValidAnnotatedEditOperation=e.ModelConstants=e.PositionNormalizationAffinity=e.TrackedRangeStickiness=e.FindMatch=e.TextModelResolvedOptions=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.MinimapPosition=e.OverviewRulerLane=void 0;var v;(function(c){c[c.Left=1]="Left",c[c.Center=2]="Center",c[c.Right=4]="Right",c[c.Full=7]="Full"})(v=e.OverviewRulerLane||(e.OverviewRulerLane={}));var R;(function(c){c[c.Inline=1]="Inline",c[c.Gutter=2]="Gutter"})(R=e.MinimapPosition||(e.MinimapPosition={}));var k;(function(c){c[c.TextDefined=0]="TextDefined",c[c.LF=1]="LF",c[c.CRLF=2]="CRLF"})(k=e.EndOfLinePreference||(e.EndOfLinePreference={}));var D;(function(c){c[c.LF=1]="LF",c[c.CRLF=2]="CRLF"})(D=e.DefaultEndOfLine||(e.DefaultEndOfLine={}));var A;(function(c){c[c.LF=0]="LF",c[c.CRLF=1]="CRLF"})(A=e.EndOfLineSequence||(e.EndOfLineSequence={}));class P{constructor(h){this.tabSize=Math.max(1,h.tabSize|0),this.indentSize=h.tabSize|0,this.insertSpaces=Boolean(h.insertSpaces),this.defaultEOL=h.defaultEOL|0,this.trimAutoWhitespace=Boolean(h.trimAutoWhitespace)}equals(h){return this.tabSize===h.tabSize&&this.indentSize===h.indentSize&&this.insertSpaces===h.insertSpaces&&this.defaultEOL===h.defaultEOL&&this.trimAutoWhitespace===h.trimAutoWhitespace}createChangeEvent(h){return{tabSize:this.tabSize!==h.tabSize,indentSize:this.indentSize!==h.indentSize,insertSpaces:this.insertSpaces!==h.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==h.trimAutoWhitespace}}}e.TextModelResolvedOptions=P;class _{constructor(h,S){this.range=h,this.matches=S}}e.FindMatch=_;var C;(function(c){c[c.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",c[c.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",c[c.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",c[c.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(C=e.TrackedRangeStickiness||(e.TrackedRangeStickiness={}));var s;(function(c){c[c.Left=0]="Left",c[c.Right=1]="Right"})(s=e.PositionNormalizationAffinity||(e.PositionNormalizationAffinity={}));var I;(function(c){c[c.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(I=e.ModelConstants||(e.ModelConstants={}));class l{constructor(h,S,w,b,u,d){this.identifier=h,this.range=S,this.text=w,this.forceMoveMarkers=b,this.isAutoWhitespaceEdit=u,this._isTracked=d}}e.ValidAnnotatedEditOperation=l;class m{constructor(h,S,w){this.reverseEdits=h,this.changes=S,this.trimAutoWhitespaceLineNumbers=w}}e.ApplyEditsResult=m}),define(ge[140],pe([0,1,8,138,44,41,107]),function(Q,e,v,R,k,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Searcher=e.isValidMatch=e.TextModelSearch=e.createFindMatch=e.SearchData=e.isMultilineRegexSource=e.SearchParams=void 0;const P=999;class _{constructor(u,d,p,t){this.searchString=u,this.isRegex=d,this.matchCase=p,this.wordSeparators=t}parseSearchRequest(){if(this.searchString==="")return null;let u;this.isRegex?u=C(this.searchString):u=this.searchString.indexOf(`
`)>=0;let d=null;try{d=v.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:u,global:!0,unicode:!0})}catch(t){return null}if(!d)return null;let p=!this.isRegex&&!u;return p&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(p=this.matchCase),new s(d,this.wordSeparators?R.getMapForWordSeparators(this.wordSeparators):null,p?this.searchString:null)}}e.SearchParams=_;function C(b){if(!b||b.length===0)return!1;for(let u=0,d=b.length;u<d;u++)if(b.charCodeAt(u)===92){if(u++,u>=d)break;const t=b.charCodeAt(u);if(t===110||t===114||t===87||t===119)return!0}return!1}e.isMultilineRegexSource=C;class s{constructor(u,d,p){this.regex=u,this.wordSeparators=d,this.simpleSearch=p}}e.SearchData=s;function I(b,u,d){if(!d)return new A.FindMatch(b,null);let p=[];for(let t=0,i=u.length;t<i;t++)p[t]=u[t];return new A.FindMatch(b,p)}e.createFindMatch=I;class l{constructor(u){let d=[],p=0;for(let t=0,i=u.length;t<i;t++)u.charCodeAt(t)===10&&(d[p++]=t);this._lineFeedsOffsets=d}findLineFeedCountBeforeOffset(u){const d=this._lineFeedsOffsets;let p=0,t=d.length-1;if(t===-1||u<=d[0])return 0;for(;p<t;){const i=p+((t-p)/2>>0);d[i]>=u?t=i-1:d[i+1]>=u?(p=i,t=i):p=i+1}return p+1}}class m{static findMatches(u,d,p,t,i){const r=d.parseSearchRequest();return r?r.regex.multiline?this._doFindMatchesMultiline(u,p,new w(r.wordSeparators,r.regex),t,i):this._doFindMatchesLineByLine(u,p,r,t,i):[]}static _getMultilineMatchRange(u,d,p,t,i,r){let n,o=0;t?(o=t.findLineFeedCountBeforeOffset(i),n=d+i+o):n=d+i;let g;if(t){let a=t.findLineFeedCountBeforeOffset(i+r.length)-o;g=n+r.length+a}else g=n+r.length;const f=u.getPositionAt(n),E=u.getPositionAt(g);return new D.Range(f.lineNumber,f.column,E.lineNumber,E.column)}static _doFindMatchesMultiline(u,d,p,t,i){const r=u.getOffsetAt(d.getStartPosition()),n=u.getValueInRange(d,1),o=u.getEOL()===`\r
`?new l(n):null,g=[];let f=0,E;for(p.reset(0);E=p.next(n);)if(g[f++]=I(this._getMultilineMatchRange(u,r,n,o,E.index,E[0]),E,t),f>=i)return g;return g}static _doFindMatchesLineByLine(u,d,p,t,i){const r=[];let n=0;if(d.startLineNumber===d.endLineNumber){const g=u.getLineContent(d.startLineNumber).substring(d.startColumn-1,d.endColumn-1);return n=this._findMatchesInLine(p,g,d.startLineNumber,d.startColumn-1,n,r,t,i),r}const o=u.getLineContent(d.startLineNumber).substring(d.startColumn-1);n=this._findMatchesInLine(p,o,d.startLineNumber,d.startColumn-1,n,r,t,i);for(let g=d.startLineNumber+1;g<d.endLineNumber&&n<i;g++)n=this._findMatchesInLine(p,u.getLineContent(g),g,0,n,r,t,i);if(n<i){const g=u.getLineContent(d.endLineNumber).substring(0,d.endColumn-1);n=this._findMatchesInLine(p,g,d.endLineNumber,0,n,r,t,i)}return r}static _findMatchesInLine(u,d,p,t,i,r,n,o){const g=u.wordSeparators;if(!n&&u.simpleSearch){const y=u.simpleSearch,a=y.length,L=d.length;let O=-a;for(;(O=d.indexOf(y,O+a))!==-1;)if((!g||S(g,d,L,O,a))&&(r[i++]=new A.FindMatch(new D.Range(p,O+1+t,p,O+1+a+t),null),i>=o))return i;return i}const f=new w(u.wordSeparators,u.regex);let E;f.reset(0);do if(E=f.next(d),E&&(r[i++]=I(new D.Range(p,E.index+1+t,p,E.index+1+E[0].length+t),E,n),i>=o))return i;while(E);return i}static findNextMatch(u,d,p,t){const i=d.parseSearchRequest();if(!i)return null;const r=new w(i.wordSeparators,i.regex);return i.regex.multiline?this._doFindNextMatchMultiline(u,p,r,t):this._doFindNextMatchLineByLine(u,p,r,t)}static _doFindNextMatchMultiline(u,d,p,t){const i=new k.Position(d.lineNumber,1),r=u.getOffsetAt(i),n=u.getLineCount(),o=u.getValueInRange(new D.Range(i.lineNumber,i.column,n,u.getLineMaxColumn(n)),1),g=u.getEOL()===`\r
`?new l(o):null;p.reset(d.column-1);let f=p.next(o);return f?I(this._getMultilineMatchRange(u,r,o,g,f.index,f[0]),f,t):d.lineNumber!==1||d.column!==1?this._doFindNextMatchMultiline(u,new k.Position(1,1),p,t):null}static _doFindNextMatchLineByLine(u,d,p,t){const i=u.getLineCount(),r=d.lineNumber,n=u.getLineContent(r),o=this._findFirstMatchInLine(p,n,r,d.column,t);if(o)return o;for(let g=1;g<=i;g++){const f=(r+g-1)%i,E=u.getLineContent(f+1),y=this._findFirstMatchInLine(p,E,f+1,1,t);if(y)return y}return null}static _findFirstMatchInLine(u,d,p,t,i){u.reset(t-1);const r=u.next(d);return r?I(new D.Range(p,r.index+1,p,r.index+1+r[0].length),r,i):null}static findPreviousMatch(u,d,p,t){const i=d.parseSearchRequest();if(!i)return null;const r=new w(i.wordSeparators,i.regex);return i.regex.multiline?this._doFindPreviousMatchMultiline(u,p,r,t):this._doFindPreviousMatchLineByLine(u,p,r,t)}static _doFindPreviousMatchMultiline(u,d,p,t){const i=this._doFindMatchesMultiline(u,new D.Range(1,1,d.lineNumber,d.column),p,t,10*P);if(i.length>0)return i[i.length-1];const r=u.getLineCount();return d.lineNumber!==r||d.column!==u.getLineMaxColumn(r)?this._doFindPreviousMatchMultiline(u,new k.Position(r,u.getLineMaxColumn(r)),p,t):null}static _doFindPreviousMatchLineByLine(u,d,p,t){const i=u.getLineCount(),r=d.lineNumber,n=u.getLineContent(r).substring(0,d.column-1),o=this._findLastMatchInLine(p,n,r,t);if(o)return o;for(let g=1;g<=i;g++){const f=(i+r-g-1)%i,E=u.getLineContent(f+1),y=this._findLastMatchInLine(p,E,f+1,t);if(y)return y}return null}static _findLastMatchInLine(u,d,p,t){let i=null,r;for(u.reset(0);r=u.next(d);)i=I(new D.Range(p,r.index+1,p,r.index+1+r[0].length),r,t);return i}}e.TextModelSearch=m;function c(b,u,d,p,t){if(p===0)return!0;const i=u.charCodeAt(p-1);if(b.get(i)!==0||i===13||i===10)return!0;if(t>0){const r=u.charCodeAt(p);if(b.get(r)!==0)return!0}return!1}function h(b,u,d,p,t){if(p+t===d)return!0;const i=u.charCodeAt(p+t);if(b.get(i)!==0||i===13||i===10)return!0;if(t>0){const r=u.charCodeAt(p+t-1);if(b.get(r)!==0)return!0}return!1}function S(b,u,d,p,t){return c(b,u,d,p,t)&&h(b,u,d,p,t)}e.isValidMatch=S;class w{constructor(u,d){this._wordSeparators=u,this._searchRegex=d,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(u){this._searchRegex.lastIndex=u,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(u){const d=u.length;let p;do{if(this._prevMatchStartIndex+this._prevMatchLength===d||(p=this._searchRegex.exec(u),!p))return null;const t=p.index,i=p[0].length;if(t===this._prevMatchStartIndex&&i===this._prevMatchLength){if(i===0){v.getNextCodePoint(u,d,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=t,this._prevMatchLength=i,!this._wordSeparators||S(this._wordSeparators,u,d,t,i))return p}while(p);return null}}e.Searcher=w}),define(ge[108],pe([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWordAtText=e.ensureValidWordDefinition=e.DEFAULT_WORD_REGEXP=e.USUAL_WORD_SEPARATORS=void 0,e.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function v(P=""){let _="(-?\\d*\\.\\d\\w*)|([^";for(const C of e.USUAL_WORD_SEPARATORS)P.indexOf(C)>=0||(_+="\\"+C);return _+="\\s]+)",new RegExp(_,"g")}e.DEFAULT_WORD_REGEXP=v();function R(P){let _=e.DEFAULT_WORD_REGEXP;if(P&&P instanceof RegExp)if(P.global)_=P;else{let C="g";P.ignoreCase&&(C+="i"),P.multiline&&(C+="m"),P.unicode&&(C+="u"),_=new RegExp(P.source,C)}return _.lastIndex=0,_}e.ensureValidWordDefinition=R;const k={maxLen:1e3,windowSize:15,timeBudget:150};function D(P,_,C,s,I=k){if(C.length>I.maxLen){let S=P-I.maxLen/2;return S<0?S=0:s+=S,C=C.substring(S,P+I.maxLen/2),D(P,_,C,s,I)}const l=Date.now(),m=P-1-s;let c=-1,h=null;for(let S=1;!(Date.now()-l>=I.timeBudget);S++){const w=m-I.windowSize*S;_.lastIndex=Math.max(0,w);const b=A(_,C,m,c);if(!b&&h||(h=b,w<=0))break;c=w}if(h){let S={word:h[0],startColumn:s+1+h.index,endColumn:s+1+h.index+h[0].length};return _.lastIndex=0,S}return null}e.getWordAtText=D;function A(P,_,C,s){let I;for(;I=P.exec(_);){const l=I.index||0;if(l<=C&&P.lastIndex>=C)return I;if(s>0&&l>s)return null}return null}}),define(ge[141],pe([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var v;(function(A){A[A.None=0]="None",A[A.Indent=1]="Indent",A[A.IndentOutdent=2]="IndentOutdent",A[A.Outdent=3]="Outdent"})(v=e.IndentAction||(e.IndentAction={}));class R{constructor(P){if(this.open=P.open,this.close=P.close,this._standardTokenMask=0,Array.isArray(P.notIn))for(let _=0,C=P.notIn.length;_<C;_++)switch(P.notIn[_]){case"string":this._standardTokenMask|=2;break;case"comment":this._standardTokenMask|=1;break;case"regex":this._standardTokenMask|=4;break}}isOK(P){return(this._standardTokenMask&P)==0}}e.StandardAutoClosingPairConditional=R;class k{constructor(P){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const _ of P)D(this.autoClosingPairsOpenByStart,_.open.charAt(0),_),D(this.autoClosingPairsOpenByEnd,_.open.charAt(_.open.length-1),_),D(this.autoClosingPairsCloseByStart,_.close.charAt(0),_),D(this.autoClosingPairsCloseByEnd,_.close.charAt(_.close.length-1),_),_.close.length===1&&_.open.length===1&&D(this.autoClosingPairsCloseSingleChar,_.close,_)}}e.AutoClosingPairs=k;function D(A,P,_){A.has(P)?A.get(P).push(_):A.set(P,[_])}}),define(ge[76],pe([0,1,30,9]),function(Q,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function k(D,A,P,_){if(Array.isArray(D)){let C=0;for(const s of D){const I=k(s,A,P,_);if(I===10)return I;I>C&&(C=I)}return C}else{if(typeof D=="string")return _?D==="*"?5:D===P?10:0:0;if(D){const{language:C,pattern:s,scheme:I,hasAccessToAllModels:l}=D;if(!_&&!l)return 0;let m=0;if(I)if(I===A.scheme)m=10;else if(I==="*")m=5;else return 0;if(C)if(C===P)m=10;else if(C==="*")m=Math.max(m,5);else return 0;if(s){let c;if(typeof s=="string"?c=s:c=Object.assign(Object.assign({},s),{base:R.normalize(s.base)}),c===A.fsPath||v.match(c,A.fsPath))m=10;else return 0}return m}else return 0}}e.score=k}),define(ge[142],pe([0,1,106]),function(Q,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeLinks=e.LinkComputer=e.StateMachine=e.Uint8Matrix=e.State=void 0;var R;(function(m){m[m.Invalid=0]="Invalid",m[m.Start=1]="Start",m[m.H=2]="H",m[m.HT=3]="HT",m[m.HTT=4]="HTT",m[m.HTTP=5]="HTTP",m[m.F=6]="F",m[m.FI=7]="FI",m[m.FIL=8]="FIL",m[m.BeforeColon=9]="BeforeColon",m[m.AfterColon=10]="AfterColon",m[m.AlmostThere=11]="AlmostThere",m[m.End=12]="End",m[m.Accept=13]="Accept",m[m.LastKnownState=14]="LastKnownState"})(R=e.State||(e.State={}));class k{constructor(c,h,S){const w=new Uint8Array(c*h);for(let b=0,u=c*h;b<u;b++)w[b]=S;this._data=w,this.rows=c,this.cols=h}get(c,h){return this._data[c*this.cols+h]}set(c,h,S){this._data[c*this.cols+h]=S}}e.Uint8Matrix=k;class D{constructor(c){let h=0,S=0;for(let b=0,u=c.length;b<u;b++){let[d,p,t]=c[b];p>h&&(h=p),d>S&&(S=d),t>S&&(S=t)}h++,S++;let w=new k(S,h,0);for(let b=0,u=c.length;b<u;b++){let[d,p,t]=c[b];w.set(d,p,t)}this._states=w,this._maxCharCode=h}nextState(c,h){return h<0||h>=this._maxCharCode?0:this._states.get(c,h)}}e.StateMachine=D;let A=null;function P(){return A===null&&(A=new D([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),A}var _;(function(m){m[m.None=0]="None",m[m.ForceTermination=1]="ForceTermination",m[m.CannotEndIn=2]="CannotEndIn"})(_||(_={}));let C=null;function s(){if(C===null){C=new v.CharacterClassifier(0);const m=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let h=0;h<m.length;h++)C.set(m.charCodeAt(h),1);const c=".,;";for(let h=0;h<c.length;h++)C.set(c.charCodeAt(h),2)}return C}class I{static _createLink(c,h,S,w,b){let u=b-1;do{const d=h.charCodeAt(u);if(c.get(d)!==2)break;u--}while(u>w);if(w>0){const d=h.charCodeAt(w-1),p=h.charCodeAt(u);(d===40&&p===41||d===91&&p===93||d===123&&p===125)&&u--}return{range:{startLineNumber:S,startColumn:w+1,endLineNumber:S,endColumn:u+2},url:h.substring(w,u+1)}}static computeLinks(c,h=P()){const S=s();let w=[];for(let b=1,u=c.getLineCount();b<=u;b++){const d=c.getLineContent(b),p=d.length;let t=0,i=0,r=0,n=1,o=!1,g=!1,f=!1,E=!1;for(;t<p;){let y=!1;const a=d.charCodeAt(t);if(n===13){let L;switch(a){case 40:o=!0,L=0;break;case 41:L=o?0:1;break;case 91:f=!0,g=!0,L=0;break;case 93:f=!1,L=g?0:1;break;case 123:E=!0,L=0;break;case 125:L=E?0:1;break;case 39:L=r===34||r===96?0:1;break;case 34:L=r===39||r===96?0:1;break;case 96:L=r===39||r===34?0:1;break;case 42:L=r===42?1:0;break;case 124:L=r===124?1:0;break;case 32:L=f?0:1;break;default:L=S.get(a)}L===1&&(w.push(I._createLink(S,d,b,i,t)),y=!0)}else if(n===12){let L;a===91?(g=!0,L=0):L=S.get(a),L===1?y=!0:n=13}else n=h.nextState(n,a),n===0&&(y=!0);y&&(n=1,o=!1,g=!1,E=!1,i=t+1,r=a),t++}n===13&&w.push(I._createLink(S,d,b,i,p))}return w}}e.LinkComputer=I;function l(m){return!m||typeof m.getLineCount!="function"||typeof m.getLineContent!="function"?[]:I.computeLinks(m)}e.computeLinks=l}),define(ge[143],pe([0,1,3,6]),function(Q,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistryImpl=void 0;class k{constructor(){this._map=new Map,this._promises=new Map,this._onDidChange=new v.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}fire(A){this._onDidChange.fire({changedLanguages:A,changedColorMap:!1})}register(A,P){return this._map.set(A,P),this.fire([A]),R.toDisposable(()=>{this._map.get(A)===P&&(this._map.delete(A),this.fire([A]))})}registerPromise(A,P){let _=null,C=!1;return this._promises.set(A,P.then(s=>{this._promises.delete(A),!(C||!s)&&(_=this.register(A,s))})),R.toDisposable(()=>{C=!0,_&&_.dispose()})}getPromise(A){const P=this.get(A);if(P)return Promise.resolve(P);const _=this._promises.get(A);return _?_.then(C=>this.get(A)):null}get(A){return this._map.get(A)||null}setColorMap(A){this._colorMap=A,this._onDidChange.fire({changedLanguages:Array.from(this._map.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}e.TokenizationRegistryImpl=k}),define(ge[109],pe([0,1,22,11]),function(Q,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var k;(function(I){I[I.Full=1]="Full",I[I.Delta=2]="Delta"})(k||(k={}));function D(I){for(let l=0,m=I.length;l<m;l+=4){const c=I[l+0],h=I[l+1],S=I[l+2],w=I[l+3];I[l+0]=w,I[l+1]=S,I[l+2]=h,I[l+3]=c}}function A(I){const l=new Uint8Array(I.buffer,I.byteOffset,I.length*4);return R.isLittleEndian()||D(l),v.VSBuffer.wrap(l)}function P(I){const l=I.buffer;if(R.isLittleEndian()||D(l),l.byteOffset%4==0)return new Uint32Array(l.buffer,l.byteOffset,l.length/4);{const m=new Uint8Array(l.byteLength);return m.set(l),new Uint32Array(m.buffer,m.byteOffset,m.length/4)}}function _(I){const l=new Uint32Array(C(I));let m=0;if(l[m++]=I.id,I.type==="full")l[m++]=1,l[m++]=I.data.length,l.set(I.data,m),m+=I.data.length;else{l[m++]=2,l[m++]=I.deltas.length;for(const c of I.deltas)l[m++]=c.start,l[m++]=c.deleteCount,c.data?(l[m++]=c.data.length,l.set(c.data,m),m+=c.data.length):l[m++]=0}return A(l)}e.encodeSemanticTokensDto=_;function C(I){let l=0;if(l+=1+1,I.type==="full")l+=1+I.data.length;else{l+=1,l+=(1+1+1)*I.deltas.length;for(const m of I.deltas)m.data&&(l+=m.data.length)}return l}function s(I){const l=P(I);let m=0;const c=l[m++];if(l[m++]===1){const b=l[m++],u=l.subarray(m,m+b);return m+=b,{id:c,type:"full",data:u}}const S=l[m++];let w=[];for(let b=0;b<S;b++){const u=l[m++],d=l[m++],p=l[m++];let t;p>0&&(t=l.subarray(m,m+p),m+=p),w[b]={start:u,deleteCount:d,data:t}}return{id:c,type:"delta",deltas:w}}e.decodeSemanticTokensDto=s}),define(ge[110],pe([0,1,94]),function(Q,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PrefixSumComputer=e.PrefixSumIndexOfResult=void 0;class R{constructor(A,P){this.index=A,this.remainder=P}}e.PrefixSumIndexOfResult=R;class k{constructor(A){this.values=A,this.prefixSum=new Uint32Array(A.length),this.prefixSumValidIndex=new Int32Array(1),this.prefixSumValidIndex[0]=-1}getCount(){return this.values.length}insertValues(A,P){A=v.toUint32(A);const _=this.values,C=this.prefixSum,s=P.length;return s===0?!1:(this.values=new Uint32Array(_.length+s),this.values.set(_.subarray(0,A),0),this.values.set(_.subarray(A),A+s),this.values.set(P,A),A-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=A-1),this.prefixSum=new Uint32Array(this.values.length),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(C.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}changeValue(A,P){return A=v.toUint32(A),P=v.toUint32(P),this.values[A]===P?!1:(this.values[A]=P,A-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=A-1),!0)}removeValues(A,P){A=v.toUint32(A),P=v.toUint32(P);const _=this.values,C=this.prefixSum;if(A>=_.length)return!1;let s=_.length-A;return P>=s&&(P=s),P===0?!1:(this.values=new Uint32Array(_.length-P),this.values.set(_.subarray(0,A),0),this.values.set(_.subarray(A+P),A),this.prefixSum=new Uint32Array(this.values.length),A-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=A-1),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(C.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}getTotalValue(){return this.values.length===0?0:this._getAccumulatedValue(this.values.length-1)}getAccumulatedValue(A){return A<0?0:(A=v.toUint32(A),this._getAccumulatedValue(A))}_getAccumulatedValue(A){if(A<=this.prefixSumValidIndex[0])return this.prefixSum[A];let P=this.prefixSumValidIndex[0]+1;P===0&&(this.prefixSum[0]=this.values[0],P++),A>=this.values.length&&(A=this.values.length-1);for(let _=P;_<=A;_++)this.prefixSum[_]=this.prefixSum[_-1]+this.values[_];return this.prefixSumValidIndex[0]=Math.max(this.prefixSumValidIndex[0],A),this.prefixSum[A]}getIndexOf(A){A=Math.floor(A),this.getTotalValue();let P=0,_=this.values.length-1,C=0,s=0,I=0;for(;P<=_;)if(C=P+(_-P)/2|0,s=this.prefixSum[C],I=s-this.values[C],A<I)_=C-1;else if(A>=s)P=C+1;else break;return new R(C,A-I)}}e.PrefixSumComputer=k}),define(ge[144],pe([0,1,8,44,110]),function(Q,e,v,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MirrorTextModel=void 0;class D{constructor(P,_,C,s){this._uri=P,this._lines=_,this._eol=C,this._versionId=s,this._lineStarts=null,this._cachedTextValue=null}dispose(){this._lines.length=0}get version(){return this._versionId}getText(){return this._cachedTextValue===null&&(this._cachedTextValue=this._lines.join(this._eol)),this._cachedTextValue}onEvents(P){P.eol&&P.eol!==this._eol&&(this._eol=P.eol,this._lineStarts=null);const _=P.changes;for(const C of _)this._acceptDeleteRange(C.range),this._acceptInsertText(new R.Position(C.range.startLineNumber,C.range.startColumn),C.text);this._versionId=P.versionId,this._cachedTextValue=null}_ensureLineStarts(){if(!this._lineStarts){const P=this._eol.length,_=this._lines.length,C=new Uint32Array(_);for(let s=0;s<_;s++)C[s]=this._lines[s].length+P;this._lineStarts=new k.PrefixSumComputer(C)}}_setLineText(P,_){this._lines[P]=_,this._lineStarts&&this._lineStarts.changeValue(P,this._lines[P].length+this._eol.length)}_acceptDeleteRange(P){if(P.startLineNumber===P.endLineNumber){if(P.startColumn===P.endColumn)return;this._setLineText(P.startLineNumber-1,this._lines[P.startLineNumber-1].substring(0,P.startColumn-1)+this._lines[P.startLineNumber-1].substring(P.endColumn-1));return}this._setLineText(P.startLineNumber-1,this._lines[P.startLineNumber-1].substring(0,P.startColumn-1)+this._lines[P.endLineNumber-1].substring(P.endColumn-1)),this._lines.splice(P.startLineNumber,P.endLineNumber-P.startLineNumber),this._lineStarts&&this._lineStarts.removeValues(P.startLineNumber,P.endLineNumber-P.startLineNumber)}_acceptInsertText(P,_){if(_.length===0)return;let C=v.splitLines(_);if(C.length===1){this._setLineText(P.lineNumber-1,this._lines[P.lineNumber-1].substring(0,P.column-1)+C[0]+this._lines[P.lineNumber-1].substring(P.column-1));return}C[C.length-1]+=this._lines[P.lineNumber-1].substring(P.column-1),this._setLineText(P.lineNumber-1,this._lines[P.lineNumber-1].substring(0,P.column-1)+C[0]);let s=new Uint32Array(C.length-1);for(let I=1;I<C.length;I++)this._lines.splice(P.lineNumber+I-1,0,C[I]),s[I-1]=C[I].length+this._eol.length;this._lineStarts&&this._lineStarts.insertValues(P.lineNumber,s)}}e.MirrorTextModel=D}),define(ge[145],pe([19,20]),function(Q,e){return Q.create("vs/base/common/date",e)}),define(ge[146],pe([0,1,145]),function(Q,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const R=60,k=R*60,D=k*24,A=D*7,P=D*30,_=D*365;function C(I,l){typeof I!="number"&&(I=I.getTime());const m=Math.round((new Date().getTime()-I)/1e3);if(m<-30)return v.localize(0,null,C(new Date().getTime()+m*1e3,!1));if(m<30)return v.localize(1,null);let c;return m<R?(c=m,l?c===1?v.localize(2,null,c):v.localize(3,null,c):c===1?v.localize(4,null,c):v.localize(5,null,c)):m<k?(c=Math.floor(m/R),l?c===1?v.localize(6,null,c):v.localize(7,null,c):c===1?v.localize(8,null,c):v.localize(9,null,c)):m<D?(c=Math.floor(m/k),l?c===1?v.localize(10,null,c):v.localize(11,null,c):c===1?v.localize(12,null,c):v.localize(13,null,c)):m<A?(c=Math.floor(m/D),l?c===1?v.localize(14,null,c):v.localize(15,null,c):c===1?v.localize(16,null,c):v.localize(17,null,c)):m<P?(c=Math.floor(m/A),l?c===1?v.localize(18,null,c):v.localize(19,null,c):c===1?v.localize(20,null,c):v.localize(21,null,c)):m<_?(c=Math.floor(m/P),l?c===1?v.localize(22,null,c):v.localize(23,null,c):c===1?v.localize(24,null,c):v.localize(25,null,c)):(c=Math.floor(m/_),l?c===1?v.localize(26,null,c):v.localize(27,null,c):c===1?v.localize(28,null,c):v.localize(29,null,c))}e.fromNow=C;function s(I){return I.getFullYear()+"-"+String(I.getMonth()+1).padStart(2,"0")+"-"+String(I.getDate()).padStart(2,"0")+"T"+String(I.getHours()).padStart(2,"0")+":"+String(I.getMinutes()).padStart(2,"0")+":"+String(I.getSeconds()).padStart(2,"0")+"."+(I.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=s}),define(ge[147],pe([19,20]),function(Q,e){return Q.create("vs/base/common/errorMessage",e)}),define(ge[56],pe([0,1,147,15,18]),function(Q,e,v,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function D(C,s){return s&&(C.stack||C.stacktrace)?v.localize(0,null,P(C),A(C.stack)||A(C.stacktrace)):P(C)}function A(C){return Array.isArray(C)?C.join(`
`):C}function P(C){return typeof C.code=="string"&&typeof C.errno=="number"&&typeof C.syscall=="string"?v.localize(1,null,C.message):C.message||v.localize(2,null)}function _(C=null,s=!1){if(!C)return v.localize(3,null);if(Array.isArray(C)){const I=k.coalesce(C),l=_(I[0],s);return I.length>1?v.localize(4,null,l,I.length):l}if(R.isString(C))return C;if(C.detail){const I=C.detail;if(I.error)return D(I.error,s);if(I.exception)return D(I.exception,s)}return C.stack?D(C,s):C.message?C.message:v.localize(5,null)}e.toErrorMessage=_}),define(ge[148],pe([19,20]),function(Q,e){return Q.create("vs/base/node/processes",e)}),define(ge[111],pe([0,1,9,28,38,148,37,15,25,29,11,137,10]),function(Q,e,v,R,k,D,A,P,_,C,s,I,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0;function m(d){switch(d){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function c(d,p){if(s.isWindows)try{const t={stdio:["pipe","pipe","ignore"]};p&&(t.cwd=p);const i=k.execFile("taskkill",["/T","/F","/PID",d.pid.toString()],t);return new Promise(r=>{i.once("error",n=>{r({success:!1,error:n})}),i.once("exit",(n,o)=>{r(n===0?{success:!0}:{success:!1,code:n!==null?n:1})})})}catch(t){return Promise.resolve({success:!1,error:t,code:t.status?m(t.status):1})}else if(s.isLinux||s.isMacintosh)try{const t=l.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",Q).fsPath;return new Promise(i=>{k.execFile(t,[d.pid.toString()],{encoding:"utf8",shell:!0},(r,n,o)=>{i(r?{success:!1,error:r}:{success:!0})})})}catch(t){return Promise.resolve({success:!1,error:t})}else d.kill("SIGKILL");return Promise.resolve({success:!0})}function h(d=A.env){return d.comspec||"cmd.exe"}e.getWindowsShell=h;class S{constructor(p,t,i,r){if(t!==void 0&&i!==void 0&&r!==void 0)this.cmd=p,this.args=t,this.shell=i,this.options=r;else{const n=p;this.cmd=n.command,this.shell=n.isShellCommand,this.args=n.args.slice(0),this.options=n.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const n=Object.create(null);Object.keys(A.env).forEach(o=>{n[o]=A.env[o]}),Object.keys(this.options.env).forEach(o=>{n[o]=this.options.env[o]}),this.options.env=n}}getSanitizedCommand(){let p=this.cmd.toLowerCase();const t=p.lastIndexOf(v.sep);return t!==-1&&(p=p.substring(t+1)),S.WellKnowCommands[p]?p:"other"}start(p){return s.isWindows&&(this.options&&this.options.cwd&&C.isUNC(this.options.cwd)||!this.options&&C.isUNC(A.cwd()))?Promise.reject(new Error(D.localize(0,null))):this.useExec().then(t=>{let i,r;const n=new Promise((o,g)=>{i=o,r=g});if(t){let o=this.cmd;this.args&&(o=o+" "+this.args.join(" ")),this.childProcess=k.exec(o,this.options,(g,f,E)=>{this.childProcess=null;const y=g;y&&y.killed?r({killed:this.terminateRequested,stdout:f.toString(),stderr:E.toString()}):this.handleExec(i,p,g,f,E)})}else{let o=null;const g=f=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(f,i,p,r);const E={terminated:this.terminateRequested};P.isNumber(f)&&(E.cmdCode=f),i(E)};if(this.shell&&s.isWindows){const f=_.deepClone(this.options);f.windowsVerbatimArguments=!0,f.detached=!1;let E=!1,y=!1;const a=[];let L=this.ensureQuotes(this.cmd);a.push(L.value),E=L.quoted,this.args&&this.args.forEach(W=>{L=this.ensureQuotes(W),a.push(L.value),y=y&&L.quoted});const O=["/s","/c"];E?y?O.push('"'+a.join(" ")+'"'):a.length>1?O.push('"'+a[0]+'" '+a.slice(1).join(" ")):O.push('"'+a[0]+'"'):O.push(a.join(" ")),o=k.spawn(h(),O,f)}else this.cmd&&(o=k.spawn(this.cmd,this.args,this.options));o&&(this.childProcess=o,this.childProcessPromise=Promise.resolve(o),this.pidResolve&&(this.pidResolve(P.isNumber(o.pid)?o.pid:-1),this.pidResolve=void 0),o.on("error",f=>{this.childProcess=null,r({terminated:this.terminateRequested,error:f})}),o.pid&&(this.childProcess.on("close",g),this.handleSpawn(o,i,p,r,!0)))}return n})}handleClose(p,t,i,r){}ensureQuotes(p){return S.regexp.test(p)?{value:'"'+p+'"',quoted:!0}:{value:p,quoted:p.length>0&&p[0]==='"'&&p[p.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(p=>p.pid,p=>-1):new Promise(p=>{this.pidResolve=p})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(p=>(this.terminateRequested=!0,c(p,this.options.cwd).then(t=>(t.success&&(this.childProcess=null),t))),p=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(p=>{if(!this.shell||!s.isWindows)return p(!1);const t=k.spawn(h(),["/s","/c"]);t.on("error",i=>p(!0)),t.on("exit",i=>p(!1))})}}e.AbstractProcess=S,S.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},S.regexp=/^[^"].* .*[^"]/;class w extends S{constructor(p,t,i,r){super(p,t,i,r);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(p,t,i,r,n){[r,n].forEach((o,g)=>{const f=new I.LineDecoder;f.write(o).forEach(a=>{t({line:a,source:g===0?0:1})});const y=f.end();y&&t({line:y,source:g===0?0:1})}),p({terminated:this.terminateRequested,error:i})}handleSpawn(p,t,i,r,n){const o=new I.LineDecoder,g=new I.LineDecoder;p.stdout.on("data",f=>{o.write(f).forEach(y=>i({line:y,source:0}))}),p.stderr.on("data",f=>{g.write(f).forEach(y=>i({line:y,source:1}))}),this.stdoutLineDecoder=o,this.stderrLineDecoder=g}handleClose(p,t,i,r){const n=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;n&&i({line:n,source:0});const o=this.stderrLineDecoder?this.stderrLineDecoder.end():null;o&&i({line:o,source:1})}}e.LineProcess=w;function b(d){let p=[],t=!1;const i=function(r){if(t){p.push(r);return}(!d.send(r,o=>{if(o&&console.error(o),t=!1,p.length>0){const g=p.slice(0);p=[],g.forEach(f=>i(f))}})||s.isWindows)&&(t=!0)};return{send:i}}e.createQueuedSender=b;var u;(function(d){async function p(t,i,r){if(v.isAbsolute(t))return t;if(i===void 0&&(i=A.cwd()),v.dirname(t)!=="."||(r===void 0&&P.isString(A.env.PATH)&&(r=A.env.PATH.split(v.delimiter)),r===void 0||r.length===0))return v.join(i,t);async function o(g){return await R.Promises.exists(g)?!(await R.Promises.stat(g)).isDirectory():!1}for(let g of r){let f;if(v.isAbsolute(g)?f=v.join(g,t):f=v.join(i,g,t),await o(f))return f;let E=f+".com";if(await o(E)||(E=f+".exe",await o(E)))return E}return v.join(i,t)}d.findExecutable=p})(u=e.win32||(e.win32={}))}),define(ge[149],pe([19,20]),function(Q,e){return Q.create("vs/editor/common/config/editorOptions",e)}),define(ge[150],pe([0,1,149,11,108]),function(Q,e,v,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_MODEL_DEFAULTS=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.boolean=e.ComputeOptionsMemory=e.ValidatedEditorOptions=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var D;(function(G){G[G.None=0]="None",G[G.Keep=1]="Keep",G[G.Brackets=2]="Brackets",G[G.Advanced=3]="Advanced",G[G.Full=4]="Full"})(D=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class A{constructor(ie){this._values=ie}hasChanged(ie){return this._values[ie]}}e.ConfigurationChangedEvent=A;class P{constructor(){this._values=[]}_read(ie){return this._values[ie]}get(ie){return this._values[ie]}_write(ie,ve){this._values[ie]=ve}}e.ValidatedEditorOptions=P;class _{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=_;class C{constructor(ie,ve,Fe,Ne){this.id=ie,this.name=ve,this.defaultValue=Fe,this.schema=Ne}compute(ie,ve,Fe){return Fe}}class s{constructor(ie,ve=null){this.schema=void 0,this.id=ie,this.name="_never_",this.defaultValue=void 0,this.deps=ve}validate(ie){return this.defaultValue}}class I{constructor(ie,ve,Fe,Ne){this.id=ie,this.name=ve,this.defaultValue=Fe,this.schema=Ne}validate(ie){return typeof ie=="undefined"?this.defaultValue:ie}compute(ie,ve,Fe){return Fe}}function l(G,ie){return typeof G=="undefined"?ie:G==="false"?!1:Boolean(G)}e.boolean=l;class m extends I{constructor(ie,ve,Fe,Ne=void 0){typeof Ne!="undefined"&&(Ne.type="boolean",Ne.default=Fe),super(ie,ve,Fe,Ne)}validate(ie){return l(ie,this.defaultValue)}}class c extends I{constructor(ie,ve,Fe,Ne,Qe,De=void 0){typeof De!="undefined"&&(De.type="integer",De.default=Fe,De.minimum=Ne,De.maximum=Qe),super(ie,ve,Fe,De),this.minimum=Ne,this.maximum=Qe}static clampedInt(ie,ve,Fe,Ne){if(typeof ie=="undefined")return ve;let Qe=parseInt(ie,10);return isNaN(Qe)?ve:(Qe=Math.max(Fe,Qe),Qe=Math.min(Ne,Qe),Qe|0)}validate(ie){return c.clampedInt(ie,this.defaultValue,this.minimum,this.maximum)}}class h extends I{constructor(ie,ve,Fe,Ne,Qe){typeof Qe!="undefined"&&(Qe.type="number",Qe.default=Fe),super(ie,ve,Fe,Qe),this.validationFn=Ne}static clamp(ie,ve,Fe){return ie<ve?ve:ie>Fe?Fe:ie}static float(ie,ve){if(typeof ie=="number")return ie;if(typeof ie=="undefined")return ve;const Fe=parseFloat(ie);return isNaN(Fe)?ve:Fe}validate(ie){return this.validationFn(h.float(ie,this.defaultValue))}}class S extends I{static string(ie,ve){return typeof ie!="string"?ve:ie}constructor(ie,ve,Fe,Ne=void 0){typeof Ne!="undefined"&&(Ne.type="string",Ne.default=Fe),super(ie,ve,Fe,Ne)}validate(ie){return S.string(ie,this.defaultValue)}}function w(G,ie,ve){return typeof G!="string"||ve.indexOf(G)===-1?ie:G}e.stringSet=w;class b extends I{constructor(ie,ve,Fe,Ne,Qe=void 0){typeof Qe!="undefined"&&(Qe.type="string",Qe.enum=Ne,Qe.default=Fe),super(ie,ve,Fe,Qe),this._allowedValues=Ne}validate(ie){return w(ie,this.defaultValue,this._allowedValues)}}class u extends C{constructor(ie,ve,Fe,Ne,Qe,De,Se=void 0){typeof Se!="undefined"&&(Se.type="string",Se.enum=Qe,Se.default=Ne),super(ie,ve,Fe,Se),this._allowedValues=Qe,this._convert=De}validate(ie){return typeof ie!="string"?this.defaultValue:this._allowedValues.indexOf(ie)===-1?this.defaultValue:this._convert(ie)}}function d(G){switch(G){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class p extends C{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[v.localize(0,null),v.localize(1,null),v.localize(2,null)],default:"auto",description:v.localize(3,null)})}validate(ie){switch(ie){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(ie,ve,Fe){return Fe===0?ie.accessibilitySupport:Fe}}class t extends C{constructor(){const ie={insertSpace:!0,ignoreEmptyLines:!0};super(17,"comments",ie,{"editor.comments.insertSpace":{type:"boolean",default:ie.insertSpace,description:v.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:ie.ignoreEmptyLines,description:v.localize(5,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const ve=ie;return{insertSpace:l(ve.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:l(ve.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var i;(function(G){G[G.Hidden=0]="Hidden",G[G.Blink=1]="Blink",G[G.Smooth=2]="Smooth",G[G.Phase=3]="Phase",G[G.Expand=4]="Expand",G[G.Solid=5]="Solid"})(i=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function r(G){switch(G){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var n;(function(G){G[G.Line=1]="Line",G[G.Block=2]="Block",G[G.Underline=3]="Underline",G[G.LineThin=4]="LineThin",G[G.BlockOutline=5]="BlockOutline",G[G.UnderlineThin=6]="UnderlineThin"})(n=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function o(G){switch(G){case n.Line:return"line";case n.Block:return"block";case n.Underline:return"underline";case n.LineThin:return"line-thin";case n.BlockOutline:return"block-outline";case n.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=o;function g(G){switch(G){case"line":return n.Line;case"block":return n.Block;case"underline":return n.Underline;case"line-thin":return n.LineThin;case"block-outline":return n.BlockOutline;case"underline-thin":return n.UnderlineThin}}class f extends s{constructor(){super(125,[63,31])}compute(ie,ve,Fe){const Ne=["monaco-editor"];return ve.get(31)&&Ne.push(ve.get(31)),ie.extraEditorClassName&&Ne.push(ie.extraEditorClassName),ve.get(63)==="default"?Ne.push("mouse-default"):ve.get(63)==="copy"&&Ne.push("mouse-copy"),ve.get(98)&&Ne.push("showUnused"),ve.get(123)&&Ne.push("showDeprecated"),Ne.join(" ")}}class E extends m{constructor(){super(30,"emptySelectionClipboard",!0,{description:v.localize(6,null)})}compute(ie,ve,Fe){return Fe&&ie.emptySelectionClipboard}}class y extends C{constructor(){const ie={cursorMoveOnType:!0,seedSearchStringFromSelection:!0,autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(33,"find",ie,{"editor.find.cursorMoveOnType":{type:"boolean",default:ie.cursorMoveOnType,description:v.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"boolean",default:ie.seedSearchStringFromSelection,description:v.localize(8,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:ie.autoFindInSelection,enumDescriptions:[v.localize(9,null),v.localize(10,null),v.localize(11,null)],description:v.localize(12,null)},"editor.find.globalFindClipboard":{type:"boolean",default:ie.globalFindClipboard,description:v.localize(13,null),included:R.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:ie.addExtraSpaceOnTop,description:v.localize(14,null)},"editor.find.loop":{type:"boolean",default:ie.loop,description:v.localize(15,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const ve=ie;return{cursorMoveOnType:l(ve.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:l(ve.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection),autoFindInSelection:typeof ie.autoFindInSelection=="boolean"?ie.autoFindInSelection?"always":"never":w(ve.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:l(ve.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:l(ve.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:l(ve.loop,this.defaultValue.loop)}}}class a extends C{constructor(){super(41,"fontLigatures",a.OFF,{anyOf:[{type:"boolean",description:v.localize(16,null)},{type:"string",description:v.localize(17,null)}],description:v.localize(18,null),default:!1})}validate(ie){return typeof ie=="undefined"?this.defaultValue:typeof ie=="string"?ie==="false"?a.OFF:ie==="true"?a.ON:ie:Boolean(ie)?a.ON:a.OFF}}e.EditorFontLigatures=a,a.OFF='"liga" off, "calt" off',a.ON='"liga" on, "calt" on';class L extends s{constructor(){super(40)}compute(ie,ve,Fe){return ie.fontInfo}}class O extends I{constructor(){super(42,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:v.localize(19,null)})}validate(ie){let ve=h.float(ie,this.defaultValue);return ve===0?e.EDITOR_FONT_DEFAULTS.fontSize:h.clamp(ve,6,100)}compute(ie,ve,Fe){return ie.fontInfo.fontSize}}class W extends C{constructor(){super(43,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:W.MINIMUM_VALUE,maximum:W.MAXIMUM_VALUE,errorMessage:v.localize(20,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:W.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:v.localize(21,null)})}validate(ie){return ie==="normal"||ie==="bold"?ie:String(c.clampedInt(ie,e.EDITOR_FONT_DEFAULTS.fontWeight,W.MINIMUM_VALUE,W.MAXIMUM_VALUE))}}W.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"],W.MINIMUM_VALUE=1,W.MAXIMUM_VALUE=1e3;class J extends C{constructor(){const ie={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},ve={type:"string",enum:["peek","gotoAndPeek","goto"],default:ie.multiple,enumDescriptions:[v.localize(22,null),v.localize(23,null),v.localize(24,null)]},Fe=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(47,"gotoLocation",ie,{"editor.gotoLocation.multiple":{deprecationMessage:v.localize(25,null)},"editor.gotoLocation.multipleDefinitions":Object.assign({description:v.localize(26,null)},ve),"editor.gotoLocation.multipleTypeDefinitions":Object.assign({description:v.localize(27,null)},ve),"editor.gotoLocation.multipleDeclarations":Object.assign({description:v.localize(28,null)},ve),"editor.gotoLocation.multipleImplementations":Object.assign({description:v.localize(29,null)},ve),"editor.gotoLocation.multipleReferences":Object.assign({description:v.localize(30,null)},ve),"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:ie.alternativeDefinitionCommand,enum:Fe,description:v.localize(31,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:ie.alternativeTypeDefinitionCommand,enum:Fe,description:v.localize(32,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:ie.alternativeDeclarationCommand,enum:Fe,description:v.localize(33,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:ie.alternativeImplementationCommand,enum:Fe,description:v.localize(34,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:ie.alternativeReferenceCommand,enum:Fe,description:v.localize(35,null)}})}validate(ie){var ve,Fe,Ne,Qe,De;if(!ie||typeof ie!="object")return this.defaultValue;const Se=ie;return{multiple:w(Se.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:(ve=Se.multipleDefinitions)!==null&&ve!==void 0?ve:w(Se.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:(Fe=Se.multipleTypeDefinitions)!==null&&Fe!==void 0?Fe:w(Se.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:(Ne=Se.multipleDeclarations)!==null&&Ne!==void 0?Ne:w(Se.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:(Qe=Se.multipleImplementations)!==null&&Qe!==void 0?Qe:w(Se.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:(De=Se.multipleReferences)!==null&&De!==void 0?De:w(Se.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:S.string(Se.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:S.string(Se.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:S.string(Se.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:S.string(Se.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:S.string(Se.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class se extends C{constructor(){const ie={enabled:!0,delay:300,sticky:!0};super(50,"hover",ie,{"editor.hover.enabled":{type:"boolean",default:ie.enabled,description:v.localize(36,null)},"editor.hover.delay":{type:"number",default:ie.delay,description:v.localize(37,null)},"editor.hover.sticky":{type:"boolean",default:ie.sticky,description:v.localize(38,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const ve=ie;return{enabled:l(ve.enabled,this.defaultValue.enabled),delay:c.clampedInt(ve.delay,this.defaultValue.delay,0,1e4),sticky:l(ve.sticky,this.defaultValue.sticky)}}}var q;(function(G){G[G.None=0]="None",G[G.Text=1]="Text",G[G.Blocks=2]="Blocks"})(q=e.RenderMinimap||(e.RenderMinimap={}));class N extends s{constructor(){super(128,[46,55,35,62,90,57,58,92,115,118,119,120,2])}compute(ie,ve,Fe){return N.computeLayout(ve,{memory:ie.memory,outerWidth:ie.outerWidth,outerHeight:ie.outerHeight,isDominatedByLongLines:ie.isDominatedByLongLines,lineHeight:ie.fontInfo.lineHeight,viewLineCount:ie.viewLineCount,lineNumbersDigitCount:ie.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:ie.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:ie.fontInfo.maxDigitWidth,pixelRatio:ie.pixelRatio})}static computeContainedMinimapLineCount(ie){const ve=ie.height/ie.lineHeight,Fe=ie.scrollBeyondLastLine?ve-1:0,Ne=(ie.viewLineCount+Fe)/(ie.pixelRatio*ie.height),Qe=Math.floor(ie.viewLineCount/Ne);return{typicalViewportLineCount:ve,extraLinesBeyondLastLine:Fe,desiredRatio:Ne,minimapLineCount:Qe}}static _computeMinimapLayout(ie,ve){const Fe=ie.outerWidth,Ne=ie.outerHeight,Qe=ie.pixelRatio;if(!ie.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(Qe*Ne),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Ne};const De=ve.stableMinimapLayoutInput,Se=De&&ie.outerHeight===De.outerHeight&&ie.lineHeight===De.lineHeight&&ie.typicalHalfwidthCharacterWidth===De.typicalHalfwidthCharacterWidth&&ie.pixelRatio===De.pixelRatio&&ie.scrollBeyondLastLine===De.scrollBeyondLastLine&&ie.minimap.enabled===De.minimap.enabled&&ie.minimap.side===De.minimap.side&&ie.minimap.size===De.minimap.size&&ie.minimap.showSlider===De.minimap.showSlider&&ie.minimap.renderCharacters===De.minimap.renderCharacters&&ie.minimap.maxColumn===De.minimap.maxColumn&&ie.minimap.scale===De.minimap.scale&&ie.verticalScrollbarWidth===De.verticalScrollbarWidth&&ie.isViewportWrapping===De.isViewportWrapping,Pe=ie.lineHeight,ae=ie.typicalHalfwidthCharacterWidth,he=ie.scrollBeyondLastLine,z=ie.minimap.renderCharacters;let ee=Qe>=2?Math.round(ie.minimap.scale*2):ie.minimap.scale;const ue=ie.minimap.maxColumn,Ie=ie.minimap.size,Te=ie.minimap.side,xe=ie.verticalScrollbarWidth,He=ie.viewLineCount,Ze=ie.remainingWidth,Ye=ie.isViewportWrapping,Xe=z?2:3;let nt=Math.floor(Qe*Ne);const pt=nt/Qe;let _e=!1,ye=!1,de=Xe*ee,K=ee/Qe,Ue=1;if(Ie==="fill"||Ie==="fit"){const{typicalViewportLineCount:ft,extraLinesBeyondLastLine:Et,desiredRatio:bt,minimapLineCount:Rt}=N.computeContainedMinimapLineCount({viewLineCount:He,scrollBeyondLastLine:he,height:Ne,lineHeight:Pe,pixelRatio:Qe});if(He/Rt>1)_e=!0,ye=!0,ee=1,de=1,K=ee/Qe;else{let ut=!1,mt=ee+1;if(Ie==="fit"){const dt=Math.ceil((He+Et)*de);Ye&&Se&&Ze<=ve.stableFitRemainingWidth?(ut=!0,mt=ve.stableFitMaxMinimapScale):(ut=dt>nt,Ye&&ut?(ve.stableMinimapLayoutInput=ie,ve.stableFitRemainingWidth=Ze):(ve.stableMinimapLayoutInput=null,ve.stableFitRemainingWidth=0))}if(Ie==="fill"||ut){_e=!0;const dt=ee;de=Math.min(Pe*Qe,Math.max(1,Math.floor(1/bt))),ee=Math.min(mt,Math.max(1,Math.floor(de/Xe))),ee>dt&&(Ue=Math.min(2,ee/dt)),K=ee/Qe/Ue,nt=Math.ceil(Math.max(ft,He+Et)*de),Ye&&ut&&(ve.stableFitMaxMinimapScale=ee)}}}const we=Math.floor(ue*K),Je=Math.min(we,Math.max(0,Math.floor((Ze-xe-2)*K/(ae+K)))+e.MINIMAP_GUTTER_WIDTH);let et=Math.floor(Qe*Je);const rt=et/Qe;et=Math.floor(et*Ue);const st=z?1:2,vt=Te==="left"?0:Fe-Je-xe;return{renderMinimap:st,minimapLeft:vt,minimapWidth:Je,minimapHeightIsEditorHeight:_e,minimapIsSampling:ye,minimapScale:ee,minimapLineHeight:de,minimapCanvasInnerWidth:et,minimapCanvasInnerHeight:nt,minimapCanvasOuterWidth:rt,minimapCanvasOuterHeight:pt}}static computeLayout(ie,ve){const Fe=ve.outerWidth|0,Ne=ve.outerHeight|0,Qe=ve.lineHeight|0,De=ve.lineNumbersDigitCount|0,Se=ve.typicalHalfwidthCharacterWidth,Pe=ve.maxDigitWidth,ae=ve.pixelRatio,he=ve.viewLineCount,z=ie.get(120),ee=z==="inherit"?ie.get(119):z,ue=ee==="inherit"?ie.get(115):ee,Ie=ie.get(118),Te=ie.get(2),xe=ve.isDominatedByLongLines,He=ie.get(46),Ze=ie.get(57).renderType!==0,Ye=ie.get(58),Xe=ie.get(92),nt=ie.get(62),pt=ie.get(90),_e=pt.verticalScrollbarSize,ye=pt.verticalHasArrows,de=pt.arrowSize,K=pt.horizontalScrollbarSize,Ue=ie.get(55),we=ie.get(35);let Je;if(typeof Ue=="string"&&/^\d+(\.\d+)?ch$/.test(Ue)){const Lt=parseFloat(Ue.substr(0,Ue.length-2));Je=c.clampedInt(Lt*Se,0,0,1e3)}else Je=c.clampedInt(Ue,0,0,1e3);we&&(Je+=16);let et=0;if(Ze){const Lt=Math.max(De,Ye);et=Math.round(Lt*Pe)}let rt=0;He&&(rt=Qe);let st=0,vt=st+rt,ft=vt+et,Et=ft+Je;const bt=Fe-rt-et-Je;let Rt=!1,wt=!1,ut=-1;Te!==2&&(ee==="inherit"&&xe?(Rt=!0,wt=!0):ue==="on"||ue==="bounded"?wt=!0:ue==="wordWrapColumn"&&(ut=Ie));const mt=N._computeMinimapLayout({outerWidth:Fe,outerHeight:Ne,lineHeight:Qe,typicalHalfwidthCharacterWidth:Se,pixelRatio:ae,scrollBeyondLastLine:Xe,minimap:nt,verticalScrollbarWidth:_e,viewLineCount:he,remainingWidth:bt,isViewportWrapping:wt},ve.memory||new _);mt.renderMinimap!==0&&mt.minimapLeft===0&&(st+=mt.minimapWidth,vt+=mt.minimapWidth,ft+=mt.minimapWidth,Et+=mt.minimapWidth);const dt=bt-mt.minimapWidth,Pt=Math.max(1,Math.floor((dt-_e-2)/Se)),Dt=ye?de:0;return wt&&(ut=Math.max(1,Pt),ue==="bounded"&&(ut=Math.min(ut,Ie))),{width:Fe,height:Ne,glyphMarginLeft:st,glyphMarginWidth:rt,lineNumbersLeft:vt,lineNumbersWidth:et,decorationsLeft:ft,decorationsWidth:Je,contentLeft:Et,contentWidth:dt,minimap:mt,viewportColumn:Pt,isWordWrapMinified:Rt,isViewportWrapping:wt,wrappingColumn:ut,verticalScrollbarWidth:_e,horizontalScrollbarHeight:K,overviewRuler:{top:Dt,width:_e,height:Ne-2*Dt,right:0}}}}e.EditorLayoutInfoComputer=N;class H extends C{constructor(){const ie={enabled:!0};super(54,"lightbulb",ie,{"editor.lightbulb.enabled":{type:"boolean",default:ie.enabled,description:v.localize(39,null)}})}validate(ie){return!ie||typeof ie!="object"?this.defaultValue:{enabled:l(ie.enabled,this.defaultValue.enabled)}}}class T extends C{constructor(){const ie={enabled:!0,fontSize:0,fontFamily:e.EDITOR_FONT_DEFAULTS.fontFamily};super(124,"inlayHints",ie,{"editor.inlayHints.enabled":{type:"boolean",default:ie.enabled,description:v.localize(40,null)},"editor.inlayHints.fontSize":{type:"number",default:ie.fontSize,markdownDescription:v.localize(41,null)},"editor.inlayHints.fontFamily":{type:"string",default:ie.fontFamily,description:v.localize(42,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const ve=ie;return{enabled:l(ve.enabled,this.defaultValue.enabled),fontSize:c.clampedInt(ve.fontSize,this.defaultValue.fontSize,0,100),fontFamily:S.string(ve.fontFamily,this.defaultValue.fontFamily)}}}class U extends c{constructor(){super(56,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,0,150,{description:v.localize(43,null)})}compute(ie,ve,Fe){return ie.fontInfo.lineHeight}}class F extends C{constructor(){const ie={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",renderCharacters:!0,maxColumn:120,scale:1};super(62,"minimap",ie,{"editor.minimap.enabled":{type:"boolean",default:ie.enabled,description:v.localize(44,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[v.localize(45,null),v.localize(46,null),v.localize(47,null)],default:ie.size,description:v.localize(48,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:ie.side,description:v.localize(49,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:ie.showSlider,description:v.localize(50,null)},"editor.minimap.scale":{type:"number",default:ie.scale,minimum:1,maximum:3,enum:[1,2,3],description:v.localize(51,null)},"editor.minimap.renderCharacters":{type:"boolean",default:ie.renderCharacters,description:v.localize(52,null)},"editor.minimap.maxColumn":{type:"number",default:ie.maxColumn,description:v.localize(53,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const ve=ie;return{enabled:l(ve.enabled,this.defaultValue.enabled),size:w(ve.size,this.defaultValue.size,["proportional","fill","fit"]),side:w(ve.side,this.defaultValue.side,["right","left"]),showSlider:w(ve.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:l(ve.renderCharacters,this.defaultValue.renderCharacters),scale:c.clampedInt(ve.scale,1,1,3),maxColumn:c.clampedInt(ve.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function M(G){return G==="ctrlCmd"?R.isMacintosh?"metaKey":"ctrlKey":"altKey"}class x extends C{constructor(){super(72,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:v.localize(54,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:v.localize(55,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const ve=ie;return{top:c.clampedInt(ve.top,0,0,1e3),bottom:c.clampedInt(ve.bottom,0,0,1e3)}}}class $ extends C{constructor(){const ie={enabled:!0,cycle:!1};super(73,"parameterHints",ie,{"editor.parameterHints.enabled":{type:"boolean",default:ie.enabled,description:v.localize(56,null)},"editor.parameterHints.cycle":{type:"boolean",default:ie.cycle,description:v.localize(57,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const ve=ie;return{enabled:l(ve.enabled,this.defaultValue.enabled),cycle:l(ve.cycle,this.defaultValue.cycle)}}}class X extends s{constructor(){super(126)}compute(ie,ve,Fe){return ie.pixelRatio}}class le extends C{constructor(){const ie={other:!0,comments:!1,strings:!1};super(76,"quickSuggestions",ie,{anyOf:[{type:"boolean"},{type:"object",properties:{strings:{type:"boolean",default:ie.strings,description:v.localize(58,null)},comments:{type:"boolean",default:ie.comments,description:v.localize(59,null)},other:{type:"boolean",default:ie.other,description:v.localize(60,null)}}}],default:ie,description:v.localize(61,null)});this.defaultValue=ie}validate(ie){if(typeof ie=="boolean")return ie;if(ie&&typeof ie=="object"){const ve=ie,Fe={other:l(ve.other,this.defaultValue.other),comments:l(ve.comments,this.defaultValue.comments),strings:l(ve.strings,this.defaultValue.strings)};return Fe.other&&Fe.comments&&Fe.strings?!0:!Fe.other&&!Fe.comments&&!Fe.strings?!1:Fe}return this.defaultValue}}var be;(function(G){G[G.Off=0]="Off",G[G.On=1]="On",G[G.Relative=2]="Relative",G[G.Interval=3]="Interval",G[G.Custom=4]="Custom"})(be=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class Re extends C{constructor(){super(57,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[v.localize(62,null),v.localize(63,null),v.localize(64,null),v.localize(65,null)],default:"on",description:v.localize(66,null)})}validate(ie){let ve=this.defaultValue.renderType,Fe=this.defaultValue.renderFn;return typeof ie!="undefined"&&(typeof ie=="function"?(ve=4,Fe=ie):ie==="interval"?ve=3:ie==="relative"?ve=2:ie==="on"?ve=1:ve=0),{renderType:ve,renderFn:Fe}}}function Ce(G){const ie=G.get(85);return ie==="editable"?G.get(78):ie!=="on"}e.filterValidationDecorations=Ce;class Me extends C{constructor(){const ie=[],ve={type:"number",description:v.localize(67,null)};super(89,"rulers",ie,{type:"array",items:{anyOf:[ve,{type:["object"],properties:{column:ve,color:{type:"string",description:v.localize(68,null),format:"color-hex"}}}]},default:ie,description:v.localize(69,null)})}validate(ie){if(Array.isArray(ie)){let ve=[];for(let Fe of ie)if(typeof Fe=="number")ve.push({column:c.clampedInt(Fe,0,0,1e4),color:null});else if(Fe&&typeof Fe=="object"){const Ne=Fe;ve.push({column:c.clampedInt(Ne.column,0,0,1e4),color:Ne.color})}return ve.sort((Fe,Ne)=>Fe.column-Ne.column),ve}return this.defaultValue}}function je(G,ie){if(typeof G!="string")return ie;switch(G){case"hidden":return 2;case"visible":return 3;default:return 1}}class ze extends C{constructor(){super(90,"scrollbar",{vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const ve=ie,Fe=c.clampedInt(ve.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Ne=c.clampedInt(ve.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:c.clampedInt(ve.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:je(ve.vertical,this.defaultValue.vertical),horizontal:je(ve.horizontal,this.defaultValue.horizontal),useShadows:l(ve.useShadows,this.defaultValue.useShadows),verticalHasArrows:l(ve.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:l(ve.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:l(ve.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:l(ve.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Fe,horizontalSliderSize:c.clampedInt(ve.horizontalSliderSize,Fe,0,1e3),verticalScrollbarSize:Ne,verticalSliderSize:c.clampedInt(ve.verticalSliderSize,Ne,0,1e3),scrollByPage:l(ve.scrollByPage,this.defaultValue.scrollByPage)}}}class qe extends C{constructor(){const ie={enabled:!1};super(52,"inlineSuggest",ie,{"editor.inlineSuggest.enabled":{type:"boolean",default:ie.enabled,description:v.localize(70,null)}})}validate(ie){return!ie||typeof ie!="object"?this.defaultValue:{enabled:l(ie.enabled,this.defaultValue.enabled)}}}class j extends C{constructor(){const ie={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,showIcons:!0,showStatusBar:!1,preview:!1,showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(104,"suggest",ie,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[v.localize(71,null),v.localize(72,null)],default:ie.insertMode,description:v.localize(73,null)},"editor.suggest.filterGraceful":{type:"boolean",default:ie.filterGraceful,description:v.localize(74,null)},"editor.suggest.localityBonus":{type:"boolean",default:ie.localityBonus,description:v.localize(75,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:ie.shareSuggestSelections,markdownDescription:v.localize(76,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:ie.snippetsPreventQuickSuggestions,description:v.localize(77,null)},"editor.suggest.showIcons":{type:"boolean",default:ie.showIcons,description:v.localize(78,null)},"editor.suggest.showStatusBar":{type:"boolean",default:ie.showStatusBar,description:v.localize(79,null)},"editor.suggest.preview":{type:"boolean",default:ie.preview,description:v.localize(80,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:ie.showInlineDetails,description:v.localize(81,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:v.localize(82,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:v.localize(83,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:v.localize(84,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:v.localize(85,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:v.localize(86,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:v.localize(87,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:v.localize(88,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:v.localize(89,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:v.localize(90,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:v.localize(91,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:v.localize(92,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:v.localize(93,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:v.localize(94,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:v.localize(95,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:v.localize(96,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:v.localize(97,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:v.localize(98,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:v.localize(99,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:v.localize(100,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:v.localize(101,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:v.localize(102,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:v.localize(103,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:v.localize(104,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:v.localize(105,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:v.localize(106,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:v.localize(107,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:v.localize(108,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:v.localize(109,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:v.localize(110,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:v.localize(111,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:v.localize(112,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const ve=ie;return{insertMode:w(ve.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:l(ve.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:l(ve.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:l(ve.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:l(ve.shareSuggestSelections,this.defaultValue.shareSuggestSelections),showIcons:l(ve.showIcons,this.defaultValue.showIcons),showStatusBar:l(ve.showStatusBar,this.defaultValue.showStatusBar),preview:l(ve.preview,this.defaultValue.preview),showInlineDetails:l(ve.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:l(ve.showMethods,this.defaultValue.showMethods),showFunctions:l(ve.showFunctions,this.defaultValue.showFunctions),showConstructors:l(ve.showConstructors,this.defaultValue.showConstructors),showDeprecated:l(ve.showDeprecated,this.defaultValue.showDeprecated),showFields:l(ve.showFields,this.defaultValue.showFields),showVariables:l(ve.showVariables,this.defaultValue.showVariables),showClasses:l(ve.showClasses,this.defaultValue.showClasses),showStructs:l(ve.showStructs,this.defaultValue.showStructs),showInterfaces:l(ve.showInterfaces,this.defaultValue.showInterfaces),showModules:l(ve.showModules,this.defaultValue.showModules),showProperties:l(ve.showProperties,this.defaultValue.showProperties),showEvents:l(ve.showEvents,this.defaultValue.showEvents),showOperators:l(ve.showOperators,this.defaultValue.showOperators),showUnits:l(ve.showUnits,this.defaultValue.showUnits),showValues:l(ve.showValues,this.defaultValue.showValues),showConstants:l(ve.showConstants,this.defaultValue.showConstants),showEnums:l(ve.showEnums,this.defaultValue.showEnums),showEnumMembers:l(ve.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:l(ve.showKeywords,this.defaultValue.showKeywords),showWords:l(ve.showWords,this.defaultValue.showWords),showColors:l(ve.showColors,this.defaultValue.showColors),showFiles:l(ve.showFiles,this.defaultValue.showFiles),showReferences:l(ve.showReferences,this.defaultValue.showReferences),showFolders:l(ve.showFolders,this.defaultValue.showFolders),showTypeParameters:l(ve.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:l(ve.showSnippets,this.defaultValue.showSnippets),showUsers:l(ve.showUsers,this.defaultValue.showUsers),showIssues:l(ve.showIssues,this.defaultValue.showIssues)}}}class Z extends C{constructor(){super(100,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:v.localize(113,null),default:!0,type:"boolean"}})}validate(ie){return!ie||typeof ie!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:l(ie.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class ne extends s{constructor(){super(127,[78])}compute(ie,ve,Fe){return ve.get(78)?!0:ie.tabFocusMode}}var oe;(function(G){G[G.None=0]="None",G[G.Same=1]="Same",G[G.Indent=2]="Indent",G[G.DeepIndent=3]="DeepIndent"})(oe=e.WrappingIndent||(e.WrappingIndent={}));function Y(G){switch(G){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}}class ce extends s{constructor(){super(129,[128])}compute(ie,ve,Fe){const Ne=ve.get(128);return{isDominatedByLongLines:ie.isDominatedByLongLines,isWordWrapMinified:Ne.isWordWrapMinified,isViewportWrapping:Ne.isViewportWrapping,wrappingColumn:Ne.wrappingColumn}}}const me="Consolas, 'Courier New', monospace",Le="Menlo, Monaco, 'Courier New', monospace",We="'Droid Sans Mono', 'monospace', monospace, 'Droid Sans Fallback'";e.EDITOR_FONT_DEFAULTS={fontFamily:R.isMacintosh?Le:R.isLinux?We:me,fontWeight:"normal",fontSize:R.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0},e.editorOptionsRegistry=[];function Ee(G){return e.editorOptionsRegistry[G.id]=G,G}var Ke;(function(G){G[G.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",G[G.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",G[G.accessibilitySupport=2]="accessibilitySupport",G[G.accessibilityPageSize=3]="accessibilityPageSize",G[G.ariaLabel=4]="ariaLabel",G[G.autoClosingBrackets=5]="autoClosingBrackets",G[G.autoClosingDelete=6]="autoClosingDelete",G[G.autoClosingOvertype=7]="autoClosingOvertype",G[G.autoClosingQuotes=8]="autoClosingQuotes",G[G.autoIndent=9]="autoIndent",G[G.automaticLayout=10]="automaticLayout",G[G.autoSurround=11]="autoSurround",G[G.codeLens=12]="codeLens",G[G.codeLensFontFamily=13]="codeLensFontFamily",G[G.codeLensFontSize=14]="codeLensFontSize",G[G.colorDecorators=15]="colorDecorators",G[G.columnSelection=16]="columnSelection",G[G.comments=17]="comments",G[G.contextmenu=18]="contextmenu",G[G.copyWithSyntaxHighlighting=19]="copyWithSyntaxHighlighting",G[G.cursorBlinking=20]="cursorBlinking",G[G.cursorSmoothCaretAnimation=21]="cursorSmoothCaretAnimation",G[G.cursorStyle=22]="cursorStyle",G[G.cursorSurroundingLines=23]="cursorSurroundingLines",G[G.cursorSurroundingLinesStyle=24]="cursorSurroundingLinesStyle",G[G.cursorWidth=25]="cursorWidth",G[G.disableLayerHinting=26]="disableLayerHinting",G[G.disableMonospaceOptimizations=27]="disableMonospaceOptimizations",G[G.domReadOnly=28]="domReadOnly",G[G.dragAndDrop=29]="dragAndDrop",G[G.emptySelectionClipboard=30]="emptySelectionClipboard",G[G.extraEditorClassName=31]="extraEditorClassName",G[G.fastScrollSensitivity=32]="fastScrollSensitivity",G[G.find=33]="find",G[G.fixedOverflowWidgets=34]="fixedOverflowWidgets",G[G.folding=35]="folding",G[G.foldingStrategy=36]="foldingStrategy",G[G.foldingHighlight=37]="foldingHighlight",G[G.unfoldOnClickAfterEndOfLine=38]="unfoldOnClickAfterEndOfLine",G[G.fontFamily=39]="fontFamily",G[G.fontInfo=40]="fontInfo",G[G.fontLigatures=41]="fontLigatures",G[G.fontSize=42]="fontSize",G[G.fontWeight=43]="fontWeight",G[G.formatOnPaste=44]="formatOnPaste",G[G.formatOnType=45]="formatOnType",G[G.glyphMargin=46]="glyphMargin",G[G.gotoLocation=47]="gotoLocation",G[G.hideCursorInOverviewRuler=48]="hideCursorInOverviewRuler",G[G.highlightActiveIndentGuide=49]="highlightActiveIndentGuide",G[G.hover=50]="hover",G[G.inDiffEditor=51]="inDiffEditor",G[G.inlineSuggest=52]="inlineSuggest",G[G.letterSpacing=53]="letterSpacing",G[G.lightbulb=54]="lightbulb",G[G.lineDecorationsWidth=55]="lineDecorationsWidth",G[G.lineHeight=56]="lineHeight",G[G.lineNumbers=57]="lineNumbers",G[G.lineNumbersMinChars=58]="lineNumbersMinChars",G[G.linkedEditing=59]="linkedEditing",G[G.links=60]="links",G[G.matchBrackets=61]="matchBrackets",G[G.minimap=62]="minimap",G[G.mouseStyle=63]="mouseStyle",G[G.mouseWheelScrollSensitivity=64]="mouseWheelScrollSensitivity",G[G.mouseWheelZoom=65]="mouseWheelZoom",G[G.multiCursorMergeOverlapping=66]="multiCursorMergeOverlapping",G[G.multiCursorModifier=67]="multiCursorModifier",G[G.multiCursorPaste=68]="multiCursorPaste",G[G.occurrencesHighlight=69]="occurrencesHighlight",G[G.overviewRulerBorder=70]="overviewRulerBorder",G[G.overviewRulerLanes=71]="overviewRulerLanes",G[G.padding=72]="padding",G[G.parameterHints=73]="parameterHints",G[G.peekWidgetDefaultFocus=74]="peekWidgetDefaultFocus",G[G.definitionLinkOpensInPeek=75]="definitionLinkOpensInPeek",G[G.quickSuggestions=76]="quickSuggestions",G[G.quickSuggestionsDelay=77]="quickSuggestionsDelay",G[G.readOnly=78]="readOnly",G[G.renameOnType=79]="renameOnType",G[G.renderControlCharacters=80]="renderControlCharacters",G[G.renderIndentGuides=81]="renderIndentGuides",G[G.renderFinalNewline=82]="renderFinalNewline",G[G.renderLineHighlight=83]="renderLineHighlight",G[G.renderLineHighlightOnlyWhenFocus=84]="renderLineHighlightOnlyWhenFocus",G[G.renderValidationDecorations=85]="renderValidationDecorations",G[G.renderWhitespace=86]="renderWhitespace",G[G.revealHorizontalRightPadding=87]="revealHorizontalRightPadding",G[G.roundedSelection=88]="roundedSelection",G[G.rulers=89]="rulers",G[G.scrollbar=90]="scrollbar",G[G.scrollBeyondLastColumn=91]="scrollBeyondLastColumn",G[G.scrollBeyondLastLine=92]="scrollBeyondLastLine",G[G.scrollPredominantAxis=93]="scrollPredominantAxis",G[G.selectionClipboard=94]="selectionClipboard",G[G.selectionHighlight=95]="selectionHighlight",G[G.selectOnLineNumbers=96]="selectOnLineNumbers",G[G.showFoldingControls=97]="showFoldingControls",G[G.showUnused=98]="showUnused",G[G.snippetSuggestions=99]="snippetSuggestions",G[G.smartSelect=100]="smartSelect",G[G.smoothScrolling=101]="smoothScrolling",G[G.stickyTabStops=102]="stickyTabStops",G[G.stopRenderingLineAfter=103]="stopRenderingLineAfter",G[G.suggest=104]="suggest",G[G.suggestFontSize=105]="suggestFontSize",G[G.suggestLineHeight=106]="suggestLineHeight",G[G.suggestOnTriggerCharacters=107]="suggestOnTriggerCharacters",G[G.suggestSelection=108]="suggestSelection",G[G.tabCompletion=109]="tabCompletion",G[G.tabIndex=110]="tabIndex",G[G.unusualLineTerminators=111]="unusualLineTerminators",G[G.useShadowDOM=112]="useShadowDOM",G[G.useTabStops=113]="useTabStops",G[G.wordSeparators=114]="wordSeparators",G[G.wordWrap=115]="wordWrap",G[G.wordWrapBreakAfterCharacters=116]="wordWrapBreakAfterCharacters",G[G.wordWrapBreakBeforeCharacters=117]="wordWrapBreakBeforeCharacters",G[G.wordWrapColumn=118]="wordWrapColumn",G[G.wordWrapOverride1=119]="wordWrapOverride1",G[G.wordWrapOverride2=120]="wordWrapOverride2",G[G.wrappingIndent=121]="wrappingIndent",G[G.wrappingStrategy=122]="wrappingStrategy",G[G.showDeprecated=123]="showDeprecated",G[G.inlayHints=124]="inlayHints",G[G.editorClassName=125]="editorClassName",G[G.pixelRatio=126]="pixelRatio",G[G.tabFocusMode=127]="tabFocusMode",G[G.layoutInfo=128]="layoutInfo",G[G.wrappingInfo=129]="wrappingInfo"})(Ke=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Ee(new m(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:v.localize(114,null)})),acceptSuggestionOnEnter:Ee(new b(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",v.localize(115,null),""],markdownDescription:v.localize(116,null)})),accessibilitySupport:Ee(new p),accessibilityPageSize:Ee(new c(3,"accessibilityPageSize",10,1,1073741824,{description:v.localize(117,null)})),ariaLabel:Ee(new S(4,"ariaLabel",v.localize(118,null))),autoClosingBrackets:Ee(new b(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",v.localize(119,null),v.localize(120,null),""],description:v.localize(121,null)})),autoClosingDelete:Ee(new b(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",v.localize(122,null),""],description:v.localize(123,null)})),autoClosingOvertype:Ee(new b(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",v.localize(124,null),""],description:v.localize(125,null)})),autoClosingQuotes:Ee(new b(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",v.localize(126,null),v.localize(127,null),""],description:v.localize(128,null)})),autoIndent:Ee(new u(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],d,{enumDescriptions:[v.localize(129,null),v.localize(130,null),v.localize(131,null),v.localize(132,null),v.localize(133,null)],description:v.localize(134,null)})),automaticLayout:Ee(new m(10,"automaticLayout",!1)),autoSurround:Ee(new b(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[v.localize(135,null),v.localize(136,null),v.localize(137,null),""],description:v.localize(138,null)})),stickyTabStops:Ee(new m(102,"stickyTabStops",!1,{description:v.localize(139,null)})),codeLens:Ee(new m(12,"codeLens",!0,{description:v.localize(140,null)})),codeLensFontFamily:Ee(new S(13,"codeLensFontFamily","",{description:v.localize(141,null)})),codeLensFontSize:Ee(new c(14,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:v.localize(142,null)})),colorDecorators:Ee(new m(15,"colorDecorators",!0,{description:v.localize(143,null)})),columnSelection:Ee(new m(16,"columnSelection",!1,{description:v.localize(144,null)})),comments:Ee(new t),contextmenu:Ee(new m(18,"contextmenu",!0)),copyWithSyntaxHighlighting:Ee(new m(19,"copyWithSyntaxHighlighting",!0,{description:v.localize(145,null)})),cursorBlinking:Ee(new u(20,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],r,{description:v.localize(146,null)})),cursorSmoothCaretAnimation:Ee(new m(21,"cursorSmoothCaretAnimation",!1,{description:v.localize(147,null)})),cursorStyle:Ee(new u(22,"cursorStyle",n.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],g,{description:v.localize(148,null)})),cursorSurroundingLines:Ee(new c(23,"cursorSurroundingLines",0,0,1073741824,{description:v.localize(149,null)})),cursorSurroundingLinesStyle:Ee(new b(24,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[v.localize(150,null),v.localize(151,null)],description:v.localize(152,null)})),cursorWidth:Ee(new c(25,"cursorWidth",0,0,1073741824,{markdownDescription:v.localize(153,null)})),disableLayerHinting:Ee(new m(26,"disableLayerHinting",!1)),disableMonospaceOptimizations:Ee(new m(27,"disableMonospaceOptimizations",!1)),domReadOnly:Ee(new m(28,"domReadOnly",!1)),dragAndDrop:Ee(new m(29,"dragAndDrop",!0,{description:v.localize(154,null)})),emptySelectionClipboard:Ee(new E),extraEditorClassName:Ee(new S(31,"extraEditorClassName","")),fastScrollSensitivity:Ee(new h(32,"fastScrollSensitivity",5,G=>G<=0?5:G,{markdownDescription:v.localize(155,null)})),find:Ee(new y),fixedOverflowWidgets:Ee(new m(34,"fixedOverflowWidgets",!1)),folding:Ee(new m(35,"folding",!0,{description:v.localize(156,null)})),foldingStrategy:Ee(new b(36,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[v.localize(157,null),v.localize(158,null)],description:v.localize(159,null)})),foldingHighlight:Ee(new m(37,"foldingHighlight",!0,{description:v.localize(160,null)})),unfoldOnClickAfterEndOfLine:Ee(new m(38,"unfoldOnClickAfterEndOfLine",!1,{description:v.localize(161,null)})),fontFamily:Ee(new S(39,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:v.localize(162,null)})),fontInfo:Ee(new L),fontLigatures2:Ee(new a),fontSize:Ee(new O),fontWeight:Ee(new W),formatOnPaste:Ee(new m(44,"formatOnPaste",!1,{description:v.localize(163,null)})),formatOnType:Ee(new m(45,"formatOnType",!1,{description:v.localize(164,null)})),glyphMargin:Ee(new m(46,"glyphMargin",!0,{description:v.localize(165,null)})),gotoLocation:Ee(new J),hideCursorInOverviewRuler:Ee(new m(48,"hideCursorInOverviewRuler",!1,{description:v.localize(166,null)})),highlightActiveIndentGuide:Ee(new m(49,"highlightActiveIndentGuide",!0,{description:v.localize(167,null)})),hover:Ee(new se),inDiffEditor:Ee(new m(51,"inDiffEditor",!1)),letterSpacing:Ee(new h(53,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,G=>h.clamp(G,-5,20),{description:v.localize(168,null)})),lightbulb:Ee(new H),lineDecorationsWidth:Ee(new I(55,"lineDecorationsWidth",10)),lineHeight:Ee(new U),lineNumbers:Ee(new Re),lineNumbersMinChars:Ee(new c(58,"lineNumbersMinChars",5,1,300)),linkedEditing:Ee(new m(59,"linkedEditing",!1,{description:v.localize(169,null)})),links:Ee(new m(60,"links",!0,{description:v.localize(170,null)})),matchBrackets:Ee(new b(61,"matchBrackets","always",["always","near","never"],{description:v.localize(171,null)})),minimap:Ee(new F),mouseStyle:Ee(new b(63,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Ee(new h(64,"mouseWheelScrollSensitivity",1,G=>G===0?1:G,{markdownDescription:v.localize(172,null)})),mouseWheelZoom:Ee(new m(65,"mouseWheelZoom",!1,{markdownDescription:v.localize(173,null)})),multiCursorMergeOverlapping:Ee(new m(66,"multiCursorMergeOverlapping",!0,{description:v.localize(174,null)})),multiCursorModifier:Ee(new u(67,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],M,{markdownEnumDescriptions:[v.localize(175,null),v.localize(176,null)],markdownDescription:v.localize(177,null)})),multiCursorPaste:Ee(new b(68,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[v.localize(178,null),v.localize(179,null)],markdownDescription:v.localize(180,null)})),occurrencesHighlight:Ee(new m(69,"occurrencesHighlight",!0,{description:v.localize(181,null)})),overviewRulerBorder:Ee(new m(70,"overviewRulerBorder",!0,{description:v.localize(182,null)})),overviewRulerLanes:Ee(new c(71,"overviewRulerLanes",3,0,3)),padding:Ee(new x),parameterHints:Ee(new $),peekWidgetDefaultFocus:Ee(new b(74,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[v.localize(183,null),v.localize(184,null)],description:v.localize(185,null)})),definitionLinkOpensInPeek:Ee(new m(75,"definitionLinkOpensInPeek",!1,{description:v.localize(186,null)})),quickSuggestions:Ee(new le),quickSuggestionsDelay:Ee(new c(77,"quickSuggestionsDelay",10,0,1073741824,{description:v.localize(187,null)})),readOnly:Ee(new m(78,"readOnly",!1)),renameOnType:Ee(new m(79,"renameOnType",!1,{description:v.localize(188,null),markdownDeprecationMessage:v.localize(189,null)})),renderControlCharacters:Ee(new m(80,"renderControlCharacters",!1,{description:v.localize(190,null)})),renderIndentGuides:Ee(new m(81,"renderIndentGuides",!0,{description:v.localize(191,null)})),renderFinalNewline:Ee(new m(82,"renderFinalNewline",!0,{description:v.localize(192,null)})),renderLineHighlight:Ee(new b(83,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",v.localize(193,null)],description:v.localize(194,null)})),renderLineHighlightOnlyWhenFocus:Ee(new m(84,"renderLineHighlightOnlyWhenFocus",!1,{description:v.localize(195,null)})),renderValidationDecorations:Ee(new b(85,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Ee(new b(86,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",v.localize(196,null),v.localize(197,null),v.localize(198,null),""],description:v.localize(199,null)})),revealHorizontalRightPadding:Ee(new c(87,"revealHorizontalRightPadding",30,0,1e3)),roundedSelection:Ee(new m(88,"roundedSelection",!0,{description:v.localize(200,null)})),rulers:Ee(new Me),scrollbar:Ee(new ze),scrollBeyondLastColumn:Ee(new c(91,"scrollBeyondLastColumn",5,0,1073741824,{description:v.localize(201,null)})),scrollBeyondLastLine:Ee(new m(92,"scrollBeyondLastLine",!0,{description:v.localize(202,null)})),scrollPredominantAxis:Ee(new m(93,"scrollPredominantAxis",!0,{description:v.localize(203,null)})),selectionClipboard:Ee(new m(94,"selectionClipboard",!0,{description:v.localize(204,null),included:R.isLinux})),selectionHighlight:Ee(new m(95,"selectionHighlight",!0,{description:v.localize(205,null)})),selectOnLineNumbers:Ee(new m(96,"selectOnLineNumbers",!0)),showFoldingControls:Ee(new b(97,"showFoldingControls","mouseover",["always","mouseover"],{enumDescriptions:[v.localize(206,null),v.localize(207,null)],description:v.localize(208,null)})),showUnused:Ee(new m(98,"showUnused",!0,{description:v.localize(209,null)})),showDeprecated:Ee(new m(123,"showDeprecated",!0,{description:v.localize(210,null)})),inlayHints:Ee(new T),snippetSuggestions:Ee(new b(99,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[v.localize(211,null),v.localize(212,null),v.localize(213,null),v.localize(214,null)],description:v.localize(215,null)})),smartSelect:Ee(new Z),smoothScrolling:Ee(new m(101,"smoothScrolling",!1,{description:v.localize(216,null)})),stopRenderingLineAfter:Ee(new c(103,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Ee(new j),inlineSuggest:Ee(new qe),suggestFontSize:Ee(new c(105,"suggestFontSize",0,0,1e3,{markdownDescription:v.localize(217,null)})),suggestLineHeight:Ee(new c(106,"suggestLineHeight",0,0,1e3,{markdownDescription:v.localize(218,null)})),suggestOnTriggerCharacters:Ee(new m(107,"suggestOnTriggerCharacters",!0,{description:v.localize(219,null)})),suggestSelection:Ee(new b(108,"suggestSelection","recentlyUsed",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[v.localize(220,null),v.localize(221,null),v.localize(222,null)],description:v.localize(223,null)})),tabCompletion:Ee(new b(109,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[v.localize(224,null),v.localize(225,null),v.localize(226,null)],description:v.localize(227,null)})),tabIndex:Ee(new c(110,"tabIndex",0,-1,1073741824)),unusualLineTerminators:Ee(new b(111,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[v.localize(228,null),v.localize(229,null),v.localize(230,null)],description:v.localize(231,null)})),useShadowDOM:Ee(new m(112,"useShadowDOM",!0)),useTabStops:Ee(new m(113,"useTabStops",!0,{description:v.localize(232,null)})),wordSeparators:Ee(new S(114,"wordSeparators",k.USUAL_WORD_SEPARATORS,{description:v.localize(233,null)})),wordWrap:Ee(new b(115,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[v.localize(234,null),v.localize(235,null),v.localize(236,null),v.localize(237,null)],description:v.localize(238,null)})),wordWrapBreakAfterCharacters:Ee(new S(116,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Ee(new S(117,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Ee(new c(118,"wordWrapColumn",80,1,1073741824,{markdownDescription:v.localize(239,null)})),wordWrapOverride1:Ee(new b(119,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Ee(new b(120,"wordWrapOverride2","inherit",["off","on","inherit"])),wrappingIndent:Ee(new u(121,"wrappingIndent",1,"same",["none","same","indent","deepIndent"],Y,{enumDescriptions:[v.localize(240,null),v.localize(241,null),v.localize(242,null),v.localize(243,null)],description:v.localize(244,null)})),wrappingStrategy:Ee(new b(122,"wrappingStrategy","simple",["simple","advanced"],{enumDescriptions:[v.localize(245,null),v.localize(246,null)],description:v.localize(247,null)})),editorClassName:Ee(new f),pixelRatio:Ee(new X),tabFocusMode:Ee(new ne),layoutInfo:Ee(new N),wrappingInfo:Ee(new ce)}}),define(ge[151],pe([19,20]),function(Q,e){return Q.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ge[152],pe([19,20]),function(Q,e){return Q.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ge[153],pe([19,20]),function(Q,e){return Q.create("vs/platform/extensions/common/extensionValidator",e)}),define(ge[154],pe([19,20]),function(Q,e){return Q.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(ge[155],pe([19,20]),function(Q,e){return Q.create("vs/platform/files/common/files",e)}),define(ge[156],pe([19,20]),function(Q,e){return Q.create("vs/platform/markers/common/markers",e)}),define(ge[157],pe([19,20]),function(Q,e){return Q.create("vs/platform/workspaces/common/workspaces",e)}),define(ge[158],pe([19,20]),function(Q,e){return Q.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(ge[159],pe([19,20]),function(Q,e){return Q.create("vs/workbench/api/common/extHostExtensionService",e)}),define(ge[160],pe([19,20]),function(Q,e){return Q.create("vs/workbench/api/common/extHostProgress",e)}),define(ge[161],pe([19,20]),function(Q,e){return Q.create("vs/workbench/api/common/extHostStatusBar",e)}),define(ge[162],pe([19,20]),function(Q,e){return Q.create("vs/workbench/api/common/extHostTerminalService",e)}),define(ge[163],pe([19,20]),function(Q,e){return Q.create("vs/workbench/api/common/extHostTreeViews",e)}),define(ge[164],pe([19,20]),function(Q,e){return Q.create("vs/workbench/api/common/extHostWorkspace",e)}),define(ge[165],pe([19,20]),function(Q,e){return Q.create("vs/workbench/api/node/extHostDebugService",e)}),define(ge[166],pe([19,20]),function(Q,e){return Q.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(ge[167],pe([19,20]),function(Q,e){return Q.create("vs/workbench/contrib/debug/node/debugAdapter",e)}),define(ge[168],pe([19,20]),function(Q,e){return Q.create("vs/workbench/contrib/search/common/queryBuilder",e)}),define(ge[169],pe([19,20]),function(Q,e){return Q.create("vs/workbench/contrib/tasks/common/taskService",e)}),define(ge[170],pe([19,20]),function(Q,e){return Q.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(ge[171],pe([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextEditorSelectionRevealType=e.EditorOpenContext=e.EditorOverride=e.EditorActivation=void 0;var v;(function(A){A[A.ACTIVATE=0]="ACTIVATE",A[A.RESTORE=1]="RESTORE",A[A.PRESERVE=2]="PRESERVE"})(v=e.EditorActivation||(e.EditorActivation={}));var R;(function(A){A[A.PICK=1]="PICK",A[A.DISABLED=2]="DISABLED"})(R=e.EditorOverride||(e.EditorOverride={}));var k;(function(A){A[A.API=0]="API",A[A.USER=1]="USER"})(k=e.EditorOpenContext||(e.EditorOpenContext={}));var D;(function(A){A[A.Center=0]="Center",A[A.CenterIfOutsideViewport=1]="CenterIfOutsideViewport",A[A.NearTop=2]="NearTop",A[A.NearTopIfOutsideViewport=3]="NearTopIfOutsideViewport"})(D=e.TextEditorSelectionRevealType||(e.TextEditorSelectionRevealType={}))}),define(ge[172],pe([0,1,153]),function(Q,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const R=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,k=/^-(\d{4})(\d{2})(\d{2})$/;function D(l){return l=l.trim(),l==="*"||R.test(l)}e.isValidVersionStr=D;function A(l){if(!D(l))return null;if(l=l.trim(),l==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let m=l.match(R);return m?{hasCaret:m[1]==="^",hasGreaterEquals:m[1]===">=",majorBase:m[2]==="x"?0:parseInt(m[2],10),majorMustEqual:m[2]!=="x",minorBase:m[4]==="x"?0:parseInt(m[4],10),minorMustEqual:m[4]!=="x",patchBase:m[6]==="x"?0:parseInt(m[6],10),patchMustEqual:m[6]!=="x",preRelease:m[8]||null}:null}e.parseVersion=A;function P(l){if(!l)return null;let m=l.majorBase,c=l.majorMustEqual,h=l.minorBase,S=l.minorMustEqual,w=l.patchBase,b=l.patchMustEqual;l.hasCaret&&(m===0||(S=!1),b=!1);let u=0;if(l.preRelease){const d=k.exec(l.preRelease);if(d){const[,p,t,i]=d;u=Date.UTC(Number(p),Number(t)-1,Number(i))}}return{majorBase:m,majorMustEqual:c,minorBase:h,minorMustEqual:S,patchBase:w,patchMustEqual:b,isMinimum:l.hasGreaterEquals,notBefore:u}}e.normalizeVersion=P;function _(l,m,c){let h;typeof l=="string"?h=P(A(l)):h=l;let S;m instanceof Date?S=m.getTime():typeof m=="string"&&(S=new Date(m).getTime());let w;if(typeof c=="string"?w=P(A(c)):w=c,!h||!w)return!1;let b=h.majorBase,u=h.minorBase,d=h.patchBase,p=w.majorBase,t=w.minorBase,i=w.patchBase,r=w.notBefore,n=w.majorMustEqual,o=w.minorMustEqual,g=w.patchMustEqual;return w.isMinimum?b>p?!0:b<p?!1:u>t?!0:u<t||S&&S<r?!1:d>=i:(b===1&&p===0&&(!n||!o||!g)&&(p=1,t=0,i=0,n=!0,o=!1,g=!1),b<p?!1:b>p?!n:u<t?!1:u>t?!o:d<i?!1:d>i?!g:!(S&&S<r))}e.isValidVersion=_;function C(l,m,c,h){return c.isBuiltin||typeof c.main=="undefined"?!0:I(l,m,c.engines.vscode,h)}e.isValidExtensionVersion=C;function s(l,m,c){return l==="*"||I(m,c,l)}e.isEngineValid=s;function I(l,m,c,h=[]){let S=P(A(c));if(!S)return h.push(v.localize(0,null,c)),!1;if(S.majorBase===0){if(!S.majorMustEqual||!S.minorMustEqual)return h.push(v.localize(1,null,c)),!1}else if(!S.majorMustEqual)return h.push(v.localize(2,null,c)),!1;return _(l,m,S)?!0:(h.push(v.localize(3,null,l,c)),!1)}}),define(ge[112],pe([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createSyncDescriptor=e.SyncDescriptor=void 0;class v{constructor(D,A=[],P=!1){this.ctor=D,this.staticArguments=A,this.supportsDelayedInstantiation=P}}e.SyncDescriptor=v;const R=(k,...D)=>new v(k,D);e.createSyncDescriptor=R}),define(ge[77],pe([0,1,112]),function(Q,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const R=[];function k(A,P,_){P instanceof v.SyncDescriptor||(P=new v.SyncDescriptor(P,[],_)),R.push([A,P])}e.registerSingleton=k;function D(){return R}e.getSingletonServiceDescriptors=D}),define(ge[173],pe([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class v{constructor(D){this.incoming=new Map,this.outgoing=new Map,this.data=D}}e.Node=v;class R{constructor(D){this._hashFn=D,this._nodes=new Map}roots(){const D=[];for(let A of this._nodes.values())A.outgoing.size===0&&D.push(A);return D}insertEdge(D,A){const P=this.lookupOrInsertNode(D),_=this.lookupOrInsertNode(A);P.outgoing.set(this._hashFn(A),_),_.incoming.set(this._hashFn(D),P)}removeNode(D){const A=this._hashFn(D);this._nodes.delete(A);for(let P of this._nodes.values())P.outgoing.delete(A),P.incoming.delete(A)}lookupOrInsertNode(D){const A=this._hashFn(D);let P=this._nodes.get(A);return P||(P=new v(D),this._nodes.set(A,P)),P}lookup(D){return this._nodes.get(this._hashFn(D))}isEmpty(){return this._nodes.size===0}toString(){let D=[];for(let[A,P]of this._nodes)D.push(`${A}, (incoming)[${[...P.incoming.keys()].join(", ")}], (outgoing)[${[...P.outgoing.keys()].join(",")}]`);return D.join(`
`)}findCycleSlow(){for(let[D,A]of this._nodes){const P=new Set([D]),_=this._findCycle(A,P);if(_)return _}}_findCycle(D,A){for(let[P,_]of D.outgoing){if(A.has(P))return[...A,P].join(" -> ");A.add(P);const C=this._findCycle(_,A);if(C)return C;A.delete(P)}}}e.Graph=R}),define(ge[4],pe([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.optional=e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var v;(function(P){P.serviceIds=new Map,P.DI_TARGET="$di$target",P.DI_DEPENDENCIES="$di$dependencies";function _(C){return C[P.DI_DEPENDENCIES]||[]}P.getServiceDependencies=_})(v=e._util||(e._util={})),e.IInstantiationService=k("instantiationService");function R(P,_,C,s){_[v.DI_TARGET]===_?_[v.DI_DEPENDENCIES].push({id:P,index:C,optional:s}):(_[v.DI_DEPENDENCIES]=[{id:P,index:C,optional:s}],_[v.DI_TARGET]=_)}function k(P){if(v.serviceIds.has(P))return v.serviceIds.get(P);const _=function(C,s,I){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");R(_,C,I,!1)};return _.toString=()=>P,v.serviceIds.set(P,_),_}e.createDecorator=k;function D(P){return P}e.refineServiceDecorator=D;function A(P){return function(_,C,s){if(arguments.length!==3)throw new Error("@optional-decorator can only be used to decorate a parameter");R(P,_,s,!0)}}e.optional=A}),define(ge[174],pe([0,1,4]),function(Q,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shouldSynchronizeModel=e.IModelService=void 0,e.IModelService=v.createDecorator("modelService");function R(k){return!k.isTooLargeForSyncing()&&!k.isForSimpleWidget}e.shouldSynchronizeModel=R}),define(ge[175],pe([0,1,3,73,6,23,72,76,174]),function(Q,e,v,R,k,D,A,P,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguageFeatureRequestDelays=e.LanguageFeatureRegistry=void 0;function C(l){return typeof l=="string"?!1:Array.isArray(l)?l.every(C):!!l.exclusive}class s{constructor(){this._clock=0,this._entries=[],this._onDidChange=new v.Emitter}get onDidChange(){return this._onDidChange.event}register(m,c){let h={selector:m,provider:c,_score:-1,_time:this._clock++};return this._entries.push(h),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),k.toDisposable(()=>{if(h){let S=this._entries.indexOf(h);S>=0&&(this._entries.splice(S,1),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),h=void 0)}})}has(m){return this.all(m).length>0}all(m){if(!m)return[];this._updateScores(m);const c=[];for(let h of this._entries)h._score>0&&c.push(h.provider);return c}ordered(m){const c=[];return this._orderedForEach(m,h=>c.push(h.provider)),c}orderedGroups(m){const c=[];let h,S;return this._orderedForEach(m,w=>{h&&S===w._score?h.push(w.provider):(S=w._score,h=[w.provider],c.push(h))}),c}_orderedForEach(m,c){if(!!m){this._updateScores(m);for(const h of this._entries)h._score>0&&c(h)}}_updateScores(m){let c={uri:m.uri.toString(),language:m.getLanguageIdentifier().language};if(!(this._lastCandidate&&this._lastCandidate.language===c.language&&this._lastCandidate.uri===c.uri)){this._lastCandidate=c;for(let h of this._entries)if(h._score=P.score(h.selector,m.uri,m.getLanguageIdentifier().language,_.shouldSynchronizeModel(m)),C(h.selector)&&h._score>0){for(let S of this._entries)S._score=0;h._score=1e3;break}this._entries.sort(s._compareByScoreAndTime)}}static _compareByScoreAndTime(m,c){return m._score<c._score?1:m._score>c._score?-1:m._time<c._time?1:m._time>c._time?-1:0}}e.LanguageFeatureRegistry=s;class I{constructor(m,c,h=Number.MAX_SAFE_INTEGER){this._registry=m,this.min=c,this.max=h,this._cache=new D.LRUCache(50,.7)}_key(m){return m.id+R.hash(this._registry.all(m))}_clamp(m){return m===void 0?this.min:Math.min(this.max,Math.max(this.min,Math.floor(m*1.3)))}get(m){const c=this._key(m),h=this._cache.get(c);return this._clamp(h==null?void 0:h.value)}update(m,c){const h=this._key(m);let S=this._cache.get(h);return S||(S=new A.MovingAverage,this._cache.set(h,S)),S.update(c),this.get(m)}}e.LanguageFeatureRequestDelays=I}),define(ge[78],pe([0,1,2,41,175,143,92]),function(Q,e,v,R,k,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.DocumentRangeSemanticTokensProviderRegistry=e.DocumentSemanticTokensProviderRegistry=e.FoldingRangeProviderRegistry=e.SelectionRangeRegistry=e.ColorProviderRegistry=e.LinkProviderRegistry=e.OnTypeFormattingEditProviderRegistry=e.DocumentRangeFormattingEditProviderRegistry=e.DocumentFormattingEditProviderRegistry=e.CodeActionProviderRegistry=e.InlayHintsProviderRegistry=e.CodeLensProviderRegistry=e.TypeDefinitionProviderRegistry=e.ImplementationProviderRegistry=e.DeclarationProviderRegistry=e.DefinitionProviderRegistry=e.LinkedEditingRangeProviderRegistry=e.DocumentHighlightProviderRegistry=e.DocumentSymbolProviderRegistry=e.InlineValuesProviderRegistry=e.EvaluatableExpressionProviderRegistry=e.HoverProviderRegistry=e.SignatureHelpProviderRegistry=e.InlineCompletionsProviderRegistry=e.CompletionProviderRegistry=e.RenameProviderRegistry=e.ReferenceProviderRegistry=e.InlayHintKind=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.completionKindFromString=e.completionKindToCssClass=e.CompletionItemKind=e.TokenMetadata=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageIdentifier=e.LanguageId=void 0;var P;(function(a){a[a.Null=0]="Null",a[a.PlainText=1]="PlainText"})(P=e.LanguageId||(e.LanguageId={}));class _{constructor(L,O){this.language=L,this.id=O}}e.LanguageIdentifier=_;var C;(function(a){a[a.NotSet=-1]="NotSet",a[a.None=0]="None",a[a.Italic=1]="Italic",a[a.Bold=2]="Bold",a[a.Underline=4]="Underline"})(C=e.FontStyle||(e.FontStyle={}));var s;(function(a){a[a.None=0]="None",a[a.DefaultForeground=1]="DefaultForeground",a[a.DefaultBackground=2]="DefaultBackground"})(s=e.ColorId||(e.ColorId={}));var I;(function(a){a[a.Other=0]="Other",a[a.Comment=1]="Comment",a[a.String=2]="String",a[a.RegEx=4]="RegEx"})(I=e.StandardTokenType||(e.StandardTokenType={}));var l;(function(a){a[a.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",a[a.TOKEN_TYPE_MASK=1792]="TOKEN_TYPE_MASK",a[a.FONT_STYLE_MASK=14336]="FONT_STYLE_MASK",a[a.FOREGROUND_MASK=8372224]="FOREGROUND_MASK",a[a.BACKGROUND_MASK=4286578688]="BACKGROUND_MASK",a[a.ITALIC_MASK=2048]="ITALIC_MASK",a[a.BOLD_MASK=4096]="BOLD_MASK",a[a.UNDERLINE_MASK=8192]="UNDERLINE_MASK",a[a.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",a[a.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",a[a.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",a[a.SEMANTIC_USE_FOREGROUND=8]="SEMANTIC_USE_FOREGROUND",a[a.SEMANTIC_USE_BACKGROUND=16]="SEMANTIC_USE_BACKGROUND",a[a.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",a[a.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",a[a.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",a[a.FOREGROUND_OFFSET=14]="FOREGROUND_OFFSET",a[a.BACKGROUND_OFFSET=23]="BACKGROUND_OFFSET"})(l=e.MetadataConsts||(e.MetadataConsts={}));class m{static getLanguageId(L){return(L&255)>>>0}static getTokenType(L){return(L&1792)>>>8}static getFontStyle(L){return(L&14336)>>>11}static getForeground(L){return(L&8372224)>>>14}static getBackground(L){return(L&4286578688)>>>23}static getClassNameFromMetadata(L){let O=this.getForeground(L),W="mtk"+O,J=this.getFontStyle(L);return J&1&&(W+=" mtki"),J&2&&(W+=" mtkb"),J&4&&(W+=" mtku"),W}static getInlineStyleFromMetadata(L,O){const W=this.getForeground(L),J=this.getFontStyle(L);let se=`color: ${O[W]};`;return J&1&&(se+="font-style: italic;"),J&2&&(se+="font-weight: bold;"),J&4&&(se+="text-decoration: underline;"),se}}e.TokenMetadata=m;var c;(function(a){a[a.Method=0]="Method",a[a.Function=1]="Function",a[a.Constructor=2]="Constructor",a[a.Field=3]="Field",a[a.Variable=4]="Variable",a[a.Class=5]="Class",a[a.Struct=6]="Struct",a[a.Interface=7]="Interface",a[a.Module=8]="Module",a[a.Property=9]="Property",a[a.Event=10]="Event",a[a.Operator=11]="Operator",a[a.Unit=12]="Unit",a[a.Value=13]="Value",a[a.Constant=14]="Constant",a[a.Enum=15]="Enum",a[a.EnumMember=16]="EnumMember",a[a.Keyword=17]="Keyword",a[a.Text=18]="Text",a[a.Color=19]="Color",a[a.File=20]="File",a[a.Reference=21]="Reference",a[a.Customcolor=22]="Customcolor",a[a.Folder=23]="Folder",a[a.TypeParameter=24]="TypeParameter",a[a.User=25]="User",a[a.Issue=26]="Issue",a[a.Snippet=27]="Snippet"})(c=e.CompletionItemKind||(e.CompletionItemKind={})),e.completionKindToCssClass=function(){let a=Object.create(null);return a[0]="symbol-method",a[1]="symbol-function",a[2]="symbol-constructor",a[3]="symbol-field",a[4]="symbol-variable",a[5]="symbol-class",a[6]="symbol-struct",a[7]="symbol-interface",a[8]="symbol-module",a[9]="symbol-property",a[10]="symbol-event",a[11]="symbol-operator",a[12]="symbol-unit",a[13]="symbol-value",a[14]="symbol-constant",a[15]="symbol-enum",a[16]="symbol-enum-member",a[17]="symbol-keyword",a[27]="symbol-snippet",a[18]="symbol-text",a[19]="symbol-color",a[20]="symbol-file",a[21]="symbol-reference",a[22]="symbol-customcolor",a[23]="symbol-folder",a[24]="symbol-type-parameter",a[25]="account",a[26]="issues",function(L){const O=a[L];let W=O&&A.iconRegistry.get(O);return W||(console.info("No codicon found for CompletionItemKind "+L),W=A.Codicon.symbolProperty),W.classNames}}(),e.completionKindFromString=function(){let a=Object.create(null);return a.method=0,a.function=1,a.constructor=2,a.field=3,a.variable=4,a.class=5,a.struct=6,a.interface=7,a.module=8,a.property=9,a.event=10,a.operator=11,a.unit=12,a.value=13,a.constant=14,a.enum=15,a["enum-member"]=16,a.enumMember=16,a.keyword=17,a.snippet=27,a.text=18,a.color=19,a.file=20,a.reference=21,a.customcolor=22,a.folder=23,a["type-parameter"]=24,a.typeParameter=24,a.account=25,a.issue=26,function(L,O){let W=a[L];return typeof W=="undefined"&&!O&&(W=9),W}}();var h;(function(a){a[a.Deprecated=1]="Deprecated"})(h=e.CompletionItemTag||(e.CompletionItemTag={}));var S;(function(a){a[a.KeepWhitespace=1]="KeepWhitespace",a[a.InsertAsSnippet=4]="InsertAsSnippet"})(S=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var w;(function(a){a[a.Invoke=0]="Invoke",a[a.TriggerCharacter=1]="TriggerCharacter",a[a.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(w=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var b;(function(a){a[a.Automatic=0]="Automatic",a[a.Explicit=1]="Explicit"})(b=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var u;(function(a){a[a.Invoke=1]="Invoke",a[a.Auto=2]="Auto"})(u=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var d;(function(a){a[a.Invoke=1]="Invoke",a[a.TriggerCharacter=2]="TriggerCharacter",a[a.ContentChange=3]="ContentChange"})(d=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var p;(function(a){a[a.Text=0]="Text",a[a.Read=1]="Read",a[a.Write=2]="Write"})(p=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function t(a){return a&&v.URI.isUri(a.uri)&&R.Range.isIRange(a.range)&&(R.Range.isIRange(a.originSelectionRange)||R.Range.isIRange(a.targetSelectionRange))}e.isLocationLink=t;var i;(function(a){a[a.File=0]="File",a[a.Module=1]="Module",a[a.Namespace=2]="Namespace",a[a.Package=3]="Package",a[a.Class=4]="Class",a[a.Method=5]="Method",a[a.Property=6]="Property",a[a.Field=7]="Field",a[a.Constructor=8]="Constructor",a[a.Enum=9]="Enum",a[a.Interface=10]="Interface",a[a.Function=11]="Function",a[a.Variable=12]="Variable",a[a.Constant=13]="Constant",a[a.String=14]="String",a[a.Number=15]="Number",a[a.Boolean=16]="Boolean",a[a.Array=17]="Array",a[a.Object=18]="Object",a[a.Key=19]="Key",a[a.Null=20]="Null",a[a.EnumMember=21]="EnumMember",a[a.Struct=22]="Struct",a[a.Event=23]="Event",a[a.Operator=24]="Operator",a[a.TypeParameter=25]="TypeParameter"})(i=e.SymbolKind||(e.SymbolKind={}));var r;(function(a){a[a.Deprecated=1]="Deprecated"})(r=e.SymbolTag||(e.SymbolTag={}));var n;(function(a){const L=new Map;L.set("file",0),L.set("module",1),L.set("namespace",2),L.set("package",3),L.set("class",4),L.set("method",5),L.set("property",6),L.set("field",7),L.set("constructor",8),L.set("enum",9),L.set("interface",10),L.set("function",11),L.set("variable",12),L.set("constant",13),L.set("string",14),L.set("number",15),L.set("boolean",16),L.set("array",17),L.set("object",18),L.set("key",19),L.set("null",20),L.set("enum-member",21),L.set("struct",22),L.set("event",23),L.set("operator",24),L.set("type-parameter",25);const O=new Map;O.set(0,"file"),O.set(1,"module"),O.set(2,"namespace"),O.set(3,"package"),O.set(4,"class"),O.set(5,"method"),O.set(6,"property"),O.set(7,"field"),O.set(8,"constructor"),O.set(9,"enum"),O.set(10,"interface"),O.set(11,"function"),O.set(12,"variable"),O.set(13,"constant"),O.set(14,"string"),O.set(15,"number"),O.set(16,"boolean"),O.set(17,"array"),O.set(18,"object"),O.set(19,"key"),O.set(20,"null"),O.set(21,"enum-member"),O.set(22,"struct"),O.set(23,"event"),O.set(24,"operator"),O.set(25,"type-parameter");function W(q){return L.get(q)}a.fromString=W;function J(q){return O.get(q)}a.toString=J;function se(q,N){const H=O.get(q);let T=H&&A.iconRegistry.get("symbol-"+H);return T||(console.info("No codicon found for SymbolKind "+q),T=A.Codicon.symbolProperty),`${N?"inline":"block"} ${T.classNames}`}a.toCssClassName=se})(n=e.SymbolKinds||(e.SymbolKinds={}));class o{constructor(L){this.value=L}}e.FoldingRangeKind=o,o.Comment=new o("comment"),o.Imports=new o("imports"),o.Region=new o("region");var g;(function(a){a[a.Collapsed=0]="Collapsed",a[a.Expanded=1]="Expanded"})(g=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var f;(function(a){a[a.Editing=0]="Editing",a[a.Preview=1]="Preview"})(f=e.CommentMode||(e.CommentMode={}));var E;(function(a){a[a.Other=0]="Other",a[a.Type=1]="Type",a[a.Parameter=2]="Parameter"})(E=e.InlayHintKind||(e.InlayHintKind={})),e.ReferenceProviderRegistry=new k.LanguageFeatureRegistry,e.RenameProviderRegistry=new k.LanguageFeatureRegistry,e.CompletionProviderRegistry=new k.LanguageFeatureRegistry,e.InlineCompletionsProviderRegistry=new k.LanguageFeatureRegistry,e.SignatureHelpProviderRegistry=new k.LanguageFeatureRegistry,e.HoverProviderRegistry=new k.LanguageFeatureRegistry,e.EvaluatableExpressionProviderRegistry=new k.LanguageFeatureRegistry,e.InlineValuesProviderRegistry=new k.LanguageFeatureRegistry,e.DocumentSymbolProviderRegistry=new k.LanguageFeatureRegistry,e.DocumentHighlightProviderRegistry=new k.LanguageFeatureRegistry,e.LinkedEditingRangeProviderRegistry=new k.LanguageFeatureRegistry,e.DefinitionProviderRegistry=new k.LanguageFeatureRegistry,e.DeclarationProviderRegistry=new k.LanguageFeatureRegistry,e.ImplementationProviderRegistry=new k.LanguageFeatureRegistry,e.TypeDefinitionProviderRegistry=new k.LanguageFeatureRegistry,e.CodeLensProviderRegistry=new k.LanguageFeatureRegistry,e.InlayHintsProviderRegistry=new k.LanguageFeatureRegistry,e.CodeActionProviderRegistry=new k.LanguageFeatureRegistry,e.DocumentFormattingEditProviderRegistry=new k.LanguageFeatureRegistry,e.DocumentRangeFormattingEditProviderRegistry=new k.LanguageFeatureRegistry,e.OnTypeFormattingEditProviderRegistry=new k.LanguageFeatureRegistry,e.LinkProviderRegistry=new k.LanguageFeatureRegistry,e.ColorProviderRegistry=new k.LanguageFeatureRegistry,e.SelectionRangeRegistry=new k.LanguageFeatureRegistry,e.FoldingRangeProviderRegistry=new k.LanguageFeatureRegistry,e.DocumentSemanticTokensProviderRegistry=new k.LanguageFeatureRegistry,e.DocumentRangeSemanticTokensProviderRegistry=new k.LanguageFeatureRegistry,e.TokenizationRegistry=new D.TokenizationRegistryImpl;var y;(function(a){a[a.None=0]="None",a[a.Option=1]="Option",a[a.Default=2]="Default",a[a.Preferred=3]="Preferred"})(y=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(ge[113],pe([0,1,8,4,11]),function(Q,e,v,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyOrExpr=e.ContextKeyAndExpr=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.ContextKeyExpr=e.ContextKeyExprType=void 0;let D=k.userAgent||"";const A=new Map;A.set("false",!1),A.set("true",!0),A.set("isMac",k.isMacintosh),A.set("isLinux",k.isLinux),A.set("isWindows",k.isWindows),A.set("isWeb",k.isWeb),A.set("isMacNative",k.isMacintosh&&!k.isWeb),A.set("isEdge",D.indexOf("Edg/")>=0),A.set("isFirefox",D.indexOf("Firefox")>=0),A.set("isChrome",D.indexOf("Chrome")>=0),A.set("isSafari",D.indexOf("Safari")>=0);const P=Object.prototype.hasOwnProperty;var _;(function(y){y[y.False=0]="False",y[y.True=1]="True",y[y.Defined=2]="Defined",y[y.Not=3]="Not",y[y.Equals=4]="Equals",y[y.NotEquals=5]="NotEquals",y[y.And=6]="And",y[y.Regex=7]="Regex",y[y.NotRegex=8]="NotRegex",y[y.Or=9]="Or",y[y.In=10]="In",y[y.NotIn=11]="NotIn",y[y.Greater=12]="Greater",y[y.GreaterEquals=13]="GreaterEquals",y[y.Smaller=14]="Smaller",y[y.SmallerEquals=15]="SmallerEquals"})(_=e.ContextKeyExprType||(e.ContextKeyExprType={}));class C{static false(){return I.INSTANCE}static true(){return l.INSTANCE}static has(a){return m.create(a)}static equals(a,L){return c.create(a,L)}static notEquals(a,L){return w.create(a,L)}static regex(a,L){return i.create(a,L)}static in(a,L){return h.create(a,L)}static not(a){return b.create(a)}static and(...a){return n.create(a)}static or(...a){return o.create(a)}static greater(a,L){return u.create(a,L)}static less(a,L){return p.create(a,L)}static deserialize(a,L=!1){if(!!a)return this._deserializeOrExpression(a,L)}static _deserializeOrExpression(a,L){let O=a.split("||");return o.create(O.map(W=>this._deserializeAndExpression(W,L)))}static _deserializeAndExpression(a,L){let O=a.split("&&");return n.create(O.map(W=>this._deserializeOne(W,L)))}static _deserializeOne(a,L){if(a=a.trim(),a.indexOf("!=")>=0){let O=a.split("!=");return w.create(O[0].trim(),this._deserializeValue(O[1],L))}if(a.indexOf("==")>=0){let O=a.split("==");return c.create(O[0].trim(),this._deserializeValue(O[1],L))}if(a.indexOf("=~")>=0){let O=a.split("=~");return i.create(O[0].trim(),this._deserializeRegexValue(O[1],L))}if(a.indexOf(" in ")>=0){let O=a.split(" in ");return h.create(O[0].trim(),O[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(a)){const O=a.split(">=");return d.create(O[0].trim(),O[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(a)){const O=a.split(">");return u.create(O[0].trim(),O[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(a)){const O=a.split("<=");return t.create(O[0].trim(),O[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(a)){const O=a.split("<");return p.create(O[0].trim(),O[1].trim())}return/^\!\s*/.test(a)?b.create(a.substr(1).trim()):m.create(a)}static _deserializeValue(a,L){if(a=a.trim(),a==="true")return!0;if(a==="false")return!1;let O=/^'([^']*)'$/.exec(a);return O?O[1].trim():a}static _deserializeRegexValue(a,L){if(v.isFalsyOrWhitespace(a)){if(L)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let O=a.indexOf("/"),W=a.lastIndexOf("/");if(O===W||O<0){if(L)throw new Error(`bad regexp-value '${a}', missing /-enclosure`);return console.warn(`bad regexp-value '${a}', missing /-enclosure`),null}let J=a.slice(O+1,W),se=a[W+1]==="i"?"i":"";try{return new RegExp(J,se)}catch(q){if(L)throw new Error(`bad regexp-value '${a}', parse error: ${q}`);return console.warn(`bad regexp-value '${a}', parse error: ${q}`),null}}}e.ContextKeyExpr=C;function s(y,a){return y.cmp(a)}class I{constructor(){this.type=0}cmp(a){return this.type-a.type}equals(a){return a.type===this.type}evaluate(a){return!1}serialize(){return"false"}keys(){return[]}map(a){return this}negate(){return l.INSTANCE}}e.ContextKeyFalseExpr=I,I.INSTANCE=new I;class l{constructor(){this.type=1}cmp(a){return this.type-a.type}equals(a){return a.type===this.type}evaluate(a){return!0}serialize(){return"true"}keys(){return[]}map(a){return this}negate(){return I.INSTANCE}}e.ContextKeyTrueExpr=l,l.INSTANCE=new l;class m{constructor(a){this.key=a,this.type=2}static create(a){const L=A.get(a);return typeof L=="boolean"?L?l.INSTANCE:I.INSTANCE:new m(a)}cmp(a){return a.type!==this.type?this.type-a.type:f(this.key,a.key)}equals(a){return a.type===this.type?this.key===a.key:!1}evaluate(a){return!!a.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(a){return a.mapDefined(this.key)}negate(){return b.create(this.key)}}e.ContextKeyDefinedExpr=m;class c{constructor(a,L){this.key=a,this.value=L,this.type=4}static create(a,L){if(typeof L=="boolean")return L?m.create(a):b.create(a);const O=A.get(a);return typeof O=="boolean"?L===(O?"true":"false")?l.INSTANCE:I.INSTANCE:new c(a,L)}cmp(a){return a.type!==this.type?this.type-a.type:E(this.key,this.value,a.key,a.value)}equals(a){return a.type===this.type?this.key===a.key&&this.value===a.value:!1}evaluate(a){return a.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(a){return a.mapEquals(this.key,this.value)}negate(){return w.create(this.key,this.value)}}e.ContextKeyEqualsExpr=c;class h{constructor(a,L){this.key=a,this.valueKey=L,this.type=10}static create(a,L){return new h(a,L)}cmp(a){return a.type!==this.type?this.type-a.type:E(this.key,this.valueKey,a.key,a.valueKey)}equals(a){return a.type===this.type?this.key===a.key&&this.valueKey===a.valueKey:!1}evaluate(a){const L=a.getValue(this.valueKey),O=a.getValue(this.key);return Array.isArray(L)?L.indexOf(O)>=0:typeof O=="string"&&typeof L=="object"&&L!==null?P.call(L,O):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(a){return a.mapIn(this.key,this.valueKey)}negate(){return S.create(this)}}e.ContextKeyInExpr=h;class S{constructor(a){this._actual=a,this.type=11}static create(a){return new S(a)}cmp(a){return a.type!==this.type?this.type-a.type:this._actual.cmp(a._actual)}equals(a){return a.type===this.type?this._actual.equals(a._actual):!1}evaluate(a){return!this._actual.evaluate(a)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(a){return new S(this._actual.map(a))}negate(){return this._actual}}e.ContextKeyNotInExpr=S;class w{constructor(a,L){this.key=a,this.value=L,this.type=5}static create(a,L){if(typeof L=="boolean")return L?b.create(a):m.create(a);const O=A.get(a);return typeof O=="boolean"?L===(O?"true":"false")?I.INSTANCE:l.INSTANCE:new w(a,L)}cmp(a){return a.type!==this.type?this.type-a.type:E(this.key,this.value,a.key,a.value)}equals(a){return a.type===this.type?this.key===a.key&&this.value===a.value:!1}evaluate(a){return a.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(a){return a.mapNotEquals(this.key,this.value)}negate(){return c.create(this.key,this.value)}}e.ContextKeyNotEqualsExpr=w;class b{constructor(a){this.key=a,this.type=3}static create(a){const L=A.get(a);return typeof L=="boolean"?L?I.INSTANCE:l.INSTANCE:new b(a)}cmp(a){return a.type!==this.type?this.type-a.type:f(this.key,a.key)}equals(a){return a.type===this.type?this.key===a.key:!1}evaluate(a){return!a.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(a){return a.mapNot(this.key)}negate(){return m.create(this.key)}}e.ContextKeyNotExpr=b;class u{constructor(a,L){this.key=a,this.value=L,this.type=12}static create(a,L){return new u(a,L)}cmp(a){return a.type!==this.type?this.type-a.type:E(this.key,this.value,a.key,a.value)}equals(a){return a.type===this.type?this.key===a.key&&this.value===a.value:!1}evaluate(a){return parseFloat(a.getValue(this.key))>parseFloat(this.value)}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(a){return a.mapGreater(this.key,this.value)}negate(){return t.create(this.key,this.value)}}e.ContextKeyGreaterExpr=u;class d{constructor(a,L){this.key=a,this.value=L,this.type=13}static create(a,L){return new d(a,L)}cmp(a){return a.type!==this.type?this.type-a.type:E(this.key,this.value,a.key,a.value)}equals(a){return a.type===this.type?this.key===a.key&&this.value===a.value:!1}evaluate(a){return parseFloat(a.getValue(this.key))>=parseFloat(this.value)}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(a){return a.mapGreaterEquals(this.key,this.value)}negate(){return p.create(this.key,this.value)}}e.ContextKeyGreaterEqualsExpr=d;class p{constructor(a,L){this.key=a,this.value=L,this.type=14}static create(a,L){return new p(a,L)}cmp(a){return a.type!==this.type?this.type-a.type:E(this.key,this.value,a.key,a.value)}equals(a){return a.type===this.type?this.key===a.key&&this.value===a.value:!1}evaluate(a){return parseFloat(a.getValue(this.key))<parseFloat(this.value)}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(a){return a.mapSmaller(this.key,this.value)}negate(){return d.create(this.key,this.value)}}e.ContextKeySmallerExpr=p;class t{constructor(a,L){this.key=a,this.value=L,this.type=15}static create(a,L){return new t(a,L)}cmp(a){return a.type!==this.type?this.type-a.type:E(this.key,this.value,a.key,a.value)}equals(a){return a.type===this.type?this.key===a.key&&this.value===a.value:!1}evaluate(a){return parseFloat(a.getValue(this.key))<=parseFloat(this.value)}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(a){return a.mapSmallerEquals(this.key,this.value)}negate(){return u.create(this.key,this.value)}}e.ContextKeySmallerEqualsExpr=t;class i{constructor(a,L){this.key=a,this.regexp=L,this.type=7}static create(a,L){return new i(a,L)}cmp(a){if(a.type!==this.type)return this.type-a.type;if(this.key<a.key)return-1;if(this.key>a.key)return 1;const L=this.regexp?this.regexp.source:"",O=a.regexp?a.regexp.source:"";return L<O?-1:L>O?1:0}equals(a){if(a.type===this.type){const L=this.regexp?this.regexp.source:"",O=a.regexp?a.regexp.source:"";return this.key===a.key&&L===O}return!1}evaluate(a){let L=a.getValue(this.key);return this.regexp?this.regexp.test(L):!1}serialize(){const a=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${a}`}keys(){return[this.key]}map(a){return a.mapRegex(this.key,this.regexp)}negate(){return r.create(this)}}e.ContextKeyRegexExpr=i;class r{constructor(a){this._actual=a,this.type=8}static create(a){return new r(a)}cmp(a){return a.type!==this.type?this.type-a.type:this._actual.cmp(a._actual)}equals(a){return a.type===this.type?this._actual.equals(a._actual):!1}evaluate(a){return!this._actual.evaluate(a)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(a){return new r(this._actual.map(a))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=r;class n{constructor(a){this.expr=a,this.type=6}static create(a){return n._normalizeArr(a)}cmp(a){if(a.type!==this.type)return this.type-a.type;if(this.expr.length<a.expr.length)return-1;if(this.expr.length>a.expr.length)return 1;for(let L=0,O=this.expr.length;L<O;L++){const W=s(this.expr[L],a.expr[L]);if(W!==0)return W}return 0}equals(a){if(a.type===this.type){if(this.expr.length!==a.expr.length)return!1;for(let L=0,O=this.expr.length;L<O;L++)if(!this.expr[L].equals(a.expr[L]))return!1;return!0}return!1}evaluate(a){for(let L=0,O=this.expr.length;L<O;L++)if(!this.expr[L].evaluate(a))return!1;return!0}static _normalizeArr(a){const L=[];let O=!1;for(const W of a)if(!!W){if(W.type===1){O=!0;continue}if(W.type===0)return I.INSTANCE;if(W.type===6){L.push(...W.expr);continue}L.push(W)}if(L.length===0&&O)return l.INSTANCE;if(L.length!==0){if(L.length===1)return L[0];for(L.sort(s);L.length>1;){const W=L[L.length-1];if(W.type!==9)break;L.pop();const J=L.pop(),se=o.create(W.expr.map(q=>n.create([q,J])));se&&(L.push(se),L.sort(s))}return L.length===1?L[0]:new n(L)}}serialize(){return this.expr.map(a=>a.serialize()).join(" && ")}keys(){const a=[];for(let L of this.expr)a.push(...L.keys());return a}map(a){return new n(this.expr.map(L=>L.map(a)))}negate(){let a=[];for(let L of this.expr)a.push(L.negate());return o.create(a)}}e.ContextKeyAndExpr=n;class o{constructor(a){this.expr=a,this.type=9}static create(a){const L=o._normalizeArr(a);if(L.length!==0)return L.length===1?L[0]:new o(L)}cmp(a){if(a.type!==this.type)return this.type-a.type;if(this.expr.length<a.expr.length)return-1;if(this.expr.length>a.expr.length)return 1;for(let L=0,O=this.expr.length;L<O;L++){const W=s(this.expr[L],a.expr[L]);if(W!==0)return W}return 0}equals(a){if(a.type===this.type){if(this.expr.length!==a.expr.length)return!1;for(let L=0,O=this.expr.length;L<O;L++)if(!this.expr[L].equals(a.expr[L]))return!1;return!0}return!1}evaluate(a){for(let L=0,O=this.expr.length;L<O;L++)if(this.expr[L].evaluate(a))return!0;return!1}static _normalizeArr(a){let L=[],O=!1;if(a){for(let W=0,J=a.length;W<J;W++){const se=a[W];if(!!se){if(se.type===0){O=!0;continue}if(se.type===1)return[l.INSTANCE];if(se.type===9){L=L.concat(se.expr);continue}L.push(se)}}if(L.length===0&&O)return[I.INSTANCE];L.sort(s)}return L}serialize(){return this.expr.map(a=>a.serialize()).join(" || ")}keys(){const a=[];for(let L of this.expr)a.push(...L.keys());return a}map(a){return new o(this.expr.map(L=>L.map(a)))}negate(){let a=[];for(let O of this.expr)a.push(O.negate());const L=O=>O.type===9?O.expr:[O];for(;a.length>1;){const O=a.shift(),W=a.shift(),J=[];for(const se of L(O))for(const q of L(W))J.push(C.and(se,q));a.unshift(C.or(...J))}return a[0]}}e.ContextKeyOrExpr=o;class g extends m{constructor(a,L,O){super(a);this._defaultValue=L,typeof O=="object"?g._info.push(Object.assign(Object.assign({},O),{key:a})):O!==!0&&g._info.push({key:a,description:O,type:L!=null?typeof L:void 0})}static all(){return g._info.values()}bindTo(a){return a.createKey(this.key,this._defaultValue)}getValue(a){return a.getContextKeyValue(this.key)}toNegated(){return C.not(this.key)}isEqualTo(a){return C.equals(this.key,a)}notEqualsTo(a){return C.notEquals(this.key,a)}}e.RawContextKey=g,g._info=[],e.IContextKeyService=R.createDecorator("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function f(y,a){return y<a?-1:y>a?1:0}function E(y,a,L,O){return y<L?-1:y>L?1:a<O?-1:a>O?1:0}}),define(ge[176],pe([0,1,4]),function(Q,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=v.createDecorator("environmentService"),e.INativeEnvironmentService=v.refineServiceDecorator(e.IEnvironmentService)}),define(ge[177],pe([0,1,152,4,10]),function(Q,e,v,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.DefaultIconPath=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.INSTALL_ERROR_INCOMPATIBLE=e.INSTALL_ERROR_MALICIOUS=e.INSTALL_ERROR_NOT_SUPPORTED=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN);function D(I){return I&&typeof I=="object"&&typeof I.id=="string"&&(!I.uuid||typeof I.uuid=="string")}e.isIExtensionIdentifier=D;var A;(function(I){I[I.NoneOrRelevance=0]="NoneOrRelevance",I[I.LastUpdatedDate=1]="LastUpdatedDate",I[I.Title=2]="Title",I[I.PublisherName=3]="PublisherName",I[I.InstallCount=4]="InstallCount",I[I.PublishedDate=5]="PublishedDate",I[I.AverageRating=6]="AverageRating",I[I.WeightedRating=12]="WeightedRating"})(A=e.SortBy||(e.SortBy={}));var P;(function(I){I[I.Default=0]="Default",I[I.Ascending=1]="Ascending",I[I.Descending=2]="Descending"})(P=e.SortOrder||(e.SortOrder={}));var _;(function(I){I.Uninstall="uninstall"})(_=e.StatisticType||(e.StatisticType={}));var C;(function(I){I[I.None=0]="None",I[I.Install=1]="Install",I[I.Update=2]="Update"})(C=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=R.createDecorator("extensionGalleryService"),e.INSTALL_ERROR_NOT_SUPPORTED="notsupported",e.INSTALL_ERROR_MALICIOUS="malicious",e.INSTALL_ERROR_INCOMPATIBLE="incompatible";class s extends Error{constructor(l,m){super(l);this.code=m}}e.ExtensionManagementError=s,e.IExtensionManagementService=R.createDecorator("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=R.createDecorator("IGlobalExtensionEnablementService"),e.IExtensionTipsService=R.createDecorator("IExtensionTipsService"),e.DefaultIconPath=k.FileAccess.asBrowserUri("./media/defaultIcon.png",Q).toString(!0),e.ExtensionsLabel=v.localize(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=v.localize(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=R.createDecorator("IExtensionManagementCLIService")}),define(ge[26],pe([0,1,8,4]),function(Q,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isAuthenticaionProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkpaceSupportTypeMessage=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin";function k(s){if(typeof s=="object"&&s!==null&&s.supported!==!0)return s.description}e.getWorkpaceSupportTypeMessage=k;function D(s){return s&&typeof s=="object"&&typeof s.id=="string"&&(!s.uuid||typeof s.uuid=="string")}e.isIExtensionIdentifier=D,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var A;(function(s){s[s.System=0]="System",s[s.User=1]="User"})(A=e.ExtensionType||(e.ExtensionType={}));class P{constructor(I){this.value=I,this._lower=I.toLowerCase()}static equals(I,l){if(typeof I=="undefined"||I===null)return typeof l=="undefined"||l===null;if(typeof l=="undefined"||l===null)return!1;if(typeof I=="string"||typeof l=="string"){let m=typeof I=="string"?I:I.value,c=typeof l=="string"?l:l.value;return v.equalsIgnoreCase(m,c)}return I._lower===l._lower}static toKey(I){return typeof I=="string"?I.toLowerCase():I._lower}}e.ExtensionIdentifier=P;function _(s){return s.contributes&&s.contributes.localizations?s.contributes.localizations.length>0:!1}e.isLanguagePackExtension=_;function C(s){return s.contributes&&s.contributes.authentication?s.contributes.authentication.length>0:!1}e.isAuthenticaionProviderExtension=C,e.IBuiltinExtensionsScannerService=R.createDecorator("IBuiltinExtensionsScannerService")}),define(ge[178],pe([0,1,8,26]),function(Q,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function k(m,c){return m.uuid&&c.uuid?m.uuid===c.uuid:m.id===c.id?!0:v.compareIgnoreCase(m.id,c.id)===0}e.areSameExtensions=k;class D{constructor(c,h){this.version=h,this.id=c.id,this.uuid=c.uuid}key(){return`${this.id}-${this.version}`}equals(c){return c instanceof D?k(this,c)&&this.version===c.version:!1}}e.ExtensionIdentifierWithVersion=D;function A(m,c){return`${m}.${c}`}e.getExtensionId=A;function P(m){return m.toLocaleLowerCase()}e.adoptToGalleryExtensionId=P;function _(m,c){return P(A(m,c))}e.getGalleryExtensionId=_;function C(m,c){const h=[],S=w=>{for(const b of h)if(b.some(u=>k(c(u),c(w))))return b;return null};for(const w of m){const b=S(w);b?b.push(w):h.push([w])}return h}e.groupByExtension=C;function s(m){return{id:m.identifier.id,name:m.manifest.name,galleryId:null,publisherId:m.publisherId,publisherName:m.manifest.publisher,publisherDisplayName:m.publisherDisplayName,dependencies:m.manifest.extensionDependencies&&m.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=s;function I(m){return Object.assign({id:m.identifier.id,name:m.name,galleryId:m.identifier.uuid,publisherId:m.publisherId,publisherName:m.publisher,publisherDisplayName:m.publisherDisplayName,dependencies:!!(m.properties.dependencies&&m.properties.dependencies.length>0)},m.telemetryData)}e.getGalleryExtensionTelemetryData=I,e.BetterMergeId=new R.ExtensionIdentifier("pprice.better-merge");function l(m){const c=new Set;for(const h of m)h.malicious&&c.add(h.id.id);return c}e.getMaliciousExtensionsSet=l}),define(ge[179],pe([0,1,4]),function(Q,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=v.createDecorator("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app",e.IExternalTerminalMainService=v.createDecorator("externalTerminal")}),define(ge[42],pe([0,1,155,9,2,4,8,15,23]),function(Q,e,v,R,k,D,A,P,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=D.createDecorator("fileService");function C(N){return N.create===!0}e.isFileOpenForWriteOptions=C;var s;(function(N){N[N.Unknown=0]="Unknown",N[N.File=1]="File",N[N.Directory=2]="Directory",N[N.SymbolicLink=64]="SymbolicLink"})(s=e.FileType||(e.FileType={}));var I;(function(N){N[N.Readonly=1]="Readonly"})(I=e.FilePermission||(e.FilePermission={}));var l;(function(N){N[N.FileReadWrite=2]="FileReadWrite",N[N.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",N[N.FileReadStream=16]="FileReadStream",N[N.FileFolderCopy=8]="FileFolderCopy",N[N.PathCaseSensitive=1024]="PathCaseSensitive",N[N.Readonly=2048]="Readonly",N[N.Trash=4096]="Trash",N[N.FileWriteUnlock=8192]="FileWriteUnlock"})(l=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function m(N){return!!(N.capabilities&2)}e.hasReadWriteCapability=m;function c(N){return!!(N.capabilities&8)}e.hasFileFolderCopyCapability=c;function h(N){return!!(N.capabilities&4)}e.hasOpenReadWriteCloseCapability=h;function S(N){return!!(N.capabilities&16)}e.hasFileReadStreamCapability=S;var w;(function(N){N.FileExists="EntryExists",N.FileNotFound="EntryNotFound",N.FileNotADirectory="EntryNotADirectory",N.FileIsADirectory="EntryIsADirectory",N.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",N.FileTooLarge="EntryTooLarge",N.FileWriteLocked="EntryWriteLocked",N.NoPermissions="NoPermissions",N.Unavailable="Unavailable",N.Unknown="Unknown"})(w=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class b extends Error{constructor(H,T){super(H);this.code=T}}e.FileSystemProviderError=b;function u(N,H){const T=new b(N.toString(),H);return p(T,H),T}e.createFileSystemProviderError=u;function d(N){return N||u(v.localize(0,null),w.Unknown)}e.ensureFileSystemProviderError=d;function p(N,H){return N.name=H?`${H} (FileSystemError)`:"FileSystemError",N}e.markAsFileSystemProviderError=p;function t(N){if(!N)return w.Unknown;if(N instanceof b)return N.code;const H=/^(.+) \(FileSystemError\)$/.exec(N.name);if(!H)return w.Unknown;switch(H[1]){case w.FileExists:return w.FileExists;case w.FileIsADirectory:return w.FileIsADirectory;case w.FileNotADirectory:return w.FileNotADirectory;case w.FileNotFound:return w.FileNotFound;case w.FileExceedsMemoryLimit:return w.FileExceedsMemoryLimit;case w.FileTooLarge:return w.FileTooLarge;case w.FileWriteLocked:return w.FileWriteLocked;case w.NoPermissions:return w.NoPermissions;case w.Unavailable:return w.Unavailable}return w.Unknown}e.toFileSystemProviderErrorCode=t;function i(N){if(N instanceof E)return N.fileOperationResult;switch(t(N)){case w.FileNotFound:return 1;case w.FileIsADirectory:return 0;case w.FileNotADirectory:return 10;case w.FileWriteLocked:return 5;case w.NoPermissions:return 6;case w.FileExists:return 4;case w.FileExceedsMemoryLimit:return 9;case w.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=i;var r;(function(N){N[N.CREATE=0]="CREATE",N[N.DELETE=1]="DELETE",N[N.MOVE=2]="MOVE",N[N.COPY=3]="COPY"})(r=e.FileOperation||(e.FileOperation={}));class n{constructor(H,T,U){this.resource=H,this.operation=T,this.target=U}isOperation(H){return this.operation===H}}e.FileOperationEvent=n;var o;(function(N){N[N.UPDATED=0]="UPDATED",N[N.ADDED=1]="ADDED",N[N.DELETED=2]="DELETED"})(o=e.FileChangeType||(e.FileChangeType={}));class g{constructor(H,T){this.changes=H,this.added=void 0,this.updated=void 0,this.deleted=void 0;for(const U of H)switch(U.type){case 1:this.added||(this.added=_.TernarySearchTree.forUris(()=>T)),this.added.set(U.resource,U);break;case 0:this.updated||(this.updated=_.TernarySearchTree.forUris(()=>T)),this.updated.set(U.resource,U);break;case 2:this.deleted||(this.deleted=_.TernarySearchTree.forUris(()=>T)),this.deleted.set(U.resource,U);break}}contains(H,...T){return this.doContains(H,{includeChildren:!1},...T)}affects(H,...T){return this.doContains(H,{includeChildren:!0},...T)}doContains(H,T,...U){var F,M,x,$,X,le;if(!H)return!1;const be=U.length>0;return!!((!be||U.includes(1))&&(((F=this.added)===null||F===void 0?void 0:F.get(H))||T.includeChildren&&((M=this.added)===null||M===void 0?void 0:M.findSuperstr(H)))||(!be||U.includes(0))&&(((x=this.updated)===null||x===void 0?void 0:x.get(H))||T.includeChildren&&(($=this.updated)===null||$===void 0?void 0:$.findSuperstr(H)))||(!be||U.includes(2))&&(((X=this.deleted)===null||X===void 0?void 0:X.findSubstr(H))||T.includeChildren&&((le=this.deleted)===null||le===void 0?void 0:le.findSuperstr(H))))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}get raw(){return this.changes}get rawAdded(){return this.added}get rawDeleted(){return this.deleted}}e.FileChangesEvent=g;function f(N,H,T){return!N||!H||N===H||H.length>N.length?!1:(H.charAt(H.length-1)!==R.sep&&(H+=R.sep),T?A.startsWithIgnoreCase(N,H):N.indexOf(H)===0)}e.isParent=f;class E extends Error{constructor(H,T,U){super(H);this.fileOperationResult=T,this.options=U}}e.FileOperationError=E;class y extends E{constructor(H,T,U){super(H,2,U);this.stat=T}}e.NotModifiedSinceFileOperationError=y;var a;(function(N){N[N.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",N[N.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",N[N.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",N[N.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",N[N.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",N[N.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",N[N.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",N[N.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",N[N.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",N[N.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",N[N.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",N[N.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(a=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var L;(function(N){N[N.FILE=0]="FILE",N[N.FOLDER=1]="FOLDER",N[N.ROOT_FOLDER=2]="ROOT_FOLDER"})(L=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function O(N){if(!(typeof N.size!="number"||typeof N.mtime!="number"))return N.mtime.toString(29)+N.size.toString(31)}e.etag=O;async function W(N,H){if(!H.canHandleResource(k.URI.from({scheme:N.scheme})))return new Promise(T=>{const U=H.onDidChangeFileSystemProviderRegistrations(F=>{F.scheme===N.scheme&&F.added&&(U.dispose(),T())})})}e.whenProviderRegistered=W,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class J{static formatSize(H){return P.isNumber(H)||(H=0),H<J.KB?v.localize(1,null,H.toFixed(0)):H<J.MB?v.localize(2,null,(H/J.KB).toFixed(2)):H<J.GB?v.localize(3,null,(H/J.MB).toFixed(2)):H<J.TB?v.localize(4,null,(H/J.GB).toFixed(2)):v.localize(5,null,(H/J.TB).toFixed(2))}}e.ByteSize=J,J.KB=1024,J.MB=J.KB*J.KB,J.GB=J.MB*J.KB,J.TB=J.GB*J.KB;var se;(function(N){N[N.IA32=0]="IA32",N[N.OTHER=1]="OTHER"})(se=e.Arch||(e.Arch={}));function q(N){return{maxFileSize:N===0?300*J.MB:16*J.GB,maxHeapSize:N===0?700*J.MB:2*700*J.MB}}e.getPlatformLimits=q}),define(ge[79],pe([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class v{constructor(...k){this._entries=new Map;for(let[D,A]of k)this.set(D,A)}set(k,D){const A=this._entries.get(k);return this._entries.set(k,D),A}has(k){return this._entries.has(k)}get(k){return this._entries.get(k)}}e.ServiceCollection=v}),define(ge[180],pe([0,1,14,173,112,4,79,16]),function(Q,e,v,R,k,D,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const _=!1;class C extends Error{constructor(c){var h;super("cyclic dependency between services");this.message=(h=c.findCycleSlow())!==null&&h!==void 0?h:`UNABLE to detect cycle, dumping graph: 
${c.toString()}`}}class s{constructor(c=new A.ServiceCollection,h=!1,S){this._activeInstantiations=new Set,this._services=c,this._strict=h,this._parent=S,this._services.set(D.IInstantiationService,this)}createChild(c){return new s(c,this._strict,this)}invokeFunction(c,...h){let S=l.traceInvocation(c),w=!1;try{return c({get:(u,d)=>{if(w)throw v.illegalState("service accessor is only valid during the invocation of its target method");const p=this._getOrCreateServiceInstance(u,S);if(!p&&d!==D.optional)throw new Error(`[invokeFunction] unknown service '${u}'`);return p}},...h)}finally{w=!0,S.stop()}}createInstance(c,...h){let S,w;return c instanceof k.SyncDescriptor?(S=l.traceCreation(c.ctor),w=this._createInstance(c.ctor,c.staticArguments.concat(h),S)):(S=l.traceCreation(c),w=this._createInstance(c,h,S)),S.stop(),w}_createInstance(c,h=[],S){let w=D._util.getServiceDependencies(c).sort((d,p)=>d.index-p.index),b=[];for(const d of w){let p=this._getOrCreateServiceInstance(d.id,S);if(!p&&this._strict&&!d.optional)throw new Error(`[createInstance] ${c.name} depends on UNKNOWN service ${d.id}.`);b.push(p)}let u=w.length>0?w[0].index:h.length;if(h.length!==u){console.warn(`[createInstance] First service dependency of ${c.name} at position ${u+1} conflicts with ${h.length} static arguments`);let d=u-h.length;d>0?h=h.concat(new Array(d)):h=h.slice(0,u)}return new c(...[...h,...b])}_setServiceInstance(c,h){if(this._services.get(c)instanceof k.SyncDescriptor)this._services.set(c,h);else if(this._parent)this._parent._setServiceInstance(c,h);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(c){let h=this._services.get(c);return!h&&this._parent?this._parent._getServiceInstanceOrDescriptor(c):h}_getOrCreateServiceInstance(c,h){let S=this._getServiceInstanceOrDescriptor(c);return S instanceof k.SyncDescriptor?this._safeCreateAndCacheServiceInstance(c,S,h.branch(c,!0)):(h.branch(c,!1),S)}_safeCreateAndCacheServiceInstance(c,h,S){if(this._activeInstantiations.has(c))throw new Error(`illegal state - RECURSIVELY instantiating service '${c}'`);this._activeInstantiations.add(c);try{return this._createAndCacheServiceInstance(c,h,S)}finally{this._activeInstantiations.delete(c)}}_createAndCacheServiceInstance(c,h,S){const w=new R.Graph(d=>d.id.toString());let b=0;const u=[{id:c,desc:h,_trace:S}];for(;u.length;){const d=u.pop();if(w.lookupOrInsertNode(d),b++>1e3)throw new C(w);for(let p of D._util.getServiceDependencies(d.desc.ctor)){let t=this._getServiceInstanceOrDescriptor(p.id);if(!t&&!p.optional&&console.warn(`[createInstance] ${c} depends on ${p.id} which is NOT registered.`),t instanceof k.SyncDescriptor){const i={id:p.id,desc:t,_trace:d._trace.branch(p.id,!0)};w.insertEdge(d,i),u.push(i)}}}for(;;){const d=w.roots();if(d.length===0){if(!w.isEmpty())throw new C(w);break}for(const{data:p}of d){if(this._getServiceInstanceOrDescriptor(p.id)instanceof k.SyncDescriptor){const i=this._createServiceInstanceWithOwner(p.id,p.desc.ctor,p.desc.staticArguments,p.desc.supportsDelayedInstantiation,p._trace);this._setServiceInstance(p.id,i)}w.removeNode(p)}}return this._getServiceInstanceOrDescriptor(c)}_createServiceInstanceWithOwner(c,h,S=[],w,b){if(this._services.get(c)instanceof k.SyncDescriptor)return this._createServiceInstance(h,S,w,b);if(this._parent)return this._parent._createServiceInstanceWithOwner(c,h,S,w,b);throw new Error(`illegalState - creating UNKNOWN service instance ${h.name}`)}_createServiceInstance(c,h=[],S,w){if(S){const b=new P.IdleValue(()=>this._createInstance(c,h,w));return new Proxy(Object.create(null),{get(u,d){if(d in u)return u[d];let p=b.value,t=p[d];return typeof t!="function"||(t=t.bind(p),u[d]=t),t},set(u,d,p){return b.value[d]=p,!0}})}else return this._createInstance(c,h,w)}}e.InstantiationService=s;var I;(function(m){m[m.Creation=0]="Creation",m[m.Invocation=1]="Invocation",m[m.Branch=2]="Branch"})(I||(I={}));class l{constructor(c,h){this.type=c,this.name=h,this._start=Date.now(),this._dep=[]}static traceInvocation(c){return _?new l(1,c.name||c.toString().substring(0,42).replace(/\n/g,"")):l._None}static traceCreation(c){return _?new l(0,c.name):l._None}branch(c,h){let S=new l(2,c.toString());return this._dep.push([c,h,S]),S}stop(){let c=Date.now()-this._start;l._totals+=c;let h=!1;function S(b,u){let d=[],p=new Array(b+1).join("	");for(const[t,i,r]of u._dep)if(i&&r){h=!0,d.push(`${p}CREATES -> ${t}`);let n=S(b+1,r);n&&d.push(n)}else d.push(`${p}uses -> ${t}`);return d.join(`
`)}let w=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${S(1,this)}`,`DONE, took ${c.toFixed(2)}ms (grand total ${l._totals.toFixed(2)}ms)`];(c>2||h)&&console.log(w.join(`
`))}}l._None=new class extends l{constructor(){super(-1,null)}stop(){}branch(){return this}},l._totals=0}),define(ge[12],pe([0,1,4,6,11,3,56]),function(Q,e,v,R,k,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=v.createDecorator("logService"),e.ILoggerService=v.createDecorator("loggerService");function P(){return new Date().toISOString()}var _;(function(p){p[p.Trace=0]="Trace",p[p.Debug=1]="Debug",p[p.Info=2]="Info",p[p.Warning=3]="Warning",p[p.Error=4]="Error",p[p.Critical=5]="Critical",p[p.Off=6]="Off"})(_=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=_.Info;class C extends R.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new D.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(t){this.level!==t&&(this.level=t,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=C;class s extends C{constructor(t){super();this.logAlways=t}checkLogLevel(t){return this.logAlways||this.getLevel()<=t}trace(t,...i){this.checkLogLevel(_.Trace)&&this.log(_.Trace,this.format([t,...i]))}debug(t,...i){this.checkLogLevel(_.Debug)&&this.log(_.Debug,this.format([t,...i]))}info(t,...i){this.checkLogLevel(_.Info)&&this.log(_.Info,this.format([t,...i]))}warn(t,...i){this.checkLogLevel(_.Warning)&&this.log(_.Warning,this.format([t,...i]))}error(t,...i){if(this.checkLogLevel(_.Error))if(t instanceof Error){const r=Array.prototype.slice.call(arguments);r[0]=t.stack,this.log(_.Error,this.format(r))}else this.log(_.Error,this.format([t,...i]))}critical(t,...i){this.checkLogLevel(_.Critical)&&this.log(_.Critical,this.format([t,...i]))}flush(){}format(t){let i="";for(let r=0;r<t.length;r++){let n=t[r];if(typeof n=="object")try{n=JSON.stringify(n)}catch(o){}i+=(r>0?" ":"")+n}return i}}e.AbstractMessageLogger=s;class I extends C{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t),this.useColors=!k.isWindows}trace(t,...i){this.getLevel()<=_.Trace&&(this.useColors?console.log(`[90m[main ${P()}][0m`,t,...i):console.log(`[main ${P()}]`,t,...i))}debug(t,...i){this.getLevel()<=_.Debug&&(this.useColors?console.log(`[90m[main ${P()}][0m`,t,...i):console.log(`[main ${P()}]`,t,...i))}info(t,...i){this.getLevel()<=_.Info&&(this.useColors?console.log(`[90m[main ${P()}][0m`,t,...i):console.log(`[main ${P()}]`,t,...i))}warn(t,...i){this.getLevel()<=_.Warning&&(this.useColors?console.warn(`[93m[main ${P()}][0m`,t,...i):console.warn(`[main ${P()}]`,t,...i))}error(t,...i){this.getLevel()<=_.Error&&(this.useColors?console.error(`[91m[main ${P()}][0m`,t,...i):console.error(`[main ${P()}]`,t,...i))}critical(t,...i){this.getLevel()<=_.Critical&&(this.useColors?console.error(`[90m[main ${P()}][0m`,t,...i):console.error(`[main ${P()}]`,t,...i))}dispose(){}flush(){}}e.ConsoleMainLogger=I;class l extends C{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t)}trace(t,...i){this.getLevel()<=_.Trace&&console.log("%cTRACE","color: #888",t,...i)}debug(t,...i){this.getLevel()<=_.Debug&&console.log("%cDEBUG","background: #eee; color: #888",t,...i)}info(t,...i){this.getLevel()<=_.Info&&console.log("%c INFO","color: #33f",t,...i)}warn(t,...i){this.getLevel()<=_.Warning&&console.log("%c WARN","color: #993",t,...i)}error(t,...i){this.getLevel()<=_.Error&&console.log("%c  ERR","color: #f33",t,...i)}critical(t,...i){this.getLevel()<=_.Critical&&console.log("%cCRITI","background: #f33; color: white",t,...i)}dispose(){}flush(){}}e.ConsoleLogger=l;class m extends C{constructor(t,i=e.DEFAULT_LOG_LEVEL){super();this.adapter=t,this.setLevel(i)}trace(t,...i){this.getLevel()<=_.Trace&&this.adapter.log(_.Trace,[this.extractMessage(t),...i])}debug(t,...i){this.getLevel()<=_.Debug&&this.adapter.log(_.Debug,[this.extractMessage(t),...i])}info(t,...i){this.getLevel()<=_.Info&&this.adapter.log(_.Info,[this.extractMessage(t),...i])}warn(t,...i){this.getLevel()<=_.Warning&&this.adapter.log(_.Warning,[this.extractMessage(t),...i])}error(t,...i){this.getLevel()<=_.Error&&this.adapter.log(_.Error,[this.extractMessage(t),...i])}critical(t,...i){this.getLevel()<=_.Critical&&this.adapter.log(_.Critical,[this.extractMessage(t),...i])}extractMessage(t){return typeof t=="string"?t:A.toErrorMessage(t,this.getLevel()<=_.Trace)}dispose(){}flush(){}}e.AdapterLogger=m;class c extends C{constructor(t){super();this.logServices=t,t.length&&this.setLevel(t[0].getLevel())}setLevel(t){for(const i of this.logServices)i.setLevel(t);super.setLevel(t)}trace(t,...i){for(const r of this.logServices)r.trace(t,...i)}debug(t,...i){for(const r of this.logServices)r.debug(t,...i)}info(t,...i){for(const r of this.logServices)r.info(t,...i)}warn(t,...i){for(const r of this.logServices)r.warn(t,...i)}error(t,...i){for(const r of this.logServices)r.error(t,...i)}critical(t,...i){for(const r of this.logServices)r.critical(t,...i)}flush(){for(const t of this.logServices)t.flush()}dispose(){for(const t of this.logServices)t.dispose()}}e.MultiplexLogService=c;class h extends R.Disposable{constructor(t){super();this.logger=t,this._register(t)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(t){this.logger.setLevel(t)}getLevel(){return this.logger.getLevel()}trace(t,...i){this.logger.trace(t,...i)}debug(t,...i){this.logger.debug(t,...i)}info(t,...i){this.logger.info(t,...i)}warn(t,...i){this.logger.warn(t,...i)}error(t,...i){this.logger.error(t,...i)}critical(t,...i){this.logger.critical(t,...i)}flush(){this.logger.flush()}}e.LogService=h;class S extends R.Disposable{constructor(t,i){super();this.logLevel=t,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(i(r=>{this.logLevel=r,this.logLevelChangeableLoggers.forEach(n=>n.setLevel(r))}))}createLogger(t,i){let r=this.loggers.get(t.toString());return r||(r=this.doCreateLogger(t,(i==null?void 0:i.always)?_.Trace:this.logLevel,i),this.loggers.set(t.toString(),r),(i==null?void 0:i.always)||this.logLevelChangeableLoggers.push(r)),r}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(t=>t.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=S;class w{constructor(){this.onDidChangeLogLevel=new D.Emitter().event}setLevel(t){}getLevel(){return _.Info}trace(t,...i){}debug(t,...i){}info(t,...i){}warn(t,...i){}error(t,...i){}critical(t,...i){}dispose(){}flush(){}}e.NullLogService=w;function b(p){if(p.verbose)return _.Trace;if(typeof p.logLevel=="string"){const t=u(p.logLevel.toLowerCase());if(t!==void 0)return t}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=b;function u(p){switch(p){case"trace":return _.Trace;case"debug":return _.Debug;case"info":return _.Info;case"warn":return _.Warning;case"error":return _.Error;case"critical":return _.Critical;case"off":return _.Off}}e.parseLogLevel=u;function d(p){switch(p){case _.Trace:return"trace";case _.Debug:return"debug";case _.Info:return"info";case _.Warning:return"warn";case _.Error:return"error";case _.Critical:return"critical";case _.Off:return"off"}}e.LogLevelToString=d}),define(ge[114],pe([0,1,12,42]),function(Q,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=e.createRotatingLogger=void 0;async function k(_,C,s,I){try{const l=await new Promise((m,c)=>{Q(["spdlog"],m,c)});return l.setFlushOn(v.LogLevel.Trace),l.createAsyncRotatingLogger(_,C,s,I)}catch(l){console.error(l)}return null}function D(_,C,s,I){const l=Q.__$__nodeRequire("spdlog");return l.setFlushOn(v.LogLevel.Trace),l.createRotatingLogger(_,C,s,I)}e.createRotatingLogger=D;function A(_,C,s){switch(C){case v.LogLevel.Trace:_.trace(s);break;case v.LogLevel.Debug:_.debug(s);break;case v.LogLevel.Info:_.info(s);break;case v.LogLevel.Warning:_.warn(s);break;case v.LogLevel.Error:_.error(s);break;case v.LogLevel.Critical:_.critical(s);break;default:throw new Error("Invalid log level")}}class P extends v.AbstractMessageLogger{constructor(C,s,I,l){super();this.name=C,this.filepath=s,this.rotating=I,this.buffer=[],this.setLevel(l),this._loggerCreationPromise=this._createSpdLogLogger(),this._register(this.onDidChangeLogLevel(m=>{this._logger&&this._logger.setLevel(m)}))}_createSpdLogLogger(){const C=this.rotating?6:1,s=30/C*R.ByteSize.MB;return k(this.name,this.filepath,s,C).then(I=>{if(I){this._logger=I,this._logger.setLevel(this.getLevel());for(const{level:l,message:m}of this.buffer)A(this._logger,l,m);this.buffer=[]}})}log(C,s){this._logger?A(this._logger,C,s):this.getLevel()<=C&&this.buffer.push({level:C,message:s})}clearFormatters(){this._logger?this._logger.clearFormatters():this._loggerCreationPromise.then(()=>this.clearFormatters())}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=P}),define(ge[115],pe([0,1,4,156,53]),function(Q,e,v,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var D;(function(_){_[_.Unnecessary=1]="Unnecessary",_[_.Deprecated=2]="Deprecated"})(D=e.MarkerTag||(e.MarkerTag={}));var A;(function(_){_[_.Hint=1]="Hint",_[_.Info=2]="Info",_[_.Warning=4]="Warning",_[_.Error=8]="Error"})(A=e.MarkerSeverity||(e.MarkerSeverity={})),function(_){function C(c,h){return h-c}_.compare=C;const s=Object.create(null);s[_.Error]=R.localize(0,null),s[_.Warning]=R.localize(1,null),s[_.Info]=R.localize(2,null);function I(c){return s[c]||""}_.toString=I;function l(c){switch(c){case k.default.Error:return _.Error;case k.default.Warning:return _.Warning;case k.default.Info:return _.Info;case k.default.Ignore:return _.Hint}}_.fromSeverity=l;function m(c){switch(c){case _.Error:return k.default.Error;case _.Warning:return k.default.Warning;case _.Info:return k.default.Info;case _.Hint:return k.default.Ignore}}_.toSeverity=m}(A=e.MarkerSeverity||(e.MarkerSeverity={}));var P;(function(_){const C="";function s(l){return I(l,!0)}_.makeKey=s;function I(l,m){let c=[C];return l.source?c.push(l.source.replace("\xA6","\\\xA6")):c.push(C),l.code?typeof l.code=="string"?c.push(l.code.replace("\xA6","\\\xA6")):c.push(l.code.value.replace("\xA6","\\\xA6")):c.push(C),l.severity!==void 0&&l.severity!==null?c.push(A.toString(l.severity)):c.push(C),l.message&&m?c.push(l.message.replace("\xA6","\\\xA6")):c.push(C),l.startLineNumber!==void 0&&l.startLineNumber!==null?c.push(l.startLineNumber.toString()):c.push(C),l.startColumn!==void 0&&l.startColumn!==null?c.push(l.startColumn.toString()):c.push(C),l.endLineNumber!==void 0&&l.endLineNumber!==null?c.push(l.endLineNumber.toString()):c.push(C),l.endColumn!==void 0&&l.endColumn!==null?c.push(l.endColumn.toString()):c.push(C),c.push(C),c.join("\xA6")}_.makeKeyOptionalMessage=I})(P=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=v.createDecorator("markerService")}),define(ge[181],pe([0,1,53,4,3]),function(Q,e,v,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=v.default,e.INotificationService=R.createDecorator("notificationService");var D;(function(C){C[C.WORKSPACE=0]="WORKSPACE",C[C.GLOBAL=1]="GLOBAL"})(D=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var A;(function(C){C[C.OFF=0]="OFF",C[C.SILENT=1]="SILENT",C[C.ERROR=2]="ERROR"})(A=e.NotificationsFilter||(e.NotificationsFilter={}));class P{constructor(){this.progress=new _,this.onDidClose=k.Event.None,this.onDidChangeVisibility=k.Event.None}updateSeverity(s){}updateMessage(s){}updateActions(s){}close(){}}e.NoOpNotification=P;class _{infinite(){}done(){}total(s){}worked(s){}}e.NoOpProgress=_}),define(ge[182],pe([0,1,6,8,2,4]),function(Q,e,v,R,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesScheme=e.NullOpenerService=e.IOpenerService=void 0,e.IOpenerService=D.createDecorator("openerService"),e.NullOpenerService=Object.freeze({_serviceBrand:void 0,registerOpener(){return v.Disposable.None},registerValidator(){return v.Disposable.None},registerExternalUriResolver(){return v.Disposable.None},setDefaultExternalOpener(){},registerExternalOpener(){return v.Disposable.None},async open(){return!1},async resolveExternalUri(P){return{resolved:P,dispose(){}}}});function A(P,_){return k.URI.isUri(P)?R.equalsIgnoreCase(P.scheme,_):R.startsWithIgnoreCase(P,_+":")}e.matchesScheme=A}),define(ge[183],pe([0,1,10,11,37,24]),function(Q,e,v,R,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let A;if(typeof R.globals.vscode!="undefined"&&typeof R.globals.vscode.context!="undefined"){const P=R.globals.vscode.context.configuration();if(P)A=P.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof(Q==null?void 0:Q.__$__nodeRequire)=="function"){const P=D.dirname(v.FileAccess.asFileUri("",Q));A=Q.__$__nodeRequire(D.joinPath(P,"product.json").fsPath);const _=Q.__$__nodeRequire(D.joinPath(P,"package.json").fsPath);k.env.VSCODE_DEV&&Object.assign(A,{nameShort:`${A.nameShort} Dev`,nameLong:`${A.nameLong} Dev`,dataFolderName:`${A.dataFolderName}-dev`}),Object.assign(A,{version:_.version})}else A={},Object.keys(A).length===0&&Object.assign(A,{version:"1.58.0-dev",nameShort:R.isWeb?"Code Web - OSS Dev":"Code - OSS Dev",nameLong:R.isWeb?"Code Web - OSS Dev":"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",extensionAllowedProposedApi:["ms-vscode.vscode-js-profile-flame","ms-vscode.vscode-js-profile-table","ms-vscode.remotehub","ms-vscode.remotehub-insiders","GitHub.remotehub","GitHub.remotehub-insiders"]});e.default=A});var $e=this&&this.__param||function(Q,e){return function(v,R){e(v,R,Q)}};define(ge[116],pe([0,1,4,21,6,16]),function(Q,e,v,R,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=v.createDecorator("progressService");var A;(function(s){s[s.Explorer=1]="Explorer",s[s.Scm=3]="Scm",s[s.Extensions=5]="Extensions",s[s.Window=10]="Window",s[s.Notification=15]="Notification",s[s.Dialog=20]="Dialog"})(A=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class P{constructor(I){this.callback=I}get value(){return this._value}report(I){this._value=I,this.callback(this._value)}}e.Progress=P,P.None=Object.freeze({report(){}});let _=class extends k.Disposable{constructor(I,l){super();this.deferred=new D.DeferredPromise,l.withProgress(I,m=>(this.reporter=m,this.lastStep&&m.report(this.lastStep),this.deferred.p)),this._register(k.toDisposable(()=>this.deferred.complete()))}report(I){this.reporter?this.reporter.report(I):this.lastStep=I}};_=Ve([$e(1,e.IProgressService)],_),e.UnmanagedProgress=_;class C extends k.Disposable{constructor(I){super();this.progressIndicator=I,this.currentOperationId=0,this.currentOperationDisposables=this._register(new k.DisposableStore)}start(I){this.stop();const l=++this.currentOperationId,m=new R.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{l===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},I),this.currentOperationDisposables.add(k.toDisposable(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add(k.toDisposable(()=>m.cancel())),this.currentOperationDisposables.add(k.toDisposable(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:l,token:m.token,stop:()=>this.doStop(l),isCurrent:()=>this.currentOperationId===l}}stop(){this.doStop(this.currentOperationId)}doStop(I){this.currentOperationId===I&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=C,e.IEditorProgressService=v.createDecorator("editorProgressService")}),define(ge[57],pe([0,1,15,50]),function(Q,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class k{constructor(){this.data=new Map}add(A,P){R.ok(v.isString(A)),R.ok(v.isObject(P)),R.ok(!this.data.has(A),"There is already an extension with this id"),this.data.set(A,P)}knows(A){return this.data.has(A)}as(A){return this.data.get(A)||null}}e.Registry=new k}),define(ge[184],pe([0,1,57,3]),function(Q,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function k(P){return P.length>0&&P.charAt(P.length-1)==="#"?P.substring(0,P.length-1):P}class D{constructor(){this._onDidChangeSchema=new R.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(_,C){this.schemasById[k(_)]=C,this._onDidChangeSchema.fire(_)}notifySchemaChanged(_){this._onDidChangeSchema.fire(_)}getSchemaContributions(){return{schemas:this.schemasById}}}const A=new D;v.Registry.add(e.Extensions.JSONContribution,A)}),define(ge[80],pe([0,1,151,3,57,15,184]),function(Q,e,v,R,k,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.overrideIdentifierFromKey=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=void 0,e.Extensions={Configuration:"base.contributions.configuration"};var P;(function(S){S[S.APPLICATION=1]="APPLICATION",S[S.MACHINE=2]="MACHINE",S[S.WINDOW=3]="WINDOW",S[S.RESOURCE=4]="RESOURCE",S[S.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",S[S.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(P=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const _=k.Registry.as(A.Extensions.JSONContribution);class C{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new R.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new R.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:v.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},_.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(w,b=!0){this.registerConfigurations([w],b)}registerConfigurations(w,b=!0){const u=[];w.forEach(d=>{u.push(...this.validateAndRegisterProperties(d,b,d.extensionInfo)),this.configurationContributors.push(d),this.registerJSONConfiguration(d)}),_.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(u)}deregisterConfigurations(w){const b=[],u=d=>{if(d.properties)for(const p in d.properties)b.push(p),delete this.configurationProperties[p],this.removeFromSchema(p,d.properties[p]);d.allOf&&d.allOf.forEach(p=>u(p))};for(const d of w){u(d);const p=this.configurationContributors.indexOf(d);p!==-1&&this.configurationContributors.splice(p,1)}_.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(b)}registerDefaultConfigurations(w){const b=[],u=[];for(const d of w)for(const p in d)if(b.push(p),e.OVERRIDE_PROPERTY_PATTERN.test(p)){this.defaultValues[p]=Object.assign(Object.assign({},this.defaultValues[p]||{}),d[p]);const t={type:"object",default:this.defaultValues[p],description:v.localize(1,null,p),$ref:e.resourceLanguageSettingsSchemaId};u.push(I(p)),this.configurationProperties[p]=t,this.defaultLanguageConfigurationOverridesNode.properties[p]=t}else{this.defaultValues[p]=d[p];const t=this.configurationProperties[p];t&&(this.updatePropertyDefaultValue(p,t),this.updateSchema(p,t))}this.registerOverrideIdentifiers(u),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(b)}deregisterDefaultConfigurations(w){const b=[];for(const u of w)for(const d in u)if(b.push(d),delete this.defaultValues[d],e.OVERRIDE_PROPERTY_PATTERN.test(d))delete this.configurationProperties[d],delete this.defaultLanguageConfigurationOverridesNode.properties[d];else{const p=this.configurationProperties[d];p&&(this.updatePropertyDefaultValue(d,p),this.updateSchema(d,p))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(b)}notifyConfigurationSchemaUpdated(...w){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(w){for(const b of w)this.overrideIdentifiers.add(b);this.updateOverridePropertyPatternKey()}validateAndRegisterProperties(w,b=!0,u,d=3){var p;d=D.isUndefinedOrNull(w.scope)?d:w.scope;let t=[],i=w.properties;if(i)for(let n in i){if(b&&c(n)){delete i[n];continue}const o=i[n];if(this.updatePropertyDefaultValue(n,o),e.OVERRIDE_PROPERTY_PATTERN.test(n)?o.scope=void 0:(o.scope=D.isUndefinedOrNull(o.scope)?d:o.scope,o.restricted=D.isUndefinedOrNull(o.restricted)?!!((p=u==null?void 0:u.restrictedConfigurations)===null||p===void 0?void 0:p.includes(n)):o.restricted),i[n].hasOwnProperty("included")&&!i[n].included){this.excludedConfigurationProperties[n]=i[n],delete i[n];continue}else this.configurationProperties[n]=i[n];!i[n].deprecationMessage&&i[n].markdownDeprecationMessage&&(i[n].deprecationMessage=i[n].markdownDeprecationMessage),t.push(n)}let r=w.allOf;if(r)for(let n of r)t.push(...this.validateAndRegisterProperties(n,b,u,d));return t}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(w){const b=u=>{let d=u.properties;if(d)for(const t in d)this.updateSchema(t,d[t]);let p=u.allOf;p&&p.forEach(b)};b(w)}updateSchema(w,b){switch(e.allSettings.properties[w]=b,b.scope){case 1:e.applicationSettings.properties[w]=b;break;case 2:e.machineSettings.properties[w]=b;break;case 6:e.machineOverridableSettings.properties[w]=b;break;case 3:e.windowSettings.properties[w]=b;break;case 4:e.resourceSettings.properties[w]=b;break;case 5:e.resourceSettings.properties[w]=b,this.resourceLanguageSettingsSchema.properties[w]=b;break}}removeFromSchema(w,b){switch(delete e.allSettings.properties[w],b.scope){case 1:delete e.applicationSettings.properties[w];break;case 2:delete e.machineSettings.properties[w];break;case 6:delete e.machineOverridableSettings.properties[w];break;case 3:delete e.windowSettings.properties[w];break;case 4:case 5:delete e.resourceSettings.properties[w];break}}updateOverridePropertyPatternKey(){for(const w of this.overrideIdentifiers.values()){const b=`[${w}]`,u={type:"object",description:v.localize(2,null),errorMessage:v.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(b,u),e.allSettings.properties[b]=u,e.applicationSettings.properties[b]=u,e.machineSettings.properties[b]=u,e.machineOverridableSettings.properties[b]=u,e.windowSettings.properties[b]=u,e.resourceSettings.properties[b]=u}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(w,b){let u=this.defaultValues[w];D.isUndefined(u)&&(u=b.default),D.isUndefined(u)&&(u=l(b.type)),b.default=u}}const s="\\[.*\\]$";e.OVERRIDE_PROPERTY_PATTERN=new RegExp(s);function I(S){return S.substring(1,S.length-1)}e.overrideIdentifierFromKey=I;function l(S){switch(Array.isArray(S)?S[0]:S){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=l;const m=new C;k.Registry.add(e.Extensions.Configuration,m);function c(S){return S.trim()?e.OVERRIDE_PROPERTY_PATTERN.test(S)?v.localize(5,null,S):m.getConfigurationProperties()[S]!==void 0?v.localize(6,null,S):null:v.localize(4,null)}e.validateProperty=c;function h(){const S=[],w=m.getConfigurationProperties();for(const b of Object.keys(w))S.push([b,w[b].scope]);return S.push(["launch",4]),S.push(["task",4]),S}e.getScopes=h}),define(ge[81],pe([0,1,25,15,2,57,4,80]),function(Q,e,v,R,k,D,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.keyFromOverrideIdentifier=e.getDefaultValues=e.getConfigurationKeys=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.toOverrides=e.compare=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=A.createDecorator("configurationService");function _(i){return i&&typeof i=="object"&&(!i.overrideIdentifier||typeof i.overrideIdentifier=="string")&&(!i.resource||i.resource instanceof k.URI)}e.isConfigurationOverrides=_;var C;(function(i){i[i.USER=1]="USER",i[i.USER_LOCAL=2]="USER_LOCAL",i[i.USER_REMOTE=3]="USER_REMOTE",i[i.WORKSPACE=4]="WORKSPACE",i[i.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",i[i.DEFAULT=6]="DEFAULT",i[i.MEMORY=7]="MEMORY"})(C=e.ConfigurationTarget||(e.ConfigurationTarget={}));function s(i){switch(i){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=s;function I(i,r){const n=r?i?r.keys.filter(L=>i.keys.indexOf(L)===-1):[...r.keys]:[],o=i?r?i.keys.filter(L=>r.keys.indexOf(L)===-1):[...i.keys]:[],g=[];if(r&&i){for(const L of i.keys)if(r.keys.indexOf(L)!==-1){const O=w(i.contents,L),W=w(r.contents,L);v.equals(O,W)||g.push(L)}}const f=[],E=L=>{const O={};for(const W of L)for(const J of W.identifiers)O[p(J)]=W;return O},y=r?E(r.overrides):{},a=i?E(i.overrides):{};if(Object.keys(y).length)for(const L of n){const O=y[L];O&&f.push([P.overrideIdentifierFromKey(L),O.keys])}if(Object.keys(a).length)for(const L of o){const O=a[L];O&&f.push([P.overrideIdentifierFromKey(L),O.keys])}if(Object.keys(y).length&&Object.keys(a).length)for(const L of g){const O=a[L],W=y[L];if(O&&W){const J=I({contents:O.contents,keys:O.keys,overrides:[]},{contents:W.contents,keys:W.keys,overrides:[]});f.push([P.overrideIdentifierFromKey(L),[...J.added,...J.removed,...J.updated]])}}return{added:n,removed:o,updated:g,overrides:f}}e.compare=I;function l(i,r){const n=[];for(const o of Object.keys(i))if(P.OVERRIDE_PROPERTY_PATTERN.test(o)){const g={};for(const f in i[o])g[f]=i[o][f];n.push({identifiers:[P.overrideIdentifierFromKey(o).trim()],keys:Object.keys(g),contents:m(g,r)})}return n}e.toOverrides=l;function m(i,r){const n=Object.create(null);for(let o in i)c(n,o,i[o],r);return n}e.toValuesTree=m;function c(i,r,n,o){const g=r.split("."),f=g.pop();let E=i;for(let y=0;y<g.length;y++){let a=g[y],L=E[a];switch(typeof L){case"undefined":L=E[a]=Object.create(null);break;case"object":break;default:o(`Ignoring ${r} as ${g.slice(0,y+1).join(".")} is ${JSON.stringify(L)}`);return}E=L}if(typeof E=="object"&&E!==null)try{E[f]=n}catch(y){o(`Ignoring ${r} as ${g.join(".")} is ${JSON.stringify(E)}`)}else o(`Ignoring ${r} as ${g.join(".")} is ${JSON.stringify(E)}`)}e.addToValueTree=c;function h(i,r){const n=r.split(".");S(i,n)}e.removeFromValueTree=h;function S(i,r){const n=r.shift();if(r.length===0){delete i[n];return}if(Object.keys(i).indexOf(n)!==-1){const o=i[n];typeof o=="object"&&!Array.isArray(o)&&(S(o,r),Object.keys(o).length===0&&delete i[n])}}function w(i,r,n){function o(E,y){let a=E;for(const L of y){if(typeof a!="object"||a===null)return;a=a[L]}return a}const g=r.split("."),f=o(i,g);return typeof f=="undefined"?n:f}e.getConfigurationValue=w;function b(i,r,n){Object.keys(r).forEach(o=>{o!=="__proto__"&&(o in i?R.isObject(i[o])&&R.isObject(r[o])?b(i[o],r[o],n):n&&(i[o]=r[o]):i[o]=r[o])})}e.merge=b;function u(){const i=D.Registry.as(P.Extensions.Configuration).getConfigurationProperties();return Object.keys(i)}e.getConfigurationKeys=u;function d(){const i=Object.create(null),r=D.Registry.as(P.Extensions.Configuration).getConfigurationProperties();for(let n in r){let o=r[n].default;c(i,n,o,g=>console.error(`Conflict in default settings: ${g}`))}return i}e.getDefaultValues=d;function p(i){return`[${i}]`}e.keyFromOverrideIdentifier=p;function t(i,r,n){const o=i.inspect(r),g=i.inspect(n);return typeof o.userValue!="undefined"||typeof o.workspaceValue!="undefined"||typeof o.workspaceFolderValue!="undefined"?o.value:typeof g.userValue!="undefined"||typeof g.workspaceValue!="undefined"||typeof g.workspaceFolderValue!="undefined"?g.value:o.defaultValue}e.getMigratedSettingValue=t}),define(ge[185],pe([0,1,52,23,18,15,25,2,80,81,57,6,3]),function(Q,e,v,R,k,D,A,P,_,C,s,I,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class m{constructor(t={},i=[],r=[]){this._contents=t,this._keys=i,this._overrides=r,this.isFrozen=!1}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(t){return t?C.getConfigurationValue(this.contents,t):this.contents}getOverrideValue(t,i){const r=this.getContentsForOverrideIdentifer(i);return r?t?C.getConfigurationValue(r,t):r:void 0}getKeysForOverrideIdentifier(t){for(const i of this.overrides)if(i.identifiers.indexOf(t)!==-1)return i.keys;return[]}override(t){const i=this.getContentsForOverrideIdentifer(t);if(!i||typeof i!="object"||!Object.keys(i).length)return this;let r={};for(const n of k.distinct([...Object.keys(this.contents),...Object.keys(i)])){let o=this.contents[n],g=i[n];g&&(typeof o=="object"&&typeof g=="object"?(o=A.deepClone(o),this.mergeContents(o,g)):o=g),r[n]=o}return new m(r,this.keys,this.overrides)}merge(...t){const i=A.deepClone(this.contents),r=A.deepClone(this.overrides),n=[...this.keys];for(const o of t){this.mergeContents(i,o.contents);for(const g of o.overrides){const[f]=r.filter(E=>k.equals(E.identifiers,g.identifiers));f?this.mergeContents(f.contents,g.contents):r.push(A.deepClone(g))}for(const g of o.keys)n.indexOf(g)===-1&&n.push(g)}return new m(i,n,r)}freeze(){return this.isFrozen=!0,this}mergeContents(t,i){for(const r of Object.keys(i)){if(r in t&&D.isObject(t[r])&&D.isObject(i[r])){this.mergeContents(t[r],i[r]);continue}t[r]=A.deepClone(i[r])}}checkAndFreeze(t){return this.isFrozen&&!Object.isFrozen(t)?A.deepFreeze(t):t}getContentsForOverrideIdentifer(t){for(const i of this.overrides)if(i.identifiers.indexOf(t)!==-1)return i.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(t,i){this.addKey(t),C.addToValueTree(this.contents,t,i,r=>{throw new Error(r)})}removeValue(t){this.removeKey(t)&&C.removeFromValueTree(this.contents,t)}addKey(t){let i=this.keys.length;for(let r=0;r<i;r++)t.indexOf(this.keys[r])===0&&(i=r);this.keys.splice(i,1,t)}removeKey(t){let i=this.keys.indexOf(t);return i!==-1?(this.keys.splice(i,1),!0):!1}}e.ConfigurationModel=m;class c extends m{constructor(){const t=C.getDefaultValues(),i=C.getConfigurationKeys(),r=[];for(const n of Object.keys(t))_.OVERRIDE_PROPERTY_PATTERN.test(n)&&r.push({identifiers:[_.overrideIdentifierFromKey(n).trim()],keys:Object.keys(t[n]),contents:C.toValuesTree(t[n],o=>console.error(`Conflict in default settings file: ${o}`))});super(t,i,r)}}e.DefaultConfigurationModel=c;class h{constructor(t){this._name=t,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new m}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(t,i){if(!D.isUndefinedOrNull(t)){const r=this.doParseContent(t);this.parseRaw(r,i)}}reparse(t){this._raw&&this.parseRaw(this._raw,t)}parseRaw(t,i){this._raw=t;const{contents:r,keys:n,overrides:o,restricted:g}=this.doParseRaw(t,i);this._configurationModel=new m(r,n,o),this._restrictedConfigurations=g||[]}doParseContent(t){let i={},r=null,n=[],o=[],g=[];function f(y){Array.isArray(n)?n.push(y):r&&(n[r]=y)}let E={onObjectBegin:()=>{let y={};f(y),o.push(n),n=y,r=null},onObjectProperty:y=>{r=y},onObjectEnd:()=>{n=o.pop()},onArrayBegin:()=>{let y=[];f(y),o.push(n),n=y,r=null},onArrayEnd:()=>{n=o.pop()},onLiteralValue:f,onError:(y,a,L)=>{g.push({error:y,offset:a,length:L})}};if(t)try{v.visit(t,E),i=n[0]||{}}catch(y){console.error(`Error while parsing settings file ${this._name}: ${y}`),this._parseErrors=[y]}return i}doParseRaw(t,i){const r=s.Registry.as(_.Extensions.Configuration).getConfigurationProperties(),n=this.filter(t,r,!0,i);t=n.raw;const o=C.toValuesTree(t,E=>console.error(`Conflict in settings file ${this._name}: ${E}`)),g=Object.keys(t),f=C.toOverrides(t,E=>console.error(`Conflict in settings file ${this._name}: ${E}`));return{contents:o,keys:g,overrides:f,restricted:n.restricted}}filter(t,i,r,n){if(!(n==null?void 0:n.scopes)&&!(n==null?void 0:n.skipRestricted))return{raw:t,restricted:[]};const o={},g=[];for(let f in t)if(_.OVERRIDE_PROPERTY_PATTERN.test(f)&&r){const E=this.filter(t[f],i,!1,n);o[f]=E.raw,g.push(...E.restricted)}else{const E=i[f],y=E?typeof E.scope!="undefined"?E.scope:3:void 0;(E==null?void 0:E.restricted)&&g.push(f),(y===void 0||n.scopes===void 0||n.scopes.includes(y))&&(n.skipRestricted&&(E==null?void 0:E.restricted)||(o[f]=t[f]))}return{raw:o,restricted:g}}}e.ConfigurationModelParser=h;class S extends I.Disposable{constructor(t,i,r,n){super();this.userSettingsResource=t,this.scopes=i,this.fileService=n,this._onDidChange=this._register(new l.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new h(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(r.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(l.Event.filter(this.fileService.onDidFilesChange,o=>o.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const t=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(t.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(t){return new m}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=S;class w{constructor(t,i,r=new m,n=new m,o=new R.ResourceMap,g=new m,f=new R.ResourceMap,E=!0){this._defaultConfiguration=t,this._localUserConfiguration=i,this._remoteUserConfiguration=r,this._workspaceConfiguration=n,this._folderConfigurations=o,this._memoryConfiguration=g,this._memoryConfigurationByResource=f,this._freeze=E,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new R.ResourceMap,this._userConfiguration=null}getValue(t,i,r){return this.getConsolidateConfigurationModel(i,r).getValue(t)}updateValue(t,i,r={}){let n;r.resource?(n=this._memoryConfigurationByResource.get(r.resource),n||(n=new m,this._memoryConfigurationByResource.set(r.resource,n))):n=this._memoryConfiguration,i===void 0?n.removeValue(t):n.setValue(t,i),r.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(t,i,r){const n=this.getConsolidateConfigurationModel(i,r),o=this.getFolderConfigurationModelForResource(i.resource,r),g=i.resource?this._memoryConfigurationByResource.get(i.resource)||this._memoryConfiguration:this._memoryConfiguration,f=i.overrideIdentifier?this._defaultConfiguration.freeze().override(i.overrideIdentifier).getValue(t):this._defaultConfiguration.freeze().getValue(t),E=i.overrideIdentifier?this.userConfiguration.freeze().override(i.overrideIdentifier).getValue(t):this.userConfiguration.freeze().getValue(t),y=i.overrideIdentifier?this.localUserConfiguration.freeze().override(i.overrideIdentifier).getValue(t):this.localUserConfiguration.freeze().getValue(t),a=i.overrideIdentifier?this.remoteUserConfiguration.freeze().override(i.overrideIdentifier).getValue(t):this.remoteUserConfiguration.freeze().getValue(t),L=r?i.overrideIdentifier?this._workspaceConfiguration.freeze().override(i.overrideIdentifier).getValue(t):this._workspaceConfiguration.freeze().getValue(t):void 0,O=o?i.overrideIdentifier?o.freeze().override(i.overrideIdentifier).getValue(t):o.freeze().getValue(t):void 0,W=i.overrideIdentifier?g.override(i.overrideIdentifier).getValue(t):g.getValue(t),J=n.getValue(t),se=k.distinct(k.flatten(n.overrides.map(q=>q.identifiers))).filter(q=>n.getOverrideValue(t,q)!==void 0);return{defaultValue:f,userValue:E,userLocalValue:y,userRemoteValue:a,workspaceValue:L,workspaceFolderValue:O,memoryValue:W,value:J,default:f!==void 0?{value:this._defaultConfiguration.freeze().getValue(t),override:i.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,user:E!==void 0?{value:this.userConfiguration.freeze().getValue(t),override:i.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,userLocal:y!==void 0?{value:this.localUserConfiguration.freeze().getValue(t),override:i.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,userRemote:a!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(t),override:i.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,workspace:L!==void 0?{value:this._workspaceConfiguration.freeze().getValue(t),override:i.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,workspaceFolder:O!==void 0?{value:o==null?void 0:o.freeze().getValue(t),override:i.overrideIdentifier?o==null?void 0:o.freeze().getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,memory:W!==void 0?{value:g.getValue(t),override:i.overrideIdentifier?g.getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,overrideIdentifiers:se.length?se:void 0}}keys(t){const i=this.getFolderConfigurationModelForResource(void 0,t);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:i?i.freeze().keys:[]}}updateDefaultConfiguration(t){this._defaultConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(t){this._localUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(t){this._remoteUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(t){this._workspaceConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(t,i){this._folderConfigurations.set(t,i),this._foldersConsolidatedConfigurations.delete(t)}deleteFolderConfiguration(t){this.folderConfigurations.delete(t),this._foldersConsolidatedConfigurations.delete(t)}compareAndUpdateDefaultConfiguration(t,i){const r=i.filter(n=>_.OVERRIDE_PROPERTY_PATTERN.test(n)).map(n=>{const o=_.overrideIdentifierFromKey(n),g=this._defaultConfiguration.getKeysForOverrideIdentifier(o),f=t.getKeysForOverrideIdentifier(o),E=[...f.filter(y=>g.indexOf(y)===-1),...g.filter(y=>f.indexOf(y)===-1),...g.filter(y=>!A.equals(this._defaultConfiguration.override(o).getValue(y),t.override(o).getValue(y)))];return[o,E]});return this.updateDefaultConfiguration(t),{keys:i,overrides:r}}compareAndUpdateLocalUserConfiguration(t){const{added:i,updated:r,removed:n,overrides:o}=C.compare(this.localUserConfiguration,t),g=[...i,...r,...n];return g.length&&this.updateLocalUserConfiguration(t),{keys:g,overrides:o}}compareAndUpdateRemoteUserConfiguration(t){const{added:i,updated:r,removed:n,overrides:o}=C.compare(this.remoteUserConfiguration,t);let g=[...i,...r,...n];return g.length&&this.updateRemoteUserConfiguration(t),{keys:g,overrides:o}}compareAndUpdateWorkspaceConfiguration(t){const{added:i,updated:r,removed:n,overrides:o}=C.compare(this.workspaceConfiguration,t);let g=[...i,...r,...n];return g.length&&this.updateWorkspaceConfiguration(t),{keys:g,overrides:o}}compareAndUpdateFolderConfiguration(t,i){const r=this.folderConfigurations.get(t),{added:n,updated:o,removed:g,overrides:f}=C.compare(r,i);let E=[...n,...o,...g];return(E.length||!r)&&this.updateFolderConfiguration(t,i),{keys:E,overrides:f}}compareAndDeleteFolderConfiguration(t){const i=this.folderConfigurations.get(t);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:r,updated:n,removed:o,overrides:g}=C.compare(i,void 0);return{keys:[...r,...n,...o],overrides:g}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(t,i){let r=this.getConsolidatedConfigurationModelForResource(t,i);return t.overrideIdentifier?r.override(t.overrideIdentifier):r}getConsolidatedConfigurationModelForResource({resource:t},i){let r=this.getWorkspaceConsolidatedConfiguration();if(i&&t){const n=i.getFolder(t);n&&(r=this.getFolderConsolidatedConfiguration(n.uri)||r);const o=this._memoryConfigurationByResource.get(t);o&&(r=r.merge(o))}return r}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(t){let i=this._foldersConsolidatedConfigurations.get(t);if(!i){const r=this.getWorkspaceConsolidatedConfiguration(),n=this._folderConfigurations.get(t);n?(i=r.merge(n),this._freeze&&(i=i.freeze()),this._foldersConsolidatedConfigurations.set(t,i)):i=r}return i}getFolderConfigurationModelForResource(t,i){if(i&&t){const r=i.getFolder(t);if(r)return this._folderConfigurations.get(r.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((t,i)=>{const{contents:r,overrides:n,keys:o}=this._folderConfigurations.get(i);return t.push([i,{contents:r,overrides:n,keys:o}]),t},[])}}allKeys(){const t=new Set;return this._defaultConfiguration.freeze().keys.forEach(i=>t.add(i)),this.userConfiguration.freeze().keys.forEach(i=>t.add(i)),this._workspaceConfiguration.freeze().keys.forEach(i=>t.add(i)),this._folderConfigurations.forEach(i=>i.freeze().keys.forEach(r=>t.add(r))),[...t.values()]}getAllKeysForOverrideIdentifier(t){const i=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(t).forEach(r=>i.add(r)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(r=>i.add(r)),this._workspaceConfiguration.getKeysForOverrideIdentifier(t).forEach(r=>i.add(r)),this._folderConfigurations.forEach(r=>r.getKeysForOverrideIdentifier(t).forEach(n=>i.add(n))),[...i.values()]}static parse(t){const i=this.parseConfigurationModel(t.defaults),r=this.parseConfigurationModel(t.user),n=this.parseConfigurationModel(t.workspace),o=t.folders.reduce((g,f)=>(g.set(P.URI.revive(f[0]),this.parseConfigurationModel(f[1])),g),new R.ResourceMap);return new w(i,r,new m,n,o,new m,new R.ResourceMap,!1)}static parseConfigurationModel(t){return new m(t.contents,t.keys,t.overrides).freeze()}}e.Configuration=w;function b(...p){if(p.length===0)return{keys:[],overrides:[]};if(p.length===1)return p[0];const t=new Set,i=new Map;for(const n of p)n.keys.forEach(o=>t.add(o)),n.overrides.forEach(([o,g])=>{const f=R.getOrSet(i,o,new Set);g.forEach(E=>f.add(E))});const r=[];return i.forEach((n,o)=>r.push([o,[...n.values()]])),{keys:[...t.values()],overrides:r}}e.mergeChanges=b;class u{constructor(t,i,r,n){this.change=t,this.previous=i,this.currentConfiguraiton=r,this.currentWorkspace=n,this._previousConfiguration=void 0;const o=new Set;t.keys.forEach(f=>o.add(f)),t.overrides.forEach(([,f])=>f.forEach(E=>o.add(E))),this.affectedKeys=[...o.values()];const g=new m;this.affectedKeys.forEach(f=>g.setValue(f,{})),this.affectedKeysTree=g.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=w.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(t,i){var r;if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,t)){if(i){const n=this.previousConfiguration?this.previousConfiguration.getValue(t,i,(r=this.previous)===null||r===void 0?void 0:r.workspace):void 0,o=this.currentConfiguraiton.getValue(t,i,this.currentWorkspace);return!A.equals(n,o)}return!0}return!1}doesAffectedKeysTreeContains(t,i){let r=C.toValuesTree({[i]:!0},()=>{}),n;for(;typeof r=="object"&&(n=Object.keys(r)[0]);){if(t=t[n],!t)return!1;r=r[n]}return!0}}e.ConfigurationChangeEvent=u;class d extends u{constructor(t,i,r,n){super({keys:t.allKeys(),overrides:[]},void 0,t,i);this.source=r,this.sourceConfig=n}}e.AllKeysConfigurationChangeEvent=d}),define(ge[186],pe([0,1,38,9,111,154,28,11,179,81,4,10,135]),function(Q,e,v,R,k,D,A,P,_,C,s,I,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const m=D.localize(0,null);class c{async getDefaultTerminalForPlatforms(){const t=await w.getDefaultTerminalLinuxReady();return{windows:h.getDefaultTerminalWindows(),linux:t,osx:"xterm"}}}let h=class jt extends c{constructor(t){super();this._configurationService=t}openTerminal(t){const i=this._configurationService.getValue();return this.spawnTerminal(v,i,k.getWindowsShell(),t)}spawnTerminal(t,i,r,n){const o=i.terminal.external,g=(o==null?void 0:o.windowsExec)||jt.getDefaultTerminalWindows();n&&n[1]===":"&&(n=n[0].toUpperCase()+n.substr(1));const f=R.basename(g).toLowerCase();if(f==="cmder"||f==="cmder.exe")return t.spawn(g,n?[n]:void 0),Promise.resolve(void 0);const E=["/c","start","/wait"];return g.indexOf(" ")>=0&&E.push('""'),E.push(g),(f==="wt"||f==="wt.exe")&&E.push("-d ."),new Promise((y,a)=>{const L=b(process),O=t.spawn(r,E,{cwd:n,env:L});O.on("error",a),O.on("exit",()=>y())})}runInTerminal(t,i,r,n,o){const g="windowsExec"in o&&o.windowsExec?o.windowsExec:jt.getDefaultTerminalWindows();return new Promise((f,E)=>{const y=`"${i} - ${m}"`,a=`""${r.join('" "')}" & pause"`,L=["/c","start",y,"/wait",g,"/c",a],O=Object.assign({},b(process),n);Object.keys(O).filter(se=>O[se]===null).forEach(se=>delete O[se]);const W={cwd:i,env:O,windowsVerbatimArguments:!0};v.spawn(jt.CMD,L,W).on("error",se=>{E(u(se))}),f(void 0)})}static getDefaultTerminalWindows(){if(!jt._DEFAULT_TERMINAL_WINDOWS){const t=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");jt._DEFAULT_TERMINAL_WINDOWS=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${t?"Sysnative":"System32"}\\cmd.exe`}return jt._DEFAULT_TERMINAL_WINDOWS}};h.CMD="cmd.exe",h=Ve([$e(0,s.optional(C.IConfigurationService))],h),e.WindowsExternalTerminalService=h;let S=class Un extends c{constructor(t){super();this._configurationService=t}openTerminal(t){const i=this._configurationService.getValue();return this.spawnTerminal(v,i,t)}runInTerminal(t,i,r,n,o){const g=o.osxExec||_.DEFAULT_TERMINAL_OSX;return new Promise((f,E)=>{if(g===_.DEFAULT_TERMINAL_OSX||g==="iTerm.app"){const y=g===_.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",L=[I.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${y}.scpt`,Q).fsPath,"-t",t||m,"-w",i];for(let J of r)L.push("-a"),L.push(J);if(n)for(let J in n){const se=n[J];se===null?(L.push("-u"),L.push(J)):(L.push("-e"),L.push(`${J}=${se}`))}let O="";const W=v.spawn(Un.OSASCRIPT,L);W.on("error",J=>{E(u(J))}),W.stderr.on("data",J=>{O+=J.toString()}),W.on("exit",J=>{if(J===0)f(void 0);else if(O){const se=O.split(`
`,1);E(new Error(se[0]))}else E(new Error(D.localize(1,null,y,J)))})}else E(new Error(D.localize(2,null,g)))})}spawnTerminal(t,i,r){const n=i.terminal.external,o=(n==null?void 0:n.osxExec)||_.DEFAULT_TERMINAL_OSX;return new Promise((g,f)=>{const E=["-a",o];r&&E.push(r);const y=t.spawn("/usr/bin/open",E);y.on("error",f),y.on("exit",()=>g())})}};S.OSASCRIPT="/usr/bin/osascript",S=Ve([$e(0,s.optional(C.IConfigurationService))],S),e.MacExternalTerminalService=S;let w=class qt extends c{constructor(t){super();this._configurationService=t}openTerminal(t){const i=this._configurationService.getValue();return this.spawnTerminal(v,i,t)}runInTerminal(t,i,r,n,o){const g=o.linuxExec?Promise.resolve(o.linuxExec):qt.getDefaultTerminalLinuxReady();return new Promise((f,E)=>{let y=[];g.then(a=>{a.indexOf("gnome-terminal")>=0?y.push("-x"):y.push("-e"),y.push("bash"),y.push("-c");const L=`${d(r)}; echo; read -p "${qt.WAIT_MESSAGE}" -n1;`;y.push(`''${L}''`);const O=Object.assign({},process.env,n);Object.keys(O).filter(q=>O[q]===null).forEach(q=>delete O[q]);const W={cwd:i,env:O};let J="";const se=v.spawn(a,y,W);se.on("error",q=>{E(u(q))}),se.stderr.on("data",q=>{J+=q.toString()}),se.on("exit",q=>{if(q===0)f(void 0);else if(J){const N=J.split(`
`,1);E(new Error(N[0]))}else E(new Error(D.localize(4,null,a,q)))})})})}static async getDefaultTerminalLinuxReady(){return qt._DEFAULT_TERMINAL_LINUX_READY||(qt._DEFAULT_TERMINAL_LINUX_READY=new Promise(async t=>{P.isLinux?await A.Promises.exists("/etc/debian_version")?t("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?t("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?t("konsole"):process.env.COLORTERM?t(process.env.COLORTERM):process.env.TERM?t(process.env.TERM):t("xterm"):t("xterm")})),qt._DEFAULT_TERMINAL_LINUX_READY}spawnTerminal(t,i,r){const n=i.terminal.external,o=(n==null?void 0:n.linuxExec)?Promise.resolve(n.linuxExec):qt.getDefaultTerminalLinuxReady();return new Promise((g,f)=>{o.then(E=>{const y=b(process),a=t.spawn(E,[],{cwd:r,env:y});a.on("error",f),a.on("exit",()=>g())})})}};w.WAIT_MESSAGE=D.localize(3,null),w=Ve([$e(0,s.optional(C.IConfigurationService))],w),e.LinuxExternalTerminalService=w;function b(p){const t=p.env;return l.sanitizeProcessEnvironment(t),t}function u(p){return"errno"in p&&p.errno==="ENOENT"&&"path"in p&&typeof p.path=="string"?new Error(D.localize(5,null,p.path)):p}function d(p){let t="";for(let i of p)i.indexOf(" ")>=0?t+='"'+i+'"':t+=i,t+=" ";return t}}),define(ge[117],pe([0,1,4]),function(Q,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=v.createDecorator("remoteAuthorityResolverService");var R;(function(D){D.Unknown="Unknown",D.NotAvailable="NotAvailable",D.TemporarilyNotAvailable="TemporarilyNotAvailable",D.NoResolverFound="NoResolverFound"})(R=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class k extends Error{constructor(A,P=R.Unknown,_){super(A);this._message=A,this._code=P,this._detail=_,this.isHandled=P===R.NotAvailable&&_===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,k.prototype)}static isTemporarilyNotAvailable(A){return A instanceof k&&A._code===R.TemporarilyNotAvailable}static isNoResolverFound(A){return A instanceof k&&A._code===R.NoResolverFound}static isHandled(A){return A instanceof k&&A.isHandled}}e.RemoteAuthorityResolverError=k}),define(ge[82],pe([0,1,10]),function(Q,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=e.getRemoteName=e.getRemoteAuthority=void 0;function R(C){return C.scheme===v.Schemas.vscodeRemote?C.authority:void 0}e.getRemoteAuthority=R;function k(C){if(!C)return;const s=C.indexOf("+");return s<0?C:C.substr(0,s)}e.getRemoteName=k;function D(C){return C.scheme!==v.Schemas.file&&C.scheme!==v.Schemas.vscodeRemote}e.isVirtualResource=D;function A(C){if(C.folders.length)return C.folders.every(s=>D(s.uri))?C.folders[0].uri:void 0;if(C.configuration&&D(C.configuration))return C.configuration}e.getVirtualWorkspaceLocation=A;function P(C){var s;return(s=A(C))===null||s===void 0?void 0:s.scheme}e.getVirtualWorkspaceScheme=P;function _(C){return A(C)!==void 0}e.isVirtualWorkspace=_}),define(ge[187],pe([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class v{vsda(){return new Promise((k,D)=>Q(["vsda"],k,D))}async sign(k){try{const D=await this.vsda(),A=new D.signer;if(A)return A.sign(k)}catch(D){}return k}}e.SignService=v}),define(ge[188],pe([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class v{constructor(k){this._callback=k,this._terminalBufferMap=new Map}dispose(){for(const k of this._terminalBufferMap.values())k.dispose()}startBuffering(k,D,A=5){let P;return P=D(_=>{const C=typeof _=="string"?_:_.data;let s=this._terminalBufferMap.get(k);if(s){s.data.push(C);return}const I=setTimeout(()=>this.flushBuffer(k),A);s={data:[C],timeoutId:I,dispose:()=>{clearTimeout(I),this.flushBuffer(k),P.dispose()}},this._terminalBufferMap.set(k,s)}),P}stopBuffering(k){const D=this._terminalBufferMap.get(k);D&&D.dispose()}flushBuffer(k){const D=this._terminalBufferMap.get(k);D&&(this._terminalBufferMap.delete(k),this._callback(k,D.data.join("")))}}e.TerminalDataBufferer=v}),define(ge[45],pe([0,1,2,24,4,23]),function(Q,e,v,R,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=k.createDecorator("contextService");var A;(function(l){l[l.EMPTY=1]="EMPTY",l[l.FOLDER=2]="FOLDER",l[l.WORKSPACE=3]="WORKSPACE"})(A=e.WorkbenchState||(e.WorkbenchState={}));function P(l){const m=l;return!!(m&&typeof m=="object"&&typeof m.id=="string"&&Array.isArray(m.folders))}e.isWorkspace=P;function _(l){const m=l;return!!(m&&typeof m=="object"&&v.URI.isUri(m.uri)&&typeof m.name=="string"&&typeof m.toResource=="function")}e.isWorkspaceFolder=_;class C{constructor(m,c,h,S){this._id=m,this._configuration=h,this._ignorePathCasing=S,this._foldersMap=D.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=c}update(m){this._id=m.id,this._configuration=m.configuration,this._ignorePathCasing=m._ignorePathCasing,this.folders=m.folders}get folders(){return this._folders}set folders(m){this._folders=m,this.updateFoldersMap()}get id(){return this._id}get configuration(){return this._configuration}set configuration(m){this._configuration=m}getFolder(m){return m&&this._foldersMap.findSubstr(m.with({scheme:m.scheme,authority:m.authority,path:m.path}))||null}updateFoldersMap(){this._foldersMap=D.TernarySearchTree.forUris(this._ignorePathCasing);for(const m of this.folders)this._foldersMap.set(m.uri,m)}toJSON(){return{id:this.id,folders:this.folders,configuration:this.configuration}}}e.Workspace=C;class s{constructor(m,c){this.raw=c,this.uri=m.uri,this.index=m.index,this.name=m.name}toResource(m){return R.joinPath(this.uri,m)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=s;function I(l){return new s({uri:l,index:0,name:R.basenameOrAuthority(l)},{uri:l.toString()})}e.toWorkspaceFolder=I}),define(ge[189],pe([0,1,4,157,45,2,11,9,24,133,52,10,75,29,82]),function(Q,e,v,R,k,D,A,P,_,C,s,I,l,m,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.useSlashForPath=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isRawUriWorkspaceFolder=e.isRawFileWorkspaceFolder=e.isStoredWorkspaceFolder=e.isUntitledWorkspace=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=e.hasWorkspaceFileExtension=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_EXTENSION=void 0,e.WORKSPACE_EXTENSION="code-workspace";const h=`.${e.WORKSPACE_EXTENSION}`;e.WORKSPACE_FILTER=[{name:R.localize(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function S(N){return(typeof N=="string"?P.extname(N):_.extname(N))===h}e.hasWorkspaceFileExtension=S,e.IWorkspacesService=v.createDecorator("workspacesService");function w(N){return N.hasOwnProperty("workspace")}e.isRecentWorkspace=w;function b(N){return N.hasOwnProperty("folderUri")}e.isRecentFolder=b;function u(N){return N.hasOwnProperty("fileUri")}e.isRecentFile=u;function d(N){const H=N;return typeof(H==null?void 0:H.id)=="string"&&D.URI.isUri(H.uri)}e.isSingleFolderWorkspaceIdentifier=d;function p(N){if(N.configuration)return{id:N.id,configPath:N.configuration};if(N.folders.length===1)return{id:N.id,uri:N.folders[0].uri}}e.toWorkspaceIdentifier=p;function t(N){const H=N;return typeof(H==null?void 0:H.id)=="string"&&D.URI.isUri(H.configPath)}e.isWorkspaceIdentifier=t;function i(N){const H=N;if(H==null?void 0:H.uri)return{id:H.id,uri:D.URI.revive(H.uri)};const T=N;if(T==null?void 0:T.configPath)return{id:T.id,configPath:D.URI.revive(T.configPath)};if(N==null?void 0:N.id)return{id:N.id}}e.reviveIdentifier=i;function r(N,H){return _.extUriBiasedIgnorePathCase.isEqualOrParent(N,H.untitledWorkspacesHome)}e.isUntitledWorkspace=r;function n(N){return o(N)||g(N)}e.isStoredWorkspaceFolder=n;function o(N){const H=N;return typeof(H==null?void 0:H.path)=="string"&&(!H.name||typeof H.name=="string")}e.isRawFileWorkspaceFolder=o;function g(N){const H=N;return typeof(H==null?void 0:H.uri)=="string"&&(!H.name||typeof H.name=="string")}e.isRawUriWorkspaceFolder=g;function f(N,H,T,U,F=!A.isWindows,M){if(N.scheme!==U.scheme)return{name:T,uri:N.toString(!0)};let x=H?void 0:M.relativePath(U,N);if(x!==void 0)x.length===0?x=".":A.isWindows&&N.scheme===I.Schemas.file&&!F&&(x=x.replace(/\//g,"\\"));else if(N.scheme===I.Schemas.file)x=N.fsPath,A.isWindows&&(x=l.normalizeDriveLetter(x),F&&(x=m.toSlashes(x)));else{if(!M.isEqualAuthority(N.authority,U.authority))return{name:T,uri:N.toString(!0)};x=N.path}return{name:T,path:x}}e.getStoredWorkspaceFolder=f;function E(N,H,T){let U=[],F=new Set;const M=T.dirname(H);for(let x of N){let $;if(o(x))x.path&&($=T.resolvePath(M,x.path));else if(g(x))try{$=D.URI.parse(x.uri),$.path[0]!=="/"&&($=$.with({path:"/"+$.path}))}catch(X){console.warn(X)}if($){let X=T.getComparisonKey($);if(!F.has(X)){F.add(X);const le=x.name||T.basenameOrAuthority($);U.push(new k.WorkspaceFolder({uri:$,name:le,index:U.length},x))}}}return U}e.toWorkspaceFolders=E;function y(N,H,T,U,F){let M=a(H,N);const x=F.dirname(H),$=F.dirname(U),X=[],le=L(M.folders);for(const Me of M.folders){const je=o(Me)?F.resolvePath(x,Me.path):D.URI.parse(Me.uri);let ze;T?ze=!1:ze=!o(Me)||P.isAbsolute(Me.path),X.push(f(je,ze,Me.name,$,le,F))}const be={insertSpaces:!1,tabSize:4,eol:A.isLinux||A.isMacintosh?`
`:`\r
`},Re=C.setProperty(N,["folders"],X,be);let Ce=C.applyEdits(N,Re);return M.remoteAuthority===c.getRemoteAuthority(U)&&(Ce=C.applyEdits(Ce,C.removeProperty(Ce,["remoteAuthority"],be))),Ce}e.rewriteWorkspaceFileForNewLocation=y;function a(N,H){let T=s.parse(H);if(T&&Array.isArray(T.folders))T.folders=T.folders.filter(U=>n(U));else throw new Error(`${N} looks like an invalid workspace file.`);return T}function L(N){return A.isWindows?N.some(H=>o(H)&&H.path.indexOf("/")>=0):!0}e.useSlashForPath=L;function O(N){return N.workspace&&typeof N.workspace=="object"&&typeof N.workspace.id=="string"&&typeof N.workspace.configPath=="string"}function W(N){return typeof N.folderUri=="string"}function J(N){return typeof N.fileUri=="string"}function se(N,H){const T={workspaces:[],files:[]};if(N){const U=function(M,x){for(let $=0;$<M.length;$++)try{x(M[$],$)}catch(X){H.warn(`Error restoring recent entry ${JSON.stringify(M[$])}: ${X.toString()}. Skip entry.`)}},F=N;if(Array.isArray(F.entries))U(F.entries,M=>{const x=M.label,$=M.remoteAuthority;O(M)?T.workspaces.push({label:x,remoteAuthority:$,workspace:{id:M.workspace.id,configPath:D.URI.parse(M.workspace.configPath)}}):W(M)?T.workspaces.push({label:x,remoteAuthority:$,folderUri:D.URI.parse(M.folderUri)}):J(M)&&T.files.push({label:x,remoteAuthority:$,fileUri:D.URI.parse(M.fileUri)})});else{const M=N;Array.isArray(M.workspaces3)&&U(M.workspaces3,(x,$)=>{const X=Array.isArray(M.workspaceLabels)&&M.workspaceLabels[$]||void 0;typeof x=="object"&&typeof x.id=="string"&&typeof x.configURIPath=="string"?T.workspaces.push({label:X,workspace:{id:x.id,configPath:D.URI.parse(x.configURIPath)}}):typeof x=="string"&&T.workspaces.push({label:X,folderUri:D.URI.parse(x)})}),Array.isArray(M.files2)&&U(M.files2,(x,$)=>{const X=Array.isArray(M.fileLabels)&&M.fileLabels[$]||void 0;typeof x=="string"&&T.files.push({label:X,fileUri:D.URI.parse(x)})})}}return T}e.restoreRecentlyOpened=se;function q(N){const H={entries:[]};for(const T of N.workspaces)b(T)?H.entries.push({folderUri:T.folderUri.toString(),label:T.label,remoteAuthority:T.remoteAuthority}):H.entries.push({workspace:{id:T.workspace.id,configPath:T.workspace.configPath.toString()},label:T.label,remoteAuthority:T.remoteAuthority});for(const T of N.files)H.entries.push({fileUri:T.fileUri.toString(),label:T.label,remoteAuthority:T.remoteAuthority});return H}e.toStoreData=q}),define(ge[83],pe([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class v{constructor(k){this.id=k,this._data=new Map,this._idPool=1}add(k){const D=this._idPool++;return this._data.set(D,k),this.logDebugInfo(),D}get(k,D){return this._data.has(k)?this._data.get(k)[D]:void 0}delete(k){this._data.delete(k),this.logDebugInfo()}logDebugInfo(){!v.enableDebugLogging||console.log(`${this.id} cache size \u2014 ${this._data.size}`)}}e.Cache=v,v.enableDebugLogging=!1}),define(ge[46],pe([0,1,2,3,4]),function(Q,e,v,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=k.createDecorator("IExtHostEditorTabs");class D{constructor(){this._onDidChangeTabs=new R.Emitter,this.onDidChangeTabs=this._onDidChangeTabs.event,this._tabs=[]}get tabs(){return this._tabs}$acceptEditorTabs(P){this._tabs=P.map(_=>({name:_.name,group:_.group,resource:v.URI.revive(_.resource),isActive:_.isActive})),this._onDidChangeTabs.fire()}}e.ExtHostEditorTabs=D}),define(ge[58],pe([0,1,10,4]),function(Q,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class k{constructor(){this._systemSchemes=new Set(Object.keys(v.Schemas)),this._providerInfo=new Map}$acceptProviderInfos(A,P){P===null?this._providerInfo.delete(A):this._providerInfo.set(A,P)}isFreeScheme(A){return!this._providerInfo.has(A)&&!this._systemSchemes.has(A)}getCapabilities(A){return this._providerInfo.get(A)}}e.ExtHostFileSystemInfo=k,e.IExtHostFileSystemInfo=R.createDecorator("IExtHostFileSystemInfo")}),define(ge[27],pe([0,1,4]),function(Q,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=v.createDecorator("IExtHostInitDataService")}),define(ge[190],pe([0,1,16]),function(Q,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class R{constructor(A,P,_){this._deferredPromises=new Map,this._id=A,this._shared=P,this._storage=_,this._init=this._storage.getValue(this._shared,this._id,Object.create(null)).then(C=>(this._value=C,this)),this._storageListener=this._storage.onDidChangeStorage(C=>{C.shared===this._shared&&C.key===this._id&&(this._value=C.value)}),this._scheduler=new v.RunOnceScheduler(()=>{const C=this._deferredPromises;this._deferredPromises=new Map,(async()=>{try{await this._storage.setValue(this._shared,this._id,this._value);for(const s of C.values())s.complete()}catch(s){for(const I of C.values())I.error(s)}})()},0)}get keys(){var A;return Object.entries((A=this._value)!==null&&A!==void 0?A:{}).filter(([,P])=>P!==void 0).map(([P])=>P)}get whenReady(){return this._init}get(A,P){let _=this._value[A];return typeof _=="undefined"&&(_=P),_}update(A,P){this._value[A]=P;let _=this._deferredPromises.get(A);if(_!==void 0)return _.p;const C=new v.DeferredPromise;return this._deferredPromises.set(A,C),this._scheduler.isScheduled()||this._scheduler.schedule(),C.p}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=R;class k extends R{constructor(A,P){super(A.identifier.value,!0,P);this._extension=A}setKeysForSync(A){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},A)}}e.ExtensionGlobalMemento=k}),define(ge[191],pe([0,1,3,2,12]),function(Q,e,v,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;let D=class{constructor(P,_){this._logService=P,this._notebooksAndEditors=_,this._onDidChangeNotebookDocumentMetadata=new v.Emitter,this.onDidChangeNotebookDocumentMetadata=this._onDidChangeNotebookDocumentMetadata.event,this._onDidSaveNotebookDocument=new v.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event}$acceptModelChanged(P,_,C){this._notebooksAndEditors.getNotebookDocument(R.URI.revive(P)).acceptModelChanged(_,C)}$acceptDirtyStateChanged(P,_){this._notebooksAndEditors.getNotebookDocument(R.URI.revive(P)).acceptDirty(_)}$acceptModelSaved(P){const _=this._notebooksAndEditors.getNotebookDocument(R.URI.revive(P));this._onDidSaveNotebookDocument.fire(_.apiNotebook)}$acceptDocumentPropertiesChanged(P,_){this._logService.debug("ExtHostNotebook#$acceptDocumentPropertiesChanged",P.path,_);const C=this._notebooksAndEditors.getNotebookDocument(R.URI.revive(P));C.acceptDocumentPropertiesChanged(_),_.metadata&&this._onDidChangeNotebookDocumentMetadata.fire({document:C.apiNotebook})}};D=Ve([$e(0,k.ILogService)],D),e.ExtHostNotebookDocuments=D}),define(ge[13],pe([0,1,4]),function(Q,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=v.createDecorator("IExtHostRpcService");class R{constructor(D){this.getProxy=D.getProxy.bind(D),this.set=D.set.bind(D),this.assertRegistered=D.assertRegistered.bind(D),this.drain=D.drain.bind(D)}}e.ExtHostRpcService=R});var it=this&&this.__classPrivateFieldSet||function(Q,e,v,R,k){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Q!==e||!k:!e.has(Q))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?k.call(Q,v):k?k.value=v:e.set(Q,v),v},Be=this&&this.__classPrivateFieldGet||function(Q,e,v,R){if(v==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Q!==e||!R:!e.has(Q))throw new TypeError("Cannot read private member from an object whose class did not declare it");return v==="m"?R:v==="a"?R.call(Q):R?R.value:e.get(Q)};define(ge[192],pe([0,1,26,3]),function(Q,e,v,R){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class D{constructor(P,_){k.set(this,void 0),this._onDidChange=new R.Emitter,this.onDidChange=this._onDidChange.event,this._id=v.ExtensionIdentifier.toKey(P.identifier),it(this,k,_,"f"),Be(this,k,"f").onDidChangePassword(C=>{C.extensionId===this._id&&this._onDidChange.fire({key:C.key})})}get(P){return Be(this,k,"f").get(this._id,P)}store(P,_){return Be(this,k,"f").store(this._id,P,_)}delete(P){return Be(this,k,"f").delete(this._id,P)}}e.ExtensionSecrets=D,k=new WeakMap}),define(ge[118],pe([0,1,4,3]),function(Q,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.ExtHostTelemetry=void 0;class k{constructor(){this._onDidChangeTelemetryEnabled=new R.Emitter,this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._enabled=!1}getTelemetryEnabled(){return this._enabled}$initializeTelemetryEnabled(A){this._enabled=A}$onDidChangeTelemetryEnabled(A){this._enabled=A,this._onDidChangeTelemetryEnabled.fire(A)}}e.ExtHostTelemetry=k,e.IExtHostTelemetry=v.createDecorator("IExtHostTelemetry")}),define(ge[84],pe([0,1,3]),function(Q,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPrivateApiFor=e.ExtHostTestItemEventType=void 0;var R;(function(A){A[A.NewChild=0]="NewChild",A[A.Disposed=1]="Disposed",A[A.Invalidated=2]="Invalidated",A[A.SetProp=3]="SetProp"})(R=e.ExtHostTestItemEventType||(e.ExtHostTestItemEventType={}));const k=new WeakMap,D=A=>{let P=k.get(A);return P||(P={children:new Map,bus:new v.Emitter},k.set(A,P)),P};e.getPrivateApiFor=D}),define(ge[47],pe([0,1,4,3,13]),function(Q,e,v,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDto=void 0;var D;(function(P){function _(s){return{remoteAddress:s.remoteAddress,localAddress:s.localAddress,public:!!s.public}}P.fromApiTunnel=_;function C(s){return{remoteAddress:{host:s.tunnelRemoteHost,port:s.tunnelRemotePort},localAddress:s.localAddress,public:s.public}}P.fromServiceTunnel=C})(D=e.TunnelDto||(e.TunnelDto={})),e.IExtHostTunnelService=v.createDecorator("IExtHostTunnelService");let A=class{constructor(_){this.onDidChangeTunnels=new R.Emitter().event}async $applyCandidateFilter(_){return _}async openTunnel(_,C){}async getTunnels(){return[]}async setTunnelExtensionFunctions(_){return{dispose:()=>{}}}registerPortsAttributesProvider(_,C){return{dispose:()=>{}}}async $providePortAttributes(_,C,s,I,l){return[]}async $forwardPort(_,C){}async $closeTunnel(_){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};A=Ve([$e(0,k.IExtHostRpcService)],A),e.ExtHostTunnelService=A});var it=this&&this.__classPrivateFieldSet||function(Q,e,v,R,k){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Q!==e||!k:!e.has(Q))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?k.call(Q,v):k?k.value=v:e.set(Q,v),v},Be=this&&this.__classPrivateFieldGet||function(Q,e,v,R){if(v==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Q!==e||!R:!e.has(Q))throw new TypeError("Cannot read private member from an object whose class did not declare it");return v==="m"?R:v==="a"?R.call(Q):R?R.value:e.get(Q)};define(ge[7],pe([0,1,18,14,96,23,99,15,2,32,42,117,84]),function(Q,e,v,R,k,D,A,P,_,C,s,I,l){"use strict";var m,c,h,S,w,b,u,d,p,t,i,r,n,o,g,f,E,y;Object.defineProperty(e,"__esModule",{value:!0}),e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.TestMessage=e.TestItemImpl=e.TestItemStatus=e.TestMessageSeverity=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookRendererScript=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.QuickInputButtons=e.DebugConfigurationProviderTriggerKind=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.TreeItemCollapsibleState=e.TreeItem=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestions=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function a(V){function B(){return Reflect.construct(V,arguments,this.constructor)}return Object.defineProperty(B,"name",Object.getOwnPropertyDescriptor(V,"name")),Object.setPrototypeOf(B,V),Object.setPrototypeOf(B.prototype,V.prototype),B}let L=w=class{constructor(B){m.set(this,void 0),it(this,m,B,"f")}static from(...B){let re=B;return new w(function(){if(re){for(const ke of re)ke&&typeof ke.dispose=="function"&&ke.dispose();re=void 0}})}dispose(){typeof Be(this,m,"f")=="function"&&(Be(this,m,"f").call(this),it(this,m,void 0,"f"))}};m=new WeakMap,L=w=Ve([a],L),e.Disposable=L;let O=b=class{constructor(B,re){if(B<0)throw R.illegalArgument("line must be non-negative");if(re<0)throw R.illegalArgument("character must be non-negative");this._line=B,this._character=re}static Min(...B){if(B.length===0)throw new TypeError;let re=B[0];for(let ke=1;ke<B.length;ke++){const Ge=B[ke];Ge.isBefore(re)&&(re=Ge)}return re}static Max(...B){if(B.length===0)throw new TypeError;let re=B[0];for(let ke=1;ke<B.length;ke++){const Ge=B[ke];Ge.isAfter(re)&&(re=Ge)}return re}static isPosition(B){if(!B)return!1;if(B instanceof b)return!0;let{line:re,character:ke}=B;return typeof re=="number"&&typeof ke=="number"}get line(){return this._line}get character(){return this._character}isBefore(B){return this._line<B._line?!0:B._line<this._line?!1:this._character<B._character}isBeforeOrEqual(B){return this._line<B._line?!0:B._line<this._line?!1:this._character<=B._character}isAfter(B){return!this.isBeforeOrEqual(B)}isAfterOrEqual(B){return!this.isBefore(B)}isEqual(B){return this._line===B._line&&this._character===B._character}compareTo(B){return this._line<B._line?-1:this._line>B.line?1:this._character<B._character?-1:this._character>B._character?1:0}translate(B,re=0){if(B===null||re===null)throw R.illegalArgument();let ke;return typeof B=="undefined"?ke=0:typeof B=="number"?ke=B:(ke=typeof B.lineDelta=="number"?B.lineDelta:0,re=typeof B.characterDelta=="number"?B.characterDelta:0),ke===0&&re===0?this:new b(this.line+ke,this.character+re)}with(B,re=this.character){if(B===null||re===null)throw R.illegalArgument();let ke;return typeof B=="undefined"?ke=this.line:typeof B=="number"?ke=B:(ke=typeof B.line=="number"?B.line:this.line,re=typeof B.character=="number"?B.character:this.character),ke===this.line&&re===this.character?this:new b(ke,re)}toJSON(){return{line:this.line,character:this.character}}};O=b=Ve([a],O),e.Position=O;let W=u=class{constructor(B,re,ke,Ge){let tt,at;if(typeof B=="number"&&typeof re=="number"&&typeof ke=="number"&&typeof Ge=="number"?(tt=new O(B,re),at=new O(ke,Ge)):B instanceof O&&re instanceof O&&(tt=B,at=re),!tt||!at)throw new Error("Invalid arguments");tt.isBefore(at)?(this._start=tt,this._end=at):(this._start=at,this._end=tt)}static isRange(B){return B instanceof u?!0:B?O.isPosition(B.start)&&O.isPosition(B.end):!1}get start(){return this._start}get end(){return this._end}contains(B){return B instanceof u?this.contains(B._start)&&this.contains(B._end):B instanceof O?!(B.isBefore(this._start)||this._end.isBefore(B)):!1}isEqual(B){return this._start.isEqual(B._start)&&this._end.isEqual(B._end)}intersection(B){const re=O.Max(B.start,this._start),ke=O.Min(B.end,this._end);if(!re.isAfter(ke))return new u(re,ke)}union(B){if(this.contains(B))return this;if(B.contains(this))return B;const re=O.Min(B.start,this._start),ke=O.Max(B.end,this.end);return new u(re,ke)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(B,re=this.end){if(B===null||re===null)throw R.illegalArgument();let ke;return B?O.isPosition(B)?ke=B:(ke=B.start||this.start,re=B.end||this.end):ke=this.start,ke.isEqual(this._start)&&re.isEqual(this.end)?this:new u(ke,re)}toJSON(){return[this.start,this.end]}};W=u=Ve([a],W),e.Range=W;let J=d=class extends W{constructor(B,re,ke,Ge){let tt,at;if(typeof B=="number"&&typeof re=="number"&&typeof ke=="number"&&typeof Ge=="number"?(tt=new O(B,re),at=new O(ke,Ge)):B instanceof O&&re instanceof O&&(tt=B,at=re),!tt||!at)throw new Error("Invalid arguments");super(tt,at);this._anchor=tt,this._active=at}static isSelection(B){return B instanceof d?!0:B?W.isRange(B)&&O.isPosition(B.anchor)&&O.isPosition(B.active)&&typeof B.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};J=d=Ve([a],J),e.Selection=J;class se{constructor(B,re,ke){if(typeof B!="string"||B.length===0)throw R.illegalArgument("host");if(typeof re!="number"||re===0||Math.round(re)!==re)throw R.illegalArgument("port");if(typeof ke!="undefined"&&(typeof ke!="string"||ke.length===0||!/^[0-9A-Za-z\-]+$/.test(ke)))throw R.illegalArgument("connectionToken");this.host=B,this.port=Math.round(re),this.connectionToken=ke}}e.ResolvedAuthority=se;class q extends Error{constructor(B,re=I.RemoteAuthorityResolverErrorCode.Unknown,ke){super(B);this._message=B,this._code=re,this._detail=ke,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,q.prototype)}static NotAvailable(B,re){return new q(B,I.RemoteAuthorityResolverErrorCode.NotAvailable,re)}static TemporarilyNotAvailable(B){return new q(B,I.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}}e.RemoteAuthorityResolverError=q;var N;(function(V){V[V.LF=1]="LF",V[V.CRLF=2]="CRLF"})(N=e.EndOfLine||(e.EndOfLine={}));var H;(function(V){V[V.Replace=1]="Replace",V[V.Append=2]="Append",V[V.Prepend=3]="Prepend"})(H=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let T=p=class{constructor(B,re){this._range=B,this._newText=re}static isTextEdit(B){return B instanceof p?!0:B?W.isRange(B)&&typeof B.newText=="string":!1}static replace(B,re){return new p(B,re)}static insert(B,re){return p.replace(new W(B,B),re)}static delete(B){return p.replace(B,"")}static setEndOfLine(B){const re=new p(new W(new O(0,0),new O(0,0)),"");return re.newEol=B,re}get range(){return this._range}set range(B){if(B&&!W.isRange(B))throw R.illegalArgument("range");this._range=B}get newText(){return this._newText||""}set newText(B){if(B&&typeof B!="string")throw R.illegalArgument("newText");this._newText=B}get newEol(){return this._newEol}set newEol(B){if(B&&typeof B!="number")throw R.illegalArgument("newEol");this._newEol=B}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};T=p=Ve([a],T),e.TextEdit=T;var U;(function(V){V[V.File=1]="File",V[V.Text=2]="Text",V[V.Cell=3]="Cell",V[V.CellReplace=5]="CellReplace"})(U=e.FileEditType||(e.FileEditType={}));let F=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(B,re,ke,Ge){this._edits.push({_type:1,from:B,to:re,options:ke,metadata:Ge})}createFile(B,re,ke){this._edits.push({_type:1,from:void 0,to:B,options:re,metadata:ke})}deleteFile(B,re,ke){this._edits.push({_type:1,from:B,to:void 0,options:re,metadata:ke})}replaceNotebookMetadata(B,re,ke){this._edits.push({_type:3,metadata:ke,uri:B,edit:{editType:5,metadata:re},notebookMetadata:re})}replaceNotebookCells(B,re,ke,Ge,tt){let at,ct,St=[],Ct;if(Ht.isNotebookRange(re)&&Mt.isNotebookCellDataArray(ke)&&!Mt.isNotebookCellDataArray(Ge)?(at=re.start,ct=re.end,St=ke,Ct=Ge):typeof re=="number"&&typeof ke=="number"&&Mt.isNotebookCellDataArray(Ge)&&(at=re,ct=ke,St=Ge,Ct=tt),at===void 0||ct===void 0)throw new Error("Invalid arguments");(at!==ct||St.length>0)&&this._edits.push({_type:5,uri:B,index:at,count:ct-at,cells:St,metadata:Ct})}replaceNotebookCellMetadata(B,re,ke,Ge){this._edits.push({_type:3,metadata:Ge,uri:B,edit:{editType:8,index:re,metadata:ke}})}replace(B,re,ke,Ge){this._edits.push({_type:2,uri:B,edit:new T(re,ke),metadata:Ge})}insert(B,re,ke,Ge){this.replace(B,new W(re,re),ke,Ge)}delete(B,re,ke){this.replace(B,re,"",ke)}has(B){return this._edits.some(re=>re._type===2&&re.uri.toString()===B.toString())}set(B,re){if(re)for(const ke of re)ke&&this._edits.push({_type:2,uri:B,edit:ke});else{for(let ke=0;ke<this._edits.length;ke++){const Ge=this._edits[ke];Ge._type===2&&Ge.uri.toString()===B.toString()&&(this._edits[ke]=void 0)}v.coalesceInPlace(this._edits)}}get(B){const re=[];for(let ke of this._edits)ke._type===2&&ke.uri.toString()===B.toString()&&re.push(ke.edit);return re}entries(){const B=new D.ResourceMap;for(let re of this._edits)if(re._type===2){let ke=B.get(re.uri);ke||(ke=[re.uri,[]],B.set(re.uri,ke)),ke[1].push(re.edit)}return[...B.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};F=Ve([a],F),e.WorkspaceEdit=F;let M=t=class{constructor(B){this._tabstop=1,this.value=B||""}static isSnippetString(B){return B instanceof t?!0:B?typeof B.value=="string":!1}static _escape(B){return B.replace(/\$|}|\\/g,"\\$&")}appendText(B){return this.value+=t._escape(B),this}appendTabstop(B=this._tabstop++){return this.value+="$",this.value+=B,this}appendPlaceholder(B,re=this._tabstop++){if(typeof B=="function"){const ke=new t;ke._tabstop=this._tabstop,B(ke),this._tabstop=ke._tabstop,B=ke.value}else B=t._escape(B);return this.value+="${",this.value+=re,this.value+=":",this.value+=B,this.value+="}",this}appendChoice(B,re=this._tabstop++){const ke=B.map(Ge=>Ge.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=re,this.value+="|",this.value+=ke,this.value+="|}",this}appendVariable(B,re){if(typeof re=="function"){const ke=new t;ke._tabstop=this._tabstop,re(ke),this._tabstop=ke._tabstop,re=ke.value}else typeof re=="string"&&(re=re.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=B,re&&(this.value+=":",this.value+=re),this.value+="}",this}};M=t=Ve([a],M),e.SnippetString=M;var x;(function(V){V[V.Unnecessary=1]="Unnecessary",V[V.Deprecated=2]="Deprecated"})(x=e.DiagnosticTag||(e.DiagnosticTag={}));var $;(function(V){V[V.Hint=3]="Hint",V[V.Information=2]="Information",V[V.Warning=1]="Warning",V[V.Error=0]="Error"})($=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let X=i=class{constructor(B,re){if(this.uri=B,re)if(re instanceof W)this.range=re;else if(re instanceof O)this.range=new W(re,re);else throw new Error("Illegal argument")}static isLocation(B){return B instanceof i?!0:B?W.isRange(B.range)&&_.URI.isUri(B.uri):!1}toJSON(){return{uri:this.uri,range:this.range}}};X=i=Ve([a],X),e.Location=X;let le=class{constructor(B,re){this.location=B,this.message=re}static is(B){return B?typeof B.message=="string"&&B.location&&W.isRange(B.location.range)&&_.URI.isUri(B.location.uri):!1}static isEqual(B,re){return B===re?!0:!B||!re?!1:B.message===re.message&&B.location.range.isEqual(re.location.range)&&B.location.uri.toString()===re.location.uri.toString()}};le=Ve([a],le),e.DiagnosticRelatedInformation=le;let be=class{constructor(B,re,ke=$.Error){if(!W.isRange(B))throw new TypeError("range must be set");if(!re)throw new TypeError("message must be set");this.range=B,this.message=re,this.severity=ke}toJSON(){return{severity:$[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(B,re){return B===re?!0:!B||!re?!1:B.message===re.message&&B.severity===re.severity&&B.code===re.code&&B.severity===re.severity&&B.source===re.source&&B.range.isEqual(re.range)&&v.equals(B.tags,re.tags)&&v.equals(B.relatedInformation,re.relatedInformation,le.isEqual)}};be=Ve([a],be),e.Diagnostic=be;let Re=class{constructor(B,re){if(!B)throw new Error("Illegal argument, contents must be defined");Array.isArray(B)?this.contents=B:k.isMarkdownString(B)?this.contents=[B]:this.contents=[B],this.range=re}};Re=Ve([a],Re),e.Hover=Re;var Ce;(function(V){V[V.Text=0]="Text",V[V.Read=1]="Read",V[V.Write=2]="Write"})(Ce=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let Me=class{constructor(B,re=Ce.Text){this.range=B,this.kind=re}toJSON(){return{range:this.range,kind:Ce[this.kind]}}};Me=Ve([a],Me),e.DocumentHighlight=Me;var je;(function(V){V[V.File=0]="File",V[V.Module=1]="Module",V[V.Namespace=2]="Namespace",V[V.Package=3]="Package",V[V.Class=4]="Class",V[V.Method=5]="Method",V[V.Property=6]="Property",V[V.Field=7]="Field",V[V.Constructor=8]="Constructor",V[V.Enum=9]="Enum",V[V.Interface=10]="Interface",V[V.Function=11]="Function",V[V.Variable=12]="Variable",V[V.Constant=13]="Constant",V[V.String=14]="String",V[V.Number=15]="Number",V[V.Boolean=16]="Boolean",V[V.Array=17]="Array",V[V.Object=18]="Object",V[V.Key=19]="Key",V[V.Null=20]="Null",V[V.EnumMember=21]="EnumMember",V[V.Struct=22]="Struct",V[V.Event=23]="Event",V[V.Operator=24]="Operator",V[V.TypeParameter=25]="TypeParameter"})(je=e.SymbolKind||(e.SymbolKind={}));var ze;(function(V){V[V.Deprecated=1]="Deprecated"})(ze=e.SymbolTag||(e.SymbolTag={}));let qe=r=class{constructor(B,re,ke,Ge,tt){this.name=B,this.kind=re,this.containerName=tt,typeof ke=="string"&&(this.containerName=ke),Ge instanceof X?this.location=Ge:ke instanceof W&&(this.location=new X(Ge,ke)),r.validate(this)}static validate(B){if(!B.name)throw new Error("name must not be falsy")}toJSON(){return{name:this.name,kind:je[this.kind],location:this.location,containerName:this.containerName}}};qe=r=Ve([a],qe),e.SymbolInformation=qe;let j=n=class{constructor(B,re,ke,Ge,tt){this.name=B,this.detail=re,this.kind=ke,this.range=Ge,this.selectionRange=tt,this.children=[],n.validate(this)}static validate(B){if(!B.name)throw new Error("name must not be falsy");if(!B.range.contains(B.selectionRange))throw new Error("selectionRange must be contained in fullRange");B.children&&B.children.forEach(n.validate)}};j=n=Ve([a],j),e.DocumentSymbol=j;var Z;(function(V){V[V.Invoke=1]="Invoke",V[V.Automatic=2]="Automatic"})(Z=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let ne=class{constructor(B,re){this.title=B,this.kind=re}};ne=Ve([a],ne),e.CodeAction=ne;let oe=o=class{constructor(B){this.value=B}append(B){return new o(this.value?this.value+o.sep+B:B)}intersects(B){return this.contains(B)||B.contains(this)}contains(B){return this.value===B.value||B.value.startsWith(this.value+o.sep)}};oe.sep=".",oe=o=Ve([a],oe),e.CodeActionKind=oe,oe.Empty=new oe(""),oe.QuickFix=oe.Empty.append("quickfix"),oe.Refactor=oe.Empty.append("refactor"),oe.RefactorExtract=oe.Refactor.append("extract"),oe.RefactorInline=oe.Refactor.append("inline"),oe.RefactorRewrite=oe.Refactor.append("rewrite"),oe.Source=oe.Empty.append("source"),oe.SourceOrganizeImports=oe.Source.append("organizeImports"),oe.SourceFixAll=oe.Source.append("fixAll");let Y=class{constructor(B,re){if(this.range=B,this.parent=re,re&&!re.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};Y=Ve([a],Y),e.SelectionRange=Y;class ce{constructor(B,re,ke,Ge,tt,at){this.kind=B,this.name=re,this.detail=ke,this.uri=Ge,this.range=tt,this.selectionRange=at}}e.CallHierarchyItem=ce;class me{constructor(B,re){this.fromRanges=re,this.from=B}}e.CallHierarchyIncomingCall=me;class Le{constructor(B,re){this.fromRanges=re,this.to=B}}e.CallHierarchyOutgoingCall=Le;let We=class{constructor(B,re){this.range=B,this.command=re}get isResolved(){return!!this.command}};We=Ve([a],We),e.CodeLens=We;let Ee=g=class{constructor(B,re=!1){c.set(this,void 0),it(this,c,new k.MarkdownString(B,{supportThemeIcons:re}),"f")}static isMarkdownString(B){return B instanceof g?!0:B&&B.appendCodeblock&&B.appendMarkdown&&B.appendText&&B.value!==void 0}get value(){return Be(this,c,"f").value}set value(B){Be(this,c,"f").value=B}get isTrusted(){return Be(this,c,"f").isTrusted}set isTrusted(B){Be(this,c,"f").isTrusted=B}get supportThemeIcons(){return Be(this,c,"f").supportThemeIcons}appendText(B){return Be(this,c,"f").appendText(B),this}appendMarkdown(B){return Be(this,c,"f").appendMarkdown(B),this}appendCodeblock(B,re){return Be(this,c,"f").appendCodeblock(re??"",B),this}};c=new WeakMap,Ee=g=Ve([a],Ee),e.MarkdownString=Ee;let Ke=class{constructor(B,re){this.label=B,this.documentation=re}};Ke=Ve([a],Ke),e.ParameterInformation=Ke;let G=class{constructor(B,re){this.label=B,this.documentation=re,this.parameters=[]}};G=Ve([a],G),e.SignatureInformation=G;let ie=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};ie=Ve([a],ie),e.SignatureHelp=ie;var ve;(function(V){V[V.Invoke=1]="Invoke",V[V.TriggerCharacter=2]="TriggerCharacter",V[V.ContentChange=3]="ContentChange"})(ve=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var Fe;(function(V){V[V.Other=0]="Other",V[V.Type=1]="Type",V[V.Parameter=2]="Parameter"})(Fe=e.InlayHintKind||(e.InlayHintKind={}));let Ne=class{constructor(B,re,ke){this.text=B,this.position=re,this.kind=ke}};Ne=Ve([a],Ne),e.InlayHint=Ne;var Qe;(function(V){V[V.Invoke=0]="Invoke",V[V.TriggerCharacter=1]="TriggerCharacter",V[V.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(Qe=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var De;(function(V){V[V.Text=0]="Text",V[V.Method=1]="Method",V[V.Function=2]="Function",V[V.Constructor=3]="Constructor",V[V.Field=4]="Field",V[V.Variable=5]="Variable",V[V.Class=6]="Class",V[V.Interface=7]="Interface",V[V.Module=8]="Module",V[V.Property=9]="Property",V[V.Unit=10]="Unit",V[V.Value=11]="Value",V[V.Enum=12]="Enum",V[V.Keyword=13]="Keyword",V[V.Snippet=14]="Snippet",V[V.Color=15]="Color",V[V.File=16]="File",V[V.Reference=17]="Reference",V[V.Folder=18]="Folder",V[V.EnumMember=19]="EnumMember",V[V.Constant=20]="Constant",V[V.Struct=21]="Struct",V[V.Event=22]="Event",V[V.Operator=23]="Operator",V[V.TypeParameter=24]="TypeParameter",V[V.User=25]="User",V[V.Issue=26]="Issue"})(De=e.CompletionItemKind||(e.CompletionItemKind={}));var Se;(function(V){V[V.Deprecated=1]="Deprecated"})(Se=e.CompletionItemTag||(e.CompletionItemTag={}));let Pe=class{constructor(B,re){this.label=B,this.kind=re}toJSON(){return{label:this.label,label2:this.label2,kind:this.kind&&De[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};Pe=Ve([a],Pe),e.CompletionItem=Pe;let ae=class{constructor(B=[],re=!1){this.items=B,this.isIncomplete=re}};ae=Ve([a],ae),e.CompletionList=ae;let he=class{constructor(B,re,ke){this.text=B,this.range=re,this.command=ke}};he=Ve([a],he),e.InlineSuggestion=he;let z=class{constructor(B){this.items=B}};z=Ve([a],z),e.InlineSuggestions=z;var ee;(function(V){V[V.Active=-1]="Active",V[V.Beside=-2]="Beside",V[V.One=1]="One",V[V.Two=2]="Two",V[V.Three=3]="Three",V[V.Four=4]="Four",V[V.Five=5]="Five",V[V.Six=6]="Six",V[V.Seven=7]="Seven",V[V.Eight=8]="Eight",V[V.Nine=9]="Nine"})(ee=e.ViewColumn||(e.ViewColumn={}));var ue;(function(V){V[V.Left=1]="Left",V[V.Right=2]="Right"})(ue=e.StatusBarAlignment||(e.StatusBarAlignment={}));var Ie;(function(V){V[V.Off=0]="Off",V[V.On=1]="On",V[V.Relative=2]="Relative"})(Ie=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var Te;(function(V){V[V.Manual=1]="Manual",V[V.AfterDelay=2]="AfterDelay",V[V.FocusOut=3]="FocusOut"})(Te=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var xe;(function(V){V[V.Default=0]="Default",V[V.InCenter=1]="InCenter",V[V.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",V[V.AtTop=3]="AtTop"})(xe=e.TextEditorRevealType||(e.TextEditorRevealType={}));var He;(function(V){V[V.Keyboard=1]="Keyboard",V[V.Mouse=2]="Mouse",V[V.Command=3]="Command"})(He=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var Ze;(function(V){V[V.OpenOpen=0]="OpenOpen",V[V.ClosedClosed=1]="ClosedClosed",V[V.OpenClosed=2]="OpenClosed",V[V.ClosedOpen=3]="ClosedOpen"})(Ze=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(V){function B(re){switch(re){case"keyboard":return V.Keyboard;case"mouse":return V.Mouse;case"api":return V.Command}}V.fromValue=B}(He=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let Ye=class{constructor(B,re){if(re&&!_.URI.isUri(re))throw R.illegalArgument("target");if(!W.isRange(B)||B.isEmpty)throw R.illegalArgument("range");this.range=B,this.target=re}};Ye=Ve([a],Ye),e.DocumentLink=Ye;let Xe=class{constructor(B,re,ke,Ge){this.red=B,this.green=re,this.blue=ke,this.alpha=Ge}};Xe=Ve([a],Xe),e.Color=Xe;let nt=class{constructor(B,re){if(re&&!(re instanceof Xe))throw R.illegalArgument("color");if(!W.isRange(B)||B.isEmpty)throw R.illegalArgument("range");this.range=B,this.color=re}};nt=Ve([a],nt),e.ColorInformation=nt;let pt=class{constructor(B){if(!B||typeof B!="string")throw R.illegalArgument("label");this.label=B}};pt=Ve([a],pt),e.ColorPresentation=pt;var _e;(function(V){V[V.RGB=0]="RGB",V[V.HEX=1]="HEX",V[V.HSL=2]="HSL"})(_e=e.ColorFormat||(e.ColorFormat={}));var ye;(function(V){V[V.Error=0]="Error",V[V.Warning=1]="Warning",V[V.Information=2]="Information"})(ye=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));var de;(function(V){V[V.Always=1]="Always",V[V.Silent=2]="Silent",V[V.Never=3]="Never"})(de=e.TaskRevealKind||(e.TaskRevealKind={}));var K;(function(V){V[V.Shared=1]="Shared",V[V.Dedicated=2]="Dedicated",V[V.New=3]="New"})(K=e.TaskPanelKind||(e.TaskPanelKind={}));let Ue=f=class{constructor(B,re){if(typeof B!="string"||typeof re!="string")throw R.illegalArgument("name");this._id=B}static from(B){switch(B){case"clean":return f.Clean;case"build":return f.Build;case"rebuild":return f.Rebuild;case"test":return f.Test;default:return}}get id(){return this._id}};Ue.Clean=new f("clean","Clean"),Ue.Build=new f("build","Build"),Ue.Rebuild=new f("rebuild","Rebuild"),Ue.Test=new f("test","Test"),Ue=f=Ve([a],Ue),e.TaskGroup=Ue;function we(V){let B="";for(let re=0;re<V.length;re++)B+=V[re].replace(/,/g,",,")+",";return B}let Je=class{constructor(B,re,ke){if(typeof B!="string")throw R.illegalArgument("process");this._args=[],this._process=B,re!==void 0&&(Array.isArray(re)?(this._args=re,this._options=ke):this._options=re)}get process(){return this._process}set process(B){if(typeof B!="string")throw R.illegalArgument("process");this._process=B}get args(){return this._args}set args(B){Array.isArray(B)||(B=[]),this._args=B}get options(){return this._options}set options(B){this._options=B}computeId(){const B=[];if(B.push("process"),this._process!==void 0&&B.push(this._process),this._args&&this._args.length>0)for(let re of this._args)B.push(re);return we(B)}};Je=Ve([a],Je),e.ProcessExecution=Je;let et=class{constructor(B,re,ke){if(this._args=[],Array.isArray(re)){if(!B)throw R.illegalArgument("command can't be undefined or null");if(typeof B!="string"&&typeof B.value!="string")throw R.illegalArgument("command");this._command=B,this._args=re,this._options=ke}else{if(typeof B!="string")throw R.illegalArgument("commandLine");this._commandLine=B,this._options=re}}get commandLine(){return this._commandLine}set commandLine(B){if(typeof B!="string")throw R.illegalArgument("commandLine");this._commandLine=B}get command(){return this._command?this._command:""}set command(B){if(typeof B!="string"&&typeof B.value!="string")throw R.illegalArgument("command");this._command=B}get args(){return this._args}set args(B){this._args=B||[]}get options(){return this._options}set options(B){this._options=B}computeId(){const B=[];if(B.push("shell"),this._commandLine!==void 0&&B.push(this._commandLine),this._command!==void 0&&B.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(let re of this._args)B.push(typeof re=="string"?re:re.value);return we(B)}};et=Ve([a],et),e.ShellExecution=et;var rt;(function(V){V[V.Escape=1]="Escape",V[V.Strong=2]="Strong",V[V.Weak=3]="Weak"})(rt=e.ShellQuoting||(e.ShellQuoting={}));var st;(function(V){V[V.Global=1]="Global",V[V.Workspace=2]="Workspace"})(st=e.TaskScope||(e.TaskScope={}));class vt{constructor(B){this._callback=B}computeId(){return"customExecution"+C.generateUuid()}set callback(B){this._callback=B}get callback(){return this._callback}}e.CustomExecution=vt;let ft=E=class{constructor(B,re,ke,Ge,tt,at){this.__deprecated=!1,this._definition=this.definition=B;let ct;typeof re=="string"?(this._name=this.name=re,this._source=this.source=ke,this.execution=Ge,ct=tt,this.__deprecated=!0):re===st.Global||re===st.Workspace?(this.target=re,this._name=this.name=ke,this._source=this.source=Ge,this.execution=tt,ct=at):(this.target=re,this._name=this.name=ke,this._source=this.source=Ge,this.execution=tt,ct=at),typeof ct=="string"?(this._problemMatchers=[ct],this._hasDefinedMatchers=!0):Array.isArray(ct)?(this._problemMatchers=ct,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(B){this.__id=B}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof Je?this._definition={type:E.ProcessType,id:this._execution.computeId()}:this._execution instanceof et?this._definition={type:E.ShellType,id:this._execution.computeId()}:this._execution instanceof vt?this._definition={type:E.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:E.EmptyType,id:C.generateUuid()}}get definition(){return this._definition}set definition(B){if(B==null)throw R.illegalArgument("Kind can't be undefined or null");this.clear(),this._definition=B}get scope(){return this._scope}set target(B){this.clear(),this._scope=B}get name(){return this._name}set name(B){if(typeof B!="string")throw R.illegalArgument("name");this.clear(),this._name=B}get execution(){return this._execution}set execution(B){B===null&&(B=void 0),this.clear(),this._execution=B;const re=this._definition.type;(E.EmptyType===re||E.ProcessType===re||E.ShellType===re||E.ExtensionCallbackType===re)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(B){if(Array.isArray(B))this.clear(),this._problemMatchers=B,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(B){B!==!0&&B!==!1&&(B=!1),this.clear(),this._isBackground=B}get source(){return this._source}set source(B){if(typeof B!="string"||B.length===0)throw R.illegalArgument("source must be a string of length > 0");this.clear(),this._source=B}get group(){return this._group}set group(B){B===null&&(B=void 0),this.clear(),this._group=B}get detail(){return this._detail}set detail(B){B===null&&(B=void 0),this._detail=B}get presentationOptions(){return this._presentationOptions}set presentationOptions(B){B==null&&(B=Object.create(null)),this.clear(),this._presentationOptions=B}get runOptions(){return this._runOptions}set runOptions(B){B==null&&(B=Object.create(null)),this.clear(),this._runOptions=B}};ft.ExtensionCallbackType="customExecution",ft.ProcessType="process",ft.ShellType="shell",ft.EmptyType="$empty",ft=E=Ve([a],ft),e.Task=ft;var Et;(function(V){V[V.SourceControl=1]="SourceControl",V[V.Window=10]="Window",V[V.Notification=15]="Notification"})(Et=e.ProgressLocation||(e.ProgressLocation={}));let bt=class{constructor(B,re=Rt.None){this.collapsibleState=re,_.URI.isUri(B)?this.resourceUri=B:this.label=B}};bt=Ve([a],bt),e.TreeItem=bt;var Rt;(function(V){V[V.None=0]="None",V[V.Collapsed=1]="Collapsed",V[V.Expanded=2]="Expanded"})(Rt=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));let wt=class{constructor(B,re){this.id=B,this.color=re}};wt=Ve([a],wt),e.ThemeIcon=wt,wt.File=new wt("file"),wt.Folder=new wt("folder");let ut=class{constructor(B){this.id=B}};ut=Ve([a],ut),e.ThemeColor=ut;var mt;(function(V){V[V.Global=1]="Global",V[V.Workspace=2]="Workspace",V[V.WorkspaceFolder=3]="WorkspaceFolder"})(mt=e.ConfigurationTarget||(e.ConfigurationTarget={}));let dt=class{constructor(B,re){if(typeof B!="string"&&(!B||!_.URI.isUri(B)&&!_.URI.isUri(B.uri)))throw R.illegalArgument("base");if(typeof re!="string")throw R.illegalArgument("pattern");typeof B=="string"?(this.baseFolder=_.URI.file(B),this.base=B):_.URI.isUri(B)?(this.baseFolder=B,this.base=B.fsPath):(this.baseFolder=B.uri,this.base=B.uri.fsPath),this.pattern=re}};dt=Ve([a],dt),e.RelativePattern=dt;let Pt=class{constructor(B,re,ke,Ge){this.enabled=typeof B=="boolean"?B:!0,typeof re=="string"&&(this.condition=re),typeof ke=="string"&&(this.hitCondition=ke),typeof Ge=="string"&&(this.logMessage=Ge)}get id(){return this._id||(this._id=C.generateUuid()),this._id}};Pt=Ve([a],Pt),e.Breakpoint=Pt;let Dt=class extends Pt{constructor(B,re,ke,Ge,tt){super(re,ke,Ge,tt);if(B===null)throw R.illegalArgument("location");this.location=B}};Dt=Ve([a],Dt),e.SourceBreakpoint=Dt;let Lt=class extends Pt{constructor(B,re,ke,Ge,tt){super(re,ke,Ge,tt);this.functionName=B}};Lt=Ve([a],Lt),e.FunctionBreakpoint=Lt;let Kt=class extends Pt{constructor(B,re,ke,Ge,tt,at,ct){super(Ge,tt,at,ct);if(!re)throw R.illegalArgument("dataId");this.label=B,this.dataId=re,this.canPersist=ke}};Kt=Ve([a],Kt),e.DataBreakpoint=Kt;let _t=class{constructor(B,re,ke){this.command=B,this.args=re||[],this.options=ke}};_t=Ve([a],_t),e.DebugAdapterExecutable=_t;let Jt=class{constructor(B,re){this.port=B,this.host=re}};Jt=Ve([a],Jt),e.DebugAdapterServer=Jt;let Zt=class{constructor(B){this.path=B}};Zt=Ve([a],Zt),e.DebugAdapterNamedPipeServer=Zt;let gt=class{constructor(B){this.implementation=B}};gt=Ve([a],gt),e.DebugAdapterInlineImplementation=gt;let Qt=class{constructor(B,re){this.range=B,this.expression=re}};Qt=Ve([a],Qt),e.EvaluatableExpression=Qt;var en;(function(V){V[V.Automatic=0]="Automatic",V[V.Explicit=1]="Explicit"})(en=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));let tn=class{constructor(B,re){this.range=B,this.text=re}};tn=Ve([a],tn),e.InlineValueText=tn;let nn=class{constructor(B,re,ke=!0){this.range=B,this.variableName=re,this.caseSensitiveLookup=ke}};nn=Ve([a],nn),e.InlineValueVariableLookup=nn;let yt=class{constructor(B,re){this.range=B,this.expression=re}};yt=Ve([a],yt),e.InlineValueEvaluatableExpression=yt;let Xt=class{constructor(B,re){this.frameId=B,this.stoppedLocation=re}};Xt=Ve([a],Xt),e.InlineValueContext=Xt;var yn;(function(V){V[V.Changed=1]="Changed",V[V.Created=2]="Created",V[V.Deleted=3]="Deleted"})(yn=e.FileChangeType||(e.FileChangeType={}));let Ut=y=class extends Error{constructor(B,re=s.FileSystemProviderErrorCode.Unknown,ke){var Ge;super(_.URI.isUri(B)?B.toString(!0):B);this.code=(Ge=ke==null?void 0:ke.name)!==null&&Ge!==void 0?Ge:"Unknown",s.markAsFileSystemProviderError(this,re),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,y.prototype),typeof Error.captureStackTrace=="function"&&typeof ke=="function"&&Error.captureStackTrace(this,ke)}static FileExists(B){return new y(B,s.FileSystemProviderErrorCode.FileExists,y.FileExists)}static FileNotFound(B){return new y(B,s.FileSystemProviderErrorCode.FileNotFound,y.FileNotFound)}static FileNotADirectory(B){return new y(B,s.FileSystemProviderErrorCode.FileNotADirectory,y.FileNotADirectory)}static FileIsADirectory(B){return new y(B,s.FileSystemProviderErrorCode.FileIsADirectory,y.FileIsADirectory)}static NoPermissions(B){return new y(B,s.FileSystemProviderErrorCode.NoPermissions,y.NoPermissions)}static Unavailable(B){return new y(B,s.FileSystemProviderErrorCode.Unavailable,y.Unavailable)}};Ut=y=Ve([a],Ut),e.FileSystemError=Ut;let lt=class{constructor(B,re,ke){this.start=B,this.end=re,this.kind=ke}};lt=Ve([a],lt),e.FoldingRange=lt;var Dn;(function(V){V[V.Comment=1]="Comment",V[V.Imports=2]="Imports",V[V.Region=3]="Region"})(Dn=e.FoldingRangeKind||(e.FoldingRangeKind={}));var Ft;(function(V){V[V.Collapsed=0]="Collapsed",V[V.Expanded=1]="Expanded"})(Ft=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var Wt;(function(V){V[V.Editing=0]="Editing",V[V.Preview=1]="Preview"})(Wt=e.CommentMode||(e.CommentMode={}));class mn{constructor(B,re=[]){this.tokenTypes=B,this.tokenModifiers=re}}e.SemanticTokensLegend=mn;function Cn(V){return typeof V=="undefined"||P.isStringArray(V)}class Yt{constructor(B){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,B){this._hasLegend=!0;for(let re=0,ke=B.tokenTypes.length;re<ke;re++)this._tokenTypeStrToInt.set(B.tokenTypes[re],re);for(let re=0,ke=B.tokenModifiers.length;re<ke;re++)this._tokenModifierStrToInt.set(B.tokenModifiers[re],re)}}push(B,re,ke,Ge,tt){if(typeof B=="number"&&typeof re=="number"&&typeof ke=="number"&&typeof Ge=="number"&&(typeof tt=="number"||typeof tt=="undefined"))return typeof tt=="undefined"&&(tt=0),this._pushEncoded(B,re,ke,Ge,tt);if(W.isRange(B)&&typeof re=="string"&&Cn(ke))return this._push(B,re,ke);throw R.illegalArgument()}_push(B,re,ke){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(B.start.line!==B.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(re))throw new Error("`tokenType` is not in the provided legend");const Ge=B.start.line,tt=B.start.character,at=B.end.character-B.start.character,ct=this._tokenTypeStrToInt.get(re);let St=0;if(ke)for(const Ct of ke){if(!this._tokenModifierStrToInt.has(Ct))throw new Error("`tokenModifier` is not in the provided legend");const At=this._tokenModifierStrToInt.get(Ct);St|=1<<At>>>0}this._pushEncoded(Ge,tt,at,ct,St)}_pushEncoded(B,re,ke,Ge,tt){if(this._dataIsSortedAndDeltaEncoded&&(B<this._prevLine||B===this._prevLine&&re<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const St=this._data.length/5|0;let Ct=0,At=0;for(let Tt=0;Tt<St;Tt++){let Ot=this._data[5*Tt],hn=this._data[5*Tt+1];Ot===0?(Ot=Ct,hn+=At):Ot+=Ct,this._data[5*Tt]=Ot,this._data[5*Tt+1]=hn,Ct=Ot,At=hn}}let at=B,ct=re;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(at-=this._prevLine,at===0&&(ct-=this._prevChar)),this._data[this._dataLen++]=at,this._data[this._dataLen++]=ct,this._data[this._dataLen++]=ke,this._data[this._dataLen++]=Ge,this._data[this._dataLen++]=tt,this._prevLine=B,this._prevChar=re}static _sortAndDeltaEncode(B){let re=[];const ke=B.length/5|0;for(let ct=0;ct<ke;ct++)re[ct]=ct;re.sort((ct,St)=>{const Ct=B[5*ct],At=B[5*St];if(Ct===At){const Tt=B[5*ct+1],Ot=B[5*St+1];return Tt-Ot}return Ct-At});const Ge=new Uint32Array(B.length);let tt=0,at=0;for(let ct=0;ct<ke;ct++){const St=5*re[ct],Ct=B[St+0],At=B[St+1],Tt=B[St+2],Ot=B[St+3],hn=B[St+4],Nn=Ct-tt,Hn=Nn===0?At-at:At,fn=5*ct;Ge[fn+0]=Nn,Ge[fn+1]=Hn,Ge[fn+2]=Tt,Ge[fn+3]=Ot,Ge[fn+4]=hn,tt=Ct,at=At}return Ge}build(B){return this._dataIsSortedAndDeltaEncoded?new rn(new Uint32Array(this._data),B):new rn(Yt._sortAndDeltaEncode(this._data),B)}}e.SemanticTokensBuilder=Yt;class rn{constructor(B,re){this.resultId=re,this.data=B}}e.SemanticTokens=rn;class gn{constructor(B,re,ke){this.start=B,this.deleteCount=re,this.data=ke}}e.SemanticTokensEdit=gn;class xt{constructor(B,re){this.resultId=re,this.edits=B}}e.SemanticTokensEdits=xt;var kn;(function(V){V[V.Separate=0]="Separate",V[V.MergeWithParent=1]="MergeWithParent"})(kn=e.DebugConsoleMode||(e.DebugConsoleMode={}));var sn;(function(V){V[V.Initial=1]="Initial",V[V.Dynamic=2]="Dynamic"})(sn=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));let Bt=class{constructor(){}};Bt.Back={iconPath:new wt("arrow-left")},Bt=Ve([a],Bt),e.QuickInputButtons=Bt;var Pn;(function(V){V[V.UI=1]="UI",V[V.Workspace=2]="Workspace"})(Pn=e.ExtensionKind||(e.ExtensionKind={}));class In{constructor(B,re,ke){this.badge=B,this.tooltip=re,this.color=ke}static validate(B){if(B.badge&&B.badge.length!==1&&B.badge.length!==2)throw new Error("The 'badge'-property must be undefined or a short character");if(!B.color&&!B.badge&&!B.tooltip)throw new Error("The decoration is empty")}}e.FileDecoration=In;let It=class{constructor(B){this.kind=B}};It=Ve([a],It),e.ColorTheme=It;var An;(function(V){V[V.Light=1]="Light",V[V.Dark=2]="Dark",V[V.HighContrast=3]="HighContrast"})(An=e.ColorThemeKind||(e.ColorThemeKind={}));class Ht{constructor(B,re){if(B<0)throw R.illegalArgument("start must be positive");if(re<0)throw R.illegalArgument("end must be positive");B<=re?(this._start=B,this._end=re):(this._start=re,this._end=B)}static isNotebookRange(B){return B instanceof Ht?!0:B?typeof B.start=="number"&&typeof B.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}with(B){let re=this._start,ke=this._end;return B.start!==void 0&&(re=B.start),B.end!==void 0&&(ke=B.end),re===this._start&&ke===this._end?this:new Ht(re,ke)}}e.NotebookRange=Ht;class Mt{constructor(B,re,ke,Ge,tt,at){this.kind=B,this.value=re,this.languageId=ke,this.outputs=Ge??[],this.metadata=tt,this.executionSummary=at,Mt.validate(this)}static validate(B){if(typeof B.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof B.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof B.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(B){return Array.isArray(B)&&B.every(re=>Mt.isNotebookCellData(re))}static isNotebookCellData(B){return!0}}e.NotebookCellData=Mt;class Tn{constructor(B){this.cells=B}}e.NotebookData=Tn;class kt{constructor(B,re){this.data=B,this.mime=re;const ke=A.normalizeMimeType(re,!0);if(!ke)throw new Error("INVALID mime type, must not be empty or falsy: "+re);this.mime=ke}static isNotebookCellOutputItem(B){return B instanceof kt?!0:B?typeof B.mime=="string"&&B.data instanceof Uint8Array:!1}static error(B){const re={name:B.name,message:B.message,stack:B.stack};return kt.json(re,"application/vnd.code.notebook.error")}static stdout(B){return kt.text(B,"application/vnd.code.notebook.stdout")}static stderr(B){return kt.text(B,"application/vnd.code.notebook.stderr")}static bytes(B,re="application/octet-stream"){return new kt(B,re)}static text(B,re=A.Mimes.text){const ke=Be(kt,h,"f",S).encode(String(B));return new kt(ke,re)}static json(B,re="application/json"){const ke=JSON.stringify(B,void 0,"	");return kt.text(ke,re)}}e.NotebookCellOutputItem=kt,h=kt,S={value:new TextEncoder};class zt{constructor(B,re,ke){this.items=zt.ensureUniqueMimeTypes(B,!0),typeof re=="string"?(this.id=re,this.metadata=ke):(this.id=C.generateUuid(),this.metadata=re??ke)}static isNotebookCellOutput(B){return B instanceof zt?!0:!B||typeof B!="object"?!1:typeof B.id=="string"&&P.isArray(B.items)}static ensureUniqueMimeTypes(B,re=!1){const ke=new Set,Ge=new Set;for(let tt=0;tt<B.length;tt++){const at=B[tt],ct=A.normalizeMimeType(at.mime);if(!ke.has(ct)){ke.add(ct);continue}Ge.add(tt),re&&console.warn(`DUPLICATED mime type '${at.mime}' will be dropped`)}return Ge.size===0?B:B.filter((tt,at)=>!Ge.has(at))}}e.NotebookCellOutput=zt;var pn;(function(V){V[V.Markup=1]="Markup",V[V.Code=2]="Code"})(pn=e.NotebookCellKind||(e.NotebookCellKind={}));var on;(function(V){V[V.Idle=1]="Idle",V[V.Pending=2]="Pending",V[V.Executing=3]="Executing"})(on=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var Oe;(function(V){V[V.Left=1]="Left",V[V.Right=2]="Right"})(Oe=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var an;(function(V){V[V.Default=0]="Default",V[V.InCenter=1]="InCenter",V[V.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",V[V.AtTop=3]="AtTop"})(an=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class vn{constructor(B,re){this.text=B,this.alignment=re}}e.NotebookCellStatusBarItem=vn;var ht;(function(V){V[V.Default=1]="Default",V[V.Preferred=2]="Preferred"})(ht=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));class Rn{constructor(B,re=[]){this.uri=B,this.provides=v.asArray(re)}}e.NotebookRendererScript=Rn;let ln=class{constructor(B,re){this.label=B,this.timestamp=re}};ln=Ve([a],ln),e.TimelineItem=ln;var wn;(function(V){V[V.Production=1]="Production",V[V.Development=2]="Development",V[V.Test=3]="Test"})(wn=e.ExtensionMode||(e.ExtensionMode={}));var bn;(function(V){V[V.Node=1]="Node",V[V.Webworker=2]="Webworker"})(bn=e.ExtensionRuntime||(e.ExtensionRuntime={}));var cn;(function(V){V[V.Other=0]="Other",V[V.Comment=1]="Comment",V[V.String=2]="String",V[V.RegEx=4]="RegEx"})(cn=e.StandardTokenType||(e.StandardTokenType={}));class Ln{constructor(B,re){this.ranges=B,this.wordPattern=re}}e.LinkedEditingRanges=Ln;class Fn{constructor(B,re){this._port=B,this._autoForwardAction=re}get port(){return this._port}get autoForwardAction(){return this._autoForwardAction}}e.PortAttributes=Fn;var Mn;(function(V){V[V.Unset=0]="Unset",V[V.Queued=1]="Queued",V[V.Running=2]="Running",V[V.Passed=3]="Passed",V[V.Failed=4]="Failed",V[V.Skipped=5]="Skipped",V[V.Errored=6]="Errored"})(Mn=e.TestResultState||(e.TestResultState={}));var un;(function(V){V[V.Error=0]="Error",V[V.Warning=1]="Warning",V[V.Information=2]="Information",V[V.Hint=3]="Hint"})(un=e.TestMessageSeverity||(e.TestMessageSeverity={}));var En;(function(V){V[V.Pending=0]="Pending",V[V.Resolved=1]="Resolved"})(En=e.TestItemStatus||(e.TestItemStatus={}));const $t=(V,B,re,ke)=>{let Ge=re;return{enumerable:!0,configurable:!1,get(){return Ge},set(tt){ke(Ge,tt)||(Ge=tt,V.bus.fire([3,B,tt]))}}},Vt=(V,B)=>V===B,On=(V,B)=>V===B?!0:!V||!B?!1:V.isEqual(B);class dn{constructor(B,re,ke,Ge){this.label=re,this.data=Ge;const tt=l.getPrivateApiFor(this);Object.defineProperties(this,{id:{value:B,enumerable:!0,writable:!1},uri:{value:ke,enumerable:!0,writable:!1},parent:{enumerable:!1,get:()=>tt.parent},children:{value:new D.ReadonlyMapView(tt.children),enumerable:!0,writable:!1},range:$t(tt,"range",void 0,On),description:$t(tt,"description",void 0,Vt),runnable:$t(tt,"runnable",!0,Vt),debuggable:$t(tt,"debuggable",!1,Vt),status:$t(tt,"status",En.Resolved,Vt),error:$t(tt,"error",void 0,Vt)})}invalidate(){l.getPrivateApiFor(this).bus.fire([2])}dispose(){const B=l.getPrivateApiFor(this);B.parent&&l.getPrivateApiFor(B.parent).children.delete(this.id),B.bus.fire([1])}addChild(B){if(!(B instanceof dn))throw new Error("Test child must be created through vscode.test.createTestItem()");const re=l.getPrivateApiFor(this);if(re.children.has(B.id))throw new Error(`Attempted to insert a duplicate test item ID ${B.id}`);re.children.set(B.id,B),re.bus.fire([0,B])}}e.TestItemImpl=dn;class te{constructor(B){this.message=B,this.severity=un.Error}static diff(B,re,ke){const Ge=new te(B);return Ge.expectedOutput=re,Ge.actualOutput=ke,Ge}}e.TestMessage=te;var fe;(function(V){V[V.None=0]="None",V[V.Option=1]="Option",V[V.Default=2]="Default",V[V.Preferred=3]="Preferred"})(fe=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var Ae;(function(V){V[V.Untrusted=0]="Untrusted",V[V.Trusted=1]="Trusted",V[V.Unspecified=2]="Unspecified"})(Ae=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var ot;(function(V){V[V.Notify=1]="Notify",V[V.OpenBrowser=2]="OpenBrowser",V[V.OpenPreview=3]="OpenPreview",V[V.Silent=4]="Silent",V[V.Ignore=5]="Ignore"})(ot=e.PortAutoForwardAction||(e.PortAutoForwardAction={}))}),define(ge[119],pe([0,1,50,10,8,144,108,7,18]),function(Q,e,v,R,k,D,A,P,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.getWordDefinitionFor=e.setWordDefinitionFor=void 0;const C=new Map;function s(c,h){h?C.set(c,h):C.delete(c)}e.setWordDefinitionFor=s;function I(c){return C.get(c)}e.getWordDefinitionFor=I;class l extends D.MirrorTextModel{constructor(h,S,w,b,u,d,p,t){super(S,w,b,u);this._proxy=h,this._languageId=d,this._isDirty=p,this._notebook=t,this._isDisposed=!1}dispose(){v.ok(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(h){return _.equals(this._lines,h)}get document(){if(!this._document){const h=this;this._document={get uri(){return h._uri},get fileName(){return h._uri.fsPath},get isUntitled(){return h._uri.scheme===R.Schemas.untitled},get languageId(){return h._languageId},get version(){return h._versionId},get isClosed(){return h._isDisposed},get isDirty(){return h._isDirty},get notebook(){return h._notebook},save(){return h._save()},getText(S){return S?h._getTextInRange(S):h.getText()},get eol(){return h._eol===`
`?P.EndOfLine.LF:P.EndOfLine.CRLF},get lineCount(){return h._lines.length},lineAt(S){return h._lineAt(S)},offsetAt(S){return h._offsetAt(S)},positionAt(S){return h._positionAt(S)},validateRange(S){return h._validateRange(S)},validatePosition(S){return h._validatePosition(S)},getWordRangeAtPosition(S,w){return h._getWordRangeAtPosition(S,w)}}}return Object.freeze(this._document)}_acceptLanguageId(h){v.ok(!this._isDisposed),this._languageId=h}_acceptIsDirty(h){v.ok(!this._isDisposed),this._isDirty=h}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(h){const S=this._validateRange(h);if(S.isEmpty)return"";if(S.isSingleLine)return this._lines[S.start.line].substring(S.start.character,S.end.character);const w=this._eol,b=S.start.line,u=S.end.line,d=[];d.push(this._lines[b].substring(S.start.character));for(let p=b+1;p<u;p++)d.push(this._lines[p]);return d.push(this._lines[u].substring(0,S.end.character)),d.join(w)}_lineAt(h){let S;if(h instanceof P.Position?S=h.line:typeof h=="number"&&(S=h),typeof S!="number"||S<0||S>=this._lines.length||Math.floor(S)!==S)throw new Error("Illegal value for `line`");return new m(S,this._lines[S],S===this._lines.length-1)}_offsetAt(h){return h=this._validatePosition(h),this._ensureLineStarts(),this._lineStarts.getAccumulatedValue(h.line-1)+h.character}_positionAt(h){h=Math.floor(h),h=Math.max(0,h),this._ensureLineStarts();const S=this._lineStarts.getIndexOf(h),w=this._lines[S.index].length;return new P.Position(S.index,Math.min(S.remainder,w))}_validateRange(h){if(!(h instanceof P.Range))throw new Error("Invalid argument");const S=this._validatePosition(h.start),w=this._validatePosition(h.end);return S===h.start&&w===h.end?h:new P.Range(S.line,S.character,w.line,w.character)}_validatePosition(h){if(!(h instanceof P.Position))throw new Error("Invalid argument");if(this._lines.length===0)return h.with(0,0);let{line:S,character:w}=h,b=!1;if(S<0)S=0,w=0,b=!0;else if(S>=this._lines.length)S=this._lines.length-1,w=this._lines[S].length,b=!0;else{const u=this._lines[S].length;w<0?(w=0,b=!0):w>u&&(w=u,b=!0)}return b?new P.Position(S,w):h}_getWordRangeAtPosition(h,S){const w=this._validatePosition(h);if(!S)S=I(this._languageId);else if(k.regExpLeadsToEndlessLoop(S))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${S.source}' because it matches the empty string.`);const b=A.getWordAtText(w.character+1,A.ensureValidWordDefinition(S),this._lines[w.line],0);if(b)return new P.Range(w.line,b.startColumn-1,w.line,b.endColumn-1)}}e.ExtHostDocumentData=l;class m{constructor(h,S,w){this._line=h,this._text=S,this._isLastLine=w}get lineNumber(){return this._line}get text(){return this._text}get range(){return new P.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new P.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=m}),define(ge[193],pe([0,1,7,3,110,6,76,23,2,32]),function(Q,e,v,R,k,D,A,P,_,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookConcatDocument=void 0;class s{constructor(l,m,c,h){this._notebook=c,this._selector=h,this._disposables=new D.DisposableStore,this._isClosed=!1,this._versionId=0,this._onDidChange=new R.Emitter,this.onDidChange=this._onDidChange.event,this.uri=_.URI.from({scheme:"vscode-concat-doc",path:C.generateUuid()}),this._init(),this._disposables.add(m.onDidChangeDocument(w=>{const b=this._cellUris.get(w.document.uri);b!==void 0&&(this._cellLengths.changeValue(b,this._cells[b].document.getText().length+1),this._cellLines.changeValue(b,this._cells[b].document.lineCount),this._versionId+=1,this._onDidChange.fire(void 0))}));const S=w=>{w===this._notebook&&(this._init(),this._versionId+=1,this._onDidChange.fire(void 0))};this._disposables.add(l.onDidChangeNotebookCells(w=>S(w.document)))}dispose(){this._disposables.dispose(),this._isClosed=!0}get isClosed(){return this._isClosed}_init(){this._cells=[],this._cellUris=new P.ResourceMap;const l=[],m=[];for(const c of this._notebook.getCells())c.kind===v.NotebookCellKind.Code&&(!this._selector||A.score(this._selector,c.document.uri,c.document.languageId,!0))&&(this._cellUris.set(c.document.uri,this._cells.length),this._cells.push(c),l.push(c.document.getText().length+1),m.push(c.document.lineCount));this._cellLengths=new k.PrefixSumComputer(new Uint32Array(l)),this._cellLines=new k.PrefixSumComputer(new Uint32Array(m))}get version(){return this._versionId}getText(l){var m,c;if(!l){let u="";for(const d of this._cells)u+=d.document.getText()+`
`;return u=u.slice(0,-1),u}if(l.isEmpty)return"";const h=this.locationAt(l.start),S=this.locationAt(l.end),w=this._cells[(m=this._cellUris.get(h.uri))!==null&&m!==void 0?m:-1],b=this._cells[(c=this._cellUris.get(S.uri))!==null&&c!==void 0?c:-1];if(!w||!b)return"";if(w===b)return w.document.getText(new v.Range(h.range.start,S.range.end));{const u=w.document.getText(new v.Range(h.range.start,new v.Position(w.document.lineCount,0))),d=b.document.getText(new v.Range(new v.Position(0,0),S.range.end));return u+`
`+d}}offsetAt(l){const m=this._cellLines.getIndexOf(l.line),c=this._cellLengths.getAccumulatedValue(m.index-1),h=this._cells[m.index].document.offsetAt(l.with(m.remainder));return c+h}positionAt(l){if(typeof l=="number"){const c=this._cellLengths.getIndexOf(l),h=this._cellLines.getAccumulatedValue(c.index-1);return this._cells[c.index].document.positionAt(c.remainder).translate(h)}const m=this._cellUris.get(l.uri);if(m!==void 0){const c=this._cellLines.getAccumulatedValue(m-1);return new v.Position(c+l.range.start.line,l.range.start.character)}return new v.Position(0,0)}locationAt(l){v.Range.isRange(l)||(l=new v.Range(l,l));const m=this._cellLines.getIndexOf(l.start.line);let c=m;l.isEmpty||(c=this._cellLines.getIndexOf(l.end.line));const h=new v.Position(m.remainder,l.start.character),S=new v.Position(c.remainder,l.end.character),w=new v.Range(h,S),b=this._cells[m.index];return new v.Location(b.document.uri,b.document.validateRange(w))}contains(l){return this._cellUris.has(l)}validateRange(l){const m=this.validatePosition(l.start),c=this.validatePosition(l.end);return l.with(m,c)}validatePosition(l){const m=this._cellLines.getIndexOf(l.line),c=new v.Position(m.remainder,l.character),h=this._cells[m.index].document.validatePosition(c),S=this._cellLines.getAccumulatedValue(m.index-1);return new v.Position(S+h.line,h.character)}}e.ExtHostNotebookConcatDocument=s}),define(ge[194],pe([0,1,7,13,3]),function(Q,e,v,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let D=class{constructor(P){this._actual=new v.ColorTheme(v.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new k.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(P){let _=P==="light"?v.ColorThemeKind.Light:P==="dark"?v.ColorThemeKind.Dark:v.ColorThemeKind.HighContrast;this._actual=new v.ColorTheme(_),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};D=Ve([$e(0,R.IExtHostRpcService)],D),e.ExtHostTheming=D}),define(ge[59],pe([0,1,4]),function(Q,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=v.createDecorator("IURITransformerService");class R{constructor(D){D?(this.transformIncoming=D.transformIncoming.bind(D),this.transformOutgoing=D.transformOutgoing.bind(D),this.transformOutgoingURI=D.transformOutgoingURI.bind(D),this.transformOutgoingScheme=D.transformOutgoingScheme.bind(D)):(this.transformIncoming=A=>A,this.transformOutgoing=A=>A,this.transformOutgoingURI=A=>A,this.transformOutgoingScheme=A=>A)}}e.URITransformerService=R}),define(ge[195],pe([0,1,22]),function(Q,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class R{constructor(){this.buffers=[]}add(_){let C=this.buffers.indexOf(_);return C<0&&(C=this.buffers.length,this.buffers.push(_)),C}}function k(P,_){if(_.serializeBuffersForPostMessage){const C=new R,s=(m,c)=>{if(c instanceof ArrayBuffer){const h=C.add(c);return{$$vscode_array_buffer_reference$$:!0,index:h}}else if(ArrayBuffer.isView(c)){const h=D(c);if(h){const S=C.add(c.buffer);return{$$vscode_array_buffer_reference$$:!0,index:S,view:{type:h,byteLength:c.byteLength,byteOffset:c.byteOffset}}}}return c},I=JSON.stringify(P,s),l=C.buffers.map(m=>{const c=new Uint8Array(m);return v.VSBuffer.wrap(c)});return{message:I,buffers:l}}else return{message:JSON.stringify(P),buffers:[]}}e.serializeWebviewMessage=k;function D(P){switch(P.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function A(P,_){const C=_.map(l=>{const m=new ArrayBuffer(l.byteLength);return new Uint8Array(m).set(l.buffer),m}),s=_.length?(l,m)=>{if(typeof m=="object"&&m.$$vscode_array_buffer_reference$$){const c=m,{index:h}=c,S=C[h];if(c.view)switch(c.view.type){case 1:return new Int8Array(S,c.view.byteOffset,c.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(S,c.view.byteOffset,c.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(S,c.view.byteOffset,c.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(S,c.view.byteOffset,c.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(S,c.view.byteOffset,c.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(S,c.view.byteOffset,c.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(S,c.view.byteOffset,c.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(S,c.view.byteOffset,c.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(S,c.view.byteOffset,c.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(S,c.view.byteOffset,c.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(S,c.view.byteOffset,c.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return S}return m}:void 0;return{message:JSON.parse(P,s),arrayBuffers:C}}e.deserializeWebviewMessage=A}),define(ge[85],pe([0,1,10,2]),function(Q,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-webview.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`https://*.${e.webviewResourceBaseHost}`;function k(D,A){return D.scheme===v.Schemas.http||D.scheme===v.Schemas.https?D:(A&&A.authority&&A.isRemote&&D.scheme===v.Schemas.file&&(D=R.URI.from({scheme:v.Schemas.vscodeRemote,authority:A.authority,path:D.path})),R.URI.from({scheme:v.Schemas.https,authority:`${D.scheme}+${D.authority}.${e.webviewRootResourceAuthority}`,path:D.path,fragment:D.fragment,query:D.query}))}e.asWebviewUri=k}),define(ge[196],pe([0,1,3,6,85]),function(Q,e,v,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class D{constructor(P,_,C){this._proxy=P,this._editors=_,this._initData=C,this._handlePool=0,this._disposables=new R.DisposableStore,this._insets=new Map,this._disposables.add(_.onDidChangeVisibleTextEditors(()=>{const s=_.getVisibleTextEditors();for(const I of this._insets.values())s.indexOf(I.editor)<0&&I.inset.dispose()}))}dispose(){this._insets.forEach(P=>P.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(P,_,C,s,I){let l;for(const u of this._editors.getVisibleTextEditors(!0))if(u.value===P){l=u;break}if(!l)throw new Error("not a visible editor");const m=this,c=this._handlePool++,h=new v.Emitter,S=new v.Emitter,w=new class{constructor(){this._html="",this._options=Object.create(null)}asWebviewUri(u){return k.asWebviewUri(u,m._initData.remote)}get cspSource(){return k.webviewGenericCspSource}set options(u){this._options=u,m._proxy.$setOptions(c,u)}get options(){return this._options}set html(u){this._html=u,m._proxy.$setHtml(c,u)}get html(){return this._html}get onDidReceiveMessage(){return h.event}postMessage(u){return m._proxy.$postMessage(c,u)}},b=new class{constructor(){this.editor=P,this.line=_,this.height=C,this.webview=w,this.onDidDispose=S.event}dispose(){m._insets.has(c)&&(m._insets.delete(c),m._proxy.$disposeEditorInset(c),S.fire(),S.dispose(),h.dispose())}};return this._proxy.$createEditorInset(c,l.id,l.value.document.uri,_+1,C,s||{},I.identifier,I.extensionLocation),this._insets.set(c,{editor:P,inset:b,onDidReceiveMessage:h}),b}$onDidDispose(P){const _=this._insets.get(P);_&&_.inset.dispose()}$onDidReceiveMessage(P,_){const C=this._insets.get(P);C&&C.onDidReceiveMessage.fire(_)}}e.ExtHostEditorInsets=D}),define(ge[120],pe([0,1,3,16,166]),function(Q,e,v,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class D{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new v.Emitter,this._onExit=new v.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(P){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=P}onEvent(P){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=P}onRequest(P){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=P}sendResponse(P){P.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${P.command}`)):this.internalSend("response",P)}sendRequest(P,_,C,s){const I={command:P};if(_&&Object.keys(_).length>0&&(I.arguments=_),this.internalSend("request",I),typeof s=="number"){const l=setTimeout(()=>{clearTimeout(l);const m=this.pendingRequests.get(I.seq);if(m){this.pendingRequests.delete(I.seq);const c={type:"response",seq:0,request_seq:I.seq,success:!1,command:P,message:k.localize(0,null,s,P)};m(c)}},s)}return C&&this.pendingRequests.set(I.seq,C),I.seq}acceptMessage(P){this.messageCallback?this.messageCallback(P):(this.queue.push(P),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(P,_){return P.type!=="event"||_.type!=="event"}async processQueue(){let P;for(;this.queue.length;){if((!P||this.needsTaskBoundaryBetween(this.queue[0],P))&&await R.timeout(0),P=this.queue.shift(),!P)return;switch(P.type){case"event":this.eventCallback&&this.eventCallback(P);break;case"request":this.requestCallback&&this.requestCallback(P);break;case"response":const _=P,C=this.pendingRequests.get(_.request_seq);C&&(this.pendingRequests.delete(_.request_seq),C(_));break}}}internalSend(P,_){_.type=P,_.seq=this.sequence++,this.sendMessage(_)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const P=new Map;this.pendingRequests.forEach((_,C)=>P.set(C,_)),await R.timeout(500),P.forEach((_,C)=>{_({type:"response",seq:0,request_seq:C,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(C)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=D}),define(ge[197],pe([0,1,8,2,9,25,10]),function(Q,e,v,R,k,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const P=/{([^}]+)}/g;function _(i,r,n){return i.replace(P,function(o,g){return r&&g.length>0&&g[0]!=="_"?o:n&&n.hasOwnProperty(g)?n[g]:o})}e.formatPII=_;function C(i){const r={};for(const n of Object.keys(i))n.startsWith("!")||(r[n]=i[n]);return r}e.filterExceptionsFromTelemetry=C;function s(i){return i.configuration.request==="attach"&&!I(i)&&(!i.parentSession||s(i.parentSession))}e.isSessionAttach=s;function I(i){let r=i.configuration.type;if(!!r)return r==="vslsShare"&&(r=i.configuration.adapterProxy.configuration.type),v.equalsIgnoreCase(r,"extensionhost")||v.equalsIgnoreCase(r,"pwa-extensionhost")?i:i.parentSession?I(i.parentSession):void 0}e.getExtensionHostDebugSession=I;function l(i){return i.type&&(i.label||i.program||i.runtime)}e.isDebuggerMainContribution=l;function m(i,r,n){let o,g=0,f=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g,E=null;for(;E=f.exec(i);){let y=E.index+1,a=y+E[0].length;if(y<=r&&a>=n){o=E[0],g=y;break}}if(o){let y=/\w+/g,a=null;for(;(a=y.exec(o))&&!(a.index+1+g+a[0].length>=n););a&&(o=o.substring(0,y.lastIndex))}return o?{start:g,end:g+o.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=m;const c=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function h(i){return!!(i&&i.match(c))}e.isUri=h;function S(i){if(typeof i.path=="string"&&!(typeof i.sourceReference=="number"&&i.sourceReference>0)){if(h(i.path))return R.URI.parse(i.path);if(k.isAbsolute(i.path))return R.URI.file(i.path)}return i.path}function w(i){if(typeof i.path=="object"){const r=R.URI.revive(i.path);if(r)return r.scheme===A.Schemas.file?r.fsPath:r.toString()}return i.path}function b(i,r){const n=r?S:w,o=D.deepClone(i);return d(o,(g,f)=>{g&&f&&(f.path=n(f))}),o}e.convertToDAPaths=b;function u(i,r){const n=r?S:w,o=D.deepClone(i);return d(o,(g,f)=>{!g&&f&&(f.path=n(f))}),o}e.convertToVSCPaths=u;function d(i,r){switch(i.type){case"event":const n=i;switch(n.event){case"output":r(!1,n.body.source);break;case"loadedSource":r(!1,n.body.source);break;case"breakpoint":r(!1,n.body.breakpoint.source);break;default:break}break;case"request":const o=i;switch(o.command){case"setBreakpoints":r(!0,o.arguments.source);break;case"breakpointLocations":r(!0,o.arguments.source);break;case"source":r(!0,o.arguments.source);break;case"gotoTargets":r(!0,o.arguments.source);break;case"launchVSCode":o.arguments.args.forEach(f=>r(!1,f));break;default:break}break;case"response":const g=i;if(g.success&&g.body)switch(g.command){case"stackTrace":g.body.stackFrames.forEach(f=>r(!1,f.source));break;case"loadedSources":g.body.sources.forEach(f=>r(!1,f));break;case"scopes":g.body.scopes.forEach(f=>r(!1,f.source));break;case"setFunctionBreakpoints":g.body.breakpoints.forEach(f=>r(!1,f.source));break;case"setBreakpoints":g.body.breakpoints.forEach(f=>r(!1,f.source));break;default:break}break}}function p(i){return i.filter(r=>{var n;return!((n=r.presentation)===null||n===void 0?void 0:n.hidden)}).sort((r,n)=>r.presentation?n.presentation?r.presentation.group?n.presentation.group?r.presentation.group!==n.presentation.group?r.presentation.group.localeCompare(n.presentation.group):t(r.presentation.order,n.presentation.order):-1:n.presentation.group?1:t(r.presentation.order,n.presentation.order):-1:n.presentation?1:0)}e.getVisibleAndSorted=p;function t(i,r){return typeof i!="number"?typeof r!="number"?0:1:typeof r!="number"?-1:i-r}}),define(ge[198],pe([0,1,28,38,167,121,9,8,25,11,177,120]),function(Q,e,v,R,k,D,A,P,_,C,s,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExecutableDebugAdapter=e.NamedPipeDebugAdapter=e.SocketDebugAdapter=e.NetworkDebugAdapter=e.StreamDebugAdapter=void 0;class l extends I.AbstractDebugAdapter{constructor(){super();this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1}connect(b,u){this.outputStream=u,this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1,b.on("data",d=>this.handleData(d))}sendMessage(b){if(this.outputStream){const u=JSON.stringify(b);this.outputStream.write(`Content-Length: ${Buffer.byteLength(u,"utf8")}${l.TWO_CRLF}${u}`,"utf8")}}handleData(b){for(this.rawData=Buffer.concat([this.rawData,b]);;){if(this.contentLength>=0){if(this.rawData.length>=this.contentLength){const u=this.rawData.toString("utf8",0,this.contentLength);if(this.rawData=this.rawData.slice(this.contentLength),this.contentLength=-1,u.length>0)try{this.acceptMessage(JSON.parse(u))}catch(d){this._onError.fire(new Error((d.message||d)+`
`+u))}continue}}else{const u=this.rawData.indexOf(l.TWO_CRLF);if(u!==-1){const p=this.rawData.toString("utf8",0,u).split(l.HEADER_LINESEPARATOR);for(const t of p){const i=t.split(l.HEADER_FIELDSEPARATOR);i[0]==="Content-Length"&&(this.contentLength=Number(i[1]))}this.rawData=this.rawData.slice(u+l.TWO_CRLF.length);continue}}break}}}e.StreamDebugAdapter=l,l.TWO_CRLF=`\r
\r
`,l.HEADER_LINESEPARATOR=/\r?\n/,l.HEADER_FIELDSEPARATOR=/: */;class m extends l{startSession(){return new Promise((b,u)=>{let d=!1;this.socket=this.createConnection(()=>{this.connect(this.socket,this.socket),b(),d=!0}),this.socket.on("close",()=>{d?this._onError.fire(new Error("connection closed")):u(new Error("connection closed"))}),this.socket.on("error",p=>{d?this._onError.fire(p):u(p)})})}async stopSession(){await this.cancelPendingRequests(),this.socket&&(this.socket.end(),this.socket=void 0)}}e.NetworkDebugAdapter=m;class c extends m{constructor(b){super();this.adapterServer=b}createConnection(b){return D.createConnection(this.adapterServer.port,this.adapterServer.host||"127.0.0.1",b)}}e.SocketDebugAdapter=c;class h extends m{constructor(b){super();this.adapterServer=b}createConnection(b){return D.createConnection(this.adapterServer.path,b)}}e.NamedPipeDebugAdapter=h;class S extends l{constructor(b,u,d){super();this.adapterExecutable=b,this.debugType=u,this.outputService=d}async startSession(){const b=this.adapterExecutable.command,u=this.adapterExecutable.args,d=this.adapterExecutable.options||{};try{if(b)if(A.isAbsolute(b)){if(!await v.Promises.exists(b))throw new Error(k.localize(0,null,b))}else b.indexOf("/")<0&&b.indexOf("\\")<0;else throw new Error(k.localize(1,null,this.debugType));let p=process.env;if(d.env&&Object.keys(d.env).length>0&&(p=_.mixin(_.deepClone(process.env),d.env)),b==="node")if(Array.isArray(u)&&u.length>0){const i=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,r={env:p,execArgv:i?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};d.cwd&&(r.cwd=d.cwd);const n=R.fork(u[0],u.slice(1),r);if(!n.pid)throw new Error(k.localize(2,null,u[0]));this.serverProcess=n}else throw new Error(k.localize(3,null));else{const i={env:p};d.cwd&&(i.cwd=d.cwd),this.serverProcess=R.spawn(b,u,i)}this.serverProcess.on("error",i=>{this._onError.fire(i)}),this.serverProcess.on("exit",(i,r)=>{this._onExit.fire(i)}),this.serverProcess.stdout.on("close",()=>{this._onError.fire(new Error("read error"))}),this.serverProcess.stdout.on("error",i=>{this._onError.fire(i)}),this.serverProcess.stdin.on("error",i=>{this._onError.fire(i)});const t=this.outputService;if(t){const i=r=>r.toString().replace(/\r?\n$/mg,"");this.serverProcess.stderr.on("data",r=>{const n=t.getChannel(s.ExtensionsChannelId);n&&n.append(i(r))})}else this.serverProcess.stderr.resume();this.connect(this.serverProcess.stdout,this.serverProcess.stdin)}catch(p){this._onError.fire(p)}}async stopSession(){return this.serverProcess?(await this.cancelPendingRequests(),C.isWindows?new Promise((b,u)=>{const d=R.exec(`taskkill /F /T /PID ${this.serverProcess.pid}`,function(p,t,i){if(p)return u(p)});d.on("exit",b),d.on("error",u)}):(this.serverProcess.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static extract(b,u){if(!b)return;const d=Object.create(null);b.runtime&&(b.runtime.indexOf("./")===0?d.runtime=A.join(u,b.runtime):d.runtime=b.runtime),b.runtimeArgs&&(d.runtimeArgs=b.runtimeArgs),b.program&&(A.isAbsolute(b.program)?d.program=b.program:d.program=A.join(u,b.program)),b.args&&(d.args=b.args);const p=b;return p.win&&(d.win=S.extract(p.win,u)),p.winx86&&(d.winx86=S.extract(p.winx86,u)),p.windows&&(d.windows=S.extract(p.windows,u)),p.osx&&(d.osx=S.extract(p.osx,u)),p.linux&&(d.linux=S.extract(p.linux,u)),d}static platformAdapterExecutable(b,u){let d=Object.create(null);u=u.toLowerCase();for(const o of b)if(o.contributes){const g=o.contributes.debuggers;g&&g.length>0&&g.filter(f=>typeof f.type=="string"&&P.equalsIgnoreCase(f.type,u)).forEach(f=>{const E=S.extract(f,o.extensionLocation.fsPath);d=_.mixin(d,E,o.isBuiltin)})}let p;C.isWindows&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?p=d.winx86||d.win||d.windows:C.isWindows?p=d.win||d.windows:C.isMacintosh?p=d.osx:C.isLinux&&(p=d.linux),p=p||d;let t=p.program||d.program;const i=p.args||d.args;let r=p.runtime||d.runtime;const n=p.runtimeArgs||d.runtimeArgs;if(r)return{type:"executable",command:r,args:(n||[]).concat(typeof t=="string"?[t]:[]).concat(i||[])};if(t)return{type:"executable",command:t,args:i||[]}}}e.ExecutableDebugAdapter=S}),define(ge[199],pe([0,1,38,11,29,186]),function(Q,e,v,R,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prepareCommand=e.hasChildProcesses=e.runInExternalTerminal=void 0;function A(l,m){return new Promise((c,h)=>{let S="";const w=v.spawn(l,m);w.pid&&w.stdout.on("data",b=>{S+=b.toString()}),w.on("error",b=>{h(b)}),w.on("close",b=>{c(S)})})}let P;function _(l,m){if(!P)if(R.isWindows)P=new D.WindowsExternalTerminalService(void 0);else if(R.isMacintosh)P=new D.MacExternalTerminalService(void 0);else if(R.isLinux)P=new D.LinuxExternalTerminalService(void 0);else throw new Error("external terminals not supported on this platform");const c=m.getConfiguration("terminal");return P.runInTerminal(l.title,l.cwd,l.args,l.env||{},c.external||{})}e.runInExternalTerminal=_;function C(l){return l?R.isWindows?new Promise(async m=>{(await new Promise((h,S)=>{Q(["windows-process-tree"],h,S)})).getProcessTree(l,h=>{m(h.children.length>0)})}):A("/usr/bin/pgrep",["-lP",String(l)]).then(m=>{const c=m.trim();return!(c.length===0||c.indexOf(" tmux")>=0)},m=>!0):Promise.resolve(!0)}e.hasChildProcesses=C;var s;(function(l){l[l.cmd=0]="cmd",l[l.powershell=1]="powershell",l[l.bash=2]="bash"})(s||(s={}));function I(l,m,c,h){l=l.trim().toLowerCase();let S;l.indexOf("powershell")>=0||l.indexOf("pwsh")>=0?S=1:l.indexOf("cmd.exe")>=0?S=0:l.indexOf("bash")>=0?S=2:R.isWindows?S=0:S=2;let w,b=" ";switch(S){case 1:if(w=d=>(d=d.replace(/\'/g,"''"),d.length>0&&d.charAt(d.length-1)==="\\"?`'${d}\\'`:`'${d}'`),c){const d=k.getDriveLetter(c);d&&(b+=`${d}:; `),b+=`cd ${w(c)}; `}if(h)for(let d in h){const p=h[d];p===null?b+=`Remove-Item env:${d}; `:b+=`\${env:${d}}='${p}'; `}if(m.length>0){const d=w(m.shift());b+=d[0]==="'"?`& ${d} `:`${d} `;for(let p of m)b+=`${w(p)} `}break;case 0:if(w=d=>(d=d.replace(/\"/g,'""'),d.indexOf(" ")>=0||d.indexOf('"')>=0||d.length===0?`"${d}"`:d),c){const d=k.getDriveLetter(c);d&&(b+=`${d}: && `),b+=`cd ${w(c)} && `}if(h){b+='cmd /C "';for(let d in h){let p=h[d];p===null?b+=`set "${d}=" && `:(p=p.replace(/[\^\&\|\<\>]/g,t=>`^${t}`),b+=`set "${d}=${p}" && `)}}for(let d of m)b+=`${w(d)} `;h&&(b+='"');break;case 2:w=d=>(d=d.replace(/(["'\\\$])/g,"\\$1"),d.indexOf(" ")>=0||d.indexOf(";")>=0||d.length===0?`"${d}"`:d);const u=d=>/[^\w@%\/+=,.:^-]/.test(d)?`'${d.replace(/'/g,"'\\''")}'`:d;if(c&&(b+=`cd ${w(c)} ; `),h){b+="/usr/bin/env";for(let d in h){const p=h[d];p===null?b+=` -u ${u(d)}`:b+=` ${u(`${d}=${p}`)}`}b+=" "}for(let d of m)b+=`${w(d)} `;break}return b}e.prepareCommand=I}),define(ge[86],pe([0,1,30,99,10,9,11,113]),function(Q,e,v,R,k,D,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.OpenGettingStarted=e.ConsolidatedRunButton=e.NotebookCellEditorOptionsCustomizations=e.DragAndDropEnabled=e.ShowFoldingControls=e.ConsolidatedOutputButton=e.UndoRedoPerCell=e.GlobalToolbar=e.InsertToolbarLocation=e.FocusIndicator=e.CompactView=e.ExperimentalInsertToolbarAlignment=e.ExperimentalUseMarkdownRenderer=e.NotebookTextDiffEditorPreview=e.ShowCellStatusBar=e.CellToolbarVisibility=e.CellToolbarLocation=e.DisplayOrderKey=e.CellSequence=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.sortMimeTypes=e.mimeTypeIsMergeable=e.mimeTypeSupportedByCore=e.mimeTypeIsAlwaysSecure=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.BUILTIN_RENDERER_ID=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=void 0;var _;(function(a){a[a.Markup=1]="Markup",a[a.Code=2]="Code"})(_=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",R.Mimes.markdown,"image/png","image/jpeg",R.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[R.Mimes.markdown,"application/json",R.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.BUILTIN_RENDERER_ID="_builtin",e.RENDERER_NOT_AVAILABLE="_notAvailable";var C;(function(a){a[a.Running=1]="Running",a[a.Idle=2]="Idle"})(C=e.NotebookRunState||(e.NotebookRunState={}));var s;(function(a){a[a.Pending=2]="Pending",a[a.Executing=3]="Executing"})(s=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var I;(function(a){a[a.WithHardKernelDependency=0]="WithHardKernelDependency",a[a.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",a[a.Pure=2]="Pure",a[a.Never=3]="Never"})(I=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var l;(function(a){a.Always="always",a.Never="never",a.Optional="optional"})(l=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var m;(function(a){a[a.ModelChange=1]="ModelChange",a[a.Move=2]="Move",a[a.ChangeLanguage=5]="ChangeLanguage",a[a.Initialize=6]="Initialize",a[a.ChangeCellMetadata=7]="ChangeCellMetadata",a[a.Output=8]="Output",a[a.OutputItem=9]="OutputItem",a[a.ChangeCellContent=10]="ChangeCellContent",a[a.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",a[a.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",a[a.Unknown=100]="Unknown"})(m=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var c;(function(a){a[a.Handle=0]="Handle",a[a.Index=1]="Index"})(c=e.SelectionStateType||(e.SelectionStateType={}));var h;(function(a){a[a.Replace=1]="Replace",a[a.Output=2]="Output",a[a.Metadata=3]="Metadata",a[a.CellLanguage=4]="CellLanguage",a[a.DocumentMetadata=5]="DocumentMetadata",a[a.Move=6]="Move",a[a.OutputItems=7]="OutputItems",a[a.PartialMetadata=8]="PartialMetadata",a[a.PartialInternalMetadata=9]="PartialInternalMetadata"})(h=e.CellEditType||(e.CellEditType={}));var S;(function(a){a.scheme=k.Schemas.vscodeNotebookCell;const L=/^ch(\d{7,})/;function O(N,H){return N.with({scheme:a.scheme,fragment:`ch${H.toString().padStart(7,"0")}${N.scheme!==k.Schemas.file?N.scheme:""}`})}a.generate=O;function W(N){if(N.scheme!==a.scheme)return;const H=L.exec(N.fragment);return H?{handle:Number(H[1]),notebook:N.with({scheme:N.fragment.substr(H[0].length)||k.Schemas.file,fragment:null})}:void 0}a.parse=W;function J(N){if(N.scheme!==k.Schemas.vscodeNotebookCellMetadata)return;const H=L.exec(N.fragment);return H?{handle:Number(H[1]),notebook:N.with({scheme:N.fragment.substr(H[0].length)||k.Schemas.file,fragment:null})}:void 0}a.parseCellMetadataUri=J;function se(N,H,T){return N.with({scheme:T,fragment:`ch${H.toString().padStart(7,"0")}${N.scheme!==k.Schemas.file?N.scheme:""}`})}a.generateCellUri=se;function q(N,H){if(N.scheme!==H)return;const T=L.exec(N.fragment);return T?{handle:Number(T[1]),notebook:N.with({scheme:N.fragment.substr(T[0].length)||k.Schemas.file,fragment:null})}:void 0}a.parseCellUri=q})(S=e.CellUri||(e.CellUri={}));const w=new Map([["application/javascript",{supportedByCore:!0}],["image/png",{alwaysSecure:!0,supportedByCore:!0}],["image/jpeg",{alwaysSecure:!0,supportedByCore:!0}],["image/git",{alwaysSecure:!0,supportedByCore:!0}],["image/svg+xml",{supportedByCore:!0}],["application/json",{alwaysSecure:!0,supportedByCore:!0}],[R.Mimes.markdown,{alwaysSecure:!0,supportedByCore:!0}],[R.Mimes.text,{alwaysSecure:!0,supportedByCore:!0}],["text/html",{supportedByCore:!0}],["text/x-javascript",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.error",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.stdout",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/vnd.code.notebook.stderr",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}]]);function b(a){var L,O;return(O=(L=w.get(a))===null||L===void 0?void 0:L.alwaysSecure)!==null&&O!==void 0?O:!1}e.mimeTypeIsAlwaysSecure=b;function u(a){var L,O;return(O=(L=w.get(a))===null||L===void 0?void 0:L.supportedByCore)!==null&&O!==void 0?O:!1}e.mimeTypeSupportedByCore=u;function d(a){var L,O;return(O=(L=w.get(a))===null||L===void 0?void 0:L.mergeable)!==null&&O!==void 0?O:!1}e.mimeTypeIsMergeable=d;function p(a,L){return A.isWindows&&(a=a.replace(/\//g,"\\"),L=L.replace(/\//g,"\\")),v.match(a,L)}function t(a,L,O){let W=0;for(let J=0;J<L.length;J++){if(p(L[J],a))return W;W++}for(let J=0;J<O.length;J++){if(p(O[J],a))return W;W++}return W}function i(a,L,O){return a.sort((W,J)=>t(W,L,O)-t(J,L,O))}e.sortMimeTypes=i;function r(a,L,O,W=(J,se)=>J===se){const J=[];function se(H,T,U){if(T===0&&U.length===0)return;const F=J[J.length-1];F&&F.start+F.deleteCount===H?(F.deleteCount+=T,F.toInsert.push(...U)):J.push({start:H,deleteCount:T,toInsert:U})}let q=0,N=0;for(;;){if(q===a.length){se(q,0,L.slice(N));break}if(N===L.length){se(q,a.length-q,[]);break}const H=a[q],T=L[N];if(W(H,T)){q+=1,N+=1;continue}O(T)?(se(q,1,[]),q+=1):(se(q,0,[T]),N+=1)}return J}e.diff=r,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new P.RawContextKey("notebookEditorCursorAtBoundary","none");var n;(function(a){a.default="default",a.option="option"})(n=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function o(a){const L=a;return!!((typeof L.include=="string"||v.isRelativePattern(L.include))&&(typeof L.exclude=="string"||v.isRelativePattern(L.exclude)))}e.isDocumentExcludePattern=o;function g(a,L,O){if(Array.isArray(a.viewType)&&a.viewType.indexOf(L)>=0||a.viewType===L)return!0;if(a.filenamePattern){let W=o(a.filenamePattern)?a.filenamePattern.include:a.filenamePattern,J=o(a.filenamePattern)?a.filenamePattern.exclude:void 0;if(v.match(W,D.basename(O.fsPath).toLowerCase()))return!(J&&v.match(J,D.basename(O.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=g;class f{constructor(L){this.textModel=L}getElements(){const L=new Int32Array(this.textModel.cells.length);for(let O=0;O<this.textModel.cells.length;O++)L[O]=this.textModel.cells[O].getHashValue();return L}}e.CellSequence=f,e.DisplayOrderKey="notebook.displayOrder",e.CellToolbarLocation="notebook.cellToolbarLocation",e.CellToolbarVisibility="notebook.cellToolbarVisibility",e.ShowCellStatusBar="notebook.showCellStatusBar",e.NotebookTextDiffEditorPreview="notebook.diff.enablePreview",e.ExperimentalUseMarkdownRenderer="notebook.experimental.useMarkdownRenderer",e.ExperimentalInsertToolbarAlignment="notebook.experimental.insertToolbarAlignment",e.CompactView="notebook.compactView",e.FocusIndicator="notebook.cellFocusIndicator",e.InsertToolbarLocation="notebook.insertToolbarLocation",e.GlobalToolbar="notebook.globalToolbar",e.UndoRedoPerCell="notebook.undoRedoPerCell",e.ConsolidatedOutputButton="notebook.consolidatedOutputButton",e.ShowFoldingControls="notebook.showFoldingControls",e.DragAndDropEnabled="notebook.dragAndDropEnabled",e.NotebookCellEditorOptionsCustomizations="notebook.editorOptionsCustomizations",e.ConsolidatedRunButton="notebook.consolidatedRunButton",e.OpenGettingStarted="notebook.experimental.openGettingStarted";var E;(function(a){a[a.Left=1]="Left",a[a.Right=2]="Right"})(E=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class y{static create(L){return`${y._prefix}${L}`}static parse(L){if(L.startsWith(y._prefix))return L.substr(y._prefix.length)}}e.NotebookWorkingCopyTypeIdentifier=y,y._prefix="notebook/"}),define(ge[200],pe([0,1,169,4,113]),function(Q,e,v,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USER_TASKS_GROUP_KEY=e.ITaskService=e.ProcessExecutionSupportedContext=e.ShellExecutionSupportedContext=e.CustomExecutionSupportedContext=void 0,e.CustomExecutionSupportedContext=new k.RawContextKey("customExecutionSupported",!0,v.localize(0,null)),e.ShellExecutionSupportedContext=new k.RawContextKey("shellExecutionSupported",!1,v.localize(1,null)),e.ProcessExecutionSupportedContext=new k.RawContextKey("processExecutionSupported",!1,v.localize(2,null)),e.ITaskService=R.createDecorator("taskService"),e.USER_TASKS_GROUP_KEY="settings"}),define(ge[201],pe([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function v(k){return[...k.entries()]}e.serializeEnvironmentVariableCollection=v;function R(k){return new Map(k)}e.deserializeEnvironmentVariableCollection=R}),define(ge[122],pe([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.IncrementalChangeCollector=e.getTestSubscriptionKey=e.TestDiffOpType=e.applyTestItemUpdate=e.TestItemExpandState=void 0;var v;(function(_){_[_.NotExpandable=0]="NotExpandable",_[_.Expandable=1]="Expandable",_[_.BusyExpanding=2]="BusyExpanding",_[_.Expanded=3]="Expanded"})(v=e.TestItemExpandState||(e.TestItemExpandState={}));const R=(_,C)=>{C.expand!==void 0&&(_.expand=C.expand),C.item!==void 0&&(_.item=_.item?Object.assign(_.item,C.item):C.item)};e.applyTestItemUpdate=R;var k;(function(_){_[_.Add=0]="Add",_[_.Update=1]="Update",_[_.Remove=2]="Remove",_[_.IncrementPendingExtHosts=3]="IncrementPendingExtHosts",_[_.Retire=4]="Retire"})(k=e.TestDiffOpType||(e.TestDiffOpType={}));const D=(_,C)=>`${_}:${C.toString()}`;e.getTestSubscriptionKey=D;class A{add(C){}update(C){}remove(C,s){}complete(){}}e.IncrementalChangeCollector=A;class P{constructor(){this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0}apply(C){const s=this.createChangeCollector();for(const I of C)switch(I[0]){case 0:{const l=I[1];if(l.parent){if(this.items.has(l.parent)){const m=this.items.get(l.parent);m.children.add(l.item.extId);const c=this.createItem(l,m);this.items.set(l.item.extId,c),s.add(c)}}else{this.roots.add(l.item.extId);const m=this.createItem(l);this.items.set(l.item.extId,m),s.add(m)}l.expand===2&&this.busyControllerCount++;break}case 1:{const l=I[1],m=this.items.get(l.extId);if(!m)break;l.expand!==void 0&&(m.expand===2&&this.busyControllerCount--,l.expand===2&&this.busyControllerCount++),e.applyTestItemUpdate(m,l),s.update(m);break}case 2:{const l=this.items.get(I[1]);if(!l)break;l.parent?this.items.get(l.parent).children.delete(l.item.extId):this.roots.delete(l.item.extId);const m=[[I[1]]];for(;m.length;)for(const c of m.pop()){const h=this.items.get(c);h&&(m.push(h.children),this.items.delete(c),s.remove(h,h!==l),h.expand===2&&this.busyControllerCount--)}break}case 4:this.retireTest(I[1]);break;case 3:this.updatePendingRoots(I[1]);break}s.complete()}retireTest(C){}updatePendingRoots(C){this.pendingRootCount+=C}createChangeCollector(){return new A}}e.AbstractIncrementalTestCollection=P}),define(ge[202],pe([0,1,9,37,15,25,11,75,170]),function(Q,e,v,R,k,D,A,P,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class C{constructor(I,l,m){this._contributedVariables=new Map,this._context=I,this._labelService=l,m&&(this._envVariablesPromise=m.then(c=>this.prepareEnv(c)))}prepareEnv(I){if(A.isWindows){const l=Object.create(null);return Object.keys(I).forEach(m=>{l[m.toLowerCase()]=I[m]}),l}return I}resolveWithEnvironment(I,l,m){return this.recursiveResolve(this.prepareEnv(I),l?l.uri:void 0,m)}async resolveAsync(I,l){return this.recursiveResolve(await this._envVariablesPromise,I?I.uri:void 0,l)}async resolveAnyBase(I,l,m,c){const h=D.deepClone(l);return A.isWindows&&h.windows?Object.keys(h.windows).forEach(S=>h[S]=h.windows[S]):A.isMacintosh&&h.osx?Object.keys(h.osx).forEach(S=>h[S]=h.osx[S]):A.isLinux&&h.linux&&Object.keys(h.linux).forEach(S=>h[S]=h.linux[S]),delete h.windows,delete h.osx,delete h.linux,this.recursiveResolve(await this._envVariablesPromise,I?I.uri:void 0,h,m,c)}async resolveAnyAsync(I,l,m){return this.resolveAnyBase(I,l,m)}async resolveAnyMap(I,l,m){const c=new Map;return{newConfig:await this.resolveAnyBase(I,l,m,c),resolvedVariables:c}}resolveWithInteractionReplace(I,l,m,c){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(I,l,m,c){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(I,l){if(this._contributedVariables.has(I))throw new Error("Variable "+I+" is contributed twice.");this._contributedVariables.set(I,l)}recursiveResolve(I,l,m,c,h){if(k.isString(m))return this.resolveString(I,l,m,c,h);if(k.isArray(m))return m.map(S=>this.recursiveResolve(I,l,S,c,h));if(k.isObject(m)){let S=Object.create(null);return Object.keys(m).forEach(w=>{const b=this.resolveString(I,l,w,c,h);S[b]=this.recursiveResolve(I,l,m[w],c,h)}),S}return m}resolveString(I,l,m,c,h){return m.replace(C.VARIABLE_REGEXP,(w,b)=>{if(b.includes(C.VARIABLE_LHS))return w;let u=this.evaluateSingleVariable(I,w,b,l,c);return h&&h.set(b,u),u!==w&&k.isString(u)&&u.match(C.VARIABLE_REGEXP)&&(u=this.resolveString(I,l,u,c,h)),u})}fsPath(I){return this._labelService?this._labelService.getUriLabel(I,{noPrefix:!0}):I.fsPath}evaluateSingleVariable(I,l,m,c,h){let S;const w=m.split(":");w.length>1&&(m=w[0],S=w[1]);const b=()=>{const p=this._context.getFilePath();if(p)return p;throw new Error(_.localize(0,null,l))},u=()=>{const p=b();if(this._context.getWorkspaceFolderPathForFile){const t=this._context.getWorkspaceFolderPathForFile();if(t)return t}throw new Error(_.localize(1,null,l,v.basename(p)))},d=()=>{if(S){const p=this._context.getFolderUri(S);if(p)return p;throw new Error(_.localize(2,null,l,S))}if(c)return c;throw this._context.getWorkspaceFolderCount()>1?new Error(_.localize(3,null,l)):new Error(_.localize(4,null,l))};switch(m){case"env":if(S){if(I){const p=I[A.isWindows?S.toLowerCase():S];if(k.isString(p))return p}return""}throw new Error(_.localize(5,null,l));case"config":if(S){const p=this._context.getConfigurationValue(c,S);if(k.isUndefinedOrNull(p))throw new Error(_.localize(6,null,l,S));if(k.isObject(p))throw new Error(_.localize(7,null,l,S));return p}throw new Error(_.localize(8,null,l));case"command":return this.resolveFromMap(l,S,h,"command");case"input":return this.resolveFromMap(l,S,h,"input");default:switch(m){case"workspaceRoot":case"workspaceFolder":return P.normalizeDriveLetter(this.fsPath(d()));case"cwd":return c||S?P.normalizeDriveLetter(this.fsPath(d())):R.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return v.basename(this.fsPath(d()));case"lineNumber":const p=this._context.getLineNumber();if(p)return p;throw new Error(_.localize(9,null,l));case"selectedText":const t=this._context.getSelectedText();if(t)return t;throw new Error(_.localize(10,null,l));case"file":return b();case"fileWorkspaceFolder":return u();case"relativeFile":return c||S?v.relative(this.fsPath(d()),b()):b();case"relativeFileDirname":const i=v.dirname(b());if(c||S){const g=v.relative(this.fsPath(d()),i);return g.length===0?".":g}return i;case"fileDirname":return v.dirname(b());case"fileExtname":return v.extname(b());case"fileBasename":return v.basename(b());case"fileBasenameNoExtension":const r=v.basename(b());return r.slice(0,r.length-v.extname(r).length);case"fileDirnameBasename":return v.basename(v.dirname(b()));case"execPath":const n=this._context.getExecPath();return n||l;case"execInstallFolder":const o=this._context.getAppRoot();return o||l;case"pathSeparator":return v.sep;default:try{const g=S?`${m}:${S}`:m;return this.resolveFromMap(l,g,h,void 0)}catch(g){return l}}}}resolveFromMap(I,l,m,c){if(l&&m){const h=c===void 0?m[l]:m[c+":"+l];if(typeof h=="string")return h;throw new Error(_.localize(11,null,I))}return I}}e.AbstractVariableResolverService=C,C.VARIABLE_LHS="${",C.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(ge[203],pe([0,1,4]),function(Q,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.OpenEditorContext=e.GroupChangeKind=e.GroupsOrder=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=v.createDecorator("editorGroupsService");var R;(function(l){l[l.UP=0]="UP",l[l.DOWN=1]="DOWN",l[l.LEFT=2]="LEFT",l[l.RIGHT=3]="RIGHT"})(R=e.GroupDirection||(e.GroupDirection={}));var k;(function(l){l[l.HORIZONTAL=0]="HORIZONTAL",l[l.VERTICAL=1]="VERTICAL"})(k=e.GroupOrientation||(e.GroupOrientation={}));var D;(function(l){l[l.FIRST=0]="FIRST",l[l.LAST=1]="LAST",l[l.NEXT=2]="NEXT",l[l.PREVIOUS=3]="PREVIOUS"})(D=e.GroupLocation||(e.GroupLocation={}));var A;(function(l){l[l.MINIMIZE_OTHERS=0]="MINIMIZE_OTHERS",l[l.EVEN=1]="EVEN",l[l.TOGGLE=2]="TOGGLE"})(A=e.GroupsArrangement||(e.GroupsArrangement={}));var P;(function(l){l[l.COPY_EDITORS=0]="COPY_EDITORS",l[l.MOVE_EDITORS=1]="MOVE_EDITORS"})(P=e.MergeGroupMode||(e.MergeGroupMode={}));var _;(function(l){l[l.CREATION_TIME=0]="CREATION_TIME",l[l.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",l[l.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(_=e.GroupsOrder||(e.GroupsOrder={}));var C;(function(l){l[l.GROUP_ACTIVE=0]="GROUP_ACTIVE",l[l.GROUP_INDEX=1]="GROUP_INDEX",l[l.EDITOR_OPEN=2]="EDITOR_OPEN",l[l.EDITOR_CLOSE=3]="EDITOR_CLOSE",l[l.EDITOR_MOVE=4]="EDITOR_MOVE",l[l.EDITOR_ACTIVE=5]="EDITOR_ACTIVE",l[l.EDITOR_LABEL=6]="EDITOR_LABEL",l[l.EDITOR_CAPABILITIES=7]="EDITOR_CAPABILITIES",l[l.EDITOR_PIN=8]="EDITOR_PIN",l[l.EDITOR_STICKY=9]="EDITOR_STICKY",l[l.EDITOR_DIRTY=10]="EDITOR_DIRTY"})(C=e.GroupChangeKind||(e.GroupChangeKind={}));var s;(function(l){l[l.NEW_EDITOR=1]="NEW_EDITOR",l[l.MOVE_EDITOR=2]="MOVE_EDITOR",l[l.COPY_EDITOR=3]="COPY_EDITOR"})(s=e.OpenEditorContext||(e.OpenEditorContext={}));function I(l){return l.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=I}),define(ge[204],pe([0,1,4]),function(Q,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=v.createDecorator("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2}),define(ge[17],pe([0,1,18,96,277,54,25,15,2,41,78,171,115,86,204,7]),function(Q,e,v,R,k,D,A,P,_,C,s,I,l,m,c,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeActionTriggerKind=e.TestResults=e.TestItem=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookStatusBarItem=e.NotebookDecorationRenderOptions=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.Position=e.TokenType=e.Range=e.Selection=void 0;var S;(function(_e){function ye(K){const{selectionStartLineNumber:Ue,selectionStartColumn:we,positionLineNumber:Je,positionColumn:et}=K,rt=new h.Position(Ue-1,we-1),st=new h.Position(Je-1,et-1);return new h.Selection(rt,st)}_e.to=ye;function de(K){const{anchor:Ue,active:we}=K;return{selectionStartLineNumber:Ue.line+1,selectionStartColumn:Ue.character+1,positionLineNumber:we.line+1,positionColumn:we.character+1}}_e.from=de})(S=e.Selection||(e.Selection={}));var w;(function(_e){function ye(K){if(!K)return;const{start:Ue,end:we}=K;return{startLineNumber:Ue.line+1,startColumn:Ue.character+1,endLineNumber:we.line+1,endColumn:we.character+1}}_e.from=ye;function de(K){if(!K)return;const{startLineNumber:Ue,startColumn:we,endLineNumber:Je,endColumn:et}=K;return new h.Range(Ue-1,we-1,Je-1,et-1)}_e.to=de})(w=e.Range||(e.Range={}));var b;(function(_e){function ye(de){switch(de){case 1:return h.StandardTokenType.Comment;case 0:return h.StandardTokenType.Other;case 4:return h.StandardTokenType.RegEx;case 2:return h.StandardTokenType.String}}_e.to=ye})(b=e.TokenType||(e.TokenType={}));var u;(function(_e){function ye(K){return new h.Position(K.lineNumber-1,K.column-1)}_e.to=ye;function de(K){return{lineNumber:K.line+1,column:K.character+1}}_e.from=de})(u=e.Position||(e.Position={}));var d;(function(_e){function ye(K){switch(K){case h.DiagnosticTag.Unnecessary:return 1;case h.DiagnosticTag.Deprecated:return 2}}_e.from=ye;function de(K){switch(K){case 1:return h.DiagnosticTag.Unnecessary;case 2:return h.DiagnosticTag.Deprecated;default:return}}_e.to=de})(d=e.DiagnosticTag||(e.DiagnosticTag={}));var p;(function(_e){function ye(K){let Ue;return K.code&&(P.isString(K.code)||P.isNumber(K.code)?Ue=String(K.code):Ue={value:String(K.code.value),target:K.code.target}),Object.assign(Object.assign({},w.from(K.range)),{message:K.message,source:K.source,code:Ue,severity:i.from(K.severity),relatedInformation:K.relatedInformation&&K.relatedInformation.map(t.from),tags:Array.isArray(K.tags)?v.coalesce(K.tags.map(d.from)):void 0})}_e.from=ye;function de(K){var Ue;const we=new h.Diagnostic(w.to(K),K.message,i.to(K.severity));return we.source=K.source,we.code=P.isString(K.code)?K.code:(Ue=K.code)===null||Ue===void 0?void 0:Ue.value,we.relatedInformation=K.relatedInformation&&K.relatedInformation.map(t.to),we.tags=K.tags&&v.coalesce(K.tags.map(d.to)),we}_e.to=de})(p=e.Diagnostic||(e.Diagnostic={}));var t;(function(_e){function ye(K){return Object.assign(Object.assign({},w.from(K.location.range)),{message:K.message,resource:K.location.uri})}_e.from=ye;function de(K){return new h.DiagnosticRelatedInformation(new h.Location(K.resource,w.to(K)),K.message)}_e.to=de})(t=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var i;(function(_e){function ye(K){switch(K){case h.DiagnosticSeverity.Error:return l.MarkerSeverity.Error;case h.DiagnosticSeverity.Warning:return l.MarkerSeverity.Warning;case h.DiagnosticSeverity.Information:return l.MarkerSeverity.Info;case h.DiagnosticSeverity.Hint:return l.MarkerSeverity.Hint}return l.MarkerSeverity.Error}_e.from=ye;function de(K){switch(K){case l.MarkerSeverity.Info:return h.DiagnosticSeverity.Information;case l.MarkerSeverity.Warning:return h.DiagnosticSeverity.Warning;case l.MarkerSeverity.Error:return h.DiagnosticSeverity.Error;case l.MarkerSeverity.Hint:return h.DiagnosticSeverity.Hint;default:return h.DiagnosticSeverity.Error}}_e.to=de})(i=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var r;(function(_e){function ye(K){return typeof K=="number"&&K>=h.ViewColumn.One?K-1:K===h.ViewColumn.Beside?c.SIDE_GROUP:c.ACTIVE_GROUP}_e.from=ye;function de(K){if(typeof K=="number"&&K>=0)return K+1;throw new Error("invalid 'EditorGroupColumn'")}_e.to=de})(r=e.ViewColumn||(e.ViewColumn={}));function n(_e){return typeof _e.range!="undefined"}function o(_e){return _e.length===0?!0:!!n(_e[0])}e.isDecorationOptionsArr=o;var g;(function(_e){function ye(et){return et.map(_e.from)}_e.fromMany=ye;function de(et){return et&&typeof et=="object"&&typeof et.language=="string"&&typeof et.value=="string"}function K(et){let rt;if(de(et)){const{language:Et,value:bt}=et;rt={value:"```"+Et+`
`+bt+"\n```\n"}}else h.MarkdownString.isMarkdownString(et)?rt={value:et.value,isTrusted:et.isTrusted,supportThemeIcons:et.supportThemeIcons}:typeof et=="string"?rt={value:et}:rt={value:""};const st=Object.create(null);rt.uris=st;const vt=Et=>{try{let bt=_.URI.parse(Et,!0);bt=bt.with({query:Ue(bt.query,st)}),st[Et]=bt}catch(bt){}return""},ft=new k.Renderer;return ft.link=vt,ft.image=Et=>vt(R.parseHrefAndDimensions(Et).href),k(rt.value,{renderer:ft}),rt}_e.from=K;function Ue(et,rt){if(!et)return et;let st;try{st=D.parse(et)}catch(ft){}if(!st)return et;let vt=!1;return st=A.cloneAndChange(st,ft=>{if(_.URI.isUri(ft)){const Et=`__uri_${Math.random().toString(16).slice(2,8)}`;return rt[Et]=ft,vt=!0,Et}else return}),vt?JSON.stringify(st):et}function we(et){const rt=new h.MarkdownString(et.value,et.supportThemeIcons);return rt.isTrusted=et.isTrusted,rt}_e.to=we;function Je(et){if(!!et)return typeof et=="string"?et:_e.from(et)}_e.fromStrict=Je})(g=e.MarkdownString||(e.MarkdownString={}));function f(_e){return o(_e)?_e.map(ye=>({range:w.from(ye.range),hoverMessage:Array.isArray(ye.hoverMessage)?g.fromMany(ye.hoverMessage):ye.hoverMessage?g.from(ye.hoverMessage):void 0,renderOptions:ye.renderOptions})):_e.map(ye=>({range:w.from(ye)}))}e.fromRangeOrRangeWithMessage=f;function E(_e){return typeof _e=="undefined"?_e:typeof _e=="string"?_.URI.file(_e):_e}e.pathOrURIToURI=E;var y;(function(_e){function ye(de){return typeof de=="undefined"?de:{contentText:de.contentText,contentIconPath:de.contentIconPath?E(de.contentIconPath):void 0,border:de.border,borderColor:de.borderColor,fontStyle:de.fontStyle,fontWeight:de.fontWeight,textDecoration:de.textDecoration,color:de.color,backgroundColor:de.backgroundColor,margin:de.margin,width:de.width,height:de.height}}_e.from=ye})(y=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var a;(function(_e){function ye(de){return typeof de=="undefined"?de:{backgroundColor:de.backgroundColor,outline:de.outline,outlineColor:de.outlineColor,outlineStyle:de.outlineStyle,outlineWidth:de.outlineWidth,border:de.border,borderColor:de.borderColor,borderRadius:de.borderRadius,borderSpacing:de.borderSpacing,borderStyle:de.borderStyle,borderWidth:de.borderWidth,fontStyle:de.fontStyle,fontWeight:de.fontWeight,textDecoration:de.textDecoration,cursor:de.cursor,color:de.color,opacity:de.opacity,letterSpacing:de.letterSpacing,gutterIconPath:de.gutterIconPath?E(de.gutterIconPath):void 0,gutterIconSize:de.gutterIconSize,overviewRulerColor:de.overviewRulerColor,before:de.before?y.from(de.before):void 0,after:de.after?y.from(de.after):void 0}}_e.from=ye})(a=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var L;(function(_e){function ye(de){if(typeof de=="undefined")return de;switch(de){case h.DecorationRangeBehavior.OpenOpen:return 0;case h.DecorationRangeBehavior.ClosedClosed:return 1;case h.DecorationRangeBehavior.OpenClosed:return 2;case h.DecorationRangeBehavior.ClosedOpen:return 3}}_e.from=ye})(L=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var O;(function(_e){function ye(de){return{isWholeLine:de.isWholeLine,rangeBehavior:de.rangeBehavior?L.from(de.rangeBehavior):void 0,overviewRulerLane:de.overviewRulerLane,light:de.light?a.from(de.light):void 0,dark:de.dark?a.from(de.dark):void 0,backgroundColor:de.backgroundColor,outline:de.outline,outlineColor:de.outlineColor,outlineStyle:de.outlineStyle,outlineWidth:de.outlineWidth,border:de.border,borderColor:de.borderColor,borderRadius:de.borderRadius,borderSpacing:de.borderSpacing,borderStyle:de.borderStyle,borderWidth:de.borderWidth,fontStyle:de.fontStyle,fontWeight:de.fontWeight,textDecoration:de.textDecoration,cursor:de.cursor,color:de.color,opacity:de.opacity,letterSpacing:de.letterSpacing,gutterIconPath:de.gutterIconPath?E(de.gutterIconPath):void 0,gutterIconSize:de.gutterIconSize,overviewRulerColor:de.overviewRulerColor,before:de.before?y.from(de.before):void 0,after:de.after?y.from(de.after):void 0}}_e.from=ye})(O=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var W;(function(_e){function ye(K){return{text:K.newText,eol:K.newEol&&G.from(K.newEol),range:w.from(K.range)}}_e.from=ye;function de(K){const Ue=new h.TextEdit(w.to(K.range),K.text);return Ue.newEol=typeof K.eol=="undefined"?void 0:G.to(K.eol),Ue}_e.to=de})(W=e.TextEdit||(e.TextEdit={}));var J;(function(_e){function ye(K,Ue,we){var Je,et;const rt={edits:[]};if(K instanceof h.WorkspaceEdit)for(let st of K._allEntries())if(st._type===1)rt.edits.push({_type:1,oldUri:st.from,newUri:st.to,options:st.options,metadata:st.metadata});else if(st._type===2){const vt=Ue==null?void 0:Ue.getDocument(st.uri);rt.edits.push({_type:2,resource:st.uri,edit:W.from(st.edit),modelVersionId:vt==null?void 0:vt.version,metadata:st.metadata})}else st._type===3?rt.edits.push({_type:3,metadata:st.metadata,resource:st.uri,edit:st.edit,notebookMetadata:st.notebookMetadata,notebookVersionId:(Je=we==null?void 0:we.getNotebookDocument(st.uri,!0))===null||Je===void 0?void 0:Je.apiNotebook.version}):st._type===5&&rt.edits.push({_type:3,metadata:st.metadata,resource:st.uri,notebookVersionId:(et=we==null?void 0:we.getNotebookDocument(st.uri,!0))===null||et===void 0?void 0:et.apiNotebook.version,edit:{editType:1,index:st.index,count:st.count,cells:st.cells.map(z.from)}});return rt}_e.from=ye;function de(K){const Ue=new h.WorkspaceEdit;for(const we of K.edits)we.edit?Ue.replace(_.URI.revive(we.resource),w.to(we.edit.range),we.edit.text):Ue.renameFile(_.URI.revive(we.oldUri),_.URI.revive(we.newUri),we.options);return Ue}_e.to=de})(J=e.WorkspaceEdit||(e.WorkspaceEdit={}));var se;(function(_e){const ye=Object.create(null);ye[h.SymbolKind.File]=0,ye[h.SymbolKind.Module]=1,ye[h.SymbolKind.Namespace]=2,ye[h.SymbolKind.Package]=3,ye[h.SymbolKind.Class]=4,ye[h.SymbolKind.Method]=5,ye[h.SymbolKind.Property]=6,ye[h.SymbolKind.Field]=7,ye[h.SymbolKind.Constructor]=8,ye[h.SymbolKind.Enum]=9,ye[h.SymbolKind.Interface]=10,ye[h.SymbolKind.Function]=11,ye[h.SymbolKind.Variable]=12,ye[h.SymbolKind.Constant]=13,ye[h.SymbolKind.String]=14,ye[h.SymbolKind.Number]=15,ye[h.SymbolKind.Boolean]=16,ye[h.SymbolKind.Array]=17,ye[h.SymbolKind.Object]=18,ye[h.SymbolKind.Key]=19,ye[h.SymbolKind.Null]=20,ye[h.SymbolKind.EnumMember]=21,ye[h.SymbolKind.Struct]=22,ye[h.SymbolKind.Event]=23,ye[h.SymbolKind.Operator]=24,ye[h.SymbolKind.TypeParameter]=25;function de(Ue){return typeof ye[Ue]=="number"?ye[Ue]:6}_e.from=de;function K(Ue){for(const we in ye)if(ye[we]===Ue)return Number(we);return h.SymbolKind.Property}_e.to=K})(se=e.SymbolKind||(e.SymbolKind={}));var q;(function(_e){function ye(K){switch(K){case h.SymbolTag.Deprecated:return 1}}_e.from=ye;function de(K){switch(K){case 1:return h.SymbolTag.Deprecated}}_e.to=de})(q=e.SymbolTag||(e.SymbolTag={}));var N;(function(_e){function ye(K){return{name:K.name,kind:se.from(K.kind),tags:K.tags&&K.tags.map(q.from),containerName:K.containerName,location:M.from(K.location)}}_e.from=ye;function de(K){const Ue=new h.SymbolInformation(K.name,se.to(K.kind),K.containerName,M.to(K.location));return Ue.tags=K.tags&&K.tags.map(q.to),Ue}_e.to=de})(N=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var H;(function(_e){function ye(K){var Ue,we;const Je={name:K.name||"!!MISSING: name!!",detail:K.detail,range:w.from(K.range),selectionRange:w.from(K.selectionRange),kind:se.from(K.kind),tags:(we=(Ue=K.tags)===null||Ue===void 0?void 0:Ue.map(q.from))!==null&&we!==void 0?we:[]};return K.children&&(Je.children=K.children.map(ye)),Je}_e.from=ye;function de(K){const Ue=new h.DocumentSymbol(K.name,K.detail,se.to(K.kind),w.to(K.range),w.to(K.selectionRange));return v.isNonEmptyArray(K.tags)&&(Ue.tags=K.tags.map(q.to)),K.children&&(Ue.children=K.children.map(de)),Ue}_e.to=de})(H=e.DocumentSymbol||(e.DocumentSymbol={}));var T;(function(_e){function ye(de){const K=new h.CallHierarchyItem(se.to(de.kind),de.name,de.detail||"",_.URI.revive(de.uri),w.to(de.range),w.to(de.selectionRange));return K._sessionId=de._sessionId,K._itemId=de._itemId,K}_e.to=ye})(T=e.CallHierarchyItem||(e.CallHierarchyItem={}));var U;(function(_e){function ye(de){return new h.CallHierarchyIncomingCall(T.to(de.from),de.fromRanges.map(K=>w.to(K)))}_e.to=ye})(U=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var F;(function(_e){function ye(de){return new h.CallHierarchyOutgoingCall(T.to(de.to),de.fromRanges.map(K=>w.to(K)))}_e.to=ye})(F=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var M;(function(_e){function ye(K){return{range:K.range&&w.from(K.range),uri:K.uri}}_e.from=ye;function de(K){return new h.Location(_.URI.revive(K.uri),w.to(K.range))}_e.to=de})(M=e.location||(e.location={}));var x;(function(_e){function ye(K){const Ue=K,we=K;return{originSelectionRange:Ue.originSelectionRange?w.from(Ue.originSelectionRange):void 0,uri:Ue.targetUri?Ue.targetUri:we.uri,range:w.from(Ue.targetRange?Ue.targetRange:we.range),targetSelectionRange:Ue.targetSelectionRange?w.from(Ue.targetSelectionRange):void 0}}_e.from=ye;function de(K){return{targetUri:_.URI.revive(K.uri),targetRange:w.to(K.range),targetSelectionRange:K.targetSelectionRange?w.to(K.targetSelectionRange):void 0,originSelectionRange:K.originSelectionRange?w.to(K.originSelectionRange):void 0}}_e.to=de})(x=e.DefinitionLink||(e.DefinitionLink={}));var $;(function(_e){function ye(K){return{range:w.from(K.range),contents:g.fromMany(K.contents)}}_e.from=ye;function de(K){return new h.Hover(K.contents.map(g.to),w.to(K.range))}_e.to=de})($=e.Hover||(e.Hover={}));var X;(function(_e){function ye(K){return{range:w.from(K.range),expression:K.expression}}_e.from=ye;function de(K){return new h.EvaluatableExpression(w.to(K.range),K.expression)}_e.to=de})(X=e.EvaluatableExpression||(e.EvaluatableExpression={}));var le;(function(_e){function ye(K){if(K instanceof h.InlineValueText)return{type:"text",range:w.from(K.range),text:K.text};if(K instanceof h.InlineValueVariableLookup)return{type:"variable",range:w.from(K.range),variableName:K.variableName,caseSensitiveLookup:K.caseSensitiveLookup};if(K instanceof h.InlineValueEvaluatableExpression)return{type:"expression",range:w.from(K.range),expression:K.expression};throw new Error("Unknown 'InlineValue' type")}_e.from=ye;function de(K){switch(K.type){case"text":return{range:w.to(K.range),text:K.text};case"variable":return{range:w.to(K.range),variableName:K.variableName,caseSensitiveLookup:K.caseSensitiveLookup};case"expression":return{range:w.to(K.range),expression:K.expression}}}_e.to=de})(le=e.InlineValue||(e.InlineValue={}));var be;(function(_e){function ye(K){return{frameId:K.frameId,stoppedLocation:w.from(K.stoppedLocation)}}_e.from=ye;function de(K){return new h.InlineValueContext(K.frameId,w.to(K.stoppedLocation))}_e.to=de})(be=e.InlineValueContext||(e.InlineValueContext={}));var Re;(function(_e){function ye(K){return{range:w.from(K.range),kind:K.kind}}_e.from=ye;function de(K){return new h.DocumentHighlight(w.to(K.range),K.kind)}_e.to=de})(Re=e.DocumentHighlight||(e.DocumentHighlight={}));var Ce;(function(_e){function ye(de){switch(de){case 1:return h.CompletionTriggerKind.TriggerCharacter;case 2:return h.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return h.CompletionTriggerKind.Invoke}}_e.to=ye})(Ce=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var Me;(function(_e){function ye(de){return{triggerKind:Ce.to(de.triggerKind),triggerCharacter:de.triggerCharacter}}_e.to=ye})(Me=e.CompletionContext||(e.CompletionContext={}));var je;(function(_e){function ye(K){switch(K){case h.CompletionItemTag.Deprecated:return 1}}_e.from=ye;function de(K){switch(K){case 1:return h.CompletionItemTag.Deprecated}}_e.to=de})(je=e.CompletionItemTag||(e.CompletionItemTag={}));var ze;(function(_e){const ye=new Map([[h.CompletionItemKind.Method,0],[h.CompletionItemKind.Function,1],[h.CompletionItemKind.Constructor,2],[h.CompletionItemKind.Field,3],[h.CompletionItemKind.Variable,4],[h.CompletionItemKind.Class,5],[h.CompletionItemKind.Interface,7],[h.CompletionItemKind.Struct,6],[h.CompletionItemKind.Module,8],[h.CompletionItemKind.Property,9],[h.CompletionItemKind.Unit,12],[h.CompletionItemKind.Value,13],[h.CompletionItemKind.Constant,14],[h.CompletionItemKind.Enum,15],[h.CompletionItemKind.EnumMember,16],[h.CompletionItemKind.Keyword,17],[h.CompletionItemKind.Snippet,27],[h.CompletionItemKind.Text,18],[h.CompletionItemKind.Color,19],[h.CompletionItemKind.File,20],[h.CompletionItemKind.Reference,21],[h.CompletionItemKind.Folder,23],[h.CompletionItemKind.Event,10],[h.CompletionItemKind.Operator,11],[h.CompletionItemKind.TypeParameter,24],[h.CompletionItemKind.Issue,26],[h.CompletionItemKind.User,25]]);function de(we){var Je;return(Je=ye.get(we))!==null&&Je!==void 0?Je:9}_e.from=de;const K=new Map([[0,h.CompletionItemKind.Method],[1,h.CompletionItemKind.Function],[2,h.CompletionItemKind.Constructor],[3,h.CompletionItemKind.Field],[4,h.CompletionItemKind.Variable],[5,h.CompletionItemKind.Class],[7,h.CompletionItemKind.Interface],[6,h.CompletionItemKind.Struct],[8,h.CompletionItemKind.Module],[9,h.CompletionItemKind.Property],[12,h.CompletionItemKind.Unit],[13,h.CompletionItemKind.Value],[14,h.CompletionItemKind.Constant],[15,h.CompletionItemKind.Enum],[16,h.CompletionItemKind.EnumMember],[17,h.CompletionItemKind.Keyword],[27,h.CompletionItemKind.Snippet],[18,h.CompletionItemKind.Text],[19,h.CompletionItemKind.Color],[20,h.CompletionItemKind.File],[21,h.CompletionItemKind.Reference],[23,h.CompletionItemKind.Folder],[10,h.CompletionItemKind.Event],[11,h.CompletionItemKind.Operator],[24,h.CompletionItemKind.TypeParameter],[25,h.CompletionItemKind.User],[26,h.CompletionItemKind.Issue]]);function Ue(we){var Je;return(Je=K.get(we))!==null&&Je!==void 0?Je:h.CompletionItemKind.Property}_e.to=Ue})(ze=e.CompletionItemKind||(e.CompletionItemKind={}));var qe;(function(_e){function ye(de,K){var Ue;const we=new h.CompletionItem(typeof de.label=="string"?de.label:de.label.name);return typeof de.label!="string"&&(we.label2=de.label),we.insertText=de.insertText,we.kind=ze.to(de.kind),we.tags=(Ue=de.tags)===null||Ue===void 0?void 0:Ue.map(je.to),we.detail=de.detail,we.documentation=R.isMarkdownString(de.documentation)?g.to(de.documentation):de.documentation,we.sortText=de.sortText,we.filterText=de.filterText,we.preselect=de.preselect,we.commitCharacters=de.commitCharacters,C.Range.isIRange(de.range)?we.range=w.to(de.range):typeof de.range=="object"&&(we.range={inserting:w.to(de.range.insert),replacing:w.to(de.range.replace)}),we.keepWhitespace=typeof de.insertTextRules=="undefined"?!1:Boolean(de.insertTextRules&1),typeof de.insertTextRules!="undefined"&&de.insertTextRules&4?we.insertText=new h.SnippetString(de.insertText):(we.insertText=de.insertText,we.textEdit=we.range instanceof h.Range?new h.TextEdit(we.range,we.insertText):void 0),de.additionalTextEdits&&de.additionalTextEdits.length>0&&(we.additionalTextEdits=de.additionalTextEdits.map(Je=>W.to(Je))),we.command=K&&de.command?K.fromInternal(de.command):void 0,we}_e.to=ye})(qe=e.CompletionItem||(e.CompletionItem={}));var j;(function(_e){function ye(K){return{label:K.label,documentation:K.documentation?g.fromStrict(K.documentation):void 0}}_e.from=ye;function de(K){return{label:K.label,documentation:R.isMarkdownString(K.documentation)?g.to(K.documentation):K.documentation}}_e.to=de})(j=e.ParameterInformation||(e.ParameterInformation={}));var Z;(function(_e){function ye(K){return{label:K.label,documentation:K.documentation?g.fromStrict(K.documentation):void 0,parameters:Array.isArray(K.parameters)?K.parameters.map(j.from):[],activeParameter:K.activeParameter}}_e.from=ye;function de(K){return{label:K.label,documentation:R.isMarkdownString(K.documentation)?g.to(K.documentation):K.documentation,parameters:Array.isArray(K.parameters)?K.parameters.map(j.to):[],activeParameter:K.activeParameter}}_e.to=de})(Z=e.SignatureInformation||(e.SignatureInformation={}));var ne;(function(_e){function ye(K){return{activeSignature:K.activeSignature,activeParameter:K.activeParameter,signatures:Array.isArray(K.signatures)?K.signatures.map(Z.from):[]}}_e.from=ye;function de(K){return{activeSignature:K.activeSignature,activeParameter:K.activeParameter,signatures:Array.isArray(K.signatures)?K.signatures.map(Z.to):[]}}_e.to=de})(ne=e.SignatureHelp||(e.SignatureHelp={}));var oe;(function(_e){function ye(K){var Ue;return{text:K.text,position:u.from(K.position),kind:Y.from((Ue=K.kind)!==null&&Ue!==void 0?Ue:h.InlayHintKind.Other),whitespaceBefore:K.whitespaceBefore,whitespaceAfter:K.whitespaceAfter}}_e.from=ye;function de(K){const Ue=new h.InlayHint(K.text,u.to(K.position),Y.to(K.kind));return Ue.whitespaceAfter=K.whitespaceAfter,Ue.whitespaceBefore=K.whitespaceBefore,Ue}_e.to=de})(oe=e.InlayHint||(e.InlayHint={}));var Y;(function(_e){function ye(K){return K}_e.from=ye;function de(K){return K}_e.to=de})(Y=e.InlayHintKind||(e.InlayHintKind={}));var ce;(function(_e){function ye(K){return{range:w.from(K.range),url:K.target,tooltip:K.tooltip}}_e.from=ye;function de(K){let Ue;if(K.url)try{Ue=typeof K.url=="string"?_.URI.parse(K.url,!0):_.URI.revive(K.url)}catch(we){}return new h.DocumentLink(w.to(K.range),Ue)}_e.to=de})(ce=e.DocumentLink||(e.DocumentLink={}));var me;(function(_e){function ye(K){const Ue=new h.ColorPresentation(K.label);return K.textEdit&&(Ue.textEdit=W.to(K.textEdit)),K.additionalTextEdits&&(Ue.additionalTextEdits=K.additionalTextEdits.map(we=>W.to(we))),Ue}_e.to=ye;function de(K){return{label:K.label,textEdit:K.textEdit?W.from(K.textEdit):void 0,additionalTextEdits:K.additionalTextEdits?K.additionalTextEdits.map(Ue=>W.from(Ue)):void 0}}_e.from=de})(me=e.ColorPresentation||(e.ColorPresentation={}));var Le;(function(_e){function ye(K){return new h.Color(K[0],K[1],K[2],K[3])}_e.to=ye;function de(K){return[K.red,K.green,K.blue,K.alpha]}_e.from=de})(Le=e.Color||(e.Color={}));var We;(function(_e){function ye(K){return{range:w.from(K.range)}}_e.from=ye;function de(K){return new h.SelectionRange(w.to(K.range))}_e.to=de})(We=e.SelectionRange||(e.SelectionRange={}));var Ee;(function(_e){function ye(de){switch(de){case 2:return h.TextDocumentSaveReason.AfterDelay;case 1:return h.TextDocumentSaveReason.Manual;case 3:case 4:return h.TextDocumentSaveReason.FocusOut}}_e.to=ye})(Ee=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var Ke;(function(_e){function ye(K){switch(K){case h.TextEditorLineNumbersStyle.Off:return 0;case h.TextEditorLineNumbersStyle.Relative:return 2;case h.TextEditorLineNumbersStyle.On:default:return 1}}_e.from=ye;function de(K){switch(K){case 0:return h.TextEditorLineNumbersStyle.Off;case 2:return h.TextEditorLineNumbersStyle.Relative;case 1:default:return h.TextEditorLineNumbersStyle.On}}_e.to=de})(Ke=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var G;(function(_e){function ye(K){if(K===h.EndOfLine.CRLF)return 1;if(K===h.EndOfLine.LF)return 0}_e.from=ye;function de(K){if(K===1)return h.EndOfLine.CRLF;if(K===0)return h.EndOfLine.LF}_e.to=de})(G=e.EndOfLine||(e.EndOfLine={}));var ie;(function(_e){function ye(de){if(typeof de=="object")return de.viewId;switch(de){case h.ProgressLocation.SourceControl:return 3;case h.ProgressLocation.Window:return 10;case h.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}_e.from=ye})(ie=e.ProgressLocation||(e.ProgressLocation={}));var ve;(function(_e){function ye(de){const K={start:de.start+1,end:de.end+1};return de.kind&&(K.kind=Fe.from(de.kind)),K}_e.from=ye})(ve=e.FoldingRange||(e.FoldingRange={}));var Fe;(function(_e){function ye(de){if(de)switch(de){case h.FoldingRangeKind.Comment:return s.FoldingRangeKind.Comment;case h.FoldingRangeKind.Imports:return s.FoldingRangeKind.Imports;case h.FoldingRangeKind.Region:return s.FoldingRangeKind.Region}}_e.from=ye})(Fe=e.FoldingRangeKind||(e.FoldingRangeKind={}));var Ne;(function(_e){function ye(de){if(de)return{pinned:typeof de.preview=="boolean"?!de.preview:void 0,inactive:de.background,preserveFocus:de.preserveFocus,selection:typeof de.selection=="object"?w.from(de.selection):void 0,override:typeof de.override=="boolean"?I.EditorOverride.DISABLED:void 0}}_e.from=ye})(Ne=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var Qe;(function(_e){function ye(K){return K instanceof h.RelativePattern||typeof K=="string"?K:de(K)?new h.RelativePattern(K.base,K.pattern):K}_e.from=ye;function de(K){const Ue=K;return Ue&&typeof Ue.base=="string"&&typeof Ue.pattern=="string"}})(Qe=e.GlobPattern||(e.GlobPattern={}));var De;(function(_e){function ye(de){if(de){if(Array.isArray(de))return de.map(ye);if(typeof de=="string")return de;{const K=de;return{language:K.language,scheme:K.scheme,pattern:typeof K.pattern=="undefined"?void 0:Qe.from(K.pattern),exclusive:K.exclusive}}}else return}_e.from=ye})(De=e.LanguageSelector||(e.LanguageSelector={}));var Se;(function(_e){function ye(K){return{start:K.start,end:K.end}}_e.from=ye;function de(K){return new h.NotebookRange(K.start,K.end)}_e.to=de})(Se=e.NotebookRange||(e.NotebookRange={}));var Pe;(function(_e){function ye(K){return{timing:typeof K.runStartTime=="number"&&typeof K.runEndTime=="number"?{startTime:K.runStartTime,endTime:K.runEndTime}:void 0,executionOrder:K.executionOrder,success:K.lastRunSuccess}}_e.to=ye;function de(K){var Ue,we;return{lastRunSuccess:K.success,runStartTime:(Ue=K.timing)===null||Ue===void 0?void 0:Ue.startTime,runEndTime:(we=K.timing)===null||we===void 0?void 0:we.endTime,executionOrder:K.executionOrder}}_e.from=de})(Pe=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var ae;(function(_e){function ye(K){switch(K){case h.NotebookCellKind.Markup:return m.CellKind.Markup;case h.NotebookCellKind.Code:default:return m.CellKind.Code}}_e.from=ye;function de(K){switch(K){case m.CellKind.Markup:return h.NotebookCellKind.Markup;case m.CellKind.Code:default:return h.NotebookCellKind.Code}}_e.to=de})(ae=e.NotebookCellKind||(e.NotebookCellKind={}));var he;(function(_e){function ye(K){var Ue;const we={metadata:(Ue=K.metadata)!==null&&Ue!==void 0?Ue:Object.create(null),cells:[]};for(let Je of K.cells)h.NotebookCellData.validate(Je),we.cells.push(z.from(Je));return we}_e.from=ye;function de(K){const Ue=new h.NotebookData(K.cells.map(z.to));return P.isEmptyObject(K.metadata)||(Ue.metadata=K.metadata),Ue}_e.to=de})(he=e.NotebookData||(e.NotebookData={}));var z;(function(_e){function ye(K){var Ue;return{cellKind:ae.from(K.kind),language:K.languageId,source:K.value,metadata:K.metadata,internalMetadata:Pe.from((Ue=K.executionSummary)!==null&&Ue!==void 0?Ue:{}),outputs:K.outputs?K.outputs.map(ue.from):[]}}_e.from=ye;function de(K){return new h.NotebookCellData(ae.to(K.cellKind),K.source,K.language,K.outputs?K.outputs.map(ue.to):void 0,K.metadata,K.internalMetadata?Pe.to(K.internalMetadata):void 0)}_e.to=de})(z=e.NotebookCellData||(e.NotebookCellData={}));var ee;(function(_e){function ye(K){return{mime:K.mime,valueBytes:Array.from(K.data)}}_e.from=ye;function de(K){return new h.NotebookCellOutputItem(new Uint8Array(K.valueBytes),K.mime)}_e.to=de})(ee=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var ue;(function(_e){function ye(K){return{outputId:K.id,items:K.items.map(ee.from),metadata:K.metadata}}_e.from=ye;function de(K){const Ue=K.items.map(ee.to);return new h.NotebookCellOutput(Ue,K.outputId,K.metadata)}_e.to=de})(ue=e.NotebookCellOutput||(e.NotebookCellOutput={}));var Ie;(function(_e){function ye(we){if(we!=null){if(we instanceof h.RelativePattern||typeof we=="string")return we;if(Ue(we))return new h.RelativePattern(we.base,we.pattern);if(K(we))return{include:Qe.from(we.include)||void 0,exclude:Qe.from(we.exclude)||void 0}}}_e.from=ye;function de(we){return typeof we=="string"?we:Ue(we)?{base:we.base,pattern:we.pattern}:{include:we.include,exclude:we.exclude}}_e.to=de;function K(we){const Je=we,et=Qe.from(Je.include);if(!(et&&et instanceof h.RelativePattern||typeof et=="string"))return!1;const rt=Qe.from(Je.exclude);return!!(rt&&rt instanceof h.RelativePattern||typeof rt=="string")}function Ue(we){const Je=we;return Je&&typeof Je.base=="string"&&typeof Je.pattern=="string"}})(Ie=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var Te;(function(_e){function ye(de){return{backgroundColor:de.backgroundColor,borderColor:de.borderColor,top:de.top?y.from(de.top):void 0}}_e.from=ye})(Te=e.NotebookDecorationRenderOptions||(e.NotebookDecorationRenderOptions={}));var xe;(function(_e){function ye(de,K,Ue){const we=typeof de.command=="string"?{title:"",command:de.command}:de.command;return{alignment:de.alignment===h.NotebookCellStatusBarAlignment.Left?1:2,command:K.toInternal(we,Ue),text:de.text,tooltip:de.tooltip,accessibilityInformation:de.accessibilityInformation,priority:de.priority}}_e.from=ye})(xe=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var He;(function(_e){function ye(de){var K,Ue,we;return{transientOutputs:(K=de==null?void 0:de.transientOutputs)!==null&&K!==void 0?K:!1,transientCellMetadata:(Ue=de==null?void 0:de.transientCellMetadata)!==null&&Ue!==void 0?Ue:{},transientDocumentMetadata:(we=de==null?void 0:de.transientDocumentMetadata)!==null&&we!==void 0?we:{}}}_e.from=ye})(He=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var Ze;(function(_e){function ye(K){return{uri:K.uri,provides:K.provides}}_e.from=ye;function de(K){return new h.NotebookRendererScript(_.URI.revive(K.uri),K.provides)}_e.to=de})(Ze=e.NotebookRendererScript||(e.NotebookRendererScript={}));var Ye;(function(_e){function ye(K){return{message:g.fromStrict(K.message)||"",severity:K.severity,expectedOutput:K.expectedOutput,actualOutput:K.actualOutput,location:K.location?M.from(K.location):void 0}}_e.from=ye;function de(K){const Ue=new h.TestMessage(typeof K.message=="string"?K.message:g.to(K.message));return Ue.severity=K.severity,Ue.actualOutput=K.actualOutput,Ue.expectedOutput=K.expectedOutput,Ue}_e.to=de})(Ye=e.TestMessage||(e.TestMessage={}));var Xe;(function(_e){function ye(we){var Je,et;return{extId:we.id,label:we.label,uri:we.uri,range:w.from(we.range)||null,debuggable:(Je=we.debuggable)!==null&&Je!==void 0?Je:!1,description:we.description||null,runnable:(et=we.runnable)!==null&&et!==void 0?et:!0,error:we.error&&g.fromStrict(we.error)||null}}_e.from=ye;function de(we){return{extId:we.id,label:we.label,uri:we.uri,range:w.from(we.range)||null,debuggable:!1,description:we.description||null,error:null,runnable:!0}}_e.fromResultSnapshot=de;function K(we){return{id:we.extId,label:we.label,uri:_.URI.revive(we.uri),range:w.to(we.range||void 0),addChild:()=>{},dispose:()=>{},status:h.TestItemStatus.Pending,data:void 0,debuggable:we.debuggable,description:we.description||void 0,runnable:we.runnable}}_e.toPlain=K;function Ue(we){const Je=new h.TestItemImpl(we.extId,we.label,_.URI.revive(we.uri),void 0);return Je.range=w.to(we.range||void 0),Je.debuggable=we.debuggable,Je.description=we.description||void 0,Je.runnable=we.runnable,Je}_e.to=Ue})(Xe=e.TestItem||(e.TestItem={}));var nt;(function(_e){const ye=(K,Ue)=>Object.assign(Object.assign({},Xe.toPlain(K.item)),{taskStates:K.tasks.map(we=>({state:we.state,duration:we.duration,messages:we.messages.map(Ye.to)})),children:K.children.map(we=>Ue.get(we)).filter(P.isDefined).map(we=>ye(we,Ue))});function de(K){const Ue=[],we=new Map;for(const Je of K.items)we.set(Je.item.extId,Je),Je.direct&&Ue.push(Je);return{completedAt:K.completedAt,results:Ue.map(Je=>ye(Je,we))}}_e.to=de})(nt=e.TestResults||(e.TestResults={}));var pt;(function(_e){function ye(de){switch(de){case 1:return h.CodeActionTriggerKind.Invoke;case 2:return h.CodeActionTriggerKind.Automatic}}_e.to=ye})(pt=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}))}),define(ge[205],pe([0,1,2,14,7,17,71]),function(Q,e,v,R,k,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class P{constructor(C,s,I,l={timeout:1500,errors:3}){this._logService=C,this._documents=s,this._mainThreadBulkEdits=I,this._thresholds=l,this._callbacks=new A.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(C){return(s,I,l)=>{const c={dispose:this._callbacks.push([s,I,C])};return Array.isArray(l)&&l.push(c),c}}async $participateInSave(C,s){const I=v.URI.revive(C);let l=!1;const m=setTimeout(()=>l=!0,this._thresholds.timeout),c=[];try{for(let h of[...this._callbacks]){if(l)break;const S=this._documents.getDocument(I),w=await this._deliverEventAsyncAndBlameBadListeners(h,{document:S,reason:D.TextDocumentSaveReason.to(s)});c.push(w)}}finally{clearTimeout(m)}return c}_deliverEventAsyncAndBlameBadListeners([C,s,I],l){const m=this._badListeners.get(C);return typeof m=="number"&&m>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(I,C,s,l).then(()=>!0,c=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${I.identifier.value}' threw ERROR`),this._logService.error(c),!(c instanceof Error)||c.message!=="concurrent_edits"){const h=this._badListeners.get(C);this._badListeners.set(C,h?h+1:1),typeof h=="number"&&h>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${I.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(C,s,I,l){const m=[],c=Date.now(),{document:h,reason:S}=l,{version:w}=h,b=Object.freeze({document:h,reason:S,waitUntil(u){if(Object.isFrozen(m))throw R.illegalState("waitUntil can not be called async");m.push(Promise.resolve(u))}});try{s.apply(I,[b])}catch(u){return Promise.reject(u)}return Object.freeze(m),new Promise((u,d)=>{const p=setTimeout(()=>d(new Error("timeout")),this._thresholds.timeout);return Promise.all(m).then(t=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${C.identifier.value}' finished after ${Date.now()-c}ms`),clearTimeout(p),u(t)}).catch(t=>{clearTimeout(p),d(t)})}).then(u=>{const d={edits:[]};for(const p of u)if(Array.isArray(p)&&p.every(t=>t instanceof k.TextEdit))for(const{newText:t,newEol:i,range:r}of p)d.edits.push({_type:2,resource:h.uri,edit:{range:r&&D.Range.from(r),text:t,eol:i&&D.EndOfLine.from(i)}});if(d.edits.length!==0)return w===h.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(d):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=P}),define(ge[206],pe([0,1,3,16,30,2,17,7]),function(Q,e,v,R,k,D,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class _{constructor(I,l,m,c,h){this._onDidCreate=new v.Emitter,this._onDidChange=new v.Emitter,this._onDidDelete=new v.Emitter,this._config=0,m&&(this._config+=1),c&&(this._config+=2),h&&(this._config+=4);const S=k.parse(l),w=I(b=>{if(!m)for(let u of b.created){const d=D.URI.revive(u);S(d.fsPath)&&this._onDidCreate.fire(d)}if(!c)for(let u of b.changed){const d=D.URI.revive(u);S(d.fsPath)&&this._onDidChange.fire(d)}if(!h)for(let u of b.deleted){const d=D.URI.revive(u);S(d.fsPath)&&this._onDidDelete.fire(d)}});this._disposable=P.Disposable.from(this._onDidCreate,this._onDidChange,this._onDidDelete,w)}get ignoreCreateEvents(){return Boolean(this._config&1)}get ignoreChangeEvents(){return Boolean(this._config&2)}get ignoreDeleteEvents(){return Boolean(this._config&4)}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class C{constructor(I,l,m){this._logService=l,this._extHostDocumentsAndEditors=m,this._onFileSystemEvent=new v.Emitter,this._onDidRenameFile=new v.Emitter,this._onDidCreateFile=new v.Emitter,this._onDidDeleteFile=new v.Emitter,this._onWillRenameFile=new R.AsyncEmitter,this._onWillCreateFile=new R.AsyncEmitter,this._onWillDeleteFile=new R.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(I,l,m,c){return new _(this._onFileSystemEvent.event,I,l,m,c)}$onFileEvent(I){this._onFileSystemEvent.fire(I)}$onDidRunFileOperation(I,l){switch(I){case 2:this._onDidRenameFile.fire(Object.freeze({files:l.map(m=>({oldUri:D.URI.revive(m.source),newUri:D.URI.revive(m.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:l.map(m=>D.URI.revive(m.target))}));break;case 0:this._onDidCreateFile.fire(Object.freeze({files:l.map(m=>D.URI.revive(m.target))}));break;default:}}getOnWillRenameFileEvent(I){return this._createWillExecuteEvent(I,this._onWillRenameFile)}getOnWillCreateFileEvent(I){return this._createWillExecuteEvent(I,this._onWillCreateFile)}getOnWillDeleteFileEvent(I){return this._createWillExecuteEvent(I,this._onWillDeleteFile)}_createWillExecuteEvent(I,l){return(m,c,h)=>{const S=function(b){m.call(c,b)};return S.extension=I,l.event(S,void 0,h)}}async $onWillRunFileOperation(I,l,m,c){switch(I){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:l.map(h=>({oldUri:D.URI.revive(h.source),newUri:D.URI.revive(h.target)}))},m,c);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:l.map(h=>D.URI.revive(h.target))},m,c);case 0:return await this._fireWillEvent(this._onWillCreateFile,{files:l.map(h=>D.URI.revive(h.target))},m,c)}}async _fireWillEvent(I,l,m,c){const h=new Set,S=[];if(await I.fireAsync(l,c,async(b,u)=>{var d;const p=Date.now(),t=await Promise.resolve(b);t instanceof P.WorkspaceEdit&&(S.push(t),h.add((d=u.extension.displayName)!==null&&d!==void 0?d:u.extension.identifier.value)),Date.now()-p>m&&this._logService.warn("SLOW file-participant",u.extension.identifier)}),c.isCancellationRequested||S.length===0)return;const w={edits:[]};for(let b of S){let{edits:u}=A.WorkspaceEdit.from(b,this._extHostDocumentsAndEditors);w.edits=w.edits.concat(u)}return{edit:w,extensionNames:Array.from(h)}}}e.ExtHostFileSystemEventService=C}),define(ge[207],pe([0,1,10,25,2,17,7,86]),function(Q,e,v,R,k,D,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class _{constructor(l,m,c,h){this.start=l,this.deletedCount=m,this.deletedItems=c,this.items=h}static asApiEvents(l){return l.map(m=>({start:m.start,deletedCount:m.deletedCount,deletedItems:m.deletedItems,items:m.items.map(c=>c.apiCell)}))}}class C{constructor(l,m,c){var h,S,w;this.notebook=l,this._extHostDocument=m,this._cellData=c,this.handle=c.handle,this.uri=k.URI.revive(c.uri),this.cellKind=c.cellKind,this._outputs=c.outputs.map(D.NotebookCellOutput.to),this._internalMetadata=(h=c.internalMetadata)!==null&&h!==void 0?h:{},this._metadata=(S=c.metadata)!==null&&S!==void 0?S:{},this._previousResult=D.NotebookCellExecutionSummary.to((w=c.internalMetadata)!==null&&w!==void 0?w:{})}static asModelAddData(l,m){return{EOL:m.eol,lines:m.source,modeId:m.language,uri:m.uri,isDirty:!1,versionId:1,notebook:l}}get internalMetadata(){return this._internalMetadata}get apiCell(){if(!this._apiCell){const l=this,m=this._extHostDocument.getDocument(this.uri);if(!m)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);this._apiCell=Object.freeze({get index(){return l.notebook.getCellIndex(l)},notebook:l.notebook.apiNotebook,kind:D.NotebookCellKind.to(this._cellData.cellKind),document:m.document,get outputs(){return l._outputs.slice(0)},get metadata(){return l._metadata},get executionSummary(){return l._previousResult}})}return this._apiCell}setOutputs(l){this._outputs=l.map(D.NotebookCellOutput.to)}setOutputItems(l,m,c){const h=c.map(D.NotebookCellOutputItem.to),S=this._outputs.find(w=>w.id===l);S&&(m||(S.items.length=0),S.items.push(...h))}setMetadata(l){this._metadata=l}setInternalMetadata(l){this._internalMetadata=l,this._previousResult=D.NotebookCellExecutionSummary.to(l)}}e.ExtHostCell=C;class s{constructor(l,m,c,h,S,w){var b;this._proxy=l,this._textDocumentsAndEditors=m,this._textDocuments=c,this._emitter=h,this.uri=S,this.handle=s._handlePool++,this._cells=[],this._versionId=0,this._isDirty=!1,this._disposed=!1,this._notebookType=w.viewType,this._metadata=(b=w.metadata)!==null&&b!==void 0?b:Object.create(null),this._spliceNotebookCells([[0,0,w.cells]],!0),this._versionId=w.versionId}dispose(){this._disposed=!0}get apiNotebook(){if(!this._notebook){const l=this;this._notebook={get uri(){return l.uri},get version(){return l._versionId},get notebookType(){return l._notebookType},get isDirty(){return l._isDirty},get isUntitled(){return l.uri.scheme===v.Schemas.untitled},get isClosed(){return l._disposed},get metadata(){return l._metadata},get cellCount(){return l._cells.length},cellAt(m){return m=l._validateIndex(m),l._cells[m].apiCell},getCells(m){return(m?l._getCells(m):l._cells).map(h=>h.apiCell)},save(){return l._save()}}}return this._notebook}updateBackup(l){var m;(m=this._backup)===null||m===void 0||m.delete(),this._backup=l}disposeBackup(){var l;(l=this._backup)===null||l===void 0||l.delete(),this._backup=void 0}acceptDocumentPropertiesChanged(l){l.metadata&&(this._metadata=Object.assign(Object.assign({},this._metadata),l.metadata))}acceptDirty(l){this._isDirty=l}acceptModelChanged(l,m){this._versionId=l.versionId,this._isDirty=m;for(const c of l.rawEvents)c.kind===P.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(c.changes,!1):c.kind===P.NotebookCellsChangeType.Move?this._moveCell(c.index,c.newIdx):c.kind===P.NotebookCellsChangeType.Output?this._setCellOutputs(c.index,c.outputs):c.kind===P.NotebookCellsChangeType.OutputItem?this._setCellOutputItems(c.index,c.outputId,c.append,c.outputItems):c.kind===P.NotebookCellsChangeType.ChangeLanguage?this._changeCellLanguage(c.index,c.language):c.kind===P.NotebookCellsChangeType.ChangeCellMetadata?this._changeCellMetadata(c.index,c.metadata):c.kind===P.NotebookCellsChangeType.ChangeCellInternalMetadata&&this._changeCellInternalMetadata(c.index,c.internalMetadata)}_validateIndex(l){return l=l|0,l<0?0:l>=this._cells.length?this._cells.length-1:l}_validateRange(l){let m=l.start|0,c=l.end|0;return m<0&&(m=0),c>this._cells.length&&(c=this._cells.length),l.with({start:m,end:c})}_getCells(l){l=this._validateRange(l);const m=[];for(let c=l.start;c<l.end;c++)m.push(this._cells[c]);return m}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveNotebook(this.uri)}_spliceNotebookCells(l,m){if(this._disposed)return;const c=[],h=[],S=[];l.reverse().forEach(w=>{const u=w[2].map(t=>{const i=new C(this,this._textDocumentsAndEditors,t);return m||h.push(C.asModelAddData(this.apiNotebook,t)),i}),d=new _(w[0],w[1],[],u),p=this._cells.splice(w[0],w[1],...u);for(const t of p)S.push(t.uri),d.deletedItems.push(t.apiCell);c.push(d)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:h,removedDocuments:S}),m||this._emitter.emitModelChange(R.deepFreeze({document:this.apiNotebook,changes:_.asApiEvents(c)}))}_moveCell(l,m){const c=this._cells.splice(l,1);this._cells.splice(m,0,...c);const h=[new _(l,1,c.map(S=>S.apiCell),[]),new _(m,0,[],c)];this._emitter.emitModelChange(R.deepFreeze({document:this.apiNotebook,changes:_.asApiEvents(h)}))}_setCellOutputs(l,m){const c=this._cells[l];c.setOutputs(m),this._emitter.emitCellOutputsChange(R.deepFreeze({document:this.apiNotebook,cells:[c.apiCell]}))}_setCellOutputItems(l,m,c,h){const S=this._cells[l];S.setOutputItems(m,c,h),this._emitter.emitCellOutputsChange(R.deepFreeze({document:this.apiNotebook,cells:[S.apiCell]}))}_changeCellLanguage(l,m){const c=this._cells[l];c.apiCell.document.languageId!==m&&this._textDocuments.$acceptModelModeChanged(c.uri,m)}_changeCellMetadata(l,m){const c=this._cells[l],h=c.apiCell.metadata;c.setMetadata(m);const S=c.apiCell.metadata;R.equals(h,S)||this._emitter.emitCellMetadataChange(R.deepFreeze({document:this.apiNotebook,cell:c.apiCell}))}_changeCellInternalMetadata(l,m){var c;const h=this._cells[l],S=h.internalMetadata;if(h.setInternalMetadata(m),S.runState!==m.runState){const w=(c=m.runState)!==null&&c!==void 0?c:A.NotebookCellExecutionState.Idle;this._emitter.emitCellExecutionStateChange(R.deepFreeze({document:this.apiNotebook,cell:h.apiCell,state:w}))}}getCellFromApiCell(l){return this._cells.find(m=>m.apiCell===l)}getCellFromIndex(l){return this._cells[l]}getCell(l){return this._cells.find(m=>m.handle===l)}getCellIndex(l){return this._cells.indexOf(l)}}e.ExtHostNotebookDocument=s,s._handlePool=0}),define(ge[123],pe([0,1,7,17,14]),function(Q,e,v,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class D{constructor(_){this._finalized=!1,this._collectedEdits=[],this._documentVersionId=_}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,cellEdits:this._collectedEdits}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replaceMetadata(_){this._throwIfFinalized(),this._collectedEdits.push({editType:5,metadata:_})}replaceCellMetadata(_,C){this._throwIfFinalized(),this._collectedEdits.push({editType:8,index:_,metadata:C})}replaceCells(_,C,s){this._throwIfFinalized(),!(_===C&&s.length===0)&&this._collectedEdits.push({editType:1,index:_,count:C-_,cells:s.map(R.NotebookCellData.from)})}}class A{constructor(_,C,s,I,l,m){this.id=_,this._proxy=C,this.notebookData=s,this._selections=[],this._visibleRanges=[],this._visible=!1,this._hasDecorationsForKey=new Set,this._selections=l,this._visibleRanges=I,this._viewColumn=m}get apiEditor(){if(!this._editor){const _=this;this._editor={get document(){return _.notebookData.apiNotebook},get selections(){return _._selections},set selections(C){if(!Array.isArray(C)||!C.every(v.NotebookRange.isNotebookRange))throw k.illegalArgument("selections");_._selections=C,_._trySetSelections(C)},get visibleRanges(){return _._visibleRanges},revealRange(C,s){_._proxy.$tryRevealRange(_.id,R.NotebookRange.from(C),s??v.NotebookEditorRevealType.Default)},get viewColumn(){return _._viewColumn},edit(C){const s=new D(this.document.version);return C(s),_._applyEdit(s.finalize())},setDecorations(C,s){return _.setDecorations(C,s)}},A.apiEditorsToExtHost.set(this._editor,this)}return this._editor}get visible(){return this._visible}_acceptVisibility(_){this._visible=_}_acceptVisibleRanges(_){this._visibleRanges=_}_acceptSelections(_){this._selections=_}_trySetSelections(_){this._proxy.$trySetSelections(this.id,_.map(R.NotebookRange.from))}_acceptViewColumn(_){this._viewColumn=_}_applyEdit(_){if(_.cellEdits.length===0)return Promise.resolve(!0);const C=[];let s=-1;for(let I=0;I<_.cellEdits.length;I++){if(s<0){C.push(_.cellEdits[I]),s++;continue}const m=C[s],c=_.cellEdits[I];if(m.editType===1&&c.editType===1&&m.index===c.index){m.cells.push(..._.cellEdits[I].cells),m.count+=_.cellEdits[I].count;continue}C.push(_.cellEdits[I]),s++}return this._proxy.$tryApplyEdits(this.id,_.documentVersionId,C)}setDecorations(_,C){if(!(C.isEmpty&&!this._hasDecorationsForKey.has(_.key)))return C.isEmpty?this._hasDecorationsForKey.delete(_.key):this._hasDecorationsForKey.add(_.key),this._proxy.$trySetDecorations(this.id,R.NotebookRange.from(C),_.key)}}e.ExtHostNotebookEditor=A,A.apiEditorsToExtHost=new WeakMap}),define(ge[208],pe([0,1,17,116,160,21,51]),function(Q,e,v,R,k,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class P{constructor(I){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=I}withProgress(I,l,m){const c=this._handles++,{title:h,location:S,cancellable:w}=l,b={label:k.localize(0,null,I.displayName||I.name),id:I.identifier.value};return this._proxy.$startProgress(c,{location:v.ProgressLocation.from(S),title:h,source:b,cancellable:w},I),this._withProgress(c,m,!!w)}_withProgress(I,l,m){let c;m&&(c=new D.CancellationTokenSource,this._mapHandleToCancellationSource.set(I,c));const h=w=>{this._proxy.$progressEnd(w),this._mapHandleToCancellationSource.delete(w),c&&c.dispose()};let S;try{S=l(new C(this._proxy,I),m&&c?c.token:D.CancellationToken.None)}catch(w){throw h(I),w}return S.then(w=>h(I),w=>h(I)),S}$acceptProgressCanceled(I){const l=this._mapHandleToCancellationSource.get(I);l&&(l.cancel(),this._mapHandleToCancellationSource.delete(I))}}e.ExtHostProgress=P;function _(s,I){return s.message=I.message,typeof I.increment=="number"&&(typeof s.increment=="number"?s.increment+=I.increment:s.increment=I.increment),s}class C extends R.Progress{constructor(I,l){super(m=>this.throttledReport(m));this._proxy=I,this._handle=l}throttledReport(I){this._proxy.$progressReport(this._handle,I)}}Ve([A.throttle(100,(s,I)=>_(s,I),()=>Object.create(null))],C.prototype,"throttledReport",null)}),define(ge[124],pe([0,1,50,14,69,17,7]),function(Q,e,v,R,k,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorEdit=e.TextEditorDecorationType=void 0;class P{constructor(l,m,c){const h=P._Keys.nextId();l.$registerTextEditorDecorationType(m.identifier,h,D.DecorationRenderOptions.from(c)),this.value=Object.freeze({key:h,dispose(){l.$removeTextEditorDecorationType(h)}})}}e.TextEditorDecorationType=P,P._Keys=new k.IdGenerator("TextEditorDecorationType");class _{constructor(l,m){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=l,this._documentVersionId=l.version,this._undoStopBefore=m.undoStopBefore,this._undoStopAfter=m.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(l,m){this._throwIfFinalized();let c=null;if(l instanceof A.Position)c=new A.Range(l,l);else if(l instanceof A.Range)c=l;else throw new Error("Unrecognized location");this._pushEdit(c,m,!1)}insert(l,m){this._throwIfFinalized(),this._pushEdit(new A.Range(l,l),m,!0)}delete(l){this._throwIfFinalized();let m=null;if(l instanceof A.Range)m=l;else throw new Error("Unrecognized location");this._pushEdit(m,null,!0)}_pushEdit(l,m,c){const h=this._document.validateRange(l);this._collectedEdits.push({range:h,text:m,forceMoveMarkers:c})}setEndOfLine(l){if(this._throwIfFinalized(),l!==A.EndOfLine.LF&&l!==A.EndOfLine.CRLF)throw R.illegalArgument("endOfLine");this._setEndOfLine=l}}e.TextEditorEdit=_;class C{constructor(l,m,c,h){this._proxy=l,this._id=m,this._accept(c),this._logService=h;const S=this;this.value={get tabSize(){return S._tabSize},set tabSize(w){S._setTabSize(w)},get insertSpaces(){return S._insertSpaces},set insertSpaces(w){S._setInsertSpaces(w)},get cursorStyle(){return S._cursorStyle},set cursorStyle(w){S._setCursorStyle(w)},get lineNumbers(){return S._lineNumbers},set lineNumbers(w){S._setLineNumbers(w)}}}_accept(l){this._tabSize=l.tabSize,this._insertSpaces=l.insertSpaces,this._cursorStyle=l.cursorStyle,this._lineNumbers=D.TextEditorLineNumbersStyle.to(l.lineNumbers)}_validateTabSize(l){if(l==="auto")return"auto";if(typeof l=="number"){const m=Math.floor(l);return m>0?m:null}if(typeof l=="string"){const m=parseInt(l,10);return isNaN(m)?null:m>0?m:null}return null}_setTabSize(l){const m=this._validateTabSize(l);if(m!==null){if(typeof m=="number"){if(this._tabSize===m)return;this._tabSize=m}this._warnOnError(this._proxy.$trySetOptions(this._id,{tabSize:m}))}}_validateInsertSpaces(l){return l==="auto"?"auto":l==="false"?!1:Boolean(l)}_setInsertSpaces(l){const m=this._validateInsertSpaces(l);if(typeof m=="boolean"){if(this._insertSpaces===m)return;this._insertSpaces=m}this._warnOnError(this._proxy.$trySetOptions(this._id,{insertSpaces:m}))}_setCursorStyle(l){this._cursorStyle!==l&&(this._cursorStyle=l,this._warnOnError(this._proxy.$trySetOptions(this._id,{cursorStyle:l})))}_setLineNumbers(l){this._lineNumbers!==l&&(this._lineNumbers=l,this._warnOnError(this._proxy.$trySetOptions(this._id,{lineNumbers:D.TextEditorLineNumbersStyle.from(l)})))}assign(l){const m={};let c=!1;if(typeof l.tabSize!="undefined"){const h=this._validateTabSize(l.tabSize);h==="auto"?(c=!0,m.tabSize=h):typeof h=="number"&&this._tabSize!==h&&(this._tabSize=h,c=!0,m.tabSize=h)}if(typeof l.insertSpaces!="undefined"){const h=this._validateInsertSpaces(l.insertSpaces);h==="auto"?(c=!0,m.insertSpaces=h):this._insertSpaces!==h&&(this._insertSpaces=h,c=!0,m.insertSpaces=h)}typeof l.cursorStyle!="undefined"&&this._cursorStyle!==l.cursorStyle&&(this._cursorStyle=l.cursorStyle,c=!0,m.cursorStyle=l.cursorStyle),typeof l.lineNumbers!="undefined"&&this._lineNumbers!==l.lineNumbers&&(this._lineNumbers=l.lineNumbers,c=!0,m.lineNumbers=D.TextEditorLineNumbersStyle.from(l.lineNumbers)),c&&this._warnOnError(this._proxy.$trySetOptions(this._id,m))}_warnOnError(l){l.catch(m=>this._logService.warn(m))}}e.ExtHostTextEditorOptions=C;class s{constructor(l,m,c,h,S,w,b,u){this.id=l,this._proxy=m,this._logService=c,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=S,this._options=new C(this._proxy,this.id,w,c),this._visibleRanges=b,this._viewColumn=u;const d=this;this.value=Object.freeze({get document(){return h.getValue()},set document(p){throw R.readonly("document")},get selection(){return d._selections&&d._selections[0]},set selection(p){if(!(p instanceof A.Selection))throw R.illegalArgument("selection");d._selections=[p],d._trySetSelection()},get selections(){return d._selections},set selections(p){if(!Array.isArray(p)||p.some(t=>!(t instanceof A.Selection)))throw R.illegalArgument("selections");d._selections=p,d._trySetSelection()},get visibleRanges(){return d._visibleRanges},set visibleRanges(p){throw R.readonly("visibleRanges")},get options(){return d._options.value},set options(p){d._disposed||d._options.assign(p)},get viewColumn(){return d._viewColumn},set viewColumn(p){throw R.readonly("viewColumn")},edit(p,t={undoStopBefore:!0,undoStopAfter:!0}){if(d._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const i=new _(h.getValue(),t);return p(i),d._applyEdit(i)},insertSnippet(p,t,i={undoStopBefore:!0,undoStopAfter:!0}){if(d._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let r;if(!t||Array.isArray(t)&&t.length===0)r=d._selections.map(n=>D.Range.from(n));else if(t instanceof A.Position){const{lineNumber:n,column:o}=D.Position.from(t);r=[{startLineNumber:n,startColumn:o,endLineNumber:n,endColumn:o}]}else if(t instanceof A.Range)r=[D.Range.from(t)];else{r=[];for(const n of t)if(n instanceof A.Range)r.push(D.Range.from(n));else{const{lineNumber:o,column:g}=D.Position.from(n);r.push({startLineNumber:o,startColumn:g,endLineNumber:o,endColumn:g})}}return m.$tryInsertSnippet(l,p.value,r,i)},setDecorations(p,t){const i=t.length===0;i&&!d._hasDecorationsForKey.has(p.key)||(i?d._hasDecorationsForKey.delete(p.key):d._hasDecorationsForKey.add(p.key),d._runOnProxy(()=>{if(D.isDecorationOptionsArr(t))return m.$trySetDecorations(l,p.key,D.fromRangeOrRangeWithMessage(t));{const r=new Array(4*t.length);for(let n=0,o=t.length;n<o;n++){const g=t[n];r[4*n]=g.start.line+1,r[4*n+1]=g.start.character+1,r[4*n+2]=g.end.line+1,r[4*n+3]=g.end.character+1}return m.$trySetDecorationsFast(l,p.key,r)}}))},revealRange(p,t){d._runOnProxy(()=>m.$tryRevealRange(l,D.Range.from(p),t||A.TextEditorRevealType.Default))},show(p){m.$tryShowEditor(l,D.ViewColumn.from(p))},hide(){m.$tryHideEditor(l)}})}dispose(){v.ok(!this._disposed),this._disposed=!0}_acceptOptions(l){v.ok(!this._disposed),this._options._accept(l)}_acceptVisibleRanges(l){v.ok(!this._disposed),this._visibleRanges=l}_acceptViewColumn(l){v.ok(!this._disposed),this._viewColumn=l}_acceptSelections(l){v.ok(!this._disposed),this._selections=l}async _trySetSelection(){const l=this._selections.map(D.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,l)),this.value}_applyEdit(l){const m=l.finalize();if(m.edits.length===0&&!m.setEndOfLine)return Promise.resolve(!0);const c=m.edits.map(S=>S.range);c.sort((S,w)=>S.end.line===w.end.line?S.end.character===w.end.character?S.start.line===w.start.line?S.start.character-w.start.character:S.start.line-w.start.line:S.end.character-w.end.character:S.end.line-w.end.line);for(let S=0,w=c.length-1;S<w;S++){const b=c[S].end;if(c[S+1].start.isBefore(b))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const h=m.edits.map(S=>({range:D.Range.from(S.range),text:S.text,forceMoveMarkers:S.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,m.documentVersionId,h,{setEndOfLine:typeof m.setEndOfLine=="number"?D.EndOfLine.from(m.setEndOfLine):void 0,undoStopBefore:m.undoStopBefore,undoStopAfter:m.undoStopAfter})}_runOnProxy(l){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):l().then(()=>this,m=>(m instanceof Error&&m.name==="DISPOSED"||this._logService.warn(m),null))}}e.ExtHostTextEditor=s}),define(ge[209],pe([0,1,163,24,2,3,6,16,7,15,18,17,21]),function(Q,e,v,R,k,D,A,P,_,C,s,I,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function m(S,w){if(C.isString(S))return{label:S};if(S&&typeof S=="object"&&typeof S.label=="string"){let b;return Array.isArray(S.highlights)&&(b=S.highlights.filter(u=>u.length===2&&typeof u[0]=="number"&&typeof u[1]=="number"),b=b.length?b:void 0),{label:S.label,highlights:b}}}class c{constructor(w,b,u){this._proxy=w,this.commands=b,this.logService=u,this.treeViews=new Map;function d(p){return p&&p.$treeViewId&&p.$treeItemHandle}b.registerArgumentProcessor({processArgument:p=>d(p)?this.convertArgument(p):Array.isArray(p)&&p.length>0?p.map(t=>d(t)?this.convertArgument(t):t):p})}registerTreeDataProvider(w,b,u){const d=this.createTreeView(w,{treeDataProvider:b},u);return{dispose:()=>d.dispose()}}createTreeView(w,b,u){if(!b||!b.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const d=b.dragAndDropController!==void 0,p=this._proxy.$registerTreeViewDataProvider(w,{showCollapseAll:!!b.showCollapseAll,canSelectMany:!!b.canSelectMany,canDragAndDrop:d}),t=this.createExtHostTreeView(w,b,u);return{get onDidCollapseElement(){return t.onDidCollapseElement},get onDidExpandElement(){return t.onDidExpandElement},get selection(){return t.selectedElements},get onDidChangeSelection(){return t.onDidChangeSelection},get visible(){return t.visible},get onDidChangeVisibility(){return t.onDidChangeVisibility},get message(){return t.message},set message(i){t.message=i},get title(){return t.title},set title(i){t.title=i},get description(){return t.description},set description(i){t.description=i},reveal:(i,r)=>t.reveal(i,r),dispose:async()=>{await p,this.treeViews.delete(w),t.dispose()}}}$getChildren(w,b){const u=this.treeViews.get(w);return u?u.getChildren(b):Promise.reject(new Error(v.localize(0,null,w)))}$onDrop(w,b,u){const d=this.treeViews.get(w);return d?d.onDrop(b,u):Promise.reject(new Error(v.localize(1,null,w)))}async $hasResolve(w){const b=this.treeViews.get(w);if(!b)throw new Error(v.localize(2,null,w));return b.hasResolve}$resolve(w,b,u){const d=this.treeViews.get(w);if(!d)throw new Error(v.localize(3,null,w));return d.resolveTreeItem(b,u)}$setExpanded(w,b,u){const d=this.treeViews.get(w);if(!d)throw new Error(v.localize(4,null,w));d.setExpanded(b,u)}$setSelection(w,b){const u=this.treeViews.get(w);if(!u)throw new Error(v.localize(5,null,w));u.setSelection(b)}$setVisible(w,b){const u=this.treeViews.get(w);if(!u)throw new Error(v.localize(6,null,w));u.setVisible(b)}createExtHostTreeView(w,b,u){const d=new h(w,b,this._proxy,this.commands.converter,this.logService,u);return this.treeViews.set(w,d),d}convertArgument(w){const b=this.treeViews.get(w.$treeViewId);return b?b.getExtensionElement(w.$treeItemHandle):null}}e.ExtHostTreeViews=c;class h extends A.Disposable{constructor(w,b,u,d,p,t){super();if(this.viewId=w,this.proxy=u,this.commands=d,this.logService=p,this.extension=t,this.roots=null,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._onDidExpandElement=this._register(new D.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new D.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new D.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeVisibility=this._register(new D.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeData=this._register(new D.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new l.CancellationTokenSource,t.contributes&&t.contributes.views)for(const n in t.contributes.views)for(const o of t.contributes.views[n])o.id===w&&(this._title=o.name);this.dataProvider=b.treeDataProvider,this.dndController=b.dragAndDropController,this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(n=>this._onDidChangeData.fire({message:!1,element:n})));let i,r;this._register(D.Event.debounce(this._onDidChangeData.event,(n,o)=>(n||(n={message:!1,elements:[]}),o.element!==!1&&(i||(i=new Promise(g=>r=g),this.refreshPromise=this.refreshPromise.then(()=>i)),n.elements.push(o.element)),o.message&&(n.message=!0),n),200,!0)(({message:n,elements:o})=>{o.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const g=r;return i=null,this.refresh(o).then(()=>g())})),n&&this.proxy.$setMessage(this.viewId,this._message)}))}get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(w=>this.getExtensionElement(w)).filter(w=>!C.isUndefinedOrNull(w))}getChildren(w){const b=w?this.getExtensionElement(w):void 0;if(w&&!b)return this.logService.error(`No tree item with id '${w}' found.`),Promise.resolve([]);const u=this.getChildrenNodes(w);return(u?Promise.resolve(u):this.fetchChildrenNodes(b)).then(d=>d.map(p=>p.item))}getExtensionElement(w){return this.elements.get(w)}reveal(w,b){b=b||{select:!0,focus:!1};const u=C.isUndefinedOrNull(b.select)?!0:b.select,d=C.isUndefinedOrNull(b.focus)?!1:b.focus,p=C.isUndefinedOrNull(b.expand)?!1:b.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):w?this.refreshPromise.then(()=>this.resolveUnknownParentChain(w)).then(t=>this.resolveTreeNode(w,t[t.length-1]).then(i=>this.proxy.$reveal(this.viewId,{item:i.item,parentChain:t.map(r=>r.item)},{select:u,focus:d,expand:p})),t=>this.logService.error(t)):this.proxy.$reveal(this.viewId,void 0,{select:u,focus:d,expand:p})}get message(){return this._message}set message(w){this._message=w,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(w){this._title=w,this.proxy.$setTitle(this.viewId,w,this._description)}get description(){return this._description}set description(w){this._description=w,this.proxy.$setTitle(this.viewId,this._title,w)}setExpanded(w,b){const u=this.getExtensionElement(w);u&&(b?this._onDidExpandElement.fire(Object.freeze({element:u})):this._onDidCollapseElement.fire(Object.freeze({element:u})))}setSelection(w){s.equals(this._selectedHandles,w)||(this._selectedHandles=w,this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})))}setVisible(w){w!==this._visible&&(this._visible=w,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}onDrop(w,b){const u=w.map(p=>this.getExtensionElement(p)).filter(p=>!C.isUndefinedOrNull(p)),d=this.getExtensionElement(b);return u&&d?P.asPromise(()=>{var p;return(p=this.dndController)===null||p===void 0?void 0:p.onDrop(u,d)}):Promise.resolve(void 0)}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(w,b){var u;if(!this.dataProvider.resolveTreeItem)return;const d=this.elements.get(w);if(d){const p=this.nodes.get(d);if(p){const t=(u=await this.dataProvider.resolveTreeItem(p.extensionItem,d,b))!==null&&u!==void 0?u:p.extensionItem;return p.item.tooltip=this.getTooltip(t.tooltip),p.item.command=this.getCommand(p.disposableStore,t.command),p.item}}}resolveUnknownParentChain(w){return this.resolveParent(w).then(b=>b?this.resolveUnknownParentChain(b).then(u=>this.resolveTreeNode(b,u[u.length-1]).then(d=>(u.push(d),u))):Promise.resolve([]))}resolveParent(w){const b=this.nodes.get(w);return b?Promise.resolve(b.parent?this.elements.get(b.parent.item.handle):void 0):P.asPromise(()=>this.dataProvider.getParent(w))}resolveTreeNode(w,b){const u=this.nodes.get(w);return u?Promise.resolve(u):P.asPromise(()=>this.dataProvider.getTreeItem(w)).then(d=>this.createHandle(w,d,b,!0)).then(d=>this.getChildren(b?b.item.handle:void 0).then(()=>{const p=this.getExtensionElement(d);if(p){const t=this.nodes.get(p);if(t)return Promise.resolve(t)}throw new Error(`Cannot resolve tree item for element ${d}`)}))}getChildrenNodes(w){if(w){let b;if(typeof w=="string"){const u=this.getExtensionElement(w);b=u?this.nodes.get(u):void 0}else b=w;return b&&b.children||null}return this.roots}async fetchChildrenNodes(w){this.clearChildren(w);const b=new l.CancellationTokenSource(this._refreshCancellationSource.token);try{const u=w?this.nodes.get(w):void 0,d=await this.dataProvider.getChildren(w);if(b.token.isCancellationRequested)return[];const p=await Promise.all(s.coalesce(d||[]).map(async t=>{const i=await this.dataProvider.getTreeItem(t);return i&&!b.token.isCancellationRequested?this.createAndRegisterTreeNode(t,i,u):null}));return b.token.isCancellationRequested?[]:s.coalesce(p)}finally{b.dispose()}}refresh(w){if(w.some(u=>!u))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new l.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const u=this.getHandlesToRefresh(w);if(u.length)return this.refreshHandles(u)}return Promise.resolve(void 0)}getHandlesToRefresh(w){const b=new Set,u=w.map(p=>this.nodes.get(p));for(const p of u)if(p&&!b.has(p.item.handle)){let t=p;for(;t&&t.parent&&u.findIndex(i=>t&&t.parent&&i&&i.item.handle===t.parent.item.handle)===-1;){const i=this.elements.get(t.parent.item.handle);t=i?this.nodes.get(i):void 0}t&&!t.parent&&b.add(p.item.handle)}const d=[];return b.forEach(p=>{const t=this.elements.get(p);if(t){const i=this.nodes.get(t);i&&(!i.parent||!b.has(i.parent.item.handle))&&d.push(p)}}),d}refreshHandles(w){const b={};return Promise.all(w.map(u=>this.refreshNode(u).then(d=>{d&&(b[u]=d.item)}))).then(()=>Object.keys(b).length?this.proxy.$refresh(this.viewId,b):void 0)}refreshNode(w){const b=this.getExtensionElement(w);if(b){const u=this.nodes.get(b);if(u)return this.clearChildren(b),P.asPromise(()=>this.dataProvider.getTreeItem(b)).then(d=>{if(d){const p=this.createTreeNode(b,d,u.parent);return this.updateNodeCache(b,p,u,u.parent),u.dispose(),p}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(w,b,u){const d=this.createTreeNode(w,b,u);if(b.id&&this.elements.has(d.item.handle))throw new Error(v.localize(7,null,b.id));return this.addNodeToCache(w,d),this.addNodeToParentCache(d,u),d}getTooltip(w){return _.MarkdownString.isMarkdownString(w)?I.MarkdownString.from(w):w}getCommand(w,b){return b?this.commands.toInternal(b,w):void 0}createTreeNode(w,b,u){const d=new A.DisposableStore,p=this.createHandle(w,b,u),t=this.getLightIconPath(b);return{item:{handle:p,parentHandle:u?u.item.handle:void 0,label:m(b.label,this.extension),description:b.description,resourceUri:b.resourceUri,tooltip:this.getTooltip(b.tooltip),command:this.getCommand(d,b.command),contextValue:b.contextValue,icon:t,iconDark:this.getDarkIconPath(b)||t,themeIcon:this.getThemeIcon(b),collapsibleState:C.isUndefinedOrNull(b.collapsibleState)?_.TreeItemCollapsibleState.None:b.collapsibleState,accessibilityInformation:b.accessibilityInformation},extensionItem:b,parent:u,children:void 0,disposableStore:d,dispose(){d.dispose()}}}getThemeIcon(w){return w.iconPath instanceof _.ThemeIcon?w.iconPath:void 0}createHandle(w,{id:b,label:u,resourceUri:d},p,t){if(b)return`${h.ID_HANDLE_PREFIX}/${b}`;const i=m(u,this.extension),r=p?p.item.handle:h.LABEL_HANDLE_PREFIX;let n=i?i.label:d?R.basename(d):"";n=n.indexOf("/")!==-1?n.replace("/","//"):n;const o=this.nodes.has(w)?this.nodes.get(w).item.handle:void 0,g=this.getChildrenNodes(p)||[];let f,E=0;do{if(f=`${r}/${E}:${n}`,t||!this.elements.has(f)||o===f)break;E++}while(E<=g.length);return f}getLightIconPath(w){if(w.iconPath&&!(w.iconPath instanceof _.ThemeIcon))return typeof w.iconPath=="string"||k.URI.isUri(w.iconPath)?this.getIconPath(w.iconPath):this.getIconPath(w.iconPath.light)}getDarkIconPath(w){if(w.iconPath&&!(w.iconPath instanceof _.ThemeIcon)&&w.iconPath.dark)return this.getIconPath(w.iconPath.dark)}getIconPath(w){return k.URI.isUri(w)?w:k.URI.file(w)}addNodeToCache(w,b){this.elements.set(b.item.handle,w),this.nodes.set(w,b)}updateNodeCache(w,b,u,d){this.elements.delete(b.item.handle),this.nodes.delete(w),b.item.handle!==u.item.handle&&this.elements.delete(u.item.handle),this.addNodeToCache(w,b);const p=this.getChildrenNodes(d)||[],t=p.filter(i=>i.item.handle===u.item.handle)[0];t&&p.splice(p.indexOf(t),1,b)}addNodeToParentCache(w,b){b?(b.children||(b.children=[]),b.children.push(w)):(this.roots||(this.roots=[]),this.roots.push(w))}clearChildren(w){if(w){const b=this.nodes.get(w);if(b){if(b.children)for(const u of b.children){const d=this.elements.get(u.item.handle);d&&this.clear(d)}b.children=void 0}}else this.clearAll()}clear(w){const b=this.nodes.get(w);if(b){if(b.children)for(const u of b.children){const d=this.elements.get(u.item.handle);d&&this.clear(d)}this.nodes.delete(w),this.elements.delete(b.item.handle),b.dispose()}}clearAll(){this.roots=null,this.elements.clear(),this.nodes.forEach(w=>w.dispose()),this.nodes.clear()}dispose(){this._refreshCancellationSource.dispose(),this.clearAll()}}h.LABEL_HANDLE_PREFIX="0",h.ID_HANDLE_PREFIX="1"}),define(ge[210],pe([0,1,18,16,21,15,84,17,7,122]),function(Q,e,v,R,k,D,A,P,_,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SingleUseTestCollection=e.TestTree=e.TestPosition=e.OwnedTestCollection=void 0;class s{constructor(){this.testIdsToInternal=new Map}getTestById(S,w){if(w!==void 0){const b=this.testIdsToInternal.get(w),u=b==null?void 0:b.get(S);if(u)return[b,u]}return v.mapFind(this.testIdsToInternal.values(),b=>{const u=b.get(S);return u&&[b,u]})}createForHierarchy(S=()=>{}){return new c(this.createIdMap(l++),S)}createIdMap(S){const w=new m(S);return this.testIdsToInternal.set(w.id,w),{object:w,dispose:()=>this.testIdsToInternal.delete(w.id)}}}e.OwnedTestCollection=s;var I;(function(h){h[h.Disconnected=0]="Disconnected",h[h.IsChild=1]="IsChild",h[h.IsParent=2]="IsParent",h[h.IsSame=3]="IsSame"})(I=e.TestPosition||(e.TestPosition={}));let l=0;class m{constructor(S){this.id=S,this.map=new Map,this._roots=new Set,this.roots=this._roots}get size(){return this.map.size}add(S){if(this.map.has(S.item.extId))throw new Error(`Attempted to insert a duplicate test item ID ${S.item.extId}`);this.map.set(S.item.extId,S),S.parent||this._roots.add(S)}has(S){return this.map.has(S)}delete(S){const w=this.map.get(S);return w?(this.map.delete(S),this._roots.delete(w),!0):!1}get(S){return this.map.get(S)}comparePositions(S,w){const b=typeof S=="string"?this.map.get(S):S,u=typeof w=="string"?this.map.get(w):w;if(!b||!u)return 0;if(b===u)return 3;for(let d=this.map.get(u.parent);d;d=this.map.get(d.parent))if(d===b)return 1;for(let d=this.map.get(b.parent);d;d=this.map.get(d.parent))if(d===u)return 2;return 0}[Symbol.iterator](){return this.map.values()}}e.TestTree=m;class c{constructor(S,w){this.testIdToInternal=S,this.publishDiff=w,this.testItemToInternal=new Map,this.diff=[],this.debounceSendDiff=new R.RunOnceScheduler(()=>this.flushDiff(),200)}get treeId(){return this.testIdToInternal.object.id}addRoot(S,w){this.addItem(S,w,null)}getTestByReference(S){return this.testItemToInternal.get(S)}collectDiff(){const S=this.diff;return this.diff=[],S}pushDiff(S){const w=this.diff[this.diff.length-1];if(w&&S[0]===1){if(w[0]===1&&w[1].extId===S[1].extId){C.applyTestItemUpdate(w[1],S[1]);return}if(w[0]===0&&w[1].item.extId===S[1].extId){C.applyTestItemUpdate(w[1],S[1]);return}}this.diff.push(S),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(S,w){var b;const u=this.testIdToInternal.object.get(S);if(!!u){if((u.expandLevels===void 0||w>u.expandLevels)&&(u.expandLevels=w),u.expand===1){const d=this.refreshChildren(u);return d.isSettled?this.expandChildren(u,w-1):d.p.then(()=>this.expandChildren(u,w-1))}else if(u.expand===3)return((b=u.initialExpand)===null||b===void 0?void 0:b.isSettled)===!1?u.initialExpand.p.then(()=>this.expandChildren(u,w-1)):this.expandChildren(u,w-1)}}dispose(){var S;for(const w of this.testItemToInternal.values())(S=w.discoverCts)===null||S===void 0||S.dispose(!0),A.getPrivateApiFor(w.actual).bus.dispose();this.diff=[],this.testIdToInternal.dispose(),this.debounceSendDiff.dispose()}onTestItemEvent(S,w){const b=S==null?void 0:S.actual.id;switch(w[0]){case 2:this.pushDiff([4,b]);break;case 1:this.removeItem(S);break;case 0:this.addItem(w[1],S.src.controller,S);break;case 3:const[u,d,p]=w;switch(d){case"status":this.updateExpandability(S);break;case"range":this.pushDiff([1,{extId:b,item:{range:P.Range.from(p)}}]);break;case"error":this.pushDiff([1,{extId:b,item:{error:P.MarkdownString.fromStrict(p)||null}}]);break;default:this.pushDiff([1,{extId:b,item:{[d]:p??null}}]);break}break;default:D.assertNever(w[0])}}addItem(S,w,b){if(!(S instanceof _.TestItemImpl))throw new Error(`TestItems provided to the VS Code API must extend \`vscode.TestItem\`, but ${S.id} did not`);if(this.testItemToInternal.has(S))throw new Error(`Attempted to add a single TestItem ${S.id} multiple times to the tree`);if(this.testIdToInternal.object.has(S.id))throw new Error(`Attempted to insert a duplicate test item ID ${S.id}`);const u=b?b.item.extId:null,d=S.resolveHandler?1:0,p=b?b.expandLevels:1,t={controller:w,tree:this.testIdToInternal.object.id},i={actual:S,parent:u,item:P.TestItem.from(S),expandLevels:p?p-1:void 0,expand:0,src:t};this.testIdToInternal.object.add(i),this.testItemToInternal.set(S,i),this.pushDiff([0,{parent:u,src:t,expand:d,item:i.item}]);const r=A.getPrivateApiFor(S);r.parent=b==null?void 0:b.actual,r.bus.event(this.onTestItemEvent.bind(this,i)),this.updateExpandability(i);for(const n of r.children.values())this.testItemToInternal.has(n)||this.addItem(n,w,i)}updateExpandability(S){var w;let b;S.actual.resolveHandler?S.actual.status===_.TestItemStatus.Pending?b=S.discoverCts?2:1:((w=S.initialExpand)===null||w===void 0||w.complete(),b=3):b=0,b!==S.expand&&(S.expand=b,this.pushDiff([1,{extId:S.actual.id,expand:b}]),b===1&&S.expandLevels!==void 0&&this.refreshChildren(S))}expandChildren(S,w){if(w<0)return;const b=[...S.actual.children.values()].map(u=>this.expand(u.id,w)).filter(R.isThenable);if(b.length)return Promise.all(b).then(()=>{})}refreshChildren(S){if(S.discoverCts&&S.discoverCts.dispose(!0),!S.actual.resolveHandler){const w=new R.DeferredPromise;return w.complete(),w}return S.expand=2,S.discoverCts=new k.CancellationTokenSource,this.pushExpandStateUpdate(S),S.initialExpand=new R.DeferredPromise,S.actual.resolveHandler(S.discoverCts.token),S.initialExpand}pushExpandStateUpdate(S){this.pushDiff([1,{extId:S.actual.id,expand:S.expand}])}removeItem(S){var w;this.pushDiff([2,S.actual.id]);const b=[S];for(;b.length;){const u=b.pop();if(!!u){(w=u.discoverCts)===null||w===void 0||w.dispose(!0),this.testIdToInternal.object.delete(u.item.extId),this.testItemToInternal.delete(u.actual);for(const d of u.actual.children.values())b.push(this.testIdToInternal.object.get(d.id))}}}flushDiff(){const S=this.collectDiff();S.length&&this.publishDiff(S)}}e.SingleUseTestCollection=c}),define(ge[211],pe([0,1,4,176]),function(Q,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=v.refineServiceDecorator(R.IEnvironmentService)}),define(ge[212],pe([0,1,26,3,9]),function(Q,e,v,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class D{constructor(s){this.removedDueToLooping=s}}e.DeltaExtensionsResult=D;class A{constructor(s){this._onDidChange=new R.Emitter,this.onDidChange=this._onDidChange.event,this._extensionDescriptions=s,this._initialize()}_initialize(){this._extensionDescriptions.sort(_),this._extensionsMap=new Map,this._extensionsArr=[],this._activationMap=new Map;for(const s of this._extensionDescriptions){if(this._extensionsMap.has(v.ExtensionIdentifier.toKey(s.identifier))){console.error("Extension `"+s.identifier.value+"` is already registered");continue}if(this._extensionsMap.set(v.ExtensionIdentifier.toKey(s.identifier),s),this._extensionsArr.push(s),Array.isArray(s.activationEvents))for(let I of s.activationEvents)I==="onUri"&&(I=`onUri:${v.ExtensionIdentifier.toKey(s.identifier)}`),this._activationMap.has(I)||this._activationMap.set(I,[]),this._activationMap.get(I).push(s)}}keepOnly(s){const I=new Set;s.forEach(l=>I.add(v.ExtensionIdentifier.toKey(l))),this._extensionDescriptions=this._extensionDescriptions.filter(l=>I.has(v.ExtensionIdentifier.toKey(l.identifier))),this._initialize(),this._onDidChange.fire(void 0)}deltaExtensions(s,I){s.length>0&&(this._extensionDescriptions=this._extensionDescriptions.concat(s));const l=A._findLoopingExtensions(this._extensionDescriptions);if(I=I.concat(l.map(m=>m.identifier)),I.length>0){const m=new Set;I.forEach(c=>m.add(v.ExtensionIdentifier.toKey(c))),this._extensionDescriptions=this._extensionDescriptions.filter(c=>!m.has(v.ExtensionIdentifier.toKey(c.identifier)))}return this._initialize(),this._onDidChange.fire(void 0),new D(l)}static _findLoopingExtensions(s){const I=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(S){this._nodesSet.has(S)||(this._nodesSet.add(S),this._nodesArr.push(S))}addArc(S,w){this.addNode(S),this.addNode(w),this._arcs.has(S)?this._arcs.get(S).push(w):this._arcs.set(S,[w])}getArcs(S){return this._arcs.has(S)?this._arcs.get(S):[]}hasOnlyGoodArcs(S,w){const b=I.getArcs(S);for(let u=0;u<b.length;u++)if(!w.has(b[u]))return!1;return!0}getNodes(){return this._nodesArr}};let l=new Map;for(let S of s){const w=v.ExtensionIdentifier.toKey(S.identifier);if(l.set(w,S),S.extensionDependencies)for(let b of S.extensionDependencies){const u=v.ExtensionIdentifier.toKey(b);I.addArc(w,u)}}let m=new Set;I.getNodes().filter(S=>I.getArcs(S).length===0).forEach(S=>m.add(S));let c=I.getNodes().filter(S=>!m.has(S)),h;do{h=!1;for(let S=0;S<c.length;S++){const w=c[S];I.hasOnlyGoodArcs(w,m)&&(c.splice(S,1),S--,m.add(w),h=!0)}}while(h);return c.map(S=>l.get(S))}containsActivationEvent(s){return this._activationMap.has(s)}containsExtension(s){return this._extensionsMap.has(v.ExtensionIdentifier.toKey(s))}getExtensionDescriptionsForActivationEvent(s){const I=this._activationMap.get(s);return I?I.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getExtensionDescription(s){const I=this._extensionsMap.get(v.ExtensionIdentifier.toKey(s));return I||void 0}}e.ExtensionDescriptionRegistry=A;var P;(function(C){C[C.Builtin=0]="Builtin",C[C.User=1]="User",C[C.Dev=2]="Dev"})(P||(P={}));function _(C,s){const I=C.isBuiltin?0:C.isUnderDevelopment?2:1,l=s.isBuiltin?0:s.isUnderDevelopment?2:1;if(I!==l)return I-l;const m=k.posix.basename(C.extensionLocation.path),c=k.posix.basename(s.extensionLocation.path);return m<c?-1:m>c?1:0}}),define(ge[213],pe([0,1,22]),function(Q,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=void 0;var R;(function(P){P[P.VersionMismatch=55]="VersionMismatch",P[P.UnexpectedError=81]="UnexpectedError"})(R=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var k;(function(P){P[P.Initialized=0]="Initialized",P[P.Ready=1]="Ready",P[P.Terminate=2]="Terminate"})(k=e.MessageType||(e.MessageType={}));function D(P){const _=v.VSBuffer.alloc(1);switch(P){case 0:_.writeUInt8(1,0);break;case 1:_.writeUInt8(2,0);break;case 2:_.writeUInt8(3,0);break}return _}e.createMessageOfType=D;function A(P,_){if(P.byteLength!==1)return!1;switch(P.readUInt8(0)){case 1:return _===0;case 2:return _===1;case 3:return _===2;default:return!1}}e.isMessageOfType=A}),define(ge[35],pe([0,1,3,2,4,26,178]),function(Q,e,v,R,k,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.throwProposedApiError=e.checkProposedApiEnabled=e.ActivationKind=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.ExtensionHostKind=e.MissingExtensionDependency=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new D.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",enableProposedApi:!1,engines:{vscode:""},extensionLocation:R.URI.parse("void:location"),isBuiltin:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=k.createDecorator("extensionService");class P{constructor(b){this.dependency=b}}e.MissingExtensionDependency=P;var _;(function(w){w[w.LocalProcess=0]="LocalProcess",w[w.LocalWebWorker=1]="LocalWebWorker",w[w.Remote=2]="Remote"})(_=e.ExtensionHostKind||(e.ExtensionHostKind={}));class C{constructor(b,u,d,p){this.codeLoadingTime=b,this.activateCallTime=u,this.activateResolvedTime=d,this.activationReason=p}}e.ActivationTimes=C;class s{constructor(b,u){this.description=b,this.value=u}}e.ExtensionPointContribution=s,e.ExtensionHostLogFileName="exthost";var I;(function(w){w[w.Normal=0]="Normal",w[w.Immediate=1]="Immediate"})(I=e.ActivationKind||(e.ActivationKind={}));function l(w){w.enableProposedApi||m(w)}e.checkProposedApiEnabled=l;function m(w){throw new Error(`[${w.identifier.value}]: Proposed API is only available when running out of dev or with the following command line switch: --enable-proposed-api ${w.identifier.value}`)}e.throwProposedApiError=m;function c(w){return{type:w.isBuiltin?0:1,isBuiltin:w.isBuiltin||w.isUserBuiltin,identifier:{id:A.getGalleryExtensionId(w.publisher,w.name),uuid:w.uuid},manifest:w,location:w.extensionLocation}}e.toExtension=c;function h(w){return Object.assign(Object.assign({identifier:new D.ExtensionIdentifier(w.identifier.id),isBuiltin:w.type===0,isUserBuiltin:w.type===1&&w.isBuiltin,isUnderDevelopment:!1,extensionLocation:w.location},w.manifest),{uuid:w.identifier.uuid})}e.toExtensionDescription=h;class S{constructor(){this.onDidRegisterExtensions=v.Event.None,this.onDidChangeExtensionsStatus=v.Event.None,this.onDidChangeExtensions=v.Event.None,this.onWillActivateByEvent=v.Event.None,this.onDidChangeResponsiveChange=v.Event.None}activateByEvent(b){return Promise.resolve(void 0)}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtensions(){return Promise.resolve([])}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(b){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(b){return Promise.resolve(0)}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(b){}canAddExtension(){return!1}canRemoveExtension(){return!1}_activateById(b,u){return Promise.resolve()}_onWillActivateExtension(b){}_onDidActivateExtension(b,u,d,p,t){}_onDidActivateExtensionError(b,u){}_onExtensionRuntimeError(b,u){}_onExtensionHostExit(b){}}e.NullExtensionService=S}),define(ge[214],pe([0,1,26,35,12]),function(Q,e,v,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.FailedExtension=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;const D=Promise.resolve(void 0);class A{constructor(c,h,S,w){this.startup=c,this.codeLoadingTime=h,this.activateCallTime=S,this.activateResolvedTime=w}}e.ExtensionActivationTimes=A,A.NONE=new A(!1,-1,-1,-1);class P{constructor(c){this._startup=c,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(c,h){return c===-1||h===-1?-1:h-c}build(){return new A(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=P;class _{constructor(c,h,S,w,b,u){this.activationFailed=c,this.activationFailedError=h,this.activationTimes=S,this.module=w,this.exports=b,this.subscriptions=u}}e.ActivatedExtension=_;class C extends _{constructor(c){super(!1,null,c,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=C;class s extends _{constructor(){super(!1,null,A.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=s;class I extends _{constructor(c){super(!0,c,A.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.FailedExtension=I;let l=class{constructor(c,h,S,w,b){this._logService=b,this._registry=c,this._resolvedExtensionsSet=new Set,h.forEach(u=>this._resolvedExtensionsSet.add(v.ExtensionIdentifier.toKey(u))),this._hostExtensionsMap=new Map,S.forEach(u=>this._hostExtensionsMap.set(v.ExtensionIdentifier.toKey(u),u)),this._host=w,this._activatingExtensions=new Map,this._activatedExtensions=new Map,this._alreadyActivatedEvents=Object.create(null)}isActivated(c){const h=v.ExtensionIdentifier.toKey(c);return this._activatedExtensions.has(h)}getActivatedExtension(c){const h=v.ExtensionIdentifier.toKey(c),S=this._activatedExtensions.get(h);if(!S)throw new Error("Extension `"+c.value+"` is not known or not activated");return S}activateByEvent(c,h){if(this._alreadyActivatedEvents[c])return D;const S=this._registry.getExtensionDescriptionsForActivationEvent(c);return this._activateExtensions(S.map(w=>({id:w.identifier,reason:{startup:h,extensionId:w.identifier,activationEvent:c}}))).then(()=>{this._alreadyActivatedEvents[c]=!0})}activateById(c,h){const S=this._registry.getExtensionDescription(c);if(!S)throw new Error("Extension `"+c+"` is not known");return this._activateExtensions([{id:S.identifier,reason:h}])}_handleActivateRequest(c,h,S){if(this._hostExtensionsMap.has(v.ExtensionIdentifier.toKey(c.id))){h[v.ExtensionIdentifier.toKey(c.id)]=c;return}const w=this._registry.getExtensionDescription(c.id);if(!w){const d=new Error(`Cannot activate unknown extension '${c.id.value}'`);this._host.onExtensionActivationError(c.id,d,new R.MissingExtensionDependency(c.id.value)),this._activatedExtensions.set(v.ExtensionIdentifier.toKey(c.id),new I(d));return}const b=typeof w.extensionDependencies=="undefined"?[]:w.extensionDependencies;let u=!0;for(let d=0,p=b.length;d<p;d++){const t=b[d];if(this._resolvedExtensionsSet.has(v.ExtensionIdentifier.toKey(t)))continue;const i=this._activatedExtensions.get(v.ExtensionIdentifier.toKey(t));if(i&&!i.activationFailed)continue;if(i&&i.activationFailed){const g=w.displayName||w.identifier.value,f=this._registry.getExtensionDescription(t),E=f&&f.displayName||t,y=new Error(`Cannot activate the '${g}' extension because its dependency '${E}' failed to activate`);y.detail=i.activationFailedError,this._host.onExtensionActivationError(w.identifier,y,null),this._activatedExtensions.set(v.ExtensionIdentifier.toKey(w.identifier),new I(y));return}if(this._hostExtensionsMap.has(v.ExtensionIdentifier.toKey(t))){u=!1,h[v.ExtensionIdentifier.toKey(t)]={id:this._hostExtensionsMap.get(v.ExtensionIdentifier.toKey(t)),reason:c.reason};continue}const r=this._registry.getExtensionDescription(t);if(r){u=!1,h[v.ExtensionIdentifier.toKey(t)]={id:r.identifier,reason:c.reason};continue}const n=w.displayName||w.identifier.value,o=new Error(`Cannot activate the '${n}' extension because it depends on unknown extension '${t}'`);this._host.onExtensionActivationError(w.identifier,o,new R.MissingExtensionDependency(t)),this._activatedExtensions.set(v.ExtensionIdentifier.toKey(w.identifier),new I(o));return}u?h[v.ExtensionIdentifier.toKey(w.identifier)]=c:S.push(c)}_activateExtensions(c){if(c.length===0||(c=c.filter(b=>!this._activatedExtensions.has(v.ExtensionIdentifier.toKey(b.id))),c.length===0))return Promise.resolve(void 0);const h=Object.create(null),S=[];for(let b=0,u=c.length;b<u;b++)this._handleActivateRequest(c[b],h,S);for(let b=0,u=S.length;b<u;b++){const d=v.ExtensionIdentifier.toKey(S[b].id);h[d]&&delete h[d]}const w=Object.keys(h).map(b=>h[b]);return S.length===0?Promise.all(w.map(b=>this._activateExtension(b.id,b.reason))).then(b=>{}):this._activateExtensions(w).then(b=>this._activateExtensions(S))}_activateExtension(c,h){const S=v.ExtensionIdentifier.toKey(c);if(this._activatedExtensions.has(S))return Promise.resolve(void 0);const w=this._activatingExtensions.get(S);if(w)return w;const b=this._host.actualActivateExtension(c,h).then(void 0,u=>{const d=new Error;return u&&u.name&&(d.name=u.name),u&&u.message?d.message=`Activating extension '${c.value}' failed: ${u.message}.`:d.message=`Activating extension '${c.value}' failed: ${u}.`,u&&u.stack&&(d.stack=u.stack),this._host.onExtensionActivationError(c,d,null),this._logService.error(`Activating extension ${c.value} failed due to an error:`),this._logService.error(u),new I(u)}).then(u=>{this._activatedExtensions.set(S,u),this._activatingExtensions.delete(S)});return this._activatingExtensions.set(S,b),b}};l=Ve([$e(4,k.ILogService)],l),e.ExtensionsActivator=l}),define(ge[215],pe([0,1,12,35,27,10,114]),function(Q,e,v,R,k,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let P=class extends v.LogService{constructor(C){if(C.logFile.scheme!==D.Schemas.file)throw new Error("Only file-logging supported");super(new A.SpdLogLogger(R.ExtensionHostLogFileName,C.logFile.fsPath,!0,C.logLevel))}$setLevel(C){this.setLevel(C)}};P=Ve([$e(0,k.IExtHostInitDataService)],P),e.ExtHostLogService=P}),define(ge[216],pe([0,1,14]),function(Q,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LazyPromise=void 0;class R{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((D,A)=>{this._actualOk=D,this._actualErr=A,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(D){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=D,this._actual&&this._actualOk(D))}resolveErr(D){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=D,this._actual?this._actualErr(D):v.onUnexpectedError(D))}then(D,A){return this._ensureActual().then(D,A)}catch(D){return this._ensureActual().then(void 0,D)}finally(D){return this._ensureActual().finally(D)}}e.LazyPromise=R}),define(ge[125],pe([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getStringIdentifierForProxy=e.createExtHostContextProxyIdentifier=e.createMainContextProxyIdentifier=e.ProxyIdentifier=void 0;class v{constructor(_,C){this.isMain=_,this.sid=C,this.nid=++v.count}}e.ProxyIdentifier=v,v.count=0;const R=[];function k(P){const _=new v(!0,P);return R[_.nid]=_,_}e.createMainContextProxyIdentifier=k;function D(P){const _=new v(!1,P);return R[_.nid]=_,_}e.createExtHostContextProxyIdentifier=D;function A(P){return R[P].sid}e.getStringIdentifierForProxy=A}),define(ge[5],pe([0,1,54,2,125]),function(Q,e,v,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.reviveWorkspaceEditDto=e.WorkspaceEditType=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.ObjectIdentifier=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TextEditorRevealType=e.UIKind=void 0;var D;(function(u){u[u.Desktop=1]="Desktop",u[u.Web=2]="Web"})(D=e.UIKind||(e.UIKind={}));var A;(function(u){u[u.Default=0]="Default",u[u.InCenter=1]="InCenter",u[u.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",u[u.AtTop=3]="AtTop"})(A=e.TextEditorRevealType||(e.TextEditorRevealType={}));var P;(function(u){u[u.Editable=0]="Editable",u[u.SupportsHotExit=1]="SupportsHotExit"})(P=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var _;(function(u){u[u.Int8Array=1]="Int8Array",u[u.Uint8Array=2]="Uint8Array",u[u.Uint8ClampedArray=3]="Uint8ClampedArray",u[u.Int16Array=4]="Int16Array",u[u.Uint16Array=5]="Uint16Array",u[u.Int32Array=6]="Int32Array",u[u.Uint32Array=7]="Uint32Array",u[u.Float32Array=8]="Float32Array",u[u.Float64Array=9]="Float64Array",u[u.BigInt64Array=10]="BigInt64Array",u[u.BigUint64Array=11]="BigUint64Array"})(_=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var C;(function(u){u[u.Text=1]="Text",u[u.Error=2]="Error",u[u.Rich=3]="Rich"})(C=e.CellOutputKind||(e.CellOutputKind={}));var s;(function(u){u[u.Default=0]="Default",u[u.InCenter=1]="InCenter",u[u.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",u[u.AtTop=3]="AtTop"})(s=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var I;(function(u){u[u.None=0]="None",u[u.Process=1]="Process",u[u.Output=2]="Output"})(I=e.CandidatePortSource||(e.CandidatePortSource={}));var l;(function(u){u.name="$ident";function d(t,i){return Object.defineProperty(t,u.name,{value:i,enumerable:!0}),t}u.mixin=d;function p(t){return t[u.name]}u.of=p})(l=e.ObjectIdentifier||(e.ObjectIdentifier={}));class m{static mixin(d){return d._id=m._n++,d}}e.IdObject=m,m._n=0;var c;(function(u){u.label="a",u.kind="b",u.detail="c",u.documentation="d",u.sortText="e",u.filterText="f",u.preselect="g",u.insertText="h",u.insertTextRules="i",u.range="j",u.commitCharacters="k",u.additionalTextEdits="l",u.command="m",u.kindModifier="n",u.label2="o"})(c=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var h;(function(u){u.defaultRanges="a",u.completions="b",u.isIncomplete="c",u.duration="d"})(h=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var S;(function(u){u[u.File=1]="File",u[u.Text=2]="Text",u[u.Cell=3]="Cell"})(S=e.WorkspaceEditType||(e.WorkspaceEditType={}));function w(u){if(u&&u.edits)for(const d of u.edits)typeof d.resource=="object"?d.resource=R.URI.revive(d.resource):(d.newUri=R.URI.revive(d.newUri),d.oldUri=R.URI.revive(d.oldUri)),d.metadata&&d.metadata.iconPath&&(d.metadata=v.revive(d.metadata));return u}e.reviveWorkspaceEditDto=w;var b;(function(u){u[u.Workspace=0]="Workspace",u[u.TextDocument=1]="TextDocument"})(b=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:k.createMainContextProxyIdentifier("MainThreadAuthentication"),MainThreadBulkEdits:k.createMainContextProxyIdentifier("MainThreadBulkEdits"),MainThreadClipboard:k.createMainContextProxyIdentifier("MainThreadClipboard"),MainThreadCommands:k.createMainContextProxyIdentifier("MainThreadCommands"),MainThreadComments:k.createMainContextProxyIdentifier("MainThreadComments"),MainThreadConfiguration:k.createMainContextProxyIdentifier("MainThreadConfiguration"),MainThreadConsole:k.createMainContextProxyIdentifier("MainThreadConsole"),MainThreadDebugService:k.createMainContextProxyIdentifier("MainThreadDebugService"),MainThreadDecorations:k.createMainContextProxyIdentifier("MainThreadDecorations"),MainThreadDiagnostics:k.createMainContextProxyIdentifier("MainThreadDiagnostics"),MainThreadDialogs:k.createMainContextProxyIdentifier("MainThreadDiaglogs"),MainThreadDocuments:k.createMainContextProxyIdentifier("MainThreadDocuments"),MainThreadDocumentContentProviders:k.createMainContextProxyIdentifier("MainThreadDocumentContentProviders"),MainThreadTextEditors:k.createMainContextProxyIdentifier("MainThreadTextEditors"),MainThreadEditorInsets:k.createMainContextProxyIdentifier("MainThreadEditorInsets"),MainThreadEditorTabs:k.createMainContextProxyIdentifier("MainThreadEditorTabs"),MainThreadErrors:k.createMainContextProxyIdentifier("MainThreadErrors"),MainThreadTreeViews:k.createMainContextProxyIdentifier("MainThreadTreeViews"),MainThreadDownloadService:k.createMainContextProxyIdentifier("MainThreadDownloadService"),MainThreadKeytar:k.createMainContextProxyIdentifier("MainThreadKeytar"),MainThreadLanguageFeatures:k.createMainContextProxyIdentifier("MainThreadLanguageFeatures"),MainThreadLanguages:k.createMainContextProxyIdentifier("MainThreadLanguages"),MainThreadLog:k.createMainContextProxyIdentifier("MainThread"),MainThreadMessageService:k.createMainContextProxyIdentifier("MainThreadMessageService"),MainThreadOutputService:k.createMainContextProxyIdentifier("MainThreadOutputService"),MainThreadProgress:k.createMainContextProxyIdentifier("MainThreadProgress"),MainThreadQuickOpen:k.createMainContextProxyIdentifier("MainThreadQuickOpen"),MainThreadStatusBar:k.createMainContextProxyIdentifier("MainThreadStatusBar"),MainThreadSecretState:k.createMainContextProxyIdentifier("MainThreadSecretState"),MainThreadStorage:k.createMainContextProxyIdentifier("MainThreadStorage"),MainThreadTelemetry:k.createMainContextProxyIdentifier("MainThreadTelemetry"),MainThreadTerminalService:k.createMainContextProxyIdentifier("MainThreadTerminalService"),MainThreadWebviews:k.createMainContextProxyIdentifier("MainThreadWebviews"),MainThreadWebviewPanels:k.createMainContextProxyIdentifier("MainThreadWebviewPanels"),MainThreadWebviewViews:k.createMainContextProxyIdentifier("MainThreadWebviewViews"),MainThreadCustomEditors:k.createMainContextProxyIdentifier("MainThreadCustomEditors"),MainThreadUrls:k.createMainContextProxyIdentifier("MainThreadUrls"),MainThreadUriOpeners:k.createMainContextProxyIdentifier("MainThreadUriOpeners"),MainThreadWorkspace:k.createMainContextProxyIdentifier("MainThreadWorkspace"),MainThreadFileSystem:k.createMainContextProxyIdentifier("MainThreadFileSystem"),MainThreadExtensionService:k.createMainContextProxyIdentifier("MainThreadExtensionService"),MainThreadSCM:k.createMainContextProxyIdentifier("MainThreadSCM"),MainThreadSearch:k.createMainContextProxyIdentifier("MainThreadSearch"),MainThreadTask:k.createMainContextProxyIdentifier("MainThreadTask"),MainThreadWindow:k.createMainContextProxyIdentifier("MainThreadWindow"),MainThreadLabelService:k.createMainContextProxyIdentifier("MainThreadLabelService"),MainThreadNotebook:k.createMainContextProxyIdentifier("MainThreadNotebook"),MainThreadNotebookDocuments:k.createMainContextProxyIdentifier("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:k.createMainContextProxyIdentifier("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:k.createMainContextProxyIdentifier("MainThreadNotebookKernels"),MainThreadNotebookRenderers:k.createMainContextProxyIdentifier("MainThreadNotebookRenderers"),MainThreadTheming:k.createMainContextProxyIdentifier("MainThreadTheming"),MainThreadTunnelService:k.createMainContextProxyIdentifier("MainThreadTunnelService"),MainThreadTimeline:k.createMainContextProxyIdentifier("MainThreadTimeline"),MainThreadTesting:k.createMainContextProxyIdentifier("MainThreadTesting")},e.ExtHostContext={ExtHostCommands:k.createExtHostContextProxyIdentifier("ExtHostCommands"),ExtHostConfiguration:k.createExtHostContextProxyIdentifier("ExtHostConfiguration"),ExtHostDiagnostics:k.createExtHostContextProxyIdentifier("ExtHostDiagnostics"),ExtHostDebugService:k.createExtHostContextProxyIdentifier("ExtHostDebugService"),ExtHostDecorations:k.createExtHostContextProxyIdentifier("ExtHostDecorations"),ExtHostDocumentsAndEditors:k.createExtHostContextProxyIdentifier("ExtHostDocumentsAndEditors"),ExtHostDocuments:k.createExtHostContextProxyIdentifier("ExtHostDocuments"),ExtHostDocumentContentProviders:k.createExtHostContextProxyIdentifier("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:k.createExtHostContextProxyIdentifier("ExtHostDocumentSaveParticipant"),ExtHostEditors:k.createExtHostContextProxyIdentifier("ExtHostEditors"),ExtHostTreeViews:k.createExtHostContextProxyIdentifier("ExtHostTreeViews"),ExtHostFileSystem:k.createExtHostContextProxyIdentifier("ExtHostFileSystem"),ExtHostFileSystemInfo:k.createExtHostContextProxyIdentifier("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:k.createExtHostContextProxyIdentifier("ExtHostFileSystemEventService"),ExtHostLanguageFeatures:k.createExtHostContextProxyIdentifier("ExtHostLanguageFeatures"),ExtHostQuickOpen:k.createExtHostContextProxyIdentifier("ExtHostQuickOpen"),ExtHostExtensionService:k.createExtHostContextProxyIdentifier("ExtHostExtensionService"),ExtHostLogService:k.createExtHostContextProxyIdentifier("ExtHostLogService"),ExtHostTerminalService:k.createExtHostContextProxyIdentifier("ExtHostTerminalService"),ExtHostSCM:k.createExtHostContextProxyIdentifier("ExtHostSCM"),ExtHostSearch:k.createExtHostContextProxyIdentifier("ExtHostSearch"),ExtHostTask:k.createExtHostContextProxyIdentifier("ExtHostTask"),ExtHostWorkspace:k.createExtHostContextProxyIdentifier("ExtHostWorkspace"),ExtHostWindow:k.createExtHostContextProxyIdentifier("ExtHostWindow"),ExtHostWebviews:k.createExtHostContextProxyIdentifier("ExtHostWebviews"),ExtHostWebviewPanels:k.createExtHostContextProxyIdentifier("ExtHostWebviewPanels"),ExtHostCustomEditors:k.createExtHostContextProxyIdentifier("ExtHostCustomEditors"),ExtHostWebviewViews:k.createExtHostContextProxyIdentifier("ExtHostWebviewViews"),ExtHostEditorInsets:k.createExtHostContextProxyIdentifier("ExtHostEditorInsets"),ExtHostEditorTabs:k.createExtHostContextProxyIdentifier("ExtHostEditorTabs"),ExtHostProgress:k.createMainContextProxyIdentifier("ExtHostProgress"),ExtHostComments:k.createMainContextProxyIdentifier("ExtHostComments"),ExtHostSecretState:k.createMainContextProxyIdentifier("ExtHostSecretState"),ExtHostStorage:k.createMainContextProxyIdentifier("ExtHostStorage"),ExtHostUrls:k.createExtHostContextProxyIdentifier("ExtHostUrls"),ExtHostUriOpeners:k.createExtHostContextProxyIdentifier("ExtHostUriOpeners"),ExtHostOutputService:k.createMainContextProxyIdentifier("ExtHostOutputService"),ExtHosLabelService:k.createMainContextProxyIdentifier("ExtHostLabelService"),ExtHostNotebook:k.createMainContextProxyIdentifier("ExtHostNotebook"),ExtHostNotebookDocuments:k.createMainContextProxyIdentifier("ExtHostNotebookDocuments"),ExtHostNotebookEditors:k.createMainContextProxyIdentifier("ExtHostNotebookEditors"),ExtHostNotebookKernels:k.createMainContextProxyIdentifier("ExtHostNotebookKernels"),ExtHostNotebookRenderers:k.createMainContextProxyIdentifier("ExtHostNotebookRenderers"),ExtHostTheming:k.createMainContextProxyIdentifier("ExtHostTheming"),ExtHostTunnelService:k.createMainContextProxyIdentifier("ExtHostTunnelService"),ExtHostAuthentication:k.createMainContextProxyIdentifier("ExtHostAuthentication"),ExtHostTimeline:k.createMainContextProxyIdentifier("ExtHostTimeline"),ExtHostTesting:k.createMainContextProxyIdentifier("ExtHostTesting"),ExtHostTelemetry:k.createMainContextProxyIdentifier("ExtHostTelemetry")}}),define(ge[87],pe([0,1,5,3,4]),function(Q,e,v,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class D{constructor(P){this._onDidChangePassword=new R.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=P.getProxy(v.MainContext.MainThreadSecretState)}async $onDidChangePassword(P){this._onDidChangePassword.fire(P)}get(P,_){return this._proxy.$getPassword(P,_)}store(P,_,C){return this._proxy.$setPassword(P,_,C)}delete(P,_){return this._proxy.$deletePassword(P,_)}}e.ExtHostSecretState=D,e.IExtHostSecretState=k.createDecorator("IExtHostSecretState")}),define(ge[60],pe([0,1,4,12,5,13]),function(Q,e,v,R,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=v.createDecorator("IExtHostApiDeprecationService");let A=class{constructor(_,C){this._extHostLogService=C,this._reportedUsages=new Set,this._telemetryShape=_.getProxy(k.MainContext.MainThreadTelemetry)}report(_,C,s){const I=this.getUsageKey(_,C);this._reportedUsages.has(I)||(this._reportedUsages.add(I),C.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${_}' is deprecated. ${s}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:C.identifier.value,apiId:_}))}getUsageKey(_,C){return`${_}-${C.identifier.value}`}};A=Ve([$e(0,D.IExtHostRpcService),$e(1,R.ILogService)],A),e.ExtHostApiDeprecationService=A,e.NullApiDeprecationService=Object.freeze(new class{report(P,_,C){}})}),define(ge[217],pe([0,1,3,5,7,26]),function(Q,e,v,R,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class A{constructor(_){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeAuthenticationProviders=new v.Emitter,this.onDidChangeAuthenticationProviders=this._onDidChangeAuthenticationProviders.event,this._onDidChangeSessions=new v.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._inFlightRequests=new Map,this._proxy=_.getProxy(R.MainContext.MainThreadAuthentication)}$setProviders(_){return this._providers=_,Promise.resolve()}get providers(){return Object.freeze(this._providers.slice())}async getSession(_,C,s,I={}){const l=D.ExtensionIdentifier.toKey(_.identifier),m=this._inFlightRequests.get(l)||[],c=[...s].sort().join(" ");let h=m.find(S=>S.scopes===c);if(h)return h.result;{const S=this._getSession(_,l,C,s,I);h={scopes:c,result:S},m.push(h),this._inFlightRequests.set(l,m);try{await S}finally{const w=m.findIndex(b=>b.scopes===c);w>-1&&(m.splice(w),this._inFlightRequests.set(l,m))}return S}}async _getSession(_,C,s,I,l={}){await this._proxy.$ensureProvider(s);const m=_.displayName||_.name;return this._proxy.$getSession(s,I,C,m,l)}async removeSession(_,C){const s=this._authenticationProviders.get(_);return s?s.provider.removeSession(C):this._proxy.$removeSession(_,C)}registerAuthenticationProvider(_,C,s,I){var l;if(this._authenticationProviders.get(_))throw new Error(`An authentication provider with id '${_}' is already registered.`);this._authenticationProviders.set(_,{label:C,provider:s,options:I??{supportsMultipleAccounts:!1}}),this._providers.find(c=>c.id===_)||this._providers.push({id:_,label:C});const m=s.onDidChangeSessions(c=>{var h,S,w;this._proxy.$sendDidChangeSessions(_,{added:(h=c.added)!==null&&h!==void 0?h:[],changed:(S=c.changed)!==null&&S!==void 0?S:[],removed:(w=c.removed)!==null&&w!==void 0?w:[]})});return this._proxy.$registerAuthenticationProvider(_,C,(l=I==null?void 0:I.supportsMultipleAccounts)!==null&&l!==void 0?l:!1),new k.Disposable(()=>{m.dispose(),this._authenticationProviders.delete(_);const c=this._providers.findIndex(h=>h.id===_);c>-1&&this._providers.splice(c),this._proxy.$unregisterAuthenticationProvider(_)})}$createSession(_,C){const s=this._authenticationProviders.get(_);if(s)return Promise.resolve(s.provider.createSession(C));throw new Error(`Unable to find authentication provider with handle: ${_}`)}$removeSession(_,C){const s=this._authenticationProviders.get(_);if(s)return Promise.resolve(s.provider.removeSession(C));throw new Error(`Unable to find authentication provider with handle: ${_}`)}$getSessions(_,C){const s=this._authenticationProviders.get(_);if(s)return Promise.resolve(s.provider.getSessions(C));throw new Error(`Unable to find authentication provider with handle: ${_}`)}$onDidChangeAuthenticationSessions(_,C){return this._onDidChangeSessions.fire({provider:{id:_,label:C}}),Promise.resolve()}$onDidChangeAuthenticationProviders(_,C){return _.forEach(s=>{this._providers.some(I=>I.id===s.id)||this._providers.push(s)}),C.forEach(s=>{const I=this._providers.findIndex(l=>l.id===s.id);I>-1&&this._providers.splice(I)}),this._onDidChangeAuthenticationProviders.fire({added:_,removed:C}),Promise.resolve()}}e.ExtHostAuthentication=A}),define(ge[218],pe([0,1,5,13,17]),function(Q,e,v,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let D=class{constructor(P,_){this._extHostDocumentsAndEditors=_,this._proxy=P.getProxy(v.MainContext.MainThreadBulkEdits)}applyWorkspaceEdit(P){const _=k.WorkspaceEdit.from(P,this._extHostDocumentsAndEditors);return this._proxy.$tryApplyWorkspaceEdit(_)}};D=Ve([$e(0,R.IExtHostRpcService)],D),e.ExtHostBulkEdits=D}),define(ge[219],pe([0,1,5]),function(Q,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class R{constructor(D){const A=D.getProxy(v.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return A.$readText()},writeText(P){return A.$writeText(P)}})}}e.ExtHostClipboard=R}),define(ge[48],pe([0,1,15,7,17,25,5,18,12,54,41,44,2,6,4,13]),function(Q,e,v,R,k,D,A,P,_,C,s,I,l,m,c,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let S=class{constructor(t,i){this._commands=new Map,this._apiCommands=new Map,this._proxy=t.getProxy(A.MainContext.MainThreadCommands),this._logService=i,this.converter=new w(this,r=>{const n=this._apiCommands.get(r);return(n==null?void 0:n.result)===u.Void?n:void 0},i),this._argumentProcessors=[{processArgument(r){return C.revive(r)}},{processArgument(r){return D.cloneAndChange(r,function(n){if(s.Range.isIRange(n))return k.Range.to(n);if(I.Position.isIPosition(n))return k.Position.to(n);if(s.Range.isIRange(n.range)&&l.URI.isUri(n.uri))return k.location.to(n);if(!Array.isArray(n))return n})}}]}registerArgumentProcessor(t){this._argumentProcessors.push(t)}registerApiCommand(t){const i=this.registerCommand(!1,t.id,async(...r)=>{const n=t.args.map((g,f)=>{if(!g.validate(r[f]))throw new Error(`Invalid argument '${g.name}' when running '${t.id}', received: ${r[f]}`);return g.convert(r[f])}),o=await this.executeCommand(t.internalId,...n);return t.result.convert(o,r,this.converter)},void 0,{description:t.description,args:t.args,returns:t.result.description});return this._apiCommands.set(t.id,t),new R.Disposable(()=>{i.dispose(),this._apiCommands.delete(t.id)})}registerCommand(t,i,r,n,o){if(this._logService.trace("ExtHostCommands#registerCommand",i),!i.trim().length)throw new Error("invalid id");if(this._commands.has(i))throw new Error(`command '${i}' already exists`);return this._commands.set(i,{callback:r,thisArg:n,description:o}),t&&this._proxy.$registerCommand(i),new R.Disposable(()=>{this._commands.delete(i)&&t&&this._proxy.$unregisterCommand(i)})}executeCommand(t,...i){return this._logService.trace("ExtHostCommands#executeCommand",t),this._doExecuteCommand(t,i,!0)}async _doExecuteCommand(t,i,r){if(this._commands.has(t))return this._executeContributedCommand(t,i);{const n=D.cloneAndChange(i,function(o){if(o instanceof R.Position)return k.Position.from(o);if(o instanceof R.Range)return k.Range.from(o);if(o instanceof R.Location)return k.location.from(o);if(R.NotebookRange.isNotebookRange(o))return k.NotebookRange.from(o);if(!Array.isArray(o))return o});try{const o=await this._proxy.$executeCommand(t,n,r);return C.revive(o)}catch(o){if(o instanceof Error&&o.message==="$executeCommand:retry")return this._doExecuteCommand(t,i,!1);throw o}}}async _executeContributedCommand(t,i){const r=this._commands.get(t);if(!r)throw new Error("Unknown command");let{callback:n,thisArg:o,description:g}=r;if(g)for(let f=0;f<g.args.length;f++)try{v.validateConstraint(i[f],g.args[f].constraint)}catch(E){throw new Error(`Running the contributed command: '${t}' failed. Illegal argument '${g.args[f].name}' - ${g.args[f].description}`)}try{return await n.apply(o,i)}catch(f){if(t===this.converter.delegatingCommandId){const E=this.converter.getActualCommand(...i);E&&(t=E.command)}throw this._logService.error(f,t),new Error(`Running the contributed command: '${t}' failed.`)}}$executeContributedCommand(t,...i){return this._logService.trace("ExtHostCommands#$executeContributedCommand",t),this._commands.has(t)?(i=i.map(r=>this._argumentProcessors.reduce((n,o)=>o.processArgument(n),r)),this._executeContributedCommand(t,i)):Promise.reject(new Error(`Contributed command '${t}' does not exist.`))}getCommands(t=!1){return this._logService.trace("ExtHostCommands#getCommands",t),this._proxy.$getCommands().then(i=>(t&&(i=i.filter(r=>r[0]!=="_")),i))}$getContributedCommandHandlerDescriptions(){const t=Object.create(null);for(let[i,r]of this._commands){let{description:n}=r;n&&(t[i]=n)}return Promise.resolve(t)}};S=Ve([$e(0,h.IExtHostRpcService),$e(1,_.ILogService)],S),e.ExtHostCommands=S,e.IExtHostCommands=c.createDecorator("IExtHostCommands");class w{constructor(t,i,r){this._commands=t,this._lookupApiCommand=i,this._logService=r,this.delegatingCommandId=`_vscode_delegate_cmd_${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(t,i){if(!t)return;const r={$ident:void 0,id:t.command,title:t.title,tooltip:t.tooltip};if(!t.command)return r;const n=this._lookupApiCommand(t.command);if(n)r.id=n.internalId,r.arguments=n.args.map((o,g)=>o.convert(t.arguments&&t.arguments[g]));else if(P.isNonEmptyArray(t.arguments)){const o=++this._cachIdPool;this._cache.set(o,t),i.add(m.toDisposable(()=>{this._cache.delete(o),this._logService.trace("CommandsConverter#DISPOSE",o)})),r.$ident=o,r.id=this.delegatingCommandId,r.arguments=[o],this._logService.trace("CommandsConverter#CREATE",t.command,o)}return r}fromInternal(t){const i=A.ObjectIdentifier.of(t);return typeof i=="number"?this._cache.get(i):{command:t.id,title:t.title,arguments:t.arguments}}getActualCommand(...t){return this._cache.get(t[0])}_executeConvertedCommand(...t){const i=this.getActualCommand(...t);return this._logService.trace("CommandsConverter#EXECUTE",t[0],i?i.command:"MISSING"),i?this._commands.executeCommand(i.command,...i.arguments||[]):Promise.reject("actual command NOT FOUND")}}e.CommandsConverter=w;class b{constructor(t,i,r,n){this.name=t,this.description=i,this.validate=r,this.convert=n}optional(){return new b(this.name,`(optional) ${this.description}`,t=>t==null||this.validate(t),t=>t===void 0?void 0:t===null?null:this.convert(t))}with(t,i){return new b(t??this.name,i??this.description,this.validate,this.convert)}}e.ApiCommandArgument=b,b.Uri=new b("uri","Uri of a text document",p=>l.URI.isUri(p),p=>p),b.Position=new b("position","A position in a text document",p=>R.Position.isPosition(p),k.Position.from),b.Range=new b("range","A range in a text document",p=>R.Range.isRange(p),k.Range.from),b.Selection=new b("selection","A selection in a text document",p=>R.Selection.isSelection(p),k.Selection.from),b.Number=new b("number","",p=>typeof p=="number",p=>p),b.String=new b("string","",p=>typeof p=="string",p=>p),b.CallHierarchyItem=new b("item","A call hierarchy item",p=>p instanceof R.CallHierarchyItem,k.CallHierarchyItem.to);class u{constructor(t,i){this.description=t,this.convert=i}}e.ApiCommandResult=u,u.Void=new u("no result",p=>p);class d{constructor(t,i,r,n,o){this.id=t,this.internalId=i,this.description=r,this.args=n,this.result=o}}e.ApiCommand=d}),define(ge[220],pe([0,1,17,7,78,48,18,109]),function(Q,e,v,R,k,D,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const _=[new D.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",s(v.DocumentHighlight.to))),new D.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[D.ApiCommandArgument.Uri],new D.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(l,m)=>{if(A.isFalsyOrEmpty(l))return;class c extends R.SymbolInformation{static to(S){const w=new c(S.name,v.SymbolKind.to(S.kind),S.containerName||"",new R.Location(m[0],v.Range.to(S.range)));return w.detail=S.detail,w.range=w.location.range,w.selectionRange=v.Range.to(S.selectionRange),w.children=S.children?S.children.map(c.to):[],w}}return l.map(c.to)})),new D.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[D.ApiCommandArgument.Uri,new D.ApiCommandArgument("options","Formatting options",l=>!0,l=>l)],new D.ApiCommandResult("A promise that resolves to an array of TextEdits.",s(v.TextEdit.to))),new D.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Range,new D.ApiCommandArgument("options","Formatting options",l=>!0,l=>l)],new D.ApiCommandResult("A promise that resolves to an array of TextEdits.",s(v.TextEdit.to))),new D.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position,new D.ApiCommandArgument("ch","Trigger character",l=>typeof l=="string",l=>l),new D.ApiCommandArgument("options","Formatting options",l=>!0,l=>l)],new D.ApiCommandResult("A promise that resolves to an array of TextEdits.",s(v.TextEdit.to))),new D.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",I)),new D.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",I)),new D.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",I)),new D.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",I)),new D.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A promise that resolves to an array of Location-instances.",s(v.location.to))),new D.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A promise that resolves to an array of Hover-instances.",s(v.Hover.to))),new D.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[D.ApiCommandArgument.Uri,new D.ApiCommandArgument("position","A position in a text document",l=>Array.isArray(l)&&l.every(m=>R.Position.isPosition(m)),l=>l.map(v.Position.from))],new D.ApiCommandResult("A promise that resolves to an array of ranges.",l=>l.map(m=>{let c;for(const h of m.reverse())c=new R.SelectionRange(v.Range.to(h),c);return c}))),new D.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[D.ApiCommandArgument.String.with("query","Search string")],new D.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",l=>{const m=[];if(Array.isArray(l))for(let c of l)m.push(...c[1].map(v.WorkspaceSymbol.to));return m})),new D.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A CallHierarchyItem or undefined",l=>l.map(v.CallHierarchyItem.to))),new D.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[D.ApiCommandArgument.CallHierarchyItem],new D.ApiCommandResult("A CallHierarchyItem or undefined",l=>l.map(v.CallHierarchyIncomingCall.to))),new D.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[D.ApiCommandArgument.CallHierarchyItem],new D.ApiCommandResult("A CallHierarchyItem or undefined",l=>l.map(v.CallHierarchyOutgoingCall.to))),new D.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position,D.ApiCommandArgument.String.with("newName","The new symbol name")],new D.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",l=>{if(!!l){if(l.rejectReason)throw new Error(l.rejectReason);return v.WorkspaceEdit.to(l)}})),new D.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new D.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",l=>l.map(v.DocumentLink.to))),new D.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[D.ApiCommandArgument.Uri],new D.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",l=>{if(!!l)return new R.SemanticTokensLegend(l.tokenTypes,l.tokenModifiers)})),new D.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[D.ApiCommandArgument.Uri],new D.ApiCommandResult("A promise that resolves to SemanticTokens.",l=>{if(!l)return;const m=P.decodeSemanticTokensDto(l);if(m.type==="full")return new R.SemanticTokens(m.data,void 0)})),new D.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[D.ApiCommandArgument.Uri],new D.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",l=>{if(!!l)return new R.SemanticTokensLegend(l.tokenTypes,l.tokenModifiers)})),new D.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Range],new D.ApiCommandResult("A promise that resolves to SemanticTokens.",l=>{if(!l)return;const m=P.decodeSemanticTokensDto(l);if(m.type==="full")return new R.SemanticTokens(m.data,void 0)})),new D.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position,D.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),D.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new D.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(l,m,c)=>{if(!l)return new R.CompletionList([]);const h=l.suggestions.map(S=>v.CompletionItem.to(S,c));return new R.CompletionList(h,l.incomplete)})),new D.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position,D.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new D.ApiCommandResult("A promise that resolves to SignatureHelp.",l=>{if(l)return v.SignatureHelp.to(l)})),new D.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new D.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(l,m,c)=>s(h=>new R.CodeLens(v.Range.to(h.range),h.command&&c.fromInternal(h.command)))(l))),new D.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[D.ApiCommandArgument.Uri,new D.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",l=>R.Range.isRange(l),l=>R.Selection.isSelection(l)?v.Selection.from(l):v.Range.from(l)),D.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),D.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new D.ApiCommandResult("A promise that resolves to an array of Command-instances.",(l,m,c)=>s(h=>{if(h._isSynthetic){if(!h.command)throw new Error("Synthetic code actions must have a command");return c.fromInternal(h.command)}else{const S=new R.CodeAction(h.title,h.kind?new R.CodeActionKind(h.kind):void 0);return h.edit&&(S.edit=v.WorkspaceEdit.to(h.edit)),h.command&&(S.command=c.fromInternal(h.command)),S.isPreferred=h.isPreferred,S}})(l))),new D.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[D.ApiCommandArgument.Uri],new D.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",l=>l?l.map(m=>new R.ColorInformation(v.Range.to(m.range),v.Color.to(m.color))):[])),new D.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new D.ApiCommandArgument("color","The color to show and insert",l=>l instanceof R.Color,v.Color.from),new D.ApiCommandArgument("context","Context object with uri and range",l=>!0,l=>({uri:l.uri,range:v.Range.from(l.range)}))],new D.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",l=>l?l.map(v.ColorPresentation.to):[])),new D.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Range],new D.ApiCommandResult("A promise that resolves to an array of Inlay objects",l=>l.map(v.InlayHint.to))),new D.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new D.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",s(l=>({viewType:l.viewType,displayName:l.displayName,options:{transientOutputs:l.options.transientOutputs,transientCellMetadata:l.options.transientCellMetadata,transientDocumentMetadata:l.options.transientDocumentMetadata},filenamePattern:l.filenamePattern.map(m=>v.NotebookExclusiveDocumentPattern.to(m))})))),new D.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Range],new D.ApiCommandResult("A promise that resolves to an array of InlineValue objects",l=>l.map(v.InlineValue.to))),new D.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[D.ApiCommandArgument.Uri,new D.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",l=>l===void 0||typeof l=="number"||typeof l=="object",l=>l&&(typeof l=="number"?[l,void 0]:[v.ViewColumn.from(l.viewColumn),v.TextEditorOpenOptions.from(l)])).optional(),D.ApiCommandArgument.String.with("label","").optional()],D.ApiCommandResult.Void),new D.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[D.ApiCommandArgument.Uri.with("resource","Resource to open"),D.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new D.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",l=>l===void 0||typeof l=="number"||typeof l=="object",l=>l&&(typeof l=="number"?[l,void 0]:[v.ViewColumn.from(l.viewColumn),v.TextEditorOpenOptions.from(l)])).optional()],D.ApiCommandResult.Void),new D.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[D.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),D.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),D.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new D.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",l=>l===void 0||typeof l=="object",l=>l&&[v.ViewColumn.from(l.viewColumn),v.TextEditorOpenOptions.from(l)]).optional()],D.ApiCommandResult.Void)];class C{static register(m){_.forEach(m.registerApiCommand,m)}}e.ExtHostApiCommands=C;function s(l){return m=>{if(Array.isArray(m))return m.map(l)}}function I(l){if(!Array.isArray(l))return;const m=[];for(const c of l)k.isLocationLink(c)?m.push(v.DefinitionLink.to(c)):m.push(v.location.to(c));return m}}),define(ge[221],pe([0,1,16,51,3,6,2,78,26,17,7,5]),function(Q,e,v,R,k,D,A,P,_,C,s,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCommentThread=e.ExtHostComments=void 0;class l{constructor(d,p,t){this._documents=t,this._commentControllers=new Map,this._commentControllersByExtension=new Map,this._proxy=d.getProxy(I.MainContext.MainThreadComments),p.registerArgumentProcessor({processArgument:i=>{if(i&&i.$mid===6){const r=this._commentControllers.get(i.handle);return r||i}else if(i&&i.$mid===7){const r=this._commentControllers.get(i.commentControlHandle);if(!r)return i;const n=r.getCommentThread(i.commentThreadHandle);return n||i}else if(i&&i.$mid===8){const r=this._commentControllers.get(i.thread.commentControlHandle);if(!r)return i;const n=r.getCommentThread(i.thread.commentThreadHandle);return n?{thread:n,text:i.text}:i}else if(i&&i.$mid===9){const r=this._commentControllers.get(i.thread.commentControlHandle);if(!r)return i;const n=r.getCommentThread(i.thread.commentThreadHandle);if(!n)return i;let o=i.commentUniqueId,g=n.getCommentByUniqueId(o);return g||i}else if(i&&i.$mid===10){const r=this._commentControllers.get(i.thread.commentControlHandle);if(!r)return i;const n=r.getCommentThread(i.thread.commentThreadHandle);if(!n)return i;let o=i.text,g=i.commentUniqueId,f=n.getCommentByUniqueId(g);return f?(f.body=o,f):i}return i}})}createCommentController(d,p,t){const i=l.handlePool++,r=new c(d,i,this._proxy,p,t);this._commentControllers.set(r.handle,r);const n=this._commentControllersByExtension.get(_.ExtensionIdentifier.toKey(d.identifier))||[];return n.push(r),this._commentControllersByExtension.set(_.ExtensionIdentifier.toKey(d.identifier),n),r}$createCommentThreadTemplate(d,p,t){const i=this._commentControllers.get(d);!i||i.$createCommentThreadTemplate(p,t)}async $updateCommentThreadTemplate(d,p,t){const i=this._commentControllers.get(d);!i||i.$updateCommentThreadTemplate(p,t)}$deleteCommentThread(d,p){const t=this._commentControllers.get(d);t&&t.$deleteCommentThread(p)}$provideCommentingRanges(d,p,t){const i=this._commentControllers.get(d);if(!i||!i.commentingRangeProvider)return Promise.resolve(void 0);const r=this._documents.getDocument(A.URI.revive(p));return v.asPromise(()=>i.commentingRangeProvider.provideCommentingRanges(r,t)).then(n=>n?n.map(o=>C.Range.from(o)):void 0)}$toggleReaction(d,p,t,i,r){const n=this._commentControllers.get(d);return!n||!n.reactionHandler?Promise.resolve(void 0):v.asPromise(()=>{const o=n.getCommentThread(p);if(o){const g=o.getCommentByUniqueId(i.uniqueIdInThread);if(n!==void 0&&g&&n.reactionHandler)return n.reactionHandler(g,w(r))}return Promise.resolve(void 0)})}dispose(){}}e.ExtHostComments=l,l.handlePool=0;class m{constructor(d,p,t,i,r,n,o){this._proxy=d,this._commentController=p,this._id=t,this._uri=i,this._range=r,this._comments=n,this.handle=m._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new k.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new D.MutableDisposable,this._acceptInputDisposables.value=new D.DisposableStore,this._id===void 0&&(this._id=`${p.id}.${this.handle}`),this._proxy.$createCommentThread(this._commentController.handle,this.handle,this._id,this._uri,C.Range.from(this._range),o),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=n}set threadId(d){this._id=d}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(d){d.isEqual(this._range)||(this._range=d,this.modifications.range=d,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(d){this._canReply!==d&&(this._canReply=d,this.modifications.canReply=d,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(d){this._label=d,this.modifications.label=d,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(d){this._contextValue=d,this.modifications.contextValue=d,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(d){this._comments=d,this.modifications.comments=d,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(d){this._collapseState=d,this.modifications.collapsibleState=d,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}eventuallyUpdateCommentThread(){if(this._isDiposed)return;this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new D.DisposableStore);const d=t=>Object.prototype.hasOwnProperty.call(this.modifications,t),p={};d("range")&&(p.range=C.Range.from(this._range)),d("label")&&(p.label=this.label),d("contextValue")&&(p.contextValue=this.contextValue),d("comments")&&(p.comments=this._comments.map(t=>h(this,this._commentController,t,this._commentsMap))),d("collapsibleState")&&(p.collapseState=b(this._collapseState)),d("canReply")&&(p.canReply=this.canReply),this.modifications={},this._proxy.$updateCommentThread(this._commentController.handle,this.handle,this._id,this._uri,p)}getCommentByUniqueId(d){for(let p of this._commentsMap){let t=p[0],i=p[1];if(d===i)return t}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(d=>d.dispose()),this._proxy.$deleteCommentThread(this._commentController.handle,this.handle)}}m._handlePool=0,Ve([R.debounce(100)],m.prototype,"eventuallyUpdateCommentThread",null),e.ExtHostCommentThread=m;class c{constructor(d,p,t,i,r){this._extension=d,this._handle=p,this._proxy=t,this._id=i,this._label=r,this._threads=new Map,this._proxy.$registerCommentController(this.handle,i,r)}get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get reactionHandler(){return this._reactionHandler}set reactionHandler(d){this._reactionHandler=d,this._proxy.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!d})}get options(){return this._options}set options(d){this._options=d,this._proxy.$updateCommentControllerFeatures(this.handle,{options:this._options})}createCommentThread(d,p,t,i){if(typeof d=="string"){const r=new m(this._proxy,this,d,p,t,i,this._extension.identifier);return this._threads.set(r.handle,r),r}else{const r=new m(this._proxy,this,void 0,d,p,t,this._extension.identifier);return this._threads.set(r.handle,r),r}}$createCommentThreadTemplate(d,p){const t=new m(this._proxy,this,void 0,A.URI.revive(d),C.Range.to(p),[],this._extension.identifier);return t.collapsibleState=P.CommentThreadCollapsibleState.Expanded,this._threads.set(t.handle,t),t}$updateCommentThreadTemplate(d,p){let t=this._threads.get(d);t&&(t.range=C.Range.to(p))}$deleteCommentThread(d){let p=this._threads.get(d);p&&p.dispose(),this._threads.delete(d)}getCommentThread(d){return this._threads.get(d)}dispose(){this._threads.forEach(d=>{d.dispose()}),this._proxy.$unregisterCommentController(this.handle)}}function h(u,d,p,t){let i=t.get(p);i||(i=++u.commentHandle,t.set(p,i));const r=p.author&&p.author.iconPath?p.author.iconPath.toString():void 0;return{mode:p.mode,contextValue:p.contextValue,uniqueIdInThread:i,body:C.MarkdownString.from(p.body),userName:p.author.name,userIconPath:r,label:p.label,commentReactions:p.reactions?p.reactions.map(n=>S(n)):void 0}}function S(u){return{label:u.label,iconPath:u.iconPath?C.pathOrURIToURI(u.iconPath):void 0,count:u.count,hasReacted:u.authorHasReacted}}function w(u){return{label:u.label||"",count:u.count||0,iconPath:u.iconPath?A.URI.revive(u.iconPath):"",authorHasReacted:u.hasReacted||!1}}function b(u){if(u!==void 0)switch(u){case s.CommentThreadCollapsibleState.Expanded:return P.CommentThreadCollapsibleState.Expanded;case s.CommentThreadCollapsibleState.Collapsed:return P.CommentThreadCollapsibleState.Collapsed}return P.CommentThreadCollapsibleState.Collapsed}}),define(ge[126],pe([0,1,2,5,7,4,13,12,18,8,9]),function(Q,e,v,R,k,D,A,P,_,C,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let I=class _n{constructor(m,c){this._logService=c,this._provider=new Map,this._proxy=m.getProxy(R.MainContext.MainThreadDecorations)}registerFileDecorationProvider(m,c){const h=_n._handlePool++;this._provider.set(h,{provider:m,extensionId:c}),this._proxy.$registerDecorationProvider(h,c.value);const S=m.onDidChangeFileDecorations&&m.onDidChangeFileDecorations(w=>{if(!w){this._proxy.$onDidChange(h,null);return}let b=_.asArray(w);if(b.length<=_n._maxEventSize){this._proxy.$onDidChange(h,b);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",c.value,b.length);const u=b.map(t=>({uri:t,rank:C.count(t.path,"/")})),d=_.groupBy(u,(t,i)=>t.rank-i.rank||C.compare(t.uri.path,i.uri.path));let p=[];e:for(let t of d){let i;for(let r of t){let n=s.dirname(r.uri.path);if(i!==n&&(i=n,p.push(r.uri)>=_n._maxEventSize))break e}}this._proxy.$onDidChange(h,p)});return new k.Disposable(()=>{S==null||S.dispose(),this._proxy.$unregisterDecorationProvider(h),this._provider.delete(h)})}async $provideDecorations(m,c,h){if(!this._provider.has(m))return Object.create(null);const S=Object.create(null),{provider:w,extensionId:b}=this._provider.get(m);return await Promise.all(c.map(async u=>{try{const{uri:d,id:p}=u,t=await Promise.resolve(w.provideFileDecoration(v.URI.revive(d),h));if(!t)return;try{k.FileDecoration.validate(t),S[p]=[t.propagate,t.tooltip,t.badge,t.color]}catch(i){this._logService.warn(`INVALID decoration from extension '${b.value}': ${i}`)}}catch(d){this._logService.error(d)}})),S}};I._handlePool=0,I._maxEventSize=250,I=Ve([$e(0,A.IExtHostRpcService),$e(1,P.ILogService)],I),e.ExtHostDecorations=I,e.IExtHostDecorations=D.createDecorator("IExtHostDecorations")}),define(ge[222],pe([0,1,158,115,2,5,7,17,3,12,23]),function(Q,e,v,R,k,D,A,P,_,C,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class I{constructor(c,h,S,w,b){this._name=c,this._owner=h,this._maxDiagnosticsPerFile=S,this._proxy=w,this._onDidChangeDiagnostics=b,this._isDisposed=!1,this._data=new s.ResourceMap}dispose(){this._isDisposed||(this._onDidChangeDiagnostics.fire([...this._data.keys()]),this._proxy&&this._proxy.$clear(this._owner),this._data=void 0,this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(c,h){if(!c){this.clear();return}this._checkDisposed();let S=[];if(k.URI.isUri(c)){if(!h){this.delete(c);return}this._data.set(c,h.slice()),S=[c]}else if(Array.isArray(c)){S=[];let b;c=[...c].sort(I._compareIndexedTuplesByUri);for(const u of c){const[d,p]=u;if((!b||d.toString()!==b.toString())&&(b&&this._data.get(b).length===0&&this._data.delete(b),b=d,S.push(d),this._data.set(d,[])),p){const t=this._data.get(d);t&&t.push(...p)}else{const t=this._data.get(d);t&&(t.length=0)}}}if(this._onDidChangeDiagnostics.fire(S),!this._proxy)return;const w=[];for(let b of S){let u=[];const d=this._data.get(b);if(d)if(d.length>this._maxDiagnosticsPerFile){u=[];const p=[A.DiagnosticSeverity.Error,A.DiagnosticSeverity.Warning,A.DiagnosticSeverity.Information,A.DiagnosticSeverity.Hint];e:for(let t=0;t<4;t++)for(let i of d)if(i.severity===p[t]&&u.push(P.Diagnostic.from(i))===this._maxDiagnosticsPerFile)break e;u.push({severity:R.MarkerSeverity.Info,message:v.localize(0,null,d.length-this._maxDiagnosticsPerFile),startLineNumber:u[u.length-1].startLineNumber,startColumn:u[u.length-1].startColumn,endLineNumber:u[u.length-1].endLineNumber,endColumn:u[u.length-1].endColumn})}else u=d.map(p=>P.Diagnostic.from(p));w.push([b,u])}this._proxy.$changeMany(this._owner,w)}delete(c){this._checkDisposed(),this._onDidChangeDiagnostics.fire([c]),this._data.delete(c),this._proxy&&this._proxy.$changeMany(this._owner,[[c,void 0]])}clear(){this._checkDisposed(),this._onDidChangeDiagnostics.fire([...this._data.keys()]),this._data.clear(),this._proxy&&this._proxy.$clear(this._owner)}forEach(c,h){this._checkDisposed();for(let S of this._data.keys())c.apply(h,[S,this.get(S),this])}get(c){this._checkDisposed();const h=this._data.get(c);return Array.isArray(h)?Object.freeze(h.slice(0)):[]}has(c){return this._checkDisposed(),Array.isArray(this._data.get(c))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(c,h){return c[0].toString()<h[0].toString()?-1:c[0].toString()>h[0].toString()?1:0}}e.DiagnosticCollection=I;let l=class Gt{constructor(c,h){this._logService=h,this._collections=new Map,this._onDidChangeDiagnostics=new _.Emitter,this.onDidChangeDiagnostics=_.Event.map(_.Event.debounce(this._onDidChangeDiagnostics.event,Gt._debouncer,50),Gt._mapper),this._proxy=c.getProxy(D.MainContext.MainThreadDiagnostics)}static _debouncer(c,h){return c?c.concat(h):h}static _mapper(c){const h=new s.ResourceMap;for(const S of c)h.set(S,S);return{uris:Object.freeze(Array.from(h.values()))}}createDiagnosticCollection(c,h){const{_collections:S,_proxy:w,_onDidChangeDiagnostics:b,_logService:u}=this,d=new class{$changeMany(i,r){w.$changeMany(i,r),u.trace("[DiagnosticCollection] change many (extension, owner, uris)",c.value,i,r.length===0?"CLEARING":r)}$clear(i){w.$clear(i),u.trace("[DiagnosticCollection] remove all (extension, owner)",c.value,i)}dispose(){w.dispose()}};let p;if(!h)h="_generated_diagnostic_collection_name_#"+Gt._idPool++,p=h;else if(!S.has(h))p=h;else{this._logService.warn(`DiagnosticCollection with name '${h}' does already exist.`);do p=h+Gt._idPool++;while(S.has(p))}return new class extends I{constructor(){super(h,p,Gt._maxDiagnosticsPerFile,d,b);S.set(p,this)}dispose(){super.dispose(),S.delete(p)}}}getDiagnostics(c){if(c)return this._getDiagnostics(c);{const h=new Map,S=[];for(const w of this._collections.values())w.forEach((b,u)=>{let d=h.get(b.toString());typeof d=="undefined"&&(d=S.length,h.set(b.toString(),d),S.push([b,[]])),S[d][1]=S[d][1].concat(...u)});return S}}_getDiagnostics(c){let h=[];for(let S of this._collections.values())S.has(c)&&(h=h.concat(S.get(c)));return h}$acceptMarkersChange(c){if(!this._mirrorCollection){const h="_generated_mirror",S=new I(h,h,Gt._maxDiagnosticsPerFile,void 0,this._onDidChangeDiagnostics);this._collections.set(h,S),this._mirrorCollection=S}for(const[h,S]of c)this._mirrorCollection.set(k.URI.revive(h),S.map(P.Diagnostic.to))}};l._idPool=0,l._maxDiagnosticsPerFile=1e3,l=Ve([$e(1,C.ILogService)],l),e.ExtHostDiagnostics=l}),define(ge[223],pe([0,1,2,5]),function(Q,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class k{constructor(A){this._proxy=A.getProxy(R.MainContext.MainThreadDialogs)}showOpenDialog(A){return this._proxy.$showOpenDialog(A).then(P=>P?P.map(_=>v.URI.revive(_)):void 0)}showSaveDialog(A){return this._proxy.$showSaveDialog(A).then(P=>P?v.URI.revive(P):void 0)}}e.ExtHostDialogs=k}),define(ge[224],pe([0,1,14,2,7,5,10,21,8]),function(Q,e,v,R,k,D,A,P,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class C{constructor(I,l,m){this._documentsAndEditors=l,this._logService=m,this._documentContentProviders=new Map,this._proxy=I.getProxy(D.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(I,l){if(Object.keys(A.Schemas).indexOf(I)>=0)throw new Error(`scheme '${I}' already registered`);const m=C._handlePool++;this._documentContentProviders.set(m,l),this._proxy.$registerTextContentProvider(m,I);let c;return typeof l.onDidChange=="function"&&(c=l.onDidChange(h=>{if(h.scheme!==I){this._logService.warn(`Provider for scheme '${I}' is firing event for schema '${h.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(h)&&this.$provideTextDocumentContent(m,h).then(S=>{if(!S&&typeof S!="string")return;const w=this._documentsAndEditors.getDocument(h);if(!w)return;const b=_.splitLines(S);if(!w.equalLines(b))return this._proxy.$onVirtualDocumentChange(h,S)},v.onUnexpectedError)})),new k.Disposable(()=>{this._documentContentProviders.delete(m)&&this._proxy.$unregisterTextContentProvider(m),c&&(c.dispose(),c=void 0)})}$provideTextDocumentContent(I,l){const m=this._documentContentProviders.get(I);return m?Promise.resolve(m.provideTextDocumentContent(R.URI.revive(l),P.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${l.scheme}`))}}e.ExtHostDocumentContentProvider=C,C._handlePool=0}),define(ge[225],pe([0,1,3,6,2,5,119,17,15,25]),function(Q,e,v,R,k,D,A,P,_,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class s{constructor(l,m){this._onDidAddDocument=new v.Emitter,this._onDidRemoveDocument=new v.Emitter,this._onDidChangeDocument=new v.Emitter,this._onDidSaveDocument=new v.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new R.DisposableStore,this._documentLoader=new Map,this._proxy=l.getProxy(D.MainContext.MainThreadDocuments),this._documentsAndEditors=m,this._documentsAndEditors.onDidRemoveDocuments(c=>{for(const h of c)this._onDidRemoveDocument.fire(h.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(c=>{for(const h of c)this._onDidAddDocument.fire(h.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(l){if(!l)return;const m=this._documentsAndEditors.getDocument(l);if(m)return m}getDocument(l){const m=this.getDocumentData(l);if(!(m==null?void 0:m.document))throw new Error(`Unable to retrieve document from URI '${l}'`);return m.document}ensureDocumentData(l){const m=this._documentsAndEditors.getDocument(l);if(m)return Promise.resolve(m);let c=this._documentLoader.get(l.toString());return c||(c=this._proxy.$tryOpenDocument(l).then(h=>{this._documentLoader.delete(l.toString());const S=k.URI.revive(h);return _.assertIsDefined(this._documentsAndEditors.getDocument(S))},h=>(this._documentLoader.delete(l.toString()),Promise.reject(h))),this._documentLoader.set(l.toString(),c)),c}createDocumentData(l){return this._proxy.$tryCreateDocument(l).then(m=>k.URI.revive(m))}$acceptModelModeChanged(l,m){const c=k.URI.revive(l),h=this._documentsAndEditors.getDocument(c);if(!h)throw new Error("unknown document");this._onDidRemoveDocument.fire(h.document),h._acceptLanguageId(m),this._onDidAddDocument.fire(h.document)}$acceptModelSaved(l){const m=k.URI.revive(l),c=this._documentsAndEditors.getDocument(m);if(!c)throw new Error("unknown document");this.$acceptDirtyStateChanged(l,!1),this._onDidSaveDocument.fire(c.document)}$acceptDirtyStateChanged(l,m){const c=k.URI.revive(l),h=this._documentsAndEditors.getDocument(c);if(!h)throw new Error("unknown document");h._acceptIsDirty(m),this._onDidChangeDocument.fire({document:h.document,contentChanges:[]})}$acceptModelChanged(l,m,c){const h=k.URI.revive(l),S=this._documentsAndEditors.getDocument(h);if(!S)throw new Error("unknown document");S._acceptIsDirty(c),S.onEvents(m),this._onDidChangeDocument.fire(C.deepFreeze({document:S.document,contentChanges:m.changes.map(w=>({range:P.Range.to(w.range),rangeOffset:w.rangeOffset,rangeLength:w.rangeLength,text:w.text}))}))}setWordDefinitionFor(l,m){A.setWordDefinitionFor(l,m)}}e.ExtHostDocuments=s}),define(ge[39],pe([0,1,50,3,6,2,4,5,119,13,124,17,12,23,10,70,134]),function(Q,e,v,R,k,D,A,P,_,C,s,I,l,m,c,h,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class w{constructor(d){this.value=d,this._count=0}ref(){this._count++}unref(){return--this._count==0}}let b=class{constructor(d,p){this._extHostRpc=d,this._logService=p,this._activeEditorId=null,this._editors=new Map,this._documents=new m.ResourceMap,this._onDidAddDocuments=new R.Emitter,this._onDidRemoveDocuments=new R.Emitter,this._onDidChangeVisibleTextEditors=new R.Emitter,this._onDidChangeActiveTextEditor=new R.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(d){this.acceptDocumentsAndEditorsDelta(d)}acceptDocumentsAndEditorsDelta(d){const p=[],t=[],i=[];if(d.removedDocuments)for(const r of d.removedDocuments){const n=D.URI.revive(r),o=this._documents.get(n);(o==null?void 0:o.unref())&&(this._documents.delete(n),p.push(o.value))}if(d.addedDocuments)for(const r of d.addedDocuments){const n=D.URI.revive(r.uri);let o=this._documents.get(n);if(o&&n.scheme!==c.Schemas.vscodeNotebookCell)throw new Error(`document '${n} already exists!'`);o||(o=new w(new _.ExtHostDocumentData(this._extHostRpc.getProxy(P.MainContext.MainThreadDocuments),n,r.lines,r.EOL,r.versionId,r.modeId,r.isDirty,r.notebook)),this._documents.set(n,o),t.push(o.value)),o.ref()}if(d.removedEditors)for(const r of d.removedEditors){const n=this._editors.get(r);this._editors.delete(r),n&&i.push(n)}if(d.addedEditors)for(const r of d.addedEditors){const n=D.URI.revive(r.documentUri);v.ok(this._documents.has(n),`document '${n}' does not exist`),v.ok(!this._editors.has(r.id),`editor '${r.id}' already exists!`);const o=this._documents.get(n).value,g=new s.ExtHostTextEditor(r.id,this._extHostRpc.getProxy(P.MainContext.MainThreadTextEditors),this._logService,new S.Lazy(()=>o.document),r.selections.map(I.Selection.to),r.options,r.visibleRanges.map(f=>I.Range.to(f)),typeof r.editorPosition=="number"?I.ViewColumn.to(r.editorPosition):void 0);this._editors.set(r.id,g)}d.newActiveEditor!==void 0&&(v.ok(d.newActiveEditor===null||this._editors.has(d.newActiveEditor),`active editor '${d.newActiveEditor}' does not exist`),this._activeEditorId=d.newActiveEditor),k.dispose(p),k.dispose(i),d.removedDocuments&&this._onDidRemoveDocuments.fire(p),d.addedDocuments&&this._onDidAddDocuments.fire(t),(d.removedEditors||d.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(r=>r.value)),d.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(d){var p;return(p=this._documents.get(d))===null||p===void 0?void 0:p.value}allDocuments(){return h.Iterable.map(this._documents.values(),d=>d.value)}getEditor(d){return this._editors.get(d)}activeEditor(d){if(!this._activeEditorId)return;const p=this._editors.get(this._activeEditorId);return d?p:p==null?void 0:p.value}allEditors(){return[...this._editors.values()]}};b=Ve([$e(0,C.IExtHostRpcService),$e(1,l.ILogService)],b),e.ExtHostDocumentsAndEditors=b,e.IExtHostDocumentsAndEditors=A.createDecorator("IExtHostDocumentsAndEditors")}),define(ge[226],pe([0,1,2,5,6,7,17,142,8,22]),function(Q,e,v,R,k,D,A,P,_,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class s{constructor(){this._schemes=[]}add(m){this._stateMachine=void 0,this._schemes.push(m)}delete(m){const c=this._schemes.indexOf(m);c>=0&&(this._schemes.splice(c,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const m=this._schemes.sort(),c=[];let h,S,w=14,b=14;for(const u of m){let d=h?_.commonPrefixLength(h,u):0;for(d===0?S=1:S=b;d<u.length;d++)d+1===u.length?(w=b,b=9):b+=1,c.push([S,u.toUpperCase().charCodeAt(d),b]),c.push([S,u.toLowerCase().charCodeAt(d),b]),S=b;h=u,b=w}c.push([9,58,10]),c.push([10,47,12]),this._stateMachine=new P.StateMachine(c)}}provideDocumentLinks(m){this._initStateMachine();const c=[],h=P.LinkComputer.computeLinks({getLineContent(S){return m.lineAt(S-1).text},getLineCount(){return m.lineCount}},this._stateMachine);for(const S of h){const w=A.DocumentLink.to(S);w.target&&c.push(w)}return c}}class I{constructor(m,c){this._extHostLanguageFeatures=c,this._linkProvider=new s,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._enableProposedApi=new Map,this._handlePool=0,this._proxy=m.getProxy(R.MainContext.MainThreadFileSystem)}dispose(){var m;(m=this._linkProviderRegistration)===null||m===void 0||m.dispose()}_registerLinkProviderIfNotYetRegistered(){this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(void 0,"*",this._linkProvider))}registerFileSystemProvider(m,c,h,S={},w){if(this._registeredSchemes.has(c))throw new Error(`a provider for the scheme '${c}' is already registered`);this._registerLinkProviderIfNotYetRegistered();const b=this._handlePool++;this._linkProvider.add(c),this._registeredSchemes.add(c),this._fsProvider.set(b,h),this._enableProposedApi.set(b,w??!1);let u=2;S.isCaseSensitive&&(u+=1024),S.isReadonly&&(u+=2048),typeof h.copy=="function"&&(u+=8),typeof h.open=="function"&&typeof h.close=="function"&&typeof h.read=="function"&&typeof h.write=="function"&&(u+=4),this._proxy.$registerFileSystemProvider(b,c,u).catch(p=>{console.error(`FAILED to register filesystem provider of ${m.value}-extension for the scheme ${c}`),console.error(p)});const d=h.onDidChangeFile(p=>{const t=[];for(const i of p){let{uri:r,type:n}=i;if(r.scheme!==c)continue;let o;switch(n){case D.FileChangeType.Changed:o=0;break;case D.FileChangeType.Created:o=1;break;case D.FileChangeType.Deleted:o=2;break;default:throw new Error("Unknown FileChangeType")}t.push({resource:r,type:o})}this._proxy.$onFileSystemChange(b,t)});return k.toDisposable(()=>{d.dispose(),this._linkProvider.delete(c),this._registeredSchemes.delete(c),this._fsProvider.delete(b),this._enableProposedApi.delete(b),this._proxy.$unregisterProvider(b)})}static _asIStat(m,c){const{type:h,ctime:S,mtime:w,size:b,permissions:u}=m;return c?{type:h,ctime:S,mtime:w,size:b,permissions:u}:{type:h,ctime:S,mtime:w,size:b}}$stat(m,c){return Promise.resolve(this._getFsProvider(m).stat(v.URI.revive(c))).then(h=>{var S;return I._asIStat(h,(S=this._enableProposedApi.get(m))!==null&&S!==void 0?S:!1)})}$readdir(m,c){return Promise.resolve(this._getFsProvider(m).readDirectory(v.URI.revive(c)))}$readFile(m,c){return Promise.resolve(this._getFsProvider(m).readFile(v.URI.revive(c))).then(h=>C.VSBuffer.wrap(h))}$writeFile(m,c,h,S){return Promise.resolve(this._getFsProvider(m).writeFile(v.URI.revive(c),h.buffer,S))}$delete(m,c,h){return Promise.resolve(this._getFsProvider(m).delete(v.URI.revive(c),h))}$rename(m,c,h,S){return Promise.resolve(this._getFsProvider(m).rename(v.URI.revive(c),v.URI.revive(h),S))}$copy(m,c,h,S){const w=this._getFsProvider(m);if(!w.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(w.copy(v.URI.revive(c),v.URI.revive(h),S))}$mkdir(m,c){return Promise.resolve(this._getFsProvider(m).createDirectory(v.URI.revive(c)))}$watch(m,c,h,S){const w=this._getFsProvider(m).watch(v.URI.revive(h),S);this._watches.set(c,w)}$unwatch(m,c){const h=this._watches.get(c);h&&(h.dispose(),this._watches.delete(c))}$open(m,c,h){const S=this._getFsProvider(m);if(!S.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(S.open(v.URI.revive(c),h))}$close(m,c){const h=this._getFsProvider(m);if(!h.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(h.close(c))}$read(m,c,h,S){const w=this._getFsProvider(m);if(!w.read)throw new Error('FileSystemProvider does not implement "read"');const b=C.VSBuffer.alloc(S);return Promise.resolve(w.read(c,h,b.buffer,0,S)).then(u=>b.slice(0,u))}$write(m,c,h,S){const w=this._getFsProvider(m);if(!w.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(w.write(c,h,S.buffer,0,S.byteLength))}_getFsProvider(m){const c=this._fsProvider.get(m);if(!c){const h=new Error;throw h.name="ENOPRO",h.message="no provider",h}return c}}e.ExtHostFileSystem=I}),define(ge[88],pe([0,1,5,42,7,22,4,13,58]),function(Q,e,v,R,k,D,A,P,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let C=class Nt{constructor(I,l){const m=I.getProxy(v.MainContext.MainThreadFileSystem);this.value=Object.freeze({stat(c){return m.$stat(c).catch(Nt._handleError)},readDirectory(c){return m.$readdir(c).catch(Nt._handleError)},createDirectory(c){return m.$mkdir(c).catch(Nt._handleError)},async readFile(c){return m.$readFile(c).then(h=>h.buffer).catch(Nt._handleError)},writeFile(c,h){return m.$writeFile(c,D.VSBuffer.wrap(h)).catch(Nt._handleError)},delete(c,h){return m.$delete(c,Object.assign({recursive:!1,useTrash:!1},h)).catch(Nt._handleError)},rename(c,h,S){return m.$rename(c,h,Object.assign({overwrite:!1},S)).catch(Nt._handleError)},copy(c,h,S){return m.$copy(c,h,Object.assign({overwrite:!1},S)).catch(Nt._handleError)},isWritableFileSystem(c){const h=l.getCapabilities(c);if(typeof h=="number")return!(h&2048)}})}static _handleError(I){if(!(I instanceof Error))throw new k.FileSystemError(String(I));if(I.name==="ENOPRO")throw k.FileSystemError.Unavailable(I.message);switch(I.name){case R.FileSystemProviderErrorCode.FileExists:throw k.FileSystemError.FileExists(I.message);case R.FileSystemProviderErrorCode.FileNotFound:throw k.FileSystemError.FileNotFound(I.message);case R.FileSystemProviderErrorCode.FileNotADirectory:throw k.FileSystemError.FileNotADirectory(I.message);case R.FileSystemProviderErrorCode.FileIsADirectory:throw k.FileSystemError.FileIsADirectory(I.message);case R.FileSystemProviderErrorCode.NoPermissions:throw k.FileSystemError.NoPermissions(I.message);case R.FileSystemProviderErrorCode.Unavailable:throw k.FileSystemError.Unavailable(I.message);default:throw new k.FileSystemError(I.message,I.name)}}};C=Ve([$e(0,P.IExtHostRpcService),$e(1,_.IExtHostFileSystemInfo)],C),e.ExtHostConsumerFileSystem=C,e.IExtHostConsumerFileSystem=A.createDecorator("IExtHostConsumerFileSystem")}),define(ge[227],pe([0,1,6,5]),function(Q,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class k{constructor(A){this._handlePool=0,this._proxy=A.getProxy(R.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(A){const P=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(P,A),v.toDisposable(()=>{this._proxy.$unregisterResourceLabelFormatter(P)})}}e.ExtHostLabelService=k}),define(ge[228],pe([0,1,2,25,17,7,16,5,8,41,18,15,139,6,109,69,83,43,14,3]),function(Q,e,v,R,k,D,A,P,_,C,s,I,l,m,c,h,S,w,b,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=e.InlineCompletionController=e.DocumentRangeSemanticTokensAdapter=e.DocumentSemanticTokensAdapter=void 0;class d{constructor(j,Z){this._documents=j,this._provider=Z}provideDocumentSymbols(j,Z){const ne=this._documents.getDocument(j);return A.asPromise(()=>this._provider.provideDocumentSymbols(ne,Z)).then(oe=>{if(!s.isFalsyOrEmpty(oe))return oe[0]instanceof D.DocumentSymbol?oe.map(k.DocumentSymbol.from):d._asDocumentSymbolTree(oe)})}static _asDocumentSymbolTree(j){var Z;j=j.slice(0).sort((Y,ce)=>{let me=Y.location.range.start.compareTo(ce.location.range.start);return me===0&&(me=ce.location.range.end.compareTo(Y.location.range.end)),me});const ne=[],oe=[];for(const Y of j){const ce={name:Y.name||"!!MISSING: name!!",kind:k.SymbolKind.from(Y.kind),tags:((Z=Y.tags)===null||Z===void 0?void 0:Z.map(k.SymbolTag.from))||[],detail:"",containerName:Y.containerName,range:k.Range.from(Y.location.range),selectionRange:k.Range.from(Y.location.range),children:[]};for(;;){if(oe.length===0){oe.push(ce),ne.push(ce);break}const me=oe[oe.length-1];if(C.Range.containsRange(me.range,ce.range)&&!C.Range.equalsRange(me.range,ce.range)){me.children&&me.children.push(ce),oe.push(ce);break}oe.pop()}}return ne}}class p{constructor(j,Z,ne){this._documents=j,this._commands=Z,this._provider=ne,this._cache=new S.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses(j,Z){const ne=this._documents.getDocument(j),oe=await this._provider.provideCodeLenses(ne,Z);if(!oe||Z.isCancellationRequested)return;const Y=this._cache.add(oe),ce=new m.DisposableStore;this._disposables.set(Y,ce);const me={cacheId:Y,lenses:[]};for(let Le=0;Le<oe.length;Le++)me.lenses.push({cacheId:[Y,Le],range:k.Range.from(oe[Le].range),command:this._commands.toInternal(oe[Le].command,ce)});return me}async resolveCodeLens(j,Z){var ne;const oe=j.cacheId&&this._cache.get(...j.cacheId);if(!oe)return;let Y;if(typeof this._provider.resolveCodeLens!="function"||oe.isResolved?Y=oe:Y=await this._provider.resolveCodeLens(oe,Z),Y||(Y=oe),Z.isCancellationRequested)return;const ce=j.cacheId&&this._disposables.get(j.cacheId[0]);if(!!ce)return j.command=this._commands.toInternal((ne=Y.command)!==null&&ne!==void 0?ne:p._badCmd,ce),j}releaseCodeLenses(j){var Z;(Z=this._disposables.get(j))===null||Z===void 0||Z.dispose(),this._disposables.delete(j),this._cache.delete(j)}}p._badCmd={command:"missing",title:"!!MISSING: command!!"};function t(qe){return Array.isArray(qe)?qe.map(k.DefinitionLink.from):qe?[k.DefinitionLink.from(qe)]:[]}class i{constructor(j,Z){this._documents=j,this._provider=Z}provideDefinition(j,Z,ne){const oe=this._documents.getDocument(j),Y=k.Position.to(Z);return A.asPromise(()=>this._provider.provideDefinition(oe,Y,ne)).then(t)}}class r{constructor(j,Z){this._documents=j,this._provider=Z}provideDeclaration(j,Z,ne){const oe=this._documents.getDocument(j),Y=k.Position.to(Z);return A.asPromise(()=>this._provider.provideDeclaration(oe,Y,ne)).then(t)}}class n{constructor(j,Z){this._documents=j,this._provider=Z}provideImplementation(j,Z,ne){const oe=this._documents.getDocument(j),Y=k.Position.to(Z);return A.asPromise(()=>this._provider.provideImplementation(oe,Y,ne)).then(t)}}class o{constructor(j,Z){this._documents=j,this._provider=Z}provideTypeDefinition(j,Z,ne){const oe=this._documents.getDocument(j),Y=k.Position.to(Z);return A.asPromise(()=>this._provider.provideTypeDefinition(oe,Y,ne)).then(t)}}class g{constructor(j,Z){this._documents=j,this._provider=Z}provideHover(j,Z,ne){const oe=this._documents.getDocument(j),Y=k.Position.to(Z);return A.asPromise(()=>this._provider.provideHover(oe,Y,ne)).then(ce=>{if(!(!ce||s.isFalsyOrEmpty(ce.contents)))return ce.range||(ce.range=oe.getWordRangeAtPosition(Y)),ce.range||(ce.range=new D.Range(Y,Y)),k.Hover.from(ce)})}}class f{constructor(j,Z){this._documents=j,this._provider=Z}provideEvaluatableExpression(j,Z,ne){const oe=this._documents.getDocument(j),Y=k.Position.to(Z);return A.asPromise(()=>this._provider.provideEvaluatableExpression(oe,Y,ne)).then(ce=>{if(ce)return k.EvaluatableExpression.from(ce)})}}class E{constructor(j,Z){this._documents=j,this._provider=Z}provideInlineValues(j,Z,ne,oe){const Y=this._documents.getDocument(j);return A.asPromise(()=>this._provider.provideInlineValues(Y,k.Range.to(Z),k.InlineValueContext.to(ne),oe)).then(ce=>{if(Array.isArray(ce))return ce.map(me=>k.InlineValue.from(me))})}}class y{constructor(j,Z){this._documents=j,this._provider=Z}provideDocumentHighlights(j,Z,ne){const oe=this._documents.getDocument(j),Y=k.Position.to(Z);return A.asPromise(()=>this._provider.provideDocumentHighlights(oe,Y,ne)).then(ce=>{if(Array.isArray(ce))return ce.map(k.DocumentHighlight.from)})}}class a{constructor(j,Z){this._documents=j,this._provider=Z}provideLinkedEditingRanges(j,Z,ne){const oe=this._documents.getDocument(j),Y=k.Position.to(Z);return A.asPromise(()=>this._provider.provideLinkedEditingRanges(oe,Y,ne)).then(ce=>{if(ce&&Array.isArray(ce.ranges))return{ranges:s.coalesce(ce.ranges.map(k.Range.from)),wordPattern:ce.wordPattern}})}}class L{constructor(j,Z){this._documents=j,this._provider=Z}provideReferences(j,Z,ne,oe){const Y=this._documents.getDocument(j),ce=k.Position.to(Z);return A.asPromise(()=>this._provider.provideReferences(Y,ce,ne,oe)).then(me=>{if(Array.isArray(me))return me.map(k.location.from)})}}class O{constructor(j,Z,ne,oe,Y,ce,me){this._documents=j,this._commands=Z,this._diagnostics=ne,this._provider=oe,this._logService=Y,this._extension=ce,this._apiDeprecation=me,this._cache=new S.Cache("CodeAction"),this._disposables=new Map}provideCodeActions(j,Z,ne,oe){const Y=this._documents.getDocument(j),ce=l.Selection.isISelection(Z)?k.Selection.to(Z):k.Range.to(Z),me=[];for(const We of this._diagnostics.getDiagnostics(j))if(ce.intersection(We.range)&&me.push(We)>O._maxCodeActionsPerFile)break;const Le={diagnostics:me,only:ne.only?new D.CodeActionKind(ne.only):void 0,triggerKind:k.CodeActionTriggerKind.to(ne.trigger)};return A.asPromise(()=>this._provider.provideCodeActions(Y,ce,Le,oe)).then(We=>{var Ee;if(!s.isNonEmptyArray(We)||oe.isCancellationRequested)return;const Ke=this._cache.add(We),G=new m.DisposableStore;this._disposables.set(Ke,G);const ie=[];for(let ve=0;ve<We.length;ve++){const Fe=We[ve];!Fe||(O._isCommand(Fe)?(this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),ie.push({_isSynthetic:!0,title:Fe.title,command:this._commands.toInternal(Fe,G)})):(Le.only&&(Fe.kind?Le.only.contains(Fe.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Le.only.value} 'requested but returned code action is of kind '${Fe.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Le.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),ie.push({cacheId:[Ke,ve],title:Fe.title,command:Fe.command&&this._commands.toInternal(Fe.command,G),diagnostics:Fe.diagnostics&&Fe.diagnostics.map(k.Diagnostic.from),edit:Fe.edit&&k.WorkspaceEdit.from(Fe.edit),kind:Fe.kind&&Fe.kind.value,isPreferred:Fe.isPreferred,disabled:(Ee=Fe.disabled)===null||Ee===void 0?void 0:Ee.reason})))}return{cacheId:Ke,actions:ie}})}async resolveCodeAction(j,Z){var ne;const[oe,Y]=j,ce=this._cache.get(oe,Y);if(!ce||O._isCommand(ce)||!this._provider.resolveCodeAction)return;const me=(ne=await this._provider.resolveCodeAction(ce,Z))!==null&&ne!==void 0?ne:ce;return(me==null?void 0:me.edit)?k.WorkspaceEdit.from(me.edit):void 0}releaseCodeActions(j){var Z;(Z=this._disposables.get(j))===null||Z===void 0||Z.dispose(),this._disposables.delete(j),this._cache.delete(j)}static _isCommand(j){return typeof j.command=="string"&&typeof j.title=="string"}}O._maxCodeActionsPerFile=1e3;class W{constructor(j,Z){this._documents=j,this._provider=Z}provideDocumentFormattingEdits(j,Z,ne){const oe=this._documents.getDocument(j);return A.asPromise(()=>this._provider.provideDocumentFormattingEdits(oe,Z,ne)).then(Y=>{if(Array.isArray(Y))return Y.map(k.TextEdit.from)})}}class J{constructor(j,Z){this._documents=j,this._provider=Z}provideDocumentRangeFormattingEdits(j,Z,ne,oe){const Y=this._documents.getDocument(j),ce=k.Range.to(Z);return A.asPromise(()=>this._provider.provideDocumentRangeFormattingEdits(Y,ce,ne,oe)).then(me=>{if(Array.isArray(me))return me.map(k.TextEdit.from)})}}class se{constructor(j,Z){this._documents=j,this._provider=Z,this.autoFormatTriggerCharacters=[]}provideOnTypeFormattingEdits(j,Z,ne,oe,Y){const ce=this._documents.getDocument(j),me=k.Position.to(Z);return A.asPromise(()=>this._provider.provideOnTypeFormattingEdits(ce,me,ne,oe,Y)).then(Le=>{if(Array.isArray(Le))return Le.map(k.TextEdit.from)})}}class q{constructor(j,Z){this._provider=j,this._logService=Z,this._symbolCache=new Map,this._resultCache=new Map}provideWorkspaceSymbols(j,Z){const ne=P.IdObject.mixin({symbols:[]});return A.asPromise(()=>this._provider.provideWorkspaceSymbols(j,Z)).then(oe=>{if(s.isNonEmptyArray(oe))for(const Y of oe){if(!Y)continue;if(!Y.name){this._logService.warn("INVALID SymbolInformation, lacks name",Y);continue}const ce=P.IdObject.mixin(k.WorkspaceSymbol.from(Y));this._symbolCache.set(ce._id,Y),ne.symbols.push(ce)}}).then(()=>(ne.symbols.length>0&&this._resultCache.set(ne._id,[ne.symbols[0]._id,ne.symbols[ne.symbols.length-1]._id]),ne))}async resolveWorkspaceSymbol(j,Z){if(typeof this._provider.resolveWorkspaceSymbol!="function")return j;const ne=this._symbolCache.get(j._id);if(ne){const oe=await A.asPromise(()=>this._provider.resolveWorkspaceSymbol(ne,Z));return oe&&R.mixin(j,k.WorkspaceSymbol.from(oe),!0)}}releaseWorkspaceSymbols(j){const Z=this._resultCache.get(j);if(Z){for(let[ne,oe]=Z;ne<=oe;ne++)this._symbolCache.delete(ne);this._resultCache.delete(j)}}}class N{constructor(j,Z,ne){this._documents=j,this._provider=Z,this._logService=ne}static supportsResolving(j){return typeof j.prepareRename=="function"}provideRenameEdits(j,Z,ne,oe){const Y=this._documents.getDocument(j),ce=k.Position.to(Z);return A.asPromise(()=>this._provider.provideRenameEdits(Y,ce,ne,oe)).then(me=>{if(!!me)return k.WorkspaceEdit.from(me)},me=>{const Le=N._asMessage(me);return Le?{rejectReason:Le,edits:void 0}:Promise.reject(me)})}resolveRenameLocation(j,Z,ne){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const oe=this._documents.getDocument(j),Y=k.Position.to(Z);return A.asPromise(()=>this._provider.prepareRename(oe,Y,ne)).then(ce=>{let me,Le;if(D.Range.isRange(ce)?(me=ce,Le=oe.getText(ce)):I.isObject(ce)&&(me=ce.range,Le=ce.placeholder),!!me){if(me.start.line>Y.line||me.end.line<Y.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:k.Range.from(me),text:Le}}},ce=>{const me=N._asMessage(ce);return me?{rejectReason:me,range:void 0,text:void 0}:Promise.reject(ce)})}static _asMessage(j){return typeof j=="string"?j:j instanceof Error&&typeof j.message=="string"?j.message:void 0}}class H{constructor(j,Z){this.resultId=j,this.tokens=Z}}class T{constructor(j,Z){this._documents=j,this._provider=Z,this._nextResultId=1,this._previousResults=new Map}provideDocumentSemanticTokens(j,Z,ne){const oe=this._documents.getDocument(j),Y=Z!==0?this._previousResults.get(Z):null;return A.asPromise(()=>Y&&typeof Y.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?this._provider.provideDocumentSemanticTokensEdits(oe,Y.resultId,ne):this._provider.provideDocumentSemanticTokens(oe,ne)).then(ce=>(Y&&this._previousResults.delete(Z),ce?(ce=T._fixProvidedSemanticTokens(ce),this._send(T._convertToEdits(Y,ce),ce)):null))}async releaseDocumentSemanticColoring(j){this._previousResults.delete(j)}static _fixProvidedSemanticTokens(j){return T._isSemanticTokens(j)?T._isCorrectSemanticTokens(j)?j:new D.SemanticTokens(new Uint32Array(j.data),j.resultId):T._isSemanticTokensEdits(j)?T._isCorrectSemanticTokensEdits(j)?j:new D.SemanticTokensEdits(j.edits.map(Z=>new D.SemanticTokensEdit(Z.start,Z.deleteCount,Z.data?new Uint32Array(Z.data):Z.data)),j.resultId):j}static _isSemanticTokens(j){return j&&!!j.data}static _isCorrectSemanticTokens(j){return j.data instanceof Uint32Array}static _isSemanticTokensEdits(j){return j&&Array.isArray(j.edits)}static _isCorrectSemanticTokensEdits(j){for(const Z of j.edits)if(!(Z.data instanceof Uint32Array))return!1;return!0}static _convertToEdits(j,Z){if(!T._isSemanticTokens(Z)||!j||!j.tokens)return Z;const ne=j.tokens,oe=ne.length,Y=Z.data,ce=Y.length;let me=0;const Le=Math.min(oe,ce);for(;me<Le&&ne[me]===Y[me];)me++;if(me===oe&&me===ce)return new D.SemanticTokensEdits([],Z.resultId);let We=0;const Ee=Le-me;for(;We<Ee&&ne[oe-We-1]===Y[ce-We-1];)We++;return new D.SemanticTokensEdits([{start:me,deleteCount:oe-me-We,data:Y.subarray(me,ce-We)}],Z.resultId)}_send(j,Z){if(T._isSemanticTokens(j)){const ne=this._nextResultId++;return this._previousResults.set(ne,new H(j.resultId,j.data)),c.encodeSemanticTokensDto({id:ne,type:"full",data:j.data})}if(T._isSemanticTokensEdits(j)){const ne=this._nextResultId++;return T._isSemanticTokens(Z)?this._previousResults.set(ne,new H(Z.resultId,Z.data)):this._previousResults.set(ne,new H(j.resultId)),c.encodeSemanticTokensDto({id:ne,type:"delta",deltas:(j.edits||[]).map(oe=>({start:oe.start,deleteCount:oe.deleteCount,data:oe.data}))})}return null}}e.DocumentSemanticTokensAdapter=T;class U{constructor(j,Z){this._documents=j,this._provider=Z}provideDocumentRangeSemanticTokens(j,Z,ne){const oe=this._documents.getDocument(j);return A.asPromise(()=>this._provider.provideDocumentRangeSemanticTokens(oe,k.Range.to(Z),ne)).then(Y=>Y?this._send(Y):null)}_send(j){return c.encodeSemanticTokensDto({id:0,type:"full",data:j.data})}}e.DocumentRangeSemanticTokensAdapter=U;class F{constructor(j,Z,ne,oe,Y){this._documents=j,this._commands=Z,this._provider=ne,this._apiDeprecation=oe,this._extension=Y,this._cache=new S.Cache("CompletionItem"),this._disposables=new Map}static supportsResolving(j){return typeof j.resolveCompletionItem=="function"}async provideCompletionItems(j,Z,ne,oe){const Y=this._documents.getDocument(j),ce=k.Position.to(Z),me=Y.getWordRangeAtPosition(ce)||new D.Range(ce,ce),Le=me.with({end:ce}),We=new w.StopWatch(!0),Ee=await A.asPromise(()=>this._provider.provideCompletionItems(Y,ce,oe,k.CompletionContext.to(ne)));if(!Ee||oe.isCancellationRequested)return;const Ke=Array.isArray(Ee)?new D.CompletionList(Ee):Ee,G=F.supportsResolving(this._provider)?this._cache.add(Ke.items):this._cache.add([]),ie=new m.DisposableStore;this._disposables.set(G,ie);const ve=[],Fe={x:G,b:ve,a:{replace:k.Range.from(me),insert:k.Range.from(Le)},c:Ke.isIncomplete||void 0,d:We.elapsed()};for(let Ne=0;Ne<Ke.items.length;Ne++){const Qe=Ke.items[Ne],De=this._convertCompletionItem(Qe,[G,Ne],Le,me);ve.push(De)}return Fe}async resolveCompletionItem(j,Z){if(typeof this._provider.resolveCompletionItem!="function")return;const ne=this._cache.get(...j);if(!ne)return;const oe=await A.asPromise(()=>this._provider.resolveCompletionItem(ne,Z));if(!!oe)return this._convertCompletionItem(oe,j)}releaseCompletionItems(j){var Z;(Z=this._disposables.get(j))===null||Z===void 0||Z.dispose(),this._disposables.delete(j),this._cache.delete(j)}_convertCompletionItem(j,Z,ne,oe){var Y;const ce=this._disposables.get(Z[0]);if(!ce)throw Error("DisposableStore is missing...");const me={x:Z,a:(Y=j.label)!==null&&Y!==void 0?Y:"",o:j.label2,b:j.kind!==void 0?k.CompletionItemKind.from(j.kind):void 0,n:j.tags&&j.tags.map(k.CompletionItemTag.from),c:j.detail,d:typeof j.documentation=="undefined"?void 0:k.MarkdownString.fromStrict(j.documentation),e:j.sortText!==j.label?j.sortText:void 0,f:j.filterText!==j.label?j.filterText:void 0,g:j.preselect||void 0,i:j.keepWhitespace?1:0,k:j.commitCharacters,l:j.additionalTextEdits&&j.additionalTextEdits.map(k.TextEdit.from),m:this._commands.toInternal(j.command,ce)};j.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),me.h=j.textEdit.newText):typeof j.insertText=="string"?me.h=j.insertText:j.insertText instanceof D.SnippetString&&(me.h=j.insertText.value,me.i|=4);let Le;return j.textEdit?Le=j.textEdit.range:j.range&&(Le=j.range),D.Range.isRange(Le)?me.j=k.Range.from(Le):Le&&(!(ne==null?void 0:ne.isEqual(Le.inserting))||!(oe==null?void 0:oe.isEqual(Le.replacing)))&&(me.j={insert:k.Range.from(Le.inserting),replace:k.Range.from(Le.replacing)}),me}}class M{constructor(j,Z,ne){this._documents=j,this._provider=Z,this._commands=ne,this._cache=new S.Cache("InlineCompletionItem"),this._disposables=new Map}async provideInlineCompletions(j,Z,ne,oe){const Y=this._documents.getDocument(j),ce=k.Position.to(Z),me=await A.asPromise(()=>this._provider.provideInlineCompletionItems(Y,ce,ne,oe));if(!me||oe.isCancellationRequested)return;const Le=I.isArray(me)?{items:me}:me,We=this._cache.add(Le.items);let Ee;return{pid:We,items:Le.items.map((Ke,G)=>{let ie;return Ke.command&&(Ee||(Ee=new m.DisposableStore,this._disposables.set(We,Ee)),ie=this._commands.toInternal(Ke.command,Ee)),{text:Ke.text,range:Ke.range?k.Range.from(Ke.range):void 0,command:ie,idx:G}})}}disposeCompletions(j){this._cache.delete(j);const Z=this._disposables.get(j);Z&&Z.clear(),this._disposables.delete(j)}handleDidShowCompletionItem(j,Z){const ne=this._cache.get(j,Z);ne&&x.get(this._provider).fireOnDidShowCompletionItem({completionItem:ne})}}class x{constructor(){this._onDidShowCompletionItemEmitter=new u.Emitter,this.onDidShowCompletionItem=this._onDidShowCompletionItemEmitter.event}static get(j){let Z=x.map.get(j);return Z||(Z=new x,x.map.set(j,Z)),Z}fireOnDidShowCompletionItem(j){this._onDidShowCompletionItemEmitter.fire(j)}}e.InlineCompletionController=x,x.map=new WeakMap;class ${constructor(j,Z){this._documents=j,this._provider=Z,this._cache=new S.Cache("SignatureHelp")}provideSignatureHelp(j,Z,ne,oe){const Y=this._documents.getDocument(j),ce=k.Position.to(Z),me=this.reviveContext(ne);return A.asPromise(()=>this._provider.provideSignatureHelp(Y,ce,oe,me)).then(Le=>{if(Le){const We=this._cache.add([Le]);return Object.assign(Object.assign({},k.SignatureHelp.from(Le)),{id:We})}})}reviveContext(j){let Z;if(j.activeSignatureHelp){const ne=k.SignatureHelp.to(j.activeSignatureHelp),oe=this._cache.get(j.activeSignatureHelp.id,0);oe?(Z=oe,Z.activeSignature=ne.activeSignature,Z.activeParameter=ne.activeParameter):Z=ne}return Object.assign(Object.assign({},j),{activeSignatureHelp:Z})}releaseSignatureHelp(j){this._cache.delete(j)}}class X{constructor(j,Z){this._documents=j,this._provider=Z}provideInlayHints(j,Z,ne){const oe=this._documents.getDocument(j);return A.asPromise(()=>this._provider.provideInlayHints(oe,k.Range.to(Z),ne)).then(Y=>Y?{hints:Y.map(k.InlayHint.from)}:void 0)}}class le{constructor(j,Z){this._documents=j,this._provider=Z,this._cache=new S.Cache("DocumentLink")}async provideLinks(j,Z){const ne=this._documents.getDocument(j),oe=await A.asPromise(()=>this._provider.provideDocumentLinks(ne,Z));if(!(!Array.isArray(oe)||oe.length===0)&&!Z.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:oe.filter(le._validateLink).map(k.DocumentLink.from)};{const Y=this._cache.add(oe),ce={links:[],id:Y};for(let me=0;me<oe.length;me++){if(!le._validateLink(oe[me]))continue;const Le=k.DocumentLink.from(oe[me]);Le.cacheId=[Y,me],ce.links.push(Le)}return ce}}}static _validateLink(j){return j.target&&j.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(j,Z){if(typeof this._provider.resolveDocumentLink!="function")return;const ne=this._cache.get(...j);if(!ne)return;const oe=await A.asPromise(()=>this._provider.resolveDocumentLink(ne,Z));if(!(!oe||!le._validateLink(oe)))return k.DocumentLink.from(oe)}releaseLinks(j){this._cache.delete(j)}}class be{constructor(j,Z){this._documents=j,this._provider=Z}provideColors(j,Z){const ne=this._documents.getDocument(j);return A.asPromise(()=>this._provider.provideDocumentColors(ne,Z)).then(oe=>Array.isArray(oe)?oe.map(ce=>({color:k.Color.from(ce.color),range:k.Range.from(ce.range)})):[])}provideColorPresentations(j,Z,ne){const oe=this._documents.getDocument(j),Y=k.Range.to(Z.range),ce=k.Color.to(Z.color);return A.asPromise(()=>this._provider.provideColorPresentations(ce,{document:oe,range:Y},ne)).then(me=>{if(!!Array.isArray(me))return me.map(k.ColorPresentation.from)})}}class Re{constructor(j,Z){this._documents=j,this._provider=Z}provideFoldingRanges(j,Z,ne){const oe=this._documents.getDocument(j);return A.asPromise(()=>this._provider.provideFoldingRanges(oe,Z,ne)).then(Y=>{if(!!Array.isArray(Y))return Y.map(k.FoldingRange.from)})}}class Ce{constructor(j,Z,ne){this._documents=j,this._provider=Z,this._logService=ne}provideSelectionRanges(j,Z,ne){const oe=this._documents.getDocument(j),Y=Z.map(k.Position.to);return A.asPromise(()=>this._provider.provideSelectionRanges(oe,Y,ne)).then(ce=>{if(!s.isNonEmptyArray(ce))return[];if(ce.length!==Y.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const me=[];for(let Le=0;Le<Y.length;Le++){const We=[];me.push(We);let Ee=Y[Le],Ke=ce[Le];for(;;){if(!Ke.range.contains(Ee))throw new Error("INVALID selection range, must contain the previous range");if(We.push(k.SelectionRange.from(Ke)),!Ke.parent)break;Ee=Ke.range,Ke=Ke.parent}}return me})}}class Me{constructor(j,Z){this._documents=j,this._provider=Z,this._idPool=new h.IdGenerator(""),this._cache=new Map}async prepareSession(j,Z,ne){const oe=this._documents.getDocument(j),Y=k.Position.to(Z),ce=await this._provider.prepareCallHierarchy(oe,Y,ne);if(!ce)return;const me=this._idPool.nextId();return this._cache.set(me,new Map),Array.isArray(ce)?ce.map(Le=>this._cacheAndConvertItem(me,Le)):[this._cacheAndConvertItem(me,ce)]}async provideCallsTo(j,Z,ne){const oe=this._itemFromCache(j,Z);if(!oe)throw new Error("missing call hierarchy item");const Y=await this._provider.provideCallHierarchyIncomingCalls(oe,ne);if(!!Y)return Y.map(ce=>({from:this._cacheAndConvertItem(j,ce.from),fromRanges:ce.fromRanges.map(me=>k.Range.from(me))}))}async provideCallsFrom(j,Z,ne){const oe=this._itemFromCache(j,Z);if(!oe)throw new Error("missing call hierarchy item");const Y=await this._provider.provideCallHierarchyOutgoingCalls(oe,ne);if(!!Y)return Y.map(ce=>({to:this._cacheAndConvertItem(j,ce.to),fromRanges:ce.fromRanges.map(me=>k.Range.from(me))}))}releaseSession(j){this._cache.delete(j)}_cacheAndConvertItem(j,Z){var ne;const oe=this._cache.get(j),Y={_sessionId:j,_itemId:oe.size.toString(36),name:Z.name,detail:Z.detail,kind:k.SymbolKind.from(Z.kind),uri:Z.uri,range:k.Range.from(Z.range),selectionRange:k.Range.from(Z.selectionRange),tags:(ne=Z.tags)===null||ne===void 0?void 0:ne.map(k.SymbolTag.from)};return oe.set(Y._itemId,Z),Y}_itemFromCache(j,Z){const ne=this._cache.get(j);return ne==null?void 0:ne.get(Z)}}class je{constructor(j,Z){this.adapter=j,this.extension=Z}}class ze{constructor(j,Z,ne,oe,Y,ce,me){this._adapter=new Map,this._uriTransformer=Z,this._proxy=j.getProxy(P.MainContext.MainThreadLanguageFeatures),this._documents=ne,this._commands=oe,this._diagnostics=Y,this._logService=ce,this._apiDeprecation=me}_transformDocumentSelector(j){return s.coalesce(s.asArray(j).map(Z=>this._doTransformDocumentSelector(Z)))}_doTransformDocumentSelector(j){if(typeof j=="string")return{$serialized:!0,language:j};if(j)return{$serialized:!0,language:j.language,scheme:this._transformScheme(j.scheme),pattern:typeof j.pattern=="undefined"?void 0:k.GlobPattern.from(j.pattern),exclusive:j.exclusive}}_transformScheme(j){return this._uriTransformer&&typeof j=="string"?this._uriTransformer.transformOutgoingScheme(j):j}_createDisposable(j){return new D.Disposable(()=>{this._adapter.delete(j),this._proxy.$unregister(j)})}_nextHandle(){return ze._handlePool++}_withAdapter(j,Z,ne,oe,Y=!1){const ce=this._adapter.get(j);if(!ce)return Promise.resolve(oe);if(ce.adapter instanceof Z){let me;ce.extension&&(me=Date.now(),this._logService.trace(`[${ce.extension.identifier.value}] INVOKE provider '${Z.name}'`));const Le=ne(ce.adapter,ce.extension),We=ce.extension;return We&&Promise.resolve(Le).then(()=>this._logService.trace(`[${We.identifier.value}] provider DONE after ${Date.now()-me}ms`),Ee=>{Y&&Ee instanceof b.CancellationError||(this._logService.error(`[${We.identifier.value}] provider FAILED`),this._logService.error(Ee))}),Le}return Promise.reject(new Error("no adapter found"))}_addNewAdapter(j,Z){const ne=this._nextHandle();return this._adapter.set(ne,new je(j,Z)),ne}static _extLabel(j){return j.displayName||j.name}registerDocumentSymbolProvider(j,Z,ne,oe){const Y=this._addNewAdapter(new d(this._documents,ne),j),ce=oe&&oe.label||ze._extLabel(j);return this._proxy.$registerDocumentSymbolProvider(Y,this._transformDocumentSelector(Z),ce),this._createDisposable(Y)}$provideDocumentSymbols(j,Z,ne){return this._withAdapter(j,d,oe=>oe.provideDocumentSymbols(v.URI.revive(Z),ne),void 0)}registerCodeLensProvider(j,Z,ne){const oe=this._nextHandle(),Y=typeof ne.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(oe,new je(new p(this._documents,this._commands.converter,ne),j)),this._proxy.$registerCodeLensSupport(oe,this._transformDocumentSelector(Z),Y);let ce=this._createDisposable(oe);if(Y!==void 0){const me=ne.onDidChangeCodeLenses(Le=>this._proxy.$emitCodeLensEvent(Y));ce=D.Disposable.from(ce,me)}return ce}$provideCodeLenses(j,Z,ne){return this._withAdapter(j,p,oe=>oe.provideCodeLenses(v.URI.revive(Z),ne),void 0)}$resolveCodeLens(j,Z,ne){return this._withAdapter(j,p,oe=>oe.resolveCodeLens(Z,ne),void 0)}$releaseCodeLenses(j,Z){this._withAdapter(j,p,ne=>Promise.resolve(ne.releaseCodeLenses(Z)),void 0)}registerDefinitionProvider(j,Z,ne){const oe=this._addNewAdapter(new i(this._documents,ne),j);return this._proxy.$registerDefinitionSupport(oe,this._transformDocumentSelector(Z)),this._createDisposable(oe)}$provideDefinition(j,Z,ne,oe){return this._withAdapter(j,i,Y=>Y.provideDefinition(v.URI.revive(Z),ne,oe),[])}registerDeclarationProvider(j,Z,ne){const oe=this._addNewAdapter(new r(this._documents,ne),j);return this._proxy.$registerDeclarationSupport(oe,this._transformDocumentSelector(Z)),this._createDisposable(oe)}$provideDeclaration(j,Z,ne,oe){return this._withAdapter(j,r,Y=>Y.provideDeclaration(v.URI.revive(Z),ne,oe),[])}registerImplementationProvider(j,Z,ne){const oe=this._addNewAdapter(new n(this._documents,ne),j);return this._proxy.$registerImplementationSupport(oe,this._transformDocumentSelector(Z)),this._createDisposable(oe)}$provideImplementation(j,Z,ne,oe){return this._withAdapter(j,n,Y=>Y.provideImplementation(v.URI.revive(Z),ne,oe),[])}registerTypeDefinitionProvider(j,Z,ne){const oe=this._addNewAdapter(new o(this._documents,ne),j);return this._proxy.$registerTypeDefinitionSupport(oe,this._transformDocumentSelector(Z)),this._createDisposable(oe)}$provideTypeDefinition(j,Z,ne,oe){return this._withAdapter(j,o,Y=>Y.provideTypeDefinition(v.URI.revive(Z),ne,oe),[])}registerHoverProvider(j,Z,ne,oe){const Y=this._addNewAdapter(new g(this._documents,ne),j);return this._proxy.$registerHoverProvider(Y,this._transformDocumentSelector(Z)),this._createDisposable(Y)}$provideHover(j,Z,ne,oe){return this._withAdapter(j,g,Y=>Y.provideHover(v.URI.revive(Z),ne,oe),void 0)}registerEvaluatableExpressionProvider(j,Z,ne,oe){const Y=this._addNewAdapter(new f(this._documents,ne),j);return this._proxy.$registerEvaluatableExpressionProvider(Y,this._transformDocumentSelector(Z)),this._createDisposable(Y)}$provideEvaluatableExpression(j,Z,ne,oe){return this._withAdapter(j,f,Y=>Y.provideEvaluatableExpression(v.URI.revive(Z),ne,oe),void 0)}registerInlineValuesProvider(j,Z,ne,oe){const Y=typeof ne.onDidChangeInlineValues=="function"?this._nextHandle():void 0,ce=this._addNewAdapter(new E(this._documents,ne),j);this._proxy.$registerInlineValuesProvider(ce,this._transformDocumentSelector(Z),Y);let me=this._createDisposable(ce);if(Y!==void 0){const Le=ne.onDidChangeInlineValues(We=>this._proxy.$emitInlineValuesEvent(Y));me=D.Disposable.from(me,Le)}return me}$provideInlineValues(j,Z,ne,oe,Y){return this._withAdapter(j,E,ce=>ce.provideInlineValues(v.URI.revive(Z),ne,oe,Y),void 0)}registerDocumentHighlightProvider(j,Z,ne){const oe=this._addNewAdapter(new y(this._documents,ne),j);return this._proxy.$registerDocumentHighlightProvider(oe,this._transformDocumentSelector(Z)),this._createDisposable(oe)}$provideDocumentHighlights(j,Z,ne,oe){return this._withAdapter(j,y,Y=>Y.provideDocumentHighlights(v.URI.revive(Z),ne,oe),void 0)}registerLinkedEditingRangeProvider(j,Z,ne){const oe=this._addNewAdapter(new a(this._documents,ne),j);return this._proxy.$registerLinkedEditingRangeProvider(oe,this._transformDocumentSelector(Z)),this._createDisposable(oe)}$provideLinkedEditingRanges(j,Z,ne,oe){return this._withAdapter(j,a,async Y=>{const ce=await Y.provideLinkedEditingRanges(v.URI.revive(Z),ne,oe);if(ce)return{ranges:ce.ranges,wordPattern:ce.wordPattern?ze._serializeRegExp(ce.wordPattern):void 0}},void 0)}registerReferenceProvider(j,Z,ne){const oe=this._addNewAdapter(new L(this._documents,ne),j);return this._proxy.$registerReferenceSupport(oe,this._transformDocumentSelector(Z)),this._createDisposable(oe)}$provideReferences(j,Z,ne,oe,Y){return this._withAdapter(j,L,ce=>ce.provideReferences(v.URI.revive(Z),ne,oe,Y),void 0)}registerCodeActionProvider(j,Z,ne,oe){var Y,ce;const me=new m.DisposableStore,Le=this._addNewAdapter(new O(this._documents,this._commands.converter,this._diagnostics,ne,this._logService,j,this._apiDeprecation),j);return this._proxy.$registerQuickFixSupport(Le,this._transformDocumentSelector(Z),{providedKinds:(Y=oe==null?void 0:oe.providedCodeActionKinds)===null||Y===void 0?void 0:Y.map(We=>We.value),documentation:(ce=oe==null?void 0:oe.documentation)===null||ce===void 0?void 0:ce.map(We=>({kind:We.kind.value,command:this._commands.converter.toInternal(We.command,me)}))},ze._extLabel(j),Boolean(ne.resolveCodeAction)),me.add(this._createDisposable(Le)),me}$provideCodeActions(j,Z,ne,oe,Y){return this._withAdapter(j,O,ce=>ce.provideCodeActions(v.URI.revive(Z),ne,oe,Y),void 0)}$resolveCodeAction(j,Z,ne){return this._withAdapter(j,O,oe=>oe.resolveCodeAction(Z,ne),void 0)}$releaseCodeActions(j,Z){this._withAdapter(j,O,ne=>Promise.resolve(ne.releaseCodeActions(Z)),void 0)}registerDocumentFormattingEditProvider(j,Z,ne){const oe=this._addNewAdapter(new W(this._documents,ne),j);return this._proxy.$registerDocumentFormattingSupport(oe,this._transformDocumentSelector(Z),j.identifier,j.displayName||j.name),this._createDisposable(oe)}$provideDocumentFormattingEdits(j,Z,ne,oe){return this._withAdapter(j,W,Y=>Y.provideDocumentFormattingEdits(v.URI.revive(Z),ne,oe),void 0)}registerDocumentRangeFormattingEditProvider(j,Z,ne){const oe=this._addNewAdapter(new J(this._documents,ne),j);return this._proxy.$registerRangeFormattingSupport(oe,this._transformDocumentSelector(Z),j.identifier,j.displayName||j.name),this._createDisposable(oe)}$provideDocumentRangeFormattingEdits(j,Z,ne,oe,Y){return this._withAdapter(j,J,ce=>ce.provideDocumentRangeFormattingEdits(v.URI.revive(Z),ne,oe,Y),void 0)}registerOnTypeFormattingEditProvider(j,Z,ne,oe){const Y=this._addNewAdapter(new se(this._documents,ne),j);return this._proxy.$registerOnTypeFormattingSupport(Y,this._transformDocumentSelector(Z),oe,j.identifier),this._createDisposable(Y)}$provideOnTypeFormattingEdits(j,Z,ne,oe,Y,ce){return this._withAdapter(j,se,me=>me.provideOnTypeFormattingEdits(v.URI.revive(Z),ne,oe,Y,ce),void 0)}registerWorkspaceSymbolProvider(j,Z){const ne=this._addNewAdapter(new q(Z,this._logService),j);return this._proxy.$registerNavigateTypeSupport(ne),this._createDisposable(ne)}$provideWorkspaceSymbols(j,Z,ne){return this._withAdapter(j,q,oe=>oe.provideWorkspaceSymbols(Z,ne),{symbols:[]})}$resolveWorkspaceSymbol(j,Z,ne){return this._withAdapter(j,q,oe=>oe.resolveWorkspaceSymbol(Z,ne),void 0)}$releaseWorkspaceSymbols(j,Z){this._withAdapter(j,q,ne=>ne.releaseWorkspaceSymbols(Z),void 0)}registerRenameProvider(j,Z,ne){const oe=this._addNewAdapter(new N(this._documents,ne,this._logService),j);return this._proxy.$registerRenameSupport(oe,this._transformDocumentSelector(Z),N.supportsResolving(ne)),this._createDisposable(oe)}$provideRenameEdits(j,Z,ne,oe,Y){return this._withAdapter(j,N,ce=>ce.provideRenameEdits(v.URI.revive(Z),ne,oe,Y),void 0)}$resolveRenameLocation(j,Z,ne,oe){return this._withAdapter(j,N,Y=>Y.resolveRenameLocation(v.URI.revive(Z),ne,oe),void 0)}registerDocumentSemanticTokensProvider(j,Z,ne,oe){const Y=this._nextHandle(),ce=typeof ne.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._adapter.set(Y,new je(new T(this._documents,ne),j)),this._proxy.$registerDocumentSemanticTokensProvider(Y,this._transformDocumentSelector(Z),oe,ce);let me=this._createDisposable(Y);if(ce){const Le=ne.onDidChangeSemanticTokens(We=>this._proxy.$emitDocumentSemanticTokensEvent(ce));me=D.Disposable.from(me,Le)}return me}$provideDocumentSemanticTokens(j,Z,ne,oe){return this._withAdapter(j,T,Y=>Y.provideDocumentSemanticTokens(v.URI.revive(Z),ne,oe),null,!0)}$releaseDocumentSemanticTokens(j,Z){this._withAdapter(j,T,ne=>ne.releaseDocumentSemanticColoring(Z),void 0)}registerDocumentRangeSemanticTokensProvider(j,Z,ne,oe){const Y=this._addNewAdapter(new U(this._documents,ne),j);return this._proxy.$registerDocumentRangeSemanticTokensProvider(Y,this._transformDocumentSelector(Z),oe),this._createDisposable(Y)}$provideDocumentRangeSemanticTokens(j,Z,ne,oe){return this._withAdapter(j,U,Y=>Y.provideDocumentRangeSemanticTokens(v.URI.revive(Z),ne,oe),null,!0)}registerCompletionItemProvider(j,Z,ne,oe){const Y=this._addNewAdapter(new F(this._documents,this._commands.converter,ne,this._apiDeprecation,j),j);return this._proxy.$registerSuggestSupport(Y,this._transformDocumentSelector(Z),oe,F.supportsResolving(ne),`${j.identifier.value}(${oe.join("")})`),this._createDisposable(Y)}$provideCompletionItems(j,Z,ne,oe,Y){return this._withAdapter(j,F,ce=>ce.provideCompletionItems(v.URI.revive(Z),ne,oe,Y),void 0)}$resolveCompletionItem(j,Z,ne){return this._withAdapter(j,F,oe=>oe.resolveCompletionItem(Z,ne),void 0)}$releaseCompletionItems(j,Z){this._withAdapter(j,F,ne=>ne.releaseCompletionItems(Z),void 0)}registerInlineCompletionsProvider(j,Z,ne){const oe=this._addNewAdapter(new M(this._documents,ne,this._commands.converter),j);return this._proxy.$registerInlineCompletionsSupport(oe,this._transformDocumentSelector(Z)),this._createDisposable(oe)}$provideInlineCompletions(j,Z,ne,oe,Y){return this._withAdapter(j,M,ce=>ce.provideInlineCompletions(v.URI.revive(Z),ne,oe,Y),void 0)}$handleInlineCompletionDidShow(j,Z,ne){this._withAdapter(j,M,async oe=>{oe.handleDidShowCompletionItem(Z,ne)},void 0)}$freeInlineCompletionsList(j,Z){this._withAdapter(j,M,async ne=>{ne.disposeCompletions(Z)},void 0)}registerSignatureHelpProvider(j,Z,ne,oe){const Y=Array.isArray(oe)?{triggerCharacters:oe,retriggerCharacters:[]}:oe,ce=this._addNewAdapter(new $(this._documents,ne),j);return this._proxy.$registerSignatureHelpProvider(ce,this._transformDocumentSelector(Z),Y),this._createDisposable(ce)}$provideSignatureHelp(j,Z,ne,oe,Y){return this._withAdapter(j,$,ce=>ce.provideSignatureHelp(v.URI.revive(Z),ne,oe,Y),void 0)}$releaseSignatureHelp(j,Z){this._withAdapter(j,$,ne=>ne.releaseSignatureHelp(Z),void 0)}registerInlayHintsProvider(j,Z,ne){const oe=typeof ne.onDidChangeInlayHints=="function"?this._nextHandle():void 0,Y=this._addNewAdapter(new X(this._documents,ne),j);this._proxy.$registerInlayHintsProvider(Y,this._transformDocumentSelector(Z),oe);let ce=this._createDisposable(Y);if(oe!==void 0){const me=ne.onDidChangeInlayHints(Le=>this._proxy.$emitInlayHintsEvent(oe));ce=D.Disposable.from(ce,me)}return ce}$provideInlayHints(j,Z,ne,oe){return this._withAdapter(j,X,Y=>Y.provideInlayHints(v.URI.revive(Z),ne,oe),void 0)}registerDocumentLinkProvider(j,Z,ne){const oe=this._addNewAdapter(new le(this._documents,ne),j);return this._proxy.$registerDocumentLinkProvider(oe,this._transformDocumentSelector(Z),typeof ne.resolveDocumentLink=="function"),this._createDisposable(oe)}$provideDocumentLinks(j,Z,ne){return this._withAdapter(j,le,oe=>oe.provideLinks(v.URI.revive(Z),ne),void 0)}$resolveDocumentLink(j,Z,ne){return this._withAdapter(j,le,oe=>oe.resolveLink(Z,ne),void 0)}$releaseDocumentLinks(j,Z){this._withAdapter(j,le,ne=>ne.releaseLinks(Z),void 0)}registerColorProvider(j,Z,ne){const oe=this._addNewAdapter(new be(this._documents,ne),j);return this._proxy.$registerDocumentColorProvider(oe,this._transformDocumentSelector(Z)),this._createDisposable(oe)}$provideDocumentColors(j,Z,ne){return this._withAdapter(j,be,oe=>oe.provideColors(v.URI.revive(Z),ne),[])}$provideColorPresentations(j,Z,ne,oe){return this._withAdapter(j,be,Y=>Y.provideColorPresentations(v.URI.revive(Z),ne,oe),void 0)}registerFoldingRangeProvider(j,Z,ne){const oe=this._nextHandle(),Y=typeof ne.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(oe,new je(new Re(this._documents,ne),j)),this._proxy.$registerFoldingRangeProvider(oe,this._transformDocumentSelector(Z),Y);let ce=this._createDisposable(oe);if(Y!==void 0){const me=ne.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(Y));ce=D.Disposable.from(ce,me)}return ce}$provideFoldingRanges(j,Z,ne,oe){return this._withAdapter(j,Re,Y=>Y.provideFoldingRanges(v.URI.revive(Z),ne,oe),void 0)}registerSelectionRangeProvider(j,Z,ne){const oe=this._addNewAdapter(new Ce(this._documents,ne,this._logService),j);return this._proxy.$registerSelectionRangeProvider(oe,this._transformDocumentSelector(Z)),this._createDisposable(oe)}$provideSelectionRanges(j,Z,ne,oe){return this._withAdapter(j,Ce,Y=>Y.provideSelectionRanges(v.URI.revive(Z),ne,oe),[])}registerCallHierarchyProvider(j,Z,ne){const oe=this._addNewAdapter(new Me(this._documents,ne),j);return this._proxy.$registerCallHierarchyProvider(oe,this._transformDocumentSelector(Z)),this._createDisposable(oe)}$prepareCallHierarchy(j,Z,ne,oe){return this._withAdapter(j,Me,Y=>Promise.resolve(Y.prepareSession(v.URI.revive(Z),ne,oe)),void 0)}$provideCallHierarchyIncomingCalls(j,Z,ne,oe){return this._withAdapter(j,Me,Y=>Y.provideCallsTo(Z,ne,oe),void 0)}$provideCallHierarchyOutgoingCalls(j,Z,ne,oe){return this._withAdapter(j,Me,Y=>Y.provideCallsFrom(Z,ne,oe),void 0)}$releaseCallHierarchy(j,Z){this._withAdapter(j,Me,ne=>Promise.resolve(ne.releaseSession(Z)),void 0)}static _serializeRegExp(j){return{pattern:j.source,flags:_.regExpFlags(j)}}static _serializeIndentationRule(j){return{decreaseIndentPattern:ze._serializeRegExp(j.decreaseIndentPattern),increaseIndentPattern:ze._serializeRegExp(j.increaseIndentPattern),indentNextLinePattern:j.indentNextLinePattern?ze._serializeRegExp(j.indentNextLinePattern):void 0,unIndentedLinePattern:j.unIndentedLinePattern?ze._serializeRegExp(j.unIndentedLinePattern):void 0}}static _serializeOnEnterRule(j){return{beforeText:ze._serializeRegExp(j.beforeText),afterText:j.afterText?ze._serializeRegExp(j.afterText):void 0,previousLineText:j.previousLineText?ze._serializeRegExp(j.previousLineText):void 0,action:j.action}}static _serializeOnEnterRules(j){return j.map(ze._serializeOnEnterRule)}setLanguageConfiguration(j,Z,ne){let{wordPattern:oe}=ne;if(oe&&_.regExpLeadsToEndlessLoop(oe))throw new Error(`Invalid language configuration: wordPattern '${oe}' is not allowed to match the empty string.`);oe?this._documents.setWordDefinitionFor(Z,oe):this._documents.setWordDefinitionFor(Z,void 0),ne.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",j,"Do not use."),ne.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",j,"Do not use.");const Y=this._nextHandle(),ce={comments:ne.comments,brackets:ne.brackets,wordPattern:ne.wordPattern?ze._serializeRegExp(ne.wordPattern):void 0,indentationRules:ne.indentationRules?ze._serializeIndentationRule(ne.indentationRules):void 0,onEnterRules:ne.onEnterRules?ze._serializeOnEnterRules(ne.onEnterRules):void 0,__electricCharacterSupport:ne.__electricCharacterSupport,__characterPairSupport:ne.__characterPairSupport};return this._proxy.$setLanguageConfiguration(Y,Z,ce),this._createDisposable(Y)}$setWordDefinitions(j){for(const Z of j)this._documents.setWordDefinitionFor(Z.languageId,new RegExp(Z.regexSource,Z.regexFlags))}}e.ExtHostLanguageFeatures=ze,ze._handlePool=0}),define(ge[229],pe([0,1,5,17,7]),function(Q,e,v,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class D{constructor(P,_){this._proxy=P.getProxy(v.MainContext.MainThreadLanguages),this._documents=_}getLanguages(){return this._proxy.$getLanguages()}async changeLanguage(P,_){await this._proxy.$changeLanguage(P,_);const C=this._documents.getDocumentData(P);if(!C)throw new Error(`document '${P.toString}' NOT found`);return C.document}async tokenAtPosition(P,_){var C;const s=P.version,I=R.Position.from(_),l=await this._proxy.$tokensAtPosition(P.uri,I),m={type:k.StandardTokenType.Other,range:(C=P.getWordRangeAtPosition(_))!==null&&C!==void 0?C:new k.Range(_.line,_.character,_.line,_.character)};if(!l)return m;const c={range:R.Range.to(l.range),type:R.TokenType.to(l.type)};return!c.range.contains(_)||s!==P.version?m:c}}e.ExtHostLanguages=D}),define(ge[230],pe([0,1,5,12,35]),function(Q,e,v,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function D(P){return P&&P.title}let A=class{constructor(_,C){this._logService=C,this._proxy=_.getProxy(v.MainContext.MainThreadMessageService)}showMessage(_,C,s,I,l){const m={extension:_};let c;typeof I=="string"||D(I)?c=[I,...l]:(m.modal=I&&I.modal,m.useCustom=I&&I.useCustom,c=l),m.useCustom&&k.checkProposedApiEnabled(_);const h=[];for(let S=0;S<c.length;S++){const w=c[S];if(typeof w=="string")h.push({title:w,handle:S,isCloseAffordance:!1});else if(typeof w=="object"){let{title:b,isCloseAffordance:u}=w;h.push({title:b,isCloseAffordance:!!u,handle:S})}else this._logService.warn("Invalid message item:",w)}return this._proxy.$showMessage(C,s,m,h).then(S=>{if(typeof S=="number")return c[S]})}};A=Ve([$e(1,R.ILogService)],A),e.ExtHostMessageService=A}),define(ge[231],pe([0,1,22,3,73,6,23,8,15,2,83,5,17,7,207,123]),function(Q,e,v,R,k,D,A,P,_,C,s,I,l,m,c,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class S{constructor(b,u,d,p,t){this._textDocumentsAndEditors=d,this._textDocuments=p,this._extensionStoragePaths=t,this._notebookContentProviders=new Map,this._notebookStatusBarItemProviders=new Map,this._documents=new A.ResourceMap,this._editors=new Map,this._onDidChangeNotebookCells=new R.Emitter,this.onDidChangeNotebookCells=this._onDidChangeNotebookCells.event,this._onDidChangeCellOutputs=new R.Emitter,this.onDidChangeCellOutputs=this._onDidChangeCellOutputs.event,this._onDidChangeCellMetadata=new R.Emitter,this.onDidChangeCellMetadata=this._onDidChangeCellMetadata.event,this._onDidChangeActiveNotebookEditor=new R.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._onDidChangeCellExecutionState=new R.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new R.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new R.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidChangeVisibleNotebookEditors=new R.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._statusBarCache=new s.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._backupIdPool=0,this._notebookProxy=b.getProxy(I.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=b.getProxy(I.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=b.getProxy(I.MainContext.MainThreadNotebookEditors),this._commandsConverter=u.converter,u.registerArgumentProcessor({processArgument:i=>{var r;if(i&&i.$mid===12){const n=(r=i.notebookEditor)===null||r===void 0?void 0:r.notebookUri,o=i.cell.handle,g=this._documents.get(n),f=g==null?void 0:g.getCell(o);if(f)return f.apiCell}return i}})}get activeNotebookEditor(){var b;return(b=this._activeNotebookEditor)===null||b===void 0?void 0:b.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(b=>b.apiEditor)}getEditorById(b){const u=this._editors.get(b);if(!u)throw new Error(`unknown text editor: ${b}. known editors: ${[...this._editors.keys()]} `);return u}getIdByEditor(b){for(const[u,d]of this._editors)if(d.apiEditor===b)return u}get notebookDocuments(){return[...this._documents.values()]}getNotebookDocument(b,u){const d=this._documents.get(b);if(!d&&!u)throw new Error(`NO notebook document for '${b}'`);return d}_getProviderData(b){const u=this._notebookContentProviders.get(b);if(!u)throw new Error(`NO provider for '${b}'`);return u}registerNotebookContentProvider(b,u,d,p,t){if(P.isFalsyOrWhitespace(u))throw new Error("viewType cannot be empty or just whitespace");if(this._notebookContentProviders.has(u))throw new Error(`Notebook provider for '${u}' already registered`);this._notebookContentProviders.set(u,{extension:b,provider:d});let i;return d.onDidChangeNotebookContentOptions&&(i=d.onDidChangeNotebookContentOptions(()=>{const r=l.NotebookDocumentContentOptions.from(d.options);this._notebookProxy.$updateNotebookProviderOptions(u,r)})),this._notebookProxy.$registerNotebookProvider({id:b.identifier,location:b.extensionLocation},u,l.NotebookDocumentContentOptions.from(p),S._convertNotebookRegistrationData(b,t)),new m.Disposable(()=>{i==null||i.dispose(),this._notebookContentProviders.delete(u),this._notebookProxy.$unregisterNotebookProvider(u)})}static _convertNotebookRegistrationData(b,u){if(!u)return;const d=u.filenamePattern.map(p=>l.NotebookExclusiveDocumentPattern.from(p)).filter(p=>p!==void 0);if(u.filenamePattern&&!d){console.warn(`Notebook content provider view options file name pattern is invalid ${u.filenamePattern}`);return}return{extension:b.identifier,providerDisplayName:b.displayName||b.name,displayName:u.displayName,filenamePattern:d,exclusive:u.exclusive||!1}}registerNotebookCellStatusBarItemProvider(b,u,d){const p=S._notebookStatusBarItemProviderHandlePool++,t=typeof d.onDidChangeCellStatusBarItems=="function"?S._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(p,d),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(p,t,u);let i;return t!==void 0&&(i=d.onDidChangeCellStatusBarItems(r=>this._notebookProxy.$emitCellStatusBarEvent(t))),new m.Disposable(()=>{this._notebookStatusBarItemProviders.delete(p),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(p,t),i&&i.dispose()})}async createNotebookDocument(b){const u=await this._notebookDocumentsProxy.$tryCreateNotebook({viewType:b.viewType,content:b.content&&l.NotebookData.from(b.content)});return C.URI.revive(u)}async openNotebookDocument(b){const u=this._documents.get(b);if(u)return u.apiNotebook;const d=await this._notebookDocumentsProxy.$tryOpenNotebook(b),p=this._documents.get(C.URI.revive(d));return _.assertIsDefined(p==null?void 0:p.apiNotebook)}async showNotebookDocument(b,u){var d;C.URI.isUri(b)&&(b=await this.openNotebookDocument(b));let p;typeof u=="object"?p={position:l.ViewColumn.from(u.viewColumn),preserveFocus:u.preserveFocus,selections:u.selections&&u.selections.map(l.NotebookRange.from),pinned:typeof u.preview=="boolean"?!u.preview:void 0}:p={preserveFocus:!1};const t=await this._notebookEditorsProxy.$tryShowNotebookDocument(b.uri,b.notebookType,p),i=t&&((d=this._editors.get(t))===null||d===void 0?void 0:d.apiEditor);if(i)return i;throw t?new Error(`Could NOT open editor for "${b.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${b.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(b,u,d,p){const t=this._notebookStatusBarItemProviders.get(b),i=C.URI.revive(u),r=this._documents.get(i);if(!r||!t)return;const n=r.getCellFromIndex(d);if(!n)return;const o=await t.provideCellStatusBarItems(n.apiCell,p);if(!o)return;const g=new D.DisposableStore,f=this._statusBarCache.add([g]),y=(Array.isArray(o)?o:[o]).map(a=>l.NotebookStatusBarItem.from(a,this._commandsConverter,g));return{cacheId:f,items:y}}$releaseNotebookCellStatusBarItems(b){this._statusBarCache.delete(b)}registerNotebookSerializer(b,u,d,p,t){if(P.isFalsyOrWhitespace(u))throw new Error("viewType cannot be empty or just whitespace");const i=this._handlePool++;return this._notebookSerializer.set(i,d),this._notebookProxy.$registerNotebookSerializer(i,{id:b.identifier,location:b.extensionLocation},u,l.NotebookDocumentContentOptions.from(p),S._convertNotebookRegistrationData(b,t)),D.toDisposable(()=>{this._notebookProxy.$unregisterNotebookSerializer(i)})}async $dataToNotebook(b,u,d){const p=this._notebookSerializer.get(b);if(!p)throw new Error("NO serializer found");const t=await p.deserializeNotebook(u.buffer,d);return l.NotebookData.from(t)}async $notebookToData(b,u,d){const p=this._notebookSerializer.get(b);if(!p)throw new Error("NO serializer found");const t=await p.serializeNotebook(l.NotebookData.to(u),d);return v.VSBuffer.wrap(t)}async $openNotebook(b,u,d,p,t){var i;const{provider:r}=this._getProviderData(b),n=await r.openNotebook(C.URI.revive(u),{backupId:d,untitledDocumentData:p==null?void 0:p.buffer},t);return{metadata:(i=n.metadata)!==null&&i!==void 0?i:Object.create(null),cells:n.cells.map(l.NotebookCellData.from)}}async $saveNotebook(b,u,d){const p=this.getNotebookDocument(C.URI.revive(u)),{provider:t}=this._getProviderData(b);return await t.saveNotebook(p.apiNotebook,d),!0}async $saveNotebookAs(b,u,d,p){const t=this.getNotebookDocument(C.URI.revive(u)),{provider:i}=this._getProviderData(b);return await i.saveNotebookAs(C.URI.revive(d),t.apiNotebook,p),!0}async $backupNotebook(b,u,d){var p;const t=this.getNotebookDocument(C.URI.revive(u)),i=this._getProviderData(b),r=(p=this._extensionStoragePaths.workspaceValue(i.extension))!==null&&p!==void 0?p:this._extensionStoragePaths.globalValue(i.extension),n=String(k.hash([t.uri.toString(),this._backupIdPool++])),o=C.URI.joinPath(r,n),g=await i.provider.backupNotebook(t.apiNotebook,{destination:o},d);return t.updateBackup(g),g.id}_createExtHostEditor(b,u,d){if(this._editors.has(u))throw new Error(`editor with id ALREADY EXSIST: ${u}`);const p=new h.ExtHostNotebookEditor(u,this._notebookEditorsProxy,b,d.visibleRanges.map(l.NotebookRange.to),d.selections.map(l.NotebookRange.to),typeof d.viewColumn=="number"?l.ViewColumn.to(d.viewColumn):void 0);this._editors.set(u,p)}$acceptDocumentAndEditorsDelta(b){var u,d,p;if(b.removedDocuments)for(const i of b.removedDocuments){const r=C.URI.revive(i),n=this._documents.get(r);n&&(n.dispose(),this._documents.delete(r),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:n.apiNotebook.getCells().map(o=>o.document.uri)}),this._onDidCloseNotebookDocument.fire(n.apiNotebook));for(const o of this._editors.values())o.notebookData.uri.toString()===r.toString()&&this._editors.delete(o.id)}if(b.addedDocuments){const i=[];for(const r of b.addedDocuments){const n=C.URI.revive(r.uri);if(this._documents.has(n))throw new Error(`adding EXISTING notebook ${n} `);const o=this,g=new c.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,{emitModelChange(f){o._onDidChangeNotebookCells.fire(f)},emitCellOutputsChange(f){o._onDidChangeCellOutputs.fire(f)},emitCellMetadataChange(f){o._onDidChangeCellMetadata.fire(f)},emitCellExecutionStateChange(f){o._onDidChangeCellExecutionState.fire(f)}},n,r);i.push(...r.cells.map(f=>c.ExtHostCell.asModelAddData(g.apiNotebook,f))),(u=this._documents.get(n))===null||u===void 0||u.dispose(),this._documents.set(n,g),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:i}),this._onDidOpenNotebookDocument.fire(g.apiNotebook)}}if(b.addedEditors)for(const i of b.addedEditors){if(this._editors.has(i.id))return;const r=C.URI.revive(i.documentUri),n=this._documents.get(r);n&&this._createExtHostEditor(n,i.id,i)}const t=[];if(b.removedEditors)for(const i of b.removedEditors){const r=this._editors.get(i);r&&(this._editors.delete(i),((d=this._activeNotebookEditor)===null||d===void 0?void 0:d.id)===r.id&&(this._activeNotebookEditor=void 0),t.push(r))}if(b.visibleEditors){this._visibleNotebookEditors=b.visibleEditors.map(r=>this._editors.get(r)).filter(r=>!!r);const i=new Set;this._visibleNotebookEditors.forEach(r=>i.add(r.id));for(const r of this._editors.values()){const n=i.has(r.id);r._acceptVisibility(n)}this._visibleNotebookEditors=[...this._editors.values()].map(r=>r).filter(r=>r.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}b.newActiveEditor===null?this._activeNotebookEditor=void 0:b.newActiveEditor&&(this._activeNotebookEditor=this._editors.get(b.newActiveEditor)),b.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire((p=this._activeNotebookEditor)===null||p===void 0?void 0:p.apiEditor)}}e.ExtHostNotebookController=S,S._notebookStatusBarItemProviderHandlePool=0}),define(ge[232],pe([0,1,3,69,12,5,13,17]),function(Q,e,v,R,k,D,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;class _{constructor(I,l){const m=_._Keys.nextId();I.$registerNotebookEditorDecorationType(m,P.NotebookDecorationRenderOptions.from(l)),this.value={key:m,dispose(){I.$removeNotebookEditorDecorationType(m)}}}}_._Keys=new R.IdGenerator("NotebookEditorDecorationType");let C=class{constructor(I,l,m){this._logService=I,this._extHostRpc=l,this._notebooksAndEditors=m,this._onDidChangeNotebookEditorSelection=new v.Emitter,this._onDidChangeNotebookEditorVisibleRanges=new v.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event}createNotebookEditorDecorationType(I){return new _(this._extHostRpc.getProxy(D.MainContext.MainThreadNotebookEditors),I).value}$acceptEditorPropertiesChanged(I,l){this._logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",I,l);const m=this._notebooksAndEditors.getEditorById(I);l.visibleRanges&&m._acceptVisibleRanges(l.visibleRanges.ranges.map(P.NotebookRange.to)),l.selections&&m._acceptSelections(l.selections.selections.map(P.NotebookRange.to)),l.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:m.apiEditor,visibleRanges:m.apiEditor.visibleRanges}),l.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:m.apiEditor,selections:m.apiEditor.selections}))}$acceptEditorViewColumns(I){for(const l in I)this._notebooksAndEditors.getEditorById(l)._acceptViewColumn(P.ViewColumn.to(I[l]))}};C=Ve([$e(0,k.ILogService),$e(1,A.IExtHostRpcService)],C),e.ExtHostNotebookEditors=C}),define(ge[233],pe([0,1,3,6,5,26,2,17,85,23,16,86,21,18,12,7,35]),function(Q,e,v,R,k,D,A,P,_,C,s,I,l,m,c,h,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookKernels=void 0;let w=class{constructor(t,i,r,n){this._initData=i,this._extHostNotebook=r,this._logService=n,this._activeExecutions=new C.ResourceMap,this._kernelData=new Map,this._handlePool=0,this._proxy=t.getProxy(k.MainContext.MainThreadNotebookKernels)}createNotebookController(t,i,r,n,o,g){for(let F of this._kernelData.values())if(F.controller.id===i&&D.ExtensionIdentifier.equals(t.identifier,F.extensionId))throw new Error(`notebook controller with id '${i}' ALREADY exist`);const f=this._handlePool++,E=this;this._logService.trace(`NotebookController[${f}], CREATED by ${t.identifier.value}, ${i}`);const y=()=>console.warn(`NO execute handler from notebook controller '${J.id}' of extension: '${t.identifier}'`);let a=!1;const L=new R.DisposableStore,O=new v.Emitter,W=new v.Emitter,J={id:`${t.identifier.value}/${i}`,notebookType:r,extensionId:t.identifier,extensionLocation:t.extensionLocation,label:n||t.identifier.value,preloads:g?g.map(P.NotebookRendererScript.from):[]};let se=o??y,q;this._proxy.$addKernel(f,J).catch(F=>{console.log(F),a=!0});let N=0;const H=()=>{if(a)return;const F=++N;Promise.resolve().then(()=>{F===N&&this._proxy.$updateKernel(f,J)})},T=new C.ResourceMap,U={get id(){return i},get notebookType(){return J.notebookType},onDidChangeSelectedNotebooks:O.event,get label(){return J.label},set label(F){var M;J.label=(M=F??t.displayName)!==null&&M!==void 0?M:t.name,H()},get detail(){var F;return(F=J.detail)!==null&&F!==void 0?F:""},set detail(F){J.detail=F,H()},get description(){var F;return(F=J.description)!==null&&F!==void 0?F:""},set description(F){J.description=F,H()},get supportedLanguages(){return J.supportedLanguages},set supportedLanguages(F){J.supportedLanguages=F,H()},get supportsExecutionOrder(){var F;return(F=J.supportsExecutionOrder)!==null&&F!==void 0?F:!1},set supportsExecutionOrder(F){J.supportsExecutionOrder=F,H()},get rendererScripts(){return J.preloads?J.preloads.map(P.NotebookRendererScript.to):[]},get executeHandler(){return se},set executeHandler(F){se=F??y},get interruptHandler(){return q},set interruptHandler(F){q=F,J.supportsInterrupt=Boolean(F),H()},createNotebookCellExecution(F){if(a)throw new Error("notebook controller is DISPOSED");if(!T.has(F.notebook.uri))throw E._logService.trace(`NotebookController[${f}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(T.keys()).map(M=>M.toString())),new Error(`notebook controller is NOT associated to notebook: ${F.notebook.uri.toString()}`);return E._createNotebookCellExecution(F)},dispose:()=>{a||(this._logService.trace(`NotebookController[${f}], DISPOSED`),a=!0,this._kernelData.delete(f),L.dispose(),O.dispose(),W.dispose(),this._proxy.$removeKernel(f))},updateNotebookAffinity(F,M){E._proxy.$updateNotebookPriority(f,F.uri,M)},onDidReceiveMessage:W.event,postMessage(F,M){return S.checkProposedApiEnabled(t),E._proxy.$postMessage(f,M&&E._extHostNotebook.getIdByEditor(M),F)},asWebviewUri(F){return S.checkProposedApiEnabled(t),_.asWebviewUri(F,E._initData.remote)}};return this._kernelData.set(f,{extensionId:t.identifier,controller:U,onDidReceiveMessage:W,onDidChangeSelection:O,associatedNotebooks:T}),U}$acceptNotebookAssociation(t,i,r){const n=this._kernelData.get(t);if(n){const o=this._extHostNotebook.getNotebookDocument(A.URI.revive(i));r?n.associatedNotebooks.set(o.uri,!0):n.associatedNotebooks.delete(o.uri),this._logService.trace(`NotebookController[${t}] ASSOCIATE notebook`,o.uri.toString(),r),n.onDidChangeSelection.fire({selected:r,notebook:o.apiNotebook})}}async $executeCells(t,i,r){const n=this._kernelData.get(t);if(!n)return;const o=this._extHostNotebook.getNotebookDocument(A.URI.revive(i)),g=[];for(let f of r){const E=o.getCell(f);E&&g.push(E.apiCell)}try{this._logService.trace(`NotebookController[${t}] EXECUTE cells`,o.uri.toString(),g.length),await n.controller.executeHandler.call(n.controller,g,o.apiNotebook,n.controller)}catch(f){this._logService.error(`NotebookController[${t}] execute cells FAILED`,f),console.error(f)}}async $cancelCells(t,i,r){var n;const o=this._kernelData.get(t);if(!o)return;const g=this._extHostNotebook.getNotebookDocument(A.URI.revive(i));if(o.controller.interruptHandler)await o.controller.interruptHandler.call(o.controller,g.apiNotebook);else for(let f of r){const E=g.getCell(f);E&&((n=this._activeExecutions.get(E.uri))===null||n===void 0||n.cancel())}}$acceptKernelMessageFromRenderer(t,i,r){const n=this._kernelData.get(t);if(!n)return;const o=this._extHostNotebook.getEditorById(i);n.onDidReceiveMessage.fire(Object.freeze({editor:o.apiEditor,message:r}))}_createNotebookCellExecution(t){if(t.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const r=this._extHostNotebook.getNotebookDocument(t.notebook.uri).getCellFromApiCell(t);if(!r)throw new Error("invalid cell");if(this._activeExecutions.has(r.uri))throw new Error(`duplicate execution for ${r.uri}`);const n=new u(r.notebook,r,this._proxy);this._activeExecutions.set(r.uri,n);const o=n.onDidChangeState(()=>{n.state===b.Resolved&&(n.dispose(),o.dispose(),this._activeExecutions.delete(r.uri))});return n.asApiObject()}};w=Ve([$e(3,c.ILogService)],w),e.ExtHostNotebookKernels=w;var b;(function(p){p[p.Init=0]="Init",p[p.Started=1]="Started",p[p.Resolved=2]="Resolved"})(b||(b={}));class u extends R.Disposable{constructor(t,i,r){super();this._document=t,this._cell=i,this._proxy=r,this._onDidChangeState=new v.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=b.Init,this._tokenSource=this._register(new l.CancellationTokenSource),this._collector=new d(10,n=>this.applyEdits(n)),this._executionOrder=i.internalMetadata.executionOrder,this.mixinMetadata({runState:I.NotebookCellExecutionState.Pending,executionOrder:null})}get state(){return this._state}cancel(){this._tokenSource.cancel()}async applyEditSoon(t){await this._collector.addItem(t)}async applyEdits(t){return this._proxy.$applyExecutionEdits(this._document.uri,t)}verifyStateForOutput(){if(this._state===b.Init)throw new Error("Must call start before modifying cell output");if(this._state===b.Resolved)throw new Error("Cannot modify cell output after calling resolve")}mixinMetadata(t){this.applyEdits([{editType:9,handle:this._cell.handle,internalMetadata:t}])}cellIndexToHandle(t){let i=this._cell;if(t&&(i=this._document.getCellFromApiCell(t)),!i)throw new Error("INVALID cell");return i.handle}validateAndConvertOutputs(t){return t.map(i=>{const r=h.NotebookCellOutput.ensureUniqueMimeTypes(i.items,!0);return r===i.items?P.NotebookCellOutput.from(i):P.NotebookCellOutput.from({items:r,id:i.id,metadata:i.metadata})})}async updateOutputs(t,i,r){const n=this.cellIndexToHandle(i),o=this.validateAndConvertOutputs(m.asArray(t));return this.applyEditSoon({editType:2,handle:n,append:r,outputs:o})}async updateOutputItems(t,i,r){return t=h.NotebookCellOutput.ensureUniqueMimeTypes(m.asArray(t),!0),this.applyEditSoon({editType:7,items:t.map(P.NotebookCellOutputItem.from),outputId:i.id,append:r})}asApiObject(){const t=this;return Object.freeze({get token(){return t._tokenSource.token},get cell(){return t._cell.apiCell},get executionOrder(){return t._executionOrder},set executionOrder(r){t._executionOrder=r,t.mixinMetadata({executionOrder:r})},start(r){if(t._state===b.Resolved||t._state===b.Started)throw new Error("Cannot call start again");t._state=b.Started,t._onDidChangeState.fire(),t.mixinMetadata({runState:I.NotebookCellExecutionState.Executing,runStartTime:r??null})},end(r,n){if(t._state===b.Resolved)throw new Error("Cannot call resolve twice");t._state=b.Resolved,t._onDidChangeState.fire(),t.mixinMetadata({runState:null,lastRunSuccess:r??null,runEndTime:n??null})},clearOutput(r){return t.verifyStateForOutput(),t.updateOutputs([],r,!1)},appendOutput(r,n){return t.verifyStateForOutput(),t.updateOutputs(r,n,!0)},replaceOutput(r,n){return t.verifyStateForOutput(),t.updateOutputs(r,n,!1)},appendOutputItems(r,n){return t.verifyStateForOutput(),t.updateOutputItems(r,n,!0)},replaceOutputItems(r,n){return t.verifyStateForOutput(),t.updateOutputItems(r,n,!1)}})}}class d{constructor(t,i){this.delay=t,this.callback=i,this.batch=[]}addItem(t){return this.batch.push(t),this.waitPromise||(this.waitPromise=s.timeout(this.delay).then(()=>{this.waitPromise=void 0;const i=this.batch;return this.batch=[],this.callback(i)})),this.waitPromise}}}),define(ge[234],pe([0,1,3,5,123]),function(Q,e,v,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class D{constructor(P,_){this._extHostNotebook=_,this._rendererMessageEmitters=new Map,this.proxy=P.getProxy(R.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(P,_,C){var s;const I=this._extHostNotebook.getEditorById(P);(s=this._rendererMessageEmitters.get(_))===null||s===void 0||s.fire({editor:I.apiEditor,message:C})}createRendererMessaging(P){return{onDidReceiveMessage:(...C)=>this.getOrCreateEmitterFor(P).event(...C),postMessage:(C,s)=>{const I=k.ExtHostNotebookEditor.apiEditorsToExtHost.get(C);if(!I)throw new Error("The first argument to postMessage() must be a NotebookEditor");this.proxy.$postMessage(I.id,P,s)}}}getOrCreateEmitterFor(P){let _=this._rendererMessageEmitters.get(P);return _||(_=new v.Emitter({onLastListenerRemove:()=>{_==null||_.dispose(),this._rendererMessageEmitters.delete(P)}}),this._rendererMessageEmitters.set(P,_),_)}}e.ExtHostNotebookRenderers=D}),define(ge[61],pe([0,1,5,3,6,22,4,13]),function(Q,e,v,R,k,D,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=e.LazyOutputChannel=e.ExtHostPushOutputChannel=e.AbstractExtHostOutputChannel=void 0;class _ extends k.Disposable{constructor(c,h,S,w){super();this._onDidAppend=this._register(new R.Emitter),this.onDidAppend=this._onDidAppend.event,this._name=c,this._proxy=w,this._id=w.$register(this.name,h,S),this._disposed=!1,this._offset=0}get name(){return this._name}append(c){this.validate(),this._offset+=c?D.VSBuffer.fromString(c).byteLength:0}update(){this._id.then(c=>this._proxy.$update(c))}appendLine(c){this.validate(),this.append(c+`
`)}clear(){this.validate();const c=this._offset;this._id.then(h=>this._proxy.$clear(h,c))}show(c,h){this.validate(),this._id.then(S=>this._proxy.$reveal(S,!!(typeof c=="boolean"?c:h)))}hide(){this.validate(),this._id.then(c=>this._proxy.$close(c))}validate(){if(this._disposed)throw new Error("Channel has been closed")}dispose(){super.dispose(),this._disposed||this._id.then(c=>this._proxy.$dispose(c)).then(()=>this._disposed=!0)}}e.AbstractExtHostOutputChannel=_;class C extends _{constructor(c,h){super(c,!1,void 0,h)}append(c){super.append(c),this._id.then(h=>this._proxy.$append(h,c)),this._onDidAppend.fire()}}e.ExtHostPushOutputChannel=C;class s extends _{constructor(c,h,S){super(c,!0,h,S)}append(c){throw new Error("Not supported")}}class I{constructor(c,h){this.name=c,this._channel=h}append(c){this._channel.then(h=>h.append(c))}appendLine(c){this._channel.then(h=>h.appendLine(c))}clear(){this._channel.then(c=>c.clear())}show(c,h){this._channel.then(S=>S.show(c,h))}hide(){this._channel.then(c=>c.hide())}dispose(){this._channel.then(c=>c.dispose())}}e.LazyOutputChannel=I;let l=class{constructor(c){this._proxy=c.getProxy(v.MainContext.MainThreadOutputService)}$setVisibleChannel(c){}createOutputChannel(c){if(c=c.trim(),!c)throw new Error("illegal argument `name`. must not be falsy");return new C(c,this._proxy)}createOutputChannelFromLogFile(c,h){if(c=c.trim(),!c)throw new Error("illegal argument `name`. must not be falsy");if(!h)throw new Error("illegal argument `file`. must not be falsy");return new s(c,h,this._proxy)}};l=Ve([$e(0,P.IExtHostRpcService)],l),e.ExtHostOutputService=l,e.IExtHostOutputService=A.createDecorator("IExtHostOutputService")}),define(ge[235],pe([0,1,16,21,3,6,5,2,7,14,18,53]),function(Q,e,v,R,k,D,A,P,_,C,s,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function l(m,c,h){const S=m.getProxy(A.MainContext.MainThreadQuickOpen);class w{constructor(n,o){this._sessions=new Map,this._instances=0,this._workspace=n,this._commands=o}showQuickPick(n,o,g,f=R.CancellationToken.None){this._onDidSelectItem=void 0;const E=Promise.resolve(n),y=++this._instances,a=S.$show(y,{title:g==null?void 0:g.title,placeHolder:g==null?void 0:g.placeHolder,matchOnDescription:g==null?void 0:g.matchOnDescription,matchOnDetail:g==null?void 0:g.matchOnDetail,ignoreFocusLost:g==null?void 0:g.ignoreFocusOut,canPickMany:g==null?void 0:g.canPickMany},f),L={},O=a.then(()=>L);return Promise.race([O,E]).then(W=>{if(W!==L)return E.then(J=>{const se=[];for(let q=0;q<J.length;q++){const N=J[q];let H,T,U,F,M;typeof N=="string"?H=N:(H=N.label,T=N.description,U=N.detail,F=N.picked,M=N.alwaysShow),se.push({label:H,description:T,handle:q,detail:U,picked:F,alwaysShow:M})}return g&&typeof g.onDidSelectItem=="function"&&(this._onDidSelectItem=q=>{g.onDidSelectItem(J[q])}),S.$setItems(y,se),a.then(q=>{if(typeof q=="number")return J[q];if(Array.isArray(q))return q.map(N=>J[N])})})}).then(void 0,W=>{if(!C.isPromiseCanceledError(W))return S.$setError(y,W),Promise.reject(W)})}$onItemSelected(n){this._onDidSelectItem&&this._onDidSelectItem(n)}showInput(n,o=R.CancellationToken.None){return this._validateInput=n?n.validateInput:void 0,S.$input(n,typeof this._validateInput=="function",o).then(void 0,g=>{if(!C.isPromiseCanceledError(g))return Promise.reject(g)})}$validateInput(n){return this._validateInput?v.asPromise(()=>this._validateInput(n)):Promise.resolve(void 0)}async showWorkspaceFolderPick(n,o=R.CancellationToken.None){const g=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[n]);if(!g)return;const f=await this._workspace.getWorkspaceFolders2();if(!!f)return f.find(E=>E.uri.toString()===g.uri.toString())}createQuickPick(n,o){const g=new t(n,o,()=>this._sessions.delete(g._id));return this._sessions.set(g._id,g),g}createInputBox(n){const o=new i(n,()=>this._sessions.delete(o._id));return this._sessions.set(o._id,o),o}$onDidChangeValue(n,o){const g=this._sessions.get(n);g&&g._fireDidChangeValue(o)}$onDidAccept(n){const o=this._sessions.get(n);o&&o._fireDidAccept()}$onDidChangeActive(n,o){const g=this._sessions.get(n);g instanceof t&&g._fireDidChangeActive(o)}$onDidChangeSelection(n,o){const g=this._sessions.get(n);g instanceof t&&g._fireDidChangeSelection(o)}$onDidTriggerButton(n,o){const g=this._sessions.get(n);g&&g._fireDidTriggerButton(o)}$onDidHide(n){const o=this._sessions.get(n);o&&o._fireDidHide()}}class b{constructor(n,o){this._extensionId=n,this._onDidDispose=o,this._id=t._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new k.Emitter,this._onDidChangeValueEmitter=new k.Emitter,this._onDidTriggerButtonEmitter=new k.Emitter,this._onDidHideEmitter=new k.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(n){this._title=n,this.update({title:n})}get step(){return this._steps}set step(n){this._steps=n,this.update({step:n})}get totalSteps(){return this._totalSteps}set totalSteps(n){this._totalSteps=n,this.update({totalSteps:n})}get enabled(){return this._enabled}set enabled(n){this._enabled=n,this.update({enabled:n})}get busy(){return this._busy}set busy(n){this._busy=n,this.update({busy:n})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(n){this._ignoreFocusOut=n,this.update({ignoreFocusOut:n})}get value(){return this._value}set value(n){this._value=n,this.update({value:n})}get placeholder(){return this._placeholder}set placeholder(n){this._placeholder=n,this.update({placeholder:n})}get buttons(){return this._buttons}set buttons(n){this._buttons=n.slice(),this._handlesToButtons.clear(),n.forEach((o,g)=>{const f=o===_.QuickInputButtons.Back?-1:g;this._handlesToButtons.set(f,o)}),this.update({buttons:n.map((o,g)=>({iconPath:u(o.iconPath),tooltip:o.tooltip,handle:o===_.QuickInputButtons.Back?-1:g}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(n){this._value=n,this._onDidChangeValueEmitter.fire(n)}_fireDidTriggerButton(n){const o=this._handlesToButtons.get(n);o&&this._onDidTriggerButtonEmitter.fire(o)}_fireDidHide(){this._expectingHide&&(this._expectingHide=!1,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=D.dispose(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),S.$dispose(this._id))}update(n){if(!this._disposed){for(const o of Object.keys(n)){const g=n[o];this._pendingUpdate[o]=g===void 0?null:g}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){S.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}b._nextId=1;function u(r){if(r instanceof _.ThemeIcon)return{id:r.id};const n=p(r),o=d(r);return{dark:typeof n=="string"?P.URI.file(n):n,light:typeof o=="string"?P.URI.file(o):o}}function d(r){return typeof r=="object"&&"light"in r?r.light:r}function p(r){return typeof r=="object"&&"dark"in r?r.dark:r}class t extends b{constructor(n,o,g){super(n,g);this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._activeItems=[],this._onDidChangeActiveEmitter=new k.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new k.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(n){this._items=n.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),n.forEach((o,g)=>{this._handlesToItems.set(g,o),this._itemsToHandles.set(o,g)}),this.update({items:n.map((o,g)=>({label:o.label,description:o.description,handle:g,detail:o.detail,picked:o.picked,alwaysShow:o.alwaysShow}))})}get canSelectMany(){return this._canSelectMany}set canSelectMany(n){this._canSelectMany=n,this.update({canSelectMany:n})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(n){this._matchOnDescription=n,this.update({matchOnDescription:n})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(n){this._matchOnDetail=n,this.update({matchOnDetail:n})}get sortByLabel(){return this._sortByLabel}set sortByLabel(n){this._sortByLabel=n,this.update({sortByLabel:n})}get activeItems(){return this._activeItems}set activeItems(n){this._activeItems=n.filter(o=>this._itemsToHandles.has(o)),this.update({activeItems:this._activeItems.map(o=>this._itemsToHandles.get(o))})}get selectedItems(){return this._selectedItems}set selectedItems(n){this._selectedItems=n.filter(o=>this._itemsToHandles.has(o)),this.update({selectedItems:this._selectedItems.map(o=>this._itemsToHandles.get(o))})}_fireDidChangeActive(n){const o=s.coalesce(n.map(g=>this._handlesToItems.get(g)));this._activeItems=o,this._onDidChangeActiveEmitter.fire(o)}_fireDidChangeSelection(n){const o=s.coalesce(n.map(g=>this._handlesToItems.get(g)));this._selectedItems=o,this._onDidChangeSelectionEmitter.fire(o)}}class i extends b{constructor(n,o){super(n,o);this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(n){this._password=n,this.update({password:n})}get prompt(){return this._prompt}set prompt(n){this._prompt=n,this.update({prompt:n})}get validationMessage(){return this._validationMessage}set validationMessage(n){this._validationMessage=n,this.update({validationMessage:n,severity:n?I.default.Error:I.default.Ignore})}}return new w(c,h)}e.createExtHostQuickOpen=l}),define(ge[236],pe([0,1,2,3,51,6,16,5,18,97,12,26,35]),function(Q,e,v,R,k,D,A,P,_,C,s,I,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function m(n){if(n)return typeof n.iconPath=="string"?v.URI.file(n.iconPath):n.iconPath}function c(n,o){if(!n.iconPath&&!o.iconPath)return 0;if(n.iconPath){if(!o.iconPath)return 1}else return-1;const g=typeof n.iconPath=="string"?n.iconPath:n.iconPath.fsPath,f=typeof o.iconPath=="string"?o.iconPath:o.iconPath.fsPath;return C.comparePaths(g,f)}function h(n,o){let g=0;if(n.strikeThrough!==o.strikeThrough)return n.strikeThrough?1:-1;if(n.faded!==o.faded)return n.faded?1:-1;if(n.tooltip!==o.tooltip)return(n.tooltip||"").localeCompare(o.tooltip||"");if(g=c(n,o),g!==0)return g;if(n.light&&o.light)g=c(n.light,o.light);else{if(n.light)return 1;if(o.light)return-1}if(g!==0)return g;if(n.dark&&o.dark)g=c(n.dark,o.dark);else{if(n.dark)return 1;if(o.dark)return-1}return g}function S(n,o){if(n.command!==o.command)return n.command<o.command?-1:1;if(n.title!==o.title)return n.title<o.title?-1:1;if(n.tooltip!==o.tooltip){if(n.tooltip!==void 0&&o.tooltip!==void 0)return n.tooltip<o.tooltip?-1:1;if(n.tooltip!==void 0)return 1;if(o.tooltip!==void 0)return-1}if(n.arguments===o.arguments)return 0;if(n.arguments)if(o.arguments){if(n.arguments.length!==o.arguments.length)return n.arguments.length-o.arguments.length}else return 1;else return-1;for(let g=0;g<n.arguments.length;g++){const f=n.arguments[g],E=o.arguments[g];if(f!==E)return f<E?-1:1}return 0}function w(n,o){let g=C.comparePaths(n.resourceUri.fsPath,o.resourceUri.fsPath,!0);if(g!==0)return g;if(n.command&&o.command)g=S(n.command,o.command);else{if(n.command)return 1;if(o.command)return-1}if(g!==0)return g;if(n.decorations&&o.decorations)g=h(n.decorations,o.decorations);else{if(n.decorations)return 1;if(o.decorations)return-1}return g}function b(n,o){for(let g=0;g<n.length;g++)if(n[g]!==o[g])return!1;return!0}function u(n,o){return n.command===o.command&&n.title===o.title&&n.tooltip===o.tooltip&&(n.arguments&&o.arguments?b(n.arguments,o.arguments):n.arguments===o.arguments)}function d(n,o){return _.equals(n,o,u)}class p{constructor(o,g,f){this._extension=o,this._proxy=g,this._sourceControlHandle=f,this._value="",this._onDidChange=new R.Emitter,this._placeholder="",this._visible=!0}get value(){return this._value}set value(o){this._proxy.$setInputBoxValue(this._sourceControlHandle,o),this.updateValue(o)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(o){this._proxy.$setInputBoxPlaceholder(this._sourceControlHandle,o),this._placeholder=o}get validateInput(){return l.checkProposedApiEnabled(this._extension),this._validateInput}set validateInput(o){if(l.checkProposedApiEnabled(this._extension),o&&typeof o!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=o,this._proxy.$setValidationProviderIsEnabled(this._sourceControlHandle,!!o)}get visible(){return this._visible}set visible(o){o=!!o,this._visible!==o&&(this._visible=o,this._proxy.$setInputBoxVisibility(this._sourceControlHandle,o))}focus(){l.checkProposedApiEnabled(this._extension),this._visible||(this.visible=!0),this._proxy.$setInputBoxFocus(this._sourceControlHandle)}showValidationMessage(o,g){l.checkProposedApiEnabled(this._extension),this._proxy.$showValidationMessage(this._sourceControlHandle,o,g)}$onInputBoxValueChange(o){this.updateValue(o)}updateValue(o){this._value=o,this._onDidChange.fire(o)}}e.ExtHostSCMInputBox=p;class t{constructor(o,g,f,E,y){this._proxy=o,this._commands=g,this._sourceControlHandle=f,this._id=E,this._label=y,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new R.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new R.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=t._handlePool++}get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(o){this._label=o,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,o)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(o){this._hideWhenEmpty=o,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(o){this._resourceStates=[...o],this._onDidUpdateResourceStates.fire()}getResourceState(o){return this._resourceStatesMap.get(o)}$executeResourceCommand(o,g){const f=this._resourceStatesCommandsMap.get(o);return f?A.asPromise(()=>this._commands.executeCommand(f.command,...f.arguments||[],g)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){var o;const g=[...this._resourceStates].sort(w),E=_.sortedDiff(this._resourceSnapshot,g,w).map(L=>{const O=L.toInsert.map(W=>{const J=this._resourceHandlePool++;this._resourceStatesMap.set(J,W);const se=W.resourceUri,q=m(W.decorations),N=W.decorations&&m(W.decorations.light)||q,H=W.decorations&&m(W.decorations.dark)||q,T=[];let U;if(W.command)if(W.command.command==="vscode.open"||W.command.command==="vscode.diff"){const le=new D.DisposableStore;U=this._commands.converter.toInternal(W.command,le),this._resourceStatesDisposablesMap.set(J,le)}else this._resourceStatesCommandsMap.set(J,W.command);N&&T.push(N),H&&H.toString()!==(N==null?void 0:N.toString())&&T.push(H);const F=W.decorations&&W.decorations.tooltip||"",M=W.decorations&&!!W.decorations.strikeThrough,x=W.decorations&&!!W.decorations.faded,$=W.contextValue||"";return{rawResource:[J,se,T,F,M,x,$,U],handle:J}});return{start:L.start,deleteCount:L.deleteCount,toInsert:O}}),y=E.map(({start:L,deleteCount:O,toInsert:W})=>[L,O,W.map(J=>J.rawResource)]),a=E.reverse();for(const{start:L,deleteCount:O,toInsert:W}of a){const J=W.map(q=>q.handle),se=this._handlesSnapshot.splice(L,O,...J);for(const q of se)this._resourceStatesMap.delete(q),this._resourceStatesCommandsMap.delete(q),(o=this._resourceStatesDisposablesMap.get(q))===null||o===void 0||o.dispose(),this._resourceStatesDisposablesMap.delete(q)}return this._resourceSnapshot=g,y}dispose(){this._disposed=!0,this._onDidDispose.fire()}}t._handlePool=0;class i{constructor(o,g,f,E,y,a){this._proxy=g,this._commands=f,this._id=E,this._label=y,this._rootUri=a,this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._commitTemplate=void 0,this._acceptInputDisposables=new D.MutableDisposable,this._acceptInputCommand=void 0,this._statusBarDisposables=new D.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new R.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=i._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,this._inputBox=new p(o,this._proxy,this.handle),this._proxy.$registerSourceControl(this.handle,E,y,a)}get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(o){this._count!==o&&(this._count=o,this._proxy.$updateSourceControl(this.handle,{count:o}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(o){this._quickDiffProvider=o,this._proxy.$updateSourceControl(this.handle,{hasQuickDiffProvider:!!o})}get commitTemplate(){return this._commitTemplate}set commitTemplate(o){o!==this._commitTemplate&&(this._commitTemplate=o,this._proxy.$updateSourceControl(this.handle,{commitTemplate:o}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(o){this._acceptInputDisposables.value=new D.DisposableStore,this._acceptInputCommand=o;const g=this._commands.converter.toInternal(o,this._acceptInputDisposables.value);this._proxy.$updateSourceControl(this.handle,{acceptInputCommand:g})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(o){if(this._statusBarCommands&&o&&d(this._statusBarCommands,o))return;this._statusBarDisposables.value=new D.DisposableStore,this._statusBarCommands=o;const g=(o||[]).map(f=>this._commands.converter.toInternal(f,this._statusBarDisposables.value));this._proxy.$updateSourceControl(this.handle,{statusBarCommands:g})}get selected(){return this._selected}createResourceGroup(o,g){const f=new t(this._proxy,this._commands,this.handle,o,g),E=R.Event.once(f.onDidDispose)(()=>this.createdResourceGroups.delete(f));return this.createdResourceGroups.set(f,E),this.eventuallyAddResourceGroups(),f}eventuallyAddResourceGroups(){const o=[],g=[];for(const[f,E]of this.createdResourceGroups){E.dispose();const y=f.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(f),this.eventuallyUpdateResourceStates()});R.Event.once(f.onDidDispose)(()=>{this.updatedResourceGroups.delete(f),y.dispose(),this._groups.delete(f.handle),this._proxy.$unregisterGroup(this.handle,f.handle)}),o.push([f.handle,f.id,f.label,f.features]);const a=f._takeResourceStateSnapshot();a.length>0&&g.push([f.handle,a]),this._groups.set(f.handle,f)}this._proxy.$registerGroups(this.handle,o,g),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const o=[];this.updatedResourceGroups.forEach(g=>{const f=g._takeResourceStateSnapshot();f.length!==0&&o.push([g.handle,f])}),o.length>0&&this._proxy.$spliceResourceStates(this.handle,o),this.updatedResourceGroups.clear()}getResourceGroup(o){return this._groups.get(o)}setSelectionState(o){this._selected=o,this._onDidChangeSelection.fire(o)}dispose(){this._acceptInputDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(o=>o.dispose()),this._proxy.$unregisterSourceControl(this.handle)}}i._handlePool=0,Ve([k.debounce(100)],i.prototype,"eventuallyAddResourceGroups",null),Ve([k.debounce(100)],i.prototype,"eventuallyUpdateResourceStates",null);let r=class xn{constructor(o,g,f){this._commands=g,this.logService=f,this._sourceControls=new Map,this._sourceControlsByExtension=new Map,this._onDidChangeActiveProvider=new R.Emitter,this._proxy=o.getProxy(P.MainContext.MainThreadSCM),this._telemetry=o.getProxy(P.MainContext.MainThreadTelemetry),g.registerArgumentProcessor({processArgument:E=>{if(E&&E.$mid===3){const y=this._sourceControls.get(E.sourceControlHandle);if(!y)return E;const a=y.getResourceGroup(E.groupHandle);return a?a.getResourceState(E.handle):E}else if(E&&E.$mid===4){const y=this._sourceControls.get(E.sourceControlHandle);return y?y.getResourceGroup(E.groupHandle):E}else if(E&&E.$mid===5){const y=this._sourceControls.get(E.handle);return y||E}return E}})}get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}createSourceControl(o,g,f,E){this.logService.trace("ExtHostSCM#createSourceControl",o.identifier.value,g,f,E),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:o.identifier.value});const y=xn._handlePool++,a=new i(o,this._proxy,this._commands,g,f,E);this._sourceControls.set(y,a);const L=this._sourceControlsByExtension.get(I.ExtensionIdentifier.toKey(o.identifier))||[];return L.push(a),this._sourceControlsByExtension.set(I.ExtensionIdentifier.toKey(o.identifier),L),a}getLastInputBox(o){this.logService.trace("ExtHostSCM#getLastInputBox",o.identifier.value);const g=this._sourceControlsByExtension.get(I.ExtensionIdentifier.toKey(o.identifier)),f=g&&g[g.length-1];return f&&f.inputBox}$provideOriginalResource(o,g,f){const E=v.URI.revive(g);this.logService.trace("ExtHostSCM#$provideOriginalResource",o,E.toString());const y=this._sourceControls.get(o);return!y||!y.quickDiffProvider||!y.quickDiffProvider.provideOriginalResource?Promise.resolve(null):A.asPromise(()=>y.quickDiffProvider.provideOriginalResource(E,f)).then(a=>a||null)}$onInputBoxValueChange(o,g){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",o);const f=this._sourceControls.get(o);return f&&f.inputBox.$onInputBoxValueChange(g),Promise.resolve(void 0)}$executeResourceCommand(o,g,f,E){this.logService.trace("ExtHostSCM#$executeResourceCommand",o,g,f);const y=this._sourceControls.get(o);if(!y)return Promise.resolve(void 0);const a=y.getResourceGroup(g);return a?a.$executeResourceCommand(f,E):Promise.resolve(void 0)}$validateInput(o,g,f){this.logService.trace("ExtHostSCM#$validateInput",o);const E=this._sourceControls.get(o);return!E||!E.inputBox.validateInput?Promise.resolve(void 0):A.asPromise(()=>E.inputBox.validateInput(g,f)).then(y=>y?Promise.resolve([y.message,y.type]):Promise.resolve(void 0))}$setSelectedSourceControl(o){var g,f;return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",o),o!==void 0&&((g=this._sourceControls.get(o))===null||g===void 0||g.setSelectionState(!0)),this._selectedSourceControlHandle!==void 0&&((f=this._sourceControls.get(this._selectedSourceControlHandle))===null||f===void 0||f.setSelectionState(!1)),this._selectedSourceControlHandle=o,Promise.resolve(void 0)}};r._handlePool=0,r=Ve([$e(2,s.ILogService)],r),e.ExtHostSCM=r});var it=this&&this.__classPrivateFieldSet||function(Q,e,v,R,k){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Q!==e||!k:!e.has(Q))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?k.call(Q,v):k?k.value=v:e.set(Q,v),v},Be=this&&this.__classPrivateFieldGet||function(Q,e,v,R){if(v==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Q!==e||!R:!e.has(Q))throw new TypeError("Cannot read private member from an object whose class did not declare it");return v==="m"?R:v==="a"?R.call(Q):R?R.value:e.get(Q)};define(ge[237],pe([0,1,7,5,161,6]),function(Q,e,v,R,k,D){"use strict";var A,P;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class _{constructor(l,m,c,h,S=v.StatusBarAlignment.Left,w){A.set(this,void 0),P.set(this,void 0),this._disposed=!1,this._visible=!1,this._text="",this._internalCommandRegistration=new D.DisposableStore,it(this,A,l,"f"),it(this,P,m,"f"),this._entryId=_.ID_GEN++,this._extension=c,this._id=h,this._alignment=S,this._priority=w}get id(){var l;return(l=this._id)!==null&&l!==void 0?l:this._extension.identifier.value}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get name(){return this._name}get tooltip(){return this._tooltip}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){var l;return(l=this._command)===null||l===void 0?void 0:l.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(l){this._text=l,this.update()}set name(l){this._name=l,this.update()}set tooltip(l){this._tooltip=l,this.update()}set color(l){this._color=l,this.update()}set backgroundColor(l){l&&!_.ALLOWED_BACKGROUND_COLORS.has(l.id)&&(l=void 0),this._backgroundColor=l,this.update()}set command(l){var m;((m=this._command)===null||m===void 0?void 0:m.fromApi)!==l&&(this._internalCommandRegistration.clear(),typeof l=="string"?this._command={fromApi:l,internal:Be(this,P,"f").toInternal({title:"",command:l},this._internalCommandRegistration)}:l?this._command={fromApi:l,internal:Be(this,P,"f").toInternal(l,this._internalCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(l){this._accessibilityInformation=l,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,Be(this,A,"f").$dispose(this._entryId)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{var l;this._timeoutHandle=void 0;let m;this._extension?this._id?m=`${this._extension.identifier.value}.${this._id}`:m=this._extension.identifier.value:m=this._id;let c;this._name?c=this._name:c=k.localize(0,null,this._extension.displayName||this._extension.name);let h=this._color;this._backgroundColor&&(h=_.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id)),Be(this,A,"f").$setEntry(this._entryId,m,c,this._text,this._tooltip,(l=this._command)===null||l===void 0?void 0:l.internal,h,this._backgroundColor,this._alignment===v.StatusBarAlignment.Left?0:1,this._priority,this._accessibilityInformation)},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=_,A=new WeakMap,P=new WeakMap,_.ID_GEN=0,_.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new v.ThemeColor("statusBarItem.errorForeground")]]);class C{constructor(l){this._messages=[],this._item=l.createStatusBarEntry(void 0,"status.extensionMessage",v.StatusBarAlignment.Left,Number.MIN_VALUE),this._item.name=k.localize(1,null)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(l){const m={message:l};return this._messages.unshift(m),this._update(),new v.Disposable(()=>{const c=this._messages.indexOf(m);c>=0&&(this._messages.splice(c,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class s{constructor(l,m){this._proxy=l.getProxy(R.MainContext.MainThreadStatusBar),this._commands=m,this._statusMessage=new C(this)}createStatusBarEntry(l,m,c,h){return new _(this._proxy,this._commands,l,m,c,h)}setStatusBarMessage(l,m){const c=this._statusMessage.setMessage(l);let h;return typeof m=="number"?h=setTimeout(()=>c.dispose(),m):typeof m!="undefined"&&m.then(()=>c.dispose(),()=>c.dispose()),new v.Disposable(()=>{c.dispose(),clearTimeout(h)})}}e.ExtHostStatusBar=s}),define(ge[89],pe([0,1,5,3,4]),function(Q,e,v,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class D{constructor(P){this._onDidChangeStorage=new R.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=P.getProxy(v.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(P,_){this._proxy.$registerExtensionStorageKeysToSync(P,_)}getValue(P,_,C){return this._proxy.$getValue(P,_).then(s=>s||C)}setValue(P,_,C){return this._proxy.$setValue(P,_,C)}$acceptValue(P,_,C){this._onDidChangeStorage.fire({shared:P,key:_,value:C})}}e.ExtHostStorage=D,e.IExtHostStorage=k.createDecorator("IExtHostStorage")}),define(ge[90],pe([0,1,4,27,12,88,2]),function(Q,e,v,R,k,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=v.createDecorator("IExtensionStoragePaths");let P=class{constructor(C,s,I){var l;this._logService=s,this._extHostFileSystem=I,this._workspace=(l=C.workspace)!==null&&l!==void 0?l:void 0,this._environment=C.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(m=>this._value=m)}async _getOrCreateWorkspaceStoragePath(){var C;if(!this._workspace)return Promise.resolve(void 0);const s=this._workspace.id,I=A.URI.joinPath(this._environment.workspaceStorageHome,s);try{return await this._extHostFileSystem.value.stat(I),this._logService.trace("[ExtHostStorage] storage dir already exists",I),I}catch(l){}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",I),await this._extHostFileSystem.value.createDirectory(I),await this._extHostFileSystem.value.writeFile(A.URI.joinPath(I,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:(C=A.URI.revive(this._workspace.configuration))===null||C===void 0?void 0:C.toString(),name:this._workspace.name},void 0,2))),I}catch(l){this._logService.error("[ExtHostStorage]",l);return}}workspaceValue(C){if(this._value)return A.URI.joinPath(this._value,C.identifier.value)}globalValue(C){return A.URI.joinPath(this._environment.globalStorageHome,C.identifier.value.toLowerCase())}};P=Ve([$e(0,R.IExtHostInitDataService),$e(1,k.ILogService),$e(2,D.IExtHostConsumerFileSystem)],P),e.ExtensionStoragePaths=P}),define(ge[33],pe([0,1,3,5,4,2,13,6,7,162,14,201,21,32,188,15]),function(Q,e,v,R,k,D,A,P,_,C,s,I,l,m,c,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.EnvironmentVariableCollection=e.BaseExtHostTerminalService=e.ExtHostPseudoterminal=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=k.createDecorator("IExtHostTerminalService");class S{constructor(r,n,o,g){this._proxy=r,this._id=n,this._creationOptions=o,this._name=g,this._disposed=!1,this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(E=>this._pidPromiseComplete=E);const f=this;this.value={get name(){return f._name||""},get processId(){return f._pidPromise},get creationOptions(){return f._creationOptions},get exitStatus(){return f._exitStatus},sendText(E,y=!0){f._checkDisposed(),f._proxy.$sendText(f._id,E,y)},show(E){f._checkDisposed(),f._proxy.$show(f._id,E)},hide(){f._checkDisposed(),f._proxy.$hide(f._id)},dispose(){f._disposed||(f._disposed=!0,f._proxy.$dispose(f._id))},get dimensions(){if(!(f._cols===void 0||f._rows===void 0))return{columns:f._cols,rows:f._rows}}}}async create(r,n){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:r.name,shellPath:h.withNullAsUndefined(r.shellPath),shellArgs:h.withNullAsUndefined(r.shellArgs),cwd:h.withNullAsUndefined(r.cwd),env:h.withNullAsUndefined(r.env),icon:h.withNullAsUndefined(t(r.iconPath)),initialText:h.withNullAsUndefined(r.message),strictEnv:h.withNullAsUndefined(r.strictEnv),hideFromUser:h.withNullAsUndefined(r.hideFromUser),isFeatureTerminal:h.withNullAsUndefined(n==null?void 0:n.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:h.withNullAsUndefined(n==null?void 0:n.useShellEnvironment),isSplitTerminal:h.withNullAsUndefined(n==null?void 0:n.isSplitTerminal)})}async createExtensionTerminal(r,n){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0,icon:n,isSplitTerminal:r}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(r){this._name=r}setExitCode(r){this._exitStatus=Object.freeze({code:r})}setDimensions(r,n){return r===this._cols&&n===this._rows||r===0||n===0?!1:(this._cols=r,this._rows=n,!0)}_setProcessId(r){this._pidPromiseComplete?(this._pidPromiseComplete(r),this._pidPromiseComplete=void 0):this._pidPromise.then(n=>{n!==r&&(this._pidPromise=Promise.resolve(r))})}}e.ExtHostTerminal=S;class w{constructor(r){this._pty=r,this.id=0,this.shouldPersist=!1,this._onProcessData=new v.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessExit=new v.Emitter,this.onProcessExit=this._onProcessExit.event,this._onProcessReady=new v.Emitter,this._onProcessTitleChanged=new v.Emitter,this.onProcessTitleChanged=this._onProcessTitleChanged.event,this._onProcessOverrideDimensions=new v.Emitter,this._onProcessShellTypeChanged=new v.Emitter,this.onProcessShellTypeChanged=this._onProcessShellTypeChanged.event}get onProcessReady(){return this._onProcessReady.event}get onProcessOverrideDimensions(){return this._onProcessOverrideDimensions.event}async start(){}shutdown(){this._pty.close()}input(r){this._pty.handleInput&&this._pty.handleInput(r)}resize(r,n){this._pty.setDimensions&&this._pty.setDimensions({columns:r,rows:n})}async processBinary(r){}acknowledgeDataEvent(r){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(r){this._pty.onDidWrite(n=>this._onProcessData.fire(n)),this._pty.onDidClose&&this._pty.onDidClose((n=void 0)=>{this._onProcessExit.fire(n===void 0?void 0:n)}),this._pty.onDidOverrideDimensions&&this._pty.onDidOverrideDimensions(n=>this._onProcessOverrideDimensions.fire(n&&{cols:n.columns,rows:n.rows})),this._pty.onDidChangeName&&this._pty.onDidChangeName(n=>this._onProcessTitleChanged.fire(n)),this._pty.open(r||void 0),this._pty.setDimensions&&r&&this._pty.setDimensions(r),this._onProcessReady.fire({pid:-1,cwd:""})}}e.ExtHostPseudoterminal=w;let b=1,u=class extends P.Disposable{constructor(r,n){super();this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._linkProviders=new Set,this._profileProviders=new Map,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new v.Emitter,this._onDidOpenTerminal=new v.Emitter,this._onDidChangeActiveTerminal=new v.Emitter,this._onDidChangeTerminalDimensions=new v.Emitter,this._proxy=n.getProxy(R.MainContext.MainThreadTerminalService),this._bufferer=new c.TerminalDataBufferer(this._proxy.$sendProcessData),this._onDidWriteTerminalData=new v.Emitter({onFirstListenerAdd:()=>this._proxy.$startSendingDataEvents(),onLastListenerRemove:()=>this._proxy.$stopSendingDataEvents()}),this._proxy.$registerProcessSupport(r),this._register({dispose:()=>{for(const[o,g]of this._terminalProcesses)g.shutdown(!0)}})}get activeTerminal(){var r;return(r=this._activeTerminal)===null||r===void 0?void 0:r.value}get terminals(){return this._terminals.map(r=>r.value)}get onDidCloseTerminal(){return this._onDidCloseTerminal&&this._onDidCloseTerminal.event}get onDidOpenTerminal(){return this._onDidOpenTerminal&&this._onDidOpenTerminal.event}get onDidChangeActiveTerminal(){return this._onDidChangeActiveTerminal&&this._onDidChangeActiveTerminal.event}get onDidChangeTerminalDimensions(){return this._onDidChangeTerminalDimensions&&this._onDidChangeTerminalDimensions.event}get onDidWriteTerminalData(){return this._onDidWriteTerminalData&&this._onDidWriteTerminalData.event}getDefaultShell(r){const n=r?this._defaultAutomationProfile:this._defaultProfile;return(n==null?void 0:n.path)||""}getDefaultShellArgs(r){const n=r?this._defaultAutomationProfile:this._defaultProfile;return(n==null?void 0:n.args)||[]}createExtensionTerminal(r,n){const o=new S(this._proxy,m.generateUuid(),r,r.name),g=new w(r.pty);return o.createExtensionTerminal(n==null?void 0:n.isSplitTerminal,t(r.iconPath)).then(f=>{const E=this._setupExtHostProcessListeners(f,g);this._terminalProcessDisposables[f]=E}),this._terminals.push(o),o.value}attachPtyToTerminal(r,n){if(!this._getTerminalById(r))throw new Error(`Cannot resolve terminal with id ${r} for virtual process`);const g=new w(n),f=this._setupExtHostProcessListeners(r,g);this._terminalProcessDisposables[r]=f}async $acceptActiveTerminalChanged(r){const n=this._activeTerminal;if(r===null){this._activeTerminal=void 0,n!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const o=this._getTerminalById(r);o&&(this._activeTerminal=o,n!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(r,n){const o=this._getTerminalById(r);o&&this._onDidWriteTerminalData.fire({terminal:o.value,data:n})}async $acceptTerminalDimensions(r,n,o){const g=this._getTerminalById(r);g&&g.setDimensions(n,o)&&this._onDidChangeTerminalDimensions.fire({terminal:g.value,dimensions:g.value.dimensions})}async $acceptTerminalMaximumDimensions(r,n,o){var g;(g=this._terminalProcesses.get(r))===null||g===void 0||g.resize(n,o)}async $acceptTerminalTitleChange(r,n){const o=this._getTerminalById(r);o&&(o.name=n)}async $acceptTerminalClosed(r,n){const o=this._getTerminalObjectIndexById(this._terminals,r);if(o!==null){const g=this._terminals.splice(o,1)[0];g.setExitCode(n),this._onDidCloseTerminal.fire(g.value)}}$acceptTerminalOpened(r,n,o,g){if(n){const y=this._getTerminalObjectIndexById(this._terminals,n);if(y!==null){this._terminals[y]._id=r,this._onDidOpenTerminal.fire(this.terminals[y]),this._terminals[y].isOpen=!0;return}}const f={name:g.name,shellPath:g.executable,shellArgs:g.args,cwd:typeof g.cwd=="string"?g.cwd:D.URI.revive(g.cwd),env:g.env,hideFromUser:g.hideFromUser},E=new S(this._proxy,r,f,o);this._terminals.push(E),this._onDidOpenTerminal.fire(E.value),E.isOpen=!0}async $acceptTerminalProcessId(r,n){const o=this._getTerminalById(r);o&&o._setProcessId(n)}async $startExtensionTerminal(r,n){const o=this._getTerminalById(r);if(!o)return{message:C.localize(0,null,r)};o.isOpen||await new Promise(f=>{const E=this.onDidOpenTerminal(async y=>{y===o.value&&(E.dispose(),f())})});const g=this._terminalProcesses.get(r);g?g.startSendingEvents(n):this._extensionTerminalAwaitingStart[r]={initialDimensions:n}}_setupExtHostProcessListeners(r,n){const o=new P.DisposableStore;o.add(n.onProcessReady(f=>this._proxy.$sendProcessReady(r,f.pid,f.cwd))),o.add(n.onProcessTitleChanged(f=>this._proxy.$sendProcessTitle(r,f))),this._bufferer.startBuffering(r,n.onProcessData),o.add(n.onProcessExit(f=>this._onProcessExit(r,f))),n.onProcessOverrideDimensions&&o.add(n.onProcessOverrideDimensions(f=>this._proxy.$sendOverrideDimensions(r,f))),this._terminalProcesses.set(r,n);const g=this._extensionTerminalAwaitingStart[r];return g&&n instanceof w&&(n.startSendingEvents(g.initialDimensions),delete this._extensionTerminalAwaitingStart[r]),o}$acceptProcessAckDataEvent(r,n){var o;(o=this._terminalProcesses.get(r))===null||o===void 0||o.acknowledgeDataEvent(n)}$acceptProcessInput(r,n){var o;(o=this._terminalProcesses.get(r))===null||o===void 0||o.input(n)}$acceptProcessResize(r,n,o){var g;try{(g=this._terminalProcesses.get(r))===null||g===void 0||g.resize(n,o)}catch(f){if(f.code!=="EPIPE"&&f.code!=="ERR_IPC_CHANNEL_CLOSED")throw f}}$acceptProcessShutdown(r,n){var o;(o=this._terminalProcesses.get(r))===null||o===void 0||o.shutdown(n)}$acceptProcessRequestInitialCwd(r){var n;(n=this._terminalProcesses.get(r))===null||n===void 0||n.getInitialCwd().then(o=>this._proxy.$sendProcessInitialCwd(r,o))}$acceptProcessRequestCwd(r){var n;(n=this._terminalProcesses.get(r))===null||n===void 0||n.getCwd().then(o=>this._proxy.$sendProcessCwd(r,o))}$acceptProcessRequestLatency(r){return r}registerLinkProvider(r){return this._linkProviders.add(r),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new _.Disposable(()=>{this._linkProviders.delete(r),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}registerProfileProvider(r,n){if(this._profileProviders.has(r))throw new Error(`Terminal profile provider "${r}" already registered`);return this._profileProviders.set(r,n),this._proxy.$registerProfileProvider(r),new _.Disposable(()=>{this._profileProviders.delete(r),this._proxy.$unregisterProfileProvider(r)})}async $createContributedProfileTerminal(r,n){var o;const g=new l.CancellationTokenSource().token,f=await((o=this._profileProviders.get(r))===null||o===void 0?void 0:o.provideProfileOptions(g));if(!g.isCancellationRequested){if(!f)throw new Error(`No terminal profile options provided for id "${r}"`);if("pty"in f){this.createExtensionTerminal(f,{isSplitTerminal:n});return}this.createTerminalFromOptions(f,{isSplitTerminal:n})}}async $provideLinks(r,n){const o=this._getTerminalById(r);if(!o)return[];this._terminalLinkCache.delete(r);const g=this._terminalLinkCancellationSource.get(r);g&&g.dispose(!0);const f=new l.CancellationTokenSource;this._terminalLinkCancellationSource.set(r,f);const E=[],y={terminal:o.value,line:n},a=[];for(const W of this._linkProviders)a.push(new Promise(async J=>{f.token.onCancellationRequested(()=>J({provider:W,links:[]}));const se=await W.provideTerminalLinks(y,f.token)||[];f.token.isCancellationRequested||J({provider:W,links:se})}));const L=await Promise.all(a);if(f.token.isCancellationRequested)return[];const O=new Map;for(const W of L)W&&W.links.length>0&&E.push(...W.links.map(J=>{const se={id:b++,startIndex:J.startIndex,length:J.length,label:J.tooltip};return O.set(se.id,{provider:W.provider,link:J}),se}));return this._terminalLinkCache.set(r,O),E}$activateLink(r,n){var o;const g=(o=this._terminalLinkCache.get(r))===null||o===void 0?void 0:o.get(n);!g||g.provider.handleTerminalLink(g.link)}_onProcessExit(r,n){this._bufferer.stopBuffering(r),this._terminalProcesses.delete(r),delete this._extensionTerminalAwaitingStart[r];const o=this._terminalProcessDisposables[r];o&&(o.dispose(),delete this._terminalProcessDisposables[r]),this._proxy.$sendProcessExit(r,n)}_getTerminalById(r){return this._getTerminalObjectById(this._terminals,r)}_getTerminalObjectById(r,n){const o=this._getTerminalObjectIndexById(r,n);return o!==null?r[o]:null}_getTerminalObjectIndexById(r,n){let o=null;return r.some((g,f)=>g._id===n?(o=f,!0):!1),o}getEnvironmentVariableCollection(r){let n=this._environmentVariableCollections.get(r.identifier.value);return n||(n=new d,this._setEnvironmentVariableCollection(r.identifier.value,n)),n}_syncEnvironmentVariableCollection(r,n){const o=I.serializeEnvironmentVariableCollection(n.map);this._proxy.$setEnvironmentVariableCollection(r,n.persistent,o.length===0?void 0:o)}$initEnvironmentVariableCollections(r){r.forEach(n=>{const o=n[0],g=new d(n[1]);this._setEnvironmentVariableCollection(o,g)})}$acceptDefaultProfile(r,n){this._defaultProfile=r,this._defaultAutomationProfile=n}_setEnvironmentVariableCollection(r,n){this._environmentVariableCollections.set(r,n),n.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(r,n)})}};u=Ve([$e(1,A.IExtHostRpcService)],u),e.BaseExtHostTerminalService=u;class d{constructor(r){this.map=new Map,this._persistent=!0,this._onDidChangeCollection=new v.Emitter,this.map=new Map(r)}get persistent(){return this._persistent}set persistent(r){this._persistent=r,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}get size(){return this.map.size}replace(r,n){this._setIfDiffers(r,{value:n,type:_.EnvironmentVariableMutatorType.Replace})}append(r,n){this._setIfDiffers(r,{value:n,type:_.EnvironmentVariableMutatorType.Append})}prepend(r,n){this._setIfDiffers(r,{value:n,type:_.EnvironmentVariableMutatorType.Prepend})}_setIfDiffers(r,n){const o=this.map.get(r);(!o||o.value!==n.value||o.type!==n.type)&&(this.map.set(r,n),this._onDidChangeCollection.fire())}get(r){return this.map.get(r)}forEach(r,n){this.map.forEach((o,g)=>r.call(n,g,o,this))}delete(r){this.map.delete(r),this._onDidChangeCollection.fire()}clear(){this.map.clear(),this._onDidChangeCollection.fire()}}e.EnvironmentVariableCollection=d;let p=class extends u{constructor(r){super(!1,r)}createTerminal(r,n,o){throw new s.NotSupportedError}createTerminalFromOptions(r,n){throw new s.NotSupportedError}};p=Ve([$e(0,A.IExtHostRpcService)],p),e.WorkerExtHostTerminalService=p;function t(i){if(!!i)return"id"in i?{id:i.id,color:i.color}:i}}),define(ge[238],pe([0,1,3,18,5,124,17,7]),function(Q,e,v,R,k,D,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class _{constructor(s,I){this._extHostDocumentsAndEditors=I,this._onDidChangeTextEditorSelection=new v.Emitter,this._onDidChangeTextEditorOptions=new v.Emitter,this._onDidChangeTextEditorVisibleRanges=new v.Emitter,this._onDidChangeTextEditorViewColumn=new v.Emitter,this._onDidChangeActiveTextEditor=new v.Emitter,this._onDidChangeVisibleTextEditors=new v.Emitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=s.getProxy(k.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(l=>this._onDidChangeVisibleTextEditors.fire(l)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(l=>this._onDidChangeActiveTextEditor.fire(l))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(s){const I=this._extHostDocumentsAndEditors.allEditors();return s?I:I.map(l=>l.value)}async showTextDocument(s,I,l){let m;typeof I=="number"?m={position:A.ViewColumn.from(I),preserveFocus:l}:typeof I=="object"?m={position:A.ViewColumn.from(I.viewColumn),preserveFocus:I.preserveFocus,selection:typeof I.selection=="object"?A.Range.from(I.selection):void 0,pinned:typeof I.preview=="boolean"?!I.preview:void 0}:m={preserveFocus:!1};const c=await this._proxy.$tryShowTextDocument(s.uri,m),h=c&&this._extHostDocumentsAndEditors.getEditor(c);if(h)return h.value;throw c?new Error(`Could NOT open editor for "${s.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${s.uri.toString()}".`)}createTextEditorDecorationType(s,I){return new D.TextEditorDecorationType(this._proxy,s,I).value}$acceptEditorPropertiesChanged(s,I){const l=this._extHostDocumentsAndEditors.getEditor(s);if(!l)throw new Error("unknown text editor");if(I.options&&l._acceptOptions(I.options),I.selections){const m=I.selections.selections.map(A.Selection.to);l._acceptSelections(m)}if(I.visibleRanges){const m=R.coalesce(I.visibleRanges.map(A.Range.to));l._acceptVisibleRanges(m)}if(I.options&&this._onDidChangeTextEditorOptions.fire({textEditor:l.value,options:Object.assign(Object.assign({},I.options),{lineNumbers:A.TextEditorLineNumbersStyle.to(I.options.lineNumbers)})}),I.selections){const m=P.TextEditorSelectionChangeKind.fromValue(I.selections.source),c=I.selections.selections.map(A.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:l.value,selections:c,kind:m})}if(I.visibleRanges){const m=R.coalesce(I.visibleRanges.map(A.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:l.value,visibleRanges:m})}}$acceptEditorPositionData(s){for(const I in s){const l=this._extHostDocumentsAndEditors.getEditor(I);if(!l)throw new Error("Unknown text editor");const m=A.ViewColumn.to(s[I]);l.value.viewColumn!==m&&(l._acceptViewColumn(m),this._onDidChangeTextEditorViewColumn.fire({textEditor:l.value,viewColumn:m}))}}getDiffInformation(s){return Promise.resolve(this._proxy.$getDiffInformation(s))}}e.ExtHostEditors=_});var Sn=this&&this.__rest||function(Q,e){var v={};for(var R in Q)Object.prototype.hasOwnProperty.call(Q,R)&&e.indexOf(R)<0&&(v[R]=Q[R]);if(Q!=null&&typeof Object.getOwnPropertySymbols=="function")for(var k=0,R=Object.getOwnPropertySymbols(Q);k<R.length;k++)e.indexOf(R[k])<0&&Object.prototype.propertyIsEnumerable.call(Q,R[k])&&(v[R[k]]=Q[R[k]]);return v};define(ge[239],pe([0,1,2,4,5,6,7]),function(Q,e,v,R,k,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=R.createDecorator("IExtHostTimeline");class P{constructor(s,I){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=s.getProxy(k.MainContext.MainThreadTimeline),I.registerArgumentProcessor({processArgument:l=>{var m,c;if(l&&l.$mid===11){const h=l.uri===void 0?void 0:v.URI.revive(l.uri);return(c=(m=this._itemsBySourceAndUriMap.get(l.source))===null||m===void 0?void 0:m.get(_(h)))===null||c===void 0?void 0:c.get(l.handle)}return l}})}async $getTimeline(s,I,l,m,c){const h=this._providers.get(s);return h==null?void 0:h.provideTimeline(v.URI.revive(I),l,m,c)}registerTimelineProvider(s,I,l,m){const c=new D.DisposableStore,h=this.convertTimelineItem(I.id,m,c).bind(this);let S;I.onDidChange&&(S=I.onDidChange(b=>this._proxy.$emitTimelineChangeEvent(Object.assign(Object.assign({uri:void 0,reset:!0},b),{id:I.id})),this));const w=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore(Object.assign(Object.assign({},I),{scheme:s,onDidChange:void 0,async provideTimeline(b,u,d,p){var t;(p==null?void 0:p.resetCache)&&(c.clear(),(t=w.get(I.id))===null||t===void 0||t.clear());const i=await I.provideTimeline(b,u,d);if(i==null)return;const r=h(b,p);return Object.assign(Object.assign({},i),{source:I.id,items:i.items.map(r)})},dispose(){var b;for(const u of w.values())(b=u.get(I.id))===null||b===void 0||b.clear();S==null||S.dispose(),c.dispose()}}))}convertTimelineItem(s,I,l){return(m,c)=>{let h;if(c==null?void 0:c.cacheResults){let S=this._itemsBySourceAndUriMap.get(s);S===void 0&&(S=new Map,this._itemsBySourceAndUriMap.set(s,S));const w=_(m);h=S.get(w),h===void 0&&(h=new Map,S.set(w,h))}return S=>{var w,b;const{iconPath:u}=S,d=Sn(S,["iconPath"]),p=`${s}|${(w=S.id)!==null&&w!==void 0?w:S.timestamp}`;h==null||h.set(p,S);let t,i,r;return S.iconPath&&(u instanceof A.ThemeIcon?r={id:u.id}:v.URI.isUri(u)?(t=u,i=u):{light:t,dark:i}=u),Object.assign(Object.assign({},d),{id:(b=d.id)!==null&&b!==void 0?b:void 0,handle:p,source:s,command:S.command?I.toInternal(S.command,l):void 0,icon:t,iconDark:i,themeIcon:r,accessibilityInformation:S.accessibilityInformation})}}}registerTimelineProviderCore(s){if(this._providers.get(s.id))throw new Error(`Timeline Provider ${s.id} already exists.`);return this._proxy.$registerTimelineProvider({id:s.id,label:s.label,scheme:s.scheme}),this._providers.set(s.id,s),D.toDisposable(()=>{var l;for(const m of this._itemsBySourceAndUriMap.values())(l=m.get(s.id))===null||l===void 0||l.clear();this._providers.delete(s.id),this._proxy.$unregisterTimelineProvider(s.id),s.dispose()})}}e.ExtHostTimeline=P;function _(C){return C==null?void 0:C.toString()}}),define(ge[240],pe([0,1,6,10,2,5]),function(Q,e,v,R,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class A{constructor(_){this._openers=new Map,this._proxy=_.getProxy(D.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(_,C,s,I){if(this._openers.has(C))throw new Error(`Opener with id '${C}' already registered`);const l=I.schemes.find(m=>!A.supportedSchemes.has(m));if(l)throw new Error(`Scheme '${l}' is not supported. Only http and https are currently supported.`);return this._openers.set(C,s),this._proxy.$registerUriOpener(C,I.schemes,_,I.label),v.toDisposable(()=>{this._openers.delete(C),this._proxy.$unregisterUriOpener(C)})}async $canOpenUri(_,C,s){const I=this._openers.get(_);if(!I)throw new Error(`Unknown opener with id: ${_}`);const l=k.URI.revive(C);return I.canOpenExternalUri(l,s)}async $openUri(_,C,s){const I=this._openers.get(_);if(!I)throw new Error(`Unknown opener id: '${_}'`);return I.openExternalUri(k.URI.revive(C.resolvedUri),{sourceUri:k.URI.revive(C.sourceUri)},s)}}e.ExtHostUriOpeners=A,A.supportedSchemes=new Set([R.Schemas.http,R.Schemas.https])}),define(ge[241],pe([0,1,5,2,6,14,26]),function(Q,e,v,R,k,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class P{constructor(C){this.handles=new Set,this.handlers=new Map,this._proxy=C.getProxy(v.MainContext.MainThreadUrls)}registerUriHandler(C,s){if(this.handles.has(A.ExtensionIdentifier.toKey(C)))throw new Error(`Protocol handler already registered for extension ${C}`);const I=P.HandlePool++;return this.handles.add(A.ExtensionIdentifier.toKey(C)),this.handlers.set(I,s),this._proxy.$registerUriHandler(I,C),k.toDisposable(()=>{this.handles.delete(A.ExtensionIdentifier.toKey(C)),this.handlers.delete(I),this._proxy.$unregisterUriHandler(I)})}$handleExternalUri(C,s){const I=this.handlers.get(C);if(!I)return Promise.resolve(void 0);try{I.handleUri(R.URI.revive(s))}catch(l){D.onUnexpectedError(l)}return Promise.resolve(void 0)}async createAppUri(C){return R.URI.revive(await this._proxy.$createAppUri(C))}}e.ExtHostUrls=P,P.HandlePool=0});var it=this&&this.__classPrivateFieldSet||function(Q,e,v,R,k){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Q!==e||!k:!e.has(Q))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?k.call(Q,v):k?k.value=v:e.set(Q,v),v},Be=this&&this.__classPrivateFieldGet||function(Q,e,v,R){if(v==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Q!==e||!R:!e.has(Q))throw new TypeError("Cannot read private member from an object whose class did not declare it");return v==="m"?R:v==="a"?R.call(Q):R?R.value:e.get(Q)};define(ge[62],pe([0,1,3,2,172,195,85,5]),function(Q,e,v,R,k,D,A,P){"use strict";var _,C,s,I,l,m,c,h,S,w,b,u;Object.defineProperty(e,"__esModule",{value:!0}),e.reviveOptions=e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class d{constructor(f,E,y,a,L,O,W){_.set(this,void 0),C.set(this,void 0),s.set(this,void 0),I.set(this,void 0),l.set(this,void 0),m.set(this,void 0),c.set(this,""),h.set(this,void 0),S.set(this,!1),w.set(this,!1),b.set(this,!1),this._onMessageEmitter=new v.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,u.set(this,new v.Emitter),this._onDidDispose=Be(this,u,"f").event,it(this,_,f,"f"),it(this,C,E,"f"),it(this,h,y,"f"),it(this,I,a,"f"),it(this,l,L,"f"),it(this,m,O,"f"),it(this,b,p(O),"f"),it(this,s,W,"f")}dispose(){it(this,S,!0,"f"),Be(this,u,"f").fire(),Be(this,u,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(f){return it(this,w,!0,"f"),A.asWebviewUri(f,Be(this,I,"f").remote)}get cspSource(){return A.webviewGenericCspSource}get html(){return this.assertNotDisposed(),Be(this,c,"f")}set html(f){this.assertNotDisposed(),Be(this,c,"f")!==f&&(it(this,c,f,"f"),!Be(this,w,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(f)&&(it(this,w,!0,"f"),Be(this,s,"f").report("Webview vscode-resource: uris",Be(this,m,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Be(this,C,"f").$setHtml(Be(this,_,"f"),f))}get options(){return this.assertNotDisposed(),Be(this,h,"f")}set options(f){this.assertNotDisposed(),Be(this,C,"f").$setOptions(Be(this,_,"f"),r(Be(this,m,"f"),Be(this,l,"f"),f)),it(this,h,f,"f")}async postMessage(f){if(Be(this,S,"f"))return!1;const E=D.serializeWebviewMessage(f,{serializeBuffersForPostMessage:Be(this,b,"f")});return Be(this,C,"f").$postMessage(Be(this,_,"f"),E.message,...E.buffers)}assertNotDisposed(){if(Be(this,S,"f"))throw new Error("Webview is disposed")}}e.ExtHostWebview=d,_=new WeakMap,C=new WeakMap,s=new WeakMap,I=new WeakMap,l=new WeakMap,m=new WeakMap,c=new WeakMap,h=new WeakMap,S=new WeakMap,w=new WeakMap,b=new WeakMap,u=new WeakMap;function p(g){try{const f=k.normalizeVersion(k.parseVersion(g.engines.vscode));return!!f&&f.majorBase>=1&&f.minorBase>=57}catch(f){return!1}}e.shouldSerializeBuffersForPostMessage=p;class t{constructor(f,E,y,a,L){this.initData=E,this.workspace=y,this._logService=a,this._deprecationService=L,this._webviews=new Map,this._webviewProxy=f.getProxy(P.MainContext.MainThreadWebviews)}$onMessage(f,E,...y){const a=this.getWebview(f);if(a){const{message:L}=D.deserializeWebviewMessage(E,y);a._onMessageEmitter.fire(L)}}$onMissingCsp(f,E){this._logService.warn(`${E} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(f,E,y){const a=new d(f,this._webviewProxy,n(E),this.initData,this.workspace,y,this._deprecationService);return this._webviews.set(f,a),a._onDidDispose(()=>{this._webviews.delete(f)}),a}deleteWebview(f){this._webviews.delete(f)}getWebview(f){return this._webviews.get(f)}}e.ExtHostWebviews=t;function i(g){return{id:g.identifier,location:g.extensionLocation}}e.toExtensionData=i;function r(g,f,E){return{enableCommandUris:E.enableCommandUris,enableScripts:E.enableScripts,portMapping:E.portMapping,localResourceRoots:E.localResourceRoots||o(g,f)}}e.serializeWebviewOptions=r;function n(g){var f;return{enableCommandUris:g.enableCommandUris,enableScripts:g.enableScripts,portMapping:g.portMapping,localResourceRoots:(f=g.localResourceRoots)===null||f===void 0?void 0:f.map(E=>R.URI.from(E))}}e.reviveOptions=n;function o(g,f){return[...((f==null?void 0:f.getWorkspaceFolders())||[]).map(E=>E.uri),g.extensionLocation]}}),define(ge[242],pe([0,1,21,73,6,10,24,2,17,62,83,5,7]),function(Q,e,v,R,k,D,A,P,_,C,s,I,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class m{constructor(t,i){this.document=t,this._storagePath=i,this._backupCounter=1,this._edits=new s.Cache("custom documents")}addEdit(t){return this._edits.add([t])}async undo(t,i){await this.getEdit(t).undo(),i||this.disposeBackup()}async redo(t,i){await this.getEdit(t).redo(),i||this.disposeBackup()}disposeEdits(t){for(const i of t)this._edits.delete(i)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const t=d(this.document.uri)+this._backupCounter++;return A.joinPath(this._storagePath,t)}updateBackup(t){var i;(i=this._backup)===null||i===void 0||i.delete(),this._backup=t}disposeBackup(){var t;(t=this._backup)===null||t===void 0||t.delete(),this._backup=void 0}getEdit(t){const i=this._edits.get(t,0);if(!i)throw new Error("No edit found");return i}}class c{constructor(){this._documents=new Map}get(t,i){return this._documents.get(this.key(t,i))}add(t,i,r){const n=this.key(t,i.uri);if(this._documents.has(n))throw new Error(`Document already exists for viewType:${t} resource:${i.uri}`);const o=new m(i,r);return this._documents.set(n,o),o}delete(t,i){const r=this.key(t,i.uri);this._documents.delete(r)}key(t,i){return`${t}@@@${i}`}}var h;(function(p){p[p.Text=0]="Text",p[p.Custom=1]="Custom"})(h||(h={}));class S{constructor(){this._providers=new Map}addTextProvider(t,i,r){return this.add(0,t,i,r)}addCustomProvider(t,i,r){return this.add(1,t,i,r)}get(t){return this._providers.get(t)}add(t,i,r,n){if(this._providers.has(i))throw new Error(`Provider for viewType:${i} already registered`);return this._providers.set(i,{type:t,extension:r,provider:n}),new l.Disposable(()=>this._providers.delete(i))}}class w{constructor(t,i,r,n,o){this._extHostDocuments=i,this._extensionStoragePaths=r,this._extHostWebview=n,this._extHostWebviewPanels=o,this._editorProviders=new S,this._documents=new c,this._proxy=t.getProxy(I.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(t,i,r,n){const o=new k.DisposableStore;return b(r)?(o.add(this._editorProviders.addTextProvider(i,t,r)),this._proxy.$registerTextEditorProvider(C.toExtensionData(t),i,n.webviewOptions||{},{supportsMove:!!r.moveCustomTextEditor},C.shouldSerializeBuffersForPostMessage(t))):(o.add(this._editorProviders.addCustomProvider(i,t,r)),this.supportEditing(r)&&o.add(r.onDidChangeCustomDocument(g=>{const f=this.getCustomDocumentEntry(i,g.document.uri);if(u(g)){const E=f.addEdit(g);this._proxy.$onDidEdit(g.document.uri,i,E,g.label)}else this._proxy.$onContentChange(g.document.uri,i)})),this._proxy.$registerCustomEditorProvider(C.toExtensionData(t),i,n.webviewOptions||{},!!n.supportsMultipleEditorsPerDocument,C.shouldSerializeBuffersForPostMessage(t))),l.Disposable.from(o,new l.Disposable(()=>{this._proxy.$unregisterEditorProvider(i)}))}async $createCustomDocument(t,i,r,n,o){var g;const f=this._editorProviders.get(i);if(!f)throw new Error(`No provider found for '${i}'`);if(f.type!==1)throw new Error(`Invalid provide type for '${i}'`);const E=P.URI.revive(t),y=await f.provider.openCustomDocument(E,{backupId:r,untitledDocumentData:n==null?void 0:n.buffer},o);let a;return this.supportEditing(f.provider)&&this._extensionStoragePaths&&(a=(g=this._extensionStoragePaths.workspaceValue(f.extension))!==null&&g!==void 0?g:this._extensionStoragePaths.globalValue(f.extension)),this._documents.add(i,y,a),{editable:this.supportEditing(f.provider)}}async $disposeCustomDocument(t,i){const r=this._editorProviders.get(i);if(!r)throw new Error(`No provider found for '${i}'`);if(r.type!==1)throw new Error(`Invalid provider type for '${i}'`);const n=P.URI.revive(t),{document:o}=this.getCustomDocumentEntry(i,n);this._documents.delete(i,o),o.dispose()}async $resolveWebviewEditor(t,i,r,n,o,g){const f=this._editorProviders.get(r);if(!f)throw new Error(`No provider found for '${r}'`);const E=_.ViewColumn.to(o),y=this._extHostWebview.createNewWebview(i,n.webviewOptions,f.extension),a=this._extHostWebviewPanels.createNewWebviewPanel(i,r,n.title,E,n.panelOptions,y),L=P.URI.revive(t);switch(f.type){case 1:{const{document:O}=this.getCustomDocumentEntry(r,L);return f.provider.resolveCustomEditor(O,a,g)}case 0:{const O=this._extHostDocuments.getDocument(L);return f.provider.resolveCustomTextEditor(O,a,g)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(t,i,r){this.getCustomDocumentEntry(i,t).disposeEdits(r)}async $onMoveCustomEditor(t,i,r){const n=this._editorProviders.get(r);if(!n)throw new Error(`No provider found for '${r}'`);if(!n.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${r}'`);const o=this._extHostWebviewPanels.getWebviewPanel(t);if(!o)throw new Error("No webview found");const g=P.URI.revive(i),f=this._extHostDocuments.getDocument(g);await n.provider.moveCustomTextEditor(f,o,v.CancellationToken.None)}async $undo(t,i,r,n){return this.getCustomDocumentEntry(i,t).undo(r,n)}async $redo(t,i,r,n){return this.getCustomDocumentEntry(i,t).redo(r,n)}async $revert(t,i,r){const n=this.getCustomDocumentEntry(i,t);await this.getCustomEditorProvider(i).revertCustomDocument(n.document,r),n.disposeBackup()}async $onSave(t,i,r){const n=this.getCustomDocumentEntry(i,t);await this.getCustomEditorProvider(i).saveCustomDocument(n.document,r),n.disposeBackup()}async $onSaveAs(t,i,r,n){const o=this.getCustomDocumentEntry(i,t);return this.getCustomEditorProvider(i).saveCustomDocumentAs(o.document,P.URI.revive(r),n)}async $backup(t,i,r){const n=this.getCustomDocumentEntry(i,t),g=await this.getCustomEditorProvider(i).backupCustomDocument(n.document,{destination:n.getNewBackupUri()},r);return n.updateBackup(g),g.id}getCustomDocumentEntry(t,i){const r=this._documents.get(t,P.URI.revive(i));if(!r)throw new Error("No custom document found");return r}getCustomEditorProvider(t){const i=this._editorProviders.get(t),r=i==null?void 0:i.provider;if(!r||!this.supportEditing(r))throw new Error("Custom document is not editable");return r}supportEditing(t){return!!t.onDidChangeCustomDocument}}e.ExtHostCustomEditors=w;function b(p){return typeof p.resolveCustomTextEditor=="function"}function u(p){return typeof p.undo=="function"&&typeof p.redo=="function"}function d(p){const t=p.scheme===D.Schemas.file||p.scheme===D.Schemas.untitled?p.fsPath:p.toString();return R.hash(t)+""}});var it=this&&this.__classPrivateFieldSet||function(Q,e,v,R,k){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Q!==e||!k:!e.has(Q))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?k.call(Q,v):k?k.value=v:e.set(Q,v),v},Be=this&&this.__classPrivateFieldGet||function(Q,e,v,R){if(v==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Q!==e||!R:!e.has(Q))throw new TypeError("Cannot read private member from an object whose class did not declare it");return v==="m"?R:v==="a"?R.call(Q):R?R.value:e.get(Q)};define(ge[243],pe([0,1,3,6,2,32,17,62,5,7]),function(Q,e,v,R,k,D,A,P,_,C){"use strict";var s,I,l,m,c,h,S,w,b,u,d,p,t;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class i extends R.Disposable{constructor(g,f,E,y,a,L,O){super();s.set(this,void 0),I.set(this,void 0),l.set(this,void 0),m.set(this,void 0),c.set(this,void 0),h.set(this,void 0),S.set(this,void 0),w.set(this,void 0),b.set(this,!0),u.set(this,!0),d.set(this,!1),p.set(this,this._register(new v.Emitter)),this.onDidDispose=Be(this,p,"f").event,t.set(this,this._register(new v.Emitter)),this.onDidChangeViewState=Be(this,t,"f").event,it(this,s,g,"f"),it(this,I,f,"f"),it(this,l,E,"f"),it(this,c,L,"f"),it(this,w,a,"f"),it(this,h,y,"f"),it(this,m,O,"f")}dispose(){Be(this,d,"f")||(it(this,d,!0,"f"),Be(this,p,"f").fire(),Be(this,I,"f").$disposeWebview(Be(this,s,"f")),Be(this,m,"f").dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),Be(this,m,"f")}get viewType(){return this.assertNotDisposed(),Be(this,l,"f")}get title(){return this.assertNotDisposed(),Be(this,h,"f")}set title(g){this.assertNotDisposed(),Be(this,h,"f")!==g&&(it(this,h,g,"f"),Be(this,I,"f").$setTitle(Be(this,s,"f"),g))}get iconPath(){return this.assertNotDisposed(),Be(this,S,"f")}set iconPath(g){this.assertNotDisposed(),Be(this,S,"f")!==g&&(it(this,S,g,"f"),Be(this,I,"f").$setIconPath(Be(this,s,"f"),k.URI.isUri(g)?{light:g,dark:g}:g))}get options(){return Be(this,c,"f")}get viewColumn(){if(this.assertNotDisposed(),!(typeof Be(this,w,"f")=="number"&&Be(this,w,"f")<0))return Be(this,w,"f")}get active(){return this.assertNotDisposed(),Be(this,u,"f")}get visible(){return this.assertNotDisposed(),Be(this,b,"f")}_updateViewState(g){Be(this,d,"f")||(this.active!==g.active||this.visible!==g.visible||this.viewColumn!==g.viewColumn)&&(it(this,u,g.active,"f"),it(this,b,g.visible,"f"),it(this,w,g.viewColumn,"f"),Be(this,t,"f").fire({webviewPanel:this}))}reveal(g,f){this.assertNotDisposed(),Be(this,I,"f").$reveal(Be(this,s,"f"),{viewColumn:g?A.ViewColumn.from(g):void 0,preserveFocus:!!f})}assertNotDisposed(){if(Be(this,d,"f"))throw new Error("Webview is disposed")}}s=new WeakMap,I=new WeakMap,l=new WeakMap,m=new WeakMap,c=new WeakMap,h=new WeakMap,S=new WeakMap,w=new WeakMap,b=new WeakMap,u=new WeakMap,d=new WeakMap,p=new WeakMap,t=new WeakMap;class r{constructor(g,f,E){this.webviews=f,this.workspace=E,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=g.getProxy(_.MainContext.MainThreadWebviewPanels)}static newHandle(){return D.generateUuid()}createWebviewPanel(g,f,E,y,a={}){const L=typeof y=="object"?y.viewColumn:y,O={viewColumn:A.ViewColumn.from(L),preserveFocus:typeof y=="object"&&!!y.preserveFocus},W=P.shouldSerializeBuffersForPostMessage(g),J=r.newHandle();this._proxy.$createWebviewPanel(P.toExtensionData(g),J,f,{title:E,panelOptions:n(a),webviewOptions:P.serializeWebviewOptions(g,this.workspace,a),serializeBuffersForPostMessage:W},O);const se=this.webviews.createNewWebview(J,a,g);return this.createNewWebviewPanel(J,f,E,L,a,se)}$onDidChangeWebviewPanelViewStates(g){const f=Object.keys(g);f.sort((E,y)=>{const a=g[E],L=g[y];return a.active?1:L.active?-1:+a.visible-+L.visible});for(const E of f){const y=this.getWebviewPanel(E);if(!y)continue;const a=g[E];y._updateViewState({active:a.active,visible:a.visible,viewColumn:A.ViewColumn.to(a.position)})}}async $onDidDisposeWebviewPanel(g){const f=this.getWebviewPanel(g);f==null||f.dispose(),this._webviewPanels.delete(g),this.webviews.deleteWebview(g)}registerWebviewPanelSerializer(g,f,E){if(this._serializers.has(f))throw new Error(`Serializer for '${f}' already registered`);return this._serializers.set(f,{serializer:E,extension:g}),this._proxy.$registerSerializer(f,{serializeBuffersForPostMessage:P.shouldSerializeBuffersForPostMessage(g)}),new C.Disposable(()=>{this._serializers.delete(f),this._proxy.$unregisterSerializer(f)})}async $deserializeWebviewPanel(g,f,E,y){const a=this._serializers.get(f);if(!a)throw new Error(`No serializer found for '${f}'`);const{serializer:L,extension:O}=a,W=this.webviews.createNewWebview(g,E.webviewOptions,O),J=this.createNewWebviewPanel(g,f,E.title,y,E.panelOptions,W);await L.deserializeWebviewPanel(J,E.state)}createNewWebviewPanel(g,f,E,y,a,L){const O=new i(g,this._proxy,f,E,y,a,L);return this._webviewPanels.set(g,O),O}getWebviewPanel(g){return this._webviewPanels.get(g)}}e.ExtHostWebviewPanels=r;function n(o){return{enableFindWidget:o.enableFindWidget,retainContextWhenHidden:o.retainContextWhenHidden}}});var it=this&&this.__classPrivateFieldSet||function(Q,e,v,R,k){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Q!==e||!k:!e.has(Q))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?k.call(Q,v):k?k.value=v:e.set(Q,v),v},Be=this&&this.__classPrivateFieldGet||function(Q,e,v,R){if(v==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Q!==e||!R:!e.has(Q))throw new TypeError("Cannot read private member from an object whose class did not declare it");return v==="m"?R:v==="a"?R.call(Q):R?R.value:e.get(Q)};define(ge[244],pe([0,1,3,6,62,5,7]),function(Q,e,v,R,k,D,A){"use strict";var P,_,C,s,I,l,m,c,h,S;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class w extends R.Disposable{constructor(d,p,t,i,r,n){super();P.set(this,void 0),_.set(this,void 0),C.set(this,void 0),s.set(this,void 0),I.set(this,!1),l.set(this,void 0),m.set(this,void 0),c.set(this,void 0),h.set(this,this._register(new v.Emitter)),this.onDidChangeVisibility=Be(this,h,"f").event,S.set(this,this._register(new v.Emitter)),this.onDidDispose=Be(this,S,"f").event,it(this,C,t,"f"),it(this,m,i,"f"),it(this,P,d,"f"),it(this,_,p,"f"),it(this,s,r,"f"),it(this,l,n,"f")}dispose(){Be(this,I,"f")||(it(this,I,!0,"f"),Be(this,S,"f").fire(),Be(this,s,"f").dispose(),super.dispose())}get title(){return this.assertNotDisposed(),Be(this,m,"f")}set title(d){this.assertNotDisposed(),Be(this,m,"f")!==d&&(it(this,m,d,"f"),Be(this,_,"f").$setWebviewViewTitle(Be(this,P,"f"),d))}get description(){return this.assertNotDisposed(),Be(this,c,"f")}set description(d){this.assertNotDisposed(),Be(this,c,"f")!==d&&(it(this,c,d,"f"),Be(this,_,"f").$setWebviewViewDescription(Be(this,P,"f"),d))}get visible(){return Be(this,l,"f")}get webview(){return Be(this,s,"f")}get viewType(){return Be(this,C,"f")}_setVisible(d){d===Be(this,l,"f")||Be(this,I,"f")||(it(this,l,d,"f"),Be(this,h,"f").fire())}show(d){this.assertNotDisposed(),Be(this,_,"f").$show(Be(this,P,"f"),!!d)}assertNotDisposed(){if(Be(this,I,"f"))throw new Error("Webview is disposed")}}P=new WeakMap,_=new WeakMap,C=new WeakMap,s=new WeakMap,I=new WeakMap,l=new WeakMap,m=new WeakMap,c=new WeakMap,h=new WeakMap,S=new WeakMap;class b{constructor(d,p){this._extHostWebview=p,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=d.getProxy(D.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(d,p,t,i){if(this._viewProviders.has(p))throw new Error(`View provider for '${p}' already registered`);return this._viewProviders.set(p,{provider:t,extension:d}),this._proxy.$registerWebviewViewProvider(k.toExtensionData(d),p,{retainContextWhenHidden:i==null?void 0:i.retainContextWhenHidden,serializeBuffersForPostMessage:!1}),new A.Disposable(()=>{this._viewProviders.delete(p),this._proxy.$unregisterWebviewViewProvider(p)})}async $resolveWebviewView(d,p,t,i,r){const n=this._viewProviders.get(p);if(!n)throw new Error(`No view provider found for '${p}'`);const{provider:o,extension:g}=n,f=this._extHostWebview.createNewWebview(d,{},g),E=new w(d,this._proxy,p,t,f,!0);this._webviewViews.set(d,E),await o.resolveWebviewView(E,{state:i},r)}async $onDidChangeWebviewViewVisibility(d,p){this.getWebviewView(d)._setVisible(p)}async $disposeWebviewView(d){const p=this.getWebviewView(d);this._webviewViews.delete(d),p.dispose(),this._extHostWebview.deleteWebview(d)}getWebviewView(d){const p=this._webviewViews.get(d);if(!p)throw new Error("No webview found");return p}}e.ExtHostWebviewViews=b}),define(ge[127],pe([0,1,3,5,2,10,8,4,13]),function(Q,e,v,R,k,D,A,P,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let C=class Bn{constructor(I){this._onDidChangeWindowState=new v.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=Bn.InitialState,this._proxy=I.getProxy(R.MainContext.MainThreadWindow),this._proxy.$getWindowVisibility().then(l=>this.$onDidChangeWindowFocus(l))}get state(){return this._state}$onDidChangeWindowFocus(I){I!==this._state.focused&&(this._state=Object.assign(Object.assign({},this._state),{focused:I}),this._onDidChangeWindowState.fire(this._state))}openUri(I,l){let m;if(typeof I=="string"){m=I;try{I=k.URI.parse(I)}catch(c){return Promise.reject(`Invalid uri - '${I}'`)}}return A.isFalsyOrWhitespace(I.scheme)?Promise.reject("Invalid scheme - cannot be empty"):I.scheme===D.Schemas.command?Promise.reject(`Invalid scheme '${I.scheme}'`):this._proxy.$openUri(I,m,l)}async asExternalUri(I,l){if(A.isFalsyOrWhitespace(I.scheme))return Promise.reject("Invalid scheme - cannot be empty");const m=await this._proxy.$asExternalUri(I,l);return k.URI.from(m)}};C.InitialState={focused:!0},C=Ve([$e(0,_.IExtHostRpcService)],C),e.ExtHostWindow=C,e.IExtHostWindow=P.createDecorator("IExtHostWindow")}),define(ge[245],pe([0,1,9,102,32,48,6,5,2,13]),function(Q,e,v,R,k,D,A,P,_,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDownloadService=void 0;let s=class extends A.Disposable{constructor(l,m){super();const c=l.getProxy(P.MainContext.MainThreadDownloadService);m.registerCommand(!1,"_workbench.downloadResource",async h=>{const S=_.URI.file(v.join(R.tmpdir(),k.generateUuid()));return await c.$download(h,S),S})}};s=Ve([$e(0,C.IExtHostRpcService),$e(1,D.IExtHostCommands)],s),e.ExtHostDownloadService=s}),define(ge[246],pe([0,1,2,9,146,28,61,27,13,6,12,114,42]),function(Q,e,v,R,k,D,A,P,_,C,s,I,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostOutputService2=void 0;class m{constructor(w,b,u){this.name=w,this.file=b,this.appender=u}static async create(w,b){const u=await I.createRotatingLogger(w,b,30*l.ByteSize.MB,1);return u.clearFormatters(),new m(w,b,u)}append(w){this.appender.critical(w)}flush(){this.appender.flush()}}class c extends A.AbstractExtHostOutputChannel{constructor(w,b,u){super(w,!1,v.URI.file(b.file),u);this._appender=b}append(w){super.append(w),this._appender.append(w),this._onDidAppend.fire()}update(){this._appender.flush(),super.update()}show(w,b){this._appender.flush(),super.show(w,b)}clear(){this._appender.flush(),super.clear()}}let h=class extends A.ExtHostOutputService{constructor(w,b,u){super(w);this.logService=b,this._namePool=1,this._channels=new Map,this._visibleChannelDisposable=new C.MutableDisposable,this._logsLocation=u.logsLocation}$setVisibleChannel(w){if(w){const b=this._channels.get(w);b&&(this._visibleChannelDisposable.value=b.onDidAppend(()=>b.update()))}}createOutputChannel(w){if(w=w.trim(),!w)throw new Error("illegal argument `name`. must not be falsy");const b=this._doCreateOutChannel(w);return b.then(u=>u._id.then(d=>this._channels.set(d,u))),new A.LazyOutputChannel(w,b)}async _doCreateOutChannel(w){try{const b=R.join(this._logsLocation.fsPath,`output_logging_${k.toLocalISOString(new Date).replace(/-|:|\.\d+Z$/g,"")}`);await D.SymlinkSupport.existsDirectory(b)||await D.Promises.mkdir(b,{recursive:!0});const d=`${this._namePool++}-${w.replace(/[\\/:\*\?"<>\|]/g,"")}`,p=v.URI.file(R.join(b,`${d}.log`)),t=await m.create(d,p.fsPath);return new c(w,t,this._proxy)}catch(b){return this.logService.error(b),new A.ExtHostPushOutputChannel(w,this._proxy)}}};h=Ve([$e(0,_.IExtHostRpcService),$e(1,s.ILogService),$e(2,P.IExtHostInitDataService)],h),e.ExtHostOutputService2=h}),define(ge[247],pe([0,1,32,13,33]),function(Q,e,v,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTerminalService=void 0;let D=class extends k.BaseExtHostTerminalService{constructor(P){super(!0,P)}createTerminal(P,_,C){return this.createTerminalFromOptions({name:P,shellPath:_,shellArgs:C})}createTerminalFromOptions(P,_){const C=new k.ExtHostTerminal(this._proxy,v.generateUuid(),P,P.name);return this._terminals.push(C),C.create(P,_),C.value}};D=Ve([$e(0,R.IExtHostRpcService)],D),e.ExtHostTerminalService=D}),define(ge[248],pe([0,1,5,13,6,27,2,38,24,28,7,11,47,3,72,12]),function(Q,e,v,R,k,D,A,P,_,C,s,I,l,m,c,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.tryFindRootPorts=e.findPorts=e.getRootProcesses=e.loadConnectionTable=e.parseIpAddress=e.loadListeningPorts=e.getSockets=void 0;class S{constructor(g,f,E){this.remoteAddress=g,this.localAddress=f,this._dispose=E,this._onDispose=new m.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}function w(o){const g=o.trim().split(`
`),f=[];return g.forEach(y=>{const a=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(y);a&&a.length>=3&&f.push({pid:parseInt(a[1],10),socket:parseInt(a[2],10)})}),f.reduce((y,a)=>(y[a.socket]=a,y),{})}e.getSockets=w;function b(...o){const g=[].concat(...o.map(d));return[...new Map(g.filter(f=>f.st==="0A").map(f=>{const E=f.local_address.split(":");return{socket:parseInt(f.inode,10),ip:u(E[0]),port:parseInt(E[1],16)}}).map(f=>[f.ip+":"+f.port,f])).values()]}e.loadListeningPorts=b;function u(o){let g="";if(o.length===8)for(let f=o.length-2;f>=0;f-=2)g+=parseInt(o.substr(f,2),16),f!==0&&(g+=".");else for(let f=o.length-4;f>=0;f-=4)g+=parseInt(o.substr(f,4),16).toString(16),f!==0&&(g+=":");return g}e.parseIpAddress=u;function d(o){const g=o.trim().split(`
`),f=g.shift().trim().split(/\s+/).filter(y=>y!=="rx_queue"&&y!=="tm->when");return g.map(y=>y.trim().split(/\s+/).reduce((a,L,O)=>(a[f[O]||O]=L,a),{}))}e.loadConnectionTable=d;function p(o){return!!o.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||o.indexOf("out/vs/server/main.js")!==-1||o.indexOf("_productName=VSCode")!==-1}function t(o){const g=o.trim().split(`
`),f=[];return g.forEach(E=>{const y=/^\d+\s+\D+\s+root\s+(\d+)\s+(\d+).+\d+\:\d+\:\d+\s+(.+)$/.exec(E);y&&y.length>=4&&f.push({pid:parseInt(y[1],10),ppid:parseInt(y[2]),cmd:y[3]})}),f}e.getRootProcesses=t;async function i(o,g,f){const E=f.reduce((a,L)=>(a[L.pid]=L,a),{}),y=[];return o.forEach(({socket:a,ip:L,port:O})=>{var W;const J=g[a]?g[a].pid:void 0,se=J?(W=E[J])===null||W===void 0?void 0:W.cmd:void 0;J&&se&&!p(se)&&y.push({host:L,port:O,detail:se,pid:J})}),y}e.findPorts=i;function r(o,g,f){const E=new Map,y=t(g);for(const a of o){const L=f.get(a.port);if(L){E.set(a.port,L);continue}const O=y.find(W=>W.cmd.includes(`${a.port}`));if(O){let W=O,J;do J=y.find(se=>se.ppid===W.pid),J&&(W=J);while(J);E.set(a.port,{host:a.ip,port:a.port,pid:W.pid,detail:W.cmd,ppid:W.ppid})}else E.set(a.port,{host:a.ip,port:a.port,ppid:Number.MAX_VALUE})}return E}e.tryFindRootPorts=r;let n=class extends k.Disposable{constructor(g,f,E){super();this.logService=E,this._showCandidatePort=()=>Promise.resolve(!0),this._extensionTunnels=new Map,this._onDidChangeTunnels=new m.Emitter,this.onDidChangeTunnels=this._onDidChangeTunnels.event,this._candidateFindingEnabled=!1,this._foundRootPorts=new Map,this._providerHandleCounter=0,this._portAttributesProviders=new Map,this._proxy=g.getProxy(v.MainContext.MainThreadTunnelService),I.isLinux&&f.remote.isRemote&&f.remote.authority&&this._proxy.$setRemoteTunnelService(process.pid)}async openTunnel(g,f){this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) ${g.identifier.value} called openTunnel API for ${f.remoteAddress.host}:${f.remoteAddress.port}.`);const E=await this._proxy.$openTunnel(f,g.displayName);if(E){const y=new S(E.remoteAddress,E.localAddress,()=>this._proxy.$closeTunnel(E.remoteAddress));return this._register(y),y}}async getTunnels(){return this._proxy.$getTunnels()}calculateDelay(g){return Math.max(g*20,2e3)}nextPortAttributesProviderHandle(){return this._providerHandleCounter++}registerPortsAttributesProvider(g,f){const E=this.nextPortAttributesProviderHandle();return this._portAttributesProviders.set(E,{selector:g,provider:f}),this._proxy.$registerPortsAttributesProvider(g,E),new s.Disposable(()=>{this._portAttributesProviders.delete(E),this._proxy.$unregisterPortsAttributesProvider(E)})}async $providePortAttributes(g,f,E,y,a){const L=[];for(const W of g){const J=this._portAttributesProviders.get(W);if(!J)return[];L.push(...await Promise.all(f.map(async se=>J.provider.providePortAttributes(se,E,y,a))))}const O=L.filter(W=>!!W);return O.length>0?O.map(W=>({autoForwardAction:W.autoForwardAction,port:W.port})):[]}async $registerCandidateFinder(g){if(g&&this._candidateFindingEnabled)return;this._candidateFindingEnabled=g;let f=new c.MovingAverage,E;for(;this._candidateFindingEnabled;){const y=new Date().getTime(),a=await this.findCandidatePorts();this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) found candidate ports ${a.map(O=>O.port).join(", ")}`);const L=new Date().getTime()-y;f.update(L),(!E||JSON.stringify(E)!==JSON.stringify(a))&&(E=a,await this._proxy.$onFoundNewCandidates(E)),await new Promise(O=>setTimeout(()=>O(),this.calculateDelay(f.value)))}}async setTunnelExtensionFunctions(g){var f;return g?(g.candidatePortSource!==void 0&&this._proxy.$setCandidatePortSource(g.candidatePortSource),g.showCandidatePort&&(this._showCandidatePort=g.showCandidatePort,this._proxy.$setCandidateFilter()),g.tunnelFactory&&(this._forwardPortProvider=g.tunnelFactory,this._proxy.$setTunnelProvider((f=g.tunnelFeatures)!==null&&f!==void 0?f:{elevation:!1,public:!1}))):this._forwardPortProvider=void 0,k.toDisposable(()=>{this._forwardPortProvider=void 0})}async $closeTunnel(g,f){if(this._extensionTunnels.has(g.host)){const E=this._extensionTunnels.get(g.host);E.has(g.port)&&(f&&E.get(g.port).disposeListener.dispose(),await E.get(g.port).tunnel.dispose(),E.delete(g.port))}}async $onDidTunnelsChange(){this._onDidChangeTunnels.fire()}async $forwardPort(g,f){if(this._forwardPortProvider)try{this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const E=this._forwardPortProvider(g,f);if(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),E!==void 0){const y=await E;this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),this._extensionTunnels.has(g.remoteAddress.host)||this._extensionTunnels.set(g.remoteAddress.host,new Map);const a=this._register(y.onDidDispose(()=>(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this._proxy.$closeTunnel(y.remoteAddress))));return this._extensionTunnels.get(g.remoteAddress.host).set(g.remoteAddress.port,{tunnel:y,disposeListener:a}),l.TunnelDto.fromApiTunnel(y)}else this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(E){this.logService.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error")}}async $applyCandidateFilter(g){const f=await Promise.all(g.map(y=>{var a;return this._showCandidatePort(y.host,y.port,(a=y.detail)!==null&&a!==void 0?a:"")})),E=g.filter((y,a)=>f[a]);return this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${g.map(y=>y.port).join(", ")} to ${E.map(y=>y.port).join(", ")}`),E}async findCandidatePorts(){let g="",f="";try{g=await C.Promises.readFile("/proc/net/tcp","utf8"),f=await C.Promises.readFile("/proc/net/tcp6","utf8")}catch(N){}const E=b(g,f),y=await new Promise(N=>{P.exec("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",(H,T,U)=>{N(T)})}),a=w(y),L=await C.Promises.readdir("/proc"),O=[];for(let N of L)try{const H=Number(N),T=_.joinPath(A.URI.file("/proc"),N);if((await C.Promises.stat(T.fsPath)).isDirectory()&&!isNaN(H)){const F=await C.Promises.readlink(_.joinPath(T,"cwd").fsPath),M=await C.Promises.readFile(_.joinPath(T,"cmdline").fsPath,"utf8");O.push({pid:H,cwd:F,cmd:M})}}catch(H){}const W=[],J=E.filter(N=>{const H=a[N.socket];return H||W.push(N),H}),se=i(J,a,O);let q;if(this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) number of possible root ports ${W.length}`),W.length>0){const N=await new Promise(H=>{P.exec("ps -F -A -l | grep root",(T,U,F)=>{H(U)})});this._foundRootPorts=r(W,N,this._foundRootPorts),q=Array.from(this._foundRootPorts.values()),this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) heuristic ports ${q.join(", ")}`)}return se.then(N=>q?N.concat(q):N)}};n=Ve([$e(0,R.IExtHostRpcService),$e(1,D.IExtHostInitDataService),$e(2,h.ILogService)],n),e.ExtHostTunnelService=n}),define(ge[249],pe([0,1,16,21,14,3,6,100,216,125,22]),function(Q,e,v,R,k,D,A,P,_,C,s){"use strict";var I;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=void 0;function l(n,o){try{return JSON.stringify(n,o)}catch(g){return"null"}}function m(n,o){return JSON.stringify(n,o)}function c(n){return n?(o,g)=>g&&g.$mid===1?n.transformOutgoing(g):g:null}var h;(function(n){n[n.LocalSide=0]="LocalSide",n[n.OtherSide=1]="OtherSide"})(h=e.RequestInitiator||(e.RequestInitiator={}));var S;(function(n){n[n.Responsive=0]="Responsive",n[n.Unresponsive=1]="Unresponsive"})(S=e.ResponsiveState||(e.ResponsiveState={}));const w=()=>{},b=Symbol.for("rpcProtocol"),u=Symbol.for("rpcProxy");class d extends A.Disposable{constructor(o,g=null,f=null){super();this[I]=!0,this._onDidChangeResponsiveState=this._register(new D.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=o,this._logger=g,this._uriTransformer=f,this._uriReplacer=c(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let E=0,y=C.ProxyIdentifier.count;E<y;E++)this._locals[E]=null,this._proxies[E]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new v.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(E=>this._receiveOneMessage(E))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(o=>{this._pendingRPCReplies[o].resolveErr(k.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(o){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+d.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(o){this._unresponsiveTime=Date.now()+d.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(o){this._responsiveState!==o&&(this._responsiveState=o,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(o){return this._uriTransformer?P.transformIncomingURIs(o,this._uriTransformer):o}getProxy(o){const{nid:g,sid:f}=o;return this._proxies[g]||(this._proxies[g]=this._createProxy(g,f)),this._proxies[g]}_createProxy(o,g){let f={get:(E,y)=>(typeof y=="string"&&!E[y]&&y.charCodeAt(0)===36&&(E[y]=(...a)=>this._remoteCall(o,y,a)),y===u?g:E[y])};return new Proxy(Object.create(null),f)}set(o,g){return this._locals[o.nid]=g,g}assertRegistered(o){for(let g=0,f=o.length;g<f;g++){const E=o[g];if(!this._locals[E.nid])throw new Error(`Missing actor ${E.sid} (isMain: ${E.isMain})`)}}_receiveOneMessage(o){if(this._isDisposed)return;const g=o.byteLength,f=p.read(o,0),E=f.readUInt8(),y=f.readUInt32();switch(E){case 1:case 2:{let{rpcId:a,method:L,args:O}=t.deserializeRequestJSONArgs(f);this._uriTransformer&&(O=P.transformIncomingURIs(O,this._uriTransformer)),this._receiveRequest(g,y,a,L,O,E===2);break}case 3:case 4:{let{rpcId:a,method:L,args:O}=t.deserializeRequestMixedArgs(f);this._uriTransformer&&(O=P.transformIncomingURIs(O,this._uriTransformer)),this._receiveRequest(g,y,a,L,O,E===4);break}case 5:{this._logger&&this._logger.logIncoming(g,y,0,"ack"),this._onDidReceiveAcknowledge(y);break}case 6:{this._receiveCancel(g,y);break}case 7:{this._receiveReply(g,y,void 0);break}case 9:{let a=t.deserializeReplyOKJSON(f);this._uriTransformer&&(a=P.transformIncomingURIs(a,this._uriTransformer)),this._receiveReply(g,y,a);break}case 8:{let a=t.deserializeReplyOKVSBuffer(f);this._receiveReply(g,y,a);break}case 10:{let a=t.deserializeReplyErrError(f);this._uriTransformer&&(a=P.transformIncomingURIs(a,this._uriTransformer)),this._receiveReplyErr(g,y,a);break}case 11:{this._receiveReplyErr(g,y,void 0);break}default:console.error("received unexpected message"),console.error(o)}}_receiveRequest(o,g,f,E,y,a){this._logger&&this._logger.logIncoming(o,g,1,`receiveRequest ${C.getStringIdentifierForProxy(f)}.${E}(`,y);const L=String(g);let O,W;if(a){const se=new R.CancellationTokenSource;y.push(se.token),O=this._invokeHandler(f,E,y),W=()=>se.cancel()}else O=this._invokeHandler(f,E,y),W=w;this._cancelInvokedHandlers[L]=W;const J=t.serializeAcknowledged(g);this._logger&&this._logger.logOutgoing(J.byteLength,g,1,"ack"),this._protocol.send(J),O.then(se=>{delete this._cancelInvokedHandlers[L];const q=t.serializeReplyOK(g,se,this._uriReplacer);this._logger&&this._logger.logOutgoing(q.byteLength,g,1,"reply:",se),this._protocol.send(q)},se=>{delete this._cancelInvokedHandlers[L];const q=t.serializeReplyErr(g,se);this._logger&&this._logger.logOutgoing(q.byteLength,g,1,"replyErr:",se),this._protocol.send(q)})}_receiveCancel(o,g){this._logger&&this._logger.logIncoming(o,g,1,"receiveCancel");const f=String(g);this._cancelInvokedHandlers[f]&&this._cancelInvokedHandlers[f]()}_receiveReply(o,g,f){this._logger&&this._logger.logIncoming(o,g,0,"receiveReply:",f);const E=String(g);if(!this._pendingRPCReplies.hasOwnProperty(E))return;const y=this._pendingRPCReplies[E];delete this._pendingRPCReplies[E],y.resolveOk(f)}_receiveReplyErr(o,g,f){this._logger&&this._logger.logIncoming(o,g,0,"receiveReplyErr:",f);const E=String(g);if(!this._pendingRPCReplies.hasOwnProperty(E))return;const y=this._pendingRPCReplies[E];delete this._pendingRPCReplies[E];let a;f&&(f.$isError?(a=new Error,a.name=f.name,a.message=f.message,a.stack=f.stack):a=f),y.resolveErr(a)}_invokeHandler(o,g,f){try{return Promise.resolve(this._doInvokeHandler(o,g,f))}catch(E){return Promise.reject(E)}}_doInvokeHandler(o,g,f){const E=this._locals[o];if(!E)throw new Error("Unknown actor "+C.getStringIdentifierForProxy(o));let y=E[g];if(typeof y!="function")throw new Error("Unknown method "+g+" on actor "+C.getStringIdentifierForProxy(o));return y.apply(E,f)}_remoteCall(o,g,f){if(this._isDisposed)return Promise.reject(k.canceled());let E=null;if(f.length>0&&R.CancellationToken.isCancellationToken(f[f.length-1])&&(E=f.pop()),E&&E.isCancellationRequested)return Promise.reject(k.canceled());const y=t.serializeRequestArguments(f,this._uriReplacer),a=++this._lastMessageId,L=String(a),O=new _.LazyPromise;E&&E.onCancellationRequested(()=>{const J=t.serializeCancel(a);this._logger&&this._logger.logOutgoing(J.byteLength,a,0,"cancel"),this._protocol.send(t.serializeCancel(a))}),this._pendingRPCReplies[L]=O,this._onWillSendRequest(a);const W=t.serializeRequest(a,o,g,y,!!E);return this._logger&&this._logger.logOutgoing(W.byteLength,a,0,`request: ${C.getStringIdentifierForProxy(o)}.${g}(`,f),this._protocol.send(W),O}}e.RPCProtocol=d,I=b,d.UNRESPONSIVE_TIME=3*1e3;class p{constructor(o,g){this._buff=o,this._offset=g}static alloc(o,g,f){let E=new p(s.VSBuffer.alloc(f+1+4),0);return E.writeUInt8(o),E.writeUInt32(g),E}static read(o,g){return new p(o,g)}get buffer(){return this._buff}static sizeUInt8(){return 1}writeUInt8(o){this._buff.writeUInt8(o,this._offset),this._offset+=1}readUInt8(){const o=this._buff.readUInt8(this._offset);return this._offset+=1,o}writeUInt32(o){this._buff.writeUInt32BE(o,this._offset),this._offset+=4}readUInt32(){const o=this._buff.readUInt32BE(this._offset);return this._offset+=4,o}static sizeShortString(o){return 1+o.byteLength}writeShortString(o){this._buff.writeUInt8(o.byteLength,this._offset),this._offset+=1,this._buff.set(o,this._offset),this._offset+=o.byteLength}readShortString(){const o=this._buff.readUInt8(this._offset);this._offset+=1;const f=this._buff.slice(this._offset,this._offset+o).toString();return this._offset+=o,f}static sizeLongString(o){return 4+o.byteLength}writeLongString(o){this._buff.writeUInt32BE(o.byteLength,this._offset),this._offset+=4,this._buff.set(o,this._offset),this._offset+=o.byteLength}readLongString(){const o=this._buff.readUInt32BE(this._offset);this._offset+=4;const f=this._buff.slice(this._offset,this._offset+o).toString();return this._offset+=o,f}writeBuffer(o){this._buff.writeUInt32BE(o.byteLength,this._offset),this._offset+=4,this._buff.set(o,this._offset),this._offset+=o.byteLength}static sizeVSBuffer(o){return 4+o.byteLength}writeVSBuffer(o){this._buff.writeUInt32BE(o.byteLength,this._offset),this._offset+=4,this._buff.set(o,this._offset),this._offset+=o.byteLength}readVSBuffer(){const o=this._buff.readUInt32BE(this._offset);this._offset+=4;const g=this._buff.slice(this._offset,this._offset+o);return this._offset+=o,g}static sizeMixedArray(o,g){let f=0;f+=1;for(let E=0,y=o.length;E<y;E++){const a=o[E],L=g[E];switch(f+=1,L){case 1:f+=this.sizeLongString(a);break;case 2:f+=this.sizeVSBuffer(a);break;case 3:break}}return f}writeMixedArray(o,g){this._buff.writeUInt8(o.length,this._offset),this._offset+=1;for(let f=0,E=o.length;f<E;f++){const y=o[f];switch(g[f]){case 1:this.writeUInt8(1),this.writeLongString(y);break;case 2:this.writeUInt8(2),this.writeVSBuffer(y);break;case 3:this.writeUInt8(3);break}}}readMixedArray(){const o=this._buff.readUInt8(this._offset);this._offset+=1;let g=new Array(o);for(let f=0;f<o;f++)switch(this.readUInt8()){case 1:g[f]=this.readLongString();break;case 2:g[f]=this.readVSBuffer();break;case 3:g[f]=void 0;break}return g}}class t{static _arrayContainsBufferOrUndefined(o){for(let g=0,f=o.length;g<f;g++)if(o[g]instanceof s.VSBuffer||typeof o[g]=="undefined")return!0;return!1}static serializeRequestArguments(o,g){if(this._arrayContainsBufferOrUndefined(o)){let f=[],E=[];for(let y=0,a=o.length;y<a;y++){const L=o[y];L instanceof s.VSBuffer?(f[y]=L,E[y]=2):typeof L=="undefined"?(f[y]=s.VSBuffer.alloc(0),E[y]=3):(f[y]=s.VSBuffer.fromString(m(L,g)),E[y]=1)}return{type:"mixed",args:f,argsType:E}}return{type:"simple",args:m(o,g)}}static serializeRequest(o,g,f,E,y){return E.type==="mixed"?this._requestMixedArgs(o,g,f,E.args,E.argsType,y):this._requestJSONArgs(o,g,f,E.args,y)}static _requestJSONArgs(o,g,f,E,y){const a=s.VSBuffer.fromString(f),L=s.VSBuffer.fromString(E);let O=0;O+=p.sizeUInt8(),O+=p.sizeShortString(a),O+=p.sizeLongString(L);let W=p.alloc(y?2:1,o,O);return W.writeUInt8(g),W.writeShortString(a),W.writeLongString(L),W.buffer}static deserializeRequestJSONArgs(o){const g=o.readUInt8(),f=o.readShortString(),E=o.readLongString();return{rpcId:g,method:f,args:JSON.parse(E)}}static _requestMixedArgs(o,g,f,E,y,a){const L=s.VSBuffer.fromString(f);let O=0;O+=p.sizeUInt8(),O+=p.sizeShortString(L),O+=p.sizeMixedArray(E,y);let W=p.alloc(a?4:3,o,O);return W.writeUInt8(g),W.writeShortString(L),W.writeMixedArray(E,y),W.buffer}static deserializeRequestMixedArgs(o){const g=o.readUInt8(),f=o.readShortString(),E=o.readMixedArray(),y=new Array(E.length);for(let a=0,L=E.length;a<L;a++){const O=E[a];typeof O=="string"?y[a]=JSON.parse(O):y[a]=O}return{rpcId:g,method:f,args:y}}static serializeAcknowledged(o){return p.alloc(5,o,0).buffer}static serializeCancel(o){return p.alloc(6,o,0).buffer}static serializeReplyOK(o,g,f){return typeof g=="undefined"?this._serializeReplyOKEmpty(o):g instanceof s.VSBuffer?this._serializeReplyOKVSBuffer(o,g):this._serializeReplyOKJSON(o,l(g,f))}static _serializeReplyOKEmpty(o){return p.alloc(7,o,0).buffer}static _serializeReplyOKVSBuffer(o,g){let f=0;f+=p.sizeVSBuffer(g);let E=p.alloc(8,o,f);return E.writeVSBuffer(g),E.buffer}static deserializeReplyOKVSBuffer(o){return o.readVSBuffer()}static _serializeReplyOKJSON(o,g){const f=s.VSBuffer.fromString(g);let E=0;E+=p.sizeLongString(f);let y=p.alloc(9,o,E);return y.writeLongString(f),y.buffer}static deserializeReplyOKJSON(o){const g=o.readLongString();return JSON.parse(g)}static serializeReplyErr(o,g){return g?this._serializeReplyErrEror(o,g):this._serializeReplyErrEmpty(o)}static _serializeReplyErrEror(o,g){const f=s.VSBuffer.fromString(l(k.transformErrorForSerialization(g),null));let E=0;E+=p.sizeLongString(f);let y=p.alloc(10,o,E);return y.writeLongString(f),y.buffer}static deserializeReplyErrError(o){const g=o.readLongString();return JSON.parse(g)}static _serializeReplyErrEmpty(o){return p.alloc(11,o,0).buffer}}var i;(function(n){n[n.RequestJSONArgs=1]="RequestJSONArgs",n[n.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",n[n.RequestMixedArgs=3]="RequestMixedArgs",n[n.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",n[n.Acknowledged=5]="Acknowledged",n[n.Cancel=6]="Cancel",n[n.ReplyOKEmpty=7]="ReplyOKEmpty",n[n.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",n[n.ReplyOKJSON=9]="ReplyOKJSON",n[n.ReplyErrError=10]="ReplyErrError",n[n.ReplyErrEmpty=11]="ReplyErrEmpty"})(i||(i={}));var r;(function(n){n[n.String=1]="String",n[n.VSBuffer=2]="VSBuffer",n[n.Undefined=3]="Undefined"})(r||(r={}))}),define(ge[250],pe([0,1,4]),function(Q,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=v.createDecorator("remoteAgentService")}),define(ge[251],pe([0,1,10,9,11,2,4,82,45,211,250]),function(Q,e,v,R,k,D,A,P,_,C,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=A.createDecorator("pathService");let I=class $n{constructor(m,c,h,S){this.localUserHome=m,this.remoteAgentService=c,this.environmentService=h,this.contextService=S,this.resolveOS=(async()=>{const w=await this.remoteAgentService.getEnvironment();return(w==null?void 0:w.os)||k.OS})(),this.resolveUserHome=(async()=>{const w=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=(w==null?void 0:w.userHome)||m})()}get defaultUriScheme(){return $n.findDefaultUriScheme(this.environmentService,this.contextService)}static findDefaultUriScheme(m,c){if(m.remoteAuthority)return v.Schemas.vscodeRemote;const h=P.getVirtualWorkspaceScheme(c.getWorkspace());if(h)return h;const S=c.getWorkspace().folders[0];if(S)return S.uri.scheme;const w=c.getWorkspace().configuration;return w?w.scheme:v.Schemas.file}async userHome(m){return(m==null?void 0:m.preferLocal)?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(m=>m===1?R.win32:R.posix)}async fileURI(m){let c="";if(await this.resolveOS===1&&(m=m.replace(/\\/g,"/")),m[0]==="/"&&m[1]==="/"){const S=m.indexOf("/",2);S===-1?(c=m.substring(2),m="/"):(c=m.substring(2,S),m=m.substring(S)||"/")}return D.URI.from({scheme:v.Schemas.file,authority:c,path:m,query:"",fragment:""})}};I=Ve([$e(1,s.IRemoteAgentService),$e(2,C.IWorkbenchEnvironmentService),$e(3,_.IWorkspaceContextService)],I),e.AbstractPathService=I}),define(ge[63],pe([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class v{constructor(A,P){this.line=A,this.character=P}isBefore(A){return!1}isBeforeOrEqual(A){return!1}isAfter(A){return!1}isAfterOrEqual(A){return!1}isEqual(A){return!1}compareTo(A){return 0}translate(A,P){return new v(0,0)}with(A){return new v(0,0)}}e.Position=v;class R{constructor(A,P,_,C){this.isEmpty=!1,this.isSingleLine=!1,this.start=new v(A,P),this.end=new v(_,C)}contains(A){return!1}isEqual(A){return!1}intersection(A){}union(A){return new R(0,0,0,0)}with(A){return new R(0,0,0,0)}}e.Range=R;var k;(function(D){D[D.Information=1]="Information",D[D.Warning=2]="Warning"})(k=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(ge[31],pe([0,1,18,30,25,29,8,4,9,14,63]),function(Q,e,v,R,k,D,A,P,_,C,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return s.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const I="\u27EA ",l=" characters skipped \u27EB",m=(I.length+l.length+5)*2;e.ISearchService=P.createDecorator("searchService");var c;(function(T){T[T.file=0]="file",T[T.text=1]="text"})(c=e.SearchProviderType||(e.SearchProviderType={}));var h;(function(T){T[T.File=1]="File",T[T.Text=2]="Text"})(h=e.QueryType||(e.QueryType={}));function S(T){return!!T.preview}e.resultIsMatch=S;function w(T){return!!T.resource}e.isFileMatch=w;function b(T){return!!T.message}e.isProgressMessage=b;var u;(function(T){T[T.Normal=0]="Normal",T[T.NewSearchStarted=1]="NewSearchStarted"})(u=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class d{constructor(U){this.resource=U,this.results=[]}}e.FileMatch=d;class p{constructor(U,F,M){this.ranges=F;const x=Array.isArray(F)?F:[F];if(M&&M.matchLines===1&&t(x)){U=A.getNLines(U,M.matchLines);let $="",X=0,le=0;const be=Math.floor(M.charsPerLine/5),Re=[];for(const Ce of x){const Me=Math.max(Ce.startColumn-be,0),je=Ce.startColumn+M.charsPerLine;if(Me>le+be+m){const ze=I+(Me-le)+l;$+=ze+U.slice(Me,je),X+=Me-(le+ze.length)}else $+=U.slice(le,je);Re.push(new r(0,Ce.startColumn-X,Ce.endColumn-X)),le=je}this.preview={text:$,matches:Array.isArray(this.ranges)?Re:Re[0]}}else{const $=Array.isArray(F)?F[0].startLineNumber:F.startLineNumber;this.preview={text:U,matches:v.mapArrayOrNot(F,X=>new i(X.startLineNumber-$,X.startColumn,X.endLineNumber-$,X.endColumn))}}}}e.TextSearchMatch=p;function t(T){const U=T[0].startLineNumber;for(const F of T)if(F.startLineNumber!==U||F.endLineNumber!==U)return!1;return!0}class i{constructor(U,F,M,x){this.startLineNumber=U,this.startColumn=F,this.endLineNumber=M,this.endColumn=x}}e.SearchRange=i;class r extends i{constructor(U,F,M){super(U,F,U,M)}}e.OneLineRange=r;var n;(function(T){T.Default="default",T.FileNames="fileNames",T.Type="type",T.Modified="modified",T.CountDescending="countDescending",T.CountAscending="countAscending"})(n=e.SearchSortOrder||(e.SearchSortOrder={}));function o(T,U=!0){const F=T&&T.files&&T.files.exclude,M=U&&T&&T.search&&T.search.exclude;if(!F&&!M)return;if(!F||!M)return F||M;let x=Object.create(null);return x=k.mixin(x,k.deepClone(F)),x=k.mixin(x,k.deepClone(M),!0),x}e.getExcludes=o;function g(T,U){return T.excludePattern&&R.match(T.excludePattern,U)?!1:T.includePattern||T.usingSearchPaths?T.includePattern&&R.match(T.includePattern,U)?!0:T.usingSearchPaths?!!T.folderQueries&&T.folderQueries.some(F=>{const M=F.folder.fsPath;if(D.isEqualOrParent(U,M)){const x=_.relative(M,U);return!F.includePattern||!!R.match(F.includePattern,x)}else return!1}):!1:!0}e.pathIncludedInQuery=g;var f;(function(T){T[T.unknownEncoding=1]="unknownEncoding",T[T.regexParseError=2]="regexParseError",T[T.globParseError=3]="globParseError",T[T.invalidLiteral=4]="invalidLiteral",T[T.rgProcessError=5]="rgProcessError",T[T.other=6]="other",T[T.canceled=7]="canceled"})(f=e.SearchErrorCode||(e.SearchErrorCode={}));class E extends Error{constructor(U,F){super(U);this.code=F}}e.SearchError=E;function y(T){const U=T.message;if(C.isPromiseCanceledError(T))return new E(U,f.canceled);try{const F=JSON.parse(U);return new E(F.message,F.code)}catch(F){return new E(U,f.other)}}e.deserializeSearchError=y;function a(T){const U={message:T.message,code:T.code};return new Error(JSON.stringify(U))}e.serializeSearchError=a;function L(T){return T.type==="error"?!0:T.type==="success"}e.isSerializedSearchComplete=L;function O(T){return T.type==="success"}e.isSerializedSearchSuccess=O;function W(T){return!!T.path}e.isSerializedFileMatch=W;function J(T,U){const F=T.searchPath?T.searchPath:T.relativePath;return A.fuzzyContains(F,U)}e.isFilePatternMatch=J;class se{constructor(U){this.path=U,this.results=[]}addMatch(U){this.results.push(U)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=se;function q(T,U){const F=Object.assign(Object.assign({},T||{}),U||{});return Object.keys(F).filter(M=>{const x=F[M];return typeof x=="boolean"&&x})}e.resolvePatternsForProvider=q;class N{constructor(U,F){this._parsedIncludeExpression=null,this._excludeExpression=Object.assign(Object.assign({},U.excludePattern||{}),F.excludePattern||{}),this._parsedExcludeExpression=R.parse(this._excludeExpression);let M=U.includePattern;F.includePattern&&(M?M=Object.assign(Object.assign({},M),F.includePattern):M=F.includePattern),M&&(this._parsedIncludeExpression=R.parse(M))}includedInQuerySync(U,F,M){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(U,F,M)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(U,F,M))}includedInQuery(U,F,M){return Promise.resolve(this._parsedExcludeExpression(U,F,M)).then($=>!!$).then($=>$?!1:this._parsedIncludeExpression?Promise.resolve(this._parsedIncludeExpression(U,F,M)).then(X=>!!X):Promise.resolve(!0)).then($=>$)}hasSiblingExcludeClauses(){return H(this._excludeExpression)}}e.QueryGlobTester=N;function H(T){for(const U in T)if(typeof T[U]!="boolean")return!0;return!1}}),define(ge[34],pe([0,1,18,16,21,3,23,10,72,24,8,15,2,164,4,12,181,45,58,27,13,7,31,5]),function(Q,e,v,R,k,D,A,P,_,C,s,I,l,m,c,h,S,w,b,u,d,p,t,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function r(L,O,W){return new C.ExtUri(J=>f(J,W)).isEqual(L,O)}function n(L,O,W){return r(L.uri,O.uri,W)?0:s.compare(L.uri.toString(),O.uri.toString())}function o(L,O,W){return L.index!==O.index?L.index<O.index?-1:1:r(L.uri,O.uri,W)?s.compare(L.name,O.name):s.compare(L.uri.toString(),O.uri.toString())}function g(L,O,W,J){const se=L.slice(0).sort((N,H)=>W(N,H,J)),q=O.slice(0).sort((N,H)=>W(N,H,J));return v.delta(se,q,(N,H)=>W(N,H,J))}function f(L,O){const W=O.getCapabilities(L.scheme);return!(W&&W&1024)}class E extends w.Workspace{constructor(O,W,J,se,q,N){super(O,J.map(H=>new w.WorkspaceFolder(H)),se,N);this._name=W,this._isUntitled=q,this._workspaceFolders=[],this._structure=A.TernarySearchTree.forUris(N),J.forEach(H=>{this._workspaceFolders.push(H),this._structure.set(H.uri,H)})}static toExtHostWorkspace(O,W,J,se){if(!O)return{workspace:null,added:[],removed:[]};const{id:q,name:N,folders:H,configuration:T,isUntitled:U}=O,F=[],M=W;W?H.forEach((le,be)=>{const Re=l.URI.revive(le.uri),Ce=E._findFolder(J||W,Re,se);Ce?(Ce.name=le.name,Ce.index=le.index,F.push(Ce)):F.push({uri:Re,name:le.name,index:be})}):F.push(...H.map(({uri:le,name:be,index:Re})=>({uri:l.URI.revive(le),name:be,index:Re}))),F.sort((le,be)=>le.index<be.index?-1:1);const x=new E(q,N,F,T?l.URI.revive(T):null,!!U,le=>f(le,se)),{added:$,removed:X}=g(M?M.workspaceFolders:[],x.workspaceFolders,n,se);return{workspace:x,added:$,removed:X}}static _findFolder(O,W,J){for(let se=0;se<O.folders.length;se++){const q=O.workspaceFolders[se];if(r(q.uri,W,J))return q}}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(O,W){return W&&this._structure.get(O)&&(O=C.dirname(O)),this._structure.findSubstr(O)}resolveWorkspaceFolder(O){return this._structure.get(O)}}let y=class{constructor(O,W,J,se){this._onDidChangeWorkspace=new D.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidGrantWorkspaceTrust=new D.Emitter,this.onDidGrantWorkspaceTrust=this._onDidGrantWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._logService=se,this._extHostFileSystemInfo=J,this._requestIdProvider=new _.Counter,this._barrier=new R.Barrier,this._proxy=O.getProxy(i.MainContext.MainThreadWorkspace),this._messageService=O.getProxy(i.MainContext.MainThreadMessageService);const q=W.workspace;this._confirmedWorkspace=q?new E(q.id,q.name,[],q.configuration?l.URI.revive(q.configuration):null,!!q.isUntitled,N=>f(N,J)):void 0}$initializeWorkspace(O,W){this._trusted=W,this.$acceptWorkspaceData(O),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?l.URI.from({scheme:P.Schemas.untitled,path:C.basename(C.dirname(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(O,W,J,...se){const q=[];if(Array.isArray(se)&&se.forEach(F=>{l.URI.isUri(F.uri)&&!q.some(M=>r(M.uri,F.uri,this._extHostFileSystemInfo))&&q.push({uri:F.uri,name:F.name||C.basenameOrAuthority(F.uri)})}),this._unconfirmedWorkspace||[W,J].some(F=>typeof F!="number"||F<0)||J===0&&q.length===0)return!1;const N=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if(W+J>N.length)return!1;const H=N.slice(0);H.splice(W,J,...q.map(F=>({uri:F.uri,name:F.name||C.basenameOrAuthority(F.uri),index:void 0})));for(let F=0;F<H.length;F++){const M=H[F];if(H.some((x,$)=>$!==F&&r(M.uri,x.uri,this._extHostFileSystemInfo)))return!1}H.forEach((F,M)=>F.index=M);const{added:T,removed:U}=g(N,H,o,this._extHostFileSystemInfo);if(T.length===0&&U.length===0)return!1;if(this._proxy){const F=O.displayName||O.name;this._proxy.$updateWorkspaceFolders(F,W,J,q).then(void 0,M=>{this._unconfirmedWorkspace=void 0,this._messageService.$showMessage(S.Severity.Error,m.localize(0,null,F,M.toString()),{extension:O},[])})}return this.trySetWorkspaceFolders(H),!0}getWorkspaceFolder(O,W){if(!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(O,W)}async getWorkspaceFolder2(O,W){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(O,W)}async resolveWorkspaceFolder(O){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(O)}getPath(){if(!this._actualWorkspace)return;const{folders:O}=this._actualWorkspace;if(O.length!==0)return O[0].uri.fsPath}getRelativePath(O,W){let J,se="";if(typeof O=="string"?(J=l.URI.file(O),se=O):typeof O!="undefined"&&(J=O,se=O.fsPath),!J)return se;const q=this.getWorkspaceFolder(J,!0);if(!q)return se;typeof W=="undefined"&&this._actualWorkspace&&(W=this._actualWorkspace.folders.length>1);let N=C.relativePath(q.uri,J);return W&&q.name&&(N=`${q.name}/${N}`),N}trySetWorkspaceFolders(O){this._actualWorkspace&&(this._unconfirmedWorkspace=E.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:O,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(O){const{workspace:W,added:J,removed:se}=E.toExtHostWorkspace(O,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=W||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:J,removed:se}))}findFiles(O,W,J,se,q=k.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${se.value}, entryPoint: findFiles`);let N;if(W===null?N=!1:W&&(typeof W=="string"?N=W:N=W.pattern),q&&q.isCancellationRequested)return Promise.resolve([]);const{includePattern:H,folder:T}=a(O);return this._proxy.$startFileSearch(I.withUndefinedAsNull(H),I.withUndefinedAsNull(T),I.withUndefinedAsNull(N),I.withUndefinedAsNull(J),q).then(U=>Array.isArray(U)?U.map(F=>l.URI.revive(F)):[])}async findTextInFiles(O,W,J,se,q=k.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${se.value}, entryPoint: findTextInFiles`);const N=this._requestIdProvider.getNext(),H=typeof W.previewOptions=="undefined"?{matchLines:100,charsPerLine:1e4}:W.previewOptions,{includePattern:T,folder:U}=a(W.include),F=typeof W.exclude=="string"?W.exclude:W.exclude?W.exclude.pattern:void 0,M={ignoreSymlinks:typeof W.followSymlinks=="boolean"?!W.followSymlinks:void 0,disregardIgnoreFiles:typeof W.useIgnoreFiles=="boolean"?!W.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof W.useGlobalIgnoreFiles=="boolean"?!W.useGlobalIgnoreFiles:void 0,disregardExcludeSettings:typeof W.useDefaultExcludes=="boolean"?!W.useDefaultExcludes:!0,fileEncoding:W.encoding,maxResults:W.maxResults,previewOptions:H,afterContext:W.afterContext,beforeContext:W.beforeContext,includePattern:T,excludePattern:F},x=!1;if(this._activeSearchCallbacks[N]=$=>{if(x)return;const X=l.URI.revive($.resource);$.results.forEach(le=>{t.resultIsMatch(le)?J({uri:X,preview:{text:le.preview.text,matches:v.mapArrayOrNot(le.preview.matches,be=>new p.Range(be.startLineNumber,be.startColumn,be.endLineNumber,be.endColumn))},ranges:v.mapArrayOrNot(le.ranges,be=>new p.Range(be.startLineNumber,be.startColumn,be.endLineNumber,be.endColumn))}):J({uri:X,text:le.text,lineNumber:le.lineNumber})})},q.isCancellationRequested)return{};try{const $=await this._proxy.$startTextSearch(O,I.withUndefinedAsNull(U),M,N,q);return delete this._activeSearchCallbacks[N],$||{}}catch($){throw delete this._activeSearchCallbacks[N],$}}$handleTextSearchResult(O,W){this._activeSearchCallbacks[W]&&this._activeSearchCallbacks[W](O)}saveAll(O){return this._proxy.$saveAll(O)}resolveProxy(O){return this._proxy.$resolveProxy(O)}get trusted(){return this._trusted}requestWorkspaceTrust(O){return this._proxy.$requestWorkspaceTrust(O)}$onDidGrantWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidGrantWorkspaceTrust.fire())}};y=Ve([$e(0,d.IExtHostRpcService),$e(1,u.IExtHostInitDataService),$e(2,b.IExtHostFileSystemInfo),$e(3,h.ILogService)],y),e.ExtHostWorkspace=y,e.IExtHostWorkspace=c.createDecorator("IExtHostWorkspace");function a(L){let O,W;return L&&(typeof L=="string"?O=L:(O=L.pattern,W=L.baseFolder||l.URI.file(L.base))),{includePattern:O,folder:W}}}),define(ge[36],pe([0,1,25,3,34,5,7,185,80,15,16,4,13,12,2]),function(Q,e,v,R,k,D,A,P,_,C,s,I,l,m,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function h(i,r){if(r){const n=r.split(".");let o=i;for(let g=0;o&&g<n.length;g++)o=o[n[g]];return o}}function S(i){return i instanceof c.URI}function w(i){return i&&i.uri instanceof c.URI&&i.languageId&&typeof i.languageId=="string"}function b(i){return i&&!i.uri&&i.languageId&&typeof i.languageId=="string"}function u(i){return i&&i.uri instanceof c.URI&&(!i.name||typeof i.name=="string")&&(!i.index||typeof i.index=="number")}function d(i){if(S(i))return{resource:i};if(w(i))return{resource:i.uri,overrideIdentifier:i.languageId};if(b(i))return{overrideIdentifier:i.languageId};if(u(i))return{resource:i.uri};if(i===null)return{resource:null}}let p=class{constructor(r,n,o){this._proxy=r.getProxy(D.MainContext.MainThreadConfiguration),this._extHostWorkspace=n,this._logService=o,this._barrier=new s.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(r=>this._actual)}$initializeConfiguration(r){this._actual=new t(this._proxy,this._extHostWorkspace,r,this._logService),this._barrier.open()}$acceptConfigurationChanged(r,n){this.getConfigProvider().then(o=>o.$acceptConfigurationChanged(r,n))}};p=Ve([$e(0,l.IExtHostRpcService),$e(1,k.IExtHostWorkspace),$e(2,m.ILogService)],p),e.ExtHostConfiguration=p;class t{constructor(r,n,o,g){this._onDidChangeConfiguration=new R.Emitter,this._proxy=r,this._logService=g,this._extHostWorkspace=n,this._configuration=P.Configuration.parse(o),this._configurationScopes=this._toMap(o.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(r,n){const o={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=P.Configuration.parse(r),this._configurationScopes=this._toMap(r.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(n,o))}getConfiguration(r,n,o){const g=d(n)||{},f=this._toReadonlyValue(r?h(this._configuration.getValue(void 0,g,this._extHostWorkspace.workspace),r):this._configuration.getValue(void 0,g,this._extHostWorkspace.workspace));r&&this._validateConfigurationAccess(r,g,o==null?void 0:o.identifier);function E(a){if(a==null)return null;if(typeof a=="boolean")return a?1:4;switch(a){case A.ConfigurationTarget.Global:return 1;case A.ConfigurationTarget.Workspace:return 4;case A.ConfigurationTarget.WorkspaceFolder:return 5}}const y={has(a){return typeof h(f,a)!="undefined"},get:(a,L)=>{this._validateConfigurationAccess(r?`${r}.${a}`:a,g,o==null?void 0:o.identifier);let O=h(f,a);if(typeof O=="undefined")O=L;else{let W;const J=(se,q)=>{let N;const H=()=>{W=W||v.deepClone(f),N=N||h(W,q)};return C.isObject(se)?new Proxy(se,{get:(T,U)=>{if(typeof U=="string"&&U.toLowerCase()==="tojson")return H(),()=>N;if(W)return N=N||h(W,q),N[U];const F=T[U];return typeof U=="string"?J(F,`${q}.${U}`):F},set:(T,U,F)=>(H(),N&&(N[U]=F),!0),deleteProperty:(T,U)=>(H(),N&&delete N[U],!0),defineProperty:(T,U,F)=>(H(),N&&Object.defineProperty(N,U,F),!0)}):se};O=J(O,a)}return O},update:(a,L,O,W)=>{a=r?`${r}.${a}`:a;const J=E(O);return L!==void 0?this._proxy.$updateConfigurationOption(J,a,L,g,W):this._proxy.$removeConfigurationOption(J,a,g,W)},inspect:a=>{var L,O,W,J,se,q,N,H;a=r?`${r}.${a}`:a;const T=v.deepClone(this._configuration.inspect(a,g,this._extHostWorkspace.workspace));if(T)return{key:a,defaultValue:(L=T.default)===null||L===void 0?void 0:L.value,globalValue:(O=T.user)===null||O===void 0?void 0:O.value,workspaceValue:(W=T.workspace)===null||W===void 0?void 0:W.value,workspaceFolderValue:(J=T.workspaceFolder)===null||J===void 0?void 0:J.value,defaultLanguageValue:(se=T.default)===null||se===void 0?void 0:se.override,globalLanguageValue:(q=T.user)===null||q===void 0?void 0:q.override,workspaceLanguageValue:(N=T.workspace)===null||N===void 0?void 0:N.override,workspaceFolderLanguageValue:(H=T.workspaceFolder)===null||H===void 0?void 0:H.override,languageIds:T.overrideIdentifiers}}};return typeof f=="object"&&v.mixin(y,f,!1),Object.freeze(y)}_toReadonlyValue(r){const n=o=>C.isObject(o)?new Proxy(o,{get:(g,f)=>n(g[f]),set:(g,f,E)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(f)}' of object`)},deleteProperty:(g,f)=>{throw new Error(`TypeError: Cannot delete read only property '${String(f)}' of object`)},defineProperty:(g,f)=>{throw new Error(`TypeError: Cannot define property '${String(f)}' for a readonly object`)},setPrototypeOf:g=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):o;return n(r)}_validateConfigurationAccess(r,n,o){const g=_.OVERRIDE_PROPERTY_PATTERN.test(r)?4:this._configurationScopes.get(r),f=o?`[${o.value}] `:"";if(g===4){typeof(n==null?void 0:n.resource)=="undefined"&&this._logService.warn(`${f}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${r}', provide the URI of a resource or 'null' for any resource.`);return}if(g===3){(n==null?void 0:n.resource)&&this._logService.warn(`${f}Accessing a window scoped configuration for a resource is not expected. To associate '${r}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(r,n){const o=new P.ConfigurationChangeEvent(r,n,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(g,f)=>o.affectsConfiguration(g,d(f))})}_toMap(r){return r.reduce((n,o)=>(n.set(o[0],o[1]),n),new Map)}}e.ExtHostConfigProvider=t,e.IExtHostConfiguration=I.createDecorator("IExtHostConfiguration")});var it=this&&this.__classPrivateFieldSet||function(Q,e,v,R,k){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Q!==e||!k:!e.has(Q))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?k.call(Q,v):k?k.value=v:e.set(Q,v),v},Be=this&&this.__classPrivateFieldGet||function(Q,e,v,R){if(v==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Q!==e||!R:!e.has(Q))throw new TypeError("Cannot read private member from an object whose class did not declare it");return v==="m"?R:v==="a"?R.call(Q):R?R.value:e.get(Q)};define(ge[64],pe([0,1,2,16,3,5,7,34,39,36,21,33,13,27,4,10,11,12,60,200,14]),function(Q,e,v,R,k,D,A,P,_,C,s,I,l,m,c,h,S,w,b,u,d){"use strict";var p;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskExecutionDTO=e.TaskFilterDTO=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=e.ShellExecutionDTO=e.ShellExecutionOptionsDTO=e.ProcessExecutionDTO=e.ProcessExecutionOptionsDTO=e.TaskPresentationOptionsDTO=e.TaskDefinitionDTO=void 0;var t;(function(se){function q(H){if(H!=null)return H}se.from=q;function N(H){if(H!=null)return H}se.to=N})(t=e.TaskDefinitionDTO||(e.TaskDefinitionDTO={}));var i;(function(se){function q(H){if(H!=null)return H}se.from=q;function N(H){if(H!=null)return H}se.to=N})(i=e.TaskPresentationOptionsDTO||(e.TaskPresentationOptionsDTO={}));var r;(function(se){function q(H){if(H!=null)return H}se.from=q;function N(H){if(H!=null)return H}se.to=N})(r=e.ProcessExecutionOptionsDTO||(e.ProcessExecutionOptionsDTO={}));var n;(function(se){function q(T){if(T){const U=T;return U&&!!U.process}else return!1}se.is=q;function N(T){if(T==null)return;const U={process:T.process,args:T.args};return T.options&&(U.options=r.from(T.options)),U}se.from=N;function H(T){if(T!=null)return new A.ProcessExecution(T.process,T.args,T.options)}se.to=H})(n=e.ProcessExecutionDTO||(e.ProcessExecutionDTO={}));var o;(function(se){function q(H){if(H!=null)return H}se.from=q;function N(H){if(H!=null)return H}se.to=N})(o=e.ShellExecutionOptionsDTO||(e.ShellExecutionOptionsDTO={}));var g;(function(se){function q(T){if(T){const U=T;return U&&(!!U.commandLine||!!U.command)}else return!1}se.is=q;function N(T){if(T==null)return;const U={};return T.commandLine!==void 0?U.commandLine=T.commandLine:(U.command=T.command,U.args=T.args),T.options&&(U.options=o.from(T.options)),U}se.from=N;function H(T){if(!(T==null||T.command===void 0&&T.commandLine===void 0))return T.commandLine?new A.ShellExecution(T.commandLine,T.options):new A.ShellExecution(T.command,T.args?T.args:[],T.options)}se.to=H})(g=e.ShellExecutionDTO||(e.ShellExecutionDTO={}));var f;(function(se){function q(T){if(T){let U=T;return U&&U.customExecution==="customExecution"}else return!1}se.is=q;function N(T){return{customExecution:"customExecution"}}se.from=N;function H(T,U){return U.get(T)}se.to=H})(f=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var E;(function(se){function q(N,H){let T;return N.scope!==void 0&&typeof N.scope!="number"?T=N.scope.uri:N.scope!==void 0&&typeof N.scope=="number"&&(N.scope===A.TaskScope.Workspace&&H&&H.workspaceFile?T=H.workspaceFile:T=u.USER_TASKS_GROUP_KEY),{id:N._id,workspaceFolder:T}}se.from=q})(E=e.TaskHandleDTO||(e.TaskHandleDTO={}));var y;(function(se){function q(T,U){if(T==null)return[];const F=[];for(let M of T){const x=N(M,U);x&&F.push(x)}return F}se.fromMany=q;function N(T,U){if(T==null)return;let F;T.execution instanceof A.ProcessExecution?F=n.from(T.execution):T.execution instanceof A.ShellExecution?F=g.from(T.execution):T.execution&&T.execution instanceof A.CustomExecution&&(F=f.from(T.execution));const M=t.from(T.definition);let x;if(T.scope?typeof T.scope=="number"?x=T.scope:x=T.scope.uri:x=A.TaskScope.Workspace,!M||!x)return;const $=T.group?T.group.id:void 0;return{_id:T._id,definition:M,name:T.name,source:{extensionId:U.identifier.value,label:T.source,scope:x},execution:F,isBackground:T.isBackground,group:$,presentationOptions:i.from(T.presentationOptions),problemMatchers:T.problemMatchers,hasDefinedMatchers:T.hasDefinedMatchers,runOptions:T.runOptions?T.runOptions:{reevaluateOnRerun:!0},detail:T.detail}}se.from=N;async function H(T,U,F){if(T==null)return;let M;n.is(T.execution)?M=n.to(T.execution):g.is(T.execution)?M=g.to(T.execution):f.is(T.execution)&&(M=f.to(T._id,F));const x=t.to(T.definition);let $;if(T.source&&(T.source.scope!==void 0?typeof T.source.scope=="number"?$=T.source.scope:$=await U.resolveWorkspaceFolder(v.URI.revive(T.source.scope)):$=A.TaskScope.Workspace),!x||!$)return;const X=new A.Task(x,$,T.name,T.source.label,M,T.problemMatchers);return T.isBackground!==void 0&&(X.isBackground=T.isBackground),T.group!==void 0&&(X.group=A.TaskGroup.from(T.group)),T.presentationOptions&&(X.presentationOptions=i.to(T.presentationOptions)),T._id&&(X._id=T._id),T.detail&&(X.detail=T.detail),X}se.to=H})(y=e.TaskDTO||(e.TaskDTO={}));var a;(function(se){function q(H){return H}se.from=q;function N(H){if(!!H)return Object.assign(Object.create(null),H)}se.to=N})(a=e.TaskFilterDTO||(e.TaskFilterDTO={}));class L{constructor(q,N,H){this._id=N,this._task=H,p.set(this,void 0),it(this,p,q,"f")}get task(){return this._task}terminate(){Be(this,p,"f").terminateTask(this)}fireDidStartProcess(q){}fireDidEndProcess(q){}}p=new WeakMap;var O;(function(se){function q(N){return{id:N._id,task:void 0}}se.from=q})(O=e.TaskExecutionDTO||(e.TaskExecutionDTO={}));let W=class{constructor(q,N,H,T,U,F,M,x){this._onDidExecuteTask=new k.Emitter,this._onDidTerminateTask=new k.Emitter,this._onDidTaskProcessStarted=new k.Emitter,this._onDidTaskProcessEnded=new k.Emitter,this._proxy=q.getProxy(D.MainContext.MainThreadTask),this._workspaceProvider=H,this._editorService=T,this._configurationService=U,this._terminalService=F,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=M,this._deprecationService=x,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(q,N,H){if(!H)return new A.Disposable(()=>{});const T=this.nextHandle();return this._handlers.set(T,{type:N,provider:H,extension:q}),this._proxy.$registerTaskProvider(T,N),new A.Disposable(()=>{this._handlers.delete(T),this._proxy.$unregisterTaskProvider(T)})}registerTaskSystem(q,N){this._proxy.$registerTaskSystem(q,N)}fetchTasks(q){return this._proxy.$fetchTasks(a.from(q)).then(async N=>{const H=[];for(let T of N){const U=await y.to(T,this._workspaceProvider,this._providedCustomExecutions2);U&&H.push(U)}return H})}get taskExecutions(){const q=[];return this._taskExecutions.forEach(N=>q.push(N)),q}terminateTask(q){if(!(q instanceof L))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(q._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(q,N,H){const T=this._providedCustomExecutions2.get(q.id);if(T){if(this._activeCustomExecutions2.get(q.id)!==void 0)throw new Error("We should not be trying to start the same custom task executions twice.");this._activeCustomExecutions2.set(q.id,T),this._terminalService.attachPtyToTerminal(N,await T.callback(H))}this._lastStartedTask=q.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(q)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(q){const N=await this.getTaskExecution(q);this._taskExecutionPromises.delete(q.id),this._taskExecutions.delete(q.id),this.customExecutionComplete(q),this._onDidTerminateTask.fire({execution:N})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(q){const N=await this.getTaskExecution(q.id);this._onDidTaskProcessStarted.fire({execution:N,processId:q.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(q){const N=await this.getTaskExecution(q.id);this._onDidTaskProcessEnded.fire({execution:N,exitCode:q.exitCode})}$provideTasks(q,N){const H=this._handlers.get(q);if(!H)return Promise.reject(new Error("no handler found"));const T=[],U=R.asPromise(()=>H.provider.provideTasks(s.CancellationToken.None)).then(F=>this.provideTasksInternal(N,T,H,F));return new Promise(F=>{U.then(M=>{Promise.all(T).then(()=>{F(M)})})})}async $resolveTask(q,N){const H=this._handlers.get(q);if(!H)return Promise.reject(new Error("no handler found"));if(N.definition.type!==H.type)throw new Error(`Unexpected: Task of type [${N.definition.type}] cannot be resolved by provider of type [${H.type}].`);const T=await y.to(N,this._workspaceProvider,this._providedCustomExecutions2);if(!T)throw new Error("Unexpected: Task cannot be resolved.");const U=await H.provider.resolveTask(T,s.CancellationToken.None);if(!U)return;this.checkDeprecation(U,H);const F=y.from(U,H.extension);if(!F)throw new Error("Unexpected: Task cannot be resolved.");if(U.definition!==T.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return f.is(F.execution)&&await this.addCustomExecution(F,U,!0),await this.resolveTaskInternal(F)}nextHandle(){return this._handleCounter++}async addCustomExecution(q,N,H){const T=await this._proxy.$createTaskId(q);!H&&!this._providedCustomExecutions2.has(T)&&this._notProvidedCustomExecutions.add(T),this._providedCustomExecutions2.set(T,N.execution)}async getTaskExecution(q,N){if(typeof q=="string"){const U=this._taskExecutionPromises.get(q);if(!U)throw new Error("Unexpected: The specified task is missing an execution");return U}let H=this._taskExecutionPromises.get(q.id);if(H)return H;const T=new Promise(async(U,F)=>{const M=N||await y.to(q.task,this._workspaceProvider,this._providedCustomExecutions2);M?U(new L(this,q.id,M)):F("Unexpected: Task does not exist.")});return this._taskExecutionPromises.set(q.id,T),T.then(U=>(this._taskExecutions.set(q.id,U),U),U=>Promise.reject(U))}checkDeprecation(q,N){q._deprecated&&this._deprecationService.report("Task.constructor",N.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(q){this._activeCustomExecutions2.get(q.id)&&this._activeCustomExecutions2.delete(q.id),this._notProvidedCustomExecutions.has(q.id)&&this._lastStartedTask!==q.id&&(this._providedCustomExecutions2.delete(q.id),this._notProvidedCustomExecutions.delete(q.id));let H=this._notProvidedCustomExecutions.values(),T=H.next();for(;!T.done;)!this._activeCustomExecutions2.has(T.value)&&this._lastStartedTask!==T.value&&(this._providedCustomExecutions2.delete(T.value),this._notProvidedCustomExecutions.delete(T.value)),T=H.next()}};W=Ve([$e(0,l.IExtHostRpcService),$e(1,m.IExtHostInitDataService),$e(2,P.IExtHostWorkspace),$e(3,_.IExtHostDocumentsAndEditors),$e(4,C.IExtHostConfiguration),$e(5,I.IExtHostTerminalService),$e(6,w.ILogService),$e(7,b.IExtHostApiDeprecationService)],W),e.ExtHostTaskBase=W;let J=class extends W{constructor(q,N,H,T,U,F,M,x){super(q,N,H,T,U,F,M,x);this.registerTaskSystem(h.Schemas.vscodeRemote,{scheme:h.Schemas.vscodeRemote,authority:"",platform:S.PlatformToString(0)})}async executeTask(q,N){if(!N.execution)throw new Error("Tasks to execute must include an execution");const H=y.from(N,q);if(H===void 0)throw new Error("Task is not valid");if(f.is(H.execution))await this.addCustomExecution(H,N,!1);else throw new d.NotSupportedError;const T=await this.getTaskExecution(await this._proxy.$getTaskExecution(H),N);return this._proxy.$executeTask(H).catch(U=>{throw new Error(U)}),T}provideTasksInternal(q,N,H,T){const U=[];if(T)for(let F of T){this.checkDeprecation(F,H),(!F.definition||!q[F.definition.type])&&this._logService.warn(`The task [${F.source}, ${F.name}] uses an undefined task type. The task will be ignored in the future.`);const M=y.from(F,H.extension);M&&f.is(M.execution)?(U.push(M),N.push(this.addCustomExecution(M,F,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:U,extension:H.extension}}async resolveTaskInternal(q){if(f.is(q.execution))return q;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(q,N){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(q,N,H){}};J=Ve([$e(0,l.IExtHostRpcService),$e(1,m.IExtHostInitDataService),$e(2,P.IExtHostWorkspace),$e(3,_.IExtHostDocumentsAndEditors),$e(4,C.IExtHostConfiguration),$e(5,I.IExtHostTerminalService),$e(6,w.ILogService),$e(7,b.IExtHostApiDeprecationService)],J),e.WorkerExtHostTask=J,e.IExtHostTask=c.createDecorator("IExtHostTask")});var it=this&&this.__classPrivateFieldSet||function(Q,e,v,R,k){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Q!==e||!k:!e.has(Q))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?k.call(Q,v):k?k.value=v:e.set(Q,v),v},Be=this&&this.__classPrivateFieldGet||function(Q,e,v,R){if(v==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Q!==e||!R:!e.has(Q))throw new TypeError("Cannot read private member from an object whose class did not declare it");return v==="m"?R:v==="a"?R.call(Q):R?R.value:e.get(Q)},Sn=this&&this.__rest||function(Q,e){var v={};for(var R in Q)Object.prototype.hasOwnProperty.call(Q,R)&&e.indexOf(R)<0&&(v[R]=Q[R]);if(Q!=null&&typeof Object.getOwnPropertySymbols=="function")for(var k=0,R=Object.getOwnPropertySymbols(Q);k<R.length;k++)e.indexOf(R[k])<0&&Object.prototype.propertyIsEnumerable.call(Q,R[k])&&(v[R[k]]=Q[R[k]]);return v};define(ge[252],pe([0,1,18,16,22,21,3,68,70,6,25,15,2,32,5,39,13,84,17,7,34,210,122]),function(Q,e,v,R,k,D,A,P,_,C,s,I,l,m,c,h,S,w,b,u,d,p,t){"use strict";var i,r,n,o;Object.defineProperty(e,"__esModule",{value:!0}),e.MirroredTestCollection=e.TestItemFilteredWrapper=e.createDefaultDocumentTestRoot=e.ExtHostTesting=void 0;const g=(H,T)=>`${H}:${T.toString()}`;let f=class{constructor(T,U,F){this.documents=U,this.workspace=F,this.resultsChangedEmitter=new A.Emitter,this.controllers=new Map,this.ownedTests=new p.OwnedTestCollection,this.testControllers=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=T.getProxy(c.MainContext.MainThreadTesting),this.runQueue=new E(this.proxy),this.workspaceObservers=new q(this.proxy),this.textDocumentObservers=new N(this.proxy,U)}registerTestController(T,U){const F=m.generateUuid();this.controllers.set(F,{instance:U,extensionId:T}),this.proxy.$registerTestController(F);const M=[...this.testControllers.keys()];return setTimeout(()=>{var x;for(const $ of M)(x=this.testControllers.get($))===null||x===void 0||x.subscribeFn(F,U)},0),new u.Disposable(()=>{this.controllers.delete(F),this.proxy.$unregisterTestController(F)})}createTextDocumentTestObserver(T){return this.textDocumentObservers.checkout(T.uri)}createWorkspaceTestObserver(T){return this.workspaceObservers.checkout(T.uri)}async runTests(T,U=D.CancellationToken.None){const F=M=>M.map(this.getInternalTestForReference,this).filter(I.isDefined).map(x=>({src:x.src,testId:x.item.extId}));await this.proxy.$runTests({exclude:T.exclude?F(T.exclude).map(M=>M.testId):void 0,tests:F(T.tests),debug:T.debug},U)}createTestRun(T,U,F,M=!0){return this.runQueue.createTestRun(T,U,F,M)}$publishTestResults(T){this.results=Object.freeze(T.map(U=>s.deepFreeze(b.TestResults.to(U))).concat(this.results).sort((U,F)=>F.completedAt-U.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $subscribeToTests(T,U){const F=l.URI.revive(U),M=g(T,F);if(this.testControllers.has(M))return;const x=new D.CancellationTokenSource;let $;if(T===1){let Ce=this.documents.getDocument(F);if(!Ce){const Me=new C.DisposableStore;Ce=await new Promise(je=>{Me.add(R.disposableTimeout(()=>je(void 0),5e3)),Me.add(this.documents.onDidAddDocuments(ze=>{const qe=ze.find(j=>j.document.uri.toString()===F.toString());qe&&je(qe)}))}).finally(()=>Me.dispose())}if(Ce){const Me=await this.workspace.getWorkspaceFolder2(F,!1);$=je=>je.createDocumentTestRoot?je.createDocumentTestRoot(Ce.document,x.token):e.createDefaultDocumentTestRoot(je,Ce.document,Me,x.token)}}else{const Ce=await this.workspace.getWorkspaceFolder2(F,!1);Ce&&($=Me=>Me.createWorkspaceTestRoot(Ce,x.token))}if(!$)return;const X=async(Ce,Me)=>{try{const je=await $(Me);je&&be.addRoot(je,Ce)}catch(je){console.error(je)}},le=new C.DisposableStore,be=le.add(this.ownedTests.createForHierarchy(Ce=>this.proxy.$publishDiff(T,U,Ce)));le.add(C.toDisposable(()=>x.dispose(!0)));const Re=[];for(const[Ce,Me]of this.controllers)Re.push(X(Ce,Me.instance));Promise.all(Re).then(()=>be.pushDiff([3,-1])),this.testControllers.set(M,{store:le,collection:be,subscribeFn:X})}async $expandTest(T,U){const F=v.mapFind(this.testControllers.values(),M=>M.collection.treeId===T.src.tree?M:void 0);await(F==null?void 0:F.collection.expand(T.testId,U<0?Infinity:U)),this.flushCollectionDiffs()}$unsubscribeFromTests(T,U){var F;const M=l.URI.revive(U),x=g(T,M);(F=this.testControllers.get(x))===null||F===void 0||F.store.dispose(),this.testControllers.delete(x)}$acceptDiff(T,U,F){T===1?this.textDocumentObservers.acceptDiff(l.URI.revive(U),F):this.workspaceObservers.acceptDiff(l.URI.revive(U),F)}async $runTestsForProvider(T,U){const F=this.controllers.get(T.tests[0].src.controller);if(!F)return;const M=T.tests.map(({testId:X,src:le})=>this.ownedTests.getTestById(X,le==null?void 0:le.tree)).filter(I.isDefined).map(([X,le])=>le),x=T.excludeExtIds.map(X=>this.ownedTests.getTestById(X)).filter(I.isDefined).filter(([X,le])=>M.some(be=>X.comparePositions(be,le)===1));if(!M.length)return;const $={tests:M.map(X=>O.unwrap(X.actual)),exclude:x.map(([,X])=>O.unwrap(X.actual)),debug:T.debug};await this.runQueue.enqueueRun({dto:y.fromInternal(T),token:U,extensionId:F.extensionId,req:$,doRun:()=>F.instance.runTests($,U)})}$lookupTest(T){const U=this.ownedTests.getTestById(T.testId);if(!U)return Promise.resolve(void 0);const F=U[1],{actual:M,discoverCts:x,expandLevels:$}=F,X=Sn(F,["actual","discoverCts","expandLevels"]);return Promise.resolve(X)}flushCollectionDiffs(){for(const{collection:T}of this.testControllers.values())T.flushDiff()}getInternalTestForReference(T){var U,F;return(F=(U=this.workspaceObservers.getMirroredTestDataByReference(T))!==null&&U!==void 0?U:v.mapFind(this.testControllers.values(),M=>M.collection.getTestByReference(T)))!==null&&F!==void 0?F:this.textDocumentObservers.getMirroredTestDataByReference(T)}};f=Ve([$e(0,S.IExtHostRpcService),$e(1,h.IExtHostDocumentsAndEditors),$e(2,d.IExtHostWorkspace)],f),e.ExtHostTesting=f;class E{constructor(T){this.proxy=T,this.state=new Map}enqueueRun(T){let U=this.state.get(T.extensionId);U||(U={queue:[],current:void 0},this.state.set(T.extensionId,U));const F=new R.DeferredPromise,M=()=>{const x=[],$=new Set;U.current={publicReq:T.req,factory:X=>{const le=new a(X,T.dto,$,this.proxy);return x.push(le),T.token.onCancellationRequested(()=>le.end()),le}},this.invokeRunner(T.extensionId,T.dto.id,T.doRun,x).finally(()=>F.complete())};return U.queue.push(M),U.queue.length===1&&M(),F.p}createTestRun(T,U,F,M){var x,$;const X=this.state.get(T);if((X==null?void 0:X.current.publicReq)===U)return X.current.factory(F);const le=y.fromPublic(U),be=new a(F,le,new Set,this.proxy);return this.proxy.$startedExtensionTestRun({debug:U.debug,exclude:($=(x=U.exclude)===null||x===void 0?void 0:x.map(Re=>Re.id))!==null&&$!==void 0?$:[],id:le.id,tests:U.tests.map(Re=>Re.id),persist:M}),be.onEnd.wait().then(()=>this.proxy.$finishedExtensionTestRun(le.id)),be}invokeRunner(T,U,F,M){try{const x=F();return R.isThenable(x)?x.then(()=>this.handleInvokeResult(T,U,M,void 0)).catch($=>this.handleInvokeResult(T,U,M,$)):this.handleInvokeResult(T,U,M,void 0)}catch(x){return this.handleInvokeResult(T,U,M,x)}}async handleInvokeResult(T,U,F,M){const x=this.state.get(T);!x||(x.queue.shift(),x.queue.length>0?x.queue[0]():this.state.delete(T),await Promise.all(F.map($=>$.onEnd.wait())))}}class y{constructor(T,U,F){this.id=T,this.include=U,this.exclude=F}static fromPublic(T){var U,F;return new y(m.generateUuid(),new Set(T.tests.map(M=>M.id)),new Set((F=(U=T.exclude)===null||U===void 0?void 0:U.map(M=>M.id))!==null&&F!==void 0?F:_.Iterable.empty()))}static fromInternal(T){return new y(T.runId,new Set(T.tests.map(U=>U.testId)),new Set(T.excludeExtIds))}isIncluded(T){for(let U=T;U;U=U.parent){if(this.include.has(U.id))return!0;if(this.exclude.has(U.id))return!1}return!0}}class a{constructor(T,U,F,M){this.name=T,i.set(this,void 0),r.set(this,void 0),n.set(this,m.generateUuid()),o.set(this,void 0),this.onEnd=new R.Barrier,it(this,i,M,"f"),it(this,r,U,"f"),it(this,o,F,"f"),M.$startedTestRunTask(U.id,{id:Be(this,n,"f"),name:T,running:!0})}setState(T,U,F){Be(this,r,"f").isIncluded(T)&&(this.ensureTestIsKnown(T),Be(this,i,"f").$updateTestStateInRun(Be(this,r,"f").id,Be(this,n,"f"),T.id,U,F))}appendMessage(T,U){Be(this,r,"f").isIncluded(T)&&(this.ensureTestIsKnown(T),Be(this,i,"f").$appendTestMessageInRun(Be(this,r,"f").id,Be(this,n,"f"),T.id,b.TestMessage.from(U)))}appendOutput(T){Be(this,i,"f").$appendOutputToRun(Be(this,r,"f").id,Be(this,n,"f"),k.VSBuffer.fromString(T))}end(){Be(this,i,"f").$finishedTestRunTask(Be(this,r,"f").id,Be(this,n,"f")),this.onEnd.open()}ensureTestIsKnown(T){const U=Be(this,o,"f");if(U.has(T.id))return;const F=[];for(;F.unshift(b.TestItem.from(T)),!(U.has(T.id)||(U.add(T.id),!T.parent));)T=T.parent;Be(this,i,"f").$addTestsToRun(Be(this,r,"f").id,F)}}i=new WeakMap,r=new WeakMap,n=new WeakMap,o=new WeakMap;const L=async(H,T,U,F)=>{if(!U)return;const M=await H.createWorkspaceTestRoot(U,F);if(!M)return;F.onCancellationRequested(()=>{O.removeFilter(T)});const x=O.getWrapperForTestItem(M,T);return x.refreshMatch(),x};e.createDefaultDocumentTestRoot=L;class O extends u.TestItemImpl{constructor(T,U,F){super(T.id,T.label,T.uri,void 0);if(this.actual=T,this.filterDocument=U,this.actualParent=F,!(T instanceof u.TestItemImpl))throw new Error(`TestItems provided to the VS Code API must extend \`vscode.TestItem\`, but ${T.id} did not`);this.debuggable=T.debuggable,this.runnable=T.runnable,this.description=T.description,this.error=T.error,this.status=T.status,this.range=T.range,this.resolveHandler=T.resolveHandler;const M=w.getPrivateApiFor(this);w.getPrivateApiFor(T).bus.event($=>{switch($[0]){case 3:this[$[1]]=$[2];break;case 0:const X=O.getWrapperForTestItem($[1],this.filterDocument,this);w.getPrivateApiFor(X).parent=T,X.refreshMatch();break;default:M.bus.fire($)}})}static removeFilter(T){this.wrapperMap.delete(T)}static getWrapperForTestItem(T,U,F){let M=this.wrapperMap.get(U);if(M==null?void 0:M.has(T))return M.get(T);M||(M=new WeakMap,this.wrapperMap.set(U,M));const x=new O(T,U,F);return M.set(T,x),x}static unwrap(T){return T instanceof O?T.actual:T}get hasNodeMatchingFilter(){return this._cachedMatchesFilter===void 0?this.refreshMatch():this._cachedMatchesFilter}refreshMatch(){var T,U;const F=this._cachedMatchesFilter;for(const x of this.actual.children.values()){const $=O.getWrapperForTestItem(x,this.filterDocument,this);$.hasNodeMatchingFilter?this.children.has($.id)||this.addChild($):$.dispose()}const M=this.children.size>0||((T=this.actual.uri)===null||T===void 0?void 0:T.toString())===this.filterDocument.uri.toString();return this._cachedMatchesFilter=M,M!==F&&((U=this.actualParent)===null||U===void 0||U.refreshMatch()),this._cachedMatchesFilter}dispose(){this.actualParent&&w.getPrivateApiFor(this.actualParent).children.delete(this.id),w.getPrivateApiFor(this).bus.fire([1])}}e.TestItemFilteredWrapper=O,O.wrapperMap=new WeakMap;class W extends t.IncrementalChangeCollector{constructor(T){super();this.emitter=T,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}add(T){this.added.add(T)}update(T){Object.assign(T.revived,b.TestItem.toPlain(T.item)),this.added.has(T)||this.updated.add(T)}remove(T){if(this.added.has(T)){this.added.delete(T);return}if(this.updated.delete(T),T.parent&&this.alreadyRemoved.has(T.parent)){this.alreadyRemoved.add(T.item.extId);return}this.removed.add(T)}getChangeEvent(){const{added:T,updated:U,removed:F}=this;return{get added(){return[...T].map(M=>M.revived)},get updated(){return[...U].map(M=>M.revived)},get removed(){return[...F].map(M=>M.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class J extends t.AbstractIncrementalTestCollection{constructor(){super(...arguments);this.changeEmitter=new A.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTestItems(){return this.getAllAsTestItem([...this.roots])}getAllAsTestItem(T){let U=[];for(const F of T){const M=this.items.get(F);M&&U.push(M.revived)}return U}getMirroredTestDataById(T){return this.items.get(T)}getMirroredTestDataByReference(T){return this.items.get(T.id)}createItem(T,U){return Object.assign(Object.assign({},T),{revived:b.TestItem.toPlain(T.item),depth:U?U.depth+1:0,children:new Set})}createChangeCollector(){return new W(this.changeEmitter)}}e.MirroredTestCollection=J;class se{constructor(){this.resources=new Map}checkout(T){var U,F;const M=T.toString(),x=(U=this.resources.get(M))!==null&&U!==void 0?U:this.createObserverData(T);return(F=x.pendingDeletion)===null||F===void 0||F.dispose(),x.observers++,{onDidChangeTest:x.tests.onDidChangeTests,onDidDiscoverInitialTests:new A.Emitter().event,get tests(){return x.tests.rootTestItems},dispose:P.once(()=>{--x.observers||(x.pendingDeletion=this.eventuallyDispose(T))})}}getMirroredTestDataByReference(T){for(const{tests:U}of this.resources.values()){const F=U.getMirroredTestDataByReference(T);if(F)return F}}eventuallyDispose(T){return R.disposableTimeout(()=>this.unlisten(T),10*1e3)}createObserverData(T){const U=new J,F=this.listen(T,x=>U.apply(x)),M={observers:0,tests:U,listener:F};return this.resources.set(T.toString(),M),M}unlisten(T){var U;const F=T.toString(),M=this.resources.get(F);M&&(M.observers=-1,(U=M.pendingDeletion)===null||U===void 0||U.dispose(),M.listener.dispose(),this.resources.delete(F))}}class q extends se{constructor(T){super();this.proxy=T,this.diffListeners=new Map}acceptDiff(T,U){var F;(F=this.diffListeners.get(T.toString()))===null||F===void 0||F(U)}listen(T,U){this.proxy.$subscribeToDiffs(0,T);const F=T.toString();return this.diffListeners.set(F,U),new u.Disposable(()=>{this.proxy.$unsubscribeFromDiffs(0,T),this.diffListeners.delete(F)})}}class N extends se{constructor(T,U){super();this.proxy=T,this.documents=U,this.diffListeners=new Map}acceptDiff(T,U){var F;(F=this.diffListeners.get(T.toString()))===null||F===void 0||F(U)}listen(T,U){if(!this.documents.getDocument(T))return new u.Disposable(()=>{});const M=T.toString();return this.diffListeners.set(M,U),this.proxy.$subscribeToDiffs(1,T),new u.Disposable(()=>{this.proxy.$unsubscribeFromDiffs(1,T),this.diffListeners.delete(M)})}}}),define(ge[253],pe([0,1,18,67,30,75,23,10,9,24,8,15,2,140,168,81,45,203,251,31]),function(Q,e,v,R,k,D,A,P,_,C,s,I,l,m,c,h,S,w,b,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let d=class{constructor(E,y,a,L){this.configurationService=E,this.workspaceContextService=y,this.editorGroupsService=a,this.pathService=L}text(E,y,a={}){E=this.getContentPattern(E,a);const L=this.configurationService.getValue(),O=y&&y.some(J=>!this.configurationService.getValue({resource:J}).search.useRipgrep),W=this.commonQuery(y==null?void 0:y.map(S.toWorkspaceFolder),a);return Object.assign(Object.assign({},W),{type:2,contentPattern:E,previewOptions:a.previewOptions,maxFileSize:a.maxFileSize,usePCRE2:L.search.usePCRE2||O||!1,beforeContext:a.beforeContext,afterContext:a.afterContext,userDisabledExcludesAndIgnoreFiles:a.disregardExcludeSettings&&a.disregardIgnoreFiles})}getContentPattern(E,y){const a=this.configurationService.getValue();E.isRegExp&&(E.pattern=E.pattern.replace(/\r?\n/g,"\\n"));const L=Object.assign(Object.assign({},E),{wordSeparators:a.editor.wordSeparators});return this.isCaseSensitive(E,y)&&(L.isCaseSensitive=!0),this.isMultiline(E)&&(L.isMultiline=!0),L}file(E,y={}){const a=this.commonQuery(E,y);return Object.assign(Object.assign({},a),{type:1,filePattern:y.filePattern?y.filePattern.trim():y.filePattern,exists:y.exists,sortByScore:y.sortByScore,cacheKey:y.cacheKey})}handleIncludeExclude(E,y){return E?(E=Array.isArray(E)?E.map(n):n(E),y?this.parseSearchPaths(E):{pattern:t(...Array.isArray(E)?E:[E])}):{}}commonQuery(E=[],y={}){const a=this.handleIncludeExclude(y.includePattern,y.expandPatterns),L=this.handleIncludeExclude(y.excludePattern,y.expandPatterns),O=E.length>1,W=(a.searchPaths&&a.searchPaths.length?a.searchPaths.map(q=>this.getFolderQueryForSearchPath(q,y,L)):E.map(q=>this.getFolderQueryForRoot(q,y,L,O))).filter(q=>!!q),J={_reason:y._reason,folderQueries:W,usingSearchPaths:!!(a.searchPaths&&a.searchPaths.length),extraFileResources:y.extraFileResources,excludePattern:L.pattern,includePattern:a.pattern,onlyOpenEditors:y.onlyOpenEditors,maxResults:y.maxResults};if(y.onlyOpenEditors){const N=v.coalesce(v.flatten(this.editorGroupsService.groups.map(T=>T.editors.map(U=>U.resource)))).filter(T=>u.pathIncludedInQuery(J,T.fsPath)),H=this.commonQueryFromFileList(N);return Object.assign(Object.assign({},J),H)}const se=y.extraFileResources&&y.extraFileResources.filter(q=>u.pathIncludedInQuery(J,q.fsPath));return J.extraFileResources=se&&se.length?se:void 0,J}commonQueryFromFileList(E){const y=[],a=new A.ResourceMap,L={};let O=!1;return E.forEach(W=>{var J,se;if(W.scheme===P.Schemas.walkThrough)return;if(C.isAbsolutePath(W)){const N=(se=(J=this.workspaceContextService.getWorkspaceFolder(W))===null||J===void 0?void 0:J.uri)!==null&&se!==void 0?se:W.with({path:_.dirname(W.fsPath)});let H=a.get(N);H||(O=!0,H={folder:N,includePattern:{}},y.push(H),a.set(N,H));const T=_.relative(N.fsPath,W.fsPath);I.assertIsDefined(H.includePattern)[T.replace(/\\/g,"/")]=!0}else W.fsPath&&(O=!0,L[W.fsPath]=!0)}),{folderQueries:y,includePattern:L,usingSearchPaths:!0,excludePattern:O?void 0:{"**/*":!0}}}isCaseSensitive(E,y){if(y.isSmartCase){if(E.isRegExp){if(s.containsUppercaseCharacter(E.pattern,!0))return!0}else if(s.containsUppercaseCharacter(E.pattern))return!0}return!!E.isCaseSensitive}isMultiline(E){return E.isMultiline||E.isRegExp&&m.isMultilineRegexSource(E.pattern)||E.pattern.indexOf(`
`)>=0?!0:!!E.isMultiline}parseSearchPaths(E){const y=H=>_.isAbsolute(H)||/^\.\.?([\/\\]|$)/.test(H),L=(Array.isArray(E)?E:i(E)).map(H=>{const T=this.pathService.resolvedUserHome;return T?D.untildify(H,T.scheme===P.Schemas.file?T.fsPath:T.path):H}),O=R.groupBy(L,H=>y(H)?"searchPaths":"exprSegments"),W=(O.exprSegments||[]).map(H=>s.rtrim(H,"/")).map(H=>s.rtrim(H,"\\")).map(H=>(H[0]==="."&&(H="*"+H),r(H))),J={},se=this.expandSearchPathPatterns(O.searchPaths||[]);se&&se.length&&(J.searchPaths=se);const q=v.flatten(W),N=t(...q);return N&&(J.pattern=N),J}getExcludesForFolder(E,y){return y.disregardExcludeSettings?void 0:u.getExcludes(E,!y.disregardSearchExcludeSettings)}expandSearchPathPatterns(E){if(!E||!E.length)return[];const y=v.flatten(E.map(L=>{let{pathPortion:O,globPortion:W}=p(L);W&&(W=o(W));const J=this.expandOneSearchPath(O);return v.flatten(J.map(se=>this.resolveOneSearchPathPattern(se,W)))})),a=new Map;return y.forEach(L=>{const O=L.searchPath.toString(),W=a.get(O);W?L.pattern&&(W.pattern=W.pattern||{},W.pattern[L.pattern]=!0):a.set(O,{searchPath:L.searchPath,pattern:L.pattern?t(L.pattern):void 0})}),Array.from(a.values())}expandOneSearchPath(E){if(_.isAbsolute(E)){const y=this.workspaceContextService.getWorkspace().folders;return y[0]&&y[0].uri.scheme!==P.Schemas.file?[{searchPath:y[0].uri.with({path:E})}]:[{searchPath:l.URI.file(_.normalize(E))}]}if(this.workspaceContextService.getWorkbenchState()===2){const y=this.workspaceContextService.getWorkspace().folders[0].uri;if(E=n(E),E.startsWith("../")||E===".."){const L=_.posix.resolve(y.path,E);return[{searchPath:y.with({path:L})}]}const a=o(E);return[{searchPath:y,pattern:a}]}else{if(E==="./"||E===".\\")return[];{const y=E.replace(/^\.[\/\\]/,""),L=this.workspaceContextService.getWorkspace().folders.map(O=>{const W=y.match(new RegExp(`^${O.name}(?:/(.*))?`));return W?{match:W,folder:O}:null}).filter(I.isDefined);if(L.length)return L.map(O=>{const W=O.match[1];return{searchPath:O.folder.uri,pattern:W&&o(W)}});{const O=E.match(/\.[\/\\](.+)[\/\\]?/),W=O?O[1]:E,J=c.localize(0,null,W);throw new Error(J)}}}}resolveOneSearchPathPattern(E,y){const a=E.pattern&&y?`${E.pattern}/${y}`:E.pattern||y,L=[{searchPath:E.searchPath,pattern:a}];return a&&!a.endsWith("**")&&L.push({searchPath:E.searchPath,pattern:a+"/**"}),L}getFolderQueryForSearchPath(E,y,a){const L=this.getFolderQueryForRoot(S.toWorkspaceFolder(E.searchPath),y,a,!1);return L?Object.assign(Object.assign({},L),{includePattern:E.pattern}):null}getFolderQueryForRoot(E,y,a,L){let O;const W=l.URI.isUri(E)?E:E.uri;if(a.searchPaths){const H=a.searchPaths.filter(T=>C.isEqual(T.searchPath,W))[0];if(H&&!H.pattern)return null;H&&(O=H.pattern)}const J=this.configurationService.getValue({resource:W}),se=this.getExcludesForFolder(J,y),q=Object.assign(Object.assign({},se||{}),O||{}),N=l.URI.isUri(E)?C.basename(E):E.name;return{folder:W,folderName:L?N:void 0,excludePattern:Object.keys(q).length>0?q:void 0,fileEncoding:J.files&&J.files.encoding,disregardIgnoreFiles:typeof y.disregardIgnoreFiles=="boolean"?y.disregardIgnoreFiles:!J.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof y.disregardGlobalIgnoreFiles=="boolean"?y.disregardGlobalIgnoreFiles:!J.search.useGlobalIgnoreFiles,ignoreSymlinks:typeof y.ignoreSymlinks=="boolean"?y.ignoreSymlinks:!J.search.followSymlinks}}};d=Ve([$e(0,h.IConfigurationService),$e(1,S.IWorkspaceContextService),$e(2,w.IEditorGroupsService),$e(3,b.IPathService)],d),e.QueryBuilder=d;function p(f){const E=f.match(/[\*\{\}\(\)\[\]\?]/);if(E){const y=E.index,a=f.substr(0,y).match(/[/|\\][^/\\]*$/);if(a){let L=f.substr(0,a.index);return L.match(/[/\\]/)||(L+="/"),{pathPortion:L,globPortion:f.substr((a.index||0)+1)}}}return{pathPortion:f}}function t(...f){return f.length?f.reduce((E,y)=>(E[y]=!0,E),Object.create(null)):void 0}function i(f){return k.splitGlobAware(f,",").map(E=>E.trim()).filter(E=>!!E.length)}function r(f){return[`**/${f}/**`,`**/${f}`].map(y=>y.replace(/\*\*\/\*\*/g,"**"))}function n(f){return f.replace(/\\/g,"/")}function o(f){return n(f).replace(/^\.\//,"").replace(/\/+$/g,"")}function g(f,E){f=v.distinct(f,L=>L.toString());const y=[],a=E.getWorkspace();return f&&f.forEach(L=>{let O;if(E.getWorkbenchState()===2)O=C.relativePath(a.folders[0].uri,L),O&&O!=="."&&(O="./"+O);else{const W=E.getWorkspaceFolder(L);if(W){const J=W.name;if(a.folders.filter(q=>q.name===J).length===1){const q=C.relativePath(W.uri,L);q===""?O=`./${W.name}`:O=`./${W.name}/${q}`}else O=L.fsPath}}O&&y.push(O)}),y}e.resolveResourcesForSearchIncludes=g}),define(ge[254],pe([0,1,24,2,21,14,4,253,31,45]),function(Q,e,v,R,k,D,A,P,_,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const s=7e3;function I(h,S){const w=S.activationEvents;if(!w)return Promise.resolve(void 0);const b=[],u=[];for(const n of w)if(/^workspaceContains:/.test(n)){const o=n.substr("workspaceContains:".length);o.indexOf("*")>=0||o.indexOf("?")>=0||h.forceUsingSearch?u.push(o):b.push(o)}if(b.length===0&&u.length===0)return Promise.resolve(void 0);let d;const p=new Promise((n,o)=>{d=n}),t=n=>d({activationEvent:n}),i=Promise.all(b.map(n=>l(h,n,t))).then(()=>{}),r=m(h,S.identifier,u,t);return Promise.all([i,r]).then(()=>{d(void 0)}),p}e.checkActivateWorkspaceContainsExtension=I;async function l(h,S,w){for(const b of h.folders)if(await h.exists(v.joinPath(R.URI.revive(b),S))){w(`workspaceContains:${S}`);return}}async function m(h,S,w,b){if(w.length===0)return Promise.resolve(void 0);const u=new k.CancellationTokenSource,d=h.checkExists(h.folders,w,u.token),p=setTimeout(async()=>{u.cancel(),b(`workspaceContainsTimeout:${w.join(",")}`)},s);let t=!1;try{t=await d}catch(i){D.isPromiseCanceledError(i)||D.onUnexpectedError(i)}u.dispose(),clearTimeout(p),t&&b(`workspaceContains:${w.join(",")}`)}function c(h,S,w,b){const u=h.get(A.IInstantiationService),d=h.get(_.ISearchService),t=u.createInstance(P.QueryBuilder).file(S.map(i=>C.toWorkspaceFolder(R.URI.revive(i))),{_reason:"checkExists",includePattern:w,exists:!0});return d.fileSearch(t,b).then(i=>!!i.limitHit,i=>D.isPromiseCanceledError(i)?!1:Promise.reject(i))}e.checkGlobFileExists=c});var it=this&&this.__classPrivateFieldSet||function(Q,e,v,R,k){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Q!==e||!k:!e.has(Q))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?k.call(Q,v):k?k.value=v:e.set(Q,v),v},Be=this&&this.__classPrivateFieldGet||function(Q,e,v,R){if(v==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Q!==e||!R:!e.has(Q))throw new TypeError("Cannot read private member from an object whose class did not declare it");return v==="m"?R:v==="a"?R.call(Q):R?R.value:e.get(Q)};define(ge[40],pe([0,1,159,9,65,24,16,6,23,2,12,5,36,214,89,34,35,212,14,26,22,190,7,117,4,27,90,13,79,47,33,3,254,87,192]),function(Q,e,v,R,k,D,A,P,_,C,s,I,l,m,c,h,S,w,b,u,d,p,t,i,r,n,o,g,f,E,y,a,L,O,W){"use strict";var J,se,q;Object.defineProperty(e,"__esModule",{value:!0}),e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=r.createDecorator("IHostUtils");let N=class Wn extends P.Disposable{constructor(F,M,x,$,X,le,be,Re,Ce,Me){super();this._onDidChangeRemoteConnectionData=this._register(new a.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._hostUtils=M,this._extHostContext=x,this._initData=be,this._extHostWorkspace=$,this._extHostConfiguration=X,this._logService=le,this._extHostTunnelService=Ce,this._extHostTerminalService=Me,this._disposables=new P.DisposableStore,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(I.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(I.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(I.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new A.Barrier,this._readyToStartExtensionHost=new A.Barrier,this._readyToRunExtensions=new A.Barrier,this._eagerExtensionsActivated=new A.Barrier,this._registry=new w.ExtensionDescriptionRegistry(this._initData.extensions),this._storage=new c.ExtHostStorage(this._extHostContext),this._secretState=new O.ExtHostSecretState(this._extHostContext),this._storagePath=Re,this._instaService=F.createChild(new f.ServiceCollection([c.IExtHostStorage,this._storage],[O.IExtHostSecretState,this._secretState]));const je=new Set;this._initData.hostExtensions.forEach(ze=>je.add(u.ExtensionIdentifier.toKey(ze))),this._activator=new m.ExtensionsActivator(this._registry,this._initData.resolvedExtensions,this._initData.hostExtensions,{onExtensionActivationError:(ze,qe,j)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(ze,b.transformErrorForSerialization(qe),j)},actualActivateExtension:async(ze,qe)=>{if(je.has(u.ExtensionIdentifier.toKey(ze)))return await this._mainThreadExtensionsProxy.$activateExtension(ze,qe),new m.HostExtension;const j=this._registry.getExtensionDescription(ze);return this._activateExtension(j,qe)}},this._logService),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),k.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(F){b.onUnexpectedError(F)}}async deactivateAll(){let F=[];try{F=this._registry.getAllExtensionDescriptions().map(X=>X.identifier).filter(X=>this.isActivated(X)).map(X=>this._deactivate(X))}catch(M){}await Promise.all(F)}isActivated(F){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(F):!1}_activateByEvent(F,M){return this._activator.activateByEvent(F,M)}_activateById(F,M){return this._activator.activateById(F,M)}activateByIdWithErrors(F,M){return this._activateById(F,M).then(()=>{const x=this._activator.getActivatedExtension(F);if(x.activationFailed)return Promise.reject(x.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(F=>this._registry)}getExtensionExports(F){return this._readyToRunExtensions.isOpen()?this._activator.getActivatedExtension(F).exports:null}getExtensionPathIndex(){if(!this._extensionPathIndex){const F=_.TernarySearchTree.forPaths(),M=this._registry.getAllExtensionDescriptions().map(x=>{if(!!this._getEntryPoint(x))return this._hostUtils.realpath(x.extensionLocation.fsPath).then($=>F.set(C.URI.file($).fsPath,x))});this._extensionPathIndex=Promise.all(M).then(()=>F)}return this._extensionPathIndex}_deactivate(F){let M=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(F))return M;const x=this._activator.getActivatedExtension(F);if(!x)return M;try{typeof x.module.deactivate=="function"&&(M=Promise.resolve(x.module.deactivate()).then(void 0,$=>(this._logService.error($),Promise.resolve(void 0))))}catch($){this._logService.error($)}try{P.dispose(x.subscriptions)}catch($){this._logService.error($)}return M}async _activateExtension(F,M){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(F.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(F.identifier),this._doActivateExtension(F,M).then(x=>{const $=x.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(F.identifier,$.codeLoadingTime,$.activateCallTime,$.activateResolvedTime,M),this._logExtensionActivationTimes(F,M,"success",$),x},x=>{throw this._logExtensionActivationTimes(F,M,"failure"),x})}_logExtensionActivationTimes(F,M,x,$){const X=H(F,M);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",Object.assign(Object.assign(Object.assign({},X),$||{}),{outcome:x}))}_doActivateExtension(F,M){const x=H(F,M);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",x);const $=this._getEntryPoint(F);if(!$)return Promise.resolve(new m.EmptyExtension(m.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${F.identifier.value} ${JSON.stringify(M)}`),this._logService.flush();const X=new m.ExtensionActivationTimesBuilder(M.startup);return Promise.all([this._loadCommonJSModule(F.identifier,D.joinPath(F.extensionLocation,$),X),this._loadExtensionContext(F)]).then(le=>(k.mark(`code/extHost/willActivateExtension/${F.identifier.value}`),Wn._callActivate(this._logService,F.identifier,le[0],le[1],X))).then(le=>(k.mark(`code/extHost/didActivateExtension/${F.identifier.value}`),le))}_loadExtensionContext(F){const M=new p.ExtensionGlobalMemento(F,this._storage),x=new p.ExtensionMemento(F.identifier.value,!1,this._storage),$=new W.ExtensionSecrets(F,this._secretState),X=F.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?t.ExtensionMode.Test:t.ExtensionMode.Development:t.ExtensionMode.Production,le=this._initData.remote.isRemote?t.ExtensionKind.Workspace:t.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${F.identifier.value}`),Promise.all([M.whenReady,x.whenReady,this._storagePath.whenReady]).then(()=>{const be=this;let Re;return Object.freeze({globalState:M,workspaceState:x,secrets:$,subscriptions:[],get extensionUri(){return F.extensionLocation},get extensionPath(){return F.extensionLocation.fsPath},asAbsolutePath(Ce){return R.join(F.extensionLocation.fsPath,Ce)},get storagePath(){var Ce;return(Ce=be._storagePath.workspaceValue(F))===null||Ce===void 0?void 0:Ce.fsPath},get globalStoragePath(){return be._storagePath.globalValue(F).fsPath},get logPath(){return R.join(be._initData.logsLocation.fsPath,F.identifier.value)},get logUri(){return C.URI.joinPath(be._initData.logsLocation,F.identifier.value)},get storageUri(){return be._storagePath.workspaceValue(F)},get globalStorageUri(){return be._storagePath.globalValue(F)},get extensionMode(){return X},get extension(){return Re===void 0&&(Re=new T(be,F.identifier,F,le)),Re},get extensionRuntime(){return S.checkProposedApiEnabled(F),be.extensionRuntime},get environmentVariableCollection(){return be._extHostTerminalService.getEnvironmentVariableCollection(F)}})})}static _callActivate(F,M,x,$,X){return x=x||{activate:void 0,deactivate:void 0},this._callActivateOptional(F,M,x,$,X).then(le=>new m.ActivatedExtension(!1,null,X.build(),x,le,$.subscriptions))}static _callActivateOptional(F,M,x,$,X){if(typeof x.activate=="function")try{X.activateCallStart(),F.trace(`ExtensionService#_callActivateOptional ${M.value}`);const le=typeof global=="object"?global:self,be=x.activate.apply(le,[$]);return X.activateCallStop(),X.activateResolveStart(),Promise.resolve(be).then(Re=>(X.activateResolveStop(),Re))}catch(le){return Promise.reject(le)}else return Promise.resolve(x)}_activateOneStartupFinished(F,M){this._activateById(F.identifier,{startup:!1,extensionId:F.identifier,activationEvent:M}).then(void 0,x=>{this._logService.error(x)})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(k.getMarks());for(const F of this._registry.getAllExtensionDescriptions())if(F.activationEvents)for(const M of F.activationEvents)M==="onStartupFinished"&&this._activateOneStartupFinished(F,M)}_handleEagerExtensions(){const F=this._activateByEvent("*",!0).then(void 0,X=>{this._logService.error(X)});this._disposables.add(this._extHostWorkspace.onDidChangeWorkspace(X=>this._handleWorkspaceContainsEagerExtensions(X.added)));const M=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],x=this._handleWorkspaceContainsEagerExtensions(M),$=Promise.all([F,x]).then(()=>{});return Promise.race([$,A.timeout(1e4)]).then(()=>{this._activateAllStartupFinished()}),$}_handleWorkspaceContainsEagerExtensions(F){return F.length===0?Promise.resolve(void 0):Promise.all(this._registry.getAllExtensionDescriptions().map(M=>this._handleWorkspaceContainsEagerExtension(F,M))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(F,M){if(this.isActivated(M.identifier))return;const x=!this._initData.remote.isRemote&&!!this._initData.remote.authority,$={folders:F.map(le=>le.uri),forceUsingSearch:x,exists:le=>this._hostUtils.exists(le.fsPath),checkExists:(le,be,Re)=>this._mainThreadWorkspaceProxy.$checkExists(le,be,Re)},X=await L.checkActivateWorkspaceContainsExtension($,M);if(!!X)return this._activateById(M.identifier,{startup:!0,extensionId:M.identifier,activationEvent:X.activationEvent}).then(void 0,le=>this._logService.error(le))}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return await this._doHandleExtensionTests()}catch(F){throw console.error(F),F}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:F,extensionTestsLocationURI:M}=this._initData.environment;if(!F||!M)throw new Error(v.localize(0,null));const x=await this._loadCommonJSModule(null,M,new m.ExtensionActivationTimesBuilder(!1));if(!x||typeof x.run!="function")throw new Error(v.localize(1,null,M.toString()));return new Promise(($,X)=>{const le=(Ce,Me)=>{Ce?X(Ce):$(typeof Me=="number"&&Me>0?1:0)},be=D.originalFSPath(M),Re=x.run(be,le);Re&&Re.then&&Re.then(()=>{$(0)}).catch(Ce=>{X(Ce.toString())})})}async $extensionTestsExit(F){this._logService.info(`extension host terminating: test runner requested exit with code ${F}`),this._logService.info(`exiting with code ${F}`),this._logService.flush(),this._hostUtils.exit(F)}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("eager extensions activated")})}registerRemoteAuthorityResolver(F,M){return this._resolvers[F]=M,P.toDisposable(()=>{delete this._resolvers[F]})}async _activateAndGetResolver(F){const M=F.indexOf("+");if(M===-1)throw new Error("Not an authority that can be resolved!");const x=F.substr(0,M);return await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${x}`,!1),{authorityPrefix:x,resolver:this._resolvers[x]}}async $resolveAuthority(F,M){const{authorityPrefix:x,resolver:$}=await this._activateAndGetResolver(F);if(!$)return{type:"error",error:{code:i.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${x}.`,detail:void 0}};try{this._disposables.add(await this._extHostTunnelService.setTunnelExtensionFunctions($)),k.mark(`code/extHost/willResolveAuthority/${x}`);const X=await $.resolve(F,{resolveAttempt:M});k.mark(`code/extHost/didResolveAuthorityOK/${x}`);const le={authority:F,host:X.host,port:X.port,connectionToken:X.connectionToken},be={extensionHostEnv:X.extensionHostEnv,isTrusted:X.isTrusted};return{type:"ok",value:{authority:le,options:be,tunnelInformation:{environmentTunnels:X.environmentTunnels}}}}catch(X){if(k.mark(`code/extHost/didResolveAuthorityError/${x}`),X instanceof t.RemoteAuthorityResolverError)return{type:"error",error:{code:X._code,message:X._message,detail:X._detail}};throw X}}async $getCanonicalURI(F,M){const{authorityPrefix:x,resolver:$}=await this._activateAndGetResolver(F);if(!$)throw new Error(`Cannot get canonical URI because no remote extension is installed to resolve ${x}`);const X=C.URI.revive(M);if(typeof $.getCanonicalURI=="undefined")return X;const le=await A.asPromise(()=>$.getCanonicalURI(X));return le||X}$startExtensionHost(F){return this._registry.keepOnly(F),this._startExtensionHost()}$activateByEvent(F,M){return M===1?this._activateByEvent(F,!1):this._readyToRunExtensions.wait().then(x=>this._activateByEvent(F,!1))}async $activate(F,M){return await this._readyToRunExtensions.wait(),this._registry.getExtensionDescription(F)?(await this._activateById(F,M),!0):!1}async $deltaExtensions(F,M){F.forEach($=>$.extensionLocation=C.URI.revive($.extensionLocation));const x=await this.getExtensionPathIndex();return await Promise.all(M.map(async $=>{const X=this._registry.getExtensionDescription($);if(!X)return;const le=await this._hostUtils.realpath(X.extensionLocation.fsPath);x.delete(C.URI.file(le).fsPath)})),await Promise.all(F.map(async $=>{const X=await this._hostUtils.realpath($.extensionLocation.fsPath);x.set(C.URI.file(X).fsPath,$)})),this._registry.deltaExtensions(F,M),Promise.resolve(void 0)}async $test_latency(F){return F}async $test_up(F){return F.byteLength}async $test_down(F){let M=d.VSBuffer.alloc(F),x=Math.random()%256;for(let $=0;$<F;$++)M.writeUInt8(x,$);return M}async $updateRemoteConnectionData(F){this._remoteConnectionData=F,this._onDidChangeRemoteConnectionData.fire()}};N=Ve([$e(0,r.IInstantiationService),$e(1,e.IHostUtils),$e(2,g.IExtHostRpcService),$e(3,h.IExtHostWorkspace),$e(4,l.IExtHostConfiguration),$e(5,s.ILogService),$e(6,n.IExtHostInitDataService),$e(7,o.IExtensionStoragePaths),$e(8,E.IExtHostTunnelService),$e(9,y.IExtHostTerminalService)],N),e.AbstractExtHostExtensionService=N;function H(U,F){return{id:U.identifier.value,name:U.name,extensionVersion:U.version,publisherDisplayName:U.publisher,activationEvents:U.activationEvents?U.activationEvents.join(","):null,isBuiltin:U.isBuiltin,reason:F.activationEvent,reasonId:F.extensionId.value}}e.IExtHostExtensionService=r.createDecorator("IExtHostExtensionService");class T{constructor(F,M,x,$){J.set(this,void 0),se.set(this,void 0),q.set(this,void 0),it(this,J,F,"f"),it(this,se,M,"f"),it(this,q,x.identifier,"f"),this.id=x.identifier.value,this.extensionUri=x.extensionLocation,this.extensionPath=R.normalize(D.originalFSPath(x.extensionLocation)),this.packageJSON=x,this.extensionKind=$}get isActive(){return Be(this,J,"f").isActivated(Be(this,q,"f"))}get exports(){if(this.packageJSON.api!=="none")return Be(this,J,"f").getExtensionExports(Be(this,q,"f"))}activate(){return Be(this,J,"f").activateByIdWithErrors(Be(this,q,"f"),{startup:!1,extensionId:Be(this,se,"f"),activationEvent:"api"}).then(()=>this.exports)}}e.Extension=T,J=new WeakMap,se=new WeakMap,q=new WeakMap}),define(ge[49],pe([0,1,9,2,3,16,5,7,120,34,40,39,202,36,197,13,4,15,37,46]),function(Q,e,v,R,k,D,A,P,_,C,s,I,l,m,c,h,S,w,b,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostVariableResolverService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=S.createDecorator("IExtHostDebugService");let d=class{constructor(f,E,y,a,L,O){this._workspaceService=E,this._extensionService=y,this._editorsService=a,this._configurationService=L,this._editorTabs=O,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new k.Emitter,this._onDidTerminateDebugSession=new k.Emitter,this._onDidChangeActiveDebugSession=new k.Emitter,this._onDidReceiveDebugSessionCustomEvent=new k.Emitter,this._debugServiceProxy=f.getProxy(A.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new k.Emitter({onFirstListenerAdd:()=>{this.startBreakpoints()}}),this._activeDebugConsole=new t(this._debugServiceProxy),this._breakpoints=new Map,this._breakpointEventsActive=!1,this._extensionService.getExtensionRegistry().then(W=>{W.onDidChange(J=>{this.registerAllDebugTypes(W)}),this.registerAllDebugTypes(W)})}get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}asDebugSourceUri(f,E){const y=f;if(typeof y.sourceReference=="number"&&y.sourceReference>0){let a=`debug:${encodeURIComponent(y.path||"")}`,L="?";return E&&(a+=`${L}session=${encodeURIComponent(E.id)}`,L="&"),a+=`${L}ref=${y.sourceReference}`,R.URI.parse(a)}else{if(y.path)return R.URI.file(y.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(f){const E=[];for(const y of f.getAllExtensionDescriptions())if(y.contributes){const a=y.contributes.debuggers;if(a&&a.length>0)for(const L of a)c.isDebuggerMainContribution(L)&&E.push(L.type)}this._debugServiceProxy.$registerDebugTypes(E)}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){this.startBreakpoints();const f=[];return this._breakpoints.forEach(E=>f.push(E)),f}addBreakpoints(f){this.startBreakpoints();const E=f.filter(L=>{const O=L.id;return this._breakpoints.has(O)?!1:(this._breakpoints.set(O,L),!0)});this.fireBreakpointChanges(E,[],[]);const y=[],a=new Map;for(const L of E)if(L instanceof P.SourceBreakpoint){let O=a.get(L.location.uri.toString());O||(O={type:"sourceMulti",uri:L.location.uri,lines:[]},a.set(L.location.uri.toString(),O),y.push(O)),O.lines.push({id:L.id,enabled:L.enabled,condition:L.condition,hitCondition:L.hitCondition,logMessage:L.logMessage,line:L.location.range.start.line,character:L.location.range.start.character})}else L instanceof P.FunctionBreakpoint&&y.push({type:"function",id:L.id,enabled:L.enabled,hitCondition:L.hitCondition,logMessage:L.logMessage,condition:L.condition,functionName:L.functionName});return this._debugServiceProxy.$registerBreakpoints(y)}removeBreakpoints(f){this.startBreakpoints();const E=f.filter(O=>this._breakpoints.delete(O.id));this.fireBreakpointChanges([],E,[]);const y=E.filter(O=>O instanceof P.SourceBreakpoint).map(O=>O.id),a=E.filter(O=>O instanceof P.FunctionBreakpoint).map(O=>O.id),L=E.filter(O=>O instanceof P.DataBreakpoint).map(O=>O.id);return this._debugServiceProxy.$unregisterBreakpoints(y,a,L)}startDebugging(f,E,y){return this._debugServiceProxy.$startDebugging(f?f.uri:void 0,E,{parentSessionID:y.parentSession?y.parentSession.id:void 0,repl:y.consoleMode===P.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:y.noDebug,compact:y.compact})}stopDebugging(f){return this._debugServiceProxy.$stopDebugging(f?f.id:void 0)}registerDebugConfigurationProvider(f,E,y){if(!E)return new P.Disposable(()=>{});const a=this._configProviderHandleCounter++;return this._configProviders.push({type:f,handle:a,provider:E}),this._debugServiceProxy.$registerDebugConfigurationProvider(f,y,!!E.provideDebugConfigurations,!!E.resolveDebugConfiguration,!!E.resolveDebugConfigurationWithSubstitutedVariables,a),new P.Disposable(()=>{this._configProviders=this._configProviders.filter(L=>L.provider!==E),this._debugServiceProxy.$unregisterDebugConfigurationProvider(a)})}registerDebugAdapterDescriptorFactory(f,E,y){if(!y)return new P.Disposable(()=>{});if(!this.definesDebugType(f,E))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${E}' debugger.`);if(this.getAdapterDescriptorFactoryByType(E))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const a=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:E,handle:a,factory:y}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(E,a),new P.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(L=>L.factory!==y),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(a)})}registerDebugAdapterTrackerFactory(f,E){if(!E)return new P.Disposable(()=>{});const y=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:f,handle:y,factory:E}),new P.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(a=>a.factory!==E)})}async $runInTerminal(f,E){return Promise.resolve(void 0)}async $substituteVariables(f,E){if(!this._variableResolver){const[L,O]=await Promise.all([this._workspaceService.getWorkspaceFolders2(),this._configurationService.getConfigProvider()]);this._variableResolver=this.createVariableResolver(L||[],this._editorsService,O)}let y;const a=await this.getFolder(f);return a&&(y={uri:a.uri,name:a.name,index:a.index,toResource:()=>{throw new Error("Not implemented")}}),this._variableResolver.resolveAnyAsync(y,E)}createDebugAdapter(f,E){if(f.type==="implementation")return new n(f.implementation)}createSignService(){}async $startDASession(f,E){const y=this,a=await this.getSession(E);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(a.type),a).then(L=>{if(!L)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${a.type}' (extension might have failed to activate)`);const O=this.convertToDto(L),W=this.createDebugAdapter(O,a);if(!W)throw new Error(`Couldn't create a debug adapter for type '${a.type}'.`);const J=W;return this._debugAdapters.set(f,J),this.getDebugAdapterTrackers(a).then(se=>(se&&this._debugAdaptersTrackers.set(f,se),J.onMessage(async q=>{if(q.type==="request"&&q.command==="handshake"){const N=q,H={type:"response",seq:0,command:N.command,request_seq:N.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const T=await this._signService.sign(N.arguments.value);H.body={signature:T},J.sendResponse(H)}else throw new Error("no signer")}catch(T){H.success=!1,H.message=T.message,J.sendResponse(H)}}else se&&se.onDidSendMessage&&se.onDidSendMessage(q),q=c.convertToVSCPaths(q,!0),y._debugServiceProxy.$acceptDAMessage(f,q)}),J.onError(q=>{se&&se.onError&&se.onError(q),this._debugServiceProxy.$acceptDAError(f,q.name,q.message,q.stack)}),J.onExit(q=>{se&&se.onExit&&se.onExit(w.withNullAsUndefined(q),void 0),this._debugServiceProxy.$acceptDAExit(f,w.withNullAsUndefined(q),void 0)}),se&&se.onWillStartSession&&se.onWillStartSession(),J.startSession()))})}$sendDAMessage(f,E){E=c.convertToDAPaths(E,!1);const y=this._debugAdaptersTrackers.get(f);y&&y.onWillReceiveMessage&&y.onWillReceiveMessage(E);const a=this._debugAdapters.get(f);a&&a.sendMessage(E)}$stopDASession(f){const E=this._debugAdaptersTrackers.get(f);this._debugAdaptersTrackers.delete(f),E&&E.onWillStopSession&&E.onWillStopSession();const y=this._debugAdapters.get(f);return this._debugAdapters.delete(f),y?y.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(f){const E=[],y=[],a=[];if(f.added)for(const L of f.added){const O=L.id;if(O&&!this._breakpoints.has(O)){let W;if(L.type==="function")W=new P.FunctionBreakpoint(L.functionName,L.enabled,L.condition,L.hitCondition,L.logMessage);else if(L.type==="data")W=new P.DataBreakpoint(L.label,L.dataId,L.canPersist,L.enabled,L.hitCondition,L.condition,L.logMessage);else{const J=R.URI.revive(L.uri);W=new P.SourceBreakpoint(new P.Location(J,new P.Position(L.line,L.character)),L.enabled,L.condition,L.hitCondition,L.logMessage)}W._id=O,this._breakpoints.set(O,W),E.push(W)}}if(f.removed)for(const L of f.removed){const O=this._breakpoints.get(L);O&&(this._breakpoints.delete(L),y.push(O))}if(f.changed){for(const L of f.changed)if(L.id){const O=this._breakpoints.get(L.id);if(O){if(O instanceof P.FunctionBreakpoint&&L.type==="function"){const W=O;W.enabled=L.enabled,W.condition=L.condition,W.hitCondition=L.hitCondition,W.logMessage=L.logMessage,W.functionName=L.functionName}else if(O instanceof P.SourceBreakpoint&&L.type==="source"){const W=O;W.enabled=L.enabled,W.condition=L.condition,W.hitCondition=L.hitCondition,W.logMessage=L.logMessage,W.location=new P.Location(R.URI.revive(L.uri),new P.Position(L.line,L.character))}a.push(O)}}}this.fireBreakpointChanges(E,y,a)}$provideDebugConfigurations(f,E,y){return D.asPromise(async()=>{const a=this.getConfigProviderByHandle(f);if(!a)throw new Error("no DebugConfigurationProvider found");if(!a.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const L=await this.getFolder(E);return a.provideDebugConfigurations(L,y)}).then(a=>{if(!a)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return a})}$resolveDebugConfiguration(f,E,y,a){return D.asPromise(async()=>{const L=this.getConfigProviderByHandle(f);if(!L)throw new Error("no DebugConfigurationProvider found");if(!L.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const O=await this.getFolder(E);return L.resolveDebugConfiguration(O,y,a)})}$resolveDebugConfigurationWithSubstitutedVariables(f,E,y,a){return D.asPromise(async()=>{const L=this.getConfigProviderByHandle(f);if(!L)throw new Error("no DebugConfigurationProvider found");if(!L.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const O=await this.getFolder(E);return L.resolveDebugConfigurationWithSubstitutedVariables(O,y,a)})}async $provideDebugAdapter(f,E){const y=this.getAdapterDescriptorFactoryByHandle(f);if(!y)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const a=await this.getSession(E);return this.getAdapterDescriptor(y,a).then(L=>{if(!L)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${a.type}'`);return this.convertToDto(L)})}async $acceptDebugSessionStarted(f){const E=await this.getSession(f);this._onDidStartDebugSession.fire(E)}async $acceptDebugSessionTerminated(f){const E=await this.getSession(f);E&&(this._onDidTerminateDebugSession.fire(E),this._debugSessions.delete(E.id))}async $acceptDebugSessionActiveChanged(f){this._activeDebugSession=f?await this.getSession(f):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(f,E){const y=await this.getSession(f);y&&y._acceptNameChanged(E)}async $acceptDebugSessionCustomEvent(f,E){const a={session:await this.getSession(f),event:E.event,body:E.body};this._onDidReceiveDebugSessionCustomEvent.fire(a)}convertToDto(f){if(f instanceof P.DebugAdapterExecutable)return{type:"executable",command:f.command,args:f.args,options:f.options};if(f instanceof P.DebugAdapterServer)return{type:"server",port:f.port,host:f.host};if(f instanceof P.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:f.path};if(f instanceof P.DebugAdapterInlineImplementation)return{type:"implementation",implementation:f.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(f){const E=this._adapterFactories.filter(y=>y.type===f);if(E.length>0)return E[0].factory}getAdapterDescriptorFactoryByHandle(f){const E=this._adapterFactories.filter(y=>y.handle===f);if(E.length>0)return E[0].factory}getConfigProviderByHandle(f){const E=this._configProviders.filter(y=>y.handle===f);if(E.length>0)return E[0].provider}definesDebugType(f,E){if(f.contributes){const y=f.contributes.debuggers;if(y&&y.length>0){for(const a of y)if(a.label&&a.type&&a.type===E)return!0}}return!1}getDebugAdapterTrackers(f){const y=f.configuration.type,a=this._trackerFactories.filter(L=>L.type===y||L.type==="*").map(L=>D.asPromise(()=>L.factory.createDebugAdapterTracker(f)).then(O=>O,O=>null));return Promise.race([Promise.all(a).then(L=>{const O=L.filter(W=>!!W);if(O.length>0)return new r(O)}),new Promise((L,O)=>{const W=setTimeout(()=>{clearTimeout(W),O(new Error("timeout"))},1e3)})]).catch(L=>{})}async getAdapterDescriptor(f,E){const y=E.configuration.debugServer;if(typeof y=="number")return Promise.resolve(new P.DebugAdapterServer(y));if(f){const L=await this._extensionService.getExtensionRegistry();return D.asPromise(()=>f.createDebugAdapterDescriptor(E,this.daExecutableFromPackage(E,L))).then(O=>{if(O)return O})}const a=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(E,a))}daExecutableFromPackage(f,E){}startBreakpoints(){this._breakpointEventsActive||(this._breakpointEventsActive=!0,this._debugServiceProxy.$startBreakpointEvents())}fireBreakpointChanges(f,E,y){(f.length>0||E.length>0||y.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:f,removed:E,changed:y}))}async getSession(f){if(f)if(typeof f=="string"){const E=this._debugSessions.get(f);if(E)return E}else{let E=this._debugSessions.get(f.id);if(!E){const y=await this.getFolder(f.folderUri),a=f.parent?this._debugSessions.get(f.parent):void 0;E=new p(this._debugServiceProxy,f.id,f.type,f.name,y,f.configuration,a),this._debugSessions.set(E.id,E),this._debugServiceProxy.$sessionCached(E.id)}return E}throw new Error("cannot find session")}getFolder(f){if(f){const E=R.URI.revive(f);return this._workspaceService.resolveWorkspaceFolder(E)}return Promise.resolve(void 0)}};d=Ve([$e(0,h.IExtHostRpcService),$e(1,C.IExtHostWorkspace),$e(2,s.IExtHostExtensionService),$e(3,I.IExtHostDocumentsAndEditors),$e(4,m.IExtHostConfiguration),$e(5,u.IExtHostEditorTabs)],d),e.ExtHostDebugServiceBase=d;class p{constructor(f,E,y,a,L,O,W){this._debugServiceProxy=f,this._id=E,this._type=y,this._name=a,this._workspaceFolder=L,this._configuration=O,this._parentSession=W}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(f){this._name=f,this._debugServiceProxy.$setDebugSessionName(this._id,f)}get parentSession(){return this._parentSession}_acceptNameChanged(f){this._name=f}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(f,E){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,f,E)}getDebugProtocolBreakpoint(f){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,f.id)}}e.ExtHostDebugSession=p;class t{constructor(f){this.value=Object.freeze({append(E){f.$appendDebugConsole(E)},appendLine(E){this.append(E+`
`)}})}}e.ExtHostDebugConsole=t;class i extends l.AbstractVariableResolverService{constructor(f,E,y,a,L){function O(){if(E){const W=E.activeEditor();if(W)return W.document.uri;const J=a.tabs.filter(se=>se.isActive);if(J.length>0)return J[0].resource}}super({getFolderUri:W=>{const J=f.filter(se=>se.name===W);if(J&&J.length>0)return J[0].uri},getWorkspaceFolderCount:()=>f.length,getConfigurationValue:(W,J)=>y.getConfiguration(void 0,W).get(J),getAppRoot:()=>b.cwd(),getExecPath:()=>b.env.VSCODE_EXEC_PATH,getFilePath:()=>{const W=O();if(W)return v.normalize(W.fsPath)},getWorkspaceFolderPathForFile:()=>{if(L){const W=O();if(W){const J=L.getWorkspaceFolder(W);if(J)return v.normalize(J.uri.fsPath)}}},getSelectedText:()=>{if(E){const W=E.activeEditor();if(W&&!W.selection.isEmpty)return W.document.getText(W.selection)}},getLineNumber:()=>{if(E){const W=E.activeEditor();if(W)return String(W.selection.end.line+1)}}},void 0,Promise.resolve(b.env))}}e.ExtHostVariableResolverService=i;class r{constructor(f){this.trackers=f}onWillStartSession(){this.trackers.forEach(f=>f.onWillStartSession?f.onWillStartSession():void 0)}onWillReceiveMessage(f){this.trackers.forEach(E=>E.onWillReceiveMessage?E.onWillReceiveMessage(f):void 0)}onDidSendMessage(f){this.trackers.forEach(E=>E.onDidSendMessage?E.onDidSendMessage(f):void 0)}onWillStopSession(){this.trackers.forEach(f=>f.onWillStopSession?f.onWillStopSession():void 0)}onError(f){this.trackers.forEach(E=>E.onError?E.onError(f):void 0)}onExit(f,E){this.trackers.forEach(y=>y.onExit?y.onExit(f,E):void 0)}}class n extends _.AbstractDebugAdapter{constructor(f){super();this.implementation=f,f.onDidSendMessage(E=>{this.acceptMessage(E)})}startSession(){return Promise.resolve(void 0)}sendMessage(f){this.implementation.handleMessage(f)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let o=class extends d{constructor(f,E,y,a,L,O){super(f,E,y,a,L,O)}createVariableResolver(f,E,y){return new i(f,E,y,this._editorTabs)}};o=Ve([$e(0,h.IExtHostRpcService),$e(1,C.IExtHostWorkspace),$e(2,s.IExtHostExtensionService),$e(3,I.IExtHostDocumentsAndEditors),$e(4,m.IExtHostConfiguration),$e(5,u.IExtHostEditorTabs)],o),e.WorkerExtHostDebugService=o}),define(ge[255],pe([0,1,65,2,5,36,35,26,13,27,4,40,37,12]),function(Q,e,v,R,k,D,A,P,_,C,s,I,l,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let c=class{constructor(u,d,p,t,i,r,n){this._apiFactory=u,this._extensionRegistry=d,this._instaService=p,this._extHostConfiguration=t,this._extHostExtensionService=i,this._initData=r,this._logService=n,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),v.mark("code/extHost/willWaitForConfig");const u=await this._extHostConfiguration.getConfigProvider();v.mark("code/extHost/didWaitForConfig");const d=await this._extHostExtensionService.getExtensionPathIndex();this.register(new h(this._apiFactory,d,this._extensionRegistry,u,this._logService)),this.register(this._instaService.createInstance(S)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(w,d,this._initData.environment.appUriScheme))}register(u){if(Array.isArray(u.nodeModuleName))for(let d of u.nodeModuleName)this._factories.set(d,u);else this._factories.set(u.nodeModuleName,u);typeof u.alternativeModuleName=="function"&&this._alternatives.push(d=>u.alternativeModuleName(d))}};c=Ve([$e(2,s.IInstantiationService),$e(3,D.IExtHostConfiguration),$e(4,I.IExtHostExtensionService),$e(5,C.IExtHostInitDataService),$e(6,m.ILogService)],c),e.RequireInterceptor=c;class h{constructor(u,d,p,t,i){this._apiFactory=u,this._extensionPaths=d,this._extensionRegistry=p,this._configProvider=t,this._logService=i,this.nodeModuleName="vscode",this._extApiImpl=new Map}load(u,d){const p=this._extensionPaths.findSubstr(d.fsPath);if(p){let t=this._extApiImpl.get(P.ExtensionIdentifier.toKey(p.identifier));return t||(t=this._apiFactory(p,this._extensionRegistry,this._configProvider),this._extApiImpl.set(P.ExtensionIdentifier.toKey(p.identifier),t)),t}if(!this._defaultApiImpl){let t="";this._extensionPaths.forEach((i,r)=>t+=`	${r} -> ${i.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${d.fsPath}. These are the extension path mappings: 
${t}`),this._defaultApiImpl=this._apiFactory(A.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let S=class{constructor(u,d){this.nodeModuleName="keytar";const{environment:p}=d,t=u.getProxy(k.MainContext.MainThreadKeytar);if(p.appRoot){let i=p.appRoot.fsPath;l.platform==="win32"&&(i=i.replace(/\\/g,"/")),i[i.length-1]==="/"&&(i=i.substr(0,i.length-1)),this.alternativeNames=new Set,this.alternativeNames.add(`${i}/node_modules.asar/keytar`),this.alternativeNames.add(`${i}/node_modules/keytar`)}this._impl={getPassword:(i,r)=>t.$getPassword(i,r),setPassword:(i,r,n)=>t.$setPassword(i,r,n),deletePassword:(i,r)=>t.$deletePassword(i,r),findPassword:i=>t.$findPassword(i),findCredentials(i){return t.$findCredentials(i)}}}load(u,d){return this._impl}alternativeModuleName(u){const d=u.length;if(d<=7||!this.alternativeNames)return;const p=d-7;if((u.charAt(p)==="/"||u.charAt(p)==="\\")&&u.endsWith("keytar")&&(u=u.replace(/\\/g,"/"),this.alternativeNames.has(u)))return"keytar"}};S=Ve([$e(0,_.IExtHostRpcService),$e(1,C.IExtHostInitDataService)],S);let w=class{constructor(u,d,p){this._extensionPaths=u,this._appUriScheme=d,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=p.getProxy(k.MainContext.MainThreadTelemetry);const t=p.getProxy(k.MainContext.MainThreadWindow);this._impl=(i,r)=>{const n=R.URI.parse(i);return r?this.callOriginal(i,r):n.scheme==="http"||n.scheme==="https"?t.$openUri(n,i,{allowTunneling:!0}):n.scheme==="mailto"||n.scheme===this._appUriScheme?t.$openUri(n,i,{}):this.callOriginal(i,r)}}load(u,d,p){const t=this._extensionPaths.findSubstr(d.fsPath);return t&&(this._extensionId=t.identifier.value,this.sendShimmingTelemetry()),this._original=p(u),this._impl}callOriginal(u,d){return this.sendNoForwardTelemetry(),this._original(u,d)}sendShimmingTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};w=Ve([$e(2,_.IExtHostRpcService)],w)}),define(ge[256],pe([0,1,165,11,7,198,34,40,39,36,33,13,49,187,16,199,46]),function(Q,e,v,R,k,D,A,P,_,C,s,I,l,m,c,h,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDebugService=void 0;let w=class extends l.ExtHostDebugServiceBase{constructor(d,p,t,i,r,n,o){super(d,p,t,i,r,o);this._terminalService=n,this._integratedTerminalInstances=new b}createDebugAdapter(d,p){switch(d.type){case"server":return new D.SocketDebugAdapter(d);case"pipeServer":return new D.NamedPipeDebugAdapter(d);case"executable":return new D.ExecutableDebugAdapter(d,p.type)}return super.createDebugAdapter(d,p)}daExecutableFromPackage(d,p){const t=D.ExecutableDebugAdapter.platformAdapterExecutable(p.getAllExtensionDescriptions(),d.type);if(t)return new k.DebugAdapterExecutable(t.command,t.args,t.options)}createSignService(){return new m.SignService}async $runInTerminal(d,p){if(d.kind==="integrated"){this._terminalDisposedListener||(this._terminalDisposedListener=this._terminalService.onDidCloseTerminal(O=>{this._integratedTerminalInstances.onTerminalClosed(O)}));const t=await this._configurationService.getConfigProvider(),i=this._terminalService.getDefaultShell(!0),r=this._terminalService.getDefaultShellArgs(!0),n=d.title||v.localize(0,null),o=JSON.stringify({shell:i,shellArgs:r});let g=await this._integratedTerminalInstances.checkout(o,n),f,E=!1;if(g)f=d.cwd;else{const O={shellPath:i,shellArgs:r,cwd:d.cwd,name:n};E=!0,g=this._terminalService.createTerminalFromOptions(O,{isFeatureTerminal:!0,useShellEnvironment:!0}),this._integratedTerminalInstances.insert(g,o)}g.show(!0);const y=await g.processId;E?await new Promise(O=>setTimeout(O,1e3)):t.getConfiguration("debug.terminal").get("clearBeforeReusing")&&(i.indexOf("powershell")>=0||i.indexOf("pwsh")>=0||i.indexOf("cmd.exe")>=0?g.sendText("cls"):i.indexOf("bash")>=0?g.sendText("clear"):R.isWindows?g.sendText("cls"):g.sendText("clear"));const a=h.prepareCommand(i,d.args,f,d.env);g.sendText(a);const L=this.onDidTerminateDebugSession(O=>{O.id===p&&(this._integratedTerminalInstances.free(g),L.dispose())});return y}else if(d.kind==="external")return h.runInExternalTerminal(d,await this._configurationService.getConfigProvider());return super.$runInTerminal(d,p)}createVariableResolver(d,p,t){return new l.ExtHostVariableResolverService(d,p,t,this._editorTabs,this._workspaceService)}};w=Ve([$e(0,I.IExtHostRpcService),$e(1,A.IExtHostWorkspace),$e(2,P.IExtHostExtensionService),$e(3,_.IExtHostDocumentsAndEditors),$e(4,C.IExtHostConfiguration),$e(5,s.IExtHostTerminalService),$e(6,S.IExtHostEditorTabs)],w),e.ExtHostDebugService=w;class b{constructor(){this._terminalInstances=new Map}async checkout(d,p){const i=[...this._terminalInstances.entries()].map(([r,n])=>c.createCancelablePromise(async o=>{if(r.name!==p||n.lastUsedAt!==-1&&await h.hasChildProcesses(await r.processId))return null;const g=Date.now();return n.lastUsedAt+b.minUseDelay>g||o.isCancellationRequested||n.config!==d?null:(n.lastUsedAt=g,r)}));return await c.firstParallel(i,r=>!!r)}insert(d,p){this._terminalInstances.set(d,{lastUsedAt:Date.now(),config:p})}free(d){const p=this._terminalInstances.get(d);p&&(p.lastUsedAt=-1)}onTerminalClosed(d){this._terminalInstances.delete(d)}}b.minUseDelay=1e3}),define(ge[257],pe([0,1,9,2,111,34,49,39,36,33,13,27,64,10,12,60,46]),function(Q,e,v,R,k,D,A,P,_,C,s,I,l,m,c,h,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTask=void 0;let w=class extends l.ExtHostTaskBase{constructor(u,d,p,t,i,r,n,o,g){super(u,d,p,t,i,r,n,o);this.workspaceService=p,this.editorTabs=g,d.remote.isRemote&&d.remote.authority?this.registerTaskSystem(m.Schemas.vscodeRemote,{scheme:m.Schemas.vscodeRemote,authority:d.remote.authority,platform:process.platform}):this.registerTaskSystem(m.Schemas.file,{scheme:m.Schemas.file,authority:"",platform:process.platform}),this._proxy.$registerSupportedExecutions(!0,!0,!0)}async executeTask(u,d){const p=d;if(!d.execution&&p._id===void 0)throw new Error("Tasks to execute must include an execution");if(p._id!==void 0){const t=l.TaskHandleDTO.from(p,this.workspaceService),i=await this._proxy.$getTaskExecution(t);if(i.task===void 0)throw new Error("Task from execution DTO is undefined");const r=await this.getTaskExecution(i,d);return this._proxy.$executeTask(t).catch(()=>{}),r}else{const t=l.TaskDTO.from(d,u);if(t===void 0)return Promise.reject(new Error("Task is not valid"));l.CustomExecutionDTO.is(t.execution)&&await this.addCustomExecution(t,d,!1);const i=await this.getTaskExecution(await this._proxy.$getTaskExecution(t),d);return this._proxy.$executeTask(t).catch(()=>{}),i}}provideTasksInternal(u,d,p,t){const i=[];if(t)for(let r of t){this.checkDeprecation(r,p),(!r.definition||!u[r.definition.type])&&this._logService.warn(`The task [${r.source}, ${r.name}] uses an undefined task type. The task will be ignored in the future.`);const n=l.TaskDTO.from(r,p.extension);n&&(i.push(n),l.CustomExecutionDTO.is(n.execution)&&d.push(this.addCustomExecution(n,r,!0)))}return{tasks:i,extension:p.extension}}async resolveTaskInternal(u){return u}async getVariableResolver(u){if(this._variableResolver===void 0){const d=await this._configurationService.getConfigProvider();this._variableResolver=new A.ExtHostVariableResolverService(u,this._editorService,d,this.editorTabs,this.workspaceService)}return this._variableResolver}async $resolveVariables(u,d){const p=R.URI.revive(u),t={process:void 0,variables:Object.create(null)},i=await this._workspaceProvider.resolveWorkspaceFolder(p),r=await this._workspaceProvider.getWorkspaceFolders2();if(!r||!i)throw new Error("Unexpected: Tasks can only be run in a workspace folder");const n=await this.getVariableResolver(r),o={uri:i.uri,name:i.name,index:i.index,toResource:()=>{throw new Error("Not implemented")}};for(let g of d.variables)t.variables[g]=await n.resolveAsync(o,g);if(d.process!==void 0){let g;if(d.process.path!==void 0){g=d.process.path.split(v.delimiter);for(let f=0;f<g.length;f++)g[f]=await n.resolveAsync(o,g[f])}t.process=await k.win32.findExecutable(await n.resolveAsync(o,d.process.name),d.process.cwd!==void 0?await n.resolveAsync(o,d.process.cwd):void 0,g)}return t}async $jsonTasksSupported(){return!0}async $findExecutable(u,d,p){return k.win32.findExecutable(u,d,p)}};w=Ve([$e(0,s.IExtHostRpcService),$e(1,I.IExtHostInitDataService),$e(2,D.IExtHostWorkspace),$e(3,P.IExtHostDocumentsAndEditors),$e(4,_.IExtHostConfiguration),$e(5,C.IExtHostTerminalService),$e(6,c.ILogService),$e(7,h.IExtHostApiDeprecationService),$e(8,S.IExtHostEditorTabs)],w),e.ExtHostTask=w}),define(ge[258],pe([0,1,16,14,65,6,2,5,249,12,77,79,27,180,13,59,40,33]),function(Q,e,v,R,k,D,A,P,_,C,s,I,l,m,c,h,S,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class b{constructor(d,p,t,i){this._disposables=new D.DisposableStore,this._isTerminating=!1,this._hostUtils=t,this._rpcProtocol=new _.RPCProtocol(d,null,i),p=b._transform(p,this._rpcProtocol);const r=new I.ServiceCollection(...s.getSingletonServiceDescriptors());r.set(l.IExtHostInitDataService,Object.assign({_serviceBrand:void 0},p)),r.set(c.IExtHostRpcService,new c.ExtHostRpcService(this._rpcProtocol)),r.set(h.IURITransformerService,new h.URITransformerService(i)),r.set(S.IHostUtils,t);const n=new m.InstantiationService(r,!0),o=n.invokeFunction(y=>y.get(w.IExtHostTerminalService));this._disposables.add(o),this._logService=n.invokeFunction(y=>y.get(C.ILogService)),k.mark("code/extHost/didCreateServices"),this._logService.info("extension host started"),this._logService.trace("initData",p),this._extensionService=n.invokeFunction(y=>y.get(S.IExtHostExtensionService)),this._extensionService.initialize(),Error.stackTraceLimit=100;const g=new WeakMap;this._extensionService.getExtensionPathIndex().then(y=>{Error.prepareStackTrace=(a,L)=>{let O="",W,J;for(const se of L)O+=`
	at ${se.toString()}`,J=se.getFileName(),!W&&J&&(W=y.findSubstr(J));return g.set(a,W),`${a.name||"Error"}: ${a.message||""}${O}`}});const f=this._rpcProtocol.getProxy(P.MainContext.MainThreadExtensionService),E=this._rpcProtocol.getProxy(P.MainContext.MainThreadErrors);R.setUnexpectedErrorHandler(y=>{const a=R.transformErrorForSerialization(y),L=g.get(y);L?f.$onExtensionRuntimeError(L.identifier,a):E.$onUnexpectedError(a)})}terminate(d){if(this._isTerminating)return;this._isTerminating=!0,this._logService.info(`extension host terminating: ${d}`),this._logService.flush(),this._disposables.dispose(),R.setUnexpectedErrorHandler(t=>{this._logService.error(t)}),this._rpcProtocol.dispose();const p=this._extensionService.deactivateAll();setTimeout(()=>{Promise.race([v.timeout(4e3),p]).finally(()=>{this._logService.info("exiting with code 0"),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(0)})},1e3)}static _transform(d,p){d.extensions.forEach(i=>i.extensionLocation=A.URI.revive(p.transformIncomingURIs(i.extensionLocation))),d.environment.appRoot=A.URI.revive(p.transformIncomingURIs(d.environment.appRoot));const t=d.environment.extensionDevelopmentLocationURI;return t&&(d.environment.extensionDevelopmentLocationURI=t.map(i=>A.URI.revive(p.transformIncomingURIs(i)))),d.environment.extensionTestsLocationURI=A.URI.revive(p.transformIncomingURIs(d.environment.extensionTestsLocationURI)),d.environment.globalStorageHome=A.URI.revive(p.transformIncomingURIs(d.environment.globalStorageHome)),d.environment.workspaceStorageHome=A.URI.revive(p.transformIncomingURIs(d.environment.workspaceStorageHome)),d.logsLocation=A.URI.revive(p.transformIncomingURIs(d.logsLocation)),d.logFile=A.URI.revive(p.transformIncomingURIs(d.logFile)),d.workspace=p.transformIncomingURIs(d.workspace),d}}e.ExtensionHostMain=b}),define(ge[259],pe([0,1,9,21,56,30,24,43,31]),function(Q,e,v,R,k,D,A,P,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class C{constructor(l,m,c){this.config=l,this.provider=m,this.sessionToken=c,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=l.filePattern,this.includePattern=l.includePattern&&D.parse(l.includePattern),this.maxResults=l.maxResults||void 0,this.exists=l.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=l.excludePattern&&D.parse(l.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(l=>l.cancel()),this.activeCancellationTokens=new Set}search(l){const m=this.config.folderQueries||[];return new Promise((c,h)=>{const S=w=>{this.resultCount++,l(w)};if(this.isCanceled)return c({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(w=>{const b=w.toString(),u=v.basename(b);this.globalExcludePattern&&this.globalExcludePattern(b,u)||this.matchFile(S,{base:w,basename:u})}),Promise.all(m.map(w=>this.searchInFolder(w,S))).then(w=>{c({limitHit:this.isLimitHit,stats:w[0]||void 0})},w=>{h(new Error(k.toErrorMessage(w)))})})}async searchInFolder(l,m){const c=new R.CancellationTokenSource,h=this.getSearchOptionsForFolder(l),S=this.initDirectoryTree(),w=new _.QueryGlobTester(this.config,l),b=!w.hasSiblingExcludeClauses();let u;try{this.activeCancellationTokens.add(c),u=P.StopWatch.create();const d=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},h,c.token),p=u.elapsed(),t=P.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(d&&d.forEach(i=>{const r=v.posix.relative(l.folder.path,i.path);if(b){const n=v.basename(i.path);this.matchFile(m,{base:l.folder,relativePath:r,basename:n});return}this.addDirectoryEntries(S,l.folder,r,m)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(S,w,m),{providerTime:p,postProcessTime:t.elapsed()})}finally{c.dispose(),this.activeCancellationTokens.delete(c)}}getSearchOptionsForFolder(l){const m=_.resolvePatternsForProvider(this.config.includePattern,l.includePattern),c=_.resolvePatternsForProvider(this.config.excludePattern,l.excludePattern);return{folder:l.folder,excludes:c,includes:m,useIgnoreFiles:!l.disregardIgnoreFiles,useGlobalIgnoreFiles:!l.disregardGlobalIgnoreFiles,followSymlinks:!l.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const l={rootEntries:[],pathToEntries:Object.create(null)};return l.pathToEntries["."]=l.rootEntries,l}addDirectoryEntries({pathToEntries:l},m,c,h){if(c===this.filePattern){const w=v.basename(this.filePattern);this.matchFile(h,{base:m,relativePath:this.filePattern,basename:w})}function S(w){const b=v.basename(w),u=v.dirname(w);let d=l[u];d||(d=l[u]=[],S(u)),d.push({base:m,relativePath:w,basename:b})}S(c)}matchDirectoryTree({rootEntries:l,pathToEntries:m},c,h){const S=this,w=this.filePattern;function b(u){const d=D.hasSiblingFn(()=>u.map(p=>p.basename));for(let p=0,t=u.length;p<t;p++){const i=u[p],{relativePath:r,basename:n}=i;if(!c.includedInQuerySync(r,n,w!==n?d:void 0))continue;const o=m[r];if(o)b(o);else{if(r===w)continue;S.matchFile(h,i)}if(S.isLimitHit)break}}b(l)}matchFile(l,m){(!this.includePattern||m.relativePath&&this.includePattern(m.relativePath,m.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||l(m))}}class s{constructor(){this.sessions=new Map}fileSearch(l,m,c,h){const S=this.getSessionTokenSource(l.cacheKey),w=new C(l,m,S&&S.token);let b=0;const u=d=>{b+=d.length,c(d.map(p=>this.rawMatchToSearchItem(p)))};return this.doSearch(w,s.BATCH_SIZE,u,h).then(d=>({limitHit:d.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:b,detailStats:d.stats}}))}clearCache(l){const m=this.getSessionTokenSource(l);m&&m.cancel()}getSessionTokenSource(l){if(!!l)return this.sessions.has(l)||this.sessions.set(l,new R.CancellationTokenSource),this.sessions.get(l)}rawMatchToSearchItem(l){return l.relativePath?{resource:A.joinPath(l.base,l.relativePath)}:{resource:l.base}}doSearch(l,m,c,h){h.onCancellationRequested(()=>{l.cancel()});const S=b=>{b&&(w.push(b),m>0&&w.length>=m&&(c(w),w=[]))};let w=[];return l.search(S).then(b=>(w.length&&c(w),b),b=>(w.length&&c(w),Promise.reject(b)))}}e.FileSearchManager=s,s.BATCH_SIZE=512}),define(ge[128],pe([0,1,9,18,21,56,24,30,2,31,10,15]),function(Q,e,v,R,k,D,A,P,_,C,s,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class l{constructor(u,d,p){this.query=u,this.provider=d,this.fileUtils=p,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(u,d){const p=this.query.folderQueries||[],t=new k.CancellationTokenSource;return d.onCancellationRequested(()=>t.cancel()),new Promise((i,r)=>{this.collector=new c(u);let n=!1;const o=(g,f)=>{if(!n&&!this.isLimitHit){const E=this.resultSize(g);S(g)&&typeof this.query.maxResults=="number"&&this.resultCount+E>this.query.maxResults&&(this.isLimitHit=!0,n=!0,t.cancel(),g=this.trimResultToSize(g,this.query.maxResults-this.resultCount));const y=this.resultSize(g);this.resultCount+=y,(y>0||!S(g))&&this.collector.add(g,f)}};Promise.all(p.map((g,f)=>this.searchInFolder(g,E=>o(E,f),t.token))).then(g=>{t.dispose(),this.collector.flush();const f=g.some(E=>!!E&&!!E.limitHit);i({limitHit:this.isLimitHit||f,messages:R.flatten(g.map(E=>(E==null?void 0:E.message)?I.isArray(E.message)?E.message:[E.message]:[])),stats:{type:"textSearchProvider"}})},g=>{t.dispose();const f=D.toErrorMessage(g);r(new Error(f))})})}resultSize(u){return S(u)?Array.isArray(u.ranges)?u.ranges.length:1:0}trimResultToSize(u,d){const p=Array.isArray(u.ranges)?u.ranges:[u.ranges],t=Array.isArray(u.preview.matches)?u.preview.matches:[u.preview.matches];return{ranges:p.slice(0,d),preview:{matches:t.slice(0,d),text:u.preview.text},uri:u.uri}}async searchInFolder(u,d,p){const t=new C.QueryGlobTester(this.query,u),i=[],r={report:g=>{if(!this.validateProviderResult(g))return;const f=u.folder.scheme===s.Schemas.file?P.hasSiblingPromiseFn(()=>this.fileUtils.readdir(A.dirname(g.uri))):void 0,E=A.relativePath(u.folder,g.uri);E&&i.push(t.includedInQuery(E,v.basename(E),f).then(y=>{y&&d(g)}))}},n=this.getSearchOptionsForFolder(u),o=await this.provider.provideTextSearchResults(m(this.query.contentPattern),n,r,p);return await Promise.all(i),o}validateProviderResult(u){if(S(u)){if(Array.isArray(u.ranges)){if(!Array.isArray(u.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(u.preview.matches.length!==u.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(u.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(u){const d=C.resolvePatternsForProvider(this.query.includePattern,u.includePattern),p=C.resolvePatternsForProvider(this.query.excludePattern,u.excludePattern),t={folder:_.URI.from(u.folder),excludes:p,includes:d,useIgnoreFiles:!u.disregardIgnoreFiles,useGlobalIgnoreFiles:!u.disregardGlobalIgnoreFiles,followSymlinks:!u.ignoreSymlinks,encoding:u.fileEncoding&&this.fileUtils.toCanonicalName(u.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return t.usePCRE2=this.query.usePCRE2,t}}e.TextSearchManager=l;function m(b){return{isCaseSensitive:b.isCaseSensitive||!1,isRegExp:b.isRegExp||!1,isWordMatch:b.isWordMatch||!1,isMultiline:b.isMultiline||!1,pattern:b.pattern}}class c{constructor(u){this._onResult=u,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new w(512,d=>this.sendItems(d))}add(u,d){this._currentFileMatch&&(this._currentFolderIdx!==d||!A.isEqual(this._currentUri,u.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=d,this._currentFileMatch={resource:u.uri,results:[]}),this._currentFileMatch.results.push(h(u))}pushToCollector(){const u=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,u)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(u){this._onResult(u)}}e.TextSearchResultsCollector=c;function h(b){return S(b)?{preview:{matches:R.mapArrayOrNot(b.preview.matches,u=>({startLineNumber:u.start.line,startColumn:u.start.character,endLineNumber:u.end.line,endColumn:u.end.character})),text:b.preview.text},ranges:R.mapArrayOrNot(b.ranges,u=>({startLineNumber:u.start.line,startColumn:u.start.character,endLineNumber:u.end.line,endColumn:u.end.character}))}:{text:b.text,lineNumber:b.lineNumber}}function S(b){return!!b.preview}e.extensionResultIsMatch=S;class w{constructor(u,d){this.maxBatchSize=u,this.cb=d,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(u,d){!u||this.addItemToBatch(u,d)}addItems(u,d){!u||this.addItemsToBatch(u,d)}addItemToBatch(u,d){this.batch.push(u),this.batchSize+=d,this.onUpdate()}addItemsToBatch(u,d){this.batch=this.batch.concat(u),this.batchSize+=d,this.onUpdate()}onUpdate(){this.totalNumberCompleted<w.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},w.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=w,w.TIMEOUT=4e3,w.START_BATCH_AFTER_COUNT=50}),define(ge[66],pe([0,1,6,5,4,259,13,59,12,2,128]),function(Q,e,v,R,k,D,A,P,_,C,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=k.createDecorator("IExtHostSearch");let I=class{constructor(h,S,w){this.extHostRpc=h,this._uriTransformer=S,this._logService=w,this._proxy=this.extHostRpc.getProxy(R.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new D.FileSearchManager}_transformScheme(h){return this._uriTransformer.transformOutgoingScheme(h)}registerTextSearchProvider(h,S){if(this._textSearchUsedSchemes.has(h))throw new Error(`a text search provider for the scheme '${h}' is already registered`);this._textSearchUsedSchemes.add(h);const w=this._handlePool++;return this._textSearchProvider.set(w,S),this._proxy.$registerTextSearchProvider(w,this._transformScheme(h)),v.toDisposable(()=>{this._textSearchUsedSchemes.delete(h),this._textSearchProvider.delete(w),this._proxy.$unregisterProvider(w)})}registerFileSearchProvider(h,S){if(this._fileSearchUsedSchemes.has(h))throw new Error(`a file search provider for the scheme '${h}' is already registered`);this._fileSearchUsedSchemes.add(h);const w=this._handlePool++;return this._fileSearchProvider.set(w,S),this._proxy.$registerFileSearchProvider(w,this._transformScheme(h)),v.toDisposable(()=>{this._fileSearchUsedSchemes.delete(h),this._fileSearchProvider.delete(w),this._proxy.$unregisterProvider(w)})}$provideFileSearchResults(h,S,w,b){const u=l(w),d=this._fileSearchProvider.get(h);if(d)return this._fileSearchManager.fileSearch(u,d,p=>{this._proxy.$handleFileMatch(h,S,p.map(t=>t.resource))},b);throw new Error("unknown provider: "+h)}$clearCache(h){return this._fileSearchManager.clearCache(h),Promise.resolve(void 0)}$provideTextSearchResults(h,S,w,b){const u=this._textSearchProvider.get(h);if(!u||!u.provideTextSearchResults)throw new Error(`Unknown provider ${h}`);const d=l(w);return this.createTextSearchManager(d,u).search(t=>this._proxy.$handleTextMatch(h,S,t),b)}createTextSearchManager(h,S){return new s.TextSearchManager(h,S,{readdir:w=>Promise.resolve([]),toCanonicalName:w=>w})}};I=Ve([$e(0,A.IExtHostRpcService),$e(1,P.IURITransformerService),$e(2,_.ILogService)],I),e.ExtHostSearch=I;function l(c){return Object.assign(Object.assign({},c),{folderQueries:c.folderQueries&&c.folderQueries.map(m),extraFileResources:c.extraFileResources&&c.extraFileResources.map(h=>C.URI.revive(h))})}e.reviveQuery=l;function m(c){return Object.assign(Object.assign({},c),{folder:C.URI.revive(c.folder)})}}),define(ge[260],pe([0,1,21,14,3,53,2,150,107,141,76,42,5,220,219,48,221,36,222,223,224,205,225,39,40,226,206,228,229,230,61,208,235,236,237,89,33,238,209,17,7,241,62,127,34,35,67,196,227,82,126,64,49,66,12,59,13,27,231,194,47,60,217,239,193,90,88,244,242,243,218,58,252,240,87,46,118,233,63,234,10,182,232,191]),function(Q,e,v,R,k,D,A,P,_,C,s,I,l,m,c,h,S,w,b,u,d,p,t,i,r,n,o,g,f,E,y,a,L,O,W,J,se,q,N,H,T,U,F,M,x,$,X,le,be,Re,Ce,Me,je,ze,qe,j,Z,ne,oe,Y,ce,me,Le,We,Ee,Ke,G,ie,ve,Fe,Ne,Qe,De,Se,Pe,ae,he,z,ee,ue,Ie,Te,xe,He){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function Ze(Ye){const Xe=Ye.get(ne.IExtHostInitDataService),nt=Ye.get(Qe.IExtHostFileSystemInfo),pt=Ye.get(G.IExtHostConsumerFileSystem),_e=Ye.get(r.IExtHostExtensionService),ye=Ye.get(x.IExtHostWorkspace),de=Ye.get(he.IExtHostTelemetry),K=Ye.get(w.IExtHostConfiguration),Ue=Ye.get(j.IURITransformerService),we=Ye.get(Z.IExtHostRpcService),Je=Ye.get(J.IExtHostStorage),et=Ye.get(Ke.IExtensionStoragePaths),rt=Ye.get(qe.ILogService),st=Ye.get(ce.IExtHostTunnelService),vt=Ye.get(me.IExtHostApiDeprecationService),ft=Ye.get(M.IExtHostWindow),Et=Ye.get(Pe.IExtHostSecretState),bt=Ye.get(ae.IExtHostEditorTabs);we.set(l.ExtHostContext.ExtHostFileSystemInfo,nt),we.set(l.ExtHostContext.ExtHostLogService,rt),we.set(l.ExtHostContext.ExtHostWorkspace,ye),we.set(l.ExtHostContext.ExtHostConfiguration,K),we.set(l.ExtHostContext.ExtHostExtensionService,_e),we.set(l.ExtHostContext.ExtHostStorage,Je),we.set(l.ExtHostContext.ExtHostTunnelService,st),we.set(l.ExtHostContext.ExtHostWindow,ft),we.set(l.ExtHostContext.ExtHostSecretState,Et),we.set(l.ExtHostContext.ExtHostTelemetry,de),we.set(l.ExtHostContext.ExtHostEditorTabs,bt);const Rt=we.set(l.ExtHostContext.ExtHostDecorations,Ye.get(Ce.IExtHostDecorations)),wt=we.set(l.ExtHostContext.ExtHostDocumentsAndEditors,Ye.get(i.IExtHostDocumentsAndEditors)),ut=we.set(l.ExtHostContext.ExtHostCommands,Ye.get(h.IExtHostCommands)),mt=we.set(l.ExtHostContext.ExtHostTerminalService,Ye.get(se.IExtHostTerminalService)),dt=we.set(l.ExtHostContext.ExtHostDebugService,Ye.get(je.IExtHostDebugService)),Pt=we.set(l.ExtHostContext.ExtHostSearch,Ye.get(ze.IExtHostSearch)),Dt=we.set(l.ExtHostContext.ExtHostTask,Ye.get(Me.IExtHostTask)),Lt=we.set(l.ExtHostContext.ExtHostOutputService,Ye.get(y.IExtHostOutputService)),Kt=we.set(l.ExtHostContext.ExtHostUrls,new U.ExtHostUrls(we)),_t=we.set(l.ExtHostContext.ExtHostDocuments,new t.ExtHostDocuments(we,wt)),Jt=we.set(l.ExtHostContext.ExtHostDocumentContentProviders,new d.ExtHostDocumentContentProvider(we,wt,rt)),Zt=we.set(l.ExtHostContext.ExtHostDocumentSaveParticipant,new p.ExtHostDocumentSaveParticipant(rt,_t,we.getProxy(l.MainContext.MainThreadBulkEdits))),gt=we.set(l.ExtHostContext.ExtHostNotebook,new oe.ExtHostNotebookController(we,ut,wt,_t,et)),Qt=we.set(l.ExtHostContext.ExtHostNotebookDocuments,new He.ExtHostNotebookDocuments(rt,gt)),en=we.set(l.ExtHostContext.ExtHostNotebookEditors,new xe.ExtHostNotebookEditors(rt,we,gt)),tn=we.set(l.ExtHostContext.ExtHostNotebookKernels,new z.ExtHostNotebookKernels(we,Xe,gt,rt)),nn=we.set(l.ExtHostContext.ExtHostNotebookRenderers,new ue.ExtHostNotebookRenderers(we,gt)),yt=we.set(l.ExtHostContext.ExtHostEditors,new q.ExtHostEditors(we,wt)),Xt=we.set(l.ExtHostContext.ExtHostTreeViews,new N.ExtHostTreeViews(we.getProxy(l.MainContext.MainThreadTreeViews),ut,rt)),yn=we.set(l.ExtHostContext.ExtHostEditorInsets,new le.ExtHostEditorInsets(we.getProxy(l.MainContext.MainThreadEditorInsets),yt,Xe)),Ut=we.set(l.ExtHostContext.ExtHostDiagnostics,new b.ExtHostDiagnostics(we,rt)),lt=we.set(l.ExtHostContext.ExtHostLanguageFeatures,new g.ExtHostLanguageFeatures(we,Ue,_t,ut,Ut,rt,vt)),Dn=we.set(l.ExtHostContext.ExtHostFileSystem,new n.ExtHostFileSystem(we,lt)),Ft=we.set(l.ExtHostContext.ExtHostFileSystemEventService,new o.ExtHostFileSystemEventService(we,rt,wt)),Wt=we.set(l.ExtHostContext.ExtHostQuickOpen,L.createExtHostQuickOpen(we,ye,ut)),mn=we.set(l.ExtHostContext.ExtHostSCM,new O.ExtHostSCM(we,ut,rt)),Cn=we.set(l.ExtHostContext.ExtHostComments,new S.ExtHostComments(we,ut,_t)),Yt=we.set(l.ExtHostContext.ExtHostProgress,new a.ExtHostProgress(we.getProxy(l.MainContext.MainThreadProgress))),rn=we.set(l.ExtHostContext.ExtHosLabelService,new be.ExtHostLabelService(we)),gn=we.set(l.ExtHostContext.ExtHostTheming,new Y.ExtHostTheming(we)),xt=we.set(l.ExtHostContext.ExtHostAuthentication,new Le.ExtHostAuthentication(we)),kn=we.set(l.ExtHostContext.ExtHostTimeline,new We.ExtHostTimeline(we,ut)),sn=we.set(l.ExtHostContext.ExtHostWebviews,new F.ExtHostWebviews(we,{remote:Xe.remote},ye,rt,vt)),Bt=we.set(l.ExtHostContext.ExtHostWebviewPanels,new Fe.ExtHostWebviewPanels(we,sn,ye)),Pn=we.set(l.ExtHostContext.ExtHostCustomEditors,new ve.ExtHostCustomEditors(we,_t,et,sn,Bt)),In=we.set(l.ExtHostContext.ExtHostWebviewViews,new ie.ExtHostWebviewViews(we,sn)),It=we.set(l.ExtHostContext.ExtHostTesting,new De.ExtHostTesting(we,wt,ye)),An=we.set(l.ExtHostContext.ExtHostUriOpeners,new Se.ExtHostUriOpeners(we)),Ht=X.values(l.ExtHostContext);we.assertRegistered(Ht);const Mt=new Ne.ExtHostBulkEdits(we,wt),Tn=new c.ExtHostClipboard(we),kt=new E.ExtHostMessageService(we,rt),zt=new u.ExtHostDialogs(we),pn=new W.ExtHostStatusBar(we,ut.converter),on=new f.ExtHostLanguages(we,_t);return m.ExtHostApiCommands.register(ut),function(Oe,an,vn){const ht=function(){let te=!Oe.isUnderDevelopment;function fe(Ae){te||(rt.info(`Extension '${Oe.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),te=!0)}return function Ae(ot){if(Array.isArray(ot))ot.forEach(Ae);else if(typeof ot=="string")fe(ot);else{const V=ot;typeof V.scheme=="undefined"&&fe(ot),!Oe.enableProposedApi&&typeof V.exclusive=="boolean"&&$.throwProposedApiError(Oe)}return ot}}(),Rn={getSession(te,fe,Ae){return xt.getSession(Oe,te,fe,Ae)},get onDidChangeSessions(){return xt.onDidChangeSessions},registerAuthenticationProvider(te,fe,Ae,ot){return xt.registerAuthenticationProvider(te,fe,Ae,ot)},get onDidChangeAuthenticationProviders(){return $.checkProposedApiEnabled(Oe),xt.onDidChangeAuthenticationProviders},get providers(){return $.checkProposedApiEnabled(Oe),xt.providers},logout(te,fe){return $.checkProposedApiEnabled(Oe),xt.removeSession(te,fe)}},ln={registerCommand(te,fe,Ae){return ut.registerCommand(!0,te,fe,Ae)},registerTextEditorCommand(te,fe,Ae){return ut.registerCommand(!0,te,(...ot)=>{const V=yt.getActiveTextEditor();if(!V){rt.warn("Cannot execute "+te+" because there is no active text editor.");return}return V.edit(B=>{fe.apply(Ae,[V,B,...ot])}).then(B=>{B||rt.warn("Edits from command "+te+" were not applied.")},B=>{rt.warn("An error occurred while running command "+te,B)})})},registerDiffInformationCommand:(te,fe,Ae)=>($.checkProposedApiEnabled(Oe),ut.registerCommand(!0,te,async(...ot)=>{const V=wt.activeEditor(!0);if(!V){rt.warn("Cannot execute "+te+" because there is no active text editor.");return}const B=await yt.getDiffInformation(V.id);fe.apply(Ae,[B,...ot])})),executeCommand(te,...fe){return ut.executeCommand(te,...fe)},getCommands(te=!1){return ut.getCommands(te)}},wn={get machineId(){return Xe.telemetryInfo.machineId},get sessionId(){return Xe.telemetryInfo.sessionId},get language(){return Xe.environment.appLanguage},get appName(){return Xe.environment.appName},get appRoot(){var te,fe;return(fe=(te=Xe.environment.appRoot)===null||te===void 0?void 0:te.fsPath)!==null&&fe!==void 0?fe:""},get uriScheme(){return Xe.environment.appUriScheme},get clipboard(){return Tn.value},get shell(){return mt.getDefaultShell(!1)},get isTelemetryEnabled(){return de.getTelemetryEnabled()},get onDidChangeTelemetryEnabled(){return de.onDidChangeTelemetryEnabled},get isNewAppInstall(){const te=Date.now()-new Date(Xe.telemetryInfo.firstSessionDate).getTime();return isNaN(te)?!1:te<1e3*60*60*24},openExternal(te,fe){return ft.openUri(te,{allowTunneling:!!Xe.remote.authority,allowContributedOpeners:fe==null?void 0:fe.allowContributedOpeners})},async asExternalUri(te){if(te.scheme===Xe.environment.appUriScheme)return Kt.createAppUri(te);const fe=Te.matchesScheme(te,Ie.Schemas.http)||Te.matchesScheme(te,Ie.Schemas.https);fe||$.checkProposedApiEnabled(Oe);try{return await ft.asExternalUri(te,{allowTunneling:!!Xe.remote.authority})}catch(Ae){if(fe)return te;throw Ae}},get remoteName(){return Re.getRemoteName(Xe.remote.authority)},get uiKind(){return Xe.uiKind}};Xe.environment.extensionTestsLocationURI||Object.freeze(wn);const bn=Xe.remote.isRemote?T.ExtensionKind.Workspace:T.ExtensionKind.UI,cn={registerTestController(te){return $.checkProposedApiEnabled(Oe),It.registerTestController(Oe.identifier.value,te)},createDocumentTestObserver(te){return $.checkProposedApiEnabled(Oe),It.createTextDocumentTestObserver(te)},createWorkspaceTestObserver(te){return $.checkProposedApiEnabled(Oe),It.createWorkspaceTestObserver(te)},runTests(te){return $.checkProposedApiEnabled(Oe),It.runTests(te)},createTestItem(te,fe){return new T.TestItemImpl(te.id,te.label,te.uri,fe)},createTestRun(te,fe,Ae){return $.checkProposedApiEnabled(Oe),It.createTestRun(Oe.identifier.value,te,fe,Ae)},get onDidChangeTestResults(){return $.checkProposedApiEnabled(Oe),It.onResultsChanged},get testResults(){return $.checkProposedApiEnabled(Oe),It.results}};cn.createTestRunTask=cn.createTestRun;const Ln={getExtension(te){const fe=an.getExtensionDescription(te);if(fe)return new r.Extension(_e,Oe.identifier,fe,bn)},get all(){return an.getAllExtensionDescriptions().map(te=>new r.Extension(_e,Oe.identifier,te,bn))},get onDidChange(){return an.onDidChange}},Fn={createDiagnosticCollection(te){return Ut.createDiagnosticCollection(Oe.identifier,te)},get onDidChangeDiagnostics(){return Ut.onDidChangeDiagnostics},getDiagnostics:te=>Ut.getDiagnostics(te),getLanguages(){return on.getLanguages()},setTextDocumentLanguage(te,fe){return on.changeLanguage(te.uri,fe)},match(te,fe){return s.score(H.LanguageSelector.from(te),fe.uri,fe.languageId,!0)},registerCodeActionsProvider(te,fe,Ae){return lt.registerCodeActionProvider(Oe,ht(te),fe,Ae)},registerCodeLensProvider(te,fe){return lt.registerCodeLensProvider(Oe,ht(te),fe)},registerDefinitionProvider(te,fe){return lt.registerDefinitionProvider(Oe,ht(te),fe)},registerDeclarationProvider(te,fe){return lt.registerDeclarationProvider(Oe,ht(te),fe)},registerImplementationProvider(te,fe){return lt.registerImplementationProvider(Oe,ht(te),fe)},registerTypeDefinitionProvider(te,fe){return lt.registerTypeDefinitionProvider(Oe,ht(te),fe)},registerHoverProvider(te,fe){return lt.registerHoverProvider(Oe,ht(te),fe,Oe.identifier)},registerEvaluatableExpressionProvider(te,fe){return lt.registerEvaluatableExpressionProvider(Oe,ht(te),fe,Oe.identifier)},registerInlineValuesProvider(te,fe){return lt.registerInlineValuesProvider(Oe,ht(te),fe,Oe.identifier)},registerDocumentHighlightProvider(te,fe){return lt.registerDocumentHighlightProvider(Oe,ht(te),fe)},registerLinkedEditingRangeProvider(te,fe){return lt.registerLinkedEditingRangeProvider(Oe,ht(te),fe)},registerReferenceProvider(te,fe){return lt.registerReferenceProvider(Oe,ht(te),fe)},registerRenameProvider(te,fe){return lt.registerRenameProvider(Oe,ht(te),fe)},registerDocumentSymbolProvider(te,fe,Ae){return lt.registerDocumentSymbolProvider(Oe,ht(te),fe,Ae)},registerWorkspaceSymbolProvider(te){return lt.registerWorkspaceSymbolProvider(Oe,te)},registerDocumentFormattingEditProvider(te,fe){return lt.registerDocumentFormattingEditProvider(Oe,ht(te),fe)},registerDocumentRangeFormattingEditProvider(te,fe){return lt.registerDocumentRangeFormattingEditProvider(Oe,ht(te),fe)},registerOnTypeFormattingEditProvider(te,fe,Ae,...ot){return lt.registerOnTypeFormattingEditProvider(Oe,ht(te),fe,[Ae].concat(ot))},registerDocumentSemanticTokensProvider(te,fe,Ae){return lt.registerDocumentSemanticTokensProvider(Oe,ht(te),fe,Ae)},registerDocumentRangeSemanticTokensProvider(te,fe,Ae){return lt.registerDocumentRangeSemanticTokensProvider(Oe,ht(te),fe,Ae)},registerSignatureHelpProvider(te,fe,Ae,...ot){return typeof Ae=="object"?lt.registerSignatureHelpProvider(Oe,ht(te),fe,Ae):lt.registerSignatureHelpProvider(Oe,ht(te),fe,typeof Ae=="undefined"?[]:[Ae,...ot])},registerCompletionItemProvider(te,fe,...Ae){return lt.registerCompletionItemProvider(Oe,ht(te),fe,Ae)},registerInlineCompletionItemProvider(te,fe){return $.checkProposedApiEnabled(Oe),lt.registerInlineCompletionsProvider(Oe,ht(te),fe)},registerDocumentLinkProvider(te,fe){return lt.registerDocumentLinkProvider(Oe,ht(te),fe)},registerColorProvider(te,fe){return lt.registerColorProvider(Oe,ht(te),fe)},registerFoldingRangeProvider(te,fe){return lt.registerFoldingRangeProvider(Oe,ht(te),fe)},registerSelectionRangeProvider(te,fe){return lt.registerSelectionRangeProvider(Oe,te,fe)},registerCallHierarchyProvider(te,fe){return lt.registerCallHierarchyProvider(Oe,te,fe)},setLanguageConfiguration:(te,fe)=>lt.setLanguageConfiguration(Oe,te,fe),getTokenInformationAtPosition(te,fe){return $.checkProposedApiEnabled(Oe),on.tokenAtPosition(te,fe)},registerInlayHintsProvider(te,fe){return $.checkProposedApiEnabled(Oe),lt.registerInlayHintsProvider(Oe,te,fe)}},Mn={get activeTextEditor(){return yt.getActiveTextEditor()},get visibleTextEditors(){return yt.getVisibleTextEditors()},get activeTerminal(){return mt.activeTerminal},get terminals(){return mt.terminals},async showTextDocument(te,fe,Ae){const ot=await(A.URI.isUri(te)?Promise.resolve(un.openTextDocument(te)):Promise.resolve(te));return yt.showTextDocument(ot,fe,Ae)},createTextEditorDecorationType(te){return yt.createTextEditorDecorationType(Oe,te)},onDidChangeActiveTextEditor(te,fe,Ae){return yt.onDidChangeActiveTextEditor(te,fe,Ae)},onDidChangeVisibleTextEditors(te,fe,Ae){return yt.onDidChangeVisibleTextEditors(te,fe,Ae)},onDidChangeTextEditorSelection(te,fe,Ae){return yt.onDidChangeTextEditorSelection(te,fe,Ae)},onDidChangeTextEditorOptions(te,fe,Ae){return yt.onDidChangeTextEditorOptions(te,fe,Ae)},onDidChangeTextEditorVisibleRanges(te,fe,Ae){return yt.onDidChangeTextEditorVisibleRanges(te,fe,Ae)},onDidChangeTextEditorViewColumn(te,fe,Ae){return yt.onDidChangeTextEditorViewColumn(te,fe,Ae)},onDidCloseTerminal(te,fe,Ae){return mt.onDidCloseTerminal(te,fe,Ae)},onDidOpenTerminal(te,fe,Ae){return mt.onDidOpenTerminal(te,fe,Ae)},onDidChangeActiveTerminal(te,fe,Ae){return mt.onDidChangeActiveTerminal(te,fe,Ae)},onDidChangeTerminalDimensions(te,fe,Ae){return $.checkProposedApiEnabled(Oe),mt.onDidChangeTerminalDimensions(te,fe,Ae)},onDidWriteTerminalData(te,fe,Ae){return $.checkProposedApiEnabled(Oe),mt.onDidWriteTerminalData(te,fe,Ae)},get state(){return ft.state},onDidChangeWindowState(te,fe,Ae){return ft.onDidChangeWindowState(te,fe,Ae)},showInformationMessage(te,...fe){return kt.showMessage(Oe,D.default.Info,te,fe[0],fe.slice(1))},showWarningMessage(te,...fe){return kt.showMessage(Oe,D.default.Warning,te,fe[0],fe.slice(1))},showErrorMessage(te,...fe){return kt.showMessage(Oe,D.default.Error,te,fe[0],fe.slice(1))},showQuickPick(te,fe,Ae){return Wt.showQuickPick(te,!!Oe.enableProposedApi,fe,Ae)},showWorkspaceFolderPick(te){return Wt.showWorkspaceFolderPick(te)},showInputBox(te,fe){return Wt.showInput(te,fe)},showOpenDialog(te){return zt.showOpenDialog(te)},showSaveDialog(te){return zt.showSaveDialog(te)},createStatusBarItem(te,fe,Ae){let ot,V,B;return typeof te=="string"?(ot=te,V=fe,B=Ae):(V=te,B=fe),pn.createStatusBarEntry(Oe,ot,V,B)},setStatusBarMessage(te,fe){return pn.setStatusBarMessage(te,fe)},withScmProgress(te){return vt.report("window.withScmProgress",Oe,"Use 'withProgress' instead."),Yt.withProgress(Oe,{location:T.ProgressLocation.SourceControl},(fe,Ae)=>te({report(ot){}}))},withProgress(te,fe){return Yt.withProgress(Oe,te,fe)},createOutputChannel(te){return Lt.createOutputChannel(te)},createWebviewPanel(te,fe,Ae,ot){return Bt.createWebviewPanel(Oe,te,fe,Ae,ot)},createWebviewTextEditorInset(te,fe,Ae,ot){return $.checkProposedApiEnabled(Oe),yn.createWebviewEditorInset(te,fe,Ae,ot,Oe)},createTerminal(te,fe,Ae){return typeof te=="object"?"pty"in te?mt.createExtensionTerminal(te):(te.iconPath&&$.checkProposedApiEnabled(Oe),mt.createTerminalFromOptions(te)):mt.createTerminal(te,fe,Ae)},registerTerminalLinkProvider(te){return mt.registerLinkProvider(te)},registerTerminalProfileProvider(te,fe){return mt.registerProfileProvider(te,fe)},registerTreeDataProvider(te,fe){return Xt.registerTreeDataProvider(te,fe,Oe)},createTreeView(te,fe){return Xt.createTreeView(te,fe,Oe)},registerWebviewPanelSerializer:(te,fe)=>Bt.registerWebviewPanelSerializer(Oe,te,fe),registerCustomEditorProvider:(te,fe,Ae={})=>Pn.registerCustomEditorProvider(Oe,te,fe,Ae),registerFileDecorationProvider(te){return Rt.registerFileDecorationProvider(te,Oe.identifier)},registerUriHandler(te){return Kt.registerUriHandler(Oe.identifier,te)},createQuickPick(){return Wt.createQuickPick(Oe.identifier,!!Oe.enableProposedApi)},createInputBox(){return Wt.createInputBox(Oe.identifier)},get activeColorTheme(){return gn.activeColorTheme},onDidChangeActiveColorTheme(te,fe,Ae){return gn.onDidChangeActiveColorTheme(te,fe,Ae)},registerWebviewViewProvider(te,fe,Ae){return In.registerWebviewViewProvider(Oe,te,fe,Ae==null?void 0:Ae.webviewOptions)},get activeNotebookEditor(){return $.checkProposedApiEnabled(Oe),gt.activeNotebookEditor},onDidChangeActiveNotebookEditor(te,fe,Ae){return $.checkProposedApiEnabled(Oe),gt.onDidChangeActiveNotebookEditor(te,fe,Ae)},get visibleNotebookEditors(){return $.checkProposedApiEnabled(Oe),gt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return $.checkProposedApiEnabled(Oe),gt.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(te,fe,Ae){return $.checkProposedApiEnabled(Oe),en.onDidChangeNotebookEditorSelection(te,fe,Ae)},onDidChangeNotebookEditorVisibleRanges(te,fe,Ae){return $.checkProposedApiEnabled(Oe),en.onDidChangeNotebookEditorVisibleRanges(te,fe,Ae)},showNotebookDocument(te,fe){return $.checkProposedApiEnabled(Oe),gt.showNotebookDocument(te,fe)},registerExternalUriOpener(te,fe,Ae){return $.checkProposedApiEnabled(Oe),An.registerExternalUriOpener(Oe.identifier,te,fe,Ae)},get openEditors(){return $.checkProposedApiEnabled(Oe),bt.tabs},get onDidChangeOpenEditors(){return $.checkProposedApiEnabled(Oe),bt.onDidChangeTabs},getInlineCompletionItemController(te){return $.checkProposedApiEnabled(Oe),g.InlineCompletionController.get(te)}},un={get rootPath(){return vt.report("workspace.rootPath",Oe,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),ye.getPath()},set rootPath(te){throw R.readonly()},getWorkspaceFolder(te){return ye.getWorkspaceFolder(te)},get workspaceFolders(){return ye.getWorkspaceFolders()},get name(){return ye.name},set name(te){throw R.readonly()},get workspaceFile(){return ye.workspaceFile},set workspaceFile(te){throw R.readonly()},updateWorkspaceFolders:(te,fe,...Ae)=>ye.updateWorkspaceFolders(Oe,te,fe||0,...Ae),onDidChangeWorkspaceFolders:function(te,fe,Ae){return ye.onDidChangeWorkspace(te,fe,Ae)},asRelativePath:(te,fe)=>ye.getRelativePath(te,fe),findFiles:(te,fe,Ae,ot)=>ye.findFiles(H.GlobPattern.from(te),H.GlobPattern.from(fe),Ae,Oe.identifier,ot),findTextInFiles:(te,fe,Ae,ot)=>{let V,B;return typeof fe=="object"?(V=fe,B=Ae):(V={},B=fe,ot=Ae),ye.findTextInFiles(te,V||{},B,Oe.identifier,ot)},saveAll:te=>ye.saveAll(te),applyEdit(te){return Mt.applyWorkspaceEdit(te)},createFileSystemWatcher:(te,fe,Ae,ot)=>Ft.createFileSystemWatcher(H.GlobPattern.from(te),fe,Ae,ot),get textDocuments(){return _t.getAllDocumentData().map(te=>te.document)},set textDocuments(te){throw R.readonly()},openTextDocument(te){let fe;const Ae=te;if(typeof te=="string")fe=Promise.resolve(A.URI.file(te));else if(A.URI.isUri(te))fe=Promise.resolve(te);else if(!Ae||typeof Ae=="object")fe=_t.createDocumentData(Ae);else throw new Error("illegal argument - uriOrFileNameOrOptions");return fe.then(ot=>_t.ensureDocumentData(ot).then(V=>V.document))},onDidOpenTextDocument:(te,fe,Ae)=>_t.onDidAddDocument(te,fe,Ae),onDidCloseTextDocument:(te,fe,Ae)=>_t.onDidRemoveDocument(te,fe,Ae),onDidChangeTextDocument:(te,fe,Ae)=>_t.onDidChangeDocument(te,fe,Ae),onDidSaveTextDocument:(te,fe,Ae)=>_t.onDidSaveDocument(te,fe,Ae),onWillSaveTextDocument:(te,fe,Ae)=>Zt.getOnWillSaveTextDocumentEvent(Oe)(te,fe,Ae),get notebookDocuments(){return gt.notebookDocuments.map(te=>te.apiNotebook)},async openNotebookDocument(te,fe){let Ae;if(A.URI.isUri(te))Ae=te,await gt.openNotebookDocument(te);else if(typeof te=="string")Ae=A.URI.revive(await gt.createNotebookDocument({viewType:te,content:fe}));else throw new Error("Invalid arguments");return gt.getNotebookDocument(Ae).apiNotebook},get onDidOpenNotebookDocument(){return gt.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return gt.onDidCloseNotebookDocument},registerNotebookSerializer(te,fe,Ae,ot){return gt.registerNotebookSerializer(Oe,te,fe,Ae,Oe.enableProposedApi?ot:void 0)},registerNotebookContentProvider:(te,fe,Ae,ot)=>($.checkProposedApiEnabled(Oe),gt.registerNotebookContentProvider(Oe,te,fe,Ae,Oe.enableProposedApi?ot:void 0)),onDidChangeConfiguration:(te,fe,Ae)=>vn.onDidChangeConfiguration(te,fe,Ae),getConfiguration(te,fe){return fe=arguments.length===1?void 0:fe,vn.getConfiguration(te,fe,Oe)},registerTextDocumentContentProvider(te,fe){return Jt.registerTextDocumentContentProvider(te,fe)},registerTaskProvider:(te,fe)=>(vt.report("window.registerTaskProvider",Oe,"Use the corresponding function on the 'tasks' namespace instead"),Dt.registerTaskProvider(Oe,te,fe)),registerFileSystemProvider(te,fe,Ae){return Dn.registerFileSystemProvider(Oe.identifier,te,fe,Ae,Oe.enableProposedApi)},get fs(){return pt.value},registerFileSearchProvider:(te,fe)=>($.checkProposedApiEnabled(Oe),Pt.registerFileSearchProvider(te,fe)),registerTextSearchProvider:(te,fe)=>($.checkProposedApiEnabled(Oe),Pt.registerTextSearchProvider(te,fe)),registerRemoteAuthorityResolver:(te,fe)=>($.checkProposedApiEnabled(Oe),_e.registerRemoteAuthorityResolver(te,fe)),registerResourceLabelFormatter:te=>($.checkProposedApiEnabled(Oe),rn.$registerResourceLabelFormatter(te)),onDidCreateFiles:(te,fe,Ae)=>Ft.onDidCreateFile(te,fe,Ae),onDidDeleteFiles:(te,fe,Ae)=>Ft.onDidDeleteFile(te,fe,Ae),onDidRenameFiles:(te,fe,Ae)=>Ft.onDidRenameFile(te,fe,Ae),onWillCreateFiles:(te,fe,Ae)=>Ft.getOnWillCreateFileEvent(Oe)(te,fe,Ae),onWillDeleteFiles:(te,fe,Ae)=>Ft.getOnWillDeleteFileEvent(Oe)(te,fe,Ae),onWillRenameFiles:(te,fe,Ae)=>Ft.getOnWillRenameFileEvent(Oe)(te,fe,Ae),openTunnel:te=>($.checkProposedApiEnabled(Oe),st.openTunnel(Oe,te).then(fe=>{if(!fe)throw new Error("cannot open tunnel");return fe})),get tunnels(){return $.checkProposedApiEnabled(Oe),st.getTunnels()},onDidChangeTunnels:(te,fe,Ae)=>($.checkProposedApiEnabled(Oe),st.onDidChangeTunnels(te,fe,Ae)),registerPortAttributesProvider:(te,fe)=>($.checkProposedApiEnabled(Oe),st.registerPortsAttributesProvider(te,fe)),registerTimelineProvider:(te,fe)=>($.checkProposedApiEnabled(Oe),kn.registerTimelineProvider(te,fe,Oe.identifier,ut.converter)),get isTrusted(){return ye.trusted},requestWorkspaceTrust:te=>($.checkProposedApiEnabled(Oe),ye.requestWorkspaceTrust(te)),onDidGrantWorkspaceTrust:(te,fe,Ae)=>ye.onDidGrantWorkspaceTrust(te,fe,Ae)},En={get inputBox(){return vt.report("scm.inputBox",Oe,"Use 'SourceControl.inputBox' instead"),mn.getLastInputBox(Oe)},createSourceControl(te,fe,Ae){return mn.createSourceControl(Oe,te,fe,Ae)}},$t={createCommentController(te,fe){return Cn.createCommentController(Oe,te,fe)}},Vt={get activeDebugSession(){return dt.activeDebugSession},get activeDebugConsole(){return dt.activeDebugConsole},get breakpoints(){return dt.breakpoints},onDidStartDebugSession(te,fe,Ae){return dt.onDidStartDebugSession(te,fe,Ae)},onDidTerminateDebugSession(te,fe,Ae){return dt.onDidTerminateDebugSession(te,fe,Ae)},onDidChangeActiveDebugSession(te,fe,Ae){return dt.onDidChangeActiveDebugSession(te,fe,Ae)},onDidReceiveDebugSessionCustomEvent(te,fe,Ae){return dt.onDidReceiveDebugSessionCustomEvent(te,fe,Ae)},onDidChangeBreakpoints(te,fe,Ae){return dt.onDidChangeBreakpoints(te,fe,Ae)},registerDebugConfigurationProvider(te,fe,Ae){return dt.registerDebugConfigurationProvider(te,fe,Ae||T.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(te,fe){return dt.registerDebugAdapterDescriptorFactory(Oe,te,fe)},registerDebugAdapterTrackerFactory(te,fe){return dt.registerDebugAdapterTrackerFactory(te,fe)},startDebugging(te,fe,Ae){return!Ae||typeof Ae=="object"&&"configuration"in Ae?dt.startDebugging(te,fe,{parentSession:Ae}):dt.startDebugging(te,fe,Ae||{})},stopDebugging(te){return dt.stopDebugging(te)},addBreakpoints(te){return dt.addBreakpoints(te)},removeBreakpoints(te){return dt.removeBreakpoints(te)},asDebugSourceUri(te,fe){return dt.asDebugSourceUri(te,fe)}},On={registerTaskProvider:(te,fe)=>Dt.registerTaskProvider(Oe,te,fe),fetchTasks:te=>Dt.fetchTasks(te),executeTask:te=>Dt.executeTask(Oe,te),get taskExecutions(){return Dt.taskExecutions},onDidStartTask:(te,fe,Ae)=>Dt.onDidStartTask(te,fe,Ae),onDidEndTask:(te,fe,Ae)=>Dt.onDidEndTask(te,fe,Ae),onDidStartTaskProcess:(te,fe,Ae)=>Dt.onDidStartTaskProcess(te,fe,Ae),onDidEndTaskProcess:(te,fe,Ae)=>Dt.onDidEndTaskProcess(te,fe,Ae)},dn={createNotebookController(te,fe,Ae,ot,V){return tn.createNotebookController(Oe,te,fe,Ae,ot,Oe.enableProposedApi?V:void 0)},registerNotebookCellStatusBarItemProvider:(te,fe)=>gt.registerNotebookCellStatusBarItemProvider(Oe,te,fe),get onDidSaveNotebookDocument(){return $.checkProposedApiEnabled(Oe),Qt.onDidSaveNotebookDocument},createNotebookEditorDecorationType(te){return $.checkProposedApiEnabled(Oe),en.createNotebookEditorDecorationType(te)},createRendererMessaging(te){return $.checkProposedApiEnabled(Oe),nn.createRendererMessaging(te)},onDidChangeNotebookDocumentMetadata(te,fe,Ae){return $.checkProposedApiEnabled(Oe),Qt.onDidChangeNotebookDocumentMetadata(te,fe,Ae)},onDidChangeNotebookCells(te,fe,Ae){return $.checkProposedApiEnabled(Oe),gt.onDidChangeNotebookCells(te,fe,Ae)},onDidChangeNotebookCellExecutionState(te,fe,Ae){return $.checkProposedApiEnabled(Oe),gt.onDidChangeNotebookCellExecutionState(te,fe,Ae)},onDidChangeCellOutputs(te,fe,Ae){return $.checkProposedApiEnabled(Oe),gt.onDidChangeCellOutputs(te,fe,Ae)},onDidChangeCellMetadata(te,fe,Ae){return $.checkProposedApiEnabled(Oe),gt.onDidChangeCellMetadata(te,fe,Ae)},createConcatTextDocument(te,fe){return $.checkProposedApiEnabled(Oe),new Ee.ExtHostNotebookConcatDocument(gt,_t,te,fe)}};return{version:Xe.version,authentication:Rn,commands:ln,comments:$t,debug:Vt,env:wn,extensions:Ln,languages:Fn,notebooks:dn,scm:En,tasks:On,test:cn,window:Mn,workspace:un,Breakpoint:T.Breakpoint,CallHierarchyIncomingCall:T.CallHierarchyIncomingCall,CallHierarchyItem:T.CallHierarchyItem,CallHierarchyOutgoingCall:T.CallHierarchyOutgoingCall,CancellationError:R.CancellationError,CancellationTokenSource:v.CancellationTokenSource,CandidatePortSource:l.CandidatePortSource,CodeAction:T.CodeAction,CodeActionKind:T.CodeActionKind,CodeActionTriggerKind:T.CodeActionTriggerKind,CodeLens:T.CodeLens,Color:T.Color,ColorInformation:T.ColorInformation,ColorPresentation:T.ColorPresentation,ColorThemeKind:T.ColorThemeKind,CommentMode:T.CommentMode,CommentThreadCollapsibleState:T.CommentThreadCollapsibleState,CompletionItem:T.CompletionItem,CompletionItemKind:T.CompletionItemKind,CompletionItemTag:T.CompletionItemTag,CompletionList:T.CompletionList,CompletionTriggerKind:T.CompletionTriggerKind,ConfigurationTarget:T.ConfigurationTarget,CustomExecution:T.CustomExecution,DebugAdapterExecutable:T.DebugAdapterExecutable,DebugAdapterInlineImplementation:T.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:T.DebugAdapterNamedPipeServer,DebugAdapterServer:T.DebugAdapterServer,DebugConfigurationProviderTriggerKind:T.DebugConfigurationProviderTriggerKind,DebugConsoleMode:T.DebugConsoleMode,DecorationRangeBehavior:T.DecorationRangeBehavior,Diagnostic:T.Diagnostic,DiagnosticRelatedInformation:T.DiagnosticRelatedInformation,DiagnosticSeverity:T.DiagnosticSeverity,DiagnosticTag:T.DiagnosticTag,Disposable:T.Disposable,DocumentHighlight:T.DocumentHighlight,DocumentHighlightKind:T.DocumentHighlightKind,DocumentLink:T.DocumentLink,DocumentSymbol:T.DocumentSymbol,EndOfLine:T.EndOfLine,EnvironmentVariableMutatorType:T.EnvironmentVariableMutatorType,EvaluatableExpression:T.EvaluatableExpression,InlineValueText:T.InlineValueText,InlineValueVariableLookup:T.InlineValueVariableLookup,InlineValueEvaluatableExpression:T.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:T.InlineCompletionTriggerKind,EventEmitter:k.Emitter,ExtensionKind:T.ExtensionKind,ExtensionMode:T.ExtensionMode,ExternalUriOpenerPriority:T.ExternalUriOpenerPriority,FileChangeType:T.FileChangeType,FileDecoration:T.FileDecoration,FileSystemError:T.FileSystemError,FileType:I.FileType,FilePermission:I.FilePermission,FoldingRange:T.FoldingRange,FoldingRangeKind:T.FoldingRangeKind,FunctionBreakpoint:T.FunctionBreakpoint,InlineCompletionItem:T.InlineSuggestion,InlineCompletionList:T.InlineSuggestions,Hover:T.Hover,IndentAction:C.IndentAction,Location:T.Location,MarkdownString:T.MarkdownString,OverviewRulerLane:_.OverviewRulerLane,ParameterInformation:T.ParameterInformation,PortAutoForwardAction:T.PortAutoForwardAction,Position:T.Position,ProcessExecution:T.ProcessExecution,ProgressLocation:T.ProgressLocation,QuickInputButtons:T.QuickInputButtons,Range:T.Range,RelativePattern:T.RelativePattern,Selection:T.Selection,SelectionRange:T.SelectionRange,SemanticTokens:T.SemanticTokens,SemanticTokensBuilder:T.SemanticTokensBuilder,SemanticTokensEdit:T.SemanticTokensEdit,SemanticTokensEdits:T.SemanticTokensEdits,SemanticTokensLegend:T.SemanticTokensLegend,ShellExecution:T.ShellExecution,ShellQuoting:T.ShellQuoting,SignatureHelp:T.SignatureHelp,SignatureHelpTriggerKind:T.SignatureHelpTriggerKind,SignatureInformation:T.SignatureInformation,SnippetString:T.SnippetString,SourceBreakpoint:T.SourceBreakpoint,StandardTokenType:T.StandardTokenType,StatusBarAlignment:T.StatusBarAlignment,SymbolInformation:T.SymbolInformation,SymbolKind:T.SymbolKind,SymbolTag:T.SymbolTag,Task:T.Task,TaskGroup:T.TaskGroup,TaskPanelKind:T.TaskPanelKind,TaskRevealKind:T.TaskRevealKind,TaskScope:T.TaskScope,TextDocumentSaveReason:T.TextDocumentSaveReason,TextEdit:T.TextEdit,TextEditorCursorStyle:P.TextEditorCursorStyle,TextEditorLineNumbersStyle:T.TextEditorLineNumbersStyle,TextEditorRevealType:T.TextEditorRevealType,TextEditorSelectionChangeKind:T.TextEditorSelectionChangeKind,ThemeColor:T.ThemeColor,ThemeIcon:T.ThemeIcon,TreeItem:T.TreeItem,TreeItemCollapsibleState:T.TreeItemCollapsibleState,UIKind:l.UIKind,Uri:A.URI,ViewColumn:T.ViewColumn,WorkspaceEdit:T.WorkspaceEdit,InlayHint:T.InlayHint,InlayHintKind:T.InlayHintKind,RemoteAuthorityResolverError:T.RemoteAuthorityResolverError,ResolvedAuthority:T.ResolvedAuthority,SourceControlInputBoxValidationType:T.SourceControlInputBoxValidationType,ExtensionRuntime:T.ExtensionRuntime,TimelineItem:T.TimelineItem,NotebookRange:T.NotebookRange,NotebookCellKind:T.NotebookCellKind,NotebookCellExecutionState:T.NotebookCellExecutionState,NotebookCellData:T.NotebookCellData,NotebookData:T.NotebookData,NotebookRendererScript:T.NotebookRendererScript,NotebookCellStatusBarAlignment:T.NotebookCellStatusBarAlignment,NotebookEditorRevealType:T.NotebookEditorRevealType,NotebookCellOutput:T.NotebookCellOutput,NotebookCellOutputItem:T.NotebookCellOutputItem,NotebookCellStatusBarItem:T.NotebookCellStatusBarItem,NotebookControllerAffinity:T.NotebookControllerAffinity,PortAttributes:T.PortAttributes,LinkedEditingRanges:T.LinkedEditingRanges,TestItemStatus:T.TestItemStatus,TestResultState:T.TestResultState,TestMessage:T.TestMessage,TextSearchCompleteMessageType:ee.TextSearchCompleteMessageType,TestMessageSeverity:T.TestMessageSeverity,WorkspaceTrustState:T.WorkspaceTrustState}}}e.createApiFactoryAndRegisterActors=Ze}),define(ge[261],pe([0,1,77,61,34,126,36,48,39,33,64,49,66,90,89,47,60,127,88,58,87,118,46]),function(Q,e,v,R,k,D,A,P,_,C,s,I,l,m,c,h,S,w,b,u,d,p,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),v.registerSingleton(m.IExtensionStoragePaths,m.ExtensionStoragePaths),v.registerSingleton(S.IExtHostApiDeprecationService,S.ExtHostApiDeprecationService),v.registerSingleton(P.IExtHostCommands,P.ExtHostCommands),v.registerSingleton(A.IExtHostConfiguration,A.ExtHostConfiguration),v.registerSingleton(b.IExtHostConsumerFileSystem,b.ExtHostConsumerFileSystem),v.registerSingleton(I.IExtHostDebugService,I.WorkerExtHostDebugService),v.registerSingleton(D.IExtHostDecorations,D.ExtHostDecorations),v.registerSingleton(_.IExtHostDocumentsAndEditors,_.ExtHostDocumentsAndEditors),v.registerSingleton(u.IExtHostFileSystemInfo,u.ExtHostFileSystemInfo),v.registerSingleton(R.IExtHostOutputService,R.ExtHostOutputService),v.registerSingleton(l.IExtHostSearch,l.ExtHostSearch),v.registerSingleton(c.IExtHostStorage,c.ExtHostStorage),v.registerSingleton(s.IExtHostTask,s.WorkerExtHostTask),v.registerSingleton(C.IExtHostTerminalService,C.WorkerExtHostTerminalService),v.registerSingleton(h.IExtHostTunnelService,h.ExtHostTunnelService),v.registerSingleton(w.IExtHostWindow,w.ExtHostWindow),v.registerSingleton(k.IExtHostWorkspace,k.ExtHostWorkspace),v.registerSingleton(d.IExtHostSecretState,d.ExtHostSecretState),v.registerSingleton(p.IExtHostTelemetry,p.ExtHostTelemetry),v.registerSingleton(t.IExtHostEditorTabs,t.ExtHostEditorTabs)}),define(ge[91],pe([0,1,18,12,31,63]),function(Q,e,v,R,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutputChannel=e.createTextSearchResult=e.anchorGlob=void 0;function A(I){return I.startsWith("**")||I.startsWith("/")?I:`/${I}`}e.anchorGlob=A;function P(I,l,m,c){const h=v.mapArrayOrNot(m,_),S=new k.TextSearchMatch(l,h,c),w=S.preview.matches;return{ranges:v.mapArrayOrNot(h,C),uri:I,preview:{text:S.preview.text,matches:v.mapArrayOrNot(w,C)}}}e.createTextSearchResult=P;function _(I){return new k.SearchRange(I.start.line,I.start.character,I.end.line,I.end.character)}function C(I){return new D.Range(I.startLineNumber,I.startColumn,I.endLineNumber,I.endColumn)}let s=class{constructor(l,m){this.prefix=l,this.logService=m}appendLine(l){this.logService.debug(`${this.prefix}#search`,l)}};s=Ve([$e(1,R.ILogService)],s),e.OutputChannel=s}),define(ge[262],pe([0,1,93,22]),function(Q,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SUPPORTED_ENCODINGS=e.detectEncodingFromBuffer=e.toCanonicalName=e.detectEncodingByBOMFromBuffer=e.toNodeEncoding=e.encodingExists=e.toEncodeReadable=e.toDecodeStream=e.UTF8_BOM=e.UTF16le_BOM=e.UTF16be_BOM=e.isUTFEncoding=e.UTF16le=e.UTF16be=e.UTF8_with_bom=e.UTF8=void 0,e.UTF8="utf8",e.UTF8_with_bom="utf8bom",e.UTF16be="utf16be",e.UTF16le="utf16le";function k(t){return[e.UTF8,e.UTF8_with_bom,e.UTF16be,e.UTF16le].some(i=>i===t)}e.isUTFEncoding=k,e.UTF16be_BOM=[254,255],e.UTF16le_BOM=[255,254],e.UTF8_BOM=[239,187,191];const D=512,A=512,P=512*8,_=512*128;class C{constructor(i){this.iconvLiteDecoder=i}static async create(i){let r;if(i!==e.UTF8)r=(await new Promise((o,g)=>{Q(["iconv-lite-umd"],o,g)})).getDecoder(m(i));else{const n=new TextDecoder;r={write(o){return n.decode(o,{stream:!0})},end(){return n.decode()}}}return new C(r)}write(i){return this.iconvLiteDecoder.write(i)}end(){return this.iconvLiteDecoder.end()}}function s(t,i){var r;const n=((r=i.minBytesRequiredForDetection)!==null&&r!==void 0?r:i.guessEncoding)?P:A;return new Promise((o,g)=>{const f=v.newWriteableStream(O=>O.join("")),E=[];let y=0,a;const L=async()=>{try{const O=await p({buffer:R.VSBuffer.concat(E),bytesRead:y},i.guessEncoding);O.encoding=await i.overwriteEncoding(O.encoding),a=await C.create(O.encoding);const W=a.write(R.VSBuffer.concat(E).buffer);f.write(W),E.length=0,y=0,o({stream:f,detected:O})}catch(O){g(O)}};v.listenStream(t,{onData:async O=>{a?f.write(a.write(O.buffer)):(E.push(O),y+=O.byteLength,y>=n&&(t.pause(),await L(),setTimeout(()=>t.resume())))},onError:O=>f.error(O),onEnd:async()=>{a||await L(),f.end(a==null?void 0:a.end())}})})}e.toDecodeStream=s;async function I(t,i,r){const o=(await new Promise((E,y)=>{Q(["iconv-lite-umd"],E,y)})).getEncoder(m(i),r);let g=!1,f=!1;return{read(){if(f)return null;const E=t.read();if(typeof E!="string"){if(f=!0,!g&&(r==null?void 0:r.addBOM))switch(i){case e.UTF8:case e.UTF8_with_bom:return R.VSBuffer.wrap(Uint8Array.from(e.UTF8_BOM));case e.UTF16be:return R.VSBuffer.wrap(Uint8Array.from(e.UTF16be_BOM));case e.UTF16le:return R.VSBuffer.wrap(Uint8Array.from(e.UTF16le_BOM))}const y=o.end();return y&&y.length>0?(g=!0,R.VSBuffer.wrap(y)):null}return g=!0,R.VSBuffer.wrap(o.write(E))}}}e.toEncodeReadable=I;async function l(t){return(await new Promise((r,n)=>{Q(["iconv-lite-umd"],r,n)})).encodingExists(m(t))}e.encodingExists=l;function m(t){return t===e.UTF8_with_bom||t===null?e.UTF8:t}e.toNodeEncoding=m;function c(t,i){if(!t||i<e.UTF16be_BOM.length)return null;const r=t.readUInt8(0),n=t.readUInt8(1);if(r===e.UTF16be_BOM[0]&&n===e.UTF16be_BOM[1])return e.UTF16be;if(r===e.UTF16le_BOM[0]&&n===e.UTF16le_BOM[1])return e.UTF16le;if(i<e.UTF8_BOM.length)return null;const o=t.readUInt8(2);return r===e.UTF8_BOM[0]&&n===e.UTF8_BOM[1]&&o===e.UTF8_BOM[2]?e.UTF8_with_bom:null}e.detectEncodingByBOMFromBuffer=c;const h=["ascii","utf-16","utf-32"];async function S(t){const i=await new Promise((f,E)=>{Q(["jschardet"],f,E)}),r=t.slice(0,_),n=u(r.buffer),o=i.detect(n);if(!o||!o.encoding)return null;const g=o.encoding.toLowerCase();return 0<=h.indexOf(g)?null:b(o.encoding)}const w={ibm866:"cp866",big5:"cp950"};function b(t){const i=t.replace(/[^a-zA-Z0-9]/g,"").toLowerCase();return w[i]||i}function u(t){let i="";for(let r=0;r<t.length;r++)i+=String.fromCharCode(t[r]);return i}function d(t){switch(t){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:const i=t.match(/windows(\d+)/);return i?"windows-"+i[1]:t}}e.toCanonicalName=d;function p({buffer:t,bytesRead:i},r){let n=c(t,i),o=!1;if(n!==e.UTF16be&&n!==e.UTF16le&&t){let g=!0,f=!0,E=!1;for(let y=0;y<i&&y<D;y++){const a=y%2==1,L=t.readUInt8(y)===0;if(L&&(E=!0),g&&(a&&!L||!a&&L)&&(g=!1),f&&(a&&L||!a&&!L)&&(f=!1),L&&!g&&!f)break}E&&(g?n=e.UTF16le:f?n=e.UTF16be:o=!0)}return r&&!o&&!n&&t?S(t.slice(0,i)).then(g=>({seemsBinary:!1,encoding:g})):{seemsBinary:o,encoding:n}}e.detectEncodingFromBuffer=p,e.SUPPORTED_ENCODINGS={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}}}),define(ge[129],pe([0,1,262,28,128]),function(Q,e,v,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeTextSearchManager=void 0;class D extends k.TextSearchManager{constructor(P,_,C=R){super(P,_,{readdir:s=>C.Promises.readdir(s.fsPath),toCanonicalName:s=>v.toCanonicalName(s)})}}e.NativeTextSearchManager=D}),define(ge[263],pe([0,1,264,278,279,2,280]),function(Q,e,v,R,k,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connectProxyResolver=void 0;function P(I,l,m,c,h,S){const w=S.environment.useHostProxy,b=typeof w=="boolean"?w:!S.remote.isRemote,u=A.createProxyResolver({resolveProxy:p=>I.resolveProxy(p),getHttpProxySetting:()=>l.getConfiguration("http").get("proxy"),log:(p,t,...i)=>{switch(p){case A.LogLevel.Trace:c.trace(t,...i);break;case A.LogLevel.Debug:c.debug(t,...i);break;case A.LogLevel.Info:c.info(t,...i);break;case A.LogLevel.Warning:c.warn(t,...i);break;case A.LogLevel.Error:c.error(t,...i);break;case A.LogLevel.Critical:c.critical(t,...i);break;case A.LogLevel.Off:break;default:r(p,t,i);break}function r(n,o,...g){c.error("Unknown log level",n),c.error(o,...g)}},getLogLevel:()=>c.getLevel(),proxyResolveTelemetry:p=>{h.$publicLog2("resolveProxy",p)},useHostProxy:b,env:process.env}),d=_(l,u);return s(m,d)}e.connectProxyResolver=P;function _(I,l){const m={config:I.getConfiguration("http").get("proxySupport")||"off"};I.onDidChangeConfiguration(h=>{m.config=I.getConfiguration("http").get("proxySupport")||"off"});const c={config:!!I.getConfiguration("http").get("systemCertificates")};return I.onDidChangeConfiguration(h=>{c.config=!!I.getConfiguration("http").get("systemCertificates")}),{http:{off:Object.assign({},v,A.createHttpPatch(v,l,{config:"off"},c,!0)),on:Object.assign({},v,A.createHttpPatch(v,l,{config:"on"},c,!0)),override:Object.assign({},v,A.createHttpPatch(v,l,{config:"override"},c,!0)),onRequest:Object.assign({},v,A.createHttpPatch(v,l,m,c,!0)),default:Object.assign(v,A.createHttpPatch(v,l,m,c,!1))},https:{off:Object.assign({},R,A.createHttpPatch(R,l,{config:"off"},c,!0)),on:Object.assign({},R,A.createHttpPatch(R,l,{config:"on"},c,!0)),override:Object.assign({},R,A.createHttpPatch(R,l,{config:"override"},c,!0)),onRequest:Object.assign({},R,A.createHttpPatch(R,l,m,c,!0)),default:Object.assign(R,A.createHttpPatch(R,l,m,c,!1))},tls:Object.assign(k,A.createTlsPatch(k))}}const C=new Map;function s(I,l){return I.getExtensionPathIndex().then(m=>{const c=Q.__$__nodeRequire("module"),h=c._load;c._load=function(w,b,u){if(w==="tls")return l.tls;if(w!=="http"&&w!=="https")return h.apply(this,arguments);const d=l[w],p=m.findSubstr(D.URI.file(b.filename).fsPath);let t=C.get(p);if(t||C.set(p,t={}),!t[w]){let i=d.default;p&&p.enableProposedApi&&(i=d[p.proxySupport]||d.onRequest),t[w]=Object.assign({},i)}return t[w]}})}}),define(ge[265],pe([0,1,38,9,74,29,11,8,91,266]),function(Q,e,v,R,k,D,A,P,_,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixDriveC=e.getAbsoluteGlob=e.foldersToIncludeGlobs=e.foldersToRgExcludeGlobs=e.spawnRipgrepCmd=void 0;const s=C.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function I(u,d,p,t){const i=l(u,d,p,t),r=d.folder.fsPath;return{cmd:v.spawn(s,i.args,{cwd:r}),rgDiskPath:s,siblingClauses:i.siblingClauses,rgArgs:i,cwd:r}}e.spawnRipgrepCmd=I;function l(u,d,p,t){const i=["--files","--hidden","--case-sensitive"];c([d],p,!1).forEach(n=>{const o=_.anchorGlob(n);if(i.push("-g",o),A.isMacintosh){const g=k.normalizeNFD(o);g!==o&&i.push("-g",g)}});const r=m([d],t,void 0,!1);return r.globArgs.forEach(n=>{const o=`!${_.anchorGlob(n)}`;if(i.push("-g",o),A.isMacintosh){const g=k.normalizeNFD(o);g!==o&&i.push("-g",g)}}),d.disregardIgnoreFiles!==!1?i.push("--no-ignore"):i.push("--no-ignore-parent"),d.ignoreSymlinks||i.push("--follow"),u.exists&&i.push("--quiet"),i.push("--no-config"),d.disregardGlobalIgnoreFiles&&i.push("--no-ignore-global"),{args:i,siblingClauses:r.siblingClauses}}function m(u,d,p,t=!0){const i=[];let r={};return u.forEach(n=>{const o=Object.assign({},n.excludePattern||{},d||{}),g=h(o,t?n.folder.fsPath:void 0,p);i.push(...g.globArgs),g.siblingClauses&&(r=Object.assign(r,g.siblingClauses))}),{globArgs:i,siblingClauses:r}}e.foldersToRgExcludeGlobs=m;function c(u,d,p=!0){const t=[];return u.forEach(i=>{const r=Object.assign({},d||{},i.includePattern||{}),n=h(r,p?i.folder.fsPath:void 0);t.push(...n.globArgs)}),t}e.foldersToIncludeGlobs=c;function h(u,d,p){const t=[],i={};return Object.keys(u).forEach(r=>{if(p&&p.has(r)||!r)return;const n=u[r];r=w(d?S(d,r):r),r.startsWith("\\\\")?r="\\\\"+r.substr(2).replace(/\\/g,"/"):r=r.replace(/\\/g,"/"),typeof n=="boolean"&&n?(r.startsWith("\\\\")&&(r+="**"),t.push(b(r))):n&&n.when&&(i[r]=n)}),{globArgs:t,siblingClauses:i}}function S(u,d){return R.isAbsolute(d)?d:R.join(u,d)}e.getAbsoluteGlob=S;function w(u){return u=P.rtrim(u,"\\"),P.rtrim(u,"/")}function b(u){return D.getRoot(u).toLowerCase()==="c:/"?u.replace(/^c:[/\\]/i,"/"):u}e.fixDriveC=b}),define(ge[267],pe([0,1,38,55,9,101,18,56,30,74,29,11,43,8,15,28,31,265,98]),function(Q,e,v,R,k,D,A,P,_,C,s,I,l,m,c,h,S,w,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.rgErrorMsgForDisplay=e.Engine=e.FileWalker=void 0;const u=new Set;process.on("exit",()=>{u.forEach(r=>r())});class d{constructor(n){this.normalizedFilePatternLowercase=null,this.maxFilesize=null,this.isCanceled=!1,this.fileWalkSW=null,this.cmdSW=null,this.cmdResultCount=0,this.config=n,this.filePattern=n.filePattern||"",this.includePattern=n.includePattern&&_.parse(n.includePattern),this.maxResults=n.maxResults||null,this.exists=!!n.exists,this.walkedPaths=Object.create(null),this.resultCount=0,this.isLimitHit=!1,this.directoriesWalked=0,this.filesWalked=0,this.errors=[],this.filePattern&&(this.normalizedFilePatternLowercase=b.prepareQuery(this.filePattern).normalizedLowercase),this.globalExcludePattern=n.excludePattern&&_.parse(n.excludePattern),this.folderExcludePatterns=new Map,n.folderQueries.forEach(o=>{const g=Object.assign({},o.excludePattern||{},this.config.excludePattern||{}),f=o.folder.fsPath;n.folderQueries.map(E=>E.folder.fsPath).filter(E=>E!==f).forEach(E=>{s.isEqualOrParent(E,f)&&(g[k.relative(f,E)]=!0)}),this.folderExcludePatterns.set(f,new t(g,f))})}cancel(){this.isCanceled=!0}walk(n,o,g,f,E){if(this.fileWalkSW=l.StopWatch.create(!1),this.isCanceled)return E(null,this.isLimitHit);o.forEach(y=>{const a=k.basename(y.fsPath);this.globalExcludePattern&&this.globalExcludePattern(y.fsPath,a)||this.matchFile(g,{relativePath:y.fsPath,searchPath:void 0})}),this.cmdSW=l.StopWatch.create(!1),this.parallel(n,(y,a)=>{this.call(this.cmdTraversal,this,y,g,f,L=>{if(L){const O=P.toErrorMessage(L);console.error(O),this.errors.push(O),a(L,void 0)}else a(null,void 0)})},(y,a)=>{this.fileWalkSW.stop();const L=y?A.coalesce(y)[0]:null;E(L,this.isLimitHit)})}parallel(n,o,g){const f=new Array(n.length),E=new Array(n.length);let y=!1,a=0;if(n.length===0)return g(null,[]);n.forEach((L,O)=>{o(L,(W,J)=>{if(W?(y=!0,f[O]=null,E[O]=W):(f[O]=J,E[O]=null),++a===n.length)return g(y?E:null,f)})})}call(n,o,...g){try{n.apply(o,g)}catch(f){g[g.length-1](f)}}cmdTraversal(n,o,g,f){const E=n.folder.fsPath,y=I.isMacintosh;let a;const L=()=>a&&a.kill();u.add(L);let O=T=>{u.delete(L),O=()=>{},f(T)},W="";const J=this.initDirectoryTree();let se;const q=w.spawnRipgrepCmd(this.config,n,this.config.includePattern,this.folderExcludePatterns.get(n.folder.fsPath).expression);a=q.cmd,se=!Object.keys(q.siblingClauses).length;const N=q.rgArgs.args.map(T=>T.match(/^-/)?T:`'${T}'`).join(" ");let H=`${q.rgDiskPath} ${N}
 - cwd: ${q.cwd}`;q.rgArgs.siblingClauses&&(H+=`
 - Sibling clauses: ${JSON.stringify(q.rgArgs.siblingClauses)}`),g({message:H}),this.cmdResultCount=0,this.collectStdout(a,"utf8",g,(T,U,F)=>{if(T){O(T);return}if(this.isLimitHit){O();return}const x=(W+(y?C.normalizeNFC(U||""):U)).split(`
`);if(F){const $=x.length;x[$-1]=x[$-1].trim(),x[$-1]||x.pop()}else W=x.pop()||"";if(x.length&&x[0].indexOf(`
`)!==-1){O(new Error("Splitting up files failed"));return}if(this.cmdResultCount+=x.length,se){for(const $ of x)if(this.matchFile(o,{base:E,relativePath:$,searchPath:this.getSearchPath(n,$)}),this.isLimitHit){L();break}(F||this.isLimitHit)&&O();return}this.addDirectoryEntries(n,J,E,x,o),F&&(this.matchDirectoryTree(J,E,o),O())})}spawnFindCmd(n){const o=this.folderExcludePatterns.get(n.folder.fsPath),g=o.getBasenameTerms(),f=o.getPathTerms(),E=["-L","."];if(g.length||f.length){E.push("-not","(","(");for(const y of g)E.push("-name",y),E.push("-o");for(const y of f)E.push("-path",y),E.push("-o");E.pop(),E.push(")","-prune",")")}return E.push("-type","f"),v.spawn("find",E,{cwd:n.folder.fsPath})}readStdout(n,o,g){let f="";this.collectStdout(n,o,()=>{},(E,y,a)=>{if(E){g(E);return}f+=y,a&&g(null,f)})}collectStdout(n,o,g,f){let E=(L,O,W)=>{(L||W)&&(E=()=>{},this.cmdSW&&this.cmdSW.stop()),f(L,O,W)},y=!1;n.stdout?(this.forwardData(n.stdout,o,E),n.stdout.once("data",()=>y=!0)):g({message:"stdout is null"});let a;n.stderr?a=this.collectData(n.stderr):g({message:"stderr is null"}),n.on("error",L=>{E(L)}),n.on("close",L=>{let O;!y&&(O=this.decodeData(a,o))&&i(O)?E(new Error(`command failed with error code ${L}: ${this.decodeData(a,o)}`)):(this.exists&&L===0&&(this.isLimitHit=!0),E(null,"",!0))})}forwardData(n,o,g){const f=new D.StringDecoder(o);return n.on("data",E=>{g(null,f.write(E))}),f}collectData(n){const o=[];return n.on("data",g=>{o.push(g)}),o}decodeData(n,o){const g=new D.StringDecoder(o);return n.map(f=>g.write(f)).join("")}initDirectoryTree(){const n={rootEntries:[],pathToEntries:Object.create(null)};return n.pathToEntries["."]=n.rootEntries,n}addDirectoryEntries(n,{pathToEntries:o},g,f,E){f.indexOf(this.filePattern)!==-1&&this.matchFile(E,{base:g,relativePath:this.filePattern,searchPath:this.getSearchPath(n,this.filePattern)});const y=a=>{const L=k.basename(a),O=k.dirname(a);let W=o[O];W||(W=o[O]=[],y(O)),W.push({base:g,relativePath:a,basename:L,searchPath:this.getSearchPath(n,a)})};f.forEach(y)}matchDirectoryTree({rootEntries:n,pathToEntries:o},g,f){const E=this,y=this.folderExcludePatterns.get(g),a=this.filePattern;function L(O){E.directoriesWalked++;const W=_.hasSiblingFn(()=>O.map(J=>J.basename));for(let J=0,se=O.length;J<se;J++){const q=O[J],{relativePath:N,basename:H}=q;if(y.test(N,H,a!==H?W:void 0))continue;const T=o[N];if(T)L(T);else{if(E.filesWalked++,N===a)continue;E.matchFile(f,q)}if(E.isLimitHit)break}}L(n)}getStats(){return{cmdTime:this.cmdSW.elapsed(),fileWalkTime:this.fileWalkSW.elapsed(),directoriesWalked:this.directoriesWalked,filesWalked:this.filesWalked,cmdResultCount:this.cmdResultCount}}doWalk(n,o,g,f,E){const y=n.folder,a=_.hasSiblingFn(()=>g);this.parallel(g,(L,O)=>{if(this.isCanceled||this.isLimitHit)return O(null);const W=o?[o,L].join(k.sep):L;if(this.folderExcludePatterns.get(n.folder.fsPath).test(W,L,this.config.filePattern!==L?a:void 0))return O(null);const J=[y.fsPath,W].join(k.sep);R.lstat(J,(se,q)=>{if(se||this.isCanceled||this.isLimitHit)return O(null);this.statLinkIfNeeded(J,q,(N,H)=>N||this.isCanceled||this.isLimitHit?O(null):H.isDirectory()?(this.directoriesWalked++,this.realPathIfNeeded(J,q,(T,U)=>T||this.isCanceled||this.isLimitHit||(U=U||"",this.walkedPaths[U])?O(null):(this.walkedPaths[U]=!0,h.Promises.readdir(J).then(F=>{if(this.isCanceled||this.isLimitHit)return O(null);this.doWalk(n,W,F,f,M=>O(M||null))},F=>{O(null)})))):(this.filesWalked++,W===this.filePattern||this.maxFilesize&&c.isNumber(H.size)&&H.size>this.maxFilesize||this.matchFile(f,{base:y.fsPath,relativePath:W,searchPath:this.getSearchPath(n,W)}),O(null,void 0)))})},L=>{const O=L&&A.coalesce(L);return E(O&&O.length>0?O[0]:void 0)})}matchFile(n,o){this.isFileMatch(o)&&(!this.includePattern||this.includePattern(o.relativePath,k.basename(o.relativePath)))&&(this.resultCount++,(this.exists||this.maxResults&&this.resultCount>this.maxResults)&&(this.isLimitHit=!0),this.isLimitHit||n(o))}isFileMatch(n){if(this.filePattern){if(this.filePattern==="*")return!0;if(this.normalizedFilePatternLowercase)return S.isFilePatternMatch(n,this.normalizedFilePatternLowercase)}return!0}statLinkIfNeeded(n,o,g){return o.isSymbolicLink()?R.stat(n,g):g(null,o)}realPathIfNeeded(n,o,g){return o.isSymbolicLink()?R.realpath(n,(f,E)=>f?g(f):g(null,E)):g(null,n)}getSearchPath(n,o){return n.folderName?k.join(n.folderName,o):o}}e.FileWalker=d;class p{constructor(n){this.folderQueries=n.folderQueries,this.extraFiles=n.extraFileResources||[],this.walker=new d(n)}search(n,o,g){this.walker.walk(this.folderQueries,this.extraFiles,n,o,(f,E)=>{g(f,{limitHit:E,stats:this.walker.getStats(),messages:[]})})}cancel(){this.walker.cancel()}}e.Engine=p;class t{constructor(n,o){this.expression=n,this.root=o,this.init(n)}init(n){let o,g;Object.keys(n).filter(f=>n[f]).forEach(f=>{k.isAbsolute(f)?(o=o||_.getEmptyExpression(),o[f]=n[f]):(g=g||_.getEmptyExpression(),g[f]=n[f])}),this.absoluteParsedExpr=o&&_.parse(o,{trimForExclusions:!0}),this.relativeParsedExpr=g&&_.parse(g,{trimForExclusions:!0})}test(n,o,g){return this.relativeParsedExpr&&this.relativeParsedExpr(n,o,g)||this.absoluteParsedExpr&&this.absoluteParsedExpr(k.join(this.root,n),o,g)}getBasenameTerms(){const n=[];return this.absoluteParsedExpr&&n.push(..._.getBasenameTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&n.push(..._.getBasenameTerms(this.relativeParsedExpr)),n}getPathTerms(){const n=[];return this.absoluteParsedExpr&&n.push(..._.getPathTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&n.push(..._.getPathTerms(this.relativeParsedExpr)),n}}function i(r){const n=r.trim().split(`
`),o=n[0].trim();if(o.startsWith("Error parsing regex"))return o;if(o.startsWith("regex parse error"))return m.uppercaseFirstLetter(n[n.length-1].trim());if(o.startsWith("error parsing glob")||o.startsWith("unsupported encoding"))return o.charAt(0).toUpperCase()+o.substr(1);if(o==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if(o.startsWith("Literal "))return o}e.rgErrorMsgForDisplay=i}),define(ge[130],pe([0,1,38,281,101,18,67,30,9,8,2,31,63,282,266,91]),function(Q,e,v,R,k,D,A,P,_,C,s,I,l,m,c,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixNewline=e.fixRegexNewline=e.unicodeEscapesToPCRE2=e.spreadGlobComponents=e.RipgrepParser=e.buildRegexParseError=e.rgErrorMsgForDisplay=e.RipgrepTextSearchEngine=void 0;const S=c.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class w{constructor(y){this.outputChannel=y}provideTextSearchResults(y,a,L,O){return this.outputChannel.appendLine(`provideTextSearchResults ${y.pattern}, ${JSON.stringify(Object.assign(Object.assign({},a),{folder:a.folder.toString()}))}`),new Promise((W,J)=>{O.onCancellationRequested(()=>M());const se=i(y,a),q=a.folder.fsPath,N=se.map(be=>be.match(/^-/)?be:`'${be}'`).join(" ");this.outputChannel.appendLine(`${S} ${N}
 - cwd: ${q}`);let H=v.spawn(S,se,{cwd:q});H.on("error",be=>{console.error(be),this.outputChannel.appendLine("Error: "+(be&&be.message)),J(I.serializeSearchError(new I.SearchError(be&&be.message,I.SearchErrorCode.rgProcessError)))});let T=!1;const U=new d(a.maxResults,q,a.previewOptions);U.on("result",be=>{T=!0,$="",L.report(be)});let F=!1;const M=()=>{F=!0,H&&H.kill(),U&&U.cancel()};let x=!1;U.on("hitLimit",()=>{x=!0,M()});let $="";H.stdout.on("data",be=>{U.handleData(be),T||($+=be)});let X=!1;H.stdout.once("data",()=>X=!0);let le="";H.stderr.on("data",be=>{const Re=be.toString();this.outputChannel.appendLine(Re),le+=Re}),H.on("close",()=>{if(this.outputChannel.appendLine(X?"Got data from stdout":"No data from stdout"),this.outputChannel.appendLine(T?"Got result from parser":"No result from parser"),$&&this.outputChannel.appendLine(`Got data without result: ${$}`),this.outputChannel.appendLine(""),F)W({limitHit:x});else{U.flush(),H=null;let be;le&&!X&&(be=b(le))?J(I.serializeSearchError(new I.SearchError(be.message,be.code))):W({limitHit:x})}})})}}e.RipgrepTextSearchEngine=w;function b(E){const y=E.split(`
`),a=y[0].trim();if(y.some(O=>O.startsWith("regex parse error")))return new I.SearchError(u(y),I.SearchErrorCode.regexParseError);const L=a.match(/grep config error: unknown encoding: (.*)/);if(L)return new I.SearchError(`Unknown encoding: ${L[1]}`,I.SearchErrorCode.unknownEncoding);if(a.startsWith("error parsing glob"))return new I.SearchError(a.charAt(0).toUpperCase()+a.substr(1),I.SearchErrorCode.globParseError);if(a.startsWith("the literal"))return new I.SearchError(a.charAt(0).toUpperCase()+a.substr(1),I.SearchErrorCode.invalidLiteral);if(a.startsWith("PCRE2: error compiling pattern"))return new I.SearchError(a,I.SearchErrorCode.regexParseError)}e.rgErrorMsgForDisplay=b;function u(E){const y=["Regex parse error"],a=E.filter(L=>L.startsWith("PCRE2:"));if(a.length>=1){const L=a[0].replace("PCRE2:","");if(L.indexOf(":")!==-1&&L.split(":").length>=2){const O=L.split(":")[1];y.push(":"+O)}}return y.join("")}e.buildRegexParseError=u;class d extends R.EventEmitter{constructor(y,a,L){super();this.maxResults=y,this.rootFolder=a,this.previewOptions=L,this.remainder="",this.isDone=!1,this.hitLimit=!1,this.numResults=0,this.stringDecoder=new k.StringDecoder}cancel(){this.isDone=!0}flush(){this.handleDecodedData(this.stringDecoder.end())}on(y,a){return super.on(y,a),this}handleData(y){if(this.isDone)return;const a=typeof y=="string"?y:this.stringDecoder.write(y);this.handleDecodedData(a)}handleDecodedData(y){let a=y.indexOf(`
`);const L=this.remainder+y;if(a>=0)a+=this.remainder.length;else{this.remainder=L;return}let O=0;for(;a>=0;)this.handleLine(L.substring(O,a).trim()),O=a+1,a=L.indexOf(`
`,O);this.remainder=L.substring(O)}handleLine(y){if(this.isDone||!y)return;let a;try{a=JSON.parse(y)}catch(L){throw new Error(`malformed line from rg: ${y}`)}if(a.type==="match"){const L=p(a.data.path),O=s.URI.file(_.join(this.rootFolder,L)),W=this.createTextSearchMatch(a.data,O);this.onResult(W),this.hitLimit&&(this.cancel(),this.emit("hitLimit"))}else if(a.type==="context"){const L=p(a.data.path),O=s.URI.file(_.join(this.rootFolder,L));this.createTextSearchContext(a.data,O).forEach(J=>this.onResult(J))}}createTextSearchMatch(y,a){const L=y.line_number-1;let O=!1,W=p(y.lines);L===0&&C.startsWithUTF8BOM(W)&&(O=!0,W=C.stripUTF8BOM(W));const J=Buffer.from(W);let se=0,q=0,N=L;y.submatches.length===0&&y.submatches.push(W.length?{start:0,end:1,match:{text:W[0]}}:{start:0,end:0,match:{text:""}});const H=D.coalesce(y.submatches.map((T,U)=>{if(this.hitLimit)return null;this.numResults++,this.numResults>=this.maxResults&&(this.hitLimit=!0);let F=p(T.match);L===0&&U===0&&O&&(F=C.stripUTF8BOM(F),T.start=T.start<=3?0:T.start-3,T.end=T.end<=3?0:T.end-3);const M=J.slice(se,T.start).toString().length,x=q+M,$=t(F),X=N,le=$.numLines+X,be=$.numLines>0?$.lastLineLength:$.lastLineLength+x;return se=T.end,q=be,N=le,new l.Range(X,x,le,be)}));return h.createTextSearchResult(a,W,H,this.previewOptions)}createTextSearchContext(y,a){const L=p(y.lines),O=y.line_number;return L.replace(/\r?\n$/,"").split(`
`).map((W,J)=>({text:W,uri:a,lineNumber:O+J}))}onResult(y){this.emit("result",y)}}e.RipgrepParser=d;function p(E){return E.bytes?Buffer.from(E.bytes,"base64").toString():E.text}function t(E){const y=/\n/g;let a=0,L=-1,O;for(;O=y.exec(E);)a++,L=O.index;const W=L>=0?E.length-L-1:E.length;return{numLines:a,lastLineLength:W}}function i(E,y){const a=["--hidden"];a.push(E.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:L,otherIncludes:O}=A.groupBy(y.includes,J=>J.startsWith("**")?"doubleStarIncludes":"otherIncludes");if(O&&O.length){const J=new Set;O.forEach(se=>{J.add(se)}),a.push("-g","!*"),J.forEach(se=>{r(se).map(h.anchorGlob).forEach(q=>{a.push("-g",q)})})}L&&L.length&&L.forEach(J=>{a.push("-g",J)}),y.excludes.map(h.anchorGlob).forEach(J=>a.push("-g",`!${J}`)),y.maxFileSize&&a.push("--max-filesize",y.maxFileSize+""),y.useIgnoreFiles?a.push("--no-ignore-parent"):a.push("--no-ignore"),y.followSymlinks&&a.push("--follow"),y.encoding&&y.encoding!=="utf8"&&a.push("--encoding",y.encoding),E.pattern==="--"&&(E.isRegExp=!0,E.pattern="\\-\\-"),E.isMultiline&&!E.isRegExp&&(E.pattern=C.escapeRegExpCharacters(E.pattern),E.isRegExp=!0),y.usePCRE2&&a.push("--pcre2"),a.push("--crlf"),E.isRegExp&&(E.pattern=n(E.pattern),a.push("--auto-hybrid-regex"));let W;if(E.isWordMatch){const se=C.createRegExp(E.pattern,!!E.isRegExp,{wholeWord:E.isWordMatch}).source.replace(/\\\//g,"/");a.push("--regexp",se)}else if(E.isRegExp){let J=g(E.pattern);J=f(J),a.push("--regexp",J)}else W=E.pattern,a.push("--fixed-strings");return a.push("--no-config"),y.useGlobalIgnoreFiles||a.push("--no-ignore-global"),a.push("--json"),E.isMultiline&&a.push("--multiline"),y.beforeContext&&a.push("--before-context",y.beforeContext+""),y.afterContext&&a.push("--after-context",y.afterContext+""),a.push("--"),W&&a.push(W),a.push("."),a}function r(E){const y=P.splitGlobAware(E,"/");return y.map((a,L)=>y.slice(0,L+1).join("/"))}e.spreadGlobComponents=r;function n(E){const y=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;E.match(y);)E=E.replace(y,"$1\\x{$2}");const a=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;E.match(a);)E=E.replace(a,"$1\\x{$2}");return E}e.unicodeEscapesToPCRE2=n;const o=E=>E.type==="Assertion"&&E.kind==="lookbehind";function g(E){let y;try{y=new m.RegExpParser().parsePattern(E)}catch(se){return E}let a="",L=0;const O=(se,q,N)=>{a+=E.slice(L,se)+N,L=q},W=[];return new m.RegExpVisitor({onCharacterEnter(se){if(se.raw!=="\\n")return;const q=W[0];if(!q)O(se.start,se.end,"\\r?\\n");else if(!W.some(o))if(q.type==="CharacterClass")if(q.negate){const N=E.slice(q.start+2,se.start)+E.slice(se.end,q.end-1);O(q.start,q.end,"(?!\\r?\\n"+(N?`|[${N}]`:"")+")")}else{const N=E.slice(q.start+1,se.start)+E.slice(se.end,q.end-1);O(q.start,q.end,N===""?"\\r?\\n":`(?:[${N}]|\\r?\\n)`)}else q.type==="Quantifier"&&O(se.start,se.end,"(?:\\r?\\n)")},onQuantifierEnter(se){W.unshift(se)},onQuantifierLeave(){W.shift()},onCharacterClassRangeEnter(se){W.unshift(se)},onCharacterClassRangeLeave(){W.shift()},onCharacterClassEnter(se){W.unshift(se)},onCharacterClassLeave(){W.shift()},onAssertionEnter(se){o(se)&&W.push(se)},onAssertionLeave(se){W[0]===se&&W.shift()}}).visit(y),a+=E.slice(L),a}e.fixRegexNewline=g;function f(E){return E.replace(/\n/g,"\\r?\\n")}e.fixNewline=f}),define(ge[268],pe([0,1,21,130,116,10]),function(Q,e,v,R,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RipgrepSearchProvider=void 0;class A{constructor(C){this.outputChannel=C,this.inProgress=new Set,process.once("exit",()=>this.dispose())}provideTextSearchResults(C,s,I,l){const m=new R.RipgrepTextSearchEngine(this.outputChannel);if(s.folder.scheme===D.Schemas.userData){const c=Object.assign(Object.assign({},s),{folder:s.folder.with({scheme:D.Schemas.file})}),h=new k.Progress(S=>I.report(Object.assign(Object.assign({},S),{uri:S.uri.with({scheme:s.folder.scheme})})));return this.withToken(l,S=>m.provideTextSearchResults(C,c,h,S))}else return this.withToken(l,c=>m.provideTextSearchResults(C,s,I,c))}async withToken(C,s){const I=P(C);this.inProgress.add(I);const l=await s(I.token);return this.inProgress.delete(I),l}dispose(){this.inProgress.forEach(C=>C.cancel())}}e.RipgrepSearchProvider=A;function P(_){const C=new v.CancellationTokenSource;return _.onCancellationRequested(()=>C.cancel()),C}}),define(ge[269],pe([0,1,28,130,129]),function(Q,e,v,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchEngineAdapter=void 0;class D{constructor(_){this.query=_}search(_,C,s){if((!this.query.folderQueries||!this.query.folderQueries.length)&&(!this.query.extraFileResources||!this.query.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"}});const I={appendLine(m){s({message:m})}},l=new k.NativeTextSearchManager(this.query,new R.RipgrepTextSearchEngine(I),v);return new Promise((m,c)=>l.search(h=>{C(h.map(A))},_).then(h=>m({limitHit:h.limitHit,type:"success"}),c))}}e.TextSearchEngineAdapter=D;function A(P){return{path:P.resource&&P.resource.fsPath,results:P.results,numMatches:(P.results||[]).reduce((_,C)=>{if(C.ranges){const s=C;return _+(Array.isArray(s.ranges)?s.ranges.length:1)}else return _+1},0)}}}),define(ge[270],pe([0,1,55,283,18,16,14,3,98,9,43,2,42,31,267,269]),function(Q,e,v,R,k,D,A,P,_,C,s,I,l,m,c,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SearchService=void 0,R.gracefulify(v);class S{constructor(){this.caches=Object.create(null)}fileSearch(t){let i;const r=u(t),n=new P.Emitter({onFirstListenerDidAdd:()=>{i=D.createCancelablePromise(o=>this.doFileSearchWithEngine(c.Engine,r,g=>n.fire(g),o)),i.then(o=>n.fire(o),o=>n.fire({type:"error",error:{message:o.message,stack:o.stack}}))},onLastListenerRemove:()=>{i.cancel()}});return n.event}textSearch(t){let i;const r=u(t),n=new P.Emitter({onFirstListenerDidAdd:()=>{i=D.createCancelablePromise(o=>this.ripgrepTextSearch(r,g=>n.fire(g),o)),i.then(o=>n.fire(o),o=>n.fire({type:"error",error:{message:o.message,stack:o.stack}}))},onLastListenerRemove:()=>{i.cancel()}});return n.event}ripgrepTextSearch(t,i,r){return t.maxFileSize=l.getPlatformLimits(process.arch==="ia32"?0:1).maxFileSize,new h.TextSearchEngineAdapter(t).search(r,i,i)}doFileSearch(t,i,r){return this.doFileSearchWithEngine(c.Engine,t,i,r)}doFileSearchWithEngine(t,i,r,n,o=S.BATCH_SIZE){let g=0;const f=y=>{Array.isArray(y)?(g+=y.length,r(y.map(a=>this.rawMatchToSearchItem(a)))):y.relativePath?(g++,r(this.rawMatchToSearchItem(y))):r(y)};if(i.sortByScore){let y=this.trySortedSearchFromCache(i,f,n);if(!y){const a=i.maxResults?Object.assign({},i,{maxResults:null}):i,L=new t(a);y=this.doSortedSearch(L,i,r,f,n)}return new Promise((a,L)=>{y.then(([O,W])=>{const J=W.map(se=>this.rawMatchToSearchItem(se));this.sendProgress(J,r,o),a(O)},L)})}const E=new t(i);return this.doSearch(E,f,o,n).then(y=>({limitHit:y.limitHit,type:"success",stats:{detailStats:y.stats,type:"searchProcess",fromCache:!1,resultCount:g,sortingTime:void 0}}))}rawMatchToSearchItem(t){return{path:t.base?C.join(t.base,t.relativePath):t.relativePath}}doSortedSearch(t,i,r,n,o){const g=new P.Emitter;let f=D.createCancelablePromise(y=>{let a=[];const L=O=>{Array.isArray(O)?a=O:(n(O),g.fire(O))};return this.doSearch(t,L,-1,y).then(O=>[O,a])}),E;if(i.cacheKey){E=this.getOrCreateCache(i.cacheKey);const y={promise:f,event:g.event,resolved:!1};E.resultsToSearchCache[i.filePattern||""]=y,f.then(()=>{y.resolved=!0},a=>{delete E.resultsToSearchCache[i.filePattern||""]}),f=this.preventCancellation(f)}return f.then(([y,a])=>{const L=E?E.scorerCache:Object.create(null),O=(typeof i.maxResults!="number"||i.maxResults>0)&&s.StopWatch.create(!1);return this.sortResults(i,a,L,o).then(W=>{const J=O?O.elapsed():-1;return[{type:"success",stats:{detailStats:y.stats,sortingTime:J,fromCache:!1,type:"searchProcess",workspaceFolderCount:i.folderQueries.length,resultCount:W.length},messages:y.messages,limitHit:y.limitHit||typeof i.maxResults=="number"&&a.length>i.maxResults},W]})})}getOrCreateCache(t){const i=this.caches[t];return i||(this.caches[t]=new w)}trySortedSearchFromCache(t,i,r){const n=t.cacheKey&&this.caches[t.cacheKey];if(!n)return;const o=this.getResultsFromCache(n,t.filePattern||"",i,r);if(o)return o.then(([g,f,E])=>{const y=s.StopWatch.create(!1);return this.sortResults(t,f,n.scorerCache,r).then(a=>{const L=y.elapsed(),O={fromCache:!0,detailStats:E,type:"searchProcess",resultCount:f.length,sortingTime:L};return[{type:"success",limitHit:g.limitHit||typeof t.maxResults=="number"&&f.length>t.maxResults,stats:O},a]})})}sortResults(t,i,r,n){const o=_.prepareQuery(t.filePattern||""),g=(E,y)=>_.compareItemsByFuzzyScore(E,y,o,!0,b,r),f=typeof t.maxResults=="number"?t.maxResults:Number.MAX_VALUE;return k.topAsync(i,g,f,1e4,n)}sendProgress(t,i,r){if(r&&r>0)for(let n=0;n<t.length;n+=r)i(t.slice(n,n+r));else i(t)}getResultsFromCache(t,i,r,n){const o=s.StopWatch.create(!1),g=i.indexOf(C.sep)>=0;let f;for(const L in t.resultsToSearchCache)if(i.startsWith(L)){if(g&&L.indexOf(C.sep)<0&&L!=="")continue;const O=t.resultsToSearchCache[L];f={promise:this.preventCancellation(O.promise),event:O.event,resolved:O.resolved};break}if(!f)return null;const E=o.elapsed(),y=s.StopWatch.create(!1),a=f.event(r);return n&&n.onCancellationRequested(()=>{a.dispose()}),f.promise.then(([L,O])=>{if(n&&n.isCancellationRequested)throw A.canceled();const W=[],J=_.prepareQuery(i).normalizedLowercase;for(const se of O)!m.isFilePatternMatch(se,J)||W.push(se);return[L,W,{cacheWasResolved:f.resolved,cacheLookupTime:E,cacheFilterTime:y.elapsed(),cacheEntryCount:O.length}]})}doSearch(t,i,r,n){return new Promise((o,g)=>{let f=[];n&&n.onCancellationRequested(()=>t.cancel()),t.search(E=>{E&&(r?(f.push(E),r>0&&f.length>=r&&(i(f),f=[])):i(E))},E=>{i(E)},(E,y)=>{f.length&&i(f),E?g(E):o(y)})})}clearCache(t){return delete this.caches[t],Promise.resolve(void 0)}preventCancellation(t){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(i,r){return t.then(i,r)}catch(i){return this.then(void 0,i)}finally(i){return t.finally(i)}}}}e.SearchService=S,S.BATCH_SIZE=512;class w{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const b=new class{getItemLabel(p){return C.basename(p.relativePath)}getItemDescription(p){return C.dirname(p.relativePath)}getItemPath(p){return p.relativePath}};function u(p){return Object.assign(Object.assign({},p),{folderQueries:p.folderQueries&&p.folderQueries.map(d),extraFileResources:p.extraFileResources&&p.extraFileResources.map(t=>I.URI.revive(t))})}function d(p){return Object.assign(Object.assign({},p),{folder:I.URI.revive(p.folder)})}}),define(ge[271],pe([0,1,6,2,28,12,31,270,268,91,13,59,27,66,10,129]),function(Q,e,v,R,k,D,A,P,_,C,s,I,l,m,c,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtHostSearch=void 0;let S=class extends m.ExtHostSearch{constructor(b,u,d,p){super(b,d,p);this._pfs=k,this._internalFileSearchHandle=-1,this._internalFileSearchProvider=null;const t=new C.OutputChannel("RipgrepSearchUD",this._logService);this.registerTextSearchProvider(c.Schemas.userData,new _.RipgrepSearchProvider(t)),u.remote.isRemote&&u.remote.authority&&this._registerEHSearchProviders()}_registerEHSearchProviders(){const b=new C.OutputChannel("RipgrepSearchEH",this._logService);this.registerTextSearchProvider(c.Schemas.file,new _.RipgrepSearchProvider(b)),this.registerInternalFileSearchProvider(c.Schemas.file,new P.SearchService)}registerInternalFileSearchProvider(b,u){const d=this._handlePool++;return this._internalFileSearchProvider=u,this._internalFileSearchHandle=d,this._proxy.$registerFileSearchProvider(d,this._transformScheme(b)),v.toDisposable(()=>{this._internalFileSearchProvider=null,this._proxy.$unregisterProvider(d)})}$provideFileSearchResults(b,u,d,p){const t=m.reviveQuery(d);return b===this._internalFileSearchHandle?this.doInternalFileSearch(b,u,t,p):super.$provideFileSearchResults(b,u,d,p)}doInternalFileSearch(b,u,d,p){const t=i=>{if(A.isSerializedFileMatch(i)&&(i=[i]),Array.isArray(i)){this._proxy.$handleFileMatch(b,u,i.map(r=>R.URI.file(r.path)));return}i.message&&this._logService.debug("ExtHostSearch",i.message)};if(!this._internalFileSearchProvider)throw new Error("No internal file search handler");return this._internalFileSearchProvider.doFileSearch(d,t,p)}$clearCache(b){return this._internalFileSearchProvider&&this._internalFileSearchProvider.clearCache(b),super.$clearCache(b)}createTextSearchManager(b,u){return new h.NativeTextSearchManager(b,u)}};S=Ve([$e(0,s.IExtHostRpcService),$e(1,l.IExtHostInitDataService),$e(2,I.IURITransformerService),$e(3,D.ILogService)],S),e.NativeExtHostSearch=S}),define(ge[131],pe([0,1,284,121,285,3,104,9,102,32,6,22,105,14,11]),function(Q,e,v,R,k,D,A,P,_,C,s,I,l,m,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class h{constructor(f){this.socket=f,this._errorListener=E=>{if(E){if(E.code==="EPIPE")return;m.onUnexpectedError(E)}},this.socket.on("error",this._errorListener)}dispose(){this.socket.off("error",this._errorListener),this.socket.destroy()}onData(f){const E=y=>f(I.VSBuffer.wrap(y));return this.socket.on("data",E),{dispose:()=>this.socket.off("data",E)}}onClose(f){const E=y=>{f({type:0,hadError:y,error:void 0})};return this.socket.on("close",E),{dispose:()=>this.socket.off("close",E)}}onEnd(f){return this.socket.on("end",f),{dispose:()=>this.socket.off("end",f)}}write(f){if(!this.socket.destroyed)try{this.socket.write(f.buffer,E=>{if(E){if(E.code==="EPIPE")return;m.onUnexpectedError(E)}})}catch(E){if(E.code==="EPIPE")return;m.onUnexpectedError(E)}}end(){this.socket.end()}drain(){return new Promise((f,E)=>{if(this.socket.bufferSize===0){f();return}const y=()=>{this.socket.off("close",y),this.socket.off("end",y),this.socket.off("error",y),this.socket.off("timeout",y),this.socket.off("drain",y),f()};this.socket.on("close",y),this.socket.on("end",y),this.socket.on("error",y),this.socket.on("timeout",y),this.socket.on("drain",y)})}}e.NodeSocket=h;var S;(function(g){g[g.MinHeaderByteSize=2]="MinHeaderByteSize"})(S||(S={}));var w;(function(g){g[g.PeekHeader=1]="PeekHeader",g[g.ReadHeader=2]="ReadHeader",g[g.ReadBody=3]="ReadBody",g[g.Fin=4]="Fin"})(w||(w={}));class b extends s.Disposable{constructor(f,E,y,a){super();this._onDidZlibFlush=this._register(new D.Emitter),this._recordedInflateBytes=[],this._pendingInflateData=[],this._pendingDeflateData=[],this._onData=this._register(new D.Emitter),this._onClose=this._register(new D.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,mask:0},this.socket=f,this._totalIncomingWireBytes=0,this._totalIncomingDataBytes=0,this._totalOutgoingWireBytes=0,this._totalOutgoingDataBytes=0,this.permessageDeflate=E,this._recordInflateBytes=a,E?(this._zlibInflate=k.createInflateRaw({windowBits:15}),this._zlibInflate.on("error",L=>{console.error(L),m.onUnexpectedError(L),this._onClose.fire({type:0,hadError:!0,error:L})}),this._zlibInflate.on("data",L=>{this._pendingInflateData.push(L)}),y&&(this._zlibInflate.write(y.buffer),this._zlibInflate.flush(()=>{this._pendingInflateData.length=0})),this._zlibDeflate=k.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",L=>{console.error(L),m.onUnexpectedError(L),this._onClose.fire({type:0,hadError:!0,error:L})}),this._zlibDeflate.on("data",L=>{this._pendingDeflateData.push(L)})):(this._zlibInflate=null,this._zlibDeflate=null),this._zlibDeflateFlushWaitingCount=0,this._incomingData=new l.ChunkStream,this._register(this.socket.onData(L=>this._acceptChunk(L))),this._register(this.socket.onClose(L=>this._onClose.fire(L)))}get totalIncomingWireBytes(){return this._totalIncomingWireBytes}get totalIncomingDataBytes(){return this._totalIncomingDataBytes}get totalOutgoingWireBytes(){return this._totalOutgoingWireBytes}get totalOutgoingDataBytes(){return this._totalOutgoingDataBytes}get recordedInflateBytes(){return this._recordInflateBytes?I.VSBuffer.wrap(Buffer.concat(this._recordedInflateBytes)):I.VSBuffer.alloc(0)}dispose(){this._zlibDeflateFlushWaitingCount>0?this._register(this._onDidZlibFlush.event(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(f){return this._onData.event(f)}onClose(f){return this._onClose.event(f)}onEnd(f){return this.socket.onEnd(f)}write(f){this._totalOutgoingDataBytes+=f.byteLength,this._zlibDeflate?(this._zlibDeflate.write(f.buffer),this._zlibDeflateFlushWaitingCount++,this._zlibDeflate.flush(2,()=>{this._zlibDeflateFlushWaitingCount--;let E=Buffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,E=E.slice(0,E.length-4),this._isEnded||this._write(I.VSBuffer.wrap(E),!0),this._zlibDeflateFlushWaitingCount===0&&this._onDidZlibFlush.fire()})):this._write(f,!1)}_write(f,E){let y=2;f.byteLength<126?y+=0:f.byteLength<2**16?y+=2:y+=8;const a=I.VSBuffer.alloc(y);if(E?a.writeUInt8(194,0):a.writeUInt8(130,0),f.byteLength<126)a.writeUInt8(f.byteLength,1);else if(f.byteLength<2**16){a.writeUInt8(126,1);let L=1;a.writeUInt8(f.byteLength>>>8&255,++L),a.writeUInt8(f.byteLength>>>0&255,++L)}else{a.writeUInt8(127,1);let L=1;a.writeUInt8(0,++L),a.writeUInt8(0,++L),a.writeUInt8(0,++L),a.writeUInt8(0,++L),a.writeUInt8(f.byteLength>>>24&255,++L),a.writeUInt8(f.byteLength>>>16&255,++L),a.writeUInt8(f.byteLength>>>8&255,++L),a.writeUInt8(f.byteLength>>>0&255,++L)}this._totalOutgoingWireBytes+=a.byteLength+f.byteLength,this.socket.write(I.VSBuffer.concat([a,f]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(f){if(f.byteLength!==0){for(this._totalIncomingWireBytes+=f.byteLength,this._incomingData.acceptChunk(f);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const E=this._incomingData.peek(this._state.readLen),a=(E.readUInt8(0)&128)>>>7,L=E.readUInt8(1),O=(L&128)>>>7,W=L&127;this._state.state=2,this._state.readLen=2+(O?4:0)+(W===126?2:0)+(W===127?8:0),this._state.fin=a,this._state.mask=0}else if(this._state.state===2){const E=this._incomingData.read(this._state.readLen),y=E.readUInt8(1),a=(y&128)>>>7;let L=y&127,O=1;L===126?L=E.readUInt8(++O)*2**8+E.readUInt8(++O):L===127&&(L=E.readUInt8(++O)*0+E.readUInt8(++O)*0+E.readUInt8(++O)*0+E.readUInt8(++O)*0+E.readUInt8(++O)*2**24+E.readUInt8(++O)*2**16+E.readUInt8(++O)*2**8+E.readUInt8(++O));let W=0;a&&(W=E.readUInt8(++O)*2**24+E.readUInt8(++O)*2**16+E.readUInt8(++O)*2**8+E.readUInt8(++O)),this._state.state=3,this._state.readLen=L,this._state.mask=W}else if(this._state.state===3){const E=this._incomingData.read(this._state.readLen);u(E,this._state.mask),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._zlibInflate?(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from(E.buffer)),this._zlibInflate.write(E.buffer),this._state.fin&&(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from([0,0,255,255])),this._zlibInflate.write(Buffer.from([0,0,255,255]))),this._zlibInflate.flush(()=>{const y=Buffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,this._totalIncomingDataBytes+=y.length,this._onData.fire(I.VSBuffer.wrap(y))})):(this._totalIncomingDataBytes+=E.byteLength,this._onData.fire(E))}}}async drain(){this._zlibDeflateFlushWaitingCount>0&&await D.Event.toPromise(this._onDidZlibFlush.event),await this.socket.drain()}}e.WebSocketNodeSocket=b;function u(g,f){if(f===0)return;let E=g.byteLength>>>2;for(let J=0;J<E;J++){const se=g.readUInt32BE(J*4);g.writeUInt32BE(se^f,J*4)}let y=E*4,a=g.byteLength-y;const L=f>>>24&255,O=f>>>16&255,W=f>>>8&255;a>=1&&g.writeUInt8(g.readUInt8(y)^L,y),a>=2&&g.writeUInt8(g.readUInt8(y+1)^O,y+1),a>=3&&g.writeUInt8(g.readUInt8(y+2)^W,y+2)}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const d={[2]:107,[1]:103};function p(){const g=C.generateUuid();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${g}-sock`;let f;return e.XDG_RUNTIME_DIR?f=P.join(e.XDG_RUNTIME_DIR,`vscode-ipc-${g}.sock`):f=P.join(_.tmpdir(),`vscode-ipc-${g}.sock`),i(f),f}e.createRandomIPCHandle=p;function t(g,f,E){const y=v.createHash("md5").update(g).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${y}-${E}-${f}-sock`;let a;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?a=P.join(e.XDG_RUNTIME_DIR,`vscode-${y.substr(0,8)}-${E}-${f}.sock`):a=P.join(g,`${E}-${f}.sock`),i(a),a}e.createStaticIPCHandle=t;function i(g){const f=d[c.platform];typeof f=="number"&&g.length>=f&&console.warn(`WARNING: IPC handle "${g}" is longer than ${f} chars, try a shorter --user-data-dir`)}class r extends A.IPCServer{constructor(f){super(r.toClientConnectionEvent(f));this.server=f}static toClientConnectionEvent(f){const E=D.Event.fromNodeEventEmitter(f,"connection");return D.Event.map(E,y=>({protocol:new l.Protocol(new h(y)),onDidClientDisconnect:D.Event.once(D.Event.fromNodeEventEmitter(y,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=r;function n(g){return new Promise((f,E)=>{const y=R.createServer();y.on("error",E),y.listen(g,()=>{y.removeListener("error",E),f(new r(y))})})}e.serve=n;function o(g,f){return new Promise((E,y)=>{const a=R.createConnection(g,()=>{a.removeListener("error",y),E(l.Client.fromSocket(new h(a),f))});a.once("error",y)})}e.connect=o}),define(ge[272],pe([0,1,131,264,55,48,2,189,12]),function(Q,e,v,R,k,D,A,P,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CLIServer=e.CLIServerBase=void 0;class C{constructor(l,m,c){this._commands=l,this.logService=m,this._ipcHandlePath=c,this._server=R.createServer((h,S)=>this.onRequest(h,S)),this.setup().catch(h=>(m.error(h),""))}get ipcHandlePath(){return this._ipcHandlePath}async setup(){try{this._server.listen(this.ipcHandlePath),this._server.on("error",l=>this.logService.error(l))}catch(l){this.logService.error("Could not start open from terminal server.")}return this._ipcHandlePath}onRequest(l,m){const c=[];l.setEncoding("utf8"),l.on("data",h=>c.push(h)),l.on("end",()=>{const h=JSON.parse(c.join(""));switch(h.type){case"open":this.open(h,m);break;case"openExternal":this.openExternal(h,m);break;case"status":this.getStatus(h,m);break;case"extensionManagement":this.manageExtensions(h,m).catch(this.logService.error);break;default:m.writeHead(404),m.write(`Unknown message type: ${h.type}`,S=>{S&&this.logService.error(S)}),m.end();break}})}open(l,m){let{fileURIs:c,folderURIs:h,forceNewWindow:S,diffMode:w,addMode:b,forceReuseWindow:u,gotoLineMode:d,waitMarkerFilePath:p}=l;const t=[];if(Array.isArray(h))for(const i of h)try{t.push({folderUri:A.URI.parse(i)})}catch(r){}if(Array.isArray(c))for(const i of c)try{P.hasWorkspaceFileExtension(i)?t.push({workspaceUri:A.URI.parse(i)}):t.push({fileUri:A.URI.parse(i)})}catch(r){}if(t.length){const i=p?A.URI.file(p):void 0,n={forceNewWindow:S,diffMode:w,addMode:b,gotoLineMode:d,forceReuseWindow:u,preferNewWindow:!u&&!i&&!b,waitMarkerFileURI:i};this._commands.executeCommand("_remoteCLI.windowOpen",t,n)}m.writeHead(200),m.end()}async openExternal(l,m){for(const c of l.uris){const h=A.URI.parse(c),S=h.scheme==="file"?h:c;await this._commands.executeCommand("_remoteCLI.openExternal",S)}m.writeHead(200),m.end()}async manageExtensions(l,m){try{const c=w=>w==null?void 0:w.map(b=>/\.vsix$/i.test(b)?A.URI.parse(b):b),h={list:l.list,install:c(l.install),uninstall:c(l.uninstall),force:l.force},S=await this._commands.executeCommand("_remoteCLI.manageExtensions",h);m.writeHead(200),m.write(S)}catch(c){m.writeHead(500),m.write(String(c),h=>{h&&this.logService.error(h)})}m.end()}async getStatus(l,m){try{const c=await this._commands.executeCommand("_remoteCLI.getSystemStatus");m.writeHead(200),m.write(c),m.end()}catch(c){m.writeHead(500),m.write(String(c),h=>{h&&this.logService.error(h)}),m.end()}}dispose(){this._server.close(),this._ipcHandlePath&&process.platform!=="win32"&&k.existsSync(this._ipcHandlePath)&&k.unlinkSync(this._ipcHandlePath)}}e.CLIServerBase=C;let s=class extends C{constructor(l,m){super(l,m,v.createRandomIPCHandle())}};s=Ve([$e(0,D.IExtHostCommands),$e(1,_.ILogService)],s),e.CLIServer=s}),define(ge[273],pe([0,1,65,260,255,5,263,40,245,2,10,7,272,103]),function(Q,e,v,R,k,D,A,P,_,C,s,I,l,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;class c extends k.RequireInterceptor{_installInterceptor(){const w=this,b=Q.__$__nodeRequire("module"),u=b._load;b._load=function(p,t,i){for(let r of w._alternatives){let n=r(p);if(n){p=n;break}}return w._factories.has(p)?w._factories.get(p).load(p,C.URI.file(m.realpathSync(t.filename)),r=>u.apply(this,[r,t,i])):u.apply(this,arguments)}}}class h extends P.AbstractExtHostExtensionService{constructor(){super(...arguments);this.extensionRuntime=I.ExtensionRuntime.Node}async _beforeAlmostReadyToRunExtensions(){const w=this._instaService.invokeFunction(R.createApiFactoryAndRegisterActors);if(this._instaService.createInstance(_.ExtHostDownloadService),this._initData.remote.isRemote&&this._initData.remote.authority){const t=this._instaService.createInstance(l.CLIServer);process.env.VSCODE_IPC_HOOK_CLI=t.ipcHandlePath}await this._instaService.createInstance(c,w,this._registry).install(),v.mark("code/extHost/didInitAPI");const u=await this._extHostConfiguration.getConfigProvider();await A.connectProxyResolver(this._extHostWorkspace,u,this,this._logService,this._mainThreadTelemetryProxy,this._initData),v.mark("code/extHost/didInitProxyResolver");const d=process.send,p=this._extHostContext.getProxy(D.MainContext.MainThreadConsole);process.send=(...t)=>t.length===0||!t[0]||t[0].type!=="__$console"?d.apply(process,t):(p.$logExtensionHostMessage(t[0]),!1)}_getEntryPoint(w){return w.main}_loadCommonJSModule(w,b,u){if(b.scheme!==s.Schemas.file)throw new Error(`Cannot load URI: '${b}', must be of file-scheme`);let d=null;u.codeLoadingStart(),this._logService.info(`ExtensionService#loadCommonJSModule ${b.toString(!0)}`),this._logService.flush();try{w&&v.mark(`code/extHost/willLoadExtensionCode/${w.value}`),d=Q.__$__nodeRequire(b.fsPath)}catch(p){return Promise.reject(p)}finally{w&&v.mark(`code/extHost/didLoadExtensionCode/${w.value}`),u.codeLoadingStop()}return Promise.resolve(d)}async $setRemoteEnvironment(w){if(!!this._initData.remote.isRemote)for(const b in w){const u=w[b];u===null?delete process.env[b]:process.env[b]=u}}}e.ExtHostExtensionService=h}),define(ge[274],pe([0,1,77,246,247,257,256,271,273,215,248,49,40,61,66,64,33,47,12]),function(Q,e,v,R,k,D,A,P,_,C,s,I,l,m,c,h,S,w,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),v.registerSingleton(l.IExtHostExtensionService,_.ExtHostExtensionService),v.registerSingleton(b.ILogService,C.ExtHostLogService),v.registerSingleton(I.IExtHostDebugService,A.ExtHostDebugService),v.registerSingleton(m.IExtHostOutputService,R.ExtHostOutputService2),v.registerSingleton(c.IExtHostSearch,P.NativeExtHostSearch),v.registerSingleton(h.IExtHostTask,D.ExtHostTask),v.registerSingleton(S.IExtHostTerminalService,k.ExtHostTerminalService),v.registerSingleton(w.IExtHostTunnelService,s.ExtHostTunnelService)}),define(ge[275],pe([0,1,121,286,65,14,105,131,183,213,258,22,100,28,103,16,261,274]),function(Q,e,v,R,k,D,A,P,_,C,s,I,l,m,c,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.startExtensionHostProcess=void 0,function(){for(let n=0;n<process.execArgv.length;n++)process.execArgv[n]==="--inspect-port=0"&&(process.execArgv.splice(n,1),n--)}();const S=R(process.argv.slice(2),{string:["uriTransformerPath","useHostProxy"]});(function(){const r=Q.__$__nodeRequire("module"),n=r._load;r._load=function(o){if(o==="natives")throw new Error('Either the extension or a NPM dependency is using the "natives" node module which is unsupported as it can cause a crash of the extension host. Click [here](https://go.microsoft.com/fwlink/?linkid=871887) to find out more');return n.apply(this,arguments)}})();const w=process.exit.bind(process);function b(r){process.exit=function(n){if(r)w(n);else{const o=new Error("An extension called process.exit() and this was prevented.");console.warn(o.stack)}},process.crash=function(){const n=new Error("An extension called process.crash() and this was prevented.");console.warn(n.stack)}}let u=function(r){w()};function d(){if(process.env.VSCODE_EXTHOST_WILL_SEND_SOCKET)return new Promise((r,n)=>{let o=null,g=setTimeout(()=>{u("VSCODE_EXTHOST_IPC_SOCKET timeout")},6e4);const f=108e5,E=3e5,y=new h.RunOnceScheduler(()=>u("renderer disconnected for too long (1)"),f),a=new h.RunOnceScheduler(()=>u("renderer disconnected for too long (2)"),E);process.on("message",(O,W)=>{if(O&&O.type==="VSCODE_EXTHOST_IPC_SOCKET"){const J=I.VSBuffer.wrap(Buffer.from(O.initialDataChunk,"base64"));let se;if(O.skipWebSocketFrames)se=new P.NodeSocket(W);else{const q=I.VSBuffer.wrap(Buffer.from(O.inflateBytes,"base64"));se=new P.WebSocketNodeSocket(new P.NodeSocket(W),O.permessageDeflate,q,!1)}o?(y.cancel(),a.cancel(),o.beginAcceptReconnection(se,J),o.endAcceptReconnection()):(clearTimeout(g),o=new A.PersistentProtocol(se,J),o.onDidDispose(()=>u("renderer disconnected")),r(o),o.onSocketClose(()=>{y.schedule()}))}if(O&&O.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if(a.isScheduled())return;y.isScheduled()&&a.schedule()}});const L={type:"VSCODE_EXTHOST_IPC_READY"};process.send&&process.send(L)});{const r=process.env.VSCODE_IPC_HOOK_EXTHOST;return new Promise((n,o)=>{const g=v.createConnection(r,()=>{g.removeListener("error",o),n(new A.PersistentProtocol(new P.NodeSocket(g)))});g.once("error",o),g.on("close",()=>{u("renderer closed the socket")})})}}async function p(){const r=await d();return new class{constructor(){this._onMessage=new A.BufferedEmitter,this.onMessage=this._onMessage.event,this._terminating=!1,r.onMessage(n=>{C.isMessageOfType(n,2)?(this._terminating=!0,u("received terminate message from renderer")):this._onMessage.fire(n)})}send(n){this._terminating||r.send(n)}drain(){return r.drain()}}}function t(r){return new Promise(n=>{const o=r.onMessage(g=>{o.dispose();const f=JSON.parse(g.toString()),E=f.commit,y=_.default.commit;E&&y&&E!==y&&w(55);const a=[];process.on("unhandledRejection",(W,J)=>{a.push(J),setTimeout(()=>{const se=a.indexOf(J);se>=0&&J.catch(q=>{a.splice(se,1),console.warn(`rejected promise not handled within 1 second: ${q}`),q&&q.stack&&console.warn(`stack trace: ${q.stack}`),D.onUnexpectedError(W)})},1e3)}),process.on("rejectionHandled",W=>{const J=a.indexOf(W);J>=0&&a.splice(J,1)}),process.on("uncaughtException",function(W){D.onUnexpectedError(W)});let L=0;setInterval(function(){try{process.kill(f.parentPid,0),L=0}catch(W){W&&W.code==="EPERM"?(L++,L>=3&&u(`parent process ${f.parentPid} does not exist anymore (3 x EPERM): ${W.message} (code: ${W.code}) (errno: ${W.errno})`)):u(`parent process ${f.parentPid} does not exist anymore: ${W.message} (code: ${W.code}) (errno: ${W.errno})`)}},1e3);let O;try{O=Q.__$__nodeRequire("native-watchdog"),O.start(f.parentPid)}catch(W){D.onUnexpectedError(W)}r.send(C.createMessageOfType(0)),n({protocol:r,initData:f})});r.send(C.createMessageOfType(1))})}async function i(){k.mark("code/extHost/willConnectToRenderer");const r=await p();k.mark("code/extHost/didConnectToRenderer");const n=await t(r);k.mark("code/extHost/didWaitForInitData");const{initData:o}=n;b(!!o.environment.extensionTestsLocationURI),o.environment.useHostProxy=S.useHostProxy!==void 0?S.useHostProxy!=="false":void 0;const g=new class{exit(a){w(a)}exists(a){return m.Promises.exists(a)}realpath(a){return c.realpath(a)}};let f=null;if(o.remote.authority&&S.uriTransformerPath)try{const a=Q.__$__nodeRequire(S.uriTransformerPath)(o.remote.authority);f=new l.URITransformer(a)}catch(y){console.error(y)}const E=new s.ExtensionHostMain(n.protocol,o,g,f);u=y=>E.terminate(y)}e.startExtensionHostProcess=i}),define(ge[287],pe([0,1,275]),function(Q,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),v.startExtensionHostProcess().catch(R=>console.log(R))})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/012b14606f75ec4fed90d7ab4154f63dffab9503/core/vs/workbench/services/extensions/node/extensionHostProcess.js.map
