/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var _e=["require","exports","vs/base/common/uri","vs/base/common/event","vs/workbench/api/common/extHost.protocol","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHostTypes","vs/base/common/lifecycle","vs/base/common/strings","vs/workbench/api/common/extHostTypeConverters","vs/base/common/types","vs/base/common/errors","vs/base/common/async","vs/workbench/api/common/extHostRpcService","vs/base/common/path","vs/platform/log/common/log","vs/base/common/network","vs/base/common/arrays","vs/base/common/cancellation","vs/nls","vs/nls!vs/workbench/services/extensions/worker/extensionHostWorker","vs/base/common/platform","vs/base/common/map","vs/base/common/buffer","vs/base/common/objects","vs/base/common/resources","vs/platform/extensions/common/extensions","vs/base/common/glob","vs/workbench/api/common/extHostInitDataService","vs/workbench/services/extensions/common/extensions","vs/workbench/api/common/extHostWorkspace","vs/editor/common/core/range","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/uuid","vs/editor/common/core/position","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostTerminalService","vs/workbench/services/search/common/search","vs/base/common/assert","vs/base/common/process","vs/base/common/severity","vs/base/common/extpath","vs/platform/registry/common/platform","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostWebview","vs/base/common/decorators","vs/base/common/functional","vs/base/common/idGenerator","vs/base/common/iterator","vs/base/common/linkedList","vs/base/common/stopwatch","vs/base/common/hash","vs/base/common/marshalling","vs/editor/common/modes/languageSelector","vs/base/common/errorMessage","vs/platform/instantiation/common/extensions","vs/editor/common/modes","vs/platform/files/common/files","vs/platform/instantiation/common/serviceCollection","vs/platform/configuration/common/configurationRegistry","vs/workbench/api/common/cache","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/api/common/shared/webview","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/api/common/exHostSecretState","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostCommands","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostStorage","vs/workbench/api/common/extHostStoragePaths","vs/base/common/performance","vs/base/common/collections","vs/base/common/numbers","vs/base/common/codicons","vs/base/common/uint","vs/base/common/htmlContent","vs/base/common/labels","vs/base/common/mime","vs/editor/common/core/characterClassifier","vs/editor/common/model","vs/editor/common/model/wordHelper","vs/editor/common/services/semanticTokensDto","vs/editor/common/viewModel/prefixSumComputer","vs/platform/instantiation/common/descriptors","vs/platform/contextkey/common/contextkey","vs/platform/markers/common/markers","vs/platform/configuration/common/configuration","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteHosts","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostDocumentData","vs/workbench/contrib/testing/common/testCollection","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTextEditor","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostOutput","vs/workbench/api/common/extHostWindow","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/json","vs/base/common/lazy","vs/base/common/stream","vs/base/common/filters","vs/base/common/iconLabels","vs/base/common/comparers","vs/base/common/uriIpc","vs/editor/common/controller/wordCharacterClassifier","vs/editor/common/core/selection","vs/editor/common/model/textModelSearch","vs/editor/common/modes/languageConfiguration","vs/editor/common/modes/linkComputer","vs/editor/common/modes/tokenizationRegistry","vs/editor/common/model/mirrorTextModel","vs/nls!vs/base/common/errorMessage","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/search/common/queryBuilder","vs/nls!vs/workbench/contrib/tasks/common/taskService","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/platform/editor/common/editor","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/editor/common/services/modelService","vs/editor/common/modes/languageFeatureRegistry","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/instantiation/common/instantiationService","vs/platform/notification/common/notification","vs/platform/opener/common/opener","vs/platform/progress/common/progress","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/terminal/common/terminalDataBuffering","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostNotebookConcatDocument","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/common/extHostCodeInsets","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/tasks/common/taskService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/editor/common/editorService","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostTreeViews","vs/workbench/contrib/testing/common/ownedTestCollection","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/worker/extHostLogService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/api/common/extHostTesting","vs/workbench/contrib/search/common/queryBuilder","vs/workbench/api/common/shared/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/services/extensions/common/extensionHostMain","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/base/common/marked/marked","vs/workbench/services/extensions/worker/extensionHostWorker"],Ee=function(Z){for(var e=[],m=0,T=Z.length;m<T;m++)e[m]=_e[Z[m]];return e};define(_e[39],Ee([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function m(T,S){if(!T)throw new Error(S?`Assertion failed (${S})`:"Assertion Failed")}e.ok=m}),define(_e[76],Ee([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const m=Object.prototype.hasOwnProperty;function T(n){const I=[];for(let o in n)m.call(n,o)&&I.push(n[o]);return I}e.values=T;function S(n,I){for(let o in n)if(m.call(n,o)&&I({key:o,value:n[o]},function(){delete n[o]})===!1)return}e.forEach=S;function y(n,I){const o=Object.create(null);for(const h of n){const d=I(h);let c=o[d];c||(c=o[d]=[]),c.push(h)}return o}e.groupBy=y;function k(n){const I=Object.create(null);return n&&n.forEach((o,h)=>{I[h]=o}),I}e.fromMap=k;function D(n,I){const o=[],h=[];for(let d of n)I.has(d)||o.push(d);for(let d of I)n.has(d)||h.push(d);return{removed:o,added:h}}e.diffSets=D;function _(n,I){const o=[],h=[];for(let[d,c]of n)I.has(d)||o.push(c);for(let[d,c]of I)n.has(d)||h.push(c);return{removed:o,added:h}}e.diffMaps=_;class C{constructor(){this.map=new Map}add(I,o){let h=this.map.get(I);h||(h=new Set,this.map.set(I,h)),h.add(o)}delete(I,o){const h=this.map.get(I);!h||(h.delete(o),h.size===0&&this.map.delete(I))}forEach(I,o){const h=this.map.get(I);!h||h.forEach(o)}}e.SetMap=C}),define(_e[47],Ee([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function m(k){return(D,_,C)=>{let n=null,I=null;if(typeof C.value=="function"?(n="value",I=C.value):typeof C.get=="function"&&(n="get",I=C.get),!I)throw new Error("not supported");C[n]=k(I,_)}}e.createDecorator=m;function T(k,D,_){let C=null,n=null;if(typeof _.value=="function"?(C="value",n=_.value,n.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof _.get=="function"&&(C="get",n=_.get),!n)throw new Error("not supported");const I=`$memoize$${D}`;_[C]=function(...o){return this.hasOwnProperty(I)||Object.defineProperty(this,I,{configurable:!1,enumerable:!1,writable:!1,value:n.apply(this,o)}),this[I]}}e.memoize=T;function S(k,D,_){return m((C,n)=>{const I=`$debounce$${n}`,o=`$debounce$result$${n}`;return function(...h){this[o]||(this[o]=_?_():void 0),clearTimeout(this[I]),D&&(this[o]=D(this[o],...h),h=[this[o]]),this[I]=setTimeout(()=>{C.apply(this,h),this[o]=_?_():void 0},k)}})}e.debounce=S;function y(k,D,_){return m((C,n)=>{const I=`$throttle$timer$${n}`,o=`$throttle$result$${n}`,h=`$throttle$lastRun$${n}`,d=`$throttle$pending$${n}`;return function(...c){if(this[o]||(this[o]=_?_():void 0),(this[h]===null||this[h]===void 0)&&(this[h]=-Number.MAX_VALUE),D&&(this[o]=D(this[o],...c)),this[d])return;const b=this[h]+k;b<=Date.now()?(this[h]=Date.now(),C.apply(this,[this[o]]),this[o]=_?_():void 0):(this[d]=!0,this[I]=setTimeout(()=>{this[d]=!1,this[h]=Date.now(),C.apply(this,[this[o]]),this[o]=_?_():void 0},b-Date.now()))}})}e.throttle=y}),define(_e[11],Ee([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isPromiseCanceledError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class m{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(t){setTimeout(()=>{throw t.stack?new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.listeners.push(t),()=>{this._removeListener(t)}}emit(t){this.listeners.forEach(i=>{i(t)})}_removeListener(t){this.listeners.splice(this.listeners.indexOf(t),1)}setUnexpectedErrorHandler(t){this.unexpectedErrorHandler=t}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(t){this.unexpectedErrorHandler(t),this.emit(t)}onUnexpectedExternalError(t){this.unexpectedErrorHandler(t)}}e.ErrorHandler=m,e.errorHandler=new m;function T(g){e.errorHandler.setUnexpectedErrorHandler(g)}e.setUnexpectedErrorHandler=T;function S(g){_(g)||e.errorHandler.onUnexpectedError(g)}e.onUnexpectedError=S;function y(g){_(g)||e.errorHandler.onUnexpectedExternalError(g)}e.onUnexpectedExternalError=y;function k(g){if(g instanceof Error){let{name:t,message:i}=g;const s=g.stacktrace||g.stack;return{$isError:!0,name:t,message:i,stack:s}}return g}e.transformErrorForSerialization=k;const D="Canceled";function _(g){return g instanceof Error&&g.name===D&&g.message===D}e.isPromiseCanceledError=_;class C extends Error{constructor(){super(D);this.name=this.message}}e.CancellationError=C;function n(){const g=new Error(D);return g.name=g.message,g}e.canceled=n;function I(g){return g?new Error(`Illegal argument: ${g}`):new Error("Illegal argument")}e.illegalArgument=I;function o(g){return g?new Error(`Illegal state: ${g}`):new Error("Illegal state")}e.illegalState=o;function h(g){return g?new Error(`readonly property '${g} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=h;function d(g){const t=new Error(`${g} has been disposed`);return t.name="DISPOSED",t}e.disposed=d;function c(g){return g?g.message?g.message:g.stack?g.stack.split(`
`)[0]:String(g):"Error"}e.getErrorMessage=c;class b extends Error{constructor(t){super("NotImplemented");t&&(this.message=t)}}e.NotImplementedError=b;class p extends Error{constructor(t){super("NotSupported");t&&(this.message=t)}}e.NotSupportedError=p;class w extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=w;function u(g){const t=g;return t instanceof Error&&Array.isArray(t.actions)}e.isErrorWithActions=u;function f(g,t=Object.create(null)){const i=new Error(g);return t.actions&&(i.actions=t.actions),i}e.createErrorWithActions=f}),define(_e[17],Ee([0,1,11]),function(Z,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.maxIndex=e.minIndex=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.uniqueFilter=e.distinctES6=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function T(B,M=0){return B[B.length-(1+M)]}e.tail=T;function S(B){if(B.length===0)throw new Error("Invalid tail call");return[B.slice(0,B.length-1),B[B.length-1]]}e.tail2=S;function y(B,M,x=(q,z)=>q===z){if(B===M)return!0;if(!B||!M||B.length!==M.length)return!1;for(let q=0,z=B.length;q<z;q++)if(!x(B[q],M[q]))return!1;return!0}e.equals=y;function k(B,M,x){let q=0,z=B.length-1;for(;q<=z;){const oe=(q+z)/2|0,pe=x(B[oe],M);if(pe<0)q=oe+1;else if(pe>0)z=oe-1;else return oe}return-(q+1)}e.binarySearch=k;function D(B,M){let x=0,q=B.length;if(q===0)return 0;for(;x<q;){const z=Math.floor((x+q)/2);M(B[z])?q=z:x=z+1}return x}e.findFirstInSorted=D;function _(B,M,x){if(B=B|0,B>=M.length)throw new TypeError("invalid index");let q=M[Math.floor(M.length*Math.random())],z=[],oe=[],pe=[];for(let Te of M){const Be=x(Te,q);Be<0?z.push(Te):Be>0?oe.push(Te):pe.push(Te)}return B<z.length?_(B,z,x):B<z.length+pe.length?pe[0]:_(B-(z.length+pe.length),oe,x)}e.quickSelect=_;function C(B,M){const x=[];let q;for(const z of B.slice(0).sort(M))!q||M(q[0],z)!==0?(q=[z],x.push(q)):q.push(z);return x}e.groupBy=C;function n(B,M,x){const q=[];function z(Te,Be,Fe){if(Be===0&&Fe.length===0)return;const We=q[q.length-1];We&&We.start+We.deleteCount===Te?(We.deleteCount+=Be,We.toInsert.push(...Fe)):q.push({start:Te,deleteCount:Be,toInsert:Fe})}let oe=0,pe=0;for(;;){if(oe===B.length){z(oe,0,M.slice(pe));break}if(pe===M.length){z(oe,B.length-oe,[]);break}const Te=B[oe],Be=M[pe],Fe=x(Te,Be);Fe===0?(oe+=1,pe+=1):Fe<0?(z(oe,1,[]),oe+=1):Fe>0&&(z(oe,0,[Be]),pe+=1)}return q}e.sortedDiff=n;function I(B,M,x){const q=n(B,M,x),z=[],oe=[];for(const pe of q)z.push(...B.slice(pe.start,pe.start+pe.deleteCount)),oe.push(...pe.toInsert);return{removed:z,added:oe}}e.delta=I;function o(B,M,x){if(x===0)return[];const q=B.slice(0,x).sort(M);return d(B,M,q,x,B.length),q}e.top=o;function h(B,M,x,q,z){return x===0?Promise.resolve([]):new Promise((oe,pe)=>{(async()=>{const Te=B.length,Be=B.slice(0,x).sort(M);for(let Fe=x,We=Math.min(x+q,Te);Fe<Te;Fe=We,We=Math.min(We+q,Te)){if(Fe>x&&await new Promise(Qe=>setTimeout(Qe)),z&&z.isCancellationRequested)throw m.canceled();d(B,M,Be,Fe,We)}return Be})().then(oe,pe)})}e.topAsync=h;function d(B,M,x,q,z){for(const oe=x.length;q<z;q++){const pe=B[q];if(M(pe,x[oe-1])<0){x.pop();const Te=D(x,Be=>M(pe,Be)<0);x.splice(Te,0,pe)}}}function c(B){return B.filter(M=>!!M)}e.coalesce=c;function b(B){let M=0;for(let x=0;x<B.length;x++)B[x]&&(B[M]=B[x],M+=1);B.length=M}e.coalesceInPlace=b;function p(B,M,x){B.splice(x,0,B.splice(M,1)[0])}e.move=p;function w(B){return!Array.isArray(B)||B.length===0}e.isFalsyOrEmpty=w;function u(B){return Array.isArray(B)&&B.length>0}e.isNonEmptyArray=u;function f(B,M){if(!M)return B.filter((q,z)=>B.indexOf(q)===z);const x=Object.create(null);return B.filter(q=>{const z=M(q);return x[z]?!1:(x[z]=!0,!0)})}e.distinct=f;function g(B){const M=new Set;return B.filter(x=>M.has(x)?!1:(M.add(x),!0))}e.distinctES6=g;function t(B){const M=Object.create(null);return x=>{const q=B(x);return M[q]?!1:(M[q]=!0,!0)}}e.uniqueFilter=t;function i(B,M){for(let x=B.length-1;x>=0;x--){const q=B[x];if(M(q))return x}return-1}e.lastIndex=i;function s(B,M){return B.length>0?B[0]:M}e.firstOrDefault=s;function r(B,M,x=(q,z)=>q===z){let q=0;for(let z=0,oe=Math.min(B.length,M.length);z<oe&&x(B[z],M[z]);z++)q++;return q}e.commonPrefixLength=r;function l(B){return[].concat(...B)}e.flatten=l;function E(B,M){let x=typeof M=="number"?B:0;typeof M=="number"?x=B:(x=0,M=B);const q=[];if(x<=M)for(let z=x;z<M;z++)q.push(z);else for(let z=x;z>M;z--)q.push(z);return q}e.range=E;function v(B,M,x){return B.reduce((q,z)=>(q[M(z)]=x?x(z):z,q),Object.create(null))}e.index=v;function A(B,M){return B.push(M),()=>P(B,M)}e.insert=A;function P(B,M){const x=B.indexOf(M);if(x>-1)return B.splice(x,1),M}e.remove=P;function a(B,M,x){const q=B.slice(0,M),z=B.slice(M);return q.concat(x,z)}e.arrayInsert=a;function F(B,M){let x;if(typeof M=="number"){let q=M;x=()=>{const z=Math.sin(q++)*179426549;return z-Math.floor(z)}}else x=Math.random;for(let q=B.length-1;q>0;q-=1){const z=Math.floor(x()*(q+1)),oe=B[q];B[q]=B[z],B[z]=oe}}e.shuffle=F;function N(B,M){const x=B.indexOf(M);x>-1&&(B.splice(x,1),B.unshift(M))}e.pushToStart=N;function W(B,M){const x=B.indexOf(M);x>-1&&(B.splice(x,1),B.push(M))}e.pushToEnd=W;function le(B,M){return Array.isArray(B)?B.map(M):M(B)}e.mapArrayOrNot=le;function fe(B){return Array.isArray(B)?B:[B]}e.asArray=fe;function Y(B){return B[Math.floor(Math.random()*B.length)]}e.getRandomElement=Y;function H(B,M){for(const x of B){const q=M(x);if(q!==void 0)return q}}e.mapFind=H;function J(B,M){let x=Number.MAX_SAFE_INTEGER,q=0;return B.forEach((z,oe)=>{const pe=M(z);pe<x&&(x=pe,q=oe)}),q}e.minIndex=J;function R(B,M){let x=Number.MIN_SAFE_INTEGER,q=0;return B.forEach((z,oe)=>{const pe=M(z);pe>x&&(x=pe,q=oe)}),q}e.maxIndex=R}),define(_e[48],Ee([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function m(T){const S=this;let y=!1,k;return function(){return y||(y=!0,k=T.apply(S,arguments)),k}}e.once=m}),define(_e[49],Ee([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class m{constructor(S){this._prefix=S,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=m,e.defaultGenerator=new m("id#")}),define(_e[50],Ee([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var m;(function(T){function S(g){return g&&typeof g=="object"&&typeof g[Symbol.iterator]=="function"}T.is=S;const y=Object.freeze([]);function k(){return y}T.empty=k;function*D(g){yield g}T.single=D;function _(g){return g||y}T.from=_;function C(g){return!g||g[Symbol.iterator]().next().done===!0}T.isEmpty=C;function n(g){return g[Symbol.iterator]().next().value}T.first=n;function I(g,t){for(const i of g)if(t(i))return!0;return!1}T.some=I;function o(g,t){for(const i of g)if(t(i))return i}T.find=o;function*h(g,t){for(const i of g)t(i)&&(yield i)}T.filter=h;function*d(g,t){let i=0;for(const s of g)yield t(s,i++)}T.map=d;function*c(...g){for(const t of g)for(const i of t)yield i}T.concat=c;function*b(g){for(const t of g)for(const i of t)yield i}T.concatNested=b;function p(g,t,i){let s=i;for(const r of g)s=t(s,r);return s}T.reduce=p;function*w(g,t,i=g.length){for(t<0&&(t+=g.length),i<0?i+=g.length:i>g.length&&(i=g.length);t<i;t++)yield g[t]}T.slice=w;function u(g,t=Number.POSITIVE_INFINITY){const i=[];if(t===0)return[i,g];const s=g[Symbol.iterator]();for(let r=0;r<t;r++){const l=s.next();if(l.done)return[i,T.empty()];i.push(l.value)}return[i,{[Symbol.iterator](){return s}}]}T.consume=u;function f(g,t,i=(s,r)=>s===r){const s=g[Symbol.iterator](),r=t[Symbol.iterator]();for(;;){const l=s.next(),E=r.next();if(l.done!==E.done)return!1;if(l.done)return!0;if(!i(l.value,E.value))return!1}}T.equals=f})(m=e.Iterable||(e.Iterable={}))}),define(_e[107],Ee([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var m;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(m=e.ScanError||(e.ScanError={}));var T;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(T=e.SyntaxKind||(e.SyntaxKind={}));var S;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(S=e.ParseErrorCode||(e.ParseErrorCode={}));var y;(function(t){t.DEFAULT={allowTrailingComma:!0}})(y=e.ParseOptions||(e.ParseOptions={}));function k(t,i=!1){let s=0,r=t.length,l="",E=0,v=16,A=0;function P(Y){let H=0,J=0;for(;H<Y;){const R=t.charCodeAt(s);if(R>=48&&R<=57)J=J*16+R-48;else if(R>=65&&R<=70)J=J*16+R-65+10;else if(R>=97&&R<=102)J=J*16+R-97+10;else break;s++,H++}return H<Y&&(J=-1),J}function a(Y){s=Y,l="",E=0,v=16,A=0}function F(){const Y=s;if(t.charCodeAt(s)===48)s++;else for(s++;s<t.length&&C(t.charCodeAt(s));)s++;if(s<t.length&&t.charCodeAt(s)===46)if(s++,s<t.length&&C(t.charCodeAt(s)))for(s++;s<t.length&&C(t.charCodeAt(s));)s++;else return A=3,t.substring(Y,s);let H=s;if(s<t.length&&(t.charCodeAt(s)===69||t.charCodeAt(s)===101))if(s++,(s<t.length&&t.charCodeAt(s)===43||t.charCodeAt(s)===45)&&s++,s<t.length&&C(t.charCodeAt(s))){for(s++;s<t.length&&C(t.charCodeAt(s));)s++;H=s}else A=3;return t.substring(Y,H)}function N(){let Y="",H=s;for(;;){if(s>=r){Y+=t.substring(H,s),A=2;break}const J=t.charCodeAt(s);if(J===34){Y+=t.substring(H,s),s++;break}if(J===92){if(Y+=t.substring(H,s),s++,s>=r){A=2;break}switch(t.charCodeAt(s++)){case 34:Y+='"';break;case 92:Y+="\\";break;case 47:Y+="/";break;case 98:Y+="\b";break;case 102:Y+="\f";break;case 110:Y+=`
`;break;case 114:Y+="\r";break;case 116:Y+="	";break;case 117:const B=P(4);B>=0?Y+=String.fromCharCode(B):A=4;break;default:A=5}H=s;continue}if(J>=0&&J<=31)if(_(J)){Y+=t.substring(H,s),A=2;break}else A=6;s++}return Y}function W(){if(l="",A=0,E=s,s>=r)return E=r,v=17;let Y=t.charCodeAt(s);if(D(Y)){do s++,l+=String.fromCharCode(Y),Y=t.charCodeAt(s);while(D(Y));return v=15}if(_(Y))return s++,l+=String.fromCharCode(Y),Y===13&&t.charCodeAt(s)===10&&(s++,l+=`
`),v=14;switch(Y){case 123:return s++,v=1;case 125:return s++,v=2;case 91:return s++,v=3;case 93:return s++,v=4;case 58:return s++,v=6;case 44:return s++,v=5;case 34:return s++,l=N(),v=10;case 47:const H=s-1;if(t.charCodeAt(s+1)===47){for(s+=2;s<r&&!_(t.charCodeAt(s));)s++;return l=t.substring(H,s),v=12}if(t.charCodeAt(s+1)===42){s+=2;const J=r-1;let R=!1;for(;s<J;){if(t.charCodeAt(s)===42&&t.charCodeAt(s+1)===47){s+=2,R=!0;break}s++}return R||(s++,A=1),l=t.substring(H,s),v=13}return l+=String.fromCharCode(Y),s++,v=16;case 45:if(l+=String.fromCharCode(Y),s++,s===r||!C(t.charCodeAt(s)))return v=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return l+=F(),v=11;default:for(;s<r&&le(Y);)s++,Y=t.charCodeAt(s);if(E!==s){switch(l=t.substring(E,s),l){case"true":return v=8;case"false":return v=9;case"null":return v=7}return v=16}return l+=String.fromCharCode(Y),s++,v=16}}function le(Y){if(D(Y)||_(Y))return!1;switch(Y){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function fe(){let Y;do Y=W();while(Y>=12&&Y<=15);return Y}return{setPosition:a,getPosition:()=>s,scan:i?fe:W,getToken:()=>v,getTokenValue:()=>l,getTokenOffset:()=>E,getTokenLength:()=>s-E,getTokenError:()=>A}}e.createScanner=k;function D(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function _(t){return t===10||t===13||t===8232||t===8233}function C(t){return t>=48&&t<=57}var n;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(n||(n={}));function I(t,i){const s=[],r=new Object;let l;const E={value:{},offset:0,length:0,type:"object",parent:void 0};let v=!1;function A(P,a,F,N){E.value=P,E.offset=a,E.length=F,E.type=N,E.colonOffset=void 0,l=E}try{u(t,{onObjectBegin:(P,a)=>{if(i<=P)throw r;l=void 0,v=i>P,s.push("")},onObjectProperty:(P,a,F)=>{if(i<a||(A(P,a,F,"property"),s[s.length-1]=P,i<=a+F))throw r},onObjectEnd:(P,a)=>{if(i<=P)throw r;l=void 0,s.pop()},onArrayBegin:(P,a)=>{if(i<=P)throw r;l=void 0,s.push(0)},onArrayEnd:(P,a)=>{if(i<=P)throw r;l=void 0,s.pop()},onLiteralValue:(P,a,F)=>{if(i<a||(A(P,a,F,g(P)),i<=a+F))throw r},onSeparator:(P,a,F)=>{if(i<=a)throw r;if(P===":"&&l&&l.type==="property")l.colonOffset=a,v=!1,l=void 0;else if(P===","){const N=s[s.length-1];typeof N=="number"?s[s.length-1]=N+1:(v=!0,s[s.length-1]=""),l=void 0}}})}catch(P){if(P!==r)throw P}return{path:s,previousNode:l,isAtPropertyKey:v,matches:P=>{let a=0;for(let F=0;a<P.length&&F<s.length;F++)if(P[a]===s[F]||P[a]==="*")a++;else if(P[a]!=="**")return!1;return a===P.length}}}e.getLocation=I;function o(t,i=[],s=y.DEFAULT){let r=null,l=[];const E=[];function v(P){Array.isArray(l)?l.push(P):r!==null&&(l[r]=P)}return u(t,{onObjectBegin:()=>{const P={};v(P),E.push(l),l=P,r=null},onObjectProperty:P=>{r=P},onObjectEnd:()=>{l=E.pop()},onArrayBegin:()=>{const P=[];v(P),E.push(l),l=P,r=null},onArrayEnd:()=>{l=E.pop()},onLiteralValue:v,onError:(P,a,F)=>{i.push({error:P,offset:a,length:F})}},s),l[0]}e.parse=o;function h(t,i=[],s=y.DEFAULT){let r={type:"array",offset:-1,length:-1,children:[],parent:void 0};function l(P){r.type==="property"&&(r.length=P-r.offset,r=r.parent)}function E(P){return r.children.push(P),P}u(t,{onObjectBegin:P=>{r=E({type:"object",offset:P,length:-1,parent:r,children:[]})},onObjectProperty:(P,a,F)=>{r=E({type:"property",offset:a,length:-1,parent:r,children:[]}),r.children.push({type:"string",value:P,offset:a,length:F,parent:r})},onObjectEnd:(P,a)=>{r.length=P+a-r.offset,r=r.parent,l(P+a)},onArrayBegin:(P,a)=>{r=E({type:"array",offset:P,length:-1,parent:r,children:[]})},onArrayEnd:(P,a)=>{r.length=P+a-r.offset,r=r.parent,l(P+a)},onLiteralValue:(P,a,F)=>{E({type:g(P),offset:a,length:F,parent:r,value:P}),l(a+F)},onSeparator:(P,a,F)=>{r.type==="property"&&(P===":"?r.colonOffset=a:P===","&&l(a))},onError:(P,a,F)=>{i.push({error:P,offset:a,length:F})}},s);const A=r.children[0];return A&&delete A.parent,A}e.parseTree=h;function d(t,i){if(!t)return;let s=t;for(let r of i)if(typeof r=="string"){if(s.type!=="object"||!Array.isArray(s.children))return;let l=!1;for(const E of s.children)if(Array.isArray(E.children)&&E.children[0].value===r){s=E.children[1],l=!0;break}if(!l)return}else{const l=r;if(s.type!=="array"||l<0||!Array.isArray(s.children)||l>=s.children.length)return;s=s.children[l]}return s}e.findNodeAtLocation=d;function c(t){if(!t.parent||!t.parent.children)return[];const i=c(t.parent);if(t.parent.type==="property"){const s=t.parent.children[0].value;i.push(s)}else if(t.parent.type==="array"){const s=t.parent.children.indexOf(t);s!==-1&&i.push(s)}return i}e.getNodePath=c;function b(t){switch(t.type){case"array":return t.children.map(b);case"object":const i=Object.create(null);for(let s of t.children){const r=s.children[1];r&&(i[s.children[0].value]=b(r))}return i;case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=b;function p(t,i,s=!1){return i>=t.offset&&i<t.offset+t.length||s&&i===t.offset+t.length}e.contains=p;function w(t,i,s=!1){if(p(t,i,s)){const r=t.children;if(Array.isArray(r))for(let l=0;l<r.length&&r[l].offset<=i;l++){const E=w(r[l],i,s);if(E)return E}return t}}e.findNodeAtOffset=w;function u(t,i,s=y.DEFAULT){const r=k(t,!1);function l(pe){return pe?()=>pe(r.getTokenOffset(),r.getTokenLength()):()=>!0}function E(pe){return pe?Te=>pe(Te,r.getTokenOffset(),r.getTokenLength()):()=>!0}const v=l(i.onObjectBegin),A=E(i.onObjectProperty),P=l(i.onObjectEnd),a=l(i.onArrayBegin),F=l(i.onArrayEnd),N=E(i.onLiteralValue),W=E(i.onSeparator),le=l(i.onComment),fe=E(i.onError),Y=s&&s.disallowComments,H=s&&s.allowTrailingComma;function J(){for(;;){const pe=r.scan();switch(r.getTokenError()){case 4:R(14);break;case 5:R(15);break;case 3:R(13);break;case 1:Y||R(11);break;case 2:R(12);break;case 6:R(16);break}switch(pe){case 12:case 13:Y?R(10):le();break;case 16:R(1);break;case 15:case 14:break;default:return pe}}}function R(pe,Te=[],Be=[]){if(fe(pe),Te.length+Be.length>0){let Fe=r.getToken();for(;Fe!==17;){if(Te.indexOf(Fe)!==-1){J();break}else if(Be.indexOf(Fe)!==-1)break;Fe=J()}}}function B(pe){const Te=r.getTokenValue();return pe?N(Te):A(Te),J(),!0}function M(){switch(r.getToken()){case 11:let pe=0;try{pe=JSON.parse(r.getTokenValue()),typeof pe!="number"&&(R(2),pe=0)}catch(Te){R(2)}N(pe);break;case 7:N(null);break;case 8:N(!0);break;case 9:N(!1);break;default:return!1}return J(),!0}function x(){return r.getToken()!==10?(R(3,[],[2,5]),!1):(B(!1),r.getToken()===6?(W(":"),J(),oe()||R(4,[],[2,5])):R(5,[],[2,5]),!0)}function q(){v(),J();let pe=!1;for(;r.getToken()!==2&&r.getToken()!==17;){if(r.getToken()===5){if(pe||R(4,[],[]),W(","),J(),r.getToken()===2&&H)break}else pe&&R(6,[],[]);x()||R(4,[],[2,5]),pe=!0}return P(),r.getToken()!==2?R(7,[2],[]):J(),!0}function z(){a(),J();let pe=!1;for(;r.getToken()!==4&&r.getToken()!==17;){if(r.getToken()===5){if(pe||R(4,[],[]),W(","),J(),r.getToken()===4&&H)break}else pe&&R(6,[],[]);oe()||R(4,[],[4,5]),pe=!0}return F(),r.getToken()!==4?R(8,[4],[]):J(),!0}function oe(){switch(r.getToken()){case 3:return z();case 1:return q();case 10:return B(!0);default:return M()}}return J(),r.getToken()===17?s.allowEmptyContent?!0:(R(4,[],[]),!1):oe()?(r.getToken()!==17&&R(9,[],[]),!0):(R(4,[],[]),!1)}e.visit=u;function f(t,i){let s=k(t),r=[],l,E=0,v;do switch(v=s.getPosition(),l=s.scan(),l){case 12:case 13:case 17:E!==v&&r.push(t.substring(E,v)),i!==void 0&&r.push(s.getTokenValue().replace(/[^\r\n]/g,i)),E=s.getPosition();break}while(l!==17);return r.join("")}e.stripComments=f;function g(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=g}),define(_e[108],Ee([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class m{constructor(S){this.executor=S,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(S){this._error=S}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(S){return new m(()=>S(this.getValue()))}}e.Lazy=m}),define(_e[7],Ee([0,1,48,50]),function(Z,e,m,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.trackDisposable=e.setDisposableTracker=void 0;const S=!1;let y=null;function k(f){y=f}if(e.setDisposableTracker=k,S){const f="__is_disposable_tracked__";y=new class{trackDisposable(g){const t=new Error("Potentially leaked disposable").stack;setTimeout(()=>{g[f]||console.log(t)},3e3)}markTracked(g){if(g&&g!==c.None)try{g[f]=!0}catch(t){}}}}function D(f){!y||y.markTracked(f)}function _(f){return y&&y.trackDisposable(f),f}e.trackDisposable=_;class C extends Error{constructor(g){super(`Encountered errors while disposing of store. Errors: [${g.join(", ")}]`);this.errors=g}}e.MultiDisposeError=C;function n(f){return typeof f.dispose=="function"&&f.dispose.length===0}e.isDisposable=n;function I(f){if(T.Iterable.is(f)){let g=[];for(const t of f)if(t){D(t);try{t.dispose()}catch(i){g.push(i)}}if(g.length===1)throw g[0];if(g.length>1)throw new C(g);return Array.isArray(f)?[]:f}else if(f)return D(f),f.dispose(),f}e.dispose=I;function o(...f){return f.forEach(D),h(()=>I(f))}e.combinedDisposable=o;function h(f){const g=_({dispose:()=>{D(g),f()}});return g}e.toDisposable=h;class d{constructor(){this._toDispose=new Set,this._isDisposed=!1}dispose(){this._isDisposed||(D(this),this._isDisposed=!0,this.clear())}clear(){try{I(this._toDispose.values())}finally{this._toDispose.clear()}}add(g){if(!g)return g;if(g===this)throw new Error("Cannot register a disposable on itself!");return D(g),this._isDisposed?d.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(g),g}}e.DisposableStore=d,d.DISABLE_DISPOSED_WARNING=!1;class c{constructor(){this._store=new d,_(this)}dispose(){D(this),this._store.dispose()}_register(g){if(g===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(g)}}e.Disposable=c,c.None=Object.freeze({dispose(){}});class b{constructor(){this._isDisposed=!1,_(this)}get value(){return this._isDisposed?void 0:this._value}set value(g){var t;this._isDisposed||g===this._value||((t=this._value)===null||t===void 0||t.dispose(),g&&D(g),this._value=g)}clear(){this.value=void 0}dispose(){var g;this._isDisposed=!0,D(this),(g=this._value)===null||g===void 0||g.dispose(),this._value=void 0}}e.MutableDisposable=b;class p{constructor(){this.references=new Map}acquire(g,...t){let i=this.references.get(g);i||(i={counter:0,object:this.createReferencedObject(g,...t)},this.references.set(g,i));const{object:s}=i,r=m.once(()=>{--i.counter==0&&(this.destroyReferencedObject(g,i.object),this.references.delete(g))});return i.counter++,{object:s,dispose:r}}}e.ReferenceCollection=p;class w{constructor(g){this.referenceCollection=g}async acquire(g,...t){const i=this.referenceCollection.acquire(g,...t);try{return{object:await i.object,dispose:()=>i.dispose()}}catch(s){throw i.dispose(),s}}}e.AsyncReferenceCollection=w;class u{constructor(g){this.object=g}dispose(){}}e.ImmortalReference=u}),define(_e[51],Ee([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class m{constructor(y){this.element=y,this.next=m.Undefined,this.prev=m.Undefined}}m.Undefined=new m(void 0);class T{constructor(){this._first=m.Undefined,this._last=m.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===m.Undefined}clear(){let y=this._first;for(;y!==m.Undefined;){const k=y.next;y.prev=m.Undefined,y.next=m.Undefined,y=k}this._first=m.Undefined,this._last=m.Undefined,this._size=0}unshift(y){return this._insert(y,!1)}push(y){return this._insert(y,!0)}_insert(y,k){const D=new m(y);if(this._first===m.Undefined)this._first=D,this._last=D;else if(k){const C=this._last;this._last=D,D.prev=C,C.next=D}else{const C=this._first;this._first=D,D.next=C,C.prev=D}this._size+=1;let _=!1;return()=>{_||(_=!0,this._remove(D))}}shift(){if(this._first!==m.Undefined){const y=this._first.element;return this._remove(this._first),y}}pop(){if(this._last!==m.Undefined){const y=this._last.element;return this._remove(this._last),y}}_remove(y){if(y.prev!==m.Undefined&&y.next!==m.Undefined){const k=y.prev;k.next=y.next,y.next.prev=k}else y.prev===m.Undefined&&y.next===m.Undefined?(this._first=m.Undefined,this._last=m.Undefined):y.next===m.Undefined?(this._last=this._last.prev,this._last.next=m.Undefined):y.prev===m.Undefined&&(this._first=this._first.next,this._first.prev=m.Undefined);this._size-=1}*[Symbol.iterator](){let y=this._first;for(;y!==m.Undefined;)yield y.element,y=y.next}}e.LinkedList=T}),function(Z,e){typeof exports=="object"&&typeof module!="undefined"?module.exports=e():typeof define=="function"&&define.amd?define("vs/base/common/marked/marked",e):(Z=typeof globalThis!="undefined"?globalThis:Z||self,Z.marked=e())}(this,function(){"use strict";function Z(Se,we){for(var Ce=0;Ce<we.length;Ce++){var ie=we[Ce];ie.enumerable=ie.enumerable||!1,ie.configurable=!0,"value"in ie&&(ie.writable=!0),Object.defineProperty(Se,ie.key,ie)}}function e(Se,we,Ce){return we&&Z(Se.prototype,we),Ce&&Z(Se,Ce),Se}function m(Se,we){if(!!Se){if(typeof Se=="string")return T(Se,we);var Ce=Object.prototype.toString.call(Se).slice(8,-1);if(Ce==="Object"&&Se.constructor&&(Ce=Se.constructor.name),Ce==="Map"||Ce==="Set")return Array.from(Se);if(Ce==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(Ce))return T(Se,we)}}function T(Se,we){(we==null||we>Se.length)&&(we=Se.length);for(var Ce=0,ie=new Array(we);Ce<we;Ce++)ie[Ce]=Se[Ce];return ie}function S(Se,we){var Ce;if(typeof Symbol=="undefined"||Se[Symbol.iterator]==null){if(Array.isArray(Se)||(Ce=m(Se))||we&&Se&&typeof Se.length=="number"){Ce&&(Se=Ce);var ie=0;return function(){return ie>=Se.length?{done:!0}:{done:!1,value:Se[ie++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}return Ce=Se[Symbol.iterator](),Ce.next.bind(Ce)}function y(Se){var we={exports:{}};return Se(we,we.exports),we.exports}var k=y(function(Se){function we(){return{baseUrl:null,breaks:!1,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}function Ce(ie){Se.exports.defaults=ie}Se.exports={defaults:we(),getDefaults:we,changeDefaults:Ce}}),D=/[&<>"']/,_=/[&<>"']/g,C=/[<>"']|&(?!#?\w+;)/,n=/[<>"']|&(?!#?\w+;)/g,I={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},o=function(we){return I[we]};function h(Se,we){if(we){if(D.test(Se))return Se.replace(_,o)}else if(C.test(Se))return Se.replace(n,o);return Se}var d=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function c(Se){return Se.replace(d,function(we,Ce){return Ce=Ce.toLowerCase(),Ce==="colon"?":":Ce.charAt(0)==="#"?Ce.charAt(1)==="x"?String.fromCharCode(parseInt(Ce.substring(2),16)):String.fromCharCode(+Ce.substring(1)):""})}var b=/(^|[^\[])\^/g;function p(Se,we){Se=Se.source||Se,we=we||"";var Ce={replace:function(ce,O){return O=O.source||O,O=O.replace(b,"$1"),Se=Se.replace(ce,O),Ce},getRegex:function(){return new RegExp(Se,we)}};return Ce}var w=/[^\w:]/g,u=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function f(Se,we,Ce){if(Se){var ie;try{ie=decodeURIComponent(c(Ce)).replace(w,"").toLowerCase()}catch(ce){return null}if(ie.indexOf("javascript:")===0||ie.indexOf("vbscript:")===0||ie.indexOf("data:")===0)return null}we&&!u.test(Ce)&&(Ce=r(we,Ce));try{Ce=encodeURI(Ce).replace(/%25/g,"%")}catch(ce){return null}return Ce}var g={},t=/^[^:]+:\/*[^/]*$/,i=/^([^:]+:)[\s\S]*$/,s=/^([^:]+:\/*[^/]*)[\s\S]*$/;function r(Se,we){g[" "+Se]||(t.test(Se)?g[" "+Se]=Se+"/":g[" "+Se]=A(Se,"/",!0)),Se=g[" "+Se];var Ce=Se.indexOf(":")===-1;return we.substring(0,2)==="//"?Ce?we:Se.replace(i,"$1")+we:we.charAt(0)==="/"?Ce?we:Se.replace(s,"$1")+we:Se+we}var l={exec:function(){}};function E(Se){for(var we=1,Ce,ie;we<arguments.length;we++){Ce=arguments[we];for(ie in Ce)Object.prototype.hasOwnProperty.call(Ce,ie)&&(Se[ie]=Ce[ie])}return Se}function v(Se,we){var Ce=Se.replace(/\|/g,function(O,K,ae){for(var ke=!1,Pe=K;--Pe>=0&&ae[Pe]==="\\";)ke=!ke;return ke?"|":" |"}),ie=Ce.split(/ \|/),ce=0;if(ie.length>we)ie.splice(we);else for(;ie.length<we;)ie.push("");for(;ce<ie.length;ce++)ie[ce]=ie[ce].trim().replace(/\\\|/g,"|");return ie}function A(Se,we,Ce){var ie=Se.length;if(ie===0)return"";for(var ce=0;ce<ie;){var O=Se.charAt(ie-ce-1);if(O===we&&!Ce)ce++;else if(O!==we&&Ce)ce++;else break}return Se.substr(0,ie-ce)}function P(Se,we){if(Se.indexOf(we[1])===-1)return-1;for(var Ce=Se.length,ie=0,ce=0;ce<Ce;ce++)if(Se[ce]==="\\")ce++;else if(Se[ce]===we[0])ie++;else if(Se[ce]===we[1]&&(ie--,ie<0))return ce;return-1}function a(Se){Se&&Se.sanitize&&!Se.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function F(Se,we){if(we<1)return"";for(var Ce="";we>1;)we&1&&(Ce+=Se),we>>=1,Se+=Se;return Ce+Se}var N={escape:h,unescape:c,edit:p,cleanUrl:f,resolveUrl:r,noopTest:l,merge:E,splitCells:v,rtrim:A,findClosingBracket:P,checkSanitizeDeprecation:a,repeatString:F},W=k.defaults,le=N.rtrim,fe=N.splitCells,Y=N.escape,H=N.findClosingBracket;function J(Se,we,Ce){var ie=we.href,ce=we.title?Y(we.title):null,O=Se[1].replace(/\\([\[\]])/g,"$1");return Se[0].charAt(0)!=="!"?{type:"link",raw:Ce,href:ie,title:ce,text:O}:{type:"image",raw:Ce,href:ie,title:ce,text:Y(O)}}function R(Se,we){var Ce=Se.match(/^(\s+)(?:```)/);if(Ce===null)return we;var ie=Ce[1];return we.split(`
`).map(function(ce){var O=ce.match(/^\s+/);if(O===null)return ce;var K=O[0];return K.length>=ie.length?ce.slice(ie.length):ce}).join(`
`)}var B=function(){function Se(Ce){this.options=Ce||W}var we=Se.prototype;return we.space=function(ie){var ce=this.rules.block.newline.exec(ie);if(ce)return ce[0].length>1?{type:"space",raw:ce[0]}:{raw:`
`}},we.code=function(ie){var ce=this.rules.block.code.exec(ie);if(ce){var O=ce[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:ce[0],codeBlockStyle:"indented",text:this.options.pedantic?O:le(O,`
`)}}},we.fences=function(ie){var ce=this.rules.block.fences.exec(ie);if(ce){var O=ce[0],K=R(O,ce[3]||"");return{type:"code",raw:O,lang:ce[2]?ce[2].trim():ce[2],text:K}}},we.heading=function(ie){var ce=this.rules.block.heading.exec(ie);if(ce){var O=ce[2].trim();if(/#$/.test(O)){var K=le(O,"#");(this.options.pedantic||!K||/ $/.test(K))&&(O=K.trim())}return{type:"heading",raw:ce[0],depth:ce[1].length,text:O}}},we.nptable=function(ie){var ce=this.rules.block.nptable.exec(ie);if(ce){var O={type:"table",header:fe(ce[1].replace(/^ *| *\| *$/g,"")),align:ce[2].replace(/^ *|\| *$/g,"").split(/ *\| */),cells:ce[3]?ce[3].replace(/\n$/,"").split(`
`):[],raw:ce[0]};if(O.header.length===O.align.length){var K=O.align.length,ae;for(ae=0;ae<K;ae++)/^ *-+: *$/.test(O.align[ae])?O.align[ae]="right":/^ *:-+: *$/.test(O.align[ae])?O.align[ae]="center":/^ *:-+ *$/.test(O.align[ae])?O.align[ae]="left":O.align[ae]=null;for(K=O.cells.length,ae=0;ae<K;ae++)O.cells[ae]=fe(O.cells[ae],O.header.length);return O}}},we.hr=function(ie){var ce=this.rules.block.hr.exec(ie);if(ce)return{type:"hr",raw:ce[0]}},we.blockquote=function(ie){var ce=this.rules.block.blockquote.exec(ie);if(ce){var O=ce[0].replace(/^ *> ?/gm,"");return{type:"blockquote",raw:ce[0],text:O}}},we.list=function(ie){var ce=this.rules.block.list.exec(ie);if(ce){var O=ce[0],K=ce[2],ae=K.length>1,ke={type:"list",raw:O,ordered:ae,start:ae?+K.slice(0,-1):"",loose:!1,items:[]},Pe=ce[0].match(this.rules.block.item),Oe=!1,$e,Ze,Je,Ye,nt,pt,be,ye,ue=Pe.length;Je=this.rules.block.listItemStart.exec(Pe[0]);for(var j=0;j<ue;j++){if($e=Pe[j],O=$e,j!==ue-1){if(Ye=this.rules.block.listItemStart.exec(Pe[j+1]),this.options.pedantic?Ye[1].length>Je[1].length:Ye[1].length>Je[0].length||Ye[1].length>3){Pe.splice(j,2,Pe[j]+`
`+Pe[j+1]),j--,ue--;continue}else(!this.options.pedantic||this.options.smartLists?Ye[2][Ye[2].length-1]!==K[K.length-1]:ae===(Ye[2].length===1))&&(nt=Pe.slice(j+1).join(`
`),ke.raw=ke.raw.substring(0,ke.raw.length-nt.length),j=ue-1);Je=Ye}Ze=$e.length,$e=$e.replace(/^ *([*+-]|\d+[.)]) ?/,""),~$e.indexOf(`
 `)&&(Ze-=$e.length,$e=this.options.pedantic?$e.replace(/^ {1,4}/gm,""):$e.replace(new RegExp("^ {1,"+Ze+"}","gm"),"")),pt=Oe||/\n\n(?!\s*$)/.test($e),j!==ue-1&&(Oe=$e.charAt($e.length-1)===`
`,pt||(pt=Oe)),pt&&(ke.loose=!0),this.options.gfm&&(be=/^\[[ xX]\] /.test($e),ye=void 0,be&&(ye=$e[1]!==" ",$e=$e.replace(/^\[[ xX]\] +/,""))),ke.items.push({type:"list_item",raw:O,task:be,checked:ye,loose:pt,text:$e})}return ke}},we.html=function(ie){var ce=this.rules.block.html.exec(ie);if(ce)return{type:this.options.sanitize?"paragraph":"html",raw:ce[0],pre:!this.options.sanitizer&&(ce[1]==="pre"||ce[1]==="script"||ce[1]==="style"),text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ce[0]):Y(ce[0]):ce[0]}},we.def=function(ie){var ce=this.rules.block.def.exec(ie);if(ce){ce[3]&&(ce[3]=ce[3].substring(1,ce[3].length-1));var O=ce[1].toLowerCase().replace(/\s+/g," ");return{tag:O,raw:ce[0],href:ce[2],title:ce[3]}}},we.table=function(ie){var ce=this.rules.block.table.exec(ie);if(ce){var O={type:"table",header:fe(ce[1].replace(/^ *| *\| *$/g,"")),align:ce[2].replace(/^ *|\| *$/g,"").split(/ *\| */),cells:ce[3]?ce[3].replace(/\n$/,"").split(`
`):[]};if(O.header.length===O.align.length){O.raw=ce[0];var K=O.align.length,ae;for(ae=0;ae<K;ae++)/^ *-+: *$/.test(O.align[ae])?O.align[ae]="right":/^ *:-+: *$/.test(O.align[ae])?O.align[ae]="center":/^ *:-+ *$/.test(O.align[ae])?O.align[ae]="left":O.align[ae]=null;for(K=O.cells.length,ae=0;ae<K;ae++)O.cells[ae]=fe(O.cells[ae].replace(/^ *\| *| *\| *$/g,""),O.header.length);return O}}},we.lheading=function(ie){var ce=this.rules.block.lheading.exec(ie);if(ce)return{type:"heading",raw:ce[0],depth:ce[2].charAt(0)==="="?1:2,text:ce[1]}},we.paragraph=function(ie){var ce=this.rules.block.paragraph.exec(ie);if(ce)return{type:"paragraph",raw:ce[0],text:ce[1].charAt(ce[1].length-1)===`
`?ce[1].slice(0,-1):ce[1]}},we.text=function(ie){var ce=this.rules.block.text.exec(ie);if(ce)return{type:"text",raw:ce[0],text:ce[0]}},we.escape=function(ie){var ce=this.rules.inline.escape.exec(ie);if(ce)return{type:"escape",raw:ce[0],text:Y(ce[1])}},we.tag=function(ie,ce,O){var K=this.rules.inline.tag.exec(ie);if(K)return!ce&&/^<a /i.test(K[0])?ce=!0:ce&&/^<\/a>/i.test(K[0])&&(ce=!1),!O&&/^<(pre|code|kbd|script)(\s|>)/i.test(K[0])?O=!0:O&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(K[0])&&(O=!1),{type:this.options.sanitize?"text":"html",raw:K[0],inLink:ce,inRawBlock:O,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(K[0]):Y(K[0]):K[0]}},we.link=function(ie){var ce=this.rules.inline.link.exec(ie);if(ce){var O=ce[2].trim();if(!this.options.pedantic&&/^</.test(O)){if(!/>$/.test(O))return;var K=le(O.slice(0,-1),"\\");if((O.length-K.length)%2==0)return}else{var ae=H(ce[2],"()");if(ae>-1){var ke=ce[0].indexOf("!")===0?5:4,Pe=ke+ce[1].length+ae;ce[2]=ce[2].substring(0,ae),ce[0]=ce[0].substring(0,Pe).trim(),ce[3]=""}}var Oe=ce[2],$e="";if(this.options.pedantic){var Ze=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Oe);Ze&&(Oe=Ze[1],$e=Ze[3])}else $e=ce[3]?ce[3].slice(1,-1):"";return Oe=Oe.trim(),/^</.test(Oe)&&(this.options.pedantic&&!/>$/.test(O)?Oe=Oe.slice(1):Oe=Oe.slice(1,-1)),J(ce,{href:Oe&&Oe.replace(this.rules.inline._escapes,"$1"),title:$e&&$e.replace(this.rules.inline._escapes,"$1")},ce[0])}},we.reflink=function(ie,ce){var O;if((O=this.rules.inline.reflink.exec(ie))||(O=this.rules.inline.nolink.exec(ie))){var K=(O[2]||O[1]).replace(/\s+/g," ");if(K=ce[K.toLowerCase()],!K||!K.href){var ae=O[0].charAt(0);return{type:"text",raw:ae,text:ae}}return J(O,K,O[0])}},we.emStrong=function(ie,ce,O){O===void 0&&(O="");var K=this.rules.inline.emStrong.lDelim.exec(ie);if(!!K&&!(K[3]&&O.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u08A0-\u08B4\u08B6-\u08C7\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u170C\u170E-\u1711\u1720-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4B\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2C2E\u2C30-\u2C5E\u2C60-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\u9FFC\uA000-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7BF\uA7C2-\uA7CA\uA7F5-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEC0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82C[\uDC00-\uDD1E\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDD\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF34\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var ae=K[1]||K[2]||"";if(!ae||ae&&(O===""||this.rules.inline.punctuation.exec(O))){var ke=K[0].length-1,Pe,Oe,$e=ke,Ze=0,Je=K[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(Je.lastIndex=0,ce=ce.slice(-1*ie.length+ke);(K=Je.exec(ce))!=null;)if(Pe=K[1]||K[2]||K[3]||K[4]||K[5]||K[6],!!Pe){if(Oe=Pe.length,K[3]||K[4]){$e+=Oe;continue}else if((K[5]||K[6])&&ke%3&&!((ke+Oe)%3)){Ze+=Oe;continue}if($e-=Oe,!($e>0)){if($e+Ze-Oe<=0&&!ce.slice(Je.lastIndex).match(Je)&&(Oe=Math.min(Oe,Oe+$e+Ze)),Math.min(ke,Oe)%2)return{type:"em",raw:ie.slice(0,ke+K.index+Oe+1),text:ie.slice(1,ke+K.index+Oe)};if(Math.min(ke,Oe)%2==0)return{type:"strong",raw:ie.slice(0,ke+K.index+Oe+1),text:ie.slice(2,ke+K.index+Oe-1)}}}}}},we.codespan=function(ie){var ce=this.rules.inline.code.exec(ie);if(ce){var O=ce[2].replace(/\n/g," "),K=/[^ ]/.test(O),ae=/^ /.test(O)&&/ $/.test(O);return K&&ae&&(O=O.substring(1,O.length-1)),O=Y(O,!0),{type:"codespan",raw:ce[0],text:O}}},we.br=function(ie){var ce=this.rules.inline.br.exec(ie);if(ce)return{type:"br",raw:ce[0]}},we.del=function(ie){var ce=this.rules.inline.del.exec(ie);if(ce)return{type:"del",raw:ce[0],text:ce[2]}},we.autolink=function(ie,ce){var O=this.rules.inline.autolink.exec(ie);if(O){var K,ae;return O[2]==="@"?(K=Y(this.options.mangle?ce(O[1]):O[1]),ae="mailto:"+K):(K=Y(O[1]),ae=K),{type:"link",raw:O[0],text:K,href:ae,tokens:[{type:"text",raw:K,text:K}]}}},we.url=function(ie,ce){var O;if(O=this.rules.inline.url.exec(ie)){var K,ae;if(O[2]==="@")K=Y(this.options.mangle?ce(O[0]):O[0]),ae="mailto:"+K;else{var ke;do ke=O[0],O[0]=this.rules.inline._backpedal.exec(O[0])[0];while(ke!==O[0]);K=Y(O[0]),O[1]==="www."?ae="http://"+K:ae=K}return{type:"link",raw:O[0],text:K,href:ae,tokens:[{type:"text",raw:K,text:K}]}}},we.inlineText=function(ie,ce,O){var K=this.rules.inline.text.exec(ie);if(K){var ae;return ce?ae=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(K[0]):Y(K[0]):K[0]:ae=Y(this.options.smartypants?O(K[0]):K[0]),{type:"text",raw:K[0],text:ae}}},Se}(),M=N.noopTest,x=N.edit,q=N.merge,z={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?:\n+|$)|$)/,hr:/^ {0,3}((?:- *){3,}|(?:_ *){3,}|(?:\* *){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3})(bull) [\s\S]+?(?:hr|def|\n{2,}(?! )(?! {0,3}bull )\n*|\s*$)/,html:"^ {0,3}(?:<(script|pre|style)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:\\n{2,}|$)|<(?!script|pre|style)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:\\n{2,}|$)|</(?!script|pre|style)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:\\n{2,}|$))",def:/^ {0,3}\[(label)\]: *\n? *<?([^\s>]+)>?(?:(?: +\n? *| *\n *)(title))? *(?:\n+|$)/,nptable:M,table:M,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html| +\n)[^\n]+)*)/,text:/^[^\n]+/};z._label=/(?!\s*\])(?:\\[\[\]]|[^\[\]])+/,z._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,z.def=x(z.def).replace("label",z._label).replace("title",z._title).getRegex(),z.bullet=/(?:[*+-]|\d{1,9}[.)])/,z.item=/^( *)(bull) ?[^\n]*(?:\n(?! *bull ?)[^\n]*)*/,z.item=x(z.item,"gm").replace(/bull/g,z.bullet).getRegex(),z.listItemStart=x(/^( *)(bull)/).replace("bull",z.bullet).getRegex(),z.list=x(z.list).replace(/bull/g,z.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+z.def.source+")").getRegex(),z._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",z._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,z.html=x(z.html,"i").replace("comment",z._comment).replace("tag",z._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),z.paragraph=x(z._paragraph).replace("hr",z.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",z._tag).getRegex(),z.blockquote=x(z.blockquote).replace("paragraph",z.paragraph).getRegex(),z.normal=q({},z),z.gfm=q({},z.normal,{nptable:"^ *([^|\\n ].*\\|.*)\\n {0,3}([-:]+ *\\|[-| :]*)(?:\\n((?:(?!\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)",table:"^ *\\|(.+)\\n {0,3}\\|?( *[-:]+[-| :]*)(?:\\n *((?:(?!\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),z.gfm.nptable=x(z.gfm.nptable).replace("hr",z.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",z._tag).getRegex(),z.gfm.table=x(z.gfm.table).replace("hr",z.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",z._tag).getRegex(),z.pedantic=q({},z.normal,{html:x(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",z._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:M,paragraph:x(z.normal._paragraph).replace("hr",z.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",z.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var oe={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:M,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(?!\s*\])((?:\\[\[\]]?|[^\[\]\\])+)\]/,nolink:/^!?\[(?!\s*\])((?:\[[^\[\]]*\]|\\[\[\]]|[^\[\]])*)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/\_\_[^_]*?\*[^_]*?\_\_|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/\*\*[^*]*?\_[^*]*?\*\*|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:M,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};oe._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",oe.punctuation=x(oe.punctuation).replace(/punctuation/g,oe._punctuation).getRegex(),oe.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,oe.escapedEmSt=/\\\*|\\_/g,oe._comment=x(z._comment).replace("(?:-->|$)","-->").getRegex(),oe.emStrong.lDelim=x(oe.emStrong.lDelim).replace(/punct/g,oe._punctuation).getRegex(),oe.emStrong.rDelimAst=x(oe.emStrong.rDelimAst,"g").replace(/punct/g,oe._punctuation).getRegex(),oe.emStrong.rDelimUnd=x(oe.emStrong.rDelimUnd,"g").replace(/punct/g,oe._punctuation).getRegex(),oe._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,oe._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,oe._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,oe.autolink=x(oe.autolink).replace("scheme",oe._scheme).replace("email",oe._email).getRegex(),oe._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,oe.tag=x(oe.tag).replace("comment",oe._comment).replace("attribute",oe._attribute).getRegex(),oe._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,oe._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,oe._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,oe.link=x(oe.link).replace("label",oe._label).replace("href",oe._href).replace("title",oe._title).getRegex(),oe.reflink=x(oe.reflink).replace("label",oe._label).getRegex(),oe.reflinkSearch=x(oe.reflinkSearch,"g").replace("reflink",oe.reflink).replace("nolink",oe.nolink).getRegex(),oe.normal=q({},oe),oe.pedantic=q({},oe.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:x(/^!?\[(label)\]\((.*?)\)/).replace("label",oe._label).getRegex(),reflink:x(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",oe._label).getRegex()}),oe.gfm=q({},oe.normal,{escape:x(oe.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@))|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@))/}),oe.gfm.url=x(oe.gfm.url,"i").replace("email",oe.gfm._extended_email).getRegex(),oe.breaks=q({},oe.gfm,{br:x(oe.br).replace("{2,}","*").getRegex(),text:x(oe.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});var pe={block:z,inline:oe},Te=k.defaults,Be=pe.block,Fe=pe.inline,We=N.repeatString;function Qe(Se){return Se.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function Ge(Se){var we="",Ce,ie,ce=Se.length;for(Ce=0;Ce<ce;Ce++)ie=Se.charCodeAt(Ce),Math.random()>.5&&(ie="x"+ie.toString(16)),we+="&#"+ie+";";return we}var Ke=function(){function Se(Ce){this.tokens=[],this.tokens.links=Object.create(null),this.options=Ce||Te,this.options.tokenizer=this.options.tokenizer||new B,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options;var ie={block:Be.normal,inline:Fe.normal};this.options.pedantic?(ie.block=Be.pedantic,ie.inline=Fe.pedantic):this.options.gfm&&(ie.block=Be.gfm,this.options.breaks?ie.inline=Fe.breaks:ie.inline=Fe.gfm),this.tokenizer.rules=ie}Se.lex=function(ie,ce){var O=new Se(ce);return O.lex(ie)},Se.lexInline=function(ie,ce){var O=new Se(ce);return O.inlineTokens(ie)};var we=Se.prototype;return we.lex=function(ie){return ie=ie.replace(/\r\n|\r/g,`
`).replace(/\t/g,"    "),this.blockTokens(ie,this.tokens,!0),this.inline(this.tokens),this.tokens},we.blockTokens=function(ie,ce,O){ce===void 0&&(ce=[]),O===void 0&&(O=!0),this.options.pedantic&&(ie=ie.replace(/^ +$/gm,""));for(var K,ae,ke,Pe;ie;){if(K=this.tokenizer.space(ie)){ie=ie.substring(K.raw.length),K.type&&ce.push(K);continue}if(K=this.tokenizer.code(ie)){ie=ie.substring(K.raw.length),Pe=ce[ce.length-1],Pe&&Pe.type==="paragraph"?(Pe.raw+=`
`+K.raw,Pe.text+=`
`+K.text):ce.push(K);continue}if(K=this.tokenizer.fences(ie)){ie=ie.substring(K.raw.length),ce.push(K);continue}if(K=this.tokenizer.heading(ie)){ie=ie.substring(K.raw.length),ce.push(K);continue}if(K=this.tokenizer.nptable(ie)){ie=ie.substring(K.raw.length),ce.push(K);continue}if(K=this.tokenizer.hr(ie)){ie=ie.substring(K.raw.length),ce.push(K);continue}if(K=this.tokenizer.blockquote(ie)){ie=ie.substring(K.raw.length),K.tokens=this.blockTokens(K.text,[],O),ce.push(K);continue}if(K=this.tokenizer.list(ie)){for(ie=ie.substring(K.raw.length),ke=K.items.length,ae=0;ae<ke;ae++)K.items[ae].tokens=this.blockTokens(K.items[ae].text,[],!1);ce.push(K);continue}if(K=this.tokenizer.html(ie)){ie=ie.substring(K.raw.length),ce.push(K);continue}if(O&&(K=this.tokenizer.def(ie))){ie=ie.substring(K.raw.length),this.tokens.links[K.tag]||(this.tokens.links[K.tag]={href:K.href,title:K.title});continue}if(K=this.tokenizer.table(ie)){ie=ie.substring(K.raw.length),ce.push(K);continue}if(K=this.tokenizer.lheading(ie)){ie=ie.substring(K.raw.length),ce.push(K);continue}if(O&&(K=this.tokenizer.paragraph(ie))){ie=ie.substring(K.raw.length),ce.push(K);continue}if(K=this.tokenizer.text(ie)){ie=ie.substring(K.raw.length),Pe=ce[ce.length-1],Pe&&Pe.type==="text"?(Pe.raw+=`
`+K.raw,Pe.text+=`
`+K.text):ce.push(K);continue}if(ie){var Oe="Infinite loop on byte: "+ie.charCodeAt(0);if(this.options.silent){console.error(Oe);break}else throw new Error(Oe)}}return ce},we.inline=function(ie){var ce,O,K,ae,ke,Pe,Oe=ie.length;for(ce=0;ce<Oe;ce++)switch(Pe=ie[ce],Pe.type){case"paragraph":case"text":case"heading":{Pe.tokens=[],this.inlineTokens(Pe.text,Pe.tokens);break}case"table":{for(Pe.tokens={header:[],cells:[]},ae=Pe.header.length,O=0;O<ae;O++)Pe.tokens.header[O]=[],this.inlineTokens(Pe.header[O],Pe.tokens.header[O]);for(ae=Pe.cells.length,O=0;O<ae;O++)for(ke=Pe.cells[O],Pe.tokens.cells[O]=[],K=0;K<ke.length;K++)Pe.tokens.cells[O][K]=[],this.inlineTokens(ke[K],Pe.tokens.cells[O][K]);break}case"blockquote":{this.inline(Pe.tokens);break}case"list":{for(ae=Pe.items.length,O=0;O<ae;O++)this.inline(Pe.items[O].tokens);break}}return ie},we.inlineTokens=function(ie,ce,O,K){ce===void 0&&(ce=[]),O===void 0&&(O=!1),K===void 0&&(K=!1);var ae,ke,Pe=ie,Oe,$e,Ze;if(this.tokens.links){var Je=Object.keys(this.tokens.links);if(Je.length>0)for(;(Oe=this.tokenizer.rules.inline.reflinkSearch.exec(Pe))!=null;)Je.includes(Oe[0].slice(Oe[0].lastIndexOf("[")+1,-1))&&(Pe=Pe.slice(0,Oe.index)+"["+We("a",Oe[0].length-2)+"]"+Pe.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Oe=this.tokenizer.rules.inline.blockSkip.exec(Pe))!=null;)Pe=Pe.slice(0,Oe.index)+"["+We("a",Oe[0].length-2)+"]"+Pe.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Oe=this.tokenizer.rules.inline.escapedEmSt.exec(Pe))!=null;)Pe=Pe.slice(0,Oe.index)+"++"+Pe.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;ie;){if($e||(Ze=""),$e=!1,ae=this.tokenizer.escape(ie)){ie=ie.substring(ae.raw.length),ce.push(ae);continue}if(ae=this.tokenizer.tag(ie,O,K)){ie=ie.substring(ae.raw.length),O=ae.inLink,K=ae.inRawBlock;var Ye=ce[ce.length-1];Ye&&ae.type==="text"&&Ye.type==="text"?(Ye.raw+=ae.raw,Ye.text+=ae.text):ce.push(ae);continue}if(ae=this.tokenizer.link(ie)){ie=ie.substring(ae.raw.length),ae.type==="link"&&(ae.tokens=this.inlineTokens(ae.text,[],!0,K)),ce.push(ae);continue}if(ae=this.tokenizer.reflink(ie,this.tokens.links)){ie=ie.substring(ae.raw.length);var nt=ce[ce.length-1];ae.type==="link"?(ae.tokens=this.inlineTokens(ae.text,[],!0,K),ce.push(ae)):nt&&ae.type==="text"&&nt.type==="text"?(nt.raw+=ae.raw,nt.text+=ae.text):ce.push(ae);continue}if(ae=this.tokenizer.emStrong(ie,Pe,Ze)){ie=ie.substring(ae.raw.length),ae.tokens=this.inlineTokens(ae.text,[],O,K),ce.push(ae);continue}if(ae=this.tokenizer.codespan(ie)){ie=ie.substring(ae.raw.length),ce.push(ae);continue}if(ae=this.tokenizer.br(ie)){ie=ie.substring(ae.raw.length),ce.push(ae);continue}if(ae=this.tokenizer.del(ie)){ie=ie.substring(ae.raw.length),ae.tokens=this.inlineTokens(ae.text,[],O,K),ce.push(ae);continue}if(ae=this.tokenizer.autolink(ie,Ge)){ie=ie.substring(ae.raw.length),ce.push(ae);continue}if(!O&&(ae=this.tokenizer.url(ie,Ge))){ie=ie.substring(ae.raw.length),ce.push(ae);continue}if(ae=this.tokenizer.inlineText(ie,K,Qe)){ie=ie.substring(ae.raw.length),ae.raw.slice(-1)!=="_"&&(Ze=ae.raw.slice(-1)),$e=!0,ke=ce[ce.length-1],ke&&ke.type==="text"?(ke.raw+=ae.raw,ke.text+=ae.text):ce.push(ae);continue}if(ie){var pt="Infinite loop on byte: "+ie.charCodeAt(0);if(this.options.silent){console.error(pt);break}else throw new Error(pt)}}return ce},e(Se,null,[{key:"rules",get:function(){return{block:Be,inline:Fe}}}]),Se}(),$=k.defaults,Q=N.cleanUrl,te=N.escape,re=function(){function Se(Ce){this.options=Ce||$}var we=Se.prototype;return we.code=function(ie,ce,O){var K=(ce||"").match(/\S*/)[0];if(this.options.highlight){var ae=this.options.highlight(ie,K);ae!=null&&ae!==ie&&(O=!0,ie=ae)}return ie=ie.replace(/\n$/,"")+`
`,K?'<pre><code class="'+this.options.langPrefix+te(K,!0)+'">'+(O?ie:te(ie,!0))+`</code></pre>
`:"<pre><code>"+(O?ie:te(ie,!0))+`</code></pre>
`},we.blockquote=function(ie){return`<blockquote>
`+ie+`</blockquote>
`},we.html=function(ie){return ie},we.heading=function(ie,ce,O,K){return this.options.headerIds?"<h"+ce+' id="'+this.options.headerPrefix+K.slug(O)+'">'+ie+"</h"+ce+`>
`:"<h"+ce+">"+ie+"</h"+ce+`>
`},we.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},we.list=function(ie,ce,O){var K=ce?"ol":"ul",ae=ce&&O!==1?' start="'+O+'"':"";return"<"+K+ae+`>
`+ie+"</"+K+`>
`},we.listitem=function(ie){return"<li>"+ie+`</li>
`},we.checkbox=function(ie){return"<input "+(ie?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},we.paragraph=function(ie){return"<p>"+ie+`</p>
`},we.table=function(ie,ce){return ce&&(ce="<tbody>"+ce+"</tbody>"),`<table>
<thead>
`+ie+`</thead>
`+ce+`</table>
`},we.tablerow=function(ie){return`<tr>
`+ie+`</tr>
`},we.tablecell=function(ie,ce){var O=ce.header?"th":"td",K=ce.align?"<"+O+' align="'+ce.align+'">':"<"+O+">";return K+ie+"</"+O+`>
`},we.strong=function(ie){return"<strong>"+ie+"</strong>"},we.em=function(ie){return"<em>"+ie+"</em>"},we.codespan=function(ie){return"<code>"+ie+"</code>"},we.br=function(){return this.options.xhtml?"<br/>":"<br>"},we.del=function(ie){return"<del>"+ie+"</del>"},we.link=function(ie,ce,O){if(ie=Q(this.options.sanitize,this.options.baseUrl,ie),ie===null)return O;var K='<a href="'+te(ie)+'"';return ce&&(K+=' title="'+ce+'"'),K+=">"+O+"</a>",K},we.image=function(ie,ce,O){if(ie=Q(this.options.sanitize,this.options.baseUrl,ie),ie===null)return O;var K='<img src="'+ie+'" alt="'+O+'"';return ce&&(K+=' title="'+ce+'"'),K+=this.options.xhtml?"/>":">",K},we.text=function(ie){return ie},Se}(),G=function(){function Se(){}var we=Se.prototype;return we.strong=function(ie){return ie},we.em=function(ie){return ie},we.codespan=function(ie){return ie},we.del=function(ie){return ie},we.html=function(ie){return ie},we.text=function(ie){return ie},we.link=function(ie,ce,O){return""+O},we.image=function(ie,ce,O){return""+O},we.br=function(){return""},Se}(),se=function(){function Se(){this.seen={}}var we=Se.prototype;return we.serialize=function(ie){return ie.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},we.getNextSafeSlug=function(ie,ce){var O=ie,K=0;if(this.seen.hasOwnProperty(O)){K=this.seen[ie];do K++,O=ie+"-"+K;while(this.seen.hasOwnProperty(O))}return ce||(this.seen[ie]=K,this.seen[O]=0),O},we.slug=function(ie,ce){ce===void 0&&(ce={});var O=this.serialize(ie);return this.getNextSafeSlug(O,ce.dryrun)},Se}(),he=k.defaults,Ae=N.unescape,xe=function(){function Se(Ce){this.options=Ce||he,this.options.renderer=this.options.renderer||new re,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new G,this.slugger=new se}Se.parse=function(ie,ce){var O=new Se(ce);return O.parse(ie)},Se.parseInline=function(ie,ce){var O=new Se(ce);return O.parseInline(ie)};var we=Se.prototype;return we.parse=function(ie,ce){ce===void 0&&(ce=!0);var O="",K,ae,ke,Pe,Oe,$e,Ze,Je,Ye,nt,pt,be,ye,ue,j,Ne,ge,Xe,et=ie.length;for(K=0;K<et;K++)switch(nt=ie[K],nt.type){case"space":continue;case"hr":{O+=this.renderer.hr();continue}case"heading":{O+=this.renderer.heading(this.parseInline(nt.tokens),nt.depth,Ae(this.parseInline(nt.tokens,this.textRenderer)),this.slugger);continue}case"code":{O+=this.renderer.code(nt.text,nt.lang,nt.escaped);continue}case"table":{for(Je="",Ze="",Pe=nt.header.length,ae=0;ae<Pe;ae++)Ze+=this.renderer.tablecell(this.parseInline(nt.tokens.header[ae]),{header:!0,align:nt.align[ae]});for(Je+=this.renderer.tablerow(Ze),Ye="",Pe=nt.cells.length,ae=0;ae<Pe;ae++){for($e=nt.tokens.cells[ae],Ze="",Oe=$e.length,ke=0;ke<Oe;ke++)Ze+=this.renderer.tablecell(this.parseInline($e[ke]),{header:!1,align:nt.align[ke]});Ye+=this.renderer.tablerow(Ze)}O+=this.renderer.table(Je,Ye);continue}case"blockquote":{Ye=this.parse(nt.tokens),O+=this.renderer.blockquote(Ye);continue}case"list":{for(pt=nt.ordered,be=nt.start,ye=nt.loose,Pe=nt.items.length,Ye="",ae=0;ae<Pe;ae++)j=nt.items[ae],Ne=j.checked,ge=j.task,ue="",j.task&&(Xe=this.renderer.checkbox(Ne),ye?j.tokens.length>0&&j.tokens[0].type==="text"?(j.tokens[0].text=Xe+" "+j.tokens[0].text,j.tokens[0].tokens&&j.tokens[0].tokens.length>0&&j.tokens[0].tokens[0].type==="text"&&(j.tokens[0].tokens[0].text=Xe+" "+j.tokens[0].tokens[0].text)):j.tokens.unshift({type:"text",text:Xe}):ue+=Xe),ue+=this.parse(j.tokens,ye),Ye+=this.renderer.listitem(ue,ge,Ne);O+=this.renderer.list(Ye,pt,be);continue}case"html":{O+=this.renderer.html(nt.text);continue}case"paragraph":{O+=this.renderer.paragraph(this.parseInline(nt.tokens));continue}case"text":{for(Ye=nt.tokens?this.parseInline(nt.tokens):nt.text;K+1<et&&ie[K+1].type==="text";)nt=ie[++K],Ye+=`
`+(nt.tokens?this.parseInline(nt.tokens):nt.text);O+=ce?this.renderer.paragraph(Ye):Ye;continue}default:{var rt='Token with "'+nt.type+'" type was not found.';if(this.options.silent){console.error(rt);return}else throw new Error(rt)}}return O},we.parseInline=function(ie,ce){ce=ce||this.renderer;var O="",K,ae,ke=ie.length;for(K=0;K<ke;K++)switch(ae=ie[K],ae.type){case"escape":{O+=ce.text(ae.text);break}case"html":{O+=ce.html(ae.text);break}case"link":{O+=ce.link(ae.href,ae.title,this.parseInline(ae.tokens,ce));break}case"image":{O+=ce.image(ae.href,ae.title,ae.text);break}case"strong":{O+=ce.strong(this.parseInline(ae.tokens,ce));break}case"em":{O+=ce.em(this.parseInline(ae.tokens,ce));break}case"codespan":{O+=ce.codespan(ae.text);break}case"br":{O+=ce.br();break}case"del":{O+=ce.del(this.parseInline(ae.tokens,ce));break}case"text":{O+=ce.text(ae.text);break}default:{var Pe='Token with "'+ae.type+'" type was not found.';if(this.options.silent){console.error(Pe);return}else throw new Error(Pe)}}return O},Se}(),ve=N.merge,je=N.checkSanitizeDeprecation,V=N.escape,ee=k.getDefaults,me=k.changeDefaults,Re=k.defaults;function Le(Se,we,Ce){if(typeof Se=="undefined"||Se===null)throw new Error("marked(): input parameter is undefined or null");if(typeof Se!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(Se)+", string expected");if(typeof we=="function"&&(Ce=we,we=null),we=ve({},Le.defaults,we||{}),je(we),Ce){var ie=we.highlight,ce;try{ce=Ke.lex(Se,we)}catch(ke){return Ce(ke)}var O=function(Pe){var Oe;if(!Pe)try{Oe=xe.parse(ce,we)}catch($e){Pe=$e}return we.highlight=ie,Pe?Ce(Pe):Ce(null,Oe)};if(!ie||ie.length<3||(delete we.highlight,!ce.length))return O();var K=0;Le.walkTokens(ce,function(ke){ke.type==="code"&&(K++,setTimeout(function(){ie(ke.text,ke.lang,function(Pe,Oe){if(Pe)return O(Pe);Oe!=null&&Oe!==ke.text&&(ke.text=Oe,ke.escaped=!0),K--,K===0&&O()})},0))}),K===0&&O();return}try{var ae=Ke.lex(Se,we);return we.walkTokens&&Le.walkTokens(ae,we.walkTokens),xe.parse(ae,we)}catch(ke){if(ke.message+=`
Please report this to https://github.com/markedjs/marked.`,we.silent)return"<p>An error occurred:</p><pre>"+V(ke.message+"",!0)+"</pre>";throw ke}}Le.options=Le.setOptions=function(Se){return ve(Le.defaults,Se),me(Le.defaults),Le},Le.getDefaults=ee,Le.defaults=Re,Le.use=function(Se){var we=ve({},Se);if(Se.renderer&&function(){var ie=Le.defaults.renderer||new re,ce=function(ae){var ke=ie[ae];ie[ae]=function(){for(var Pe=arguments.length,Oe=new Array(Pe),$e=0;$e<Pe;$e++)Oe[$e]=arguments[$e];var Ze=Se.renderer[ae].apply(ie,Oe);return Ze===!1&&(Ze=ke.apply(ie,Oe)),Ze}};for(var O in Se.renderer)ce(O);we.renderer=ie}(),Se.tokenizer&&function(){var ie=Le.defaults.tokenizer||new B,ce=function(ae){var ke=ie[ae];ie[ae]=function(){for(var Pe=arguments.length,Oe=new Array(Pe),$e=0;$e<Pe;$e++)Oe[$e]=arguments[$e];var Ze=Se.tokenizer[ae].apply(ie,Oe);return Ze===!1&&(Ze=ke.apply(ie,Oe)),Ze}};for(var O in Se.tokenizer)ce(O);we.tokenizer=ie}(),Se.walkTokens){var Ce=Le.defaults.walkTokens;we.walkTokens=function(ie){Se.walkTokens(ie),Ce&&Ce(ie)}}Le.setOptions(we)},Le.walkTokens=function(Se,we){for(var Ce=S(Se),ie;!(ie=Ce()).done;){var ce=ie.value;switch(we(ce),ce.type){case"table":{for(var O=S(ce.tokens.header),K;!(K=O()).done;){var ae=K.value;Le.walkTokens(ae,we)}for(var ke=S(ce.tokens.cells),Pe;!(Pe=ke()).done;)for(var Oe=Pe.value,$e=S(Oe),Ze;!(Ze=$e()).done;){var Je=Ze.value;Le.walkTokens(Je,we)}break}case"list":{Le.walkTokens(ce.items,we);break}default:ce.tokens&&Le.walkTokens(ce.tokens,we)}}},Le.parseInline=function(Se,we){if(typeof Se=="undefined"||Se===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof Se!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(Se)+", string expected");we=ve({},Le.defaults,we||{}),je(we);try{var Ce=Ke.lexInline(Se,we);return we.walkTokens&&Le.walkTokens(Ce,we.walkTokens),xe.parseInline(Ce,we)}catch(ie){if(ie.message+=`
Please report this to https://github.com/markedjs/marked.`,we.silent)return"<p>An error occurred:</p><pre>"+V(ie.message+"",!0)+"</pre>";throw ie}},Le.Parser=xe,Le.parser=xe.parse,Le.Renderer=re,Le.TextRenderer=G,Le.Lexer=Ke,Le.lexer=Ke.lex,Le.Tokenizer=B,Le.Slugger=se,Le.parse=Le;var qe=Le;return qe}),define(_e[77],Ee([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function m(k,D,_){return Math.min(Math.max(k,D),_)}e.clamp=m;function T(k,D){return(D+k%D)%D}e.rot=T;class S{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=S;class y{constructor(){this._n=1,this._val=0}update(D){return this._val=this._val+(D-this._val)/this._n,this._n+=1,this}get value(){return this._val}}e.MovingAverage=y}),function(){function Z(S){const y=[];typeof S=="number"&&y.push("code/timeOrigin",S);function k(_){y.push(_,Date.now())}function D(){const _=[];for(let C=0;C<y.length;C+=2)_.push({name:y[C],startTime:y[C+1]});return _}return{mark:k,getMarks:D}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?Z():{mark(S){performance.mark(S)},getMarks(){let S=performance.timeOrigin;typeof S!="number"&&(S=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const y=[{name:"code/timeOrigin",startTime:Math.round(S)}];for(const k of performance.getEntriesByType("mark"))y.push({name:k.name,startTime:Math.round(S+k.startTime)});return y}};if(typeof process=="object"){const S=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return Z(S)}else return console.trace("perf-util loaded in UNKNOWN environment"),Z()}function m(S){return S.MonacoPerformanceMarks||(S.MonacoPerformanceMarks=e()),S.MonacoPerformanceMarks}var T;typeof global=="object"?T=global:typeof self=="object"?T=self:T={},typeof define=="function"?define("vs/base/common/performance",[],function(){return m(T)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=m(T):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),T.perf=m(T))}(),define(_e[21],Ee([0,1]),function(Z,e){"use strict";var m;Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setImmediate=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isPreferringBrowserCodeLoad=e.browserCodeLoadingCacheStrategy=e.isElectronSandboxed=e.globals=void 0;const T="en";let S=!1,y=!1,k=!1,D=!1,_=!1,C=!1,n=!1,I,o=T,h,d;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let c;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?c=e.globals.vscode.process:typeof process!="undefined"&&(c=process);const b=typeof((m=c==null?void 0:c.versions)===null||m===void 0?void 0:m.electron)=="string"&&c.type==="renderer";if(e.isElectronSandboxed=b&&(c==null?void 0:c.sandboxed),e.browserCodeLoadingCacheStrategy=(()=>{if(e.isElectronSandboxed)return"bypassHeatCheck";const r=c==null?void 0:c.env.VSCODE_BROWSER_CODE_LOADING;if(typeof r=="string")return r==="none"||r==="code"||r==="bypassHeatCheck"||r==="bypassHeatCheckAndEagerCompile"?r:"bypassHeatCheck"})(),e.isPreferringBrowserCodeLoad=typeof e.browserCodeLoadingCacheStrategy=="string",typeof navigator=="object"&&!b)d=navigator.userAgent,S=d.indexOf("Windows")>=0,y=d.indexOf("Macintosh")>=0,n=(d.indexOf("Macintosh")>=0||d.indexOf("iPad")>=0||d.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,k=d.indexOf("Linux")>=0,C=!0,I=navigator.language,o=I;else if(typeof c=="object"){S=c.platform==="win32",y=c.platform==="darwin",k=c.platform==="linux",D=k&&!!c.env.SNAP&&!!c.env.SNAP_REVISION,I=T,o=T;const r=c.env.VSCODE_NLS_CONFIG;if(r)try{const l=JSON.parse(r),E=l.availableLanguages["*"];I=l.locale,o=E||T,h=l._translationsConfigFile}catch(l){}_=!0}else console.error("Unable to resolve platform.");var p;(function(r){r[r.Web=0]="Web",r[r.Mac=1]="Mac",r[r.Linux=2]="Linux",r[r.Windows=3]="Windows"})(p=e.Platform||(e.Platform={}));function w(r){switch(r){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=w;let u=0;y?u=1:S?u=3:k&&(u=2),e.isWindows=S,e.isMacintosh=y,e.isLinux=k,e.isLinuxSnap=D,e.isNative=_,e.isWeb=C,e.isIOS=n,e.platform=u,e.userAgent=d,e.language=o;var f;(function(r){function l(){return e.language}r.value=l;function E(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}r.isDefaultVariant=E;function v(){return e.language==="en"}r.isDefault=v})(f=e.Language||(e.Language={})),e.locale=I,e.translationsConfigFile=h,e.setImmediate=function(){if(e.globals.setImmediate)return e.globals.setImmediate.bind(e.globals);if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let E=[];e.globals.addEventListener("message",A=>{if(A.data&&A.data.vscodeSetImmediateId)for(let P=0,a=E.length;P<a;P++){const F=E[P];if(F.id===A.data.vscodeSetImmediateId){E.splice(P,1),F.callback();return}}});let v=0;return A=>{const P=++v;E.push({id:P,callback:A}),e.globals.postMessage({vscodeSetImmediateId:P},"*")}}if(typeof(c==null?void 0:c.nextTick)=="function")return c.nextTick.bind(c);const l=Promise.resolve();return E=>l.then(E)}();var g;(function(r){r[r.Windows=1]="Windows",r[r.Macintosh=2]="Macintosh",r[r.Linux=3]="Linux"})(g=e.OperatingSystem||(e.OperatingSystem={})),e.OS=y||n?2:S?1:3;let t=!0,i=!1;function s(){if(!i){i=!0;const r=new Uint8Array(2);r[0]=1,r[1]=2,t=new Uint16Array(r.buffer)[0]===(2<<8)+1}return t}e.isLittleEndian=s}),define(_e[40],Ee([0,1,21]),function(Z,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nextTick=e.platform=e.env=e.cwd=void 0;let T;if(typeof m.globals.vscode!="undefined"&&typeof m.globals.vscode.process!="undefined"){const S=m.globals.vscode.process;T={get platform(){return S.platform},get env(){return S.env},cwd(){return S.cwd()},nextTick(y){return m.setImmediate(y)}}}else typeof process!="undefined"?T={get platform(){return process.platform},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()},nextTick(S){return process.nextTick(S)}}:T={get platform(){return m.isWindows?"win32":m.isMacintosh?"darwin":"linux"},nextTick(S){return m.setImmediate(S)},get env(){return{}},cwd(){return"/"}};e.cwd=T.cwd,e.env=T.env,e.platform=T.platform,e.nextTick=T.nextTick}),define(_e[14],Ee([0,1,40]),function(Z,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const T=65,S=97,y=90,k=122,D=46,_=47,C=92,n=58,I=63;class o extends Error{constructor(f,g,t){let i;typeof g=="string"&&g.indexOf("not ")===0?(i="must not be",g=g.replace(/^not /,"")):i="must be";const s=f.indexOf(".")!==-1?"property":"argument";let r=`The "${f}" ${s} ${i} of type ${g}`;r+=`. Received type ${typeof t}`,super(r),this.code="ERR_INVALID_ARG_TYPE"}}function h(u,f){if(typeof u!="string")throw new o(f,"string",u)}function d(u){return u===_||u===C}function c(u){return u===_}function b(u){return u>=T&&u<=y||u>=S&&u<=k}function p(u,f,g,t){let i="",s=0,r=-1,l=0,E=0;for(let v=0;v<=u.length;++v){if(v<u.length)E=u.charCodeAt(v);else{if(t(E))break;E=_}if(t(E)){if(!(r===v-1||l===1))if(l===2){if(i.length<2||s!==2||i.charCodeAt(i.length-1)!==D||i.charCodeAt(i.length-2)!==D){if(i.length>2){const A=i.lastIndexOf(g);A===-1?(i="",s=0):(i=i.slice(0,A),s=i.length-1-i.lastIndexOf(g)),r=v,l=0;continue}else if(i.length!==0){i="",s=0,r=v,l=0;continue}}f&&(i+=i.length>0?`${g}..`:"..",s=2)}else i.length>0?i+=`${g}${u.slice(r+1,v)}`:i=u.slice(r+1,v),s=v-r-1;r=v,l=0}else E===D&&l!==-1?++l:l=-1}return i}function w(u,f){if(f===null||typeof f!="object")throw new o("pathObject","Object",f);const g=f.dir||f.root,t=f.base||`${f.name||""}${f.ext||""}`;return g?g===f.root?`${g}${t}`:`${g}${u}${t}`:t}e.win32={resolve(...u){let f="",g="",t=!1;for(let i=u.length-1;i>=-1;i--){let s;if(i>=0){if(s=u[i],h(s,"path"),s.length===0)continue}else f.length===0?s=m.cwd():(s=m.env[`=${f}`]||m.cwd(),(s===void 0||s.slice(0,2).toLowerCase()!==f.toLowerCase()&&s.charCodeAt(2)===C)&&(s=`${f}\\`));const r=s.length;let l=0,E="",v=!1;const A=s.charCodeAt(0);if(r===1)d(A)&&(l=1,v=!0);else if(d(A))if(v=!0,d(s.charCodeAt(1))){let P=2,a=P;for(;P<r&&!d(s.charCodeAt(P));)P++;if(P<r&&P!==a){const F=s.slice(a,P);for(a=P;P<r&&d(s.charCodeAt(P));)P++;if(P<r&&P!==a){for(a=P;P<r&&!d(s.charCodeAt(P));)P++;(P===r||P!==a)&&(E=`\\\\${F}\\${s.slice(a,P)}`,l=P)}}}else l=1;else b(A)&&s.charCodeAt(1)===n&&(E=s.slice(0,2),l=2,r>2&&d(s.charCodeAt(2))&&(v=!0,l=3));if(E.length>0)if(f.length>0){if(E.toLowerCase()!==f.toLowerCase())continue}else f=E;if(t){if(f.length>0)break}else if(g=`${s.slice(l)}\\${g}`,t=v,v&&f.length>0)break}return g=p(g,!t,"\\",d),t?`${f}\\${g}`:`${f}${g}`||"."},normalize(u){h(u,"path");const f=u.length;if(f===0)return".";let g=0,t,i=!1;const s=u.charCodeAt(0);if(f===1)return c(s)?"\\":u;if(d(s))if(i=!0,d(u.charCodeAt(1))){let l=2,E=l;for(;l<f&&!d(u.charCodeAt(l));)l++;if(l<f&&l!==E){const v=u.slice(E,l);for(E=l;l<f&&d(u.charCodeAt(l));)l++;if(l<f&&l!==E){for(E=l;l<f&&!d(u.charCodeAt(l));)l++;if(l===f)return`\\\\${v}\\${u.slice(E)}\\`;l!==E&&(t=`\\\\${v}\\${u.slice(E,l)}`,g=l)}}}else g=1;else b(s)&&u.charCodeAt(1)===n&&(t=u.slice(0,2),g=2,f>2&&d(u.charCodeAt(2))&&(i=!0,g=3));let r=g<f?p(u.slice(g),!i,"\\",d):"";return r.length===0&&!i&&(r="."),r.length>0&&d(u.charCodeAt(f-1))&&(r+="\\"),t===void 0?i?`\\${r}`:r:i?`${t}\\${r}`:`${t}${r}`},isAbsolute(u){h(u,"path");const f=u.length;if(f===0)return!1;const g=u.charCodeAt(0);return d(g)||f>2&&b(g)&&u.charCodeAt(1)===n&&d(u.charCodeAt(2))},join(...u){if(u.length===0)return".";let f,g;for(let s=0;s<u.length;++s){const r=u[s];h(r,"path"),r.length>0&&(f===void 0?f=g=r:f+=`\\${r}`)}if(f===void 0)return".";let t=!0,i=0;if(typeof g=="string"&&d(g.charCodeAt(0))){++i;const s=g.length;s>1&&d(g.charCodeAt(1))&&(++i,s>2&&(d(g.charCodeAt(2))?++i:t=!1))}if(t){for(;i<f.length&&d(f.charCodeAt(i));)i++;i>=2&&(f=`\\${f.slice(i)}`)}return e.win32.normalize(f)},relative(u,f){if(h(u,"from"),h(f,"to"),u===f)return"";const g=e.win32.resolve(u),t=e.win32.resolve(f);if(g===t||(u=g.toLowerCase(),f=t.toLowerCase(),u===f))return"";let i=0;for(;i<u.length&&u.charCodeAt(i)===C;)i++;let s=u.length;for(;s-1>i&&u.charCodeAt(s-1)===C;)s--;const r=s-i;let l=0;for(;l<f.length&&f.charCodeAt(l)===C;)l++;let E=f.length;for(;E-1>l&&f.charCodeAt(E-1)===C;)E--;const v=E-l,A=r<v?r:v;let P=-1,a=0;for(;a<A;a++){const N=u.charCodeAt(i+a);if(N!==f.charCodeAt(l+a))break;N===C&&(P=a)}if(a!==A){if(P===-1)return t}else{if(v>A){if(f.charCodeAt(l+a)===C)return t.slice(l+a+1);if(a===2)return t.slice(l+a)}r>A&&(u.charCodeAt(i+a)===C?P=a:a===2&&(P=3)),P===-1&&(P=0)}let F="";for(a=i+P+1;a<=s;++a)(a===s||u.charCodeAt(a)===C)&&(F+=F.length===0?"..":"\\..");return l+=P,F.length>0?`${F}${t.slice(l,E)}`:(t.charCodeAt(l)===C&&++l,t.slice(l,E))},toNamespacedPath(u){if(typeof u!="string")return u;if(u.length===0)return"";const f=e.win32.resolve(u);if(f.length<=2)return u;if(f.charCodeAt(0)===C){if(f.charCodeAt(1)===C){const g=f.charCodeAt(2);if(g!==I&&g!==D)return`\\\\?\\UNC\\${f.slice(2)}`}}else if(b(f.charCodeAt(0))&&f.charCodeAt(1)===n&&f.charCodeAt(2)===C)return`\\\\?\\${f}`;return u},dirname(u){h(u,"path");const f=u.length;if(f===0)return".";let g=-1,t=0;const i=u.charCodeAt(0);if(f===1)return d(i)?u:".";if(d(i)){if(g=t=1,d(u.charCodeAt(1))){let l=2,E=l;for(;l<f&&!d(u.charCodeAt(l));)l++;if(l<f&&l!==E){for(E=l;l<f&&d(u.charCodeAt(l));)l++;if(l<f&&l!==E){for(E=l;l<f&&!d(u.charCodeAt(l));)l++;if(l===f)return u;l!==E&&(g=t=l+1)}}}}else b(i)&&u.charCodeAt(1)===n&&(g=f>2&&d(u.charCodeAt(2))?3:2,t=g);let s=-1,r=!0;for(let l=f-1;l>=t;--l)if(d(u.charCodeAt(l))){if(!r){s=l;break}}else r=!1;if(s===-1){if(g===-1)return".";s=g}return u.slice(0,s)},basename(u,f){f!==void 0&&h(f,"ext"),h(u,"path");let g=0,t=-1,i=!0,s;if(u.length>=2&&b(u.charCodeAt(0))&&u.charCodeAt(1)===n&&(g=2),f!==void 0&&f.length>0&&f.length<=u.length){if(f===u)return"";let r=f.length-1,l=-1;for(s=u.length-1;s>=g;--s){const E=u.charCodeAt(s);if(d(E)){if(!i){g=s+1;break}}else l===-1&&(i=!1,l=s+1),r>=0&&(E===f.charCodeAt(r)?--r==-1&&(t=s):(r=-1,t=l))}return g===t?t=l:t===-1&&(t=u.length),u.slice(g,t)}for(s=u.length-1;s>=g;--s)if(d(u.charCodeAt(s))){if(!i){g=s+1;break}}else t===-1&&(i=!1,t=s+1);return t===-1?"":u.slice(g,t)},extname(u){h(u,"path");let f=0,g=-1,t=0,i=-1,s=!0,r=0;u.length>=2&&u.charCodeAt(1)===n&&b(u.charCodeAt(0))&&(f=t=2);for(let l=u.length-1;l>=f;--l){const E=u.charCodeAt(l);if(d(E)){if(!s){t=l+1;break}continue}i===-1&&(s=!1,i=l+1),E===D?g===-1?g=l:r!==1&&(r=1):g!==-1&&(r=-1)}return g===-1||i===-1||r===0||r===1&&g===i-1&&g===t+1?"":u.slice(g,i)},format:w.bind(null,"\\"),parse(u){h(u,"path");const f={root:"",dir:"",base:"",ext:"",name:""};if(u.length===0)return f;const g=u.length;let t=0,i=u.charCodeAt(0);if(g===1)return d(i)?(f.root=f.dir=u,f):(f.base=f.name=u,f);if(d(i)){if(t=1,d(u.charCodeAt(1))){let P=2,a=P;for(;P<g&&!d(u.charCodeAt(P));)P++;if(P<g&&P!==a){for(a=P;P<g&&d(u.charCodeAt(P));)P++;if(P<g&&P!==a){for(a=P;P<g&&!d(u.charCodeAt(P));)P++;P===g?t=P:P!==a&&(t=P+1)}}}}else if(b(i)&&u.charCodeAt(1)===n){if(g<=2)return f.root=f.dir=u,f;if(t=2,d(u.charCodeAt(2))){if(g===3)return f.root=f.dir=u,f;t=3}}t>0&&(f.root=u.slice(0,t));let s=-1,r=t,l=-1,E=!0,v=u.length-1,A=0;for(;v>=t;--v){if(i=u.charCodeAt(v),d(i)){if(!E){r=v+1;break}continue}l===-1&&(E=!1,l=v+1),i===D?s===-1?s=v:A!==1&&(A=1):s!==-1&&(A=-1)}return l!==-1&&(s===-1||A===0||A===1&&s===l-1&&s===r+1?f.base=f.name=u.slice(r,l):(f.name=u.slice(r,s),f.base=u.slice(r,l),f.ext=u.slice(s,l))),r>0&&r!==t?f.dir=u.slice(0,r-1):f.dir=f.root,f},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...u){let f="",g=!1;for(let t=u.length-1;t>=-1&&!g;t--){const i=t>=0?u[t]:m.cwd();h(i,"path"),i.length!==0&&(f=`${i}/${f}`,g=i.charCodeAt(0)===_)}return f=p(f,!g,"/",c),g?`/${f}`:f.length>0?f:"."},normalize(u){if(h(u,"path"),u.length===0)return".";const f=u.charCodeAt(0)===_,g=u.charCodeAt(u.length-1)===_;return u=p(u,!f,"/",c),u.length===0?f?"/":g?"./":".":(g&&(u+="/"),f?`/${u}`:u)},isAbsolute(u){return h(u,"path"),u.length>0&&u.charCodeAt(0)===_},join(...u){if(u.length===0)return".";let f;for(let g=0;g<u.length;++g){const t=u[g];h(t,"path"),t.length>0&&(f===void 0?f=t:f+=`/${t}`)}return f===void 0?".":e.posix.normalize(f)},relative(u,f){if(h(u,"from"),h(f,"to"),u===f||(u=e.posix.resolve(u),f=e.posix.resolve(f),u===f))return"";const g=1,t=u.length,i=t-g,s=1,r=f.length-s,l=i<r?i:r;let E=-1,v=0;for(;v<l;v++){const P=u.charCodeAt(g+v);if(P!==f.charCodeAt(s+v))break;P===_&&(E=v)}if(v===l)if(r>l){if(f.charCodeAt(s+v)===_)return f.slice(s+v+1);if(v===0)return f.slice(s+v)}else i>l&&(u.charCodeAt(g+v)===_?E=v:v===0&&(E=0));let A="";for(v=g+E+1;v<=t;++v)(v===t||u.charCodeAt(v)===_)&&(A+=A.length===0?"..":"/..");return`${A}${f.slice(s+E)}`},toNamespacedPath(u){return u},dirname(u){if(h(u,"path"),u.length===0)return".";const f=u.charCodeAt(0)===_;let g=-1,t=!0;for(let i=u.length-1;i>=1;--i)if(u.charCodeAt(i)===_){if(!t){g=i;break}}else t=!1;return g===-1?f?"/":".":f&&g===1?"//":u.slice(0,g)},basename(u,f){f!==void 0&&h(f,"ext"),h(u,"path");let g=0,t=-1,i=!0,s;if(f!==void 0&&f.length>0&&f.length<=u.length){if(f===u)return"";let r=f.length-1,l=-1;for(s=u.length-1;s>=0;--s){const E=u.charCodeAt(s);if(E===_){if(!i){g=s+1;break}}else l===-1&&(i=!1,l=s+1),r>=0&&(E===f.charCodeAt(r)?--r==-1&&(t=s):(r=-1,t=l))}return g===t?t=l:t===-1&&(t=u.length),u.slice(g,t)}for(s=u.length-1;s>=0;--s)if(u.charCodeAt(s)===_){if(!i){g=s+1;break}}else t===-1&&(i=!1,t=s+1);return t===-1?"":u.slice(g,t)},extname(u){h(u,"path");let f=-1,g=0,t=-1,i=!0,s=0;for(let r=u.length-1;r>=0;--r){const l=u.charCodeAt(r);if(l===_){if(!i){g=r+1;break}continue}t===-1&&(i=!1,t=r+1),l===D?f===-1?f=r:s!==1&&(s=1):f!==-1&&(s=-1)}return f===-1||t===-1||s===0||s===1&&f===t-1&&f===g+1?"":u.slice(f,t)},format:w.bind(null,"/"),parse(u){h(u,"path");const f={root:"",dir:"",base:"",ext:"",name:""};if(u.length===0)return f;const g=u.charCodeAt(0)===_;let t;g?(f.root="/",t=1):t=0;let i=-1,s=0,r=-1,l=!0,E=u.length-1,v=0;for(;E>=t;--E){const A=u.charCodeAt(E);if(A===_){if(!l){s=E+1;break}continue}r===-1&&(l=!1,r=E+1),A===D?i===-1?i=E:v!==1&&(v=1):i!==-1&&(v=-1)}if(r!==-1){const A=s===0&&g?1:s;i===-1||v===0||v===1&&i===r-1&&i===s+1?f.base=f.name=u.slice(A,r):(f.name=u.slice(A,i),f.base=u.slice(A,r),f.ext=u.slice(i,r))}return s>0?f.dir=u.slice(0,s-1):g&&(f.dir="/"),f},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=m.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=m.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=m.platform==="win32"?e.win32.join:e.posix.join,e.resolve=m.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=m.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=m.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=m.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=m.platform==="win32"?e.win32.extname:e.posix.extname,e.format=m.platform==="win32"?e.win32.format:e.posix.format,e.parse=m.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=m.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=m.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=m.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(_e[52],Ee([0,1,21]),function(Z,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const T=m.globals.performance&&typeof m.globals.performance.now=="function";class S{constructor(k){this._highResolution=T&&k,this._startTime=this._now(),this._stopTime=-1}static create(k=!0){return new S(k)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?m.globals.performance.now():Date.now()}}e.StopWatch=S}),define(_e[3],Ee([0,1,11,48,7,51,52]),function(Z,e,m,T,S,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.PauseableEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var D;(function(p){p.None=()=>S.Disposable.None;function w(Y){return(H,J=null,R)=>{let B=!1,M;return M=Y(x=>{if(!B)return M?M.dispose():B=!0,H.call(J,x)},null,R),B&&M.dispose(),M}}p.once=w;function u(Y,H){return r((J,R=null,B)=>Y(M=>J.call(R,H(M)),null,B))}p.map=u;function f(Y,H){return r((J,R=null,B)=>Y(M=>{H(M),J.call(R,M)},null,B))}p.forEach=f;function g(Y,H){return r((J,R=null,B)=>Y(M=>H(M)&&J.call(R,M),null,B))}p.filter=g;function t(Y){return Y}p.signal=t;function i(...Y){return(H,J=null,R)=>S.combinedDisposable(...Y.map(B=>B(M=>H.call(J,M),null,R)))}p.any=i;function s(Y,H,J){let R=J;return u(Y,B=>(R=H(R,B),R))}p.reduce=s;function r(Y){let H;const J=new o({onFirstListenerAdd(){H=Y(J.fire,J)},onLastListenerRemove(){H.dispose()}});return J.event}p.snapshot=r;function l(Y,H,J=100,R=!1,B){let M,x,q,z=0;const oe=new o({leakWarningThreshold:B,onFirstListenerAdd(){M=Y(pe=>{z++,x=H(x,pe),R&&!q&&(oe.fire(x),x=void 0),clearTimeout(q),q=setTimeout(()=>{const Te=x;x=void 0,q=void 0,(!R||z>1)&&oe.fire(Te),z=0},J)})},onLastListenerRemove(){M.dispose()}});return oe.event}p.debounce=l;function E(Y){const H=new Date().getTime();return u(w(Y),J=>new Date().getTime()-H)}p.stopwatch=E;function v(Y,H=(J,R)=>J===R){let J=!0,R;return g(Y,B=>{const M=J||!H(B,R);return J=!1,R=B,M})}p.latch=v;function A(Y,H){return[p.filter(Y,H),p.filter(Y,J=>!H(J))]}p.split=A;function P(Y,H=!1,J=[]){let R=J.slice(),B=Y(q=>{R?R.push(q):x.fire(q)});const M=()=>{R&&R.forEach(q=>x.fire(q)),R=null},x=new o({onFirstListenerAdd(){B||(B=Y(q=>x.fire(q)))},onFirstListenerDidAdd(){R&&(H?setTimeout(M):M())},onLastListenerRemove(){B&&B.dispose(),B=null}});return x.event}p.buffer=P;class a{constructor(H){this.event=H}map(H){return new a(u(this.event,H))}forEach(H){return new a(f(this.event,H))}filter(H){return new a(g(this.event,H))}reduce(H,J){return new a(s(this.event,H,J))}latch(){return new a(v(this.event))}debounce(H,J=100,R=!1,B){return new a(l(this.event,H,J,R,B))}on(H,J,R){return this.event(H,J,R)}once(H,J,R){return w(this.event)(H,J,R)}}function F(Y){return new a(Y)}p.chain=F;function N(Y,H,J=R=>R){const R=(...q)=>x.fire(J(...q)),B=()=>Y.on(H,R),M=()=>Y.removeListener(H,R),x=new o({onFirstListenerAdd:B,onLastListenerRemove:M});return x.event}p.fromNodeEventEmitter=N;function W(Y,H,J=R=>R){const R=(...q)=>x.fire(J(...q)),B=()=>Y.addEventListener(H,R),M=()=>Y.removeEventListener(H,R),x=new o({onFirstListenerAdd:B,onLastListenerRemove:M});return x.event}p.fromDOMEventEmitter=W;function le(Y){const H=new o;let J=!1;return Y.then(void 0,()=>null).then(()=>{J?H.fire(void 0):setTimeout(()=>H.fire(void 0),0)}),J=!0,H.event}p.fromPromise=le;function fe(Y){return new Promise(H=>w(Y)(H))}p.toPromise=fe})(D=e.Event||(e.Event={}));class _{constructor(w){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${w}_${_._idPool++}`}start(w){this._stopWatch=new k.StopWatch(!0),this._listenerCount=w}stop(){if(this._stopWatch){const w=this._stopWatch.elapsed();this._elapsedOverall+=w,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${w.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}_._idPool=0;let C=-1;function n(p){const w=C;return C=p,{dispose(){C=w}}}e.setGlobalLeakWarningThreshold=n;class I{constructor(w,u=Math.random().toString(18).slice(2,5)){this.customThreshold=w,this.name=u,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(w){let u=C;if(typeof this.customThreshold=="number"&&(u=this.customThreshold),u<=0||w<u)return;this._stacks||(this._stacks=new Map);const f=new Error().stack.split(`
`).slice(3).join(`
`),g=this._stacks.get(f)||0;if(this._stacks.set(f,g+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=u*.5;let t,i=0;for(const[s,r]of this._stacks)(!t||i<r)&&(t=s,i=r);console.warn(`[${this.name}] potential listener LEAK detected, having ${w} listeners already. MOST frequent listener (${i}):`),console.warn(t)}return()=>{const t=this._stacks.get(f)||0;this._stacks.set(f,t-1)}}}class o{constructor(w){var u;this._disposed=!1,this._options=w,this._leakageMon=C>0?new I(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=((u=this._options)===null||u===void 0?void 0:u._profName)?new _(this._options._profName):void 0}get event(){return this._event||(this._event=(w,u,f)=>{var g;this._listeners||(this._listeners=new y.LinkedList);const t=this._listeners.isEmpty();t&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const i=this._listeners.push(u?[w,u]:w);t&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,w,u);const s=(g=this._leakageMon)===null||g===void 0?void 0:g.check(this._listeners.size);let r;return r={dispose:()=>{s&&s(),r.dispose=o._noop,this._disposed||(i(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))}},f instanceof S.DisposableStore?f.add(r):Array.isArray(f)&&f.push(r),r}),this._event}fire(w){var u,f;if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new y.LinkedList);for(let g of this._listeners)this._deliveryQueue.push([g,w]);for((u=this._perfMon)===null||u===void 0||u.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[g,t]=this._deliveryQueue.shift();try{typeof g=="function"?g.call(void 0,t):g[0].call(g[1],t)}catch(i){m.onUnexpectedError(i)}}(f=this._perfMon)===null||f===void 0||f.stop()}}dispose(){var w,u,f,g,t;this._disposed||(this._disposed=!0,(w=this._listeners)===null||w===void 0||w.clear(),(u=this._deliveryQueue)===null||u===void 0||u.clear(),(g=(f=this._options)===null||f===void 0?void 0:f.onLastListenerRemove)===null||g===void 0||g.call(f),(t=this._leakageMon)===null||t===void 0||t.dispose())}}e.Emitter=o,o._noop=function(){};class h extends o{constructor(w){super(w);this._isPaused=0,this._eventQueue=new y.LinkedList,this._mergeFn=w==null?void 0:w.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const w=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(w))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(w){this._listeners&&(this._isPaused!==0?this._eventQueue.push(w):super.fire(w))}}e.PauseableEmitter=h;class d{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new o({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(w){const u={event:w,listener:null};this.events.push(u),this.hasListeners&&this.hook(u);const f=()=>{this.hasListeners&&this.unhook(u);const g=this.events.indexOf(u);this.events.splice(g,1)};return S.toDisposable(T.once(f))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(w=>this.hook(w))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(w=>this.unhook(w))}hook(w){w.listener=w.event(u=>this.emitter.fire(u))}unhook(w){w.listener&&w.listener.dispose(),w.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=d;class c{constructor(){this.buffers=[]}wrapEvent(w){return(u,f,g)=>w(t=>{const i=this.buffers[this.buffers.length-1];i?i.push(()=>u.call(f,t)):u.call(f,t)},void 0,g)}bufferEvents(w){const u=[];this.buffers.push(u);const f=w();return this.buffers.pop(),u.forEach(g=>g()),f}}e.EventBufferer=c;class b{constructor(){this.listening=!1,this.inputEvent=D.None,this.inputEventListener=S.Disposable.None,this.emitter=new o({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(w){this.inputEvent=w,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=w(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=b}),define(_e[18],Ee([0,1,3]),function(Z,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const T=Object.freeze(function(D,_){const C=setTimeout(D.bind(_),0);return{dispose(){clearTimeout(C)}}});var S;(function(D){function _(C){return C===D.None||C===D.Cancelled||C instanceof y?!0:!C||typeof C!="object"?!1:typeof C.isCancellationRequested=="boolean"&&typeof C.onCancellationRequested=="function"}D.isCancellationToken=_,D.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:m.Event.None}),D.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:T})})(S=e.CancellationToken||(e.CancellationToken={}));class y{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?T:(this._emitter||(this._emitter=new m.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class k{constructor(_){this._token=void 0,this._parentListener=void 0,this._parentListener=_&&_.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new y),this._token}cancel(){this._token?this._token instanceof y&&this._token.cancel():this._token=S.Cancelled}dispose(_=!1){_&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof y&&this._token.dispose():this._token=S.None}}e.CancellationTokenSource=k}),define(_e[78],Ee([0,1,3]),function(Z,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=e.registerCodicon=e.iconRegistry=void 0;class T{constructor(){this._icons=new Map,this._onDidRegister=new m.Emitter}add(I){const o=this._icons.get(I.id);o?I.description?o.description=I.description:console.error(`Duplicate registration of codicon ${I.id}`):(this._icons.set(I.id,I),this._onDidRegister.fire(I))}get(I){return this._icons.get(I)}get all(){return this._icons.values()}get onDidRegister(){return this._onDidRegister.event}}const S=new T;e.iconRegistry=S;function y(n,I){return new D(n,I)}e.registerCodicon=y;function k(n){return n?n.replace(/\$\((.*?)\)/g,(I,o)=>` ${o} `).trim():""}e.getCodiconAriaLabel=k;class D{constructor(I,o,h){this.id=I,this.definition=o,this.description=h,S.add(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}}e.Codicon=D;function _(n,I){const o=["codicon","codicon-"+n];return I&&o.push("codicon-modifier-"+I),o}e.getClassNamesArray=_;var C;(function(n){n.iconNameSegment="[A-Za-z0-9]+",n.iconNameExpression="[A-Za-z0-9\\-]+",n.iconModifierExpression="~[A-Za-z]+";const I=new RegExp(`^(${n.iconNameExpression})(${n.iconModifierExpression})?$`);function o(c){if(c instanceof D)return["codicon","codicon-"+c.id];const b=I.exec(c.id);if(!b)return o(D.error);let[,p,w]=b;const u=["codicon","codicon-"+p];return w&&u.push("codicon-modifier-"+w.substr(1)),u}n.asClassNameArray=o;function h(c){return o(c).join(" ")}n.asClassName=h;function d(c){return"."+o(c).join(".")}n.asCSSSelector=d})(C=e.CSSIcon||(e.CSSIcon={})),function(n){n.add=new n("add",{fontCharacter:"\\ea60"}),n.plus=new n("plus",{fontCharacter:"\\ea60"}),n.gistNew=new n("gist-new",{fontCharacter:"\\ea60"}),n.repoCreate=new n("repo-create",{fontCharacter:"\\ea60"}),n.lightbulb=new n("lightbulb",{fontCharacter:"\\ea61"}),n.lightBulb=new n("light-bulb",{fontCharacter:"\\ea61"}),n.repo=new n("repo",{fontCharacter:"\\ea62"}),n.repoDelete=new n("repo-delete",{fontCharacter:"\\ea62"}),n.gistFork=new n("gist-fork",{fontCharacter:"\\ea63"}),n.repoForked=new n("repo-forked",{fontCharacter:"\\ea63"}),n.gitPullRequest=new n("git-pull-request",{fontCharacter:"\\ea64"}),n.gitPullRequestAbandoned=new n("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),n.recordKeys=new n("record-keys",{fontCharacter:"\\ea65"}),n.keyboard=new n("keyboard",{fontCharacter:"\\ea65"}),n.tag=new n("tag",{fontCharacter:"\\ea66"}),n.tagAdd=new n("tag-add",{fontCharacter:"\\ea66"}),n.tagRemove=new n("tag-remove",{fontCharacter:"\\ea66"}),n.person=new n("person",{fontCharacter:"\\ea67"}),n.personFollow=new n("person-follow",{fontCharacter:"\\ea67"}),n.personOutline=new n("person-outline",{fontCharacter:"\\ea67"}),n.personFilled=new n("person-filled",{fontCharacter:"\\ea67"}),n.gitBranch=new n("git-branch",{fontCharacter:"\\ea68"}),n.gitBranchCreate=new n("git-branch-create",{fontCharacter:"\\ea68"}),n.gitBranchDelete=new n("git-branch-delete",{fontCharacter:"\\ea68"}),n.sourceControl=new n("source-control",{fontCharacter:"\\ea68"}),n.mirror=new n("mirror",{fontCharacter:"\\ea69"}),n.mirrorPublic=new n("mirror-public",{fontCharacter:"\\ea69"}),n.star=new n("star",{fontCharacter:"\\ea6a"}),n.starAdd=new n("star-add",{fontCharacter:"\\ea6a"}),n.starDelete=new n("star-delete",{fontCharacter:"\\ea6a"}),n.starEmpty=new n("star-empty",{fontCharacter:"\\ea6a"}),n.comment=new n("comment",{fontCharacter:"\\ea6b"}),n.commentAdd=new n("comment-add",{fontCharacter:"\\ea6b"}),n.alert=new n("alert",{fontCharacter:"\\ea6c"}),n.warning=new n("warning",{fontCharacter:"\\ea6c"}),n.search=new n("search",{fontCharacter:"\\ea6d"}),n.searchSave=new n("search-save",{fontCharacter:"\\ea6d"}),n.logOut=new n("log-out",{fontCharacter:"\\ea6e"}),n.signOut=new n("sign-out",{fontCharacter:"\\ea6e"}),n.logIn=new n("log-in",{fontCharacter:"\\ea6f"}),n.signIn=new n("sign-in",{fontCharacter:"\\ea6f"}),n.eye=new n("eye",{fontCharacter:"\\ea70"}),n.eyeUnwatch=new n("eye-unwatch",{fontCharacter:"\\ea70"}),n.eyeWatch=new n("eye-watch",{fontCharacter:"\\ea70"}),n.circleFilled=new n("circle-filled",{fontCharacter:"\\ea71"}),n.primitiveDot=new n("primitive-dot",{fontCharacter:"\\ea71"}),n.closeDirty=new n("close-dirty",{fontCharacter:"\\ea71"}),n.debugBreakpoint=new n("debug-breakpoint",{fontCharacter:"\\ea71"}),n.debugBreakpointDisabled=new n("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),n.debugHint=new n("debug-hint",{fontCharacter:"\\ea71"}),n.primitiveSquare=new n("primitive-square",{fontCharacter:"\\ea72"}),n.edit=new n("edit",{fontCharacter:"\\ea73"}),n.pencil=new n("pencil",{fontCharacter:"\\ea73"}),n.info=new n("info",{fontCharacter:"\\ea74"}),n.issueOpened=new n("issue-opened",{fontCharacter:"\\ea74"}),n.gistPrivate=new n("gist-private",{fontCharacter:"\\ea75"}),n.gitForkPrivate=new n("git-fork-private",{fontCharacter:"\\ea75"}),n.lock=new n("lock",{fontCharacter:"\\ea75"}),n.mirrorPrivate=new n("mirror-private",{fontCharacter:"\\ea75"}),n.close=new n("close",{fontCharacter:"\\ea76"}),n.removeClose=new n("remove-close",{fontCharacter:"\\ea76"}),n.x=new n("x",{fontCharacter:"\\ea76"}),n.repoSync=new n("repo-sync",{fontCharacter:"\\ea77"}),n.sync=new n("sync",{fontCharacter:"\\ea77"}),n.clone=new n("clone",{fontCharacter:"\\ea78"}),n.desktopDownload=new n("desktop-download",{fontCharacter:"\\ea78"}),n.beaker=new n("beaker",{fontCharacter:"\\ea79"}),n.microscope=new n("microscope",{fontCharacter:"\\ea79"}),n.vm=new n("vm",{fontCharacter:"\\ea7a"}),n.deviceDesktop=new n("device-desktop",{fontCharacter:"\\ea7a"}),n.file=new n("file",{fontCharacter:"\\ea7b"}),n.fileText=new n("file-text",{fontCharacter:"\\ea7b"}),n.more=new n("more",{fontCharacter:"\\ea7c"}),n.ellipsis=new n("ellipsis",{fontCharacter:"\\ea7c"}),n.kebabHorizontal=new n("kebab-horizontal",{fontCharacter:"\\ea7c"}),n.mailReply=new n("mail-reply",{fontCharacter:"\\ea7d"}),n.reply=new n("reply",{fontCharacter:"\\ea7d"}),n.organization=new n("organization",{fontCharacter:"\\ea7e"}),n.organizationFilled=new n("organization-filled",{fontCharacter:"\\ea7e"}),n.organizationOutline=new n("organization-outline",{fontCharacter:"\\ea7e"}),n.newFile=new n("new-file",{fontCharacter:"\\ea7f"}),n.fileAdd=new n("file-add",{fontCharacter:"\\ea7f"}),n.newFolder=new n("new-folder",{fontCharacter:"\\ea80"}),n.fileDirectoryCreate=new n("file-directory-create",{fontCharacter:"\\ea80"}),n.trash=new n("trash",{fontCharacter:"\\ea81"}),n.trashcan=new n("trashcan",{fontCharacter:"\\ea81"}),n.history=new n("history",{fontCharacter:"\\ea82"}),n.clock=new n("clock",{fontCharacter:"\\ea82"}),n.folder=new n("folder",{fontCharacter:"\\ea83"}),n.fileDirectory=new n("file-directory",{fontCharacter:"\\ea83"}),n.symbolFolder=new n("symbol-folder",{fontCharacter:"\\ea83"}),n.logoGithub=new n("logo-github",{fontCharacter:"\\ea84"}),n.markGithub=new n("mark-github",{fontCharacter:"\\ea84"}),n.github=new n("github",{fontCharacter:"\\ea84"}),n.terminal=new n("terminal",{fontCharacter:"\\ea85"}),n.console=new n("console",{fontCharacter:"\\ea85"}),n.repl=new n("repl",{fontCharacter:"\\ea85"}),n.zap=new n("zap",{fontCharacter:"\\ea86"}),n.symbolEvent=new n("symbol-event",{fontCharacter:"\\ea86"}),n.error=new n("error",{fontCharacter:"\\ea87"}),n.stop=new n("stop",{fontCharacter:"\\ea87"}),n.variable=new n("variable",{fontCharacter:"\\ea88"}),n.symbolVariable=new n("symbol-variable",{fontCharacter:"\\ea88"}),n.array=new n("array",{fontCharacter:"\\ea8a"}),n.symbolArray=new n("symbol-array",{fontCharacter:"\\ea8a"}),n.symbolModule=new n("symbol-module",{fontCharacter:"\\ea8b"}),n.symbolPackage=new n("symbol-package",{fontCharacter:"\\ea8b"}),n.symbolNamespace=new n("symbol-namespace",{fontCharacter:"\\ea8b"}),n.symbolObject=new n("symbol-object",{fontCharacter:"\\ea8b"}),n.symbolMethod=new n("symbol-method",{fontCharacter:"\\ea8c"}),n.symbolFunction=new n("symbol-function",{fontCharacter:"\\ea8c"}),n.symbolConstructor=new n("symbol-constructor",{fontCharacter:"\\ea8c"}),n.symbolBoolean=new n("symbol-boolean",{fontCharacter:"\\ea8f"}),n.symbolNull=new n("symbol-null",{fontCharacter:"\\ea8f"}),n.symbolNumeric=new n("symbol-numeric",{fontCharacter:"\\ea90"}),n.symbolNumber=new n("symbol-number",{fontCharacter:"\\ea90"}),n.symbolStructure=new n("symbol-structure",{fontCharacter:"\\ea91"}),n.symbolStruct=new n("symbol-struct",{fontCharacter:"\\ea91"}),n.symbolParameter=new n("symbol-parameter",{fontCharacter:"\\ea92"}),n.symbolTypeParameter=new n("symbol-type-parameter",{fontCharacter:"\\ea92"}),n.symbolKey=new n("symbol-key",{fontCharacter:"\\ea93"}),n.symbolText=new n("symbol-text",{fontCharacter:"\\ea93"}),n.symbolReference=new n("symbol-reference",{fontCharacter:"\\ea94"}),n.goToFile=new n("go-to-file",{fontCharacter:"\\ea94"}),n.symbolEnum=new n("symbol-enum",{fontCharacter:"\\ea95"}),n.symbolValue=new n("symbol-value",{fontCharacter:"\\ea95"}),n.symbolRuler=new n("symbol-ruler",{fontCharacter:"\\ea96"}),n.symbolUnit=new n("symbol-unit",{fontCharacter:"\\ea96"}),n.activateBreakpoints=new n("activate-breakpoints",{fontCharacter:"\\ea97"}),n.archive=new n("archive",{fontCharacter:"\\ea98"}),n.arrowBoth=new n("arrow-both",{fontCharacter:"\\ea99"}),n.arrowDown=new n("arrow-down",{fontCharacter:"\\ea9a"}),n.arrowLeft=new n("arrow-left",{fontCharacter:"\\ea9b"}),n.arrowRight=new n("arrow-right",{fontCharacter:"\\ea9c"}),n.arrowSmallDown=new n("arrow-small-down",{fontCharacter:"\\ea9d"}),n.arrowSmallLeft=new n("arrow-small-left",{fontCharacter:"\\ea9e"}),n.arrowSmallRight=new n("arrow-small-right",{fontCharacter:"\\ea9f"}),n.arrowSmallUp=new n("arrow-small-up",{fontCharacter:"\\eaa0"}),n.arrowUp=new n("arrow-up",{fontCharacter:"\\eaa1"}),n.bell=new n("bell",{fontCharacter:"\\eaa2"}),n.bold=new n("bold",{fontCharacter:"\\eaa3"}),n.book=new n("book",{fontCharacter:"\\eaa4"}),n.bookmark=new n("bookmark",{fontCharacter:"\\eaa5"}),n.debugBreakpointConditionalUnverified=new n("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),n.debugBreakpointConditional=new n("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),n.debugBreakpointConditionalDisabled=new n("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),n.debugBreakpointDataUnverified=new n("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),n.debugBreakpointData=new n("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),n.debugBreakpointDataDisabled=new n("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),n.debugBreakpointLogUnverified=new n("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),n.debugBreakpointLog=new n("debug-breakpoint-log",{fontCharacter:"\\eaab"}),n.debugBreakpointLogDisabled=new n("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),n.briefcase=new n("briefcase",{fontCharacter:"\\eaac"}),n.broadcast=new n("broadcast",{fontCharacter:"\\eaad"}),n.browser=new n("browser",{fontCharacter:"\\eaae"}),n.bug=new n("bug",{fontCharacter:"\\eaaf"}),n.calendar=new n("calendar",{fontCharacter:"\\eab0"}),n.caseSensitive=new n("case-sensitive",{fontCharacter:"\\eab1"}),n.check=new n("check",{fontCharacter:"\\eab2"}),n.checklist=new n("checklist",{fontCharacter:"\\eab3"}),n.chevronDown=new n("chevron-down",{fontCharacter:"\\eab4"}),n.chevronLeft=new n("chevron-left",{fontCharacter:"\\eab5"}),n.chevronRight=new n("chevron-right",{fontCharacter:"\\eab6"}),n.chevronUp=new n("chevron-up",{fontCharacter:"\\eab7"}),n.chromeClose=new n("chrome-close",{fontCharacter:"\\eab8"}),n.chromeMaximize=new n("chrome-maximize",{fontCharacter:"\\eab9"}),n.chromeMinimize=new n("chrome-minimize",{fontCharacter:"\\eaba"}),n.chromeRestore=new n("chrome-restore",{fontCharacter:"\\eabb"}),n.circleOutline=new n("circle-outline",{fontCharacter:"\\eabc"}),n.debugBreakpointUnverified=new n("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),n.circleSlash=new n("circle-slash",{fontCharacter:"\\eabd"}),n.circuitBoard=new n("circuit-board",{fontCharacter:"\\eabe"}),n.clearAll=new n("clear-all",{fontCharacter:"\\eabf"}),n.clippy=new n("clippy",{fontCharacter:"\\eac0"}),n.closeAll=new n("close-all",{fontCharacter:"\\eac1"}),n.cloudDownload=new n("cloud-download",{fontCharacter:"\\eac2"}),n.cloudUpload=new n("cloud-upload",{fontCharacter:"\\eac3"}),n.code=new n("code",{fontCharacter:"\\eac4"}),n.collapseAll=new n("collapse-all",{fontCharacter:"\\eac5"}),n.colorMode=new n("color-mode",{fontCharacter:"\\eac6"}),n.commentDiscussion=new n("comment-discussion",{fontCharacter:"\\eac7"}),n.compareChanges=new n("compare-changes",{fontCharacter:"\\eafd"}),n.creditCard=new n("credit-card",{fontCharacter:"\\eac9"}),n.dash=new n("dash",{fontCharacter:"\\eacc"}),n.dashboard=new n("dashboard",{fontCharacter:"\\eacd"}),n.database=new n("database",{fontCharacter:"\\eace"}),n.debugContinue=new n("debug-continue",{fontCharacter:"\\eacf"}),n.debugDisconnect=new n("debug-disconnect",{fontCharacter:"\\ead0"}),n.debugPause=new n("debug-pause",{fontCharacter:"\\ead1"}),n.debugRestart=new n("debug-restart",{fontCharacter:"\\ead2"}),n.debugStart=new n("debug-start",{fontCharacter:"\\ead3"}),n.debugStepInto=new n("debug-step-into",{fontCharacter:"\\ead4"}),n.debugStepOut=new n("debug-step-out",{fontCharacter:"\\ead5"}),n.debugStepOver=new n("debug-step-over",{fontCharacter:"\\ead6"}),n.debugStop=new n("debug-stop",{fontCharacter:"\\ead7"}),n.debug=new n("debug",{fontCharacter:"\\ead8"}),n.deviceCameraVideo=new n("device-camera-video",{fontCharacter:"\\ead9"}),n.deviceCamera=new n("device-camera",{fontCharacter:"\\eada"}),n.deviceMobile=new n("device-mobile",{fontCharacter:"\\eadb"}),n.diffAdded=new n("diff-added",{fontCharacter:"\\eadc"}),n.diffIgnored=new n("diff-ignored",{fontCharacter:"\\eadd"}),n.diffModified=new n("diff-modified",{fontCharacter:"\\eade"}),n.diffRemoved=new n("diff-removed",{fontCharacter:"\\eadf"}),n.diffRenamed=new n("diff-renamed",{fontCharacter:"\\eae0"}),n.diff=new n("diff",{fontCharacter:"\\eae1"}),n.discard=new n("discard",{fontCharacter:"\\eae2"}),n.editorLayout=new n("editor-layout",{fontCharacter:"\\eae3"}),n.emptyWindow=new n("empty-window",{fontCharacter:"\\eae4"}),n.exclude=new n("exclude",{fontCharacter:"\\eae5"}),n.extensions=new n("extensions",{fontCharacter:"\\eae6"}),n.eyeClosed=new n("eye-closed",{fontCharacter:"\\eae7"}),n.fileBinary=new n("file-binary",{fontCharacter:"\\eae8"}),n.fileCode=new n("file-code",{fontCharacter:"\\eae9"}),n.fileMedia=new n("file-media",{fontCharacter:"\\eaea"}),n.filePdf=new n("file-pdf",{fontCharacter:"\\eaeb"}),n.fileSubmodule=new n("file-submodule",{fontCharacter:"\\eaec"}),n.fileSymlinkDirectory=new n("file-symlink-directory",{fontCharacter:"\\eaed"}),n.fileSymlinkFile=new n("file-symlink-file",{fontCharacter:"\\eaee"}),n.fileZip=new n("file-zip",{fontCharacter:"\\eaef"}),n.files=new n("files",{fontCharacter:"\\eaf0"}),n.filter=new n("filter",{fontCharacter:"\\eaf1"}),n.flame=new n("flame",{fontCharacter:"\\eaf2"}),n.foldDown=new n("fold-down",{fontCharacter:"\\eaf3"}),n.foldUp=new n("fold-up",{fontCharacter:"\\eaf4"}),n.fold=new n("fold",{fontCharacter:"\\eaf5"}),n.folderActive=new n("folder-active",{fontCharacter:"\\eaf6"}),n.folderOpened=new n("folder-opened",{fontCharacter:"\\eaf7"}),n.gear=new n("gear",{fontCharacter:"\\eaf8"}),n.gift=new n("gift",{fontCharacter:"\\eaf9"}),n.gistSecret=new n("gist-secret",{fontCharacter:"\\eafa"}),n.gist=new n("gist",{fontCharacter:"\\eafb"}),n.gitCommit=new n("git-commit",{fontCharacter:"\\eafc"}),n.gitCompare=new n("git-compare",{fontCharacter:"\\eafd"}),n.gitMerge=new n("git-merge",{fontCharacter:"\\eafe"}),n.githubAction=new n("github-action",{fontCharacter:"\\eaff"}),n.githubAlt=new n("github-alt",{fontCharacter:"\\eb00"}),n.globe=new n("globe",{fontCharacter:"\\eb01"}),n.grabber=new n("grabber",{fontCharacter:"\\eb02"}),n.graph=new n("graph",{fontCharacter:"\\eb03"}),n.gripper=new n("gripper",{fontCharacter:"\\eb04"}),n.heart=new n("heart",{fontCharacter:"\\eb05"}),n.home=new n("home",{fontCharacter:"\\eb06"}),n.horizontalRule=new n("horizontal-rule",{fontCharacter:"\\eb07"}),n.hubot=new n("hubot",{fontCharacter:"\\eb08"}),n.inbox=new n("inbox",{fontCharacter:"\\eb09"}),n.issueClosed=new n("issue-closed",{fontCharacter:"\\eb0a"}),n.issueReopened=new n("issue-reopened",{fontCharacter:"\\eb0b"}),n.issues=new n("issues",{fontCharacter:"\\eb0c"}),n.italic=new n("italic",{fontCharacter:"\\eb0d"}),n.jersey=new n("jersey",{fontCharacter:"\\eb0e"}),n.json=new n("json",{fontCharacter:"\\eb0f"}),n.kebabVertical=new n("kebab-vertical",{fontCharacter:"\\eb10"}),n.key=new n("key",{fontCharacter:"\\eb11"}),n.law=new n("law",{fontCharacter:"\\eb12"}),n.lightbulbAutofix=new n("lightbulb-autofix",{fontCharacter:"\\eb13"}),n.linkExternal=new n("link-external",{fontCharacter:"\\eb14"}),n.link=new n("link",{fontCharacter:"\\eb15"}),n.listOrdered=new n("list-ordered",{fontCharacter:"\\eb16"}),n.listUnordered=new n("list-unordered",{fontCharacter:"\\eb17"}),n.liveShare=new n("live-share",{fontCharacter:"\\eb18"}),n.loading=new n("loading",{fontCharacter:"\\eb19"}),n.location=new n("location",{fontCharacter:"\\eb1a"}),n.mailRead=new n("mail-read",{fontCharacter:"\\eb1b"}),n.mail=new n("mail",{fontCharacter:"\\eb1c"}),n.markdown=new n("markdown",{fontCharacter:"\\eb1d"}),n.megaphone=new n("megaphone",{fontCharacter:"\\eb1e"}),n.mention=new n("mention",{fontCharacter:"\\eb1f"}),n.milestone=new n("milestone",{fontCharacter:"\\eb20"}),n.mortarBoard=new n("mortar-board",{fontCharacter:"\\eb21"}),n.move=new n("move",{fontCharacter:"\\eb22"}),n.multipleWindows=new n("multiple-windows",{fontCharacter:"\\eb23"}),n.mute=new n("mute",{fontCharacter:"\\eb24"}),n.noNewline=new n("no-newline",{fontCharacter:"\\eb25"}),n.note=new n("note",{fontCharacter:"\\eb26"}),n.octoface=new n("octoface",{fontCharacter:"\\eb27"}),n.openPreview=new n("open-preview",{fontCharacter:"\\eb28"}),n.package_=new n("package",{fontCharacter:"\\eb29"}),n.paintcan=new n("paintcan",{fontCharacter:"\\eb2a"}),n.pin=new n("pin",{fontCharacter:"\\eb2b"}),n.play=new n("play",{fontCharacter:"\\eb2c"}),n.run=new n("run",{fontCharacter:"\\eb2c"}),n.plug=new n("plug",{fontCharacter:"\\eb2d"}),n.preserveCase=new n("preserve-case",{fontCharacter:"\\eb2e"}),n.preview=new n("preview",{fontCharacter:"\\eb2f"}),n.project=new n("project",{fontCharacter:"\\eb30"}),n.pulse=new n("pulse",{fontCharacter:"\\eb31"}),n.question=new n("question",{fontCharacter:"\\eb32"}),n.quote=new n("quote",{fontCharacter:"\\eb33"}),n.radioTower=new n("radio-tower",{fontCharacter:"\\eb34"}),n.reactions=new n("reactions",{fontCharacter:"\\eb35"}),n.references=new n("references",{fontCharacter:"\\eb36"}),n.refresh=new n("refresh",{fontCharacter:"\\eb37"}),n.regex=new n("regex",{fontCharacter:"\\eb38"}),n.remoteExplorer=new n("remote-explorer",{fontCharacter:"\\eb39"}),n.remote=new n("remote",{fontCharacter:"\\eb3a"}),n.remove=new n("remove",{fontCharacter:"\\eb3b"}),n.replaceAll=new n("replace-all",{fontCharacter:"\\eb3c"}),n.replace=new n("replace",{fontCharacter:"\\eb3d"}),n.repoClone=new n("repo-clone",{fontCharacter:"\\eb3e"}),n.repoForcePush=new n("repo-force-push",{fontCharacter:"\\eb3f"}),n.repoPull=new n("repo-pull",{fontCharacter:"\\eb40"}),n.repoPush=new n("repo-push",{fontCharacter:"\\eb41"}),n.report=new n("report",{fontCharacter:"\\eb42"}),n.requestChanges=new n("request-changes",{fontCharacter:"\\eb43"}),n.rocket=new n("rocket",{fontCharacter:"\\eb44"}),n.rootFolderOpened=new n("root-folder-opened",{fontCharacter:"\\eb45"}),n.rootFolder=new n("root-folder",{fontCharacter:"\\eb46"}),n.rss=new n("rss",{fontCharacter:"\\eb47"}),n.ruby=new n("ruby",{fontCharacter:"\\eb48"}),n.saveAll=new n("save-all",{fontCharacter:"\\eb49"}),n.saveAs=new n("save-as",{fontCharacter:"\\eb4a"}),n.save=new n("save",{fontCharacter:"\\eb4b"}),n.screenFull=new n("screen-full",{fontCharacter:"\\eb4c"}),n.screenNormal=new n("screen-normal",{fontCharacter:"\\eb4d"}),n.searchStop=new n("search-stop",{fontCharacter:"\\eb4e"}),n.server=new n("server",{fontCharacter:"\\eb50"}),n.settingsGear=new n("settings-gear",{fontCharacter:"\\eb51"}),n.settings=new n("settings",{fontCharacter:"\\eb52"}),n.shield=new n("shield",{fontCharacter:"\\eb53"}),n.smiley=new n("smiley",{fontCharacter:"\\eb54"}),n.sortPrecedence=new n("sort-precedence",{fontCharacter:"\\eb55"}),n.splitHorizontal=new n("split-horizontal",{fontCharacter:"\\eb56"}),n.splitVertical=new n("split-vertical",{fontCharacter:"\\eb57"}),n.squirrel=new n("squirrel",{fontCharacter:"\\eb58"}),n.starFull=new n("star-full",{fontCharacter:"\\eb59"}),n.starHalf=new n("star-half",{fontCharacter:"\\eb5a"}),n.symbolClass=new n("symbol-class",{fontCharacter:"\\eb5b"}),n.symbolColor=new n("symbol-color",{fontCharacter:"\\eb5c"}),n.symbolConstant=new n("symbol-constant",{fontCharacter:"\\eb5d"}),n.symbolEnumMember=new n("symbol-enum-member",{fontCharacter:"\\eb5e"}),n.symbolField=new n("symbol-field",{fontCharacter:"\\eb5f"}),n.symbolFile=new n("symbol-file",{fontCharacter:"\\eb60"}),n.symbolInterface=new n("symbol-interface",{fontCharacter:"\\eb61"}),n.symbolKeyword=new n("symbol-keyword",{fontCharacter:"\\eb62"}),n.symbolMisc=new n("symbol-misc",{fontCharacter:"\\eb63"}),n.symbolOperator=new n("symbol-operator",{fontCharacter:"\\eb64"}),n.symbolProperty=new n("symbol-property",{fontCharacter:"\\eb65"}),n.wrench=new n("wrench",{fontCharacter:"\\eb65"}),n.wrenchSubaction=new n("wrench-subaction",{fontCharacter:"\\eb65"}),n.symbolSnippet=new n("symbol-snippet",{fontCharacter:"\\eb66"}),n.tasklist=new n("tasklist",{fontCharacter:"\\eb67"}),n.telescope=new n("telescope",{fontCharacter:"\\eb68"}),n.textSize=new n("text-size",{fontCharacter:"\\eb69"}),n.threeBars=new n("three-bars",{fontCharacter:"\\eb6a"}),n.thumbsdown=new n("thumbsdown",{fontCharacter:"\\eb6b"}),n.thumbsup=new n("thumbsup",{fontCharacter:"\\eb6c"}),n.tools=new n("tools",{fontCharacter:"\\eb6d"}),n.triangleDown=new n("triangle-down",{fontCharacter:"\\eb6e"}),n.triangleLeft=new n("triangle-left",{fontCharacter:"\\eb6f"}),n.triangleRight=new n("triangle-right",{fontCharacter:"\\eb70"}),n.triangleUp=new n("triangle-up",{fontCharacter:"\\eb71"}),n.twitter=new n("twitter",{fontCharacter:"\\eb72"}),n.unfold=new n("unfold",{fontCharacter:"\\eb73"}),n.unlock=new n("unlock",{fontCharacter:"\\eb74"}),n.unmute=new n("unmute",{fontCharacter:"\\eb75"}),n.unverified=new n("unverified",{fontCharacter:"\\eb76"}),n.verified=new n("verified",{fontCharacter:"\\eb77"}),n.versions=new n("versions",{fontCharacter:"\\eb78"}),n.vmActive=new n("vm-active",{fontCharacter:"\\eb79"}),n.vmOutline=new n("vm-outline",{fontCharacter:"\\eb7a"}),n.vmRunning=new n("vm-running",{fontCharacter:"\\eb7b"}),n.watch=new n("watch",{fontCharacter:"\\eb7c"}),n.whitespace=new n("whitespace",{fontCharacter:"\\eb7d"}),n.wholeWord=new n("whole-word",{fontCharacter:"\\eb7e"}),n.window=new n("window",{fontCharacter:"\\eb7f"}),n.wordWrap=new n("word-wrap",{fontCharacter:"\\eb80"}),n.zoomIn=new n("zoom-in",{fontCharacter:"\\eb81"}),n.zoomOut=new n("zoom-out",{fontCharacter:"\\eb82"}),n.listFilter=new n("list-filter",{fontCharacter:"\\eb83"}),n.listFlat=new n("list-flat",{fontCharacter:"\\eb84"}),n.listSelection=new n("list-selection",{fontCharacter:"\\eb85"}),n.selection=new n("selection",{fontCharacter:"\\eb85"}),n.listTree=new n("list-tree",{fontCharacter:"\\eb86"}),n.debugBreakpointFunctionUnverified=new n("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),n.debugBreakpointFunction=new n("debug-breakpoint-function",{fontCharacter:"\\eb88"}),n.debugBreakpointFunctionDisabled=new n("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),n.debugStackframeActive=new n("debug-stackframe-active",{fontCharacter:"\\eb89"}),n.debugStackframeDot=new n("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),n.debugStackframe=new n("debug-stackframe",{fontCharacter:"\\eb8b"}),n.debugStackframeFocused=new n("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),n.debugBreakpointUnsupported=new n("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),n.symbolString=new n("symbol-string",{fontCharacter:"\\eb8d"}),n.debugReverseContinue=new n("debug-reverse-continue",{fontCharacter:"\\eb8e"}),n.debugStepBack=new n("debug-step-back",{fontCharacter:"\\eb8f"}),n.debugRestartFrame=new n("debug-restart-frame",{fontCharacter:"\\eb90"}),n.callIncoming=new n("call-incoming",{fontCharacter:"\\eb92"}),n.callOutgoing=new n("call-outgoing",{fontCharacter:"\\eb93"}),n.menu=new n("menu",{fontCharacter:"\\eb94"}),n.expandAll=new n("expand-all",{fontCharacter:"\\eb95"}),n.feedback=new n("feedback",{fontCharacter:"\\eb96"}),n.groupByRefType=new n("group-by-ref-type",{fontCharacter:"\\eb97"}),n.ungroupByRefType=new n("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),n.account=new n("account",{fontCharacter:"\\eb99"}),n.bellDot=new n("bell-dot",{fontCharacter:"\\eb9a"}),n.debugConsole=new n("debug-console",{fontCharacter:"\\eb9b"}),n.library=new n("library",{fontCharacter:"\\eb9c"}),n.output=new n("output",{fontCharacter:"\\eb9d"}),n.runAll=new n("run-all",{fontCharacter:"\\eb9e"}),n.syncIgnored=new n("sync-ignored",{fontCharacter:"\\eb9f"}),n.pinned=new n("pinned",{fontCharacter:"\\eba0"}),n.githubInverted=new n("github-inverted",{fontCharacter:"\\eba1"}),n.debugAlt=new n("debug-alt",{fontCharacter:"\\eb91"}),n.serverProcess=new n("server-process",{fontCharacter:"\\eba2"}),n.serverEnvironment=new n("server-environment",{fontCharacter:"\\eba3"}),n.pass=new n("pass",{fontCharacter:"\\eba4"}),n.stopCircle=new n("stop-circle",{fontCharacter:"\\eba5"}),n.playCircle=new n("play-circle",{fontCharacter:"\\eba6"}),n.record=new n("record",{fontCharacter:"\\eba7"}),n.debugAltSmall=new n("debug-alt-small",{fontCharacter:"\\eba8"}),n.vmConnect=new n("vm-connect",{fontCharacter:"\\eba9"}),n.cloud=new n("cloud",{fontCharacter:"\\ebaa"}),n.merge=new n("merge",{fontCharacter:"\\ebab"}),n.exportIcon=new n("export",{fontCharacter:"\\ebac"}),n.graphLeft=new n("graph-left",{fontCharacter:"\\ebad"}),n.magnet=new n("magnet",{fontCharacter:"\\ebae"}),n.notebook=new n("notebook",{fontCharacter:"\\ebaf"}),n.redo=new n("redo",{fontCharacter:"\\ebb0"}),n.checkAll=new n("check-all",{fontCharacter:"\\ebb1"}),n.pinnedDirty=new n("pinned-dirty",{fontCharacter:"\\ebb2"}),n.passFilled=new n("pass-filled",{fontCharacter:"\\ebb3"}),n.circleLargeFilled=new n("circle-large-filled",{fontCharacter:"\\ebb4"}),n.circleLargeOutline=new n("circle-large-outline",{fontCharacter:"\\ebb5"}),n.combine=new n("combine",{fontCharacter:"\\ebb6"}),n.gather=new n("gather",{fontCharacter:"\\ebb6"}),n.table=new n("table",{fontCharacter:"\\ebb7"}),n.variableGroup=new n("variable-group",{fontCharacter:"\\ebb8"}),n.typeHierarchy=new n("type-hierarchy",{fontCharacter:"\\ebb9"}),n.typeHierarchySub=new n("type-hierarchy-sub",{fontCharacter:"\\ebba"}),n.typeHierarchySuper=new n("type-hierarchy-super",{fontCharacter:"\\ebbb"}),n.gitPullRequestCreate=new n("git-pull-request-create",{fontCharacter:"\\ebbc"}),n.runAbove=new n("run-above",{fontCharacter:"\\ebbd"}),n.runBelow=new n("run-below",{fontCharacter:"\\ebbe"}),n.notebookTemplate=new n("notebook-template",{fontCharacter:"\\ebbf"}),n.debugRerun=new n("debug-rerun",{fontCharacter:"\\ebc0"}),n.workspaceTrusted=new n("workspace-trusted",{fontCharacter:"\\ebc1"}),n.workspaceUntrusted=new n("workspace-untrusted",{fontCharacter:"\\ebc2"}),n.workspaceUnspecified=new n("workspace-unspecified",{fontCharacter:"\\ebc3"}),n.terminalCmd=new n("terminal-cmd",{fontCharacter:"\\ebc4"}),n.terminalDebian=new n("terminal-debian",{fontCharacter:"\\ebc5"}),n.terminalLinux=new n("terminal-linux",{fontCharacter:"\\ebc6"}),n.terminalPowershell=new n("terminal-powershell",{fontCharacter:"\\ebc7"}),n.terminalTmux=new n("terminal-tmux",{fontCharacter:"\\ebc8"}),n.terminalUbuntu=new n("terminal-ubuntu",{fontCharacter:"\\ebc9"}),n.terminalBash=new n("terminal-bash",{fontCharacter:"\\ebca"}),n.arrowSwap=new n("arrow-swap",{fontCharacter:"\\ebcb"}),n.copy=new n("copy",{fontCharacter:"\\ebcc"}),n.personAdd=new n("person-add",{fontCharacter:"\\ebcd"}),n.filterFilled=new n("filter-filled",{fontCharacter:"\\ebce"}),n.wand=new n("wand",{fontCharacter:"\\ebcf"}),n.debugLineByLine=new n("debug-line-by-line",{fontCharacter:"\\ebd0"}),n.inspect=new n("inspect",{fontCharacter:"\\ebd1"}),n.dropDownButton=new n("drop-down-button",n.chevronDown.definition)}(D=e.Codicon||(e.Codicon={}))}),define(_e[109],Ee([0,1,11,7]),function(Z,e,m,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function S(u){const f=u;return f?[f.on,f.pause,f.resume,f.destroy].every(g=>typeof g=="function"):!1}e.isReadableStream=S;function y(u){const f=u;return f?S(f.stream)&&Array.isArray(f.buffer)&&typeof f.ended=="boolean":!1}e.isReadableBufferedStream=y;function k(u,f){return new D(u,f)}e.newWriteableStream=k;class D{constructor(f,g){this.reducer=f,this.options=g,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(f){var g;if(!this.state.destroyed){if(this.state.flowing)this.emitData(f);else if(this.buffer.data.push(f),typeof((g=this.options)===null||g===void 0?void 0:g.highWaterMark)=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(t=>this.pendingWritePromises.push(t))}}error(f){this.state.destroyed||(this.state.flowing?this.emitError(f):this.buffer.error.push(f))}end(f){this.state.destroyed||(typeof f!="undefined"&&this.write(f),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(f){this.listeners.data.slice(0).forEach(g=>g(f))}emitError(f){this.listeners.error.length===0?m.onUnexpectedError(f):this.listeners.error.slice(0).forEach(g=>g(f))}emitEnd(){this.listeners.end.slice(0).forEach(f=>f())}on(f,g){if(!this.state.destroyed)switch(f){case"data":this.listeners.data.push(g),this.resume();break;case"end":this.listeners.end.push(g),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(g),this.state.flowing&&this.flowErrors();break}}removeListener(f,g){if(this.state.destroyed)return;let t;switch(f){case"data":t=this.listeners.data;break;case"end":t=this.listeners.end;break;case"error":t=this.listeners.error;break}if(t){const i=t.indexOf(g);i>=0&&t.splice(i,1)}}flowData(){if(this.buffer.data.length>0){const f=this.reducer(this.buffer.data);this.emitData(f),this.buffer.data.length=0;const g=[...this.pendingWritePromises];this.pendingWritePromises.length=0,g.forEach(t=>t())}}flowErrors(){if(this.listeners.error.length>0){for(const f of this.buffer.error)this.emitError(f);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function _(u,f){const g=[];let t;for(;(t=u.read())!==null;)g.push(t);return f(g)}e.consumeReadable=_;function C(u,f,g){const t=[];let i;for(;(i=u.read())!==null&&t.length<g;)t.push(i);return i===null&&t.length>0?f(t):{read:()=>{if(t.length>0)return t.shift();if(typeof i!="undefined"){const s=i;return i=void 0,s}return u.read()}}}e.peekReadable=C;function n(u,f){return new Promise((g,t)=>{const i=[];I(u,{onData:s=>{f&&i.push(s)},onError:s=>{f?t(s):g(void 0)},onEnd:()=>{g(f?f(i):void 0)}})})}e.consumeStream=n;function I(u,f){u.on("error",g=>f.onError(g)),u.on("end",()=>f.onEnd()),u.on("data",g=>f.onData(g))}e.listenStream=I;function o(u,f){return new Promise((g,t)=>{const i=new T.DisposableStore,s=[],r=v=>{if(s.push(v),s.length>f)return i.dispose(),u.pause(),g({stream:u,buffer:s,ended:!1})},l=v=>t(v),E=()=>g({stream:u,buffer:s,ended:!0});i.add(T.toDisposable(()=>u.removeListener("error",l))),u.on("error",l),i.add(T.toDisposable(()=>u.removeListener("end",E))),u.on("end",E),i.add(T.toDisposable(()=>u.removeListener("data",r))),u.on("data",r)})}e.peekStream=o;function h(u,f){const g=k(f);return g.end(u),g}e.toStream=h;function d(){const u=k(()=>{throw new Error("not supported")});return u.end(),u}e.emptyStream=d;function c(u){let f=!1;return{read:()=>f?null:(f=!0,u)}}e.toReadable=c;function b(u,f,g){const t=k(g);return I(u,{onData:i=>t.write(f.data(i)),onError:i=>t.error(f.error?f.error(i):i),onEnd:()=>t.end()}),t}e.transform=b;function p(u,f,g){let t=!1;return{read:()=>{const i=f.read();return t?i:(t=!0,i!==null?g([u,i]):u)}}}e.prefixedReadable=p;function w(u,f,g){let t=!1;const i=k(g);return I(f,{onData:s=>t?i.write(s):(t=!0,i.write(g([u,s]))),onError:s=>i.error(s),onEnd:()=>{t||(t=!0,i.write(u)),i.end()}}),i}e.prefixedStream=w}),define(_e[8],Ee([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLeftDeleteOffset=e.GraphemeBreakType=e.breakBetweenGraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsEmoji=e.containsRTL=e.decodeUTF8=e.encodeUTF8=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format=e.isFalsyOrWhitespace=void 0;function m(O){return!O||typeof O!="string"?!0:O.trim().length===0}e.isFalsyOrWhitespace=m;const T=/{(\d+)}/g;function S(O,...K){return K.length===0?O:O.replace(T,function(ae,ke){const Pe=parseInt(ke,10);return isNaN(Pe)||Pe<0||Pe>=K.length?ae:K[Pe]})}e.format=S;function y(O){return O.replace(/[<>&]/g,function(K){switch(K){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return K}})}e.escape=y;function k(O){return O.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=k;function D(O,K){let ae=0;const ke=K.charCodeAt(0);for(let Pe=O.length-1;Pe>=0;Pe--)O.charCodeAt(Pe)===ke&&ae++;return ae}e.count=D;function _(O,K,ae="\u2026"){return O.length<=K?O:`${O.substr(0,K)}${ae}`}e.truncate=_;function C(O,K=" "){const ae=n(O,K);return I(ae,K)}e.trim=C;function n(O,K){if(!O||!K)return O;const ae=K.length;if(ae===0||O.length===0)return O;let ke=0;for(;O.indexOf(K,ke)===ke;)ke=ke+ae;return O.substring(ke)}e.ltrim=n;function I(O,K){if(!O||!K)return O;const ae=K.length,ke=O.length;if(ae===0||ke===0)return O;let Pe=ke,Oe=-1;for(;Oe=O.lastIndexOf(K,Pe-1),!(Oe===-1||Oe+ae!==Pe);){if(Oe===0)return"";Pe=Oe}return O.substring(0,Pe)}e.rtrim=I;function o(O){return O.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=o;function h(O){return O.replace(/\*/g,"")}e.stripWildcards=h;function d(O,K,ae={}){if(!O)throw new Error("Cannot create regex from empty string");K||(O=k(O)),ae.wholeWord&&(/\B/.test(O.charAt(0))||(O="\\b"+O),/\B/.test(O.charAt(O.length-1))||(O=O+"\\b"));let ke="";return ae.global&&(ke+="g"),ae.matchCase||(ke+="i"),ae.multiline&&(ke+="m"),ae.unicode&&(ke+="u"),new RegExp(O,ke)}e.createRegExp=d;function c(O){return O.source==="^"||O.source==="^$"||O.source==="$"||O.source==="^\\s*$"?!1:!!(O.exec("")&&O.lastIndex===0)}e.regExpLeadsToEndlessLoop=c;function b(O){return!!O.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=b;function p(O){return(O.global?"g":"")+(O.ignoreCase?"i":"")+(O.multiline?"m":"")+(O.unicode?"u":"")}e.regExpFlags=p;function w(O){return O.split(/\r\n|\r|\n/)}e.splitLines=w;function u(O){for(let K=0,ae=O.length;K<ae;K++){const ke=O.charCodeAt(K);if(ke!==32&&ke!==9)return K}return-1}e.firstNonWhitespaceIndex=u;function f(O,K=0,ae=O.length){for(let ke=K;ke<ae;ke++){const Pe=O.charCodeAt(ke);if(Pe!==32&&Pe!==9)return O.substring(K,ke)}return O.substring(K,ae)}e.getLeadingWhitespace=f;function g(O,K=O.length-1){for(let ae=K;ae>=0;ae--){const ke=O.charCodeAt(ae);if(ke!==32&&ke!==9)return ae}return-1}e.lastNonWhitespaceIndex=g;function t(O,K){return O<K?-1:O>K?1:0}e.compare=t;function i(O,K,ae=0,ke=O.length,Pe=0,Oe=K.length){for(;ae<ke&&Pe<Oe;ae++,Pe++){let Je=O.charCodeAt(ae),Ye=K.charCodeAt(Pe);if(Je<Ye)return-1;if(Je>Ye)return 1}const $e=ke-ae,Ze=Oe-Pe;return $e<Ze?-1:$e>Ze?1:0}e.compareSubstring=i;function s(O,K){return r(O,K,0,O.length,0,K.length)}e.compareIgnoreCase=s;function r(O,K,ae=0,ke=O.length,Pe=0,Oe=K.length){for(;ae<ke&&Pe<Oe;ae++,Pe++){let Je=O.charCodeAt(ae),Ye=K.charCodeAt(Pe);if(Je===Ye)continue;const nt=Je-Ye;if(!(nt===32&&E(Ye))&&!(nt===-32&&E(Je)))return l(Je)&&l(Ye)?nt:i(O.toLowerCase(),K.toLowerCase(),ae,ke,Pe,Oe)}const $e=ke-ae,Ze=Oe-Pe;return $e<Ze?-1:$e>Ze?1:0}e.compareSubstringIgnoreCase=r;function l(O){return O>=97&&O<=122}e.isLowerAsciiLetter=l;function E(O){return O>=65&&O<=90}e.isUpperAsciiLetter=E;function v(O){return l(O)||E(O)}function A(O,K){return O.length===K.length&&P(O,K)}e.equalsIgnoreCase=A;function P(O,K,ae=O.length){for(let ke=0;ke<ae;ke++){const Pe=O.charCodeAt(ke),Oe=K.charCodeAt(ke);if(Pe!==Oe){if(v(Pe)&&v(Oe)){const $e=Math.abs(Pe-Oe);if($e!==0&&$e!==32)return!1}else if(String.fromCharCode(Pe).toLowerCase()!==String.fromCharCode(Oe).toLowerCase())return!1}}return!0}function a(O,K){const ae=K.length;return K.length>O.length?!1:P(O,K,ae)}e.startsWithIgnoreCase=a;function F(O,K){let ae,ke=Math.min(O.length,K.length);for(ae=0;ae<ke;ae++)if(O.charCodeAt(ae)!==K.charCodeAt(ae))return ae;return ke}e.commonPrefixLength=F;function N(O,K){let ae,ke=Math.min(O.length,K.length);const Pe=O.length-1,Oe=K.length-1;for(ae=0;ae<ke;ae++)if(O.charCodeAt(Pe-ae)!==K.charCodeAt(Oe-ae))return ae;return ke}e.commonSuffixLength=N;function W(O){return 55296<=O&&O<=56319}e.isHighSurrogate=W;function le(O){return 56320<=O&&O<=57343}e.isLowSurrogate=le;function fe(O,K){return(O-55296<<10)+(K-56320)+65536}e.computeCodePoint=fe;function Y(O,K,ae){const ke=O.charCodeAt(ae);if(W(ke)&&ae+1<K){const Pe=O.charCodeAt(ae+1);if(le(Pe))return fe(ke,Pe)}return ke}e.getNextCodePoint=Y;function H(O,K){const ae=O.charCodeAt(K-1);if(le(ae)&&K>1){const ke=O.charCodeAt(K-2);if(W(ke))return fe(ke,ae)}return ae}function J(O,K){const ae=Le.getInstance(),ke=K,Pe=O.length,Oe=Y(O,Pe,K);K+=Oe>=65536?2:1;let $e=ae.getGraphemeBreakType(Oe);for(;K<Pe;){const Ze=Y(O,Pe,K),Je=ae.getGraphemeBreakType(Ze);if(me($e,Je))break;K+=Ze>=65536?2:1,$e=Je}return K-ke}e.nextCharLength=J;function R(O,K){const ae=Le.getInstance(),ke=K,Pe=H(O,K);K-=Pe>=65536?2:1;let Oe=ae.getGraphemeBreakType(Pe);for(;K>0;){const $e=H(O,K),Ze=ae.getGraphemeBreakType($e);if(me(Ze,Oe))break;K-=$e>=65536?2:1,Oe=Ze}return ke-K}e.prevCharLength=R;function B(O,K){const ae=Le.getInstance(),ke=O.length,Pe=K,Oe=Y(O,ke,K),$e=ae.getGraphemeBreakType(Oe);K+=Oe>=65536?2:1;let Ze=$e;for(;K<ke;){const Ye=Y(O,ke,K),nt=ae.getGraphemeBreakType(Ye);if(me(Ze,nt))break;K+=Ye>=65536?2:1,Ze=nt}const Je=K;for(K=Pe,Ze=$e;K>0;){const Ye=H(O,K),nt=ae.getGraphemeBreakType(Ye);if(me(nt,Ze))break;K-=Ye>=65536?2:1,Ze=nt}return[K,Je]}function M(O,K){return K>0&&le(O.charCodeAt(K))?B(O,K-1):B(O,K)}e.getCharContainingOffset=M;function x(O){const K=O.length;let ae=0,ke=0;for(;ke<K;){const $e=Y(O,K,ke);ke+=$e>=65536?2:1,$e<128?ae+=1:$e<2048?ae+=2:$e<65536?ae+=3:ae+=4}const Pe=new Uint8Array(ae);ke=0;let Oe=0;for(;ke<K;){const $e=Y(O,K,ke);ke+=$e>=65536?2:1,$e<128?Pe[Oe++]=$e:$e<2048?(Pe[Oe++]=192|($e&1984)>>>6,Pe[Oe++]=128|($e&63)>>>0):$e<65536?(Pe[Oe++]=224|($e&61440)>>>12,Pe[Oe++]=128|($e&4032)>>>6,Pe[Oe++]=128|($e&63)>>>0):(Pe[Oe++]=240|($e&1835008)>>>18,Pe[Oe++]=128|($e&258048)>>>12,Pe[Oe++]=128|($e&4032)>>>6,Pe[Oe++]=128|($e&63)>>>0)}return Pe}e.encodeUTF8=x;function q(O){const K=O.byteLength,ae=[];let ke=0;for(;ke<K;){const Pe=O[ke];let Oe;if(Pe>=240&&ke+3<K?Oe=(O[ke++]&7)<<18>>>0|(O[ke++]&63)<<12>>>0|(O[ke++]&63)<<6>>>0|(O[ke++]&63)<<0>>>0:Pe>=224&&ke+2<K?Oe=(O[ke++]&15)<<12>>>0|(O[ke++]&63)<<6>>>0|(O[ke++]&63)<<0>>>0:Pe>=192&&ke+1<K?Oe=(O[ke++]&31)<<6>>>0|(O[ke++]&63)<<0>>>0:Oe=O[ke++],Oe>=0&&Oe<=55295||Oe>=57344&&Oe<=65535)ae.push(String.fromCharCode(Oe));else if(Oe>=65536&&Oe<=1114111){const $e=Oe-65536,Ze=55296+(($e&1047552)>>>10),Je=56320+(($e&1023)>>>0);ae.push(String.fromCharCode(Ze)),ae.push(String.fromCharCode(Je))}else ae.push(String.fromCharCode(65533))}return ae.join("")}e.decodeUTF8=q;const z=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u08BD\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE33\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDCFF]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD50-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function oe(O){return z.test(O)}e.containsRTL=oe;const pe=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD00-\uDDFF\uDE70-\uDED6])/;function Te(O){return pe.test(O)}e.containsEmoji=Te;const Be=/^[\t\n\r\x20-\x7E]*$/;function Fe(O){return Be.test(O)}e.isBasicASCII=Fe,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function We(O){return e.UNUSUAL_LINE_TERMINATORS.test(O)}e.containsUnusualLineTerminators=We;function Qe(O){for(let K=0,ae=O.length;K<ae;K++)if(Ge(O.charCodeAt(K)))return!0;return!1}e.containsFullWidthCharacter=Qe;function Ge(O){return O=+O,O>=11904&&O<=55215||O>=63744&&O<=64255||O>=65281&&O<=65374}e.isFullWidthCharacter=Ge;function Ke(O){return O>=127462&&O<=127487||O===8986||O===8987||O===9200||O===9203||O>=9728&&O<=10175||O===11088||O===11093||O>=127744&&O<=128591||O>=128640&&O<=128764||O>=128992&&O<=129003||O>=129280&&O<=129535||O>=129648&&O<=129750}e.isEmojiImprecise=Ke;function $(O,K){if(O.length<K)return O;const ae=/\b/g;let ke=0;for(;ae.test(O)&&!(O.length-ae.lastIndex<K);)ke=ae.lastIndex,ae.lastIndex+=1;return O.substring(ke).replace(/^\s/,"")}e.lcut=$;const Q=/\x1B\x5B[12]?K/g,te=/\x1b\[\d+m/g,re=/\x1b\[0?m/g;function G(O){return O&&(O=O.replace(Q,""),O=O.replace(te,""),O=O.replace(re,"")),O}e.removeAnsiEscapeCodes=G,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function se(O){return!!(O&&O.length>0&&O.charCodeAt(0)===65279)}e.startsWithUTF8BOM=se;function he(O){return se(O)?O.substr(1):O}e.stripUTF8BOM=he;function Ae(O,K){if(!O||!K||O.length<K.length)return!1;const ae=K.length,ke=O.toLowerCase();let Pe=0,Oe=-1;for(;Pe<ae;){const $e=ke.indexOf(K[Pe],Oe+1);if($e<0)return!1;Oe=$e,Pe++}return!0}e.fuzzyContains=Ae;function xe(O,K=!1){return O?(K&&(O=O.replace(/\\./g,"")),O.toLowerCase()!==O):!1}e.containsUppercaseCharacter=xe;function ve(O){return O.charAt(0).toUpperCase()+O.slice(1)}e.uppercaseFirstLetter=ve;function je(O,K=1){if(K===0)return"";let ae=-1;do ae=O.indexOf(`
`,ae+1),K--;while(K>0&&ae>=0);return ae===-1?O:(O[ae-1]==="\r"&&ae--,O.substr(0,ae))}e.getNLines=je;function V(O){const K=90-65+1;return O=O%(2*K),O<K?String.fromCharCode(97+O):String.fromCharCode(65+O-K)}e.singleLetterHash=V;function ee(O){return Le.getInstance().getGraphemeBreakType(O)}e.getGraphemeBreakType=ee;function me(O,K){return O===0?K!==5&&K!==7:O===2&&K===3?!1:O===4||O===2||O===3||K===4||K===2||K===3?!0:!(O===8&&(K===8||K===9||K===11||K===12)||(O===11||O===9)&&(K===9||K===10)||(O===12||O===10)&&K===10||K===5||K===13||K===7||O===1||O===13&&K===14||O===6&&K===6)}e.breakBetweenGraphemeBreakType=me;var Re;(function(O){O[O.Other=0]="Other",O[O.Prepend=1]="Prepend",O[O.CR=2]="CR",O[O.LF=3]="LF",O[O.Control=4]="Control",O[O.Extend=5]="Extend",O[O.Regional_Indicator=6]="Regional_Indicator",O[O.SpacingMark=7]="SpacingMark",O[O.L=8]="L",O[O.V=9]="V",O[O.T=10]="T",O[O.LV=11]="LV",O[O.LVT=12]="LVT",O[O.ZWJ=13]="ZWJ",O[O.Extended_Pictographic=14]="Extended_Pictographic"})(Re=e.GraphemeBreakType||(e.GraphemeBreakType={}));class Le{constructor(){this._data=qe()}static getInstance(){return Le._INSTANCE||(Le._INSTANCE=new Le),Le._INSTANCE}getGraphemeBreakType(K){if(K<32)return K===10?3:K===13?2:4;if(K<127)return 0;const ae=this._data,ke=ae.length/3;let Pe=1;for(;Pe<=ke;)if(K<ae[3*Pe])Pe=2*Pe;else if(K>ae[3*Pe+1])Pe=2*Pe+1;else return ae[3*Pe+2];return 0}}Le._INSTANCE=null;function qe(){return JSON.parse("[0,0,0,51592,51592,11,44424,44424,11,72251,72254,5,7150,7150,7,48008,48008,11,55176,55176,11,128420,128420,14,3276,3277,5,9979,9980,14,46216,46216,11,49800,49800,11,53384,53384,11,70726,70726,5,122915,122916,5,129320,129327,14,2558,2558,5,5906,5908,5,9762,9763,14,43360,43388,8,45320,45320,11,47112,47112,11,48904,48904,11,50696,50696,11,52488,52488,11,54280,54280,11,70082,70083,1,71350,71350,7,73111,73111,5,127892,127893,14,128726,128727,14,129473,129474,14,2027,2035,5,2901,2902,5,3784,3789,5,6754,6754,5,8418,8420,5,9877,9877,14,11088,11088,14,44008,44008,5,44872,44872,11,45768,45768,11,46664,46664,11,47560,47560,11,48456,48456,11,49352,49352,11,50248,50248,11,51144,51144,11,52040,52040,11,52936,52936,11,53832,53832,11,54728,54728,11,69811,69814,5,70459,70460,5,71096,71099,7,71998,71998,5,72874,72880,5,119149,119149,7,127374,127374,14,128335,128335,14,128482,128482,14,128765,128767,14,129399,129400,14,129680,129685,14,1476,1477,5,2377,2380,7,2759,2760,5,3137,3140,7,3458,3459,7,4153,4154,5,6432,6434,5,6978,6978,5,7675,7679,5,9723,9726,14,9823,9823,14,9919,9923,14,10035,10036,14,42736,42737,5,43596,43596,5,44200,44200,11,44648,44648,11,45096,45096,11,45544,45544,11,45992,45992,11,46440,46440,11,46888,46888,11,47336,47336,11,47784,47784,11,48232,48232,11,48680,48680,11,49128,49128,11,49576,49576,11,50024,50024,11,50472,50472,11,50920,50920,11,51368,51368,11,51816,51816,11,52264,52264,11,52712,52712,11,53160,53160,11,53608,53608,11,54056,54056,11,54504,54504,11,54952,54952,11,68108,68111,5,69933,69940,5,70197,70197,7,70498,70499,7,70845,70845,5,71229,71229,5,71727,71735,5,72154,72155,5,72344,72345,5,73023,73029,5,94095,94098,5,121403,121452,5,126981,127182,14,127538,127546,14,127990,127990,14,128391,128391,14,128445,128449,14,128500,128505,14,128752,128752,14,129160,129167,14,129356,129356,14,129432,129442,14,129648,129651,14,129751,131069,14,173,173,4,1757,1757,1,2274,2274,1,2494,2494,5,2641,2641,5,2876,2876,5,3014,3016,7,3262,3262,7,3393,3396,5,3570,3571,7,3968,3972,5,4228,4228,7,6086,6086,5,6679,6680,5,6912,6915,5,7080,7081,5,7380,7392,5,8252,8252,14,9096,9096,14,9748,9749,14,9784,9786,14,9833,9850,14,9890,9894,14,9938,9938,14,9999,9999,14,10085,10087,14,12349,12349,14,43136,43137,7,43454,43456,7,43755,43755,7,44088,44088,11,44312,44312,11,44536,44536,11,44760,44760,11,44984,44984,11,45208,45208,11,45432,45432,11,45656,45656,11,45880,45880,11,46104,46104,11,46328,46328,11,46552,46552,11,46776,46776,11,47000,47000,11,47224,47224,11,47448,47448,11,47672,47672,11,47896,47896,11,48120,48120,11,48344,48344,11,48568,48568,11,48792,48792,11,49016,49016,11,49240,49240,11,49464,49464,11,49688,49688,11,49912,49912,11,50136,50136,11,50360,50360,11,50584,50584,11,50808,50808,11,51032,51032,11,51256,51256,11,51480,51480,11,51704,51704,11,51928,51928,11,52152,52152,11,52376,52376,11,52600,52600,11,52824,52824,11,53048,53048,11,53272,53272,11,53496,53496,11,53720,53720,11,53944,53944,11,54168,54168,11,54392,54392,11,54616,54616,11,54840,54840,11,55064,55064,11,65438,65439,5,69633,69633,5,69837,69837,1,70018,70018,7,70188,70190,7,70368,70370,7,70465,70468,7,70712,70719,5,70835,70840,5,70850,70851,5,71132,71133,5,71340,71340,7,71458,71461,5,71985,71989,7,72002,72002,7,72193,72202,5,72281,72283,5,72766,72766,7,72885,72886,5,73104,73105,5,92912,92916,5,113824,113827,4,119173,119179,5,121505,121519,5,125136,125142,5,127279,127279,14,127489,127490,14,127570,127743,14,127900,127901,14,128254,128254,14,128369,128370,14,128400,128400,14,128425,128432,14,128468,128475,14,128489,128494,14,128715,128720,14,128745,128745,14,128759,128760,14,129004,129023,14,129296,129304,14,129340,129342,14,129388,129392,14,129404,129407,14,129454,129455,14,129485,129487,14,129659,129663,14,129719,129727,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2363,2363,7,2402,2403,5,2507,2508,7,2622,2624,7,2691,2691,7,2786,2787,5,2881,2884,5,3006,3006,5,3072,3072,5,3170,3171,5,3267,3268,7,3330,3331,7,3406,3406,1,3538,3540,5,3655,3662,5,3897,3897,5,4038,4038,5,4184,4185,5,4352,4447,8,6068,6069,5,6155,6157,5,6448,6449,7,6742,6742,5,6783,6783,5,6966,6970,5,7042,7042,7,7143,7143,7,7212,7219,5,7412,7412,5,8206,8207,4,8294,8303,4,8596,8601,14,9410,9410,14,9742,9742,14,9757,9757,14,9770,9770,14,9794,9794,14,9828,9828,14,9855,9855,14,9882,9882,14,9900,9903,14,9929,9933,14,9963,9967,14,9987,9988,14,10006,10006,14,10062,10062,14,10175,10175,14,11744,11775,5,42607,42607,5,43043,43044,7,43263,43263,5,43444,43445,7,43569,43570,5,43698,43700,5,43766,43766,5,44032,44032,11,44144,44144,11,44256,44256,11,44368,44368,11,44480,44480,11,44592,44592,11,44704,44704,11,44816,44816,11,44928,44928,11,45040,45040,11,45152,45152,11,45264,45264,11,45376,45376,11,45488,45488,11,45600,45600,11,45712,45712,11,45824,45824,11,45936,45936,11,46048,46048,11,46160,46160,11,46272,46272,11,46384,46384,11,46496,46496,11,46608,46608,11,46720,46720,11,46832,46832,11,46944,46944,11,47056,47056,11,47168,47168,11,47280,47280,11,47392,47392,11,47504,47504,11,47616,47616,11,47728,47728,11,47840,47840,11,47952,47952,11,48064,48064,11,48176,48176,11,48288,48288,11,48400,48400,11,48512,48512,11,48624,48624,11,48736,48736,11,48848,48848,11,48960,48960,11,49072,49072,11,49184,49184,11,49296,49296,11,49408,49408,11,49520,49520,11,49632,49632,11,49744,49744,11,49856,49856,11,49968,49968,11,50080,50080,11,50192,50192,11,50304,50304,11,50416,50416,11,50528,50528,11,50640,50640,11,50752,50752,11,50864,50864,11,50976,50976,11,51088,51088,11,51200,51200,11,51312,51312,11,51424,51424,11,51536,51536,11,51648,51648,11,51760,51760,11,51872,51872,11,51984,51984,11,52096,52096,11,52208,52208,11,52320,52320,11,52432,52432,11,52544,52544,11,52656,52656,11,52768,52768,11,52880,52880,11,52992,52992,11,53104,53104,11,53216,53216,11,53328,53328,11,53440,53440,11,53552,53552,11,53664,53664,11,53776,53776,11,53888,53888,11,54000,54000,11,54112,54112,11,54224,54224,11,54336,54336,11,54448,54448,11,54560,54560,11,54672,54672,11,54784,54784,11,54896,54896,11,55008,55008,11,55120,55120,11,64286,64286,5,66272,66272,5,68900,68903,5,69762,69762,7,69817,69818,5,69927,69931,5,70003,70003,5,70070,70078,5,70094,70094,7,70194,70195,7,70206,70206,5,70400,70401,5,70463,70463,7,70475,70477,7,70512,70516,5,70722,70724,5,70832,70832,5,70842,70842,5,70847,70848,5,71088,71089,7,71102,71102,7,71219,71226,5,71231,71232,5,71342,71343,7,71453,71455,5,71463,71467,5,71737,71738,5,71995,71996,5,72000,72000,7,72145,72147,7,72160,72160,5,72249,72249,7,72273,72278,5,72330,72342,5,72752,72758,5,72850,72871,5,72882,72883,5,73018,73018,5,73031,73031,5,73109,73109,5,73461,73462,7,94031,94031,5,94192,94193,7,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,126976,126979,14,127184,127231,14,127344,127345,14,127405,127461,14,127514,127514,14,127561,127567,14,127778,127779,14,127896,127896,14,127985,127986,14,127995,127999,5,128326,128328,14,128360,128366,14,128378,128378,14,128394,128397,14,128405,128406,14,128422,128423,14,128435,128443,14,128453,128464,14,128479,128480,14,128484,128487,14,128496,128498,14,128640,128709,14,128723,128724,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129096,129103,14,129292,129292,14,129311,129311,14,129329,129330,14,129344,129349,14,129360,129374,14,129394,129394,14,129402,129402,14,129413,129425,14,129445,129450,14,129466,129471,14,129483,129483,14,129511,129535,14,129653,129655,14,129667,129670,14,129705,129711,14,129731,129743,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2307,2307,7,2366,2368,7,2382,2383,7,2434,2435,7,2497,2500,5,2519,2519,5,2563,2563,7,2631,2632,5,2677,2677,5,2750,2752,7,2763,2764,7,2817,2817,5,2879,2879,5,2891,2892,7,2914,2915,5,3008,3008,5,3021,3021,5,3076,3076,5,3146,3149,5,3202,3203,7,3264,3265,7,3271,3272,7,3298,3299,5,3390,3390,5,3402,3404,7,3426,3427,5,3535,3535,5,3544,3550,7,3635,3635,7,3763,3763,7,3893,3893,5,3953,3966,5,3981,3991,5,4145,4145,7,4157,4158,5,4209,4212,5,4237,4237,5,4520,4607,10,5970,5971,5,6071,6077,5,6089,6099,5,6277,6278,5,6439,6440,5,6451,6456,7,6683,6683,5,6744,6750,5,6765,6770,7,6846,6846,5,6964,6964,5,6972,6972,5,7019,7027,5,7074,7077,5,7083,7085,5,7146,7148,7,7154,7155,7,7222,7223,5,7394,7400,5,7416,7417,5,8204,8204,5,8233,8233,4,8288,8292,4,8413,8416,5,8482,8482,14,8986,8987,14,9193,9203,14,9654,9654,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9775,14,9792,9792,14,9800,9811,14,9825,9826,14,9831,9831,14,9852,9853,14,9872,9873,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9936,9936,14,9941,9960,14,9974,9974,14,9982,9985,14,9992,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10145,10145,14,11013,11015,14,11503,11505,5,12334,12335,5,12951,12951,14,42612,42621,5,43014,43014,5,43047,43047,7,43204,43205,5,43335,43345,5,43395,43395,7,43450,43451,7,43561,43566,5,43573,43574,5,43644,43644,5,43710,43711,5,43758,43759,7,44005,44005,5,44012,44012,7,44060,44060,11,44116,44116,11,44172,44172,11,44228,44228,11,44284,44284,11,44340,44340,11,44396,44396,11,44452,44452,11,44508,44508,11,44564,44564,11,44620,44620,11,44676,44676,11,44732,44732,11,44788,44788,11,44844,44844,11,44900,44900,11,44956,44956,11,45012,45012,11,45068,45068,11,45124,45124,11,45180,45180,11,45236,45236,11,45292,45292,11,45348,45348,11,45404,45404,11,45460,45460,11,45516,45516,11,45572,45572,11,45628,45628,11,45684,45684,11,45740,45740,11,45796,45796,11,45852,45852,11,45908,45908,11,45964,45964,11,46020,46020,11,46076,46076,11,46132,46132,11,46188,46188,11,46244,46244,11,46300,46300,11,46356,46356,11,46412,46412,11,46468,46468,11,46524,46524,11,46580,46580,11,46636,46636,11,46692,46692,11,46748,46748,11,46804,46804,11,46860,46860,11,46916,46916,11,46972,46972,11,47028,47028,11,47084,47084,11,47140,47140,11,47196,47196,11,47252,47252,11,47308,47308,11,47364,47364,11,47420,47420,11,47476,47476,11,47532,47532,11,47588,47588,11,47644,47644,11,47700,47700,11,47756,47756,11,47812,47812,11,47868,47868,11,47924,47924,11,47980,47980,11,48036,48036,11,48092,48092,11,48148,48148,11,48204,48204,11,48260,48260,11,48316,48316,11,48372,48372,11,48428,48428,11,48484,48484,11,48540,48540,11,48596,48596,11,48652,48652,11,48708,48708,11,48764,48764,11,48820,48820,11,48876,48876,11,48932,48932,11,48988,48988,11,49044,49044,11,49100,49100,11,49156,49156,11,49212,49212,11,49268,49268,11,49324,49324,11,49380,49380,11,49436,49436,11,49492,49492,11,49548,49548,11,49604,49604,11,49660,49660,11,49716,49716,11,49772,49772,11,49828,49828,11,49884,49884,11,49940,49940,11,49996,49996,11,50052,50052,11,50108,50108,11,50164,50164,11,50220,50220,11,50276,50276,11,50332,50332,11,50388,50388,11,50444,50444,11,50500,50500,11,50556,50556,11,50612,50612,11,50668,50668,11,50724,50724,11,50780,50780,11,50836,50836,11,50892,50892,11,50948,50948,11,51004,51004,11,51060,51060,11,51116,51116,11,51172,51172,11,51228,51228,11,51284,51284,11,51340,51340,11,51396,51396,11,51452,51452,11,51508,51508,11,51564,51564,11,51620,51620,11,51676,51676,11,51732,51732,11,51788,51788,11,51844,51844,11,51900,51900,11,51956,51956,11,52012,52012,11,52068,52068,11,52124,52124,11,52180,52180,11,52236,52236,11,52292,52292,11,52348,52348,11,52404,52404,11,52460,52460,11,52516,52516,11,52572,52572,11,52628,52628,11,52684,52684,11,52740,52740,11,52796,52796,11,52852,52852,11,52908,52908,11,52964,52964,11,53020,53020,11,53076,53076,11,53132,53132,11,53188,53188,11,53244,53244,11,53300,53300,11,53356,53356,11,53412,53412,11,53468,53468,11,53524,53524,11,53580,53580,11,53636,53636,11,53692,53692,11,53748,53748,11,53804,53804,11,53860,53860,11,53916,53916,11,53972,53972,11,54028,54028,11,54084,54084,11,54140,54140,11,54196,54196,11,54252,54252,11,54308,54308,11,54364,54364,11,54420,54420,11,54476,54476,11,54532,54532,11,54588,54588,11,54644,54644,11,54700,54700,11,54756,54756,11,54812,54812,11,54868,54868,11,54924,54924,11,54980,54980,11,55036,55036,11,55092,55092,11,55148,55148,11,55216,55238,9,65056,65071,5,65529,65531,4,68097,68099,5,68159,68159,5,69446,69456,5,69688,69702,5,69808,69810,7,69815,69816,7,69821,69821,1,69888,69890,5,69932,69932,7,69957,69958,7,70016,70017,5,70067,70069,7,70079,70080,7,70089,70092,5,70095,70095,5,70191,70193,5,70196,70196,5,70198,70199,5,70367,70367,5,70371,70378,5,70402,70403,7,70462,70462,5,70464,70464,5,70471,70472,7,70487,70487,5,70502,70508,5,70709,70711,7,70720,70721,7,70725,70725,7,70750,70750,5,70833,70834,7,70841,70841,7,70843,70844,7,70846,70846,7,70849,70849,7,71087,71087,5,71090,71093,5,71100,71101,5,71103,71104,5,71216,71218,7,71227,71228,7,71230,71230,7,71339,71339,5,71341,71341,5,71344,71349,5,71351,71351,5,71456,71457,7,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123628,123631,5,125252,125258,5,126980,126980,14,127183,127183,14,127245,127247,14,127340,127343,14,127358,127359,14,127377,127386,14,127462,127487,6,127491,127503,14,127535,127535,14,127548,127551,14,127568,127569,14,127744,127777,14,127780,127891,14,127894,127895,14,127897,127899,14,127902,127984,14,127987,127989,14,127991,127994,14,128000,128253,14,128255,128317,14,128329,128334,14,128336,128359,14,128367,128368,14,128371,128377,14,128379,128390,14,128392,128393,14,128398,128399,14,128401,128404,14,128407,128419,14,128421,128421,14,128424,128424,14,128433,128434,14,128444,128444,14,128450,128452,14,128465,128467,14,128476,128478,14,128481,128481,14,128483,128483,14,128488,128488,14,128495,128495,14,128499,128499,14,128506,128591,14,128710,128714,14,128721,128722,14,128725,128725,14,128728,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129664,129666,14,129671,129679,14,129686,129704,14,129712,129718,14,129728,129730,14,129744,129750,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2259,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3134,3136,5,3142,3144,5,3157,3158,5,3201,3201,5,3260,3260,5,3263,3263,5,3266,3266,5,3270,3270,5,3274,3275,7,3285,3286,5,3328,3329,5,3387,3388,5,3391,3392,7,3398,3400,7,3405,3405,5,3415,3415,5,3457,3457,5,3530,3530,5,3536,3537,7,3542,3542,5,3551,3551,5,3633,3633,5,3636,3642,5,3761,3761,5,3764,3772,5,3864,3865,5,3895,3895,5,3902,3903,7,3967,3967,7,3974,3975,5,3993,4028,5,4141,4144,5,4146,4151,5,4155,4156,7,4182,4183,7,4190,4192,5,4226,4226,5,4229,4230,5,4253,4253,5,4448,4519,9,4957,4959,5,5938,5940,5,6002,6003,5,6070,6070,7,6078,6085,7,6087,6088,7,6109,6109,5,6158,6158,4,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6848,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7673,5,8203,8203,4,8205,8205,13,8232,8232,4,8234,8238,4,8265,8265,14,8293,8293,4,8400,8412,5,8417,8417,5,8421,8432,5,8505,8505,14,8617,8618,14,9000,9000,14,9167,9167,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9776,9783,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9935,14,9937,9937,14,9939,9940,14,9961,9962,14,9968,9973,14,9975,9978,14,9981,9981,14,9986,9986,14,9989,9989,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10084,14,10133,10135,14,10160,10160,14,10548,10549,14,11035,11036,14,11093,11093,14,11647,11647,5,12330,12333,5,12336,12336,14,12441,12442,5,12953,12953,14,42608,42610,5,42654,42655,5,43010,43010,5,43019,43019,5,43045,43046,5,43052,43052,5,43188,43203,7,43232,43249,5,43302,43309,5,43346,43347,7,43392,43394,5,43443,43443,5,43446,43449,5,43452,43453,5,43493,43493,5,43567,43568,7,43571,43572,7,43587,43587,5,43597,43597,7,43696,43696,5,43703,43704,5,43713,43713,5,43756,43757,5,43765,43765,7,44003,44004,7,44006,44007,7,44009,44010,7,44013,44013,5,44033,44059,12,44061,44087,12,44089,44115,12,44117,44143,12,44145,44171,12,44173,44199,12,44201,44227,12,44229,44255,12,44257,44283,12,44285,44311,12,44313,44339,12,44341,44367,12,44369,44395,12,44397,44423,12,44425,44451,12,44453,44479,12,44481,44507,12,44509,44535,12,44537,44563,12,44565,44591,12,44593,44619,12,44621,44647,12,44649,44675,12,44677,44703,12,44705,44731,12,44733,44759,12,44761,44787,12,44789,44815,12,44817,44843,12,44845,44871,12,44873,44899,12,44901,44927,12,44929,44955,12,44957,44983,12,44985,45011,12,45013,45039,12,45041,45067,12,45069,45095,12,45097,45123,12,45125,45151,12,45153,45179,12,45181,45207,12,45209,45235,12,45237,45263,12,45265,45291,12,45293,45319,12,45321,45347,12,45349,45375,12,45377,45403,12,45405,45431,12,45433,45459,12,45461,45487,12,45489,45515,12,45517,45543,12,45545,45571,12,45573,45599,12,45601,45627,12,45629,45655,12,45657,45683,12,45685,45711,12,45713,45739,12,45741,45767,12,45769,45795,12,45797,45823,12,45825,45851,12,45853,45879,12,45881,45907,12,45909,45935,12,45937,45963,12,45965,45991,12,45993,46019,12,46021,46047,12,46049,46075,12,46077,46103,12,46105,46131,12,46133,46159,12,46161,46187,12,46189,46215,12,46217,46243,12,46245,46271,12,46273,46299,12,46301,46327,12,46329,46355,12,46357,46383,12,46385,46411,12,46413,46439,12,46441,46467,12,46469,46495,12,46497,46523,12,46525,46551,12,46553,46579,12,46581,46607,12,46609,46635,12,46637,46663,12,46665,46691,12,46693,46719,12,46721,46747,12,46749,46775,12,46777,46803,12,46805,46831,12,46833,46859,12,46861,46887,12,46889,46915,12,46917,46943,12,46945,46971,12,46973,46999,12,47001,47027,12,47029,47055,12,47057,47083,12,47085,47111,12,47113,47139,12,47141,47167,12,47169,47195,12,47197,47223,12,47225,47251,12,47253,47279,12,47281,47307,12,47309,47335,12,47337,47363,12,47365,47391,12,47393,47419,12,47421,47447,12,47449,47475,12,47477,47503,12,47505,47531,12,47533,47559,12,47561,47587,12,47589,47615,12,47617,47643,12,47645,47671,12,47673,47699,12,47701,47727,12,47729,47755,12,47757,47783,12,47785,47811,12,47813,47839,12,47841,47867,12,47869,47895,12,47897,47923,12,47925,47951,12,47953,47979,12,47981,48007,12,48009,48035,12,48037,48063,12,48065,48091,12,48093,48119,12,48121,48147,12,48149,48175,12,48177,48203,12,48205,48231,12,48233,48259,12,48261,48287,12,48289,48315,12,48317,48343,12,48345,48371,12,48373,48399,12,48401,48427,12,48429,48455,12,48457,48483,12,48485,48511,12,48513,48539,12,48541,48567,12,48569,48595,12,48597,48623,12,48625,48651,12,48653,48679,12,48681,48707,12,48709,48735,12,48737,48763,12,48765,48791,12,48793,48819,12,48821,48847,12,48849,48875,12,48877,48903,12,48905,48931,12,48933,48959,12,48961,48987,12,48989,49015,12,49017,49043,12,49045,49071,12,49073,49099,12,49101,49127,12,49129,49155,12,49157,49183,12,49185,49211,12,49213,49239,12,49241,49267,12,49269,49295,12,49297,49323,12,49325,49351,12,49353,49379,12,49381,49407,12,49409,49435,12,49437,49463,12,49465,49491,12,49493,49519,12,49521,49547,12,49549,49575,12,49577,49603,12,49605,49631,12,49633,49659,12,49661,49687,12,49689,49715,12,49717,49743,12,49745,49771,12,49773,49799,12,49801,49827,12,49829,49855,12,49857,49883,12,49885,49911,12,49913,49939,12,49941,49967,12,49969,49995,12,49997,50023,12,50025,50051,12,50053,50079,12,50081,50107,12,50109,50135,12,50137,50163,12,50165,50191,12,50193,50219,12,50221,50247,12,50249,50275,12,50277,50303,12,50305,50331,12,50333,50359,12,50361,50387,12,50389,50415,12,50417,50443,12,50445,50471,12,50473,50499,12,50501,50527,12,50529,50555,12,50557,50583,12,50585,50611,12,50613,50639,12,50641,50667,12,50669,50695,12,50697,50723,12,50725,50751,12,50753,50779,12,50781,50807,12,50809,50835,12,50837,50863,12,50865,50891,12,50893,50919,12,50921,50947,12,50949,50975,12,50977,51003,12,51005,51031,12,51033,51059,12,51061,51087,12,51089,51115,12,51117,51143,12,51145,51171,12,51173,51199,12,51201,51227,12,51229,51255,12,51257,51283,12,51285,51311,12,51313,51339,12,51341,51367,12,51369,51395,12,51397,51423,12,51425,51451,12,51453,51479,12,51481,51507,12,51509,51535,12,51537,51563,12,51565,51591,12,51593,51619,12,51621,51647,12,51649,51675,12,51677,51703,12,51705,51731,12,51733,51759,12,51761,51787,12,51789,51815,12,51817,51843,12,51845,51871,12,51873,51899,12,51901,51927,12,51929,51955,12,51957,51983,12,51985,52011,12,52013,52039,12,52041,52067,12,52069,52095,12,52097,52123,12,52125,52151,12,52153,52179,12,52181,52207,12,52209,52235,12,52237,52263,12,52265,52291,12,52293,52319,12,52321,52347,12,52349,52375,12,52377,52403,12,52405,52431,12,52433,52459,12,52461,52487,12,52489,52515,12,52517,52543,12,52545,52571,12,52573,52599,12,52601,52627,12,52629,52655,12,52657,52683,12,52685,52711,12,52713,52739,12,52741,52767,12,52769,52795,12,52797,52823,12,52825,52851,12,52853,52879,12,52881,52907,12,52909,52935,12,52937,52963,12,52965,52991,12,52993,53019,12,53021,53047,12,53049,53075,12,53077,53103,12,53105,53131,12,53133,53159,12,53161,53187,12,53189,53215,12,53217,53243,12,53245,53271,12,53273,53299,12,53301,53327,12,53329,53355,12,53357,53383,12,53385,53411,12,53413,53439,12,53441,53467,12,53469,53495,12,53497,53523,12,53525,53551,12,53553,53579,12,53581,53607,12,53609,53635,12,53637,53663,12,53665,53691,12,53693,53719,12,53721,53747,12,53749,53775,12,53777,53803,12,53805,53831,12,53833,53859,12,53861,53887,12,53889,53915,12,53917,53943,12,53945,53971,12,53973,53999,12,54001,54027,12,54029,54055,12,54057,54083,12,54085,54111,12,54113,54139,12,54141,54167,12,54169,54195,12,54197,54223,12,54225,54251,12,54253,54279,12,54281,54307,12,54309,54335,12,54337,54363,12,54365,54391,12,54393,54419,12,54421,54447,12,54449,54475,12,54477,54503,12,54505,54531,12,54533,54559,12,54561,54587,12,54589,54615,12,54617,54643,12,54645,54671,12,54673,54699,12,54701,54727,12,54729,54755,12,54757,54783,12,54785,54811,12,54813,54839,12,54841,54867,12,54869,54895,12,54897,54923,12,54925,54951,12,54953,54979,12,54981,55007,12,55009,55035,12,55037,55063,12,55065,55091,12,55093,55119,12,55121,55147,12,55149,55175,12,55177,55203,12,55243,55291,10,65024,65039,5,65279,65279,4,65520,65528,4,66045,66045,5,66422,66426,5,68101,68102,5,68152,68154,5,68325,68326,5,69291,69292,5,69632,69632,7,69634,69634,7,69759,69761,5]")}function Se(O,K){if(O===0)return 0;const ae=we(O,K);if(ae!==void 0)return ae;const ke=H(K,O);return O-=Ce(ke),O}e.getLeftDeleteOffset=Se;function we(O,K){let ae=H(K,O);for(O-=Ce(ae);ie(ae)||ae===65039||ae===8419;){if(O===0)return;ae=H(K,O),O-=Ce(ae)}if(!!Ke(ae)){if(O>=0){const ke=H(K,O);ke===8205&&(O-=Ce(ke))}return O}}function Ce(O){return O>=65536?2:1}function ie(O){return 127995<=O&&O<=127999}var ce;(function(O){O[O.zwj=8205]="zwj",O[O.emojiVariantSelector=65039]="emojiVariantSelector",O[O.enclosingKeyCap=8419]="enclosingKeyCap"})(ce||(ce={}))}),define(_e[23],Ee([0,1,8,109]),function(Z,e,m,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const S=typeof Buffer!="undefined",y=typeof TextEncoder!="undefined",k=typeof TextDecoder!="undefined";let D,_;class C{constructor(v){this.buffer=v,this.byteLength=this.buffer.byteLength}static alloc(v){return S?new C(Buffer.allocUnsafe(v)):new C(new Uint8Array(v))}static wrap(v){return S&&!Buffer.isBuffer(v)&&(v=Buffer.from(v.buffer,v.byteOffset,v.byteLength)),new C(v)}static fromString(v,A){return!((A==null?void 0:A.dontUseNodeBuffer)||!1)&&S?new C(Buffer.from(v)):y?(D||(D=new TextEncoder),new C(D.encode(v))):new C(m.encodeUTF8(v))}static concat(v,A){if(typeof A=="undefined"){A=0;for(let F=0,N=v.length;F<N;F++)A+=v[F].byteLength}const P=C.alloc(A);let a=0;for(let F=0,N=v.length;F<N;F++){const W=v[F];P.set(W,a),a+=W.byteLength}return P}toString(){return S?this.buffer.toString():k?(_||(_=new TextDecoder),_.decode(this.buffer)):m.decodeUTF8(this.buffer)}slice(v,A){return new C(this.buffer.subarray(v,A))}set(v,A){v instanceof C?this.buffer.set(v.buffer,A):this.buffer.set(v,A)}readUInt32BE(v){return o(this.buffer,v)}writeUInt32BE(v,A){h(this.buffer,v,A)}readUInt32LE(v){return d(this.buffer,v)}writeUInt32LE(v,A){c(this.buffer,v,A)}readUInt8(v){return b(this.buffer,v)}writeUInt8(v,A){p(this.buffer,v,A)}}e.VSBuffer=C;function n(E,v){return E[v+0]<<0>>>0|E[v+1]<<8>>>0}e.readUInt16LE=n;function I(E,v,A){E[A+0]=v&255,v=v>>>8,E[A+1]=v&255}e.writeUInt16LE=I;function o(E,v){return E[v]*2**24+E[v+1]*2**16+E[v+2]*2**8+E[v+3]}e.readUInt32BE=o;function h(E,v,A){E[A+3]=v,v=v>>>8,E[A+2]=v,v=v>>>8,E[A+1]=v,v=v>>>8,E[A]=v}e.writeUInt32BE=h;function d(E,v){return E[v+0]<<0>>>0|E[v+1]<<8>>>0|E[v+2]<<16>>>0|E[v+3]<<24>>>0}e.readUInt32LE=d;function c(E,v,A){E[A+0]=v&255,v=v>>>8,E[A+1]=v&255,v=v>>>8,E[A+2]=v&255,v=v>>>8,E[A+3]=v&255}e.writeUInt32LE=c;function b(E,v){return E[v]}e.readUInt8=b;function p(E,v,A){E[A]=v}e.writeUInt8=p;function w(E){return T.consumeReadable(E,v=>C.concat(v))}e.readableToBuffer=w;function u(E){return T.toReadable(E)}e.bufferToReadable=u;function f(E){return T.consumeStream(E,v=>C.concat(v))}e.streamToBuffer=f;async function g(E){return E.ended?C.concat(E.buffer):C.concat([...E.buffer,await f(E.stream)])}e.bufferedStreamToBuffer=g;function t(E){return T.toStream(E,v=>C.concat(v))}e.bufferToStream=t;function i(E){return T.transform(E,{data:v=>typeof v=="string"?C.fromString(v):C.wrap(v)},v=>C.concat(v))}e.streamToBufferReadableStream=i;function s(E){return T.newWriteableStream(v=>C.concat(v),E)}e.newWriteableBufferStream=s;function r(E,v){return T.prefixedReadable(E,v,A=>C.concat(A))}e.prefixedBufferReadable=r;function l(E,v){return T.prefixedStream(E,v,A=>C.concat(A))}e.prefixedBufferStream=l}),define(_e[53],Ee([0,1,8]),function(Z,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.doHash=e.hash=void 0;function T(p){return S(p,0)}e.hash=T;function S(p,w){switch(typeof p){case"object":return p===null?y(349,w):Array.isArray(p)?_(p,w):C(p,w);case"string":return D(p,w);case"boolean":return k(p,w);case"number":return y(p,w);case"undefined":return y(937,w);default:return y(617,w)}}e.doHash=S;function y(p,w){return(w<<5)-w+p|0}function k(p,w){return y(p?433:863,w)}function D(p,w){w=y(149417,w);for(let u=0,f=p.length;u<f;u++)w=y(p.charCodeAt(u),w);return w}e.stringHash=D;function _(p,w){return w=y(104579,w),p.reduce((u,f)=>S(f,u),w)}function C(p,w){return w=y(181387,w),Object.keys(p).sort().reduce((u,f)=>(u=D(f,u),S(p[f],u)),w)}class n{constructor(){this._value=0}get value(){return this._value}hash(w){return this._value=S(w,this._value),this._value}}e.Hasher=n;var I;(function(p){p[p.BLOCK_SIZE=64]="BLOCK_SIZE",p[p.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(I||(I={}));function o(p,w,u=32){const f=u-w,g=~((1<<f)-1);return(p<<w|(g&p)>>>f)>>>0}function h(p,w=0,u=p.byteLength,f=0){for(let g=0;g<u;g++)p[w+g]=f}function d(p,w,u="0"){for(;p.length<w;)p=u+p;return p}function c(p,w=32){return p instanceof ArrayBuffer?Array.from(new Uint8Array(p)).map(u=>u.toString(16).padStart(2,"0")).join(""):d((p>>>0).toString(16),w/4)}e.toHexString=c;class b{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(w){const u=w.length;if(u===0)return;const f=this._buff;let g=this._buffLen,t=this._leftoverHighSurrogate,i,s;for(t!==0?(i=t,s=-1,t=0):(i=w.charCodeAt(0),s=0);;){let r=i;if(m.isHighSurrogate(i))if(s+1<u){const l=w.charCodeAt(s+1);m.isLowSurrogate(l)?(s++,r=m.computeCodePoint(i,l)):r=65533}else{t=i;break}else m.isLowSurrogate(i)&&(r=65533);if(g=this._push(f,g,r),s++,s<u)i=w.charCodeAt(s);else break}this._buffLen=g,this._leftoverHighSurrogate=t}_push(w,u,f){return f<128?w[u++]=f:f<2048?(w[u++]=192|(f&1984)>>>6,w[u++]=128|(f&63)>>>0):f<65536?(w[u++]=224|(f&61440)>>>12,w[u++]=128|(f&4032)>>>6,w[u++]=128|(f&63)>>>0):(w[u++]=240|(f&1835008)>>>18,w[u++]=128|(f&258048)>>>12,w[u++]=128|(f&4032)>>>6,w[u++]=128|(f&63)>>>0),u>=64&&(this._step(),u-=64,this._totalLen+=64,w[0]=w[64+0],w[1]=w[64+1],w[2]=w[64+2]),u}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),c(this._h0)+c(this._h1)+c(this._h2)+c(this._h3)+c(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,h(this._buff,this._buffLen),this._buffLen>56&&(this._step(),h(this._buff));const w=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(w/4294967296),!1),this._buffDV.setUint32(60,w%4294967296,!1),this._step()}_step(){const w=b._bigBlock32,u=this._buffDV;for(let v=0;v<64;v+=4)w.setUint32(v,u.getUint32(v,!1),!1);for(let v=64;v<320;v+=4)w.setUint32(v,o(w.getUint32(v-12,!1)^w.getUint32(v-32,!1)^w.getUint32(v-56,!1)^w.getUint32(v-64,!1),1),!1);let f=this._h0,g=this._h1,t=this._h2,i=this._h3,s=this._h4,r,l,E;for(let v=0;v<80;v++)v<20?(r=g&t|~g&i,l=1518500249):v<40?(r=g^t^i,l=1859775393):v<60?(r=g&t|g&i|t&i,l=2400959708):(r=g^t^i,l=3395469782),E=o(f,5)+r+s+l+w.getUint32(v*4,!1)&4294967295,s=i,i=t,t=o(g,30),g=f,f=E;this._h0=this._h0+f&4294967295,this._h1=this._h1+g&4294967295,this._h2=this._h2+t&4294967295,this._h3=this._h3+i&4294967295,this._h4=this._h4+s&4294967295}}e.StringSHA1=b,b._bigBlock32=new DataView(new ArrayBuffer(320))}),define(_e[41],Ee([0,1,8]),function(Z,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var T;(function(S){S[S.Ignore=0]="Ignore",S[S.Info=1]="Info",S[S.Warning=2]="Warning",S[S.Error=3]="Error"})(T||(T={})),function(S){const y="error",k="warning",D="warn",_="info",C="ignore";function n(o){return o?m.equalsIgnoreCase(y,o)?S.Error:m.equalsIgnoreCase(k,o)||m.equalsIgnoreCase(D,o)?S.Warning:m.equalsIgnoreCase(_,o)?S.Info:S.Ignore:S.Ignore}S.fromValue=n;function I(o){switch(o){case S.Error:return y;case S.Warning:return k;case S.Info:return _;default:return C}}S.toString=I}(T||(T={})),e.default=T}),define(_e[10],Ee([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.assertNever=e.NotImplementedProxy=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function m(v){return Array.isArray(v)}e.isArray=m;function T(v){return typeof v=="string"}e.isString=T;function S(v){return Array.isArray(v)&&v.every(A=>T(A))}e.isStringArray=S;function y(v){return typeof v=="object"&&v!==null&&!Array.isArray(v)&&!(v instanceof RegExp)&&!(v instanceof Date)}e.isObject=y;function k(v){return typeof v=="number"&&!isNaN(v)}e.isNumber=k;function D(v){return!!v&&typeof v[Symbol.iterator]=="function"}e.isIterable=D;function _(v){return v===!0||v===!1}e.isBoolean=_;function C(v){return typeof v=="undefined"}e.isUndefined=C;function n(v){return!I(v)}e.isDefined=n;function I(v){return C(v)||v===null}e.isUndefinedOrNull=I;function o(v,A){if(!v)throw new Error(A?`Unexpected type, expected '${A}'`:"Unexpected type")}e.assertType=o;function h(v){if(I(v))throw new Error("Assertion Failed: argument is undefined or null");return v}e.assertIsDefined=h;function d(...v){const A=[];for(let P=0;P<v.length;P++){const a=v[P];if(I(a))throw new Error(`Assertion Failed: argument at index ${P} is undefined or null`);A.push(a)}return A}e.assertAllDefined=d;const c=Object.prototype.hasOwnProperty;function b(v){if(!y(v))return!1;for(let A in v)if(c.call(v,A))return!1;return!0}e.isEmptyObject=b;function p(v){return typeof v=="function"}e.isFunction=p;function w(...v){return v.length>0&&v.every(p)}e.areFunctions=w;function u(v,A){const P=Math.min(v.length,A.length);for(let a=0;a<P;a++)f(v[a],A[a])}e.validateConstraints=u;function f(v,A){if(T(A)){if(typeof v!==A)throw new Error(`argument does not match constraint: typeof ${A}`)}else if(p(A)){try{if(v instanceof A)return}catch(P){}if(!I(v)&&v.constructor===A||A.length===1&&A.call(void 0,v)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=f;function g(v){let A=[],P=Object.getPrototypeOf(v);for(;Object.prototype!==P;)A=A.concat(Object.getOwnPropertyNames(P)),P=Object.getPrototypeOf(P);return A}e.getAllPropertyNames=g;function t(v){const A=[];for(const P of g(v))typeof v[P]=="function"&&A.push(P);return A}e.getAllMethodNames=t;function i(v,A){const P=F=>function(){const N=Array.prototype.slice.call(arguments,0);return A(F,N)};let a={};for(const F of v)a[F]=P(F);return a}e.createProxyObject=i;function s(v){return v===null?void 0:v}e.withNullAsUndefined=s;function r(v){return typeof v=="undefined"?null:v}e.withUndefinedAsNull=r;function l(v){return class{constructor(){return new Proxy({},{get(A,P){if(A[P])return A[P];throw new Error(`Not Implemented: ${v}->${String(P)}`)}})}}}e.NotImplementedProxy=l;function E(v){throw new Error("Unreachable")}e.assertNever=E}),define(_e[42],Ee([0,1,21,8,14,10]),function(Z,e,m,T,S,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function k(s){return s===47||s===92}e.isPathSeparator=k;function D(s){return s.replace(/[\\/]/g,S.posix.sep)}e.toSlashes=D;function _(s){return s.indexOf("/")===-1&&(s=D(s)),/^[a-zA-Z]:(\/|$)/.test(s)&&(s="/"+s),s}e.toPosixPath=_;function C(s,r=S.posix.sep){if(!s)return"";const l=s.length,E=s.charCodeAt(0);if(k(E)){if(k(s.charCodeAt(1))&&!k(s.charCodeAt(2))){let A=3;const P=A;for(;A<l&&!k(s.charCodeAt(A));A++);if(P!==A&&!k(s.charCodeAt(A+1))){for(A+=1;A<l;A++)if(k(s.charCodeAt(A)))return s.slice(0,A+1).replace(/[\\/]/g,r)}}return r}else if(p(E)&&s.charCodeAt(1)===58)return k(s.charCodeAt(2))?s.slice(0,2)+r:s.slice(0,2);let v=s.indexOf("://");if(v!==-1){for(v+=3;v<l;v++)if(k(s.charCodeAt(v)))return s.slice(0,v+1)}return""}e.getRoot=C;function n(s){if(!m.isWindows||!s||s.length<5)return!1;let r=s.charCodeAt(0);if(r!==92||(r=s.charCodeAt(1),r!==92))return!1;let l=2;const E=l;for(;l<s.length&&(r=s.charCodeAt(l),r!==92);l++);return!(E===l||(r=s.charCodeAt(l+1),isNaN(r)||r===92))}e.isUNC=n;const I=/[\\/:\*\?"<>\|]/g,o=/[\\/]/g,h=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function d(s,r=m.isWindows){const l=r?I:o;return!(!s||s.length===0||/^\s+$/.test(s)||(l.lastIndex=0,l.test(s))||r&&h.test(s)||s==="."||s===".."||r&&s[s.length-1]==="."||r&&s.length!==s.trim().length||s.length>255)}e.isValidBasename=d;function c(s,r,l){const E=s===r;return!l||E?E:!s||!r?!1:T.equalsIgnoreCase(s,r)}e.isEqual=c;function b(s,r,l,E=S.sep){if(s===r)return!0;if(!s||!r||r.length>s.length)return!1;if(l){if(!T.startsWithIgnoreCase(s,r))return!1;if(r.length===s.length)return!0;let A=r.length;return r.charAt(r.length-1)===E&&A--,s.charAt(A)===E}return r.charAt(r.length-1)!==E&&(r+=E),s.indexOf(r)===0}e.isEqualOrParent=b;function p(s){return s>=65&&s<=90||s>=97&&s<=122}e.isWindowsDriveLetter=p;function w(s,r){return m.isWindows&&s.endsWith(":")&&(s+=S.sep),S.isAbsolute(s)||(s=S.join(r,s)),s=S.normalize(s),m.isWindows?(s=T.rtrim(s,S.sep),s.endsWith(":")&&(s+=S.sep)):(s=T.rtrim(s,S.sep),s||(s=S.sep)),s}e.sanitizeFilePath=w;function u(s){const r=S.normalize(s);return m.isWindows?s.length>3?!1:f(r)&&(s.length===2||r.charCodeAt(2)===92):r===S.posix.sep}e.isRootOrDriveLetter=u;function f(s){return m.isWindows?p(s.charCodeAt(0))&&s.charCodeAt(1)===58:!1}e.hasDriveLetter=f;function g(s){return f(s)?s[0]:void 0}e.getDriveLetter=g;function t(s,r,l){return r.length>s.length?-1:s===r?0:(l&&(s=s.toLowerCase(),r=r.toLowerCase()),s.indexOf(r))}e.indexOfPath=t;function i(s){const r=s.split(":");let l,E,v;if(r.forEach(A=>{const P=Number(A);y.isNumber(P)?E===void 0?E=P:v===void 0&&(v=P):l=l?[l,A].join(":"):A}),!l)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:l,line:E!==void 0?E:void 0,column:v!==void 0?v:E!==void 0?1:void 0}}e.parseLineAndColumnAware=i}),define(_e[24],Ee([0,1,10]),function(Z,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function T(c){if(!c||typeof c!="object"||c instanceof RegExp)return c;const b=Array.isArray(c)?[]:{};return Object.keys(c).forEach(p=>{c[p]&&typeof c[p]=="object"?b[p]=T(c[p]):b[p]=c[p]}),b}e.deepClone=T;function S(c){if(!c||typeof c!="object")return c;const b=[c];for(;b.length>0;){const p=b.shift();Object.freeze(p);for(const w in p)if(y.call(p,w)){const u=p[w];typeof u=="object"&&!Object.isFrozen(u)&&b.push(u)}}return c}e.deepFreeze=S;const y=Object.prototype.hasOwnProperty;function k(c,b){return D(c,b,new Set)}e.cloneAndChange=k;function D(c,b,p){if(m.isUndefinedOrNull(c))return c;const w=b(c);if(typeof w!="undefined")return w;if(m.isArray(c)){const u=[];for(const f of c)u.push(D(f,b,p));return u}if(m.isObject(c)){if(p.has(c))throw new Error("Cannot clone recursive data-structure");p.add(c);const u={};for(let f in c)y.call(c,f)&&(u[f]=D(c[f],b,p));return p.delete(c),u}return c}function _(c,b,p=!0){return m.isObject(c)?(m.isObject(b)&&Object.keys(b).forEach(w=>{w in c?p&&(m.isObject(c[w])&&m.isObject(b[w])?_(c[w],b[w],p):c[w]=b[w]):c[w]=b[w]}),c):b}e.mixin=_;function C(c,b){if(c===b)return!0;if(c==null||b===null||b===void 0||typeof c!=typeof b||typeof c!="object"||Array.isArray(c)!==Array.isArray(b))return!1;let p,w;if(Array.isArray(c)){if(c.length!==b.length)return!1;for(p=0;p<c.length;p++)if(!C(c[p],b[p]))return!1}else{const u=[];for(w in c)u.push(w);u.sort();const f=[];for(w in b)f.push(w);if(f.sort(),!C(u,f))return!1;for(p=0;p<u.length;p++)if(!C(c[u[p]],b[u[p]]))return!1}return!0}e.equals=C;function n(c){const b=new Set;return JSON.stringify(c,(p,w)=>{if(m.isObject(w)||Array.isArray(w)){if(b.has(w))return"[Circular]";b.add(w)}return w})}e.safeStringify=n;function I(c,b,p){const w=b(c);return typeof w=="undefined"?p:w}e.getOrDefault=I;function o(c,b){const p=Object.create(null);return!c||!b||Object.keys(b).forEach(u=>{const f=c[u],g=b[u];C(f,g)||(p[u]=g)}),p}e.distinct=o;function h(c,b){const p=b.toLowerCase(),w=Object.keys(c).find(u=>u.toLowerCase()===p);return w?c[w]:c[b]}e.getCaseInsensitive=h;function d(c,b){const p=Object.create(null);for(const w of Object.keys(c))b(w,c[w])&&(p[w]=c[w]);return p}e.filter=d}),define(_e[79],Ee([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toUint32=e.toUint8=e.Constants=void 0;var m;(function(y){y[y.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",y[y.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",y[y.MAX_UINT_8=255]="MAX_UINT_8",y[y.MAX_UINT_16=65535]="MAX_UINT_16",y[y.MAX_UINT_32=4294967295]="MAX_UINT_32",y[y.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(m=e.Constants||(e.Constants={}));function T(y){return y<0?0:y>255?255:y|0}e.toUint8=T;function S(y){return y<0?0:y>4294967295?4294967295:y|0}e.toUint32=S}),define(_e[2],Ee([0,1,21,14]),function(Z,e,m,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const S=/^\w[\w\d+.-]*$/,y=/^\//,k=/^\/\//;function D(s,r){if(!s.scheme&&r)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${s.authority}", path: "${s.path}", query: "${s.query}", fragment: "${s.fragment}"}`);if(s.scheme&&!S.test(s.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(s.path){if(s.authority){if(!y.test(s.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(k.test(s.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function _(s,r){return!s&&!r?"file":s}function C(s,r){switch(s){case"https":case"http":case"file":r?r[0]!==I&&(r=I+r):r=I;break}return r}const n="",I="/",o=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class h{constructor(r,l,E,v,A,P=!1){typeof r=="object"?(this.scheme=r.scheme||n,this.authority=r.authority||n,this.path=r.path||n,this.query=r.query||n,this.fragment=r.fragment||n):(this.scheme=_(r,P),this.authority=l||n,this.path=C(this.scheme,E||n),this.query=v||n,this.fragment=A||n,D(this,P))}static isUri(r){return r instanceof h?!0:r?typeof r.authority=="string"&&typeof r.fragment=="string"&&typeof r.path=="string"&&typeof r.query=="string"&&typeof r.scheme=="string"&&typeof r.fsPath=="string"&&typeof r.with=="function"&&typeof r.toString=="function":!1}get fsPath(){return u(this,!1)}with(r){if(!r)return this;let{scheme:l,authority:E,path:v,query:A,fragment:P}=r;return l===void 0?l=this.scheme:l===null&&(l=n),E===void 0?E=this.authority:E===null&&(E=n),v===void 0?v=this.path:v===null&&(v=n),A===void 0?A=this.query:A===null&&(A=n),P===void 0?P=this.fragment:P===null&&(P=n),l===this.scheme&&E===this.authority&&v===this.path&&A===this.query&&P===this.fragment?this:new c(l,E,v,A,P)}static parse(r,l=!1){const E=o.exec(r);return E?new c(E[2]||n,i(E[4]||n),i(E[5]||n),i(E[7]||n),i(E[9]||n),l):new c(n,n,n,n,n)}static file(r){let l=n;if(m.isWindows&&(r=r.replace(/\\/g,I)),r[0]===I&&r[1]===I){const E=r.indexOf(I,2);E===-1?(l=r.substring(2),r=I):(l=r.substring(2,E),r=r.substring(E)||I)}return new c("file",l,r,n,n)}static from(r){const l=new c(r.scheme,r.authority,r.path,r.query,r.fragment);return D(l,!0),l}static joinPath(r,...l){if(!r.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let E;return m.isWindows&&r.scheme==="file"?E=h.file(T.win32.join(u(r,!0),...l)).path:E=T.posix.join(r.path,...l),r.with({path:E})}toString(r=!1){return f(this,r)}toJSON(){return this}static revive(r){if(r){if(r instanceof h)return r;{const l=new c(r);return l._formatted=r.external,l._fsPath=r._sep===d?r.fsPath:null,l}}else return r}}e.URI=h;const d=m.isWindows?1:void 0;class c extends h{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=u(this,!1)),this._fsPath}toString(r=!1){return r?f(this,!0):(this._formatted||(this._formatted=f(this,!1)),this._formatted)}toJSON(){const r={$mid:1};return this._fsPath&&(r.fsPath=this._fsPath,r._sep=d),this._formatted&&(r.external=this._formatted),this.path&&(r.path=this.path),this.scheme&&(r.scheme=this.scheme),this.authority&&(r.authority=this.authority),this.query&&(r.query=this.query),this.fragment&&(r.fragment=this.fragment),r}}const b={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function p(s,r){let l,E=-1;for(let v=0;v<s.length;v++){const A=s.charCodeAt(v);if(A>=97&&A<=122||A>=65&&A<=90||A>=48&&A<=57||A===45||A===46||A===95||A===126||r&&A===47)E!==-1&&(l+=encodeURIComponent(s.substring(E,v)),E=-1),l!==void 0&&(l+=s.charAt(v));else{l===void 0&&(l=s.substr(0,v));const P=b[A];P!==void 0?(E!==-1&&(l+=encodeURIComponent(s.substring(E,v)),E=-1),l+=P):E===-1&&(E=v)}}return E!==-1&&(l+=encodeURIComponent(s.substring(E))),l!==void 0?l:s}function w(s){let r;for(let l=0;l<s.length;l++){const E=s.charCodeAt(l);E===35||E===63?(r===void 0&&(r=s.substr(0,l)),r+=b[E]):r!==void 0&&(r+=s[l])}return r!==void 0?r:s}function u(s,r){let l;return s.authority&&s.path.length>1&&s.scheme==="file"?l=`//${s.authority}${s.path}`:s.path.charCodeAt(0)===47&&(s.path.charCodeAt(1)>=65&&s.path.charCodeAt(1)<=90||s.path.charCodeAt(1)>=97&&s.path.charCodeAt(1)<=122)&&s.path.charCodeAt(2)===58?r?l=s.path.substr(1):l=s.path[1].toLowerCase()+s.path.substr(2):l=s.path,m.isWindows&&(l=l.replace(/\//g,"\\")),l}e.uriToFsPath=u;function f(s,r){const l=r?w:p;let E="",{scheme:v,authority:A,path:P,query:a,fragment:F}=s;if(v&&(E+=v,E+=":"),(A||v==="file")&&(E+=I,E+=I),A){let N=A.indexOf("@");if(N!==-1){const W=A.substr(0,N);A=A.substr(N+1),N=W.indexOf(":"),N===-1?E+=l(W,!1):(E+=l(W.substr(0,N),!1),E+=":",E+=l(W.substr(N+1),!1)),E+="@"}A=A.toLowerCase(),N=A.indexOf(":"),N===-1?E+=l(A,!1):(E+=l(A.substr(0,N),!1),E+=A.substr(N))}if(P){if(P.length>=3&&P.charCodeAt(0)===47&&P.charCodeAt(2)===58){const N=P.charCodeAt(1);N>=65&&N<=90&&(P=`/${String.fromCharCode(N+32)}:${P.substr(3)}`)}else if(P.length>=2&&P.charCodeAt(1)===58){const N=P.charCodeAt(0);N>=65&&N<=90&&(P=`${String.fromCharCode(N+32)}:${P.substr(2)}`)}E+=l(P,!0)}return a&&(E+="?",E+=l(a,!1)),F&&(E+="#",E+=r?F:p(F,!1)),E}function g(s){try{return decodeURIComponent(s)}catch(r){return s.length>3?s.substr(0,3)+g(s.substr(3)):s}}const t=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function i(s){return s.match(t)?s.replace(t,r=>g(r)):s}});var it=this&&this.__classPrivateFieldSet||function(Z,e,m,T,S){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!S:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?S.call(Z,m):S?S.value=m:e.set(Z,m),m},Ue=this&&this.__classPrivateFieldGet||function(Z,e,m,T){if(m==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!T:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?T:m==="a"?T.call(Z):T?T.value:e.get(Z)};define(_e[22],Ee([0,1,2,8]),function(Z,e,m,T){"use strict";var S,y,k;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function D(t,i,s){let r=t.get(i);return r===void 0&&(r=s,t.set(i,r)),r}e.getOrSet=D;function _(t){const i=[];return t.forEach((s,r)=>{i.push(`${r} => ${s}`)}),`Map(${t.size}) {${i.join(", ")}}`}e.mapToString=_;function C(t){const i=[];return t.forEach(s=>{i.push(s)}),`Set(${t.size}) {${i.join(", ")}}`}e.setToString=C;class n{constructor(){this._value="",this._pos=0}reset(i){return this._value=i,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(i){const s=i.charCodeAt(0),r=this._value.charCodeAt(this._pos);return s-r}value(){return this._value[this._pos]}}e.StringIterator=n;class I{constructor(i=!0){this._caseSensitive=i}reset(i){return this._value=i,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let i=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(i)this._from++;else break;else i=!1;return this}cmp(i){return this._caseSensitive?T.compareSubstring(i,this._value,0,i.length,this._from,this._to):T.compareSubstringIgnoreCase(i,this._value,0,i.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=I;class o{constructor(i=!0,s=!0){this._splitOnBackslash=i,this._caseSensitive=s}reset(i){return this._value=i.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let i=!0;for(;this._to<this._value.length;this._to++){const s=this._value.charCodeAt(this._to);if(s===47||this._splitOnBackslash&&s===92)if(i)this._from++;else break;else i=!1}return this}cmp(i){return this._caseSensitive?T.compareSubstring(i,this._value,0,i.length,this._from,this._to):T.compareSubstringIgnoreCase(i,this._value,0,i.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=o;var h;(function(t){t[t.Scheme=1]="Scheme",t[t.Authority=2]="Authority",t[t.Path=3]="Path",t[t.Query=4]="Query",t[t.Fragment=5]="Fragment"})(h||(h={}));class d{constructor(i){this._ignorePathCasing=i,this._states=[],this._stateIdx=0}reset(i){return this._value=i,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new o(!1,!this._ignorePathCasing(i)),this._pathIterator.reset(i.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(i){if(this._states[this._stateIdx]===1)return T.compareIgnoreCase(i,this._value.scheme);if(this._states[this._stateIdx]===2)return T.compareIgnoreCase(i,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(i);if(this._states[this._stateIdx]===4)return T.compare(i,this._value.query);if(this._states[this._stateIdx]===5)return T.compare(i,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=d;class c{isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}}class b{constructor(i){this._iter=i}static forUris(i=()=>!1){return new b(new d(i))}static forPaths(){return new b(new o)}static forStrings(){return new b(new n)}static forConfigKeys(){return new b(new I)}clear(){this._root=void 0}set(i,s){const r=this._iter.reset(i);let l;for(this._root||(this._root=new c,this._root.segment=r.value()),l=this._root;;){const v=r.cmp(l.segment);if(v>0)l.left||(l.left=new c,l.left.segment=r.value()),l=l.left;else if(v<0)l.right||(l.right=new c,l.right.segment=r.value()),l=l.right;else if(r.hasNext())r.next(),l.mid||(l.mid=new c,l.mid.segment=r.value()),l=l.mid;else break}const E=l.value;return l.value=s,l.key=i,E}get(i){var s;return(s=this._getNode(i))===null||s===void 0?void 0:s.value}_getNode(i){const s=this._iter.reset(i);let r=this._root;for(;r;){const l=s.cmp(r.segment);if(l>0)r=r.left;else if(l<0)r=r.right;else if(s.hasNext())s.next(),r=r.mid;else break}return r}has(i){const s=this._getNode(i);return!((s==null?void 0:s.value)===void 0&&(s==null?void 0:s.mid)===void 0)}delete(i){return this._delete(i,!1)}deleteSuperstr(i){return this._delete(i,!0)}_delete(i,s){const r=this._iter.reset(i),l=[];let E=this._root;for(;E;){const v=r.cmp(E.segment);if(v>0)l.push([1,E]),E=E.left;else if(v<0)l.push([-1,E]),E=E.right;else if(r.hasNext())r.next(),l.push([0,E]),E=E.mid;else{for(s?(E.left=void 0,E.mid=void 0,E.right=void 0):E.value=void 0;l.length>0&&E.isEmpty();){let[A,P]=l.pop();switch(A){case 1:P.left=void 0;break;case 0:P.mid=void 0;break;case-1:P.right=void 0;break}E=P}break}}}findSubstr(i){const s=this._iter.reset(i);let r=this._root,l;for(;r;){const E=s.cmp(r.segment);if(E>0)r=r.left;else if(E<0)r=r.right;else if(s.hasNext())s.next(),l=r.value||l,r=r.mid;else break}return r&&r.value||l}findSuperstr(i){const s=this._iter.reset(i);let r=this._root;for(;r;){const l=s.cmp(r.segment);if(l>0)r=r.left;else if(l<0)r=r.right;else if(s.hasNext())s.next(),r=r.mid;else return r.mid?this._entries(r.mid):void 0}}forEach(i){for(const[s,r]of this)i(r,s)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(i){if(!i)return;const s=[i];for(;s.length>0;){const r=s.pop();r&&(r.value&&(yield[r.key,r.value]),r.left&&s.push(r.left),r.mid&&s.push(r.mid),r.right&&s.push(r.right))}}}e.TernarySearchTree=b;class p{constructor(i,s){this[S]="ResourceMap",i instanceof p?(this.map=new Map(i.map),this.toKey=s??p.defaultToKey):(this.map=new Map,this.toKey=i??p.defaultToKey)}set(i,s){return this.map.set(this.toKey(i),s),this}get(i){return this.map.get(this.toKey(i))}has(i){return this.map.has(this.toKey(i))}get size(){return this.map.size}clear(){this.map.clear()}delete(i){return this.map.delete(this.toKey(i))}forEach(i,s){typeof s!="undefined"&&(i=i.bind(s));for(let[r,l]of this.map)i(l,m.URI.parse(r),this)}values(){return this.map.values()}*keys(){for(let i of this.map.keys())yield m.URI.parse(i)}*entries(){for(let i of this.map.entries())yield[m.URI.parse(i[0]),i[1]]}*[(S=Symbol.toStringTag,Symbol.iterator)](){for(let i of this.map)yield[m.URI.parse(i[0]),i[1]]}}e.ResourceMap=p,p.defaultToKey=t=>t.toString();var w;(function(t){t[t.None=0]="None",t[t.AsOld=1]="AsOld",t[t.AsNew=2]="AsNew"})(w=e.Touch||(e.Touch={}));class u{constructor(){this[y]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){var i;return(i=this._head)===null||i===void 0?void 0:i.value}get last(){var i;return(i=this._tail)===null||i===void 0?void 0:i.value}has(i){return this._map.has(i)}get(i,s=0){const r=this._map.get(i);if(!!r)return s!==0&&this.touch(r,s),r.value}set(i,s,r=0){let l=this._map.get(i);if(l)l.value=s,r!==0&&this.touch(l,r);else{switch(l={key:i,value:s,next:void 0,previous:void 0},r){case 0:this.addItemLast(l);break;case 1:this.addItemFirst(l);break;case 2:this.addItemLast(l);break;default:this.addItemLast(l);break}this._map.set(i,l),this._size++}return this}delete(i){return!!this.remove(i)}remove(i){const s=this._map.get(i);if(!!s)return this._map.delete(i),this.removeItem(s),this._size--,s.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const i=this._head;return this._map.delete(i.key),this.removeItem(i),this._size--,i.value}forEach(i,s){const r=this._state;let l=this._head;for(;l;){if(s?i.bind(s)(l.value,l.key,this):i(l.value,l.key,this),this._state!==r)throw new Error("LinkedMap got modified during iteration.");l=l.next}}keys(){const i=this,s=this._state;let r=this._head;const l={[Symbol.iterator](){return l},next(){if(i._state!==s)throw new Error("LinkedMap got modified during iteration.");if(r){const E={value:r.key,done:!1};return r=r.next,E}else return{value:void 0,done:!0}}};return l}values(){const i=this,s=this._state;let r=this._head;const l={[Symbol.iterator](){return l},next(){if(i._state!==s)throw new Error("LinkedMap got modified during iteration.");if(r){const E={value:r.value,done:!1};return r=r.next,E}else return{value:void 0,done:!0}}};return l}entries(){const i=this,s=this._state;let r=this._head;const l={[Symbol.iterator](){return l},next(){if(i._state!==s)throw new Error("LinkedMap got modified during iteration.");if(r){const E={value:[r.key,r.value],done:!1};return r=r.next,E}else return{value:void 0,done:!0}}};return l}[(y=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(i){if(i>=this.size)return;if(i===0){this.clear();return}let s=this._head,r=this.size;for(;s&&r>i;)this._map.delete(s.key),s=s.next,r--;this._head=s,this._size=r,s&&(s.previous=void 0),this._state++}addItemFirst(i){if(!this._head&&!this._tail)this._tail=i;else if(this._head)i.next=this._head,this._head.previous=i;else throw new Error("Invalid list");this._head=i,this._state++}addItemLast(i){if(!this._head&&!this._tail)this._head=i;else if(this._tail)i.previous=this._tail,this._tail.next=i;else throw new Error("Invalid list");this._tail=i,this._state++}removeItem(i){if(i===this._head&&i===this._tail)this._head=void 0,this._tail=void 0;else if(i===this._head){if(!i.next)throw new Error("Invalid list");i.next.previous=void 0,this._head=i.next}else if(i===this._tail){if(!i.previous)throw new Error("Invalid list");i.previous.next=void 0,this._tail=i.previous}else{const s=i.next,r=i.previous;if(!s||!r)throw new Error("Invalid list");s.previous=r,r.next=s}i.next=void 0,i.previous=void 0,this._state++}touch(i,s){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(s!==1&&s!==2)){if(s===1){if(i===this._head)return;const r=i.next,l=i.previous;i===this._tail?(l.next=void 0,this._tail=l):(r.previous=l,l.next=r),i.previous=void 0,i.next=this._head,this._head.previous=i,this._head=i,this._state++}else if(s===2){if(i===this._tail)return;const r=i.next,l=i.previous;i===this._head?(r.previous=void 0,this._head=r):(r.previous=l,l.next=r),i.next=void 0,i.previous=this._tail,this._tail.next=i,this._tail=i,this._state++}}}toJSON(){const i=[];return this.forEach((s,r)=>{i.push([r,s])}),i}fromJSON(i){this.clear();for(const[s,r]of i)this.set(s,r)}}e.LinkedMap=u;class f extends u{constructor(i,s=1){super();this._limit=i,this._ratio=Math.min(Math.max(0,s),1)}get limit(){return this._limit}set limit(i){this._limit=i,this.checkTrim()}get ratio(){return this._ratio}set ratio(i){this._ratio=Math.min(Math.max(0,i),1),this.checkTrim()}get(i,s=2){return super.get(i,s)}peek(i){return super.get(i,0)}set(i,s){return super.set(i,s,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=f;class g{constructor(i){k.set(this,void 0),it(this,k,i,"f")}get size(){return Ue(this,k,"f").size}forEach(i,s){Ue(this,k,"f").forEach(i,s)}get(i){return Ue(this,k,"f").get(i)}has(i){return Ue(this,k,"f").has(i)}entries(){return Ue(this,k,"f").entries()}keys(){return Ue(this,k,"f").keys()}values(){return Ue(this,k,"f").values()}[(k=new WeakMap,Symbol.iterator)](){return Ue(this,k,"f").entries()}}e.ReadonlyMapView=g}),define(_e[110],Ee([0,1,22,8]),function(Z,e,m,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function S(...G){return function(se,he){for(let Ae=0,xe=G.length;Ae<xe;Ae++){const ve=G[Ae](se,he);if(ve)return ve}return null}}e.or=S,e.matchesStrictPrefix=y.bind(void 0,!1),e.matchesPrefix=y.bind(void 0,!0);function y(G,se,he){if(!he||he.length<se.length)return null;let Ae;return G?Ae=T.startsWithIgnoreCase(he,se):Ae=he.indexOf(se)===0,Ae?se.length>0?[{start:0,end:se.length}]:[]:null}function k(G,se){const he=se.toLowerCase().indexOf(G.toLowerCase());return he===-1?null:[{start:he,end:he+G.length}]}e.matchesContiguousSubString=k;function D(G,se){return _(G.toLowerCase(),se.toLowerCase(),0,0)}e.matchesSubString=D;function _(G,se,he,Ae){if(he===G.length)return[];if(Ae===se.length)return null;if(G[he]===se[Ae]){let xe=null;return(xe=_(G,se,he+1,Ae+1))?p({start:Ae,end:Ae+1},xe):null}return _(G,se,he,Ae+1)}function C(G){return 97<=G&&G<=122}function n(G){return 65<=G&&G<=90}e.isUpper=n;function I(G){return 48<=G&&G<=57}function o(G){return G===32||G===9||G===10||G===13}const h=new Set;"`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?".split("").forEach(G=>h.add(G.charCodeAt(0)));function d(G){return o(G)||h.has(G)}function c(G,se){return G===se||d(G)&&d(se)}function b(G){return C(G)||n(G)||I(G)}function p(G,se){return se.length===0?se=[G]:G.end===se[0].start?se[0].start=G.start:se.unshift(G),se}function w(G,se){for(let he=se;he<G.length;he++){const Ae=G.charCodeAt(he);if(n(Ae)||I(Ae)||he>0&&!b(G.charCodeAt(he-1)))return he}return G.length}function u(G,se,he,Ae){if(he===G.length)return[];if(Ae===se.length)return null;if(G[he]!==se[Ae].toLowerCase())return null;{let xe=null,ve=Ae+1;for(xe=u(G,se,he+1,Ae+1);!xe&&(ve=w(se,ve))<se.length;)xe=u(G,se,he+1,ve),ve++;return xe===null?null:p({start:Ae,end:Ae+1},xe)}}function f(G){let se=0,he=0,Ae=0,xe=0,ve=0;for(let Re=0;Re<G.length;Re++)ve=G.charCodeAt(Re),n(ve)&&se++,C(ve)&&he++,b(ve)&&Ae++,I(ve)&&xe++;const je=se/G.length,V=he/G.length,ee=Ae/G.length,me=xe/G.length;return{upperPercent:je,lowerPercent:V,alphaPercent:ee,numericPercent:me}}function g(G){const{upperPercent:se,lowerPercent:he}=G;return he===0&&se>.6}function t(G){const{upperPercent:se,lowerPercent:he,alphaPercent:Ae,numericPercent:xe}=G;return he>.2&&se<.8&&Ae>.6&&xe<.2}function i(G){let se=0,he=0,Ae=0,xe=0;for(let ve=0;ve<G.length;ve++)Ae=G.charCodeAt(ve),n(Ae)&&se++,C(Ae)&&he++,o(Ae)&&xe++;return(se===0||he===0)&&xe===0?G.length<=30:se<=5}function s(G,se){if(!se||(se=se.trim(),se.length===0)||!i(G)||se.length>60)return null;const he=f(se);if(!t(he)){if(!g(he))return null;se=se.toLowerCase()}let Ae=null,xe=0;for(G=G.toLowerCase();xe<se.length&&(Ae=u(G,se,0,xe))===null;)xe=w(se,xe+1);return Ae}e.matchesCamelCase=s;function r(G,se,he=!1){if(!se||se.length===0)return null;let Ae=null,xe=0;for(G=G.toLowerCase(),se=se.toLowerCase();xe<se.length&&(Ae=l(G,se,0,xe,he))===null;)xe=E(se,xe+1);return Ae}e.matchesWords=r;function l(G,se,he,Ae,xe){if(he===G.length)return[];if(Ae===se.length)return null;if(c(G.charCodeAt(he),se.charCodeAt(Ae))){let ve=null,je=Ae+1;if(ve=l(G,se,he+1,Ae+1,xe),!xe)for(;!ve&&(je=E(se,je))<se.length;)ve=l(G,se,he+1,je,xe),je++;return ve===null?null:p({start:Ae,end:Ae+1},ve)}else return null}function E(G,se){for(let he=se;he<G.length;he++)if(d(G.charCodeAt(he))||he>0&&d(G.charCodeAt(he-1)))return he;return G.length}const v=S(e.matchesPrefix,s,k),A=S(e.matchesPrefix,s,D),P=new m.LRUCache(1e4);function a(G,se,he=!1){if(typeof G!="string"||typeof se!="string")return null;let Ae=P.get(G);Ae||(Ae=new RegExp(T.convertSimple2RegExpPattern(G),"i"),P.set(G,Ae));const xe=Ae.exec(se);return xe?[{start:xe.index,end:xe.index+xe[0].length}]:he?A(G,se):v(G,se)}e.matchesFuzzy=a;function F(G,se){const he=Qe(G,G.toLowerCase(),0,se,se.toLowerCase(),0,!0);return he?W(he):null}e.matchesFuzzy2=F;function N(G,se,he,Ae,xe,ve){const je=Math.min(13,G.length);for(;he<je;he++){const V=Qe(G,se,he,Ae,xe,ve,!1);if(V)return V}return[0,ve]}e.anyScore=N;function W(G){if(typeof G=="undefined")return[];const se=[],he=G[1];for(let Ae=G.length-1;Ae>1;Ae--){const xe=G[Ae]+he,ve=se[se.length-1];ve&&ve.end===xe?ve.end=xe+1:se.push({start:xe,end:xe+1})}return se}e.createMatches=W;const le=128;function fe(){const G=[],se=[];for(let he=0;he<=le;he++)se[he]=0;for(let he=0;he<=le;he++)G.push(se.slice(0));return G}function Y(G){const se=[];for(let he=0;he<=G;he++)se[he]=0;return se}const H=Y(2*le),J=Y(2*le),R=fe(),B=fe(),M=fe(),x=!1;function q(G,se,he,Ae,xe){function ve(V,ee,me=" "){for(;V.length<ee;)V=me+V;return V}let je=` |   |${Ae.split("").map(V=>ve(V,3)).join("|")}
`;for(let V=0;V<=he;V++)V===0?je+=" |":je+=`${se[V-1]}|`,je+=G[V].slice(0,xe+1).map(ee=>ve(ee.toString(),3)).join("|")+`
`;return je}function z(G,se,he,Ae){G=G.substr(se),he=he.substr(Ae),console.log(q(B,G,G.length,he,he.length)),console.log(q(M,G,G.length,he,he.length)),console.log(q(R,G,G.length,he,he.length))}function oe(G,se){if(se<0||se>=G.length)return!1;const he=G.codePointAt(se);switch(he){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 40:case 91:return!0;case void 0:return!1;default:return!!T.isEmojiImprecise(he)}}function pe(G,se){if(se<0||se>=G.length)return!1;switch(G.charCodeAt(se)){case 32:case 9:return!0;default:return!1}}function Te(G,se,he){return se[G]!==he[G]}function Be(G,se,he,Ae,xe,ve,je=!1){for(;se<he&&xe<ve;)G[se]===Ae[xe]&&(je&&(H[se]=xe),se+=1),xe+=1;return se===he}e.isPatternInWord=Be;var Fe;(function(G){G[G.Diag=1]="Diag",G[G.Left=2]="Left",G[G.LeftLeft=3]="LeftLeft"})(Fe||(Fe={}));var We;(function(G){G.Default=[-100,0];function se(he){return!he||he.length===2&&he[0]===-100&&he[1]===0}G.isDefault=se})(We=e.FuzzyScore||(e.FuzzyScore={}));function Qe(G,se,he,Ae,xe,ve,je){const V=G.length>le?le:G.length,ee=Ae.length>le?le:Ae.length;if(he>=V||ve>=ee||V-he>ee-ve||!Be(se,he,V,xe,ve,ee,!0))return;Ge(V,ee,he,ve,se,xe);let me=1,Re=1,Le=he,qe=ve;const Se=[!1];for(me=1,Le=he;Le<V;me++,Le++){const O=H[Le],K=J[Le],ae=Le+1<V?J[Le+1]:ee;for(Re=O-ve+1,qe=O;qe<ae;Re++,qe++){let ke=Number.MIN_SAFE_INTEGER,Pe=!1;qe<=K&&(ke=Ke(G,se,Le,he,Ae,xe,qe,ee,ve,R[me-1][Re-1]===0,Se));let Oe=0;ke!==Number.MAX_SAFE_INTEGER&&(Pe=!0,Oe=ke+B[me-1][Re-1]);const $e=qe>O,Ze=$e?B[me][Re-1]+(R[me][Re-1]>0?-5:0):0,Je=qe>O+1&&R[me][Re-1]>0,Ye=Je?B[me][Re-2]+(R[me][Re-2]>0?-5:0):0;if(Je&&(!$e||Ye>=Ze)&&(!Pe||Ye>=Oe))B[me][Re]=Ye,M[me][Re]=3,R[me][Re]=0;else if($e&&(!Pe||Ze>=Oe))B[me][Re]=Ze,M[me][Re]=2,R[me][Re]=0;else if(Pe)B[me][Re]=Oe,M[me][Re]=1,R[me][Re]=R[me-1][Re-1]+1;else throw new Error("not possible")}}if(x&&z(G,he,Ae,ve),!Se[0]&&!je)return;me--,Re--;const we=[B[me][Re],ve];let Ce=0,ie=0;for(;me>=1;){let O=Re;do{const K=M[me][O];if(K===3)O=O-2;else if(K===2)O=O-1;else break}while(O>=1);Ce>1&&se[he+me-1]===xe[ve+Re-1]&&!Te(O+ve-1,Ae,xe)&&Ce+1>R[me][O]&&(O=Re),O===Re?Ce++:Ce=1,ie||(ie=O),me--,Re=O-1,we.push(Re)}ee===V&&(we[0]+=2);const ce=ie-V;return we[0]-=ce,we}e.fuzzyScore=Qe;function Ge(G,se,he,Ae,xe,ve){let je=G-1,V=se-1;for(;je>=he&&V>=Ae;)xe[je]===ve[V]&&(J[je]=V,je--),V--}function Ke(G,se,he,Ae,xe,ve,je,V,ee,me,Re){if(se[he]!==ve[je])return Number.MIN_SAFE_INTEGER;let Le=1,qe=!1;return je===he-Ae?Le=G[he]===xe[je]?7:5:Te(je,xe,ve)&&(je===0||!Te(je-1,xe,ve))?(Le=G[he]===xe[je]?7:5,qe=!0):oe(ve,je)&&(je===0||!oe(ve,je-1))?Le=5:(oe(ve,je-1)||pe(ve,je-1))&&(Le=5,qe=!0),Le>1&&he===Ae&&(Re[0]=!0),qe||(qe=Te(je,xe,ve)||oe(ve,je-1)||pe(ve,je-1)),he===Ae?je>ee&&(Le-=qe?3:5):me?Le+=qe?2:0:Le+=qe?0:1,je+1===V&&(Le-=qe?3:5),Le}function $(G,se,he,Ae,xe,ve,je){return te(G,se,he,Ae,xe,ve,!0,je)}e.fuzzyScoreGracefulAggressive=$;function Q(G,se,he,Ae,xe,ve,je){return te(G,se,he,Ae,xe,ve,!1,je)}e.fuzzyScoreGraceful=Q;function te(G,se,he,Ae,xe,ve,je,V){let ee=Qe(G,se,he,Ae,xe,ve,V);if(ee&&!je)return ee;if(G.length>=3){const me=Math.min(7,G.length-1);for(let Re=he+1;Re<me;Re++){const Le=re(G,Re);if(Le){const qe=Qe(Le,Le.toLowerCase(),he,Ae,xe,ve,V);qe&&(qe[0]-=3,(!ee||qe[0]>ee[0])&&(ee=qe))}}}return ee}function re(G,se){if(se+1>=G.length)return;const he=G[se],Ae=G[se+1];if(he!==Ae)return G.slice(0,se)+Ae+he+G.slice(se+2)}}),define(_e[111],Ee([0,1,78,110,8]),function(Z,e,m,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=e.iconStartMarker=void 0,e.iconStartMarker="$(";const y=new RegExp(`\\$\\(${m.CSSIcon.iconNameExpression}(?:${m.CSSIcon.iconModifierExpression})?\\)`,"g"),k=new RegExp(`(\\\\)?${y.source}`,"g");function D(c){return c.replace(k,(b,p)=>p?b:`\\${b}`)}e.escapeIcons=D;const _=new RegExp(`\\\\${y.source}`,"g");function C(c){return c.replace(_,b=>`\\${b}`)}e.markdownEscapeEscapedIcons=C;const n=new RegExp(`(\\s)?(\\\\)?${y.source}(\\s)?`,"g");function I(c){return c.indexOf(e.iconStartMarker)===-1?c:c.replace(n,(b,p,w,u)=>w?b:p||u||"")}e.stripIcons=I;function o(c){const b=c.indexOf(e.iconStartMarker);return b===-1?{text:c}:h(c,b)}e.parseLabelWithIcons=o;function h(c,b){const p=[];let w="";function u(E){if(E){w+=E;for(const v of E)p.push(t)}}let f=-1,g="",t=0,i,s,r=b;const l=c.length;for(u(c.substr(0,b));r<l;)i=c[r],s=c[r+1],i===e.iconStartMarker[0]&&s===e.iconStartMarker[1]?(f=r,u(g),g=e.iconStartMarker,r++):i===")"&&f!==-1?(t+=r-f+1,f=-1,g=""):f!==-1?/^[a-z0-9\-]$/i.test(i)?g+=i:(u(g),f=-1,g=""):u(i),r++;return u(g),{text:w,iconOffsets:p}}function d(c,b,p=!1){const{text:w,iconOffsets:u}=b;if(!u||u.length===0)return T.matchesFuzzy(c,w,p);const f=S.ltrim(w," "),g=w.length-f.length,t=T.matchesFuzzy(c,f,p);if(t)for(const i of t){const s=u[i.start+g]+g;i.start+=s,i.end+=s}return t}e.matchesFuzzyIconAware=d}),define(_e[80],Ee([0,1,111,11]),function(Z,e,m,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var S;(function(o){o[o.Paragraph=0]="Paragraph",o[o.Break=1]="Break"})(S=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class y{constructor(h="",d=!1){var c,b;if(this.value=h,typeof this.value!="string")throw T.illegalArgument("value");typeof d=="boolean"?(this.isTrusted=d,this.supportThemeIcons=!1):(this.isTrusted=(c=d.isTrusted)!==null&&c!==void 0?c:void 0,this.supportThemeIcons=(b=d.supportThemeIcons)!==null&&b!==void 0?b:!1)}appendText(h,d=0){return this.value+=C(this.supportThemeIcons?m.escapeIcons(h):h).replace(/([ \t]+)/g,(c,b)=>"&nbsp;".repeat(b.length)).replace(/^>/gm,"\\>").replace(/\n/g,d===1?`\\
`:`

`),this}appendMarkdown(h){return this.value+=h,this}appendCodeblock(h,d){return this.value+="\n```",this.value+=h,this.value+=`
`,this.value+=d,this.value+="\n```\n",this}}e.MarkdownString=y;function k(o){return D(o)?!o.value:Array.isArray(o)?o.every(k):!0}e.isEmptyMarkdownString=k;function D(o){return o instanceof y?!0:o&&typeof o=="object"?typeof o.value=="string"&&(typeof o.isTrusted=="boolean"||o.isTrusted===void 0)&&(typeof o.supportThemeIcons=="boolean"||o.supportThemeIcons===void 0):!1}e.isMarkdownString=D;function _(o,h){return o===h?!0:!o||!h?!1:o.value===h.value&&o.isTrusted===h.isTrusted&&o.supportThemeIcons===h.supportThemeIcons}e.markdownStringEqual=_;function C(o){return o.replace(/[\\`*_{}[\]()#+\-.!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=C;function n(o){return o&&o.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=n;function I(o){const h=[],d=o.split("|").map(b=>b.trim());o=d[0];const c=d[1];if(c){const b=/height=(\d+)/.exec(c),p=/width=(\d+)/.exec(c),w=b?b[1]:"",u=p?p[1]:"",f=isFinite(parseInt(u)),g=isFinite(parseInt(w));f&&h.push(`width="${u}"`),g&&h.push(`height="${w}"`)}return{href:o,dimensions:h}}e.parseHrefAndDimensions=I}),define(_e[54],Ee([0,1,23,8,2]),function(Z,e,m,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function y(C){return JSON.stringify(C,D)}e.stringify=y;function k(C){let n=JSON.parse(C);return n=_(n),n}e.parse=k;function D(C,n){return n instanceof RegExp?{$mid:2,source:n.source,flags:T.regExpFlags(n)}:n}function _(C,n=0){if(!C||n>200)return C;if(typeof C=="object"){switch(C.$mid){case 1:return S.URI.revive(C);case 2:return new RegExp(C.source,C.flags)}if(C instanceof m.VSBuffer||C instanceof Uint8Array)return C;if(Array.isArray(C))for(let I=0;I<C.length;++I)C[I]=_(C[I],n+1);else for(const I in C)Object.hasOwnProperty.call(C,I)&&(C[I]=_(C[I],n+1))}return C}e.revive=_}),define(_e[16],Ee([0,1,2,21]),function(Z,e,m,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var S;(function(D){D.inMemory="inmemory",D.vscode="vscode",D.internal="private",D.walkThrough="walkThrough",D.walkThroughSnippet="walkThroughSnippet",D.http="http",D.https="https",D.file="file",D.mailto="mailto",D.untitled="untitled",D.data="data",D.command="command",D.vscodeRemote="vscode-remote",D.vscodeRemoteResource="vscode-remote-resource",D.userData="vscode-userdata",D.vscodeCustomEditor="vscode-custom-editor",D.vscodeNotebook="vscode-notebook",D.vscodeNotebookCell="vscode-notebook-cell",D.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",D.vscodeNotebookCellOutput="vscode-notebook-cell-output",D.vscodeSettings="vscode-settings",D.vscodeWorkspaceTrust="vscode-workspace-trust",D.vscodeTerminal="vscode-terminal",D.webviewPanel="webview-panel",D.vscodeWebview="vscode-webview",D.extension="extension",D.vscodeFileResource="vscode-file",D.tmp="tmp"})(S=e.Schemas||(e.Schemas={}));class y{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(_){this._preferredWebSchema=_}setDelegate(_){this._delegate=_}set(_,C,n){this._hosts[_]=C,this._ports[_]=n}setConnectionToken(_,C){this._connectionTokens[_]=C}rewrite(_){if(this._delegate)return this._delegate(_);const C=_.authority;let n=this._hosts[C];n&&n.indexOf(":")!==-1&&(n=`[${n}]`);const I=this._ports[C],o=this._connectionTokens[C];let h=`path=${encodeURIComponent(_.path)}`;return typeof o=="string"&&(h+=`&tkn=${encodeURIComponent(o)}`),m.URI.from({scheme:T.isWeb?this._preferredWebSchema:S.vscodeRemoteResource,authority:`${n}:${I}`,path:"/vscode-remote-resource",query:h})}}e.RemoteAuthorities=new y;class k{constructor(){this.FALLBACK_AUTHORITY="vscode-app"}asBrowserUri(_,C,n){const I=this.toUri(_,C);return I.scheme===S.vscodeRemote?e.RemoteAuthorities.rewrite(I):T.isNative&&(n||T.isPreferringBrowserCodeLoad)&&I.scheme===S.file?I.with({scheme:S.vscodeFileResource,authority:I.authority||this.FALLBACK_AUTHORITY,query:null,fragment:null}):I}asFileUri(_,C){const n=this.toUri(_,C);return n.scheme===S.vscodeFileResource?n.with({scheme:S.file,authority:n.authority!==this.FALLBACK_AUTHORITY?n.authority:null,query:null,fragment:null}):n}toUri(_,C){return m.URI.isUri(_)?_:m.URI.parse(C.toUrl(_))}}e.FileAccess=new k}),define(_e[25],Ee([0,1,42,14,2,8,16,21]),function(Z,e,m,T,S,y,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function _(h){return S.uriToFsPath(h,!0)}e.originalFSPath=_;class C{constructor(d){this._ignorePathCasing=d}compare(d,c,b=!1){return d===c?0:y.compare(this.getComparisonKey(d,b),this.getComparisonKey(c,b))}isEqual(d,c,b=!1){return d===c?!0:!d||!c?!1:this.getComparisonKey(d,b)===this.getComparisonKey(c,b)}getComparisonKey(d,c=!1){return d.with({path:this._ignorePathCasing(d)?d.path.toLowerCase():void 0,fragment:c?null:void 0}).toString()}ignorePathCasing(d){return this._ignorePathCasing(d)}isEqualOrParent(d,c,b=!1){if(d.scheme===c.scheme){if(d.scheme===k.Schemas.file)return m.isEqualOrParent(_(d),_(c),this._ignorePathCasing(d))&&d.query===c.query&&(b||d.fragment===c.fragment);if(e.isEqualAuthority(d.authority,c.authority))return m.isEqualOrParent(d.path,c.path,this._ignorePathCasing(d),"/")&&d.query===c.query&&(b||d.fragment===c.fragment)}return!1}joinPath(d,...c){return S.URI.joinPath(d,...c)}basenameOrAuthority(d){return e.basename(d)||d.authority}basename(d){return T.posix.basename(d.path)}extname(d){return T.posix.extname(d.path)}dirname(d){if(d.path.length===0)return d;let c;return d.scheme===k.Schemas.file?c=S.URI.file(T.dirname(_(d))).path:(c=T.posix.dirname(d.path),d.authority&&c.length&&c.charCodeAt(0)!==47&&(console.error(`dirname("${d.toString})) resulted in a relative path`),c="/")),d.with({path:c})}normalizePath(d){if(!d.path.length)return d;let c;return d.scheme===k.Schemas.file?c=S.URI.file(T.normalize(_(d))).path:c=T.posix.normalize(d.path),d.with({path:c})}relativePath(d,c){if(d.scheme!==c.scheme||!e.isEqualAuthority(d.authority,c.authority))return;if(d.scheme===k.Schemas.file){const w=T.relative(_(d),_(c));return D.isWindows?m.toSlashes(w):w}let b=d.path||"/",p=c.path||"/";if(this._ignorePathCasing(d)){let w=0;for(const u=Math.min(b.length,p.length);w<u&&!(b.charCodeAt(w)!==p.charCodeAt(w)&&b.charAt(w).toLowerCase()!==p.charAt(w).toLowerCase());w++);b=p.substr(0,w)+b.substr(w)}return T.posix.relative(b,p)}resolvePath(d,c){if(d.scheme===k.Schemas.file){const b=S.URI.file(T.resolve(_(d),c));return d.with({authority:b.authority,path:b.path})}return c=m.toPosixPath(c),d.with({path:T.posix.resolve(d.path,c)})}isAbsolutePath(d){return!!d.path&&d.path[0]==="/"}isEqualAuthority(d,c){return d===c||y.equalsIgnoreCase(d,c)}hasTrailingPathSeparator(d,c=T.sep){if(d.scheme===k.Schemas.file){const b=_(d);return b.length>m.getRoot(b).length&&b[b.length-1]===c}else{const b=d.path;return b.length>1&&b.charCodeAt(b.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(d.fsPath)}}removeTrailingPathSeparator(d,c=T.sep){return e.hasTrailingPathSeparator(d,c)?d.with({path:d.path.substr(0,d.path.length-1)}):d}addTrailingPathSeparator(d,c=T.sep){let b=!1;if(d.scheme===k.Schemas.file){const p=_(d);b=p!==void 0&&p.length===m.getRoot(p).length&&p[p.length-1]===c}else{c="/";const p=d.path;b=p.length===1&&p.charCodeAt(p.length-1)===47}return!b&&!e.hasTrailingPathSeparator(d,c)?d.with({path:d.path+"/"}):d}}e.ExtUri=C,e.extUri=new C(()=>!1),e.extUriBiasedIgnorePathCase=new C(h=>h.scheme===k.Schemas.file?!D.isLinux:!0),e.extUriIgnorePathCase=new C(h=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function n(h,d){const c=[];for(let b=0;b<h.length;b++){const p=d(h[b]);h.some((w,u)=>u===b?!1:e.isEqualOrParent(p,d(w)))||c.push(h[b])}return c}e.distinctParents=n;var I;(function(h){h.META_DATA_LABEL="label",h.META_DATA_DESCRIPTION="description",h.META_DATA_SIZE="size",h.META_DATA_MIME="mime";function d(c){const b=new Map;c.path.substring(c.path.indexOf(";")+1,c.path.lastIndexOf(";")).split(";").forEach(u=>{const[f,g]=u.split(":");f&&g&&b.set(f,g)});const w=c.path.substring(0,c.path.indexOf(";"));return w&&b.set(h.META_DATA_MIME,w),b}h.parseMetaData=d})(I=e.DataUri||(e.DataUri={}));function o(h,d,c){if(d){let b=h.path;return b&&b[0]!==T.posix.sep&&(b=T.posix.sep+b),h.with({scheme:c,authority:d,path:b})}return h.with({scheme:c})}e.toLocalResource=o}),define(_e[12],Ee([0,1,18,11,3,7,51,25]),function(Z,e,m,T,S,y,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.AsyncEmitter=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.RunOnceWorker=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.ignoreErrors=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function _(B){return!!B&&typeof B.then=="function"}e.isThenable=_;function C(B){const M=new m.CancellationTokenSource,x=B(M.token),q=new Promise((z,oe)=>{M.token.onCancellationRequested(()=>{oe(T.canceled())}),Promise.resolve(x).then(pe=>{M.dispose(),z(pe)},pe=>{M.dispose(),oe(pe)})});return new class{cancel(){M.cancel()}then(z,oe){return q.then(z,oe)}catch(z){return this.then(void 0,z)}finally(z){return q.finally(z)}}}e.createCancelablePromise=C;function n(B,M,x){return Promise.race([B,new Promise(q=>M.onCancellationRequested(()=>q(x)))])}e.raceCancellation=n;async function I(B){let M=-1;const x=B.map((z,oe)=>z.then(pe=>(M=oe,pe))),q=await Promise.race(x);return B.forEach((z,oe)=>{oe!==M&&z.cancel()}),q}e.raceCancellablePromises=I;function o(B,M,x){let q;const z=setTimeout(()=>{q==null||q(void 0),x==null||x()},M);return Promise.race([B.finally(()=>clearTimeout(z)),new Promise(oe=>q=oe)])}e.raceTimeout=o;function h(B){return new Promise((M,x)=>{const q=B();_(q)?q.then(M,x):M(q)})}e.asPromise=h;class d{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(M){if(this.activePromise){if(this.queuedPromiseFactory=M,!this.queuedPromise){const x=()=>{this.queuedPromise=null;const q=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,q};this.queuedPromise=new Promise(q=>{this.activePromise.then(x,x).then(q)})}return new Promise((x,q)=>{this.queuedPromise.then(x,q)})}return this.activePromise=M(),new Promise((x,q)=>{this.activePromise.then(z=>{this.activePromise=null,x(z)},z=>{this.activePromise=null,q(z)})})}}e.Throttler=d;class c{constructor(){this.current=Promise.resolve(null)}queue(M){return this.current=this.current.then(()=>M(),()=>M())}}e.Sequencer=c;class b{constructor(){this.promiseMap=new Map}queue(M,x){var q;const oe=((q=this.promiseMap.get(M))!==null&&q!==void 0?q:Promise.resolve()).catch(()=>{}).then(x).finally(()=>{this.promiseMap.get(M)===oe&&this.promiseMap.delete(M)});return this.promiseMap.set(M,oe),oe}}e.SequencerByKey=b;class p{constructor(M){this.defaultDelay=M,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(M,x=this.defaultDelay){return this.task=M,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((q,z)=>{this.doResolve=q,this.doReject=z}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const q=this.task;return this.task=null,q()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},x),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject(T.canceled()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancel()}}e.Delayer=p;class w{constructor(M){this.delayer=new p(M),this.throttler=new d}trigger(M,x){return this.delayer.trigger(()=>this.throttler.queue(M),x)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=w;class u{constructor(){this._isOpen=!1,this._promise=new Promise((M,x)=>{this._completePromise=M})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=u;class f extends u{constructor(M){super();this._timeout=setTimeout(()=>this.open(),M)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=f;function g(B,M){return M?new Promise((x,q)=>{const z=setTimeout(x,B);M.onCancellationRequested(()=>{clearTimeout(z),q(T.canceled())})}):C(x=>g(B,x))}e.timeout=g;function t(B,M=0){const x=setTimeout(B,M);return y.toDisposable(()=>clearTimeout(x))}e.disposableTimeout=t;function i(B){return B.then(void 0,M=>{})}e.ignoreErrors=i;function s(B){const M=[];let x=0;const q=B.length;function z(){return x<q?B[x++]():null}function oe(pe){pe!=null&&M.push(pe);const Te=z();return Te?Te.then(oe):Promise.resolve(M)}return Promise.resolve(null).then(oe)}e.sequence=s;function r(B,M=q=>!!q,x=null){let q=0;const z=B.length,oe=()=>{if(q>=z)return Promise.resolve(x);const pe=B[q++];return Promise.resolve(pe()).then(Be=>M(Be)?Promise.resolve(Be):oe())};return oe()}e.first=r;function l(B,M=q=>!!q,x=null){if(B.length===0)return Promise.resolve(x);let q=B.length;const z=()=>{var oe,pe;q=-1;for(const Te of B)(pe=(oe=Te).cancel)===null||pe===void 0||pe.call(oe)};return new Promise((oe,pe)=>{for(const Te of B)Te.then(Be=>{--q>=0&&M(Be)?(z(),oe(Be)):q===0&&oe(x)}).catch(Be=>{--q>=0&&(z(),pe(Be))})})}e.firstParallel=l;class E{constructor(M){this._size=0,this.maxDegreeOfParalellism=M,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new S.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(M){return this._size++,new Promise((x,q)=>{this.outstandingPromises.push({factory:M,c:x,e:q}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const M=this.outstandingPromises.shift();this.runningPromises++;const x=M.factory();x.then(M.c,M.e),x.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=E;class v extends E{constructor(){super(1)}}e.Queue=v;class A{constructor(){this.queues=new Map}queueFor(M,x=D.extUri){const q=x.getComparisonKey(M);let z=this.queues.get(q);return z||(z=new v,S.Event.once(z.onFinished)(()=>{z==null||z.dispose(),this.queues.delete(q)}),this.queues.set(q,z)),z}dispose(){this.queues.forEach(M=>M.dispose()),this.queues.clear()}}e.ResourceQueue=A;class P{constructor(M,x){this._token=-1,typeof M=="function"&&typeof x=="number"&&this.setIfNotSet(M,x)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(M,x){this.cancel(),this._token=setTimeout(()=>{this._token=-1,M()},x)}setIfNotSet(M,x){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,M()},x))}}e.TimeoutTimer=P;class a{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(M,x){this.cancel(),this._token=setInterval(()=>{M()},x)}}e.IntervalTimer=a;class F{constructor(M,x){this.timeoutToken=-1,this.runner=M,this.timeout=x,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(M=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,M)}get delay(){return this.timeout}set delay(M){this.timeout=M}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=F;class N extends F{constructor(M,x){super(M,x);this.units=[]}work(M){this.units.push(M),this.isScheduled()||this.schedule()}doRun(){const M=this.units;this.units=[],this.runner&&this.runner(M)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=N,function(){if(typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"){const B=Object.freeze({didTimeout:!0,timeRemaining(){return 15}});e.runWhenIdle=M=>{const x=setTimeout(()=>M(B));let q=!1;return{dispose(){q||(q=!0,clearTimeout(x))}}}}else e.runWhenIdle=(B,M)=>{const x=requestIdleCallback(B,typeof M=="number"?{timeout:M}:void 0);let q=!1;return{dispose(){q||(q=!0,cancelIdleCallback(x))}}}}();class W{constructor(M){this._didRun=!1,this._executor=()=>{try{this._value=M()}catch(x){this._error=x}finally{this._didRun=!0}},this._handle=e.runWhenIdle(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}}e.IdleValue=W;async function le(B,M,x){let q;for(let z=0;z<x;z++)try{return await B()}catch(oe){q=oe,await g(M)}throw q}e.retry=le;class fe{hasPending(M){return this._pending?typeof M=="number"?this._pending.taskId===M:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){var M;(M=this._pending)===null||M===void 0||M.cancel()}setPending(M,x,q){return this._pending={taskId:M,cancel:()=>q==null?void 0:q(),promise:x},x.then(()=>this.donePending(M),()=>this.donePending(M)),x}donePending(M){this._pending&&M===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const M=this._next;this._next=void 0,M.run().then(M.promiseResolve,M.promiseReject)}}setNext(M){if(this._next)this._next.run=M;else{let x,q;const z=new Promise((oe,pe)=>{x=oe,q=pe});this._next={run:M,promise:z,promiseResolve:x,promiseReject:q}}return this._next.promise}}e.TaskSequentializer=fe;class Y{constructor(M){this.interval=M,this.lastIncrementTime=0,this.value=0}increment(){const M=Date.now();return M-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=M,this.value=0),this.value++,this.value}}e.IntervalCounter=Y;class H{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((M,x)=>{this.completeCallback=M,this.errorCallback=x})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(M){return new Promise(x=>{this.completeCallback(M),this.resolved=!0,x()})}error(M){return new Promise(x=>{this.errorCallback(M),this.rejected=!0,x()})}cancel(){new Promise(M=>{this.errorCallback(T.canceled()),this.rejected=!0,M()})}}e.DeferredPromise=H;class J extends S.Emitter{async fireAsync(M,x,q){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new k.LinkedList);for(const z of this._listeners)this._asyncDeliveryQueue.push([z,M]);for(;this._asyncDeliveryQueue.size>0&&!x.isCancellationRequested;){const[z,oe]=this._asyncDeliveryQueue.shift(),pe=[],Te=Object.assign(Object.assign({},oe),{waitUntil:Be=>{if(Object.isFrozen(pe))throw new Error("waitUntil can NOT be called asynchronous");q&&(Be=q(Be,typeof z=="function"?z:z[0])),pe.push(Be)}});try{typeof z=="function"?z.call(void 0,Te):z[0].call(z[1],Te)}catch(Be){T.onUnexpectedError(Be);continue}Object.freeze(pe),await R.settled(pe).catch(Be=>T.onUnexpectedError(Be))}}}}e.AsyncEmitter=J;var R;(function(B){async function M(oe){return typeof Promise.allSettled=="function"?x(oe):q(oe)}B.allSettled=M;async function x(oe){return Promise.allSettled(oe)}async function q(oe){return Promise.all(oe.map(pe=>pe.then(Te=>({status:"fulfilled",value:Te}),Te=>({status:"rejected",reason:Te}))))}async function z(oe){let pe;const Te=await Promise.all(oe.map(Be=>Be.then(Fe=>Fe,Fe=>{pe||(pe=Fe)})));if(typeof pe!="undefined")throw pe;return Te}B.settled=z})(R=e.Promises||(e.Promises={}))}),define(_e[112],Ee([0,1,14,12]),function(Z,e,m,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.noIntlCompareFileNames=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const S=new T.IdleValue(()=>{const P=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:P,collatorIsNumeric:P.resolvedOptions().numeric}}),y=new T.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),k=new T.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function D(P,a,F=!1){const N=P||"",W=a||"",le=S.value.collator.compare(N,W);return S.value.collatorIsNumeric&&le===0&&N!==W?N<W?-1:1:le}e.compareFileNames=D;function _(P,a){const F=y.value.collator;return P=P||"",a=a||"",g(F,P,a)}e.compareFileNamesDefault=_;function C(P,a){const F=y.value.collator;return P=P||"",a=a||"",r(P,a)||g(F,P,a)}e.compareFileNamesUpper=C;function n(P,a){const F=y.value.collator;return P=P||"",a=a||"",s(P,a)||g(F,P,a)}e.compareFileNamesLower=n;function I(P,a){return P=P||"",a=a||"",P===a?0:P<a?-1:1}e.compareFileNamesUnicode=I;function o(P,a,F=!1){F||(P=P&&P.toLowerCase(),a=a&&a.toLowerCase());const[N,W]=u(P),[le,fe]=u(a);return N!==le?N<le?-1:1:W===fe?0:W<fe?-1:1}e.noIntlCompareFileNames=o;function h(P,a){const[F,N]=u(P),[W,le]=u(a);let fe=S.value.collator.compare(N,le);if(fe===0){if(S.value.collatorIsNumeric&&N!==le)return N<le?-1:1;if(fe=S.value.collator.compare(F,W),S.value.collatorIsNumeric&&fe===0&&F!==W)return F<W?-1:1}return fe}e.compareFileExtensions=h;function d(P,a){P=P||"",a=a||"";const F=f(P),N=f(a),W=y.value.collator,le=k.value.collator;return g(le,F,N)||g(W,P,a)}e.compareFileExtensionsDefault=d;function c(P,a){P=P||"",a=a||"";const F=f(P),N=f(a),W=y.value.collator,le=k.value.collator;return g(le,F,N)||r(P,a)||g(W,P,a)}e.compareFileExtensionsUpper=c;function b(P,a){P=P||"",a=a||"";const F=f(P),N=f(a),W=y.value.collator,le=k.value.collator;return g(le,F,N)||s(P,a)||g(W,P,a)}e.compareFileExtensionsLower=b;function p(P,a){P=P||"",a=a||"";const F=f(P).toLowerCase(),N=f(a).toLowerCase();return F!==N?F<N?-1:1:P!==a?P<a?-1:1:0}e.compareFileExtensionsUnicode=p;const w=/^(.*?)(\.([^.]*))?$/;function u(P,a=!1){const F=P?w.exec(P):[];let N=[F&&F[1]||"",F&&F[3]||""];return a&&(!N[0]&&N[1]||N[0]&&N[0].charAt(0)===".")&&(N=[N[0]+"."+N[1],""]),N}function f(P){const a=P?w.exec(P):[];return a&&a[1]&&a[1].charAt(0)!=="."&&a[3]||""}function g(P,a,F){let N=P.compare(a,F);return N!==0?N:a.length!==F.length?a.length<F.length?-1:1:0}function t(P){const a=P.charAt(0);return a.toLocaleUpperCase()!==a}function i(P){const a=P.charAt(0);return a.toLocaleLowerCase()!==a}function s(P,a){return t(P)&&i(a)?-1:i(P)&&t(a)?1:0}function r(P,a){return i(P)&&t(a)?-1:t(P)&&i(a)?1:0}function l(P,a,F=!1){return F||(P=P&&P.toLowerCase(),a=a&&a.toLowerCase()),P===a?0:P<a?-1:1}function E(P,a,F=!1){const N=P.split(m.sep),W=a.split(m.sep),le=N.length-1,fe=W.length-1;let Y,H;for(let J=0;;J++){if(Y=le===J,H=fe===J,Y&&H)return D(N[J],W[J],F);if(Y)return-1;if(H)return 1;const R=l(N[J],W[J],F);if(R!==0)return R}}e.comparePaths=E;function v(P,a,F){const N=P.toLowerCase(),W=a.toLowerCase(),le=A(P,a,F);if(le)return le;const fe=N.endsWith(F),Y=W.endsWith(F);if(fe!==Y)return fe?-1:1;const H=D(N,W);return H!==0?H:N.localeCompare(W)}e.compareAnything=v;function A(P,a,F){const N=P.toLowerCase(),W=a.toLowerCase(),le=N.startsWith(F),fe=W.startsWith(F);if(le!==fe)return le?-1:1;if(le&&fe){if(N.length<W.length)return-1;if(N.length>W.length)return 1}return 0}e.compareByPrefix=A}),define(_e[27],Ee([0,1,8,42,14,22,12]),function(Z,e,m,T,S,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function D(){return Object.create(null)}e.getEmptyExpression=D;const _="**",C="/",n="[/\\\\]",I="[^/\\\\]",o=/\//g;function h(x){switch(x){case 0:return"";case 1:return`${I}*?`;default:return`(?:${n}|${I}+${n}|${n}${I}+)*?`}}function d(x,q){if(!x)return[];const z=[];let oe=!1,pe=!1,Te="";for(const Be of x){switch(Be){case q:if(!oe&&!pe){z.push(Te),Te="";continue}break;case"{":oe=!0;break;case"}":oe=!1;break;case"[":pe=!0;break;case"]":pe=!1;break}Te+=Be}return Te&&z.push(Te),z}e.splitGlobAware=d;function c(x){if(!x)return"";let q="";const z=d(x,C);if(z.every(oe=>oe===_))q=".*";else{let oe=!1;z.forEach((pe,Te)=>{if(pe===_){oe||(q+=h(2),oe=!0);return}let Be=!1,Fe="",We=!1,Qe="";for(const Ge of pe){if(Ge!=="}"&&Be){Fe+=Ge;continue}if(We&&(Ge!=="]"||!Qe)){let Ke;Ge==="-"?Ke=Ge:(Ge==="^"||Ge==="!")&&!Qe?Ke="^":Ge===C?Ke="":Ke=m.escapeRegExpCharacters(Ge),Qe+=Ke;continue}switch(Ge){case"{":Be=!0;continue;case"[":We=!0;continue;case"}":q+=`(?:${d(Fe,",").map(Q=>c(Q)).join("|")})`,Be=!1,Fe="";break;case"]":q+="["+Qe+"]",We=!1,Qe="";break;case"?":q+=I;continue;case"*":q+=h(1);continue;default:q+=m.escapeRegExpCharacters(Ge)}}Te<z.length-1&&(z[Te+1]!==_||Te+2<z.length)&&(q+=n),oe=!1})}return q}const b=/^\*\*\/\*\.[\w\.-]+$/,p=/^\*\*\/([\w\.-]+)\/?$/,w=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,u=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,f=/^\*\*((\/[\w\.-]+)+)\/?$/,g=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new y.LRUCache(1e4),i=function(){return!1},s=function(){return null};function r(x,q){if(!x)return s;let z;typeof x!="string"?z=x.pattern:z=x,z=z.trim();const oe=`${z}_${!!q.trimForExclusions}`;let pe=t.get(oe);if(pe)return l(pe,x);let Te;if(b.test(z)){const Be=z.substr(4);pe=function(Fe,We){return typeof Fe=="string"&&Fe.endsWith(Be)?z:null}}else(Te=p.exec(E(z,q)))?pe=v(Te[1],z):(q.trimForExclusions?u:w).test(z)?pe=A(z,q):(Te=f.exec(E(z,q)))?pe=P(Te[1].substr(1),z,!0):(Te=g.exec(E(z,q)))?pe=P(Te[1],z,!1):pe=a(z);return t.set(oe,pe),l(pe,x)}function l(x,q){return typeof q=="string"?x:function(z,oe){return T.isEqualOrParent(z,q.base)?x(S.relative(q.base,z),oe):null}}function E(x,q){return q.trimForExclusions&&x.endsWith("/**")?x.substr(0,x.length-2):x}function v(x,q){const z=`/${x}`,oe=`\\${x}`,pe=function(Be,Fe){return typeof Be!="string"?null:Fe?Fe===x?q:null:Be===x||Be.endsWith(z)||Be.endsWith(oe)?q:null},Te=[x];return pe.basenames=Te,pe.patterns=[q],pe.allBasenames=Te,pe}function A(x,q){const z=M(x.slice(1,-1).split(",").map(Fe=>r(Fe,q)).filter(Fe=>Fe!==s),x),oe=z.length;if(!oe)return s;if(oe===1)return z[0];const pe=function(Fe,We){for(let Qe=0,Ge=z.length;Qe<Ge;Qe++)if(z[Qe](Fe,We))return x;return null},Te=z.find(Fe=>!!Fe.allBasenames);Te&&(pe.allBasenames=Te.allBasenames);const Be=z.reduce((Fe,We)=>We.allPaths?Fe.concat(We.allPaths):Fe,[]);return Be.length&&(pe.allPaths=Be),pe}function P(x,q,z){const oe=S.sep===S.posix.sep,pe=oe?x:x.replace(o,S.sep),Te=S.sep+pe,Be=S.posix.sep+x,Fe=z?function(We,Qe){return typeof We=="string"&&(We===pe||We.endsWith(Te)||!oe&&(We===x||We.endsWith(Be)))?q:null}:function(We,Qe){return typeof We=="string"&&(We===pe||!oe&&We===x)?q:null};return Fe.allPaths=[(z?"*/":"./")+x],Fe}function a(x){try{const q=new RegExp(`^${c(x)}$`);return function(z){return q.lastIndex=0,typeof z=="string"&&q.test(z)?x:null}}catch(q){return s}}function F(x,q,z){return!x||typeof q!="string"?!1:N(x)(q,void 0,z)}e.match=F;function N(x,q={}){if(!x)return i;if(typeof x=="string"||Y(x)){const z=r(x,q);if(z===s)return i;const oe=function(pe,Te){return!!z(pe,Te)};return z.allBasenames&&(oe.allBasenames=z.allBasenames),z.allPaths&&(oe.allPaths=z.allPaths),oe}return R(x,q)}e.parse=N;function W(x){if(!x)return;let q;return z=>(q||(q=(x()||Promise.resolve([])).then(oe=>oe?fe(oe):{})),q.then(oe=>!!oe[z]))}e.hasSiblingPromiseFn=W;function le(x){if(!x)return;let q;return z=>{if(!q){const oe=x();q=oe?fe(oe):{}}return!!q[z]}}e.hasSiblingFn=le;function fe(x){const q={};for(const z of x)q[z]=!0;return q}function Y(x){const q=x;return q&&typeof q.base=="string"&&typeof q.pattern=="string"}e.isRelativePattern=Y;function H(x){return x.allBasenames||[]}e.getBasenameTerms=H;function J(x){return x.allPaths||[]}e.getPathTerms=J;function R(x,q){const z=M(Object.getOwnPropertyNames(x).map(Fe=>B(Fe,x[Fe],q)).filter(Fe=>Fe!==s)),oe=z.length;if(!oe)return s;if(!z.some(Fe=>!!Fe.requiresSiblings)){if(oe===1)return z[0];const Fe=function(Ge,Ke){for(let $=0,Q=z.length;$<Q;$++){const te=z[$](Ge,Ke);if(te)return te}return null},We=z.find(Ge=>!!Ge.allBasenames);We&&(Fe.allBasenames=We.allBasenames);const Qe=z.reduce((Ge,Ke)=>Ke.allPaths?Ge.concat(Ke.allPaths):Ge,[]);return Qe.length&&(Fe.allPaths=Qe),Fe}const pe=function(Fe,We,Qe){let Ge;for(let Ke=0,$=z.length;Ke<$;Ke++){const Q=z[Ke];Q.requiresSiblings&&Qe&&(We||(We=S.basename(Fe)),Ge||(Ge=We.substr(0,We.length-S.extname(Fe).length)));const te=Q(Fe,We,Ge,Qe);if(te)return te}return null},Te=z.find(Fe=>!!Fe.allBasenames);Te&&(pe.allBasenames=Te.allBasenames);const Be=z.reduce((Fe,We)=>We.allPaths?Fe.concat(We.allPaths):Fe,[]);return Be.length&&(pe.allPaths=Be),pe}function B(x,q,z){if(q===!1)return s;const oe=r(x,z);if(oe===s)return s;if(typeof q=="boolean")return oe;if(q){const pe=q.when;if(typeof pe=="string"){const Te=(Be,Fe,We,Qe)=>{if(!Qe||!oe(Be,Fe))return null;const Ge=pe.replace("$(basename)",We),Ke=Qe(Ge);return k.isThenable(Ke)?Ke.then($=>$?x:null):Ke?x:null};return Te.requiresSiblings=!0,Te}}return oe}function M(x,q){const z=x.filter(Fe=>!!Fe.basenames);if(z.length<2)return x;const oe=z.reduce((Fe,We)=>{const Qe=We.basenames;return Qe?Fe.concat(Qe):Fe},[]);let pe;if(q){pe=[];for(let Fe=0,We=oe.length;Fe<We;Fe++)pe.push(q)}else pe=z.reduce((Fe,We)=>{const Qe=We.patterns;return Qe?Fe.concat(Qe):Fe},[]);const Te=function(Fe,We){if(typeof Fe!="string")return null;if(!We){let Ge;for(Ge=Fe.length;Ge>0;Ge--){const Ke=Fe.charCodeAt(Ge-1);if(Ke===47||Ke===92)break}We=Fe.substr(Ge)}const Qe=oe.indexOf(We);return Qe!==-1?pe[Qe]:null};Te.basenames=oe,Te.patterns=pe,Te.allBasenames=oe;const Be=x.filter(Fe=>!Fe.basenames);return Be.push(Te),Be}}),define(_e[81],Ee([0,1,2,14,8,16,21,25,42]),function(Z,e,m,T,S,y,k,D,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function C(r,l,E){if(typeof r=="string"&&(r=m.URI.file(r)),E){const A=E.getWorkspaceFolder(r);if(A){const P=E.getWorkspace().folders.length>1;let a;if(D.isEqual(A.uri,r)?a="":a=D.relativePath(A.uri,r),P){const F=A.name?A.name:D.basename(A.uri);a=a?F+" \u2022 "+a:F}return a}}if(r.scheme!==y.Schemas.file&&r.scheme!==y.Schemas.untitled)return r.with({query:null,fragment:null}).toString(!0);if(_.hasDriveLetter(r.fsPath))return T.normalize(I(r.fsPath));let v=T.normalize(r.fsPath);return!k.isWindows&&(l==null?void 0:l.userHome)&&(v=h(v,l.userHome.fsPath)),v}e.getPathLabel=C;function n(r){if(!r)return;typeof r=="string"&&(r=m.URI.file(r));const l=D.basename(r)||(r.scheme===y.Schemas.file?r.fsPath:r.path);return k.isWindows&&_.isRootOrDriveLetter(l)?I(l):l}e.getBaseLabel=n;function I(r){return _.hasDriveLetter(r)?r.charAt(0).toUpperCase()+r.slice(1):r}e.normalizeDriveLetter=I;let o=Object.create(null);function h(r,l){if(k.isWindows||!r||!l)return r;let E=o.original===l?o.normalized:void 0;return E||(E=`${S.rtrim(l,T.posix.sep)}${T.posix.sep}`,o={original:l,normalized:E}),(k.isLinux?r.startsWith(E):S.startsWithIgnoreCase(r,E))&&(r=`~/${r.substr(E.length)}`),r}e.tildify=h;function d(r,l){return r.replace(/^~($|\/|\\)/,`${l}$1`)}e.untildify=d;const c="\u2026",b="\\\\",p="~";function w(r,l=T.sep){const E=new Array(r.length);let v=!1;for(let A=0;A<r.length;A++){let P=r[A];if(P===""){E[A]=`.${l}`;continue}if(!P){E[A]=P;continue}v=!0;let a="";P.indexOf(b)===0?(a=P.substr(0,P.indexOf(b)+b.length),P=P.substr(P.indexOf(b)+b.length)):P.indexOf(l)===0?(a=P.substr(0,P.indexOf(l)+l.length),P=P.substr(P.indexOf(l)+l.length)):P.indexOf(p)===0&&(a=P.substr(0,P.indexOf(p)+p.length),P=P.substr(P.indexOf(p)+p.length));const F=P.split(l);for(let N=1;v&&N<=F.length;N++)for(let W=F.length-N;v&&W>=0;W--){v=!1;let le=F.slice(W,W+N).join(l);for(let fe=0;!v&&fe<r.length;fe++)if(fe!==A&&r[fe]&&r[fe].indexOf(le)>-1){const Y=W+N===F.length,H=W>0&&r[fe].indexOf(l)>-1?l+le:le,J=r[fe].endsWith(H);v=!Y||J}if(!v){let fe="";(F[0].endsWith(":")||a!=="")&&(W===1&&(W=0,N++,le=F[0]+l+le),W>0&&(fe=F[0]+l),fe=a+fe),W>0&&(fe=fe+c+l),fe=fe+le,W+N<F.length&&(fe=fe+l+c),E[A]=fe}}v&&(E[A]=P)}return E}e.shorten=w;var u;(function(r){r[r.TEXT=0]="TEXT",r[r.VARIABLE=1]="VARIABLE",r[r.SEPARATOR=2]="SEPARATOR"})(u||(u={}));function f(r,l=Object.create(null)){const E=[];let v=!1,A="";for(const P of r)if(P==="$"||v&&P==="{")A&&E.push({value:A,type:u.TEXT}),A="",v=!0;else if(P==="}"&&v){const a=l[A];if(typeof a=="string")a.length&&E.push({value:a,type:u.VARIABLE});else if(a){const F=E[E.length-1];(!F||F.type!==u.SEPARATOR)&&E.push({value:a.label,type:u.SEPARATOR})}A="",v=!1}else A+=P;return A&&!v&&E.push({value:A,type:u.TEXT}),E.filter((P,a)=>{if(P.type===u.SEPARATOR){const F=E[a-1],N=E[a+1];return[F,N].every(W=>W&&(W.type===u.VARIABLE||W.type===u.TEXT)&&W.value.length>0)}return!0}).map(P=>P.value).join("")}e.template=f;function g(r,l){return k.isMacintosh||l?r.replace(/\(&&\w\)|&&/g,"").replace(/&/g,k.isMacintosh?"&":"&&"):r.replace(/&&|&/g,E=>E==="&"?"&&":"&")}e.mnemonicMenuLabel=g;function t(r,l){return k.isMacintosh||l?r.replace(/\(&&\w\)|&&/g,""):k.isWindows?r.replace(/&&|&/g,E=>E==="&"?"&&":"&"):r.replace(/&&/g,"_")}e.mnemonicButtonLabel=t;function i(r){return r.replace(/&/g,"&&")}e.unmnemonicLabel=i;function s(r){const l=r.indexOf("/")!==-1?T.posix:T.win32,E=l.basename(r),v=l.dirname(r);return E.length?{name:E,parentPath:v}:{name:v,parentPath:""}}e.splitName=s}),define(_e[82],Ee([0,1,14,8,27,16,25]),function(Z,e,m,T,S,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.isUnspecific=e.guessMimeTypes=e.clearTextMimes=e.registerTextMime=e.Mimes=void 0;var D;(function(i){i.text="text/plain",i.binary="application/octet-stream",i.unknown="application/unknown",i.markdown="text/markdown"})(D=e.Mimes||(e.Mimes={}));let _=[],C=[],n=[];function I(i,s=!1){const r=o(i);_.push(r),r.userConfigured?n.push(r):C.push(r),s&&!r.userConfigured&&_.forEach(l=>{l.mime===r.mime||l.userConfigured||(r.extension&&l.extension===r.extension&&console.warn(`Overwriting extension <<${r.extension}>> to now point to mime <<${r.mime}>>`),r.filename&&l.filename===r.filename&&console.warn(`Overwriting filename <<${r.filename}>> to now point to mime <<${r.mime}>>`),r.filepattern&&l.filepattern===r.filepattern&&console.warn(`Overwriting filepattern <<${r.filepattern}>> to now point to mime <<${r.mime}>>`),r.firstline&&l.firstline===r.firstline&&console.warn(`Overwriting firstline <<${r.firstline}>> to now point to mime <<${r.mime}>>`))})}e.registerTextMime=I;function o(i){return{id:i.id,mime:i.mime,filename:i.filename,extension:i.extension,filepattern:i.filepattern,firstline:i.firstline,userConfigured:i.userConfigured,filenameLowercase:i.filename?i.filename.toLowerCase():void 0,extensionLowercase:i.extension?i.extension.toLowerCase():void 0,filepatternLowercase:i.filepattern?i.filepattern.toLowerCase():void 0,filepatternOnPath:i.filepattern?i.filepattern.indexOf(m.posix.sep)>=0:!1}}function h(i){i?(_=_.filter(s=>!s.userConfigured),n=[]):(_=[],C=[],n=[])}e.clearTextMimes=h;function d(i,s){let r;if(i)switch(i.scheme){case y.Schemas.file:r=i.fsPath;break;case y.Schemas.data:r=k.DataUri.parseMetaData(i).get(k.DataUri.META_DATA_LABEL);break;default:r=i.path}if(!r)return[D.unknown];r=r.toLowerCase();const l=m.basename(r),E=c(r,l,n);if(E)return[E,D.text];const v=c(r,l,C);if(v)return[v,D.text];if(s){const A=b(s);if(A)return[A,D.text]}return[D.unknown]}e.guessMimeTypes=d;function c(i,s,r){let l=null,E=null,v=null;for(let A=r.length-1;A>=0;A--){const P=r[A];if(s===P.filenameLowercase){l=P;break}if(P.filepattern&&(!E||P.filepattern.length>E.filepattern.length)){const a=P.filepatternOnPath?i:s;S.match(P.filepatternLowercase,a)&&(E=P)}P.extension&&(!v||P.extension.length>v.extension.length)&&s.endsWith(P.extensionLowercase)&&(v=P)}return l?l.mime:E?E.mime:v?v.mime:null}function b(i){if(T.startsWithUTF8BOM(i)&&(i=i.substr(1)),i.length>0)for(let s=_.length-1;s>=0;s--){const r=_[s];if(!r.firstline)continue;const l=i.match(r.firstline);if(l&&l.length>0)return r.mime}return null}function p(i){return i?typeof i=="string"?i===D.binary||i===D.text||i===D.unknown:i.length===1&&p(i[0]):!0}e.isUnspecific=p;const w={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function u(i){const s=m.extname(i);return w[s.toLowerCase()]}e.getMediaMime=u;function f(i){for(const s in w)if(w[s]===i)return s}e.getExtensionForMimeType=f;const g=/^(.+)\/(.+?)(;.+)?$/;function t(i,s){var r;const l=g.exec(i);return l?`${l[1].toLowerCase()}/${l[2].toLowerCase()}${(r=l[3])!==null&&r!==void 0?r:""}`:s?void 0:i}e.normalizeMimeType=t}),define(_e[113],Ee([0,1,2]),function(Z,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function T(n){return n.toJSON()}class S{constructor(I){this._uriTransformer=I}transformIncoming(I){const o=this._uriTransformer.transformIncoming(I);return o===I?I:T(m.URI.from(o))}transformOutgoing(I){const o=this._uriTransformer.transformOutgoing(I);return o===I?I:T(m.URI.from(o))}transformOutgoingURI(I){const o=this._uriTransformer.transformOutgoing(I);return o===I?I:m.URI.from(o)}transformOutgoingScheme(I){return this._uriTransformer.transformOutgoingScheme(I)}}e.URITransformer=S,e.DefaultURITransformer=new class{transformIncoming(n){return n}transformOutgoing(n){return n}transformOutgoingURI(n){return n}transformOutgoingScheme(n){return n}};function y(n,I,o){if(!n||o>200)return null;if(typeof n=="object"){if(n instanceof m.URI)return I.transformOutgoing(n);for(let h in n)if(Object.hasOwnProperty.call(n,h)){const d=y(n[h],I,o+1);d!==null&&(n[h]=d)}}return null}function k(n,I){const o=y(n,I,0);return o===null?n:o}e.transformOutgoingURIs=k;function D(n,I,o,h){if(!n||h>200)return null;if(typeof n=="object"){if(n.$mid===1)return o?m.URI.revive(I.transformIncoming(n)):I.transformIncoming(n);for(let d in n)if(Object.hasOwnProperty.call(n,d)){const c=D(n[d],I,o,h+1);c!==null&&(n[d]=c)}}return null}function _(n,I){const o=D(n,I,!1,0);return o===null?n:o}e.transformIncomingURIs=_;function C(n,I){const o=D(n,I,!0,0);return o===null?n:o}e.transformAndReviveIncomingURIs=C}),define(_e[34],Ee([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const m=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function T(_){return m.test(_)}e.isUUID=T;const S=new Uint8Array(16),y=[];for(let _=0;_<256;_++)y.push(_.toString(16).padStart(2,"0"));let k;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?k=crypto.getRandomValues.bind(crypto):k=function(_){for(let C=0;C<_.length;C++)_[C]=Math.floor(Math.random()*256);return _};function D(){k(S),S[6]=S[6]&15|64,S[8]=S[8]&63|128;let _=0,C="";return C+=y[S[_++]],C+=y[S[_++]],C+=y[S[_++]],C+=y[S[_++]],C+="-",C+=y[S[_++]],C+=y[S[_++]],C+="-",C+=y[S[_++]],C+=y[S[_++]],C+="-",C+=y[S[_++]],C+=y[S[_++]],C+="-",C+=y[S[_++]],C+=y[S[_++]],C+=y[S[_++]],C+=y[S[_++]],C+=y[S[_++]],C+=y[S[_++]],C}e.generateUuid=D}),define(_e[83],Ee([0,1,79]),function(Z,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharacterSet=e.CharacterClassifier=void 0;class T{constructor(D){let _=m.toUint8(D);this._defaultValue=_,this._asciiMap=T._createAsciiMap(_),this._map=new Map}static _createAsciiMap(D){let _=new Uint8Array(256);for(let C=0;C<256;C++)_[C]=D;return _}set(D,_){let C=m.toUint8(_);D>=0&&D<256?this._asciiMap[D]=C:this._map.set(D,C)}get(D){return D>=0&&D<256?this._asciiMap[D]:this._map.get(D)||this._defaultValue}}e.CharacterClassifier=T;var S;(function(k){k[k.False=0]="False",k[k.True=1]="True"})(S||(S={}));class y{constructor(){this._actual=new T(0)}add(D){this._actual.set(D,1)}has(D){return this._actual.get(D)===1}}e.CharacterSet=y}),define(_e[114],Ee([0,1,83]),function(Z,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMapForWordSeparators=e.WordCharacterClassifier=e.WordCharacterClass=void 0;var T;(function(k){k[k.Regular=0]="Regular",k[k.Whitespace=1]="Whitespace",k[k.WordSeparator=2]="WordSeparator"})(T=e.WordCharacterClass||(e.WordCharacterClass={}));class S extends m.CharacterClassifier{constructor(D){super(0);for(let _=0,C=D.length;_<C;_++)this.set(D.charCodeAt(_),2);this.set(32,1),this.set(9,1)}}e.WordCharacterClassifier=S;function y(k){let D={};return _=>(D.hasOwnProperty(_)||(D[_]=k(_)),D[_])}e.getMapForWordSeparators=y(k=>new S(k))}),define(_e[35],Ee([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Position=void 0;class m{constructor(S,y){this.lineNumber=S,this.column=y}with(S=this.lineNumber,y=this.column){return S===this.lineNumber&&y===this.column?this:new m(S,y)}delta(S=0,y=0){return this.with(this.lineNumber+S,this.column+y)}equals(S){return m.equals(this,S)}static equals(S,y){return!S&&!y?!0:!!S&&!!y&&S.lineNumber===y.lineNumber&&S.column===y.column}isBefore(S){return m.isBefore(this,S)}static isBefore(S,y){return S.lineNumber<y.lineNumber?!0:y.lineNumber<S.lineNumber?!1:S.column<y.column}isBeforeOrEqual(S){return m.isBeforeOrEqual(this,S)}static isBeforeOrEqual(S,y){return S.lineNumber<y.lineNumber?!0:y.lineNumber<S.lineNumber?!1:S.column<=y.column}static compare(S,y){let k=S.lineNumber|0,D=y.lineNumber|0;if(k===D){let _=S.column|0,C=y.column|0;return _-C}return k-D}clone(){return new m(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(S){return new m(S.lineNumber,S.column)}static isIPosition(S){return S&&typeof S.lineNumber=="number"&&typeof S.column=="number"}}e.Position=m}),define(_e[31],Ee([0,1,35]),function(Z,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=void 0;class T{constructor(y,k,D,_){y>D||y===D&&k>_?(this.startLineNumber=D,this.startColumn=_,this.endLineNumber=y,this.endColumn=k):(this.startLineNumber=y,this.startColumn=k,this.endLineNumber=D,this.endColumn=_)}isEmpty(){return T.isEmpty(this)}static isEmpty(y){return y.startLineNumber===y.endLineNumber&&y.startColumn===y.endColumn}containsPosition(y){return T.containsPosition(this,y)}static containsPosition(y,k){return!(k.lineNumber<y.startLineNumber||k.lineNumber>y.endLineNumber||k.lineNumber===y.startLineNumber&&k.column<y.startColumn||k.lineNumber===y.endLineNumber&&k.column>y.endColumn)}containsRange(y){return T.containsRange(this,y)}static containsRange(y,k){return!(k.startLineNumber<y.startLineNumber||k.endLineNumber<y.startLineNumber||k.startLineNumber>y.endLineNumber||k.endLineNumber>y.endLineNumber||k.startLineNumber===y.startLineNumber&&k.startColumn<y.startColumn||k.endLineNumber===y.endLineNumber&&k.endColumn>y.endColumn)}strictContainsRange(y){return T.strictContainsRange(this,y)}static strictContainsRange(y,k){return!(k.startLineNumber<y.startLineNumber||k.endLineNumber<y.startLineNumber||k.startLineNumber>y.endLineNumber||k.endLineNumber>y.endLineNumber||k.startLineNumber===y.startLineNumber&&k.startColumn<=y.startColumn||k.endLineNumber===y.endLineNumber&&k.endColumn>=y.endColumn)}plusRange(y){return T.plusRange(this,y)}static plusRange(y,k){let D,_,C,n;return k.startLineNumber<y.startLineNumber?(D=k.startLineNumber,_=k.startColumn):k.startLineNumber===y.startLineNumber?(D=k.startLineNumber,_=Math.min(k.startColumn,y.startColumn)):(D=y.startLineNumber,_=y.startColumn),k.endLineNumber>y.endLineNumber?(C=k.endLineNumber,n=k.endColumn):k.endLineNumber===y.endLineNumber?(C=k.endLineNumber,n=Math.max(k.endColumn,y.endColumn)):(C=y.endLineNumber,n=y.endColumn),new T(D,_,C,n)}intersectRanges(y){return T.intersectRanges(this,y)}static intersectRanges(y,k){let D=y.startLineNumber,_=y.startColumn,C=y.endLineNumber,n=y.endColumn,I=k.startLineNumber,o=k.startColumn,h=k.endLineNumber,d=k.endColumn;return D<I?(D=I,_=o):D===I&&(_=Math.max(_,o)),C>h?(C=h,n=d):C===h&&(n=Math.min(n,d)),D>C||D===C&&_>n?null:new T(D,_,C,n)}equalsRange(y){return T.equalsRange(this,y)}static equalsRange(y,k){return!!y&&!!k&&y.startLineNumber===k.startLineNumber&&y.startColumn===k.startColumn&&y.endLineNumber===k.endLineNumber&&y.endColumn===k.endColumn}getEndPosition(){return T.getEndPosition(this)}static getEndPosition(y){return new m.Position(y.endLineNumber,y.endColumn)}getStartPosition(){return T.getStartPosition(this)}static getStartPosition(y){return new m.Position(y.startLineNumber,y.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(y,k){return new T(this.startLineNumber,this.startColumn,y,k)}setStartPosition(y,k){return new T(y,k,this.endLineNumber,this.endColumn)}collapseToStart(){return T.collapseToStart(this)}static collapseToStart(y){return new T(y.startLineNumber,y.startColumn,y.startLineNumber,y.startColumn)}static fromPositions(y,k=y){return new T(y.lineNumber,y.column,k.lineNumber,k.column)}static lift(y){return y?new T(y.startLineNumber,y.startColumn,y.endLineNumber,y.endColumn):null}static isIRange(y){return y&&typeof y.startLineNumber=="number"&&typeof y.startColumn=="number"&&typeof y.endLineNumber=="number"&&typeof y.endColumn=="number"}static areIntersectingOrTouching(y,k){return!(y.endLineNumber<k.startLineNumber||y.endLineNumber===k.startLineNumber&&y.endColumn<k.startColumn||k.endLineNumber<y.startLineNumber||k.endLineNumber===y.startLineNumber&&k.endColumn<y.startColumn)}static areIntersecting(y,k){return!(y.endLineNumber<k.startLineNumber||y.endLineNumber===k.startLineNumber&&y.endColumn<=k.startColumn||k.endLineNumber<y.startLineNumber||k.endLineNumber===y.startLineNumber&&k.endColumn<=y.startColumn)}static compareRangesUsingStarts(y,k){if(y&&k){const C=y.startLineNumber|0,n=k.startLineNumber|0;if(C===n){const I=y.startColumn|0,o=k.startColumn|0;if(I===o){const h=y.endLineNumber|0,d=k.endLineNumber|0;if(h===d){const c=y.endColumn|0,b=k.endColumn|0;return c-b}return h-d}return I-o}return C-n}return(y?1:0)-(k?1:0)}static compareRangesUsingEnds(y,k){return y.endLineNumber===k.endLineNumber?y.endColumn===k.endColumn?y.startLineNumber===k.startLineNumber?y.startColumn-k.startColumn:y.startLineNumber-k.startLineNumber:y.endColumn-k.endColumn:y.endLineNumber-k.endLineNumber}static spansMultipleLines(y){return y.endLineNumber>y.startLineNumber}}e.Range=T}),define(_e[115],Ee([0,1,35,31]),function(Z,e,m,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Selection=e.SelectionDirection=void 0;var S;(function(k){k[k.LTR=0]="LTR",k[k.RTL=1]="RTL"})(S=e.SelectionDirection||(e.SelectionDirection={}));class y extends T.Range{constructor(D,_,C,n){super(D,_,C,n);this.selectionStartLineNumber=D,this.selectionStartColumn=_,this.positionLineNumber=C,this.positionColumn=n}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(D){return y.selectionsEqual(this,D)}static selectionsEqual(D,_){return D.selectionStartLineNumber===_.selectionStartLineNumber&&D.selectionStartColumn===_.selectionStartColumn&&D.positionLineNumber===_.positionLineNumber&&D.positionColumn===_.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(D,_){return this.getDirection()===0?new y(this.startLineNumber,this.startColumn,D,_):new y(D,_,this.startLineNumber,this.startColumn)}getPosition(){return new m.Position(this.positionLineNumber,this.positionColumn)}setStartPosition(D,_){return this.getDirection()===0?new y(D,_,this.endLineNumber,this.endColumn):new y(this.endLineNumber,this.endColumn,D,_)}static fromPositions(D,_=D){return new y(D.lineNumber,D.column,_.lineNumber,_.column)}static liftSelection(D){return new y(D.selectionStartLineNumber,D.selectionStartColumn,D.positionLineNumber,D.positionColumn)}static selectionsArrEqual(D,_){if(D&&!_||!D&&_)return!1;if(!D&&!_)return!0;if(D.length!==_.length)return!1;for(let C=0,n=D.length;C<n;C++)if(!this.selectionsEqual(D[C],_[C]))return!1;return!0}static isISelection(D){return D&&typeof D.selectionStartLineNumber=="number"&&typeof D.selectionStartColumn=="number"&&typeof D.positionLineNumber=="number"&&typeof D.positionColumn=="number"}static createWithDirection(D,_,C,n,I){return I===0?new y(D,_,C,n):new y(C,n,D,_)}}e.Selection=y}),define(_e[84],Ee([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApplyEditsResult=e.ValidAnnotatedEditOperation=e.ModelConstants=e.PositionNormalizationAffinity=e.TrackedRangeStickiness=e.FindMatch=e.TextModelResolvedOptions=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.MinimapPosition=e.OverviewRulerLane=void 0;var m;(function(d){d[d.Left=1]="Left",d[d.Center=2]="Center",d[d.Right=4]="Right",d[d.Full=7]="Full"})(m=e.OverviewRulerLane||(e.OverviewRulerLane={}));var T;(function(d){d[d.Inline=1]="Inline",d[d.Gutter=2]="Gutter"})(T=e.MinimapPosition||(e.MinimapPosition={}));var S;(function(d){d[d.TextDefined=0]="TextDefined",d[d.LF=1]="LF",d[d.CRLF=2]="CRLF"})(S=e.EndOfLinePreference||(e.EndOfLinePreference={}));var y;(function(d){d[d.LF=1]="LF",d[d.CRLF=2]="CRLF"})(y=e.DefaultEndOfLine||(e.DefaultEndOfLine={}));var k;(function(d){d[d.LF=0]="LF",d[d.CRLF=1]="CRLF"})(k=e.EndOfLineSequence||(e.EndOfLineSequence={}));class D{constructor(c){this.tabSize=Math.max(1,c.tabSize|0),this.indentSize=c.tabSize|0,this.insertSpaces=Boolean(c.insertSpaces),this.defaultEOL=c.defaultEOL|0,this.trimAutoWhitespace=Boolean(c.trimAutoWhitespace)}equals(c){return this.tabSize===c.tabSize&&this.indentSize===c.indentSize&&this.insertSpaces===c.insertSpaces&&this.defaultEOL===c.defaultEOL&&this.trimAutoWhitespace===c.trimAutoWhitespace}createChangeEvent(c){return{tabSize:this.tabSize!==c.tabSize,indentSize:this.indentSize!==c.indentSize,insertSpaces:this.insertSpaces!==c.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==c.trimAutoWhitespace}}}e.TextModelResolvedOptions=D;class _{constructor(c,b){this.range=c,this.matches=b}}e.FindMatch=_;var C;(function(d){d[d.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",d[d.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",d[d.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",d[d.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(C=e.TrackedRangeStickiness||(e.TrackedRangeStickiness={}));var n;(function(d){d[d.Left=0]="Left",d[d.Right=1]="Right"})(n=e.PositionNormalizationAffinity||(e.PositionNormalizationAffinity={}));var I;(function(d){d[d.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(I=e.ModelConstants||(e.ModelConstants={}));class o{constructor(c,b,p,w,u,f){this.identifier=c,this.range=b,this.text=p,this.forceMoveMarkers=w,this.isAutoWhitespaceEdit=u,this._isTracked=f}}e.ValidAnnotatedEditOperation=o;class h{constructor(c,b,p){this.reverseEdits=c,this.changes=b,this.trimAutoWhitespaceLineNumbers=p}}e.ApplyEditsResult=h}),define(_e[116],Ee([0,1,8,114,35,31,84]),function(Z,e,m,T,S,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Searcher=e.isValidMatch=e.TextModelSearch=e.createFindMatch=e.SearchData=e.isMultilineRegexSource=e.SearchParams=void 0;const D=999;class _{constructor(u,f,g,t){this.searchString=u,this.isRegex=f,this.matchCase=g,this.wordSeparators=t}parseSearchRequest(){if(this.searchString==="")return null;let u;this.isRegex?u=C(this.searchString):u=this.searchString.indexOf(`
`)>=0;let f=null;try{f=m.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:u,global:!0,unicode:!0})}catch(t){return null}if(!f)return null;let g=!this.isRegex&&!u;return g&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(g=this.matchCase),new n(f,this.wordSeparators?T.getMapForWordSeparators(this.wordSeparators):null,g?this.searchString:null)}}e.SearchParams=_;function C(w){if(!w||w.length===0)return!1;for(let u=0,f=w.length;u<f;u++)if(w.charCodeAt(u)===92){if(u++,u>=f)break;const t=w.charCodeAt(u);if(t===110||t===114||t===87||t===119)return!0}return!1}e.isMultilineRegexSource=C;class n{constructor(u,f,g){this.regex=u,this.wordSeparators=f,this.simpleSearch=g}}e.SearchData=n;function I(w,u,f){if(!f)return new k.FindMatch(w,null);let g=[];for(let t=0,i=u.length;t<i;t++)g[t]=u[t];return new k.FindMatch(w,g)}e.createFindMatch=I;class o{constructor(u){let f=[],g=0;for(let t=0,i=u.length;t<i;t++)u.charCodeAt(t)===10&&(f[g++]=t);this._lineFeedsOffsets=f}findLineFeedCountBeforeOffset(u){const f=this._lineFeedsOffsets;let g=0,t=f.length-1;if(t===-1||u<=f[0])return 0;for(;g<t;){const i=g+((t-g)/2>>0);f[i]>=u?t=i-1:f[i+1]>=u?(g=i,t=i):g=i+1}return g+1}}class h{static findMatches(u,f,g,t,i){const s=f.parseSearchRequest();return s?s.regex.multiline?this._doFindMatchesMultiline(u,g,new p(s.wordSeparators,s.regex),t,i):this._doFindMatchesLineByLine(u,g,s,t,i):[]}static _getMultilineMatchRange(u,f,g,t,i,s){let r,l=0;t?(l=t.findLineFeedCountBeforeOffset(i),r=f+i+l):r=f+i;let E;if(t){let a=t.findLineFeedCountBeforeOffset(i+s.length)-l;E=r+s.length+a}else E=r+s.length;const v=u.getPositionAt(r),A=u.getPositionAt(E);return new y.Range(v.lineNumber,v.column,A.lineNumber,A.column)}static _doFindMatchesMultiline(u,f,g,t,i){const s=u.getOffsetAt(f.getStartPosition()),r=u.getValueInRange(f,1),l=u.getEOL()===`\r
`?new o(r):null,E=[];let v=0,A;for(g.reset(0);A=g.next(r);)if(E[v++]=I(this._getMultilineMatchRange(u,s,r,l,A.index,A[0]),A,t),v>=i)return E;return E}static _doFindMatchesLineByLine(u,f,g,t,i){const s=[];let r=0;if(f.startLineNumber===f.endLineNumber){const E=u.getLineContent(f.startLineNumber).substring(f.startColumn-1,f.endColumn-1);return r=this._findMatchesInLine(g,E,f.startLineNumber,f.startColumn-1,r,s,t,i),s}const l=u.getLineContent(f.startLineNumber).substring(f.startColumn-1);r=this._findMatchesInLine(g,l,f.startLineNumber,f.startColumn-1,r,s,t,i);for(let E=f.startLineNumber+1;E<f.endLineNumber&&r<i;E++)r=this._findMatchesInLine(g,u.getLineContent(E),E,0,r,s,t,i);if(r<i){const E=u.getLineContent(f.endLineNumber).substring(0,f.endColumn-1);r=this._findMatchesInLine(g,E,f.endLineNumber,0,r,s,t,i)}return s}static _findMatchesInLine(u,f,g,t,i,s,r,l){const E=u.wordSeparators;if(!r&&u.simpleSearch){const P=u.simpleSearch,a=P.length,F=f.length;let N=-a;for(;(N=f.indexOf(P,N+a))!==-1;)if((!E||b(E,f,F,N,a))&&(s[i++]=new k.FindMatch(new y.Range(g,N+1+t,g,N+1+a+t),null),i>=l))return i;return i}const v=new p(u.wordSeparators,u.regex);let A;v.reset(0);do if(A=v.next(f),A&&(s[i++]=I(new y.Range(g,A.index+1+t,g,A.index+1+A[0].length+t),A,r),i>=l))return i;while(A);return i}static findNextMatch(u,f,g,t){const i=f.parseSearchRequest();if(!i)return null;const s=new p(i.wordSeparators,i.regex);return i.regex.multiline?this._doFindNextMatchMultiline(u,g,s,t):this._doFindNextMatchLineByLine(u,g,s,t)}static _doFindNextMatchMultiline(u,f,g,t){const i=new S.Position(f.lineNumber,1),s=u.getOffsetAt(i),r=u.getLineCount(),l=u.getValueInRange(new y.Range(i.lineNumber,i.column,r,u.getLineMaxColumn(r)),1),E=u.getEOL()===`\r
`?new o(l):null;g.reset(f.column-1);let v=g.next(l);return v?I(this._getMultilineMatchRange(u,s,l,E,v.index,v[0]),v,t):f.lineNumber!==1||f.column!==1?this._doFindNextMatchMultiline(u,new S.Position(1,1),g,t):null}static _doFindNextMatchLineByLine(u,f,g,t){const i=u.getLineCount(),s=f.lineNumber,r=u.getLineContent(s),l=this._findFirstMatchInLine(g,r,s,f.column,t);if(l)return l;for(let E=1;E<=i;E++){const v=(s+E-1)%i,A=u.getLineContent(v+1),P=this._findFirstMatchInLine(g,A,v+1,1,t);if(P)return P}return null}static _findFirstMatchInLine(u,f,g,t,i){u.reset(t-1);const s=u.next(f);return s?I(new y.Range(g,s.index+1,g,s.index+1+s[0].length),s,i):null}static findPreviousMatch(u,f,g,t){const i=f.parseSearchRequest();if(!i)return null;const s=new p(i.wordSeparators,i.regex);return i.regex.multiline?this._doFindPreviousMatchMultiline(u,g,s,t):this._doFindPreviousMatchLineByLine(u,g,s,t)}static _doFindPreviousMatchMultiline(u,f,g,t){const i=this._doFindMatchesMultiline(u,new y.Range(1,1,f.lineNumber,f.column),g,t,10*D);if(i.length>0)return i[i.length-1];const s=u.getLineCount();return f.lineNumber!==s||f.column!==u.getLineMaxColumn(s)?this._doFindPreviousMatchMultiline(u,new S.Position(s,u.getLineMaxColumn(s)),g,t):null}static _doFindPreviousMatchLineByLine(u,f,g,t){const i=u.getLineCount(),s=f.lineNumber,r=u.getLineContent(s).substring(0,f.column-1),l=this._findLastMatchInLine(g,r,s,t);if(l)return l;for(let E=1;E<=i;E++){const v=(i+s-E-1)%i,A=u.getLineContent(v+1),P=this._findLastMatchInLine(g,A,v+1,t);if(P)return P}return null}static _findLastMatchInLine(u,f,g,t){let i=null,s;for(u.reset(0);s=u.next(f);)i=I(new y.Range(g,s.index+1,g,s.index+1+s[0].length),s,t);return i}}e.TextModelSearch=h;function d(w,u,f,g,t){if(g===0)return!0;const i=u.charCodeAt(g-1);if(w.get(i)!==0||i===13||i===10)return!0;if(t>0){const s=u.charCodeAt(g);if(w.get(s)!==0)return!0}return!1}function c(w,u,f,g,t){if(g+t===f)return!0;const i=u.charCodeAt(g+t);if(w.get(i)!==0||i===13||i===10)return!0;if(t>0){const s=u.charCodeAt(g+t-1);if(w.get(s)!==0)return!0}return!1}function b(w,u,f,g,t){return d(w,u,f,g,t)&&c(w,u,f,g,t)}e.isValidMatch=b;class p{constructor(u,f){this._wordSeparators=u,this._searchRegex=f,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(u){this._searchRegex.lastIndex=u,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(u){const f=u.length;let g;do{if(this._prevMatchStartIndex+this._prevMatchLength===f||(g=this._searchRegex.exec(u),!g))return null;const t=g.index,i=g[0].length;if(t===this._prevMatchStartIndex&&i===this._prevMatchLength){if(i===0){m.getNextCodePoint(u,f,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=t,this._prevMatchLength=i,!this._wordSeparators||b(this._wordSeparators,u,f,t,i))return g}while(g);return null}}e.Searcher=p}),define(_e[85],Ee([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWordAtText=e.ensureValidWordDefinition=e.DEFAULT_WORD_REGEXP=e.USUAL_WORD_SEPARATORS=void 0,e.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function m(D=""){let _="(-?\\d*\\.\\d\\w*)|([^";for(const C of e.USUAL_WORD_SEPARATORS)D.indexOf(C)>=0||(_+="\\"+C);return _+="\\s]+)",new RegExp(_,"g")}e.DEFAULT_WORD_REGEXP=m();function T(D){let _=e.DEFAULT_WORD_REGEXP;if(D&&D instanceof RegExp)if(D.global)_=D;else{let C="g";D.ignoreCase&&(C+="i"),D.multiline&&(C+="m"),D.unicode&&(C+="u"),_=new RegExp(D.source,C)}return _.lastIndex=0,_}e.ensureValidWordDefinition=T;const S={maxLen:1e3,windowSize:15,timeBudget:150};function y(D,_,C,n,I=S){if(C.length>I.maxLen){let b=D-I.maxLen/2;return b<0?b=0:n+=b,C=C.substring(b,D+I.maxLen/2),y(D,_,C,n,I)}const o=Date.now(),h=D-1-n;let d=-1,c=null;for(let b=1;!(Date.now()-o>=I.timeBudget);b++){const p=h-I.windowSize*b;_.lastIndex=Math.max(0,p);const w=k(_,C,h,d);if(!w&&c||(c=w,p<=0))break;d=p}if(c){let b={word:c[0],startColumn:n+1+c.index,endColumn:n+1+c.index+c[0].length};return _.lastIndex=0,b}return null}e.getWordAtText=y;function k(D,_,C,n){let I;for(;I=D.exec(_);){const o=I.index||0;if(o<=C&&D.lastIndex>=C)return I;if(n>0&&o>n)return null}return null}}),define(_e[117],Ee([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var m;(function(k){k[k.None=0]="None",k[k.Indent=1]="Indent",k[k.IndentOutdent=2]="IndentOutdent",k[k.Outdent=3]="Outdent"})(m=e.IndentAction||(e.IndentAction={}));class T{constructor(D){if(this.open=D.open,this.close=D.close,this._standardTokenMask=0,Array.isArray(D.notIn))for(let _=0,C=D.notIn.length;_<C;_++)switch(D.notIn[_]){case"string":this._standardTokenMask|=2;break;case"comment":this._standardTokenMask|=1;break;case"regex":this._standardTokenMask|=4;break}}isOK(D){return(this._standardTokenMask&D)==0}}e.StandardAutoClosingPairConditional=T;class S{constructor(D){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const _ of D)y(this.autoClosingPairsOpenByStart,_.open.charAt(0),_),y(this.autoClosingPairsOpenByEnd,_.open.charAt(_.open.length-1),_),y(this.autoClosingPairsCloseByStart,_.close.charAt(0),_),y(this.autoClosingPairsCloseByEnd,_.close.charAt(_.close.length-1),_),_.close.length===1&&_.open.length===1&&y(this.autoClosingPairsCloseSingleChar,_.close,_)}}e.AutoClosingPairs=S;function y(k,D,_){k.has(D)?k.get(D).push(_):k.set(D,[_])}}),define(_e[55],Ee([0,1,27,14]),function(Z,e,m,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function S(y,k,D,_){if(Array.isArray(y)){let C=0;for(const n of y){const I=S(n,k,D,_);if(I===10)return I;I>C&&(C=I)}return C}else{if(typeof y=="string")return _?y==="*"?5:y===D?10:0:0;if(y){const{language:C,pattern:n,scheme:I,hasAccessToAllModels:o}=y;if(!_&&!o)return 0;let h=0;if(I)if(I===k.scheme)h=10;else if(I==="*")h=5;else return 0;if(C)if(C===D)h=10;else if(C==="*")h=Math.max(h,5);else return 0;if(n){let d;if(typeof n=="string"?d=n:d=Object.assign(Object.assign({},n),{base:T.normalize(n.base)}),d===k.fsPath||m.match(d,k.fsPath))h=10;else return 0}return h}else return 0}}e.score=S}),define(_e[118],Ee([0,1,83]),function(Z,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeLinks=e.LinkComputer=e.StateMachine=e.Uint8Matrix=e.State=void 0;var T;(function(h){h[h.Invalid=0]="Invalid",h[h.Start=1]="Start",h[h.H=2]="H",h[h.HT=3]="HT",h[h.HTT=4]="HTT",h[h.HTTP=5]="HTTP",h[h.F=6]="F",h[h.FI=7]="FI",h[h.FIL=8]="FIL",h[h.BeforeColon=9]="BeforeColon",h[h.AfterColon=10]="AfterColon",h[h.AlmostThere=11]="AlmostThere",h[h.End=12]="End",h[h.Accept=13]="Accept",h[h.LastKnownState=14]="LastKnownState"})(T=e.State||(e.State={}));class S{constructor(d,c,b){const p=new Uint8Array(d*c);for(let w=0,u=d*c;w<u;w++)p[w]=b;this._data=p,this.rows=d,this.cols=c}get(d,c){return this._data[d*this.cols+c]}set(d,c,b){this._data[d*this.cols+c]=b}}e.Uint8Matrix=S;class y{constructor(d){let c=0,b=0;for(let w=0,u=d.length;w<u;w++){let[f,g,t]=d[w];g>c&&(c=g),f>b&&(b=f),t>b&&(b=t)}c++,b++;let p=new S(b,c,0);for(let w=0,u=d.length;w<u;w++){let[f,g,t]=d[w];p.set(f,g,t)}this._states=p,this._maxCharCode=c}nextState(d,c){return c<0||c>=this._maxCharCode?0:this._states.get(d,c)}}e.StateMachine=y;let k=null;function D(){return k===null&&(k=new y([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),k}var _;(function(h){h[h.None=0]="None",h[h.ForceTermination=1]="ForceTermination",h[h.CannotEndIn=2]="CannotEndIn"})(_||(_={}));let C=null;function n(){if(C===null){C=new m.CharacterClassifier(0);const h=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let c=0;c<h.length;c++)C.set(h.charCodeAt(c),1);const d=".,;";for(let c=0;c<d.length;c++)C.set(d.charCodeAt(c),2)}return C}class I{static _createLink(d,c,b,p,w){let u=w-1;do{const f=c.charCodeAt(u);if(d.get(f)!==2)break;u--}while(u>p);if(p>0){const f=c.charCodeAt(p-1),g=c.charCodeAt(u);(f===40&&g===41||f===91&&g===93||f===123&&g===125)&&u--}return{range:{startLineNumber:b,startColumn:p+1,endLineNumber:b,endColumn:u+2},url:c.substring(p,u+1)}}static computeLinks(d,c=D()){const b=n();let p=[];for(let w=1,u=d.getLineCount();w<=u;w++){const f=d.getLineContent(w),g=f.length;let t=0,i=0,s=0,r=1,l=!1,E=!1,v=!1,A=!1;for(;t<g;){let P=!1;const a=f.charCodeAt(t);if(r===13){let F;switch(a){case 40:l=!0,F=0;break;case 41:F=l?0:1;break;case 91:v=!0,E=!0,F=0;break;case 93:v=!1,F=E?0:1;break;case 123:A=!0,F=0;break;case 125:F=A?0:1;break;case 39:F=s===34||s===96?0:1;break;case 34:F=s===39||s===96?0:1;break;case 96:F=s===39||s===34?0:1;break;case 42:F=s===42?1:0;break;case 124:F=s===124?1:0;break;case 32:F=v?0:1;break;default:F=b.get(a)}F===1&&(p.push(I._createLink(b,f,w,i,t)),P=!0)}else if(r===12){let F;a===91?(E=!0,F=0):F=b.get(a),F===1?P=!0:r=13}else r=c.nextState(r,a),r===0&&(P=!0);P&&(r=1,l=!1,E=!1,A=!1,i=t+1,s=a),t++}r===13&&p.push(I._createLink(b,f,w,i,g))}return p}}e.LinkComputer=I;function o(h){return!h||typeof h.getLineCount!="function"||typeof h.getLineContent!="function"?[]:I.computeLinks(h)}e.computeLinks=o}),define(_e[119],Ee([0,1,3,7]),function(Z,e,m,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistryImpl=void 0;class S{constructor(){this._map=new Map,this._promises=new Map,this._onDidChange=new m.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}fire(k){this._onDidChange.fire({changedLanguages:k,changedColorMap:!1})}register(k,D){return this._map.set(k,D),this.fire([k]),T.toDisposable(()=>{this._map.get(k)===D&&(this._map.delete(k),this.fire([k]))})}registerPromise(k,D){let _=null,C=!1;return this._promises.set(k,D.then(n=>{this._promises.delete(k),!(C||!n)&&(_=this.register(k,n))})),T.toDisposable(()=>{C=!0,_&&_.dispose()})}getPromise(k){const D=this.get(k);if(D)return Promise.resolve(D);const _=this._promises.get(k);return _?_.then(C=>this.get(k)):null}get(k){return this._map.get(k)||null}setColorMap(k){this._colorMap=k,this._onDidChange.fire({changedLanguages:Array.from(this._map.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}e.TokenizationRegistryImpl=S}),define(_e[86],Ee([0,1,23,21]),function(Z,e,m,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var S;(function(I){I[I.Full=1]="Full",I[I.Delta=2]="Delta"})(S||(S={}));function y(I){for(let o=0,h=I.length;o<h;o+=4){const d=I[o+0],c=I[o+1],b=I[o+2],p=I[o+3];I[o+0]=p,I[o+1]=b,I[o+2]=c,I[o+3]=d}}function k(I){const o=new Uint8Array(I.buffer,I.byteOffset,I.length*4);return T.isLittleEndian()||y(o),m.VSBuffer.wrap(o)}function D(I){const o=I.buffer;if(T.isLittleEndian()||y(o),o.byteOffset%4==0)return new Uint32Array(o.buffer,o.byteOffset,o.length/4);{const h=new Uint8Array(o.byteLength);return h.set(o),new Uint32Array(h.buffer,h.byteOffset,h.length/4)}}function _(I){const o=new Uint32Array(C(I));let h=0;if(o[h++]=I.id,I.type==="full")o[h++]=1,o[h++]=I.data.length,o.set(I.data,h),h+=I.data.length;else{o[h++]=2,o[h++]=I.deltas.length;for(const d of I.deltas)o[h++]=d.start,o[h++]=d.deleteCount,d.data?(o[h++]=d.data.length,o.set(d.data,h),h+=d.data.length):o[h++]=0}return k(o)}e.encodeSemanticTokensDto=_;function C(I){let o=0;if(o+=1+1,I.type==="full")o+=1+I.data.length;else{o+=1,o+=(1+1+1)*I.deltas.length;for(const h of I.deltas)h.data&&(o+=h.data.length)}return o}function n(I){const o=D(I);let h=0;const d=o[h++];if(o[h++]===1){const w=o[h++],u=o.subarray(h,h+w);return h+=w,{id:d,type:"full",data:u}}const b=o[h++];let p=[];for(let w=0;w<b;w++){const u=o[h++],f=o[h++],g=o[h++];let t;g>0&&(t=o.subarray(h,h+g),h+=g),p[w]={start:u,deleteCount:f,data:t}}return{id:d,type:"delta",deltas:p}}e.decodeSemanticTokensDto=n}),define(_e[87],Ee([0,1,79]),function(Z,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PrefixSumComputer=e.PrefixSumIndexOfResult=void 0;class T{constructor(k,D){this.index=k,this.remainder=D}}e.PrefixSumIndexOfResult=T;class S{constructor(k){this.values=k,this.prefixSum=new Uint32Array(k.length),this.prefixSumValidIndex=new Int32Array(1),this.prefixSumValidIndex[0]=-1}getCount(){return this.values.length}insertValues(k,D){k=m.toUint32(k);const _=this.values,C=this.prefixSum,n=D.length;return n===0?!1:(this.values=new Uint32Array(_.length+n),this.values.set(_.subarray(0,k),0),this.values.set(_.subarray(k),k+n),this.values.set(D,k),k-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=k-1),this.prefixSum=new Uint32Array(this.values.length),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(C.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}changeValue(k,D){return k=m.toUint32(k),D=m.toUint32(D),this.values[k]===D?!1:(this.values[k]=D,k-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=k-1),!0)}removeValues(k,D){k=m.toUint32(k),D=m.toUint32(D);const _=this.values,C=this.prefixSum;if(k>=_.length)return!1;let n=_.length-k;return D>=n&&(D=n),D===0?!1:(this.values=new Uint32Array(_.length-D),this.values.set(_.subarray(0,k),0),this.values.set(_.subarray(k+D),k),this.prefixSum=new Uint32Array(this.values.length),k-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=k-1),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(C.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}getTotalValue(){return this.values.length===0?0:this._getAccumulatedValue(this.values.length-1)}getAccumulatedValue(k){return k<0?0:(k=m.toUint32(k),this._getAccumulatedValue(k))}_getAccumulatedValue(k){if(k<=this.prefixSumValidIndex[0])return this.prefixSum[k];let D=this.prefixSumValidIndex[0]+1;D===0&&(this.prefixSum[0]=this.values[0],D++),k>=this.values.length&&(k=this.values.length-1);for(let _=D;_<=k;_++)this.prefixSum[_]=this.prefixSum[_-1]+this.values[_];return this.prefixSumValidIndex[0]=Math.max(this.prefixSumValidIndex[0],k),this.prefixSum[k]}getIndexOf(k){k=Math.floor(k),this.getTotalValue();let D=0,_=this.values.length-1,C=0,n=0,I=0;for(;D<=_;)if(C=D+(_-D)/2|0,n=this.prefixSum[C],I=n-this.values[C],k<I)_=C-1;else if(k>=n)D=C+1;else break;return new T(C,k-I)}}e.PrefixSumComputer=S}),define(_e[120],Ee([0,1,8,35,87]),function(Z,e,m,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MirrorTextModel=void 0;class y{constructor(D,_,C,n){this._uri=D,this._lines=_,this._eol=C,this._versionId=n,this._lineStarts=null,this._cachedTextValue=null}dispose(){this._lines.length=0}get version(){return this._versionId}getText(){return this._cachedTextValue===null&&(this._cachedTextValue=this._lines.join(this._eol)),this._cachedTextValue}onEvents(D){D.eol&&D.eol!==this._eol&&(this._eol=D.eol,this._lineStarts=null);const _=D.changes;for(const C of _)this._acceptDeleteRange(C.range),this._acceptInsertText(new T.Position(C.range.startLineNumber,C.range.startColumn),C.text);this._versionId=D.versionId,this._cachedTextValue=null}_ensureLineStarts(){if(!this._lineStarts){const D=this._eol.length,_=this._lines.length,C=new Uint32Array(_);for(let n=0;n<_;n++)C[n]=this._lines[n].length+D;this._lineStarts=new S.PrefixSumComputer(C)}}_setLineText(D,_){this._lines[D]=_,this._lineStarts&&this._lineStarts.changeValue(D,this._lines[D].length+this._eol.length)}_acceptDeleteRange(D){if(D.startLineNumber===D.endLineNumber){if(D.startColumn===D.endColumn)return;this._setLineText(D.startLineNumber-1,this._lines[D.startLineNumber-1].substring(0,D.startColumn-1)+this._lines[D.startLineNumber-1].substring(D.endColumn-1));return}this._setLineText(D.startLineNumber-1,this._lines[D.startLineNumber-1].substring(0,D.startColumn-1)+this._lines[D.endLineNumber-1].substring(D.endColumn-1)),this._lines.splice(D.startLineNumber,D.endLineNumber-D.startLineNumber),this._lineStarts&&this._lineStarts.removeValues(D.startLineNumber,D.endLineNumber-D.startLineNumber)}_acceptInsertText(D,_){if(_.length===0)return;let C=m.splitLines(_);if(C.length===1){this._setLineText(D.lineNumber-1,this._lines[D.lineNumber-1].substring(0,D.column-1)+C[0]+this._lines[D.lineNumber-1].substring(D.column-1));return}C[C.length-1]+=this._lines[D.lineNumber-1].substring(D.column-1),this._setLineText(D.lineNumber-1,this._lines[D.lineNumber-1].substring(0,D.column-1)+C[0]);let n=new Uint32Array(C.length-1);for(let I=1;I<C.length;I++)this._lines.splice(D.lineNumber+I-1,0,C[I]),n[I-1]=C[I].length+this._eol.length;this._lineStarts&&this._lineStarts.insertValues(D.lineNumber,n)}}e.MirrorTextModel=y}),define(_e[121],Ee([19,20]),function(Z,e){return Z.create("vs/base/common/errorMessage",e)}),define(_e[56],Ee([0,1,121,10,17]),function(Z,e,m,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function y(C,n){return n&&(C.stack||C.stacktrace)?m.localize(0,null,D(C),k(C.stack)||k(C.stacktrace)):D(C)}function k(C){return Array.isArray(C)?C.join(`
`):C}function D(C){return typeof C.code=="string"&&typeof C.errno=="number"&&typeof C.syscall=="string"?m.localize(1,null,C.message):C.message||m.localize(2,null)}function _(C=null,n=!1){if(!C)return m.localize(3,null);if(Array.isArray(C)){const I=S.coalesce(C),o=_(I[0],n);return I.length>1?m.localize(4,null,o,I.length):o}if(T.isString(C))return C;if(C.detail){const I=C.detail;if(I.error)return y(I.error,n);if(I.exception)return y(I.exception,n)}return C.stack?y(C,n):C.message?C.message:m.localize(5,null)}e.toErrorMessage=_}),define(_e[122],Ee([19,20]),function(Z,e){return Z.create("vs/editor/common/config/editorOptions",e)}),define(_e[123],Ee([0,1,122,21,85]),function(Z,e,m,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_MODEL_DEFAULTS=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.boolean=e.ComputeOptionsMemory=e.ValidatedEditorOptions=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var y;(function(V){V[V.None=0]="None",V[V.Keep=1]="Keep",V[V.Brackets=2]="Brackets",V[V.Advanced=3]="Advanced",V[V.Full=4]="Full"})(y=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class k{constructor(ee){this._values=ee}hasChanged(ee){return this._values[ee]}}e.ConfigurationChangedEvent=k;class D{constructor(){this._values=[]}_read(ee){return this._values[ee]}get(ee){return this._values[ee]}_write(ee,me){this._values[ee]=me}}e.ValidatedEditorOptions=D;class _{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=_;class C{constructor(ee,me,Re,Le){this.id=ee,this.name=me,this.defaultValue=Re,this.schema=Le}compute(ee,me,Re){return Re}}class n{constructor(ee,me=null){this.schema=void 0,this.id=ee,this.name="_never_",this.defaultValue=void 0,this.deps=me}validate(ee){return this.defaultValue}}class I{constructor(ee,me,Re,Le){this.id=ee,this.name=me,this.defaultValue=Re,this.schema=Le}validate(ee){return typeof ee=="undefined"?this.defaultValue:ee}compute(ee,me,Re){return Re}}function o(V,ee){return typeof V=="undefined"?ee:V==="false"?!1:Boolean(V)}e.boolean=o;class h extends I{constructor(ee,me,Re,Le=void 0){typeof Le!="undefined"&&(Le.type="boolean",Le.default=Re),super(ee,me,Re,Le)}validate(ee){return o(ee,this.defaultValue)}}class d extends I{constructor(ee,me,Re,Le,qe,Se=void 0){typeof Se!="undefined"&&(Se.type="integer",Se.default=Re,Se.minimum=Le,Se.maximum=qe),super(ee,me,Re,Se),this.minimum=Le,this.maximum=qe}static clampedInt(ee,me,Re,Le){if(typeof ee=="undefined")return me;let qe=parseInt(ee,10);return isNaN(qe)?me:(qe=Math.max(Re,qe),qe=Math.min(Le,qe),qe|0)}validate(ee){return d.clampedInt(ee,this.defaultValue,this.minimum,this.maximum)}}class c extends I{constructor(ee,me,Re,Le,qe){typeof qe!="undefined"&&(qe.type="number",qe.default=Re),super(ee,me,Re,qe),this.validationFn=Le}static clamp(ee,me,Re){return ee<me?me:ee>Re?Re:ee}static float(ee,me){if(typeof ee=="number")return ee;if(typeof ee=="undefined")return me;const Re=parseFloat(ee);return isNaN(Re)?me:Re}validate(ee){return this.validationFn(c.float(ee,this.defaultValue))}}class b extends I{static string(ee,me){return typeof ee!="string"?me:ee}constructor(ee,me,Re,Le=void 0){typeof Le!="undefined"&&(Le.type="string",Le.default=Re),super(ee,me,Re,Le)}validate(ee){return b.string(ee,this.defaultValue)}}function p(V,ee,me){return typeof V!="string"||me.indexOf(V)===-1?ee:V}e.stringSet=p;class w extends I{constructor(ee,me,Re,Le,qe=void 0){typeof qe!="undefined"&&(qe.type="string",qe.enum=Le,qe.default=Re),super(ee,me,Re,qe),this._allowedValues=Le}validate(ee){return p(ee,this.defaultValue,this._allowedValues)}}class u extends C{constructor(ee,me,Re,Le,qe,Se,we=void 0){typeof we!="undefined"&&(we.type="string",we.enum=qe,we.default=Le),super(ee,me,Re,we),this._allowedValues=qe,this._convert=Se}validate(ee){return typeof ee!="string"?this.defaultValue:this._allowedValues.indexOf(ee)===-1?this.defaultValue:this._convert(ee)}}function f(V){switch(V){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class g extends C{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[m.localize(0,null),m.localize(1,null),m.localize(2,null)],default:"auto",description:m.localize(3,null)})}validate(ee){switch(ee){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(ee,me,Re){return Re===0?ee.accessibilitySupport:Re}}class t extends C{constructor(){const ee={insertSpace:!0,ignoreEmptyLines:!0};super(17,"comments",ee,{"editor.comments.insertSpace":{type:"boolean",default:ee.insertSpace,description:m.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:ee.ignoreEmptyLines,description:m.localize(5,null)}})}validate(ee){if(!ee||typeof ee!="object")return this.defaultValue;const me=ee;return{insertSpace:o(me.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:o(me.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var i;(function(V){V[V.Hidden=0]="Hidden",V[V.Blink=1]="Blink",V[V.Smooth=2]="Smooth",V[V.Phase=3]="Phase",V[V.Expand=4]="Expand",V[V.Solid=5]="Solid"})(i=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function s(V){switch(V){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var r;(function(V){V[V.Line=1]="Line",V[V.Block=2]="Block",V[V.Underline=3]="Underline",V[V.LineThin=4]="LineThin",V[V.BlockOutline=5]="BlockOutline",V[V.UnderlineThin=6]="UnderlineThin"})(r=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function l(V){switch(V){case r.Line:return"line";case r.Block:return"block";case r.Underline:return"underline";case r.LineThin:return"line-thin";case r.BlockOutline:return"block-outline";case r.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=l;function E(V){switch(V){case"line":return r.Line;case"block":return r.Block;case"underline":return r.Underline;case"line-thin":return r.LineThin;case"block-outline":return r.BlockOutline;case"underline-thin":return r.UnderlineThin}}class v extends n{constructor(){super(125,[63,31])}compute(ee,me,Re){const Le=["monaco-editor"];return me.get(31)&&Le.push(me.get(31)),ee.extraEditorClassName&&Le.push(ee.extraEditorClassName),me.get(63)==="default"?Le.push("mouse-default"):me.get(63)==="copy"&&Le.push("mouse-copy"),me.get(98)&&Le.push("showUnused"),me.get(123)&&Le.push("showDeprecated"),Le.join(" ")}}class A extends h{constructor(){super(30,"emptySelectionClipboard",!0,{description:m.localize(6,null)})}compute(ee,me,Re){return Re&&ee.emptySelectionClipboard}}class P extends C{constructor(){const ee={cursorMoveOnType:!0,seedSearchStringFromSelection:!0,autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(33,"find",ee,{"editor.find.cursorMoveOnType":{type:"boolean",default:ee.cursorMoveOnType,description:m.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"boolean",default:ee.seedSearchStringFromSelection,description:m.localize(8,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:ee.autoFindInSelection,enumDescriptions:[m.localize(9,null),m.localize(10,null),m.localize(11,null)],description:m.localize(12,null)},"editor.find.globalFindClipboard":{type:"boolean",default:ee.globalFindClipboard,description:m.localize(13,null),included:T.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:ee.addExtraSpaceOnTop,description:m.localize(14,null)},"editor.find.loop":{type:"boolean",default:ee.loop,description:m.localize(15,null)}})}validate(ee){if(!ee||typeof ee!="object")return this.defaultValue;const me=ee;return{cursorMoveOnType:o(me.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:o(me.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection),autoFindInSelection:typeof ee.autoFindInSelection=="boolean"?ee.autoFindInSelection?"always":"never":p(me.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:o(me.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:o(me.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:o(me.loop,this.defaultValue.loop)}}}class a extends C{constructor(){super(41,"fontLigatures",a.OFF,{anyOf:[{type:"boolean",description:m.localize(16,null)},{type:"string",description:m.localize(17,null)}],description:m.localize(18,null),default:!1})}validate(ee){return typeof ee=="undefined"?this.defaultValue:typeof ee=="string"?ee==="false"?a.OFF:ee==="true"?a.ON:ee:Boolean(ee)?a.ON:a.OFF}}e.EditorFontLigatures=a,a.OFF='"liga" off, "calt" off',a.ON='"liga" on, "calt" on';class F extends n{constructor(){super(40)}compute(ee,me,Re){return ee.fontInfo}}class N extends I{constructor(){super(42,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:m.localize(19,null)})}validate(ee){let me=c.float(ee,this.defaultValue);return me===0?e.EDITOR_FONT_DEFAULTS.fontSize:c.clamp(me,6,100)}compute(ee,me,Re){return ee.fontInfo.fontSize}}class W extends C{constructor(){super(43,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:W.MINIMUM_VALUE,maximum:W.MAXIMUM_VALUE,errorMessage:m.localize(20,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:W.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:m.localize(21,null)})}validate(ee){return ee==="normal"||ee==="bold"?ee:String(d.clampedInt(ee,e.EDITOR_FONT_DEFAULTS.fontWeight,W.MINIMUM_VALUE,W.MAXIMUM_VALUE))}}W.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"],W.MINIMUM_VALUE=1,W.MAXIMUM_VALUE=1e3;class le extends C{constructor(){const ee={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},me={type:"string",enum:["peek","gotoAndPeek","goto"],default:ee.multiple,enumDescriptions:[m.localize(22,null),m.localize(23,null),m.localize(24,null)]},Re=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(47,"gotoLocation",ee,{"editor.gotoLocation.multiple":{deprecationMessage:m.localize(25,null)},"editor.gotoLocation.multipleDefinitions":Object.assign({description:m.localize(26,null)},me),"editor.gotoLocation.multipleTypeDefinitions":Object.assign({description:m.localize(27,null)},me),"editor.gotoLocation.multipleDeclarations":Object.assign({description:m.localize(28,null)},me),"editor.gotoLocation.multipleImplementations":Object.assign({description:m.localize(29,null)},me),"editor.gotoLocation.multipleReferences":Object.assign({description:m.localize(30,null)},me),"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:ee.alternativeDefinitionCommand,enum:Re,description:m.localize(31,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:ee.alternativeTypeDefinitionCommand,enum:Re,description:m.localize(32,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:ee.alternativeDeclarationCommand,enum:Re,description:m.localize(33,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:ee.alternativeImplementationCommand,enum:Re,description:m.localize(34,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:ee.alternativeReferenceCommand,enum:Re,description:m.localize(35,null)}})}validate(ee){var me,Re,Le,qe,Se;if(!ee||typeof ee!="object")return this.defaultValue;const we=ee;return{multiple:p(we.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:(me=we.multipleDefinitions)!==null&&me!==void 0?me:p(we.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:(Re=we.multipleTypeDefinitions)!==null&&Re!==void 0?Re:p(we.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:(Le=we.multipleDeclarations)!==null&&Le!==void 0?Le:p(we.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:(qe=we.multipleImplementations)!==null&&qe!==void 0?qe:p(we.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:(Se=we.multipleReferences)!==null&&Se!==void 0?Se:p(we.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:b.string(we.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:b.string(we.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:b.string(we.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:b.string(we.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:b.string(we.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class fe extends C{constructor(){const ee={enabled:!0,delay:300,sticky:!0};super(50,"hover",ee,{"editor.hover.enabled":{type:"boolean",default:ee.enabled,description:m.localize(36,null)},"editor.hover.delay":{type:"number",default:ee.delay,description:m.localize(37,null)},"editor.hover.sticky":{type:"boolean",default:ee.sticky,description:m.localize(38,null)}})}validate(ee){if(!ee||typeof ee!="object")return this.defaultValue;const me=ee;return{enabled:o(me.enabled,this.defaultValue.enabled),delay:d.clampedInt(me.delay,this.defaultValue.delay,0,1e4),sticky:o(me.sticky,this.defaultValue.sticky)}}}var Y;(function(V){V[V.None=0]="None",V[V.Text=1]="Text",V[V.Blocks=2]="Blocks"})(Y=e.RenderMinimap||(e.RenderMinimap={}));class H extends n{constructor(){super(128,[46,55,35,62,90,57,58,92,115,118,119,120,2])}compute(ee,me,Re){return H.computeLayout(me,{memory:ee.memory,outerWidth:ee.outerWidth,outerHeight:ee.outerHeight,isDominatedByLongLines:ee.isDominatedByLongLines,lineHeight:ee.fontInfo.lineHeight,viewLineCount:ee.viewLineCount,lineNumbersDigitCount:ee.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:ee.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:ee.fontInfo.maxDigitWidth,pixelRatio:ee.pixelRatio})}static computeContainedMinimapLineCount(ee){const me=ee.height/ee.lineHeight,Re=ee.scrollBeyondLastLine?me-1:0,Le=(ee.viewLineCount+Re)/(ee.pixelRatio*ee.height),qe=Math.floor(ee.viewLineCount/Le);return{typicalViewportLineCount:me,extraLinesBeyondLastLine:Re,desiredRatio:Le,minimapLineCount:qe}}static _computeMinimapLayout(ee,me){const Re=ee.outerWidth,Le=ee.outerHeight,qe=ee.pixelRatio;if(!ee.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(qe*Le),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Le};const Se=me.stableMinimapLayoutInput,we=Se&&ee.outerHeight===Se.outerHeight&&ee.lineHeight===Se.lineHeight&&ee.typicalHalfwidthCharacterWidth===Se.typicalHalfwidthCharacterWidth&&ee.pixelRatio===Se.pixelRatio&&ee.scrollBeyondLastLine===Se.scrollBeyondLastLine&&ee.minimap.enabled===Se.minimap.enabled&&ee.minimap.side===Se.minimap.side&&ee.minimap.size===Se.minimap.size&&ee.minimap.showSlider===Se.minimap.showSlider&&ee.minimap.renderCharacters===Se.minimap.renderCharacters&&ee.minimap.maxColumn===Se.minimap.maxColumn&&ee.minimap.scale===Se.minimap.scale&&ee.verticalScrollbarWidth===Se.verticalScrollbarWidth&&ee.isViewportWrapping===Se.isViewportWrapping,Ce=ee.lineHeight,ie=ee.typicalHalfwidthCharacterWidth,ce=ee.scrollBeyondLastLine,O=ee.minimap.renderCharacters;let K=qe>=2?Math.round(ee.minimap.scale*2):ee.minimap.scale;const ae=ee.minimap.maxColumn,ke=ee.minimap.size,Pe=ee.minimap.side,Oe=ee.verticalScrollbarWidth,$e=ee.viewLineCount,Ze=ee.remainingWidth,Je=ee.isViewportWrapping,Ye=O?2:3;let nt=Math.floor(qe*Le);const pt=nt/qe;let be=!1,ye=!1,ue=Ye*K,j=K/qe,Ne=1;if(ke==="fill"||ke==="fit"){const{typicalViewportLineCount:ft,extraLinesBeyondLastLine:_t,desiredRatio:wt,minimapLineCount:Rt}=H.computeContainedMinimapLineCount({viewLineCount:$e,scrollBeyondLastLine:ce,height:Le,lineHeight:Ce,pixelRatio:qe});if($e/Rt>1)be=!0,ye=!0,K=1,ue=1,j=K/qe;else{let ct=!1,mt=K+1;if(ke==="fit"){const dt=Math.ceil(($e+_t)*ue);Je&&we&&Ze<=me.stableFitRemainingWidth?(ct=!0,mt=me.stableFitMaxMinimapScale):(ct=dt>nt,Je&&ct?(me.stableMinimapLayoutInput=ee,me.stableFitRemainingWidth=Ze):(me.stableMinimapLayoutInput=null,me.stableFitRemainingWidth=0))}if(ke==="fill"||ct){be=!0;const dt=K;ue=Math.min(Ce*qe,Math.max(1,Math.floor(1/wt))),K=Math.min(mt,Math.max(1,Math.floor(ue/Ye))),K>dt&&(Ne=Math.min(2,K/dt)),j=K/qe/Ne,nt=Math.ceil(Math.max(ft,$e+_t)*ue),Je&&ct&&(me.stableFitMaxMinimapScale=K)}}}const ge=Math.floor(ae*j),Xe=Math.min(ge,Math.max(0,Math.floor((Ze-Oe-2)*j/(ie+j)))+e.MINIMAP_GUTTER_WIDTH);let et=Math.floor(qe*Xe);const rt=et/qe;et=Math.floor(et*Ne);const st=O?1:2,vt=Pe==="left"?0:Re-Xe-Oe;return{renderMinimap:st,minimapLeft:vt,minimapWidth:Xe,minimapHeightIsEditorHeight:be,minimapIsSampling:ye,minimapScale:K,minimapLineHeight:ue,minimapCanvasInnerWidth:et,minimapCanvasInnerHeight:nt,minimapCanvasOuterWidth:rt,minimapCanvasOuterHeight:pt}}static computeLayout(ee,me){const Re=me.outerWidth|0,Le=me.outerHeight|0,qe=me.lineHeight|0,Se=me.lineNumbersDigitCount|0,we=me.typicalHalfwidthCharacterWidth,Ce=me.maxDigitWidth,ie=me.pixelRatio,ce=me.viewLineCount,O=ee.get(120),K=O==="inherit"?ee.get(119):O,ae=K==="inherit"?ee.get(115):K,ke=ee.get(118),Pe=ee.get(2),Oe=me.isDominatedByLongLines,$e=ee.get(46),Ze=ee.get(57).renderType!==0,Je=ee.get(58),Ye=ee.get(92),nt=ee.get(62),pt=ee.get(90),be=pt.verticalScrollbarSize,ye=pt.verticalHasArrows,ue=pt.arrowSize,j=pt.horizontalScrollbarSize,Ne=ee.get(55),ge=ee.get(35);let Xe;if(typeof Ne=="string"&&/^\d+(\.\d+)?ch$/.test(Ne)){const Ft=parseFloat(Ne.substr(0,Ne.length-2));Xe=d.clampedInt(Ft*we,0,0,1e3)}else Xe=d.clampedInt(Ne,0,0,1e3);ge&&(Xe+=16);let et=0;if(Ze){const Ft=Math.max(Se,Je);et=Math.round(Ft*Ce)}let rt=0;$e&&(rt=qe);let st=0,vt=st+rt,ft=vt+et,_t=ft+Xe;const wt=Re-rt-et-Xe;let Rt=!1,bt=!1,ct=-1;Pe!==2&&(K==="inherit"&&Oe?(Rt=!0,bt=!0):ae==="on"||ae==="bounded"?bt=!0:ae==="wordWrapColumn"&&(ct=ke));const mt=H._computeMinimapLayout({outerWidth:Re,outerHeight:Le,lineHeight:qe,typicalHalfwidthCharacterWidth:we,pixelRatio:ie,scrollBeyondLastLine:Ye,minimap:nt,verticalScrollbarWidth:be,viewLineCount:ce,remainingWidth:wt,isViewportWrapping:bt},me.memory||new _);mt.renderMinimap!==0&&mt.minimapLeft===0&&(st+=mt.minimapWidth,vt+=mt.minimapWidth,ft+=mt.minimapWidth,_t+=mt.minimapWidth);const dt=wt-mt.minimapWidth,It=Math.max(1,Math.floor((dt-be-2)/we)),Dt=ye?ue:0;return bt&&(ct=Math.max(1,It),ae==="bounded"&&(ct=Math.min(ct,ke))),{width:Re,height:Le,glyphMarginLeft:st,glyphMarginWidth:rt,lineNumbersLeft:vt,lineNumbersWidth:et,decorationsLeft:ft,decorationsWidth:Xe,contentLeft:_t,contentWidth:dt,minimap:mt,viewportColumn:It,isWordWrapMinified:Rt,isViewportWrapping:bt,wrappingColumn:ct,verticalScrollbarWidth:be,horizontalScrollbarHeight:j,overviewRuler:{top:Dt,width:be,height:Le-2*Dt,right:0}}}}e.EditorLayoutInfoComputer=H;class J extends C{constructor(){const ee={enabled:!0};super(54,"lightbulb",ee,{"editor.lightbulb.enabled":{type:"boolean",default:ee.enabled,description:m.localize(39,null)}})}validate(ee){return!ee||typeof ee!="object"?this.defaultValue:{enabled:o(ee.enabled,this.defaultValue.enabled)}}}class R extends C{constructor(){const ee={enabled:!0,fontSize:0,fontFamily:e.EDITOR_FONT_DEFAULTS.fontFamily};super(124,"inlayHints",ee,{"editor.inlayHints.enabled":{type:"boolean",default:ee.enabled,description:m.localize(40,null)},"editor.inlayHints.fontSize":{type:"number",default:ee.fontSize,markdownDescription:m.localize(41,null)},"editor.inlayHints.fontFamily":{type:"string",default:ee.fontFamily,description:m.localize(42,null)}})}validate(ee){if(!ee||typeof ee!="object")return this.defaultValue;const me=ee;return{enabled:o(me.enabled,this.defaultValue.enabled),fontSize:d.clampedInt(me.fontSize,this.defaultValue.fontSize,0,100),fontFamily:b.string(me.fontFamily,this.defaultValue.fontFamily)}}}class B extends d{constructor(){super(56,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,0,150,{description:m.localize(43,null)})}compute(ee,me,Re){return ee.fontInfo.lineHeight}}class M extends C{constructor(){const ee={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",renderCharacters:!0,maxColumn:120,scale:1};super(62,"minimap",ee,{"editor.minimap.enabled":{type:"boolean",default:ee.enabled,description:m.localize(44,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[m.localize(45,null),m.localize(46,null),m.localize(47,null)],default:ee.size,description:m.localize(48,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:ee.side,description:m.localize(49,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:ee.showSlider,description:m.localize(50,null)},"editor.minimap.scale":{type:"number",default:ee.scale,minimum:1,maximum:3,enum:[1,2,3],description:m.localize(51,null)},"editor.minimap.renderCharacters":{type:"boolean",default:ee.renderCharacters,description:m.localize(52,null)},"editor.minimap.maxColumn":{type:"number",default:ee.maxColumn,description:m.localize(53,null)}})}validate(ee){if(!ee||typeof ee!="object")return this.defaultValue;const me=ee;return{enabled:o(me.enabled,this.defaultValue.enabled),size:p(me.size,this.defaultValue.size,["proportional","fill","fit"]),side:p(me.side,this.defaultValue.side,["right","left"]),showSlider:p(me.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:o(me.renderCharacters,this.defaultValue.renderCharacters),scale:d.clampedInt(me.scale,1,1,3),maxColumn:d.clampedInt(me.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function x(V){return V==="ctrlCmd"?T.isMacintosh?"metaKey":"ctrlKey":"altKey"}class q extends C{constructor(){super(72,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:m.localize(54,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:m.localize(55,null)}})}validate(ee){if(!ee||typeof ee!="object")return this.defaultValue;const me=ee;return{top:d.clampedInt(me.top,0,0,1e3),bottom:d.clampedInt(me.bottom,0,0,1e3)}}}class z extends C{constructor(){const ee={enabled:!0,cycle:!1};super(73,"parameterHints",ee,{"editor.parameterHints.enabled":{type:"boolean",default:ee.enabled,description:m.localize(56,null)},"editor.parameterHints.cycle":{type:"boolean",default:ee.cycle,description:m.localize(57,null)}})}validate(ee){if(!ee||typeof ee!="object")return this.defaultValue;const me=ee;return{enabled:o(me.enabled,this.defaultValue.enabled),cycle:o(me.cycle,this.defaultValue.cycle)}}}class oe extends n{constructor(){super(126)}compute(ee,me,Re){return ee.pixelRatio}}class pe extends C{constructor(){const ee={other:!0,comments:!1,strings:!1};super(76,"quickSuggestions",ee,{anyOf:[{type:"boolean"},{type:"object",properties:{strings:{type:"boolean",default:ee.strings,description:m.localize(58,null)},comments:{type:"boolean",default:ee.comments,description:m.localize(59,null)},other:{type:"boolean",default:ee.other,description:m.localize(60,null)}}}],default:ee,description:m.localize(61,null)});this.defaultValue=ee}validate(ee){if(typeof ee=="boolean")return ee;if(ee&&typeof ee=="object"){const me=ee,Re={other:o(me.other,this.defaultValue.other),comments:o(me.comments,this.defaultValue.comments),strings:o(me.strings,this.defaultValue.strings)};return Re.other&&Re.comments&&Re.strings?!0:!Re.other&&!Re.comments&&!Re.strings?!1:Re}return this.defaultValue}}var Te;(function(V){V[V.Off=0]="Off",V[V.On=1]="On",V[V.Relative=2]="Relative",V[V.Interval=3]="Interval",V[V.Custom=4]="Custom"})(Te=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class Be extends C{constructor(){super(57,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[m.localize(62,null),m.localize(63,null),m.localize(64,null),m.localize(65,null)],default:"on",description:m.localize(66,null)})}validate(ee){let me=this.defaultValue.renderType,Re=this.defaultValue.renderFn;return typeof ee!="undefined"&&(typeof ee=="function"?(me=4,Re=ee):ee==="interval"?me=3:ee==="relative"?me=2:ee==="on"?me=1:me=0),{renderType:me,renderFn:Re}}}function Fe(V){const ee=V.get(85);return ee==="editable"?V.get(78):ee!=="on"}e.filterValidationDecorations=Fe;class We extends C{constructor(){const ee=[],me={type:"number",description:m.localize(67,null)};super(89,"rulers",ee,{type:"array",items:{anyOf:[me,{type:["object"],properties:{column:me,color:{type:"string",description:m.localize(68,null),format:"color-hex"}}}]},default:ee,description:m.localize(69,null)})}validate(ee){if(Array.isArray(ee)){let me=[];for(let Re of ee)if(typeof Re=="number")me.push({column:d.clampedInt(Re,0,0,1e4),color:null});else if(Re&&typeof Re=="object"){const Le=Re;me.push({column:d.clampedInt(Le.column,0,0,1e4),color:Le.color})}return me.sort((Re,Le)=>Re.column-Le.column),me}return this.defaultValue}}function Qe(V,ee){if(typeof V!="string")return ee;switch(V){case"hidden":return 2;case"visible":return 3;default:return 1}}class Ge extends C{constructor(){super(90,"scrollbar",{vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1})}validate(ee){if(!ee||typeof ee!="object")return this.defaultValue;const me=ee,Re=d.clampedInt(me.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Le=d.clampedInt(me.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:d.clampedInt(me.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:Qe(me.vertical,this.defaultValue.vertical),horizontal:Qe(me.horizontal,this.defaultValue.horizontal),useShadows:o(me.useShadows,this.defaultValue.useShadows),verticalHasArrows:o(me.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:o(me.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:o(me.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:o(me.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Re,horizontalSliderSize:d.clampedInt(me.horizontalSliderSize,Re,0,1e3),verticalScrollbarSize:Le,verticalSliderSize:d.clampedInt(me.verticalSliderSize,Le,0,1e3),scrollByPage:o(me.scrollByPage,this.defaultValue.scrollByPage)}}}class Ke extends C{constructor(){const ee={enabled:!1};super(52,"inlineSuggest",ee,{"editor.inlineSuggest.enabled":{type:"boolean",default:ee.enabled,description:m.localize(70,null)}})}validate(ee){return!ee||typeof ee!="object"?this.defaultValue:{enabled:o(ee.enabled,this.defaultValue.enabled)}}}class $ extends C{constructor(){const ee={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,showIcons:!0,showStatusBar:!1,preview:!1,showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(104,"suggest",ee,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[m.localize(71,null),m.localize(72,null)],default:ee.insertMode,description:m.localize(73,null)},"editor.suggest.filterGraceful":{type:"boolean",default:ee.filterGraceful,description:m.localize(74,null)},"editor.suggest.localityBonus":{type:"boolean",default:ee.localityBonus,description:m.localize(75,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:ee.shareSuggestSelections,markdownDescription:m.localize(76,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:ee.snippetsPreventQuickSuggestions,description:m.localize(77,null)},"editor.suggest.showIcons":{type:"boolean",default:ee.showIcons,description:m.localize(78,null)},"editor.suggest.showStatusBar":{type:"boolean",default:ee.showStatusBar,description:m.localize(79,null)},"editor.suggest.preview":{type:"boolean",default:ee.preview,description:m.localize(80,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:ee.showInlineDetails,description:m.localize(81,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:m.localize(82,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:m.localize(83,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:m.localize(84,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:m.localize(85,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:m.localize(86,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:m.localize(87,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:m.localize(88,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:m.localize(89,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:m.localize(90,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:m.localize(91,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:m.localize(92,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:m.localize(93,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:m.localize(94,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:m.localize(95,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:m.localize(96,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:m.localize(97,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:m.localize(98,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:m.localize(99,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:m.localize(100,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:m.localize(101,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:m.localize(102,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:m.localize(103,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:m.localize(104,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:m.localize(105,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:m.localize(106,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:m.localize(107,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:m.localize(108,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:m.localize(109,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:m.localize(110,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:m.localize(111,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:m.localize(112,null)}})}validate(ee){if(!ee||typeof ee!="object")return this.defaultValue;const me=ee;return{insertMode:p(me.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:o(me.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:o(me.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:o(me.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:o(me.shareSuggestSelections,this.defaultValue.shareSuggestSelections),showIcons:o(me.showIcons,this.defaultValue.showIcons),showStatusBar:o(me.showStatusBar,this.defaultValue.showStatusBar),preview:o(me.preview,this.defaultValue.preview),showInlineDetails:o(me.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:o(me.showMethods,this.defaultValue.showMethods),showFunctions:o(me.showFunctions,this.defaultValue.showFunctions),showConstructors:o(me.showConstructors,this.defaultValue.showConstructors),showDeprecated:o(me.showDeprecated,this.defaultValue.showDeprecated),showFields:o(me.showFields,this.defaultValue.showFields),showVariables:o(me.showVariables,this.defaultValue.showVariables),showClasses:o(me.showClasses,this.defaultValue.showClasses),showStructs:o(me.showStructs,this.defaultValue.showStructs),showInterfaces:o(me.showInterfaces,this.defaultValue.showInterfaces),showModules:o(me.showModules,this.defaultValue.showModules),showProperties:o(me.showProperties,this.defaultValue.showProperties),showEvents:o(me.showEvents,this.defaultValue.showEvents),showOperators:o(me.showOperators,this.defaultValue.showOperators),showUnits:o(me.showUnits,this.defaultValue.showUnits),showValues:o(me.showValues,this.defaultValue.showValues),showConstants:o(me.showConstants,this.defaultValue.showConstants),showEnums:o(me.showEnums,this.defaultValue.showEnums),showEnumMembers:o(me.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:o(me.showKeywords,this.defaultValue.showKeywords),showWords:o(me.showWords,this.defaultValue.showWords),showColors:o(me.showColors,this.defaultValue.showColors),showFiles:o(me.showFiles,this.defaultValue.showFiles),showReferences:o(me.showReferences,this.defaultValue.showReferences),showFolders:o(me.showFolders,this.defaultValue.showFolders),showTypeParameters:o(me.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:o(me.showSnippets,this.defaultValue.showSnippets),showUsers:o(me.showUsers,this.defaultValue.showUsers),showIssues:o(me.showIssues,this.defaultValue.showIssues)}}}class Q extends C{constructor(){super(100,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:m.localize(113,null),default:!0,type:"boolean"}})}validate(ee){return!ee||typeof ee!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:o(ee.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class te extends n{constructor(){super(127,[78])}compute(ee,me,Re){return me.get(78)?!0:ee.tabFocusMode}}var re;(function(V){V[V.None=0]="None",V[V.Same=1]="Same",V[V.Indent=2]="Indent",V[V.DeepIndent=3]="DeepIndent"})(re=e.WrappingIndent||(e.WrappingIndent={}));function G(V){switch(V){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}}class se extends n{constructor(){super(129,[128])}compute(ee,me,Re){const Le=me.get(128);return{isDominatedByLongLines:ee.isDominatedByLongLines,isWordWrapMinified:Le.isWordWrapMinified,isViewportWrapping:Le.isViewportWrapping,wrappingColumn:Le.wrappingColumn}}}const he="Consolas, 'Courier New', monospace",Ae="Menlo, Monaco, 'Courier New', monospace",xe="'Droid Sans Mono', 'monospace', monospace, 'Droid Sans Fallback'";e.EDITOR_FONT_DEFAULTS={fontFamily:T.isMacintosh?Ae:T.isLinux?xe:he,fontWeight:"normal",fontSize:T.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0},e.editorOptionsRegistry=[];function ve(V){return e.editorOptionsRegistry[V.id]=V,V}var je;(function(V){V[V.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",V[V.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",V[V.accessibilitySupport=2]="accessibilitySupport",V[V.accessibilityPageSize=3]="accessibilityPageSize",V[V.ariaLabel=4]="ariaLabel",V[V.autoClosingBrackets=5]="autoClosingBrackets",V[V.autoClosingDelete=6]="autoClosingDelete",V[V.autoClosingOvertype=7]="autoClosingOvertype",V[V.autoClosingQuotes=8]="autoClosingQuotes",V[V.autoIndent=9]="autoIndent",V[V.automaticLayout=10]="automaticLayout",V[V.autoSurround=11]="autoSurround",V[V.codeLens=12]="codeLens",V[V.codeLensFontFamily=13]="codeLensFontFamily",V[V.codeLensFontSize=14]="codeLensFontSize",V[V.colorDecorators=15]="colorDecorators",V[V.columnSelection=16]="columnSelection",V[V.comments=17]="comments",V[V.contextmenu=18]="contextmenu",V[V.copyWithSyntaxHighlighting=19]="copyWithSyntaxHighlighting",V[V.cursorBlinking=20]="cursorBlinking",V[V.cursorSmoothCaretAnimation=21]="cursorSmoothCaretAnimation",V[V.cursorStyle=22]="cursorStyle",V[V.cursorSurroundingLines=23]="cursorSurroundingLines",V[V.cursorSurroundingLinesStyle=24]="cursorSurroundingLinesStyle",V[V.cursorWidth=25]="cursorWidth",V[V.disableLayerHinting=26]="disableLayerHinting",V[V.disableMonospaceOptimizations=27]="disableMonospaceOptimizations",V[V.domReadOnly=28]="domReadOnly",V[V.dragAndDrop=29]="dragAndDrop",V[V.emptySelectionClipboard=30]="emptySelectionClipboard",V[V.extraEditorClassName=31]="extraEditorClassName",V[V.fastScrollSensitivity=32]="fastScrollSensitivity",V[V.find=33]="find",V[V.fixedOverflowWidgets=34]="fixedOverflowWidgets",V[V.folding=35]="folding",V[V.foldingStrategy=36]="foldingStrategy",V[V.foldingHighlight=37]="foldingHighlight",V[V.unfoldOnClickAfterEndOfLine=38]="unfoldOnClickAfterEndOfLine",V[V.fontFamily=39]="fontFamily",V[V.fontInfo=40]="fontInfo",V[V.fontLigatures=41]="fontLigatures",V[V.fontSize=42]="fontSize",V[V.fontWeight=43]="fontWeight",V[V.formatOnPaste=44]="formatOnPaste",V[V.formatOnType=45]="formatOnType",V[V.glyphMargin=46]="glyphMargin",V[V.gotoLocation=47]="gotoLocation",V[V.hideCursorInOverviewRuler=48]="hideCursorInOverviewRuler",V[V.highlightActiveIndentGuide=49]="highlightActiveIndentGuide",V[V.hover=50]="hover",V[V.inDiffEditor=51]="inDiffEditor",V[V.inlineSuggest=52]="inlineSuggest",V[V.letterSpacing=53]="letterSpacing",V[V.lightbulb=54]="lightbulb",V[V.lineDecorationsWidth=55]="lineDecorationsWidth",V[V.lineHeight=56]="lineHeight",V[V.lineNumbers=57]="lineNumbers",V[V.lineNumbersMinChars=58]="lineNumbersMinChars",V[V.linkedEditing=59]="linkedEditing",V[V.links=60]="links",V[V.matchBrackets=61]="matchBrackets",V[V.minimap=62]="minimap",V[V.mouseStyle=63]="mouseStyle",V[V.mouseWheelScrollSensitivity=64]="mouseWheelScrollSensitivity",V[V.mouseWheelZoom=65]="mouseWheelZoom",V[V.multiCursorMergeOverlapping=66]="multiCursorMergeOverlapping",V[V.multiCursorModifier=67]="multiCursorModifier",V[V.multiCursorPaste=68]="multiCursorPaste",V[V.occurrencesHighlight=69]="occurrencesHighlight",V[V.overviewRulerBorder=70]="overviewRulerBorder",V[V.overviewRulerLanes=71]="overviewRulerLanes",V[V.padding=72]="padding",V[V.parameterHints=73]="parameterHints",V[V.peekWidgetDefaultFocus=74]="peekWidgetDefaultFocus",V[V.definitionLinkOpensInPeek=75]="definitionLinkOpensInPeek",V[V.quickSuggestions=76]="quickSuggestions",V[V.quickSuggestionsDelay=77]="quickSuggestionsDelay",V[V.readOnly=78]="readOnly",V[V.renameOnType=79]="renameOnType",V[V.renderControlCharacters=80]="renderControlCharacters",V[V.renderIndentGuides=81]="renderIndentGuides",V[V.renderFinalNewline=82]="renderFinalNewline",V[V.renderLineHighlight=83]="renderLineHighlight",V[V.renderLineHighlightOnlyWhenFocus=84]="renderLineHighlightOnlyWhenFocus",V[V.renderValidationDecorations=85]="renderValidationDecorations",V[V.renderWhitespace=86]="renderWhitespace",V[V.revealHorizontalRightPadding=87]="revealHorizontalRightPadding",V[V.roundedSelection=88]="roundedSelection",V[V.rulers=89]="rulers",V[V.scrollbar=90]="scrollbar",V[V.scrollBeyondLastColumn=91]="scrollBeyondLastColumn",V[V.scrollBeyondLastLine=92]="scrollBeyondLastLine",V[V.scrollPredominantAxis=93]="scrollPredominantAxis",V[V.selectionClipboard=94]="selectionClipboard",V[V.selectionHighlight=95]="selectionHighlight",V[V.selectOnLineNumbers=96]="selectOnLineNumbers",V[V.showFoldingControls=97]="showFoldingControls",V[V.showUnused=98]="showUnused",V[V.snippetSuggestions=99]="snippetSuggestions",V[V.smartSelect=100]="smartSelect",V[V.smoothScrolling=101]="smoothScrolling",V[V.stickyTabStops=102]="stickyTabStops",V[V.stopRenderingLineAfter=103]="stopRenderingLineAfter",V[V.suggest=104]="suggest",V[V.suggestFontSize=105]="suggestFontSize",V[V.suggestLineHeight=106]="suggestLineHeight",V[V.suggestOnTriggerCharacters=107]="suggestOnTriggerCharacters",V[V.suggestSelection=108]="suggestSelection",V[V.tabCompletion=109]="tabCompletion",V[V.tabIndex=110]="tabIndex",V[V.unusualLineTerminators=111]="unusualLineTerminators",V[V.useShadowDOM=112]="useShadowDOM",V[V.useTabStops=113]="useTabStops",V[V.wordSeparators=114]="wordSeparators",V[V.wordWrap=115]="wordWrap",V[V.wordWrapBreakAfterCharacters=116]="wordWrapBreakAfterCharacters",V[V.wordWrapBreakBeforeCharacters=117]="wordWrapBreakBeforeCharacters",V[V.wordWrapColumn=118]="wordWrapColumn",V[V.wordWrapOverride1=119]="wordWrapOverride1",V[V.wordWrapOverride2=120]="wordWrapOverride2",V[V.wrappingIndent=121]="wrappingIndent",V[V.wrappingStrategy=122]="wrappingStrategy",V[V.showDeprecated=123]="showDeprecated",V[V.inlayHints=124]="inlayHints",V[V.editorClassName=125]="editorClassName",V[V.pixelRatio=126]="pixelRatio",V[V.tabFocusMode=127]="tabFocusMode",V[V.layoutInfo=128]="layoutInfo",V[V.wrappingInfo=129]="wrappingInfo"})(je=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:ve(new h(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:m.localize(114,null)})),acceptSuggestionOnEnter:ve(new w(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",m.localize(115,null),""],markdownDescription:m.localize(116,null)})),accessibilitySupport:ve(new g),accessibilityPageSize:ve(new d(3,"accessibilityPageSize",10,1,1073741824,{description:m.localize(117,null)})),ariaLabel:ve(new b(4,"ariaLabel",m.localize(118,null))),autoClosingBrackets:ve(new w(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",m.localize(119,null),m.localize(120,null),""],description:m.localize(121,null)})),autoClosingDelete:ve(new w(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",m.localize(122,null),""],description:m.localize(123,null)})),autoClosingOvertype:ve(new w(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",m.localize(124,null),""],description:m.localize(125,null)})),autoClosingQuotes:ve(new w(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",m.localize(126,null),m.localize(127,null),""],description:m.localize(128,null)})),autoIndent:ve(new u(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],f,{enumDescriptions:[m.localize(129,null),m.localize(130,null),m.localize(131,null),m.localize(132,null),m.localize(133,null)],description:m.localize(134,null)})),automaticLayout:ve(new h(10,"automaticLayout",!1)),autoSurround:ve(new w(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[m.localize(135,null),m.localize(136,null),m.localize(137,null),""],description:m.localize(138,null)})),stickyTabStops:ve(new h(102,"stickyTabStops",!1,{description:m.localize(139,null)})),codeLens:ve(new h(12,"codeLens",!0,{description:m.localize(140,null)})),codeLensFontFamily:ve(new b(13,"codeLensFontFamily","",{description:m.localize(141,null)})),codeLensFontSize:ve(new d(14,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:m.localize(142,null)})),colorDecorators:ve(new h(15,"colorDecorators",!0,{description:m.localize(143,null)})),columnSelection:ve(new h(16,"columnSelection",!1,{description:m.localize(144,null)})),comments:ve(new t),contextmenu:ve(new h(18,"contextmenu",!0)),copyWithSyntaxHighlighting:ve(new h(19,"copyWithSyntaxHighlighting",!0,{description:m.localize(145,null)})),cursorBlinking:ve(new u(20,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],s,{description:m.localize(146,null)})),cursorSmoothCaretAnimation:ve(new h(21,"cursorSmoothCaretAnimation",!1,{description:m.localize(147,null)})),cursorStyle:ve(new u(22,"cursorStyle",r.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],E,{description:m.localize(148,null)})),cursorSurroundingLines:ve(new d(23,"cursorSurroundingLines",0,0,1073741824,{description:m.localize(149,null)})),cursorSurroundingLinesStyle:ve(new w(24,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[m.localize(150,null),m.localize(151,null)],description:m.localize(152,null)})),cursorWidth:ve(new d(25,"cursorWidth",0,0,1073741824,{markdownDescription:m.localize(153,null)})),disableLayerHinting:ve(new h(26,"disableLayerHinting",!1)),disableMonospaceOptimizations:ve(new h(27,"disableMonospaceOptimizations",!1)),domReadOnly:ve(new h(28,"domReadOnly",!1)),dragAndDrop:ve(new h(29,"dragAndDrop",!0,{description:m.localize(154,null)})),emptySelectionClipboard:ve(new A),extraEditorClassName:ve(new b(31,"extraEditorClassName","")),fastScrollSensitivity:ve(new c(32,"fastScrollSensitivity",5,V=>V<=0?5:V,{markdownDescription:m.localize(155,null)})),find:ve(new P),fixedOverflowWidgets:ve(new h(34,"fixedOverflowWidgets",!1)),folding:ve(new h(35,"folding",!0,{description:m.localize(156,null)})),foldingStrategy:ve(new w(36,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[m.localize(157,null),m.localize(158,null)],description:m.localize(159,null)})),foldingHighlight:ve(new h(37,"foldingHighlight",!0,{description:m.localize(160,null)})),unfoldOnClickAfterEndOfLine:ve(new h(38,"unfoldOnClickAfterEndOfLine",!1,{description:m.localize(161,null)})),fontFamily:ve(new b(39,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:m.localize(162,null)})),fontInfo:ve(new F),fontLigatures2:ve(new a),fontSize:ve(new N),fontWeight:ve(new W),formatOnPaste:ve(new h(44,"formatOnPaste",!1,{description:m.localize(163,null)})),formatOnType:ve(new h(45,"formatOnType",!1,{description:m.localize(164,null)})),glyphMargin:ve(new h(46,"glyphMargin",!0,{description:m.localize(165,null)})),gotoLocation:ve(new le),hideCursorInOverviewRuler:ve(new h(48,"hideCursorInOverviewRuler",!1,{description:m.localize(166,null)})),highlightActiveIndentGuide:ve(new h(49,"highlightActiveIndentGuide",!0,{description:m.localize(167,null)})),hover:ve(new fe),inDiffEditor:ve(new h(51,"inDiffEditor",!1)),letterSpacing:ve(new c(53,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,V=>c.clamp(V,-5,20),{description:m.localize(168,null)})),lightbulb:ve(new J),lineDecorationsWidth:ve(new I(55,"lineDecorationsWidth",10)),lineHeight:ve(new B),lineNumbers:ve(new Be),lineNumbersMinChars:ve(new d(58,"lineNumbersMinChars",5,1,300)),linkedEditing:ve(new h(59,"linkedEditing",!1,{description:m.localize(169,null)})),links:ve(new h(60,"links",!0,{description:m.localize(170,null)})),matchBrackets:ve(new w(61,"matchBrackets","always",["always","near","never"],{description:m.localize(171,null)})),minimap:ve(new M),mouseStyle:ve(new w(63,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:ve(new c(64,"mouseWheelScrollSensitivity",1,V=>V===0?1:V,{markdownDescription:m.localize(172,null)})),mouseWheelZoom:ve(new h(65,"mouseWheelZoom",!1,{markdownDescription:m.localize(173,null)})),multiCursorMergeOverlapping:ve(new h(66,"multiCursorMergeOverlapping",!0,{description:m.localize(174,null)})),multiCursorModifier:ve(new u(67,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],x,{markdownEnumDescriptions:[m.localize(175,null),m.localize(176,null)],markdownDescription:m.localize(177,null)})),multiCursorPaste:ve(new w(68,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[m.localize(178,null),m.localize(179,null)],markdownDescription:m.localize(180,null)})),occurrencesHighlight:ve(new h(69,"occurrencesHighlight",!0,{description:m.localize(181,null)})),overviewRulerBorder:ve(new h(70,"overviewRulerBorder",!0,{description:m.localize(182,null)})),overviewRulerLanes:ve(new d(71,"overviewRulerLanes",3,0,3)),padding:ve(new q),parameterHints:ve(new z),peekWidgetDefaultFocus:ve(new w(74,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[m.localize(183,null),m.localize(184,null)],description:m.localize(185,null)})),definitionLinkOpensInPeek:ve(new h(75,"definitionLinkOpensInPeek",!1,{description:m.localize(186,null)})),quickSuggestions:ve(new pe),quickSuggestionsDelay:ve(new d(77,"quickSuggestionsDelay",10,0,1073741824,{description:m.localize(187,null)})),readOnly:ve(new h(78,"readOnly",!1)),renameOnType:ve(new h(79,"renameOnType",!1,{description:m.localize(188,null),markdownDeprecationMessage:m.localize(189,null)})),renderControlCharacters:ve(new h(80,"renderControlCharacters",!1,{description:m.localize(190,null)})),renderIndentGuides:ve(new h(81,"renderIndentGuides",!0,{description:m.localize(191,null)})),renderFinalNewline:ve(new h(82,"renderFinalNewline",!0,{description:m.localize(192,null)})),renderLineHighlight:ve(new w(83,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",m.localize(193,null)],description:m.localize(194,null)})),renderLineHighlightOnlyWhenFocus:ve(new h(84,"renderLineHighlightOnlyWhenFocus",!1,{description:m.localize(195,null)})),renderValidationDecorations:ve(new w(85,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:ve(new w(86,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",m.localize(196,null),m.localize(197,null),m.localize(198,null),""],description:m.localize(199,null)})),revealHorizontalRightPadding:ve(new d(87,"revealHorizontalRightPadding",30,0,1e3)),roundedSelection:ve(new h(88,"roundedSelection",!0,{description:m.localize(200,null)})),rulers:ve(new We),scrollbar:ve(new Ge),scrollBeyondLastColumn:ve(new d(91,"scrollBeyondLastColumn",5,0,1073741824,{description:m.localize(201,null)})),scrollBeyondLastLine:ve(new h(92,"scrollBeyondLastLine",!0,{description:m.localize(202,null)})),scrollPredominantAxis:ve(new h(93,"scrollPredominantAxis",!0,{description:m.localize(203,null)})),selectionClipboard:ve(new h(94,"selectionClipboard",!0,{description:m.localize(204,null),included:T.isLinux})),selectionHighlight:ve(new h(95,"selectionHighlight",!0,{description:m.localize(205,null)})),selectOnLineNumbers:ve(new h(96,"selectOnLineNumbers",!0)),showFoldingControls:ve(new w(97,"showFoldingControls","mouseover",["always","mouseover"],{enumDescriptions:[m.localize(206,null),m.localize(207,null)],description:m.localize(208,null)})),showUnused:ve(new h(98,"showUnused",!0,{description:m.localize(209,null)})),showDeprecated:ve(new h(123,"showDeprecated",!0,{description:m.localize(210,null)})),inlayHints:ve(new R),snippetSuggestions:ve(new w(99,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[m.localize(211,null),m.localize(212,null),m.localize(213,null),m.localize(214,null)],description:m.localize(215,null)})),smartSelect:ve(new Q),smoothScrolling:ve(new h(101,"smoothScrolling",!1,{description:m.localize(216,null)})),stopRenderingLineAfter:ve(new d(103,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:ve(new $),inlineSuggest:ve(new Ke),suggestFontSize:ve(new d(105,"suggestFontSize",0,0,1e3,{markdownDescription:m.localize(217,null)})),suggestLineHeight:ve(new d(106,"suggestLineHeight",0,0,1e3,{markdownDescription:m.localize(218,null)})),suggestOnTriggerCharacters:ve(new h(107,"suggestOnTriggerCharacters",!0,{description:m.localize(219,null)})),suggestSelection:ve(new w(108,"suggestSelection","recentlyUsed",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[m.localize(220,null),m.localize(221,null),m.localize(222,null)],description:m.localize(223,null)})),tabCompletion:ve(new w(109,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[m.localize(224,null),m.localize(225,null),m.localize(226,null)],description:m.localize(227,null)})),tabIndex:ve(new d(110,"tabIndex",0,-1,1073741824)),unusualLineTerminators:ve(new w(111,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[m.localize(228,null),m.localize(229,null),m.localize(230,null)],description:m.localize(231,null)})),useShadowDOM:ve(new h(112,"useShadowDOM",!0)),useTabStops:ve(new h(113,"useTabStops",!0,{description:m.localize(232,null)})),wordSeparators:ve(new b(114,"wordSeparators",S.USUAL_WORD_SEPARATORS,{description:m.localize(233,null)})),wordWrap:ve(new w(115,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[m.localize(234,null),m.localize(235,null),m.localize(236,null),m.localize(237,null)],description:m.localize(238,null)})),wordWrapBreakAfterCharacters:ve(new b(116,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:ve(new b(117,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:ve(new d(118,"wordWrapColumn",80,1,1073741824,{markdownDescription:m.localize(239,null)})),wordWrapOverride1:ve(new w(119,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:ve(new w(120,"wordWrapOverride2","inherit",["off","on","inherit"])),wrappingIndent:ve(new u(121,"wrappingIndent",1,"same",["none","same","indent","deepIndent"],G,{enumDescriptions:[m.localize(240,null),m.localize(241,null),m.localize(242,null),m.localize(243,null)],description:m.localize(244,null)})),wrappingStrategy:ve(new w(122,"wrappingStrategy","simple",["simple","advanced"],{enumDescriptions:[m.localize(245,null),m.localize(246,null)],description:m.localize(247,null)})),editorClassName:ve(new v),pixelRatio:ve(new oe),tabFocusMode:ve(new te),layoutInfo:ve(new H),wrappingInfo:ve(new se)}}),define(_e[124],Ee([19,20]),function(Z,e){return Z.create("vs/platform/configuration/common/configurationRegistry",e)}),define(_e[125],Ee([19,20]),function(Z,e){return Z.create("vs/platform/extensions/common/extensionValidator",e)}),define(_e[126],Ee([19,20]),function(Z,e){return Z.create("vs/platform/files/common/files",e)}),define(_e[127],Ee([19,20]),function(Z,e){return Z.create("vs/platform/markers/common/markers",e)}),define(_e[128],Ee([19,20]),function(Z,e){return Z.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(_e[129],Ee([19,20]),function(Z,e){return Z.create("vs/workbench/api/common/extHostExtensionService",e)}),define(_e[130],Ee([19,20]),function(Z,e){return Z.create("vs/workbench/api/common/extHostProgress",e)}),define(_e[131],Ee([19,20]),function(Z,e){return Z.create("vs/workbench/api/common/extHostStatusBar",e)}),define(_e[132],Ee([19,20]),function(Z,e){return Z.create("vs/workbench/api/common/extHostTerminalService",e)}),define(_e[133],Ee([19,20]),function(Z,e){return Z.create("vs/workbench/api/common/extHostTreeViews",e)}),define(_e[134],Ee([19,20]),function(Z,e){return Z.create("vs/workbench/api/common/extHostWorkspace",e)}),define(_e[135],Ee([19,20]),function(Z,e){return Z.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(_e[136],Ee([19,20]),function(Z,e){return Z.create("vs/workbench/contrib/search/common/queryBuilder",e)}),define(_e[137],Ee([19,20]),function(Z,e){return Z.create("vs/workbench/contrib/tasks/common/taskService",e)}),define(_e[138],Ee([19,20]),function(Z,e){return Z.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(_e[139],Ee([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextEditorSelectionRevealType=e.EditorOpenContext=e.EditorOverride=e.EditorActivation=void 0;var m;(function(k){k[k.ACTIVATE=0]="ACTIVATE",k[k.RESTORE=1]="RESTORE",k[k.PRESERVE=2]="PRESERVE"})(m=e.EditorActivation||(e.EditorActivation={}));var T;(function(k){k[k.PICK=1]="PICK",k[k.DISABLED=2]="DISABLED"})(T=e.EditorOverride||(e.EditorOverride={}));var S;(function(k){k[k.API=0]="API",k[k.USER=1]="USER"})(S=e.EditorOpenContext||(e.EditorOpenContext={}));var y;(function(k){k[k.Center=0]="Center",k[k.CenterIfOutsideViewport=1]="CenterIfOutsideViewport",k[k.NearTop=2]="NearTop",k[k.NearTopIfOutsideViewport=3]="NearTopIfOutsideViewport"})(y=e.TextEditorSelectionRevealType||(e.TextEditorSelectionRevealType={}))}),define(_e[140],Ee([0,1,125]),function(Z,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const T=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,S=/^-(\d{4})(\d{2})(\d{2})$/;function y(o){return o=o.trim(),o==="*"||T.test(o)}e.isValidVersionStr=y;function k(o){if(!y(o))return null;if(o=o.trim(),o==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let h=o.match(T);return h?{hasCaret:h[1]==="^",hasGreaterEquals:h[1]===">=",majorBase:h[2]==="x"?0:parseInt(h[2],10),majorMustEqual:h[2]!=="x",minorBase:h[4]==="x"?0:parseInt(h[4],10),minorMustEqual:h[4]!=="x",patchBase:h[6]==="x"?0:parseInt(h[6],10),patchMustEqual:h[6]!=="x",preRelease:h[8]||null}:null}e.parseVersion=k;function D(o){if(!o)return null;let h=o.majorBase,d=o.majorMustEqual,c=o.minorBase,b=o.minorMustEqual,p=o.patchBase,w=o.patchMustEqual;o.hasCaret&&(h===0||(b=!1),w=!1);let u=0;if(o.preRelease){const f=S.exec(o.preRelease);if(f){const[,g,t,i]=f;u=Date.UTC(Number(g),Number(t)-1,Number(i))}}return{majorBase:h,majorMustEqual:d,minorBase:c,minorMustEqual:b,patchBase:p,patchMustEqual:w,isMinimum:o.hasGreaterEquals,notBefore:u}}e.normalizeVersion=D;function _(o,h,d){let c;typeof o=="string"?c=D(k(o)):c=o;let b;h instanceof Date?b=h.getTime():typeof h=="string"&&(b=new Date(h).getTime());let p;if(typeof d=="string"?p=D(k(d)):p=d,!c||!p)return!1;let w=c.majorBase,u=c.minorBase,f=c.patchBase,g=p.majorBase,t=p.minorBase,i=p.patchBase,s=p.notBefore,r=p.majorMustEqual,l=p.minorMustEqual,E=p.patchMustEqual;return p.isMinimum?w>g?!0:w<g?!1:u>t?!0:u<t||b&&b<s?!1:f>=i:(w===1&&g===0&&(!r||!l||!E)&&(g=1,t=0,i=0,r=!0,l=!1,E=!1),w<g?!1:w>g?!r:u<t?!1:u>t?!l:f<i?!1:f>i?!E:!(b&&b<s))}e.isValidVersion=_;function C(o,h,d,c){return d.isBuiltin||typeof d.main=="undefined"?!0:I(o,h,d.engines.vscode,c)}e.isValidExtensionVersion=C;function n(o,h,d){return o==="*"||I(h,d,o)}e.isEngineValid=n;function I(o,h,d,c=[]){let b=D(k(d));if(!b)return c.push(m.localize(0,null,d)),!1;if(b.majorBase===0){if(!b.majorMustEqual||!b.minorMustEqual)return c.push(m.localize(1,null,d)),!1}else if(!b.majorMustEqual)return c.push(m.localize(2,null,d)),!1;return _(o,h,b)?!0:(c.push(m.localize(3,null,o,d)),!1)}}),define(_e[88],Ee([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createSyncDescriptor=e.SyncDescriptor=void 0;class m{constructor(y,k=[],D=!1){this.ctor=y,this.staticArguments=k,this.supportsDelayedInstantiation=D}}e.SyncDescriptor=m;const T=(S,...y)=>new m(S,y);e.createSyncDescriptor=T}),define(_e[57],Ee([0,1,88]),function(Z,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const T=[];function S(k,D,_){D instanceof m.SyncDescriptor||(D=new m.SyncDescriptor(D,[],_)),T.push([k,D])}e.registerSingleton=S;function y(){return T}e.getSingletonServiceDescriptors=y}),define(_e[141],Ee([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class m{constructor(y){this.incoming=new Map,this.outgoing=new Map,this.data=y}}e.Node=m;class T{constructor(y){this._hashFn=y,this._nodes=new Map}roots(){const y=[];for(let k of this._nodes.values())k.outgoing.size===0&&y.push(k);return y}insertEdge(y,k){const D=this.lookupOrInsertNode(y),_=this.lookupOrInsertNode(k);D.outgoing.set(this._hashFn(k),_),_.incoming.set(this._hashFn(y),D)}removeNode(y){const k=this._hashFn(y);this._nodes.delete(k);for(let D of this._nodes.values())D.outgoing.delete(k),D.incoming.delete(k)}lookupOrInsertNode(y){const k=this._hashFn(y);let D=this._nodes.get(k);return D||(D=new m(y),this._nodes.set(k,D)),D}lookup(y){return this._nodes.get(this._hashFn(y))}isEmpty(){return this._nodes.size===0}toString(){let y=[];for(let[k,D]of this._nodes)y.push(`${k}, (incoming)[${[...D.incoming.keys()].join(", ")}], (outgoing)[${[...D.outgoing.keys()].join(",")}]`);return y.join(`
`)}findCycleSlow(){for(let[y,k]of this._nodes){const D=new Set([y]),_=this._findCycle(k,D);if(_)return _}}_findCycle(y,k){for(let[D,_]of y.outgoing){if(k.has(D))return[...k,D].join(" -> ");k.add(D);const C=this._findCycle(_,k);if(C)return C;k.delete(D)}}}e.Graph=T}),define(_e[5],Ee([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.optional=e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var m;(function(D){D.serviceIds=new Map,D.DI_TARGET="$di$target",D.DI_DEPENDENCIES="$di$dependencies";function _(C){return C[D.DI_DEPENDENCIES]||[]}D.getServiceDependencies=_})(m=e._util||(e._util={})),e.IInstantiationService=S("instantiationService");function T(D,_,C,n){_[m.DI_TARGET]===_?_[m.DI_DEPENDENCIES].push({id:D,index:C,optional:n}):(_[m.DI_DEPENDENCIES]=[{id:D,index:C,optional:n}],_[m.DI_TARGET]=_)}function S(D){if(m.serviceIds.has(D))return m.serviceIds.get(D);const _=function(C,n,I){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");T(_,C,I,!1)};return _.toString=()=>D,m.serviceIds.set(D,_),_}e.createDecorator=S;function y(D){return D}e.refineServiceDecorator=y;function k(D){return function(_,C,n){if(arguments.length!==3)throw new Error("@optional-decorator can only be used to decorate a parameter");T(D,_,n,!0)}}e.optional=k}),define(_e[142],Ee([0,1,5]),function(Z,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shouldSynchronizeModel=e.IModelService=void 0,e.IModelService=m.createDecorator("modelService");function T(S){return!S.isTooLargeForSyncing()&&!S.isForSimpleWidget}e.shouldSynchronizeModel=T}),define(_e[143],Ee([0,1,3,53,7,22,77,55,142]),function(Z,e,m,T,S,y,k,D,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguageFeatureRequestDelays=e.LanguageFeatureRegistry=void 0;function C(o){return typeof o=="string"?!1:Array.isArray(o)?o.every(C):!!o.exclusive}class n{constructor(){this._clock=0,this._entries=[],this._onDidChange=new m.Emitter}get onDidChange(){return this._onDidChange.event}register(h,d){let c={selector:h,provider:d,_score:-1,_time:this._clock++};return this._entries.push(c),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),S.toDisposable(()=>{if(c){let b=this._entries.indexOf(c);b>=0&&(this._entries.splice(b,1),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),c=void 0)}})}has(h){return this.all(h).length>0}all(h){if(!h)return[];this._updateScores(h);const d=[];for(let c of this._entries)c._score>0&&d.push(c.provider);return d}ordered(h){const d=[];return this._orderedForEach(h,c=>d.push(c.provider)),d}orderedGroups(h){const d=[];let c,b;return this._orderedForEach(h,p=>{c&&b===p._score?c.push(p.provider):(b=p._score,c=[p.provider],d.push(c))}),d}_orderedForEach(h,d){if(!!h){this._updateScores(h);for(const c of this._entries)c._score>0&&d(c)}}_updateScores(h){let d={uri:h.uri.toString(),language:h.getLanguageIdentifier().language};if(!(this._lastCandidate&&this._lastCandidate.language===d.language&&this._lastCandidate.uri===d.uri)){this._lastCandidate=d;for(let c of this._entries)if(c._score=D.score(c.selector,h.uri,h.getLanguageIdentifier().language,_.shouldSynchronizeModel(h)),C(c.selector)&&c._score>0){for(let b of this._entries)b._score=0;c._score=1e3;break}this._entries.sort(n._compareByScoreAndTime)}}static _compareByScoreAndTime(h,d){return h._score<d._score?1:h._score>d._score?-1:h._time<d._time?1:h._time>d._time?-1:0}}e.LanguageFeatureRegistry=n;class I{constructor(h,d,c=Number.MAX_SAFE_INTEGER){this._registry=h,this.min=d,this.max=c,this._cache=new y.LRUCache(50,.7)}_key(h){return h.id+T.hash(this._registry.all(h))}_clamp(h){return h===void 0?this.min:Math.min(this.max,Math.max(this.min,Math.floor(h*1.3)))}get(h){const d=this._key(h),c=this._cache.get(d);return this._clamp(c==null?void 0:c.value)}update(h,d){const c=this._key(h);let b=this._cache.get(c);return b||(b=new k.MovingAverage,this._cache.set(c,b)),b.update(d),this.get(h)}}e.LanguageFeatureRequestDelays=I}),define(_e[58],Ee([0,1,2,31,143,119,78]),function(Z,e,m,T,S,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.DocumentRangeSemanticTokensProviderRegistry=e.DocumentSemanticTokensProviderRegistry=e.FoldingRangeProviderRegistry=e.SelectionRangeRegistry=e.ColorProviderRegistry=e.LinkProviderRegistry=e.OnTypeFormattingEditProviderRegistry=e.DocumentRangeFormattingEditProviderRegistry=e.DocumentFormattingEditProviderRegistry=e.CodeActionProviderRegistry=e.InlayHintsProviderRegistry=e.CodeLensProviderRegistry=e.TypeDefinitionProviderRegistry=e.ImplementationProviderRegistry=e.DeclarationProviderRegistry=e.DefinitionProviderRegistry=e.LinkedEditingRangeProviderRegistry=e.DocumentHighlightProviderRegistry=e.DocumentSymbolProviderRegistry=e.InlineValuesProviderRegistry=e.EvaluatableExpressionProviderRegistry=e.HoverProviderRegistry=e.SignatureHelpProviderRegistry=e.InlineCompletionsProviderRegistry=e.CompletionProviderRegistry=e.RenameProviderRegistry=e.ReferenceProviderRegistry=e.InlayHintKind=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.completionKindFromString=e.completionKindToCssClass=e.CompletionItemKind=e.TokenMetadata=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageIdentifier=e.LanguageId=void 0;var D;(function(a){a[a.Null=0]="Null",a[a.PlainText=1]="PlainText"})(D=e.LanguageId||(e.LanguageId={}));class _{constructor(F,N){this.language=F,this.id=N}}e.LanguageIdentifier=_;var C;(function(a){a[a.NotSet=-1]="NotSet",a[a.None=0]="None",a[a.Italic=1]="Italic",a[a.Bold=2]="Bold",a[a.Underline=4]="Underline"})(C=e.FontStyle||(e.FontStyle={}));var n;(function(a){a[a.None=0]="None",a[a.DefaultForeground=1]="DefaultForeground",a[a.DefaultBackground=2]="DefaultBackground"})(n=e.ColorId||(e.ColorId={}));var I;(function(a){a[a.Other=0]="Other",a[a.Comment=1]="Comment",a[a.String=2]="String",a[a.RegEx=4]="RegEx"})(I=e.StandardTokenType||(e.StandardTokenType={}));var o;(function(a){a[a.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",a[a.TOKEN_TYPE_MASK=1792]="TOKEN_TYPE_MASK",a[a.FONT_STYLE_MASK=14336]="FONT_STYLE_MASK",a[a.FOREGROUND_MASK=8372224]="FOREGROUND_MASK",a[a.BACKGROUND_MASK=4286578688]="BACKGROUND_MASK",a[a.ITALIC_MASK=2048]="ITALIC_MASK",a[a.BOLD_MASK=4096]="BOLD_MASK",a[a.UNDERLINE_MASK=8192]="UNDERLINE_MASK",a[a.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",a[a.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",a[a.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",a[a.SEMANTIC_USE_FOREGROUND=8]="SEMANTIC_USE_FOREGROUND",a[a.SEMANTIC_USE_BACKGROUND=16]="SEMANTIC_USE_BACKGROUND",a[a.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",a[a.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",a[a.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",a[a.FOREGROUND_OFFSET=14]="FOREGROUND_OFFSET",a[a.BACKGROUND_OFFSET=23]="BACKGROUND_OFFSET"})(o=e.MetadataConsts||(e.MetadataConsts={}));class h{static getLanguageId(F){return(F&255)>>>0}static getTokenType(F){return(F&1792)>>>8}static getFontStyle(F){return(F&14336)>>>11}static getForeground(F){return(F&8372224)>>>14}static getBackground(F){return(F&4286578688)>>>23}static getClassNameFromMetadata(F){let N=this.getForeground(F),W="mtk"+N,le=this.getFontStyle(F);return le&1&&(W+=" mtki"),le&2&&(W+=" mtkb"),le&4&&(W+=" mtku"),W}static getInlineStyleFromMetadata(F,N){const W=this.getForeground(F),le=this.getFontStyle(F);let fe=`color: ${N[W]};`;return le&1&&(fe+="font-style: italic;"),le&2&&(fe+="font-weight: bold;"),le&4&&(fe+="text-decoration: underline;"),fe}}e.TokenMetadata=h;var d;(function(a){a[a.Method=0]="Method",a[a.Function=1]="Function",a[a.Constructor=2]="Constructor",a[a.Field=3]="Field",a[a.Variable=4]="Variable",a[a.Class=5]="Class",a[a.Struct=6]="Struct",a[a.Interface=7]="Interface",a[a.Module=8]="Module",a[a.Property=9]="Property",a[a.Event=10]="Event",a[a.Operator=11]="Operator",a[a.Unit=12]="Unit",a[a.Value=13]="Value",a[a.Constant=14]="Constant",a[a.Enum=15]="Enum",a[a.EnumMember=16]="EnumMember",a[a.Keyword=17]="Keyword",a[a.Text=18]="Text",a[a.Color=19]="Color",a[a.File=20]="File",a[a.Reference=21]="Reference",a[a.Customcolor=22]="Customcolor",a[a.Folder=23]="Folder",a[a.TypeParameter=24]="TypeParameter",a[a.User=25]="User",a[a.Issue=26]="Issue",a[a.Snippet=27]="Snippet"})(d=e.CompletionItemKind||(e.CompletionItemKind={})),e.completionKindToCssClass=function(){let a=Object.create(null);return a[0]="symbol-method",a[1]="symbol-function",a[2]="symbol-constructor",a[3]="symbol-field",a[4]="symbol-variable",a[5]="symbol-class",a[6]="symbol-struct",a[7]="symbol-interface",a[8]="symbol-module",a[9]="symbol-property",a[10]="symbol-event",a[11]="symbol-operator",a[12]="symbol-unit",a[13]="symbol-value",a[14]="symbol-constant",a[15]="symbol-enum",a[16]="symbol-enum-member",a[17]="symbol-keyword",a[27]="symbol-snippet",a[18]="symbol-text",a[19]="symbol-color",a[20]="symbol-file",a[21]="symbol-reference",a[22]="symbol-customcolor",a[23]="symbol-folder",a[24]="symbol-type-parameter",a[25]="account",a[26]="issues",function(F){const N=a[F];let W=N&&k.iconRegistry.get(N);return W||(console.info("No codicon found for CompletionItemKind "+F),W=k.Codicon.symbolProperty),W.classNames}}(),e.completionKindFromString=function(){let a=Object.create(null);return a.method=0,a.function=1,a.constructor=2,a.field=3,a.variable=4,a.class=5,a.struct=6,a.interface=7,a.module=8,a.property=9,a.event=10,a.operator=11,a.unit=12,a.value=13,a.constant=14,a.enum=15,a["enum-member"]=16,a.enumMember=16,a.keyword=17,a.snippet=27,a.text=18,a.color=19,a.file=20,a.reference=21,a.customcolor=22,a.folder=23,a["type-parameter"]=24,a.typeParameter=24,a.account=25,a.issue=26,function(F,N){let W=a[F];return typeof W=="undefined"&&!N&&(W=9),W}}();var c;(function(a){a[a.Deprecated=1]="Deprecated"})(c=e.CompletionItemTag||(e.CompletionItemTag={}));var b;(function(a){a[a.KeepWhitespace=1]="KeepWhitespace",a[a.InsertAsSnippet=4]="InsertAsSnippet"})(b=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var p;(function(a){a[a.Invoke=0]="Invoke",a[a.TriggerCharacter=1]="TriggerCharacter",a[a.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(p=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var w;(function(a){a[a.Automatic=0]="Automatic",a[a.Explicit=1]="Explicit"})(w=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var u;(function(a){a[a.Invoke=1]="Invoke",a[a.Auto=2]="Auto"})(u=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var f;(function(a){a[a.Invoke=1]="Invoke",a[a.TriggerCharacter=2]="TriggerCharacter",a[a.ContentChange=3]="ContentChange"})(f=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var g;(function(a){a[a.Text=0]="Text",a[a.Read=1]="Read",a[a.Write=2]="Write"})(g=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function t(a){return a&&m.URI.isUri(a.uri)&&T.Range.isIRange(a.range)&&(T.Range.isIRange(a.originSelectionRange)||T.Range.isIRange(a.targetSelectionRange))}e.isLocationLink=t;var i;(function(a){a[a.File=0]="File",a[a.Module=1]="Module",a[a.Namespace=2]="Namespace",a[a.Package=3]="Package",a[a.Class=4]="Class",a[a.Method=5]="Method",a[a.Property=6]="Property",a[a.Field=7]="Field",a[a.Constructor=8]="Constructor",a[a.Enum=9]="Enum",a[a.Interface=10]="Interface",a[a.Function=11]="Function",a[a.Variable=12]="Variable",a[a.Constant=13]="Constant",a[a.String=14]="String",a[a.Number=15]="Number",a[a.Boolean=16]="Boolean",a[a.Array=17]="Array",a[a.Object=18]="Object",a[a.Key=19]="Key",a[a.Null=20]="Null",a[a.EnumMember=21]="EnumMember",a[a.Struct=22]="Struct",a[a.Event=23]="Event",a[a.Operator=24]="Operator",a[a.TypeParameter=25]="TypeParameter"})(i=e.SymbolKind||(e.SymbolKind={}));var s;(function(a){a[a.Deprecated=1]="Deprecated"})(s=e.SymbolTag||(e.SymbolTag={}));var r;(function(a){const F=new Map;F.set("file",0),F.set("module",1),F.set("namespace",2),F.set("package",3),F.set("class",4),F.set("method",5),F.set("property",6),F.set("field",7),F.set("constructor",8),F.set("enum",9),F.set("interface",10),F.set("function",11),F.set("variable",12),F.set("constant",13),F.set("string",14),F.set("number",15),F.set("boolean",16),F.set("array",17),F.set("object",18),F.set("key",19),F.set("null",20),F.set("enum-member",21),F.set("struct",22),F.set("event",23),F.set("operator",24),F.set("type-parameter",25);const N=new Map;N.set(0,"file"),N.set(1,"module"),N.set(2,"namespace"),N.set(3,"package"),N.set(4,"class"),N.set(5,"method"),N.set(6,"property"),N.set(7,"field"),N.set(8,"constructor"),N.set(9,"enum"),N.set(10,"interface"),N.set(11,"function"),N.set(12,"variable"),N.set(13,"constant"),N.set(14,"string"),N.set(15,"number"),N.set(16,"boolean"),N.set(17,"array"),N.set(18,"object"),N.set(19,"key"),N.set(20,"null"),N.set(21,"enum-member"),N.set(22,"struct"),N.set(23,"event"),N.set(24,"operator"),N.set(25,"type-parameter");function W(Y){return F.get(Y)}a.fromString=W;function le(Y){return N.get(Y)}a.toString=le;function fe(Y,H){const J=N.get(Y);let R=J&&k.iconRegistry.get("symbol-"+J);return R||(console.info("No codicon found for SymbolKind "+Y),R=k.Codicon.symbolProperty),`${H?"inline":"block"} ${R.classNames}`}a.toCssClassName=fe})(r=e.SymbolKinds||(e.SymbolKinds={}));class l{constructor(F){this.value=F}}e.FoldingRangeKind=l,l.Comment=new l("comment"),l.Imports=new l("imports"),l.Region=new l("region");var E;(function(a){a[a.Collapsed=0]="Collapsed",a[a.Expanded=1]="Expanded"})(E=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var v;(function(a){a[a.Editing=0]="Editing",a[a.Preview=1]="Preview"})(v=e.CommentMode||(e.CommentMode={}));var A;(function(a){a[a.Other=0]="Other",a[a.Type=1]="Type",a[a.Parameter=2]="Parameter"})(A=e.InlayHintKind||(e.InlayHintKind={})),e.ReferenceProviderRegistry=new S.LanguageFeatureRegistry,e.RenameProviderRegistry=new S.LanguageFeatureRegistry,e.CompletionProviderRegistry=new S.LanguageFeatureRegistry,e.InlineCompletionsProviderRegistry=new S.LanguageFeatureRegistry,e.SignatureHelpProviderRegistry=new S.LanguageFeatureRegistry,e.HoverProviderRegistry=new S.LanguageFeatureRegistry,e.EvaluatableExpressionProviderRegistry=new S.LanguageFeatureRegistry,e.InlineValuesProviderRegistry=new S.LanguageFeatureRegistry,e.DocumentSymbolProviderRegistry=new S.LanguageFeatureRegistry,e.DocumentHighlightProviderRegistry=new S.LanguageFeatureRegistry,e.LinkedEditingRangeProviderRegistry=new S.LanguageFeatureRegistry,e.DefinitionProviderRegistry=new S.LanguageFeatureRegistry,e.DeclarationProviderRegistry=new S.LanguageFeatureRegistry,e.ImplementationProviderRegistry=new S.LanguageFeatureRegistry,e.TypeDefinitionProviderRegistry=new S.LanguageFeatureRegistry,e.CodeLensProviderRegistry=new S.LanguageFeatureRegistry,e.InlayHintsProviderRegistry=new S.LanguageFeatureRegistry,e.CodeActionProviderRegistry=new S.LanguageFeatureRegistry,e.DocumentFormattingEditProviderRegistry=new S.LanguageFeatureRegistry,e.DocumentRangeFormattingEditProviderRegistry=new S.LanguageFeatureRegistry,e.OnTypeFormattingEditProviderRegistry=new S.LanguageFeatureRegistry,e.LinkProviderRegistry=new S.LanguageFeatureRegistry,e.ColorProviderRegistry=new S.LanguageFeatureRegistry,e.SelectionRangeRegistry=new S.LanguageFeatureRegistry,e.FoldingRangeProviderRegistry=new S.LanguageFeatureRegistry,e.DocumentSemanticTokensProviderRegistry=new S.LanguageFeatureRegistry,e.DocumentRangeSemanticTokensProviderRegistry=new S.LanguageFeatureRegistry,e.TokenizationRegistry=new y.TokenizationRegistryImpl;var P;(function(a){a[a.None=0]="None",a[a.Option=1]="Option",a[a.Default=2]="Default",a[a.Preferred=3]="Preferred"})(P=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(_e[89],Ee([0,1,8,5,21]),function(Z,e,m,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyOrExpr=e.ContextKeyAndExpr=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.ContextKeyExpr=e.ContextKeyExprType=void 0;let y=S.userAgent||"";const k=new Map;k.set("false",!1),k.set("true",!0),k.set("isMac",S.isMacintosh),k.set("isLinux",S.isLinux),k.set("isWindows",S.isWindows),k.set("isWeb",S.isWeb),k.set("isMacNative",S.isMacintosh&&!S.isWeb),k.set("isEdge",y.indexOf("Edg/")>=0),k.set("isFirefox",y.indexOf("Firefox")>=0),k.set("isChrome",y.indexOf("Chrome")>=0),k.set("isSafari",y.indexOf("Safari")>=0);const D=Object.prototype.hasOwnProperty;var _;(function(P){P[P.False=0]="False",P[P.True=1]="True",P[P.Defined=2]="Defined",P[P.Not=3]="Not",P[P.Equals=4]="Equals",P[P.NotEquals=5]="NotEquals",P[P.And=6]="And",P[P.Regex=7]="Regex",P[P.NotRegex=8]="NotRegex",P[P.Or=9]="Or",P[P.In=10]="In",P[P.NotIn=11]="NotIn",P[P.Greater=12]="Greater",P[P.GreaterEquals=13]="GreaterEquals",P[P.Smaller=14]="Smaller",P[P.SmallerEquals=15]="SmallerEquals"})(_=e.ContextKeyExprType||(e.ContextKeyExprType={}));class C{static false(){return I.INSTANCE}static true(){return o.INSTANCE}static has(a){return h.create(a)}static equals(a,F){return d.create(a,F)}static notEquals(a,F){return p.create(a,F)}static regex(a,F){return i.create(a,F)}static in(a,F){return c.create(a,F)}static not(a){return w.create(a)}static and(...a){return r.create(a)}static or(...a){return l.create(a)}static greater(a,F){return u.create(a,F)}static less(a,F){return g.create(a,F)}static deserialize(a,F=!1){if(!!a)return this._deserializeOrExpression(a,F)}static _deserializeOrExpression(a,F){let N=a.split("||");return l.create(N.map(W=>this._deserializeAndExpression(W,F)))}static _deserializeAndExpression(a,F){let N=a.split("&&");return r.create(N.map(W=>this._deserializeOne(W,F)))}static _deserializeOne(a,F){if(a=a.trim(),a.indexOf("!=")>=0){let N=a.split("!=");return p.create(N[0].trim(),this._deserializeValue(N[1],F))}if(a.indexOf("==")>=0){let N=a.split("==");return d.create(N[0].trim(),this._deserializeValue(N[1],F))}if(a.indexOf("=~")>=0){let N=a.split("=~");return i.create(N[0].trim(),this._deserializeRegexValue(N[1],F))}if(a.indexOf(" in ")>=0){let N=a.split(" in ");return c.create(N[0].trim(),N[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(a)){const N=a.split(">=");return f.create(N[0].trim(),N[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(a)){const N=a.split(">");return u.create(N[0].trim(),N[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(a)){const N=a.split("<=");return t.create(N[0].trim(),N[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(a)){const N=a.split("<");return g.create(N[0].trim(),N[1].trim())}return/^\!\s*/.test(a)?w.create(a.substr(1).trim()):h.create(a)}static _deserializeValue(a,F){if(a=a.trim(),a==="true")return!0;if(a==="false")return!1;let N=/^'([^']*)'$/.exec(a);return N?N[1].trim():a}static _deserializeRegexValue(a,F){if(m.isFalsyOrWhitespace(a)){if(F)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let N=a.indexOf("/"),W=a.lastIndexOf("/");if(N===W||N<0){if(F)throw new Error(`bad regexp-value '${a}', missing /-enclosure`);return console.warn(`bad regexp-value '${a}', missing /-enclosure`),null}let le=a.slice(N+1,W),fe=a[W+1]==="i"?"i":"";try{return new RegExp(le,fe)}catch(Y){if(F)throw new Error(`bad regexp-value '${a}', parse error: ${Y}`);return console.warn(`bad regexp-value '${a}', parse error: ${Y}`),null}}}e.ContextKeyExpr=C;function n(P,a){return P.cmp(a)}class I{constructor(){this.type=0}cmp(a){return this.type-a.type}equals(a){return a.type===this.type}evaluate(a){return!1}serialize(){return"false"}keys(){return[]}map(a){return this}negate(){return o.INSTANCE}}e.ContextKeyFalseExpr=I,I.INSTANCE=new I;class o{constructor(){this.type=1}cmp(a){return this.type-a.type}equals(a){return a.type===this.type}evaluate(a){return!0}serialize(){return"true"}keys(){return[]}map(a){return this}negate(){return I.INSTANCE}}e.ContextKeyTrueExpr=o,o.INSTANCE=new o;class h{constructor(a){this.key=a,this.type=2}static create(a){const F=k.get(a);return typeof F=="boolean"?F?o.INSTANCE:I.INSTANCE:new h(a)}cmp(a){return a.type!==this.type?this.type-a.type:v(this.key,a.key)}equals(a){return a.type===this.type?this.key===a.key:!1}evaluate(a){return!!a.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(a){return a.mapDefined(this.key)}negate(){return w.create(this.key)}}e.ContextKeyDefinedExpr=h;class d{constructor(a,F){this.key=a,this.value=F,this.type=4}static create(a,F){if(typeof F=="boolean")return F?h.create(a):w.create(a);const N=k.get(a);return typeof N=="boolean"?F===(N?"true":"false")?o.INSTANCE:I.INSTANCE:new d(a,F)}cmp(a){return a.type!==this.type?this.type-a.type:A(this.key,this.value,a.key,a.value)}equals(a){return a.type===this.type?this.key===a.key&&this.value===a.value:!1}evaluate(a){return a.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(a){return a.mapEquals(this.key,this.value)}negate(){return p.create(this.key,this.value)}}e.ContextKeyEqualsExpr=d;class c{constructor(a,F){this.key=a,this.valueKey=F,this.type=10}static create(a,F){return new c(a,F)}cmp(a){return a.type!==this.type?this.type-a.type:A(this.key,this.valueKey,a.key,a.valueKey)}equals(a){return a.type===this.type?this.key===a.key&&this.valueKey===a.valueKey:!1}evaluate(a){const F=a.getValue(this.valueKey),N=a.getValue(this.key);return Array.isArray(F)?F.indexOf(N)>=0:typeof N=="string"&&typeof F=="object"&&F!==null?D.call(F,N):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(a){return a.mapIn(this.key,this.valueKey)}negate(){return b.create(this)}}e.ContextKeyInExpr=c;class b{constructor(a){this._actual=a,this.type=11}static create(a){return new b(a)}cmp(a){return a.type!==this.type?this.type-a.type:this._actual.cmp(a._actual)}equals(a){return a.type===this.type?this._actual.equals(a._actual):!1}evaluate(a){return!this._actual.evaluate(a)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(a){return new b(this._actual.map(a))}negate(){return this._actual}}e.ContextKeyNotInExpr=b;class p{constructor(a,F){this.key=a,this.value=F,this.type=5}static create(a,F){if(typeof F=="boolean")return F?w.create(a):h.create(a);const N=k.get(a);return typeof N=="boolean"?F===(N?"true":"false")?I.INSTANCE:o.INSTANCE:new p(a,F)}cmp(a){return a.type!==this.type?this.type-a.type:A(this.key,this.value,a.key,a.value)}equals(a){return a.type===this.type?this.key===a.key&&this.value===a.value:!1}evaluate(a){return a.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(a){return a.mapNotEquals(this.key,this.value)}negate(){return d.create(this.key,this.value)}}e.ContextKeyNotEqualsExpr=p;class w{constructor(a){this.key=a,this.type=3}static create(a){const F=k.get(a);return typeof F=="boolean"?F?I.INSTANCE:o.INSTANCE:new w(a)}cmp(a){return a.type!==this.type?this.type-a.type:v(this.key,a.key)}equals(a){return a.type===this.type?this.key===a.key:!1}evaluate(a){return!a.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(a){return a.mapNot(this.key)}negate(){return h.create(this.key)}}e.ContextKeyNotExpr=w;class u{constructor(a,F){this.key=a,this.value=F,this.type=12}static create(a,F){return new u(a,F)}cmp(a){return a.type!==this.type?this.type-a.type:A(this.key,this.value,a.key,a.value)}equals(a){return a.type===this.type?this.key===a.key&&this.value===a.value:!1}evaluate(a){return parseFloat(a.getValue(this.key))>parseFloat(this.value)}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(a){return a.mapGreater(this.key,this.value)}negate(){return t.create(this.key,this.value)}}e.ContextKeyGreaterExpr=u;class f{constructor(a,F){this.key=a,this.value=F,this.type=13}static create(a,F){return new f(a,F)}cmp(a){return a.type!==this.type?this.type-a.type:A(this.key,this.value,a.key,a.value)}equals(a){return a.type===this.type?this.key===a.key&&this.value===a.value:!1}evaluate(a){return parseFloat(a.getValue(this.key))>=parseFloat(this.value)}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(a){return a.mapGreaterEquals(this.key,this.value)}negate(){return g.create(this.key,this.value)}}e.ContextKeyGreaterEqualsExpr=f;class g{constructor(a,F){this.key=a,this.value=F,this.type=14}static create(a,F){return new g(a,F)}cmp(a){return a.type!==this.type?this.type-a.type:A(this.key,this.value,a.key,a.value)}equals(a){return a.type===this.type?this.key===a.key&&this.value===a.value:!1}evaluate(a){return parseFloat(a.getValue(this.key))<parseFloat(this.value)}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(a){return a.mapSmaller(this.key,this.value)}negate(){return f.create(this.key,this.value)}}e.ContextKeySmallerExpr=g;class t{constructor(a,F){this.key=a,this.value=F,this.type=15}static create(a,F){return new t(a,F)}cmp(a){return a.type!==this.type?this.type-a.type:A(this.key,this.value,a.key,a.value)}equals(a){return a.type===this.type?this.key===a.key&&this.value===a.value:!1}evaluate(a){return parseFloat(a.getValue(this.key))<=parseFloat(this.value)}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(a){return a.mapSmallerEquals(this.key,this.value)}negate(){return u.create(this.key,this.value)}}e.ContextKeySmallerEqualsExpr=t;class i{constructor(a,F){this.key=a,this.regexp=F,this.type=7}static create(a,F){return new i(a,F)}cmp(a){if(a.type!==this.type)return this.type-a.type;if(this.key<a.key)return-1;if(this.key>a.key)return 1;const F=this.regexp?this.regexp.source:"",N=a.regexp?a.regexp.source:"";return F<N?-1:F>N?1:0}equals(a){if(a.type===this.type){const F=this.regexp?this.regexp.source:"",N=a.regexp?a.regexp.source:"";return this.key===a.key&&F===N}return!1}evaluate(a){let F=a.getValue(this.key);return this.regexp?this.regexp.test(F):!1}serialize(){const a=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${a}`}keys(){return[this.key]}map(a){return a.mapRegex(this.key,this.regexp)}negate(){return s.create(this)}}e.ContextKeyRegexExpr=i;class s{constructor(a){this._actual=a,this.type=8}static create(a){return new s(a)}cmp(a){return a.type!==this.type?this.type-a.type:this._actual.cmp(a._actual)}equals(a){return a.type===this.type?this._actual.equals(a._actual):!1}evaluate(a){return!this._actual.evaluate(a)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(a){return new s(this._actual.map(a))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=s;class r{constructor(a){this.expr=a,this.type=6}static create(a){return r._normalizeArr(a)}cmp(a){if(a.type!==this.type)return this.type-a.type;if(this.expr.length<a.expr.length)return-1;if(this.expr.length>a.expr.length)return 1;for(let F=0,N=this.expr.length;F<N;F++){const W=n(this.expr[F],a.expr[F]);if(W!==0)return W}return 0}equals(a){if(a.type===this.type){if(this.expr.length!==a.expr.length)return!1;for(let F=0,N=this.expr.length;F<N;F++)if(!this.expr[F].equals(a.expr[F]))return!1;return!0}return!1}evaluate(a){for(let F=0,N=this.expr.length;F<N;F++)if(!this.expr[F].evaluate(a))return!1;return!0}static _normalizeArr(a){const F=[];let N=!1;for(const W of a)if(!!W){if(W.type===1){N=!0;continue}if(W.type===0)return I.INSTANCE;if(W.type===6){F.push(...W.expr);continue}F.push(W)}if(F.length===0&&N)return o.INSTANCE;if(F.length!==0){if(F.length===1)return F[0];for(F.sort(n);F.length>1;){const W=F[F.length-1];if(W.type!==9)break;F.pop();const le=F.pop(),fe=l.create(W.expr.map(Y=>r.create([Y,le])));fe&&(F.push(fe),F.sort(n))}return F.length===1?F[0]:new r(F)}}serialize(){return this.expr.map(a=>a.serialize()).join(" && ")}keys(){const a=[];for(let F of this.expr)a.push(...F.keys());return a}map(a){return new r(this.expr.map(F=>F.map(a)))}negate(){let a=[];for(let F of this.expr)a.push(F.negate());return l.create(a)}}e.ContextKeyAndExpr=r;class l{constructor(a){this.expr=a,this.type=9}static create(a){const F=l._normalizeArr(a);if(F.length!==0)return F.length===1?F[0]:new l(F)}cmp(a){if(a.type!==this.type)return this.type-a.type;if(this.expr.length<a.expr.length)return-1;if(this.expr.length>a.expr.length)return 1;for(let F=0,N=this.expr.length;F<N;F++){const W=n(this.expr[F],a.expr[F]);if(W!==0)return W}return 0}equals(a){if(a.type===this.type){if(this.expr.length!==a.expr.length)return!1;for(let F=0,N=this.expr.length;F<N;F++)if(!this.expr[F].equals(a.expr[F]))return!1;return!0}return!1}evaluate(a){for(let F=0,N=this.expr.length;F<N;F++)if(this.expr[F].evaluate(a))return!0;return!1}static _normalizeArr(a){let F=[],N=!1;if(a){for(let W=0,le=a.length;W<le;W++){const fe=a[W];if(!!fe){if(fe.type===0){N=!0;continue}if(fe.type===1)return[o.INSTANCE];if(fe.type===9){F=F.concat(fe.expr);continue}F.push(fe)}}if(F.length===0&&N)return[I.INSTANCE];F.sort(n)}return F}serialize(){return this.expr.map(a=>a.serialize()).join(" || ")}keys(){const a=[];for(let F of this.expr)a.push(...F.keys());return a}map(a){return new l(this.expr.map(F=>F.map(a)))}negate(){let a=[];for(let N of this.expr)a.push(N.negate());const F=N=>N.type===9?N.expr:[N];for(;a.length>1;){const N=a.shift(),W=a.shift(),le=[];for(const fe of F(N))for(const Y of F(W))le.push(C.and(fe,Y));a.unshift(C.or(...le))}return a[0]}}e.ContextKeyOrExpr=l;class E extends h{constructor(a,F,N){super(a);this._defaultValue=F,typeof N=="object"?E._info.push(Object.assign(Object.assign({},N),{key:a})):N!==!0&&E._info.push({key:a,description:N,type:F!=null?typeof F:void 0})}static all(){return E._info.values()}bindTo(a){return a.createKey(this.key,this._defaultValue)}getValue(a){return a.getContextKeyValue(this.key)}toNegated(){return C.not(this.key)}isEqualTo(a){return C.equals(this.key,a)}notEqualsTo(a){return C.notEquals(this.key,a)}}e.RawContextKey=E,E._info=[],e.IContextKeyService=T.createDecorator("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function v(P,a){return P<a?-1:P>a?1:0}function A(P,a,F,N){return P<F?-1:P>F?1:a<N?-1:a>N?1:0}}),define(_e[144],Ee([0,1,5]),function(Z,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=m.createDecorator("environmentService"),e.INativeEnvironmentService=m.refineServiceDecorator(e.IEnvironmentService)}),define(_e[26],Ee([0,1,8,5]),function(Z,e,m,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isAuthenticaionProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkpaceSupportTypeMessage=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin";function S(n){if(typeof n=="object"&&n!==null&&n.supported!==!0)return n.description}e.getWorkpaceSupportTypeMessage=S;function y(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(!n.uuid||typeof n.uuid=="string")}e.isIExtensionIdentifier=y,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var k;(function(n){n[n.System=0]="System",n[n.User=1]="User"})(k=e.ExtensionType||(e.ExtensionType={}));class D{constructor(I){this.value=I,this._lower=I.toLowerCase()}static equals(I,o){if(typeof I=="undefined"||I===null)return typeof o=="undefined"||o===null;if(typeof o=="undefined"||o===null)return!1;if(typeof I=="string"||typeof o=="string"){let h=typeof I=="string"?I:I.value,d=typeof o=="string"?o:o.value;return m.equalsIgnoreCase(h,d)}return I._lower===o._lower}static toKey(I){return typeof I=="string"?I.toLowerCase():I._lower}}e.ExtensionIdentifier=D;function _(n){return n.contributes&&n.contributes.localizations?n.contributes.localizations.length>0:!1}e.isLanguagePackExtension=_;function C(n){return n.contributes&&n.contributes.authentication?n.contributes.authentication.length>0:!1}e.isAuthenticaionProviderExtension=C,e.IBuiltinExtensionsScannerService=T.createDecorator("IBuiltinExtensionsScannerService")}),define(_e[145],Ee([0,1,8,26]),function(Z,e,m,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function S(h,d){return h.uuid&&d.uuid?h.uuid===d.uuid:h.id===d.id?!0:m.compareIgnoreCase(h.id,d.id)===0}e.areSameExtensions=S;class y{constructor(d,c){this.version=c,this.id=d.id,this.uuid=d.uuid}key(){return`${this.id}-${this.version}`}equals(d){return d instanceof y?S(this,d)&&this.version===d.version:!1}}e.ExtensionIdentifierWithVersion=y;function k(h,d){return`${h}.${d}`}e.getExtensionId=k;function D(h){return h.toLocaleLowerCase()}e.adoptToGalleryExtensionId=D;function _(h,d){return D(k(h,d))}e.getGalleryExtensionId=_;function C(h,d){const c=[],b=p=>{for(const w of c)if(w.some(u=>S(d(u),d(p))))return w;return null};for(const p of h){const w=b(p);w?w.push(p):c.push([p])}return c}e.groupByExtension=C;function n(h){return{id:h.identifier.id,name:h.manifest.name,galleryId:null,publisherId:h.publisherId,publisherName:h.manifest.publisher,publisherDisplayName:h.publisherDisplayName,dependencies:h.manifest.extensionDependencies&&h.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=n;function I(h){return Object.assign({id:h.identifier.id,name:h.name,galleryId:h.identifier.uuid,publisherId:h.publisherId,publisherName:h.publisher,publisherDisplayName:h.publisherDisplayName,dependencies:!!(h.properties.dependencies&&h.properties.dependencies.length>0)},h.telemetryData)}e.getGalleryExtensionTelemetryData=I,e.BetterMergeId=new T.ExtensionIdentifier("pprice.better-merge");function o(h){const d=new Set;for(const c of h)c.malicious&&d.add(c.id.id);return d}e.getMaliciousExtensionsSet=o}),define(_e[59],Ee([0,1,126,14,2,5,8,10,22]),function(Z,e,m,T,S,y,k,D,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=y.createDecorator("fileService");function C(H){return H.create===!0}e.isFileOpenForWriteOptions=C;var n;(function(H){H[H.Unknown=0]="Unknown",H[H.File=1]="File",H[H.Directory=2]="Directory",H[H.SymbolicLink=64]="SymbolicLink"})(n=e.FileType||(e.FileType={}));var I;(function(H){H[H.Readonly=1]="Readonly"})(I=e.FilePermission||(e.FilePermission={}));var o;(function(H){H[H.FileReadWrite=2]="FileReadWrite",H[H.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",H[H.FileReadStream=16]="FileReadStream",H[H.FileFolderCopy=8]="FileFolderCopy",H[H.PathCaseSensitive=1024]="PathCaseSensitive",H[H.Readonly=2048]="Readonly",H[H.Trash=4096]="Trash",H[H.FileWriteUnlock=8192]="FileWriteUnlock"})(o=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function h(H){return!!(H.capabilities&2)}e.hasReadWriteCapability=h;function d(H){return!!(H.capabilities&8)}e.hasFileFolderCopyCapability=d;function c(H){return!!(H.capabilities&4)}e.hasOpenReadWriteCloseCapability=c;function b(H){return!!(H.capabilities&16)}e.hasFileReadStreamCapability=b;var p;(function(H){H.FileExists="EntryExists",H.FileNotFound="EntryNotFound",H.FileNotADirectory="EntryNotADirectory",H.FileIsADirectory="EntryIsADirectory",H.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",H.FileTooLarge="EntryTooLarge",H.FileWriteLocked="EntryWriteLocked",H.NoPermissions="NoPermissions",H.Unavailable="Unavailable",H.Unknown="Unknown"})(p=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class w extends Error{constructor(J,R){super(J);this.code=R}}e.FileSystemProviderError=w;function u(H,J){const R=new w(H.toString(),J);return g(R,J),R}e.createFileSystemProviderError=u;function f(H){return H||u(m.localize(0,null),p.Unknown)}e.ensureFileSystemProviderError=f;function g(H,J){return H.name=J?`${J} (FileSystemError)`:"FileSystemError",H}e.markAsFileSystemProviderError=g;function t(H){if(!H)return p.Unknown;if(H instanceof w)return H.code;const J=/^(.+) \(FileSystemError\)$/.exec(H.name);if(!J)return p.Unknown;switch(J[1]){case p.FileExists:return p.FileExists;case p.FileIsADirectory:return p.FileIsADirectory;case p.FileNotADirectory:return p.FileNotADirectory;case p.FileNotFound:return p.FileNotFound;case p.FileExceedsMemoryLimit:return p.FileExceedsMemoryLimit;case p.FileTooLarge:return p.FileTooLarge;case p.FileWriteLocked:return p.FileWriteLocked;case p.NoPermissions:return p.NoPermissions;case p.Unavailable:return p.Unavailable}return p.Unknown}e.toFileSystemProviderErrorCode=t;function i(H){if(H instanceof A)return H.fileOperationResult;switch(t(H)){case p.FileNotFound:return 1;case p.FileIsADirectory:return 0;case p.FileNotADirectory:return 10;case p.FileWriteLocked:return 5;case p.NoPermissions:return 6;case p.FileExists:return 4;case p.FileExceedsMemoryLimit:return 9;case p.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=i;var s;(function(H){H[H.CREATE=0]="CREATE",H[H.DELETE=1]="DELETE",H[H.MOVE=2]="MOVE",H[H.COPY=3]="COPY"})(s=e.FileOperation||(e.FileOperation={}));class r{constructor(J,R,B){this.resource=J,this.operation=R,this.target=B}isOperation(J){return this.operation===J}}e.FileOperationEvent=r;var l;(function(H){H[H.UPDATED=0]="UPDATED",H[H.ADDED=1]="ADDED",H[H.DELETED=2]="DELETED"})(l=e.FileChangeType||(e.FileChangeType={}));class E{constructor(J,R){this.changes=J,this.added=void 0,this.updated=void 0,this.deleted=void 0;for(const B of J)switch(B.type){case 1:this.added||(this.added=_.TernarySearchTree.forUris(()=>R)),this.added.set(B.resource,B);break;case 0:this.updated||(this.updated=_.TernarySearchTree.forUris(()=>R)),this.updated.set(B.resource,B);break;case 2:this.deleted||(this.deleted=_.TernarySearchTree.forUris(()=>R)),this.deleted.set(B.resource,B);break}}contains(J,...R){return this.doContains(J,{includeChildren:!1},...R)}affects(J,...R){return this.doContains(J,{includeChildren:!0},...R)}doContains(J,R,...B){var M,x,q,z,oe,pe;if(!J)return!1;const Te=B.length>0;return!!((!Te||B.includes(1))&&(((M=this.added)===null||M===void 0?void 0:M.get(J))||R.includeChildren&&((x=this.added)===null||x===void 0?void 0:x.findSuperstr(J)))||(!Te||B.includes(0))&&(((q=this.updated)===null||q===void 0?void 0:q.get(J))||R.includeChildren&&((z=this.updated)===null||z===void 0?void 0:z.findSuperstr(J)))||(!Te||B.includes(2))&&(((oe=this.deleted)===null||oe===void 0?void 0:oe.findSubstr(J))||R.includeChildren&&((pe=this.deleted)===null||pe===void 0?void 0:pe.findSuperstr(J))))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}get raw(){return this.changes}get rawAdded(){return this.added}get rawDeleted(){return this.deleted}}e.FileChangesEvent=E;function v(H,J,R){return!H||!J||H===J||J.length>H.length?!1:(J.charAt(J.length-1)!==T.sep&&(J+=T.sep),R?k.startsWithIgnoreCase(H,J):H.indexOf(J)===0)}e.isParent=v;class A extends Error{constructor(J,R,B){super(J);this.fileOperationResult=R,this.options=B}}e.FileOperationError=A;class P extends A{constructor(J,R,B){super(J,2,B);this.stat=R}}e.NotModifiedSinceFileOperationError=P;var a;(function(H){H[H.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",H[H.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",H[H.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",H[H.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",H[H.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",H[H.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",H[H.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",H[H.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",H[H.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",H[H.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",H[H.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",H[H.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(a=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var F;(function(H){H[H.FILE=0]="FILE",H[H.FOLDER=1]="FOLDER",H[H.ROOT_FOLDER=2]="ROOT_FOLDER"})(F=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function N(H){if(!(typeof H.size!="number"||typeof H.mtime!="number"))return H.mtime.toString(29)+H.size.toString(31)}e.etag=N;async function W(H,J){if(!J.canHandleResource(S.URI.from({scheme:H.scheme})))return new Promise(R=>{const B=J.onDidChangeFileSystemProviderRegistrations(M=>{M.scheme===H.scheme&&M.added&&(B.dispose(),R())})})}e.whenProviderRegistered=W,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class le{static formatSize(J){return D.isNumber(J)||(J=0),J<le.KB?m.localize(1,null,J.toFixed(0)):J<le.MB?m.localize(2,null,(J/le.KB).toFixed(2)):J<le.GB?m.localize(3,null,(J/le.MB).toFixed(2)):J<le.TB?m.localize(4,null,(J/le.GB).toFixed(2)):m.localize(5,null,(J/le.TB).toFixed(2))}}e.ByteSize=le,le.KB=1024,le.MB=le.KB*le.KB,le.GB=le.MB*le.KB,le.TB=le.GB*le.KB;var fe;(function(H){H[H.IA32=0]="IA32",H[H.OTHER=1]="OTHER"})(fe=e.Arch||(e.Arch={}));function Y(H){return{maxFileSize:H===0?300*le.MB:16*le.GB,maxHeapSize:H===0?700*le.MB:2*700*le.MB}}e.getPlatformLimits=Y}),define(_e[60],Ee([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class m{constructor(...S){this._entries=new Map;for(let[y,k]of S)this.set(y,k)}set(S,y){const k=this._entries.get(S);return this._entries.set(S,y),k}has(S){return this._entries.has(S)}get(S){return this._entries.get(S)}}e.ServiceCollection=m}),define(_e[146],Ee([0,1,11,141,88,5,60,12]),function(Z,e,m,T,S,y,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const _=!1;class C extends Error{constructor(d){var c;super("cyclic dependency between services");this.message=(c=d.findCycleSlow())!==null&&c!==void 0?c:`UNABLE to detect cycle, dumping graph: 
${d.toString()}`}}class n{constructor(d=new k.ServiceCollection,c=!1,b){this._activeInstantiations=new Set,this._services=d,this._strict=c,this._parent=b,this._services.set(y.IInstantiationService,this)}createChild(d){return new n(d,this._strict,this)}invokeFunction(d,...c){let b=o.traceInvocation(d),p=!1;try{return d({get:(u,f)=>{if(p)throw m.illegalState("service accessor is only valid during the invocation of its target method");const g=this._getOrCreateServiceInstance(u,b);if(!g&&f!==y.optional)throw new Error(`[invokeFunction] unknown service '${u}'`);return g}},...c)}finally{p=!0,b.stop()}}createInstance(d,...c){let b,p;return d instanceof S.SyncDescriptor?(b=o.traceCreation(d.ctor),p=this._createInstance(d.ctor,d.staticArguments.concat(c),b)):(b=o.traceCreation(d),p=this._createInstance(d,c,b)),b.stop(),p}_createInstance(d,c=[],b){let p=y._util.getServiceDependencies(d).sort((f,g)=>f.index-g.index),w=[];for(const f of p){let g=this._getOrCreateServiceInstance(f.id,b);if(!g&&this._strict&&!f.optional)throw new Error(`[createInstance] ${d.name} depends on UNKNOWN service ${f.id}.`);w.push(g)}let u=p.length>0?p[0].index:c.length;if(c.length!==u){console.warn(`[createInstance] First service dependency of ${d.name} at position ${u+1} conflicts with ${c.length} static arguments`);let f=u-c.length;f>0?c=c.concat(new Array(f)):c=c.slice(0,u)}return new d(...[...c,...w])}_setServiceInstance(d,c){if(this._services.get(d)instanceof S.SyncDescriptor)this._services.set(d,c);else if(this._parent)this._parent._setServiceInstance(d,c);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(d){let c=this._services.get(d);return!c&&this._parent?this._parent._getServiceInstanceOrDescriptor(d):c}_getOrCreateServiceInstance(d,c){let b=this._getServiceInstanceOrDescriptor(d);return b instanceof S.SyncDescriptor?this._safeCreateAndCacheServiceInstance(d,b,c.branch(d,!0)):(c.branch(d,!1),b)}_safeCreateAndCacheServiceInstance(d,c,b){if(this._activeInstantiations.has(d))throw new Error(`illegal state - RECURSIVELY instantiating service '${d}'`);this._activeInstantiations.add(d);try{return this._createAndCacheServiceInstance(d,c,b)}finally{this._activeInstantiations.delete(d)}}_createAndCacheServiceInstance(d,c,b){const p=new T.Graph(f=>f.id.toString());let w=0;const u=[{id:d,desc:c,_trace:b}];for(;u.length;){const f=u.pop();if(p.lookupOrInsertNode(f),w++>1e3)throw new C(p);for(let g of y._util.getServiceDependencies(f.desc.ctor)){let t=this._getServiceInstanceOrDescriptor(g.id);if(!t&&!g.optional&&console.warn(`[createInstance] ${d} depends on ${g.id} which is NOT registered.`),t instanceof S.SyncDescriptor){const i={id:g.id,desc:t,_trace:f._trace.branch(g.id,!0)};p.insertEdge(f,i),u.push(i)}}}for(;;){const f=p.roots();if(f.length===0){if(!p.isEmpty())throw new C(p);break}for(const{data:g}of f){if(this._getServiceInstanceOrDescriptor(g.id)instanceof S.SyncDescriptor){const i=this._createServiceInstanceWithOwner(g.id,g.desc.ctor,g.desc.staticArguments,g.desc.supportsDelayedInstantiation,g._trace);this._setServiceInstance(g.id,i)}p.removeNode(g)}}return this._getServiceInstanceOrDescriptor(d)}_createServiceInstanceWithOwner(d,c,b=[],p,w){if(this._services.get(d)instanceof S.SyncDescriptor)return this._createServiceInstance(c,b,p,w);if(this._parent)return this._parent._createServiceInstanceWithOwner(d,c,b,p,w);throw new Error(`illegalState - creating UNKNOWN service instance ${c.name}`)}_createServiceInstance(d,c=[],b,p){if(b){const w=new D.IdleValue(()=>this._createInstance(d,c,p));return new Proxy(Object.create(null),{get(u,f){if(f in u)return u[f];let g=w.value,t=g[f];return typeof t!="function"||(t=t.bind(g),u[f]=t),t},set(u,f,g){return w.value[f]=g,!0}})}else return this._createInstance(d,c,p)}}e.InstantiationService=n;var I;(function(h){h[h.Creation=0]="Creation",h[h.Invocation=1]="Invocation",h[h.Branch=2]="Branch"})(I||(I={}));class o{constructor(d,c){this.type=d,this.name=c,this._start=Date.now(),this._dep=[]}static traceInvocation(d){return _?new o(1,d.name||d.toString().substring(0,42).replace(/\n/g,"")):o._None}static traceCreation(d){return _?new o(0,d.name):o._None}branch(d,c){let b=new o(2,d.toString());return this._dep.push([d,c,b]),b}stop(){let d=Date.now()-this._start;o._totals+=d;let c=!1;function b(w,u){let f=[],g=new Array(w+1).join("	");for(const[t,i,s]of u._dep)if(i&&s){c=!0,f.push(`${g}CREATES -> ${t}`);let r=b(w+1,s);r&&f.push(r)}else f.push(`${g}uses -> ${t}`);return f.join(`
`)}let p=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${b(1,this)}`,`DONE, took ${d.toFixed(2)}ms (grand total ${o._totals.toFixed(2)}ms)`];(d>2||c)&&console.log(p.join(`
`))}}o._None=new class extends o{constructor(){super(-1,null)}stop(){}branch(){return this}},o._totals=0}),define(_e[15],Ee([0,1,5,7,21,3,56]),function(Z,e,m,T,S,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=m.createDecorator("logService"),e.ILoggerService=m.createDecorator("loggerService");function D(){return new Date().toISOString()}var _;(function(g){g[g.Trace=0]="Trace",g[g.Debug=1]="Debug",g[g.Info=2]="Info",g[g.Warning=3]="Warning",g[g.Error=4]="Error",g[g.Critical=5]="Critical",g[g.Off=6]="Off"})(_=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=_.Info;class C extends T.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new y.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(t){this.level!==t&&(this.level=t,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=C;class n extends C{constructor(t){super();this.logAlways=t}checkLogLevel(t){return this.logAlways||this.getLevel()<=t}trace(t,...i){this.checkLogLevel(_.Trace)&&this.log(_.Trace,this.format([t,...i]))}debug(t,...i){this.checkLogLevel(_.Debug)&&this.log(_.Debug,this.format([t,...i]))}info(t,...i){this.checkLogLevel(_.Info)&&this.log(_.Info,this.format([t,...i]))}warn(t,...i){this.checkLogLevel(_.Warning)&&this.log(_.Warning,this.format([t,...i]))}error(t,...i){if(this.checkLogLevel(_.Error))if(t instanceof Error){const s=Array.prototype.slice.call(arguments);s[0]=t.stack,this.log(_.Error,this.format(s))}else this.log(_.Error,this.format([t,...i]))}critical(t,...i){this.checkLogLevel(_.Critical)&&this.log(_.Critical,this.format([t,...i]))}flush(){}format(t){let i="";for(let s=0;s<t.length;s++){let r=t[s];if(typeof r=="object")try{r=JSON.stringify(r)}catch(l){}i+=(s>0?" ":"")+r}return i}}e.AbstractMessageLogger=n;class I extends C{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t),this.useColors=!S.isWindows}trace(t,...i){this.getLevel()<=_.Trace&&(this.useColors?console.log(`[90m[main ${D()}][0m`,t,...i):console.log(`[main ${D()}]`,t,...i))}debug(t,...i){this.getLevel()<=_.Debug&&(this.useColors?console.log(`[90m[main ${D()}][0m`,t,...i):console.log(`[main ${D()}]`,t,...i))}info(t,...i){this.getLevel()<=_.Info&&(this.useColors?console.log(`[90m[main ${D()}][0m`,t,...i):console.log(`[main ${D()}]`,t,...i))}warn(t,...i){this.getLevel()<=_.Warning&&(this.useColors?console.warn(`[93m[main ${D()}][0m`,t,...i):console.warn(`[main ${D()}]`,t,...i))}error(t,...i){this.getLevel()<=_.Error&&(this.useColors?console.error(`[91m[main ${D()}][0m`,t,...i):console.error(`[main ${D()}]`,t,...i))}critical(t,...i){this.getLevel()<=_.Critical&&(this.useColors?console.error(`[90m[main ${D()}][0m`,t,...i):console.error(`[main ${D()}]`,t,...i))}dispose(){}flush(){}}e.ConsoleMainLogger=I;class o extends C{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t)}trace(t,...i){this.getLevel()<=_.Trace&&console.log("%cTRACE","color: #888",t,...i)}debug(t,...i){this.getLevel()<=_.Debug&&console.log("%cDEBUG","background: #eee; color: #888",t,...i)}info(t,...i){this.getLevel()<=_.Info&&console.log("%c INFO","color: #33f",t,...i)}warn(t,...i){this.getLevel()<=_.Warning&&console.log("%c WARN","color: #993",t,...i)}error(t,...i){this.getLevel()<=_.Error&&console.log("%c  ERR","color: #f33",t,...i)}critical(t,...i){this.getLevel()<=_.Critical&&console.log("%cCRITI","background: #f33; color: white",t,...i)}dispose(){}flush(){}}e.ConsoleLogger=o;class h extends C{constructor(t,i=e.DEFAULT_LOG_LEVEL){super();this.adapter=t,this.setLevel(i)}trace(t,...i){this.getLevel()<=_.Trace&&this.adapter.log(_.Trace,[this.extractMessage(t),...i])}debug(t,...i){this.getLevel()<=_.Debug&&this.adapter.log(_.Debug,[this.extractMessage(t),...i])}info(t,...i){this.getLevel()<=_.Info&&this.adapter.log(_.Info,[this.extractMessage(t),...i])}warn(t,...i){this.getLevel()<=_.Warning&&this.adapter.log(_.Warning,[this.extractMessage(t),...i])}error(t,...i){this.getLevel()<=_.Error&&this.adapter.log(_.Error,[this.extractMessage(t),...i])}critical(t,...i){this.getLevel()<=_.Critical&&this.adapter.log(_.Critical,[this.extractMessage(t),...i])}extractMessage(t){return typeof t=="string"?t:k.toErrorMessage(t,this.getLevel()<=_.Trace)}dispose(){}flush(){}}e.AdapterLogger=h;class d extends C{constructor(t){super();this.logServices=t,t.length&&this.setLevel(t[0].getLevel())}setLevel(t){for(const i of this.logServices)i.setLevel(t);super.setLevel(t)}trace(t,...i){for(const s of this.logServices)s.trace(t,...i)}debug(t,...i){for(const s of this.logServices)s.debug(t,...i)}info(t,...i){for(const s of this.logServices)s.info(t,...i)}warn(t,...i){for(const s of this.logServices)s.warn(t,...i)}error(t,...i){for(const s of this.logServices)s.error(t,...i)}critical(t,...i){for(const s of this.logServices)s.critical(t,...i)}flush(){for(const t of this.logServices)t.flush()}dispose(){for(const t of this.logServices)t.dispose()}}e.MultiplexLogService=d;class c extends T.Disposable{constructor(t){super();this.logger=t,this._register(t)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(t){this.logger.setLevel(t)}getLevel(){return this.logger.getLevel()}trace(t,...i){this.logger.trace(t,...i)}debug(t,...i){this.logger.debug(t,...i)}info(t,...i){this.logger.info(t,...i)}warn(t,...i){this.logger.warn(t,...i)}error(t,...i){this.logger.error(t,...i)}critical(t,...i){this.logger.critical(t,...i)}flush(){this.logger.flush()}}e.LogService=c;class b extends T.Disposable{constructor(t,i){super();this.logLevel=t,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(i(s=>{this.logLevel=s,this.logLevelChangeableLoggers.forEach(r=>r.setLevel(s))}))}createLogger(t,i){let s=this.loggers.get(t.toString());return s||(s=this.doCreateLogger(t,(i==null?void 0:i.always)?_.Trace:this.logLevel,i),this.loggers.set(t.toString(),s),(i==null?void 0:i.always)||this.logLevelChangeableLoggers.push(s)),s}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(t=>t.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=b;class p{constructor(){this.onDidChangeLogLevel=new y.Emitter().event}setLevel(t){}getLevel(){return _.Info}trace(t,...i){}debug(t,...i){}info(t,...i){}warn(t,...i){}error(t,...i){}critical(t,...i){}dispose(){}flush(){}}e.NullLogService=p;function w(g){if(g.verbose)return _.Trace;if(typeof g.logLevel=="string"){const t=u(g.logLevel.toLowerCase());if(t!==void 0)return t}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=w;function u(g){switch(g){case"trace":return _.Trace;case"debug":return _.Debug;case"info":return _.Info;case"warn":return _.Warning;case"error":return _.Error;case"critical":return _.Critical;case"off":return _.Off}}e.parseLogLevel=u;function f(g){switch(g){case _.Trace:return"trace";case _.Debug:return"debug";case _.Info:return"info";case _.Warning:return"warn";case _.Error:return"error";case _.Critical:return"critical";case _.Off:return"off"}}e.LogLevelToString=f}),define(_e[90],Ee([0,1,5,127,41]),function(Z,e,m,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var y;(function(_){_[_.Unnecessary=1]="Unnecessary",_[_.Deprecated=2]="Deprecated"})(y=e.MarkerTag||(e.MarkerTag={}));var k;(function(_){_[_.Hint=1]="Hint",_[_.Info=2]="Info",_[_.Warning=4]="Warning",_[_.Error=8]="Error"})(k=e.MarkerSeverity||(e.MarkerSeverity={})),function(_){function C(d,c){return c-d}_.compare=C;const n=Object.create(null);n[_.Error]=T.localize(0,null),n[_.Warning]=T.localize(1,null),n[_.Info]=T.localize(2,null);function I(d){return n[d]||""}_.toString=I;function o(d){switch(d){case S.default.Error:return _.Error;case S.default.Warning:return _.Warning;case S.default.Info:return _.Info;case S.default.Ignore:return _.Hint}}_.fromSeverity=o;function h(d){switch(d){case _.Error:return S.default.Error;case _.Warning:return S.default.Warning;case _.Info:return S.default.Info;case _.Hint:return S.default.Ignore}}_.toSeverity=h}(k=e.MarkerSeverity||(e.MarkerSeverity={}));var D;(function(_){const C="";function n(o){return I(o,!0)}_.makeKey=n;function I(o,h){let d=[C];return o.source?d.push(o.source.replace("\xA6","\\\xA6")):d.push(C),o.code?typeof o.code=="string"?d.push(o.code.replace("\xA6","\\\xA6")):d.push(o.code.value.replace("\xA6","\\\xA6")):d.push(C),o.severity!==void 0&&o.severity!==null?d.push(k.toString(o.severity)):d.push(C),o.message&&h?d.push(o.message.replace("\xA6","\\\xA6")):d.push(C),o.startLineNumber!==void 0&&o.startLineNumber!==null?d.push(o.startLineNumber.toString()):d.push(C),o.startColumn!==void 0&&o.startColumn!==null?d.push(o.startColumn.toString()):d.push(C),o.endLineNumber!==void 0&&o.endLineNumber!==null?d.push(o.endLineNumber.toString()):d.push(C),o.endColumn!==void 0&&o.endColumn!==null?d.push(o.endColumn.toString()):d.push(C),d.push(C),d.join("\xA6")}_.makeKeyOptionalMessage=I})(D=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=m.createDecorator("markerService")}),define(_e[147],Ee([0,1,41,5,3]),function(Z,e,m,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=m.default,e.INotificationService=T.createDecorator("notificationService");var y;(function(C){C[C.WORKSPACE=0]="WORKSPACE",C[C.GLOBAL=1]="GLOBAL"})(y=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var k;(function(C){C[C.OFF=0]="OFF",C[C.SILENT=1]="SILENT",C[C.ERROR=2]="ERROR"})(k=e.NotificationsFilter||(e.NotificationsFilter={}));class D{constructor(){this.progress=new _,this.onDidClose=S.Event.None,this.onDidChangeVisibility=S.Event.None}updateSeverity(n){}updateMessage(n){}updateActions(n){}close(){}}e.NoOpNotification=D;class _{infinite(){}done(){}total(n){}worked(n){}}e.NoOpProgress=_}),define(_e[148],Ee([0,1,7,8,2,5]),function(Z,e,m,T,S,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesScheme=e.NullOpenerService=e.IOpenerService=void 0,e.IOpenerService=y.createDecorator("openerService"),e.NullOpenerService=Object.freeze({_serviceBrand:void 0,registerOpener(){return m.Disposable.None},registerValidator(){return m.Disposable.None},registerExternalUriResolver(){return m.Disposable.None},setDefaultExternalOpener(){},registerExternalOpener(){return m.Disposable.None},async open(){return!1},async resolveExternalUri(D){return{resolved:D,dispose(){}}}});function k(D,_){return S.URI.isUri(D)?T.equalsIgnoreCase(D.scheme,_):T.startsWithIgnoreCase(D,_+":")}e.matchesScheme=k});var He=this&&this.__decorate||function(Z,e,m,T){var S=arguments.length,y=S<3?e:T===null?T=Object.getOwnPropertyDescriptor(e,m):T,k;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")y=Reflect.decorate(Z,e,m,T);else for(var D=Z.length-1;D>=0;D--)(k=Z[D])&&(y=(S<3?k(y):S>3?k(e,m,y):k(e,m))||y);return S>3&&y&&Object.defineProperty(e,m,y),y},ze=this&&this.__param||function(Z,e){return function(m,T){e(m,T,Z)}};define(_e[149],Ee([0,1,5,18,7,12]),function(Z,e,m,T,S,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=m.createDecorator("progressService");var k;(function(n){n[n.Explorer=1]="Explorer",n[n.Scm=3]="Scm",n[n.Extensions=5]="Extensions",n[n.Window=10]="Window",n[n.Notification=15]="Notification",n[n.Dialog=20]="Dialog"})(k=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class D{constructor(I){this.callback=I}get value(){return this._value}report(I){this._value=I,this.callback(this._value)}}e.Progress=D,D.None=Object.freeze({report(){}});let _=class extends S.Disposable{constructor(I,o){super();this.deferred=new y.DeferredPromise,o.withProgress(I,h=>(this.reporter=h,this.lastStep&&h.report(this.lastStep),this.deferred.p)),this._register(S.toDisposable(()=>this.deferred.complete()))}report(I){this.reporter?this.reporter.report(I):this.lastStep=I}};_=He([ze(1,e.IProgressService)],_),e.UnmanagedProgress=_;class C extends S.Disposable{constructor(I){super();this.progressIndicator=I,this.currentOperationId=0,this.currentOperationDisposables=this._register(new S.DisposableStore)}start(I){this.stop();const o=++this.currentOperationId,h=new T.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{o===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},I),this.currentOperationDisposables.add(S.toDisposable(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add(S.toDisposable(()=>h.cancel())),this.currentOperationDisposables.add(S.toDisposable(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:o,token:h.token,stop:()=>this.doStop(o),isCurrent:()=>this.currentOperationId===o}}stop(){this.doStop(this.currentOperationId)}doStop(I){this.currentOperationId===I&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=C,e.IEditorProgressService=m.createDecorator("editorProgressService")}),define(_e[43],Ee([0,1,10,39]),function(Z,e,m,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class S{constructor(){this.data=new Map}add(k,D){T.ok(m.isString(k)),T.ok(m.isObject(D)),T.ok(!this.data.has(k),"There is already an extension with this id"),this.data.set(k,D)}knows(k){return this.data.has(k)}as(k){return this.data.get(k)||null}}e.Registry=new S}),define(_e[150],Ee([0,1,43,3]),function(Z,e,m,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function S(D){return D.length>0&&D.charAt(D.length-1)==="#"?D.substring(0,D.length-1):D}class y{constructor(){this._onDidChangeSchema=new T.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(_,C){this.schemasById[S(_)]=C,this._onDidChangeSchema.fire(_)}notifySchemaChanged(_){this._onDidChangeSchema.fire(_)}getSchemaContributions(){return{schemas:this.schemasById}}}const k=new y;m.Registry.add(e.Extensions.JSONContribution,k)}),define(_e[61],Ee([0,1,124,3,43,10,150]),function(Z,e,m,T,S,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.overrideIdentifierFromKey=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=void 0,e.Extensions={Configuration:"base.contributions.configuration"};var D;(function(b){b[b.APPLICATION=1]="APPLICATION",b[b.MACHINE=2]="MACHINE",b[b.WINDOW=3]="WINDOW",b[b.RESOURCE=4]="RESOURCE",b[b.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",b[b.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(D=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const _=S.Registry.as(k.Extensions.JSONContribution);class C{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new T.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new T.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:m.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},_.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(p,w=!0){this.registerConfigurations([p],w)}registerConfigurations(p,w=!0){const u=[];p.forEach(f=>{u.push(...this.validateAndRegisterProperties(f,w,f.extensionInfo)),this.configurationContributors.push(f),this.registerJSONConfiguration(f)}),_.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(u)}deregisterConfigurations(p){const w=[],u=f=>{if(f.properties)for(const g in f.properties)w.push(g),delete this.configurationProperties[g],this.removeFromSchema(g,f.properties[g]);f.allOf&&f.allOf.forEach(g=>u(g))};for(const f of p){u(f);const g=this.configurationContributors.indexOf(f);g!==-1&&this.configurationContributors.splice(g,1)}_.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(w)}registerDefaultConfigurations(p){const w=[],u=[];for(const f of p)for(const g in f)if(w.push(g),e.OVERRIDE_PROPERTY_PATTERN.test(g)){this.defaultValues[g]=Object.assign(Object.assign({},this.defaultValues[g]||{}),f[g]);const t={type:"object",default:this.defaultValues[g],description:m.localize(1,null,g),$ref:e.resourceLanguageSettingsSchemaId};u.push(I(g)),this.configurationProperties[g]=t,this.defaultLanguageConfigurationOverridesNode.properties[g]=t}else{this.defaultValues[g]=f[g];const t=this.configurationProperties[g];t&&(this.updatePropertyDefaultValue(g,t),this.updateSchema(g,t))}this.registerOverrideIdentifiers(u),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(w)}deregisterDefaultConfigurations(p){const w=[];for(const u of p)for(const f in u)if(w.push(f),delete this.defaultValues[f],e.OVERRIDE_PROPERTY_PATTERN.test(f))delete this.configurationProperties[f],delete this.defaultLanguageConfigurationOverridesNode.properties[f];else{const g=this.configurationProperties[f];g&&(this.updatePropertyDefaultValue(f,g),this.updateSchema(f,g))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(w)}notifyConfigurationSchemaUpdated(...p){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(p){for(const w of p)this.overrideIdentifiers.add(w);this.updateOverridePropertyPatternKey()}validateAndRegisterProperties(p,w=!0,u,f=3){var g;f=y.isUndefinedOrNull(p.scope)?f:p.scope;let t=[],i=p.properties;if(i)for(let r in i){if(w&&d(r)){delete i[r];continue}const l=i[r];if(this.updatePropertyDefaultValue(r,l),e.OVERRIDE_PROPERTY_PATTERN.test(r)?l.scope=void 0:(l.scope=y.isUndefinedOrNull(l.scope)?f:l.scope,l.restricted=y.isUndefinedOrNull(l.restricted)?!!((g=u==null?void 0:u.restrictedConfigurations)===null||g===void 0?void 0:g.includes(r)):l.restricted),i[r].hasOwnProperty("included")&&!i[r].included){this.excludedConfigurationProperties[r]=i[r],delete i[r];continue}else this.configurationProperties[r]=i[r];!i[r].deprecationMessage&&i[r].markdownDeprecationMessage&&(i[r].deprecationMessage=i[r].markdownDeprecationMessage),t.push(r)}let s=p.allOf;if(s)for(let r of s)t.push(...this.validateAndRegisterProperties(r,w,u,f));return t}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(p){const w=u=>{let f=u.properties;if(f)for(const t in f)this.updateSchema(t,f[t]);let g=u.allOf;g&&g.forEach(w)};w(p)}updateSchema(p,w){switch(e.allSettings.properties[p]=w,w.scope){case 1:e.applicationSettings.properties[p]=w;break;case 2:e.machineSettings.properties[p]=w;break;case 6:e.machineOverridableSettings.properties[p]=w;break;case 3:e.windowSettings.properties[p]=w;break;case 4:e.resourceSettings.properties[p]=w;break;case 5:e.resourceSettings.properties[p]=w,this.resourceLanguageSettingsSchema.properties[p]=w;break}}removeFromSchema(p,w){switch(delete e.allSettings.properties[p],w.scope){case 1:delete e.applicationSettings.properties[p];break;case 2:delete e.machineSettings.properties[p];break;case 6:delete e.machineOverridableSettings.properties[p];break;case 3:delete e.windowSettings.properties[p];break;case 4:case 5:delete e.resourceSettings.properties[p];break}}updateOverridePropertyPatternKey(){for(const p of this.overrideIdentifiers.values()){const w=`[${p}]`,u={type:"object",description:m.localize(2,null),errorMessage:m.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(w,u),e.allSettings.properties[w]=u,e.applicationSettings.properties[w]=u,e.machineSettings.properties[w]=u,e.machineOverridableSettings.properties[w]=u,e.windowSettings.properties[w]=u,e.resourceSettings.properties[w]=u}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(p,w){let u=this.defaultValues[p];y.isUndefined(u)&&(u=w.default),y.isUndefined(u)&&(u=o(w.type)),w.default=u}}const n="\\[.*\\]$";e.OVERRIDE_PROPERTY_PATTERN=new RegExp(n);function I(b){return b.substring(1,b.length-1)}e.overrideIdentifierFromKey=I;function o(b){switch(Array.isArray(b)?b[0]:b){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=o;const h=new C;S.Registry.add(e.Extensions.Configuration,h);function d(b){return b.trim()?e.OVERRIDE_PROPERTY_PATTERN.test(b)?m.localize(5,null,b):h.getConfigurationProperties()[b]!==void 0?m.localize(6,null,b):null:m.localize(4,null)}e.validateProperty=d;function c(){const b=[],p=h.getConfigurationProperties();for(const w of Object.keys(p))b.push([w,p[w].scope]);return b.push(["launch",4]),b.push(["task",4]),b}e.getScopes=c}),define(_e[91],Ee([0,1,24,10,2,43,5,61]),function(Z,e,m,T,S,y,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.keyFromOverrideIdentifier=e.getDefaultValues=e.getConfigurationKeys=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.toOverrides=e.compare=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=k.createDecorator("configurationService");function _(i){return i&&typeof i=="object"&&(!i.overrideIdentifier||typeof i.overrideIdentifier=="string")&&(!i.resource||i.resource instanceof S.URI)}e.isConfigurationOverrides=_;var C;(function(i){i[i.USER=1]="USER",i[i.USER_LOCAL=2]="USER_LOCAL",i[i.USER_REMOTE=3]="USER_REMOTE",i[i.WORKSPACE=4]="WORKSPACE",i[i.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",i[i.DEFAULT=6]="DEFAULT",i[i.MEMORY=7]="MEMORY"})(C=e.ConfigurationTarget||(e.ConfigurationTarget={}));function n(i){switch(i){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=n;function I(i,s){const r=s?i?s.keys.filter(F=>i.keys.indexOf(F)===-1):[...s.keys]:[],l=i?s?i.keys.filter(F=>s.keys.indexOf(F)===-1):[...i.keys]:[],E=[];if(s&&i){for(const F of i.keys)if(s.keys.indexOf(F)!==-1){const N=p(i.contents,F),W=p(s.contents,F);m.equals(N,W)||E.push(F)}}const v=[],A=F=>{const N={};for(const W of F)for(const le of W.identifiers)N[g(le)]=W;return N},P=s?A(s.overrides):{},a=i?A(i.overrides):{};if(Object.keys(P).length)for(const F of r){const N=P[F];N&&v.push([D.overrideIdentifierFromKey(F),N.keys])}if(Object.keys(a).length)for(const F of l){const N=a[F];N&&v.push([D.overrideIdentifierFromKey(F),N.keys])}if(Object.keys(P).length&&Object.keys(a).length)for(const F of E){const N=a[F],W=P[F];if(N&&W){const le=I({contents:N.contents,keys:N.keys,overrides:[]},{contents:W.contents,keys:W.keys,overrides:[]});v.push([D.overrideIdentifierFromKey(F),[...le.added,...le.removed,...le.updated]])}}return{added:r,removed:l,updated:E,overrides:v}}e.compare=I;function o(i,s){const r=[];for(const l of Object.keys(i))if(D.OVERRIDE_PROPERTY_PATTERN.test(l)){const E={};for(const v in i[l])E[v]=i[l][v];r.push({identifiers:[D.overrideIdentifierFromKey(l).trim()],keys:Object.keys(E),contents:h(E,s)})}return r}e.toOverrides=o;function h(i,s){const r=Object.create(null);for(let l in i)d(r,l,i[l],s);return r}e.toValuesTree=h;function d(i,s,r,l){const E=s.split("."),v=E.pop();let A=i;for(let P=0;P<E.length;P++){let a=E[P],F=A[a];switch(typeof F){case"undefined":F=A[a]=Object.create(null);break;case"object":break;default:l(`Ignoring ${s} as ${E.slice(0,P+1).join(".")} is ${JSON.stringify(F)}`);return}A=F}if(typeof A=="object"&&A!==null)try{A[v]=r}catch(P){l(`Ignoring ${s} as ${E.join(".")} is ${JSON.stringify(A)}`)}else l(`Ignoring ${s} as ${E.join(".")} is ${JSON.stringify(A)}`)}e.addToValueTree=d;function c(i,s){const r=s.split(".");b(i,r)}e.removeFromValueTree=c;function b(i,s){const r=s.shift();if(s.length===0){delete i[r];return}if(Object.keys(i).indexOf(r)!==-1){const l=i[r];typeof l=="object"&&!Array.isArray(l)&&(b(l,s),Object.keys(l).length===0&&delete i[r])}}function p(i,s,r){function l(A,P){let a=A;for(const F of P){if(typeof a!="object"||a===null)return;a=a[F]}return a}const E=s.split("."),v=l(i,E);return typeof v=="undefined"?r:v}e.getConfigurationValue=p;function w(i,s,r){Object.keys(s).forEach(l=>{l!=="__proto__"&&(l in i?T.isObject(i[l])&&T.isObject(s[l])?w(i[l],s[l],r):r&&(i[l]=s[l]):i[l]=s[l])})}e.merge=w;function u(){const i=y.Registry.as(D.Extensions.Configuration).getConfigurationProperties();return Object.keys(i)}e.getConfigurationKeys=u;function f(){const i=Object.create(null),s=y.Registry.as(D.Extensions.Configuration).getConfigurationProperties();for(let r in s){let l=s[r].default;d(i,r,l,E=>console.error(`Conflict in default settings: ${E}`))}return i}e.getDefaultValues=f;function g(i){return`[${i}]`}e.keyFromOverrideIdentifier=g;function t(i,s,r){const l=i.inspect(s),E=i.inspect(r);return typeof l.userValue!="undefined"||typeof l.workspaceValue!="undefined"||typeof l.workspaceFolderValue!="undefined"?l.value:typeof E.userValue!="undefined"||typeof E.workspaceValue!="undefined"||typeof E.workspaceFolderValue!="undefined"?E.value:l.defaultValue}e.getMigratedSettingValue=t}),define(_e[151],Ee([0,1,107,22,17,10,24,2,61,91,43,7,3]),function(Z,e,m,T,S,y,k,D,_,C,n,I,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class h{constructor(t={},i=[],s=[]){this._contents=t,this._keys=i,this._overrides=s,this.isFrozen=!1}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(t){return t?C.getConfigurationValue(this.contents,t):this.contents}getOverrideValue(t,i){const s=this.getContentsForOverrideIdentifer(i);return s?t?C.getConfigurationValue(s,t):s:void 0}getKeysForOverrideIdentifier(t){for(const i of this.overrides)if(i.identifiers.indexOf(t)!==-1)return i.keys;return[]}override(t){const i=this.getContentsForOverrideIdentifer(t);if(!i||typeof i!="object"||!Object.keys(i).length)return this;let s={};for(const r of S.distinct([...Object.keys(this.contents),...Object.keys(i)])){let l=this.contents[r],E=i[r];E&&(typeof l=="object"&&typeof E=="object"?(l=k.deepClone(l),this.mergeContents(l,E)):l=E),s[r]=l}return new h(s,this.keys,this.overrides)}merge(...t){const i=k.deepClone(this.contents),s=k.deepClone(this.overrides),r=[...this.keys];for(const l of t){this.mergeContents(i,l.contents);for(const E of l.overrides){const[v]=s.filter(A=>S.equals(A.identifiers,E.identifiers));v?this.mergeContents(v.contents,E.contents):s.push(k.deepClone(E))}for(const E of l.keys)r.indexOf(E)===-1&&r.push(E)}return new h(i,r,s)}freeze(){return this.isFrozen=!0,this}mergeContents(t,i){for(const s of Object.keys(i)){if(s in t&&y.isObject(t[s])&&y.isObject(i[s])){this.mergeContents(t[s],i[s]);continue}t[s]=k.deepClone(i[s])}}checkAndFreeze(t){return this.isFrozen&&!Object.isFrozen(t)?k.deepFreeze(t):t}getContentsForOverrideIdentifer(t){for(const i of this.overrides)if(i.identifiers.indexOf(t)!==-1)return i.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(t,i){this.addKey(t),C.addToValueTree(this.contents,t,i,s=>{throw new Error(s)})}removeValue(t){this.removeKey(t)&&C.removeFromValueTree(this.contents,t)}addKey(t){let i=this.keys.length;for(let s=0;s<i;s++)t.indexOf(this.keys[s])===0&&(i=s);this.keys.splice(i,1,t)}removeKey(t){let i=this.keys.indexOf(t);return i!==-1?(this.keys.splice(i,1),!0):!1}}e.ConfigurationModel=h;class d extends h{constructor(){const t=C.getDefaultValues(),i=C.getConfigurationKeys(),s=[];for(const r of Object.keys(t))_.OVERRIDE_PROPERTY_PATTERN.test(r)&&s.push({identifiers:[_.overrideIdentifierFromKey(r).trim()],keys:Object.keys(t[r]),contents:C.toValuesTree(t[r],l=>console.error(`Conflict in default settings file: ${l}`))});super(t,i,s)}}e.DefaultConfigurationModel=d;class c{constructor(t){this._name=t,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new h}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(t,i){if(!y.isUndefinedOrNull(t)){const s=this.doParseContent(t);this.parseRaw(s,i)}}reparse(t){this._raw&&this.parseRaw(this._raw,t)}parseRaw(t,i){this._raw=t;const{contents:s,keys:r,overrides:l,restricted:E}=this.doParseRaw(t,i);this._configurationModel=new h(s,r,l),this._restrictedConfigurations=E||[]}doParseContent(t){let i={},s=null,r=[],l=[],E=[];function v(P){Array.isArray(r)?r.push(P):s&&(r[s]=P)}let A={onObjectBegin:()=>{let P={};v(P),l.push(r),r=P,s=null},onObjectProperty:P=>{s=P},onObjectEnd:()=>{r=l.pop()},onArrayBegin:()=>{let P=[];v(P),l.push(r),r=P,s=null},onArrayEnd:()=>{r=l.pop()},onLiteralValue:v,onError:(P,a,F)=>{E.push({error:P,offset:a,length:F})}};if(t)try{m.visit(t,A),i=r[0]||{}}catch(P){console.error(`Error while parsing settings file ${this._name}: ${P}`),this._parseErrors=[P]}return i}doParseRaw(t,i){const s=n.Registry.as(_.Extensions.Configuration).getConfigurationProperties(),r=this.filter(t,s,!0,i);t=r.raw;const l=C.toValuesTree(t,A=>console.error(`Conflict in settings file ${this._name}: ${A}`)),E=Object.keys(t),v=C.toOverrides(t,A=>console.error(`Conflict in settings file ${this._name}: ${A}`));return{contents:l,keys:E,overrides:v,restricted:r.restricted}}filter(t,i,s,r){if(!(r==null?void 0:r.scopes)&&!(r==null?void 0:r.skipRestricted))return{raw:t,restricted:[]};const l={},E=[];for(let v in t)if(_.OVERRIDE_PROPERTY_PATTERN.test(v)&&s){const A=this.filter(t[v],i,!1,r);l[v]=A.raw,E.push(...A.restricted)}else{const A=i[v],P=A?typeof A.scope!="undefined"?A.scope:3:void 0;(A==null?void 0:A.restricted)&&E.push(v),(P===void 0||r.scopes===void 0||r.scopes.includes(P))&&(r.skipRestricted&&(A==null?void 0:A.restricted)||(l[v]=t[v]))}return{raw:l,restricted:E}}}e.ConfigurationModelParser=c;class b extends I.Disposable{constructor(t,i,s,r){super();this.userSettingsResource=t,this.scopes=i,this.fileService=r,this._onDidChange=this._register(new o.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new c(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(s.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(o.Event.filter(this.fileService.onDidFilesChange,l=>l.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const t=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(t.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(t){return new h}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=b;class p{constructor(t,i,s=new h,r=new h,l=new T.ResourceMap,E=new h,v=new T.ResourceMap,A=!0){this._defaultConfiguration=t,this._localUserConfiguration=i,this._remoteUserConfiguration=s,this._workspaceConfiguration=r,this._folderConfigurations=l,this._memoryConfiguration=E,this._memoryConfigurationByResource=v,this._freeze=A,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new T.ResourceMap,this._userConfiguration=null}getValue(t,i,s){return this.getConsolidateConfigurationModel(i,s).getValue(t)}updateValue(t,i,s={}){let r;s.resource?(r=this._memoryConfigurationByResource.get(s.resource),r||(r=new h,this._memoryConfigurationByResource.set(s.resource,r))):r=this._memoryConfiguration,i===void 0?r.removeValue(t):r.setValue(t,i),s.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(t,i,s){const r=this.getConsolidateConfigurationModel(i,s),l=this.getFolderConfigurationModelForResource(i.resource,s),E=i.resource?this._memoryConfigurationByResource.get(i.resource)||this._memoryConfiguration:this._memoryConfiguration,v=i.overrideIdentifier?this._defaultConfiguration.freeze().override(i.overrideIdentifier).getValue(t):this._defaultConfiguration.freeze().getValue(t),A=i.overrideIdentifier?this.userConfiguration.freeze().override(i.overrideIdentifier).getValue(t):this.userConfiguration.freeze().getValue(t),P=i.overrideIdentifier?this.localUserConfiguration.freeze().override(i.overrideIdentifier).getValue(t):this.localUserConfiguration.freeze().getValue(t),a=i.overrideIdentifier?this.remoteUserConfiguration.freeze().override(i.overrideIdentifier).getValue(t):this.remoteUserConfiguration.freeze().getValue(t),F=s?i.overrideIdentifier?this._workspaceConfiguration.freeze().override(i.overrideIdentifier).getValue(t):this._workspaceConfiguration.freeze().getValue(t):void 0,N=l?i.overrideIdentifier?l.freeze().override(i.overrideIdentifier).getValue(t):l.freeze().getValue(t):void 0,W=i.overrideIdentifier?E.override(i.overrideIdentifier).getValue(t):E.getValue(t),le=r.getValue(t),fe=S.distinct(S.flatten(r.overrides.map(Y=>Y.identifiers))).filter(Y=>r.getOverrideValue(t,Y)!==void 0);return{defaultValue:v,userValue:A,userLocalValue:P,userRemoteValue:a,workspaceValue:F,workspaceFolderValue:N,memoryValue:W,value:le,default:v!==void 0?{value:this._defaultConfiguration.freeze().getValue(t),override:i.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,user:A!==void 0?{value:this.userConfiguration.freeze().getValue(t),override:i.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,userLocal:P!==void 0?{value:this.localUserConfiguration.freeze().getValue(t),override:i.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,userRemote:a!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(t),override:i.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,workspace:F!==void 0?{value:this._workspaceConfiguration.freeze().getValue(t),override:i.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,workspaceFolder:N!==void 0?{value:l==null?void 0:l.freeze().getValue(t),override:i.overrideIdentifier?l==null?void 0:l.freeze().getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,memory:W!==void 0?{value:E.getValue(t),override:i.overrideIdentifier?E.getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,overrideIdentifiers:fe.length?fe:void 0}}keys(t){const i=this.getFolderConfigurationModelForResource(void 0,t);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:i?i.freeze().keys:[]}}updateDefaultConfiguration(t){this._defaultConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(t){this._localUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(t){this._remoteUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(t){this._workspaceConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(t,i){this._folderConfigurations.set(t,i),this._foldersConsolidatedConfigurations.delete(t)}deleteFolderConfiguration(t){this.folderConfigurations.delete(t),this._foldersConsolidatedConfigurations.delete(t)}compareAndUpdateDefaultConfiguration(t,i){const s=i.filter(r=>_.OVERRIDE_PROPERTY_PATTERN.test(r)).map(r=>{const l=_.overrideIdentifierFromKey(r),E=this._defaultConfiguration.getKeysForOverrideIdentifier(l),v=t.getKeysForOverrideIdentifier(l),A=[...v.filter(P=>E.indexOf(P)===-1),...E.filter(P=>v.indexOf(P)===-1),...E.filter(P=>!k.equals(this._defaultConfiguration.override(l).getValue(P),t.override(l).getValue(P)))];return[l,A]});return this.updateDefaultConfiguration(t),{keys:i,overrides:s}}compareAndUpdateLocalUserConfiguration(t){const{added:i,updated:s,removed:r,overrides:l}=C.compare(this.localUserConfiguration,t),E=[...i,...s,...r];return E.length&&this.updateLocalUserConfiguration(t),{keys:E,overrides:l}}compareAndUpdateRemoteUserConfiguration(t){const{added:i,updated:s,removed:r,overrides:l}=C.compare(this.remoteUserConfiguration,t);let E=[...i,...s,...r];return E.length&&this.updateRemoteUserConfiguration(t),{keys:E,overrides:l}}compareAndUpdateWorkspaceConfiguration(t){const{added:i,updated:s,removed:r,overrides:l}=C.compare(this.workspaceConfiguration,t);let E=[...i,...s,...r];return E.length&&this.updateWorkspaceConfiguration(t),{keys:E,overrides:l}}compareAndUpdateFolderConfiguration(t,i){const s=this.folderConfigurations.get(t),{added:r,updated:l,removed:E,overrides:v}=C.compare(s,i);let A=[...r,...l,...E];return(A.length||!s)&&this.updateFolderConfiguration(t,i),{keys:A,overrides:v}}compareAndDeleteFolderConfiguration(t){const i=this.folderConfigurations.get(t);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:s,updated:r,removed:l,overrides:E}=C.compare(i,void 0);return{keys:[...s,...r,...l],overrides:E}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(t,i){let s=this.getConsolidatedConfigurationModelForResource(t,i);return t.overrideIdentifier?s.override(t.overrideIdentifier):s}getConsolidatedConfigurationModelForResource({resource:t},i){let s=this.getWorkspaceConsolidatedConfiguration();if(i&&t){const r=i.getFolder(t);r&&(s=this.getFolderConsolidatedConfiguration(r.uri)||s);const l=this._memoryConfigurationByResource.get(t);l&&(s=s.merge(l))}return s}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(t){let i=this._foldersConsolidatedConfigurations.get(t);if(!i){const s=this.getWorkspaceConsolidatedConfiguration(),r=this._folderConfigurations.get(t);r?(i=s.merge(r),this._freeze&&(i=i.freeze()),this._foldersConsolidatedConfigurations.set(t,i)):i=s}return i}getFolderConfigurationModelForResource(t,i){if(i&&t){const s=i.getFolder(t);if(s)return this._folderConfigurations.get(s.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((t,i)=>{const{contents:s,overrides:r,keys:l}=this._folderConfigurations.get(i);return t.push([i,{contents:s,overrides:r,keys:l}]),t},[])}}allKeys(){const t=new Set;return this._defaultConfiguration.freeze().keys.forEach(i=>t.add(i)),this.userConfiguration.freeze().keys.forEach(i=>t.add(i)),this._workspaceConfiguration.freeze().keys.forEach(i=>t.add(i)),this._folderConfigurations.forEach(i=>i.freeze().keys.forEach(s=>t.add(s))),[...t.values()]}getAllKeysForOverrideIdentifier(t){const i=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(t).forEach(s=>i.add(s)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(s=>i.add(s)),this._workspaceConfiguration.getKeysForOverrideIdentifier(t).forEach(s=>i.add(s)),this._folderConfigurations.forEach(s=>s.getKeysForOverrideIdentifier(t).forEach(r=>i.add(r))),[...i.values()]}static parse(t){const i=this.parseConfigurationModel(t.defaults),s=this.parseConfigurationModel(t.user),r=this.parseConfigurationModel(t.workspace),l=t.folders.reduce((E,v)=>(E.set(D.URI.revive(v[0]),this.parseConfigurationModel(v[1])),E),new T.ResourceMap);return new p(i,s,new h,r,l,new h,new T.ResourceMap,!1)}static parseConfigurationModel(t){return new h(t.contents,t.keys,t.overrides).freeze()}}e.Configuration=p;function w(...g){if(g.length===0)return{keys:[],overrides:[]};if(g.length===1)return g[0];const t=new Set,i=new Map;for(const r of g)r.keys.forEach(l=>t.add(l)),r.overrides.forEach(([l,E])=>{const v=T.getOrSet(i,l,new Set);E.forEach(A=>v.add(A))});const s=[];return i.forEach((r,l)=>s.push([l,[...r.values()]])),{keys:[...t.values()],overrides:s}}e.mergeChanges=w;class u{constructor(t,i,s,r){this.change=t,this.previous=i,this.currentConfiguraiton=s,this.currentWorkspace=r,this._previousConfiguration=void 0;const l=new Set;t.keys.forEach(v=>l.add(v)),t.overrides.forEach(([,v])=>v.forEach(A=>l.add(A))),this.affectedKeys=[...l.values()];const E=new h;this.affectedKeys.forEach(v=>E.setValue(v,{})),this.affectedKeysTree=E.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=p.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(t,i){var s;if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,t)){if(i){const r=this.previousConfiguration?this.previousConfiguration.getValue(t,i,(s=this.previous)===null||s===void 0?void 0:s.workspace):void 0,l=this.currentConfiguraiton.getValue(t,i,this.currentWorkspace);return!k.equals(r,l)}return!0}return!1}doesAffectedKeysTreeContains(t,i){let s=C.toValuesTree({[i]:!0},()=>{}),r;for(;typeof s=="object"&&(r=Object.keys(s)[0]);){if(t=t[r],!t)return!1;s=s[r]}return!0}}e.ConfigurationChangeEvent=u;class f extends u{constructor(t,i,s,r){super({keys:t.allKeys(),overrides:[]},void 0,t,i);this.source=s,this.sourceConfig=r}}e.AllKeysConfigurationChangeEvent=f}),define(_e[92],Ee([0,1,5]),function(Z,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=m.createDecorator("remoteAuthorityResolverService");var T;(function(y){y.Unknown="Unknown",y.NotAvailable="NotAvailable",y.TemporarilyNotAvailable="TemporarilyNotAvailable",y.NoResolverFound="NoResolverFound"})(T=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class S extends Error{constructor(k,D=T.Unknown,_){super(k);this._message=k,this._code=D,this._detail=_,this.isHandled=D===T.NotAvailable&&_===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,S.prototype)}static isTemporarilyNotAvailable(k){return k instanceof S&&k._code===T.TemporarilyNotAvailable}static isNoResolverFound(k){return k instanceof S&&k._code===T.NoResolverFound}static isHandled(k){return k instanceof S&&k.isHandled}}e.RemoteAuthorityResolverError=S}),define(_e[93],Ee([0,1,16]),function(Z,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=e.getRemoteName=e.getRemoteAuthority=void 0;function T(C){return C.scheme===m.Schemas.vscodeRemote?C.authority:void 0}e.getRemoteAuthority=T;function S(C){if(!C)return;const n=C.indexOf("+");return n<0?C:C.substr(0,n)}e.getRemoteName=S;function y(C){return C.scheme!==m.Schemas.file&&C.scheme!==m.Schemas.vscodeRemote}e.isVirtualResource=y;function k(C){if(C.folders.length)return C.folders.every(n=>y(n.uri))?C.folders[0].uri:void 0;if(C.configuration&&y(C.configuration))return C.configuration}e.getVirtualWorkspaceLocation=k;function D(C){var n;return(n=k(C))===null||n===void 0?void 0:n.scheme}e.getVirtualWorkspaceScheme=D;function _(C){return k(C)!==void 0}e.isVirtualWorkspace=_}),define(_e[152],Ee([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class m{constructor(S){this._callback=S,this._terminalBufferMap=new Map}dispose(){for(const S of this._terminalBufferMap.values())S.dispose()}startBuffering(S,y,k=5){let D;return D=y(_=>{const C=typeof _=="string"?_:_.data;let n=this._terminalBufferMap.get(S);if(n){n.data.push(C);return}const I=setTimeout(()=>this.flushBuffer(S),k);n={data:[C],timeoutId:I,dispose:()=>{clearTimeout(I),this.flushBuffer(S),D.dispose()}},this._terminalBufferMap.set(S,n)}),D}stopBuffering(S){const y=this._terminalBufferMap.get(S);y&&y.dispose()}flushBuffer(S){const y=this._terminalBufferMap.get(S);y&&(this._terminalBufferMap.delete(S),this._callback(S,y.data.join("")))}}e.TerminalDataBufferer=m}),define(_e[44],Ee([0,1,2,25,5,22]),function(Z,e,m,T,S,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=S.createDecorator("contextService");var k;(function(o){o[o.EMPTY=1]="EMPTY",o[o.FOLDER=2]="FOLDER",o[o.WORKSPACE=3]="WORKSPACE"})(k=e.WorkbenchState||(e.WorkbenchState={}));function D(o){const h=o;return!!(h&&typeof h=="object"&&typeof h.id=="string"&&Array.isArray(h.folders))}e.isWorkspace=D;function _(o){const h=o;return!!(h&&typeof h=="object"&&m.URI.isUri(h.uri)&&typeof h.name=="string"&&typeof h.toResource=="function")}e.isWorkspaceFolder=_;class C{constructor(h,d,c,b){this._id=h,this._configuration=c,this._ignorePathCasing=b,this._foldersMap=y.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=d}update(h){this._id=h.id,this._configuration=h.configuration,this._ignorePathCasing=h._ignorePathCasing,this.folders=h.folders}get folders(){return this._folders}set folders(h){this._folders=h,this.updateFoldersMap()}get id(){return this._id}get configuration(){return this._configuration}set configuration(h){this._configuration=h}getFolder(h){return h&&this._foldersMap.findSubstr(h.with({scheme:h.scheme,authority:h.authority,path:h.path}))||null}updateFoldersMap(){this._foldersMap=y.TernarySearchTree.forUris(this._ignorePathCasing);for(const h of this.folders)this._foldersMap.set(h.uri,h)}toJSON(){return{id:this.id,folders:this.folders,configuration:this.configuration}}}e.Workspace=C;class n{constructor(h,d){this.raw=d,this.uri=h.uri,this.index=h.index,this.name=h.name}toResource(h){return T.joinPath(this.uri,h)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=n;function I(o){return new n({uri:o,index:0,name:T.basenameOrAuthority(o)},{uri:o.toString()})}e.toWorkspaceFolder=I}),define(_e[62],Ee([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class m{constructor(S){this.id=S,this._data=new Map,this._idPool=1}add(S){const y=this._idPool++;return this._data.set(y,S),this.logDebugInfo(),y}get(S,y){return this._data.has(S)?this._data.get(S)[y]:void 0}delete(S){this._data.delete(S),this.logDebugInfo()}logDebugInfo(){!m.enableDebugLogging||console.log(`${this.id} cache size \u2014 ${this._data.size}`)}}e.Cache=m,m.enableDebugLogging=!1}),define(_e[63],Ee([0,1,2,3,5]),function(Z,e,m,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=S.createDecorator("IExtHostEditorTabs");class y{constructor(){this._onDidChangeTabs=new T.Emitter,this.onDidChangeTabs=this._onDidChangeTabs.event,this._tabs=[]}get tabs(){return this._tabs}$acceptEditorTabs(D){this._tabs=D.map(_=>({name:_.name,group:_.group,resource:m.URI.revive(_.resource),isActive:_.isActive})),this._onDidChangeTabs.fire()}}e.ExtHostEditorTabs=y}),define(_e[45],Ee([0,1,16,5]),function(Z,e,m,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class S{constructor(){this._systemSchemes=new Set(Object.keys(m.Schemas)),this._providerInfo=new Map}$acceptProviderInfos(k,D){D===null?this._providerInfo.delete(k):this._providerInfo.set(k,D)}isFreeScheme(k){return!this._providerInfo.has(k)&&!this._systemSchemes.has(k)}getCapabilities(k){return this._providerInfo.get(k)}}e.ExtHostFileSystemInfo=S,e.IExtHostFileSystemInfo=T.createDecorator("IExtHostFileSystemInfo")}),define(_e[28],Ee([0,1,5]),function(Z,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=m.createDecorator("IExtHostInitDataService")}),define(_e[153],Ee([0,1,12]),function(Z,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class T{constructor(k,D,_){this._deferredPromises=new Map,this._id=k,this._shared=D,this._storage=_,this._init=this._storage.getValue(this._shared,this._id,Object.create(null)).then(C=>(this._value=C,this)),this._storageListener=this._storage.onDidChangeStorage(C=>{C.shared===this._shared&&C.key===this._id&&(this._value=C.value)}),this._scheduler=new m.RunOnceScheduler(()=>{const C=this._deferredPromises;this._deferredPromises=new Map,(async()=>{try{await this._storage.setValue(this._shared,this._id,this._value);for(const n of C.values())n.complete()}catch(n){for(const I of C.values())I.error(n)}})()},0)}get keys(){var k;return Object.entries((k=this._value)!==null&&k!==void 0?k:{}).filter(([,D])=>D!==void 0).map(([D])=>D)}get whenReady(){return this._init}get(k,D){let _=this._value[k];return typeof _=="undefined"&&(_=D),_}update(k,D){this._value[k]=D;let _=this._deferredPromises.get(k);if(_!==void 0)return _.p;const C=new m.DeferredPromise;return this._deferredPromises.set(k,C),this._scheduler.isScheduled()||this._scheduler.schedule(),C.p}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=T;class S extends T{constructor(k,D){super(k.identifier.value,!0,D);this._extension=k}setKeysForSync(k){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},k)}}e.ExtensionGlobalMemento=S}),define(_e[154],Ee([0,1,3,2,15]),function(Z,e,m,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;let y=class{constructor(D,_){this._logService=D,this._notebooksAndEditors=_,this._onDidChangeNotebookDocumentMetadata=new m.Emitter,this.onDidChangeNotebookDocumentMetadata=this._onDidChangeNotebookDocumentMetadata.event,this._onDidSaveNotebookDocument=new m.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event}$acceptModelChanged(D,_,C){this._notebooksAndEditors.getNotebookDocument(T.URI.revive(D)).acceptModelChanged(_,C)}$acceptDirtyStateChanged(D,_){this._notebooksAndEditors.getNotebookDocument(T.URI.revive(D)).acceptDirty(_)}$acceptModelSaved(D){const _=this._notebooksAndEditors.getNotebookDocument(T.URI.revive(D));this._onDidSaveNotebookDocument.fire(_.apiNotebook)}$acceptDocumentPropertiesChanged(D,_){this._logService.debug("ExtHostNotebook#$acceptDocumentPropertiesChanged",D.path,_);const C=this._notebooksAndEditors.getNotebookDocument(T.URI.revive(D));C.acceptDocumentPropertiesChanged(_),_.metadata&&this._onDidChangeNotebookDocumentMetadata.fire({document:C.apiNotebook})}};y=He([ze(0,S.ILogService)],y),e.ExtHostNotebookDocuments=y}),define(_e[13],Ee([0,1,5]),function(Z,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=m.createDecorator("IExtHostRpcService");class T{constructor(y){this.getProxy=y.getProxy.bind(y),this.set=y.set.bind(y),this.assertRegistered=y.assertRegistered.bind(y),this.drain=y.drain.bind(y)}}e.ExtHostRpcService=T});var it=this&&this.__classPrivateFieldSet||function(Z,e,m,T,S){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!S:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?S.call(Z,m):S?S.value=m:e.set(Z,m),m},Ue=this&&this.__classPrivateFieldGet||function(Z,e,m,T){if(m==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!T:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?T:m==="a"?T.call(Z):T?T.value:e.get(Z)};define(_e[155],Ee([0,1,26,3]),function(Z,e,m,T){"use strict";var S;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class y{constructor(D,_){S.set(this,void 0),this._onDidChange=new T.Emitter,this.onDidChange=this._onDidChange.event,this._id=m.ExtensionIdentifier.toKey(D.identifier),it(this,S,_,"f"),Ue(this,S,"f").onDidChangePassword(C=>{C.extensionId===this._id&&this._onDidChange.fire({key:C.key})})}get(D){return Ue(this,S,"f").get(this._id,D)}store(D,_){return Ue(this,S,"f").store(this._id,D,_)}delete(D){return Ue(this,S,"f").delete(this._id,D)}}e.ExtensionSecrets=y,S=new WeakMap}),define(_e[94],Ee([0,1,5,3]),function(Z,e,m,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.ExtHostTelemetry=void 0;class S{constructor(){this._onDidChangeTelemetryEnabled=new T.Emitter,this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._enabled=!1}getTelemetryEnabled(){return this._enabled}$initializeTelemetryEnabled(k){this._enabled=k}$onDidChangeTelemetryEnabled(k){this._enabled=k,this._onDidChangeTelemetryEnabled.fire(k)}}e.ExtHostTelemetry=S,e.IExtHostTelemetry=m.createDecorator("IExtHostTelemetry")}),define(_e[64],Ee([0,1,3]),function(Z,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPrivateApiFor=e.ExtHostTestItemEventType=void 0;var T;(function(k){k[k.NewChild=0]="NewChild",k[k.Disposed=1]="Disposed",k[k.Invalidated=2]="Invalidated",k[k.SetProp=3]="SetProp"})(T=e.ExtHostTestItemEventType||(e.ExtHostTestItemEventType={}));const S=new WeakMap,y=k=>{let D=S.get(k);return D||(D={children:new Map,bus:new m.Emitter},S.set(k,D)),D};e.getPrivateApiFor=y}),define(_e[65],Ee([0,1,5,3,13]),function(Z,e,m,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDto=void 0;var y;(function(D){function _(n){return{remoteAddress:n.remoteAddress,localAddress:n.localAddress,public:!!n.public}}D.fromApiTunnel=_;function C(n){return{remoteAddress:{host:n.tunnelRemoteHost,port:n.tunnelRemotePort},localAddress:n.localAddress,public:n.public}}D.fromServiceTunnel=C})(y=e.TunnelDto||(e.TunnelDto={})),e.IExtHostTunnelService=m.createDecorator("IExtHostTunnelService");let k=class{constructor(_){this.onDidChangeTunnels=new T.Emitter().event}async $applyCandidateFilter(_){return _}async openTunnel(_,C){}async getTunnels(){return[]}async setTunnelExtensionFunctions(_){return{dispose:()=>{}}}registerPortsAttributesProvider(_,C){return{dispose:()=>{}}}async $providePortAttributes(_,C,n,I,o){return[]}async $forwardPort(_,C){}async $closeTunnel(_){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};k=He([ze(0,S.IExtHostRpcService)],k),e.ExtHostTunnelService=k});var it=this&&this.__classPrivateFieldSet||function(Z,e,m,T,S){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!S:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?S.call(Z,m):S?S.value=m:e.set(Z,m),m},Ue=this&&this.__classPrivateFieldGet||function(Z,e,m,T){if(m==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!T:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?T:m==="a"?T.call(Z):T?T.value:e.get(Z)};define(_e[6],Ee([0,1,17,11,80,22,82,10,2,34,59,92,64]),function(Z,e,m,T,S,y,k,D,_,C,n,I,o){"use strict";var h,d,c,b,p,w,u,f,g,t,i,s,r,l,E,v,A,P;Object.defineProperty(e,"__esModule",{value:!0}),e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.TestMessage=e.TestItemImpl=e.TestItemStatus=e.TestMessageSeverity=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookRendererScript=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.QuickInputButtons=e.DebugConfigurationProviderTriggerKind=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.TreeItemCollapsibleState=e.TreeItem=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestions=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function a(U){function L(){return Reflect.construct(U,arguments,this.constructor)}return Object.defineProperty(L,"name",Object.getOwnPropertyDescriptor(U,"name")),Object.setPrototypeOf(L,U),Object.setPrototypeOf(L.prototype,U.prototype),L}let F=p=class{constructor(L){h.set(this,void 0),it(this,h,L,"f")}static from(...L){let ne=L;return new p(function(){if(ne){for(const De of ne)De&&typeof De.dispose=="function"&&De.dispose();ne=void 0}})}dispose(){typeof Ue(this,h,"f")=="function"&&(Ue(this,h,"f").call(this),it(this,h,void 0,"f"))}};h=new WeakMap,F=p=He([a],F),e.Disposable=F;let N=w=class{constructor(L,ne){if(L<0)throw T.illegalArgument("line must be non-negative");if(ne<0)throw T.illegalArgument("character must be non-negative");this._line=L,this._character=ne}static Min(...L){if(L.length===0)throw new TypeError;let ne=L[0];for(let De=1;De<L.length;De++){const Ve=L[De];Ve.isBefore(ne)&&(ne=Ve)}return ne}static Max(...L){if(L.length===0)throw new TypeError;let ne=L[0];for(let De=1;De<L.length;De++){const Ve=L[De];Ve.isAfter(ne)&&(ne=Ve)}return ne}static isPosition(L){if(!L)return!1;if(L instanceof w)return!0;let{line:ne,character:De}=L;return typeof ne=="number"&&typeof De=="number"}get line(){return this._line}get character(){return this._character}isBefore(L){return this._line<L._line?!0:L._line<this._line?!1:this._character<L._character}isBeforeOrEqual(L){return this._line<L._line?!0:L._line<this._line?!1:this._character<=L._character}isAfter(L){return!this.isBeforeOrEqual(L)}isAfterOrEqual(L){return!this.isBefore(L)}isEqual(L){return this._line===L._line&&this._character===L._character}compareTo(L){return this._line<L._line?-1:this._line>L.line?1:this._character<L._character?-1:this._character>L._character?1:0}translate(L,ne=0){if(L===null||ne===null)throw T.illegalArgument();let De;return typeof L=="undefined"?De=0:typeof L=="number"?De=L:(De=typeof L.lineDelta=="number"?L.lineDelta:0,ne=typeof L.characterDelta=="number"?L.characterDelta:0),De===0&&ne===0?this:new w(this.line+De,this.character+ne)}with(L,ne=this.character){if(L===null||ne===null)throw T.illegalArgument();let De;return typeof L=="undefined"?De=this.line:typeof L=="number"?De=L:(De=typeof L.line=="number"?L.line:this.line,ne=typeof L.character=="number"?L.character:this.character),De===this.line&&ne===this.character?this:new w(De,ne)}toJSON(){return{line:this.line,character:this.character}}};N=w=He([a],N),e.Position=N;let W=u=class{constructor(L,ne,De,Ve){let tt,at;if(typeof L=="number"&&typeof ne=="number"&&typeof De=="number"&&typeof Ve=="number"?(tt=new N(L,ne),at=new N(De,Ve)):L instanceof N&&ne instanceof N&&(tt=L,at=ne),!tt||!at)throw new Error("Invalid arguments");tt.isBefore(at)?(this._start=tt,this._end=at):(this._start=at,this._end=tt)}static isRange(L){return L instanceof u?!0:L?N.isPosition(L.start)&&N.isPosition(L.end):!1}get start(){return this._start}get end(){return this._end}contains(L){return L instanceof u?this.contains(L._start)&&this.contains(L._end):L instanceof N?!(L.isBefore(this._start)||this._end.isBefore(L)):!1}isEqual(L){return this._start.isEqual(L._start)&&this._end.isEqual(L._end)}intersection(L){const ne=N.Max(L.start,this._start),De=N.Min(L.end,this._end);if(!ne.isAfter(De))return new u(ne,De)}union(L){if(this.contains(L))return this;if(L.contains(this))return L;const ne=N.Min(L.start,this._start),De=N.Max(L.end,this.end);return new u(ne,De)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(L,ne=this.end){if(L===null||ne===null)throw T.illegalArgument();let De;return L?N.isPosition(L)?De=L:(De=L.start||this.start,ne=L.end||this.end):De=this.start,De.isEqual(this._start)&&ne.isEqual(this.end)?this:new u(De,ne)}toJSON(){return[this.start,this.end]}};W=u=He([a],W),e.Range=W;let le=f=class extends W{constructor(L,ne,De,Ve){let tt,at;if(typeof L=="number"&&typeof ne=="number"&&typeof De=="number"&&typeof Ve=="number"?(tt=new N(L,ne),at=new N(De,Ve)):L instanceof N&&ne instanceof N&&(tt=L,at=ne),!tt||!at)throw new Error("Invalid arguments");super(tt,at);this._anchor=tt,this._active=at}static isSelection(L){return L instanceof f?!0:L?W.isRange(L)&&N.isPosition(L.anchor)&&N.isPosition(L.active)&&typeof L.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};le=f=He([a],le),e.Selection=le;class fe{constructor(L,ne,De){if(typeof L!="string"||L.length===0)throw T.illegalArgument("host");if(typeof ne!="number"||ne===0||Math.round(ne)!==ne)throw T.illegalArgument("port");if(typeof De!="undefined"&&(typeof De!="string"||De.length===0||!/^[0-9A-Za-z\-]+$/.test(De)))throw T.illegalArgument("connectionToken");this.host=L,this.port=Math.round(ne),this.connectionToken=De}}e.ResolvedAuthority=fe;class Y extends Error{constructor(L,ne=I.RemoteAuthorityResolverErrorCode.Unknown,De){super(L);this._message=L,this._code=ne,this._detail=De,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,Y.prototype)}static NotAvailable(L,ne){return new Y(L,I.RemoteAuthorityResolverErrorCode.NotAvailable,ne)}static TemporarilyNotAvailable(L){return new Y(L,I.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}}e.RemoteAuthorityResolverError=Y;var H;(function(U){U[U.LF=1]="LF",U[U.CRLF=2]="CRLF"})(H=e.EndOfLine||(e.EndOfLine={}));var J;(function(U){U[U.Replace=1]="Replace",U[U.Append=2]="Append",U[U.Prepend=3]="Prepend"})(J=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let R=g=class{constructor(L,ne){this._range=L,this._newText=ne}static isTextEdit(L){return L instanceof g?!0:L?W.isRange(L)&&typeof L.newText=="string":!1}static replace(L,ne){return new g(L,ne)}static insert(L,ne){return g.replace(new W(L,L),ne)}static delete(L){return g.replace(L,"")}static setEndOfLine(L){const ne=new g(new W(new N(0,0),new N(0,0)),"");return ne.newEol=L,ne}get range(){return this._range}set range(L){if(L&&!W.isRange(L))throw T.illegalArgument("range");this._range=L}get newText(){return this._newText||""}set newText(L){if(L&&typeof L!="string")throw T.illegalArgument("newText");this._newText=L}get newEol(){return this._newEol}set newEol(L){if(L&&typeof L!="number")throw T.illegalArgument("newEol");this._newEol=L}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};R=g=He([a],R),e.TextEdit=R;var B;(function(U){U[U.File=1]="File",U[U.Text=2]="Text",U[U.Cell=3]="Cell",U[U.CellReplace=5]="CellReplace"})(B=e.FileEditType||(e.FileEditType={}));let M=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(L,ne,De,Ve){this._edits.push({_type:1,from:L,to:ne,options:De,metadata:Ve})}createFile(L,ne,De){this._edits.push({_type:1,from:void 0,to:L,options:ne,metadata:De})}deleteFile(L,ne,De){this._edits.push({_type:1,from:L,to:void 0,options:ne,metadata:De})}replaceNotebookMetadata(L,ne,De){this._edits.push({_type:3,metadata:De,uri:L,edit:{editType:5,metadata:ne},notebookMetadata:ne})}replaceNotebookCells(L,ne,De,Ve,tt){let at,ut,yt=[],Ct;if(Ht.isNotebookRange(ne)&&Lt.isNotebookCellDataArray(De)&&!Lt.isNotebookCellDataArray(Ve)?(at=ne.start,ut=ne.end,yt=De,Ct=Ve):typeof ne=="number"&&typeof De=="number"&&Lt.isNotebookCellDataArray(Ve)&&(at=ne,ut=De,yt=Ve,Ct=tt),at===void 0||ut===void 0)throw new Error("Invalid arguments");(at!==ut||yt.length>0)&&this._edits.push({_type:5,uri:L,index:at,count:ut-at,cells:yt,metadata:Ct})}replaceNotebookCellMetadata(L,ne,De,Ve){this._edits.push({_type:3,metadata:Ve,uri:L,edit:{editType:8,index:ne,metadata:De}})}replace(L,ne,De,Ve){this._edits.push({_type:2,uri:L,edit:new R(ne,De),metadata:Ve})}insert(L,ne,De,Ve){this.replace(L,new W(ne,ne),De,Ve)}delete(L,ne,De){this.replace(L,ne,"",De)}has(L){return this._edits.some(ne=>ne._type===2&&ne.uri.toString()===L.toString())}set(L,ne){if(ne)for(const De of ne)De&&this._edits.push({_type:2,uri:L,edit:De});else{for(let De=0;De<this._edits.length;De++){const Ve=this._edits[De];Ve._type===2&&Ve.uri.toString()===L.toString()&&(this._edits[De]=void 0)}m.coalesceInPlace(this._edits)}}get(L){const ne=[];for(let De of this._edits)De._type===2&&De.uri.toString()===L.toString()&&ne.push(De.edit);return ne}entries(){const L=new y.ResourceMap;for(let ne of this._edits)if(ne._type===2){let De=L.get(ne.uri);De||(De=[ne.uri,[]],L.set(ne.uri,De)),De[1].push(ne.edit)}return[...L.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};M=He([a],M),e.WorkspaceEdit=M;let x=t=class{constructor(L){this._tabstop=1,this.value=L||""}static isSnippetString(L){return L instanceof t?!0:L?typeof L.value=="string":!1}static _escape(L){return L.replace(/\$|}|\\/g,"\\$&")}appendText(L){return this.value+=t._escape(L),this}appendTabstop(L=this._tabstop++){return this.value+="$",this.value+=L,this}appendPlaceholder(L,ne=this._tabstop++){if(typeof L=="function"){const De=new t;De._tabstop=this._tabstop,L(De),this._tabstop=De._tabstop,L=De.value}else L=t._escape(L);return this.value+="${",this.value+=ne,this.value+=":",this.value+=L,this.value+="}",this}appendChoice(L,ne=this._tabstop++){const De=L.map(Ve=>Ve.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=ne,this.value+="|",this.value+=De,this.value+="|}",this}appendVariable(L,ne){if(typeof ne=="function"){const De=new t;De._tabstop=this._tabstop,ne(De),this._tabstop=De._tabstop,ne=De.value}else typeof ne=="string"&&(ne=ne.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=L,ne&&(this.value+=":",this.value+=ne),this.value+="}",this}};x=t=He([a],x),e.SnippetString=x;var q;(function(U){U[U.Unnecessary=1]="Unnecessary",U[U.Deprecated=2]="Deprecated"})(q=e.DiagnosticTag||(e.DiagnosticTag={}));var z;(function(U){U[U.Hint=3]="Hint",U[U.Information=2]="Information",U[U.Warning=1]="Warning",U[U.Error=0]="Error"})(z=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let oe=i=class{constructor(L,ne){if(this.uri=L,ne)if(ne instanceof W)this.range=ne;else if(ne instanceof N)this.range=new W(ne,ne);else throw new Error("Illegal argument")}static isLocation(L){return L instanceof i?!0:L?W.isRange(L.range)&&_.URI.isUri(L.uri):!1}toJSON(){return{uri:this.uri,range:this.range}}};oe=i=He([a],oe),e.Location=oe;let pe=class{constructor(L,ne){this.location=L,this.message=ne}static is(L){return L?typeof L.message=="string"&&L.location&&W.isRange(L.location.range)&&_.URI.isUri(L.location.uri):!1}static isEqual(L,ne){return L===ne?!0:!L||!ne?!1:L.message===ne.message&&L.location.range.isEqual(ne.location.range)&&L.location.uri.toString()===ne.location.uri.toString()}};pe=He([a],pe),e.DiagnosticRelatedInformation=pe;let Te=class{constructor(L,ne,De=z.Error){if(!W.isRange(L))throw new TypeError("range must be set");if(!ne)throw new TypeError("message must be set");this.range=L,this.message=ne,this.severity=De}toJSON(){return{severity:z[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(L,ne){return L===ne?!0:!L||!ne?!1:L.message===ne.message&&L.severity===ne.severity&&L.code===ne.code&&L.severity===ne.severity&&L.source===ne.source&&L.range.isEqual(ne.range)&&m.equals(L.tags,ne.tags)&&m.equals(L.relatedInformation,ne.relatedInformation,pe.isEqual)}};Te=He([a],Te),e.Diagnostic=Te;let Be=class{constructor(L,ne){if(!L)throw new Error("Illegal argument, contents must be defined");Array.isArray(L)?this.contents=L:S.isMarkdownString(L)?this.contents=[L]:this.contents=[L],this.range=ne}};Be=He([a],Be),e.Hover=Be;var Fe;(function(U){U[U.Text=0]="Text",U[U.Read=1]="Read",U[U.Write=2]="Write"})(Fe=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let We=class{constructor(L,ne=Fe.Text){this.range=L,this.kind=ne}toJSON(){return{range:this.range,kind:Fe[this.kind]}}};We=He([a],We),e.DocumentHighlight=We;var Qe;(function(U){U[U.File=0]="File",U[U.Module=1]="Module",U[U.Namespace=2]="Namespace",U[U.Package=3]="Package",U[U.Class=4]="Class",U[U.Method=5]="Method",U[U.Property=6]="Property",U[U.Field=7]="Field",U[U.Constructor=8]="Constructor",U[U.Enum=9]="Enum",U[U.Interface=10]="Interface",U[U.Function=11]="Function",U[U.Variable=12]="Variable",U[U.Constant=13]="Constant",U[U.String=14]="String",U[U.Number=15]="Number",U[U.Boolean=16]="Boolean",U[U.Array=17]="Array",U[U.Object=18]="Object",U[U.Key=19]="Key",U[U.Null=20]="Null",U[U.EnumMember=21]="EnumMember",U[U.Struct=22]="Struct",U[U.Event=23]="Event",U[U.Operator=24]="Operator",U[U.TypeParameter=25]="TypeParameter"})(Qe=e.SymbolKind||(e.SymbolKind={}));var Ge;(function(U){U[U.Deprecated=1]="Deprecated"})(Ge=e.SymbolTag||(e.SymbolTag={}));let Ke=s=class{constructor(L,ne,De,Ve,tt){this.name=L,this.kind=ne,this.containerName=tt,typeof De=="string"&&(this.containerName=De),Ve instanceof oe?this.location=Ve:De instanceof W&&(this.location=new oe(Ve,De)),s.validate(this)}static validate(L){if(!L.name)throw new Error("name must not be falsy")}toJSON(){return{name:this.name,kind:Qe[this.kind],location:this.location,containerName:this.containerName}}};Ke=s=He([a],Ke),e.SymbolInformation=Ke;let $=r=class{constructor(L,ne,De,Ve,tt){this.name=L,this.detail=ne,this.kind=De,this.range=Ve,this.selectionRange=tt,this.children=[],r.validate(this)}static validate(L){if(!L.name)throw new Error("name must not be falsy");if(!L.range.contains(L.selectionRange))throw new Error("selectionRange must be contained in fullRange");L.children&&L.children.forEach(r.validate)}};$=r=He([a],$),e.DocumentSymbol=$;var Q;(function(U){U[U.Invoke=1]="Invoke",U[U.Automatic=2]="Automatic"})(Q=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let te=class{constructor(L,ne){this.title=L,this.kind=ne}};te=He([a],te),e.CodeAction=te;let re=l=class{constructor(L){this.value=L}append(L){return new l(this.value?this.value+l.sep+L:L)}intersects(L){return this.contains(L)||L.contains(this)}contains(L){return this.value===L.value||L.value.startsWith(this.value+l.sep)}};re.sep=".",re=l=He([a],re),e.CodeActionKind=re,re.Empty=new re(""),re.QuickFix=re.Empty.append("quickfix"),re.Refactor=re.Empty.append("refactor"),re.RefactorExtract=re.Refactor.append("extract"),re.RefactorInline=re.Refactor.append("inline"),re.RefactorRewrite=re.Refactor.append("rewrite"),re.Source=re.Empty.append("source"),re.SourceOrganizeImports=re.Source.append("organizeImports"),re.SourceFixAll=re.Source.append("fixAll");let G=class{constructor(L,ne){if(this.range=L,this.parent=ne,ne&&!ne.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};G=He([a],G),e.SelectionRange=G;class se{constructor(L,ne,De,Ve,tt,at){this.kind=L,this.name=ne,this.detail=De,this.uri=Ve,this.range=tt,this.selectionRange=at}}e.CallHierarchyItem=se;class he{constructor(L,ne){this.fromRanges=ne,this.from=L}}e.CallHierarchyIncomingCall=he;class Ae{constructor(L,ne){this.fromRanges=ne,this.to=L}}e.CallHierarchyOutgoingCall=Ae;let xe=class{constructor(L,ne){this.range=L,this.command=ne}get isResolved(){return!!this.command}};xe=He([a],xe),e.CodeLens=xe;let ve=E=class{constructor(L,ne=!1){d.set(this,void 0),it(this,d,new S.MarkdownString(L,{supportThemeIcons:ne}),"f")}static isMarkdownString(L){return L instanceof E?!0:L&&L.appendCodeblock&&L.appendMarkdown&&L.appendText&&L.value!==void 0}get value(){return Ue(this,d,"f").value}set value(L){Ue(this,d,"f").value=L}get isTrusted(){return Ue(this,d,"f").isTrusted}set isTrusted(L){Ue(this,d,"f").isTrusted=L}get supportThemeIcons(){return Ue(this,d,"f").supportThemeIcons}appendText(L){return Ue(this,d,"f").appendText(L),this}appendMarkdown(L){return Ue(this,d,"f").appendMarkdown(L),this}appendCodeblock(L,ne){return Ue(this,d,"f").appendCodeblock(ne??"",L),this}};d=new WeakMap,ve=E=He([a],ve),e.MarkdownString=ve;let je=class{constructor(L,ne){this.label=L,this.documentation=ne}};je=He([a],je),e.ParameterInformation=je;let V=class{constructor(L,ne){this.label=L,this.documentation=ne,this.parameters=[]}};V=He([a],V),e.SignatureInformation=V;let ee=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};ee=He([a],ee),e.SignatureHelp=ee;var me;(function(U){U[U.Invoke=1]="Invoke",U[U.TriggerCharacter=2]="TriggerCharacter",U[U.ContentChange=3]="ContentChange"})(me=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var Re;(function(U){U[U.Other=0]="Other",U[U.Type=1]="Type",U[U.Parameter=2]="Parameter"})(Re=e.InlayHintKind||(e.InlayHintKind={}));let Le=class{constructor(L,ne,De){this.text=L,this.position=ne,this.kind=De}};Le=He([a],Le),e.InlayHint=Le;var qe;(function(U){U[U.Invoke=0]="Invoke",U[U.TriggerCharacter=1]="TriggerCharacter",U[U.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(qe=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var Se;(function(U){U[U.Text=0]="Text",U[U.Method=1]="Method",U[U.Function=2]="Function",U[U.Constructor=3]="Constructor",U[U.Field=4]="Field",U[U.Variable=5]="Variable",U[U.Class=6]="Class",U[U.Interface=7]="Interface",U[U.Module=8]="Module",U[U.Property=9]="Property",U[U.Unit=10]="Unit",U[U.Value=11]="Value",U[U.Enum=12]="Enum",U[U.Keyword=13]="Keyword",U[U.Snippet=14]="Snippet",U[U.Color=15]="Color",U[U.File=16]="File",U[U.Reference=17]="Reference",U[U.Folder=18]="Folder",U[U.EnumMember=19]="EnumMember",U[U.Constant=20]="Constant",U[U.Struct=21]="Struct",U[U.Event=22]="Event",U[U.Operator=23]="Operator",U[U.TypeParameter=24]="TypeParameter",U[U.User=25]="User",U[U.Issue=26]="Issue"})(Se=e.CompletionItemKind||(e.CompletionItemKind={}));var we;(function(U){U[U.Deprecated=1]="Deprecated"})(we=e.CompletionItemTag||(e.CompletionItemTag={}));let Ce=class{constructor(L,ne){this.label=L,this.kind=ne}toJSON(){return{label:this.label,label2:this.label2,kind:this.kind&&Se[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};Ce=He([a],Ce),e.CompletionItem=Ce;let ie=class{constructor(L=[],ne=!1){this.items=L,this.isIncomplete=ne}};ie=He([a],ie),e.CompletionList=ie;let ce=class{constructor(L,ne,De){this.text=L,this.range=ne,this.command=De}};ce=He([a],ce),e.InlineSuggestion=ce;let O=class{constructor(L){this.items=L}};O=He([a],O),e.InlineSuggestions=O;var K;(function(U){U[U.Active=-1]="Active",U[U.Beside=-2]="Beside",U[U.One=1]="One",U[U.Two=2]="Two",U[U.Three=3]="Three",U[U.Four=4]="Four",U[U.Five=5]="Five",U[U.Six=6]="Six",U[U.Seven=7]="Seven",U[U.Eight=8]="Eight",U[U.Nine=9]="Nine"})(K=e.ViewColumn||(e.ViewColumn={}));var ae;(function(U){U[U.Left=1]="Left",U[U.Right=2]="Right"})(ae=e.StatusBarAlignment||(e.StatusBarAlignment={}));var ke;(function(U){U[U.Off=0]="Off",U[U.On=1]="On",U[U.Relative=2]="Relative"})(ke=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var Pe;(function(U){U[U.Manual=1]="Manual",U[U.AfterDelay=2]="AfterDelay",U[U.FocusOut=3]="FocusOut"})(Pe=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var Oe;(function(U){U[U.Default=0]="Default",U[U.InCenter=1]="InCenter",U[U.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",U[U.AtTop=3]="AtTop"})(Oe=e.TextEditorRevealType||(e.TextEditorRevealType={}));var $e;(function(U){U[U.Keyboard=1]="Keyboard",U[U.Mouse=2]="Mouse",U[U.Command=3]="Command"})($e=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var Ze;(function(U){U[U.OpenOpen=0]="OpenOpen",U[U.ClosedClosed=1]="ClosedClosed",U[U.OpenClosed=2]="OpenClosed",U[U.ClosedOpen=3]="ClosedOpen"})(Ze=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(U){function L(ne){switch(ne){case"keyboard":return U.Keyboard;case"mouse":return U.Mouse;case"api":return U.Command}}U.fromValue=L}($e=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let Je=class{constructor(L,ne){if(ne&&!_.URI.isUri(ne))throw T.illegalArgument("target");if(!W.isRange(L)||L.isEmpty)throw T.illegalArgument("range");this.range=L,this.target=ne}};Je=He([a],Je),e.DocumentLink=Je;let Ye=class{constructor(L,ne,De,Ve){this.red=L,this.green=ne,this.blue=De,this.alpha=Ve}};Ye=He([a],Ye),e.Color=Ye;let nt=class{constructor(L,ne){if(ne&&!(ne instanceof Ye))throw T.illegalArgument("color");if(!W.isRange(L)||L.isEmpty)throw T.illegalArgument("range");this.range=L,this.color=ne}};nt=He([a],nt),e.ColorInformation=nt;let pt=class{constructor(L){if(!L||typeof L!="string")throw T.illegalArgument("label");this.label=L}};pt=He([a],pt),e.ColorPresentation=pt;var be;(function(U){U[U.RGB=0]="RGB",U[U.HEX=1]="HEX",U[U.HSL=2]="HSL"})(be=e.ColorFormat||(e.ColorFormat={}));var ye;(function(U){U[U.Error=0]="Error",U[U.Warning=1]="Warning",U[U.Information=2]="Information"})(ye=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));var ue;(function(U){U[U.Always=1]="Always",U[U.Silent=2]="Silent",U[U.Never=3]="Never"})(ue=e.TaskRevealKind||(e.TaskRevealKind={}));var j;(function(U){U[U.Shared=1]="Shared",U[U.Dedicated=2]="Dedicated",U[U.New=3]="New"})(j=e.TaskPanelKind||(e.TaskPanelKind={}));let Ne=v=class{constructor(L,ne){if(typeof L!="string"||typeof ne!="string")throw T.illegalArgument("name");this._id=L}static from(L){switch(L){case"clean":return v.Clean;case"build":return v.Build;case"rebuild":return v.Rebuild;case"test":return v.Test;default:return}}get id(){return this._id}};Ne.Clean=new v("clean","Clean"),Ne.Build=new v("build","Build"),Ne.Rebuild=new v("rebuild","Rebuild"),Ne.Test=new v("test","Test"),Ne=v=He([a],Ne),e.TaskGroup=Ne;function ge(U){let L="";for(let ne=0;ne<U.length;ne++)L+=U[ne].replace(/,/g,",,")+",";return L}let Xe=class{constructor(L,ne,De){if(typeof L!="string")throw T.illegalArgument("process");this._args=[],this._process=L,ne!==void 0&&(Array.isArray(ne)?(this._args=ne,this._options=De):this._options=ne)}get process(){return this._process}set process(L){if(typeof L!="string")throw T.illegalArgument("process");this._process=L}get args(){return this._args}set args(L){Array.isArray(L)||(L=[]),this._args=L}get options(){return this._options}set options(L){this._options=L}computeId(){const L=[];if(L.push("process"),this._process!==void 0&&L.push(this._process),this._args&&this._args.length>0)for(let ne of this._args)L.push(ne);return ge(L)}};Xe=He([a],Xe),e.ProcessExecution=Xe;let et=class{constructor(L,ne,De){if(this._args=[],Array.isArray(ne)){if(!L)throw T.illegalArgument("command can't be undefined or null");if(typeof L!="string"&&typeof L.value!="string")throw T.illegalArgument("command");this._command=L,this._args=ne,this._options=De}else{if(typeof L!="string")throw T.illegalArgument("commandLine");this._commandLine=L,this._options=ne}}get commandLine(){return this._commandLine}set commandLine(L){if(typeof L!="string")throw T.illegalArgument("commandLine");this._commandLine=L}get command(){return this._command?this._command:""}set command(L){if(typeof L!="string"&&typeof L.value!="string")throw T.illegalArgument("command");this._command=L}get args(){return this._args}set args(L){this._args=L||[]}get options(){return this._options}set options(L){this._options=L}computeId(){const L=[];if(L.push("shell"),this._commandLine!==void 0&&L.push(this._commandLine),this._command!==void 0&&L.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(let ne of this._args)L.push(typeof ne=="string"?ne:ne.value);return ge(L)}};et=He([a],et),e.ShellExecution=et;var rt;(function(U){U[U.Escape=1]="Escape",U[U.Strong=2]="Strong",U[U.Weak=3]="Weak"})(rt=e.ShellQuoting||(e.ShellQuoting={}));var st;(function(U){U[U.Global=1]="Global",U[U.Workspace=2]="Workspace"})(st=e.TaskScope||(e.TaskScope={}));class vt{constructor(L){this._callback=L}computeId(){return"customExecution"+C.generateUuid()}set callback(L){this._callback=L}get callback(){return this._callback}}e.CustomExecution=vt;let ft=A=class{constructor(L,ne,De,Ve,tt,at){this.__deprecated=!1,this._definition=this.definition=L;let ut;typeof ne=="string"?(this._name=this.name=ne,this._source=this.source=De,this.execution=Ve,ut=tt,this.__deprecated=!0):ne===st.Global||ne===st.Workspace?(this.target=ne,this._name=this.name=De,this._source=this.source=Ve,this.execution=tt,ut=at):(this.target=ne,this._name=this.name=De,this._source=this.source=Ve,this.execution=tt,ut=at),typeof ut=="string"?(this._problemMatchers=[ut],this._hasDefinedMatchers=!0):Array.isArray(ut)?(this._problemMatchers=ut,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(L){this.__id=L}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof Xe?this._definition={type:A.ProcessType,id:this._execution.computeId()}:this._execution instanceof et?this._definition={type:A.ShellType,id:this._execution.computeId()}:this._execution instanceof vt?this._definition={type:A.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:A.EmptyType,id:C.generateUuid()}}get definition(){return this._definition}set definition(L){if(L==null)throw T.illegalArgument("Kind can't be undefined or null");this.clear(),this._definition=L}get scope(){return this._scope}set target(L){this.clear(),this._scope=L}get name(){return this._name}set name(L){if(typeof L!="string")throw T.illegalArgument("name");this.clear(),this._name=L}get execution(){return this._execution}set execution(L){L===null&&(L=void 0),this.clear(),this._execution=L;const ne=this._definition.type;(A.EmptyType===ne||A.ProcessType===ne||A.ShellType===ne||A.ExtensionCallbackType===ne)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(L){if(Array.isArray(L))this.clear(),this._problemMatchers=L,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(L){L!==!0&&L!==!1&&(L=!1),this.clear(),this._isBackground=L}get source(){return this._source}set source(L){if(typeof L!="string"||L.length===0)throw T.illegalArgument("source must be a string of length > 0");this.clear(),this._source=L}get group(){return this._group}set group(L){L===null&&(L=void 0),this.clear(),this._group=L}get detail(){return this._detail}set detail(L){L===null&&(L=void 0),this._detail=L}get presentationOptions(){return this._presentationOptions}set presentationOptions(L){L==null&&(L=Object.create(null)),this.clear(),this._presentationOptions=L}get runOptions(){return this._runOptions}set runOptions(L){L==null&&(L=Object.create(null)),this.clear(),this._runOptions=L}};ft.ExtensionCallbackType="customExecution",ft.ProcessType="process",ft.ShellType="shell",ft.EmptyType="$empty",ft=A=He([a],ft),e.Task=ft;var _t;(function(U){U[U.SourceControl=1]="SourceControl",U[U.Window=10]="Window",U[U.Notification=15]="Notification"})(_t=e.ProgressLocation||(e.ProgressLocation={}));let wt=class{constructor(L,ne=Rt.None){this.collapsibleState=ne,_.URI.isUri(L)?this.resourceUri=L:this.label=L}};wt=He([a],wt),e.TreeItem=wt;var Rt;(function(U){U[U.None=0]="None",U[U.Collapsed=1]="Collapsed",U[U.Expanded=2]="Expanded"})(Rt=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));let bt=class{constructor(L,ne){this.id=L,this.color=ne}};bt=He([a],bt),e.ThemeIcon=bt,bt.File=new bt("file"),bt.Folder=new bt("folder");let ct=class{constructor(L){this.id=L}};ct=He([a],ct),e.ThemeColor=ct;var mt;(function(U){U[U.Global=1]="Global",U[U.Workspace=2]="Workspace",U[U.WorkspaceFolder=3]="WorkspaceFolder"})(mt=e.ConfigurationTarget||(e.ConfigurationTarget={}));let dt=class{constructor(L,ne){if(typeof L!="string"&&(!L||!_.URI.isUri(L)&&!_.URI.isUri(L.uri)))throw T.illegalArgument("base");if(typeof ne!="string")throw T.illegalArgument("pattern");typeof L=="string"?(this.baseFolder=_.URI.file(L),this.base=L):_.URI.isUri(L)?(this.baseFolder=L,this.base=L.fsPath):(this.baseFolder=L.uri,this.base=L.uri.fsPath),this.pattern=ne}};dt=He([a],dt),e.RelativePattern=dt;let It=class{constructor(L,ne,De,Ve){this.enabled=typeof L=="boolean"?L:!0,typeof ne=="string"&&(this.condition=ne),typeof De=="string"&&(this.hitCondition=De),typeof Ve=="string"&&(this.logMessage=Ve)}get id(){return this._id||(this._id=C.generateUuid()),this._id}};It=He([a],It),e.Breakpoint=It;let Dt=class extends It{constructor(L,ne,De,Ve,tt){super(ne,De,Ve,tt);if(L===null)throw T.illegalArgument("location");this.location=L}};Dt=He([a],Dt),e.SourceBreakpoint=Dt;let Ft=class extends It{constructor(L,ne,De,Ve,tt){super(ne,De,Ve,tt);this.functionName=L}};Ft=He([a],Ft),e.FunctionBreakpoint=Ft;let qt=class extends It{constructor(L,ne,De,Ve,tt,at,ut){super(Ve,tt,at,ut);if(!ne)throw T.illegalArgument("dataId");this.label=L,this.dataId=ne,this.canPersist=De}};qt=He([a],qt),e.DataBreakpoint=qt;let Et=class{constructor(L,ne,De){this.command=L,this.args=ne||[],this.options=De}};Et=He([a],Et),e.DebugAdapterExecutable=Et;let Yt=class{constructor(L,ne){this.port=L,this.host=ne}};Yt=He([a],Yt),e.DebugAdapterServer=Yt;let Jt=class{constructor(L){this.path=L}};Jt=He([a],Jt),e.DebugAdapterNamedPipeServer=Jt;let gt=class{constructor(L){this.implementation=L}};gt=He([a],gt),e.DebugAdapterInlineImplementation=gt;let Gt=class{constructor(L,ne){this.range=L,this.expression=ne}};Gt=He([a],Gt),e.EvaluatableExpression=Gt;var Xt;(function(U){U[U.Automatic=0]="Automatic",U[U.Explicit=1]="Explicit"})(Xt=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));let Zt=class{constructor(L,ne){this.range=L,this.text=ne}};Zt=He([a],Zt),e.InlineValueText=Zt;let en=class{constructor(L,ne,De=!0){this.range=L,this.variableName=ne,this.caseSensitiveLookup=De}};en=He([a],en),e.InlineValueVariableLookup=en;let St=class{constructor(L,ne){this.range=L,this.expression=ne}};St=He([a],St),e.InlineValueEvaluatableExpression=St;let Kt=class{constructor(L,ne){this.frameId=L,this.stoppedLocation=ne}};Kt=He([a],Kt),e.InlineValueContext=Kt;var En;(function(U){U[U.Changed=1]="Changed",U[U.Created=2]="Created",U[U.Deleted=3]="Deleted"})(En=e.FileChangeType||(e.FileChangeType={}));let Ut=P=class extends Error{constructor(L,ne=n.FileSystemProviderErrorCode.Unknown,De){var Ve;super(_.URI.isUri(L)?L.toString(!0):L);this.code=(Ve=De==null?void 0:De.name)!==null&&Ve!==void 0?Ve:"Unknown",n.markAsFileSystemProviderError(this,ne),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,P.prototype),typeof Error.captureStackTrace=="function"&&typeof De=="function"&&Error.captureStackTrace(this,De)}static FileExists(L){return new P(L,n.FileSystemProviderErrorCode.FileExists,P.FileExists)}static FileNotFound(L){return new P(L,n.FileSystemProviderErrorCode.FileNotFound,P.FileNotFound)}static FileNotADirectory(L){return new P(L,n.FileSystemProviderErrorCode.FileNotADirectory,P.FileNotADirectory)}static FileIsADirectory(L){return new P(L,n.FileSystemProviderErrorCode.FileIsADirectory,P.FileIsADirectory)}static NoPermissions(L){return new P(L,n.FileSystemProviderErrorCode.NoPermissions,P.NoPermissions)}static Unavailable(L){return new P(L,n.FileSystemProviderErrorCode.Unavailable,P.Unavailable)}};Ut=P=He([a],Ut),e.FileSystemError=Ut;let lt=class{constructor(L,ne,De){this.start=L,this.end=ne,this.kind=De}};lt=He([a],lt),e.FoldingRange=lt;var yn;(function(U){U[U.Comment=1]="Comment",U[U.Imports=2]="Imports",U[U.Region=3]="Region"})(yn=e.FoldingRangeKind||(e.FoldingRangeKind={}));var Mt;(function(U){U[U.Collapsed=0]="Collapsed",U[U.Expanded=1]="Expanded"})(Mt=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var Wt;(function(U){U[U.Editing=0]="Editing",U[U.Preview=1]="Preview"})(Wt=e.CommentMode||(e.CommentMode={}));class hn{constructor(L,ne=[]){this.tokenTypes=L,this.tokenModifiers=ne}}e.SemanticTokensLegend=hn;function Sn(U){return typeof U=="undefined"||D.isStringArray(U)}class Qt{constructor(L){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,L){this._hasLegend=!0;for(let ne=0,De=L.tokenTypes.length;ne<De;ne++)this._tokenTypeStrToInt.set(L.tokenTypes[ne],ne);for(let ne=0,De=L.tokenModifiers.length;ne<De;ne++)this._tokenModifierStrToInt.set(L.tokenModifiers[ne],ne)}}push(L,ne,De,Ve,tt){if(typeof L=="number"&&typeof ne=="number"&&typeof De=="number"&&typeof Ve=="number"&&(typeof tt=="number"||typeof tt=="undefined"))return typeof tt=="undefined"&&(tt=0),this._pushEncoded(L,ne,De,Ve,tt);if(W.isRange(L)&&typeof ne=="string"&&Sn(De))return this._push(L,ne,De);throw T.illegalArgument()}_push(L,ne,De){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(L.start.line!==L.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(ne))throw new Error("`tokenType` is not in the provided legend");const Ve=L.start.line,tt=L.start.character,at=L.end.character-L.start.character,ut=this._tokenTypeStrToInt.get(ne);let yt=0;if(De)for(const Ct of De){if(!this._tokenModifierStrToInt.has(Ct))throw new Error("`tokenModifier` is not in the provided legend");const At=this._tokenModifierStrToInt.get(Ct);yt|=1<<At>>>0}this._pushEncoded(Ve,tt,at,ut,yt)}_pushEncoded(L,ne,De,Ve,tt){if(this._dataIsSortedAndDeltaEncoded&&(L<this._prevLine||L===this._prevLine&&ne<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const yt=this._data.length/5|0;let Ct=0,At=0;for(let Tt=0;Tt<yt;Tt++){let Nt=this._data[5*Tt],cn=this._data[5*Tt+1];Nt===0?(Nt=Ct,cn+=At):Nt+=Ct,this._data[5*Tt]=Nt,this._data[5*Tt+1]=cn,Ct=Nt,At=cn}}let at=L,ut=ne;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(at-=this._prevLine,at===0&&(ut-=this._prevChar)),this._data[this._dataLen++]=at,this._data[this._dataLen++]=ut,this._data[this._dataLen++]=De,this._data[this._dataLen++]=Ve,this._data[this._dataLen++]=tt,this._prevLine=L,this._prevChar=ne}static _sortAndDeltaEncode(L){let ne=[];const De=L.length/5|0;for(let ut=0;ut<De;ut++)ne[ut]=ut;ne.sort((ut,yt)=>{const Ct=L[5*ut],At=L[5*yt];if(Ct===At){const Tt=L[5*ut+1],Nt=L[5*yt+1];return Tt-Nt}return Ct-At});const Ve=new Uint32Array(L.length);let tt=0,at=0;for(let ut=0;ut<De;ut++){const yt=5*ne[ut],Ct=L[yt+0],At=L[yt+1],Tt=L[yt+2],Nt=L[yt+3],cn=L[yt+4],Ln=Ct-tt,Bn=Ln===0?At-at:At,dn=5*ut;Ve[dn+0]=Ln,Ve[dn+1]=Bn,Ve[dn+2]=Tt,Ve[dn+3]=Nt,Ve[dn+4]=cn,tt=Ct,at=At}return Ve}build(L){return this._dataIsSortedAndDeltaEncoded?new tn(new Uint32Array(this._data),L):new tn(Qt._sortAndDeltaEncode(this._data),L)}}e.SemanticTokensBuilder=Qt;class tn{constructor(L,ne){this.resultId=ne,this.data=L}}e.SemanticTokens=tn;class fn{constructor(L,ne,De){this.start=L,this.deleteCount=ne,this.data=De}}e.SemanticTokensEdit=fn;class xt{constructor(L,ne){this.resultId=ne,this.edits=L}}e.SemanticTokensEdits=xt;var Dn;(function(U){U[U.Separate=0]="Separate",U[U.MergeWithParent=1]="MergeWithParent"})(Dn=e.DebugConsoleMode||(e.DebugConsoleMode={}));var nn;(function(U){U[U.Initial=1]="Initial",U[U.Dynamic=2]="Dynamic"})(nn=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));let Bt=class{constructor(){}};Bt.Back={iconPath:new bt("arrow-left")},Bt=He([a],Bt),e.QuickInputButtons=Bt;var Cn;(function(U){U[U.UI=1]="UI",U[U.Workspace=2]="Workspace"})(Cn=e.ExtensionKind||(e.ExtensionKind={}));class kn{constructor(L,ne,De){this.badge=L,this.tooltip=ne,this.color=De}static validate(L){if(L.badge&&L.badge.length!==1&&L.badge.length!==2)throw new Error("The 'badge'-property must be undefined or a short character");if(!L.color&&!L.badge&&!L.tooltip)throw new Error("The decoration is empty")}}e.FileDecoration=kn;let Pt=class{constructor(L){this.kind=L}};Pt=He([a],Pt),e.ColorTheme=Pt;var In;(function(U){U[U.Light=1]="Light",U[U.Dark=2]="Dark",U[U.HighContrast=3]="HighContrast"})(In=e.ColorThemeKind||(e.ColorThemeKind={}));class Ht{constructor(L,ne){if(L<0)throw T.illegalArgument("start must be positive");if(ne<0)throw T.illegalArgument("end must be positive");L<=ne?(this._start=L,this._end=ne):(this._start=ne,this._end=L)}static isNotebookRange(L){return L instanceof Ht?!0:L?typeof L.start=="number"&&typeof L.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}with(L){let ne=this._start,De=this._end;return L.start!==void 0&&(ne=L.start),L.end!==void 0&&(De=L.end),ne===this._start&&De===this._end?this:new Ht(ne,De)}}e.NotebookRange=Ht;class Lt{constructor(L,ne,De,Ve,tt,at){this.kind=L,this.value=ne,this.languageId=De,this.outputs=Ve??[],this.metadata=tt,this.executionSummary=at,Lt.validate(this)}static validate(L){if(typeof L.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof L.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof L.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(L){return Array.isArray(L)&&L.every(ne=>Lt.isNotebookCellData(ne))}static isNotebookCellData(L){return!0}}e.NotebookCellData=Lt;class Pn{constructor(L){this.cells=L}}e.NotebookData=Pn;class kt{constructor(L,ne){this.data=L,this.mime=ne;const De=k.normalizeMimeType(ne,!0);if(!De)throw new Error("INVALID mime type, must not be empty or falsy: "+ne);this.mime=De}static isNotebookCellOutputItem(L){return L instanceof kt?!0:L?typeof L.mime=="string"&&L.data instanceof Uint8Array:!1}static error(L){const ne={name:L.name,message:L.message,stack:L.stack};return kt.json(ne,"application/vnd.code.notebook.error")}static stdout(L){return kt.text(L,"application/vnd.code.notebook.stdout")}static stderr(L){return kt.text(L,"application/vnd.code.notebook.stderr")}static bytes(L,ne="application/octet-stream"){return new kt(L,ne)}static text(L,ne=k.Mimes.text){const De=Ue(kt,c,"f",b).encode(String(L));return new kt(De,ne)}static json(L,ne="application/json"){const De=JSON.stringify(L,void 0,"	");return kt.text(De,ne)}}e.NotebookCellOutputItem=kt,c=kt,b={value:new TextEncoder};class zt{constructor(L,ne,De){this.items=zt.ensureUniqueMimeTypes(L,!0),typeof ne=="string"?(this.id=ne,this.metadata=De):(this.id=C.generateUuid(),this.metadata=ne??De)}static isNotebookCellOutput(L){return L instanceof zt?!0:!L||typeof L!="object"?!1:typeof L.id=="string"&&D.isArray(L.items)}static ensureUniqueMimeTypes(L,ne=!1){const De=new Set,Ve=new Set;for(let tt=0;tt<L.length;tt++){const at=L[tt],ut=k.normalizeMimeType(at.mime);if(!De.has(ut)){De.add(ut);continue}Ve.add(tt),ne&&console.warn(`DUPLICATED mime type '${at.mime}' will be dropped`)}return Ve.size===0?L:L.filter((tt,at)=>!Ve.has(at))}}e.NotebookCellOutput=zt;var mn;(function(U){U[U.Markup=1]="Markup",U[U.Code=2]="Code"})(mn=e.NotebookCellKind||(e.NotebookCellKind={}));var rn;(function(U){U[U.Idle=1]="Idle",U[U.Pending=2]="Pending",U[U.Executing=3]="Executing"})(rn=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var Me;(function(U){U[U.Left=1]="Left",U[U.Right=2]="Right"})(Me=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var sn;(function(U){U[U.Default=0]="Default",U[U.InCenter=1]="InCenter",U[U.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",U[U.AtTop=3]="AtTop"})(sn=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class gn{constructor(L,ne){this.text=L,this.alignment=ne}}e.NotebookCellStatusBarItem=gn;var ht;(function(U){U[U.Default=1]="Default",U[U.Preferred=2]="Preferred"})(ht=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));class An{constructor(L,ne=[]){this.uri=L,this.provides=m.asArray(ne)}}e.NotebookRendererScript=An;let on=class{constructor(L,ne){this.label=L,this.timestamp=ne}};on=He([a],on),e.TimelineItem=on;var pn;(function(U){U[U.Production=1]="Production",U[U.Development=2]="Development",U[U.Test=3]="Test"})(pn=e.ExtensionMode||(e.ExtensionMode={}));var vn;(function(U){U[U.Node=1]="Node",U[U.Webworker=2]="Webworker"})(vn=e.ExtensionRuntime||(e.ExtensionRuntime={}));var an;(function(U){U[U.Other=0]="Other",U[U.Comment=1]="Comment",U[U.String=2]="String",U[U.RegEx=4]="RegEx"})(an=e.StandardTokenType||(e.StandardTokenType={}));class Tn{constructor(L,ne){this.ranges=L,this.wordPattern=ne}}e.LinkedEditingRanges=Tn;class Rn{constructor(L,ne){this._port=L,this._autoForwardAction=ne}get port(){return this._port}get autoForwardAction(){return this._autoForwardAction}}e.PortAttributes=Rn;var Fn;(function(U){U[U.Unset=0]="Unset",U[U.Queued=1]="Queued",U[U.Running=2]="Running",U[U.Passed=3]="Passed",U[U.Failed=4]="Failed",U[U.Skipped=5]="Skipped",U[U.Errored=6]="Errored"})(Fn=e.TestResultState||(e.TestResultState={}));var ln;(function(U){U[U.Error=0]="Error",U[U.Warning=1]="Warning",U[U.Information=2]="Information",U[U.Hint=3]="Hint"})(ln=e.TestMessageSeverity||(e.TestMessageSeverity={}));var bn;(function(U){U[U.Pending=0]="Pending",U[U.Resolved=1]="Resolved"})(bn=e.TestItemStatus||(e.TestItemStatus={}));const $t=(U,L,ne,De)=>{let Ve=ne;return{enumerable:!0,configurable:!1,get(){return Ve},set(tt){De(Ve,tt)||(Ve=tt,U.bus.fire([3,L,tt]))}}},Vt=(U,L)=>U===L,Mn=(U,L)=>U===L?!0:!U||!L?!1:U.isEqual(L);class un{constructor(L,ne,De,Ve){this.label=ne,this.data=Ve;const tt=o.getPrivateApiFor(this);Object.defineProperties(this,{id:{value:L,enumerable:!0,writable:!1},uri:{value:De,enumerable:!0,writable:!1},parent:{enumerable:!1,get:()=>tt.parent},children:{value:new y.ReadonlyMapView(tt.children),enumerable:!0,writable:!1},range:$t(tt,"range",void 0,Mn),description:$t(tt,"description",void 0,Vt),runnable:$t(tt,"runnable",!0,Vt),debuggable:$t(tt,"debuggable",!1,Vt),status:$t(tt,"status",bn.Resolved,Vt),error:$t(tt,"error",void 0,Vt)})}invalidate(){o.getPrivateApiFor(this).bus.fire([2])}dispose(){const L=o.getPrivateApiFor(this);L.parent&&o.getPrivateApiFor(L.parent).children.delete(this.id),L.bus.fire([1])}addChild(L){if(!(L instanceof un))throw new Error("Test child must be created through vscode.test.createTestItem()");const ne=o.getPrivateApiFor(this);if(ne.children.has(L.id))throw new Error(`Attempted to insert a duplicate test item ID ${L.id}`);ne.children.set(L.id,L),ne.bus.fire([0,L])}}e.TestItemImpl=un;class X{constructor(L){this.message=L,this.severity=ln.Error}static diff(L,ne,De){const Ve=new X(L);return Ve.expectedOutput=ne,Ve.actualOutput=De,Ve}}e.TestMessage=X;var de;(function(U){U[U.None=0]="None",U[U.Option=1]="Option",U[U.Default=2]="Default",U[U.Preferred=3]="Preferred"})(de=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var Ie;(function(U){U[U.Untrusted=0]="Untrusted",U[U.Trusted=1]="Trusted",U[U.Unspecified=2]="Unspecified"})(Ie=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var ot;(function(U){U[U.Notify=1]="Notify",U[U.OpenBrowser=2]="OpenBrowser",U[U.OpenPreview=3]="OpenPreview",U[U.Silent=4]="Silent",U[U.Ignore=5]="Ignore"})(ot=e.PortAutoForwardAction||(e.PortAutoForwardAction={}))}),define(_e[95],Ee([0,1,39,16,8,120,85,6,17]),function(Z,e,m,T,S,y,k,D,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.getWordDefinitionFor=e.setWordDefinitionFor=void 0;const C=new Map;function n(d,c){c?C.set(d,c):C.delete(d)}e.setWordDefinitionFor=n;function I(d){return C.get(d)}e.getWordDefinitionFor=I;class o extends y.MirrorTextModel{constructor(c,b,p,w,u,f,g,t){super(b,p,w,u);this._proxy=c,this._languageId=f,this._isDirty=g,this._notebook=t,this._isDisposed=!1}dispose(){m.ok(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(c){return _.equals(this._lines,c)}get document(){if(!this._document){const c=this;this._document={get uri(){return c._uri},get fileName(){return c._uri.fsPath},get isUntitled(){return c._uri.scheme===T.Schemas.untitled},get languageId(){return c._languageId},get version(){return c._versionId},get isClosed(){return c._isDisposed},get isDirty(){return c._isDirty},get notebook(){return c._notebook},save(){return c._save()},getText(b){return b?c._getTextInRange(b):c.getText()},get eol(){return c._eol===`
`?D.EndOfLine.LF:D.EndOfLine.CRLF},get lineCount(){return c._lines.length},lineAt(b){return c._lineAt(b)},offsetAt(b){return c._offsetAt(b)},positionAt(b){return c._positionAt(b)},validateRange(b){return c._validateRange(b)},validatePosition(b){return c._validatePosition(b)},getWordRangeAtPosition(b,p){return c._getWordRangeAtPosition(b,p)}}}return Object.freeze(this._document)}_acceptLanguageId(c){m.ok(!this._isDisposed),this._languageId=c}_acceptIsDirty(c){m.ok(!this._isDisposed),this._isDirty=c}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(c){const b=this._validateRange(c);if(b.isEmpty)return"";if(b.isSingleLine)return this._lines[b.start.line].substring(b.start.character,b.end.character);const p=this._eol,w=b.start.line,u=b.end.line,f=[];f.push(this._lines[w].substring(b.start.character));for(let g=w+1;g<u;g++)f.push(this._lines[g]);return f.push(this._lines[u].substring(0,b.end.character)),f.join(p)}_lineAt(c){let b;if(c instanceof D.Position?b=c.line:typeof c=="number"&&(b=c),typeof b!="number"||b<0||b>=this._lines.length||Math.floor(b)!==b)throw new Error("Illegal value for `line`");return new h(b,this._lines[b],b===this._lines.length-1)}_offsetAt(c){return c=this._validatePosition(c),this._ensureLineStarts(),this._lineStarts.getAccumulatedValue(c.line-1)+c.character}_positionAt(c){c=Math.floor(c),c=Math.max(0,c),this._ensureLineStarts();const b=this._lineStarts.getIndexOf(c),p=this._lines[b.index].length;return new D.Position(b.index,Math.min(b.remainder,p))}_validateRange(c){if(!(c instanceof D.Range))throw new Error("Invalid argument");const b=this._validatePosition(c.start),p=this._validatePosition(c.end);return b===c.start&&p===c.end?c:new D.Range(b.line,b.character,p.line,p.character)}_validatePosition(c){if(!(c instanceof D.Position))throw new Error("Invalid argument");if(this._lines.length===0)return c.with(0,0);let{line:b,character:p}=c,w=!1;if(b<0)b=0,p=0,w=!0;else if(b>=this._lines.length)b=this._lines.length-1,p=this._lines[b].length,w=!0;else{const u=this._lines[b].length;p<0?(p=0,w=!0):p>u&&(p=u,w=!0)}return w?new D.Position(b,p):c}_getWordRangeAtPosition(c,b){const p=this._validatePosition(c);if(!b)b=I(this._languageId);else if(S.regExpLeadsToEndlessLoop(b))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${b.source}' because it matches the empty string.`);const w=k.getWordAtText(p.character+1,k.ensureValidWordDefinition(b),this._lines[p.line],0);if(w)return new D.Range(p.line,w.startColumn-1,p.line,w.endColumn-1)}}e.ExtHostDocumentData=o;class h{constructor(c,b,p){this._line=c,this._text=b,this._isLastLine=p}get lineNumber(){return this._line}get text(){return this._text}get range(){return new D.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new D.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=h}),define(_e[156],Ee([0,1,6,3,87,7,55,22,2,34]),function(Z,e,m,T,S,y,k,D,_,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookConcatDocument=void 0;class n{constructor(o,h,d,c){this._notebook=d,this._selector=c,this._disposables=new y.DisposableStore,this._isClosed=!1,this._versionId=0,this._onDidChange=new T.Emitter,this.onDidChange=this._onDidChange.event,this.uri=_.URI.from({scheme:"vscode-concat-doc",path:C.generateUuid()}),this._init(),this._disposables.add(h.onDidChangeDocument(p=>{const w=this._cellUris.get(p.document.uri);w!==void 0&&(this._cellLengths.changeValue(w,this._cells[w].document.getText().length+1),this._cellLines.changeValue(w,this._cells[w].document.lineCount),this._versionId+=1,this._onDidChange.fire(void 0))}));const b=p=>{p===this._notebook&&(this._init(),this._versionId+=1,this._onDidChange.fire(void 0))};this._disposables.add(o.onDidChangeNotebookCells(p=>b(p.document)))}dispose(){this._disposables.dispose(),this._isClosed=!0}get isClosed(){return this._isClosed}_init(){this._cells=[],this._cellUris=new D.ResourceMap;const o=[],h=[];for(const d of this._notebook.getCells())d.kind===m.NotebookCellKind.Code&&(!this._selector||k.score(this._selector,d.document.uri,d.document.languageId,!0))&&(this._cellUris.set(d.document.uri,this._cells.length),this._cells.push(d),o.push(d.document.getText().length+1),h.push(d.document.lineCount));this._cellLengths=new S.PrefixSumComputer(new Uint32Array(o)),this._cellLines=new S.PrefixSumComputer(new Uint32Array(h))}get version(){return this._versionId}getText(o){var h,d;if(!o){let u="";for(const f of this._cells)u+=f.document.getText()+`
`;return u=u.slice(0,-1),u}if(o.isEmpty)return"";const c=this.locationAt(o.start),b=this.locationAt(o.end),p=this._cells[(h=this._cellUris.get(c.uri))!==null&&h!==void 0?h:-1],w=this._cells[(d=this._cellUris.get(b.uri))!==null&&d!==void 0?d:-1];if(!p||!w)return"";if(p===w)return p.document.getText(new m.Range(c.range.start,b.range.end));{const u=p.document.getText(new m.Range(c.range.start,new m.Position(p.document.lineCount,0))),f=w.document.getText(new m.Range(new m.Position(0,0),b.range.end));return u+`
`+f}}offsetAt(o){const h=this._cellLines.getIndexOf(o.line),d=this._cellLengths.getAccumulatedValue(h.index-1),c=this._cells[h.index].document.offsetAt(o.with(h.remainder));return d+c}positionAt(o){if(typeof o=="number"){const d=this._cellLengths.getIndexOf(o),c=this._cellLines.getAccumulatedValue(d.index-1);return this._cells[d.index].document.positionAt(d.remainder).translate(c)}const h=this._cellUris.get(o.uri);if(h!==void 0){const d=this._cellLines.getAccumulatedValue(h-1);return new m.Position(d+o.range.start.line,o.range.start.character)}return new m.Position(0,0)}locationAt(o){m.Range.isRange(o)||(o=new m.Range(o,o));const h=this._cellLines.getIndexOf(o.start.line);let d=h;o.isEmpty||(d=this._cellLines.getIndexOf(o.end.line));const c=new m.Position(h.remainder,o.start.character),b=new m.Position(d.remainder,o.end.character),p=new m.Range(c,b),w=this._cells[h.index];return new m.Location(w.document.uri,w.document.validateRange(p))}contains(o){return this._cellUris.has(o)}validateRange(o){const h=this.validatePosition(o.start),d=this.validatePosition(o.end);return o.with(h,d)}validatePosition(o){const h=this._cellLines.getIndexOf(o.line),d=new m.Position(h.remainder,o.character),c=this._cells[h.index].document.validatePosition(d),b=this._cellLines.getAccumulatedValue(h.index-1);return new m.Position(b+c.line,c.character)}}e.ExtHostNotebookConcatDocument=n}),define(_e[157],Ee([0,1,6,13,3]),function(Z,e,m,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let y=class{constructor(D){this._actual=new m.ColorTheme(m.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new S.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(D){let _=D==="light"?m.ColorThemeKind.Light:D==="dark"?m.ColorThemeKind.Dark:m.ColorThemeKind.HighContrast;this._actual=new m.ColorTheme(_),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};y=He([ze(0,T.IExtHostRpcService)],y),e.ExtHostTheming=y}),define(_e[66],Ee([0,1,5]),function(Z,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=m.createDecorator("IURITransformerService");class T{constructor(y){y?(this.transformIncoming=y.transformIncoming.bind(y),this.transformOutgoing=y.transformOutgoing.bind(y),this.transformOutgoingURI=y.transformOutgoingURI.bind(y),this.transformOutgoingScheme=y.transformOutgoingScheme.bind(y)):(this.transformIncoming=k=>k,this.transformOutgoing=k=>k,this.transformOutgoingURI=k=>k,this.transformOutgoingScheme=k=>k)}}e.URITransformerService=T}),define(_e[158],Ee([0,1,23]),function(Z,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class T{constructor(){this.buffers=[]}add(_){let C=this.buffers.indexOf(_);return C<0&&(C=this.buffers.length,this.buffers.push(_)),C}}function S(D,_){if(_.serializeBuffersForPostMessage){const C=new T,n=(h,d)=>{if(d instanceof ArrayBuffer){const c=C.add(d);return{$$vscode_array_buffer_reference$$:!0,index:c}}else if(ArrayBuffer.isView(d)){const c=y(d);if(c){const b=C.add(d.buffer);return{$$vscode_array_buffer_reference$$:!0,index:b,view:{type:c,byteLength:d.byteLength,byteOffset:d.byteOffset}}}}return d},I=JSON.stringify(D,n),o=C.buffers.map(h=>{const d=new Uint8Array(h);return m.VSBuffer.wrap(d)});return{message:I,buffers:o}}else return{message:JSON.stringify(D),buffers:[]}}e.serializeWebviewMessage=S;function y(D){switch(D.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function k(D,_){const C=_.map(o=>{const h=new ArrayBuffer(o.byteLength);return new Uint8Array(h).set(o.buffer),h}),n=_.length?(o,h)=>{if(typeof h=="object"&&h.$$vscode_array_buffer_reference$$){const d=h,{index:c}=d,b=C[c];if(d.view)switch(d.view.type){case 1:return new Int8Array(b,d.view.byteOffset,d.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(b,d.view.byteOffset,d.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(b,d.view.byteOffset,d.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(b,d.view.byteOffset,d.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(b,d.view.byteOffset,d.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(b,d.view.byteOffset,d.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(b,d.view.byteOffset,d.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(b,d.view.byteOffset,d.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(b,d.view.byteOffset,d.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(b,d.view.byteOffset,d.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(b,d.view.byteOffset,d.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return b}return h}:void 0;return{message:JSON.parse(D,n),arrayBuffers:C}}e.deserializeWebviewMessage=k}),define(_e[67],Ee([0,1,16,2]),function(Z,e,m,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-webview.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`https://*.${e.webviewResourceBaseHost}`;function S(y,k){return y.scheme===m.Schemas.http||y.scheme===m.Schemas.https?y:(k&&k.authority&&k.isRemote&&y.scheme===m.Schemas.file&&(y=T.URI.from({scheme:m.Schemas.vscodeRemote,authority:k.authority,path:y.path})),T.URI.from({scheme:m.Schemas.https,authority:`${y.scheme}+${y.authority}.${e.webviewRootResourceAuthority}`,path:y.path,fragment:y.fragment,query:y.query}))}e.asWebviewUri=S}),define(_e[159],Ee([0,1,3,7,67]),function(Z,e,m,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class y{constructor(D,_,C){this._proxy=D,this._editors=_,this._initData=C,this._handlePool=0,this._disposables=new T.DisposableStore,this._insets=new Map,this._disposables.add(_.onDidChangeVisibleTextEditors(()=>{const n=_.getVisibleTextEditors();for(const I of this._insets.values())n.indexOf(I.editor)<0&&I.inset.dispose()}))}dispose(){this._insets.forEach(D=>D.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(D,_,C,n,I){let o;for(const u of this._editors.getVisibleTextEditors(!0))if(u.value===D){o=u;break}if(!o)throw new Error("not a visible editor");const h=this,d=this._handlePool++,c=new m.Emitter,b=new m.Emitter,p=new class{constructor(){this._html="",this._options=Object.create(null)}asWebviewUri(u){return S.asWebviewUri(u,h._initData.remote)}get cspSource(){return S.webviewGenericCspSource}set options(u){this._options=u,h._proxy.$setOptions(d,u)}get options(){return this._options}set html(u){this._html=u,h._proxy.$setHtml(d,u)}get html(){return this._html}get onDidReceiveMessage(){return c.event}postMessage(u){return h._proxy.$postMessage(d,u)}},w=new class{constructor(){this.editor=D,this.line=_,this.height=C,this.webview=p,this.onDidDispose=b.event}dispose(){h._insets.has(d)&&(h._insets.delete(d),h._proxy.$disposeEditorInset(d),b.fire(),b.dispose(),c.dispose())}};return this._proxy.$createEditorInset(d,o.id,o.value.document.uri,_+1,C,n||{},I.identifier,I.extensionLocation),this._insets.set(d,{editor:D,inset:w,onDidReceiveMessage:c}),w}$onDidDispose(D){const _=this._insets.get(D);_&&_.inset.dispose()}$onDidReceiveMessage(D,_){const C=this._insets.get(D);C&&C.onDidReceiveMessage.fire(_)}}e.ExtHostEditorInsets=y}),define(_e[160],Ee([0,1,3,12,135]),function(Z,e,m,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class y{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new m.Emitter,this._onExit=new m.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(D){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=D}onEvent(D){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=D}onRequest(D){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=D}sendResponse(D){D.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${D.command}`)):this.internalSend("response",D)}sendRequest(D,_,C,n){const I={command:D};if(_&&Object.keys(_).length>0&&(I.arguments=_),this.internalSend("request",I),typeof n=="number"){const o=setTimeout(()=>{clearTimeout(o);const h=this.pendingRequests.get(I.seq);if(h){this.pendingRequests.delete(I.seq);const d={type:"response",seq:0,request_seq:I.seq,success:!1,command:D,message:S.localize(0,null,n,D)};h(d)}},n)}return C&&this.pendingRequests.set(I.seq,C),I.seq}acceptMessage(D){this.messageCallback?this.messageCallback(D):(this.queue.push(D),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(D,_){return D.type!=="event"||_.type!=="event"}async processQueue(){let D;for(;this.queue.length;){if((!D||this.needsTaskBoundaryBetween(this.queue[0],D))&&await T.timeout(0),D=this.queue.shift(),!D)return;switch(D.type){case"event":this.eventCallback&&this.eventCallback(D);break;case"request":this.requestCallback&&this.requestCallback(D);break;case"response":const _=D,C=this.pendingRequests.get(_.request_seq);C&&(this.pendingRequests.delete(_.request_seq),C(_));break}}}internalSend(D,_){_.type=D,_.seq=this.sequence++,this.sendMessage(_)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const D=new Map;this.pendingRequests.forEach((_,C)=>D.set(C,_)),await T.timeout(500),D.forEach((_,C)=>{_({type:"response",seq:0,request_seq:C,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(C)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=y}),define(_e[161],Ee([0,1,8,2,14,24,16]),function(Z,e,m,T,S,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const D=/{([^}]+)}/g;function _(i,s,r){return i.replace(D,function(l,E){return s&&E.length>0&&E[0]!=="_"?l:r&&r.hasOwnProperty(E)?r[E]:l})}e.formatPII=_;function C(i){const s={};for(const r of Object.keys(i))r.startsWith("!")||(s[r]=i[r]);return s}e.filterExceptionsFromTelemetry=C;function n(i){return i.configuration.request==="attach"&&!I(i)&&(!i.parentSession||n(i.parentSession))}e.isSessionAttach=n;function I(i){let s=i.configuration.type;if(!!s)return s==="vslsShare"&&(s=i.configuration.adapterProxy.configuration.type),m.equalsIgnoreCase(s,"extensionhost")||m.equalsIgnoreCase(s,"pwa-extensionhost")?i:i.parentSession?I(i.parentSession):void 0}e.getExtensionHostDebugSession=I;function o(i){return i.type&&(i.label||i.program||i.runtime)}e.isDebuggerMainContribution=o;function h(i,s,r){let l,E=0,v=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g,A=null;for(;A=v.exec(i);){let P=A.index+1,a=P+A[0].length;if(P<=s&&a>=r){l=A[0],E=P;break}}if(l){let P=/\w+/g,a=null;for(;(a=P.exec(l))&&!(a.index+1+E+a[0].length>=r););a&&(l=l.substring(0,P.lastIndex))}return l?{start:E,end:E+l.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=h;const d=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function c(i){return!!(i&&i.match(d))}e.isUri=c;function b(i){if(typeof i.path=="string"&&!(typeof i.sourceReference=="number"&&i.sourceReference>0)){if(c(i.path))return T.URI.parse(i.path);if(S.isAbsolute(i.path))return T.URI.file(i.path)}return i.path}function p(i){if(typeof i.path=="object"){const s=T.URI.revive(i.path);if(s)return s.scheme===k.Schemas.file?s.fsPath:s.toString()}return i.path}function w(i,s){const r=s?b:p,l=y.deepClone(i);return f(l,(E,v)=>{E&&v&&(v.path=r(v))}),l}e.convertToDAPaths=w;function u(i,s){const r=s?b:p,l=y.deepClone(i);return f(l,(E,v)=>{!E&&v&&(v.path=r(v))}),l}e.convertToVSCPaths=u;function f(i,s){switch(i.type){case"event":const r=i;switch(r.event){case"output":s(!1,r.body.source);break;case"loadedSource":s(!1,r.body.source);break;case"breakpoint":s(!1,r.body.breakpoint.source);break;default:break}break;case"request":const l=i;switch(l.command){case"setBreakpoints":s(!0,l.arguments.source);break;case"breakpointLocations":s(!0,l.arguments.source);break;case"source":s(!0,l.arguments.source);break;case"gotoTargets":s(!0,l.arguments.source);break;case"launchVSCode":l.arguments.args.forEach(v=>s(!1,v));break;default:break}break;case"response":const E=i;if(E.success&&E.body)switch(E.command){case"stackTrace":E.body.stackFrames.forEach(v=>s(!1,v.source));break;case"loadedSources":E.body.sources.forEach(v=>s(!1,v));break;case"scopes":E.body.scopes.forEach(v=>s(!1,v.source));break;case"setFunctionBreakpoints":E.body.breakpoints.forEach(v=>s(!1,v.source));break;case"setBreakpoints":E.body.breakpoints.forEach(v=>s(!1,v.source));break;default:break}break}}function g(i){return i.filter(s=>{var r;return!((r=s.presentation)===null||r===void 0?void 0:r.hidden)}).sort((s,r)=>s.presentation?r.presentation?s.presentation.group?r.presentation.group?s.presentation.group!==r.presentation.group?s.presentation.group.localeCompare(r.presentation.group):t(s.presentation.order,r.presentation.order):-1:r.presentation.group?1:t(s.presentation.order,r.presentation.order):-1:r.presentation?1:0)}e.getVisibleAndSorted=g;function t(i,s){return typeof i!="number"?typeof s!="number"?0:1:typeof s!="number"?-1:i-s}}),define(_e[68],Ee([0,1,27,82,16,14,21,89]),function(Z,e,m,T,S,y,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.OpenGettingStarted=e.ConsolidatedRunButton=e.NotebookCellEditorOptionsCustomizations=e.DragAndDropEnabled=e.ShowFoldingControls=e.ConsolidatedOutputButton=e.UndoRedoPerCell=e.GlobalToolbar=e.InsertToolbarLocation=e.FocusIndicator=e.CompactView=e.ExperimentalInsertToolbarAlignment=e.ExperimentalUseMarkdownRenderer=e.NotebookTextDiffEditorPreview=e.ShowCellStatusBar=e.CellToolbarVisibility=e.CellToolbarLocation=e.DisplayOrderKey=e.CellSequence=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.sortMimeTypes=e.mimeTypeIsMergeable=e.mimeTypeSupportedByCore=e.mimeTypeIsAlwaysSecure=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.BUILTIN_RENDERER_ID=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=void 0;var _;(function(a){a[a.Markup=1]="Markup",a[a.Code=2]="Code"})(_=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",T.Mimes.markdown,"image/png","image/jpeg",T.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[T.Mimes.markdown,"application/json",T.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.BUILTIN_RENDERER_ID="_builtin",e.RENDERER_NOT_AVAILABLE="_notAvailable";var C;(function(a){a[a.Running=1]="Running",a[a.Idle=2]="Idle"})(C=e.NotebookRunState||(e.NotebookRunState={}));var n;(function(a){a[a.Pending=2]="Pending",a[a.Executing=3]="Executing"})(n=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var I;(function(a){a[a.WithHardKernelDependency=0]="WithHardKernelDependency",a[a.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",a[a.Pure=2]="Pure",a[a.Never=3]="Never"})(I=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var o;(function(a){a.Always="always",a.Never="never",a.Optional="optional"})(o=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var h;(function(a){a[a.ModelChange=1]="ModelChange",a[a.Move=2]="Move",a[a.ChangeLanguage=5]="ChangeLanguage",a[a.Initialize=6]="Initialize",a[a.ChangeCellMetadata=7]="ChangeCellMetadata",a[a.Output=8]="Output",a[a.OutputItem=9]="OutputItem",a[a.ChangeCellContent=10]="ChangeCellContent",a[a.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",a[a.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",a[a.Unknown=100]="Unknown"})(h=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var d;(function(a){a[a.Handle=0]="Handle",a[a.Index=1]="Index"})(d=e.SelectionStateType||(e.SelectionStateType={}));var c;(function(a){a[a.Replace=1]="Replace",a[a.Output=2]="Output",a[a.Metadata=3]="Metadata",a[a.CellLanguage=4]="CellLanguage",a[a.DocumentMetadata=5]="DocumentMetadata",a[a.Move=6]="Move",a[a.OutputItems=7]="OutputItems",a[a.PartialMetadata=8]="PartialMetadata",a[a.PartialInternalMetadata=9]="PartialInternalMetadata"})(c=e.CellEditType||(e.CellEditType={}));var b;(function(a){a.scheme=S.Schemas.vscodeNotebookCell;const F=/^ch(\d{7,})/;function N(H,J){return H.with({scheme:a.scheme,fragment:`ch${J.toString().padStart(7,"0")}${H.scheme!==S.Schemas.file?H.scheme:""}`})}a.generate=N;function W(H){if(H.scheme!==a.scheme)return;const J=F.exec(H.fragment);return J?{handle:Number(J[1]),notebook:H.with({scheme:H.fragment.substr(J[0].length)||S.Schemas.file,fragment:null})}:void 0}a.parse=W;function le(H){if(H.scheme!==S.Schemas.vscodeNotebookCellMetadata)return;const J=F.exec(H.fragment);return J?{handle:Number(J[1]),notebook:H.with({scheme:H.fragment.substr(J[0].length)||S.Schemas.file,fragment:null})}:void 0}a.parseCellMetadataUri=le;function fe(H,J,R){return H.with({scheme:R,fragment:`ch${J.toString().padStart(7,"0")}${H.scheme!==S.Schemas.file?H.scheme:""}`})}a.generateCellUri=fe;function Y(H,J){if(H.scheme!==J)return;const R=F.exec(H.fragment);return R?{handle:Number(R[1]),notebook:H.with({scheme:H.fragment.substr(R[0].length)||S.Schemas.file,fragment:null})}:void 0}a.parseCellUri=Y})(b=e.CellUri||(e.CellUri={}));const p=new Map([["application/javascript",{supportedByCore:!0}],["image/png",{alwaysSecure:!0,supportedByCore:!0}],["image/jpeg",{alwaysSecure:!0,supportedByCore:!0}],["image/git",{alwaysSecure:!0,supportedByCore:!0}],["image/svg+xml",{supportedByCore:!0}],["application/json",{alwaysSecure:!0,supportedByCore:!0}],[T.Mimes.markdown,{alwaysSecure:!0,supportedByCore:!0}],[T.Mimes.text,{alwaysSecure:!0,supportedByCore:!0}],["text/html",{supportedByCore:!0}],["text/x-javascript",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.error",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.stdout",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/vnd.code.notebook.stderr",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}]]);function w(a){var F,N;return(N=(F=p.get(a))===null||F===void 0?void 0:F.alwaysSecure)!==null&&N!==void 0?N:!1}e.mimeTypeIsAlwaysSecure=w;function u(a){var F,N;return(N=(F=p.get(a))===null||F===void 0?void 0:F.supportedByCore)!==null&&N!==void 0?N:!1}e.mimeTypeSupportedByCore=u;function f(a){var F,N;return(N=(F=p.get(a))===null||F===void 0?void 0:F.mergeable)!==null&&N!==void 0?N:!1}e.mimeTypeIsMergeable=f;function g(a,F){return k.isWindows&&(a=a.replace(/\//g,"\\"),F=F.replace(/\//g,"\\")),m.match(a,F)}function t(a,F,N){let W=0;for(let le=0;le<F.length;le++){if(g(F[le],a))return W;W++}for(let le=0;le<N.length;le++){if(g(N[le],a))return W;W++}return W}function i(a,F,N){return a.sort((W,le)=>t(W,F,N)-t(le,F,N))}e.sortMimeTypes=i;function s(a,F,N,W=(le,fe)=>le===fe){const le=[];function fe(J,R,B){if(R===0&&B.length===0)return;const M=le[le.length-1];M&&M.start+M.deleteCount===J?(M.deleteCount+=R,M.toInsert.push(...B)):le.push({start:J,deleteCount:R,toInsert:B})}let Y=0,H=0;for(;;){if(Y===a.length){fe(Y,0,F.slice(H));break}if(H===F.length){fe(Y,a.length-Y,[]);break}const J=a[Y],R=F[H];if(W(J,R)){Y+=1,H+=1;continue}N(R)?(fe(Y,1,[]),Y+=1):(fe(Y,0,[R]),H+=1)}return le}e.diff=s,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new D.RawContextKey("notebookEditorCursorAtBoundary","none");var r;(function(a){a.default="default",a.option="option"})(r=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function l(a){const F=a;return!!((typeof F.include=="string"||m.isRelativePattern(F.include))&&(typeof F.exclude=="string"||m.isRelativePattern(F.exclude)))}e.isDocumentExcludePattern=l;function E(a,F,N){if(Array.isArray(a.viewType)&&a.viewType.indexOf(F)>=0||a.viewType===F)return!0;if(a.filenamePattern){let W=l(a.filenamePattern)?a.filenamePattern.include:a.filenamePattern,le=l(a.filenamePattern)?a.filenamePattern.exclude:void 0;if(m.match(W,y.basename(N.fsPath).toLowerCase()))return!(le&&m.match(le,y.basename(N.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=E;class v{constructor(F){this.textModel=F}getElements(){const F=new Int32Array(this.textModel.cells.length);for(let N=0;N<this.textModel.cells.length;N++)F[N]=this.textModel.cells[N].getHashValue();return F}}e.CellSequence=v,e.DisplayOrderKey="notebook.displayOrder",e.CellToolbarLocation="notebook.cellToolbarLocation",e.CellToolbarVisibility="notebook.cellToolbarVisibility",e.ShowCellStatusBar="notebook.showCellStatusBar",e.NotebookTextDiffEditorPreview="notebook.diff.enablePreview",e.ExperimentalUseMarkdownRenderer="notebook.experimental.useMarkdownRenderer",e.ExperimentalInsertToolbarAlignment="notebook.experimental.insertToolbarAlignment",e.CompactView="notebook.compactView",e.FocusIndicator="notebook.cellFocusIndicator",e.InsertToolbarLocation="notebook.insertToolbarLocation",e.GlobalToolbar="notebook.globalToolbar",e.UndoRedoPerCell="notebook.undoRedoPerCell",e.ConsolidatedOutputButton="notebook.consolidatedOutputButton",e.ShowFoldingControls="notebook.showFoldingControls",e.DragAndDropEnabled="notebook.dragAndDropEnabled",e.NotebookCellEditorOptionsCustomizations="notebook.editorOptionsCustomizations",e.ConsolidatedRunButton="notebook.consolidatedRunButton",e.OpenGettingStarted="notebook.experimental.openGettingStarted";var A;(function(a){a[a.Left=1]="Left",a[a.Right=2]="Right"})(A=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class P{static create(F){return`${P._prefix}${F}`}static parse(F){if(F.startsWith(P._prefix))return F.substr(P._prefix.length)}}e.NotebookWorkingCopyTypeIdentifier=P,P._prefix="notebook/"}),define(_e[162],Ee([0,1,137,5,89]),function(Z,e,m,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USER_TASKS_GROUP_KEY=e.ITaskService=e.ProcessExecutionSupportedContext=e.ShellExecutionSupportedContext=e.CustomExecutionSupportedContext=void 0,e.CustomExecutionSupportedContext=new S.RawContextKey("customExecutionSupported",!0,m.localize(0,null)),e.ShellExecutionSupportedContext=new S.RawContextKey("shellExecutionSupported",!1,m.localize(1,null)),e.ProcessExecutionSupportedContext=new S.RawContextKey("processExecutionSupported",!1,m.localize(2,null)),e.ITaskService=T.createDecorator("taskService"),e.USER_TASKS_GROUP_KEY="settings"}),define(_e[163],Ee([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function m(S){return[...S.entries()]}e.serializeEnvironmentVariableCollection=m;function T(S){return new Map(S)}e.deserializeEnvironmentVariableCollection=T}),define(_e[96],Ee([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.IncrementalChangeCollector=e.getTestSubscriptionKey=e.TestDiffOpType=e.applyTestItemUpdate=e.TestItemExpandState=void 0;var m;(function(_){_[_.NotExpandable=0]="NotExpandable",_[_.Expandable=1]="Expandable",_[_.BusyExpanding=2]="BusyExpanding",_[_.Expanded=3]="Expanded"})(m=e.TestItemExpandState||(e.TestItemExpandState={}));const T=(_,C)=>{C.expand!==void 0&&(_.expand=C.expand),C.item!==void 0&&(_.item=_.item?Object.assign(_.item,C.item):C.item)};e.applyTestItemUpdate=T;var S;(function(_){_[_.Add=0]="Add",_[_.Update=1]="Update",_[_.Remove=2]="Remove",_[_.IncrementPendingExtHosts=3]="IncrementPendingExtHosts",_[_.Retire=4]="Retire"})(S=e.TestDiffOpType||(e.TestDiffOpType={}));const y=(_,C)=>`${_}:${C.toString()}`;e.getTestSubscriptionKey=y;class k{add(C){}update(C){}remove(C,n){}complete(){}}e.IncrementalChangeCollector=k;class D{constructor(){this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0}apply(C){const n=this.createChangeCollector();for(const I of C)switch(I[0]){case 0:{const o=I[1];if(o.parent){if(this.items.has(o.parent)){const h=this.items.get(o.parent);h.children.add(o.item.extId);const d=this.createItem(o,h);this.items.set(o.item.extId,d),n.add(d)}}else{this.roots.add(o.item.extId);const h=this.createItem(o);this.items.set(o.item.extId,h),n.add(h)}o.expand===2&&this.busyControllerCount++;break}case 1:{const o=I[1],h=this.items.get(o.extId);if(!h)break;o.expand!==void 0&&(h.expand===2&&this.busyControllerCount--,o.expand===2&&this.busyControllerCount++),e.applyTestItemUpdate(h,o),n.update(h);break}case 2:{const o=this.items.get(I[1]);if(!o)break;o.parent?this.items.get(o.parent).children.delete(o.item.extId):this.roots.delete(o.item.extId);const h=[[I[1]]];for(;h.length;)for(const d of h.pop()){const c=this.items.get(d);c&&(h.push(c.children),this.items.delete(d),n.remove(c,c!==o),c.expand===2&&this.busyControllerCount--)}break}case 4:this.retireTest(I[1]);break;case 3:this.updatePendingRoots(I[1]);break}n.complete()}retireTest(C){}updatePendingRoots(C){this.pendingRootCount+=C}createChangeCollector(){return new k}}e.AbstractIncrementalTestCollection=D}),define(_e[164],Ee([0,1,14,40,10,24,21,81,138]),function(Z,e,m,T,S,y,k,D,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class C{constructor(I,o,h){this._contributedVariables=new Map,this._context=I,this._labelService=o,h&&(this._envVariablesPromise=h.then(d=>this.prepareEnv(d)))}prepareEnv(I){if(k.isWindows){const o=Object.create(null);return Object.keys(I).forEach(h=>{o[h.toLowerCase()]=I[h]}),o}return I}resolveWithEnvironment(I,o,h){return this.recursiveResolve(this.prepareEnv(I),o?o.uri:void 0,h)}async resolveAsync(I,o){return this.recursiveResolve(await this._envVariablesPromise,I?I.uri:void 0,o)}async resolveAnyBase(I,o,h,d){const c=y.deepClone(o);return k.isWindows&&c.windows?Object.keys(c.windows).forEach(b=>c[b]=c.windows[b]):k.isMacintosh&&c.osx?Object.keys(c.osx).forEach(b=>c[b]=c.osx[b]):k.isLinux&&c.linux&&Object.keys(c.linux).forEach(b=>c[b]=c.linux[b]),delete c.windows,delete c.osx,delete c.linux,this.recursiveResolve(await this._envVariablesPromise,I?I.uri:void 0,c,h,d)}async resolveAnyAsync(I,o,h){return this.resolveAnyBase(I,o,h)}async resolveAnyMap(I,o,h){const d=new Map;return{newConfig:await this.resolveAnyBase(I,o,h,d),resolvedVariables:d}}resolveWithInteractionReplace(I,o,h,d){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(I,o,h,d){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(I,o){if(this._contributedVariables.has(I))throw new Error("Variable "+I+" is contributed twice.");this._contributedVariables.set(I,o)}recursiveResolve(I,o,h,d,c){if(S.isString(h))return this.resolveString(I,o,h,d,c);if(S.isArray(h))return h.map(b=>this.recursiveResolve(I,o,b,d,c));if(S.isObject(h)){let b=Object.create(null);return Object.keys(h).forEach(p=>{const w=this.resolveString(I,o,p,d,c);b[w]=this.recursiveResolve(I,o,h[p],d,c)}),b}return h}resolveString(I,o,h,d,c){return h.replace(C.VARIABLE_REGEXP,(p,w)=>{if(w.includes(C.VARIABLE_LHS))return p;let u=this.evaluateSingleVariable(I,p,w,o,d);return c&&c.set(w,u),u!==p&&S.isString(u)&&u.match(C.VARIABLE_REGEXP)&&(u=this.resolveString(I,o,u,d,c)),u})}fsPath(I){return this._labelService?this._labelService.getUriLabel(I,{noPrefix:!0}):I.fsPath}evaluateSingleVariable(I,o,h,d,c){let b;const p=h.split(":");p.length>1&&(h=p[0],b=p[1]);const w=()=>{const g=this._context.getFilePath();if(g)return g;throw new Error(_.localize(0,null,o))},u=()=>{const g=w();if(this._context.getWorkspaceFolderPathForFile){const t=this._context.getWorkspaceFolderPathForFile();if(t)return t}throw new Error(_.localize(1,null,o,m.basename(g)))},f=()=>{if(b){const g=this._context.getFolderUri(b);if(g)return g;throw new Error(_.localize(2,null,o,b))}if(d)return d;throw this._context.getWorkspaceFolderCount()>1?new Error(_.localize(3,null,o)):new Error(_.localize(4,null,o))};switch(h){case"env":if(b){if(I){const g=I[k.isWindows?b.toLowerCase():b];if(S.isString(g))return g}return""}throw new Error(_.localize(5,null,o));case"config":if(b){const g=this._context.getConfigurationValue(d,b);if(S.isUndefinedOrNull(g))throw new Error(_.localize(6,null,o,b));if(S.isObject(g))throw new Error(_.localize(7,null,o,b));return g}throw new Error(_.localize(8,null,o));case"command":return this.resolveFromMap(o,b,c,"command");case"input":return this.resolveFromMap(o,b,c,"input");default:switch(h){case"workspaceRoot":case"workspaceFolder":return D.normalizeDriveLetter(this.fsPath(f()));case"cwd":return d||b?D.normalizeDriveLetter(this.fsPath(f())):T.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return m.basename(this.fsPath(f()));case"lineNumber":const g=this._context.getLineNumber();if(g)return g;throw new Error(_.localize(9,null,o));case"selectedText":const t=this._context.getSelectedText();if(t)return t;throw new Error(_.localize(10,null,o));case"file":return w();case"fileWorkspaceFolder":return u();case"relativeFile":return d||b?m.relative(this.fsPath(f()),w()):w();case"relativeFileDirname":const i=m.dirname(w());if(d||b){const E=m.relative(this.fsPath(f()),i);return E.length===0?".":E}return i;case"fileDirname":return m.dirname(w());case"fileExtname":return m.extname(w());case"fileBasename":return m.basename(w());case"fileBasenameNoExtension":const s=m.basename(w());return s.slice(0,s.length-m.extname(s).length);case"fileDirnameBasename":return m.basename(m.dirname(w()));case"execPath":const r=this._context.getExecPath();return r||o;case"execInstallFolder":const l=this._context.getAppRoot();return l||o;case"pathSeparator":return m.sep;default:try{const E=b?`${h}:${b}`:h;return this.resolveFromMap(o,E,c,void 0)}catch(E){return o}}}}resolveFromMap(I,o,h,d){if(o&&h){const c=d===void 0?h[o]:h[d+":"+o];if(typeof c=="string")return c;throw new Error(_.localize(11,null,I))}return I}}e.AbstractVariableResolverService=C,C.VARIABLE_LHS="${",C.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(_e[165],Ee([0,1,5]),function(Z,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.OpenEditorContext=e.GroupChangeKind=e.GroupsOrder=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=m.createDecorator("editorGroupsService");var T;(function(o){o[o.UP=0]="UP",o[o.DOWN=1]="DOWN",o[o.LEFT=2]="LEFT",o[o.RIGHT=3]="RIGHT"})(T=e.GroupDirection||(e.GroupDirection={}));var S;(function(o){o[o.HORIZONTAL=0]="HORIZONTAL",o[o.VERTICAL=1]="VERTICAL"})(S=e.GroupOrientation||(e.GroupOrientation={}));var y;(function(o){o[o.FIRST=0]="FIRST",o[o.LAST=1]="LAST",o[o.NEXT=2]="NEXT",o[o.PREVIOUS=3]="PREVIOUS"})(y=e.GroupLocation||(e.GroupLocation={}));var k;(function(o){o[o.MINIMIZE_OTHERS=0]="MINIMIZE_OTHERS",o[o.EVEN=1]="EVEN",o[o.TOGGLE=2]="TOGGLE"})(k=e.GroupsArrangement||(e.GroupsArrangement={}));var D;(function(o){o[o.COPY_EDITORS=0]="COPY_EDITORS",o[o.MOVE_EDITORS=1]="MOVE_EDITORS"})(D=e.MergeGroupMode||(e.MergeGroupMode={}));var _;(function(o){o[o.CREATION_TIME=0]="CREATION_TIME",o[o.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",o[o.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(_=e.GroupsOrder||(e.GroupsOrder={}));var C;(function(o){o[o.GROUP_ACTIVE=0]="GROUP_ACTIVE",o[o.GROUP_INDEX=1]="GROUP_INDEX",o[o.EDITOR_OPEN=2]="EDITOR_OPEN",o[o.EDITOR_CLOSE=3]="EDITOR_CLOSE",o[o.EDITOR_MOVE=4]="EDITOR_MOVE",o[o.EDITOR_ACTIVE=5]="EDITOR_ACTIVE",o[o.EDITOR_LABEL=6]="EDITOR_LABEL",o[o.EDITOR_CAPABILITIES=7]="EDITOR_CAPABILITIES",o[o.EDITOR_PIN=8]="EDITOR_PIN",o[o.EDITOR_STICKY=9]="EDITOR_STICKY",o[o.EDITOR_DIRTY=10]="EDITOR_DIRTY"})(C=e.GroupChangeKind||(e.GroupChangeKind={}));var n;(function(o){o[o.NEW_EDITOR=1]="NEW_EDITOR",o[o.MOVE_EDITOR=2]="MOVE_EDITOR",o[o.COPY_EDITOR=3]="COPY_EDITOR"})(n=e.OpenEditorContext||(e.OpenEditorContext={}));function I(o){return o.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=I}),define(_e[166],Ee([0,1,5]),function(Z,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=m.createDecorator("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2}),define(_e[9],Ee([0,1,17,80,222,54,24,10,2,31,58,139,90,68,166,6]),function(Z,e,m,T,S,y,k,D,_,C,n,I,o,h,d,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeActionTriggerKind=e.TestResults=e.TestItem=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookStatusBarItem=e.NotebookDecorationRenderOptions=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.Position=e.TokenType=e.Range=e.Selection=void 0;var b;(function(be){function ye(j){const{selectionStartLineNumber:Ne,selectionStartColumn:ge,positionLineNumber:Xe,positionColumn:et}=j,rt=new c.Position(Ne-1,ge-1),st=new c.Position(Xe-1,et-1);return new c.Selection(rt,st)}be.to=ye;function ue(j){const{anchor:Ne,active:ge}=j;return{selectionStartLineNumber:Ne.line+1,selectionStartColumn:Ne.character+1,positionLineNumber:ge.line+1,positionColumn:ge.character+1}}be.from=ue})(b=e.Selection||(e.Selection={}));var p;(function(be){function ye(j){if(!j)return;const{start:Ne,end:ge}=j;return{startLineNumber:Ne.line+1,startColumn:Ne.character+1,endLineNumber:ge.line+1,endColumn:ge.character+1}}be.from=ye;function ue(j){if(!j)return;const{startLineNumber:Ne,startColumn:ge,endLineNumber:Xe,endColumn:et}=j;return new c.Range(Ne-1,ge-1,Xe-1,et-1)}be.to=ue})(p=e.Range||(e.Range={}));var w;(function(be){function ye(ue){switch(ue){case 1:return c.StandardTokenType.Comment;case 0:return c.StandardTokenType.Other;case 4:return c.StandardTokenType.RegEx;case 2:return c.StandardTokenType.String}}be.to=ye})(w=e.TokenType||(e.TokenType={}));var u;(function(be){function ye(j){return new c.Position(j.lineNumber-1,j.column-1)}be.to=ye;function ue(j){return{lineNumber:j.line+1,column:j.character+1}}be.from=ue})(u=e.Position||(e.Position={}));var f;(function(be){function ye(j){switch(j){case c.DiagnosticTag.Unnecessary:return 1;case c.DiagnosticTag.Deprecated:return 2}}be.from=ye;function ue(j){switch(j){case 1:return c.DiagnosticTag.Unnecessary;case 2:return c.DiagnosticTag.Deprecated;default:return}}be.to=ue})(f=e.DiagnosticTag||(e.DiagnosticTag={}));var g;(function(be){function ye(j){let Ne;return j.code&&(D.isString(j.code)||D.isNumber(j.code)?Ne=String(j.code):Ne={value:String(j.code.value),target:j.code.target}),Object.assign(Object.assign({},p.from(j.range)),{message:j.message,source:j.source,code:Ne,severity:i.from(j.severity),relatedInformation:j.relatedInformation&&j.relatedInformation.map(t.from),tags:Array.isArray(j.tags)?m.coalesce(j.tags.map(f.from)):void 0})}be.from=ye;function ue(j){var Ne;const ge=new c.Diagnostic(p.to(j),j.message,i.to(j.severity));return ge.source=j.source,ge.code=D.isString(j.code)?j.code:(Ne=j.code)===null||Ne===void 0?void 0:Ne.value,ge.relatedInformation=j.relatedInformation&&j.relatedInformation.map(t.to),ge.tags=j.tags&&m.coalesce(j.tags.map(f.to)),ge}be.to=ue})(g=e.Diagnostic||(e.Diagnostic={}));var t;(function(be){function ye(j){return Object.assign(Object.assign({},p.from(j.location.range)),{message:j.message,resource:j.location.uri})}be.from=ye;function ue(j){return new c.DiagnosticRelatedInformation(new c.Location(j.resource,p.to(j)),j.message)}be.to=ue})(t=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var i;(function(be){function ye(j){switch(j){case c.DiagnosticSeverity.Error:return o.MarkerSeverity.Error;case c.DiagnosticSeverity.Warning:return o.MarkerSeverity.Warning;case c.DiagnosticSeverity.Information:return o.MarkerSeverity.Info;case c.DiagnosticSeverity.Hint:return o.MarkerSeverity.Hint}return o.MarkerSeverity.Error}be.from=ye;function ue(j){switch(j){case o.MarkerSeverity.Info:return c.DiagnosticSeverity.Information;case o.MarkerSeverity.Warning:return c.DiagnosticSeverity.Warning;case o.MarkerSeverity.Error:return c.DiagnosticSeverity.Error;case o.MarkerSeverity.Hint:return c.DiagnosticSeverity.Hint;default:return c.DiagnosticSeverity.Error}}be.to=ue})(i=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var s;(function(be){function ye(j){return typeof j=="number"&&j>=c.ViewColumn.One?j-1:j===c.ViewColumn.Beside?d.SIDE_GROUP:d.ACTIVE_GROUP}be.from=ye;function ue(j){if(typeof j=="number"&&j>=0)return j+1;throw new Error("invalid 'EditorGroupColumn'")}be.to=ue})(s=e.ViewColumn||(e.ViewColumn={}));function r(be){return typeof be.range!="undefined"}function l(be){return be.length===0?!0:!!r(be[0])}e.isDecorationOptionsArr=l;var E;(function(be){function ye(et){return et.map(be.from)}be.fromMany=ye;function ue(et){return et&&typeof et=="object"&&typeof et.language=="string"&&typeof et.value=="string"}function j(et){let rt;if(ue(et)){const{language:_t,value:wt}=et;rt={value:"```"+_t+`
`+wt+"\n```\n"}}else c.MarkdownString.isMarkdownString(et)?rt={value:et.value,isTrusted:et.isTrusted,supportThemeIcons:et.supportThemeIcons}:typeof et=="string"?rt={value:et}:rt={value:""};const st=Object.create(null);rt.uris=st;const vt=_t=>{try{let wt=_.URI.parse(_t,!0);wt=wt.with({query:Ne(wt.query,st)}),st[_t]=wt}catch(wt){}return""},ft=new S.Renderer;return ft.link=vt,ft.image=_t=>vt(T.parseHrefAndDimensions(_t).href),S(rt.value,{renderer:ft}),rt}be.from=j;function Ne(et,rt){if(!et)return et;let st;try{st=y.parse(et)}catch(ft){}if(!st)return et;let vt=!1;return st=k.cloneAndChange(st,ft=>{if(_.URI.isUri(ft)){const _t=`__uri_${Math.random().toString(16).slice(2,8)}`;return rt[_t]=ft,vt=!0,_t}else return}),vt?JSON.stringify(st):et}function ge(et){const rt=new c.MarkdownString(et.value,et.supportThemeIcons);return rt.isTrusted=et.isTrusted,rt}be.to=ge;function Xe(et){if(!!et)return typeof et=="string"?et:be.from(et)}be.fromStrict=Xe})(E=e.MarkdownString||(e.MarkdownString={}));function v(be){return l(be)?be.map(ye=>({range:p.from(ye.range),hoverMessage:Array.isArray(ye.hoverMessage)?E.fromMany(ye.hoverMessage):ye.hoverMessage?E.from(ye.hoverMessage):void 0,renderOptions:ye.renderOptions})):be.map(ye=>({range:p.from(ye)}))}e.fromRangeOrRangeWithMessage=v;function A(be){return typeof be=="undefined"?be:typeof be=="string"?_.URI.file(be):be}e.pathOrURIToURI=A;var P;(function(be){function ye(ue){return typeof ue=="undefined"?ue:{contentText:ue.contentText,contentIconPath:ue.contentIconPath?A(ue.contentIconPath):void 0,border:ue.border,borderColor:ue.borderColor,fontStyle:ue.fontStyle,fontWeight:ue.fontWeight,textDecoration:ue.textDecoration,color:ue.color,backgroundColor:ue.backgroundColor,margin:ue.margin,width:ue.width,height:ue.height}}be.from=ye})(P=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var a;(function(be){function ye(ue){return typeof ue=="undefined"?ue:{backgroundColor:ue.backgroundColor,outline:ue.outline,outlineColor:ue.outlineColor,outlineStyle:ue.outlineStyle,outlineWidth:ue.outlineWidth,border:ue.border,borderColor:ue.borderColor,borderRadius:ue.borderRadius,borderSpacing:ue.borderSpacing,borderStyle:ue.borderStyle,borderWidth:ue.borderWidth,fontStyle:ue.fontStyle,fontWeight:ue.fontWeight,textDecoration:ue.textDecoration,cursor:ue.cursor,color:ue.color,opacity:ue.opacity,letterSpacing:ue.letterSpacing,gutterIconPath:ue.gutterIconPath?A(ue.gutterIconPath):void 0,gutterIconSize:ue.gutterIconSize,overviewRulerColor:ue.overviewRulerColor,before:ue.before?P.from(ue.before):void 0,after:ue.after?P.from(ue.after):void 0}}be.from=ye})(a=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var F;(function(be){function ye(ue){if(typeof ue=="undefined")return ue;switch(ue){case c.DecorationRangeBehavior.OpenOpen:return 0;case c.DecorationRangeBehavior.ClosedClosed:return 1;case c.DecorationRangeBehavior.OpenClosed:return 2;case c.DecorationRangeBehavior.ClosedOpen:return 3}}be.from=ye})(F=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var N;(function(be){function ye(ue){return{isWholeLine:ue.isWholeLine,rangeBehavior:ue.rangeBehavior?F.from(ue.rangeBehavior):void 0,overviewRulerLane:ue.overviewRulerLane,light:ue.light?a.from(ue.light):void 0,dark:ue.dark?a.from(ue.dark):void 0,backgroundColor:ue.backgroundColor,outline:ue.outline,outlineColor:ue.outlineColor,outlineStyle:ue.outlineStyle,outlineWidth:ue.outlineWidth,border:ue.border,borderColor:ue.borderColor,borderRadius:ue.borderRadius,borderSpacing:ue.borderSpacing,borderStyle:ue.borderStyle,borderWidth:ue.borderWidth,fontStyle:ue.fontStyle,fontWeight:ue.fontWeight,textDecoration:ue.textDecoration,cursor:ue.cursor,color:ue.color,opacity:ue.opacity,letterSpacing:ue.letterSpacing,gutterIconPath:ue.gutterIconPath?A(ue.gutterIconPath):void 0,gutterIconSize:ue.gutterIconSize,overviewRulerColor:ue.overviewRulerColor,before:ue.before?P.from(ue.before):void 0,after:ue.after?P.from(ue.after):void 0}}be.from=ye})(N=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var W;(function(be){function ye(j){return{text:j.newText,eol:j.newEol&&V.from(j.newEol),range:p.from(j.range)}}be.from=ye;function ue(j){const Ne=new c.TextEdit(p.to(j.range),j.text);return Ne.newEol=typeof j.eol=="undefined"?void 0:V.to(j.eol),Ne}be.to=ue})(W=e.TextEdit||(e.TextEdit={}));var le;(function(be){function ye(j,Ne,ge){var Xe,et;const rt={edits:[]};if(j instanceof c.WorkspaceEdit)for(let st of j._allEntries())if(st._type===1)rt.edits.push({_type:1,oldUri:st.from,newUri:st.to,options:st.options,metadata:st.metadata});else if(st._type===2){const vt=Ne==null?void 0:Ne.getDocument(st.uri);rt.edits.push({_type:2,resource:st.uri,edit:W.from(st.edit),modelVersionId:vt==null?void 0:vt.version,metadata:st.metadata})}else st._type===3?rt.edits.push({_type:3,metadata:st.metadata,resource:st.uri,edit:st.edit,notebookMetadata:st.notebookMetadata,notebookVersionId:(Xe=ge==null?void 0:ge.getNotebookDocument(st.uri,!0))===null||Xe===void 0?void 0:Xe.apiNotebook.version}):st._type===5&&rt.edits.push({_type:3,metadata:st.metadata,resource:st.uri,notebookVersionId:(et=ge==null?void 0:ge.getNotebookDocument(st.uri,!0))===null||et===void 0?void 0:et.apiNotebook.version,edit:{editType:1,index:st.index,count:st.count,cells:st.cells.map(O.from)}});return rt}be.from=ye;function ue(j){const Ne=new c.WorkspaceEdit;for(const ge of j.edits)ge.edit?Ne.replace(_.URI.revive(ge.resource),p.to(ge.edit.range),ge.edit.text):Ne.renameFile(_.URI.revive(ge.oldUri),_.URI.revive(ge.newUri),ge.options);return Ne}be.to=ue})(le=e.WorkspaceEdit||(e.WorkspaceEdit={}));var fe;(function(be){const ye=Object.create(null);ye[c.SymbolKind.File]=0,ye[c.SymbolKind.Module]=1,ye[c.SymbolKind.Namespace]=2,ye[c.SymbolKind.Package]=3,ye[c.SymbolKind.Class]=4,ye[c.SymbolKind.Method]=5,ye[c.SymbolKind.Property]=6,ye[c.SymbolKind.Field]=7,ye[c.SymbolKind.Constructor]=8,ye[c.SymbolKind.Enum]=9,ye[c.SymbolKind.Interface]=10,ye[c.SymbolKind.Function]=11,ye[c.SymbolKind.Variable]=12,ye[c.SymbolKind.Constant]=13,ye[c.SymbolKind.String]=14,ye[c.SymbolKind.Number]=15,ye[c.SymbolKind.Boolean]=16,ye[c.SymbolKind.Array]=17,ye[c.SymbolKind.Object]=18,ye[c.SymbolKind.Key]=19,ye[c.SymbolKind.Null]=20,ye[c.SymbolKind.EnumMember]=21,ye[c.SymbolKind.Struct]=22,ye[c.SymbolKind.Event]=23,ye[c.SymbolKind.Operator]=24,ye[c.SymbolKind.TypeParameter]=25;function ue(Ne){return typeof ye[Ne]=="number"?ye[Ne]:6}be.from=ue;function j(Ne){for(const ge in ye)if(ye[ge]===Ne)return Number(ge);return c.SymbolKind.Property}be.to=j})(fe=e.SymbolKind||(e.SymbolKind={}));var Y;(function(be){function ye(j){switch(j){case c.SymbolTag.Deprecated:return 1}}be.from=ye;function ue(j){switch(j){case 1:return c.SymbolTag.Deprecated}}be.to=ue})(Y=e.SymbolTag||(e.SymbolTag={}));var H;(function(be){function ye(j){return{name:j.name,kind:fe.from(j.kind),tags:j.tags&&j.tags.map(Y.from),containerName:j.containerName,location:x.from(j.location)}}be.from=ye;function ue(j){const Ne=new c.SymbolInformation(j.name,fe.to(j.kind),j.containerName,x.to(j.location));return Ne.tags=j.tags&&j.tags.map(Y.to),Ne}be.to=ue})(H=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var J;(function(be){function ye(j){var Ne,ge;const Xe={name:j.name||"!!MISSING: name!!",detail:j.detail,range:p.from(j.range),selectionRange:p.from(j.selectionRange),kind:fe.from(j.kind),tags:(ge=(Ne=j.tags)===null||Ne===void 0?void 0:Ne.map(Y.from))!==null&&ge!==void 0?ge:[]};return j.children&&(Xe.children=j.children.map(ye)),Xe}be.from=ye;function ue(j){const Ne=new c.DocumentSymbol(j.name,j.detail,fe.to(j.kind),p.to(j.range),p.to(j.selectionRange));return m.isNonEmptyArray(j.tags)&&(Ne.tags=j.tags.map(Y.to)),j.children&&(Ne.children=j.children.map(ue)),Ne}be.to=ue})(J=e.DocumentSymbol||(e.DocumentSymbol={}));var R;(function(be){function ye(ue){const j=new c.CallHierarchyItem(fe.to(ue.kind),ue.name,ue.detail||"",_.URI.revive(ue.uri),p.to(ue.range),p.to(ue.selectionRange));return j._sessionId=ue._sessionId,j._itemId=ue._itemId,j}be.to=ye})(R=e.CallHierarchyItem||(e.CallHierarchyItem={}));var B;(function(be){function ye(ue){return new c.CallHierarchyIncomingCall(R.to(ue.from),ue.fromRanges.map(j=>p.to(j)))}be.to=ye})(B=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var M;(function(be){function ye(ue){return new c.CallHierarchyOutgoingCall(R.to(ue.to),ue.fromRanges.map(j=>p.to(j)))}be.to=ye})(M=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var x;(function(be){function ye(j){return{range:j.range&&p.from(j.range),uri:j.uri}}be.from=ye;function ue(j){return new c.Location(_.URI.revive(j.uri),p.to(j.range))}be.to=ue})(x=e.location||(e.location={}));var q;(function(be){function ye(j){const Ne=j,ge=j;return{originSelectionRange:Ne.originSelectionRange?p.from(Ne.originSelectionRange):void 0,uri:Ne.targetUri?Ne.targetUri:ge.uri,range:p.from(Ne.targetRange?Ne.targetRange:ge.range),targetSelectionRange:Ne.targetSelectionRange?p.from(Ne.targetSelectionRange):void 0}}be.from=ye;function ue(j){return{targetUri:_.URI.revive(j.uri),targetRange:p.to(j.range),targetSelectionRange:j.targetSelectionRange?p.to(j.targetSelectionRange):void 0,originSelectionRange:j.originSelectionRange?p.to(j.originSelectionRange):void 0}}be.to=ue})(q=e.DefinitionLink||(e.DefinitionLink={}));var z;(function(be){function ye(j){return{range:p.from(j.range),contents:E.fromMany(j.contents)}}be.from=ye;function ue(j){return new c.Hover(j.contents.map(E.to),p.to(j.range))}be.to=ue})(z=e.Hover||(e.Hover={}));var oe;(function(be){function ye(j){return{range:p.from(j.range),expression:j.expression}}be.from=ye;function ue(j){return new c.EvaluatableExpression(p.to(j.range),j.expression)}be.to=ue})(oe=e.EvaluatableExpression||(e.EvaluatableExpression={}));var pe;(function(be){function ye(j){if(j instanceof c.InlineValueText)return{type:"text",range:p.from(j.range),text:j.text};if(j instanceof c.InlineValueVariableLookup)return{type:"variable",range:p.from(j.range),variableName:j.variableName,caseSensitiveLookup:j.caseSensitiveLookup};if(j instanceof c.InlineValueEvaluatableExpression)return{type:"expression",range:p.from(j.range),expression:j.expression};throw new Error("Unknown 'InlineValue' type")}be.from=ye;function ue(j){switch(j.type){case"text":return{range:p.to(j.range),text:j.text};case"variable":return{range:p.to(j.range),variableName:j.variableName,caseSensitiveLookup:j.caseSensitiveLookup};case"expression":return{range:p.to(j.range),expression:j.expression}}}be.to=ue})(pe=e.InlineValue||(e.InlineValue={}));var Te;(function(be){function ye(j){return{frameId:j.frameId,stoppedLocation:p.from(j.stoppedLocation)}}be.from=ye;function ue(j){return new c.InlineValueContext(j.frameId,p.to(j.stoppedLocation))}be.to=ue})(Te=e.InlineValueContext||(e.InlineValueContext={}));var Be;(function(be){function ye(j){return{range:p.from(j.range),kind:j.kind}}be.from=ye;function ue(j){return new c.DocumentHighlight(p.to(j.range),j.kind)}be.to=ue})(Be=e.DocumentHighlight||(e.DocumentHighlight={}));var Fe;(function(be){function ye(ue){switch(ue){case 1:return c.CompletionTriggerKind.TriggerCharacter;case 2:return c.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return c.CompletionTriggerKind.Invoke}}be.to=ye})(Fe=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var We;(function(be){function ye(ue){return{triggerKind:Fe.to(ue.triggerKind),triggerCharacter:ue.triggerCharacter}}be.to=ye})(We=e.CompletionContext||(e.CompletionContext={}));var Qe;(function(be){function ye(j){switch(j){case c.CompletionItemTag.Deprecated:return 1}}be.from=ye;function ue(j){switch(j){case 1:return c.CompletionItemTag.Deprecated}}be.to=ue})(Qe=e.CompletionItemTag||(e.CompletionItemTag={}));var Ge;(function(be){const ye=new Map([[c.CompletionItemKind.Method,0],[c.CompletionItemKind.Function,1],[c.CompletionItemKind.Constructor,2],[c.CompletionItemKind.Field,3],[c.CompletionItemKind.Variable,4],[c.CompletionItemKind.Class,5],[c.CompletionItemKind.Interface,7],[c.CompletionItemKind.Struct,6],[c.CompletionItemKind.Module,8],[c.CompletionItemKind.Property,9],[c.CompletionItemKind.Unit,12],[c.CompletionItemKind.Value,13],[c.CompletionItemKind.Constant,14],[c.CompletionItemKind.Enum,15],[c.CompletionItemKind.EnumMember,16],[c.CompletionItemKind.Keyword,17],[c.CompletionItemKind.Snippet,27],[c.CompletionItemKind.Text,18],[c.CompletionItemKind.Color,19],[c.CompletionItemKind.File,20],[c.CompletionItemKind.Reference,21],[c.CompletionItemKind.Folder,23],[c.CompletionItemKind.Event,10],[c.CompletionItemKind.Operator,11],[c.CompletionItemKind.TypeParameter,24],[c.CompletionItemKind.Issue,26],[c.CompletionItemKind.User,25]]);function ue(ge){var Xe;return(Xe=ye.get(ge))!==null&&Xe!==void 0?Xe:9}be.from=ue;const j=new Map([[0,c.CompletionItemKind.Method],[1,c.CompletionItemKind.Function],[2,c.CompletionItemKind.Constructor],[3,c.CompletionItemKind.Field],[4,c.CompletionItemKind.Variable],[5,c.CompletionItemKind.Class],[7,c.CompletionItemKind.Interface],[6,c.CompletionItemKind.Struct],[8,c.CompletionItemKind.Module],[9,c.CompletionItemKind.Property],[12,c.CompletionItemKind.Unit],[13,c.CompletionItemKind.Value],[14,c.CompletionItemKind.Constant],[15,c.CompletionItemKind.Enum],[16,c.CompletionItemKind.EnumMember],[17,c.CompletionItemKind.Keyword],[27,c.CompletionItemKind.Snippet],[18,c.CompletionItemKind.Text],[19,c.CompletionItemKind.Color],[20,c.CompletionItemKind.File],[21,c.CompletionItemKind.Reference],[23,c.CompletionItemKind.Folder],[10,c.CompletionItemKind.Event],[11,c.CompletionItemKind.Operator],[24,c.CompletionItemKind.TypeParameter],[25,c.CompletionItemKind.User],[26,c.CompletionItemKind.Issue]]);function Ne(ge){var Xe;return(Xe=j.get(ge))!==null&&Xe!==void 0?Xe:c.CompletionItemKind.Property}be.to=Ne})(Ge=e.CompletionItemKind||(e.CompletionItemKind={}));var Ke;(function(be){function ye(ue,j){var Ne;const ge=new c.CompletionItem(typeof ue.label=="string"?ue.label:ue.label.name);return typeof ue.label!="string"&&(ge.label2=ue.label),ge.insertText=ue.insertText,ge.kind=Ge.to(ue.kind),ge.tags=(Ne=ue.tags)===null||Ne===void 0?void 0:Ne.map(Qe.to),ge.detail=ue.detail,ge.documentation=T.isMarkdownString(ue.documentation)?E.to(ue.documentation):ue.documentation,ge.sortText=ue.sortText,ge.filterText=ue.filterText,ge.preselect=ue.preselect,ge.commitCharacters=ue.commitCharacters,C.Range.isIRange(ue.range)?ge.range=p.to(ue.range):typeof ue.range=="object"&&(ge.range={inserting:p.to(ue.range.insert),replacing:p.to(ue.range.replace)}),ge.keepWhitespace=typeof ue.insertTextRules=="undefined"?!1:Boolean(ue.insertTextRules&1),typeof ue.insertTextRules!="undefined"&&ue.insertTextRules&4?ge.insertText=new c.SnippetString(ue.insertText):(ge.insertText=ue.insertText,ge.textEdit=ge.range instanceof c.Range?new c.TextEdit(ge.range,ge.insertText):void 0),ue.additionalTextEdits&&ue.additionalTextEdits.length>0&&(ge.additionalTextEdits=ue.additionalTextEdits.map(Xe=>W.to(Xe))),ge.command=j&&ue.command?j.fromInternal(ue.command):void 0,ge}be.to=ye})(Ke=e.CompletionItem||(e.CompletionItem={}));var $;(function(be){function ye(j){return{label:j.label,documentation:j.documentation?E.fromStrict(j.documentation):void 0}}be.from=ye;function ue(j){return{label:j.label,documentation:T.isMarkdownString(j.documentation)?E.to(j.documentation):j.documentation}}be.to=ue})($=e.ParameterInformation||(e.ParameterInformation={}));var Q;(function(be){function ye(j){return{label:j.label,documentation:j.documentation?E.fromStrict(j.documentation):void 0,parameters:Array.isArray(j.parameters)?j.parameters.map($.from):[],activeParameter:j.activeParameter}}be.from=ye;function ue(j){return{label:j.label,documentation:T.isMarkdownString(j.documentation)?E.to(j.documentation):j.documentation,parameters:Array.isArray(j.parameters)?j.parameters.map($.to):[],activeParameter:j.activeParameter}}be.to=ue})(Q=e.SignatureInformation||(e.SignatureInformation={}));var te;(function(be){function ye(j){return{activeSignature:j.activeSignature,activeParameter:j.activeParameter,signatures:Array.isArray(j.signatures)?j.signatures.map(Q.from):[]}}be.from=ye;function ue(j){return{activeSignature:j.activeSignature,activeParameter:j.activeParameter,signatures:Array.isArray(j.signatures)?j.signatures.map(Q.to):[]}}be.to=ue})(te=e.SignatureHelp||(e.SignatureHelp={}));var re;(function(be){function ye(j){var Ne;return{text:j.text,position:u.from(j.position),kind:G.from((Ne=j.kind)!==null&&Ne!==void 0?Ne:c.InlayHintKind.Other),whitespaceBefore:j.whitespaceBefore,whitespaceAfter:j.whitespaceAfter}}be.from=ye;function ue(j){const Ne=new c.InlayHint(j.text,u.to(j.position),G.to(j.kind));return Ne.whitespaceAfter=j.whitespaceAfter,Ne.whitespaceBefore=j.whitespaceBefore,Ne}be.to=ue})(re=e.InlayHint||(e.InlayHint={}));var G;(function(be){function ye(j){return j}be.from=ye;function ue(j){return j}be.to=ue})(G=e.InlayHintKind||(e.InlayHintKind={}));var se;(function(be){function ye(j){return{range:p.from(j.range),url:j.target,tooltip:j.tooltip}}be.from=ye;function ue(j){let Ne;if(j.url)try{Ne=typeof j.url=="string"?_.URI.parse(j.url,!0):_.URI.revive(j.url)}catch(ge){}return new c.DocumentLink(p.to(j.range),Ne)}be.to=ue})(se=e.DocumentLink||(e.DocumentLink={}));var he;(function(be){function ye(j){const Ne=new c.ColorPresentation(j.label);return j.textEdit&&(Ne.textEdit=W.to(j.textEdit)),j.additionalTextEdits&&(Ne.additionalTextEdits=j.additionalTextEdits.map(ge=>W.to(ge))),Ne}be.to=ye;function ue(j){return{label:j.label,textEdit:j.textEdit?W.from(j.textEdit):void 0,additionalTextEdits:j.additionalTextEdits?j.additionalTextEdits.map(Ne=>W.from(Ne)):void 0}}be.from=ue})(he=e.ColorPresentation||(e.ColorPresentation={}));var Ae;(function(be){function ye(j){return new c.Color(j[0],j[1],j[2],j[3])}be.to=ye;function ue(j){return[j.red,j.green,j.blue,j.alpha]}be.from=ue})(Ae=e.Color||(e.Color={}));var xe;(function(be){function ye(j){return{range:p.from(j.range)}}be.from=ye;function ue(j){return new c.SelectionRange(p.to(j.range))}be.to=ue})(xe=e.SelectionRange||(e.SelectionRange={}));var ve;(function(be){function ye(ue){switch(ue){case 2:return c.TextDocumentSaveReason.AfterDelay;case 1:return c.TextDocumentSaveReason.Manual;case 3:case 4:return c.TextDocumentSaveReason.FocusOut}}be.to=ye})(ve=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var je;(function(be){function ye(j){switch(j){case c.TextEditorLineNumbersStyle.Off:return 0;case c.TextEditorLineNumbersStyle.Relative:return 2;case c.TextEditorLineNumbersStyle.On:default:return 1}}be.from=ye;function ue(j){switch(j){case 0:return c.TextEditorLineNumbersStyle.Off;case 2:return c.TextEditorLineNumbersStyle.Relative;case 1:default:return c.TextEditorLineNumbersStyle.On}}be.to=ue})(je=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var V;(function(be){function ye(j){if(j===c.EndOfLine.CRLF)return 1;if(j===c.EndOfLine.LF)return 0}be.from=ye;function ue(j){if(j===1)return c.EndOfLine.CRLF;if(j===0)return c.EndOfLine.LF}be.to=ue})(V=e.EndOfLine||(e.EndOfLine={}));var ee;(function(be){function ye(ue){if(typeof ue=="object")return ue.viewId;switch(ue){case c.ProgressLocation.SourceControl:return 3;case c.ProgressLocation.Window:return 10;case c.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}be.from=ye})(ee=e.ProgressLocation||(e.ProgressLocation={}));var me;(function(be){function ye(ue){const j={start:ue.start+1,end:ue.end+1};return ue.kind&&(j.kind=Re.from(ue.kind)),j}be.from=ye})(me=e.FoldingRange||(e.FoldingRange={}));var Re;(function(be){function ye(ue){if(ue)switch(ue){case c.FoldingRangeKind.Comment:return n.FoldingRangeKind.Comment;case c.FoldingRangeKind.Imports:return n.FoldingRangeKind.Imports;case c.FoldingRangeKind.Region:return n.FoldingRangeKind.Region}}be.from=ye})(Re=e.FoldingRangeKind||(e.FoldingRangeKind={}));var Le;(function(be){function ye(ue){if(ue)return{pinned:typeof ue.preview=="boolean"?!ue.preview:void 0,inactive:ue.background,preserveFocus:ue.preserveFocus,selection:typeof ue.selection=="object"?p.from(ue.selection):void 0,override:typeof ue.override=="boolean"?I.EditorOverride.DISABLED:void 0}}be.from=ye})(Le=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var qe;(function(be){function ye(j){return j instanceof c.RelativePattern||typeof j=="string"?j:ue(j)?new c.RelativePattern(j.base,j.pattern):j}be.from=ye;function ue(j){const Ne=j;return Ne&&typeof Ne.base=="string"&&typeof Ne.pattern=="string"}})(qe=e.GlobPattern||(e.GlobPattern={}));var Se;(function(be){function ye(ue){if(ue){if(Array.isArray(ue))return ue.map(ye);if(typeof ue=="string")return ue;{const j=ue;return{language:j.language,scheme:j.scheme,pattern:typeof j.pattern=="undefined"?void 0:qe.from(j.pattern),exclusive:j.exclusive}}}else return}be.from=ye})(Se=e.LanguageSelector||(e.LanguageSelector={}));var we;(function(be){function ye(j){return{start:j.start,end:j.end}}be.from=ye;function ue(j){return new c.NotebookRange(j.start,j.end)}be.to=ue})(we=e.NotebookRange||(e.NotebookRange={}));var Ce;(function(be){function ye(j){return{timing:typeof j.runStartTime=="number"&&typeof j.runEndTime=="number"?{startTime:j.runStartTime,endTime:j.runEndTime}:void 0,executionOrder:j.executionOrder,success:j.lastRunSuccess}}be.to=ye;function ue(j){var Ne,ge;return{lastRunSuccess:j.success,runStartTime:(Ne=j.timing)===null||Ne===void 0?void 0:Ne.startTime,runEndTime:(ge=j.timing)===null||ge===void 0?void 0:ge.endTime,executionOrder:j.executionOrder}}be.from=ue})(Ce=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var ie;(function(be){function ye(j){switch(j){case c.NotebookCellKind.Markup:return h.CellKind.Markup;case c.NotebookCellKind.Code:default:return h.CellKind.Code}}be.from=ye;function ue(j){switch(j){case h.CellKind.Markup:return c.NotebookCellKind.Markup;case h.CellKind.Code:default:return c.NotebookCellKind.Code}}be.to=ue})(ie=e.NotebookCellKind||(e.NotebookCellKind={}));var ce;(function(be){function ye(j){var Ne;const ge={metadata:(Ne=j.metadata)!==null&&Ne!==void 0?Ne:Object.create(null),cells:[]};for(let Xe of j.cells)c.NotebookCellData.validate(Xe),ge.cells.push(O.from(Xe));return ge}be.from=ye;function ue(j){const Ne=new c.NotebookData(j.cells.map(O.to));return D.isEmptyObject(j.metadata)||(Ne.metadata=j.metadata),Ne}be.to=ue})(ce=e.NotebookData||(e.NotebookData={}));var O;(function(be){function ye(j){var Ne;return{cellKind:ie.from(j.kind),language:j.languageId,source:j.value,metadata:j.metadata,internalMetadata:Ce.from((Ne=j.executionSummary)!==null&&Ne!==void 0?Ne:{}),outputs:j.outputs?j.outputs.map(ae.from):[]}}be.from=ye;function ue(j){return new c.NotebookCellData(ie.to(j.cellKind),j.source,j.language,j.outputs?j.outputs.map(ae.to):void 0,j.metadata,j.internalMetadata?Ce.to(j.internalMetadata):void 0)}be.to=ue})(O=e.NotebookCellData||(e.NotebookCellData={}));var K;(function(be){function ye(j){return{mime:j.mime,valueBytes:Array.from(j.data)}}be.from=ye;function ue(j){return new c.NotebookCellOutputItem(new Uint8Array(j.valueBytes),j.mime)}be.to=ue})(K=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var ae;(function(be){function ye(j){return{outputId:j.id,items:j.items.map(K.from),metadata:j.metadata}}be.from=ye;function ue(j){const Ne=j.items.map(K.to);return new c.NotebookCellOutput(Ne,j.outputId,j.metadata)}be.to=ue})(ae=e.NotebookCellOutput||(e.NotebookCellOutput={}));var ke;(function(be){function ye(ge){if(ge!=null){if(ge instanceof c.RelativePattern||typeof ge=="string")return ge;if(Ne(ge))return new c.RelativePattern(ge.base,ge.pattern);if(j(ge))return{include:qe.from(ge.include)||void 0,exclude:qe.from(ge.exclude)||void 0}}}be.from=ye;function ue(ge){return typeof ge=="string"?ge:Ne(ge)?{base:ge.base,pattern:ge.pattern}:{include:ge.include,exclude:ge.exclude}}be.to=ue;function j(ge){const Xe=ge,et=qe.from(Xe.include);if(!(et&&et instanceof c.RelativePattern||typeof et=="string"))return!1;const rt=qe.from(Xe.exclude);return!!(rt&&rt instanceof c.RelativePattern||typeof rt=="string")}function Ne(ge){const Xe=ge;return Xe&&typeof Xe.base=="string"&&typeof Xe.pattern=="string"}})(ke=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var Pe;(function(be){function ye(ue){return{backgroundColor:ue.backgroundColor,borderColor:ue.borderColor,top:ue.top?P.from(ue.top):void 0}}be.from=ye})(Pe=e.NotebookDecorationRenderOptions||(e.NotebookDecorationRenderOptions={}));var Oe;(function(be){function ye(ue,j,Ne){const ge=typeof ue.command=="string"?{title:"",command:ue.command}:ue.command;return{alignment:ue.alignment===c.NotebookCellStatusBarAlignment.Left?1:2,command:j.toInternal(ge,Ne),text:ue.text,tooltip:ue.tooltip,accessibilityInformation:ue.accessibilityInformation,priority:ue.priority}}be.from=ye})(Oe=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var $e;(function(be){function ye(ue){var j,Ne,ge;return{transientOutputs:(j=ue==null?void 0:ue.transientOutputs)!==null&&j!==void 0?j:!1,transientCellMetadata:(Ne=ue==null?void 0:ue.transientCellMetadata)!==null&&Ne!==void 0?Ne:{},transientDocumentMetadata:(ge=ue==null?void 0:ue.transientDocumentMetadata)!==null&&ge!==void 0?ge:{}}}be.from=ye})($e=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var Ze;(function(be){function ye(j){return{uri:j.uri,provides:j.provides}}be.from=ye;function ue(j){return new c.NotebookRendererScript(_.URI.revive(j.uri),j.provides)}be.to=ue})(Ze=e.NotebookRendererScript||(e.NotebookRendererScript={}));var Je;(function(be){function ye(j){return{message:E.fromStrict(j.message)||"",severity:j.severity,expectedOutput:j.expectedOutput,actualOutput:j.actualOutput,location:j.location?x.from(j.location):void 0}}be.from=ye;function ue(j){const Ne=new c.TestMessage(typeof j.message=="string"?j.message:E.to(j.message));return Ne.severity=j.severity,Ne.actualOutput=j.actualOutput,Ne.expectedOutput=j.expectedOutput,Ne}be.to=ue})(Je=e.TestMessage||(e.TestMessage={}));var Ye;(function(be){function ye(ge){var Xe,et;return{extId:ge.id,label:ge.label,uri:ge.uri,range:p.from(ge.range)||null,debuggable:(Xe=ge.debuggable)!==null&&Xe!==void 0?Xe:!1,description:ge.description||null,runnable:(et=ge.runnable)!==null&&et!==void 0?et:!0,error:ge.error&&E.fromStrict(ge.error)||null}}be.from=ye;function ue(ge){return{extId:ge.id,label:ge.label,uri:ge.uri,range:p.from(ge.range)||null,debuggable:!1,description:ge.description||null,error:null,runnable:!0}}be.fromResultSnapshot=ue;function j(ge){return{id:ge.extId,label:ge.label,uri:_.URI.revive(ge.uri),range:p.to(ge.range||void 0),addChild:()=>{},dispose:()=>{},status:c.TestItemStatus.Pending,data:void 0,debuggable:ge.debuggable,description:ge.description||void 0,runnable:ge.runnable}}be.toPlain=j;function Ne(ge){const Xe=new c.TestItemImpl(ge.extId,ge.label,_.URI.revive(ge.uri),void 0);return Xe.range=p.to(ge.range||void 0),Xe.debuggable=ge.debuggable,Xe.description=ge.description||void 0,Xe.runnable=ge.runnable,Xe}be.to=Ne})(Ye=e.TestItem||(e.TestItem={}));var nt;(function(be){const ye=(j,Ne)=>Object.assign(Object.assign({},Ye.toPlain(j.item)),{taskStates:j.tasks.map(ge=>({state:ge.state,duration:ge.duration,messages:ge.messages.map(Je.to)})),children:j.children.map(ge=>Ne.get(ge)).filter(D.isDefined).map(ge=>ye(ge,Ne))});function ue(j){const Ne=[],ge=new Map;for(const Xe of j.items)ge.set(Xe.item.extId,Xe),Xe.direct&&Ne.push(Xe);return{completedAt:j.completedAt,results:Ne.map(Xe=>ye(Xe,ge))}}be.to=ue})(nt=e.TestResults||(e.TestResults={}));var pt;(function(be){function ye(ue){switch(ue){case 1:return c.CodeActionTriggerKind.Invoke;case 2:return c.CodeActionTriggerKind.Automatic}}be.to=ye})(pt=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}))}),define(_e[167],Ee([0,1,2,11,6,9,51]),function(Z,e,m,T,S,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class D{constructor(C,n,I,o={timeout:1500,errors:3}){this._logService=C,this._documents=n,this._mainThreadBulkEdits=I,this._thresholds=o,this._callbacks=new k.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(C){return(n,I,o)=>{const d={dispose:this._callbacks.push([n,I,C])};return Array.isArray(o)&&o.push(d),d}}async $participateInSave(C,n){const I=m.URI.revive(C);let o=!1;const h=setTimeout(()=>o=!0,this._thresholds.timeout),d=[];try{for(let c of[...this._callbacks]){if(o)break;const b=this._documents.getDocument(I),p=await this._deliverEventAsyncAndBlameBadListeners(c,{document:b,reason:y.TextDocumentSaveReason.to(n)});d.push(p)}}finally{clearTimeout(h)}return d}_deliverEventAsyncAndBlameBadListeners([C,n,I],o){const h=this._badListeners.get(C);return typeof h=="number"&&h>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(I,C,n,o).then(()=>!0,d=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${I.identifier.value}' threw ERROR`),this._logService.error(d),!(d instanceof Error)||d.message!=="concurrent_edits"){const c=this._badListeners.get(C);this._badListeners.set(C,c?c+1:1),typeof c=="number"&&c>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${I.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(C,n,I,o){const h=[],d=Date.now(),{document:c,reason:b}=o,{version:p}=c,w=Object.freeze({document:c,reason:b,waitUntil(u){if(Object.isFrozen(h))throw T.illegalState("waitUntil can not be called async");h.push(Promise.resolve(u))}});try{n.apply(I,[w])}catch(u){return Promise.reject(u)}return Object.freeze(h),new Promise((u,f)=>{const g=setTimeout(()=>f(new Error("timeout")),this._thresholds.timeout);return Promise.all(h).then(t=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${C.identifier.value}' finished after ${Date.now()-d}ms`),clearTimeout(g),u(t)}).catch(t=>{clearTimeout(g),f(t)})}).then(u=>{const f={edits:[]};for(const g of u)if(Array.isArray(g)&&g.every(t=>t instanceof S.TextEdit))for(const{newText:t,newEol:i,range:s}of g)f.edits.push({_type:2,resource:c.uri,edit:{range:s&&y.Range.from(s),text:t,eol:i&&y.EndOfLine.from(i)}});if(f.edits.length!==0)return p===c.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(f):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=D}),define(_e[168],Ee([0,1,3,12,27,2,9,6]),function(Z,e,m,T,S,y,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class _{constructor(I,o,h,d,c){this._onDidCreate=new m.Emitter,this._onDidChange=new m.Emitter,this._onDidDelete=new m.Emitter,this._config=0,h&&(this._config+=1),d&&(this._config+=2),c&&(this._config+=4);const b=S.parse(o),p=I(w=>{if(!h)for(let u of w.created){const f=y.URI.revive(u);b(f.fsPath)&&this._onDidCreate.fire(f)}if(!d)for(let u of w.changed){const f=y.URI.revive(u);b(f.fsPath)&&this._onDidChange.fire(f)}if(!c)for(let u of w.deleted){const f=y.URI.revive(u);b(f.fsPath)&&this._onDidDelete.fire(f)}});this._disposable=D.Disposable.from(this._onDidCreate,this._onDidChange,this._onDidDelete,p)}get ignoreCreateEvents(){return Boolean(this._config&1)}get ignoreChangeEvents(){return Boolean(this._config&2)}get ignoreDeleteEvents(){return Boolean(this._config&4)}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class C{constructor(I,o,h){this._logService=o,this._extHostDocumentsAndEditors=h,this._onFileSystemEvent=new m.Emitter,this._onDidRenameFile=new m.Emitter,this._onDidCreateFile=new m.Emitter,this._onDidDeleteFile=new m.Emitter,this._onWillRenameFile=new T.AsyncEmitter,this._onWillCreateFile=new T.AsyncEmitter,this._onWillDeleteFile=new T.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(I,o,h,d){return new _(this._onFileSystemEvent.event,I,o,h,d)}$onFileEvent(I){this._onFileSystemEvent.fire(I)}$onDidRunFileOperation(I,o){switch(I){case 2:this._onDidRenameFile.fire(Object.freeze({files:o.map(h=>({oldUri:y.URI.revive(h.source),newUri:y.URI.revive(h.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:o.map(h=>y.URI.revive(h.target))}));break;case 0:this._onDidCreateFile.fire(Object.freeze({files:o.map(h=>y.URI.revive(h.target))}));break;default:}}getOnWillRenameFileEvent(I){return this._createWillExecuteEvent(I,this._onWillRenameFile)}getOnWillCreateFileEvent(I){return this._createWillExecuteEvent(I,this._onWillCreateFile)}getOnWillDeleteFileEvent(I){return this._createWillExecuteEvent(I,this._onWillDeleteFile)}_createWillExecuteEvent(I,o){return(h,d,c)=>{const b=function(w){h.call(d,w)};return b.extension=I,o.event(b,void 0,c)}}async $onWillRunFileOperation(I,o,h,d){switch(I){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:o.map(c=>({oldUri:y.URI.revive(c.source),newUri:y.URI.revive(c.target)}))},h,d);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:o.map(c=>y.URI.revive(c.target))},h,d);case 0:return await this._fireWillEvent(this._onWillCreateFile,{files:o.map(c=>y.URI.revive(c.target))},h,d)}}async _fireWillEvent(I,o,h,d){const c=new Set,b=[];if(await I.fireAsync(o,d,async(w,u)=>{var f;const g=Date.now(),t=await Promise.resolve(w);t instanceof D.WorkspaceEdit&&(b.push(t),c.add((f=u.extension.displayName)!==null&&f!==void 0?f:u.extension.identifier.value)),Date.now()-g>h&&this._logService.warn("SLOW file-participant",u.extension.identifier)}),d.isCancellationRequested||b.length===0)return;const p={edits:[]};for(let w of b){let{edits:u}=k.WorkspaceEdit.from(w,this._extHostDocumentsAndEditors);p.edits=p.edits.concat(u)}return{edit:p,extensionNames:Array.from(c)}}}e.ExtHostFileSystemEventService=C}),define(_e[169],Ee([0,1,16,24,2,9,6,68]),function(Z,e,m,T,S,y,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class _{constructor(o,h,d,c){this.start=o,this.deletedCount=h,this.deletedItems=d,this.items=c}static asApiEvents(o){return o.map(h=>({start:h.start,deletedCount:h.deletedCount,deletedItems:h.deletedItems,items:h.items.map(d=>d.apiCell)}))}}class C{constructor(o,h,d){var c,b,p;this.notebook=o,this._extHostDocument=h,this._cellData=d,this.handle=d.handle,this.uri=S.URI.revive(d.uri),this.cellKind=d.cellKind,this._outputs=d.outputs.map(y.NotebookCellOutput.to),this._internalMetadata=(c=d.internalMetadata)!==null&&c!==void 0?c:{},this._metadata=(b=d.metadata)!==null&&b!==void 0?b:{},this._previousResult=y.NotebookCellExecutionSummary.to((p=d.internalMetadata)!==null&&p!==void 0?p:{})}static asModelAddData(o,h){return{EOL:h.eol,lines:h.source,modeId:h.language,uri:h.uri,isDirty:!1,versionId:1,notebook:o}}get internalMetadata(){return this._internalMetadata}get apiCell(){if(!this._apiCell){const o=this,h=this._extHostDocument.getDocument(this.uri);if(!h)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);this._apiCell=Object.freeze({get index(){return o.notebook.getCellIndex(o)},notebook:o.notebook.apiNotebook,kind:y.NotebookCellKind.to(this._cellData.cellKind),document:h.document,get outputs(){return o._outputs.slice(0)},get metadata(){return o._metadata},get executionSummary(){return o._previousResult}})}return this._apiCell}setOutputs(o){this._outputs=o.map(y.NotebookCellOutput.to)}setOutputItems(o,h,d){const c=d.map(y.NotebookCellOutputItem.to),b=this._outputs.find(p=>p.id===o);b&&(h||(b.items.length=0),b.items.push(...c))}setMetadata(o){this._metadata=o}setInternalMetadata(o){this._internalMetadata=o,this._previousResult=y.NotebookCellExecutionSummary.to(o)}}e.ExtHostCell=C;class n{constructor(o,h,d,c,b,p){var w;this._proxy=o,this._textDocumentsAndEditors=h,this._textDocuments=d,this._emitter=c,this.uri=b,this.handle=n._handlePool++,this._cells=[],this._versionId=0,this._isDirty=!1,this._disposed=!1,this._notebookType=p.viewType,this._metadata=(w=p.metadata)!==null&&w!==void 0?w:Object.create(null),this._spliceNotebookCells([[0,0,p.cells]],!0),this._versionId=p.versionId}dispose(){this._disposed=!0}get apiNotebook(){if(!this._notebook){const o=this;this._notebook={get uri(){return o.uri},get version(){return o._versionId},get notebookType(){return o._notebookType},get isDirty(){return o._isDirty},get isUntitled(){return o.uri.scheme===m.Schemas.untitled},get isClosed(){return o._disposed},get metadata(){return o._metadata},get cellCount(){return o._cells.length},cellAt(h){return h=o._validateIndex(h),o._cells[h].apiCell},getCells(h){return(h?o._getCells(h):o._cells).map(c=>c.apiCell)},save(){return o._save()}}}return this._notebook}updateBackup(o){var h;(h=this._backup)===null||h===void 0||h.delete(),this._backup=o}disposeBackup(){var o;(o=this._backup)===null||o===void 0||o.delete(),this._backup=void 0}acceptDocumentPropertiesChanged(o){o.metadata&&(this._metadata=Object.assign(Object.assign({},this._metadata),o.metadata))}acceptDirty(o){this._isDirty=o}acceptModelChanged(o,h){this._versionId=o.versionId,this._isDirty=h;for(const d of o.rawEvents)d.kind===D.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(d.changes,!1):d.kind===D.NotebookCellsChangeType.Move?this._moveCell(d.index,d.newIdx):d.kind===D.NotebookCellsChangeType.Output?this._setCellOutputs(d.index,d.outputs):d.kind===D.NotebookCellsChangeType.OutputItem?this._setCellOutputItems(d.index,d.outputId,d.append,d.outputItems):d.kind===D.NotebookCellsChangeType.ChangeLanguage?this._changeCellLanguage(d.index,d.language):d.kind===D.NotebookCellsChangeType.ChangeCellMetadata?this._changeCellMetadata(d.index,d.metadata):d.kind===D.NotebookCellsChangeType.ChangeCellInternalMetadata&&this._changeCellInternalMetadata(d.index,d.internalMetadata)}_validateIndex(o){return o=o|0,o<0?0:o>=this._cells.length?this._cells.length-1:o}_validateRange(o){let h=o.start|0,d=o.end|0;return h<0&&(h=0),d>this._cells.length&&(d=this._cells.length),o.with({start:h,end:d})}_getCells(o){o=this._validateRange(o);const h=[];for(let d=o.start;d<o.end;d++)h.push(this._cells[d]);return h}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveNotebook(this.uri)}_spliceNotebookCells(o,h){if(this._disposed)return;const d=[],c=[],b=[];o.reverse().forEach(p=>{const u=p[2].map(t=>{const i=new C(this,this._textDocumentsAndEditors,t);return h||c.push(C.asModelAddData(this.apiNotebook,t)),i}),f=new _(p[0],p[1],[],u),g=this._cells.splice(p[0],p[1],...u);for(const t of g)b.push(t.uri),f.deletedItems.push(t.apiCell);d.push(f)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:c,removedDocuments:b}),h||this._emitter.emitModelChange(T.deepFreeze({document:this.apiNotebook,changes:_.asApiEvents(d)}))}_moveCell(o,h){const d=this._cells.splice(o,1);this._cells.splice(h,0,...d);const c=[new _(o,1,d.map(b=>b.apiCell),[]),new _(h,0,[],d)];this._emitter.emitModelChange(T.deepFreeze({document:this.apiNotebook,changes:_.asApiEvents(c)}))}_setCellOutputs(o,h){const d=this._cells[o];d.setOutputs(h),this._emitter.emitCellOutputsChange(T.deepFreeze({document:this.apiNotebook,cells:[d.apiCell]}))}_setCellOutputItems(o,h,d,c){const b=this._cells[o];b.setOutputItems(h,d,c),this._emitter.emitCellOutputsChange(T.deepFreeze({document:this.apiNotebook,cells:[b.apiCell]}))}_changeCellLanguage(o,h){const d=this._cells[o];d.apiCell.document.languageId!==h&&this._textDocuments.$acceptModelModeChanged(d.uri,h)}_changeCellMetadata(o,h){const d=this._cells[o],c=d.apiCell.metadata;d.setMetadata(h);const b=d.apiCell.metadata;T.equals(c,b)||this._emitter.emitCellMetadataChange(T.deepFreeze({document:this.apiNotebook,cell:d.apiCell}))}_changeCellInternalMetadata(o,h){var d;const c=this._cells[o],b=c.internalMetadata;if(c.setInternalMetadata(h),b.runState!==h.runState){const p=(d=h.runState)!==null&&d!==void 0?d:k.NotebookCellExecutionState.Idle;this._emitter.emitCellExecutionStateChange(T.deepFreeze({document:this.apiNotebook,cell:c.apiCell,state:p}))}}getCellFromApiCell(o){return this._cells.find(h=>h.apiCell===o)}getCellFromIndex(o){return this._cells[o]}getCell(o){return this._cells.find(h=>h.handle===o)}getCellIndex(o){return this._cells.indexOf(o)}}e.ExtHostNotebookDocument=n,n._handlePool=0}),define(_e[97],Ee([0,1,6,9,11]),function(Z,e,m,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class y{constructor(_){this._finalized=!1,this._collectedEdits=[],this._documentVersionId=_}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,cellEdits:this._collectedEdits}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replaceMetadata(_){this._throwIfFinalized(),this._collectedEdits.push({editType:5,metadata:_})}replaceCellMetadata(_,C){this._throwIfFinalized(),this._collectedEdits.push({editType:8,index:_,metadata:C})}replaceCells(_,C,n){this._throwIfFinalized(),!(_===C&&n.length===0)&&this._collectedEdits.push({editType:1,index:_,count:C-_,cells:n.map(T.NotebookCellData.from)})}}class k{constructor(_,C,n,I,o,h){this.id=_,this._proxy=C,this.notebookData=n,this._selections=[],this._visibleRanges=[],this._visible=!1,this._hasDecorationsForKey=new Set,this._selections=o,this._visibleRanges=I,this._viewColumn=h}get apiEditor(){if(!this._editor){const _=this;this._editor={get document(){return _.notebookData.apiNotebook},get selections(){return _._selections},set selections(C){if(!Array.isArray(C)||!C.every(m.NotebookRange.isNotebookRange))throw S.illegalArgument("selections");_._selections=C,_._trySetSelections(C)},get visibleRanges(){return _._visibleRanges},revealRange(C,n){_._proxy.$tryRevealRange(_.id,T.NotebookRange.from(C),n??m.NotebookEditorRevealType.Default)},get viewColumn(){return _._viewColumn},edit(C){const n=new y(this.document.version);return C(n),_._applyEdit(n.finalize())},setDecorations(C,n){return _.setDecorations(C,n)}},k.apiEditorsToExtHost.set(this._editor,this)}return this._editor}get visible(){return this._visible}_acceptVisibility(_){this._visible=_}_acceptVisibleRanges(_){this._visibleRanges=_}_acceptSelections(_){this._selections=_}_trySetSelections(_){this._proxy.$trySetSelections(this.id,_.map(T.NotebookRange.from))}_acceptViewColumn(_){this._viewColumn=_}_applyEdit(_){if(_.cellEdits.length===0)return Promise.resolve(!0);const C=[];let n=-1;for(let I=0;I<_.cellEdits.length;I++){if(n<0){C.push(_.cellEdits[I]),n++;continue}const h=C[n],d=_.cellEdits[I];if(h.editType===1&&d.editType===1&&h.index===d.index){h.cells.push(..._.cellEdits[I].cells),h.count+=_.cellEdits[I].count;continue}C.push(_.cellEdits[I]),n++}return this._proxy.$tryApplyEdits(this.id,_.documentVersionId,C)}setDecorations(_,C){if(!(C.isEmpty&&!this._hasDecorationsForKey.has(_.key)))return C.isEmpty?this._hasDecorationsForKey.delete(_.key):this._hasDecorationsForKey.add(_.key),this._proxy.$trySetDecorations(this.id,T.NotebookRange.from(C),_.key)}}e.ExtHostNotebookEditor=k,k.apiEditorsToExtHost=new WeakMap}),define(_e[170],Ee([0,1,9,149,130,18,47]),function(Z,e,m,T,S,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class D{constructor(I){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=I}withProgress(I,o,h){const d=this._handles++,{title:c,location:b,cancellable:p}=o,w={label:S.localize(0,null,I.displayName||I.name),id:I.identifier.value};return this._proxy.$startProgress(d,{location:m.ProgressLocation.from(b),title:c,source:w,cancellable:p},I),this._withProgress(d,h,!!p)}_withProgress(I,o,h){let d;h&&(d=new y.CancellationTokenSource,this._mapHandleToCancellationSource.set(I,d));const c=p=>{this._proxy.$progressEnd(p),this._mapHandleToCancellationSource.delete(p),d&&d.dispose()};let b;try{b=o(new C(this._proxy,I),h&&d?d.token:y.CancellationToken.None)}catch(p){throw c(I),p}return b.then(p=>c(I),p=>c(I)),b}$acceptProgressCanceled(I){const o=this._mapHandleToCancellationSource.get(I);o&&(o.cancel(),this._mapHandleToCancellationSource.delete(I))}}e.ExtHostProgress=D;function _(n,I){return n.message=I.message,typeof I.increment=="number"&&(typeof n.increment=="number"?n.increment+=I.increment:n.increment=I.increment),n}class C extends T.Progress{constructor(I,o){super(h=>this.throttledReport(h));this._proxy=I,this._handle=o}throttledReport(I){this._proxy.$progressReport(this._handle,I)}}He([k.throttle(100,(n,I)=>_(n,I),()=>Object.create(null))],C.prototype,"throttledReport",null)}),define(_e[98],Ee([0,1,39,11,49,9,6]),function(Z,e,m,T,S,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorEdit=e.TextEditorDecorationType=void 0;class D{constructor(o,h,d){const c=D._Keys.nextId();o.$registerTextEditorDecorationType(h.identifier,c,y.DecorationRenderOptions.from(d)),this.value=Object.freeze({key:c,dispose(){o.$removeTextEditorDecorationType(c)}})}}e.TextEditorDecorationType=D,D._Keys=new S.IdGenerator("TextEditorDecorationType");class _{constructor(o,h){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=o,this._documentVersionId=o.version,this._undoStopBefore=h.undoStopBefore,this._undoStopAfter=h.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(o,h){this._throwIfFinalized();let d=null;if(o instanceof k.Position)d=new k.Range(o,o);else if(o instanceof k.Range)d=o;else throw new Error("Unrecognized location");this._pushEdit(d,h,!1)}insert(o,h){this._throwIfFinalized(),this._pushEdit(new k.Range(o,o),h,!0)}delete(o){this._throwIfFinalized();let h=null;if(o instanceof k.Range)h=o;else throw new Error("Unrecognized location");this._pushEdit(h,null,!0)}_pushEdit(o,h,d){const c=this._document.validateRange(o);this._collectedEdits.push({range:c,text:h,forceMoveMarkers:d})}setEndOfLine(o){if(this._throwIfFinalized(),o!==k.EndOfLine.LF&&o!==k.EndOfLine.CRLF)throw T.illegalArgument("endOfLine");this._setEndOfLine=o}}e.TextEditorEdit=_;class C{constructor(o,h,d,c){this._proxy=o,this._id=h,this._accept(d),this._logService=c;const b=this;this.value={get tabSize(){return b._tabSize},set tabSize(p){b._setTabSize(p)},get insertSpaces(){return b._insertSpaces},set insertSpaces(p){b._setInsertSpaces(p)},get cursorStyle(){return b._cursorStyle},set cursorStyle(p){b._setCursorStyle(p)},get lineNumbers(){return b._lineNumbers},set lineNumbers(p){b._setLineNumbers(p)}}}_accept(o){this._tabSize=o.tabSize,this._insertSpaces=o.insertSpaces,this._cursorStyle=o.cursorStyle,this._lineNumbers=y.TextEditorLineNumbersStyle.to(o.lineNumbers)}_validateTabSize(o){if(o==="auto")return"auto";if(typeof o=="number"){const h=Math.floor(o);return h>0?h:null}if(typeof o=="string"){const h=parseInt(o,10);return isNaN(h)?null:h>0?h:null}return null}_setTabSize(o){const h=this._validateTabSize(o);if(h!==null){if(typeof h=="number"){if(this._tabSize===h)return;this._tabSize=h}this._warnOnError(this._proxy.$trySetOptions(this._id,{tabSize:h}))}}_validateInsertSpaces(o){return o==="auto"?"auto":o==="false"?!1:Boolean(o)}_setInsertSpaces(o){const h=this._validateInsertSpaces(o);if(typeof h=="boolean"){if(this._insertSpaces===h)return;this._insertSpaces=h}this._warnOnError(this._proxy.$trySetOptions(this._id,{insertSpaces:h}))}_setCursorStyle(o){this._cursorStyle!==o&&(this._cursorStyle=o,this._warnOnError(this._proxy.$trySetOptions(this._id,{cursorStyle:o})))}_setLineNumbers(o){this._lineNumbers!==o&&(this._lineNumbers=o,this._warnOnError(this._proxy.$trySetOptions(this._id,{lineNumbers:y.TextEditorLineNumbersStyle.from(o)})))}assign(o){const h={};let d=!1;if(typeof o.tabSize!="undefined"){const c=this._validateTabSize(o.tabSize);c==="auto"?(d=!0,h.tabSize=c):typeof c=="number"&&this._tabSize!==c&&(this._tabSize=c,d=!0,h.tabSize=c)}if(typeof o.insertSpaces!="undefined"){const c=this._validateInsertSpaces(o.insertSpaces);c==="auto"?(d=!0,h.insertSpaces=c):this._insertSpaces!==c&&(this._insertSpaces=c,d=!0,h.insertSpaces=c)}typeof o.cursorStyle!="undefined"&&this._cursorStyle!==o.cursorStyle&&(this._cursorStyle=o.cursorStyle,d=!0,h.cursorStyle=o.cursorStyle),typeof o.lineNumbers!="undefined"&&this._lineNumbers!==o.lineNumbers&&(this._lineNumbers=o.lineNumbers,d=!0,h.lineNumbers=y.TextEditorLineNumbersStyle.from(o.lineNumbers)),d&&this._warnOnError(this._proxy.$trySetOptions(this._id,h))}_warnOnError(o){o.catch(h=>this._logService.warn(h))}}e.ExtHostTextEditorOptions=C;class n{constructor(o,h,d,c,b,p,w,u){this.id=o,this._proxy=h,this._logService=d,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=b,this._options=new C(this._proxy,this.id,p,d),this._visibleRanges=w,this._viewColumn=u;const f=this;this.value=Object.freeze({get document(){return c.getValue()},set document(g){throw T.readonly("document")},get selection(){return f._selections&&f._selections[0]},set selection(g){if(!(g instanceof k.Selection))throw T.illegalArgument("selection");f._selections=[g],f._trySetSelection()},get selections(){return f._selections},set selections(g){if(!Array.isArray(g)||g.some(t=>!(t instanceof k.Selection)))throw T.illegalArgument("selections");f._selections=g,f._trySetSelection()},get visibleRanges(){return f._visibleRanges},set visibleRanges(g){throw T.readonly("visibleRanges")},get options(){return f._options.value},set options(g){f._disposed||f._options.assign(g)},get viewColumn(){return f._viewColumn},set viewColumn(g){throw T.readonly("viewColumn")},edit(g,t={undoStopBefore:!0,undoStopAfter:!0}){if(f._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const i=new _(c.getValue(),t);return g(i),f._applyEdit(i)},insertSnippet(g,t,i={undoStopBefore:!0,undoStopAfter:!0}){if(f._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let s;if(!t||Array.isArray(t)&&t.length===0)s=f._selections.map(r=>y.Range.from(r));else if(t instanceof k.Position){const{lineNumber:r,column:l}=y.Position.from(t);s=[{startLineNumber:r,startColumn:l,endLineNumber:r,endColumn:l}]}else if(t instanceof k.Range)s=[y.Range.from(t)];else{s=[];for(const r of t)if(r instanceof k.Range)s.push(y.Range.from(r));else{const{lineNumber:l,column:E}=y.Position.from(r);s.push({startLineNumber:l,startColumn:E,endLineNumber:l,endColumn:E})}}return h.$tryInsertSnippet(o,g.value,s,i)},setDecorations(g,t){const i=t.length===0;i&&!f._hasDecorationsForKey.has(g.key)||(i?f._hasDecorationsForKey.delete(g.key):f._hasDecorationsForKey.add(g.key),f._runOnProxy(()=>{if(y.isDecorationOptionsArr(t))return h.$trySetDecorations(o,g.key,y.fromRangeOrRangeWithMessage(t));{const s=new Array(4*t.length);for(let r=0,l=t.length;r<l;r++){const E=t[r];s[4*r]=E.start.line+1,s[4*r+1]=E.start.character+1,s[4*r+2]=E.end.line+1,s[4*r+3]=E.end.character+1}return h.$trySetDecorationsFast(o,g.key,s)}}))},revealRange(g,t){f._runOnProxy(()=>h.$tryRevealRange(o,y.Range.from(g),t||k.TextEditorRevealType.Default))},show(g){h.$tryShowEditor(o,y.ViewColumn.from(g))},hide(){h.$tryHideEditor(o)}})}dispose(){m.ok(!this._disposed),this._disposed=!0}_acceptOptions(o){m.ok(!this._disposed),this._options._accept(o)}_acceptVisibleRanges(o){m.ok(!this._disposed),this._visibleRanges=o}_acceptViewColumn(o){m.ok(!this._disposed),this._viewColumn=o}_acceptSelections(o){m.ok(!this._disposed),this._selections=o}async _trySetSelection(){const o=this._selections.map(y.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,o)),this.value}_applyEdit(o){const h=o.finalize();if(h.edits.length===0&&!h.setEndOfLine)return Promise.resolve(!0);const d=h.edits.map(b=>b.range);d.sort((b,p)=>b.end.line===p.end.line?b.end.character===p.end.character?b.start.line===p.start.line?b.start.character-p.start.character:b.start.line-p.start.line:b.end.character-p.end.character:b.end.line-p.end.line);for(let b=0,p=d.length-1;b<p;b++){const w=d[b].end;if(d[b+1].start.isBefore(w))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const c=h.edits.map(b=>({range:y.Range.from(b.range),text:b.text,forceMoveMarkers:b.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,h.documentVersionId,c,{setEndOfLine:typeof h.setEndOfLine=="number"?y.EndOfLine.from(h.setEndOfLine):void 0,undoStopBefore:h.undoStopBefore,undoStopAfter:h.undoStopAfter})}_runOnProxy(o){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):o().then(()=>this,h=>(h instanceof Error&&h.name==="DISPOSED"||this._logService.warn(h),null))}}e.ExtHostTextEditor=n}),define(_e[171],Ee([0,1,133,25,2,3,7,12,6,10,17,9,18]),function(Z,e,m,T,S,y,k,D,_,C,n,I,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function h(b,p){if(C.isString(b))return{label:b};if(b&&typeof b=="object"&&typeof b.label=="string"){let w;return Array.isArray(b.highlights)&&(w=b.highlights.filter(u=>u.length===2&&typeof u[0]=="number"&&typeof u[1]=="number"),w=w.length?w:void 0),{label:b.label,highlights:w}}}class d{constructor(p,w,u){this._proxy=p,this.commands=w,this.logService=u,this.treeViews=new Map;function f(g){return g&&g.$treeViewId&&g.$treeItemHandle}w.registerArgumentProcessor({processArgument:g=>f(g)?this.convertArgument(g):Array.isArray(g)&&g.length>0?g.map(t=>f(t)?this.convertArgument(t):t):g})}registerTreeDataProvider(p,w,u){const f=this.createTreeView(p,{treeDataProvider:w},u);return{dispose:()=>f.dispose()}}createTreeView(p,w,u){if(!w||!w.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const f=w.dragAndDropController!==void 0,g=this._proxy.$registerTreeViewDataProvider(p,{showCollapseAll:!!w.showCollapseAll,canSelectMany:!!w.canSelectMany,canDragAndDrop:f}),t=this.createExtHostTreeView(p,w,u);return{get onDidCollapseElement(){return t.onDidCollapseElement},get onDidExpandElement(){return t.onDidExpandElement},get selection(){return t.selectedElements},get onDidChangeSelection(){return t.onDidChangeSelection},get visible(){return t.visible},get onDidChangeVisibility(){return t.onDidChangeVisibility},get message(){return t.message},set message(i){t.message=i},get title(){return t.title},set title(i){t.title=i},get description(){return t.description},set description(i){t.description=i},reveal:(i,s)=>t.reveal(i,s),dispose:async()=>{await g,this.treeViews.delete(p),t.dispose()}}}$getChildren(p,w){const u=this.treeViews.get(p);return u?u.getChildren(w):Promise.reject(new Error(m.localize(0,null,p)))}$onDrop(p,w,u){const f=this.treeViews.get(p);return f?f.onDrop(w,u):Promise.reject(new Error(m.localize(1,null,p)))}async $hasResolve(p){const w=this.treeViews.get(p);if(!w)throw new Error(m.localize(2,null,p));return w.hasResolve}$resolve(p,w,u){const f=this.treeViews.get(p);if(!f)throw new Error(m.localize(3,null,p));return f.resolveTreeItem(w,u)}$setExpanded(p,w,u){const f=this.treeViews.get(p);if(!f)throw new Error(m.localize(4,null,p));f.setExpanded(w,u)}$setSelection(p,w){const u=this.treeViews.get(p);if(!u)throw new Error(m.localize(5,null,p));u.setSelection(w)}$setVisible(p,w){const u=this.treeViews.get(p);if(!u)throw new Error(m.localize(6,null,p));u.setVisible(w)}createExtHostTreeView(p,w,u){const f=new c(p,w,this._proxy,this.commands.converter,this.logService,u);return this.treeViews.set(p,f),f}convertArgument(p){const w=this.treeViews.get(p.$treeViewId);return w?w.getExtensionElement(p.$treeItemHandle):null}}e.ExtHostTreeViews=d;class c extends k.Disposable{constructor(p,w,u,f,g,t){super();if(this.viewId=p,this.proxy=u,this.commands=f,this.logService=g,this.extension=t,this.roots=null,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._onDidExpandElement=this._register(new y.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new y.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new y.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeVisibility=this._register(new y.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeData=this._register(new y.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new o.CancellationTokenSource,t.contributes&&t.contributes.views)for(const r in t.contributes.views)for(const l of t.contributes.views[r])l.id===p&&(this._title=l.name);this.dataProvider=w.treeDataProvider,this.dndController=w.dragAndDropController,this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(r=>this._onDidChangeData.fire({message:!1,element:r})));let i,s;this._register(y.Event.debounce(this._onDidChangeData.event,(r,l)=>(r||(r={message:!1,elements:[]}),l.element!==!1&&(i||(i=new Promise(E=>s=E),this.refreshPromise=this.refreshPromise.then(()=>i)),r.elements.push(l.element)),l.message&&(r.message=!0),r),200,!0)(({message:r,elements:l})=>{l.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const E=s;return i=null,this.refresh(l).then(()=>E())})),r&&this.proxy.$setMessage(this.viewId,this._message)}))}get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(p=>this.getExtensionElement(p)).filter(p=>!C.isUndefinedOrNull(p))}getChildren(p){const w=p?this.getExtensionElement(p):void 0;if(p&&!w)return this.logService.error(`No tree item with id '${p}' found.`),Promise.resolve([]);const u=this.getChildrenNodes(p);return(u?Promise.resolve(u):this.fetchChildrenNodes(w)).then(f=>f.map(g=>g.item))}getExtensionElement(p){return this.elements.get(p)}reveal(p,w){w=w||{select:!0,focus:!1};const u=C.isUndefinedOrNull(w.select)?!0:w.select,f=C.isUndefinedOrNull(w.focus)?!1:w.focus,g=C.isUndefinedOrNull(w.expand)?!1:w.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):p?this.refreshPromise.then(()=>this.resolveUnknownParentChain(p)).then(t=>this.resolveTreeNode(p,t[t.length-1]).then(i=>this.proxy.$reveal(this.viewId,{item:i.item,parentChain:t.map(s=>s.item)},{select:u,focus:f,expand:g})),t=>this.logService.error(t)):this.proxy.$reveal(this.viewId,void 0,{select:u,focus:f,expand:g})}get message(){return this._message}set message(p){this._message=p,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(p){this._title=p,this.proxy.$setTitle(this.viewId,p,this._description)}get description(){return this._description}set description(p){this._description=p,this.proxy.$setTitle(this.viewId,this._title,p)}setExpanded(p,w){const u=this.getExtensionElement(p);u&&(w?this._onDidExpandElement.fire(Object.freeze({element:u})):this._onDidCollapseElement.fire(Object.freeze({element:u})))}setSelection(p){n.equals(this._selectedHandles,p)||(this._selectedHandles=p,this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})))}setVisible(p){p!==this._visible&&(this._visible=p,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}onDrop(p,w){const u=p.map(g=>this.getExtensionElement(g)).filter(g=>!C.isUndefinedOrNull(g)),f=this.getExtensionElement(w);return u&&f?D.asPromise(()=>{var g;return(g=this.dndController)===null||g===void 0?void 0:g.onDrop(u,f)}):Promise.resolve(void 0)}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(p,w){var u;if(!this.dataProvider.resolveTreeItem)return;const f=this.elements.get(p);if(f){const g=this.nodes.get(f);if(g){const t=(u=await this.dataProvider.resolveTreeItem(g.extensionItem,f,w))!==null&&u!==void 0?u:g.extensionItem;return g.item.tooltip=this.getTooltip(t.tooltip),g.item.command=this.getCommand(g.disposableStore,t.command),g.item}}}resolveUnknownParentChain(p){return this.resolveParent(p).then(w=>w?this.resolveUnknownParentChain(w).then(u=>this.resolveTreeNode(w,u[u.length-1]).then(f=>(u.push(f),u))):Promise.resolve([]))}resolveParent(p){const w=this.nodes.get(p);return w?Promise.resolve(w.parent?this.elements.get(w.parent.item.handle):void 0):D.asPromise(()=>this.dataProvider.getParent(p))}resolveTreeNode(p,w){const u=this.nodes.get(p);return u?Promise.resolve(u):D.asPromise(()=>this.dataProvider.getTreeItem(p)).then(f=>this.createHandle(p,f,w,!0)).then(f=>this.getChildren(w?w.item.handle:void 0).then(()=>{const g=this.getExtensionElement(f);if(g){const t=this.nodes.get(g);if(t)return Promise.resolve(t)}throw new Error(`Cannot resolve tree item for element ${f}`)}))}getChildrenNodes(p){if(p){let w;if(typeof p=="string"){const u=this.getExtensionElement(p);w=u?this.nodes.get(u):void 0}else w=p;return w&&w.children||null}return this.roots}async fetchChildrenNodes(p){this.clearChildren(p);const w=new o.CancellationTokenSource(this._refreshCancellationSource.token);try{const u=p?this.nodes.get(p):void 0,f=await this.dataProvider.getChildren(p);if(w.token.isCancellationRequested)return[];const g=await Promise.all(n.coalesce(f||[]).map(async t=>{const i=await this.dataProvider.getTreeItem(t);return i&&!w.token.isCancellationRequested?this.createAndRegisterTreeNode(t,i,u):null}));return w.token.isCancellationRequested?[]:n.coalesce(g)}finally{w.dispose()}}refresh(p){if(p.some(u=>!u))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new o.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const u=this.getHandlesToRefresh(p);if(u.length)return this.refreshHandles(u)}return Promise.resolve(void 0)}getHandlesToRefresh(p){const w=new Set,u=p.map(g=>this.nodes.get(g));for(const g of u)if(g&&!w.has(g.item.handle)){let t=g;for(;t&&t.parent&&u.findIndex(i=>t&&t.parent&&i&&i.item.handle===t.parent.item.handle)===-1;){const i=this.elements.get(t.parent.item.handle);t=i?this.nodes.get(i):void 0}t&&!t.parent&&w.add(g.item.handle)}const f=[];return w.forEach(g=>{const t=this.elements.get(g);if(t){const i=this.nodes.get(t);i&&(!i.parent||!w.has(i.parent.item.handle))&&f.push(g)}}),f}refreshHandles(p){const w={};return Promise.all(p.map(u=>this.refreshNode(u).then(f=>{f&&(w[u]=f.item)}))).then(()=>Object.keys(w).length?this.proxy.$refresh(this.viewId,w):void 0)}refreshNode(p){const w=this.getExtensionElement(p);if(w){const u=this.nodes.get(w);if(u)return this.clearChildren(w),D.asPromise(()=>this.dataProvider.getTreeItem(w)).then(f=>{if(f){const g=this.createTreeNode(w,f,u.parent);return this.updateNodeCache(w,g,u,u.parent),u.dispose(),g}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(p,w,u){const f=this.createTreeNode(p,w,u);if(w.id&&this.elements.has(f.item.handle))throw new Error(m.localize(7,null,w.id));return this.addNodeToCache(p,f),this.addNodeToParentCache(f,u),f}getTooltip(p){return _.MarkdownString.isMarkdownString(p)?I.MarkdownString.from(p):p}getCommand(p,w){return w?this.commands.toInternal(w,p):void 0}createTreeNode(p,w,u){const f=new k.DisposableStore,g=this.createHandle(p,w,u),t=this.getLightIconPath(w);return{item:{handle:g,parentHandle:u?u.item.handle:void 0,label:h(w.label,this.extension),description:w.description,resourceUri:w.resourceUri,tooltip:this.getTooltip(w.tooltip),command:this.getCommand(f,w.command),contextValue:w.contextValue,icon:t,iconDark:this.getDarkIconPath(w)||t,themeIcon:this.getThemeIcon(w),collapsibleState:C.isUndefinedOrNull(w.collapsibleState)?_.TreeItemCollapsibleState.None:w.collapsibleState,accessibilityInformation:w.accessibilityInformation},extensionItem:w,parent:u,children:void 0,disposableStore:f,dispose(){f.dispose()}}}getThemeIcon(p){return p.iconPath instanceof _.ThemeIcon?p.iconPath:void 0}createHandle(p,{id:w,label:u,resourceUri:f},g,t){if(w)return`${c.ID_HANDLE_PREFIX}/${w}`;const i=h(u,this.extension),s=g?g.item.handle:c.LABEL_HANDLE_PREFIX;let r=i?i.label:f?T.basename(f):"";r=r.indexOf("/")!==-1?r.replace("/","//"):r;const l=this.nodes.has(p)?this.nodes.get(p).item.handle:void 0,E=this.getChildrenNodes(g)||[];let v,A=0;do{if(v=`${s}/${A}:${r}`,t||!this.elements.has(v)||l===v)break;A++}while(A<=E.length);return v}getLightIconPath(p){if(p.iconPath&&!(p.iconPath instanceof _.ThemeIcon))return typeof p.iconPath=="string"||S.URI.isUri(p.iconPath)?this.getIconPath(p.iconPath):this.getIconPath(p.iconPath.light)}getDarkIconPath(p){if(p.iconPath&&!(p.iconPath instanceof _.ThemeIcon)&&p.iconPath.dark)return this.getIconPath(p.iconPath.dark)}getIconPath(p){return S.URI.isUri(p)?p:S.URI.file(p)}addNodeToCache(p,w){this.elements.set(w.item.handle,p),this.nodes.set(p,w)}updateNodeCache(p,w,u,f){this.elements.delete(w.item.handle),this.nodes.delete(p),w.item.handle!==u.item.handle&&this.elements.delete(u.item.handle),this.addNodeToCache(p,w);const g=this.getChildrenNodes(f)||[],t=g.filter(i=>i.item.handle===u.item.handle)[0];t&&g.splice(g.indexOf(t),1,w)}addNodeToParentCache(p,w){w?(w.children||(w.children=[]),w.children.push(p)):(this.roots||(this.roots=[]),this.roots.push(p))}clearChildren(p){if(p){const w=this.nodes.get(p);if(w){if(w.children)for(const u of w.children){const f=this.elements.get(u.item.handle);f&&this.clear(f)}w.children=void 0}}else this.clearAll()}clear(p){const w=this.nodes.get(p);if(w){if(w.children)for(const u of w.children){const f=this.elements.get(u.item.handle);f&&this.clear(f)}this.nodes.delete(p),this.elements.delete(w.item.handle),w.dispose()}}clearAll(){this.roots=null,this.elements.clear(),this.nodes.forEach(p=>p.dispose()),this.nodes.clear()}dispose(){this._refreshCancellationSource.dispose(),this.clearAll()}}c.LABEL_HANDLE_PREFIX="0",c.ID_HANDLE_PREFIX="1"}),define(_e[172],Ee([0,1,17,12,18,10,64,9,6,96]),function(Z,e,m,T,S,y,k,D,_,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SingleUseTestCollection=e.TestTree=e.TestPosition=e.OwnedTestCollection=void 0;class n{constructor(){this.testIdsToInternal=new Map}getTestById(b,p){if(p!==void 0){const w=this.testIdsToInternal.get(p),u=w==null?void 0:w.get(b);if(u)return[w,u]}return m.mapFind(this.testIdsToInternal.values(),w=>{const u=w.get(b);return u&&[w,u]})}createForHierarchy(b=()=>{}){return new d(this.createIdMap(o++),b)}createIdMap(b){const p=new h(b);return this.testIdsToInternal.set(p.id,p),{object:p,dispose:()=>this.testIdsToInternal.delete(p.id)}}}e.OwnedTestCollection=n;var I;(function(c){c[c.Disconnected=0]="Disconnected",c[c.IsChild=1]="IsChild",c[c.IsParent=2]="IsParent",c[c.IsSame=3]="IsSame"})(I=e.TestPosition||(e.TestPosition={}));let o=0;class h{constructor(b){this.id=b,this.map=new Map,this._roots=new Set,this.roots=this._roots}get size(){return this.map.size}add(b){if(this.map.has(b.item.extId))throw new Error(`Attempted to insert a duplicate test item ID ${b.item.extId}`);this.map.set(b.item.extId,b),b.parent||this._roots.add(b)}has(b){return this.map.has(b)}delete(b){const p=this.map.get(b);return p?(this.map.delete(b),this._roots.delete(p),!0):!1}get(b){return this.map.get(b)}comparePositions(b,p){const w=typeof b=="string"?this.map.get(b):b,u=typeof p=="string"?this.map.get(p):p;if(!w||!u)return 0;if(w===u)return 3;for(let f=this.map.get(u.parent);f;f=this.map.get(f.parent))if(f===w)return 1;for(let f=this.map.get(w.parent);f;f=this.map.get(f.parent))if(f===u)return 2;return 0}[Symbol.iterator](){return this.map.values()}}e.TestTree=h;class d{constructor(b,p){this.testIdToInternal=b,this.publishDiff=p,this.testItemToInternal=new Map,this.diff=[],this.debounceSendDiff=new T.RunOnceScheduler(()=>this.flushDiff(),200)}get treeId(){return this.testIdToInternal.object.id}addRoot(b,p){this.addItem(b,p,null)}getTestByReference(b){return this.testItemToInternal.get(b)}collectDiff(){const b=this.diff;return this.diff=[],b}pushDiff(b){const p=this.diff[this.diff.length-1];if(p&&b[0]===1){if(p[0]===1&&p[1].extId===b[1].extId){C.applyTestItemUpdate(p[1],b[1]);return}if(p[0]===0&&p[1].item.extId===b[1].extId){C.applyTestItemUpdate(p[1],b[1]);return}}this.diff.push(b),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(b,p){var w;const u=this.testIdToInternal.object.get(b);if(!!u){if((u.expandLevels===void 0||p>u.expandLevels)&&(u.expandLevels=p),u.expand===1){const f=this.refreshChildren(u);return f.isSettled?this.expandChildren(u,p-1):f.p.then(()=>this.expandChildren(u,p-1))}else if(u.expand===3)return((w=u.initialExpand)===null||w===void 0?void 0:w.isSettled)===!1?u.initialExpand.p.then(()=>this.expandChildren(u,p-1)):this.expandChildren(u,p-1)}}dispose(){var b;for(const p of this.testItemToInternal.values())(b=p.discoverCts)===null||b===void 0||b.dispose(!0),k.getPrivateApiFor(p.actual).bus.dispose();this.diff=[],this.testIdToInternal.dispose(),this.debounceSendDiff.dispose()}onTestItemEvent(b,p){const w=b==null?void 0:b.actual.id;switch(p[0]){case 2:this.pushDiff([4,w]);break;case 1:this.removeItem(b);break;case 0:this.addItem(p[1],b.src.controller,b);break;case 3:const[u,f,g]=p;switch(f){case"status":this.updateExpandability(b);break;case"range":this.pushDiff([1,{extId:w,item:{range:D.Range.from(g)}}]);break;case"error":this.pushDiff([1,{extId:w,item:{error:D.MarkdownString.fromStrict(g)||null}}]);break;default:this.pushDiff([1,{extId:w,item:{[f]:g??null}}]);break}break;default:y.assertNever(p[0])}}addItem(b,p,w){if(!(b instanceof _.TestItemImpl))throw new Error(`TestItems provided to the VS Code API must extend \`vscode.TestItem\`, but ${b.id} did not`);if(this.testItemToInternal.has(b))throw new Error(`Attempted to add a single TestItem ${b.id} multiple times to the tree`);if(this.testIdToInternal.object.has(b.id))throw new Error(`Attempted to insert a duplicate test item ID ${b.id}`);const u=w?w.item.extId:null,f=b.resolveHandler?1:0,g=w?w.expandLevels:1,t={controller:p,tree:this.testIdToInternal.object.id},i={actual:b,parent:u,item:D.TestItem.from(b),expandLevels:g?g-1:void 0,expand:0,src:t};this.testIdToInternal.object.add(i),this.testItemToInternal.set(b,i),this.pushDiff([0,{parent:u,src:t,expand:f,item:i.item}]);const s=k.getPrivateApiFor(b);s.parent=w==null?void 0:w.actual,s.bus.event(this.onTestItemEvent.bind(this,i)),this.updateExpandability(i);for(const r of s.children.values())this.testItemToInternal.has(r)||this.addItem(r,p,i)}updateExpandability(b){var p;let w;b.actual.resolveHandler?b.actual.status===_.TestItemStatus.Pending?w=b.discoverCts?2:1:((p=b.initialExpand)===null||p===void 0||p.complete(),w=3):w=0,w!==b.expand&&(b.expand=w,this.pushDiff([1,{extId:b.actual.id,expand:w}]),w===1&&b.expandLevels!==void 0&&this.refreshChildren(b))}expandChildren(b,p){if(p<0)return;const w=[...b.actual.children.values()].map(u=>this.expand(u.id,p)).filter(T.isThenable);if(w.length)return Promise.all(w).then(()=>{})}refreshChildren(b){if(b.discoverCts&&b.discoverCts.dispose(!0),!b.actual.resolveHandler){const p=new T.DeferredPromise;return p.complete(),p}return b.expand=2,b.discoverCts=new S.CancellationTokenSource,this.pushExpandStateUpdate(b),b.initialExpand=new T.DeferredPromise,b.actual.resolveHandler(b.discoverCts.token),b.initialExpand}pushExpandStateUpdate(b){this.pushDiff([1,{extId:b.actual.id,expand:b.expand}])}removeItem(b){var p;this.pushDiff([2,b.actual.id]);const w=[b];for(;w.length;){const u=w.pop();if(!!u){(p=u.discoverCts)===null||p===void 0||p.dispose(!0),this.testIdToInternal.object.delete(u.item.extId),this.testItemToInternal.delete(u.actual);for(const f of u.actual.children.values())w.push(this.testIdToInternal.object.get(f.id))}}}flushDiff(){const b=this.collectDiff();b.length&&this.publishDiff(b)}}e.SingleUseTestCollection=d}),define(_e[173],Ee([0,1,5,144]),function(Z,e,m,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=m.refineServiceDecorator(T.IEnvironmentService)}),define(_e[174],Ee([0,1,26,3,14]),function(Z,e,m,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class y{constructor(n){this.removedDueToLooping=n}}e.DeltaExtensionsResult=y;class k{constructor(n){this._onDidChange=new T.Emitter,this.onDidChange=this._onDidChange.event,this._extensionDescriptions=n,this._initialize()}_initialize(){this._extensionDescriptions.sort(_),this._extensionsMap=new Map,this._extensionsArr=[],this._activationMap=new Map;for(const n of this._extensionDescriptions){if(this._extensionsMap.has(m.ExtensionIdentifier.toKey(n.identifier))){console.error("Extension `"+n.identifier.value+"` is already registered");continue}if(this._extensionsMap.set(m.ExtensionIdentifier.toKey(n.identifier),n),this._extensionsArr.push(n),Array.isArray(n.activationEvents))for(let I of n.activationEvents)I==="onUri"&&(I=`onUri:${m.ExtensionIdentifier.toKey(n.identifier)}`),this._activationMap.has(I)||this._activationMap.set(I,[]),this._activationMap.get(I).push(n)}}keepOnly(n){const I=new Set;n.forEach(o=>I.add(m.ExtensionIdentifier.toKey(o))),this._extensionDescriptions=this._extensionDescriptions.filter(o=>I.has(m.ExtensionIdentifier.toKey(o.identifier))),this._initialize(),this._onDidChange.fire(void 0)}deltaExtensions(n,I){n.length>0&&(this._extensionDescriptions=this._extensionDescriptions.concat(n));const o=k._findLoopingExtensions(this._extensionDescriptions);if(I=I.concat(o.map(h=>h.identifier)),I.length>0){const h=new Set;I.forEach(d=>h.add(m.ExtensionIdentifier.toKey(d))),this._extensionDescriptions=this._extensionDescriptions.filter(d=>!h.has(m.ExtensionIdentifier.toKey(d.identifier)))}return this._initialize(),this._onDidChange.fire(void 0),new y(o)}static _findLoopingExtensions(n){const I=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(b){this._nodesSet.has(b)||(this._nodesSet.add(b),this._nodesArr.push(b))}addArc(b,p){this.addNode(b),this.addNode(p),this._arcs.has(b)?this._arcs.get(b).push(p):this._arcs.set(b,[p])}getArcs(b){return this._arcs.has(b)?this._arcs.get(b):[]}hasOnlyGoodArcs(b,p){const w=I.getArcs(b);for(let u=0;u<w.length;u++)if(!p.has(w[u]))return!1;return!0}getNodes(){return this._nodesArr}};let o=new Map;for(let b of n){const p=m.ExtensionIdentifier.toKey(b.identifier);if(o.set(p,b),b.extensionDependencies)for(let w of b.extensionDependencies){const u=m.ExtensionIdentifier.toKey(w);I.addArc(p,u)}}let h=new Set;I.getNodes().filter(b=>I.getArcs(b).length===0).forEach(b=>h.add(b));let d=I.getNodes().filter(b=>!h.has(b)),c;do{c=!1;for(let b=0;b<d.length;b++){const p=d[b];I.hasOnlyGoodArcs(p,h)&&(d.splice(b,1),b--,h.add(p),c=!0)}}while(c);return d.map(b=>o.get(b))}containsActivationEvent(n){return this._activationMap.has(n)}containsExtension(n){return this._extensionsMap.has(m.ExtensionIdentifier.toKey(n))}getExtensionDescriptionsForActivationEvent(n){const I=this._activationMap.get(n);return I?I.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getExtensionDescription(n){const I=this._extensionsMap.get(m.ExtensionIdentifier.toKey(n));return I||void 0}}e.ExtensionDescriptionRegistry=k;var D;(function(C){C[C.Builtin=0]="Builtin",C[C.User=1]="User",C[C.Dev=2]="Dev"})(D||(D={}));function _(C,n){const I=C.isBuiltin?0:C.isUnderDevelopment?2:1,o=n.isBuiltin?0:n.isUnderDevelopment?2:1;if(I!==o)return I-o;const h=S.posix.basename(C.extensionLocation.path),d=S.posix.basename(n.extensionLocation.path);return h<d?-1:h>d?1:0}}),define(_e[175],Ee([0,1,23]),function(Z,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=void 0;var T;(function(D){D[D.VersionMismatch=55]="VersionMismatch",D[D.UnexpectedError=81]="UnexpectedError"})(T=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var S;(function(D){D[D.Initialized=0]="Initialized",D[D.Ready=1]="Ready",D[D.Terminate=2]="Terminate"})(S=e.MessageType||(e.MessageType={}));function y(D){const _=m.VSBuffer.alloc(1);switch(D){case 0:_.writeUInt8(1,0);break;case 1:_.writeUInt8(2,0);break;case 2:_.writeUInt8(3,0);break}return _}e.createMessageOfType=y;function k(D,_){if(D.byteLength!==1)return!1;switch(D.readUInt8(0)){case 1:return _===0;case 2:return _===1;case 3:return _===2;default:return!1}}e.isMessageOfType=k}),define(_e[29],Ee([0,1,3,2,5,26,145]),function(Z,e,m,T,S,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.throwProposedApiError=e.checkProposedApiEnabled=e.ActivationKind=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.ExtensionHostKind=e.MissingExtensionDependency=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new y.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",enableProposedApi:!1,engines:{vscode:""},extensionLocation:T.URI.parse("void:location"),isBuiltin:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=S.createDecorator("extensionService");class D{constructor(w){this.dependency=w}}e.MissingExtensionDependency=D;var _;(function(p){p[p.LocalProcess=0]="LocalProcess",p[p.LocalWebWorker=1]="LocalWebWorker",p[p.Remote=2]="Remote"})(_=e.ExtensionHostKind||(e.ExtensionHostKind={}));class C{constructor(w,u,f,g){this.codeLoadingTime=w,this.activateCallTime=u,this.activateResolvedTime=f,this.activationReason=g}}e.ActivationTimes=C;class n{constructor(w,u){this.description=w,this.value=u}}e.ExtensionPointContribution=n,e.ExtensionHostLogFileName="exthost";var I;(function(p){p[p.Normal=0]="Normal",p[p.Immediate=1]="Immediate"})(I=e.ActivationKind||(e.ActivationKind={}));function o(p){p.enableProposedApi||h(p)}e.checkProposedApiEnabled=o;function h(p){throw new Error(`[${p.identifier.value}]: Proposed API is only available when running out of dev or with the following command line switch: --enable-proposed-api ${p.identifier.value}`)}e.throwProposedApiError=h;function d(p){return{type:p.isBuiltin?0:1,isBuiltin:p.isBuiltin||p.isUserBuiltin,identifier:{id:k.getGalleryExtensionId(p.publisher,p.name),uuid:p.uuid},manifest:p,location:p.extensionLocation}}e.toExtension=d;function c(p){return Object.assign(Object.assign({identifier:new y.ExtensionIdentifier(p.identifier.id),isBuiltin:p.type===0,isUserBuiltin:p.type===1&&p.isBuiltin,isUnderDevelopment:!1,extensionLocation:p.location},p.manifest),{uuid:p.identifier.uuid})}e.toExtensionDescription=c;class b{constructor(){this.onDidRegisterExtensions=m.Event.None,this.onDidChangeExtensionsStatus=m.Event.None,this.onDidChangeExtensions=m.Event.None,this.onWillActivateByEvent=m.Event.None,this.onDidChangeResponsiveChange=m.Event.None}activateByEvent(w){return Promise.resolve(void 0)}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtensions(){return Promise.resolve([])}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(w){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(w){return Promise.resolve(0)}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(w){}canAddExtension(){return!1}canRemoveExtension(){return!1}_activateById(w,u){return Promise.resolve()}_onWillActivateExtension(w){}_onDidActivateExtension(w,u,f,g,t){}_onDidActivateExtensionError(w,u){}_onExtensionRuntimeError(w,u){}_onExtensionHostExit(w){}}e.NullExtensionService=b}),define(_e[176],Ee([0,1,26,29,15]),function(Z,e,m,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.FailedExtension=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;const y=Promise.resolve(void 0);class k{constructor(d,c,b,p){this.startup=d,this.codeLoadingTime=c,this.activateCallTime=b,this.activateResolvedTime=p}}e.ExtensionActivationTimes=k,k.NONE=new k(!1,-1,-1,-1);class D{constructor(d){this._startup=d,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(d,c){return d===-1||c===-1?-1:c-d}build(){return new k(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=D;class _{constructor(d,c,b,p,w,u){this.activationFailed=d,this.activationFailedError=c,this.activationTimes=b,this.module=p,this.exports=w,this.subscriptions=u}}e.ActivatedExtension=_;class C extends _{constructor(d){super(!1,null,d,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=C;class n extends _{constructor(){super(!1,null,k.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=n;class I extends _{constructor(d){super(!0,d,k.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.FailedExtension=I;let o=class{constructor(d,c,b,p,w){this._logService=w,this._registry=d,this._resolvedExtensionsSet=new Set,c.forEach(u=>this._resolvedExtensionsSet.add(m.ExtensionIdentifier.toKey(u))),this._hostExtensionsMap=new Map,b.forEach(u=>this._hostExtensionsMap.set(m.ExtensionIdentifier.toKey(u),u)),this._host=p,this._activatingExtensions=new Map,this._activatedExtensions=new Map,this._alreadyActivatedEvents=Object.create(null)}isActivated(d){const c=m.ExtensionIdentifier.toKey(d);return this._activatedExtensions.has(c)}getActivatedExtension(d){const c=m.ExtensionIdentifier.toKey(d),b=this._activatedExtensions.get(c);if(!b)throw new Error("Extension `"+d.value+"` is not known or not activated");return b}activateByEvent(d,c){if(this._alreadyActivatedEvents[d])return y;const b=this._registry.getExtensionDescriptionsForActivationEvent(d);return this._activateExtensions(b.map(p=>({id:p.identifier,reason:{startup:c,extensionId:p.identifier,activationEvent:d}}))).then(()=>{this._alreadyActivatedEvents[d]=!0})}activateById(d,c){const b=this._registry.getExtensionDescription(d);if(!b)throw new Error("Extension `"+d+"` is not known");return this._activateExtensions([{id:b.identifier,reason:c}])}_handleActivateRequest(d,c,b){if(this._hostExtensionsMap.has(m.ExtensionIdentifier.toKey(d.id))){c[m.ExtensionIdentifier.toKey(d.id)]=d;return}const p=this._registry.getExtensionDescription(d.id);if(!p){const f=new Error(`Cannot activate unknown extension '${d.id.value}'`);this._host.onExtensionActivationError(d.id,f,new T.MissingExtensionDependency(d.id.value)),this._activatedExtensions.set(m.ExtensionIdentifier.toKey(d.id),new I(f));return}const w=typeof p.extensionDependencies=="undefined"?[]:p.extensionDependencies;let u=!0;for(let f=0,g=w.length;f<g;f++){const t=w[f];if(this._resolvedExtensionsSet.has(m.ExtensionIdentifier.toKey(t)))continue;const i=this._activatedExtensions.get(m.ExtensionIdentifier.toKey(t));if(i&&!i.activationFailed)continue;if(i&&i.activationFailed){const E=p.displayName||p.identifier.value,v=this._registry.getExtensionDescription(t),A=v&&v.displayName||t,P=new Error(`Cannot activate the '${E}' extension because its dependency '${A}' failed to activate`);P.detail=i.activationFailedError,this._host.onExtensionActivationError(p.identifier,P,null),this._activatedExtensions.set(m.ExtensionIdentifier.toKey(p.identifier),new I(P));return}if(this._hostExtensionsMap.has(m.ExtensionIdentifier.toKey(t))){u=!1,c[m.ExtensionIdentifier.toKey(t)]={id:this._hostExtensionsMap.get(m.ExtensionIdentifier.toKey(t)),reason:d.reason};continue}const s=this._registry.getExtensionDescription(t);if(s){u=!1,c[m.ExtensionIdentifier.toKey(t)]={id:s.identifier,reason:d.reason};continue}const r=p.displayName||p.identifier.value,l=new Error(`Cannot activate the '${r}' extension because it depends on unknown extension '${t}'`);this._host.onExtensionActivationError(p.identifier,l,new T.MissingExtensionDependency(t)),this._activatedExtensions.set(m.ExtensionIdentifier.toKey(p.identifier),new I(l));return}u?c[m.ExtensionIdentifier.toKey(p.identifier)]=d:b.push(d)}_activateExtensions(d){if(d.length===0||(d=d.filter(w=>!this._activatedExtensions.has(m.ExtensionIdentifier.toKey(w.id))),d.length===0))return Promise.resolve(void 0);const c=Object.create(null),b=[];for(let w=0,u=d.length;w<u;w++)this._handleActivateRequest(d[w],c,b);for(let w=0,u=b.length;w<u;w++){const f=m.ExtensionIdentifier.toKey(b[w].id);c[f]&&delete c[f]}const p=Object.keys(c).map(w=>c[w]);return b.length===0?Promise.all(p.map(w=>this._activateExtension(w.id,w.reason))).then(w=>{}):this._activateExtensions(p).then(w=>this._activateExtensions(b))}_activateExtension(d,c){const b=m.ExtensionIdentifier.toKey(d);if(this._activatedExtensions.has(b))return Promise.resolve(void 0);const p=this._activatingExtensions.get(b);if(p)return p;const w=this._host.actualActivateExtension(d,c).then(void 0,u=>{const f=new Error;return u&&u.name&&(f.name=u.name),u&&u.message?f.message=`Activating extension '${d.value}' failed: ${u.message}.`:f.message=`Activating extension '${d.value}' failed: ${u}.`,u&&u.stack&&(f.stack=u.stack),this._host.onExtensionActivationError(d,f,null),this._logService.error(`Activating extension ${d.value} failed due to an error:`),this._logService.error(u),new I(u)}).then(u=>{this._activatedExtensions.set(b,u),this._activatingExtensions.delete(b)});return this._activatingExtensions.set(b,w),w}};o=He([ze(4,S.ILogService)],o),e.ExtensionsActivator=o}),define(_e[177],Ee([0,1,11]),function(Z,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LazyPromise=void 0;class T{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((y,k)=>{this._actualOk=y,this._actualErr=k,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(y){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=y,this._actual&&this._actualOk(y))}resolveErr(y){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=y,this._actual?this._actualErr(y):m.onUnexpectedError(y))}then(y,k){return this._ensureActual().then(y,k)}catch(y){return this._ensureActual().then(void 0,y)}finally(y){return this._ensureActual().finally(y)}}e.LazyPromise=T}),define(_e[99],Ee([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getStringIdentifierForProxy=e.createExtHostContextProxyIdentifier=e.createMainContextProxyIdentifier=e.ProxyIdentifier=void 0;class m{constructor(_,C){this.isMain=_,this.sid=C,this.nid=++m.count}}e.ProxyIdentifier=m,m.count=0;const T=[];function S(D){const _=new m(!0,D);return T[_.nid]=_,_}e.createMainContextProxyIdentifier=S;function y(D){const _=new m(!1,D);return T[_.nid]=_,_}e.createExtHostContextProxyIdentifier=y;function k(D){return T[D].sid}e.getStringIdentifierForProxy=k}),define(_e[4],Ee([0,1,54,2,99]),function(Z,e,m,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.reviveWorkspaceEditDto=e.WorkspaceEditType=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.ObjectIdentifier=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TextEditorRevealType=e.UIKind=void 0;var y;(function(u){u[u.Desktop=1]="Desktop",u[u.Web=2]="Web"})(y=e.UIKind||(e.UIKind={}));var k;(function(u){u[u.Default=0]="Default",u[u.InCenter=1]="InCenter",u[u.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",u[u.AtTop=3]="AtTop"})(k=e.TextEditorRevealType||(e.TextEditorRevealType={}));var D;(function(u){u[u.Editable=0]="Editable",u[u.SupportsHotExit=1]="SupportsHotExit"})(D=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var _;(function(u){u[u.Int8Array=1]="Int8Array",u[u.Uint8Array=2]="Uint8Array",u[u.Uint8ClampedArray=3]="Uint8ClampedArray",u[u.Int16Array=4]="Int16Array",u[u.Uint16Array=5]="Uint16Array",u[u.Int32Array=6]="Int32Array",u[u.Uint32Array=7]="Uint32Array",u[u.Float32Array=8]="Float32Array",u[u.Float64Array=9]="Float64Array",u[u.BigInt64Array=10]="BigInt64Array",u[u.BigUint64Array=11]="BigUint64Array"})(_=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var C;(function(u){u[u.Text=1]="Text",u[u.Error=2]="Error",u[u.Rich=3]="Rich"})(C=e.CellOutputKind||(e.CellOutputKind={}));var n;(function(u){u[u.Default=0]="Default",u[u.InCenter=1]="InCenter",u[u.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",u[u.AtTop=3]="AtTop"})(n=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var I;(function(u){u[u.None=0]="None",u[u.Process=1]="Process",u[u.Output=2]="Output"})(I=e.CandidatePortSource||(e.CandidatePortSource={}));var o;(function(u){u.name="$ident";function f(t,i){return Object.defineProperty(t,u.name,{value:i,enumerable:!0}),t}u.mixin=f;function g(t){return t[u.name]}u.of=g})(o=e.ObjectIdentifier||(e.ObjectIdentifier={}));class h{static mixin(f){return f._id=h._n++,f}}e.IdObject=h,h._n=0;var d;(function(u){u.label="a",u.kind="b",u.detail="c",u.documentation="d",u.sortText="e",u.filterText="f",u.preselect="g",u.insertText="h",u.insertTextRules="i",u.range="j",u.commitCharacters="k",u.additionalTextEdits="l",u.command="m",u.kindModifier="n",u.label2="o"})(d=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var c;(function(u){u.defaultRanges="a",u.completions="b",u.isIncomplete="c",u.duration="d"})(c=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var b;(function(u){u[u.File=1]="File",u[u.Text=2]="Text",u[u.Cell=3]="Cell"})(b=e.WorkspaceEditType||(e.WorkspaceEditType={}));function p(u){if(u&&u.edits)for(const f of u.edits)typeof f.resource=="object"?f.resource=T.URI.revive(f.resource):(f.newUri=T.URI.revive(f.newUri),f.oldUri=T.URI.revive(f.oldUri)),f.metadata&&f.metadata.iconPath&&(f.metadata=m.revive(f.metadata));return u}e.reviveWorkspaceEditDto=p;var w;(function(u){u[u.Workspace=0]="Workspace",u[u.TextDocument=1]="TextDocument"})(w=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:S.createMainContextProxyIdentifier("MainThreadAuthentication"),MainThreadBulkEdits:S.createMainContextProxyIdentifier("MainThreadBulkEdits"),MainThreadClipboard:S.createMainContextProxyIdentifier("MainThreadClipboard"),MainThreadCommands:S.createMainContextProxyIdentifier("MainThreadCommands"),MainThreadComments:S.createMainContextProxyIdentifier("MainThreadComments"),MainThreadConfiguration:S.createMainContextProxyIdentifier("MainThreadConfiguration"),MainThreadConsole:S.createMainContextProxyIdentifier("MainThreadConsole"),MainThreadDebugService:S.createMainContextProxyIdentifier("MainThreadDebugService"),MainThreadDecorations:S.createMainContextProxyIdentifier("MainThreadDecorations"),MainThreadDiagnostics:S.createMainContextProxyIdentifier("MainThreadDiagnostics"),MainThreadDialogs:S.createMainContextProxyIdentifier("MainThreadDiaglogs"),MainThreadDocuments:S.createMainContextProxyIdentifier("MainThreadDocuments"),MainThreadDocumentContentProviders:S.createMainContextProxyIdentifier("MainThreadDocumentContentProviders"),MainThreadTextEditors:S.createMainContextProxyIdentifier("MainThreadTextEditors"),MainThreadEditorInsets:S.createMainContextProxyIdentifier("MainThreadEditorInsets"),MainThreadEditorTabs:S.createMainContextProxyIdentifier("MainThreadEditorTabs"),MainThreadErrors:S.createMainContextProxyIdentifier("MainThreadErrors"),MainThreadTreeViews:S.createMainContextProxyIdentifier("MainThreadTreeViews"),MainThreadDownloadService:S.createMainContextProxyIdentifier("MainThreadDownloadService"),MainThreadKeytar:S.createMainContextProxyIdentifier("MainThreadKeytar"),MainThreadLanguageFeatures:S.createMainContextProxyIdentifier("MainThreadLanguageFeatures"),MainThreadLanguages:S.createMainContextProxyIdentifier("MainThreadLanguages"),MainThreadLog:S.createMainContextProxyIdentifier("MainThread"),MainThreadMessageService:S.createMainContextProxyIdentifier("MainThreadMessageService"),MainThreadOutputService:S.createMainContextProxyIdentifier("MainThreadOutputService"),MainThreadProgress:S.createMainContextProxyIdentifier("MainThreadProgress"),MainThreadQuickOpen:S.createMainContextProxyIdentifier("MainThreadQuickOpen"),MainThreadStatusBar:S.createMainContextProxyIdentifier("MainThreadStatusBar"),MainThreadSecretState:S.createMainContextProxyIdentifier("MainThreadSecretState"),MainThreadStorage:S.createMainContextProxyIdentifier("MainThreadStorage"),MainThreadTelemetry:S.createMainContextProxyIdentifier("MainThreadTelemetry"),MainThreadTerminalService:S.createMainContextProxyIdentifier("MainThreadTerminalService"),MainThreadWebviews:S.createMainContextProxyIdentifier("MainThreadWebviews"),MainThreadWebviewPanels:S.createMainContextProxyIdentifier("MainThreadWebviewPanels"),MainThreadWebviewViews:S.createMainContextProxyIdentifier("MainThreadWebviewViews"),MainThreadCustomEditors:S.createMainContextProxyIdentifier("MainThreadCustomEditors"),MainThreadUrls:S.createMainContextProxyIdentifier("MainThreadUrls"),MainThreadUriOpeners:S.createMainContextProxyIdentifier("MainThreadUriOpeners"),MainThreadWorkspace:S.createMainContextProxyIdentifier("MainThreadWorkspace"),MainThreadFileSystem:S.createMainContextProxyIdentifier("MainThreadFileSystem"),MainThreadExtensionService:S.createMainContextProxyIdentifier("MainThreadExtensionService"),MainThreadSCM:S.createMainContextProxyIdentifier("MainThreadSCM"),MainThreadSearch:S.createMainContextProxyIdentifier("MainThreadSearch"),MainThreadTask:S.createMainContextProxyIdentifier("MainThreadTask"),MainThreadWindow:S.createMainContextProxyIdentifier("MainThreadWindow"),MainThreadLabelService:S.createMainContextProxyIdentifier("MainThreadLabelService"),MainThreadNotebook:S.createMainContextProxyIdentifier("MainThreadNotebook"),MainThreadNotebookDocuments:S.createMainContextProxyIdentifier("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:S.createMainContextProxyIdentifier("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:S.createMainContextProxyIdentifier("MainThreadNotebookKernels"),MainThreadNotebookRenderers:S.createMainContextProxyIdentifier("MainThreadNotebookRenderers"),MainThreadTheming:S.createMainContextProxyIdentifier("MainThreadTheming"),MainThreadTunnelService:S.createMainContextProxyIdentifier("MainThreadTunnelService"),MainThreadTimeline:S.createMainContextProxyIdentifier("MainThreadTimeline"),MainThreadTesting:S.createMainContextProxyIdentifier("MainThreadTesting")},e.ExtHostContext={ExtHostCommands:S.createExtHostContextProxyIdentifier("ExtHostCommands"),ExtHostConfiguration:S.createExtHostContextProxyIdentifier("ExtHostConfiguration"),ExtHostDiagnostics:S.createExtHostContextProxyIdentifier("ExtHostDiagnostics"),ExtHostDebugService:S.createExtHostContextProxyIdentifier("ExtHostDebugService"),ExtHostDecorations:S.createExtHostContextProxyIdentifier("ExtHostDecorations"),ExtHostDocumentsAndEditors:S.createExtHostContextProxyIdentifier("ExtHostDocumentsAndEditors"),ExtHostDocuments:S.createExtHostContextProxyIdentifier("ExtHostDocuments"),ExtHostDocumentContentProviders:S.createExtHostContextProxyIdentifier("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:S.createExtHostContextProxyIdentifier("ExtHostDocumentSaveParticipant"),ExtHostEditors:S.createExtHostContextProxyIdentifier("ExtHostEditors"),ExtHostTreeViews:S.createExtHostContextProxyIdentifier("ExtHostTreeViews"),ExtHostFileSystem:S.createExtHostContextProxyIdentifier("ExtHostFileSystem"),ExtHostFileSystemInfo:S.createExtHostContextProxyIdentifier("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:S.createExtHostContextProxyIdentifier("ExtHostFileSystemEventService"),ExtHostLanguageFeatures:S.createExtHostContextProxyIdentifier("ExtHostLanguageFeatures"),ExtHostQuickOpen:S.createExtHostContextProxyIdentifier("ExtHostQuickOpen"),ExtHostExtensionService:S.createExtHostContextProxyIdentifier("ExtHostExtensionService"),ExtHostLogService:S.createExtHostContextProxyIdentifier("ExtHostLogService"),ExtHostTerminalService:S.createExtHostContextProxyIdentifier("ExtHostTerminalService"),ExtHostSCM:S.createExtHostContextProxyIdentifier("ExtHostSCM"),ExtHostSearch:S.createExtHostContextProxyIdentifier("ExtHostSearch"),ExtHostTask:S.createExtHostContextProxyIdentifier("ExtHostTask"),ExtHostWorkspace:S.createExtHostContextProxyIdentifier("ExtHostWorkspace"),ExtHostWindow:S.createExtHostContextProxyIdentifier("ExtHostWindow"),ExtHostWebviews:S.createExtHostContextProxyIdentifier("ExtHostWebviews"),ExtHostWebviewPanels:S.createExtHostContextProxyIdentifier("ExtHostWebviewPanels"),ExtHostCustomEditors:S.createExtHostContextProxyIdentifier("ExtHostCustomEditors"),ExtHostWebviewViews:S.createExtHostContextProxyIdentifier("ExtHostWebviewViews"),ExtHostEditorInsets:S.createExtHostContextProxyIdentifier("ExtHostEditorInsets"),ExtHostEditorTabs:S.createExtHostContextProxyIdentifier("ExtHostEditorTabs"),ExtHostProgress:S.createMainContextProxyIdentifier("ExtHostProgress"),ExtHostComments:S.createMainContextProxyIdentifier("ExtHostComments"),ExtHostSecretState:S.createMainContextProxyIdentifier("ExtHostSecretState"),ExtHostStorage:S.createMainContextProxyIdentifier("ExtHostStorage"),ExtHostUrls:S.createExtHostContextProxyIdentifier("ExtHostUrls"),ExtHostUriOpeners:S.createExtHostContextProxyIdentifier("ExtHostUriOpeners"),ExtHostOutputService:S.createMainContextProxyIdentifier("ExtHostOutputService"),ExtHosLabelService:S.createMainContextProxyIdentifier("ExtHostLabelService"),ExtHostNotebook:S.createMainContextProxyIdentifier("ExtHostNotebook"),ExtHostNotebookDocuments:S.createMainContextProxyIdentifier("ExtHostNotebookDocuments"),ExtHostNotebookEditors:S.createMainContextProxyIdentifier("ExtHostNotebookEditors"),ExtHostNotebookKernels:S.createMainContextProxyIdentifier("ExtHostNotebookKernels"),ExtHostNotebookRenderers:S.createMainContextProxyIdentifier("ExtHostNotebookRenderers"),ExtHostTheming:S.createMainContextProxyIdentifier("ExtHostTheming"),ExtHostTunnelService:S.createMainContextProxyIdentifier("ExtHostTunnelService"),ExtHostAuthentication:S.createMainContextProxyIdentifier("ExtHostAuthentication"),ExtHostTimeline:S.createMainContextProxyIdentifier("ExtHostTimeline"),ExtHostTesting:S.createMainContextProxyIdentifier("ExtHostTesting"),ExtHostTelemetry:S.createMainContextProxyIdentifier("ExtHostTelemetry")}}),define(_e[69],Ee([0,1,4,3,5]),function(Z,e,m,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class y{constructor(D){this._onDidChangePassword=new T.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=D.getProxy(m.MainContext.MainThreadSecretState)}async $onDidChangePassword(D){this._onDidChangePassword.fire(D)}get(D,_){return this._proxy.$getPassword(D,_)}store(D,_,C){return this._proxy.$setPassword(D,_,C)}delete(D,_){return this._proxy.$deletePassword(D,_)}}e.ExtHostSecretState=y,e.IExtHostSecretState=S.createDecorator("IExtHostSecretState")}),define(_e[70],Ee([0,1,5,15,4,13]),function(Z,e,m,T,S,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=m.createDecorator("IExtHostApiDeprecationService");let k=class{constructor(_,C){this._extHostLogService=C,this._reportedUsages=new Set,this._telemetryShape=_.getProxy(S.MainContext.MainThreadTelemetry)}report(_,C,n){const I=this.getUsageKey(_,C);this._reportedUsages.has(I)||(this._reportedUsages.add(I),C.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${_}' is deprecated. ${n}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:C.identifier.value,apiId:_}))}getUsageKey(_,C){return`${_}-${C.identifier.value}`}};k=He([ze(0,y.IExtHostRpcService),ze(1,T.ILogService)],k),e.ExtHostApiDeprecationService=k,e.NullApiDeprecationService=Object.freeze(new class{report(D,_,C){}})}),define(_e[178],Ee([0,1,3,4,6,26]),function(Z,e,m,T,S,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class k{constructor(_){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeAuthenticationProviders=new m.Emitter,this.onDidChangeAuthenticationProviders=this._onDidChangeAuthenticationProviders.event,this._onDidChangeSessions=new m.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._inFlightRequests=new Map,this._proxy=_.getProxy(T.MainContext.MainThreadAuthentication)}$setProviders(_){return this._providers=_,Promise.resolve()}get providers(){return Object.freeze(this._providers.slice())}async getSession(_,C,n,I={}){const o=y.ExtensionIdentifier.toKey(_.identifier),h=this._inFlightRequests.get(o)||[],d=[...n].sort().join(" ");let c=h.find(b=>b.scopes===d);if(c)return c.result;{const b=this._getSession(_,o,C,n,I);c={scopes:d,result:b},h.push(c),this._inFlightRequests.set(o,h);try{await b}finally{const p=h.findIndex(w=>w.scopes===d);p>-1&&(h.splice(p),this._inFlightRequests.set(o,h))}return b}}async _getSession(_,C,n,I,o={}){await this._proxy.$ensureProvider(n);const h=_.displayName||_.name;return this._proxy.$getSession(n,I,C,h,o)}async removeSession(_,C){const n=this._authenticationProviders.get(_);return n?n.provider.removeSession(C):this._proxy.$removeSession(_,C)}registerAuthenticationProvider(_,C,n,I){var o;if(this._authenticationProviders.get(_))throw new Error(`An authentication provider with id '${_}' is already registered.`);this._authenticationProviders.set(_,{label:C,provider:n,options:I??{supportsMultipleAccounts:!1}}),this._providers.find(d=>d.id===_)||this._providers.push({id:_,label:C});const h=n.onDidChangeSessions(d=>{var c,b,p;this._proxy.$sendDidChangeSessions(_,{added:(c=d.added)!==null&&c!==void 0?c:[],changed:(b=d.changed)!==null&&b!==void 0?b:[],removed:(p=d.removed)!==null&&p!==void 0?p:[]})});return this._proxy.$registerAuthenticationProvider(_,C,(o=I==null?void 0:I.supportsMultipleAccounts)!==null&&o!==void 0?o:!1),new S.Disposable(()=>{h.dispose(),this._authenticationProviders.delete(_);const d=this._providers.findIndex(c=>c.id===_);d>-1&&this._providers.splice(d),this._proxy.$unregisterAuthenticationProvider(_)})}$createSession(_,C){const n=this._authenticationProviders.get(_);if(n)return Promise.resolve(n.provider.createSession(C));throw new Error(`Unable to find authentication provider with handle: ${_}`)}$removeSession(_,C){const n=this._authenticationProviders.get(_);if(n)return Promise.resolve(n.provider.removeSession(C));throw new Error(`Unable to find authentication provider with handle: ${_}`)}$getSessions(_,C){const n=this._authenticationProviders.get(_);if(n)return Promise.resolve(n.provider.getSessions(C));throw new Error(`Unable to find authentication provider with handle: ${_}`)}$onDidChangeAuthenticationSessions(_,C){return this._onDidChangeSessions.fire({provider:{id:_,label:C}}),Promise.resolve()}$onDidChangeAuthenticationProviders(_,C){return _.forEach(n=>{this._providers.some(I=>I.id===n.id)||this._providers.push(n)}),C.forEach(n=>{const I=this._providers.findIndex(o=>o.id===n.id);I>-1&&this._providers.splice(I)}),this._onDidChangeAuthenticationProviders.fire({added:_,removed:C}),Promise.resolve()}}e.ExtHostAuthentication=k}),define(_e[179],Ee([0,1,4,13,9]),function(Z,e,m,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let y=class{constructor(D,_){this._extHostDocumentsAndEditors=_,this._proxy=D.getProxy(m.MainContext.MainThreadBulkEdits)}applyWorkspaceEdit(D){const _=S.WorkspaceEdit.from(D,this._extHostDocumentsAndEditors);return this._proxy.$tryApplyWorkspaceEdit(_)}};y=He([ze(0,T.IExtHostRpcService)],y),e.ExtHostBulkEdits=y}),define(_e[180],Ee([0,1,4]),function(Z,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class T{constructor(y){const k=y.getProxy(m.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return k.$readText()},writeText(D){return k.$writeText(D)}})}}e.ExtHostClipboard=T}),define(_e[71],Ee([0,1,10,6,9,24,4,17,15,54,31,35,2,7,5,13]),function(Z,e,m,T,S,y,k,D,_,C,n,I,o,h,d,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let b=class{constructor(t,i){this._commands=new Map,this._apiCommands=new Map,this._proxy=t.getProxy(k.MainContext.MainThreadCommands),this._logService=i,this.converter=new p(this,s=>{const r=this._apiCommands.get(s);return(r==null?void 0:r.result)===u.Void?r:void 0},i),this._argumentProcessors=[{processArgument(s){return C.revive(s)}},{processArgument(s){return y.cloneAndChange(s,function(r){if(n.Range.isIRange(r))return S.Range.to(r);if(I.Position.isIPosition(r))return S.Position.to(r);if(n.Range.isIRange(r.range)&&o.URI.isUri(r.uri))return S.location.to(r);if(!Array.isArray(r))return r})}}]}registerArgumentProcessor(t){this._argumentProcessors.push(t)}registerApiCommand(t){const i=this.registerCommand(!1,t.id,async(...s)=>{const r=t.args.map((E,v)=>{if(!E.validate(s[v]))throw new Error(`Invalid argument '${E.name}' when running '${t.id}', received: ${s[v]}`);return E.convert(s[v])}),l=await this.executeCommand(t.internalId,...r);return t.result.convert(l,s,this.converter)},void 0,{description:t.description,args:t.args,returns:t.result.description});return this._apiCommands.set(t.id,t),new T.Disposable(()=>{i.dispose(),this._apiCommands.delete(t.id)})}registerCommand(t,i,s,r,l){if(this._logService.trace("ExtHostCommands#registerCommand",i),!i.trim().length)throw new Error("invalid id");if(this._commands.has(i))throw new Error(`command '${i}' already exists`);return this._commands.set(i,{callback:s,thisArg:r,description:l}),t&&this._proxy.$registerCommand(i),new T.Disposable(()=>{this._commands.delete(i)&&t&&this._proxy.$unregisterCommand(i)})}executeCommand(t,...i){return this._logService.trace("ExtHostCommands#executeCommand",t),this._doExecuteCommand(t,i,!0)}async _doExecuteCommand(t,i,s){if(this._commands.has(t))return this._executeContributedCommand(t,i);{const r=y.cloneAndChange(i,function(l){if(l instanceof T.Position)return S.Position.from(l);if(l instanceof T.Range)return S.Range.from(l);if(l instanceof T.Location)return S.location.from(l);if(T.NotebookRange.isNotebookRange(l))return S.NotebookRange.from(l);if(!Array.isArray(l))return l});try{const l=await this._proxy.$executeCommand(t,r,s);return C.revive(l)}catch(l){if(l instanceof Error&&l.message==="$executeCommand:retry")return this._doExecuteCommand(t,i,!1);throw l}}}async _executeContributedCommand(t,i){const s=this._commands.get(t);if(!s)throw new Error("Unknown command");let{callback:r,thisArg:l,description:E}=s;if(E)for(let v=0;v<E.args.length;v++)try{m.validateConstraint(i[v],E.args[v].constraint)}catch(A){throw new Error(`Running the contributed command: '${t}' failed. Illegal argument '${E.args[v].name}' - ${E.args[v].description}`)}try{return await r.apply(l,i)}catch(v){if(t===this.converter.delegatingCommandId){const A=this.converter.getActualCommand(...i);A&&(t=A.command)}throw this._logService.error(v,t),new Error(`Running the contributed command: '${t}' failed.`)}}$executeContributedCommand(t,...i){return this._logService.trace("ExtHostCommands#$executeContributedCommand",t),this._commands.has(t)?(i=i.map(s=>this._argumentProcessors.reduce((r,l)=>l.processArgument(r),s)),this._executeContributedCommand(t,i)):Promise.reject(new Error(`Contributed command '${t}' does not exist.`))}getCommands(t=!1){return this._logService.trace("ExtHostCommands#getCommands",t),this._proxy.$getCommands().then(i=>(t&&(i=i.filter(s=>s[0]!=="_")),i))}$getContributedCommandHandlerDescriptions(){const t=Object.create(null);for(let[i,s]of this._commands){let{description:r}=s;r&&(t[i]=r)}return Promise.resolve(t)}};b=He([ze(0,c.IExtHostRpcService),ze(1,_.ILogService)],b),e.ExtHostCommands=b,e.IExtHostCommands=d.createDecorator("IExtHostCommands");class p{constructor(t,i,s){this._commands=t,this._lookupApiCommand=i,this._logService=s,this.delegatingCommandId=`_vscode_delegate_cmd_${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(t,i){if(!t)return;const s={$ident:void 0,id:t.command,title:t.title,tooltip:t.tooltip};if(!t.command)return s;const r=this._lookupApiCommand(t.command);if(r)s.id=r.internalId,s.arguments=r.args.map((l,E)=>l.convert(t.arguments&&t.arguments[E]));else if(D.isNonEmptyArray(t.arguments)){const l=++this._cachIdPool;this._cache.set(l,t),i.add(h.toDisposable(()=>{this._cache.delete(l),this._logService.trace("CommandsConverter#DISPOSE",l)})),s.$ident=l,s.id=this.delegatingCommandId,s.arguments=[l],this._logService.trace("CommandsConverter#CREATE",t.command,l)}return s}fromInternal(t){const i=k.ObjectIdentifier.of(t);return typeof i=="number"?this._cache.get(i):{command:t.id,title:t.title,arguments:t.arguments}}getActualCommand(...t){return this._cache.get(t[0])}_executeConvertedCommand(...t){const i=this.getActualCommand(...t);return this._logService.trace("CommandsConverter#EXECUTE",t[0],i?i.command:"MISSING"),i?this._commands.executeCommand(i.command,...i.arguments||[]):Promise.reject("actual command NOT FOUND")}}e.CommandsConverter=p;class w{constructor(t,i,s,r){this.name=t,this.description=i,this.validate=s,this.convert=r}optional(){return new w(this.name,`(optional) ${this.description}`,t=>t==null||this.validate(t),t=>t===void 0?void 0:t===null?null:this.convert(t))}with(t,i){return new w(t??this.name,i??this.description,this.validate,this.convert)}}e.ApiCommandArgument=w,w.Uri=new w("uri","Uri of a text document",g=>o.URI.isUri(g),g=>g),w.Position=new w("position","A position in a text document",g=>T.Position.isPosition(g),S.Position.from),w.Range=new w("range","A range in a text document",g=>T.Range.isRange(g),S.Range.from),w.Selection=new w("selection","A selection in a text document",g=>T.Selection.isSelection(g),S.Selection.from),w.Number=new w("number","",g=>typeof g=="number",g=>g),w.String=new w("string","",g=>typeof g=="string",g=>g),w.CallHierarchyItem=new w("item","A call hierarchy item",g=>g instanceof T.CallHierarchyItem,S.CallHierarchyItem.to);class u{constructor(t,i){this.description=t,this.convert=i}}e.ApiCommandResult=u,u.Void=new u("no result",g=>g);class f{constructor(t,i,s,r,l){this.id=t,this.internalId=i,this.description=s,this.args=r,this.result=l}}e.ApiCommand=f}),define(_e[181],Ee([0,1,9,6,58,71,17,86]),function(Z,e,m,T,S,y,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const _=[new y.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",n(m.DocumentHighlight.to))),new y.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(o,h)=>{if(k.isFalsyOrEmpty(o))return;class d extends T.SymbolInformation{static to(b){const p=new d(b.name,m.SymbolKind.to(b.kind),b.containerName||"",new T.Location(h[0],m.Range.to(b.range)));return p.detail=b.detail,p.range=p.location.range,p.selectionRange=m.Range.to(b.selectionRange),p.children=b.children?b.children.map(d.to):[],p}}return o.map(d.to)})),new y.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[y.ApiCommandArgument.Uri,new y.ApiCommandArgument("options","Formatting options",o=>!0,o=>o)],new y.ApiCommandResult("A promise that resolves to an array of TextEdits.",n(m.TextEdit.to))),new y.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range,new y.ApiCommandArgument("options","Formatting options",o=>!0,o=>o)],new y.ApiCommandResult("A promise that resolves to an array of TextEdits.",n(m.TextEdit.to))),new y.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position,new y.ApiCommandArgument("ch","Trigger character",o=>typeof o=="string",o=>o),new y.ApiCommandArgument("options","Formatting options",o=>!0,o=>o)],new y.ApiCommandResult("A promise that resolves to an array of TextEdits.",n(m.TextEdit.to))),new y.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",I)),new y.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",I)),new y.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",I)),new y.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",I)),new y.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location-instances.",n(m.location.to))),new y.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Hover-instances.",n(m.Hover.to))),new y.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[y.ApiCommandArgument.Uri,new y.ApiCommandArgument("position","A position in a text document",o=>Array.isArray(o)&&o.every(h=>T.Position.isPosition(h)),o=>o.map(m.Position.from))],new y.ApiCommandResult("A promise that resolves to an array of ranges.",o=>o.map(h=>{let d;for(const c of h.reverse())d=new T.SelectionRange(m.Range.to(c),d);return d}))),new y.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[y.ApiCommandArgument.String.with("query","Search string")],new y.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",o=>{const h=[];if(Array.isArray(o))for(let d of o)h.push(...d[1].map(m.WorkspaceSymbol.to));return h})),new y.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A CallHierarchyItem or undefined",o=>o.map(m.CallHierarchyItem.to))),new y.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[y.ApiCommandArgument.CallHierarchyItem],new y.ApiCommandResult("A CallHierarchyItem or undefined",o=>o.map(m.CallHierarchyIncomingCall.to))),new y.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[y.ApiCommandArgument.CallHierarchyItem],new y.ApiCommandResult("A CallHierarchyItem or undefined",o=>o.map(m.CallHierarchyOutgoingCall.to))),new y.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position,y.ApiCommandArgument.String.with("newName","The new symbol name")],new y.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",o=>{if(!!o){if(o.rejectReason)throw new Error(o.rejectReason);return m.WorkspaceEdit.to(o)}})),new y.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new y.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",o=>o.map(m.DocumentLink.to))),new y.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",o=>{if(!!o)return new T.SemanticTokensLegend(o.tokenTypes,o.tokenModifiers)})),new y.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to SemanticTokens.",o=>{if(!o)return;const h=D.decodeSemanticTokensDto(o);if(h.type==="full")return new T.SemanticTokens(h.data,void 0)})),new y.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",o=>{if(!!o)return new T.SemanticTokensLegend(o.tokenTypes,o.tokenModifiers)})),new y.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range],new y.ApiCommandResult("A promise that resolves to SemanticTokens.",o=>{if(!o)return;const h=D.decodeSemanticTokensDto(o);if(h.type==="full")return new T.SemanticTokens(h.data,void 0)})),new y.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position,y.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),y.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new y.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(o,h,d)=>{if(!o)return new T.CompletionList([]);const c=o.suggestions.map(b=>m.CompletionItem.to(b,d));return new T.CompletionList(c,o.incomplete)})),new y.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position,y.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new y.ApiCommandResult("A promise that resolves to SignatureHelp.",o=>{if(o)return m.SignatureHelp.to(o)})),new y.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new y.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(o,h,d)=>n(c=>new T.CodeLens(m.Range.to(c.range),c.command&&d.fromInternal(c.command)))(o))),new y.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[y.ApiCommandArgument.Uri,new y.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",o=>T.Range.isRange(o),o=>T.Selection.isSelection(o)?m.Selection.from(o):m.Range.from(o)),y.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),y.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new y.ApiCommandResult("A promise that resolves to an array of Command-instances.",(o,h,d)=>n(c=>{if(c._isSynthetic){if(!c.command)throw new Error("Synthetic code actions must have a command");return d.fromInternal(c.command)}else{const b=new T.CodeAction(c.title,c.kind?new T.CodeActionKind(c.kind):void 0);return c.edit&&(b.edit=m.WorkspaceEdit.to(c.edit)),c.command&&(b.command=d.fromInternal(c.command)),b.isPreferred=c.isPreferred,b}})(o))),new y.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",o=>o?o.map(h=>new T.ColorInformation(m.Range.to(h.range),m.Color.to(h.color))):[])),new y.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new y.ApiCommandArgument("color","The color to show and insert",o=>o instanceof T.Color,m.Color.from),new y.ApiCommandArgument("context","Context object with uri and range",o=>!0,o=>({uri:o.uri,range:m.Range.from(o.range)}))],new y.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",o=>o?o.map(m.ColorPresentation.to):[])),new y.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range],new y.ApiCommandResult("A promise that resolves to an array of Inlay objects",o=>o.map(m.InlayHint.to))),new y.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new y.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",n(o=>({viewType:o.viewType,displayName:o.displayName,options:{transientOutputs:o.options.transientOutputs,transientCellMetadata:o.options.transientCellMetadata,transientDocumentMetadata:o.options.transientDocumentMetadata},filenamePattern:o.filenamePattern.map(h=>m.NotebookExclusiveDocumentPattern.to(h))})))),new y.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range],new y.ApiCommandResult("A promise that resolves to an array of InlineValue objects",o=>o.map(m.InlineValue.to))),new y.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[y.ApiCommandArgument.Uri,new y.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",o=>o===void 0||typeof o=="number"||typeof o=="object",o=>o&&(typeof o=="number"?[o,void 0]:[m.ViewColumn.from(o.viewColumn),m.TextEditorOpenOptions.from(o)])).optional(),y.ApiCommandArgument.String.with("label","").optional()],y.ApiCommandResult.Void),new y.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[y.ApiCommandArgument.Uri.with("resource","Resource to open"),y.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new y.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",o=>o===void 0||typeof o=="number"||typeof o=="object",o=>o&&(typeof o=="number"?[o,void 0]:[m.ViewColumn.from(o.viewColumn),m.TextEditorOpenOptions.from(o)])).optional()],y.ApiCommandResult.Void),new y.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[y.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),y.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),y.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new y.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",o=>o===void 0||typeof o=="object",o=>o&&[m.ViewColumn.from(o.viewColumn),m.TextEditorOpenOptions.from(o)]).optional()],y.ApiCommandResult.Void)];class C{static register(h){_.forEach(h.registerApiCommand,h)}}e.ExtHostApiCommands=C;function n(o){return h=>{if(Array.isArray(h))return h.map(o)}}function I(o){if(!Array.isArray(o))return;const h=[];for(const d of o)S.isLocationLink(d)?h.push(m.DefinitionLink.to(d)):h.push(m.location.to(d));return h}}),define(_e[182],Ee([0,1,12,47,3,7,2,58,26,9,6,4]),function(Z,e,m,T,S,y,k,D,_,C,n,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCommentThread=e.ExtHostComments=void 0;class o{constructor(f,g,t){this._documents=t,this._commentControllers=new Map,this._commentControllersByExtension=new Map,this._proxy=f.getProxy(I.MainContext.MainThreadComments),g.registerArgumentProcessor({processArgument:i=>{if(i&&i.$mid===6){const s=this._commentControllers.get(i.handle);return s||i}else if(i&&i.$mid===7){const s=this._commentControllers.get(i.commentControlHandle);if(!s)return i;const r=s.getCommentThread(i.commentThreadHandle);return r||i}else if(i&&i.$mid===8){const s=this._commentControllers.get(i.thread.commentControlHandle);if(!s)return i;const r=s.getCommentThread(i.thread.commentThreadHandle);return r?{thread:r,text:i.text}:i}else if(i&&i.$mid===9){const s=this._commentControllers.get(i.thread.commentControlHandle);if(!s)return i;const r=s.getCommentThread(i.thread.commentThreadHandle);if(!r)return i;let l=i.commentUniqueId,E=r.getCommentByUniqueId(l);return E||i}else if(i&&i.$mid===10){const s=this._commentControllers.get(i.thread.commentControlHandle);if(!s)return i;const r=s.getCommentThread(i.thread.commentThreadHandle);if(!r)return i;let l=i.text,E=i.commentUniqueId,v=r.getCommentByUniqueId(E);return v?(v.body=l,v):i}return i}})}createCommentController(f,g,t){const i=o.handlePool++,s=new d(f,i,this._proxy,g,t);this._commentControllers.set(s.handle,s);const r=this._commentControllersByExtension.get(_.ExtensionIdentifier.toKey(f.identifier))||[];return r.push(s),this._commentControllersByExtension.set(_.ExtensionIdentifier.toKey(f.identifier),r),s}$createCommentThreadTemplate(f,g,t){const i=this._commentControllers.get(f);!i||i.$createCommentThreadTemplate(g,t)}async $updateCommentThreadTemplate(f,g,t){const i=this._commentControllers.get(f);!i||i.$updateCommentThreadTemplate(g,t)}$deleteCommentThread(f,g){const t=this._commentControllers.get(f);t&&t.$deleteCommentThread(g)}$provideCommentingRanges(f,g,t){const i=this._commentControllers.get(f);if(!i||!i.commentingRangeProvider)return Promise.resolve(void 0);const s=this._documents.getDocument(k.URI.revive(g));return m.asPromise(()=>i.commentingRangeProvider.provideCommentingRanges(s,t)).then(r=>r?r.map(l=>C.Range.from(l)):void 0)}$toggleReaction(f,g,t,i,s){const r=this._commentControllers.get(f);return!r||!r.reactionHandler?Promise.resolve(void 0):m.asPromise(()=>{const l=r.getCommentThread(g);if(l){const E=l.getCommentByUniqueId(i.uniqueIdInThread);if(r!==void 0&&E&&r.reactionHandler)return r.reactionHandler(E,p(s))}return Promise.resolve(void 0)})}dispose(){}}e.ExtHostComments=o,o.handlePool=0;class h{constructor(f,g,t,i,s,r,l){this._proxy=f,this._commentController=g,this._id=t,this._uri=i,this._range=s,this._comments=r,this.handle=h._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new S.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new y.MutableDisposable,this._acceptInputDisposables.value=new y.DisposableStore,this._id===void 0&&(this._id=`${g.id}.${this.handle}`),this._proxy.$createCommentThread(this._commentController.handle,this.handle,this._id,this._uri,C.Range.from(this._range),l),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=r}set threadId(f){this._id=f}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(f){f.isEqual(this._range)||(this._range=f,this.modifications.range=f,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(f){this._canReply!==f&&(this._canReply=f,this.modifications.canReply=f,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(f){this._label=f,this.modifications.label=f,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(f){this._contextValue=f,this.modifications.contextValue=f,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(f){this._comments=f,this.modifications.comments=f,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(f){this._collapseState=f,this.modifications.collapsibleState=f,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}eventuallyUpdateCommentThread(){if(this._isDiposed)return;this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new y.DisposableStore);const f=t=>Object.prototype.hasOwnProperty.call(this.modifications,t),g={};f("range")&&(g.range=C.Range.from(this._range)),f("label")&&(g.label=this.label),f("contextValue")&&(g.contextValue=this.contextValue),f("comments")&&(g.comments=this._comments.map(t=>c(this,this._commentController,t,this._commentsMap))),f("collapsibleState")&&(g.collapseState=w(this._collapseState)),f("canReply")&&(g.canReply=this.canReply),this.modifications={},this._proxy.$updateCommentThread(this._commentController.handle,this.handle,this._id,this._uri,g)}getCommentByUniqueId(f){for(let g of this._commentsMap){let t=g[0],i=g[1];if(f===i)return t}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(f=>f.dispose()),this._proxy.$deleteCommentThread(this._commentController.handle,this.handle)}}h._handlePool=0,He([T.debounce(100)],h.prototype,"eventuallyUpdateCommentThread",null),e.ExtHostCommentThread=h;class d{constructor(f,g,t,i,s){this._extension=f,this._handle=g,this._proxy=t,this._id=i,this._label=s,this._threads=new Map,this._proxy.$registerCommentController(this.handle,i,s)}get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get reactionHandler(){return this._reactionHandler}set reactionHandler(f){this._reactionHandler=f,this._proxy.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!f})}get options(){return this._options}set options(f){this._options=f,this._proxy.$updateCommentControllerFeatures(this.handle,{options:this._options})}createCommentThread(f,g,t,i){if(typeof f=="string"){const s=new h(this._proxy,this,f,g,t,i,this._extension.identifier);return this._threads.set(s.handle,s),s}else{const s=new h(this._proxy,this,void 0,f,g,t,this._extension.identifier);return this._threads.set(s.handle,s),s}}$createCommentThreadTemplate(f,g){const t=new h(this._proxy,this,void 0,k.URI.revive(f),C.Range.to(g),[],this._extension.identifier);return t.collapsibleState=D.CommentThreadCollapsibleState.Expanded,this._threads.set(t.handle,t),t}$updateCommentThreadTemplate(f,g){let t=this._threads.get(f);t&&(t.range=C.Range.to(g))}$deleteCommentThread(f){let g=this._threads.get(f);g&&g.dispose(),this._threads.delete(f)}getCommentThread(f){return this._threads.get(f)}dispose(){this._threads.forEach(f=>{f.dispose()}),this._proxy.$unregisterCommentController(this.handle)}}function c(u,f,g,t){let i=t.get(g);i||(i=++u.commentHandle,t.set(g,i));const s=g.author&&g.author.iconPath?g.author.iconPath.toString():void 0;return{mode:g.mode,contextValue:g.contextValue,uniqueIdInThread:i,body:C.MarkdownString.from(g.body),userName:g.author.name,userIconPath:s,label:g.label,commentReactions:g.reactions?g.reactions.map(r=>b(r)):void 0}}function b(u){return{label:u.label,iconPath:u.iconPath?C.pathOrURIToURI(u.iconPath):void 0,count:u.count,hasReacted:u.authorHasReacted}}function p(u){return{label:u.label||"",count:u.count||0,iconPath:u.iconPath?k.URI.revive(u.iconPath):"",authorHasReacted:u.hasReacted||!1}}function w(u){if(u!==void 0)switch(u){case n.CommentThreadCollapsibleState.Expanded:return D.CommentThreadCollapsibleState.Expanded;case n.CommentThreadCollapsibleState.Collapsed:return D.CommentThreadCollapsibleState.Collapsed}return D.CommentThreadCollapsibleState.Collapsed}}),define(_e[100],Ee([0,1,2,4,6,5,13,15,17,8,14]),function(Z,e,m,T,S,y,k,D,_,C,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let I=class wn{constructor(h,d){this._logService=d,this._provider=new Map,this._proxy=h.getProxy(T.MainContext.MainThreadDecorations)}registerFileDecorationProvider(h,d){const c=wn._handlePool++;this._provider.set(c,{provider:h,extensionId:d}),this._proxy.$registerDecorationProvider(c,d.value);const b=h.onDidChangeFileDecorations&&h.onDidChangeFileDecorations(p=>{if(!p){this._proxy.$onDidChange(c,null);return}let w=_.asArray(p);if(w.length<=wn._maxEventSize){this._proxy.$onDidChange(c,w);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",d.value,w.length);const u=w.map(t=>({uri:t,rank:C.count(t.path,"/")})),f=_.groupBy(u,(t,i)=>t.rank-i.rank||C.compare(t.uri.path,i.uri.path));let g=[];e:for(let t of f){let i;for(let s of t){let r=n.dirname(s.uri.path);if(i!==r&&(i=r,g.push(s.uri)>=wn._maxEventSize))break e}}this._proxy.$onDidChange(c,g)});return new S.Disposable(()=>{b==null||b.dispose(),this._proxy.$unregisterDecorationProvider(c),this._provider.delete(c)})}async $provideDecorations(h,d,c){if(!this._provider.has(h))return Object.create(null);const b=Object.create(null),{provider:p,extensionId:w}=this._provider.get(h);return await Promise.all(d.map(async u=>{try{const{uri:f,id:g}=u,t=await Promise.resolve(p.provideFileDecoration(m.URI.revive(f),c));if(!t)return;try{S.FileDecoration.validate(t),b[g]=[t.propagate,t.tooltip,t.badge,t.color]}catch(i){this._logService.warn(`INVALID decoration from extension '${w.value}': ${i}`)}}catch(f){this._logService.error(f)}})),b}};I._handlePool=0,I._maxEventSize=250,I=He([ze(0,k.IExtHostRpcService),ze(1,D.ILogService)],I),e.ExtHostDecorations=I,e.IExtHostDecorations=y.createDecorator("IExtHostDecorations")}),define(_e[183],Ee([0,1,128,90,2,4,6,9,3,15,22]),function(Z,e,m,T,S,y,k,D,_,C,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class I{constructor(d,c,b,p,w){this._name=d,this._owner=c,this._maxDiagnosticsPerFile=b,this._proxy=p,this._onDidChangeDiagnostics=w,this._isDisposed=!1,this._data=new n.ResourceMap}dispose(){this._isDisposed||(this._onDidChangeDiagnostics.fire([...this._data.keys()]),this._proxy&&this._proxy.$clear(this._owner),this._data=void 0,this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(d,c){if(!d){this.clear();return}this._checkDisposed();let b=[];if(S.URI.isUri(d)){if(!c){this.delete(d);return}this._data.set(d,c.slice()),b=[d]}else if(Array.isArray(d)){b=[];let w;d=[...d].sort(I._compareIndexedTuplesByUri);for(const u of d){const[f,g]=u;if((!w||f.toString()!==w.toString())&&(w&&this._data.get(w).length===0&&this._data.delete(w),w=f,b.push(f),this._data.set(f,[])),g){const t=this._data.get(f);t&&t.push(...g)}else{const t=this._data.get(f);t&&(t.length=0)}}}if(this._onDidChangeDiagnostics.fire(b),!this._proxy)return;const p=[];for(let w of b){let u=[];const f=this._data.get(w);if(f)if(f.length>this._maxDiagnosticsPerFile){u=[];const g=[k.DiagnosticSeverity.Error,k.DiagnosticSeverity.Warning,k.DiagnosticSeverity.Information,k.DiagnosticSeverity.Hint];e:for(let t=0;t<4;t++)for(let i of f)if(i.severity===g[t]&&u.push(D.Diagnostic.from(i))===this._maxDiagnosticsPerFile)break e;u.push({severity:T.MarkerSeverity.Info,message:m.localize(0,null,f.length-this._maxDiagnosticsPerFile),startLineNumber:u[u.length-1].startLineNumber,startColumn:u[u.length-1].startColumn,endLineNumber:u[u.length-1].endLineNumber,endColumn:u[u.length-1].endColumn})}else u=f.map(g=>D.Diagnostic.from(g));p.push([w,u])}this._proxy.$changeMany(this._owner,p)}delete(d){this._checkDisposed(),this._onDidChangeDiagnostics.fire([d]),this._data.delete(d),this._proxy&&this._proxy.$changeMany(this._owner,[[d,void 0]])}clear(){this._checkDisposed(),this._onDidChangeDiagnostics.fire([...this._data.keys()]),this._data.clear(),this._proxy&&this._proxy.$clear(this._owner)}forEach(d,c){this._checkDisposed();for(let b of this._data.keys())d.apply(c,[b,this.get(b),this])}get(d){this._checkDisposed();const c=this._data.get(d);return Array.isArray(c)?Object.freeze(c.slice(0)):[]}has(d){return this._checkDisposed(),Array.isArray(this._data.get(d))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(d,c){return d[0].toString()<c[0].toString()?-1:d[0].toString()>c[0].toString()?1:0}}e.DiagnosticCollection=I;let o=class jt{constructor(d,c){this._logService=c,this._collections=new Map,this._onDidChangeDiagnostics=new _.Emitter,this.onDidChangeDiagnostics=_.Event.map(_.Event.debounce(this._onDidChangeDiagnostics.event,jt._debouncer,50),jt._mapper),this._proxy=d.getProxy(y.MainContext.MainThreadDiagnostics)}static _debouncer(d,c){return d?d.concat(c):c}static _mapper(d){const c=new n.ResourceMap;for(const b of d)c.set(b,b);return{uris:Object.freeze(Array.from(c.values()))}}createDiagnosticCollection(d,c){const{_collections:b,_proxy:p,_onDidChangeDiagnostics:w,_logService:u}=this,f=new class{$changeMany(i,s){p.$changeMany(i,s),u.trace("[DiagnosticCollection] change many (extension, owner, uris)",d.value,i,s.length===0?"CLEARING":s)}$clear(i){p.$clear(i),u.trace("[DiagnosticCollection] remove all (extension, owner)",d.value,i)}dispose(){p.dispose()}};let g;if(!c)c="_generated_diagnostic_collection_name_#"+jt._idPool++,g=c;else if(!b.has(c))g=c;else{this._logService.warn(`DiagnosticCollection with name '${c}' does already exist.`);do g=c+jt._idPool++;while(b.has(g))}return new class extends I{constructor(){super(c,g,jt._maxDiagnosticsPerFile,f,w);b.set(g,this)}dispose(){super.dispose(),b.delete(g)}}}getDiagnostics(d){if(d)return this._getDiagnostics(d);{const c=new Map,b=[];for(const p of this._collections.values())p.forEach((w,u)=>{let f=c.get(w.toString());typeof f=="undefined"&&(f=b.length,c.set(w.toString(),f),b.push([w,[]])),b[f][1]=b[f][1].concat(...u)});return b}}_getDiagnostics(d){let c=[];for(let b of this._collections.values())b.has(d)&&(c=c.concat(b.get(d)));return c}$acceptMarkersChange(d){if(!this._mirrorCollection){const c="_generated_mirror",b=new I(c,c,jt._maxDiagnosticsPerFile,void 0,this._onDidChangeDiagnostics);this._collections.set(c,b),this._mirrorCollection=b}for(const[c,b]of d)this._mirrorCollection.set(S.URI.revive(c),b.map(D.Diagnostic.to))}};o._idPool=0,o._maxDiagnosticsPerFile=1e3,o=He([ze(1,C.ILogService)],o),e.ExtHostDiagnostics=o}),define(_e[184],Ee([0,1,2,4]),function(Z,e,m,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class S{constructor(k){this._proxy=k.getProxy(T.MainContext.MainThreadDialogs)}showOpenDialog(k){return this._proxy.$showOpenDialog(k).then(D=>D?D.map(_=>m.URI.revive(_)):void 0)}showSaveDialog(k){return this._proxy.$showSaveDialog(k).then(D=>D?m.URI.revive(D):void 0)}}e.ExtHostDialogs=S}),define(_e[185],Ee([0,1,11,2,6,4,16,18,8]),function(Z,e,m,T,S,y,k,D,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class C{constructor(I,o,h){this._documentsAndEditors=o,this._logService=h,this._documentContentProviders=new Map,this._proxy=I.getProxy(y.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(I,o){if(Object.keys(k.Schemas).indexOf(I)>=0)throw new Error(`scheme '${I}' already registered`);const h=C._handlePool++;this._documentContentProviders.set(h,o),this._proxy.$registerTextContentProvider(h,I);let d;return typeof o.onDidChange=="function"&&(d=o.onDidChange(c=>{if(c.scheme!==I){this._logService.warn(`Provider for scheme '${I}' is firing event for schema '${c.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(c)&&this.$provideTextDocumentContent(h,c).then(b=>{if(!b&&typeof b!="string")return;const p=this._documentsAndEditors.getDocument(c);if(!p)return;const w=_.splitLines(b);if(!p.equalLines(w))return this._proxy.$onVirtualDocumentChange(c,b)},m.onUnexpectedError)})),new S.Disposable(()=>{this._documentContentProviders.delete(h)&&this._proxy.$unregisterTextContentProvider(h),d&&(d.dispose(),d=void 0)})}$provideTextDocumentContent(I,o){const h=this._documentContentProviders.get(I);return h?Promise.resolve(h.provideTextDocumentContent(T.URI.revive(o),D.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${o.scheme}`))}}e.ExtHostDocumentContentProvider=C,C._handlePool=0}),define(_e[186],Ee([0,1,3,7,2,4,95,9,10,24]),function(Z,e,m,T,S,y,k,D,_,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class n{constructor(o,h){this._onDidAddDocument=new m.Emitter,this._onDidRemoveDocument=new m.Emitter,this._onDidChangeDocument=new m.Emitter,this._onDidSaveDocument=new m.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new T.DisposableStore,this._documentLoader=new Map,this._proxy=o.getProxy(y.MainContext.MainThreadDocuments),this._documentsAndEditors=h,this._documentsAndEditors.onDidRemoveDocuments(d=>{for(const c of d)this._onDidRemoveDocument.fire(c.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(d=>{for(const c of d)this._onDidAddDocument.fire(c.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(o){if(!o)return;const h=this._documentsAndEditors.getDocument(o);if(h)return h}getDocument(o){const h=this.getDocumentData(o);if(!(h==null?void 0:h.document))throw new Error(`Unable to retrieve document from URI '${o}'`);return h.document}ensureDocumentData(o){const h=this._documentsAndEditors.getDocument(o);if(h)return Promise.resolve(h);let d=this._documentLoader.get(o.toString());return d||(d=this._proxy.$tryOpenDocument(o).then(c=>{this._documentLoader.delete(o.toString());const b=S.URI.revive(c);return _.assertIsDefined(this._documentsAndEditors.getDocument(b))},c=>(this._documentLoader.delete(o.toString()),Promise.reject(c))),this._documentLoader.set(o.toString(),d)),d}createDocumentData(o){return this._proxy.$tryCreateDocument(o).then(h=>S.URI.revive(h))}$acceptModelModeChanged(o,h){const d=S.URI.revive(o),c=this._documentsAndEditors.getDocument(d);if(!c)throw new Error("unknown document");this._onDidRemoveDocument.fire(c.document),c._acceptLanguageId(h),this._onDidAddDocument.fire(c.document)}$acceptModelSaved(o){const h=S.URI.revive(o),d=this._documentsAndEditors.getDocument(h);if(!d)throw new Error("unknown document");this.$acceptDirtyStateChanged(o,!1),this._onDidSaveDocument.fire(d.document)}$acceptDirtyStateChanged(o,h){const d=S.URI.revive(o),c=this._documentsAndEditors.getDocument(d);if(!c)throw new Error("unknown document");c._acceptIsDirty(h),this._onDidChangeDocument.fire({document:c.document,contentChanges:[]})}$acceptModelChanged(o,h,d){const c=S.URI.revive(o),b=this._documentsAndEditors.getDocument(c);if(!b)throw new Error("unknown document");b._acceptIsDirty(d),b.onEvents(h),this._onDidChangeDocument.fire(C.deepFreeze({document:b.document,contentChanges:h.changes.map(p=>({range:D.Range.to(p.range),rangeOffset:p.rangeOffset,rangeLength:p.rangeLength,text:p.text}))}))}setWordDefinitionFor(o,h){k.setWordDefinitionFor(o,h)}}e.ExtHostDocuments=n}),define(_e[36],Ee([0,1,39,3,7,2,5,4,95,13,98,9,15,22,16,50,108]),function(Z,e,m,T,S,y,k,D,_,C,n,I,o,h,d,c,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class p{constructor(f){this.value=f,this._count=0}ref(){this._count++}unref(){return--this._count==0}}let w=class{constructor(f,g){this._extHostRpc=f,this._logService=g,this._activeEditorId=null,this._editors=new Map,this._documents=new h.ResourceMap,this._onDidAddDocuments=new T.Emitter,this._onDidRemoveDocuments=new T.Emitter,this._onDidChangeVisibleTextEditors=new T.Emitter,this._onDidChangeActiveTextEditor=new T.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(f){this.acceptDocumentsAndEditorsDelta(f)}acceptDocumentsAndEditorsDelta(f){const g=[],t=[],i=[];if(f.removedDocuments)for(const s of f.removedDocuments){const r=y.URI.revive(s),l=this._documents.get(r);(l==null?void 0:l.unref())&&(this._documents.delete(r),g.push(l.value))}if(f.addedDocuments)for(const s of f.addedDocuments){const r=y.URI.revive(s.uri);let l=this._documents.get(r);if(l&&r.scheme!==d.Schemas.vscodeNotebookCell)throw new Error(`document '${r} already exists!'`);l||(l=new p(new _.ExtHostDocumentData(this._extHostRpc.getProxy(D.MainContext.MainThreadDocuments),r,s.lines,s.EOL,s.versionId,s.modeId,s.isDirty,s.notebook)),this._documents.set(r,l),t.push(l.value)),l.ref()}if(f.removedEditors)for(const s of f.removedEditors){const r=this._editors.get(s);this._editors.delete(s),r&&i.push(r)}if(f.addedEditors)for(const s of f.addedEditors){const r=y.URI.revive(s.documentUri);m.ok(this._documents.has(r),`document '${r}' does not exist`),m.ok(!this._editors.has(s.id),`editor '${s.id}' already exists!`);const l=this._documents.get(r).value,E=new n.ExtHostTextEditor(s.id,this._extHostRpc.getProxy(D.MainContext.MainThreadTextEditors),this._logService,new b.Lazy(()=>l.document),s.selections.map(I.Selection.to),s.options,s.visibleRanges.map(v=>I.Range.to(v)),typeof s.editorPosition=="number"?I.ViewColumn.to(s.editorPosition):void 0);this._editors.set(s.id,E)}f.newActiveEditor!==void 0&&(m.ok(f.newActiveEditor===null||this._editors.has(f.newActiveEditor),`active editor '${f.newActiveEditor}' does not exist`),this._activeEditorId=f.newActiveEditor),S.dispose(g),S.dispose(i),f.removedDocuments&&this._onDidRemoveDocuments.fire(g),f.addedDocuments&&this._onDidAddDocuments.fire(t),(f.removedEditors||f.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(s=>s.value)),f.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(f){var g;return(g=this._documents.get(f))===null||g===void 0?void 0:g.value}allDocuments(){return c.Iterable.map(this._documents.values(),f=>f.value)}getEditor(f){return this._editors.get(f)}activeEditor(f){if(!this._activeEditorId)return;const g=this._editors.get(this._activeEditorId);return f?g:g==null?void 0:g.value}allEditors(){return[...this._editors.values()]}};w=He([ze(0,C.IExtHostRpcService),ze(1,o.ILogService)],w),e.ExtHostDocumentsAndEditors=w,e.IExtHostDocumentsAndEditors=k.createDecorator("IExtHostDocumentsAndEditors")}),define(_e[187],Ee([0,1,2,4,7,6,9,118,8,23]),function(Z,e,m,T,S,y,k,D,_,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class n{constructor(){this._schemes=[]}add(h){this._stateMachine=void 0,this._schemes.push(h)}delete(h){const d=this._schemes.indexOf(h);d>=0&&(this._schemes.splice(d,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const h=this._schemes.sort(),d=[];let c,b,p=14,w=14;for(const u of h){let f=c?_.commonPrefixLength(c,u):0;for(f===0?b=1:b=w;f<u.length;f++)f+1===u.length?(p=w,w=9):w+=1,d.push([b,u.toUpperCase().charCodeAt(f),w]),d.push([b,u.toLowerCase().charCodeAt(f),w]),b=w;c=u,w=p}d.push([9,58,10]),d.push([10,47,12]),this._stateMachine=new D.StateMachine(d)}}provideDocumentLinks(h){this._initStateMachine();const d=[],c=D.LinkComputer.computeLinks({getLineContent(b){return h.lineAt(b-1).text},getLineCount(){return h.lineCount}},this._stateMachine);for(const b of c){const p=k.DocumentLink.to(b);p.target&&d.push(p)}return d}}class I{constructor(h,d){this._extHostLanguageFeatures=d,this._linkProvider=new n,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._enableProposedApi=new Map,this._handlePool=0,this._proxy=h.getProxy(T.MainContext.MainThreadFileSystem)}dispose(){var h;(h=this._linkProviderRegistration)===null||h===void 0||h.dispose()}_registerLinkProviderIfNotYetRegistered(){this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(void 0,"*",this._linkProvider))}registerFileSystemProvider(h,d,c,b={},p){if(this._registeredSchemes.has(d))throw new Error(`a provider for the scheme '${d}' is already registered`);this._registerLinkProviderIfNotYetRegistered();const w=this._handlePool++;this._linkProvider.add(d),this._registeredSchemes.add(d),this._fsProvider.set(w,c),this._enableProposedApi.set(w,p??!1);let u=2;b.isCaseSensitive&&(u+=1024),b.isReadonly&&(u+=2048),typeof c.copy=="function"&&(u+=8),typeof c.open=="function"&&typeof c.close=="function"&&typeof c.read=="function"&&typeof c.write=="function"&&(u+=4),this._proxy.$registerFileSystemProvider(w,d,u).catch(g=>{console.error(`FAILED to register filesystem provider of ${h.value}-extension for the scheme ${d}`),console.error(g)});const f=c.onDidChangeFile(g=>{const t=[];for(const i of g){let{uri:s,type:r}=i;if(s.scheme!==d)continue;let l;switch(r){case y.FileChangeType.Changed:l=0;break;case y.FileChangeType.Created:l=1;break;case y.FileChangeType.Deleted:l=2;break;default:throw new Error("Unknown FileChangeType")}t.push({resource:s,type:l})}this._proxy.$onFileSystemChange(w,t)});return S.toDisposable(()=>{f.dispose(),this._linkProvider.delete(d),this._registeredSchemes.delete(d),this._fsProvider.delete(w),this._enableProposedApi.delete(w),this._proxy.$unregisterProvider(w)})}static _asIStat(h,d){const{type:c,ctime:b,mtime:p,size:w,permissions:u}=h;return d?{type:c,ctime:b,mtime:p,size:w,permissions:u}:{type:c,ctime:b,mtime:p,size:w}}$stat(h,d){return Promise.resolve(this._getFsProvider(h).stat(m.URI.revive(d))).then(c=>{var b;return I._asIStat(c,(b=this._enableProposedApi.get(h))!==null&&b!==void 0?b:!1)})}$readdir(h,d){return Promise.resolve(this._getFsProvider(h).readDirectory(m.URI.revive(d)))}$readFile(h,d){return Promise.resolve(this._getFsProvider(h).readFile(m.URI.revive(d))).then(c=>C.VSBuffer.wrap(c))}$writeFile(h,d,c,b){return Promise.resolve(this._getFsProvider(h).writeFile(m.URI.revive(d),c.buffer,b))}$delete(h,d,c){return Promise.resolve(this._getFsProvider(h).delete(m.URI.revive(d),c))}$rename(h,d,c,b){return Promise.resolve(this._getFsProvider(h).rename(m.URI.revive(d),m.URI.revive(c),b))}$copy(h,d,c,b){const p=this._getFsProvider(h);if(!p.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(p.copy(m.URI.revive(d),m.URI.revive(c),b))}$mkdir(h,d){return Promise.resolve(this._getFsProvider(h).createDirectory(m.URI.revive(d)))}$watch(h,d,c,b){const p=this._getFsProvider(h).watch(m.URI.revive(c),b);this._watches.set(d,p)}$unwatch(h,d){const c=this._watches.get(d);c&&(c.dispose(),this._watches.delete(d))}$open(h,d,c){const b=this._getFsProvider(h);if(!b.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(b.open(m.URI.revive(d),c))}$close(h,d){const c=this._getFsProvider(h);if(!c.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(c.close(d))}$read(h,d,c,b){const p=this._getFsProvider(h);if(!p.read)throw new Error('FileSystemProvider does not implement "read"');const w=C.VSBuffer.alloc(b);return Promise.resolve(p.read(d,c,w.buffer,0,b)).then(u=>w.slice(0,u))}$write(h,d,c,b){const p=this._getFsProvider(h);if(!p.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(p.write(d,c,b.buffer,0,b.byteLength))}_getFsProvider(h){const d=this._fsProvider.get(h);if(!d){const c=new Error;throw c.name="ENOPRO",c.message="no provider",c}return d}}e.ExtHostFileSystem=I}),define(_e[72],Ee([0,1,4,59,6,23,5,13,45]),function(Z,e,m,T,S,y,k,D,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let C=class Ot{constructor(I,o){const h=I.getProxy(m.MainContext.MainThreadFileSystem);this.value=Object.freeze({stat(d){return h.$stat(d).catch(Ot._handleError)},readDirectory(d){return h.$readdir(d).catch(Ot._handleError)},createDirectory(d){return h.$mkdir(d).catch(Ot._handleError)},async readFile(d){return h.$readFile(d).then(c=>c.buffer).catch(Ot._handleError)},writeFile(d,c){return h.$writeFile(d,y.VSBuffer.wrap(c)).catch(Ot._handleError)},delete(d,c){return h.$delete(d,Object.assign({recursive:!1,useTrash:!1},c)).catch(Ot._handleError)},rename(d,c,b){return h.$rename(d,c,Object.assign({overwrite:!1},b)).catch(Ot._handleError)},copy(d,c,b){return h.$copy(d,c,Object.assign({overwrite:!1},b)).catch(Ot._handleError)},isWritableFileSystem(d){const c=o.getCapabilities(d);if(typeof c=="number")return!(c&2048)}})}static _handleError(I){if(!(I instanceof Error))throw new S.FileSystemError(String(I));if(I.name==="ENOPRO")throw S.FileSystemError.Unavailable(I.message);switch(I.name){case T.FileSystemProviderErrorCode.FileExists:throw S.FileSystemError.FileExists(I.message);case T.FileSystemProviderErrorCode.FileNotFound:throw S.FileSystemError.FileNotFound(I.message);case T.FileSystemProviderErrorCode.FileNotADirectory:throw S.FileSystemError.FileNotADirectory(I.message);case T.FileSystemProviderErrorCode.FileIsADirectory:throw S.FileSystemError.FileIsADirectory(I.message);case T.FileSystemProviderErrorCode.NoPermissions:throw S.FileSystemError.NoPermissions(I.message);case T.FileSystemProviderErrorCode.Unavailable:throw S.FileSystemError.Unavailable(I.message);default:throw new S.FileSystemError(I.message,I.name)}}};C=He([ze(0,D.IExtHostRpcService),ze(1,_.IExtHostFileSystemInfo)],C),e.ExtHostConsumerFileSystem=C,e.IExtHostConsumerFileSystem=k.createDecorator("IExtHostConsumerFileSystem")}),define(_e[188],Ee([0,1,7,4]),function(Z,e,m,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class S{constructor(k){this._handlePool=0,this._proxy=k.getProxy(T.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(k){const D=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(D,k),m.toDisposable(()=>{this._proxy.$unregisterResourceLabelFormatter(D)})}}e.ExtHostLabelService=S}),define(_e[189],Ee([0,1,2,24,9,6,12,4,8,31,17,10,115,7,86,49,62,52,11,3]),function(Z,e,m,T,S,y,k,D,_,C,n,I,o,h,d,c,b,p,w,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=e.InlineCompletionController=e.DocumentRangeSemanticTokensAdapter=e.DocumentSemanticTokensAdapter=void 0;class f{constructor($,Q){this._documents=$,this._provider=Q}provideDocumentSymbols($,Q){const te=this._documents.getDocument($);return k.asPromise(()=>this._provider.provideDocumentSymbols(te,Q)).then(re=>{if(!n.isFalsyOrEmpty(re))return re[0]instanceof y.DocumentSymbol?re.map(S.DocumentSymbol.from):f._asDocumentSymbolTree(re)})}static _asDocumentSymbolTree($){var Q;$=$.slice(0).sort((G,se)=>{let he=G.location.range.start.compareTo(se.location.range.start);return he===0&&(he=se.location.range.end.compareTo(G.location.range.end)),he});const te=[],re=[];for(const G of $){const se={name:G.name||"!!MISSING: name!!",kind:S.SymbolKind.from(G.kind),tags:((Q=G.tags)===null||Q===void 0?void 0:Q.map(S.SymbolTag.from))||[],detail:"",containerName:G.containerName,range:S.Range.from(G.location.range),selectionRange:S.Range.from(G.location.range),children:[]};for(;;){if(re.length===0){re.push(se),te.push(se);break}const he=re[re.length-1];if(C.Range.containsRange(he.range,se.range)&&!C.Range.equalsRange(he.range,se.range)){he.children&&he.children.push(se),re.push(se);break}re.pop()}}return te}}class g{constructor($,Q,te){this._documents=$,this._commands=Q,this._provider=te,this._cache=new b.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses($,Q){const te=this._documents.getDocument($),re=await this._provider.provideCodeLenses(te,Q);if(!re||Q.isCancellationRequested)return;const G=this._cache.add(re),se=new h.DisposableStore;this._disposables.set(G,se);const he={cacheId:G,lenses:[]};for(let Ae=0;Ae<re.length;Ae++)he.lenses.push({cacheId:[G,Ae],range:S.Range.from(re[Ae].range),command:this._commands.toInternal(re[Ae].command,se)});return he}async resolveCodeLens($,Q){var te;const re=$.cacheId&&this._cache.get(...$.cacheId);if(!re)return;let G;if(typeof this._provider.resolveCodeLens!="function"||re.isResolved?G=re:G=await this._provider.resolveCodeLens(re,Q),G||(G=re),Q.isCancellationRequested)return;const se=$.cacheId&&this._disposables.get($.cacheId[0]);if(!!se)return $.command=this._commands.toInternal((te=G.command)!==null&&te!==void 0?te:g._badCmd,se),$}releaseCodeLenses($){var Q;(Q=this._disposables.get($))===null||Q===void 0||Q.dispose(),this._disposables.delete($),this._cache.delete($)}}g._badCmd={command:"missing",title:"!!MISSING: command!!"};function t(Ke){return Array.isArray(Ke)?Ke.map(S.DefinitionLink.from):Ke?[S.DefinitionLink.from(Ke)]:[]}class i{constructor($,Q){this._documents=$,this._provider=Q}provideDefinition($,Q,te){const re=this._documents.getDocument($),G=S.Position.to(Q);return k.asPromise(()=>this._provider.provideDefinition(re,G,te)).then(t)}}class s{constructor($,Q){this._documents=$,this._provider=Q}provideDeclaration($,Q,te){const re=this._documents.getDocument($),G=S.Position.to(Q);return k.asPromise(()=>this._provider.provideDeclaration(re,G,te)).then(t)}}class r{constructor($,Q){this._documents=$,this._provider=Q}provideImplementation($,Q,te){const re=this._documents.getDocument($),G=S.Position.to(Q);return k.asPromise(()=>this._provider.provideImplementation(re,G,te)).then(t)}}class l{constructor($,Q){this._documents=$,this._provider=Q}provideTypeDefinition($,Q,te){const re=this._documents.getDocument($),G=S.Position.to(Q);return k.asPromise(()=>this._provider.provideTypeDefinition(re,G,te)).then(t)}}class E{constructor($,Q){this._documents=$,this._provider=Q}provideHover($,Q,te){const re=this._documents.getDocument($),G=S.Position.to(Q);return k.asPromise(()=>this._provider.provideHover(re,G,te)).then(se=>{if(!(!se||n.isFalsyOrEmpty(se.contents)))return se.range||(se.range=re.getWordRangeAtPosition(G)),se.range||(se.range=new y.Range(G,G)),S.Hover.from(se)})}}class v{constructor($,Q){this._documents=$,this._provider=Q}provideEvaluatableExpression($,Q,te){const re=this._documents.getDocument($),G=S.Position.to(Q);return k.asPromise(()=>this._provider.provideEvaluatableExpression(re,G,te)).then(se=>{if(se)return S.EvaluatableExpression.from(se)})}}class A{constructor($,Q){this._documents=$,this._provider=Q}provideInlineValues($,Q,te,re){const G=this._documents.getDocument($);return k.asPromise(()=>this._provider.provideInlineValues(G,S.Range.to(Q),S.InlineValueContext.to(te),re)).then(se=>{if(Array.isArray(se))return se.map(he=>S.InlineValue.from(he))})}}class P{constructor($,Q){this._documents=$,this._provider=Q}provideDocumentHighlights($,Q,te){const re=this._documents.getDocument($),G=S.Position.to(Q);return k.asPromise(()=>this._provider.provideDocumentHighlights(re,G,te)).then(se=>{if(Array.isArray(se))return se.map(S.DocumentHighlight.from)})}}class a{constructor($,Q){this._documents=$,this._provider=Q}provideLinkedEditingRanges($,Q,te){const re=this._documents.getDocument($),G=S.Position.to(Q);return k.asPromise(()=>this._provider.provideLinkedEditingRanges(re,G,te)).then(se=>{if(se&&Array.isArray(se.ranges))return{ranges:n.coalesce(se.ranges.map(S.Range.from)),wordPattern:se.wordPattern}})}}class F{constructor($,Q){this._documents=$,this._provider=Q}provideReferences($,Q,te,re){const G=this._documents.getDocument($),se=S.Position.to(Q);return k.asPromise(()=>this._provider.provideReferences(G,se,te,re)).then(he=>{if(Array.isArray(he))return he.map(S.location.from)})}}class N{constructor($,Q,te,re,G,se,he){this._documents=$,this._commands=Q,this._diagnostics=te,this._provider=re,this._logService=G,this._extension=se,this._apiDeprecation=he,this._cache=new b.Cache("CodeAction"),this._disposables=new Map}provideCodeActions($,Q,te,re){const G=this._documents.getDocument($),se=o.Selection.isISelection(Q)?S.Selection.to(Q):S.Range.to(Q),he=[];for(const xe of this._diagnostics.getDiagnostics($))if(se.intersection(xe.range)&&he.push(xe)>N._maxCodeActionsPerFile)break;const Ae={diagnostics:he,only:te.only?new y.CodeActionKind(te.only):void 0,triggerKind:S.CodeActionTriggerKind.to(te.trigger)};return k.asPromise(()=>this._provider.provideCodeActions(G,se,Ae,re)).then(xe=>{var ve;if(!n.isNonEmptyArray(xe)||re.isCancellationRequested)return;const je=this._cache.add(xe),V=new h.DisposableStore;this._disposables.set(je,V);const ee=[];for(let me=0;me<xe.length;me++){const Re=xe[me];!Re||(N._isCommand(Re)?(this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),ee.push({_isSynthetic:!0,title:Re.title,command:this._commands.toInternal(Re,V)})):(Ae.only&&(Re.kind?Ae.only.contains(Re.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Ae.only.value} 'requested but returned code action is of kind '${Re.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Ae.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),ee.push({cacheId:[je,me],title:Re.title,command:Re.command&&this._commands.toInternal(Re.command,V),diagnostics:Re.diagnostics&&Re.diagnostics.map(S.Diagnostic.from),edit:Re.edit&&S.WorkspaceEdit.from(Re.edit),kind:Re.kind&&Re.kind.value,isPreferred:Re.isPreferred,disabled:(ve=Re.disabled)===null||ve===void 0?void 0:ve.reason})))}return{cacheId:je,actions:ee}})}async resolveCodeAction($,Q){var te;const[re,G]=$,se=this._cache.get(re,G);if(!se||N._isCommand(se)||!this._provider.resolveCodeAction)return;const he=(te=await this._provider.resolveCodeAction(se,Q))!==null&&te!==void 0?te:se;return(he==null?void 0:he.edit)?S.WorkspaceEdit.from(he.edit):void 0}releaseCodeActions($){var Q;(Q=this._disposables.get($))===null||Q===void 0||Q.dispose(),this._disposables.delete($),this._cache.delete($)}static _isCommand($){return typeof $.command=="string"&&typeof $.title=="string"}}N._maxCodeActionsPerFile=1e3;class W{constructor($,Q){this._documents=$,this._provider=Q}provideDocumentFormattingEdits($,Q,te){const re=this._documents.getDocument($);return k.asPromise(()=>this._provider.provideDocumentFormattingEdits(re,Q,te)).then(G=>{if(Array.isArray(G))return G.map(S.TextEdit.from)})}}class le{constructor($,Q){this._documents=$,this._provider=Q}provideDocumentRangeFormattingEdits($,Q,te,re){const G=this._documents.getDocument($),se=S.Range.to(Q);return k.asPromise(()=>this._provider.provideDocumentRangeFormattingEdits(G,se,te,re)).then(he=>{if(Array.isArray(he))return he.map(S.TextEdit.from)})}}class fe{constructor($,Q){this._documents=$,this._provider=Q,this.autoFormatTriggerCharacters=[]}provideOnTypeFormattingEdits($,Q,te,re,G){const se=this._documents.getDocument($),he=S.Position.to(Q);return k.asPromise(()=>this._provider.provideOnTypeFormattingEdits(se,he,te,re,G)).then(Ae=>{if(Array.isArray(Ae))return Ae.map(S.TextEdit.from)})}}class Y{constructor($,Q){this._provider=$,this._logService=Q,this._symbolCache=new Map,this._resultCache=new Map}provideWorkspaceSymbols($,Q){const te=D.IdObject.mixin({symbols:[]});return k.asPromise(()=>this._provider.provideWorkspaceSymbols($,Q)).then(re=>{if(n.isNonEmptyArray(re))for(const G of re){if(!G)continue;if(!G.name){this._logService.warn("INVALID SymbolInformation, lacks name",G);continue}const se=D.IdObject.mixin(S.WorkspaceSymbol.from(G));this._symbolCache.set(se._id,G),te.symbols.push(se)}}).then(()=>(te.symbols.length>0&&this._resultCache.set(te._id,[te.symbols[0]._id,te.symbols[te.symbols.length-1]._id]),te))}async resolveWorkspaceSymbol($,Q){if(typeof this._provider.resolveWorkspaceSymbol!="function")return $;const te=this._symbolCache.get($._id);if(te){const re=await k.asPromise(()=>this._provider.resolveWorkspaceSymbol(te,Q));return re&&T.mixin($,S.WorkspaceSymbol.from(re),!0)}}releaseWorkspaceSymbols($){const Q=this._resultCache.get($);if(Q){for(let[te,re]=Q;te<=re;te++)this._symbolCache.delete(te);this._resultCache.delete($)}}}class H{constructor($,Q,te){this._documents=$,this._provider=Q,this._logService=te}static supportsResolving($){return typeof $.prepareRename=="function"}provideRenameEdits($,Q,te,re){const G=this._documents.getDocument($),se=S.Position.to(Q);return k.asPromise(()=>this._provider.provideRenameEdits(G,se,te,re)).then(he=>{if(!!he)return S.WorkspaceEdit.from(he)},he=>{const Ae=H._asMessage(he);return Ae?{rejectReason:Ae,edits:void 0}:Promise.reject(he)})}resolveRenameLocation($,Q,te){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const re=this._documents.getDocument($),G=S.Position.to(Q);return k.asPromise(()=>this._provider.prepareRename(re,G,te)).then(se=>{let he,Ae;if(y.Range.isRange(se)?(he=se,Ae=re.getText(se)):I.isObject(se)&&(he=se.range,Ae=se.placeholder),!!he){if(he.start.line>G.line||he.end.line<G.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:S.Range.from(he),text:Ae}}},se=>{const he=H._asMessage(se);return he?{rejectReason:he,range:void 0,text:void 0}:Promise.reject(se)})}static _asMessage($){return typeof $=="string"?$:$ instanceof Error&&typeof $.message=="string"?$.message:void 0}}class J{constructor($,Q){this.resultId=$,this.tokens=Q}}class R{constructor($,Q){this._documents=$,this._provider=Q,this._nextResultId=1,this._previousResults=new Map}provideDocumentSemanticTokens($,Q,te){const re=this._documents.getDocument($),G=Q!==0?this._previousResults.get(Q):null;return k.asPromise(()=>G&&typeof G.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?this._provider.provideDocumentSemanticTokensEdits(re,G.resultId,te):this._provider.provideDocumentSemanticTokens(re,te)).then(se=>(G&&this._previousResults.delete(Q),se?(se=R._fixProvidedSemanticTokens(se),this._send(R._convertToEdits(G,se),se)):null))}async releaseDocumentSemanticColoring($){this._previousResults.delete($)}static _fixProvidedSemanticTokens($){return R._isSemanticTokens($)?R._isCorrectSemanticTokens($)?$:new y.SemanticTokens(new Uint32Array($.data),$.resultId):R._isSemanticTokensEdits($)?R._isCorrectSemanticTokensEdits($)?$:new y.SemanticTokensEdits($.edits.map(Q=>new y.SemanticTokensEdit(Q.start,Q.deleteCount,Q.data?new Uint32Array(Q.data):Q.data)),$.resultId):$}static _isSemanticTokens($){return $&&!!$.data}static _isCorrectSemanticTokens($){return $.data instanceof Uint32Array}static _isSemanticTokensEdits($){return $&&Array.isArray($.edits)}static _isCorrectSemanticTokensEdits($){for(const Q of $.edits)if(!(Q.data instanceof Uint32Array))return!1;return!0}static _convertToEdits($,Q){if(!R._isSemanticTokens(Q)||!$||!$.tokens)return Q;const te=$.tokens,re=te.length,G=Q.data,se=G.length;let he=0;const Ae=Math.min(re,se);for(;he<Ae&&te[he]===G[he];)he++;if(he===re&&he===se)return new y.SemanticTokensEdits([],Q.resultId);let xe=0;const ve=Ae-he;for(;xe<ve&&te[re-xe-1]===G[se-xe-1];)xe++;return new y.SemanticTokensEdits([{start:he,deleteCount:re-he-xe,data:G.subarray(he,se-xe)}],Q.resultId)}_send($,Q){if(R._isSemanticTokens($)){const te=this._nextResultId++;return this._previousResults.set(te,new J($.resultId,$.data)),d.encodeSemanticTokensDto({id:te,type:"full",data:$.data})}if(R._isSemanticTokensEdits($)){const te=this._nextResultId++;return R._isSemanticTokens(Q)?this._previousResults.set(te,new J(Q.resultId,Q.data)):this._previousResults.set(te,new J($.resultId)),d.encodeSemanticTokensDto({id:te,type:"delta",deltas:($.edits||[]).map(re=>({start:re.start,deleteCount:re.deleteCount,data:re.data}))})}return null}}e.DocumentSemanticTokensAdapter=R;class B{constructor($,Q){this._documents=$,this._provider=Q}provideDocumentRangeSemanticTokens($,Q,te){const re=this._documents.getDocument($);return k.asPromise(()=>this._provider.provideDocumentRangeSemanticTokens(re,S.Range.to(Q),te)).then(G=>G?this._send(G):null)}_send($){return d.encodeSemanticTokensDto({id:0,type:"full",data:$.data})}}e.DocumentRangeSemanticTokensAdapter=B;class M{constructor($,Q,te,re,G){this._documents=$,this._commands=Q,this._provider=te,this._apiDeprecation=re,this._extension=G,this._cache=new b.Cache("CompletionItem"),this._disposables=new Map}static supportsResolving($){return typeof $.resolveCompletionItem=="function"}async provideCompletionItems($,Q,te,re){const G=this._documents.getDocument($),se=S.Position.to(Q),he=G.getWordRangeAtPosition(se)||new y.Range(se,se),Ae=he.with({end:se}),xe=new p.StopWatch(!0),ve=await k.asPromise(()=>this._provider.provideCompletionItems(G,se,re,S.CompletionContext.to(te)));if(!ve||re.isCancellationRequested)return;const je=Array.isArray(ve)?new y.CompletionList(ve):ve,V=M.supportsResolving(this._provider)?this._cache.add(je.items):this._cache.add([]),ee=new h.DisposableStore;this._disposables.set(V,ee);const me=[],Re={x:V,b:me,a:{replace:S.Range.from(he),insert:S.Range.from(Ae)},c:je.isIncomplete||void 0,d:xe.elapsed()};for(let Le=0;Le<je.items.length;Le++){const qe=je.items[Le],Se=this._convertCompletionItem(qe,[V,Le],Ae,he);me.push(Se)}return Re}async resolveCompletionItem($,Q){if(typeof this._provider.resolveCompletionItem!="function")return;const te=this._cache.get(...$);if(!te)return;const re=await k.asPromise(()=>this._provider.resolveCompletionItem(te,Q));if(!!re)return this._convertCompletionItem(re,$)}releaseCompletionItems($){var Q;(Q=this._disposables.get($))===null||Q===void 0||Q.dispose(),this._disposables.delete($),this._cache.delete($)}_convertCompletionItem($,Q,te,re){var G;const se=this._disposables.get(Q[0]);if(!se)throw Error("DisposableStore is missing...");const he={x:Q,a:(G=$.label)!==null&&G!==void 0?G:"",o:$.label2,b:$.kind!==void 0?S.CompletionItemKind.from($.kind):void 0,n:$.tags&&$.tags.map(S.CompletionItemTag.from),c:$.detail,d:typeof $.documentation=="undefined"?void 0:S.MarkdownString.fromStrict($.documentation),e:$.sortText!==$.label?$.sortText:void 0,f:$.filterText!==$.label?$.filterText:void 0,g:$.preselect||void 0,i:$.keepWhitespace?1:0,k:$.commitCharacters,l:$.additionalTextEdits&&$.additionalTextEdits.map(S.TextEdit.from),m:this._commands.toInternal($.command,se)};$.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),he.h=$.textEdit.newText):typeof $.insertText=="string"?he.h=$.insertText:$.insertText instanceof y.SnippetString&&(he.h=$.insertText.value,he.i|=4);let Ae;return $.textEdit?Ae=$.textEdit.range:$.range&&(Ae=$.range),y.Range.isRange(Ae)?he.j=S.Range.from(Ae):Ae&&(!(te==null?void 0:te.isEqual(Ae.inserting))||!(re==null?void 0:re.isEqual(Ae.replacing)))&&(he.j={insert:S.Range.from(Ae.inserting),replace:S.Range.from(Ae.replacing)}),he}}class x{constructor($,Q,te){this._documents=$,this._provider=Q,this._commands=te,this._cache=new b.Cache("InlineCompletionItem"),this._disposables=new Map}async provideInlineCompletions($,Q,te,re){const G=this._documents.getDocument($),se=S.Position.to(Q),he=await k.asPromise(()=>this._provider.provideInlineCompletionItems(G,se,te,re));if(!he||re.isCancellationRequested)return;const Ae=I.isArray(he)?{items:he}:he,xe=this._cache.add(Ae.items);let ve;return{pid:xe,items:Ae.items.map((je,V)=>{let ee;return je.command&&(ve||(ve=new h.DisposableStore,this._disposables.set(xe,ve)),ee=this._commands.toInternal(je.command,ve)),{text:je.text,range:je.range?S.Range.from(je.range):void 0,command:ee,idx:V}})}}disposeCompletions($){this._cache.delete($);const Q=this._disposables.get($);Q&&Q.clear(),this._disposables.delete($)}handleDidShowCompletionItem($,Q){const te=this._cache.get($,Q);te&&q.get(this._provider).fireOnDidShowCompletionItem({completionItem:te})}}class q{constructor(){this._onDidShowCompletionItemEmitter=new u.Emitter,this.onDidShowCompletionItem=this._onDidShowCompletionItemEmitter.event}static get($){let Q=q.map.get($);return Q||(Q=new q,q.map.set($,Q)),Q}fireOnDidShowCompletionItem($){this._onDidShowCompletionItemEmitter.fire($)}}e.InlineCompletionController=q,q.map=new WeakMap;class z{constructor($,Q){this._documents=$,this._provider=Q,this._cache=new b.Cache("SignatureHelp")}provideSignatureHelp($,Q,te,re){const G=this._documents.getDocument($),se=S.Position.to(Q),he=this.reviveContext(te);return k.asPromise(()=>this._provider.provideSignatureHelp(G,se,re,he)).then(Ae=>{if(Ae){const xe=this._cache.add([Ae]);return Object.assign(Object.assign({},S.SignatureHelp.from(Ae)),{id:xe})}})}reviveContext($){let Q;if($.activeSignatureHelp){const te=S.SignatureHelp.to($.activeSignatureHelp),re=this._cache.get($.activeSignatureHelp.id,0);re?(Q=re,Q.activeSignature=te.activeSignature,Q.activeParameter=te.activeParameter):Q=te}return Object.assign(Object.assign({},$),{activeSignatureHelp:Q})}releaseSignatureHelp($){this._cache.delete($)}}class oe{constructor($,Q){this._documents=$,this._provider=Q}provideInlayHints($,Q,te){const re=this._documents.getDocument($);return k.asPromise(()=>this._provider.provideInlayHints(re,S.Range.to(Q),te)).then(G=>G?{hints:G.map(S.InlayHint.from)}:void 0)}}class pe{constructor($,Q){this._documents=$,this._provider=Q,this._cache=new b.Cache("DocumentLink")}async provideLinks($,Q){const te=this._documents.getDocument($),re=await k.asPromise(()=>this._provider.provideDocumentLinks(te,Q));if(!(!Array.isArray(re)||re.length===0)&&!Q.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:re.filter(pe._validateLink).map(S.DocumentLink.from)};{const G=this._cache.add(re),se={links:[],id:G};for(let he=0;he<re.length;he++){if(!pe._validateLink(re[he]))continue;const Ae=S.DocumentLink.from(re[he]);Ae.cacheId=[G,he],se.links.push(Ae)}return se}}}static _validateLink($){return $.target&&$.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink($,Q){if(typeof this._provider.resolveDocumentLink!="function")return;const te=this._cache.get(...$);if(!te)return;const re=await k.asPromise(()=>this._provider.resolveDocumentLink(te,Q));if(!(!re||!pe._validateLink(re)))return S.DocumentLink.from(re)}releaseLinks($){this._cache.delete($)}}class Te{constructor($,Q){this._documents=$,this._provider=Q}provideColors($,Q){const te=this._documents.getDocument($);return k.asPromise(()=>this._provider.provideDocumentColors(te,Q)).then(re=>Array.isArray(re)?re.map(se=>({color:S.Color.from(se.color),range:S.Range.from(se.range)})):[])}provideColorPresentations($,Q,te){const re=this._documents.getDocument($),G=S.Range.to(Q.range),se=S.Color.to(Q.color);return k.asPromise(()=>this._provider.provideColorPresentations(se,{document:re,range:G},te)).then(he=>{if(!!Array.isArray(he))return he.map(S.ColorPresentation.from)})}}class Be{constructor($,Q){this._documents=$,this._provider=Q}provideFoldingRanges($,Q,te){const re=this._documents.getDocument($);return k.asPromise(()=>this._provider.provideFoldingRanges(re,Q,te)).then(G=>{if(!!Array.isArray(G))return G.map(S.FoldingRange.from)})}}class Fe{constructor($,Q,te){this._documents=$,this._provider=Q,this._logService=te}provideSelectionRanges($,Q,te){const re=this._documents.getDocument($),G=Q.map(S.Position.to);return k.asPromise(()=>this._provider.provideSelectionRanges(re,G,te)).then(se=>{if(!n.isNonEmptyArray(se))return[];if(se.length!==G.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const he=[];for(let Ae=0;Ae<G.length;Ae++){const xe=[];he.push(xe);let ve=G[Ae],je=se[Ae];for(;;){if(!je.range.contains(ve))throw new Error("INVALID selection range, must contain the previous range");if(xe.push(S.SelectionRange.from(je)),!je.parent)break;ve=je.range,je=je.parent}}return he})}}class We{constructor($,Q){this._documents=$,this._provider=Q,this._idPool=new c.IdGenerator(""),this._cache=new Map}async prepareSession($,Q,te){const re=this._documents.getDocument($),G=S.Position.to(Q),se=await this._provider.prepareCallHierarchy(re,G,te);if(!se)return;const he=this._idPool.nextId();return this._cache.set(he,new Map),Array.isArray(se)?se.map(Ae=>this._cacheAndConvertItem(he,Ae)):[this._cacheAndConvertItem(he,se)]}async provideCallsTo($,Q,te){const re=this._itemFromCache($,Q);if(!re)throw new Error("missing call hierarchy item");const G=await this._provider.provideCallHierarchyIncomingCalls(re,te);if(!!G)return G.map(se=>({from:this._cacheAndConvertItem($,se.from),fromRanges:se.fromRanges.map(he=>S.Range.from(he))}))}async provideCallsFrom($,Q,te){const re=this._itemFromCache($,Q);if(!re)throw new Error("missing call hierarchy item");const G=await this._provider.provideCallHierarchyOutgoingCalls(re,te);if(!!G)return G.map(se=>({to:this._cacheAndConvertItem($,se.to),fromRanges:se.fromRanges.map(he=>S.Range.from(he))}))}releaseSession($){this._cache.delete($)}_cacheAndConvertItem($,Q){var te;const re=this._cache.get($),G={_sessionId:$,_itemId:re.size.toString(36),name:Q.name,detail:Q.detail,kind:S.SymbolKind.from(Q.kind),uri:Q.uri,range:S.Range.from(Q.range),selectionRange:S.Range.from(Q.selectionRange),tags:(te=Q.tags)===null||te===void 0?void 0:te.map(S.SymbolTag.from)};return re.set(G._itemId,Q),G}_itemFromCache($,Q){const te=this._cache.get($);return te==null?void 0:te.get(Q)}}class Qe{constructor($,Q){this.adapter=$,this.extension=Q}}class Ge{constructor($,Q,te,re,G,se,he){this._adapter=new Map,this._uriTransformer=Q,this._proxy=$.getProxy(D.MainContext.MainThreadLanguageFeatures),this._documents=te,this._commands=re,this._diagnostics=G,this._logService=se,this._apiDeprecation=he}_transformDocumentSelector($){return n.coalesce(n.asArray($).map(Q=>this._doTransformDocumentSelector(Q)))}_doTransformDocumentSelector($){if(typeof $=="string")return{$serialized:!0,language:$};if($)return{$serialized:!0,language:$.language,scheme:this._transformScheme($.scheme),pattern:typeof $.pattern=="undefined"?void 0:S.GlobPattern.from($.pattern),exclusive:$.exclusive}}_transformScheme($){return this._uriTransformer&&typeof $=="string"?this._uriTransformer.transformOutgoingScheme($):$}_createDisposable($){return new y.Disposable(()=>{this._adapter.delete($),this._proxy.$unregister($)})}_nextHandle(){return Ge._handlePool++}_withAdapter($,Q,te,re,G=!1){const se=this._adapter.get($);if(!se)return Promise.resolve(re);if(se.adapter instanceof Q){let he;se.extension&&(he=Date.now(),this._logService.trace(`[${se.extension.identifier.value}] INVOKE provider '${Q.name}'`));const Ae=te(se.adapter,se.extension),xe=se.extension;return xe&&Promise.resolve(Ae).then(()=>this._logService.trace(`[${xe.identifier.value}] provider DONE after ${Date.now()-he}ms`),ve=>{G&&ve instanceof w.CancellationError||(this._logService.error(`[${xe.identifier.value}] provider FAILED`),this._logService.error(ve))}),Ae}return Promise.reject(new Error("no adapter found"))}_addNewAdapter($,Q){const te=this._nextHandle();return this._adapter.set(te,new Qe($,Q)),te}static _extLabel($){return $.displayName||$.name}registerDocumentSymbolProvider($,Q,te,re){const G=this._addNewAdapter(new f(this._documents,te),$),se=re&&re.label||Ge._extLabel($);return this._proxy.$registerDocumentSymbolProvider(G,this._transformDocumentSelector(Q),se),this._createDisposable(G)}$provideDocumentSymbols($,Q,te){return this._withAdapter($,f,re=>re.provideDocumentSymbols(m.URI.revive(Q),te),void 0)}registerCodeLensProvider($,Q,te){const re=this._nextHandle(),G=typeof te.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(re,new Qe(new g(this._documents,this._commands.converter,te),$)),this._proxy.$registerCodeLensSupport(re,this._transformDocumentSelector(Q),G);let se=this._createDisposable(re);if(G!==void 0){const he=te.onDidChangeCodeLenses(Ae=>this._proxy.$emitCodeLensEvent(G));se=y.Disposable.from(se,he)}return se}$provideCodeLenses($,Q,te){return this._withAdapter($,g,re=>re.provideCodeLenses(m.URI.revive(Q),te),void 0)}$resolveCodeLens($,Q,te){return this._withAdapter($,g,re=>re.resolveCodeLens(Q,te),void 0)}$releaseCodeLenses($,Q){this._withAdapter($,g,te=>Promise.resolve(te.releaseCodeLenses(Q)),void 0)}registerDefinitionProvider($,Q,te){const re=this._addNewAdapter(new i(this._documents,te),$);return this._proxy.$registerDefinitionSupport(re,this._transformDocumentSelector(Q)),this._createDisposable(re)}$provideDefinition($,Q,te,re){return this._withAdapter($,i,G=>G.provideDefinition(m.URI.revive(Q),te,re),[])}registerDeclarationProvider($,Q,te){const re=this._addNewAdapter(new s(this._documents,te),$);return this._proxy.$registerDeclarationSupport(re,this._transformDocumentSelector(Q)),this._createDisposable(re)}$provideDeclaration($,Q,te,re){return this._withAdapter($,s,G=>G.provideDeclaration(m.URI.revive(Q),te,re),[])}registerImplementationProvider($,Q,te){const re=this._addNewAdapter(new r(this._documents,te),$);return this._proxy.$registerImplementationSupport(re,this._transformDocumentSelector(Q)),this._createDisposable(re)}$provideImplementation($,Q,te,re){return this._withAdapter($,r,G=>G.provideImplementation(m.URI.revive(Q),te,re),[])}registerTypeDefinitionProvider($,Q,te){const re=this._addNewAdapter(new l(this._documents,te),$);return this._proxy.$registerTypeDefinitionSupport(re,this._transformDocumentSelector(Q)),this._createDisposable(re)}$provideTypeDefinition($,Q,te,re){return this._withAdapter($,l,G=>G.provideTypeDefinition(m.URI.revive(Q),te,re),[])}registerHoverProvider($,Q,te,re){const G=this._addNewAdapter(new E(this._documents,te),$);return this._proxy.$registerHoverProvider(G,this._transformDocumentSelector(Q)),this._createDisposable(G)}$provideHover($,Q,te,re){return this._withAdapter($,E,G=>G.provideHover(m.URI.revive(Q),te,re),void 0)}registerEvaluatableExpressionProvider($,Q,te,re){const G=this._addNewAdapter(new v(this._documents,te),$);return this._proxy.$registerEvaluatableExpressionProvider(G,this._transformDocumentSelector(Q)),this._createDisposable(G)}$provideEvaluatableExpression($,Q,te,re){return this._withAdapter($,v,G=>G.provideEvaluatableExpression(m.URI.revive(Q),te,re),void 0)}registerInlineValuesProvider($,Q,te,re){const G=typeof te.onDidChangeInlineValues=="function"?this._nextHandle():void 0,se=this._addNewAdapter(new A(this._documents,te),$);this._proxy.$registerInlineValuesProvider(se,this._transformDocumentSelector(Q),G);let he=this._createDisposable(se);if(G!==void 0){const Ae=te.onDidChangeInlineValues(xe=>this._proxy.$emitInlineValuesEvent(G));he=y.Disposable.from(he,Ae)}return he}$provideInlineValues($,Q,te,re,G){return this._withAdapter($,A,se=>se.provideInlineValues(m.URI.revive(Q),te,re,G),void 0)}registerDocumentHighlightProvider($,Q,te){const re=this._addNewAdapter(new P(this._documents,te),$);return this._proxy.$registerDocumentHighlightProvider(re,this._transformDocumentSelector(Q)),this._createDisposable(re)}$provideDocumentHighlights($,Q,te,re){return this._withAdapter($,P,G=>G.provideDocumentHighlights(m.URI.revive(Q),te,re),void 0)}registerLinkedEditingRangeProvider($,Q,te){const re=this._addNewAdapter(new a(this._documents,te),$);return this._proxy.$registerLinkedEditingRangeProvider(re,this._transformDocumentSelector(Q)),this._createDisposable(re)}$provideLinkedEditingRanges($,Q,te,re){return this._withAdapter($,a,async G=>{const se=await G.provideLinkedEditingRanges(m.URI.revive(Q),te,re);if(se)return{ranges:se.ranges,wordPattern:se.wordPattern?Ge._serializeRegExp(se.wordPattern):void 0}},void 0)}registerReferenceProvider($,Q,te){const re=this._addNewAdapter(new F(this._documents,te),$);return this._proxy.$registerReferenceSupport(re,this._transformDocumentSelector(Q)),this._createDisposable(re)}$provideReferences($,Q,te,re,G){return this._withAdapter($,F,se=>se.provideReferences(m.URI.revive(Q),te,re,G),void 0)}registerCodeActionProvider($,Q,te,re){var G,se;const he=new h.DisposableStore,Ae=this._addNewAdapter(new N(this._documents,this._commands.converter,this._diagnostics,te,this._logService,$,this._apiDeprecation),$);return this._proxy.$registerQuickFixSupport(Ae,this._transformDocumentSelector(Q),{providedKinds:(G=re==null?void 0:re.providedCodeActionKinds)===null||G===void 0?void 0:G.map(xe=>xe.value),documentation:(se=re==null?void 0:re.documentation)===null||se===void 0?void 0:se.map(xe=>({kind:xe.kind.value,command:this._commands.converter.toInternal(xe.command,he)}))},Ge._extLabel($),Boolean(te.resolveCodeAction)),he.add(this._createDisposable(Ae)),he}$provideCodeActions($,Q,te,re,G){return this._withAdapter($,N,se=>se.provideCodeActions(m.URI.revive(Q),te,re,G),void 0)}$resolveCodeAction($,Q,te){return this._withAdapter($,N,re=>re.resolveCodeAction(Q,te),void 0)}$releaseCodeActions($,Q){this._withAdapter($,N,te=>Promise.resolve(te.releaseCodeActions(Q)),void 0)}registerDocumentFormattingEditProvider($,Q,te){const re=this._addNewAdapter(new W(this._documents,te),$);return this._proxy.$registerDocumentFormattingSupport(re,this._transformDocumentSelector(Q),$.identifier,$.displayName||$.name),this._createDisposable(re)}$provideDocumentFormattingEdits($,Q,te,re){return this._withAdapter($,W,G=>G.provideDocumentFormattingEdits(m.URI.revive(Q),te,re),void 0)}registerDocumentRangeFormattingEditProvider($,Q,te){const re=this._addNewAdapter(new le(this._documents,te),$);return this._proxy.$registerRangeFormattingSupport(re,this._transformDocumentSelector(Q),$.identifier,$.displayName||$.name),this._createDisposable(re)}$provideDocumentRangeFormattingEdits($,Q,te,re,G){return this._withAdapter($,le,se=>se.provideDocumentRangeFormattingEdits(m.URI.revive(Q),te,re,G),void 0)}registerOnTypeFormattingEditProvider($,Q,te,re){const G=this._addNewAdapter(new fe(this._documents,te),$);return this._proxy.$registerOnTypeFormattingSupport(G,this._transformDocumentSelector(Q),re,$.identifier),this._createDisposable(G)}$provideOnTypeFormattingEdits($,Q,te,re,G,se){return this._withAdapter($,fe,he=>he.provideOnTypeFormattingEdits(m.URI.revive(Q),te,re,G,se),void 0)}registerWorkspaceSymbolProvider($,Q){const te=this._addNewAdapter(new Y(Q,this._logService),$);return this._proxy.$registerNavigateTypeSupport(te),this._createDisposable(te)}$provideWorkspaceSymbols($,Q,te){return this._withAdapter($,Y,re=>re.provideWorkspaceSymbols(Q,te),{symbols:[]})}$resolveWorkspaceSymbol($,Q,te){return this._withAdapter($,Y,re=>re.resolveWorkspaceSymbol(Q,te),void 0)}$releaseWorkspaceSymbols($,Q){this._withAdapter($,Y,te=>te.releaseWorkspaceSymbols(Q),void 0)}registerRenameProvider($,Q,te){const re=this._addNewAdapter(new H(this._documents,te,this._logService),$);return this._proxy.$registerRenameSupport(re,this._transformDocumentSelector(Q),H.supportsResolving(te)),this._createDisposable(re)}$provideRenameEdits($,Q,te,re,G){return this._withAdapter($,H,se=>se.provideRenameEdits(m.URI.revive(Q),te,re,G),void 0)}$resolveRenameLocation($,Q,te,re){return this._withAdapter($,H,G=>G.resolveRenameLocation(m.URI.revive(Q),te,re),void 0)}registerDocumentSemanticTokensProvider($,Q,te,re){const G=this._nextHandle(),se=typeof te.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._adapter.set(G,new Qe(new R(this._documents,te),$)),this._proxy.$registerDocumentSemanticTokensProvider(G,this._transformDocumentSelector(Q),re,se);let he=this._createDisposable(G);if(se){const Ae=te.onDidChangeSemanticTokens(xe=>this._proxy.$emitDocumentSemanticTokensEvent(se));he=y.Disposable.from(he,Ae)}return he}$provideDocumentSemanticTokens($,Q,te,re){return this._withAdapter($,R,G=>G.provideDocumentSemanticTokens(m.URI.revive(Q),te,re),null,!0)}$releaseDocumentSemanticTokens($,Q){this._withAdapter($,R,te=>te.releaseDocumentSemanticColoring(Q),void 0)}registerDocumentRangeSemanticTokensProvider($,Q,te,re){const G=this._addNewAdapter(new B(this._documents,te),$);return this._proxy.$registerDocumentRangeSemanticTokensProvider(G,this._transformDocumentSelector(Q),re),this._createDisposable(G)}$provideDocumentRangeSemanticTokens($,Q,te,re){return this._withAdapter($,B,G=>G.provideDocumentRangeSemanticTokens(m.URI.revive(Q),te,re),null,!0)}registerCompletionItemProvider($,Q,te,re){const G=this._addNewAdapter(new M(this._documents,this._commands.converter,te,this._apiDeprecation,$),$);return this._proxy.$registerSuggestSupport(G,this._transformDocumentSelector(Q),re,M.supportsResolving(te),`${$.identifier.value}(${re.join("")})`),this._createDisposable(G)}$provideCompletionItems($,Q,te,re,G){return this._withAdapter($,M,se=>se.provideCompletionItems(m.URI.revive(Q),te,re,G),void 0)}$resolveCompletionItem($,Q,te){return this._withAdapter($,M,re=>re.resolveCompletionItem(Q,te),void 0)}$releaseCompletionItems($,Q){this._withAdapter($,M,te=>te.releaseCompletionItems(Q),void 0)}registerInlineCompletionsProvider($,Q,te){const re=this._addNewAdapter(new x(this._documents,te,this._commands.converter),$);return this._proxy.$registerInlineCompletionsSupport(re,this._transformDocumentSelector(Q)),this._createDisposable(re)}$provideInlineCompletions($,Q,te,re,G){return this._withAdapter($,x,se=>se.provideInlineCompletions(m.URI.revive(Q),te,re,G),void 0)}$handleInlineCompletionDidShow($,Q,te){this._withAdapter($,x,async re=>{re.handleDidShowCompletionItem(Q,te)},void 0)}$freeInlineCompletionsList($,Q){this._withAdapter($,x,async te=>{te.disposeCompletions(Q)},void 0)}registerSignatureHelpProvider($,Q,te,re){const G=Array.isArray(re)?{triggerCharacters:re,retriggerCharacters:[]}:re,se=this._addNewAdapter(new z(this._documents,te),$);return this._proxy.$registerSignatureHelpProvider(se,this._transformDocumentSelector(Q),G),this._createDisposable(se)}$provideSignatureHelp($,Q,te,re,G){return this._withAdapter($,z,se=>se.provideSignatureHelp(m.URI.revive(Q),te,re,G),void 0)}$releaseSignatureHelp($,Q){this._withAdapter($,z,te=>te.releaseSignatureHelp(Q),void 0)}registerInlayHintsProvider($,Q,te){const re=typeof te.onDidChangeInlayHints=="function"?this._nextHandle():void 0,G=this._addNewAdapter(new oe(this._documents,te),$);this._proxy.$registerInlayHintsProvider(G,this._transformDocumentSelector(Q),re);let se=this._createDisposable(G);if(re!==void 0){const he=te.onDidChangeInlayHints(Ae=>this._proxy.$emitInlayHintsEvent(re));se=y.Disposable.from(se,he)}return se}$provideInlayHints($,Q,te,re){return this._withAdapter($,oe,G=>G.provideInlayHints(m.URI.revive(Q),te,re),void 0)}registerDocumentLinkProvider($,Q,te){const re=this._addNewAdapter(new pe(this._documents,te),$);return this._proxy.$registerDocumentLinkProvider(re,this._transformDocumentSelector(Q),typeof te.resolveDocumentLink=="function"),this._createDisposable(re)}$provideDocumentLinks($,Q,te){return this._withAdapter($,pe,re=>re.provideLinks(m.URI.revive(Q),te),void 0)}$resolveDocumentLink($,Q,te){return this._withAdapter($,pe,re=>re.resolveLink(Q,te),void 0)}$releaseDocumentLinks($,Q){this._withAdapter($,pe,te=>te.releaseLinks(Q),void 0)}registerColorProvider($,Q,te){const re=this._addNewAdapter(new Te(this._documents,te),$);return this._proxy.$registerDocumentColorProvider(re,this._transformDocumentSelector(Q)),this._createDisposable(re)}$provideDocumentColors($,Q,te){return this._withAdapter($,Te,re=>re.provideColors(m.URI.revive(Q),te),[])}$provideColorPresentations($,Q,te,re){return this._withAdapter($,Te,G=>G.provideColorPresentations(m.URI.revive(Q),te,re),void 0)}registerFoldingRangeProvider($,Q,te){const re=this._nextHandle(),G=typeof te.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(re,new Qe(new Be(this._documents,te),$)),this._proxy.$registerFoldingRangeProvider(re,this._transformDocumentSelector(Q),G);let se=this._createDisposable(re);if(G!==void 0){const he=te.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(G));se=y.Disposable.from(se,he)}return se}$provideFoldingRanges($,Q,te,re){return this._withAdapter($,Be,G=>G.provideFoldingRanges(m.URI.revive(Q),te,re),void 0)}registerSelectionRangeProvider($,Q,te){const re=this._addNewAdapter(new Fe(this._documents,te,this._logService),$);return this._proxy.$registerSelectionRangeProvider(re,this._transformDocumentSelector(Q)),this._createDisposable(re)}$provideSelectionRanges($,Q,te,re){return this._withAdapter($,Fe,G=>G.provideSelectionRanges(m.URI.revive(Q),te,re),[])}registerCallHierarchyProvider($,Q,te){const re=this._addNewAdapter(new We(this._documents,te),$);return this._proxy.$registerCallHierarchyProvider(re,this._transformDocumentSelector(Q)),this._createDisposable(re)}$prepareCallHierarchy($,Q,te,re){return this._withAdapter($,We,G=>Promise.resolve(G.prepareSession(m.URI.revive(Q),te,re)),void 0)}$provideCallHierarchyIncomingCalls($,Q,te,re){return this._withAdapter($,We,G=>G.provideCallsTo(Q,te,re),void 0)}$provideCallHierarchyOutgoingCalls($,Q,te,re){return this._withAdapter($,We,G=>G.provideCallsFrom(Q,te,re),void 0)}$releaseCallHierarchy($,Q){this._withAdapter($,We,te=>Promise.resolve(te.releaseSession(Q)),void 0)}static _serializeRegExp($){return{pattern:$.source,flags:_.regExpFlags($)}}static _serializeIndentationRule($){return{decreaseIndentPattern:Ge._serializeRegExp($.decreaseIndentPattern),increaseIndentPattern:Ge._serializeRegExp($.increaseIndentPattern),indentNextLinePattern:$.indentNextLinePattern?Ge._serializeRegExp($.indentNextLinePattern):void 0,unIndentedLinePattern:$.unIndentedLinePattern?Ge._serializeRegExp($.unIndentedLinePattern):void 0}}static _serializeOnEnterRule($){return{beforeText:Ge._serializeRegExp($.beforeText),afterText:$.afterText?Ge._serializeRegExp($.afterText):void 0,previousLineText:$.previousLineText?Ge._serializeRegExp($.previousLineText):void 0,action:$.action}}static _serializeOnEnterRules($){return $.map(Ge._serializeOnEnterRule)}setLanguageConfiguration($,Q,te){let{wordPattern:re}=te;if(re&&_.regExpLeadsToEndlessLoop(re))throw new Error(`Invalid language configuration: wordPattern '${re}' is not allowed to match the empty string.`);re?this._documents.setWordDefinitionFor(Q,re):this._documents.setWordDefinitionFor(Q,void 0),te.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",$,"Do not use."),te.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",$,"Do not use.");const G=this._nextHandle(),se={comments:te.comments,brackets:te.brackets,wordPattern:te.wordPattern?Ge._serializeRegExp(te.wordPattern):void 0,indentationRules:te.indentationRules?Ge._serializeIndentationRule(te.indentationRules):void 0,onEnterRules:te.onEnterRules?Ge._serializeOnEnterRules(te.onEnterRules):void 0,__electricCharacterSupport:te.__electricCharacterSupport,__characterPairSupport:te.__characterPairSupport};return this._proxy.$setLanguageConfiguration(G,Q,se),this._createDisposable(G)}$setWordDefinitions($){for(const Q of $)this._documents.setWordDefinitionFor(Q.languageId,new RegExp(Q.regexSource,Q.regexFlags))}}e.ExtHostLanguageFeatures=Ge,Ge._handlePool=0}),define(_e[190],Ee([0,1,4,9,6]),function(Z,e,m,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class y{constructor(D,_){this._proxy=D.getProxy(m.MainContext.MainThreadLanguages),this._documents=_}getLanguages(){return this._proxy.$getLanguages()}async changeLanguage(D,_){await this._proxy.$changeLanguage(D,_);const C=this._documents.getDocumentData(D);if(!C)throw new Error(`document '${D.toString}' NOT found`);return C.document}async tokenAtPosition(D,_){var C;const n=D.version,I=T.Position.from(_),o=await this._proxy.$tokensAtPosition(D.uri,I),h={type:S.StandardTokenType.Other,range:(C=D.getWordRangeAtPosition(_))!==null&&C!==void 0?C:new S.Range(_.line,_.character,_.line,_.character)};if(!o)return h;const d={range:T.Range.to(o.range),type:T.TokenType.to(o.type)};return!d.range.contains(_)||n!==D.version?h:d}}e.ExtHostLanguages=y}),define(_e[191],Ee([0,1,4,15,29]),function(Z,e,m,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function y(D){return D&&D.title}let k=class{constructor(_,C){this._logService=C,this._proxy=_.getProxy(m.MainContext.MainThreadMessageService)}showMessage(_,C,n,I,o){const h={extension:_};let d;typeof I=="string"||y(I)?d=[I,...o]:(h.modal=I&&I.modal,h.useCustom=I&&I.useCustom,d=o),h.useCustom&&S.checkProposedApiEnabled(_);const c=[];for(let b=0;b<d.length;b++){const p=d[b];if(typeof p=="string")c.push({title:p,handle:b,isCloseAffordance:!1});else if(typeof p=="object"){let{title:w,isCloseAffordance:u}=p;c.push({title:w,isCloseAffordance:!!u,handle:b})}else this._logService.warn("Invalid message item:",p)}return this._proxy.$showMessage(C,n,h,c).then(b=>{if(typeof b=="number")return d[b]})}};k=He([ze(1,T.ILogService)],k),e.ExtHostMessageService=k}),define(_e[192],Ee([0,1,23,3,53,7,22,8,10,2,62,4,9,6,169,97]),function(Z,e,m,T,S,y,k,D,_,C,n,I,o,h,d,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class b{constructor(w,u,f,g,t){this._textDocumentsAndEditors=f,this._textDocuments=g,this._extensionStoragePaths=t,this._notebookContentProviders=new Map,this._notebookStatusBarItemProviders=new Map,this._documents=new k.ResourceMap,this._editors=new Map,this._onDidChangeNotebookCells=new T.Emitter,this.onDidChangeNotebookCells=this._onDidChangeNotebookCells.event,this._onDidChangeCellOutputs=new T.Emitter,this.onDidChangeCellOutputs=this._onDidChangeCellOutputs.event,this._onDidChangeCellMetadata=new T.Emitter,this.onDidChangeCellMetadata=this._onDidChangeCellMetadata.event,this._onDidChangeActiveNotebookEditor=new T.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._onDidChangeCellExecutionState=new T.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new T.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new T.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidChangeVisibleNotebookEditors=new T.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._statusBarCache=new n.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._backupIdPool=0,this._notebookProxy=w.getProxy(I.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=w.getProxy(I.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=w.getProxy(I.MainContext.MainThreadNotebookEditors),this._commandsConverter=u.converter,u.registerArgumentProcessor({processArgument:i=>{var s;if(i&&i.$mid===12){const r=(s=i.notebookEditor)===null||s===void 0?void 0:s.notebookUri,l=i.cell.handle,E=this._documents.get(r),v=E==null?void 0:E.getCell(l);if(v)return v.apiCell}return i}})}get activeNotebookEditor(){var w;return(w=this._activeNotebookEditor)===null||w===void 0?void 0:w.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(w=>w.apiEditor)}getEditorById(w){const u=this._editors.get(w);if(!u)throw new Error(`unknown text editor: ${w}. known editors: ${[...this._editors.keys()]} `);return u}getIdByEditor(w){for(const[u,f]of this._editors)if(f.apiEditor===w)return u}get notebookDocuments(){return[...this._documents.values()]}getNotebookDocument(w,u){const f=this._documents.get(w);if(!f&&!u)throw new Error(`NO notebook document for '${w}'`);return f}_getProviderData(w){const u=this._notebookContentProviders.get(w);if(!u)throw new Error(`NO provider for '${w}'`);return u}registerNotebookContentProvider(w,u,f,g,t){if(D.isFalsyOrWhitespace(u))throw new Error("viewType cannot be empty or just whitespace");if(this._notebookContentProviders.has(u))throw new Error(`Notebook provider for '${u}' already registered`);this._notebookContentProviders.set(u,{extension:w,provider:f});let i;return f.onDidChangeNotebookContentOptions&&(i=f.onDidChangeNotebookContentOptions(()=>{const s=o.NotebookDocumentContentOptions.from(f.options);this._notebookProxy.$updateNotebookProviderOptions(u,s)})),this._notebookProxy.$registerNotebookProvider({id:w.identifier,location:w.extensionLocation},u,o.NotebookDocumentContentOptions.from(g),b._convertNotebookRegistrationData(w,t)),new h.Disposable(()=>{i==null||i.dispose(),this._notebookContentProviders.delete(u),this._notebookProxy.$unregisterNotebookProvider(u)})}static _convertNotebookRegistrationData(w,u){if(!u)return;const f=u.filenamePattern.map(g=>o.NotebookExclusiveDocumentPattern.from(g)).filter(g=>g!==void 0);if(u.filenamePattern&&!f){console.warn(`Notebook content provider view options file name pattern is invalid ${u.filenamePattern}`);return}return{extension:w.identifier,providerDisplayName:w.displayName||w.name,displayName:u.displayName,filenamePattern:f,exclusive:u.exclusive||!1}}registerNotebookCellStatusBarItemProvider(w,u,f){const g=b._notebookStatusBarItemProviderHandlePool++,t=typeof f.onDidChangeCellStatusBarItems=="function"?b._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(g,f),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(g,t,u);let i;return t!==void 0&&(i=f.onDidChangeCellStatusBarItems(s=>this._notebookProxy.$emitCellStatusBarEvent(t))),new h.Disposable(()=>{this._notebookStatusBarItemProviders.delete(g),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(g,t),i&&i.dispose()})}async createNotebookDocument(w){const u=await this._notebookDocumentsProxy.$tryCreateNotebook({viewType:w.viewType,content:w.content&&o.NotebookData.from(w.content)});return C.URI.revive(u)}async openNotebookDocument(w){const u=this._documents.get(w);if(u)return u.apiNotebook;const f=await this._notebookDocumentsProxy.$tryOpenNotebook(w),g=this._documents.get(C.URI.revive(f));return _.assertIsDefined(g==null?void 0:g.apiNotebook)}async showNotebookDocument(w,u){var f;C.URI.isUri(w)&&(w=await this.openNotebookDocument(w));let g;typeof u=="object"?g={position:o.ViewColumn.from(u.viewColumn),preserveFocus:u.preserveFocus,selections:u.selections&&u.selections.map(o.NotebookRange.from),pinned:typeof u.preview=="boolean"?!u.preview:void 0}:g={preserveFocus:!1};const t=await this._notebookEditorsProxy.$tryShowNotebookDocument(w.uri,w.notebookType,g),i=t&&((f=this._editors.get(t))===null||f===void 0?void 0:f.apiEditor);if(i)return i;throw t?new Error(`Could NOT open editor for "${w.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${w.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(w,u,f,g){const t=this._notebookStatusBarItemProviders.get(w),i=C.URI.revive(u),s=this._documents.get(i);if(!s||!t)return;const r=s.getCellFromIndex(f);if(!r)return;const l=await t.provideCellStatusBarItems(r.apiCell,g);if(!l)return;const E=new y.DisposableStore,v=this._statusBarCache.add([E]),P=(Array.isArray(l)?l:[l]).map(a=>o.NotebookStatusBarItem.from(a,this._commandsConverter,E));return{cacheId:v,items:P}}$releaseNotebookCellStatusBarItems(w){this._statusBarCache.delete(w)}registerNotebookSerializer(w,u,f,g,t){if(D.isFalsyOrWhitespace(u))throw new Error("viewType cannot be empty or just whitespace");const i=this._handlePool++;return this._notebookSerializer.set(i,f),this._notebookProxy.$registerNotebookSerializer(i,{id:w.identifier,location:w.extensionLocation},u,o.NotebookDocumentContentOptions.from(g),b._convertNotebookRegistrationData(w,t)),y.toDisposable(()=>{this._notebookProxy.$unregisterNotebookSerializer(i)})}async $dataToNotebook(w,u,f){const g=this._notebookSerializer.get(w);if(!g)throw new Error("NO serializer found");const t=await g.deserializeNotebook(u.buffer,f);return o.NotebookData.from(t)}async $notebookToData(w,u,f){const g=this._notebookSerializer.get(w);if(!g)throw new Error("NO serializer found");const t=await g.serializeNotebook(o.NotebookData.to(u),f);return m.VSBuffer.wrap(t)}async $openNotebook(w,u,f,g,t){var i;const{provider:s}=this._getProviderData(w),r=await s.openNotebook(C.URI.revive(u),{backupId:f,untitledDocumentData:g==null?void 0:g.buffer},t);return{metadata:(i=r.metadata)!==null&&i!==void 0?i:Object.create(null),cells:r.cells.map(o.NotebookCellData.from)}}async $saveNotebook(w,u,f){const g=this.getNotebookDocument(C.URI.revive(u)),{provider:t}=this._getProviderData(w);return await t.saveNotebook(g.apiNotebook,f),!0}async $saveNotebookAs(w,u,f,g){const t=this.getNotebookDocument(C.URI.revive(u)),{provider:i}=this._getProviderData(w);return await i.saveNotebookAs(C.URI.revive(f),t.apiNotebook,g),!0}async $backupNotebook(w,u,f){var g;const t=this.getNotebookDocument(C.URI.revive(u)),i=this._getProviderData(w),s=(g=this._extensionStoragePaths.workspaceValue(i.extension))!==null&&g!==void 0?g:this._extensionStoragePaths.globalValue(i.extension),r=String(S.hash([t.uri.toString(),this._backupIdPool++])),l=C.URI.joinPath(s,r),E=await i.provider.backupNotebook(t.apiNotebook,{destination:l},f);return t.updateBackup(E),E.id}_createExtHostEditor(w,u,f){if(this._editors.has(u))throw new Error(`editor with id ALREADY EXSIST: ${u}`);const g=new c.ExtHostNotebookEditor(u,this._notebookEditorsProxy,w,f.visibleRanges.map(o.NotebookRange.to),f.selections.map(o.NotebookRange.to),typeof f.viewColumn=="number"?o.ViewColumn.to(f.viewColumn):void 0);this._editors.set(u,g)}$acceptDocumentAndEditorsDelta(w){var u,f,g;if(w.removedDocuments)for(const i of w.removedDocuments){const s=C.URI.revive(i),r=this._documents.get(s);r&&(r.dispose(),this._documents.delete(s),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:r.apiNotebook.getCells().map(l=>l.document.uri)}),this._onDidCloseNotebookDocument.fire(r.apiNotebook));for(const l of this._editors.values())l.notebookData.uri.toString()===s.toString()&&this._editors.delete(l.id)}if(w.addedDocuments){const i=[];for(const s of w.addedDocuments){const r=C.URI.revive(s.uri);if(this._documents.has(r))throw new Error(`adding EXISTING notebook ${r} `);const l=this,E=new d.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,{emitModelChange(v){l._onDidChangeNotebookCells.fire(v)},emitCellOutputsChange(v){l._onDidChangeCellOutputs.fire(v)},emitCellMetadataChange(v){l._onDidChangeCellMetadata.fire(v)},emitCellExecutionStateChange(v){l._onDidChangeCellExecutionState.fire(v)}},r,s);i.push(...s.cells.map(v=>d.ExtHostCell.asModelAddData(E.apiNotebook,v))),(u=this._documents.get(r))===null||u===void 0||u.dispose(),this._documents.set(r,E),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:i}),this._onDidOpenNotebookDocument.fire(E.apiNotebook)}}if(w.addedEditors)for(const i of w.addedEditors){if(this._editors.has(i.id))return;const s=C.URI.revive(i.documentUri),r=this._documents.get(s);r&&this._createExtHostEditor(r,i.id,i)}const t=[];if(w.removedEditors)for(const i of w.removedEditors){const s=this._editors.get(i);s&&(this._editors.delete(i),((f=this._activeNotebookEditor)===null||f===void 0?void 0:f.id)===s.id&&(this._activeNotebookEditor=void 0),t.push(s))}if(w.visibleEditors){this._visibleNotebookEditors=w.visibleEditors.map(s=>this._editors.get(s)).filter(s=>!!s);const i=new Set;this._visibleNotebookEditors.forEach(s=>i.add(s.id));for(const s of this._editors.values()){const r=i.has(s.id);s._acceptVisibility(r)}this._visibleNotebookEditors=[...this._editors.values()].map(s=>s).filter(s=>s.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}w.newActiveEditor===null?this._activeNotebookEditor=void 0:w.newActiveEditor&&(this._activeNotebookEditor=this._editors.get(w.newActiveEditor)),w.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire((g=this._activeNotebookEditor)===null||g===void 0?void 0:g.apiEditor)}}e.ExtHostNotebookController=b,b._notebookStatusBarItemProviderHandlePool=0}),define(_e[193],Ee([0,1,3,49,15,4,13,9]),function(Z,e,m,T,S,y,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;class _{constructor(I,o){const h=_._Keys.nextId();I.$registerNotebookEditorDecorationType(h,D.NotebookDecorationRenderOptions.from(o)),this.value={key:h,dispose(){I.$removeNotebookEditorDecorationType(h)}}}}_._Keys=new T.IdGenerator("NotebookEditorDecorationType");let C=class{constructor(I,o,h){this._logService=I,this._extHostRpc=o,this._notebooksAndEditors=h,this._onDidChangeNotebookEditorSelection=new m.Emitter,this._onDidChangeNotebookEditorVisibleRanges=new m.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event}createNotebookEditorDecorationType(I){return new _(this._extHostRpc.getProxy(y.MainContext.MainThreadNotebookEditors),I).value}$acceptEditorPropertiesChanged(I,o){this._logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",I,o);const h=this._notebooksAndEditors.getEditorById(I);o.visibleRanges&&h._acceptVisibleRanges(o.visibleRanges.ranges.map(D.NotebookRange.to)),o.selections&&h._acceptSelections(o.selections.selections.map(D.NotebookRange.to)),o.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:h.apiEditor,visibleRanges:h.apiEditor.visibleRanges}),o.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:h.apiEditor,selections:h.apiEditor.selections}))}$acceptEditorViewColumns(I){for(const o in I)this._notebooksAndEditors.getEditorById(o)._acceptViewColumn(D.ViewColumn.to(I[o]))}};C=He([ze(0,S.ILogService),ze(1,k.IExtHostRpcService)],C),e.ExtHostNotebookEditors=C}),define(_e[194],Ee([0,1,3,7,4,26,2,9,67,22,12,68,18,17,15,6,29]),function(Z,e,m,T,S,y,k,D,_,C,n,I,o,h,d,c,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookKernels=void 0;let p=class{constructor(t,i,s,r){this._initData=i,this._extHostNotebook=s,this._logService=r,this._activeExecutions=new C.ResourceMap,this._kernelData=new Map,this._handlePool=0,this._proxy=t.getProxy(S.MainContext.MainThreadNotebookKernels)}createNotebookController(t,i,s,r,l,E){for(let M of this._kernelData.values())if(M.controller.id===i&&y.ExtensionIdentifier.equals(t.identifier,M.extensionId))throw new Error(`notebook controller with id '${i}' ALREADY exist`);const v=this._handlePool++,A=this;this._logService.trace(`NotebookController[${v}], CREATED by ${t.identifier.value}, ${i}`);const P=()=>console.warn(`NO execute handler from notebook controller '${le.id}' of extension: '${t.identifier}'`);let a=!1;const F=new T.DisposableStore,N=new m.Emitter,W=new m.Emitter,le={id:`${t.identifier.value}/${i}`,notebookType:s,extensionId:t.identifier,extensionLocation:t.extensionLocation,label:r||t.identifier.value,preloads:E?E.map(D.NotebookRendererScript.from):[]};let fe=l??P,Y;this._proxy.$addKernel(v,le).catch(M=>{console.log(M),a=!0});let H=0;const J=()=>{if(a)return;const M=++H;Promise.resolve().then(()=>{M===H&&this._proxy.$updateKernel(v,le)})},R=new C.ResourceMap,B={get id(){return i},get notebookType(){return le.notebookType},onDidChangeSelectedNotebooks:N.event,get label(){return le.label},set label(M){var x;le.label=(x=M??t.displayName)!==null&&x!==void 0?x:t.name,J()},get detail(){var M;return(M=le.detail)!==null&&M!==void 0?M:""},set detail(M){le.detail=M,J()},get description(){var M;return(M=le.description)!==null&&M!==void 0?M:""},set description(M){le.description=M,J()},get supportedLanguages(){return le.supportedLanguages},set supportedLanguages(M){le.supportedLanguages=M,J()},get supportsExecutionOrder(){var M;return(M=le.supportsExecutionOrder)!==null&&M!==void 0?M:!1},set supportsExecutionOrder(M){le.supportsExecutionOrder=M,J()},get rendererScripts(){return le.preloads?le.preloads.map(D.NotebookRendererScript.to):[]},get executeHandler(){return fe},set executeHandler(M){fe=M??P},get interruptHandler(){return Y},set interruptHandler(M){Y=M,le.supportsInterrupt=Boolean(M),J()},createNotebookCellExecution(M){if(a)throw new Error("notebook controller is DISPOSED");if(!R.has(M.notebook.uri))throw A._logService.trace(`NotebookController[${v}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(R.keys()).map(x=>x.toString())),new Error(`notebook controller is NOT associated to notebook: ${M.notebook.uri.toString()}`);return A._createNotebookCellExecution(M)},dispose:()=>{a||(this._logService.trace(`NotebookController[${v}], DISPOSED`),a=!0,this._kernelData.delete(v),F.dispose(),N.dispose(),W.dispose(),this._proxy.$removeKernel(v))},updateNotebookAffinity(M,x){A._proxy.$updateNotebookPriority(v,M.uri,x)},onDidReceiveMessage:W.event,postMessage(M,x){return b.checkProposedApiEnabled(t),A._proxy.$postMessage(v,x&&A._extHostNotebook.getIdByEditor(x),M)},asWebviewUri(M){return b.checkProposedApiEnabled(t),_.asWebviewUri(M,A._initData.remote)}};return this._kernelData.set(v,{extensionId:t.identifier,controller:B,onDidReceiveMessage:W,onDidChangeSelection:N,associatedNotebooks:R}),B}$acceptNotebookAssociation(t,i,s){const r=this._kernelData.get(t);if(r){const l=this._extHostNotebook.getNotebookDocument(k.URI.revive(i));s?r.associatedNotebooks.set(l.uri,!0):r.associatedNotebooks.delete(l.uri),this._logService.trace(`NotebookController[${t}] ASSOCIATE notebook`,l.uri.toString(),s),r.onDidChangeSelection.fire({selected:s,notebook:l.apiNotebook})}}async $executeCells(t,i,s){const r=this._kernelData.get(t);if(!r)return;const l=this._extHostNotebook.getNotebookDocument(k.URI.revive(i)),E=[];for(let v of s){const A=l.getCell(v);A&&E.push(A.apiCell)}try{this._logService.trace(`NotebookController[${t}] EXECUTE cells`,l.uri.toString(),E.length),await r.controller.executeHandler.call(r.controller,E,l.apiNotebook,r.controller)}catch(v){this._logService.error(`NotebookController[${t}] execute cells FAILED`,v),console.error(v)}}async $cancelCells(t,i,s){var r;const l=this._kernelData.get(t);if(!l)return;const E=this._extHostNotebook.getNotebookDocument(k.URI.revive(i));if(l.controller.interruptHandler)await l.controller.interruptHandler.call(l.controller,E.apiNotebook);else for(let v of s){const A=E.getCell(v);A&&((r=this._activeExecutions.get(A.uri))===null||r===void 0||r.cancel())}}$acceptKernelMessageFromRenderer(t,i,s){const r=this._kernelData.get(t);if(!r)return;const l=this._extHostNotebook.getEditorById(i);r.onDidReceiveMessage.fire(Object.freeze({editor:l.apiEditor,message:s}))}_createNotebookCellExecution(t){if(t.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const s=this._extHostNotebook.getNotebookDocument(t.notebook.uri).getCellFromApiCell(t);if(!s)throw new Error("invalid cell");if(this._activeExecutions.has(s.uri))throw new Error(`duplicate execution for ${s.uri}`);const r=new u(s.notebook,s,this._proxy);this._activeExecutions.set(s.uri,r);const l=r.onDidChangeState(()=>{r.state===w.Resolved&&(r.dispose(),l.dispose(),this._activeExecutions.delete(s.uri))});return r.asApiObject()}};p=He([ze(3,d.ILogService)],p),e.ExtHostNotebookKernels=p;var w;(function(g){g[g.Init=0]="Init",g[g.Started=1]="Started",g[g.Resolved=2]="Resolved"})(w||(w={}));class u extends T.Disposable{constructor(t,i,s){super();this._document=t,this._cell=i,this._proxy=s,this._onDidChangeState=new m.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=w.Init,this._tokenSource=this._register(new o.CancellationTokenSource),this._collector=new f(10,r=>this.applyEdits(r)),this._executionOrder=i.internalMetadata.executionOrder,this.mixinMetadata({runState:I.NotebookCellExecutionState.Pending,executionOrder:null})}get state(){return this._state}cancel(){this._tokenSource.cancel()}async applyEditSoon(t){await this._collector.addItem(t)}async applyEdits(t){return this._proxy.$applyExecutionEdits(this._document.uri,t)}verifyStateForOutput(){if(this._state===w.Init)throw new Error("Must call start before modifying cell output");if(this._state===w.Resolved)throw new Error("Cannot modify cell output after calling resolve")}mixinMetadata(t){this.applyEdits([{editType:9,handle:this._cell.handle,internalMetadata:t}])}cellIndexToHandle(t){let i=this._cell;if(t&&(i=this._document.getCellFromApiCell(t)),!i)throw new Error("INVALID cell");return i.handle}validateAndConvertOutputs(t){return t.map(i=>{const s=c.NotebookCellOutput.ensureUniqueMimeTypes(i.items,!0);return s===i.items?D.NotebookCellOutput.from(i):D.NotebookCellOutput.from({items:s,id:i.id,metadata:i.metadata})})}async updateOutputs(t,i,s){const r=this.cellIndexToHandle(i),l=this.validateAndConvertOutputs(h.asArray(t));return this.applyEditSoon({editType:2,handle:r,append:s,outputs:l})}async updateOutputItems(t,i,s){return t=c.NotebookCellOutput.ensureUniqueMimeTypes(h.asArray(t),!0),this.applyEditSoon({editType:7,items:t.map(D.NotebookCellOutputItem.from),outputId:i.id,append:s})}asApiObject(){const t=this;return Object.freeze({get token(){return t._tokenSource.token},get cell(){return t._cell.apiCell},get executionOrder(){return t._executionOrder},set executionOrder(s){t._executionOrder=s,t.mixinMetadata({executionOrder:s})},start(s){if(t._state===w.Resolved||t._state===w.Started)throw new Error("Cannot call start again");t._state=w.Started,t._onDidChangeState.fire(),t.mixinMetadata({runState:I.NotebookCellExecutionState.Executing,runStartTime:s??null})},end(s,r){if(t._state===w.Resolved)throw new Error("Cannot call resolve twice");t._state=w.Resolved,t._onDidChangeState.fire(),t.mixinMetadata({runState:null,lastRunSuccess:s??null,runEndTime:r??null})},clearOutput(s){return t.verifyStateForOutput(),t.updateOutputs([],s,!1)},appendOutput(s,r){return t.verifyStateForOutput(),t.updateOutputs(s,r,!0)},replaceOutput(s,r){return t.verifyStateForOutput(),t.updateOutputs(s,r,!1)},appendOutputItems(s,r){return t.verifyStateForOutput(),t.updateOutputItems(s,r,!0)},replaceOutputItems(s,r){return t.verifyStateForOutput(),t.updateOutputItems(s,r,!1)}})}}class f{constructor(t,i){this.delay=t,this.callback=i,this.batch=[]}addItem(t){return this.batch.push(t),this.waitPromise||(this.waitPromise=n.timeout(this.delay).then(()=>{this.waitPromise=void 0;const i=this.batch;return this.batch=[],this.callback(i)})),this.waitPromise}}}),define(_e[195],Ee([0,1,3,4,97]),function(Z,e,m,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class y{constructor(D,_){this._extHostNotebook=_,this._rendererMessageEmitters=new Map,this.proxy=D.getProxy(T.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(D,_,C){var n;const I=this._extHostNotebook.getEditorById(D);(n=this._rendererMessageEmitters.get(_))===null||n===void 0||n.fire({editor:I.apiEditor,message:C})}createRendererMessaging(D){return{onDidReceiveMessage:(...C)=>this.getOrCreateEmitterFor(D).event(...C),postMessage:(C,n)=>{const I=S.ExtHostNotebookEditor.apiEditorsToExtHost.get(C);if(!I)throw new Error("The first argument to postMessage() must be a NotebookEditor");this.proxy.$postMessage(I.id,D,n)}}}getOrCreateEmitterFor(D){let _=this._rendererMessageEmitters.get(D);return _||(_=new m.Emitter({onLastListenerRemove:()=>{_==null||_.dispose(),this._rendererMessageEmitters.delete(D)}}),this._rendererMessageEmitters.set(D,_),_)}}e.ExtHostNotebookRenderers=y}),define(_e[101],Ee([0,1,4,3,7,23,5,13]),function(Z,e,m,T,S,y,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=e.LazyOutputChannel=e.ExtHostPushOutputChannel=e.AbstractExtHostOutputChannel=void 0;class _ extends S.Disposable{constructor(d,c,b,p){super();this._onDidAppend=this._register(new T.Emitter),this.onDidAppend=this._onDidAppend.event,this._name=d,this._proxy=p,this._id=p.$register(this.name,c,b),this._disposed=!1,this._offset=0}get name(){return this._name}append(d){this.validate(),this._offset+=d?y.VSBuffer.fromString(d).byteLength:0}update(){this._id.then(d=>this._proxy.$update(d))}appendLine(d){this.validate(),this.append(d+`
`)}clear(){this.validate();const d=this._offset;this._id.then(c=>this._proxy.$clear(c,d))}show(d,c){this.validate(),this._id.then(b=>this._proxy.$reveal(b,!!(typeof d=="boolean"?d:c)))}hide(){this.validate(),this._id.then(d=>this._proxy.$close(d))}validate(){if(this._disposed)throw new Error("Channel has been closed")}dispose(){super.dispose(),this._disposed||this._id.then(d=>this._proxy.$dispose(d)).then(()=>this._disposed=!0)}}e.AbstractExtHostOutputChannel=_;class C extends _{constructor(d,c){super(d,!1,void 0,c)}append(d){super.append(d),this._id.then(c=>this._proxy.$append(c,d)),this._onDidAppend.fire()}}e.ExtHostPushOutputChannel=C;class n extends _{constructor(d,c,b){super(d,!0,c,b)}append(d){throw new Error("Not supported")}}class I{constructor(d,c){this.name=d,this._channel=c}append(d){this._channel.then(c=>c.append(d))}appendLine(d){this._channel.then(c=>c.appendLine(d))}clear(){this._channel.then(d=>d.clear())}show(d,c){this._channel.then(b=>b.show(d,c))}hide(){this._channel.then(d=>d.hide())}dispose(){this._channel.then(d=>d.dispose())}}e.LazyOutputChannel=I;let o=class{constructor(d){this._proxy=d.getProxy(m.MainContext.MainThreadOutputService)}$setVisibleChannel(d){}createOutputChannel(d){if(d=d.trim(),!d)throw new Error("illegal argument `name`. must not be falsy");return new C(d,this._proxy)}createOutputChannelFromLogFile(d,c){if(d=d.trim(),!d)throw new Error("illegal argument `name`. must not be falsy");if(!c)throw new Error("illegal argument `file`. must not be falsy");return new n(d,c,this._proxy)}};o=He([ze(0,D.IExtHostRpcService)],o),e.ExtHostOutputService=o,e.IExtHostOutputService=k.createDecorator("IExtHostOutputService")}),define(_e[196],Ee([0,1,12,18,3,7,4,2,6,11,17,41]),function(Z,e,m,T,S,y,k,D,_,C,n,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function o(h,d,c){const b=h.getProxy(k.MainContext.MainThreadQuickOpen);class p{constructor(r,l){this._sessions=new Map,this._instances=0,this._workspace=r,this._commands=l}showQuickPick(r,l,E,v=T.CancellationToken.None){this._onDidSelectItem=void 0;const A=Promise.resolve(r),P=++this._instances,a=b.$show(P,{title:E==null?void 0:E.title,placeHolder:E==null?void 0:E.placeHolder,matchOnDescription:E==null?void 0:E.matchOnDescription,matchOnDetail:E==null?void 0:E.matchOnDetail,ignoreFocusLost:E==null?void 0:E.ignoreFocusOut,canPickMany:E==null?void 0:E.canPickMany},v),F={},N=a.then(()=>F);return Promise.race([N,A]).then(W=>{if(W!==F)return A.then(le=>{const fe=[];for(let Y=0;Y<le.length;Y++){const H=le[Y];let J,R,B,M,x;typeof H=="string"?J=H:(J=H.label,R=H.description,B=H.detail,M=H.picked,x=H.alwaysShow),fe.push({label:J,description:R,handle:Y,detail:B,picked:M,alwaysShow:x})}return E&&typeof E.onDidSelectItem=="function"&&(this._onDidSelectItem=Y=>{E.onDidSelectItem(le[Y])}),b.$setItems(P,fe),a.then(Y=>{if(typeof Y=="number")return le[Y];if(Array.isArray(Y))return Y.map(H=>le[H])})})}).then(void 0,W=>{if(!C.isPromiseCanceledError(W))return b.$setError(P,W),Promise.reject(W)})}$onItemSelected(r){this._onDidSelectItem&&this._onDidSelectItem(r)}showInput(r,l=T.CancellationToken.None){return this._validateInput=r?r.validateInput:void 0,b.$input(r,typeof this._validateInput=="function",l).then(void 0,E=>{if(!C.isPromiseCanceledError(E))return Promise.reject(E)})}$validateInput(r){return this._validateInput?m.asPromise(()=>this._validateInput(r)):Promise.resolve(void 0)}async showWorkspaceFolderPick(r,l=T.CancellationToken.None){const E=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[r]);if(!E)return;const v=await this._workspace.getWorkspaceFolders2();if(!!v)return v.find(A=>A.uri.toString()===E.uri.toString())}createQuickPick(r,l){const E=new t(r,l,()=>this._sessions.delete(E._id));return this._sessions.set(E._id,E),E}createInputBox(r){const l=new i(r,()=>this._sessions.delete(l._id));return this._sessions.set(l._id,l),l}$onDidChangeValue(r,l){const E=this._sessions.get(r);E&&E._fireDidChangeValue(l)}$onDidAccept(r){const l=this._sessions.get(r);l&&l._fireDidAccept()}$onDidChangeActive(r,l){const E=this._sessions.get(r);E instanceof t&&E._fireDidChangeActive(l)}$onDidChangeSelection(r,l){const E=this._sessions.get(r);E instanceof t&&E._fireDidChangeSelection(l)}$onDidTriggerButton(r,l){const E=this._sessions.get(r);E&&E._fireDidTriggerButton(l)}$onDidHide(r){const l=this._sessions.get(r);l&&l._fireDidHide()}}class w{constructor(r,l){this._extensionId=r,this._onDidDispose=l,this._id=t._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new S.Emitter,this._onDidChangeValueEmitter=new S.Emitter,this._onDidTriggerButtonEmitter=new S.Emitter,this._onDidHideEmitter=new S.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(r){this._title=r,this.update({title:r})}get step(){return this._steps}set step(r){this._steps=r,this.update({step:r})}get totalSteps(){return this._totalSteps}set totalSteps(r){this._totalSteps=r,this.update({totalSteps:r})}get enabled(){return this._enabled}set enabled(r){this._enabled=r,this.update({enabled:r})}get busy(){return this._busy}set busy(r){this._busy=r,this.update({busy:r})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(r){this._ignoreFocusOut=r,this.update({ignoreFocusOut:r})}get value(){return this._value}set value(r){this._value=r,this.update({value:r})}get placeholder(){return this._placeholder}set placeholder(r){this._placeholder=r,this.update({placeholder:r})}get buttons(){return this._buttons}set buttons(r){this._buttons=r.slice(),this._handlesToButtons.clear(),r.forEach((l,E)=>{const v=l===_.QuickInputButtons.Back?-1:E;this._handlesToButtons.set(v,l)}),this.update({buttons:r.map((l,E)=>({iconPath:u(l.iconPath),tooltip:l.tooltip,handle:l===_.QuickInputButtons.Back?-1:E}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(r){this._value=r,this._onDidChangeValueEmitter.fire(r)}_fireDidTriggerButton(r){const l=this._handlesToButtons.get(r);l&&this._onDidTriggerButtonEmitter.fire(l)}_fireDidHide(){this._expectingHide&&(this._expectingHide=!1,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=y.dispose(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),b.$dispose(this._id))}update(r){if(!this._disposed){for(const l of Object.keys(r)){const E=r[l];this._pendingUpdate[l]=E===void 0?null:E}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){b.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}w._nextId=1;function u(s){if(s instanceof _.ThemeIcon)return{id:s.id};const r=g(s),l=f(s);return{dark:typeof r=="string"?D.URI.file(r):r,light:typeof l=="string"?D.URI.file(l):l}}function f(s){return typeof s=="object"&&"light"in s?s.light:s}function g(s){return typeof s=="object"&&"dark"in s?s.dark:s}class t extends w{constructor(r,l,E){super(r,E);this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._activeItems=[],this._onDidChangeActiveEmitter=new S.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new S.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(r){this._items=r.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),r.forEach((l,E)=>{this._handlesToItems.set(E,l),this._itemsToHandles.set(l,E)}),this.update({items:r.map((l,E)=>({label:l.label,description:l.description,handle:E,detail:l.detail,picked:l.picked,alwaysShow:l.alwaysShow}))})}get canSelectMany(){return this._canSelectMany}set canSelectMany(r){this._canSelectMany=r,this.update({canSelectMany:r})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(r){this._matchOnDescription=r,this.update({matchOnDescription:r})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(r){this._matchOnDetail=r,this.update({matchOnDetail:r})}get sortByLabel(){return this._sortByLabel}set sortByLabel(r){this._sortByLabel=r,this.update({sortByLabel:r})}get activeItems(){return this._activeItems}set activeItems(r){this._activeItems=r.filter(l=>this._itemsToHandles.has(l)),this.update({activeItems:this._activeItems.map(l=>this._itemsToHandles.get(l))})}get selectedItems(){return this._selectedItems}set selectedItems(r){this._selectedItems=r.filter(l=>this._itemsToHandles.has(l)),this.update({selectedItems:this._selectedItems.map(l=>this._itemsToHandles.get(l))})}_fireDidChangeActive(r){const l=n.coalesce(r.map(E=>this._handlesToItems.get(E)));this._activeItems=l,this._onDidChangeActiveEmitter.fire(l)}_fireDidChangeSelection(r){const l=n.coalesce(r.map(E=>this._handlesToItems.get(E)));this._selectedItems=l,this._onDidChangeSelectionEmitter.fire(l)}}class i extends w{constructor(r,l){super(r,l);this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(r){this._password=r,this.update({password:r})}get prompt(){return this._prompt}set prompt(r){this._prompt=r,this.update({prompt:r})}get validationMessage(){return this._validationMessage}set validationMessage(r){this._validationMessage=r,this.update({validationMessage:r,severity:r?I.default.Error:I.default.Ignore})}}return new p(d,c)}e.createExtHostQuickOpen=o}),define(_e[197],Ee([0,1,2,3,47,7,12,4,17,112,15,26,29]),function(Z,e,m,T,S,y,k,D,_,C,n,I,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function h(r){if(r)return typeof r.iconPath=="string"?m.URI.file(r.iconPath):r.iconPath}function d(r,l){if(!r.iconPath&&!l.iconPath)return 0;if(r.iconPath){if(!l.iconPath)return 1}else return-1;const E=typeof r.iconPath=="string"?r.iconPath:r.iconPath.fsPath,v=typeof l.iconPath=="string"?l.iconPath:l.iconPath.fsPath;return C.comparePaths(E,v)}function c(r,l){let E=0;if(r.strikeThrough!==l.strikeThrough)return r.strikeThrough?1:-1;if(r.faded!==l.faded)return r.faded?1:-1;if(r.tooltip!==l.tooltip)return(r.tooltip||"").localeCompare(l.tooltip||"");if(E=d(r,l),E!==0)return E;if(r.light&&l.light)E=d(r.light,l.light);else{if(r.light)return 1;if(l.light)return-1}if(E!==0)return E;if(r.dark&&l.dark)E=d(r.dark,l.dark);else{if(r.dark)return 1;if(l.dark)return-1}return E}function b(r,l){if(r.command!==l.command)return r.command<l.command?-1:1;if(r.title!==l.title)return r.title<l.title?-1:1;if(r.tooltip!==l.tooltip){if(r.tooltip!==void 0&&l.tooltip!==void 0)return r.tooltip<l.tooltip?-1:1;if(r.tooltip!==void 0)return 1;if(l.tooltip!==void 0)return-1}if(r.arguments===l.arguments)return 0;if(r.arguments)if(l.arguments){if(r.arguments.length!==l.arguments.length)return r.arguments.length-l.arguments.length}else return 1;else return-1;for(let E=0;E<r.arguments.length;E++){const v=r.arguments[E],A=l.arguments[E];if(v!==A)return v<A?-1:1}return 0}function p(r,l){let E=C.comparePaths(r.resourceUri.fsPath,l.resourceUri.fsPath,!0);if(E!==0)return E;if(r.command&&l.command)E=b(r.command,l.command);else{if(r.command)return 1;if(l.command)return-1}if(E!==0)return E;if(r.decorations&&l.decorations)E=c(r.decorations,l.decorations);else{if(r.decorations)return 1;if(l.decorations)return-1}return E}function w(r,l){for(let E=0;E<r.length;E++)if(r[E]!==l[E])return!1;return!0}function u(r,l){return r.command===l.command&&r.title===l.title&&r.tooltip===l.tooltip&&(r.arguments&&l.arguments?w(r.arguments,l.arguments):r.arguments===l.arguments)}function f(r,l){return _.equals(r,l,u)}class g{constructor(l,E,v){this._extension=l,this._proxy=E,this._sourceControlHandle=v,this._value="",this._onDidChange=new T.Emitter,this._placeholder="",this._visible=!0}get value(){return this._value}set value(l){this._proxy.$setInputBoxValue(this._sourceControlHandle,l),this.updateValue(l)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(l){this._proxy.$setInputBoxPlaceholder(this._sourceControlHandle,l),this._placeholder=l}get validateInput(){return o.checkProposedApiEnabled(this._extension),this._validateInput}set validateInput(l){if(o.checkProposedApiEnabled(this._extension),l&&typeof l!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=l,this._proxy.$setValidationProviderIsEnabled(this._sourceControlHandle,!!l)}get visible(){return this._visible}set visible(l){l=!!l,this._visible!==l&&(this._visible=l,this._proxy.$setInputBoxVisibility(this._sourceControlHandle,l))}focus(){o.checkProposedApiEnabled(this._extension),this._visible||(this.visible=!0),this._proxy.$setInputBoxFocus(this._sourceControlHandle)}showValidationMessage(l,E){o.checkProposedApiEnabled(this._extension),this._proxy.$showValidationMessage(this._sourceControlHandle,l,E)}$onInputBoxValueChange(l){this.updateValue(l)}updateValue(l){this._value=l,this._onDidChange.fire(l)}}e.ExtHostSCMInputBox=g;class t{constructor(l,E,v,A,P){this._proxy=l,this._commands=E,this._sourceControlHandle=v,this._id=A,this._label=P,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new T.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new T.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=t._handlePool++}get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(l){this._label=l,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,l)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(l){this._hideWhenEmpty=l,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(l){this._resourceStates=[...l],this._onDidUpdateResourceStates.fire()}getResourceState(l){return this._resourceStatesMap.get(l)}$executeResourceCommand(l,E){const v=this._resourceStatesCommandsMap.get(l);return v?k.asPromise(()=>this._commands.executeCommand(v.command,...v.arguments||[],E)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){var l;const E=[...this._resourceStates].sort(p),A=_.sortedDiff(this._resourceSnapshot,E,p).map(F=>{const N=F.toInsert.map(W=>{const le=this._resourceHandlePool++;this._resourceStatesMap.set(le,W);const fe=W.resourceUri,Y=h(W.decorations),H=W.decorations&&h(W.decorations.light)||Y,J=W.decorations&&h(W.decorations.dark)||Y,R=[];let B;if(W.command)if(W.command.command==="vscode.open"||W.command.command==="vscode.diff"){const pe=new y.DisposableStore;B=this._commands.converter.toInternal(W.command,pe),this._resourceStatesDisposablesMap.set(le,pe)}else this._resourceStatesCommandsMap.set(le,W.command);H&&R.push(H),J&&J.toString()!==(H==null?void 0:H.toString())&&R.push(J);const M=W.decorations&&W.decorations.tooltip||"",x=W.decorations&&!!W.decorations.strikeThrough,q=W.decorations&&!!W.decorations.faded,z=W.contextValue||"";return{rawResource:[le,fe,R,M,x,q,z,B],handle:le}});return{start:F.start,deleteCount:F.deleteCount,toInsert:N}}),P=A.map(({start:F,deleteCount:N,toInsert:W})=>[F,N,W.map(le=>le.rawResource)]),a=A.reverse();for(const{start:F,deleteCount:N,toInsert:W}of a){const le=W.map(Y=>Y.handle),fe=this._handlesSnapshot.splice(F,N,...le);for(const Y of fe)this._resourceStatesMap.delete(Y),this._resourceStatesCommandsMap.delete(Y),(l=this._resourceStatesDisposablesMap.get(Y))===null||l===void 0||l.dispose(),this._resourceStatesDisposablesMap.delete(Y)}return this._resourceSnapshot=E,P}dispose(){this._disposed=!0,this._onDidDispose.fire()}}t._handlePool=0;class i{constructor(l,E,v,A,P,a){this._proxy=E,this._commands=v,this._id=A,this._label=P,this._rootUri=a,this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._commitTemplate=void 0,this._acceptInputDisposables=new y.MutableDisposable,this._acceptInputCommand=void 0,this._statusBarDisposables=new y.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new T.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=i._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,this._inputBox=new g(l,this._proxy,this.handle),this._proxy.$registerSourceControl(this.handle,A,P,a)}get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(l){this._count!==l&&(this._count=l,this._proxy.$updateSourceControl(this.handle,{count:l}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(l){this._quickDiffProvider=l,this._proxy.$updateSourceControl(this.handle,{hasQuickDiffProvider:!!l})}get commitTemplate(){return this._commitTemplate}set commitTemplate(l){l!==this._commitTemplate&&(this._commitTemplate=l,this._proxy.$updateSourceControl(this.handle,{commitTemplate:l}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(l){this._acceptInputDisposables.value=new y.DisposableStore,this._acceptInputCommand=l;const E=this._commands.converter.toInternal(l,this._acceptInputDisposables.value);this._proxy.$updateSourceControl(this.handle,{acceptInputCommand:E})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(l){if(this._statusBarCommands&&l&&f(this._statusBarCommands,l))return;this._statusBarDisposables.value=new y.DisposableStore,this._statusBarCommands=l;const E=(l||[]).map(v=>this._commands.converter.toInternal(v,this._statusBarDisposables.value));this._proxy.$updateSourceControl(this.handle,{statusBarCommands:E})}get selected(){return this._selected}createResourceGroup(l,E){const v=new t(this._proxy,this._commands,this.handle,l,E),A=T.Event.once(v.onDidDispose)(()=>this.createdResourceGroups.delete(v));return this.createdResourceGroups.set(v,A),this.eventuallyAddResourceGroups(),v}eventuallyAddResourceGroups(){const l=[],E=[];for(const[v,A]of this.createdResourceGroups){A.dispose();const P=v.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(v),this.eventuallyUpdateResourceStates()});T.Event.once(v.onDidDispose)(()=>{this.updatedResourceGroups.delete(v),P.dispose(),this._groups.delete(v.handle),this._proxy.$unregisterGroup(this.handle,v.handle)}),l.push([v.handle,v.id,v.label,v.features]);const a=v._takeResourceStateSnapshot();a.length>0&&E.push([v.handle,a]),this._groups.set(v.handle,v)}this._proxy.$registerGroups(this.handle,l,E),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const l=[];this.updatedResourceGroups.forEach(E=>{const v=E._takeResourceStateSnapshot();v.length!==0&&l.push([E.handle,v])}),l.length>0&&this._proxy.$spliceResourceStates(this.handle,l),this.updatedResourceGroups.clear()}getResourceGroup(l){return this._groups.get(l)}setSelectionState(l){this._selected=l,this._onDidChangeSelection.fire(l)}dispose(){this._acceptInputDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(l=>l.dispose()),this._proxy.$unregisterSourceControl(this.handle)}}i._handlePool=0,He([S.debounce(100)],i.prototype,"eventuallyAddResourceGroups",null),He([S.debounce(100)],i.prototype,"eventuallyUpdateResourceStates",null);let s=class Nn{constructor(l,E,v){this._commands=E,this.logService=v,this._sourceControls=new Map,this._sourceControlsByExtension=new Map,this._onDidChangeActiveProvider=new T.Emitter,this._proxy=l.getProxy(D.MainContext.MainThreadSCM),this._telemetry=l.getProxy(D.MainContext.MainThreadTelemetry),E.registerArgumentProcessor({processArgument:A=>{if(A&&A.$mid===3){const P=this._sourceControls.get(A.sourceControlHandle);if(!P)return A;const a=P.getResourceGroup(A.groupHandle);return a?a.getResourceState(A.handle):A}else if(A&&A.$mid===4){const P=this._sourceControls.get(A.sourceControlHandle);return P?P.getResourceGroup(A.groupHandle):A}else if(A&&A.$mid===5){const P=this._sourceControls.get(A.handle);return P||A}return A}})}get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}createSourceControl(l,E,v,A){this.logService.trace("ExtHostSCM#createSourceControl",l.identifier.value,E,v,A),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:l.identifier.value});const P=Nn._handlePool++,a=new i(l,this._proxy,this._commands,E,v,A);this._sourceControls.set(P,a);const F=this._sourceControlsByExtension.get(I.ExtensionIdentifier.toKey(l.identifier))||[];return F.push(a),this._sourceControlsByExtension.set(I.ExtensionIdentifier.toKey(l.identifier),F),a}getLastInputBox(l){this.logService.trace("ExtHostSCM#getLastInputBox",l.identifier.value);const E=this._sourceControlsByExtension.get(I.ExtensionIdentifier.toKey(l.identifier)),v=E&&E[E.length-1];return v&&v.inputBox}$provideOriginalResource(l,E,v){const A=m.URI.revive(E);this.logService.trace("ExtHostSCM#$provideOriginalResource",l,A.toString());const P=this._sourceControls.get(l);return!P||!P.quickDiffProvider||!P.quickDiffProvider.provideOriginalResource?Promise.resolve(null):k.asPromise(()=>P.quickDiffProvider.provideOriginalResource(A,v)).then(a=>a||null)}$onInputBoxValueChange(l,E){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",l);const v=this._sourceControls.get(l);return v&&v.inputBox.$onInputBoxValueChange(E),Promise.resolve(void 0)}$executeResourceCommand(l,E,v,A){this.logService.trace("ExtHostSCM#$executeResourceCommand",l,E,v);const P=this._sourceControls.get(l);if(!P)return Promise.resolve(void 0);const a=P.getResourceGroup(E);return a?a.$executeResourceCommand(v,A):Promise.resolve(void 0)}$validateInput(l,E,v){this.logService.trace("ExtHostSCM#$validateInput",l);const A=this._sourceControls.get(l);return!A||!A.inputBox.validateInput?Promise.resolve(void 0):k.asPromise(()=>A.inputBox.validateInput(E,v)).then(P=>P?Promise.resolve([P.message,P.type]):Promise.resolve(void 0))}$setSelectedSourceControl(l){var E,v;return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",l),l!==void 0&&((E=this._sourceControls.get(l))===null||E===void 0||E.setSelectionState(!0)),this._selectedSourceControlHandle!==void 0&&((v=this._sourceControls.get(this._selectedSourceControlHandle))===null||v===void 0||v.setSelectionState(!1)),this._selectedSourceControlHandle=l,Promise.resolve(void 0)}};s._handlePool=0,s=He([ze(2,n.ILogService)],s),e.ExtHostSCM=s});var it=this&&this.__classPrivateFieldSet||function(Z,e,m,T,S){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!S:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?S.call(Z,m):S?S.value=m:e.set(Z,m),m},Ue=this&&this.__classPrivateFieldGet||function(Z,e,m,T){if(m==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!T:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?T:m==="a"?T.call(Z):T?T.value:e.get(Z)};define(_e[198],Ee([0,1,6,4,131,7]),function(Z,e,m,T,S,y){"use strict";var k,D;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class _{constructor(o,h,d,c,b=m.StatusBarAlignment.Left,p){k.set(this,void 0),D.set(this,void 0),this._disposed=!1,this._visible=!1,this._text="",this._internalCommandRegistration=new y.DisposableStore,it(this,k,o,"f"),it(this,D,h,"f"),this._entryId=_.ID_GEN++,this._extension=d,this._id=c,this._alignment=b,this._priority=p}get id(){var o;return(o=this._id)!==null&&o!==void 0?o:this._extension.identifier.value}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get name(){return this._name}get tooltip(){return this._tooltip}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){var o;return(o=this._command)===null||o===void 0?void 0:o.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(o){this._text=o,this.update()}set name(o){this._name=o,this.update()}set tooltip(o){this._tooltip=o,this.update()}set color(o){this._color=o,this.update()}set backgroundColor(o){o&&!_.ALLOWED_BACKGROUND_COLORS.has(o.id)&&(o=void 0),this._backgroundColor=o,this.update()}set command(o){var h;((h=this._command)===null||h===void 0?void 0:h.fromApi)!==o&&(this._internalCommandRegistration.clear(),typeof o=="string"?this._command={fromApi:o,internal:Ue(this,D,"f").toInternal({title:"",command:o},this._internalCommandRegistration)}:o?this._command={fromApi:o,internal:Ue(this,D,"f").toInternal(o,this._internalCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(o){this._accessibilityInformation=o,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,Ue(this,k,"f").$dispose(this._entryId)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{var o;this._timeoutHandle=void 0;let h;this._extension?this._id?h=`${this._extension.identifier.value}.${this._id}`:h=this._extension.identifier.value:h=this._id;let d;this._name?d=this._name:d=S.localize(0,null,this._extension.displayName||this._extension.name);let c=this._color;this._backgroundColor&&(c=_.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id)),Ue(this,k,"f").$setEntry(this._entryId,h,d,this._text,this._tooltip,(o=this._command)===null||o===void 0?void 0:o.internal,c,this._backgroundColor,this._alignment===m.StatusBarAlignment.Left?0:1,this._priority,this._accessibilityInformation)},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=_,k=new WeakMap,D=new WeakMap,_.ID_GEN=0,_.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new m.ThemeColor("statusBarItem.errorForeground")]]);class C{constructor(o){this._messages=[],this._item=o.createStatusBarEntry(void 0,"status.extensionMessage",m.StatusBarAlignment.Left,Number.MIN_VALUE),this._item.name=S.localize(1,null)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(o){const h={message:o};return this._messages.unshift(h),this._update(),new m.Disposable(()=>{const d=this._messages.indexOf(h);d>=0&&(this._messages.splice(d,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class n{constructor(o,h){this._proxy=o.getProxy(T.MainContext.MainThreadStatusBar),this._commands=h,this._statusMessage=new C(this)}createStatusBarEntry(o,h,d,c){return new _(this._proxy,this._commands,o,h,d,c)}setStatusBarMessage(o,h){const d=this._statusMessage.setMessage(o);let c;return typeof h=="number"?c=setTimeout(()=>d.dispose(),h):typeof h!="undefined"&&h.then(()=>d.dispose(),()=>d.dispose()),new m.Disposable(()=>{d.dispose(),clearTimeout(c)})}}e.ExtHostStatusBar=n}),define(_e[73],Ee([0,1,4,3,5]),function(Z,e,m,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class y{constructor(D){this._onDidChangeStorage=new T.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=D.getProxy(m.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(D,_){this._proxy.$registerExtensionStorageKeysToSync(D,_)}getValue(D,_,C){return this._proxy.$getValue(D,_).then(n=>n||C)}setValue(D,_,C){return this._proxy.$setValue(D,_,C)}$acceptValue(D,_,C){this._onDidChangeStorage.fire({shared:D,key:_,value:C})}}e.ExtHostStorage=y,e.IExtHostStorage=S.createDecorator("IExtHostStorage")}),define(_e[74],Ee([0,1,5,28,15,72,2]),function(Z,e,m,T,S,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=m.createDecorator("IExtensionStoragePaths");let D=class{constructor(C,n,I){var o;this._logService=n,this._extHostFileSystem=I,this._workspace=(o=C.workspace)!==null&&o!==void 0?o:void 0,this._environment=C.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(h=>this._value=h)}async _getOrCreateWorkspaceStoragePath(){var C;if(!this._workspace)return Promise.resolve(void 0);const n=this._workspace.id,I=k.URI.joinPath(this._environment.workspaceStorageHome,n);try{return await this._extHostFileSystem.value.stat(I),this._logService.trace("[ExtHostStorage] storage dir already exists",I),I}catch(o){}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",I),await this._extHostFileSystem.value.createDirectory(I),await this._extHostFileSystem.value.writeFile(k.URI.joinPath(I,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:(C=k.URI.revive(this._workspace.configuration))===null||C===void 0?void 0:C.toString(),name:this._workspace.name},void 0,2))),I}catch(o){this._logService.error("[ExtHostStorage]",o);return}}workspaceValue(C){if(this._value)return k.URI.joinPath(this._value,C.identifier.value)}globalValue(C){return k.URI.joinPath(this._environment.globalStorageHome,C.identifier.value.toLowerCase())}};D=He([ze(0,T.IExtHostInitDataService),ze(1,S.ILogService),ze(2,y.IExtHostConsumerFileSystem)],D),e.ExtensionStoragePaths=D}),define(_e[37],Ee([0,1,3,4,5,2,13,7,6,132,11,163,18,34,152,10]),function(Z,e,m,T,S,y,k,D,_,C,n,I,o,h,d,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.EnvironmentVariableCollection=e.BaseExtHostTerminalService=e.ExtHostPseudoterminal=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=S.createDecorator("IExtHostTerminalService");class b{constructor(s,r,l,E){this._proxy=s,this._id=r,this._creationOptions=l,this._name=E,this._disposed=!1,this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(A=>this._pidPromiseComplete=A);const v=this;this.value={get name(){return v._name||""},get processId(){return v._pidPromise},get creationOptions(){return v._creationOptions},get exitStatus(){return v._exitStatus},sendText(A,P=!0){v._checkDisposed(),v._proxy.$sendText(v._id,A,P)},show(A){v._checkDisposed(),v._proxy.$show(v._id,A)},hide(){v._checkDisposed(),v._proxy.$hide(v._id)},dispose(){v._disposed||(v._disposed=!0,v._proxy.$dispose(v._id))},get dimensions(){if(!(v._cols===void 0||v._rows===void 0))return{columns:v._cols,rows:v._rows}}}}async create(s,r){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:s.name,shellPath:c.withNullAsUndefined(s.shellPath),shellArgs:c.withNullAsUndefined(s.shellArgs),cwd:c.withNullAsUndefined(s.cwd),env:c.withNullAsUndefined(s.env),icon:c.withNullAsUndefined(t(s.iconPath)),initialText:c.withNullAsUndefined(s.message),strictEnv:c.withNullAsUndefined(s.strictEnv),hideFromUser:c.withNullAsUndefined(s.hideFromUser),isFeatureTerminal:c.withNullAsUndefined(r==null?void 0:r.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:c.withNullAsUndefined(r==null?void 0:r.useShellEnvironment),isSplitTerminal:c.withNullAsUndefined(r==null?void 0:r.isSplitTerminal)})}async createExtensionTerminal(s,r){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0,icon:r,isSplitTerminal:s}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(s){this._name=s}setExitCode(s){this._exitStatus=Object.freeze({code:s})}setDimensions(s,r){return s===this._cols&&r===this._rows||s===0||r===0?!1:(this._cols=s,this._rows=r,!0)}_setProcessId(s){this._pidPromiseComplete?(this._pidPromiseComplete(s),this._pidPromiseComplete=void 0):this._pidPromise.then(r=>{r!==s&&(this._pidPromise=Promise.resolve(s))})}}e.ExtHostTerminal=b;class p{constructor(s){this._pty=s,this.id=0,this.shouldPersist=!1,this._onProcessData=new m.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessExit=new m.Emitter,this.onProcessExit=this._onProcessExit.event,this._onProcessReady=new m.Emitter,this._onProcessTitleChanged=new m.Emitter,this.onProcessTitleChanged=this._onProcessTitleChanged.event,this._onProcessOverrideDimensions=new m.Emitter,this._onProcessShellTypeChanged=new m.Emitter,this.onProcessShellTypeChanged=this._onProcessShellTypeChanged.event}get onProcessReady(){return this._onProcessReady.event}get onProcessOverrideDimensions(){return this._onProcessOverrideDimensions.event}async start(){}shutdown(){this._pty.close()}input(s){this._pty.handleInput&&this._pty.handleInput(s)}resize(s,r){this._pty.setDimensions&&this._pty.setDimensions({columns:s,rows:r})}async processBinary(s){}acknowledgeDataEvent(s){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(s){this._pty.onDidWrite(r=>this._onProcessData.fire(r)),this._pty.onDidClose&&this._pty.onDidClose((r=void 0)=>{this._onProcessExit.fire(r===void 0?void 0:r)}),this._pty.onDidOverrideDimensions&&this._pty.onDidOverrideDimensions(r=>this._onProcessOverrideDimensions.fire(r&&{cols:r.columns,rows:r.rows})),this._pty.onDidChangeName&&this._pty.onDidChangeName(r=>this._onProcessTitleChanged.fire(r)),this._pty.open(s||void 0),this._pty.setDimensions&&s&&this._pty.setDimensions(s),this._onProcessReady.fire({pid:-1,cwd:""})}}e.ExtHostPseudoterminal=p;let w=1,u=class extends D.Disposable{constructor(s,r){super();this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._linkProviders=new Set,this._profileProviders=new Map,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new m.Emitter,this._onDidOpenTerminal=new m.Emitter,this._onDidChangeActiveTerminal=new m.Emitter,this._onDidChangeTerminalDimensions=new m.Emitter,this._proxy=r.getProxy(T.MainContext.MainThreadTerminalService),this._bufferer=new d.TerminalDataBufferer(this._proxy.$sendProcessData),this._onDidWriteTerminalData=new m.Emitter({onFirstListenerAdd:()=>this._proxy.$startSendingDataEvents(),onLastListenerRemove:()=>this._proxy.$stopSendingDataEvents()}),this._proxy.$registerProcessSupport(s),this._register({dispose:()=>{for(const[l,E]of this._terminalProcesses)E.shutdown(!0)}})}get activeTerminal(){var s;return(s=this._activeTerminal)===null||s===void 0?void 0:s.value}get terminals(){return this._terminals.map(s=>s.value)}get onDidCloseTerminal(){return this._onDidCloseTerminal&&this._onDidCloseTerminal.event}get onDidOpenTerminal(){return this._onDidOpenTerminal&&this._onDidOpenTerminal.event}get onDidChangeActiveTerminal(){return this._onDidChangeActiveTerminal&&this._onDidChangeActiveTerminal.event}get onDidChangeTerminalDimensions(){return this._onDidChangeTerminalDimensions&&this._onDidChangeTerminalDimensions.event}get onDidWriteTerminalData(){return this._onDidWriteTerminalData&&this._onDidWriteTerminalData.event}getDefaultShell(s){const r=s?this._defaultAutomationProfile:this._defaultProfile;return(r==null?void 0:r.path)||""}getDefaultShellArgs(s){const r=s?this._defaultAutomationProfile:this._defaultProfile;return(r==null?void 0:r.args)||[]}createExtensionTerminal(s,r){const l=new b(this._proxy,h.generateUuid(),s,s.name),E=new p(s.pty);return l.createExtensionTerminal(r==null?void 0:r.isSplitTerminal,t(s.iconPath)).then(v=>{const A=this._setupExtHostProcessListeners(v,E);this._terminalProcessDisposables[v]=A}),this._terminals.push(l),l.value}attachPtyToTerminal(s,r){if(!this._getTerminalById(s))throw new Error(`Cannot resolve terminal with id ${s} for virtual process`);const E=new p(r),v=this._setupExtHostProcessListeners(s,E);this._terminalProcessDisposables[s]=v}async $acceptActiveTerminalChanged(s){const r=this._activeTerminal;if(s===null){this._activeTerminal=void 0,r!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const l=this._getTerminalById(s);l&&(this._activeTerminal=l,r!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(s,r){const l=this._getTerminalById(s);l&&this._onDidWriteTerminalData.fire({terminal:l.value,data:r})}async $acceptTerminalDimensions(s,r,l){const E=this._getTerminalById(s);E&&E.setDimensions(r,l)&&this._onDidChangeTerminalDimensions.fire({terminal:E.value,dimensions:E.value.dimensions})}async $acceptTerminalMaximumDimensions(s,r,l){var E;(E=this._terminalProcesses.get(s))===null||E===void 0||E.resize(r,l)}async $acceptTerminalTitleChange(s,r){const l=this._getTerminalById(s);l&&(l.name=r)}async $acceptTerminalClosed(s,r){const l=this._getTerminalObjectIndexById(this._terminals,s);if(l!==null){const E=this._terminals.splice(l,1)[0];E.setExitCode(r),this._onDidCloseTerminal.fire(E.value)}}$acceptTerminalOpened(s,r,l,E){if(r){const P=this._getTerminalObjectIndexById(this._terminals,r);if(P!==null){this._terminals[P]._id=s,this._onDidOpenTerminal.fire(this.terminals[P]),this._terminals[P].isOpen=!0;return}}const v={name:E.name,shellPath:E.executable,shellArgs:E.args,cwd:typeof E.cwd=="string"?E.cwd:y.URI.revive(E.cwd),env:E.env,hideFromUser:E.hideFromUser},A=new b(this._proxy,s,v,l);this._terminals.push(A),this._onDidOpenTerminal.fire(A.value),A.isOpen=!0}async $acceptTerminalProcessId(s,r){const l=this._getTerminalById(s);l&&l._setProcessId(r)}async $startExtensionTerminal(s,r){const l=this._getTerminalById(s);if(!l)return{message:C.localize(0,null,s)};l.isOpen||await new Promise(v=>{const A=this.onDidOpenTerminal(async P=>{P===l.value&&(A.dispose(),v())})});const E=this._terminalProcesses.get(s);E?E.startSendingEvents(r):this._extensionTerminalAwaitingStart[s]={initialDimensions:r}}_setupExtHostProcessListeners(s,r){const l=new D.DisposableStore;l.add(r.onProcessReady(v=>this._proxy.$sendProcessReady(s,v.pid,v.cwd))),l.add(r.onProcessTitleChanged(v=>this._proxy.$sendProcessTitle(s,v))),this._bufferer.startBuffering(s,r.onProcessData),l.add(r.onProcessExit(v=>this._onProcessExit(s,v))),r.onProcessOverrideDimensions&&l.add(r.onProcessOverrideDimensions(v=>this._proxy.$sendOverrideDimensions(s,v))),this._terminalProcesses.set(s,r);const E=this._extensionTerminalAwaitingStart[s];return E&&r instanceof p&&(r.startSendingEvents(E.initialDimensions),delete this._extensionTerminalAwaitingStart[s]),l}$acceptProcessAckDataEvent(s,r){var l;(l=this._terminalProcesses.get(s))===null||l===void 0||l.acknowledgeDataEvent(r)}$acceptProcessInput(s,r){var l;(l=this._terminalProcesses.get(s))===null||l===void 0||l.input(r)}$acceptProcessResize(s,r,l){var E;try{(E=this._terminalProcesses.get(s))===null||E===void 0||E.resize(r,l)}catch(v){if(v.code!=="EPIPE"&&v.code!=="ERR_IPC_CHANNEL_CLOSED")throw v}}$acceptProcessShutdown(s,r){var l;(l=this._terminalProcesses.get(s))===null||l===void 0||l.shutdown(r)}$acceptProcessRequestInitialCwd(s){var r;(r=this._terminalProcesses.get(s))===null||r===void 0||r.getInitialCwd().then(l=>this._proxy.$sendProcessInitialCwd(s,l))}$acceptProcessRequestCwd(s){var r;(r=this._terminalProcesses.get(s))===null||r===void 0||r.getCwd().then(l=>this._proxy.$sendProcessCwd(s,l))}$acceptProcessRequestLatency(s){return s}registerLinkProvider(s){return this._linkProviders.add(s),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new _.Disposable(()=>{this._linkProviders.delete(s),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}registerProfileProvider(s,r){if(this._profileProviders.has(s))throw new Error(`Terminal profile provider "${s}" already registered`);return this._profileProviders.set(s,r),this._proxy.$registerProfileProvider(s),new _.Disposable(()=>{this._profileProviders.delete(s),this._proxy.$unregisterProfileProvider(s)})}async $createContributedProfileTerminal(s,r){var l;const E=new o.CancellationTokenSource().token,v=await((l=this._profileProviders.get(s))===null||l===void 0?void 0:l.provideProfileOptions(E));if(!E.isCancellationRequested){if(!v)throw new Error(`No terminal profile options provided for id "${s}"`);if("pty"in v){this.createExtensionTerminal(v,{isSplitTerminal:r});return}this.createTerminalFromOptions(v,{isSplitTerminal:r})}}async $provideLinks(s,r){const l=this._getTerminalById(s);if(!l)return[];this._terminalLinkCache.delete(s);const E=this._terminalLinkCancellationSource.get(s);E&&E.dispose(!0);const v=new o.CancellationTokenSource;this._terminalLinkCancellationSource.set(s,v);const A=[],P={terminal:l.value,line:r},a=[];for(const W of this._linkProviders)a.push(new Promise(async le=>{v.token.onCancellationRequested(()=>le({provider:W,links:[]}));const fe=await W.provideTerminalLinks(P,v.token)||[];v.token.isCancellationRequested||le({provider:W,links:fe})}));const F=await Promise.all(a);if(v.token.isCancellationRequested)return[];const N=new Map;for(const W of F)W&&W.links.length>0&&A.push(...W.links.map(le=>{const fe={id:w++,startIndex:le.startIndex,length:le.length,label:le.tooltip};return N.set(fe.id,{provider:W.provider,link:le}),fe}));return this._terminalLinkCache.set(s,N),A}$activateLink(s,r){var l;const E=(l=this._terminalLinkCache.get(s))===null||l===void 0?void 0:l.get(r);!E||E.provider.handleTerminalLink(E.link)}_onProcessExit(s,r){this._bufferer.stopBuffering(s),this._terminalProcesses.delete(s),delete this._extensionTerminalAwaitingStart[s];const l=this._terminalProcessDisposables[s];l&&(l.dispose(),delete this._terminalProcessDisposables[s]),this._proxy.$sendProcessExit(s,r)}_getTerminalById(s){return this._getTerminalObjectById(this._terminals,s)}_getTerminalObjectById(s,r){const l=this._getTerminalObjectIndexById(s,r);return l!==null?s[l]:null}_getTerminalObjectIndexById(s,r){let l=null;return s.some((E,v)=>E._id===r?(l=v,!0):!1),l}getEnvironmentVariableCollection(s){let r=this._environmentVariableCollections.get(s.identifier.value);return r||(r=new f,this._setEnvironmentVariableCollection(s.identifier.value,r)),r}_syncEnvironmentVariableCollection(s,r){const l=I.serializeEnvironmentVariableCollection(r.map);this._proxy.$setEnvironmentVariableCollection(s,r.persistent,l.length===0?void 0:l)}$initEnvironmentVariableCollections(s){s.forEach(r=>{const l=r[0],E=new f(r[1]);this._setEnvironmentVariableCollection(l,E)})}$acceptDefaultProfile(s,r){this._defaultProfile=s,this._defaultAutomationProfile=r}_setEnvironmentVariableCollection(s,r){this._environmentVariableCollections.set(s,r),r.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(s,r)})}};u=He([ze(1,k.IExtHostRpcService)],u),e.BaseExtHostTerminalService=u;class f{constructor(s){this.map=new Map,this._persistent=!0,this._onDidChangeCollection=new m.Emitter,this.map=new Map(s)}get persistent(){return this._persistent}set persistent(s){this._persistent=s,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}get size(){return this.map.size}replace(s,r){this._setIfDiffers(s,{value:r,type:_.EnvironmentVariableMutatorType.Replace})}append(s,r){this._setIfDiffers(s,{value:r,type:_.EnvironmentVariableMutatorType.Append})}prepend(s,r){this._setIfDiffers(s,{value:r,type:_.EnvironmentVariableMutatorType.Prepend})}_setIfDiffers(s,r){const l=this.map.get(s);(!l||l.value!==r.value||l.type!==r.type)&&(this.map.set(s,r),this._onDidChangeCollection.fire())}get(s){return this.map.get(s)}forEach(s,r){this.map.forEach((l,E)=>s.call(r,E,l,this))}delete(s){this.map.delete(s),this._onDidChangeCollection.fire()}clear(){this.map.clear(),this._onDidChangeCollection.fire()}}e.EnvironmentVariableCollection=f;let g=class extends u{constructor(s){super(!1,s)}createTerminal(s,r,l){throw new n.NotSupportedError}createTerminalFromOptions(s,r){throw new n.NotSupportedError}};g=He([ze(0,k.IExtHostRpcService)],g),e.WorkerExtHostTerminalService=g;function t(i){if(!!i)return"id"in i?{id:i.id,color:i.color}:i}}),define(_e[199],Ee([0,1,3,17,4,98,9,6]),function(Z,e,m,T,S,y,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class _{constructor(n,I){this._extHostDocumentsAndEditors=I,this._onDidChangeTextEditorSelection=new m.Emitter,this._onDidChangeTextEditorOptions=new m.Emitter,this._onDidChangeTextEditorVisibleRanges=new m.Emitter,this._onDidChangeTextEditorViewColumn=new m.Emitter,this._onDidChangeActiveTextEditor=new m.Emitter,this._onDidChangeVisibleTextEditors=new m.Emitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=n.getProxy(S.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(o=>this._onDidChangeVisibleTextEditors.fire(o)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(o=>this._onDidChangeActiveTextEditor.fire(o))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(n){const I=this._extHostDocumentsAndEditors.allEditors();return n?I:I.map(o=>o.value)}async showTextDocument(n,I,o){let h;typeof I=="number"?h={position:k.ViewColumn.from(I),preserveFocus:o}:typeof I=="object"?h={position:k.ViewColumn.from(I.viewColumn),preserveFocus:I.preserveFocus,selection:typeof I.selection=="object"?k.Range.from(I.selection):void 0,pinned:typeof I.preview=="boolean"?!I.preview:void 0}:h={preserveFocus:!1};const d=await this._proxy.$tryShowTextDocument(n.uri,h),c=d&&this._extHostDocumentsAndEditors.getEditor(d);if(c)return c.value;throw d?new Error(`Could NOT open editor for "${n.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${n.uri.toString()}".`)}createTextEditorDecorationType(n,I){return new y.TextEditorDecorationType(this._proxy,n,I).value}$acceptEditorPropertiesChanged(n,I){const o=this._extHostDocumentsAndEditors.getEditor(n);if(!o)throw new Error("unknown text editor");if(I.options&&o._acceptOptions(I.options),I.selections){const h=I.selections.selections.map(k.Selection.to);o._acceptSelections(h)}if(I.visibleRanges){const h=T.coalesce(I.visibleRanges.map(k.Range.to));o._acceptVisibleRanges(h)}if(I.options&&this._onDidChangeTextEditorOptions.fire({textEditor:o.value,options:Object.assign(Object.assign({},I.options),{lineNumbers:k.TextEditorLineNumbersStyle.to(I.options.lineNumbers)})}),I.selections){const h=D.TextEditorSelectionChangeKind.fromValue(I.selections.source),d=I.selections.selections.map(k.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:o.value,selections:d,kind:h})}if(I.visibleRanges){const h=T.coalesce(I.visibleRanges.map(k.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:o.value,visibleRanges:h})}}$acceptEditorPositionData(n){for(const I in n){const o=this._extHostDocumentsAndEditors.getEditor(I);if(!o)throw new Error("Unknown text editor");const h=k.ViewColumn.to(n[I]);o.value.viewColumn!==h&&(o._acceptViewColumn(h),this._onDidChangeTextEditorViewColumn.fire({textEditor:o.value,viewColumn:h}))}}getDiffInformation(n){return Promise.resolve(this._proxy.$getDiffInformation(n))}}e.ExtHostEditors=_});var _n=this&&this.__rest||function(Z,e){var m={};for(var T in Z)Object.prototype.hasOwnProperty.call(Z,T)&&e.indexOf(T)<0&&(m[T]=Z[T]);if(Z!=null&&typeof Object.getOwnPropertySymbols=="function")for(var S=0,T=Object.getOwnPropertySymbols(Z);S<T.length;S++)e.indexOf(T[S])<0&&Object.prototype.propertyIsEnumerable.call(Z,T[S])&&(m[T[S]]=Z[T[S]]);return m};define(_e[200],Ee([0,1,2,5,4,7,6]),function(Z,e,m,T,S,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=T.createDecorator("IExtHostTimeline");class D{constructor(n,I){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=n.getProxy(S.MainContext.MainThreadTimeline),I.registerArgumentProcessor({processArgument:o=>{var h,d;if(o&&o.$mid===11){const c=o.uri===void 0?void 0:m.URI.revive(o.uri);return(d=(h=this._itemsBySourceAndUriMap.get(o.source))===null||h===void 0?void 0:h.get(_(c)))===null||d===void 0?void 0:d.get(o.handle)}return o}})}async $getTimeline(n,I,o,h,d){const c=this._providers.get(n);return c==null?void 0:c.provideTimeline(m.URI.revive(I),o,h,d)}registerTimelineProvider(n,I,o,h){const d=new y.DisposableStore,c=this.convertTimelineItem(I.id,h,d).bind(this);let b;I.onDidChange&&(b=I.onDidChange(w=>this._proxy.$emitTimelineChangeEvent(Object.assign(Object.assign({uri:void 0,reset:!0},w),{id:I.id})),this));const p=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore(Object.assign(Object.assign({},I),{scheme:n,onDidChange:void 0,async provideTimeline(w,u,f,g){var t;(g==null?void 0:g.resetCache)&&(d.clear(),(t=p.get(I.id))===null||t===void 0||t.clear());const i=await I.provideTimeline(w,u,f);if(i==null)return;const s=c(w,g);return Object.assign(Object.assign({},i),{source:I.id,items:i.items.map(s)})},dispose(){var w;for(const u of p.values())(w=u.get(I.id))===null||w===void 0||w.clear();b==null||b.dispose(),d.dispose()}}))}convertTimelineItem(n,I,o){return(h,d)=>{let c;if(d==null?void 0:d.cacheResults){let b=this._itemsBySourceAndUriMap.get(n);b===void 0&&(b=new Map,this._itemsBySourceAndUriMap.set(n,b));const p=_(h);c=b.get(p),c===void 0&&(c=new Map,b.set(p,c))}return b=>{var p,w;const{iconPath:u}=b,f=_n(b,["iconPath"]),g=`${n}|${(p=b.id)!==null&&p!==void 0?p:b.timestamp}`;c==null||c.set(g,b);let t,i,s;return b.iconPath&&(u instanceof k.ThemeIcon?s={id:u.id}:m.URI.isUri(u)?(t=u,i=u):{light:t,dark:i}=u),Object.assign(Object.assign({},f),{id:(w=f.id)!==null&&w!==void 0?w:void 0,handle:g,source:n,command:b.command?I.toInternal(b.command,o):void 0,icon:t,iconDark:i,themeIcon:s,accessibilityInformation:b.accessibilityInformation})}}}registerTimelineProviderCore(n){if(this._providers.get(n.id))throw new Error(`Timeline Provider ${n.id} already exists.`);return this._proxy.$registerTimelineProvider({id:n.id,label:n.label,scheme:n.scheme}),this._providers.set(n.id,n),y.toDisposable(()=>{var o;for(const h of this._itemsBySourceAndUriMap.values())(o=h.get(n.id))===null||o===void 0||o.clear();this._providers.delete(n.id),this._proxy.$unregisterTimelineProvider(n.id),n.dispose()})}}e.ExtHostTimeline=D;function _(C){return C==null?void 0:C.toString()}}),define(_e[201],Ee([0,1,7,16,2,4]),function(Z,e,m,T,S,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class k{constructor(_){this._openers=new Map,this._proxy=_.getProxy(y.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(_,C,n,I){if(this._openers.has(C))throw new Error(`Opener with id '${C}' already registered`);const o=I.schemes.find(h=>!k.supportedSchemes.has(h));if(o)throw new Error(`Scheme '${o}' is not supported. Only http and https are currently supported.`);return this._openers.set(C,n),this._proxy.$registerUriOpener(C,I.schemes,_,I.label),m.toDisposable(()=>{this._openers.delete(C),this._proxy.$unregisterUriOpener(C)})}async $canOpenUri(_,C,n){const I=this._openers.get(_);if(!I)throw new Error(`Unknown opener with id: ${_}`);const o=S.URI.revive(C);return I.canOpenExternalUri(o,n)}async $openUri(_,C,n){const I=this._openers.get(_);if(!I)throw new Error(`Unknown opener id: '${_}'`);return I.openExternalUri(S.URI.revive(C.resolvedUri),{sourceUri:S.URI.revive(C.sourceUri)},n)}}e.ExtHostUriOpeners=k,k.supportedSchemes=new Set([T.Schemas.http,T.Schemas.https])}),define(_e[202],Ee([0,1,4,2,7,11,26]),function(Z,e,m,T,S,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class D{constructor(C){this.handles=new Set,this.handlers=new Map,this._proxy=C.getProxy(m.MainContext.MainThreadUrls)}registerUriHandler(C,n){if(this.handles.has(k.ExtensionIdentifier.toKey(C)))throw new Error(`Protocol handler already registered for extension ${C}`);const I=D.HandlePool++;return this.handles.add(k.ExtensionIdentifier.toKey(C)),this.handlers.set(I,n),this._proxy.$registerUriHandler(I,C),S.toDisposable(()=>{this.handles.delete(k.ExtensionIdentifier.toKey(C)),this.handlers.delete(I),this._proxy.$unregisterUriHandler(I)})}$handleExternalUri(C,n){const I=this.handlers.get(C);if(!I)return Promise.resolve(void 0);try{I.handleUri(T.URI.revive(n))}catch(o){y.onUnexpectedError(o)}return Promise.resolve(void 0)}async createAppUri(C){return T.URI.revive(await this._proxy.$createAppUri(C))}}e.ExtHostUrls=D,D.HandlePool=0});var it=this&&this.__classPrivateFieldSet||function(Z,e,m,T,S){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!S:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?S.call(Z,m):S?S.value=m:e.set(Z,m),m},Ue=this&&this.__classPrivateFieldGet||function(Z,e,m,T){if(m==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!T:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?T:m==="a"?T.call(Z):T?T.value:e.get(Z)};define(_e[46],Ee([0,1,3,2,140,158,67,4]),function(Z,e,m,T,S,y,k,D){"use strict";var _,C,n,I,o,h,d,c,b,p,w,u;Object.defineProperty(e,"__esModule",{value:!0}),e.reviveOptions=e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class f{constructor(v,A,P,a,F,N,W){_.set(this,void 0),C.set(this,void 0),n.set(this,void 0),I.set(this,void 0),o.set(this,void 0),h.set(this,void 0),d.set(this,""),c.set(this,void 0),b.set(this,!1),p.set(this,!1),w.set(this,!1),this._onMessageEmitter=new m.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,u.set(this,new m.Emitter),this._onDidDispose=Ue(this,u,"f").event,it(this,_,v,"f"),it(this,C,A,"f"),it(this,c,P,"f"),it(this,I,a,"f"),it(this,o,F,"f"),it(this,h,N,"f"),it(this,w,g(N),"f"),it(this,n,W,"f")}dispose(){it(this,b,!0,"f"),Ue(this,u,"f").fire(),Ue(this,u,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(v){return it(this,p,!0,"f"),k.asWebviewUri(v,Ue(this,I,"f").remote)}get cspSource(){return k.webviewGenericCspSource}get html(){return this.assertNotDisposed(),Ue(this,d,"f")}set html(v){this.assertNotDisposed(),Ue(this,d,"f")!==v&&(it(this,d,v,"f"),!Ue(this,p,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(v)&&(it(this,p,!0,"f"),Ue(this,n,"f").report("Webview vscode-resource: uris",Ue(this,h,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Ue(this,C,"f").$setHtml(Ue(this,_,"f"),v))}get options(){return this.assertNotDisposed(),Ue(this,c,"f")}set options(v){this.assertNotDisposed(),Ue(this,C,"f").$setOptions(Ue(this,_,"f"),s(Ue(this,h,"f"),Ue(this,o,"f"),v)),it(this,c,v,"f")}async postMessage(v){if(Ue(this,b,"f"))return!1;const A=y.serializeWebviewMessage(v,{serializeBuffersForPostMessage:Ue(this,w,"f")});return Ue(this,C,"f").$postMessage(Ue(this,_,"f"),A.message,...A.buffers)}assertNotDisposed(){if(Ue(this,b,"f"))throw new Error("Webview is disposed")}}e.ExtHostWebview=f,_=new WeakMap,C=new WeakMap,n=new WeakMap,I=new WeakMap,o=new WeakMap,h=new WeakMap,d=new WeakMap,c=new WeakMap,b=new WeakMap,p=new WeakMap,w=new WeakMap,u=new WeakMap;function g(E){try{const v=S.normalizeVersion(S.parseVersion(E.engines.vscode));return!!v&&v.majorBase>=1&&v.minorBase>=57}catch(v){return!1}}e.shouldSerializeBuffersForPostMessage=g;class t{constructor(v,A,P,a,F){this.initData=A,this.workspace=P,this._logService=a,this._deprecationService=F,this._webviews=new Map,this._webviewProxy=v.getProxy(D.MainContext.MainThreadWebviews)}$onMessage(v,A,...P){const a=this.getWebview(v);if(a){const{message:F}=y.deserializeWebviewMessage(A,P);a._onMessageEmitter.fire(F)}}$onMissingCsp(v,A){this._logService.warn(`${A} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(v,A,P){const a=new f(v,this._webviewProxy,r(A),this.initData,this.workspace,P,this._deprecationService);return this._webviews.set(v,a),a._onDidDispose(()=>{this._webviews.delete(v)}),a}deleteWebview(v){this._webviews.delete(v)}getWebview(v){return this._webviews.get(v)}}e.ExtHostWebviews=t;function i(E){return{id:E.identifier,location:E.extensionLocation}}e.toExtensionData=i;function s(E,v,A){return{enableCommandUris:A.enableCommandUris,enableScripts:A.enableScripts,portMapping:A.portMapping,localResourceRoots:A.localResourceRoots||l(E,v)}}e.serializeWebviewOptions=s;function r(E){var v;return{enableCommandUris:E.enableCommandUris,enableScripts:E.enableScripts,portMapping:E.portMapping,localResourceRoots:(v=E.localResourceRoots)===null||v===void 0?void 0:v.map(A=>T.URI.from(A))}}e.reviveOptions=r;function l(E,v){return[...((v==null?void 0:v.getWorkspaceFolders())||[]).map(A=>A.uri),E.extensionLocation]}}),define(_e[203],Ee([0,1,18,53,7,16,25,2,9,46,62,4,6]),function(Z,e,m,T,S,y,k,D,_,C,n,I,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class h{constructor(t,i){this.document=t,this._storagePath=i,this._backupCounter=1,this._edits=new n.Cache("custom documents")}addEdit(t){return this._edits.add([t])}async undo(t,i){await this.getEdit(t).undo(),i||this.disposeBackup()}async redo(t,i){await this.getEdit(t).redo(),i||this.disposeBackup()}disposeEdits(t){for(const i of t)this._edits.delete(i)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const t=f(this.document.uri)+this._backupCounter++;return k.joinPath(this._storagePath,t)}updateBackup(t){var i;(i=this._backup)===null||i===void 0||i.delete(),this._backup=t}disposeBackup(){var t;(t=this._backup)===null||t===void 0||t.delete(),this._backup=void 0}getEdit(t){const i=this._edits.get(t,0);if(!i)throw new Error("No edit found");return i}}class d{constructor(){this._documents=new Map}get(t,i){return this._documents.get(this.key(t,i))}add(t,i,s){const r=this.key(t,i.uri);if(this._documents.has(r))throw new Error(`Document already exists for viewType:${t} resource:${i.uri}`);const l=new h(i,s);return this._documents.set(r,l),l}delete(t,i){const s=this.key(t,i.uri);this._documents.delete(s)}key(t,i){return`${t}@@@${i}`}}var c;(function(g){g[g.Text=0]="Text",g[g.Custom=1]="Custom"})(c||(c={}));class b{constructor(){this._providers=new Map}addTextProvider(t,i,s){return this.add(0,t,i,s)}addCustomProvider(t,i,s){return this.add(1,t,i,s)}get(t){return this._providers.get(t)}add(t,i,s,r){if(this._providers.has(i))throw new Error(`Provider for viewType:${i} already registered`);return this._providers.set(i,{type:t,extension:s,provider:r}),new o.Disposable(()=>this._providers.delete(i))}}class p{constructor(t,i,s,r,l){this._extHostDocuments=i,this._extensionStoragePaths=s,this._extHostWebview=r,this._extHostWebviewPanels=l,this._editorProviders=new b,this._documents=new d,this._proxy=t.getProxy(I.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(t,i,s,r){const l=new S.DisposableStore;return w(s)?(l.add(this._editorProviders.addTextProvider(i,t,s)),this._proxy.$registerTextEditorProvider(C.toExtensionData(t),i,r.webviewOptions||{},{supportsMove:!!s.moveCustomTextEditor},C.shouldSerializeBuffersForPostMessage(t))):(l.add(this._editorProviders.addCustomProvider(i,t,s)),this.supportEditing(s)&&l.add(s.onDidChangeCustomDocument(E=>{const v=this.getCustomDocumentEntry(i,E.document.uri);if(u(E)){const A=v.addEdit(E);this._proxy.$onDidEdit(E.document.uri,i,A,E.label)}else this._proxy.$onContentChange(E.document.uri,i)})),this._proxy.$registerCustomEditorProvider(C.toExtensionData(t),i,r.webviewOptions||{},!!r.supportsMultipleEditorsPerDocument,C.shouldSerializeBuffersForPostMessage(t))),o.Disposable.from(l,new o.Disposable(()=>{this._proxy.$unregisterEditorProvider(i)}))}async $createCustomDocument(t,i,s,r,l){var E;const v=this._editorProviders.get(i);if(!v)throw new Error(`No provider found for '${i}'`);if(v.type!==1)throw new Error(`Invalid provide type for '${i}'`);const A=D.URI.revive(t),P=await v.provider.openCustomDocument(A,{backupId:s,untitledDocumentData:r==null?void 0:r.buffer},l);let a;return this.supportEditing(v.provider)&&this._extensionStoragePaths&&(a=(E=this._extensionStoragePaths.workspaceValue(v.extension))!==null&&E!==void 0?E:this._extensionStoragePaths.globalValue(v.extension)),this._documents.add(i,P,a),{editable:this.supportEditing(v.provider)}}async $disposeCustomDocument(t,i){const s=this._editorProviders.get(i);if(!s)throw new Error(`No provider found for '${i}'`);if(s.type!==1)throw new Error(`Invalid provider type for '${i}'`);const r=D.URI.revive(t),{document:l}=this.getCustomDocumentEntry(i,r);this._documents.delete(i,l),l.dispose()}async $resolveWebviewEditor(t,i,s,r,l,E){const v=this._editorProviders.get(s);if(!v)throw new Error(`No provider found for '${s}'`);const A=_.ViewColumn.to(l),P=this._extHostWebview.createNewWebview(i,r.webviewOptions,v.extension),a=this._extHostWebviewPanels.createNewWebviewPanel(i,s,r.title,A,r.panelOptions,P),F=D.URI.revive(t);switch(v.type){case 1:{const{document:N}=this.getCustomDocumentEntry(s,F);return v.provider.resolveCustomEditor(N,a,E)}case 0:{const N=this._extHostDocuments.getDocument(F);return v.provider.resolveCustomTextEditor(N,a,E)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(t,i,s){this.getCustomDocumentEntry(i,t).disposeEdits(s)}async $onMoveCustomEditor(t,i,s){const r=this._editorProviders.get(s);if(!r)throw new Error(`No provider found for '${s}'`);if(!r.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${s}'`);const l=this._extHostWebviewPanels.getWebviewPanel(t);if(!l)throw new Error("No webview found");const E=D.URI.revive(i),v=this._extHostDocuments.getDocument(E);await r.provider.moveCustomTextEditor(v,l,m.CancellationToken.None)}async $undo(t,i,s,r){return this.getCustomDocumentEntry(i,t).undo(s,r)}async $redo(t,i,s,r){return this.getCustomDocumentEntry(i,t).redo(s,r)}async $revert(t,i,s){const r=this.getCustomDocumentEntry(i,t);await this.getCustomEditorProvider(i).revertCustomDocument(r.document,s),r.disposeBackup()}async $onSave(t,i,s){const r=this.getCustomDocumentEntry(i,t);await this.getCustomEditorProvider(i).saveCustomDocument(r.document,s),r.disposeBackup()}async $onSaveAs(t,i,s,r){const l=this.getCustomDocumentEntry(i,t);return this.getCustomEditorProvider(i).saveCustomDocumentAs(l.document,D.URI.revive(s),r)}async $backup(t,i,s){const r=this.getCustomDocumentEntry(i,t),E=await this.getCustomEditorProvider(i).backupCustomDocument(r.document,{destination:r.getNewBackupUri()},s);return r.updateBackup(E),E.id}getCustomDocumentEntry(t,i){const s=this._documents.get(t,D.URI.revive(i));if(!s)throw new Error("No custom document found");return s}getCustomEditorProvider(t){const i=this._editorProviders.get(t),s=i==null?void 0:i.provider;if(!s||!this.supportEditing(s))throw new Error("Custom document is not editable");return s}supportEditing(t){return!!t.onDidChangeCustomDocument}}e.ExtHostCustomEditors=p;function w(g){return typeof g.resolveCustomTextEditor=="function"}function u(g){return typeof g.undo=="function"&&typeof g.redo=="function"}function f(g){const t=g.scheme===y.Schemas.file||g.scheme===y.Schemas.untitled?g.fsPath:g.toString();return T.hash(t)+""}});var it=this&&this.__classPrivateFieldSet||function(Z,e,m,T,S){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!S:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?S.call(Z,m):S?S.value=m:e.set(Z,m),m},Ue=this&&this.__classPrivateFieldGet||function(Z,e,m,T){if(m==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!T:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?T:m==="a"?T.call(Z):T?T.value:e.get(Z)};define(_e[204],Ee([0,1,3,7,2,34,9,46,4,6]),function(Z,e,m,T,S,y,k,D,_,C){"use strict";var n,I,o,h,d,c,b,p,w,u,f,g,t;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class i extends T.Disposable{constructor(E,v,A,P,a,F,N){super();n.set(this,void 0),I.set(this,void 0),o.set(this,void 0),h.set(this,void 0),d.set(this,void 0),c.set(this,void 0),b.set(this,void 0),p.set(this,void 0),w.set(this,!0),u.set(this,!0),f.set(this,!1),g.set(this,this._register(new m.Emitter)),this.onDidDispose=Ue(this,g,"f").event,t.set(this,this._register(new m.Emitter)),this.onDidChangeViewState=Ue(this,t,"f").event,it(this,n,E,"f"),it(this,I,v,"f"),it(this,o,A,"f"),it(this,d,F,"f"),it(this,p,a,"f"),it(this,c,P,"f"),it(this,h,N,"f")}dispose(){Ue(this,f,"f")||(it(this,f,!0,"f"),Ue(this,g,"f").fire(),Ue(this,I,"f").$disposeWebview(Ue(this,n,"f")),Ue(this,h,"f").dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),Ue(this,h,"f")}get viewType(){return this.assertNotDisposed(),Ue(this,o,"f")}get title(){return this.assertNotDisposed(),Ue(this,c,"f")}set title(E){this.assertNotDisposed(),Ue(this,c,"f")!==E&&(it(this,c,E,"f"),Ue(this,I,"f").$setTitle(Ue(this,n,"f"),E))}get iconPath(){return this.assertNotDisposed(),Ue(this,b,"f")}set iconPath(E){this.assertNotDisposed(),Ue(this,b,"f")!==E&&(it(this,b,E,"f"),Ue(this,I,"f").$setIconPath(Ue(this,n,"f"),S.URI.isUri(E)?{light:E,dark:E}:E))}get options(){return Ue(this,d,"f")}get viewColumn(){if(this.assertNotDisposed(),!(typeof Ue(this,p,"f")=="number"&&Ue(this,p,"f")<0))return Ue(this,p,"f")}get active(){return this.assertNotDisposed(),Ue(this,u,"f")}get visible(){return this.assertNotDisposed(),Ue(this,w,"f")}_updateViewState(E){Ue(this,f,"f")||(this.active!==E.active||this.visible!==E.visible||this.viewColumn!==E.viewColumn)&&(it(this,u,E.active,"f"),it(this,w,E.visible,"f"),it(this,p,E.viewColumn,"f"),Ue(this,t,"f").fire({webviewPanel:this}))}reveal(E,v){this.assertNotDisposed(),Ue(this,I,"f").$reveal(Ue(this,n,"f"),{viewColumn:E?k.ViewColumn.from(E):void 0,preserveFocus:!!v})}assertNotDisposed(){if(Ue(this,f,"f"))throw new Error("Webview is disposed")}}n=new WeakMap,I=new WeakMap,o=new WeakMap,h=new WeakMap,d=new WeakMap,c=new WeakMap,b=new WeakMap,p=new WeakMap,w=new WeakMap,u=new WeakMap,f=new WeakMap,g=new WeakMap,t=new WeakMap;class s{constructor(E,v,A){this.webviews=v,this.workspace=A,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=E.getProxy(_.MainContext.MainThreadWebviewPanels)}static newHandle(){return y.generateUuid()}createWebviewPanel(E,v,A,P,a={}){const F=typeof P=="object"?P.viewColumn:P,N={viewColumn:k.ViewColumn.from(F),preserveFocus:typeof P=="object"&&!!P.preserveFocus},W=D.shouldSerializeBuffersForPostMessage(E),le=s.newHandle();this._proxy.$createWebviewPanel(D.toExtensionData(E),le,v,{title:A,panelOptions:r(a),webviewOptions:D.serializeWebviewOptions(E,this.workspace,a),serializeBuffersForPostMessage:W},N);const fe=this.webviews.createNewWebview(le,a,E);return this.createNewWebviewPanel(le,v,A,F,a,fe)}$onDidChangeWebviewPanelViewStates(E){const v=Object.keys(E);v.sort((A,P)=>{const a=E[A],F=E[P];return a.active?1:F.active?-1:+a.visible-+F.visible});for(const A of v){const P=this.getWebviewPanel(A);if(!P)continue;const a=E[A];P._updateViewState({active:a.active,visible:a.visible,viewColumn:k.ViewColumn.to(a.position)})}}async $onDidDisposeWebviewPanel(E){const v=this.getWebviewPanel(E);v==null||v.dispose(),this._webviewPanels.delete(E),this.webviews.deleteWebview(E)}registerWebviewPanelSerializer(E,v,A){if(this._serializers.has(v))throw new Error(`Serializer for '${v}' already registered`);return this._serializers.set(v,{serializer:A,extension:E}),this._proxy.$registerSerializer(v,{serializeBuffersForPostMessage:D.shouldSerializeBuffersForPostMessage(E)}),new C.Disposable(()=>{this._serializers.delete(v),this._proxy.$unregisterSerializer(v)})}async $deserializeWebviewPanel(E,v,A,P){const a=this._serializers.get(v);if(!a)throw new Error(`No serializer found for '${v}'`);const{serializer:F,extension:N}=a,W=this.webviews.createNewWebview(E,A.webviewOptions,N),le=this.createNewWebviewPanel(E,v,A.title,P,A.panelOptions,W);await F.deserializeWebviewPanel(le,A.state)}createNewWebviewPanel(E,v,A,P,a,F){const N=new i(E,this._proxy,v,A,P,a,F);return this._webviewPanels.set(E,N),N}getWebviewPanel(E){return this._webviewPanels.get(E)}}e.ExtHostWebviewPanels=s;function r(l){return{enableFindWidget:l.enableFindWidget,retainContextWhenHidden:l.retainContextWhenHidden}}});var it=this&&this.__classPrivateFieldSet||function(Z,e,m,T,S){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!S:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?S.call(Z,m):S?S.value=m:e.set(Z,m),m},Ue=this&&this.__classPrivateFieldGet||function(Z,e,m,T){if(m==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!T:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?T:m==="a"?T.call(Z):T?T.value:e.get(Z)};define(_e[205],Ee([0,1,3,7,46,4,6]),function(Z,e,m,T,S,y,k){"use strict";var D,_,C,n,I,o,h,d,c,b;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class p extends T.Disposable{constructor(f,g,t,i,s,r){super();D.set(this,void 0),_.set(this,void 0),C.set(this,void 0),n.set(this,void 0),I.set(this,!1),o.set(this,void 0),h.set(this,void 0),d.set(this,void 0),c.set(this,this._register(new m.Emitter)),this.onDidChangeVisibility=Ue(this,c,"f").event,b.set(this,this._register(new m.Emitter)),this.onDidDispose=Ue(this,b,"f").event,it(this,C,t,"f"),it(this,h,i,"f"),it(this,D,f,"f"),it(this,_,g,"f"),it(this,n,s,"f"),it(this,o,r,"f")}dispose(){Ue(this,I,"f")||(it(this,I,!0,"f"),Ue(this,b,"f").fire(),Ue(this,n,"f").dispose(),super.dispose())}get title(){return this.assertNotDisposed(),Ue(this,h,"f")}set title(f){this.assertNotDisposed(),Ue(this,h,"f")!==f&&(it(this,h,f,"f"),Ue(this,_,"f").$setWebviewViewTitle(Ue(this,D,"f"),f))}get description(){return this.assertNotDisposed(),Ue(this,d,"f")}set description(f){this.assertNotDisposed(),Ue(this,d,"f")!==f&&(it(this,d,f,"f"),Ue(this,_,"f").$setWebviewViewDescription(Ue(this,D,"f"),f))}get visible(){return Ue(this,o,"f")}get webview(){return Ue(this,n,"f")}get viewType(){return Ue(this,C,"f")}_setVisible(f){f===Ue(this,o,"f")||Ue(this,I,"f")||(it(this,o,f,"f"),Ue(this,c,"f").fire())}show(f){this.assertNotDisposed(),Ue(this,_,"f").$show(Ue(this,D,"f"),!!f)}assertNotDisposed(){if(Ue(this,I,"f"))throw new Error("Webview is disposed")}}D=new WeakMap,_=new WeakMap,C=new WeakMap,n=new WeakMap,I=new WeakMap,o=new WeakMap,h=new WeakMap,d=new WeakMap,c=new WeakMap,b=new WeakMap;class w{constructor(f,g){this._extHostWebview=g,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=f.getProxy(y.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(f,g,t,i){if(this._viewProviders.has(g))throw new Error(`View provider for '${g}' already registered`);return this._viewProviders.set(g,{provider:t,extension:f}),this._proxy.$registerWebviewViewProvider(S.toExtensionData(f),g,{retainContextWhenHidden:i==null?void 0:i.retainContextWhenHidden,serializeBuffersForPostMessage:!1}),new k.Disposable(()=>{this._viewProviders.delete(g),this._proxy.$unregisterWebviewViewProvider(g)})}async $resolveWebviewView(f,g,t,i,s){const r=this._viewProviders.get(g);if(!r)throw new Error(`No view provider found for '${g}'`);const{provider:l,extension:E}=r,v=this._extHostWebview.createNewWebview(f,{},E),A=new p(f,this._proxy,g,t,v,!0);this._webviewViews.set(f,A),await l.resolveWebviewView(A,{state:i},s)}async $onDidChangeWebviewViewVisibility(f,g){this.getWebviewView(f)._setVisible(g)}async $disposeWebviewView(f){const g=this.getWebviewView(f);this._webviewViews.delete(f),g.dispose(),this._extHostWebview.deleteWebview(f)}getWebviewView(f){const g=this._webviewViews.get(f);if(!g)throw new Error("No webview found");return g}}e.ExtHostWebviewViews=w}),define(_e[102],Ee([0,1,3,4,2,16,8,5,13]),function(Z,e,m,T,S,y,k,D,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let C=class On{constructor(I){this._onDidChangeWindowState=new m.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=On.InitialState,this._proxy=I.getProxy(T.MainContext.MainThreadWindow),this._proxy.$getWindowVisibility().then(o=>this.$onDidChangeWindowFocus(o))}get state(){return this._state}$onDidChangeWindowFocus(I){I!==this._state.focused&&(this._state=Object.assign(Object.assign({},this._state),{focused:I}),this._onDidChangeWindowState.fire(this._state))}openUri(I,o){let h;if(typeof I=="string"){h=I;try{I=S.URI.parse(I)}catch(d){return Promise.reject(`Invalid uri - '${I}'`)}}return k.isFalsyOrWhitespace(I.scheme)?Promise.reject("Invalid scheme - cannot be empty"):I.scheme===y.Schemas.command?Promise.reject(`Invalid scheme '${I.scheme}'`):this._proxy.$openUri(I,h,o)}async asExternalUri(I,o){if(k.isFalsyOrWhitespace(I.scheme))return Promise.reject("Invalid scheme - cannot be empty");const h=await this._proxy.$asExternalUri(I,o);return S.URI.from(h)}};C.InitialState={focused:!0},C=He([ze(0,_.IExtHostRpcService)],C),e.ExtHostWindow=C,e.IExtHostWindow=D.createDecorator("IExtHostWindow")}),define(_e[206],Ee([0,1,15,4,28,13]),function(Z,e,m,T,S,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let k=class extends m.AbstractLogger{constructor(_,C){super();this._proxy=_.getProxy(T.MainContext.MainThreadLog),this._logFile=C.logFile.toJSON(),this.setLevel(C.logLevel)}$setLevel(_){this.setLevel(_)}trace(_,...C){this.getLevel()<=m.LogLevel.Trace&&this._proxy.$log(this._logFile,m.LogLevel.Trace,Array.from(arguments))}debug(_,...C){this.getLevel()<=m.LogLevel.Debug&&this._proxy.$log(this._logFile,m.LogLevel.Debug,Array.from(arguments))}info(_,...C){this.getLevel()<=m.LogLevel.Info&&this._proxy.$log(this._logFile,m.LogLevel.Info,Array.from(arguments))}warn(_,...C){this.getLevel()<=m.LogLevel.Warning&&this._proxy.$log(this._logFile,m.LogLevel.Warning,Array.from(arguments))}error(_,...C){this.getLevel()<=m.LogLevel.Error&&this._proxy.$log(this._logFile,m.LogLevel.Error,Array.from(arguments))}critical(_,...C){this.getLevel()<=m.LogLevel.Critical&&this._proxy.$log(this._logFile,m.LogLevel.Critical,Array.from(arguments))}flush(){}};k=He([ze(0,y.IExtHostRpcService),ze(1,S.IExtHostInitDataService)],k),e.ExtHostLogService=k}),define(_e[207],Ee([0,1,12,18,11,3,7,113,177,99,23]),function(Z,e,m,T,S,y,k,D,_,C,n){"use strict";var I;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=void 0;function o(r,l){try{return JSON.stringify(r,l)}catch(E){return"null"}}function h(r,l){return JSON.stringify(r,l)}function d(r){return r?(l,E)=>E&&E.$mid===1?r.transformOutgoing(E):E:null}var c;(function(r){r[r.LocalSide=0]="LocalSide",r[r.OtherSide=1]="OtherSide"})(c=e.RequestInitiator||(e.RequestInitiator={}));var b;(function(r){r[r.Responsive=0]="Responsive",r[r.Unresponsive=1]="Unresponsive"})(b=e.ResponsiveState||(e.ResponsiveState={}));const p=()=>{},w=Symbol.for("rpcProtocol"),u=Symbol.for("rpcProxy");class f extends k.Disposable{constructor(l,E=null,v=null){super();this[I]=!0,this._onDidChangeResponsiveState=this._register(new y.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=l,this._logger=E,this._uriTransformer=v,this._uriReplacer=d(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let A=0,P=C.ProxyIdentifier.count;A<P;A++)this._locals[A]=null,this._proxies[A]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new m.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(A=>this._receiveOneMessage(A))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(l=>{this._pendingRPCReplies[l].resolveErr(S.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(l){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+f.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(l){this._unresponsiveTime=Date.now()+f.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(l){this._responsiveState!==l&&(this._responsiveState=l,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(l){return this._uriTransformer?D.transformIncomingURIs(l,this._uriTransformer):l}getProxy(l){const{nid:E,sid:v}=l;return this._proxies[E]||(this._proxies[E]=this._createProxy(E,v)),this._proxies[E]}_createProxy(l,E){let v={get:(A,P)=>(typeof P=="string"&&!A[P]&&P.charCodeAt(0)===36&&(A[P]=(...a)=>this._remoteCall(l,P,a)),P===u?E:A[P])};return new Proxy(Object.create(null),v)}set(l,E){return this._locals[l.nid]=E,E}assertRegistered(l){for(let E=0,v=l.length;E<v;E++){const A=l[E];if(!this._locals[A.nid])throw new Error(`Missing actor ${A.sid} (isMain: ${A.isMain})`)}}_receiveOneMessage(l){if(this._isDisposed)return;const E=l.byteLength,v=g.read(l,0),A=v.readUInt8(),P=v.readUInt32();switch(A){case 1:case 2:{let{rpcId:a,method:F,args:N}=t.deserializeRequestJSONArgs(v);this._uriTransformer&&(N=D.transformIncomingURIs(N,this._uriTransformer)),this._receiveRequest(E,P,a,F,N,A===2);break}case 3:case 4:{let{rpcId:a,method:F,args:N}=t.deserializeRequestMixedArgs(v);this._uriTransformer&&(N=D.transformIncomingURIs(N,this._uriTransformer)),this._receiveRequest(E,P,a,F,N,A===4);break}case 5:{this._logger&&this._logger.logIncoming(E,P,0,"ack"),this._onDidReceiveAcknowledge(P);break}case 6:{this._receiveCancel(E,P);break}case 7:{this._receiveReply(E,P,void 0);break}case 9:{let a=t.deserializeReplyOKJSON(v);this._uriTransformer&&(a=D.transformIncomingURIs(a,this._uriTransformer)),this._receiveReply(E,P,a);break}case 8:{let a=t.deserializeReplyOKVSBuffer(v);this._receiveReply(E,P,a);break}case 10:{let a=t.deserializeReplyErrError(v);this._uriTransformer&&(a=D.transformIncomingURIs(a,this._uriTransformer)),this._receiveReplyErr(E,P,a);break}case 11:{this._receiveReplyErr(E,P,void 0);break}default:console.error("received unexpected message"),console.error(l)}}_receiveRequest(l,E,v,A,P,a){this._logger&&this._logger.logIncoming(l,E,1,`receiveRequest ${C.getStringIdentifierForProxy(v)}.${A}(`,P);const F=String(E);let N,W;if(a){const fe=new T.CancellationTokenSource;P.push(fe.token),N=this._invokeHandler(v,A,P),W=()=>fe.cancel()}else N=this._invokeHandler(v,A,P),W=p;this._cancelInvokedHandlers[F]=W;const le=t.serializeAcknowledged(E);this._logger&&this._logger.logOutgoing(le.byteLength,E,1,"ack"),this._protocol.send(le),N.then(fe=>{delete this._cancelInvokedHandlers[F];const Y=t.serializeReplyOK(E,fe,this._uriReplacer);this._logger&&this._logger.logOutgoing(Y.byteLength,E,1,"reply:",fe),this._protocol.send(Y)},fe=>{delete this._cancelInvokedHandlers[F];const Y=t.serializeReplyErr(E,fe);this._logger&&this._logger.logOutgoing(Y.byteLength,E,1,"replyErr:",fe),this._protocol.send(Y)})}_receiveCancel(l,E){this._logger&&this._logger.logIncoming(l,E,1,"receiveCancel");const v=String(E);this._cancelInvokedHandlers[v]&&this._cancelInvokedHandlers[v]()}_receiveReply(l,E,v){this._logger&&this._logger.logIncoming(l,E,0,"receiveReply:",v);const A=String(E);if(!this._pendingRPCReplies.hasOwnProperty(A))return;const P=this._pendingRPCReplies[A];delete this._pendingRPCReplies[A],P.resolveOk(v)}_receiveReplyErr(l,E,v){this._logger&&this._logger.logIncoming(l,E,0,"receiveReplyErr:",v);const A=String(E);if(!this._pendingRPCReplies.hasOwnProperty(A))return;const P=this._pendingRPCReplies[A];delete this._pendingRPCReplies[A];let a;v&&(v.$isError?(a=new Error,a.name=v.name,a.message=v.message,a.stack=v.stack):a=v),P.resolveErr(a)}_invokeHandler(l,E,v){try{return Promise.resolve(this._doInvokeHandler(l,E,v))}catch(A){return Promise.reject(A)}}_doInvokeHandler(l,E,v){const A=this._locals[l];if(!A)throw new Error("Unknown actor "+C.getStringIdentifierForProxy(l));let P=A[E];if(typeof P!="function")throw new Error("Unknown method "+E+" on actor "+C.getStringIdentifierForProxy(l));return P.apply(A,v)}_remoteCall(l,E,v){if(this._isDisposed)return Promise.reject(S.canceled());let A=null;if(v.length>0&&T.CancellationToken.isCancellationToken(v[v.length-1])&&(A=v.pop()),A&&A.isCancellationRequested)return Promise.reject(S.canceled());const P=t.serializeRequestArguments(v,this._uriReplacer),a=++this._lastMessageId,F=String(a),N=new _.LazyPromise;A&&A.onCancellationRequested(()=>{const le=t.serializeCancel(a);this._logger&&this._logger.logOutgoing(le.byteLength,a,0,"cancel"),this._protocol.send(t.serializeCancel(a))}),this._pendingRPCReplies[F]=N,this._onWillSendRequest(a);const W=t.serializeRequest(a,l,E,P,!!A);return this._logger&&this._logger.logOutgoing(W.byteLength,a,0,`request: ${C.getStringIdentifierForProxy(l)}.${E}(`,v),this._protocol.send(W),N}}e.RPCProtocol=f,I=w,f.UNRESPONSIVE_TIME=3*1e3;class g{constructor(l,E){this._buff=l,this._offset=E}static alloc(l,E,v){let A=new g(n.VSBuffer.alloc(v+1+4),0);return A.writeUInt8(l),A.writeUInt32(E),A}static read(l,E){return new g(l,E)}get buffer(){return this._buff}static sizeUInt8(){return 1}writeUInt8(l){this._buff.writeUInt8(l,this._offset),this._offset+=1}readUInt8(){const l=this._buff.readUInt8(this._offset);return this._offset+=1,l}writeUInt32(l){this._buff.writeUInt32BE(l,this._offset),this._offset+=4}readUInt32(){const l=this._buff.readUInt32BE(this._offset);return this._offset+=4,l}static sizeShortString(l){return 1+l.byteLength}writeShortString(l){this._buff.writeUInt8(l.byteLength,this._offset),this._offset+=1,this._buff.set(l,this._offset),this._offset+=l.byteLength}readShortString(){const l=this._buff.readUInt8(this._offset);this._offset+=1;const v=this._buff.slice(this._offset,this._offset+l).toString();return this._offset+=l,v}static sizeLongString(l){return 4+l.byteLength}writeLongString(l){this._buff.writeUInt32BE(l.byteLength,this._offset),this._offset+=4,this._buff.set(l,this._offset),this._offset+=l.byteLength}readLongString(){const l=this._buff.readUInt32BE(this._offset);this._offset+=4;const v=this._buff.slice(this._offset,this._offset+l).toString();return this._offset+=l,v}writeBuffer(l){this._buff.writeUInt32BE(l.byteLength,this._offset),this._offset+=4,this._buff.set(l,this._offset),this._offset+=l.byteLength}static sizeVSBuffer(l){return 4+l.byteLength}writeVSBuffer(l){this._buff.writeUInt32BE(l.byteLength,this._offset),this._offset+=4,this._buff.set(l,this._offset),this._offset+=l.byteLength}readVSBuffer(){const l=this._buff.readUInt32BE(this._offset);this._offset+=4;const E=this._buff.slice(this._offset,this._offset+l);return this._offset+=l,E}static sizeMixedArray(l,E){let v=0;v+=1;for(let A=0,P=l.length;A<P;A++){const a=l[A],F=E[A];switch(v+=1,F){case 1:v+=this.sizeLongString(a);break;case 2:v+=this.sizeVSBuffer(a);break;case 3:break}}return v}writeMixedArray(l,E){this._buff.writeUInt8(l.length,this._offset),this._offset+=1;for(let v=0,A=l.length;v<A;v++){const P=l[v];switch(E[v]){case 1:this.writeUInt8(1),this.writeLongString(P);break;case 2:this.writeUInt8(2),this.writeVSBuffer(P);break;case 3:this.writeUInt8(3);break}}}readMixedArray(){const l=this._buff.readUInt8(this._offset);this._offset+=1;let E=new Array(l);for(let v=0;v<l;v++)switch(this.readUInt8()){case 1:E[v]=this.readLongString();break;case 2:E[v]=this.readVSBuffer();break;case 3:E[v]=void 0;break}return E}}class t{static _arrayContainsBufferOrUndefined(l){for(let E=0,v=l.length;E<v;E++)if(l[E]instanceof n.VSBuffer||typeof l[E]=="undefined")return!0;return!1}static serializeRequestArguments(l,E){if(this._arrayContainsBufferOrUndefined(l)){let v=[],A=[];for(let P=0,a=l.length;P<a;P++){const F=l[P];F instanceof n.VSBuffer?(v[P]=F,A[P]=2):typeof F=="undefined"?(v[P]=n.VSBuffer.alloc(0),A[P]=3):(v[P]=n.VSBuffer.fromString(h(F,E)),A[P]=1)}return{type:"mixed",args:v,argsType:A}}return{type:"simple",args:h(l,E)}}static serializeRequest(l,E,v,A,P){return A.type==="mixed"?this._requestMixedArgs(l,E,v,A.args,A.argsType,P):this._requestJSONArgs(l,E,v,A.args,P)}static _requestJSONArgs(l,E,v,A,P){const a=n.VSBuffer.fromString(v),F=n.VSBuffer.fromString(A);let N=0;N+=g.sizeUInt8(),N+=g.sizeShortString(a),N+=g.sizeLongString(F);let W=g.alloc(P?2:1,l,N);return W.writeUInt8(E),W.writeShortString(a),W.writeLongString(F),W.buffer}static deserializeRequestJSONArgs(l){const E=l.readUInt8(),v=l.readShortString(),A=l.readLongString();return{rpcId:E,method:v,args:JSON.parse(A)}}static _requestMixedArgs(l,E,v,A,P,a){const F=n.VSBuffer.fromString(v);let N=0;N+=g.sizeUInt8(),N+=g.sizeShortString(F),N+=g.sizeMixedArray(A,P);let W=g.alloc(a?4:3,l,N);return W.writeUInt8(E),W.writeShortString(F),W.writeMixedArray(A,P),W.buffer}static deserializeRequestMixedArgs(l){const E=l.readUInt8(),v=l.readShortString(),A=l.readMixedArray(),P=new Array(A.length);for(let a=0,F=A.length;a<F;a++){const N=A[a];typeof N=="string"?P[a]=JSON.parse(N):P[a]=N}return{rpcId:E,method:v,args:P}}static serializeAcknowledged(l){return g.alloc(5,l,0).buffer}static serializeCancel(l){return g.alloc(6,l,0).buffer}static serializeReplyOK(l,E,v){return typeof E=="undefined"?this._serializeReplyOKEmpty(l):E instanceof n.VSBuffer?this._serializeReplyOKVSBuffer(l,E):this._serializeReplyOKJSON(l,o(E,v))}static _serializeReplyOKEmpty(l){return g.alloc(7,l,0).buffer}static _serializeReplyOKVSBuffer(l,E){let v=0;v+=g.sizeVSBuffer(E);let A=g.alloc(8,l,v);return A.writeVSBuffer(E),A.buffer}static deserializeReplyOKVSBuffer(l){return l.readVSBuffer()}static _serializeReplyOKJSON(l,E){const v=n.VSBuffer.fromString(E);let A=0;A+=g.sizeLongString(v);let P=g.alloc(9,l,A);return P.writeLongString(v),P.buffer}static deserializeReplyOKJSON(l){const E=l.readLongString();return JSON.parse(E)}static serializeReplyErr(l,E){return E?this._serializeReplyErrEror(l,E):this._serializeReplyErrEmpty(l)}static _serializeReplyErrEror(l,E){const v=n.VSBuffer.fromString(o(S.transformErrorForSerialization(E),null));let A=0;A+=g.sizeLongString(v);let P=g.alloc(10,l,A);return P.writeLongString(v),P.buffer}static deserializeReplyErrError(l){const E=l.readLongString();return JSON.parse(E)}static _serializeReplyErrEmpty(l){return g.alloc(11,l,0).buffer}}var i;(function(r){r[r.RequestJSONArgs=1]="RequestJSONArgs",r[r.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",r[r.RequestMixedArgs=3]="RequestMixedArgs",r[r.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",r[r.Acknowledged=5]="Acknowledged",r[r.Cancel=6]="Cancel",r[r.ReplyOKEmpty=7]="ReplyOKEmpty",r[r.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",r[r.ReplyOKJSON=9]="ReplyOKJSON",r[r.ReplyErrError=10]="ReplyErrError",r[r.ReplyErrEmpty=11]="ReplyErrEmpty"})(i||(i={}));var s;(function(r){r[r.String=1]="String",r[r.VSBuffer=2]="VSBuffer",r[r.Undefined=3]="Undefined"})(s||(s={}))}),define(_e[208],Ee([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NestedWorker=void 0;const m=function(y){const k=D=>{self.removeEventListener("message",k);const _=D.data;Object.defineProperties(self,{postMessage:{value(C,n){_.postMessage(C,n)}},onmessage:{get(){return _.onmessage},set(C){_.onmessage=C}}}),_.addEventListener("message",C=>{self.dispatchEvent(new MessageEvent("message",{data:C.data}))}),_.start(),self.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(y)};self.addEventListener("message",k)}.toString();class T extends EventTarget{constructor(y,k,D){super();this.onmessage=null,this.onmessageerror=null,this.onerror=null;const _=`((${m})('${k}'))`,C=new Blob([_],{type:"application/javascript"}),n=URL.createObjectURL(C),I=new MessageChannel,o=n,h={type:"_newWorker",id:o,port:I.port2,url:n,options:D};y(h,[I.port2]),this.postMessage=I.port1.postMessage.bind(I.port1),this.terminate=()=>{const d={type:"_terminateWorker",id:o};I.port1.postMessage(d),URL.revokeObjectURL(n),I.port1.close(),I.port2.close()},Object.defineProperties(this,{onmessage:{get(){return I.port1.onmessage},set(d){I.port1.onmessage=d}},onmessageerror:{get(){return I.port1.onmessageerror},set(d){I.port1.onmessageerror=d}}}),I.port1.addEventListener("messageerror",d=>{const c=new MessageEvent("messageerror",{data:d.data});this.dispatchEvent(c)}),I.port1.addEventListener("message",d=>{const c=new MessageEvent("message",{data:d.data});this.dispatchEvent(c)}),I.port1.start()}}e.NestedWorker=T}),define(_e[209],Ee([0,1,5]),function(Z,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=m.createDecorator("remoteAgentService")}),define(_e[210],Ee([0,1,16,14,21,2,5,93,44,173,209]),function(Z,e,m,T,S,y,k,D,_,C,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=k.createDecorator("pathService");let I=class Un{constructor(h,d,c,b){this.localUserHome=h,this.remoteAgentService=d,this.environmentService=c,this.contextService=b,this.resolveOS=(async()=>{const p=await this.remoteAgentService.getEnvironment();return(p==null?void 0:p.os)||S.OS})(),this.resolveUserHome=(async()=>{const p=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=(p==null?void 0:p.userHome)||h})()}get defaultUriScheme(){return Un.findDefaultUriScheme(this.environmentService,this.contextService)}static findDefaultUriScheme(h,d){if(h.remoteAuthority)return m.Schemas.vscodeRemote;const c=D.getVirtualWorkspaceScheme(d.getWorkspace());if(c)return c;const b=d.getWorkspace().folders[0];if(b)return b.uri.scheme;const p=d.getWorkspace().configuration;return p?p.scheme:m.Schemas.file}async userHome(h){return(h==null?void 0:h.preferLocal)?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(h=>h===1?T.win32:T.posix)}async fileURI(h){let d="";if(await this.resolveOS===1&&(h=h.replace(/\\/g,"/")),h[0]==="/"&&h[1]==="/"){const b=h.indexOf("/",2);b===-1?(d=h.substring(2),h="/"):(d=h.substring(2,b),h=h.substring(b)||"/")}return y.URI.from({scheme:m.Schemas.file,authority:d,path:h,query:"",fragment:""})}};I=He([ze(1,n.IRemoteAgentService),ze(2,C.IWorkbenchEnvironmentService),ze(3,_.IWorkspaceContextService)],I),e.AbstractPathService=I}),define(_e[103],Ee([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class m{constructor(k,D){this.line=k,this.character=D}isBefore(k){return!1}isBeforeOrEqual(k){return!1}isAfter(k){return!1}isAfterOrEqual(k){return!1}isEqual(k){return!1}compareTo(k){return 0}translate(k,D){return new m(0,0)}with(k){return new m(0,0)}}e.Position=m;class T{constructor(k,D,_,C){this.isEmpty=!1,this.isSingleLine=!1,this.start=new m(k,D),this.end=new m(_,C)}contains(k){return!1}isEqual(k){return!1}intersection(k){}union(k){return new T(0,0,0,0)}with(k){return new T(0,0,0,0)}}e.Range=T;var S;(function(y){y[y.Information=1]="Information",y[y.Warning=2]="Warning"})(S=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(_e[38],Ee([0,1,17,27,24,42,8,5,14,11,103]),function(Z,e,m,T,S,y,k,D,_,C,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return n.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const I="\u27EA ",o=" characters skipped \u27EB",h=(I.length+o.length+5)*2;e.ISearchService=D.createDecorator("searchService");var d;(function(R){R[R.file=0]="file",R[R.text=1]="text"})(d=e.SearchProviderType||(e.SearchProviderType={}));var c;(function(R){R[R.File=1]="File",R[R.Text=2]="Text"})(c=e.QueryType||(e.QueryType={}));function b(R){return!!R.preview}e.resultIsMatch=b;function p(R){return!!R.resource}e.isFileMatch=p;function w(R){return!!R.message}e.isProgressMessage=w;var u;(function(R){R[R.Normal=0]="Normal",R[R.NewSearchStarted=1]="NewSearchStarted"})(u=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class f{constructor(B){this.resource=B,this.results=[]}}e.FileMatch=f;class g{constructor(B,M,x){this.ranges=M;const q=Array.isArray(M)?M:[M];if(x&&x.matchLines===1&&t(q)){B=k.getNLines(B,x.matchLines);let z="",oe=0,pe=0;const Te=Math.floor(x.charsPerLine/5),Be=[];for(const Fe of q){const We=Math.max(Fe.startColumn-Te,0),Qe=Fe.startColumn+x.charsPerLine;if(We>pe+Te+h){const Ge=I+(We-pe)+o;z+=Ge+B.slice(We,Qe),oe+=We-(pe+Ge.length)}else z+=B.slice(pe,Qe);Be.push(new s(0,Fe.startColumn-oe,Fe.endColumn-oe)),pe=Qe}this.preview={text:z,matches:Array.isArray(this.ranges)?Be:Be[0]}}else{const z=Array.isArray(M)?M[0].startLineNumber:M.startLineNumber;this.preview={text:B,matches:m.mapArrayOrNot(M,oe=>new i(oe.startLineNumber-z,oe.startColumn,oe.endLineNumber-z,oe.endColumn))}}}}e.TextSearchMatch=g;function t(R){const B=R[0].startLineNumber;for(const M of R)if(M.startLineNumber!==B||M.endLineNumber!==B)return!1;return!0}class i{constructor(B,M,x,q){this.startLineNumber=B,this.startColumn=M,this.endLineNumber=x,this.endColumn=q}}e.SearchRange=i;class s extends i{constructor(B,M,x){super(B,M,B,x)}}e.OneLineRange=s;var r;(function(R){R.Default="default",R.FileNames="fileNames",R.Type="type",R.Modified="modified",R.CountDescending="countDescending",R.CountAscending="countAscending"})(r=e.SearchSortOrder||(e.SearchSortOrder={}));function l(R,B=!0){const M=R&&R.files&&R.files.exclude,x=B&&R&&R.search&&R.search.exclude;if(!M&&!x)return;if(!M||!x)return M||x;let q=Object.create(null);return q=S.mixin(q,S.deepClone(M)),q=S.mixin(q,S.deepClone(x),!0),q}e.getExcludes=l;function E(R,B){return R.excludePattern&&T.match(R.excludePattern,B)?!1:R.includePattern||R.usingSearchPaths?R.includePattern&&T.match(R.includePattern,B)?!0:R.usingSearchPaths?!!R.folderQueries&&R.folderQueries.some(M=>{const x=M.folder.fsPath;if(y.isEqualOrParent(B,x)){const q=_.relative(x,B);return!M.includePattern||!!T.match(M.includePattern,q)}else return!1}):!1:!0}e.pathIncludedInQuery=E;var v;(function(R){R[R.unknownEncoding=1]="unknownEncoding",R[R.regexParseError=2]="regexParseError",R[R.globParseError=3]="globParseError",R[R.invalidLiteral=4]="invalidLiteral",R[R.rgProcessError=5]="rgProcessError",R[R.other=6]="other",R[R.canceled=7]="canceled"})(v=e.SearchErrorCode||(e.SearchErrorCode={}));class A extends Error{constructor(B,M){super(B);this.code=M}}e.SearchError=A;function P(R){const B=R.message;if(C.isPromiseCanceledError(R))return new A(B,v.canceled);try{const M=JSON.parse(B);return new A(M.message,M.code)}catch(M){return new A(B,v.other)}}e.deserializeSearchError=P;function a(R){const B={message:R.message,code:R.code};return new Error(JSON.stringify(B))}e.serializeSearchError=a;function F(R){return R.type==="error"?!0:R.type==="success"}e.isSerializedSearchComplete=F;function N(R){return R.type==="success"}e.isSerializedSearchSuccess=N;function W(R){return!!R.path}e.isSerializedFileMatch=W;function le(R,B){const M=R.searchPath?R.searchPath:R.relativePath;return k.fuzzyContains(M,B)}e.isFilePatternMatch=le;class fe{constructor(B){this.path=B,this.results=[]}addMatch(B){this.results.push(B)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=fe;function Y(R,B){const M=Object.assign(Object.assign({},R||{}),B||{});return Object.keys(M).filter(x=>{const q=M[x];return typeof q=="boolean"&&q})}e.resolvePatternsForProvider=Y;class H{constructor(B,M){this._parsedIncludeExpression=null,this._excludeExpression=Object.assign(Object.assign({},B.excludePattern||{}),M.excludePattern||{}),this._parsedExcludeExpression=T.parse(this._excludeExpression);let x=B.includePattern;M.includePattern&&(x?x=Object.assign(Object.assign({},x),M.includePattern):x=M.includePattern),x&&(this._parsedIncludeExpression=T.parse(x))}includedInQuerySync(B,M,x){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(B,M,x)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(B,M,x))}includedInQuery(B,M,x){return Promise.resolve(this._parsedExcludeExpression(B,M,x)).then(z=>!!z).then(z=>z?!1:this._parsedIncludeExpression?Promise.resolve(this._parsedIncludeExpression(B,M,x)).then(oe=>!!oe):Promise.resolve(!0)).then(z=>z)}hasSiblingExcludeClauses(){return J(this._excludeExpression)}}e.QueryGlobTester=H;function J(R){for(const B in R)if(typeof R[B]!="boolean")return!0;return!1}}),define(_e[30],Ee([0,1,17,12,18,3,22,16,77,25,8,10,2,134,5,15,147,44,45,28,13,6,38,4]),function(Z,e,m,T,S,y,k,D,_,C,n,I,o,h,d,c,b,p,w,u,f,g,t,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function s(F,N,W){return new C.ExtUri(le=>v(le,W)).isEqual(F,N)}function r(F,N,W){return s(F.uri,N.uri,W)?0:n.compare(F.uri.toString(),N.uri.toString())}function l(F,N,W){return F.index!==N.index?F.index<N.index?-1:1:s(F.uri,N.uri,W)?n.compare(F.name,N.name):n.compare(F.uri.toString(),N.uri.toString())}function E(F,N,W,le){const fe=F.slice(0).sort((H,J)=>W(H,J,le)),Y=N.slice(0).sort((H,J)=>W(H,J,le));return m.delta(fe,Y,(H,J)=>W(H,J,le))}function v(F,N){const W=N.getCapabilities(F.scheme);return!(W&&W&1024)}class A extends p.Workspace{constructor(N,W,le,fe,Y,H){super(N,le.map(J=>new p.WorkspaceFolder(J)),fe,H);this._name=W,this._isUntitled=Y,this._workspaceFolders=[],this._structure=k.TernarySearchTree.forUris(H),le.forEach(J=>{this._workspaceFolders.push(J),this._structure.set(J.uri,J)})}static toExtHostWorkspace(N,W,le,fe){if(!N)return{workspace:null,added:[],removed:[]};const{id:Y,name:H,folders:J,configuration:R,isUntitled:B}=N,M=[],x=W;W?J.forEach((pe,Te)=>{const Be=o.URI.revive(pe.uri),Fe=A._findFolder(le||W,Be,fe);Fe?(Fe.name=pe.name,Fe.index=pe.index,M.push(Fe)):M.push({uri:Be,name:pe.name,index:Te})}):M.push(...J.map(({uri:pe,name:Te,index:Be})=>({uri:o.URI.revive(pe),name:Te,index:Be}))),M.sort((pe,Te)=>pe.index<Te.index?-1:1);const q=new A(Y,H,M,R?o.URI.revive(R):null,!!B,pe=>v(pe,fe)),{added:z,removed:oe}=E(x?x.workspaceFolders:[],q.workspaceFolders,r,fe);return{workspace:q,added:z,removed:oe}}static _findFolder(N,W,le){for(let fe=0;fe<N.folders.length;fe++){const Y=N.workspaceFolders[fe];if(s(Y.uri,W,le))return Y}}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(N,W){return W&&this._structure.get(N)&&(N=C.dirname(N)),this._structure.findSubstr(N)}resolveWorkspaceFolder(N){return this._structure.get(N)}}let P=class{constructor(N,W,le,fe){this._onDidChangeWorkspace=new y.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidGrantWorkspaceTrust=new y.Emitter,this.onDidGrantWorkspaceTrust=this._onDidGrantWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._logService=fe,this._extHostFileSystemInfo=le,this._requestIdProvider=new _.Counter,this._barrier=new T.Barrier,this._proxy=N.getProxy(i.MainContext.MainThreadWorkspace),this._messageService=N.getProxy(i.MainContext.MainThreadMessageService);const Y=W.workspace;this._confirmedWorkspace=Y?new A(Y.id,Y.name,[],Y.configuration?o.URI.revive(Y.configuration):null,!!Y.isUntitled,H=>v(H,le)):void 0}$initializeWorkspace(N,W){this._trusted=W,this.$acceptWorkspaceData(N),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?o.URI.from({scheme:D.Schemas.untitled,path:C.basename(C.dirname(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(N,W,le,...fe){const Y=[];if(Array.isArray(fe)&&fe.forEach(M=>{o.URI.isUri(M.uri)&&!Y.some(x=>s(x.uri,M.uri,this._extHostFileSystemInfo))&&Y.push({uri:M.uri,name:M.name||C.basenameOrAuthority(M.uri)})}),this._unconfirmedWorkspace||[W,le].some(M=>typeof M!="number"||M<0)||le===0&&Y.length===0)return!1;const H=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if(W+le>H.length)return!1;const J=H.slice(0);J.splice(W,le,...Y.map(M=>({uri:M.uri,name:M.name||C.basenameOrAuthority(M.uri),index:void 0})));for(let M=0;M<J.length;M++){const x=J[M];if(J.some((q,z)=>z!==M&&s(x.uri,q.uri,this._extHostFileSystemInfo)))return!1}J.forEach((M,x)=>M.index=x);const{added:R,removed:B}=E(H,J,l,this._extHostFileSystemInfo);if(R.length===0&&B.length===0)return!1;if(this._proxy){const M=N.displayName||N.name;this._proxy.$updateWorkspaceFolders(M,W,le,Y).then(void 0,x=>{this._unconfirmedWorkspace=void 0,this._messageService.$showMessage(b.Severity.Error,h.localize(0,null,M,x.toString()),{extension:N},[])})}return this.trySetWorkspaceFolders(J),!0}getWorkspaceFolder(N,W){if(!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(N,W)}async getWorkspaceFolder2(N,W){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(N,W)}async resolveWorkspaceFolder(N){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(N)}getPath(){if(!this._actualWorkspace)return;const{folders:N}=this._actualWorkspace;if(N.length!==0)return N[0].uri.fsPath}getRelativePath(N,W){let le,fe="";if(typeof N=="string"?(le=o.URI.file(N),fe=N):typeof N!="undefined"&&(le=N,fe=N.fsPath),!le)return fe;const Y=this.getWorkspaceFolder(le,!0);if(!Y)return fe;typeof W=="undefined"&&this._actualWorkspace&&(W=this._actualWorkspace.folders.length>1);let H=C.relativePath(Y.uri,le);return W&&Y.name&&(H=`${Y.name}/${H}`),H}trySetWorkspaceFolders(N){this._actualWorkspace&&(this._unconfirmedWorkspace=A.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:N,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(N){const{workspace:W,added:le,removed:fe}=A.toExtHostWorkspace(N,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=W||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:le,removed:fe}))}findFiles(N,W,le,fe,Y=S.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${fe.value}, entryPoint: findFiles`);let H;if(W===null?H=!1:W&&(typeof W=="string"?H=W:H=W.pattern),Y&&Y.isCancellationRequested)return Promise.resolve([]);const{includePattern:J,folder:R}=a(N);return this._proxy.$startFileSearch(I.withUndefinedAsNull(J),I.withUndefinedAsNull(R),I.withUndefinedAsNull(H),I.withUndefinedAsNull(le),Y).then(B=>Array.isArray(B)?B.map(M=>o.URI.revive(M)):[])}async findTextInFiles(N,W,le,fe,Y=S.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${fe.value}, entryPoint: findTextInFiles`);const H=this._requestIdProvider.getNext(),J=typeof W.previewOptions=="undefined"?{matchLines:100,charsPerLine:1e4}:W.previewOptions,{includePattern:R,folder:B}=a(W.include),M=typeof W.exclude=="string"?W.exclude:W.exclude?W.exclude.pattern:void 0,x={ignoreSymlinks:typeof W.followSymlinks=="boolean"?!W.followSymlinks:void 0,disregardIgnoreFiles:typeof W.useIgnoreFiles=="boolean"?!W.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof W.useGlobalIgnoreFiles=="boolean"?!W.useGlobalIgnoreFiles:void 0,disregardExcludeSettings:typeof W.useDefaultExcludes=="boolean"?!W.useDefaultExcludes:!0,fileEncoding:W.encoding,maxResults:W.maxResults,previewOptions:J,afterContext:W.afterContext,beforeContext:W.beforeContext,includePattern:R,excludePattern:M},q=!1;if(this._activeSearchCallbacks[H]=z=>{if(q)return;const oe=o.URI.revive(z.resource);z.results.forEach(pe=>{t.resultIsMatch(pe)?le({uri:oe,preview:{text:pe.preview.text,matches:m.mapArrayOrNot(pe.preview.matches,Te=>new g.Range(Te.startLineNumber,Te.startColumn,Te.endLineNumber,Te.endColumn))},ranges:m.mapArrayOrNot(pe.ranges,Te=>new g.Range(Te.startLineNumber,Te.startColumn,Te.endLineNumber,Te.endColumn))}):le({uri:oe,text:pe.text,lineNumber:pe.lineNumber})})},Y.isCancellationRequested)return{};try{const z=await this._proxy.$startTextSearch(N,I.withUndefinedAsNull(B),x,H,Y);return delete this._activeSearchCallbacks[H],z||{}}catch(z){throw delete this._activeSearchCallbacks[H],z}}$handleTextSearchResult(N,W){this._activeSearchCallbacks[W]&&this._activeSearchCallbacks[W](N)}saveAll(N){return this._proxy.$saveAll(N)}resolveProxy(N){return this._proxy.$resolveProxy(N)}get trusted(){return this._trusted}requestWorkspaceTrust(N){return this._proxy.$requestWorkspaceTrust(N)}$onDidGrantWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidGrantWorkspaceTrust.fire())}};P=He([ze(0,f.IExtHostRpcService),ze(1,u.IExtHostInitDataService),ze(2,w.IExtHostFileSystemInfo),ze(3,c.ILogService)],P),e.ExtHostWorkspace=P,e.IExtHostWorkspace=d.createDecorator("IExtHostWorkspace");function a(F){let N,W;return F&&(typeof F=="string"?N=F:(N=F.pattern,W=F.baseFolder||o.URI.file(F.base))),{includePattern:N,folder:W}}}),define(_e[32],Ee([0,1,24,3,30,4,6,151,61,10,12,5,13,15,2]),function(Z,e,m,T,S,y,k,D,_,C,n,I,o,h,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function c(i,s){if(s){const r=s.split(".");let l=i;for(let E=0;l&&E<r.length;E++)l=l[r[E]];return l}}function b(i){return i instanceof d.URI}function p(i){return i&&i.uri instanceof d.URI&&i.languageId&&typeof i.languageId=="string"}function w(i){return i&&!i.uri&&i.languageId&&typeof i.languageId=="string"}function u(i){return i&&i.uri instanceof d.URI&&(!i.name||typeof i.name=="string")&&(!i.index||typeof i.index=="number")}function f(i){if(b(i))return{resource:i};if(p(i))return{resource:i.uri,overrideIdentifier:i.languageId};if(w(i))return{overrideIdentifier:i.languageId};if(u(i))return{resource:i.uri};if(i===null)return{resource:null}}let g=class{constructor(s,r,l){this._proxy=s.getProxy(y.MainContext.MainThreadConfiguration),this._extHostWorkspace=r,this._logService=l,this._barrier=new n.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(s=>this._actual)}$initializeConfiguration(s){this._actual=new t(this._proxy,this._extHostWorkspace,s,this._logService),this._barrier.open()}$acceptConfigurationChanged(s,r){this.getConfigProvider().then(l=>l.$acceptConfigurationChanged(s,r))}};g=He([ze(0,o.IExtHostRpcService),ze(1,S.IExtHostWorkspace),ze(2,h.ILogService)],g),e.ExtHostConfiguration=g;class t{constructor(s,r,l,E){this._onDidChangeConfiguration=new T.Emitter,this._proxy=s,this._logService=E,this._extHostWorkspace=r,this._configuration=D.Configuration.parse(l),this._configurationScopes=this._toMap(l.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(s,r){const l={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=D.Configuration.parse(s),this._configurationScopes=this._toMap(s.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(r,l))}getConfiguration(s,r,l){const E=f(r)||{},v=this._toReadonlyValue(s?c(this._configuration.getValue(void 0,E,this._extHostWorkspace.workspace),s):this._configuration.getValue(void 0,E,this._extHostWorkspace.workspace));s&&this._validateConfigurationAccess(s,E,l==null?void 0:l.identifier);function A(a){if(a==null)return null;if(typeof a=="boolean")return a?1:4;switch(a){case k.ConfigurationTarget.Global:return 1;case k.ConfigurationTarget.Workspace:return 4;case k.ConfigurationTarget.WorkspaceFolder:return 5}}const P={has(a){return typeof c(v,a)!="undefined"},get:(a,F)=>{this._validateConfigurationAccess(s?`${s}.${a}`:a,E,l==null?void 0:l.identifier);let N=c(v,a);if(typeof N=="undefined")N=F;else{let W;const le=(fe,Y)=>{let H;const J=()=>{W=W||m.deepClone(v),H=H||c(W,Y)};return C.isObject(fe)?new Proxy(fe,{get:(R,B)=>{if(typeof B=="string"&&B.toLowerCase()==="tojson")return J(),()=>H;if(W)return H=H||c(W,Y),H[B];const M=R[B];return typeof B=="string"?le(M,`${Y}.${B}`):M},set:(R,B,M)=>(J(),H&&(H[B]=M),!0),deleteProperty:(R,B)=>(J(),H&&delete H[B],!0),defineProperty:(R,B,M)=>(J(),H&&Object.defineProperty(H,B,M),!0)}):fe};N=le(N,a)}return N},update:(a,F,N,W)=>{a=s?`${s}.${a}`:a;const le=A(N);return F!==void 0?this._proxy.$updateConfigurationOption(le,a,F,E,W):this._proxy.$removeConfigurationOption(le,a,E,W)},inspect:a=>{var F,N,W,le,fe,Y,H,J;a=s?`${s}.${a}`:a;const R=m.deepClone(this._configuration.inspect(a,E,this._extHostWorkspace.workspace));if(R)return{key:a,defaultValue:(F=R.default)===null||F===void 0?void 0:F.value,globalValue:(N=R.user)===null||N===void 0?void 0:N.value,workspaceValue:(W=R.workspace)===null||W===void 0?void 0:W.value,workspaceFolderValue:(le=R.workspaceFolder)===null||le===void 0?void 0:le.value,defaultLanguageValue:(fe=R.default)===null||fe===void 0?void 0:fe.override,globalLanguageValue:(Y=R.user)===null||Y===void 0?void 0:Y.override,workspaceLanguageValue:(H=R.workspace)===null||H===void 0?void 0:H.override,workspaceFolderLanguageValue:(J=R.workspaceFolder)===null||J===void 0?void 0:J.override,languageIds:R.overrideIdentifiers}}};return typeof v=="object"&&m.mixin(P,v,!1),Object.freeze(P)}_toReadonlyValue(s){const r=l=>C.isObject(l)?new Proxy(l,{get:(E,v)=>r(E[v]),set:(E,v,A)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(v)}' of object`)},deleteProperty:(E,v)=>{throw new Error(`TypeError: Cannot delete read only property '${String(v)}' of object`)},defineProperty:(E,v)=>{throw new Error(`TypeError: Cannot define property '${String(v)}' for a readonly object`)},setPrototypeOf:E=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):l;return r(s)}_validateConfigurationAccess(s,r,l){const E=_.OVERRIDE_PROPERTY_PATTERN.test(s)?4:this._configurationScopes.get(s),v=l?`[${l.value}] `:"";if(E===4){typeof(r==null?void 0:r.resource)=="undefined"&&this._logService.warn(`${v}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${s}', provide the URI of a resource or 'null' for any resource.`);return}if(E===3){(r==null?void 0:r.resource)&&this._logService.warn(`${v}Accessing a window scoped configuration for a resource is not expected. To associate '${s}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(s,r){const l=new D.ConfigurationChangeEvent(s,r,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(E,v)=>l.affectsConfiguration(E,f(v))})}_toMap(s){return s.reduce((r,l)=>(r.set(l[0],l[1]),r),new Map)}}e.ExtHostConfigProvider=t,e.IExtHostConfiguration=I.createDecorator("IExtHostConfiguration")});var it=this&&this.__classPrivateFieldSet||function(Z,e,m,T,S){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!S:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?S.call(Z,m):S?S.value=m:e.set(Z,m),m},Ue=this&&this.__classPrivateFieldGet||function(Z,e,m,T){if(m==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!T:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?T:m==="a"?T.call(Z):T?T.value:e.get(Z)};define(_e[104],Ee([0,1,2,12,3,4,6,30,36,32,18,37,13,28,5,16,21,15,70,162,11]),function(Z,e,m,T,S,y,k,D,_,C,n,I,o,h,d,c,b,p,w,u,f){"use strict";var g;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskExecutionDTO=e.TaskFilterDTO=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=e.ShellExecutionDTO=e.ShellExecutionOptionsDTO=e.ProcessExecutionDTO=e.ProcessExecutionOptionsDTO=e.TaskPresentationOptionsDTO=e.TaskDefinitionDTO=void 0;var t;(function(fe){function Y(J){if(J!=null)return J}fe.from=Y;function H(J){if(J!=null)return J}fe.to=H})(t=e.TaskDefinitionDTO||(e.TaskDefinitionDTO={}));var i;(function(fe){function Y(J){if(J!=null)return J}fe.from=Y;function H(J){if(J!=null)return J}fe.to=H})(i=e.TaskPresentationOptionsDTO||(e.TaskPresentationOptionsDTO={}));var s;(function(fe){function Y(J){if(J!=null)return J}fe.from=Y;function H(J){if(J!=null)return J}fe.to=H})(s=e.ProcessExecutionOptionsDTO||(e.ProcessExecutionOptionsDTO={}));var r;(function(fe){function Y(R){if(R){const B=R;return B&&!!B.process}else return!1}fe.is=Y;function H(R){if(R==null)return;const B={process:R.process,args:R.args};return R.options&&(B.options=s.from(R.options)),B}fe.from=H;function J(R){if(R!=null)return new k.ProcessExecution(R.process,R.args,R.options)}fe.to=J})(r=e.ProcessExecutionDTO||(e.ProcessExecutionDTO={}));var l;(function(fe){function Y(J){if(J!=null)return J}fe.from=Y;function H(J){if(J!=null)return J}fe.to=H})(l=e.ShellExecutionOptionsDTO||(e.ShellExecutionOptionsDTO={}));var E;(function(fe){function Y(R){if(R){const B=R;return B&&(!!B.commandLine||!!B.command)}else return!1}fe.is=Y;function H(R){if(R==null)return;const B={};return R.commandLine!==void 0?B.commandLine=R.commandLine:(B.command=R.command,B.args=R.args),R.options&&(B.options=l.from(R.options)),B}fe.from=H;function J(R){if(!(R==null||R.command===void 0&&R.commandLine===void 0))return R.commandLine?new k.ShellExecution(R.commandLine,R.options):new k.ShellExecution(R.command,R.args?R.args:[],R.options)}fe.to=J})(E=e.ShellExecutionDTO||(e.ShellExecutionDTO={}));var v;(function(fe){function Y(R){if(R){let B=R;return B&&B.customExecution==="customExecution"}else return!1}fe.is=Y;function H(R){return{customExecution:"customExecution"}}fe.from=H;function J(R,B){return B.get(R)}fe.to=J})(v=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var A;(function(fe){function Y(H,J){let R;return H.scope!==void 0&&typeof H.scope!="number"?R=H.scope.uri:H.scope!==void 0&&typeof H.scope=="number"&&(H.scope===k.TaskScope.Workspace&&J&&J.workspaceFile?R=J.workspaceFile:R=u.USER_TASKS_GROUP_KEY),{id:H._id,workspaceFolder:R}}fe.from=Y})(A=e.TaskHandleDTO||(e.TaskHandleDTO={}));var P;(function(fe){function Y(R,B){if(R==null)return[];const M=[];for(let x of R){const q=H(x,B);q&&M.push(q)}return M}fe.fromMany=Y;function H(R,B){if(R==null)return;let M;R.execution instanceof k.ProcessExecution?M=r.from(R.execution):R.execution instanceof k.ShellExecution?M=E.from(R.execution):R.execution&&R.execution instanceof k.CustomExecution&&(M=v.from(R.execution));const x=t.from(R.definition);let q;if(R.scope?typeof R.scope=="number"?q=R.scope:q=R.scope.uri:q=k.TaskScope.Workspace,!x||!q)return;const z=R.group?R.group.id:void 0;return{_id:R._id,definition:x,name:R.name,source:{extensionId:B.identifier.value,label:R.source,scope:q},execution:M,isBackground:R.isBackground,group:z,presentationOptions:i.from(R.presentationOptions),problemMatchers:R.problemMatchers,hasDefinedMatchers:R.hasDefinedMatchers,runOptions:R.runOptions?R.runOptions:{reevaluateOnRerun:!0},detail:R.detail}}fe.from=H;async function J(R,B,M){if(R==null)return;let x;r.is(R.execution)?x=r.to(R.execution):E.is(R.execution)?x=E.to(R.execution):v.is(R.execution)&&(x=v.to(R._id,M));const q=t.to(R.definition);let z;if(R.source&&(R.source.scope!==void 0?typeof R.source.scope=="number"?z=R.source.scope:z=await B.resolveWorkspaceFolder(m.URI.revive(R.source.scope)):z=k.TaskScope.Workspace),!q||!z)return;const oe=new k.Task(q,z,R.name,R.source.label,x,R.problemMatchers);return R.isBackground!==void 0&&(oe.isBackground=R.isBackground),R.group!==void 0&&(oe.group=k.TaskGroup.from(R.group)),R.presentationOptions&&(oe.presentationOptions=i.to(R.presentationOptions)),R._id&&(oe._id=R._id),R.detail&&(oe.detail=R.detail),oe}fe.to=J})(P=e.TaskDTO||(e.TaskDTO={}));var a;(function(fe){function Y(J){return J}fe.from=Y;function H(J){if(!!J)return Object.assign(Object.create(null),J)}fe.to=H})(a=e.TaskFilterDTO||(e.TaskFilterDTO={}));class F{constructor(Y,H,J){this._id=H,this._task=J,g.set(this,void 0),it(this,g,Y,"f")}get task(){return this._task}terminate(){Ue(this,g,"f").terminateTask(this)}fireDidStartProcess(Y){}fireDidEndProcess(Y){}}g=new WeakMap;var N;(function(fe){function Y(H){return{id:H._id,task:void 0}}fe.from=Y})(N=e.TaskExecutionDTO||(e.TaskExecutionDTO={}));let W=class{constructor(Y,H,J,R,B,M,x,q){this._onDidExecuteTask=new S.Emitter,this._onDidTerminateTask=new S.Emitter,this._onDidTaskProcessStarted=new S.Emitter,this._onDidTaskProcessEnded=new S.Emitter,this._proxy=Y.getProxy(y.MainContext.MainThreadTask),this._workspaceProvider=J,this._editorService=R,this._configurationService=B,this._terminalService=M,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=x,this._deprecationService=q,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(Y,H,J){if(!J)return new k.Disposable(()=>{});const R=this.nextHandle();return this._handlers.set(R,{type:H,provider:J,extension:Y}),this._proxy.$registerTaskProvider(R,H),new k.Disposable(()=>{this._handlers.delete(R),this._proxy.$unregisterTaskProvider(R)})}registerTaskSystem(Y,H){this._proxy.$registerTaskSystem(Y,H)}fetchTasks(Y){return this._proxy.$fetchTasks(a.from(Y)).then(async H=>{const J=[];for(let R of H){const B=await P.to(R,this._workspaceProvider,this._providedCustomExecutions2);B&&J.push(B)}return J})}get taskExecutions(){const Y=[];return this._taskExecutions.forEach(H=>Y.push(H)),Y}terminateTask(Y){if(!(Y instanceof F))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(Y._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(Y,H,J){const R=this._providedCustomExecutions2.get(Y.id);if(R){if(this._activeCustomExecutions2.get(Y.id)!==void 0)throw new Error("We should not be trying to start the same custom task executions twice.");this._activeCustomExecutions2.set(Y.id,R),this._terminalService.attachPtyToTerminal(H,await R.callback(J))}this._lastStartedTask=Y.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(Y)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(Y){const H=await this.getTaskExecution(Y);this._taskExecutionPromises.delete(Y.id),this._taskExecutions.delete(Y.id),this.customExecutionComplete(Y),this._onDidTerminateTask.fire({execution:H})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(Y){const H=await this.getTaskExecution(Y.id);this._onDidTaskProcessStarted.fire({execution:H,processId:Y.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(Y){const H=await this.getTaskExecution(Y.id);this._onDidTaskProcessEnded.fire({execution:H,exitCode:Y.exitCode})}$provideTasks(Y,H){const J=this._handlers.get(Y);if(!J)return Promise.reject(new Error("no handler found"));const R=[],B=T.asPromise(()=>J.provider.provideTasks(n.CancellationToken.None)).then(M=>this.provideTasksInternal(H,R,J,M));return new Promise(M=>{B.then(x=>{Promise.all(R).then(()=>{M(x)})})})}async $resolveTask(Y,H){const J=this._handlers.get(Y);if(!J)return Promise.reject(new Error("no handler found"));if(H.definition.type!==J.type)throw new Error(`Unexpected: Task of type [${H.definition.type}] cannot be resolved by provider of type [${J.type}].`);const R=await P.to(H,this._workspaceProvider,this._providedCustomExecutions2);if(!R)throw new Error("Unexpected: Task cannot be resolved.");const B=await J.provider.resolveTask(R,n.CancellationToken.None);if(!B)return;this.checkDeprecation(B,J);const M=P.from(B,J.extension);if(!M)throw new Error("Unexpected: Task cannot be resolved.");if(B.definition!==R.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return v.is(M.execution)&&await this.addCustomExecution(M,B,!0),await this.resolveTaskInternal(M)}nextHandle(){return this._handleCounter++}async addCustomExecution(Y,H,J){const R=await this._proxy.$createTaskId(Y);!J&&!this._providedCustomExecutions2.has(R)&&this._notProvidedCustomExecutions.add(R),this._providedCustomExecutions2.set(R,H.execution)}async getTaskExecution(Y,H){if(typeof Y=="string"){const B=this._taskExecutionPromises.get(Y);if(!B)throw new Error("Unexpected: The specified task is missing an execution");return B}let J=this._taskExecutionPromises.get(Y.id);if(J)return J;const R=new Promise(async(B,M)=>{const x=H||await P.to(Y.task,this._workspaceProvider,this._providedCustomExecutions2);x?B(new F(this,Y.id,x)):M("Unexpected: Task does not exist.")});return this._taskExecutionPromises.set(Y.id,R),R.then(B=>(this._taskExecutions.set(Y.id,B),B),B=>Promise.reject(B))}checkDeprecation(Y,H){Y._deprecated&&this._deprecationService.report("Task.constructor",H.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(Y){this._activeCustomExecutions2.get(Y.id)&&this._activeCustomExecutions2.delete(Y.id),this._notProvidedCustomExecutions.has(Y.id)&&this._lastStartedTask!==Y.id&&(this._providedCustomExecutions2.delete(Y.id),this._notProvidedCustomExecutions.delete(Y.id));let J=this._notProvidedCustomExecutions.values(),R=J.next();for(;!R.done;)!this._activeCustomExecutions2.has(R.value)&&this._lastStartedTask!==R.value&&(this._providedCustomExecutions2.delete(R.value),this._notProvidedCustomExecutions.delete(R.value)),R=J.next()}};W=He([ze(0,o.IExtHostRpcService),ze(1,h.IExtHostInitDataService),ze(2,D.IExtHostWorkspace),ze(3,_.IExtHostDocumentsAndEditors),ze(4,C.IExtHostConfiguration),ze(5,I.IExtHostTerminalService),ze(6,p.ILogService),ze(7,w.IExtHostApiDeprecationService)],W),e.ExtHostTaskBase=W;let le=class extends W{constructor(Y,H,J,R,B,M,x,q){super(Y,H,J,R,B,M,x,q);this.registerTaskSystem(c.Schemas.vscodeRemote,{scheme:c.Schemas.vscodeRemote,authority:"",platform:b.PlatformToString(0)})}async executeTask(Y,H){if(!H.execution)throw new Error("Tasks to execute must include an execution");const J=P.from(H,Y);if(J===void 0)throw new Error("Task is not valid");if(v.is(J.execution))await this.addCustomExecution(J,H,!1);else throw new f.NotSupportedError;const R=await this.getTaskExecution(await this._proxy.$getTaskExecution(J),H);return this._proxy.$executeTask(J).catch(B=>{throw new Error(B)}),R}provideTasksInternal(Y,H,J,R){const B=[];if(R)for(let M of R){this.checkDeprecation(M,J),(!M.definition||!Y[M.definition.type])&&this._logService.warn(`The task [${M.source}, ${M.name}] uses an undefined task type. The task will be ignored in the future.`);const x=P.from(M,J.extension);x&&v.is(x.execution)?(B.push(x),H.push(this.addCustomExecution(x,M,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:B,extension:J.extension}}async resolveTaskInternal(Y){if(v.is(Y.execution))return Y;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(Y,H){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(Y,H,J){}};le=He([ze(0,o.IExtHostRpcService),ze(1,h.IExtHostInitDataService),ze(2,D.IExtHostWorkspace),ze(3,_.IExtHostDocumentsAndEditors),ze(4,C.IExtHostConfiguration),ze(5,I.IExtHostTerminalService),ze(6,p.ILogService),ze(7,w.IExtHostApiDeprecationService)],le),e.WorkerExtHostTask=le,e.IExtHostTask=d.createDecorator("IExtHostTask")});var it=this&&this.__classPrivateFieldSet||function(Z,e,m,T,S){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!S:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?S.call(Z,m):S?S.value=m:e.set(Z,m),m},Ue=this&&this.__classPrivateFieldGet||function(Z,e,m,T){if(m==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!T:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?T:m==="a"?T.call(Z):T?T.value:e.get(Z)},_n=this&&this.__rest||function(Z,e){var m={};for(var T in Z)Object.prototype.hasOwnProperty.call(Z,T)&&e.indexOf(T)<0&&(m[T]=Z[T]);if(Z!=null&&typeof Object.getOwnPropertySymbols=="function")for(var S=0,T=Object.getOwnPropertySymbols(Z);S<T.length;S++)e.indexOf(T[S])<0&&Object.prototype.propertyIsEnumerable.call(Z,T[S])&&(m[T[S]]=Z[T[S]]);return m};define(_e[211],Ee([0,1,17,12,23,18,3,48,50,7,24,10,2,34,4,36,13,64,9,6,30,172,96]),function(Z,e,m,T,S,y,k,D,_,C,n,I,o,h,d,c,b,p,w,u,f,g,t){"use strict";var i,s,r,l;Object.defineProperty(e,"__esModule",{value:!0}),e.MirroredTestCollection=e.TestItemFilteredWrapper=e.createDefaultDocumentTestRoot=e.ExtHostTesting=void 0;const E=(J,R)=>`${J}:${R.toString()}`;let v=class{constructor(R,B,M){this.documents=B,this.workspace=M,this.resultsChangedEmitter=new k.Emitter,this.controllers=new Map,this.ownedTests=new g.OwnedTestCollection,this.testControllers=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=R.getProxy(d.MainContext.MainThreadTesting),this.runQueue=new A(this.proxy),this.workspaceObservers=new Y(this.proxy),this.textDocumentObservers=new H(this.proxy,B)}registerTestController(R,B){const M=h.generateUuid();this.controllers.set(M,{instance:B,extensionId:R}),this.proxy.$registerTestController(M);const x=[...this.testControllers.keys()];return setTimeout(()=>{var q;for(const z of x)(q=this.testControllers.get(z))===null||q===void 0||q.subscribeFn(M,B)},0),new u.Disposable(()=>{this.controllers.delete(M),this.proxy.$unregisterTestController(M)})}createTextDocumentTestObserver(R){return this.textDocumentObservers.checkout(R.uri)}createWorkspaceTestObserver(R){return this.workspaceObservers.checkout(R.uri)}async runTests(R,B=y.CancellationToken.None){const M=x=>x.map(this.getInternalTestForReference,this).filter(I.isDefined).map(q=>({src:q.src,testId:q.item.extId}));await this.proxy.$runTests({exclude:R.exclude?M(R.exclude).map(x=>x.testId):void 0,tests:M(R.tests),debug:R.debug},B)}createTestRun(R,B,M,x=!0){return this.runQueue.createTestRun(R,B,M,x)}$publishTestResults(R){this.results=Object.freeze(R.map(B=>n.deepFreeze(w.TestResults.to(B))).concat(this.results).sort((B,M)=>M.completedAt-B.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $subscribeToTests(R,B){const M=o.URI.revive(B),x=E(R,M);if(this.testControllers.has(x))return;const q=new y.CancellationTokenSource;let z;if(R===1){let Fe=this.documents.getDocument(M);if(!Fe){const We=new C.DisposableStore;Fe=await new Promise(Qe=>{We.add(T.disposableTimeout(()=>Qe(void 0),5e3)),We.add(this.documents.onDidAddDocuments(Ge=>{const Ke=Ge.find($=>$.document.uri.toString()===M.toString());Ke&&Qe(Ke)}))}).finally(()=>We.dispose())}if(Fe){const We=await this.workspace.getWorkspaceFolder2(M,!1);z=Qe=>Qe.createDocumentTestRoot?Qe.createDocumentTestRoot(Fe.document,q.token):e.createDefaultDocumentTestRoot(Qe,Fe.document,We,q.token)}}else{const Fe=await this.workspace.getWorkspaceFolder2(M,!1);Fe&&(z=We=>We.createWorkspaceTestRoot(Fe,q.token))}if(!z)return;const oe=async(Fe,We)=>{try{const Qe=await z(We);Qe&&Te.addRoot(Qe,Fe)}catch(Qe){console.error(Qe)}},pe=new C.DisposableStore,Te=pe.add(this.ownedTests.createForHierarchy(Fe=>this.proxy.$publishDiff(R,B,Fe)));pe.add(C.toDisposable(()=>q.dispose(!0)));const Be=[];for(const[Fe,We]of this.controllers)Be.push(oe(Fe,We.instance));Promise.all(Be).then(()=>Te.pushDiff([3,-1])),this.testControllers.set(x,{store:pe,collection:Te,subscribeFn:oe})}async $expandTest(R,B){const M=m.mapFind(this.testControllers.values(),x=>x.collection.treeId===R.src.tree?x:void 0);await(M==null?void 0:M.collection.expand(R.testId,B<0?Infinity:B)),this.flushCollectionDiffs()}$unsubscribeFromTests(R,B){var M;const x=o.URI.revive(B),q=E(R,x);(M=this.testControllers.get(q))===null||M===void 0||M.store.dispose(),this.testControllers.delete(q)}$acceptDiff(R,B,M){R===1?this.textDocumentObservers.acceptDiff(o.URI.revive(B),M):this.workspaceObservers.acceptDiff(o.URI.revive(B),M)}async $runTestsForProvider(R,B){const M=this.controllers.get(R.tests[0].src.controller);if(!M)return;const x=R.tests.map(({testId:oe,src:pe})=>this.ownedTests.getTestById(oe,pe==null?void 0:pe.tree)).filter(I.isDefined).map(([oe,pe])=>pe),q=R.excludeExtIds.map(oe=>this.ownedTests.getTestById(oe)).filter(I.isDefined).filter(([oe,pe])=>x.some(Te=>oe.comparePositions(Te,pe)===1));if(!x.length)return;const z={tests:x.map(oe=>N.unwrap(oe.actual)),exclude:q.map(([,oe])=>N.unwrap(oe.actual)),debug:R.debug};await this.runQueue.enqueueRun({dto:P.fromInternal(R),token:B,extensionId:M.extensionId,req:z,doRun:()=>M.instance.runTests(z,B)})}$lookupTest(R){const B=this.ownedTests.getTestById(R.testId);if(!B)return Promise.resolve(void 0);const M=B[1],{actual:x,discoverCts:q,expandLevels:z}=M,oe=_n(M,["actual","discoverCts","expandLevels"]);return Promise.resolve(oe)}flushCollectionDiffs(){for(const{collection:R}of this.testControllers.values())R.flushDiff()}getInternalTestForReference(R){var B,M;return(M=(B=this.workspaceObservers.getMirroredTestDataByReference(R))!==null&&B!==void 0?B:m.mapFind(this.testControllers.values(),x=>x.collection.getTestByReference(R)))!==null&&M!==void 0?M:this.textDocumentObservers.getMirroredTestDataByReference(R)}};v=He([ze(0,b.IExtHostRpcService),ze(1,c.IExtHostDocumentsAndEditors),ze(2,f.IExtHostWorkspace)],v),e.ExtHostTesting=v;class A{constructor(R){this.proxy=R,this.state=new Map}enqueueRun(R){let B=this.state.get(R.extensionId);B||(B={queue:[],current:void 0},this.state.set(R.extensionId,B));const M=new T.DeferredPromise,x=()=>{const q=[],z=new Set;B.current={publicReq:R.req,factory:oe=>{const pe=new a(oe,R.dto,z,this.proxy);return q.push(pe),R.token.onCancellationRequested(()=>pe.end()),pe}},this.invokeRunner(R.extensionId,R.dto.id,R.doRun,q).finally(()=>M.complete())};return B.queue.push(x),B.queue.length===1&&x(),M.p}createTestRun(R,B,M,x){var q,z;const oe=this.state.get(R);if((oe==null?void 0:oe.current.publicReq)===B)return oe.current.factory(M);const pe=P.fromPublic(B),Te=new a(M,pe,new Set,this.proxy);return this.proxy.$startedExtensionTestRun({debug:B.debug,exclude:(z=(q=B.exclude)===null||q===void 0?void 0:q.map(Be=>Be.id))!==null&&z!==void 0?z:[],id:pe.id,tests:B.tests.map(Be=>Be.id),persist:x}),Te.onEnd.wait().then(()=>this.proxy.$finishedExtensionTestRun(pe.id)),Te}invokeRunner(R,B,M,x){try{const q=M();return T.isThenable(q)?q.then(()=>this.handleInvokeResult(R,B,x,void 0)).catch(z=>this.handleInvokeResult(R,B,x,z)):this.handleInvokeResult(R,B,x,void 0)}catch(q){return this.handleInvokeResult(R,B,x,q)}}async handleInvokeResult(R,B,M,x){const q=this.state.get(R);!q||(q.queue.shift(),q.queue.length>0?q.queue[0]():this.state.delete(R),await Promise.all(M.map(z=>z.onEnd.wait())))}}class P{constructor(R,B,M){this.id=R,this.include=B,this.exclude=M}static fromPublic(R){var B,M;return new P(h.generateUuid(),new Set(R.tests.map(x=>x.id)),new Set((M=(B=R.exclude)===null||B===void 0?void 0:B.map(x=>x.id))!==null&&M!==void 0?M:_.Iterable.empty()))}static fromInternal(R){return new P(R.runId,new Set(R.tests.map(B=>B.testId)),new Set(R.excludeExtIds))}isIncluded(R){for(let B=R;B;B=B.parent){if(this.include.has(B.id))return!0;if(this.exclude.has(B.id))return!1}return!0}}class a{constructor(R,B,M,x){this.name=R,i.set(this,void 0),s.set(this,void 0),r.set(this,h.generateUuid()),l.set(this,void 0),this.onEnd=new T.Barrier,it(this,i,x,"f"),it(this,s,B,"f"),it(this,l,M,"f"),x.$startedTestRunTask(B.id,{id:Ue(this,r,"f"),name:R,running:!0})}setState(R,B,M){Ue(this,s,"f").isIncluded(R)&&(this.ensureTestIsKnown(R),Ue(this,i,"f").$updateTestStateInRun(Ue(this,s,"f").id,Ue(this,r,"f"),R.id,B,M))}appendMessage(R,B){Ue(this,s,"f").isIncluded(R)&&(this.ensureTestIsKnown(R),Ue(this,i,"f").$appendTestMessageInRun(Ue(this,s,"f").id,Ue(this,r,"f"),R.id,w.TestMessage.from(B)))}appendOutput(R){Ue(this,i,"f").$appendOutputToRun(Ue(this,s,"f").id,Ue(this,r,"f"),S.VSBuffer.fromString(R))}end(){Ue(this,i,"f").$finishedTestRunTask(Ue(this,s,"f").id,Ue(this,r,"f")),this.onEnd.open()}ensureTestIsKnown(R){const B=Ue(this,l,"f");if(B.has(R.id))return;const M=[];for(;M.unshift(w.TestItem.from(R)),!(B.has(R.id)||(B.add(R.id),!R.parent));)R=R.parent;Ue(this,i,"f").$addTestsToRun(Ue(this,s,"f").id,M)}}i=new WeakMap,s=new WeakMap,r=new WeakMap,l=new WeakMap;const F=async(J,R,B,M)=>{if(!B)return;const x=await J.createWorkspaceTestRoot(B,M);if(!x)return;M.onCancellationRequested(()=>{N.removeFilter(R)});const q=N.getWrapperForTestItem(x,R);return q.refreshMatch(),q};e.createDefaultDocumentTestRoot=F;class N extends u.TestItemImpl{constructor(R,B,M){super(R.id,R.label,R.uri,void 0);if(this.actual=R,this.filterDocument=B,this.actualParent=M,!(R instanceof u.TestItemImpl))throw new Error(`TestItems provided to the VS Code API must extend \`vscode.TestItem\`, but ${R.id} did not`);this.debuggable=R.debuggable,this.runnable=R.runnable,this.description=R.description,this.error=R.error,this.status=R.status,this.range=R.range,this.resolveHandler=R.resolveHandler;const x=p.getPrivateApiFor(this);p.getPrivateApiFor(R).bus.event(z=>{switch(z[0]){case 3:this[z[1]]=z[2];break;case 0:const oe=N.getWrapperForTestItem(z[1],this.filterDocument,this);p.getPrivateApiFor(oe).parent=R,oe.refreshMatch();break;default:x.bus.fire(z)}})}static removeFilter(R){this.wrapperMap.delete(R)}static getWrapperForTestItem(R,B,M){let x=this.wrapperMap.get(B);if(x==null?void 0:x.has(R))return x.get(R);x||(x=new WeakMap,this.wrapperMap.set(B,x));const q=new N(R,B,M);return x.set(R,q),q}static unwrap(R){return R instanceof N?R.actual:R}get hasNodeMatchingFilter(){return this._cachedMatchesFilter===void 0?this.refreshMatch():this._cachedMatchesFilter}refreshMatch(){var R,B;const M=this._cachedMatchesFilter;for(const q of this.actual.children.values()){const z=N.getWrapperForTestItem(q,this.filterDocument,this);z.hasNodeMatchingFilter?this.children.has(z.id)||this.addChild(z):z.dispose()}const x=this.children.size>0||((R=this.actual.uri)===null||R===void 0?void 0:R.toString())===this.filterDocument.uri.toString();return this._cachedMatchesFilter=x,x!==M&&((B=this.actualParent)===null||B===void 0||B.refreshMatch()),this._cachedMatchesFilter}dispose(){this.actualParent&&p.getPrivateApiFor(this.actualParent).children.delete(this.id),p.getPrivateApiFor(this).bus.fire([1])}}e.TestItemFilteredWrapper=N,N.wrapperMap=new WeakMap;class W extends t.IncrementalChangeCollector{constructor(R){super();this.emitter=R,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}add(R){this.added.add(R)}update(R){Object.assign(R.revived,w.TestItem.toPlain(R.item)),this.added.has(R)||this.updated.add(R)}remove(R){if(this.added.has(R)){this.added.delete(R);return}if(this.updated.delete(R),R.parent&&this.alreadyRemoved.has(R.parent)){this.alreadyRemoved.add(R.item.extId);return}this.removed.add(R)}getChangeEvent(){const{added:R,updated:B,removed:M}=this;return{get added(){return[...R].map(x=>x.revived)},get updated(){return[...B].map(x=>x.revived)},get removed(){return[...M].map(x=>x.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class le extends t.AbstractIncrementalTestCollection{constructor(){super(...arguments);this.changeEmitter=new k.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTestItems(){return this.getAllAsTestItem([...this.roots])}getAllAsTestItem(R){let B=[];for(const M of R){const x=this.items.get(M);x&&B.push(x.revived)}return B}getMirroredTestDataById(R){return this.items.get(R)}getMirroredTestDataByReference(R){return this.items.get(R.id)}createItem(R,B){return Object.assign(Object.assign({},R),{revived:w.TestItem.toPlain(R.item),depth:B?B.depth+1:0,children:new Set})}createChangeCollector(){return new W(this.changeEmitter)}}e.MirroredTestCollection=le;class fe{constructor(){this.resources=new Map}checkout(R){var B,M;const x=R.toString(),q=(B=this.resources.get(x))!==null&&B!==void 0?B:this.createObserverData(R);return(M=q.pendingDeletion)===null||M===void 0||M.dispose(),q.observers++,{onDidChangeTest:q.tests.onDidChangeTests,onDidDiscoverInitialTests:new k.Emitter().event,get tests(){return q.tests.rootTestItems},dispose:D.once(()=>{--q.observers||(q.pendingDeletion=this.eventuallyDispose(R))})}}getMirroredTestDataByReference(R){for(const{tests:B}of this.resources.values()){const M=B.getMirroredTestDataByReference(R);if(M)return M}}eventuallyDispose(R){return T.disposableTimeout(()=>this.unlisten(R),10*1e3)}createObserverData(R){const B=new le,M=this.listen(R,q=>B.apply(q)),x={observers:0,tests:B,listener:M};return this.resources.set(R.toString(),x),x}unlisten(R){var B;const M=R.toString(),x=this.resources.get(M);x&&(x.observers=-1,(B=x.pendingDeletion)===null||B===void 0||B.dispose(),x.listener.dispose(),this.resources.delete(M))}}class Y extends fe{constructor(R){super();this.proxy=R,this.diffListeners=new Map}acceptDiff(R,B){var M;(M=this.diffListeners.get(R.toString()))===null||M===void 0||M(B)}listen(R,B){this.proxy.$subscribeToDiffs(0,R);const M=R.toString();return this.diffListeners.set(M,B),new u.Disposable(()=>{this.proxy.$unsubscribeFromDiffs(0,R),this.diffListeners.delete(M)})}}class H extends fe{constructor(R,B){super();this.proxy=R,this.documents=B,this.diffListeners=new Map}acceptDiff(R,B){var M;(M=this.diffListeners.get(R.toString()))===null||M===void 0||M(B)}listen(R,B){if(!this.documents.getDocument(R))return new u.Disposable(()=>{});const x=R.toString();return this.diffListeners.set(x,B),this.proxy.$subscribeToDiffs(1,R),new u.Disposable(()=>{this.proxy.$unsubscribeFromDiffs(1,R),this.diffListeners.delete(x)})}}}),define(_e[212],Ee([0,1,17,76,27,81,22,16,14,25,8,10,2,116,136,91,44,165,210,38]),function(Z,e,m,T,S,y,k,D,_,C,n,I,o,h,d,c,b,p,w,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let f=class{constructor(A,P,a,F){this.configurationService=A,this.workspaceContextService=P,this.editorGroupsService=a,this.pathService=F}text(A,P,a={}){A=this.getContentPattern(A,a);const F=this.configurationService.getValue(),N=P&&P.some(le=>!this.configurationService.getValue({resource:le}).search.useRipgrep),W=this.commonQuery(P==null?void 0:P.map(b.toWorkspaceFolder),a);return Object.assign(Object.assign({},W),{type:2,contentPattern:A,previewOptions:a.previewOptions,maxFileSize:a.maxFileSize,usePCRE2:F.search.usePCRE2||N||!1,beforeContext:a.beforeContext,afterContext:a.afterContext,userDisabledExcludesAndIgnoreFiles:a.disregardExcludeSettings&&a.disregardIgnoreFiles})}getContentPattern(A,P){const a=this.configurationService.getValue();A.isRegExp&&(A.pattern=A.pattern.replace(/\r?\n/g,"\\n"));const F=Object.assign(Object.assign({},A),{wordSeparators:a.editor.wordSeparators});return this.isCaseSensitive(A,P)&&(F.isCaseSensitive=!0),this.isMultiline(A)&&(F.isMultiline=!0),F}file(A,P={}){const a=this.commonQuery(A,P);return Object.assign(Object.assign({},a),{type:1,filePattern:P.filePattern?P.filePattern.trim():P.filePattern,exists:P.exists,sortByScore:P.sortByScore,cacheKey:P.cacheKey})}handleIncludeExclude(A,P){return A?(A=Array.isArray(A)?A.map(r):r(A),P?this.parseSearchPaths(A):{pattern:t(...Array.isArray(A)?A:[A])}):{}}commonQuery(A=[],P={}){const a=this.handleIncludeExclude(P.includePattern,P.expandPatterns),F=this.handleIncludeExclude(P.excludePattern,P.expandPatterns),N=A.length>1,W=(a.searchPaths&&a.searchPaths.length?a.searchPaths.map(Y=>this.getFolderQueryForSearchPath(Y,P,F)):A.map(Y=>this.getFolderQueryForRoot(Y,P,F,N))).filter(Y=>!!Y),le={_reason:P._reason,folderQueries:W,usingSearchPaths:!!(a.searchPaths&&a.searchPaths.length),extraFileResources:P.extraFileResources,excludePattern:F.pattern,includePattern:a.pattern,onlyOpenEditors:P.onlyOpenEditors,maxResults:P.maxResults};if(P.onlyOpenEditors){const H=m.coalesce(m.flatten(this.editorGroupsService.groups.map(R=>R.editors.map(B=>B.resource)))).filter(R=>u.pathIncludedInQuery(le,R.fsPath)),J=this.commonQueryFromFileList(H);return Object.assign(Object.assign({},le),J)}const fe=P.extraFileResources&&P.extraFileResources.filter(Y=>u.pathIncludedInQuery(le,Y.fsPath));return le.extraFileResources=fe&&fe.length?fe:void 0,le}commonQueryFromFileList(A){const P=[],a=new k.ResourceMap,F={};let N=!1;return A.forEach(W=>{var le,fe;if(W.scheme===D.Schemas.walkThrough)return;if(C.isAbsolutePath(W)){const H=(fe=(le=this.workspaceContextService.getWorkspaceFolder(W))===null||le===void 0?void 0:le.uri)!==null&&fe!==void 0?fe:W.with({path:_.dirname(W.fsPath)});let J=a.get(H);J||(N=!0,J={folder:H,includePattern:{}},P.push(J),a.set(H,J));const R=_.relative(H.fsPath,W.fsPath);I.assertIsDefined(J.includePattern)[R.replace(/\\/g,"/")]=!0}else W.fsPath&&(N=!0,F[W.fsPath]=!0)}),{folderQueries:P,includePattern:F,usingSearchPaths:!0,excludePattern:N?void 0:{"**/*":!0}}}isCaseSensitive(A,P){if(P.isSmartCase){if(A.isRegExp){if(n.containsUppercaseCharacter(A.pattern,!0))return!0}else if(n.containsUppercaseCharacter(A.pattern))return!0}return!!A.isCaseSensitive}isMultiline(A){return A.isMultiline||A.isRegExp&&h.isMultilineRegexSource(A.pattern)||A.pattern.indexOf(`
`)>=0?!0:!!A.isMultiline}parseSearchPaths(A){const P=J=>_.isAbsolute(J)||/^\.\.?([\/\\]|$)/.test(J),F=(Array.isArray(A)?A:i(A)).map(J=>{const R=this.pathService.resolvedUserHome;return R?y.untildify(J,R.scheme===D.Schemas.file?R.fsPath:R.path):J}),N=T.groupBy(F,J=>P(J)?"searchPaths":"exprSegments"),W=(N.exprSegments||[]).map(J=>n.rtrim(J,"/")).map(J=>n.rtrim(J,"\\")).map(J=>(J[0]==="."&&(J="*"+J),s(J))),le={},fe=this.expandSearchPathPatterns(N.searchPaths||[]);fe&&fe.length&&(le.searchPaths=fe);const Y=m.flatten(W),H=t(...Y);return H&&(le.pattern=H),le}getExcludesForFolder(A,P){return P.disregardExcludeSettings?void 0:u.getExcludes(A,!P.disregardSearchExcludeSettings)}expandSearchPathPatterns(A){if(!A||!A.length)return[];const P=m.flatten(A.map(F=>{let{pathPortion:N,globPortion:W}=g(F);W&&(W=l(W));const le=this.expandOneSearchPath(N);return m.flatten(le.map(fe=>this.resolveOneSearchPathPattern(fe,W)))})),a=new Map;return P.forEach(F=>{const N=F.searchPath.toString(),W=a.get(N);W?F.pattern&&(W.pattern=W.pattern||{},W.pattern[F.pattern]=!0):a.set(N,{searchPath:F.searchPath,pattern:F.pattern?t(F.pattern):void 0})}),Array.from(a.values())}expandOneSearchPath(A){if(_.isAbsolute(A)){const P=this.workspaceContextService.getWorkspace().folders;return P[0]&&P[0].uri.scheme!==D.Schemas.file?[{searchPath:P[0].uri.with({path:A})}]:[{searchPath:o.URI.file(_.normalize(A))}]}if(this.workspaceContextService.getWorkbenchState()===2){const P=this.workspaceContextService.getWorkspace().folders[0].uri;if(A=r(A),A.startsWith("../")||A===".."){const F=_.posix.resolve(P.path,A);return[{searchPath:P.with({path:F})}]}const a=l(A);return[{searchPath:P,pattern:a}]}else{if(A==="./"||A===".\\")return[];{const P=A.replace(/^\.[\/\\]/,""),F=this.workspaceContextService.getWorkspace().folders.map(N=>{const W=P.match(new RegExp(`^${N.name}(?:/(.*))?`));return W?{match:W,folder:N}:null}).filter(I.isDefined);if(F.length)return F.map(N=>{const W=N.match[1];return{searchPath:N.folder.uri,pattern:W&&l(W)}});{const N=A.match(/\.[\/\\](.+)[\/\\]?/),W=N?N[1]:A,le=d.localize(0,null,W);throw new Error(le)}}}}resolveOneSearchPathPattern(A,P){const a=A.pattern&&P?`${A.pattern}/${P}`:A.pattern||P,F=[{searchPath:A.searchPath,pattern:a}];return a&&!a.endsWith("**")&&F.push({searchPath:A.searchPath,pattern:a+"/**"}),F}getFolderQueryForSearchPath(A,P,a){const F=this.getFolderQueryForRoot(b.toWorkspaceFolder(A.searchPath),P,a,!1);return F?Object.assign(Object.assign({},F),{includePattern:A.pattern}):null}getFolderQueryForRoot(A,P,a,F){let N;const W=o.URI.isUri(A)?A:A.uri;if(a.searchPaths){const J=a.searchPaths.filter(R=>C.isEqual(R.searchPath,W))[0];if(J&&!J.pattern)return null;J&&(N=J.pattern)}const le=this.configurationService.getValue({resource:W}),fe=this.getExcludesForFolder(le,P),Y=Object.assign(Object.assign({},fe||{}),N||{}),H=o.URI.isUri(A)?C.basename(A):A.name;return{folder:W,folderName:F?H:void 0,excludePattern:Object.keys(Y).length>0?Y:void 0,fileEncoding:le.files&&le.files.encoding,disregardIgnoreFiles:typeof P.disregardIgnoreFiles=="boolean"?P.disregardIgnoreFiles:!le.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof P.disregardGlobalIgnoreFiles=="boolean"?P.disregardGlobalIgnoreFiles:!le.search.useGlobalIgnoreFiles,ignoreSymlinks:typeof P.ignoreSymlinks=="boolean"?P.ignoreSymlinks:!le.search.followSymlinks}}};f=He([ze(0,c.IConfigurationService),ze(1,b.IWorkspaceContextService),ze(2,p.IEditorGroupsService),ze(3,w.IPathService)],f),e.QueryBuilder=f;function g(v){const A=v.match(/[\*\{\}\(\)\[\]\?]/);if(A){const P=A.index,a=v.substr(0,P).match(/[/|\\][^/\\]*$/);if(a){let F=v.substr(0,a.index);return F.match(/[/\\]/)||(F+="/"),{pathPortion:F,globPortion:v.substr((a.index||0)+1)}}}return{pathPortion:v}}function t(...v){return v.length?v.reduce((A,P)=>(A[P]=!0,A),Object.create(null)):void 0}function i(v){return S.splitGlobAware(v,",").map(A=>A.trim()).filter(A=>!!A.length)}function s(v){return[`**/${v}/**`,`**/${v}`].map(P=>P.replace(/\*\*\/\*\*/g,"**"))}function r(v){return v.replace(/\\/g,"/")}function l(v){return r(v).replace(/^\.\//,"").replace(/\/+$/g,"")}function E(v,A){v=m.distinct(v,F=>F.toString());const P=[],a=A.getWorkspace();return v&&v.forEach(F=>{let N;if(A.getWorkbenchState()===2)N=C.relativePath(a.folders[0].uri,F),N&&N!=="."&&(N="./"+N);else{const W=A.getWorkspaceFolder(F);if(W){const le=W.name;if(a.folders.filter(Y=>Y.name===le).length===1){const Y=C.relativePath(W.uri,F);Y===""?N=`./${W.name}`:N=`./${W.name}/${Y}`}else N=F.fsPath}}N&&P.push(N)}),P}e.resolveResourcesForSearchIncludes=E}),define(_e[213],Ee([0,1,25,2,18,11,5,212,38,44]),function(Z,e,m,T,S,y,k,D,_,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const n=7e3;function I(c,b){const p=b.activationEvents;if(!p)return Promise.resolve(void 0);const w=[],u=[];for(const r of p)if(/^workspaceContains:/.test(r)){const l=r.substr("workspaceContains:".length);l.indexOf("*")>=0||l.indexOf("?")>=0||c.forceUsingSearch?u.push(l):w.push(l)}if(w.length===0&&u.length===0)return Promise.resolve(void 0);let f;const g=new Promise((r,l)=>{f=r}),t=r=>f({activationEvent:r}),i=Promise.all(w.map(r=>o(c,r,t))).then(()=>{}),s=h(c,b.identifier,u,t);return Promise.all([i,s]).then(()=>{f(void 0)}),g}e.checkActivateWorkspaceContainsExtension=I;async function o(c,b,p){for(const w of c.folders)if(await c.exists(m.joinPath(T.URI.revive(w),b))){p(`workspaceContains:${b}`);return}}async function h(c,b,p,w){if(p.length===0)return Promise.resolve(void 0);const u=new S.CancellationTokenSource,f=c.checkExists(c.folders,p,u.token),g=setTimeout(async()=>{u.cancel(),w(`workspaceContainsTimeout:${p.join(",")}`)},n);let t=!1;try{t=await f}catch(i){y.isPromiseCanceledError(i)||y.onUnexpectedError(i)}u.dispose(),clearTimeout(g),t&&w(`workspaceContains:${p.join(",")}`)}function d(c,b,p,w){const u=c.get(k.IInstantiationService),f=c.get(_.ISearchService),t=u.createInstance(D.QueryBuilder).file(b.map(i=>C.toWorkspaceFolder(T.URI.revive(i))),{_reason:"checkExists",includePattern:p,exists:!0});return f.fileSearch(t,w).then(i=>!!i.limitHit,i=>y.isPromiseCanceledError(i)?!1:Promise.reject(i))}e.checkGlobFileExists=d});var it=this&&this.__classPrivateFieldSet||function(Z,e,m,T,S){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!S:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?S.call(Z,m):S?S.value=m:e.set(Z,m),m},Ue=this&&this.__classPrivateFieldGet||function(Z,e,m,T){if(m==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!T:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?T:m==="a"?T.call(Z):T?T.value:e.get(Z)};define(_e[33],Ee([0,1,129,14,75,25,12,7,22,2,15,4,32,176,73,30,29,174,11,26,23,153,6,92,5,28,74,13,60,65,37,3,213,69,155]),function(Z,e,m,T,S,y,k,D,_,C,n,I,o,h,d,c,b,p,w,u,f,g,t,i,s,r,l,E,v,A,P,a,F,N,W){"use strict";var le,fe,Y;Object.defineProperty(e,"__esModule",{value:!0}),e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=s.createDecorator("IHostUtils");let H=class xn extends D.Disposable{constructor(M,x,q,z,oe,pe,Te,Be,Fe,We){super();this._onDidChangeRemoteConnectionData=this._register(new a.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._hostUtils=x,this._extHostContext=q,this._initData=Te,this._extHostWorkspace=z,this._extHostConfiguration=oe,this._logService=pe,this._extHostTunnelService=Fe,this._extHostTerminalService=We,this._disposables=new D.DisposableStore,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(I.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(I.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(I.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new k.Barrier,this._readyToStartExtensionHost=new k.Barrier,this._readyToRunExtensions=new k.Barrier,this._eagerExtensionsActivated=new k.Barrier,this._registry=new p.ExtensionDescriptionRegistry(this._initData.extensions),this._storage=new d.ExtHostStorage(this._extHostContext),this._secretState=new N.ExtHostSecretState(this._extHostContext),this._storagePath=Be,this._instaService=M.createChild(new v.ServiceCollection([d.IExtHostStorage,this._storage],[N.IExtHostSecretState,this._secretState]));const Qe=new Set;this._initData.hostExtensions.forEach(Ge=>Qe.add(u.ExtensionIdentifier.toKey(Ge))),this._activator=new h.ExtensionsActivator(this._registry,this._initData.resolvedExtensions,this._initData.hostExtensions,{onExtensionActivationError:(Ge,Ke,$)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(Ge,w.transformErrorForSerialization(Ke),$)},actualActivateExtension:async(Ge,Ke)=>{if(Qe.has(u.ExtensionIdentifier.toKey(Ge)))return await this._mainThreadExtensionsProxy.$activateExtension(Ge,Ke),new h.HostExtension;const $=this._registry.getExtensionDescription(Ge);return this._activateExtension($,Ke)}},this._logService),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),S.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(M){w.onUnexpectedError(M)}}async deactivateAll(){let M=[];try{M=this._registry.getAllExtensionDescriptions().map(oe=>oe.identifier).filter(oe=>this.isActivated(oe)).map(oe=>this._deactivate(oe))}catch(x){}await Promise.all(M)}isActivated(M){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(M):!1}_activateByEvent(M,x){return this._activator.activateByEvent(M,x)}_activateById(M,x){return this._activator.activateById(M,x)}activateByIdWithErrors(M,x){return this._activateById(M,x).then(()=>{const q=this._activator.getActivatedExtension(M);if(q.activationFailed)return Promise.reject(q.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(M=>this._registry)}getExtensionExports(M){return this._readyToRunExtensions.isOpen()?this._activator.getActivatedExtension(M).exports:null}getExtensionPathIndex(){if(!this._extensionPathIndex){const M=_.TernarySearchTree.forPaths(),x=this._registry.getAllExtensionDescriptions().map(q=>{if(!!this._getEntryPoint(q))return this._hostUtils.realpath(q.extensionLocation.fsPath).then(z=>M.set(C.URI.file(z).fsPath,q))});this._extensionPathIndex=Promise.all(x).then(()=>M)}return this._extensionPathIndex}_deactivate(M){let x=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(M))return x;const q=this._activator.getActivatedExtension(M);if(!q)return x;try{typeof q.module.deactivate=="function"&&(x=Promise.resolve(q.module.deactivate()).then(void 0,z=>(this._logService.error(z),Promise.resolve(void 0))))}catch(z){this._logService.error(z)}try{D.dispose(q.subscriptions)}catch(z){this._logService.error(z)}return x}async _activateExtension(M,x){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(M.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(M.identifier),this._doActivateExtension(M,x).then(q=>{const z=q.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(M.identifier,z.codeLoadingTime,z.activateCallTime,z.activateResolvedTime,x),this._logExtensionActivationTimes(M,x,"success",z),q},q=>{throw this._logExtensionActivationTimes(M,x,"failure"),q})}_logExtensionActivationTimes(M,x,q,z){const oe=J(M,x);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",Object.assign(Object.assign(Object.assign({},oe),z||{}),{outcome:q}))}_doActivateExtension(M,x){const q=J(M,x);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",q);const z=this._getEntryPoint(M);if(!z)return Promise.resolve(new h.EmptyExtension(h.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${M.identifier.value} ${JSON.stringify(x)}`),this._logService.flush();const oe=new h.ExtensionActivationTimesBuilder(x.startup);return Promise.all([this._loadCommonJSModule(M.identifier,y.joinPath(M.extensionLocation,z),oe),this._loadExtensionContext(M)]).then(pe=>(S.mark(`code/extHost/willActivateExtension/${M.identifier.value}`),xn._callActivate(this._logService,M.identifier,pe[0],pe[1],oe))).then(pe=>(S.mark(`code/extHost/didActivateExtension/${M.identifier.value}`),pe))}_loadExtensionContext(M){const x=new g.ExtensionGlobalMemento(M,this._storage),q=new g.ExtensionMemento(M.identifier.value,!1,this._storage),z=new W.ExtensionSecrets(M,this._secretState),oe=M.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?t.ExtensionMode.Test:t.ExtensionMode.Development:t.ExtensionMode.Production,pe=this._initData.remote.isRemote?t.ExtensionKind.Workspace:t.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${M.identifier.value}`),Promise.all([x.whenReady,q.whenReady,this._storagePath.whenReady]).then(()=>{const Te=this;let Be;return Object.freeze({globalState:x,workspaceState:q,secrets:z,subscriptions:[],get extensionUri(){return M.extensionLocation},get extensionPath(){return M.extensionLocation.fsPath},asAbsolutePath(Fe){return T.join(M.extensionLocation.fsPath,Fe)},get storagePath(){var Fe;return(Fe=Te._storagePath.workspaceValue(M))===null||Fe===void 0?void 0:Fe.fsPath},get globalStoragePath(){return Te._storagePath.globalValue(M).fsPath},get logPath(){return T.join(Te._initData.logsLocation.fsPath,M.identifier.value)},get logUri(){return C.URI.joinPath(Te._initData.logsLocation,M.identifier.value)},get storageUri(){return Te._storagePath.workspaceValue(M)},get globalStorageUri(){return Te._storagePath.globalValue(M)},get extensionMode(){return oe},get extension(){return Be===void 0&&(Be=new R(Te,M.identifier,M,pe)),Be},get extensionRuntime(){return b.checkProposedApiEnabled(M),Te.extensionRuntime},get environmentVariableCollection(){return Te._extHostTerminalService.getEnvironmentVariableCollection(M)}})})}static _callActivate(M,x,q,z,oe){return q=q||{activate:void 0,deactivate:void 0},this._callActivateOptional(M,x,q,z,oe).then(pe=>new h.ActivatedExtension(!1,null,oe.build(),q,pe,z.subscriptions))}static _callActivateOptional(M,x,q,z,oe){if(typeof q.activate=="function")try{oe.activateCallStart(),M.trace(`ExtensionService#_callActivateOptional ${x.value}`);const pe=typeof global=="object"?global:self,Te=q.activate.apply(pe,[z]);return oe.activateCallStop(),oe.activateResolveStart(),Promise.resolve(Te).then(Be=>(oe.activateResolveStop(),Be))}catch(pe){return Promise.reject(pe)}else return Promise.resolve(q)}_activateOneStartupFinished(M,x){this._activateById(M.identifier,{startup:!1,extensionId:M.identifier,activationEvent:x}).then(void 0,q=>{this._logService.error(q)})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(S.getMarks());for(const M of this._registry.getAllExtensionDescriptions())if(M.activationEvents)for(const x of M.activationEvents)x==="onStartupFinished"&&this._activateOneStartupFinished(M,x)}_handleEagerExtensions(){const M=this._activateByEvent("*",!0).then(void 0,oe=>{this._logService.error(oe)});this._disposables.add(this._extHostWorkspace.onDidChangeWorkspace(oe=>this._handleWorkspaceContainsEagerExtensions(oe.added)));const x=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],q=this._handleWorkspaceContainsEagerExtensions(x),z=Promise.all([M,q]).then(()=>{});return Promise.race([z,k.timeout(1e4)]).then(()=>{this._activateAllStartupFinished()}),z}_handleWorkspaceContainsEagerExtensions(M){return M.length===0?Promise.resolve(void 0):Promise.all(this._registry.getAllExtensionDescriptions().map(x=>this._handleWorkspaceContainsEagerExtension(M,x))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(M,x){if(this.isActivated(x.identifier))return;const q=!this._initData.remote.isRemote&&!!this._initData.remote.authority,z={folders:M.map(pe=>pe.uri),forceUsingSearch:q,exists:pe=>this._hostUtils.exists(pe.fsPath),checkExists:(pe,Te,Be)=>this._mainThreadWorkspaceProxy.$checkExists(pe,Te,Be)},oe=await F.checkActivateWorkspaceContainsExtension(z,x);if(!!oe)return this._activateById(x.identifier,{startup:!0,extensionId:x.identifier,activationEvent:oe.activationEvent}).then(void 0,pe=>this._logService.error(pe))}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return await this._doHandleExtensionTests()}catch(M){throw console.error(M),M}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:M,extensionTestsLocationURI:x}=this._initData.environment;if(!M||!x)throw new Error(m.localize(0,null));const q=await this._loadCommonJSModule(null,x,new h.ExtensionActivationTimesBuilder(!1));if(!q||typeof q.run!="function")throw new Error(m.localize(1,null,x.toString()));return new Promise((z,oe)=>{const pe=(Fe,We)=>{Fe?oe(Fe):z(typeof We=="number"&&We>0?1:0)},Te=y.originalFSPath(x),Be=q.run(Te,pe);Be&&Be.then&&Be.then(()=>{z(0)}).catch(Fe=>{oe(Fe.toString())})})}async $extensionTestsExit(M){this._logService.info(`extension host terminating: test runner requested exit with code ${M}`),this._logService.info(`exiting with code ${M}`),this._logService.flush(),this._hostUtils.exit(M)}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("eager extensions activated")})}registerRemoteAuthorityResolver(M,x){return this._resolvers[M]=x,D.toDisposable(()=>{delete this._resolvers[M]})}async _activateAndGetResolver(M){const x=M.indexOf("+");if(x===-1)throw new Error("Not an authority that can be resolved!");const q=M.substr(0,x);return await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${q}`,!1),{authorityPrefix:q,resolver:this._resolvers[q]}}async $resolveAuthority(M,x){const{authorityPrefix:q,resolver:z}=await this._activateAndGetResolver(M);if(!z)return{type:"error",error:{code:i.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${q}.`,detail:void 0}};try{this._disposables.add(await this._extHostTunnelService.setTunnelExtensionFunctions(z)),S.mark(`code/extHost/willResolveAuthority/${q}`);const oe=await z.resolve(M,{resolveAttempt:x});S.mark(`code/extHost/didResolveAuthorityOK/${q}`);const pe={authority:M,host:oe.host,port:oe.port,connectionToken:oe.connectionToken},Te={extensionHostEnv:oe.extensionHostEnv,isTrusted:oe.isTrusted};return{type:"ok",value:{authority:pe,options:Te,tunnelInformation:{environmentTunnels:oe.environmentTunnels}}}}catch(oe){if(S.mark(`code/extHost/didResolveAuthorityError/${q}`),oe instanceof t.RemoteAuthorityResolverError)return{type:"error",error:{code:oe._code,message:oe._message,detail:oe._detail}};throw oe}}async $getCanonicalURI(M,x){const{authorityPrefix:q,resolver:z}=await this._activateAndGetResolver(M);if(!z)throw new Error(`Cannot get canonical URI because no remote extension is installed to resolve ${q}`);const oe=C.URI.revive(x);if(typeof z.getCanonicalURI=="undefined")return oe;const pe=await k.asPromise(()=>z.getCanonicalURI(oe));return pe||oe}$startExtensionHost(M){return this._registry.keepOnly(M),this._startExtensionHost()}$activateByEvent(M,x){return x===1?this._activateByEvent(M,!1):this._readyToRunExtensions.wait().then(q=>this._activateByEvent(M,!1))}async $activate(M,x){return await this._readyToRunExtensions.wait(),this._registry.getExtensionDescription(M)?(await this._activateById(M,x),!0):!1}async $deltaExtensions(M,x){M.forEach(z=>z.extensionLocation=C.URI.revive(z.extensionLocation));const q=await this.getExtensionPathIndex();return await Promise.all(x.map(async z=>{const oe=this._registry.getExtensionDescription(z);if(!oe)return;const pe=await this._hostUtils.realpath(oe.extensionLocation.fsPath);q.delete(C.URI.file(pe).fsPath)})),await Promise.all(M.map(async z=>{const oe=await this._hostUtils.realpath(z.extensionLocation.fsPath);q.set(C.URI.file(oe).fsPath,z)})),this._registry.deltaExtensions(M,x),Promise.resolve(void 0)}async $test_latency(M){return M}async $test_up(M){return M.byteLength}async $test_down(M){let x=f.VSBuffer.alloc(M),q=Math.random()%256;for(let z=0;z<M;z++)x.writeUInt8(q,z);return x}async $updateRemoteConnectionData(M){this._remoteConnectionData=M,this._onDidChangeRemoteConnectionData.fire()}};H=He([ze(0,s.IInstantiationService),ze(1,e.IHostUtils),ze(2,E.IExtHostRpcService),ze(3,c.IExtHostWorkspace),ze(4,o.IExtHostConfiguration),ze(5,n.ILogService),ze(6,r.IExtHostInitDataService),ze(7,l.IExtensionStoragePaths),ze(8,A.IExtHostTunnelService),ze(9,P.IExtHostTerminalService)],H),e.AbstractExtHostExtensionService=H;function J(B,M){return{id:B.identifier.value,name:B.name,extensionVersion:B.version,publisherDisplayName:B.publisher,activationEvents:B.activationEvents?B.activationEvents.join(","):null,isBuiltin:B.isBuiltin,reason:M.activationEvent,reasonId:M.extensionId.value}}e.IExtHostExtensionService=s.createDecorator("IExtHostExtensionService");class R{constructor(M,x,q,z){le.set(this,void 0),fe.set(this,void 0),Y.set(this,void 0),it(this,le,M,"f"),it(this,fe,x,"f"),it(this,Y,q.identifier,"f"),this.id=q.identifier.value,this.extensionUri=q.extensionLocation,this.extensionPath=T.normalize(y.originalFSPath(q.extensionLocation)),this.packageJSON=q,this.extensionKind=z}get isActive(){return Ue(this,le,"f").isActivated(Ue(this,Y,"f"))}get exports(){if(this.packageJSON.api!=="none")return Ue(this,le,"f").getExtensionExports(Ue(this,Y,"f"))}activate(){return Ue(this,le,"f").activateByIdWithErrors(Ue(this,Y,"f"),{startup:!1,extensionId:Ue(this,fe,"f"),activationEvent:"api"}).then(()=>this.exports)}}e.Extension=R,le=new WeakMap,fe=new WeakMap,Y=new WeakMap}),define(_e[105],Ee([0,1,14,2,3,12,4,6,160,30,33,36,164,32,161,13,5,10,40,63]),function(Z,e,m,T,S,y,k,D,_,C,n,I,o,h,d,c,b,p,w,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostVariableResolverService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=b.createDecorator("IExtHostDebugService");let f=class{constructor(v,A,P,a,F,N){this._workspaceService=A,this._extensionService=P,this._editorsService=a,this._configurationService=F,this._editorTabs=N,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new S.Emitter,this._onDidTerminateDebugSession=new S.Emitter,this._onDidChangeActiveDebugSession=new S.Emitter,this._onDidReceiveDebugSessionCustomEvent=new S.Emitter,this._debugServiceProxy=v.getProxy(k.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new S.Emitter({onFirstListenerAdd:()=>{this.startBreakpoints()}}),this._activeDebugConsole=new t(this._debugServiceProxy),this._breakpoints=new Map,this._breakpointEventsActive=!1,this._extensionService.getExtensionRegistry().then(W=>{W.onDidChange(le=>{this.registerAllDebugTypes(W)}),this.registerAllDebugTypes(W)})}get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}asDebugSourceUri(v,A){const P=v;if(typeof P.sourceReference=="number"&&P.sourceReference>0){let a=`debug:${encodeURIComponent(P.path||"")}`,F="?";return A&&(a+=`${F}session=${encodeURIComponent(A.id)}`,F="&"),a+=`${F}ref=${P.sourceReference}`,T.URI.parse(a)}else{if(P.path)return T.URI.file(P.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(v){const A=[];for(const P of v.getAllExtensionDescriptions())if(P.contributes){const a=P.contributes.debuggers;if(a&&a.length>0)for(const F of a)d.isDebuggerMainContribution(F)&&A.push(F.type)}this._debugServiceProxy.$registerDebugTypes(A)}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){this.startBreakpoints();const v=[];return this._breakpoints.forEach(A=>v.push(A)),v}addBreakpoints(v){this.startBreakpoints();const A=v.filter(F=>{const N=F.id;return this._breakpoints.has(N)?!1:(this._breakpoints.set(N,F),!0)});this.fireBreakpointChanges(A,[],[]);const P=[],a=new Map;for(const F of A)if(F instanceof D.SourceBreakpoint){let N=a.get(F.location.uri.toString());N||(N={type:"sourceMulti",uri:F.location.uri,lines:[]},a.set(F.location.uri.toString(),N),P.push(N)),N.lines.push({id:F.id,enabled:F.enabled,condition:F.condition,hitCondition:F.hitCondition,logMessage:F.logMessage,line:F.location.range.start.line,character:F.location.range.start.character})}else F instanceof D.FunctionBreakpoint&&P.push({type:"function",id:F.id,enabled:F.enabled,hitCondition:F.hitCondition,logMessage:F.logMessage,condition:F.condition,functionName:F.functionName});return this._debugServiceProxy.$registerBreakpoints(P)}removeBreakpoints(v){this.startBreakpoints();const A=v.filter(N=>this._breakpoints.delete(N.id));this.fireBreakpointChanges([],A,[]);const P=A.filter(N=>N instanceof D.SourceBreakpoint).map(N=>N.id),a=A.filter(N=>N instanceof D.FunctionBreakpoint).map(N=>N.id),F=A.filter(N=>N instanceof D.DataBreakpoint).map(N=>N.id);return this._debugServiceProxy.$unregisterBreakpoints(P,a,F)}startDebugging(v,A,P){return this._debugServiceProxy.$startDebugging(v?v.uri:void 0,A,{parentSessionID:P.parentSession?P.parentSession.id:void 0,repl:P.consoleMode===D.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:P.noDebug,compact:P.compact})}stopDebugging(v){return this._debugServiceProxy.$stopDebugging(v?v.id:void 0)}registerDebugConfigurationProvider(v,A,P){if(!A)return new D.Disposable(()=>{});const a=this._configProviderHandleCounter++;return this._configProviders.push({type:v,handle:a,provider:A}),this._debugServiceProxy.$registerDebugConfigurationProvider(v,P,!!A.provideDebugConfigurations,!!A.resolveDebugConfiguration,!!A.resolveDebugConfigurationWithSubstitutedVariables,a),new D.Disposable(()=>{this._configProviders=this._configProviders.filter(F=>F.provider!==A),this._debugServiceProxy.$unregisterDebugConfigurationProvider(a)})}registerDebugAdapterDescriptorFactory(v,A,P){if(!P)return new D.Disposable(()=>{});if(!this.definesDebugType(v,A))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${A}' debugger.`);if(this.getAdapterDescriptorFactoryByType(A))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const a=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:A,handle:a,factory:P}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(A,a),new D.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(F=>F.factory!==P),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(a)})}registerDebugAdapterTrackerFactory(v,A){if(!A)return new D.Disposable(()=>{});const P=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:v,handle:P,factory:A}),new D.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(a=>a.factory!==A)})}async $runInTerminal(v,A){return Promise.resolve(void 0)}async $substituteVariables(v,A){if(!this._variableResolver){const[F,N]=await Promise.all([this._workspaceService.getWorkspaceFolders2(),this._configurationService.getConfigProvider()]);this._variableResolver=this.createVariableResolver(F||[],this._editorsService,N)}let P;const a=await this.getFolder(v);return a&&(P={uri:a.uri,name:a.name,index:a.index,toResource:()=>{throw new Error("Not implemented")}}),this._variableResolver.resolveAnyAsync(P,A)}createDebugAdapter(v,A){if(v.type==="implementation")return new r(v.implementation)}createSignService(){}async $startDASession(v,A){const P=this,a=await this.getSession(A);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(a.type),a).then(F=>{if(!F)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${a.type}' (extension might have failed to activate)`);const N=this.convertToDto(F),W=this.createDebugAdapter(N,a);if(!W)throw new Error(`Couldn't create a debug adapter for type '${a.type}'.`);const le=W;return this._debugAdapters.set(v,le),this.getDebugAdapterTrackers(a).then(fe=>(fe&&this._debugAdaptersTrackers.set(v,fe),le.onMessage(async Y=>{if(Y.type==="request"&&Y.command==="handshake"){const H=Y,J={type:"response",seq:0,command:H.command,request_seq:H.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const R=await this._signService.sign(H.arguments.value);J.body={signature:R},le.sendResponse(J)}else throw new Error("no signer")}catch(R){J.success=!1,J.message=R.message,le.sendResponse(J)}}else fe&&fe.onDidSendMessage&&fe.onDidSendMessage(Y),Y=d.convertToVSCPaths(Y,!0),P._debugServiceProxy.$acceptDAMessage(v,Y)}),le.onError(Y=>{fe&&fe.onError&&fe.onError(Y),this._debugServiceProxy.$acceptDAError(v,Y.name,Y.message,Y.stack)}),le.onExit(Y=>{fe&&fe.onExit&&fe.onExit(p.withNullAsUndefined(Y),void 0),this._debugServiceProxy.$acceptDAExit(v,p.withNullAsUndefined(Y),void 0)}),fe&&fe.onWillStartSession&&fe.onWillStartSession(),le.startSession()))})}$sendDAMessage(v,A){A=d.convertToDAPaths(A,!1);const P=this._debugAdaptersTrackers.get(v);P&&P.onWillReceiveMessage&&P.onWillReceiveMessage(A);const a=this._debugAdapters.get(v);a&&a.sendMessage(A)}$stopDASession(v){const A=this._debugAdaptersTrackers.get(v);this._debugAdaptersTrackers.delete(v),A&&A.onWillStopSession&&A.onWillStopSession();const P=this._debugAdapters.get(v);return this._debugAdapters.delete(v),P?P.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(v){const A=[],P=[],a=[];if(v.added)for(const F of v.added){const N=F.id;if(N&&!this._breakpoints.has(N)){let W;if(F.type==="function")W=new D.FunctionBreakpoint(F.functionName,F.enabled,F.condition,F.hitCondition,F.logMessage);else if(F.type==="data")W=new D.DataBreakpoint(F.label,F.dataId,F.canPersist,F.enabled,F.hitCondition,F.condition,F.logMessage);else{const le=T.URI.revive(F.uri);W=new D.SourceBreakpoint(new D.Location(le,new D.Position(F.line,F.character)),F.enabled,F.condition,F.hitCondition,F.logMessage)}W._id=N,this._breakpoints.set(N,W),A.push(W)}}if(v.removed)for(const F of v.removed){const N=this._breakpoints.get(F);N&&(this._breakpoints.delete(F),P.push(N))}if(v.changed){for(const F of v.changed)if(F.id){const N=this._breakpoints.get(F.id);if(N){if(N instanceof D.FunctionBreakpoint&&F.type==="function"){const W=N;W.enabled=F.enabled,W.condition=F.condition,W.hitCondition=F.hitCondition,W.logMessage=F.logMessage,W.functionName=F.functionName}else if(N instanceof D.SourceBreakpoint&&F.type==="source"){const W=N;W.enabled=F.enabled,W.condition=F.condition,W.hitCondition=F.hitCondition,W.logMessage=F.logMessage,W.location=new D.Location(T.URI.revive(F.uri),new D.Position(F.line,F.character))}a.push(N)}}}this.fireBreakpointChanges(A,P,a)}$provideDebugConfigurations(v,A,P){return y.asPromise(async()=>{const a=this.getConfigProviderByHandle(v);if(!a)throw new Error("no DebugConfigurationProvider found");if(!a.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const F=await this.getFolder(A);return a.provideDebugConfigurations(F,P)}).then(a=>{if(!a)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return a})}$resolveDebugConfiguration(v,A,P,a){return y.asPromise(async()=>{const F=this.getConfigProviderByHandle(v);if(!F)throw new Error("no DebugConfigurationProvider found");if(!F.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const N=await this.getFolder(A);return F.resolveDebugConfiguration(N,P,a)})}$resolveDebugConfigurationWithSubstitutedVariables(v,A,P,a){return y.asPromise(async()=>{const F=this.getConfigProviderByHandle(v);if(!F)throw new Error("no DebugConfigurationProvider found");if(!F.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const N=await this.getFolder(A);return F.resolveDebugConfigurationWithSubstitutedVariables(N,P,a)})}async $provideDebugAdapter(v,A){const P=this.getAdapterDescriptorFactoryByHandle(v);if(!P)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const a=await this.getSession(A);return this.getAdapterDescriptor(P,a).then(F=>{if(!F)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${a.type}'`);return this.convertToDto(F)})}async $acceptDebugSessionStarted(v){const A=await this.getSession(v);this._onDidStartDebugSession.fire(A)}async $acceptDebugSessionTerminated(v){const A=await this.getSession(v);A&&(this._onDidTerminateDebugSession.fire(A),this._debugSessions.delete(A.id))}async $acceptDebugSessionActiveChanged(v){this._activeDebugSession=v?await this.getSession(v):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(v,A){const P=await this.getSession(v);P&&P._acceptNameChanged(A)}async $acceptDebugSessionCustomEvent(v,A){const a={session:await this.getSession(v),event:A.event,body:A.body};this._onDidReceiveDebugSessionCustomEvent.fire(a)}convertToDto(v){if(v instanceof D.DebugAdapterExecutable)return{type:"executable",command:v.command,args:v.args,options:v.options};if(v instanceof D.DebugAdapterServer)return{type:"server",port:v.port,host:v.host};if(v instanceof D.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:v.path};if(v instanceof D.DebugAdapterInlineImplementation)return{type:"implementation",implementation:v.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(v){const A=this._adapterFactories.filter(P=>P.type===v);if(A.length>0)return A[0].factory}getAdapterDescriptorFactoryByHandle(v){const A=this._adapterFactories.filter(P=>P.handle===v);if(A.length>0)return A[0].factory}getConfigProviderByHandle(v){const A=this._configProviders.filter(P=>P.handle===v);if(A.length>0)return A[0].provider}definesDebugType(v,A){if(v.contributes){const P=v.contributes.debuggers;if(P&&P.length>0){for(const a of P)if(a.label&&a.type&&a.type===A)return!0}}return!1}getDebugAdapterTrackers(v){const P=v.configuration.type,a=this._trackerFactories.filter(F=>F.type===P||F.type==="*").map(F=>y.asPromise(()=>F.factory.createDebugAdapterTracker(v)).then(N=>N,N=>null));return Promise.race([Promise.all(a).then(F=>{const N=F.filter(W=>!!W);if(N.length>0)return new s(N)}),new Promise((F,N)=>{const W=setTimeout(()=>{clearTimeout(W),N(new Error("timeout"))},1e3)})]).catch(F=>{})}async getAdapterDescriptor(v,A){const P=A.configuration.debugServer;if(typeof P=="number")return Promise.resolve(new D.DebugAdapterServer(P));if(v){const F=await this._extensionService.getExtensionRegistry();return y.asPromise(()=>v.createDebugAdapterDescriptor(A,this.daExecutableFromPackage(A,F))).then(N=>{if(N)return N})}const a=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(A,a))}daExecutableFromPackage(v,A){}startBreakpoints(){this._breakpointEventsActive||(this._breakpointEventsActive=!0,this._debugServiceProxy.$startBreakpointEvents())}fireBreakpointChanges(v,A,P){(v.length>0||A.length>0||P.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:v,removed:A,changed:P}))}async getSession(v){if(v)if(typeof v=="string"){const A=this._debugSessions.get(v);if(A)return A}else{let A=this._debugSessions.get(v.id);if(!A){const P=await this.getFolder(v.folderUri),a=v.parent?this._debugSessions.get(v.parent):void 0;A=new g(this._debugServiceProxy,v.id,v.type,v.name,P,v.configuration,a),this._debugSessions.set(A.id,A),this._debugServiceProxy.$sessionCached(A.id)}return A}throw new Error("cannot find session")}getFolder(v){if(v){const A=T.URI.revive(v);return this._workspaceService.resolveWorkspaceFolder(A)}return Promise.resolve(void 0)}};f=He([ze(0,c.IExtHostRpcService),ze(1,C.IExtHostWorkspace),ze(2,n.IExtHostExtensionService),ze(3,I.IExtHostDocumentsAndEditors),ze(4,h.IExtHostConfiguration),ze(5,u.IExtHostEditorTabs)],f),e.ExtHostDebugServiceBase=f;class g{constructor(v,A,P,a,F,N,W){this._debugServiceProxy=v,this._id=A,this._type=P,this._name=a,this._workspaceFolder=F,this._configuration=N,this._parentSession=W}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(v){this._name=v,this._debugServiceProxy.$setDebugSessionName(this._id,v)}get parentSession(){return this._parentSession}_acceptNameChanged(v){this._name=v}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(v,A){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,v,A)}getDebugProtocolBreakpoint(v){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,v.id)}}e.ExtHostDebugSession=g;class t{constructor(v){this.value=Object.freeze({append(A){v.$appendDebugConsole(A)},appendLine(A){this.append(A+`
`)}})}}e.ExtHostDebugConsole=t;class i extends o.AbstractVariableResolverService{constructor(v,A,P,a,F){function N(){if(A){const W=A.activeEditor();if(W)return W.document.uri;const le=a.tabs.filter(fe=>fe.isActive);if(le.length>0)return le[0].resource}}super({getFolderUri:W=>{const le=v.filter(fe=>fe.name===W);if(le&&le.length>0)return le[0].uri},getWorkspaceFolderCount:()=>v.length,getConfigurationValue:(W,le)=>P.getConfiguration(void 0,W).get(le),getAppRoot:()=>w.cwd(),getExecPath:()=>w.env.VSCODE_EXEC_PATH,getFilePath:()=>{const W=N();if(W)return m.normalize(W.fsPath)},getWorkspaceFolderPathForFile:()=>{if(F){const W=N();if(W){const le=F.getWorkspaceFolder(W);if(le)return m.normalize(le.uri.fsPath)}}},getSelectedText:()=>{if(A){const W=A.activeEditor();if(W&&!W.selection.isEmpty)return W.document.getText(W.selection)}},getLineNumber:()=>{if(A){const W=A.activeEditor();if(W)return String(W.selection.end.line+1)}}},void 0,Promise.resolve(w.env))}}e.ExtHostVariableResolverService=i;class s{constructor(v){this.trackers=v}onWillStartSession(){this.trackers.forEach(v=>v.onWillStartSession?v.onWillStartSession():void 0)}onWillReceiveMessage(v){this.trackers.forEach(A=>A.onWillReceiveMessage?A.onWillReceiveMessage(v):void 0)}onDidSendMessage(v){this.trackers.forEach(A=>A.onDidSendMessage?A.onDidSendMessage(v):void 0)}onWillStopSession(){this.trackers.forEach(v=>v.onWillStopSession?v.onWillStopSession():void 0)}onError(v){this.trackers.forEach(A=>A.onError?A.onError(v):void 0)}onExit(v,A){this.trackers.forEach(P=>P.onExit?P.onExit(v,A):void 0)}}class r extends _.AbstractDebugAdapter{constructor(v){super();this.implementation=v,v.onDidSendMessage(A=>{this.acceptMessage(A)})}startSession(){return Promise.resolve(void 0)}sendMessage(v){this.implementation.handleMessage(v)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let l=class extends f{constructor(v,A,P,a,F,N){super(v,A,P,a,F,N)}createVariableResolver(v,A,P){return new i(v,A,P,this._editorTabs)}};l=He([ze(0,c.IExtHostRpcService),ze(1,C.IExtHostWorkspace),ze(2,n.IExtHostExtensionService),ze(3,I.IExtHostDocumentsAndEditors),ze(4,h.IExtHostConfiguration),ze(5,u.IExtHostEditorTabs)],l),e.WorkerExtHostDebugService=l}),define(_e[214],Ee([0,1,75,2,4,32,29,26,13,28,5,33,40,15]),function(Z,e,m,T,S,y,k,D,_,C,n,I,o,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let d=class{constructor(u,f,g,t,i,s,r){this._apiFactory=u,this._extensionRegistry=f,this._instaService=g,this._extHostConfiguration=t,this._extHostExtensionService=i,this._initData=s,this._logService=r,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),m.mark("code/extHost/willWaitForConfig");const u=await this._extHostConfiguration.getConfigProvider();m.mark("code/extHost/didWaitForConfig");const f=await this._extHostExtensionService.getExtensionPathIndex();this.register(new c(this._apiFactory,f,this._extensionRegistry,u,this._logService)),this.register(this._instaService.createInstance(b)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(p,f,this._initData.environment.appUriScheme))}register(u){if(Array.isArray(u.nodeModuleName))for(let f of u.nodeModuleName)this._factories.set(f,u);else this._factories.set(u.nodeModuleName,u);typeof u.alternativeModuleName=="function"&&this._alternatives.push(f=>u.alternativeModuleName(f))}};d=He([ze(2,n.IInstantiationService),ze(3,y.IExtHostConfiguration),ze(4,I.IExtHostExtensionService),ze(5,C.IExtHostInitDataService),ze(6,h.ILogService)],d),e.RequireInterceptor=d;class c{constructor(u,f,g,t,i){this._apiFactory=u,this._extensionPaths=f,this._extensionRegistry=g,this._configProvider=t,this._logService=i,this.nodeModuleName="vscode",this._extApiImpl=new Map}load(u,f){const g=this._extensionPaths.findSubstr(f.fsPath);if(g){let t=this._extApiImpl.get(D.ExtensionIdentifier.toKey(g.identifier));return t||(t=this._apiFactory(g,this._extensionRegistry,this._configProvider),this._extApiImpl.set(D.ExtensionIdentifier.toKey(g.identifier),t)),t}if(!this._defaultApiImpl){let t="";this._extensionPaths.forEach((i,s)=>t+=`	${s} -> ${i.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${f.fsPath}. These are the extension path mappings: 
${t}`),this._defaultApiImpl=this._apiFactory(k.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let b=class{constructor(u,f){this.nodeModuleName="keytar";const{environment:g}=f,t=u.getProxy(S.MainContext.MainThreadKeytar);if(g.appRoot){let i=g.appRoot.fsPath;o.platform==="win32"&&(i=i.replace(/\\/g,"/")),i[i.length-1]==="/"&&(i=i.substr(0,i.length-1)),this.alternativeNames=new Set,this.alternativeNames.add(`${i}/node_modules.asar/keytar`),this.alternativeNames.add(`${i}/node_modules/keytar`)}this._impl={getPassword:(i,s)=>t.$getPassword(i,s),setPassword:(i,s,r)=>t.$setPassword(i,s,r),deletePassword:(i,s)=>t.$deletePassword(i,s),findPassword:i=>t.$findPassword(i),findCredentials(i){return t.$findCredentials(i)}}}load(u,f){return this._impl}alternativeModuleName(u){const f=u.length;if(f<=7||!this.alternativeNames)return;const g=f-7;if((u.charAt(g)==="/"||u.charAt(g)==="\\")&&u.endsWith("keytar")&&(u=u.replace(/\\/g,"/"),this.alternativeNames.has(u)))return"keytar"}};b=He([ze(0,_.IExtHostRpcService),ze(1,C.IExtHostInitDataService)],b);let p=class{constructor(u,f,g){this._extensionPaths=u,this._appUriScheme=f,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=g.getProxy(S.MainContext.MainThreadTelemetry);const t=g.getProxy(S.MainContext.MainThreadWindow);this._impl=(i,s)=>{const r=T.URI.parse(i);return s?this.callOriginal(i,s):r.scheme==="http"||r.scheme==="https"?t.$openUri(r,i,{allowTunneling:!0}):r.scheme==="mailto"||r.scheme===this._appUriScheme?t.$openUri(r,i,{}):this.callOriginal(i,s)}}load(u,f,g){const t=this._extensionPaths.findSubstr(f.fsPath);return t&&(this._extensionId=t.identifier.value,this.sendShimmingTelemetry()),this._original=g(u),this._impl}callOriginal(u,f){return this.sendNoForwardTelemetry(),this._original(u,f)}sendShimmingTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};p=He([ze(2,_.IExtHostRpcService)],p)}),define(_e[215],Ee([0,1,12,11,75,7,2,4,207,15,57,60,28,146,13,66,33,37]),function(Z,e,m,T,S,y,k,D,_,C,n,I,o,h,d,c,b,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class w{constructor(f,g,t,i){this._disposables=new y.DisposableStore,this._isTerminating=!1,this._hostUtils=t,this._rpcProtocol=new _.RPCProtocol(f,null,i),g=w._transform(g,this._rpcProtocol);const s=new I.ServiceCollection(...n.getSingletonServiceDescriptors());s.set(o.IExtHostInitDataService,Object.assign({_serviceBrand:void 0},g)),s.set(d.IExtHostRpcService,new d.ExtHostRpcService(this._rpcProtocol)),s.set(c.IURITransformerService,new c.URITransformerService(i)),s.set(b.IHostUtils,t);const r=new h.InstantiationService(s,!0),l=r.invokeFunction(P=>P.get(p.IExtHostTerminalService));this._disposables.add(l),this._logService=r.invokeFunction(P=>P.get(C.ILogService)),S.mark("code/extHost/didCreateServices"),this._logService.info("extension host started"),this._logService.trace("initData",g),this._extensionService=r.invokeFunction(P=>P.get(b.IExtHostExtensionService)),this._extensionService.initialize(),Error.stackTraceLimit=100;const E=new WeakMap;this._extensionService.getExtensionPathIndex().then(P=>{Error.prepareStackTrace=(a,F)=>{let N="",W,le;for(const fe of F)N+=`
	at ${fe.toString()}`,le=fe.getFileName(),!W&&le&&(W=P.findSubstr(le));return E.set(a,W),`${a.name||"Error"}: ${a.message||""}${N}`}});const v=this._rpcProtocol.getProxy(D.MainContext.MainThreadExtensionService),A=this._rpcProtocol.getProxy(D.MainContext.MainThreadErrors);T.setUnexpectedErrorHandler(P=>{const a=T.transformErrorForSerialization(P),F=E.get(P);F?v.$onExtensionRuntimeError(F.identifier,a):A.$onUnexpectedError(a)})}terminate(f){if(this._isTerminating)return;this._isTerminating=!0,this._logService.info(`extension host terminating: ${f}`),this._logService.flush(),this._disposables.dispose(),T.setUnexpectedErrorHandler(t=>{this._logService.error(t)}),this._rpcProtocol.dispose();const g=this._extensionService.deactivateAll();setTimeout(()=>{Promise.race([m.timeout(4e3),g]).finally(()=>{this._logService.info("exiting with code 0"),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(0)})},1e3)}static _transform(f,g){f.extensions.forEach(i=>i.extensionLocation=k.URI.revive(g.transformIncomingURIs(i.extensionLocation))),f.environment.appRoot=k.URI.revive(g.transformIncomingURIs(f.environment.appRoot));const t=f.environment.extensionDevelopmentLocationURI;return t&&(f.environment.extensionDevelopmentLocationURI=t.map(i=>k.URI.revive(g.transformIncomingURIs(i)))),f.environment.extensionTestsLocationURI=k.URI.revive(g.transformIncomingURIs(f.environment.extensionTestsLocationURI)),f.environment.globalStorageHome=k.URI.revive(g.transformIncomingURIs(f.environment.globalStorageHome)),f.environment.workspaceStorageHome=k.URI.revive(g.transformIncomingURIs(f.environment.workspaceStorageHome)),f.logsLocation=k.URI.revive(g.transformIncomingURIs(f.logsLocation)),f.logFile=k.URI.revive(g.transformIncomingURIs(f.logFile)),f.workspace=g.transformIncomingURIs(f.workspace),f}}e.ExtensionHostMain=w}),define(_e[216],Ee([0,1,14,18,56,27,25,52,38]),function(Z,e,m,T,S,y,k,D,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class C{constructor(o,h,d){this.config=o,this.provider=h,this.sessionToken=d,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=o.filePattern,this.includePattern=o.includePattern&&y.parse(o.includePattern),this.maxResults=o.maxResults||void 0,this.exists=o.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=o.excludePattern&&y.parse(o.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(o=>o.cancel()),this.activeCancellationTokens=new Set}search(o){const h=this.config.folderQueries||[];return new Promise((d,c)=>{const b=p=>{this.resultCount++,o(p)};if(this.isCanceled)return d({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(p=>{const w=p.toString(),u=m.basename(w);this.globalExcludePattern&&this.globalExcludePattern(w,u)||this.matchFile(b,{base:p,basename:u})}),Promise.all(h.map(p=>this.searchInFolder(p,b))).then(p=>{d({limitHit:this.isLimitHit,stats:p[0]||void 0})},p=>{c(new Error(S.toErrorMessage(p)))})})}async searchInFolder(o,h){const d=new T.CancellationTokenSource,c=this.getSearchOptionsForFolder(o),b=this.initDirectoryTree(),p=new _.QueryGlobTester(this.config,o),w=!p.hasSiblingExcludeClauses();let u;try{this.activeCancellationTokens.add(d),u=D.StopWatch.create();const f=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},c,d.token),g=u.elapsed(),t=D.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(f&&f.forEach(i=>{const s=m.posix.relative(o.folder.path,i.path);if(w){const r=m.basename(i.path);this.matchFile(h,{base:o.folder,relativePath:s,basename:r});return}this.addDirectoryEntries(b,o.folder,s,h)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(b,p,h),{providerTime:g,postProcessTime:t.elapsed()})}finally{d.dispose(),this.activeCancellationTokens.delete(d)}}getSearchOptionsForFolder(o){const h=_.resolvePatternsForProvider(this.config.includePattern,o.includePattern),d=_.resolvePatternsForProvider(this.config.excludePattern,o.excludePattern);return{folder:o.folder,excludes:d,includes:h,useIgnoreFiles:!o.disregardIgnoreFiles,useGlobalIgnoreFiles:!o.disregardGlobalIgnoreFiles,followSymlinks:!o.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const o={rootEntries:[],pathToEntries:Object.create(null)};return o.pathToEntries["."]=o.rootEntries,o}addDirectoryEntries({pathToEntries:o},h,d,c){if(d===this.filePattern){const p=m.basename(this.filePattern);this.matchFile(c,{base:h,relativePath:this.filePattern,basename:p})}function b(p){const w=m.basename(p),u=m.dirname(p);let f=o[u];f||(f=o[u]=[],b(u)),f.push({base:h,relativePath:p,basename:w})}b(d)}matchDirectoryTree({rootEntries:o,pathToEntries:h},d,c){const b=this,p=this.filePattern;function w(u){const f=y.hasSiblingFn(()=>u.map(g=>g.basename));for(let g=0,t=u.length;g<t;g++){const i=u[g],{relativePath:s,basename:r}=i;if(!d.includedInQuerySync(s,r,p!==r?f:void 0))continue;const l=h[s];if(l)w(l);else{if(s===p)continue;b.matchFile(c,i)}if(b.isLimitHit)break}}w(o)}matchFile(o,h){(!this.includePattern||h.relativePath&&this.includePattern(h.relativePath,h.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||o(h))}}class n{constructor(){this.sessions=new Map}fileSearch(o,h,d,c){const b=this.getSessionTokenSource(o.cacheKey),p=new C(o,h,b&&b.token);let w=0;const u=f=>{w+=f.length,d(f.map(g=>this.rawMatchToSearchItem(g)))};return this.doSearch(p,n.BATCH_SIZE,u,c).then(f=>({limitHit:f.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:w,detailStats:f.stats}}))}clearCache(o){const h=this.getSessionTokenSource(o);h&&h.cancel()}getSessionTokenSource(o){if(!!o)return this.sessions.has(o)||this.sessions.set(o,new T.CancellationTokenSource),this.sessions.get(o)}rawMatchToSearchItem(o){return o.relativePath?{resource:k.joinPath(o.base,o.relativePath)}:{resource:o.base}}doSearch(o,h,d,c){c.onCancellationRequested(()=>{o.cancel()});const b=w=>{w&&(p.push(w),h>0&&p.length>=h&&(d(p),p=[]))};let p=[];return o.search(b).then(w=>(p.length&&d(p),w),w=>(p.length&&d(p),Promise.reject(w)))}}e.FileSearchManager=n,n.BATCH_SIZE=512}),define(_e[217],Ee([0,1,14,17,18,56,25,27,2,38,16,10]),function(Z,e,m,T,S,y,k,D,_,C,n,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class o{constructor(u,f,g){this.query=u,this.provider=f,this.fileUtils=g,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(u,f){const g=this.query.folderQueries||[],t=new S.CancellationTokenSource;return f.onCancellationRequested(()=>t.cancel()),new Promise((i,s)=>{this.collector=new d(u);let r=!1;const l=(E,v)=>{if(!r&&!this.isLimitHit){const A=this.resultSize(E);b(E)&&typeof this.query.maxResults=="number"&&this.resultCount+A>this.query.maxResults&&(this.isLimitHit=!0,r=!0,t.cancel(),E=this.trimResultToSize(E,this.query.maxResults-this.resultCount));const P=this.resultSize(E);this.resultCount+=P,(P>0||!b(E))&&this.collector.add(E,v)}};Promise.all(g.map((E,v)=>this.searchInFolder(E,A=>l(A,v),t.token))).then(E=>{t.dispose(),this.collector.flush();const v=E.some(A=>!!A&&!!A.limitHit);i({limitHit:this.isLimitHit||v,messages:T.flatten(E.map(A=>(A==null?void 0:A.message)?I.isArray(A.message)?A.message:[A.message]:[])),stats:{type:"textSearchProvider"}})},E=>{t.dispose();const v=y.toErrorMessage(E);s(new Error(v))})})}resultSize(u){return b(u)?Array.isArray(u.ranges)?u.ranges.length:1:0}trimResultToSize(u,f){const g=Array.isArray(u.ranges)?u.ranges:[u.ranges],t=Array.isArray(u.preview.matches)?u.preview.matches:[u.preview.matches];return{ranges:g.slice(0,f),preview:{matches:t.slice(0,f),text:u.preview.text},uri:u.uri}}async searchInFolder(u,f,g){const t=new C.QueryGlobTester(this.query,u),i=[],s={report:E=>{if(!this.validateProviderResult(E))return;const v=u.folder.scheme===n.Schemas.file?D.hasSiblingPromiseFn(()=>this.fileUtils.readdir(k.dirname(E.uri))):void 0,A=k.relativePath(u.folder,E.uri);A&&i.push(t.includedInQuery(A,m.basename(A),v).then(P=>{P&&f(E)}))}},r=this.getSearchOptionsForFolder(u),l=await this.provider.provideTextSearchResults(h(this.query.contentPattern),r,s,g);return await Promise.all(i),l}validateProviderResult(u){if(b(u)){if(Array.isArray(u.ranges)){if(!Array.isArray(u.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(u.preview.matches.length!==u.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(u.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(u){const f=C.resolvePatternsForProvider(this.query.includePattern,u.includePattern),g=C.resolvePatternsForProvider(this.query.excludePattern,u.excludePattern),t={folder:_.URI.from(u.folder),excludes:g,includes:f,useIgnoreFiles:!u.disregardIgnoreFiles,useGlobalIgnoreFiles:!u.disregardGlobalIgnoreFiles,followSymlinks:!u.ignoreSymlinks,encoding:u.fileEncoding&&this.fileUtils.toCanonicalName(u.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return t.usePCRE2=this.query.usePCRE2,t}}e.TextSearchManager=o;function h(w){return{isCaseSensitive:w.isCaseSensitive||!1,isRegExp:w.isRegExp||!1,isWordMatch:w.isWordMatch||!1,isMultiline:w.isMultiline||!1,pattern:w.pattern}}class d{constructor(u){this._onResult=u,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new p(512,f=>this.sendItems(f))}add(u,f){this._currentFileMatch&&(this._currentFolderIdx!==f||!k.isEqual(this._currentUri,u.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=f,this._currentFileMatch={resource:u.uri,results:[]}),this._currentFileMatch.results.push(c(u))}pushToCollector(){const u=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,u)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(u){this._onResult(u)}}e.TextSearchResultsCollector=d;function c(w){return b(w)?{preview:{matches:T.mapArrayOrNot(w.preview.matches,u=>({startLineNumber:u.start.line,startColumn:u.start.character,endLineNumber:u.end.line,endColumn:u.end.character})),text:w.preview.text},ranges:T.mapArrayOrNot(w.ranges,u=>({startLineNumber:u.start.line,startColumn:u.start.character,endLineNumber:u.end.line,endColumn:u.end.character}))}:{text:w.text,lineNumber:w.lineNumber}}function b(w){return!!w.preview}e.extensionResultIsMatch=b;class p{constructor(u,f){this.maxBatchSize=u,this.cb=f,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(u,f){!u||this.addItemToBatch(u,f)}addItems(u,f){!u||this.addItemsToBatch(u,f)}addItemToBatch(u,f){this.batch.push(u),this.batchSize+=f,this.onUpdate()}addItemsToBatch(u,f){this.batch=this.batch.concat(u),this.batchSize+=f,this.onUpdate()}onUpdate(){this.totalNumberCompleted<p.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},p.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=p,p.TIMEOUT=4e3,p.START_BATCH_AFTER_COUNT=50}),define(_e[106],Ee([0,1,7,4,5,216,13,66,15,2,217]),function(Z,e,m,T,S,y,k,D,_,C,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=S.createDecorator("IExtHostSearch");let I=class{constructor(c,b,p){this.extHostRpc=c,this._uriTransformer=b,this._logService=p,this._proxy=this.extHostRpc.getProxy(T.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new y.FileSearchManager}_transformScheme(c){return this._uriTransformer.transformOutgoingScheme(c)}registerTextSearchProvider(c,b){if(this._textSearchUsedSchemes.has(c))throw new Error(`a text search provider for the scheme '${c}' is already registered`);this._textSearchUsedSchemes.add(c);const p=this._handlePool++;return this._textSearchProvider.set(p,b),this._proxy.$registerTextSearchProvider(p,this._transformScheme(c)),m.toDisposable(()=>{this._textSearchUsedSchemes.delete(c),this._textSearchProvider.delete(p),this._proxy.$unregisterProvider(p)})}registerFileSearchProvider(c,b){if(this._fileSearchUsedSchemes.has(c))throw new Error(`a file search provider for the scheme '${c}' is already registered`);this._fileSearchUsedSchemes.add(c);const p=this._handlePool++;return this._fileSearchProvider.set(p,b),this._proxy.$registerFileSearchProvider(p,this._transformScheme(c)),m.toDisposable(()=>{this._fileSearchUsedSchemes.delete(c),this._fileSearchProvider.delete(p),this._proxy.$unregisterProvider(p)})}$provideFileSearchResults(c,b,p,w){const u=o(p),f=this._fileSearchProvider.get(c);if(f)return this._fileSearchManager.fileSearch(u,f,g=>{this._proxy.$handleFileMatch(c,b,g.map(t=>t.resource))},w);throw new Error("unknown provider: "+c)}$clearCache(c){return this._fileSearchManager.clearCache(c),Promise.resolve(void 0)}$provideTextSearchResults(c,b,p,w){const u=this._textSearchProvider.get(c);if(!u||!u.provideTextSearchResults)throw new Error(`Unknown provider ${c}`);const f=o(p);return this.createTextSearchManager(f,u).search(t=>this._proxy.$handleTextMatch(c,b,t),w)}createTextSearchManager(c,b){return new n.TextSearchManager(c,b,{readdir:p=>Promise.resolve([]),toCanonicalName:p=>p})}};I=He([ze(0,k.IExtHostRpcService),ze(1,D.IURITransformerService),ze(2,_.ILogService)],I),e.ExtHostSearch=I;function o(d){return Object.assign(Object.assign({},d),{folderQueries:d.folderQueries&&d.folderQueries.map(h),extraFileResources:d.extraFileResources&&d.extraFileResources.map(c=>C.URI.revive(c))})}e.reviveQuery=o;function h(d){return Object.assign(Object.assign({},d),{folder:C.URI.revive(d.folder)})}}),define(_e[218],Ee([0,1,18,11,3,41,2,123,84,117,55,59,4,181,180,71,182,32,183,184,185,167,186,36,33,187,168,189,190,191,101,170,196,197,198,73,37,199,171,9,6,202,46,102,30,29,76,159,188,93,100,104,105,106,15,66,13,28,192,157,65,70,178,200,156,74,72,205,203,204,179,45,211,201,69,63,94,194,103,195,16,148,193,154]),function(Z,e,m,T,S,y,k,D,_,C,n,I,o,h,d,c,b,p,w,u,f,g,t,i,s,r,l,E,v,A,P,a,F,N,W,le,fe,Y,H,J,R,B,M,x,q,z,oe,pe,Te,Be,Fe,We,Qe,Ge,Ke,$,Q,te,re,G,se,he,Ae,xe,ve,je,V,ee,me,Re,Le,qe,Se,we,Ce,ie,ce,O,K,ae,ke,Pe,Oe,$e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function Ze(Je){const Ye=Je.get(te.IExtHostInitDataService),nt=Je.get(qe.IExtHostFileSystemInfo),pt=Je.get(V.IExtHostConsumerFileSystem),be=Je.get(s.IExtHostExtensionService),ye=Je.get(q.IExtHostWorkspace),ue=Je.get(ce.IExtHostTelemetry),j=Je.get(p.IExtHostConfiguration),Ne=Je.get($.IURITransformerService),ge=Je.get(Q.IExtHostRpcService),Xe=Je.get(le.IExtHostStorage),et=Je.get(je.IExtensionStoragePaths),rt=Je.get(Ke.ILogService),st=Je.get(se.IExtHostTunnelService),vt=Je.get(he.IExtHostApiDeprecationService),ft=Je.get(x.IExtHostWindow),_t=Je.get(Ce.IExtHostSecretState),wt=Je.get(ie.IExtHostEditorTabs);ge.set(o.ExtHostContext.ExtHostFileSystemInfo,nt),ge.set(o.ExtHostContext.ExtHostLogService,rt),ge.set(o.ExtHostContext.ExtHostWorkspace,ye),ge.set(o.ExtHostContext.ExtHostConfiguration,j),ge.set(o.ExtHostContext.ExtHostExtensionService,be),ge.set(o.ExtHostContext.ExtHostStorage,Xe),ge.set(o.ExtHostContext.ExtHostTunnelService,st),ge.set(o.ExtHostContext.ExtHostWindow,ft),ge.set(o.ExtHostContext.ExtHostSecretState,_t),ge.set(o.ExtHostContext.ExtHostTelemetry,ue),ge.set(o.ExtHostContext.ExtHostEditorTabs,wt);const Rt=ge.set(o.ExtHostContext.ExtHostDecorations,Je.get(Fe.IExtHostDecorations)),bt=ge.set(o.ExtHostContext.ExtHostDocumentsAndEditors,Je.get(i.IExtHostDocumentsAndEditors)),ct=ge.set(o.ExtHostContext.ExtHostCommands,Je.get(c.IExtHostCommands)),mt=ge.set(o.ExtHostContext.ExtHostTerminalService,Je.get(fe.IExtHostTerminalService)),dt=ge.set(o.ExtHostContext.ExtHostDebugService,Je.get(Qe.IExtHostDebugService)),It=ge.set(o.ExtHostContext.ExtHostSearch,Je.get(Ge.IExtHostSearch)),Dt=ge.set(o.ExtHostContext.ExtHostTask,Je.get(We.IExtHostTask)),Ft=ge.set(o.ExtHostContext.ExtHostOutputService,Je.get(P.IExtHostOutputService)),qt=ge.set(o.ExtHostContext.ExtHostUrls,new B.ExtHostUrls(ge)),Et=ge.set(o.ExtHostContext.ExtHostDocuments,new t.ExtHostDocuments(ge,bt)),Yt=ge.set(o.ExtHostContext.ExtHostDocumentContentProviders,new f.ExtHostDocumentContentProvider(ge,bt,rt)),Jt=ge.set(o.ExtHostContext.ExtHostDocumentSaveParticipant,new g.ExtHostDocumentSaveParticipant(rt,Et,ge.getProxy(o.MainContext.MainThreadBulkEdits))),gt=ge.set(o.ExtHostContext.ExtHostNotebook,new re.ExtHostNotebookController(ge,ct,bt,Et,et)),Gt=ge.set(o.ExtHostContext.ExtHostNotebookDocuments,new $e.ExtHostNotebookDocuments(rt,gt)),Xt=ge.set(o.ExtHostContext.ExtHostNotebookEditors,new Oe.ExtHostNotebookEditors(rt,ge,gt)),Zt=ge.set(o.ExtHostContext.ExtHostNotebookKernels,new O.ExtHostNotebookKernels(ge,Ye,gt,rt)),en=ge.set(o.ExtHostContext.ExtHostNotebookRenderers,new ae.ExtHostNotebookRenderers(ge,gt)),St=ge.set(o.ExtHostContext.ExtHostEditors,new Y.ExtHostEditors(ge,bt)),Kt=ge.set(o.ExtHostContext.ExtHostTreeViews,new H.ExtHostTreeViews(ge.getProxy(o.MainContext.MainThreadTreeViews),ct,rt)),En=ge.set(o.ExtHostContext.ExtHostEditorInsets,new pe.ExtHostEditorInsets(ge.getProxy(o.MainContext.MainThreadEditorInsets),St,Ye)),Ut=ge.set(o.ExtHostContext.ExtHostDiagnostics,new w.ExtHostDiagnostics(ge,rt)),lt=ge.set(o.ExtHostContext.ExtHostLanguageFeatures,new E.ExtHostLanguageFeatures(ge,Ne,Et,ct,Ut,rt,vt)),yn=ge.set(o.ExtHostContext.ExtHostFileSystem,new r.ExtHostFileSystem(ge,lt)),Mt=ge.set(o.ExtHostContext.ExtHostFileSystemEventService,new l.ExtHostFileSystemEventService(ge,rt,bt)),Wt=ge.set(o.ExtHostContext.ExtHostQuickOpen,F.createExtHostQuickOpen(ge,ye,ct)),hn=ge.set(o.ExtHostContext.ExtHostSCM,new N.ExtHostSCM(ge,ct,rt)),Sn=ge.set(o.ExtHostContext.ExtHostComments,new b.ExtHostComments(ge,ct,Et)),Qt=ge.set(o.ExtHostContext.ExtHostProgress,new a.ExtHostProgress(ge.getProxy(o.MainContext.MainThreadProgress))),tn=ge.set(o.ExtHostContext.ExtHosLabelService,new Te.ExtHostLabelService(ge)),fn=ge.set(o.ExtHostContext.ExtHostTheming,new G.ExtHostTheming(ge)),xt=ge.set(o.ExtHostContext.ExtHostAuthentication,new Ae.ExtHostAuthentication(ge)),Dn=ge.set(o.ExtHostContext.ExtHostTimeline,new xe.ExtHostTimeline(ge,ct)),nn=ge.set(o.ExtHostContext.ExtHostWebviews,new M.ExtHostWebviews(ge,{remote:Ye.remote},ye,rt,vt)),Bt=ge.set(o.ExtHostContext.ExtHostWebviewPanels,new Re.ExtHostWebviewPanels(ge,nn,ye)),Cn=ge.set(o.ExtHostContext.ExtHostCustomEditors,new me.ExtHostCustomEditors(ge,Et,et,nn,Bt)),kn=ge.set(o.ExtHostContext.ExtHostWebviewViews,new ee.ExtHostWebviewViews(ge,nn)),Pt=ge.set(o.ExtHostContext.ExtHostTesting,new Se.ExtHostTesting(ge,bt,ye)),In=ge.set(o.ExtHostContext.ExtHostUriOpeners,new we.ExtHostUriOpeners(ge)),Ht=oe.values(o.ExtHostContext);ge.assertRegistered(Ht);const Lt=new Le.ExtHostBulkEdits(ge,bt),Pn=new d.ExtHostClipboard(ge),kt=new A.ExtHostMessageService(ge,rt),zt=new u.ExtHostDialogs(ge),mn=new W.ExtHostStatusBar(ge,ct.converter),rn=new v.ExtHostLanguages(ge,Et);return h.ExtHostApiCommands.register(ct),function(Me,sn,gn){const ht=function(){let X=!Me.isUnderDevelopment;function de(Ie){X||(rt.info(`Extension '${Me.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),X=!0)}return function Ie(ot){if(Array.isArray(ot))ot.forEach(Ie);else if(typeof ot=="string")de(ot);else{const U=ot;typeof U.scheme=="undefined"&&de(ot),!Me.enableProposedApi&&typeof U.exclusive=="boolean"&&z.throwProposedApiError(Me)}return ot}}(),An={getSession(X,de,Ie){return xt.getSession(Me,X,de,Ie)},get onDidChangeSessions(){return xt.onDidChangeSessions},registerAuthenticationProvider(X,de,Ie,ot){return xt.registerAuthenticationProvider(X,de,Ie,ot)},get onDidChangeAuthenticationProviders(){return z.checkProposedApiEnabled(Me),xt.onDidChangeAuthenticationProviders},get providers(){return z.checkProposedApiEnabled(Me),xt.providers},logout(X,de){return z.checkProposedApiEnabled(Me),xt.removeSession(X,de)}},on={registerCommand(X,de,Ie){return ct.registerCommand(!0,X,de,Ie)},registerTextEditorCommand(X,de,Ie){return ct.registerCommand(!0,X,(...ot)=>{const U=St.getActiveTextEditor();if(!U){rt.warn("Cannot execute "+X+" because there is no active text editor.");return}return U.edit(L=>{de.apply(Ie,[U,L,...ot])}).then(L=>{L||rt.warn("Edits from command "+X+" were not applied.")},L=>{rt.warn("An error occurred while running command "+X,L)})})},registerDiffInformationCommand:(X,de,Ie)=>(z.checkProposedApiEnabled(Me),ct.registerCommand(!0,X,async(...ot)=>{const U=bt.activeEditor(!0);if(!U){rt.warn("Cannot execute "+X+" because there is no active text editor.");return}const L=await St.getDiffInformation(U.id);de.apply(Ie,[L,...ot])})),executeCommand(X,...de){return ct.executeCommand(X,...de)},getCommands(X=!1){return ct.getCommands(X)}},pn={get machineId(){return Ye.telemetryInfo.machineId},get sessionId(){return Ye.telemetryInfo.sessionId},get language(){return Ye.environment.appLanguage},get appName(){return Ye.environment.appName},get appRoot(){var X,de;return(de=(X=Ye.environment.appRoot)===null||X===void 0?void 0:X.fsPath)!==null&&de!==void 0?de:""},get uriScheme(){return Ye.environment.appUriScheme},get clipboard(){return Pn.value},get shell(){return mt.getDefaultShell(!1)},get isTelemetryEnabled(){return ue.getTelemetryEnabled()},get onDidChangeTelemetryEnabled(){return ue.onDidChangeTelemetryEnabled},get isNewAppInstall(){const X=Date.now()-new Date(Ye.telemetryInfo.firstSessionDate).getTime();return isNaN(X)?!1:X<1e3*60*60*24},openExternal(X,de){return ft.openUri(X,{allowTunneling:!!Ye.remote.authority,allowContributedOpeners:de==null?void 0:de.allowContributedOpeners})},async asExternalUri(X){if(X.scheme===Ye.environment.appUriScheme)return qt.createAppUri(X);const de=Pe.matchesScheme(X,ke.Schemas.http)||Pe.matchesScheme(X,ke.Schemas.https);de||z.checkProposedApiEnabled(Me);try{return await ft.asExternalUri(X,{allowTunneling:!!Ye.remote.authority})}catch(Ie){if(de)return X;throw Ie}},get remoteName(){return Be.getRemoteName(Ye.remote.authority)},get uiKind(){return Ye.uiKind}};Ye.environment.extensionTestsLocationURI||Object.freeze(pn);const vn=Ye.remote.isRemote?R.ExtensionKind.Workspace:R.ExtensionKind.UI,an={registerTestController(X){return z.checkProposedApiEnabled(Me),Pt.registerTestController(Me.identifier.value,X)},createDocumentTestObserver(X){return z.checkProposedApiEnabled(Me),Pt.createTextDocumentTestObserver(X)},createWorkspaceTestObserver(X){return z.checkProposedApiEnabled(Me),Pt.createWorkspaceTestObserver(X)},runTests(X){return z.checkProposedApiEnabled(Me),Pt.runTests(X)},createTestItem(X,de){return new R.TestItemImpl(X.id,X.label,X.uri,de)},createTestRun(X,de,Ie){return z.checkProposedApiEnabled(Me),Pt.createTestRun(Me.identifier.value,X,de,Ie)},get onDidChangeTestResults(){return z.checkProposedApiEnabled(Me),Pt.onResultsChanged},get testResults(){return z.checkProposedApiEnabled(Me),Pt.results}};an.createTestRunTask=an.createTestRun;const Tn={getExtension(X){const de=sn.getExtensionDescription(X);if(de)return new s.Extension(be,Me.identifier,de,vn)},get all(){return sn.getAllExtensionDescriptions().map(X=>new s.Extension(be,Me.identifier,X,vn))},get onDidChange(){return sn.onDidChange}},Rn={createDiagnosticCollection(X){return Ut.createDiagnosticCollection(Me.identifier,X)},get onDidChangeDiagnostics(){return Ut.onDidChangeDiagnostics},getDiagnostics:X=>Ut.getDiagnostics(X),getLanguages(){return rn.getLanguages()},setTextDocumentLanguage(X,de){return rn.changeLanguage(X.uri,de)},match(X,de){return n.score(J.LanguageSelector.from(X),de.uri,de.languageId,!0)},registerCodeActionsProvider(X,de,Ie){return lt.registerCodeActionProvider(Me,ht(X),de,Ie)},registerCodeLensProvider(X,de){return lt.registerCodeLensProvider(Me,ht(X),de)},registerDefinitionProvider(X,de){return lt.registerDefinitionProvider(Me,ht(X),de)},registerDeclarationProvider(X,de){return lt.registerDeclarationProvider(Me,ht(X),de)},registerImplementationProvider(X,de){return lt.registerImplementationProvider(Me,ht(X),de)},registerTypeDefinitionProvider(X,de){return lt.registerTypeDefinitionProvider(Me,ht(X),de)},registerHoverProvider(X,de){return lt.registerHoverProvider(Me,ht(X),de,Me.identifier)},registerEvaluatableExpressionProvider(X,de){return lt.registerEvaluatableExpressionProvider(Me,ht(X),de,Me.identifier)},registerInlineValuesProvider(X,de){return lt.registerInlineValuesProvider(Me,ht(X),de,Me.identifier)},registerDocumentHighlightProvider(X,de){return lt.registerDocumentHighlightProvider(Me,ht(X),de)},registerLinkedEditingRangeProvider(X,de){return lt.registerLinkedEditingRangeProvider(Me,ht(X),de)},registerReferenceProvider(X,de){return lt.registerReferenceProvider(Me,ht(X),de)},registerRenameProvider(X,de){return lt.registerRenameProvider(Me,ht(X),de)},registerDocumentSymbolProvider(X,de,Ie){return lt.registerDocumentSymbolProvider(Me,ht(X),de,Ie)},registerWorkspaceSymbolProvider(X){return lt.registerWorkspaceSymbolProvider(Me,X)},registerDocumentFormattingEditProvider(X,de){return lt.registerDocumentFormattingEditProvider(Me,ht(X),de)},registerDocumentRangeFormattingEditProvider(X,de){return lt.registerDocumentRangeFormattingEditProvider(Me,ht(X),de)},registerOnTypeFormattingEditProvider(X,de,Ie,...ot){return lt.registerOnTypeFormattingEditProvider(Me,ht(X),de,[Ie].concat(ot))},registerDocumentSemanticTokensProvider(X,de,Ie){return lt.registerDocumentSemanticTokensProvider(Me,ht(X),de,Ie)},registerDocumentRangeSemanticTokensProvider(X,de,Ie){return lt.registerDocumentRangeSemanticTokensProvider(Me,ht(X),de,Ie)},registerSignatureHelpProvider(X,de,Ie,...ot){return typeof Ie=="object"?lt.registerSignatureHelpProvider(Me,ht(X),de,Ie):lt.registerSignatureHelpProvider(Me,ht(X),de,typeof Ie=="undefined"?[]:[Ie,...ot])},registerCompletionItemProvider(X,de,...Ie){return lt.registerCompletionItemProvider(Me,ht(X),de,Ie)},registerInlineCompletionItemProvider(X,de){return z.checkProposedApiEnabled(Me),lt.registerInlineCompletionsProvider(Me,ht(X),de)},registerDocumentLinkProvider(X,de){return lt.registerDocumentLinkProvider(Me,ht(X),de)},registerColorProvider(X,de){return lt.registerColorProvider(Me,ht(X),de)},registerFoldingRangeProvider(X,de){return lt.registerFoldingRangeProvider(Me,ht(X),de)},registerSelectionRangeProvider(X,de){return lt.registerSelectionRangeProvider(Me,X,de)},registerCallHierarchyProvider(X,de){return lt.registerCallHierarchyProvider(Me,X,de)},setLanguageConfiguration:(X,de)=>lt.setLanguageConfiguration(Me,X,de),getTokenInformationAtPosition(X,de){return z.checkProposedApiEnabled(Me),rn.tokenAtPosition(X,de)},registerInlayHintsProvider(X,de){return z.checkProposedApiEnabled(Me),lt.registerInlayHintsProvider(Me,X,de)}},Fn={get activeTextEditor(){return St.getActiveTextEditor()},get visibleTextEditors(){return St.getVisibleTextEditors()},get activeTerminal(){return mt.activeTerminal},get terminals(){return mt.terminals},async showTextDocument(X,de,Ie){const ot=await(k.URI.isUri(X)?Promise.resolve(ln.openTextDocument(X)):Promise.resolve(X));return St.showTextDocument(ot,de,Ie)},createTextEditorDecorationType(X){return St.createTextEditorDecorationType(Me,X)},onDidChangeActiveTextEditor(X,de,Ie){return St.onDidChangeActiveTextEditor(X,de,Ie)},onDidChangeVisibleTextEditors(X,de,Ie){return St.onDidChangeVisibleTextEditors(X,de,Ie)},onDidChangeTextEditorSelection(X,de,Ie){return St.onDidChangeTextEditorSelection(X,de,Ie)},onDidChangeTextEditorOptions(X,de,Ie){return St.onDidChangeTextEditorOptions(X,de,Ie)},onDidChangeTextEditorVisibleRanges(X,de,Ie){return St.onDidChangeTextEditorVisibleRanges(X,de,Ie)},onDidChangeTextEditorViewColumn(X,de,Ie){return St.onDidChangeTextEditorViewColumn(X,de,Ie)},onDidCloseTerminal(X,de,Ie){return mt.onDidCloseTerminal(X,de,Ie)},onDidOpenTerminal(X,de,Ie){return mt.onDidOpenTerminal(X,de,Ie)},onDidChangeActiveTerminal(X,de,Ie){return mt.onDidChangeActiveTerminal(X,de,Ie)},onDidChangeTerminalDimensions(X,de,Ie){return z.checkProposedApiEnabled(Me),mt.onDidChangeTerminalDimensions(X,de,Ie)},onDidWriteTerminalData(X,de,Ie){return z.checkProposedApiEnabled(Me),mt.onDidWriteTerminalData(X,de,Ie)},get state(){return ft.state},onDidChangeWindowState(X,de,Ie){return ft.onDidChangeWindowState(X,de,Ie)},showInformationMessage(X,...de){return kt.showMessage(Me,y.default.Info,X,de[0],de.slice(1))},showWarningMessage(X,...de){return kt.showMessage(Me,y.default.Warning,X,de[0],de.slice(1))},showErrorMessage(X,...de){return kt.showMessage(Me,y.default.Error,X,de[0],de.slice(1))},showQuickPick(X,de,Ie){return Wt.showQuickPick(X,!!Me.enableProposedApi,de,Ie)},showWorkspaceFolderPick(X){return Wt.showWorkspaceFolderPick(X)},showInputBox(X,de){return Wt.showInput(X,de)},showOpenDialog(X){return zt.showOpenDialog(X)},showSaveDialog(X){return zt.showSaveDialog(X)},createStatusBarItem(X,de,Ie){let ot,U,L;return typeof X=="string"?(ot=X,U=de,L=Ie):(U=X,L=de),mn.createStatusBarEntry(Me,ot,U,L)},setStatusBarMessage(X,de){return mn.setStatusBarMessage(X,de)},withScmProgress(X){return vt.report("window.withScmProgress",Me,"Use 'withProgress' instead."),Qt.withProgress(Me,{location:R.ProgressLocation.SourceControl},(de,Ie)=>X({report(ot){}}))},withProgress(X,de){return Qt.withProgress(Me,X,de)},createOutputChannel(X){return Ft.createOutputChannel(X)},createWebviewPanel(X,de,Ie,ot){return Bt.createWebviewPanel(Me,X,de,Ie,ot)},createWebviewTextEditorInset(X,de,Ie,ot){return z.checkProposedApiEnabled(Me),En.createWebviewEditorInset(X,de,Ie,ot,Me)},createTerminal(X,de,Ie){return typeof X=="object"?"pty"in X?mt.createExtensionTerminal(X):(X.iconPath&&z.checkProposedApiEnabled(Me),mt.createTerminalFromOptions(X)):mt.createTerminal(X,de,Ie)},registerTerminalLinkProvider(X){return mt.registerLinkProvider(X)},registerTerminalProfileProvider(X,de){return mt.registerProfileProvider(X,de)},registerTreeDataProvider(X,de){return Kt.registerTreeDataProvider(X,de,Me)},createTreeView(X,de){return Kt.createTreeView(X,de,Me)},registerWebviewPanelSerializer:(X,de)=>Bt.registerWebviewPanelSerializer(Me,X,de),registerCustomEditorProvider:(X,de,Ie={})=>Cn.registerCustomEditorProvider(Me,X,de,Ie),registerFileDecorationProvider(X){return Rt.registerFileDecorationProvider(X,Me.identifier)},registerUriHandler(X){return qt.registerUriHandler(Me.identifier,X)},createQuickPick(){return Wt.createQuickPick(Me.identifier,!!Me.enableProposedApi)},createInputBox(){return Wt.createInputBox(Me.identifier)},get activeColorTheme(){return fn.activeColorTheme},onDidChangeActiveColorTheme(X,de,Ie){return fn.onDidChangeActiveColorTheme(X,de,Ie)},registerWebviewViewProvider(X,de,Ie){return kn.registerWebviewViewProvider(Me,X,de,Ie==null?void 0:Ie.webviewOptions)},get activeNotebookEditor(){return z.checkProposedApiEnabled(Me),gt.activeNotebookEditor},onDidChangeActiveNotebookEditor(X,de,Ie){return z.checkProposedApiEnabled(Me),gt.onDidChangeActiveNotebookEditor(X,de,Ie)},get visibleNotebookEditors(){return z.checkProposedApiEnabled(Me),gt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return z.checkProposedApiEnabled(Me),gt.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(X,de,Ie){return z.checkProposedApiEnabled(Me),Xt.onDidChangeNotebookEditorSelection(X,de,Ie)},onDidChangeNotebookEditorVisibleRanges(X,de,Ie){return z.checkProposedApiEnabled(Me),Xt.onDidChangeNotebookEditorVisibleRanges(X,de,Ie)},showNotebookDocument(X,de){return z.checkProposedApiEnabled(Me),gt.showNotebookDocument(X,de)},registerExternalUriOpener(X,de,Ie){return z.checkProposedApiEnabled(Me),In.registerExternalUriOpener(Me.identifier,X,de,Ie)},get openEditors(){return z.checkProposedApiEnabled(Me),wt.tabs},get onDidChangeOpenEditors(){return z.checkProposedApiEnabled(Me),wt.onDidChangeTabs},getInlineCompletionItemController(X){return z.checkProposedApiEnabled(Me),E.InlineCompletionController.get(X)}},ln={get rootPath(){return vt.report("workspace.rootPath",Me,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),ye.getPath()},set rootPath(X){throw T.readonly()},getWorkspaceFolder(X){return ye.getWorkspaceFolder(X)},get workspaceFolders(){return ye.getWorkspaceFolders()},get name(){return ye.name},set name(X){throw T.readonly()},get workspaceFile(){return ye.workspaceFile},set workspaceFile(X){throw T.readonly()},updateWorkspaceFolders:(X,de,...Ie)=>ye.updateWorkspaceFolders(Me,X,de||0,...Ie),onDidChangeWorkspaceFolders:function(X,de,Ie){return ye.onDidChangeWorkspace(X,de,Ie)},asRelativePath:(X,de)=>ye.getRelativePath(X,de),findFiles:(X,de,Ie,ot)=>ye.findFiles(J.GlobPattern.from(X),J.GlobPattern.from(de),Ie,Me.identifier,ot),findTextInFiles:(X,de,Ie,ot)=>{let U,L;return typeof de=="object"?(U=de,L=Ie):(U={},L=de,ot=Ie),ye.findTextInFiles(X,U||{},L,Me.identifier,ot)},saveAll:X=>ye.saveAll(X),applyEdit(X){return Lt.applyWorkspaceEdit(X)},createFileSystemWatcher:(X,de,Ie,ot)=>Mt.createFileSystemWatcher(J.GlobPattern.from(X),de,Ie,ot),get textDocuments(){return Et.getAllDocumentData().map(X=>X.document)},set textDocuments(X){throw T.readonly()},openTextDocument(X){let de;const Ie=X;if(typeof X=="string")de=Promise.resolve(k.URI.file(X));else if(k.URI.isUri(X))de=Promise.resolve(X);else if(!Ie||typeof Ie=="object")de=Et.createDocumentData(Ie);else throw new Error("illegal argument - uriOrFileNameOrOptions");return de.then(ot=>Et.ensureDocumentData(ot).then(U=>U.document))},onDidOpenTextDocument:(X,de,Ie)=>Et.onDidAddDocument(X,de,Ie),onDidCloseTextDocument:(X,de,Ie)=>Et.onDidRemoveDocument(X,de,Ie),onDidChangeTextDocument:(X,de,Ie)=>Et.onDidChangeDocument(X,de,Ie),onDidSaveTextDocument:(X,de,Ie)=>Et.onDidSaveDocument(X,de,Ie),onWillSaveTextDocument:(X,de,Ie)=>Jt.getOnWillSaveTextDocumentEvent(Me)(X,de,Ie),get notebookDocuments(){return gt.notebookDocuments.map(X=>X.apiNotebook)},async openNotebookDocument(X,de){let Ie;if(k.URI.isUri(X))Ie=X,await gt.openNotebookDocument(X);else if(typeof X=="string")Ie=k.URI.revive(await gt.createNotebookDocument({viewType:X,content:de}));else throw new Error("Invalid arguments");return gt.getNotebookDocument(Ie).apiNotebook},get onDidOpenNotebookDocument(){return gt.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return gt.onDidCloseNotebookDocument},registerNotebookSerializer(X,de,Ie,ot){return gt.registerNotebookSerializer(Me,X,de,Ie,Me.enableProposedApi?ot:void 0)},registerNotebookContentProvider:(X,de,Ie,ot)=>(z.checkProposedApiEnabled(Me),gt.registerNotebookContentProvider(Me,X,de,Ie,Me.enableProposedApi?ot:void 0)),onDidChangeConfiguration:(X,de,Ie)=>gn.onDidChangeConfiguration(X,de,Ie),getConfiguration(X,de){return de=arguments.length===1?void 0:de,gn.getConfiguration(X,de,Me)},registerTextDocumentContentProvider(X,de){return Yt.registerTextDocumentContentProvider(X,de)},registerTaskProvider:(X,de)=>(vt.report("window.registerTaskProvider",Me,"Use the corresponding function on the 'tasks' namespace instead"),Dt.registerTaskProvider(Me,X,de)),registerFileSystemProvider(X,de,Ie){return yn.registerFileSystemProvider(Me.identifier,X,de,Ie,Me.enableProposedApi)},get fs(){return pt.value},registerFileSearchProvider:(X,de)=>(z.checkProposedApiEnabled(Me),It.registerFileSearchProvider(X,de)),registerTextSearchProvider:(X,de)=>(z.checkProposedApiEnabled(Me),It.registerTextSearchProvider(X,de)),registerRemoteAuthorityResolver:(X,de)=>(z.checkProposedApiEnabled(Me),be.registerRemoteAuthorityResolver(X,de)),registerResourceLabelFormatter:X=>(z.checkProposedApiEnabled(Me),tn.$registerResourceLabelFormatter(X)),onDidCreateFiles:(X,de,Ie)=>Mt.onDidCreateFile(X,de,Ie),onDidDeleteFiles:(X,de,Ie)=>Mt.onDidDeleteFile(X,de,Ie),onDidRenameFiles:(X,de,Ie)=>Mt.onDidRenameFile(X,de,Ie),onWillCreateFiles:(X,de,Ie)=>Mt.getOnWillCreateFileEvent(Me)(X,de,Ie),onWillDeleteFiles:(X,de,Ie)=>Mt.getOnWillDeleteFileEvent(Me)(X,de,Ie),onWillRenameFiles:(X,de,Ie)=>Mt.getOnWillRenameFileEvent(Me)(X,de,Ie),openTunnel:X=>(z.checkProposedApiEnabled(Me),st.openTunnel(Me,X).then(de=>{if(!de)throw new Error("cannot open tunnel");return de})),get tunnels(){return z.checkProposedApiEnabled(Me),st.getTunnels()},onDidChangeTunnels:(X,de,Ie)=>(z.checkProposedApiEnabled(Me),st.onDidChangeTunnels(X,de,Ie)),registerPortAttributesProvider:(X,de)=>(z.checkProposedApiEnabled(Me),st.registerPortsAttributesProvider(X,de)),registerTimelineProvider:(X,de)=>(z.checkProposedApiEnabled(Me),Dn.registerTimelineProvider(X,de,Me.identifier,ct.converter)),get isTrusted(){return ye.trusted},requestWorkspaceTrust:X=>(z.checkProposedApiEnabled(Me),ye.requestWorkspaceTrust(X)),onDidGrantWorkspaceTrust:(X,de,Ie)=>ye.onDidGrantWorkspaceTrust(X,de,Ie)},bn={get inputBox(){return vt.report("scm.inputBox",Me,"Use 'SourceControl.inputBox' instead"),hn.getLastInputBox(Me)},createSourceControl(X,de,Ie){return hn.createSourceControl(Me,X,de,Ie)}},$t={createCommentController(X,de){return Sn.createCommentController(Me,X,de)}},Vt={get activeDebugSession(){return dt.activeDebugSession},get activeDebugConsole(){return dt.activeDebugConsole},get breakpoints(){return dt.breakpoints},onDidStartDebugSession(X,de,Ie){return dt.onDidStartDebugSession(X,de,Ie)},onDidTerminateDebugSession(X,de,Ie){return dt.onDidTerminateDebugSession(X,de,Ie)},onDidChangeActiveDebugSession(X,de,Ie){return dt.onDidChangeActiveDebugSession(X,de,Ie)},onDidReceiveDebugSessionCustomEvent(X,de,Ie){return dt.onDidReceiveDebugSessionCustomEvent(X,de,Ie)},onDidChangeBreakpoints(X,de,Ie){return dt.onDidChangeBreakpoints(X,de,Ie)},registerDebugConfigurationProvider(X,de,Ie){return dt.registerDebugConfigurationProvider(X,de,Ie||R.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(X,de){return dt.registerDebugAdapterDescriptorFactory(Me,X,de)},registerDebugAdapterTrackerFactory(X,de){return dt.registerDebugAdapterTrackerFactory(X,de)},startDebugging(X,de,Ie){return!Ie||typeof Ie=="object"&&"configuration"in Ie?dt.startDebugging(X,de,{parentSession:Ie}):dt.startDebugging(X,de,Ie||{})},stopDebugging(X){return dt.stopDebugging(X)},addBreakpoints(X){return dt.addBreakpoints(X)},removeBreakpoints(X){return dt.removeBreakpoints(X)},asDebugSourceUri(X,de){return dt.asDebugSourceUri(X,de)}},Mn={registerTaskProvider:(X,de)=>Dt.registerTaskProvider(Me,X,de),fetchTasks:X=>Dt.fetchTasks(X),executeTask:X=>Dt.executeTask(Me,X),get taskExecutions(){return Dt.taskExecutions},onDidStartTask:(X,de,Ie)=>Dt.onDidStartTask(X,de,Ie),onDidEndTask:(X,de,Ie)=>Dt.onDidEndTask(X,de,Ie),onDidStartTaskProcess:(X,de,Ie)=>Dt.onDidStartTaskProcess(X,de,Ie),onDidEndTaskProcess:(X,de,Ie)=>Dt.onDidEndTaskProcess(X,de,Ie)},un={createNotebookController(X,de,Ie,ot,U){return Zt.createNotebookController(Me,X,de,Ie,ot,Me.enableProposedApi?U:void 0)},registerNotebookCellStatusBarItemProvider:(X,de)=>gt.registerNotebookCellStatusBarItemProvider(Me,X,de),get onDidSaveNotebookDocument(){return z.checkProposedApiEnabled(Me),Gt.onDidSaveNotebookDocument},createNotebookEditorDecorationType(X){return z.checkProposedApiEnabled(Me),Xt.createNotebookEditorDecorationType(X)},createRendererMessaging(X){return z.checkProposedApiEnabled(Me),en.createRendererMessaging(X)},onDidChangeNotebookDocumentMetadata(X,de,Ie){return z.checkProposedApiEnabled(Me),Gt.onDidChangeNotebookDocumentMetadata(X,de,Ie)},onDidChangeNotebookCells(X,de,Ie){return z.checkProposedApiEnabled(Me),gt.onDidChangeNotebookCells(X,de,Ie)},onDidChangeNotebookCellExecutionState(X,de,Ie){return z.checkProposedApiEnabled(Me),gt.onDidChangeNotebookCellExecutionState(X,de,Ie)},onDidChangeCellOutputs(X,de,Ie){return z.checkProposedApiEnabled(Me),gt.onDidChangeCellOutputs(X,de,Ie)},onDidChangeCellMetadata(X,de,Ie){return z.checkProposedApiEnabled(Me),gt.onDidChangeCellMetadata(X,de,Ie)},createConcatTextDocument(X,de){return z.checkProposedApiEnabled(Me),new ve.ExtHostNotebookConcatDocument(gt,Et,X,de)}};return{version:Ye.version,authentication:An,commands:on,comments:$t,debug:Vt,env:pn,extensions:Tn,languages:Rn,notebooks:un,scm:bn,tasks:Mn,test:an,window:Fn,workspace:ln,Breakpoint:R.Breakpoint,CallHierarchyIncomingCall:R.CallHierarchyIncomingCall,CallHierarchyItem:R.CallHierarchyItem,CallHierarchyOutgoingCall:R.CallHierarchyOutgoingCall,CancellationError:T.CancellationError,CancellationTokenSource:m.CancellationTokenSource,CandidatePortSource:o.CandidatePortSource,CodeAction:R.CodeAction,CodeActionKind:R.CodeActionKind,CodeActionTriggerKind:R.CodeActionTriggerKind,CodeLens:R.CodeLens,Color:R.Color,ColorInformation:R.ColorInformation,ColorPresentation:R.ColorPresentation,ColorThemeKind:R.ColorThemeKind,CommentMode:R.CommentMode,CommentThreadCollapsibleState:R.CommentThreadCollapsibleState,CompletionItem:R.CompletionItem,CompletionItemKind:R.CompletionItemKind,CompletionItemTag:R.CompletionItemTag,CompletionList:R.CompletionList,CompletionTriggerKind:R.CompletionTriggerKind,ConfigurationTarget:R.ConfigurationTarget,CustomExecution:R.CustomExecution,DebugAdapterExecutable:R.DebugAdapterExecutable,DebugAdapterInlineImplementation:R.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:R.DebugAdapterNamedPipeServer,DebugAdapterServer:R.DebugAdapterServer,DebugConfigurationProviderTriggerKind:R.DebugConfigurationProviderTriggerKind,DebugConsoleMode:R.DebugConsoleMode,DecorationRangeBehavior:R.DecorationRangeBehavior,Diagnostic:R.Diagnostic,DiagnosticRelatedInformation:R.DiagnosticRelatedInformation,DiagnosticSeverity:R.DiagnosticSeverity,DiagnosticTag:R.DiagnosticTag,Disposable:R.Disposable,DocumentHighlight:R.DocumentHighlight,DocumentHighlightKind:R.DocumentHighlightKind,DocumentLink:R.DocumentLink,DocumentSymbol:R.DocumentSymbol,EndOfLine:R.EndOfLine,EnvironmentVariableMutatorType:R.EnvironmentVariableMutatorType,EvaluatableExpression:R.EvaluatableExpression,InlineValueText:R.InlineValueText,InlineValueVariableLookup:R.InlineValueVariableLookup,InlineValueEvaluatableExpression:R.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:R.InlineCompletionTriggerKind,EventEmitter:S.Emitter,ExtensionKind:R.ExtensionKind,ExtensionMode:R.ExtensionMode,ExternalUriOpenerPriority:R.ExternalUriOpenerPriority,FileChangeType:R.FileChangeType,FileDecoration:R.FileDecoration,FileSystemError:R.FileSystemError,FileType:I.FileType,FilePermission:I.FilePermission,FoldingRange:R.FoldingRange,FoldingRangeKind:R.FoldingRangeKind,FunctionBreakpoint:R.FunctionBreakpoint,InlineCompletionItem:R.InlineSuggestion,InlineCompletionList:R.InlineSuggestions,Hover:R.Hover,IndentAction:C.IndentAction,Location:R.Location,MarkdownString:R.MarkdownString,OverviewRulerLane:_.OverviewRulerLane,ParameterInformation:R.ParameterInformation,PortAutoForwardAction:R.PortAutoForwardAction,Position:R.Position,ProcessExecution:R.ProcessExecution,ProgressLocation:R.ProgressLocation,QuickInputButtons:R.QuickInputButtons,Range:R.Range,RelativePattern:R.RelativePattern,Selection:R.Selection,SelectionRange:R.SelectionRange,SemanticTokens:R.SemanticTokens,SemanticTokensBuilder:R.SemanticTokensBuilder,SemanticTokensEdit:R.SemanticTokensEdit,SemanticTokensEdits:R.SemanticTokensEdits,SemanticTokensLegend:R.SemanticTokensLegend,ShellExecution:R.ShellExecution,ShellQuoting:R.ShellQuoting,SignatureHelp:R.SignatureHelp,SignatureHelpTriggerKind:R.SignatureHelpTriggerKind,SignatureInformation:R.SignatureInformation,SnippetString:R.SnippetString,SourceBreakpoint:R.SourceBreakpoint,StandardTokenType:R.StandardTokenType,StatusBarAlignment:R.StatusBarAlignment,SymbolInformation:R.SymbolInformation,SymbolKind:R.SymbolKind,SymbolTag:R.SymbolTag,Task:R.Task,TaskGroup:R.TaskGroup,TaskPanelKind:R.TaskPanelKind,TaskRevealKind:R.TaskRevealKind,TaskScope:R.TaskScope,TextDocumentSaveReason:R.TextDocumentSaveReason,TextEdit:R.TextEdit,TextEditorCursorStyle:D.TextEditorCursorStyle,TextEditorLineNumbersStyle:R.TextEditorLineNumbersStyle,TextEditorRevealType:R.TextEditorRevealType,TextEditorSelectionChangeKind:R.TextEditorSelectionChangeKind,ThemeColor:R.ThemeColor,ThemeIcon:R.ThemeIcon,TreeItem:R.TreeItem,TreeItemCollapsibleState:R.TreeItemCollapsibleState,UIKind:o.UIKind,Uri:k.URI,ViewColumn:R.ViewColumn,WorkspaceEdit:R.WorkspaceEdit,InlayHint:R.InlayHint,InlayHintKind:R.InlayHintKind,RemoteAuthorityResolverError:R.RemoteAuthorityResolverError,ResolvedAuthority:R.ResolvedAuthority,SourceControlInputBoxValidationType:R.SourceControlInputBoxValidationType,ExtensionRuntime:R.ExtensionRuntime,TimelineItem:R.TimelineItem,NotebookRange:R.NotebookRange,NotebookCellKind:R.NotebookCellKind,NotebookCellExecutionState:R.NotebookCellExecutionState,NotebookCellData:R.NotebookCellData,NotebookData:R.NotebookData,NotebookRendererScript:R.NotebookRendererScript,NotebookCellStatusBarAlignment:R.NotebookCellStatusBarAlignment,NotebookEditorRevealType:R.NotebookEditorRevealType,NotebookCellOutput:R.NotebookCellOutput,NotebookCellOutputItem:R.NotebookCellOutputItem,NotebookCellStatusBarItem:R.NotebookCellStatusBarItem,NotebookControllerAffinity:R.NotebookControllerAffinity,PortAttributes:R.PortAttributes,LinkedEditingRanges:R.LinkedEditingRanges,TestItemStatus:R.TestItemStatus,TestResultState:R.TestResultState,TestMessage:R.TestMessage,TextSearchCompleteMessageType:K.TextSearchCompleteMessageType,TestMessageSeverity:R.TestMessageSeverity,WorkspaceTrustState:R.WorkspaceTrustState}}}e.createApiFactoryAndRegisterActors=Ze}),define(_e[219],Ee([0,1,57,101,30,100,32,71,36,37,104,105,106,74,73,65,70,102,72,45,69,94,63]),function(Z,e,m,T,S,y,k,D,_,C,n,I,o,h,d,c,b,p,w,u,f,g,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),m.registerSingleton(h.IExtensionStoragePaths,h.ExtensionStoragePaths),m.registerSingleton(b.IExtHostApiDeprecationService,b.ExtHostApiDeprecationService),m.registerSingleton(D.IExtHostCommands,D.ExtHostCommands),m.registerSingleton(k.IExtHostConfiguration,k.ExtHostConfiguration),m.registerSingleton(w.IExtHostConsumerFileSystem,w.ExtHostConsumerFileSystem),m.registerSingleton(I.IExtHostDebugService,I.WorkerExtHostDebugService),m.registerSingleton(y.IExtHostDecorations,y.ExtHostDecorations),m.registerSingleton(_.IExtHostDocumentsAndEditors,_.ExtHostDocumentsAndEditors),m.registerSingleton(u.IExtHostFileSystemInfo,u.ExtHostFileSystemInfo),m.registerSingleton(T.IExtHostOutputService,T.ExtHostOutputService),m.registerSingleton(o.IExtHostSearch,o.ExtHostSearch),m.registerSingleton(d.IExtHostStorage,d.ExtHostStorage),m.registerSingleton(n.IExtHostTask,n.WorkerExtHostTask),m.registerSingleton(C.IExtHostTerminalService,C.WorkerExtHostTerminalService),m.registerSingleton(c.IExtHostTunnelService,c.ExtHostTunnelService),m.registerSingleton(p.IExtHostWindow,p.ExtHostWindow),m.registerSingleton(S.IExtHostWorkspace,S.ExtHostWorkspace),m.registerSingleton(f.IExtHostSecretState,f.ExtHostSecretState),m.registerSingleton(g.IExtHostTelemetry,g.ExtHostTelemetry),m.registerSingleton(t.IExtHostEditorTabs,t.ExtHostEditorTabs)}),define(_e[220],Ee([0,1,218,33,214,6,12,4]),function(Z,e,m,T,S,y,k,D){"use strict";var _;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;var C;(function(d){var c;const b=(c=self.trustedTypes)===null||c===void 0?void 0:c.createPolicy("TrustedFunctionWorkaround",{createScript:(w,...u)=>{u.forEach(i=>{var s;if(!((s=self.trustedTypes)===null||s===void 0?void 0:s.isScript(i)))throw new Error("TrustedScripts only, please")});const f=u.slice(0,-1).join(","),g=u.pop().toString();return`(function anonymous(${f}) {
${g}
})`}});function p(...w){return b?self.eval(b.createScript("",...w)):new Function(...w)}d.create=p})(C||(C={}));class n extends S.RequireInterceptor{_installInterceptor(){}getModule(c,b){for(let p of this._alternatives){let w=p(c);if(w){c=w;break}}if(this._factories.has(c))return this._factories.get(c).load(c,b,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class I extends T.AbstractExtHostExtensionService{constructor(){super(...arguments);this.extensionRuntime=y.ExtensionRuntime.Webworker}async _beforeAlmostReadyToRunExtensions(){const c=this._extHostContext.getProxy(D.MainContext.MainThreadConsole);h(c,this._initData.environment.isExtensionDevelopmentDebug);const b=this._instaService.invokeFunction(m.createApiFactoryAndRegisterActors);this._fakeModules=this._instaService.createInstance(n,b,this._registry),await this._fakeModules.install(),performance.mark("code/extHost/didInitAPI"),await this._waitForDebuggerAttachment()}_getEntryPoint(c){return c.browser}async _loadCommonJSModule(c,b,p){var w,u,f,g,t,i,s,r;b=b.with({path:o(b.path,".js")}),c&&performance.mark(`code/extHost/willFetchExtensionCode/${c.value}`);const l=await fetch(b.toString(!0));if(c&&performance.mark(`code/extHost/didFetchExtensionCode/${c.value}`),l.status!==200)throw new Error(l.statusText);const E=await l.text(),v=`${b.toString(!0)}#vscode-extension`,A=`${E}
//# sourceURL=${v}`;let P;try{P=C.create((u=(w=I._ttpExtensionScripts)===null||w===void 0?void 0:w.createScript("module"))!==null&&u!==void 0?u:"module",(g=(f=I._ttpExtensionScripts)===null||f===void 0?void 0:f.createScript("exports"))!==null&&g!==void 0?g:"exports",(i=(t=I._ttpExtensionScripts)===null||t===void 0?void 0:t.createScript("require"))!==null&&i!==void 0?i:"require",(r=(s=I._ttpExtensionScripts)===null||s===void 0?void 0:s.createScript(A))!==null&&r!==void 0?r:A)}catch(W){throw console.error(c?`Loading code for extension ${c.value} failed: ${W.message}`:`Loading code failed: ${W.message}`),console.error(`${b.toString(!0)}${typeof W.line=="number"?` line ${W.line}`:""}${typeof W.column=="number"?` column ${W.column}`:""}`),console.error(W),W}const a={},F={exports:a},N=W=>{const le=this._fakeModules.getModule(W,b);if(le===void 0)throw new Error(`Cannot load module '${W}'`);return le};try{return p.codeLoadingStart(),c&&performance.mark(`code/extHost/willLoadExtensionCode/${c.value}`),P(F,a,N),F.exports!==a?F.exports:a}finally{c&&performance.mark(`code/extHost/didLoadExtensionCode/${c.value}`),p.codeLoadingStop()}}async $setRemoteEnvironment(c){throw new Error("Not supported")}async _waitForDebuggerAttachment(c=5e3){if(!this._initData.environment.isExtensionDevelopmentDebug)return;const b=Date.now()+c;for(;Date.now()<b&&!("__jsDebugIsReady"in globalThis);)await k.timeout(10)}}e.ExtHostExtensionService=I,I._ttpExtensionScripts=(_=self.trustedTypes)===null||_===void 0?void 0:_.createPolicy("ExtensionScripts",{createScript:d=>d});function o(d,c){return d.endsWith(c)?d:d+c}function h(d,c){b("info","log"),b("log","log"),b("warn","warn"),b("error","error");function b(u,f){const g=console[u];console[u]=function(){d.$logExtensionHostMessage({type:"__$console",severity:f,arguments:w(arguments)}),c&&g.apply(console,arguments)}}const p=1e5;function w(u){const f=[],g=[];if(u.length)for(let t=0;t<u.length;t++){if(typeof u[t]=="undefined")u[t]="undefined";else if(u[t]instanceof Error){const i=u[t];i.stack?u[t]=i.stack:u[t]=i.toString()}g.push(u[t])}try{const t=JSON.stringify(g,function(i,s){if(s&&typeof s=="object"){if(f.indexOf(s)!==-1)return"[Circular]";f.push(s)}return s});return t.length>p?"Output omitted for a large object that exceeds the limits":t}catch(t){return`Output omitted for an object that cannot be inspected ('${t.toString()}')`}}}}),define(_e[221],Ee([0,1,57,15,33,220,206]),function(Z,e,m,T,S,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),m.registerSingleton(S.IExtHostExtensionService,y.ExtHostExtensionService),m.registerSingleton(T.ILogService,k.ExtHostLogService)}),define(_e[223],Ee([0,1,23,3,175,215,208,14,75,219,221]),function(Z,e,m,T,S,y,k,D,_){"use strict";var C;Object.defineProperty(e,"__esModule",{value:!0});const n=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const I=postMessage.bind(self);if(self.postMessage=()=>console.trace("'postMessage' has been blocked"),self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const b=(C=self.trustedTypes)===null||C===void 0?void 0:C.createPolicy("extensionHostWorker",{createScriptURL:w=>w}),p=self.Worker;Worker=function(w,u){const f=`importScripts('${w}');`;u=u||{},u.name=u.name||D.basename(w.toString());const g=new Blob([f],{type:"application/javascript"}),t=URL.createObjectURL(g);return new p(b?b.createScriptURL(t):t,u)}}else self.Worker=class extends k.NestedWorker{constructor(b,p){super(I,b,Object.assign({name:D.basename(b.toString())},p))}};const o=new class{exit(b){n()}async exists(b){return!0}async realpath(b){return b}};class h{constructor(){const p=new MessageChannel,w=new T.Emitter;let u=!1;I(p.port2,[p.port2]),p.port1.onmessage=f=>{const{data:g}=f;if(!(g instanceof ArrayBuffer)){console.warn("UNKNOWN data received",g);return}const t=m.VSBuffer.wrap(new Uint8Array(g,0,g.byteLength));if(S.isMessageOfType(t,2)){u=!0,c("received terminate message from renderer");return}w.fire(t)},this.protocol={onMessage:w.event,send:f=>{if(!u){const g=f.buffer.buffer.slice(f.buffer.byteOffset,f.buffer.byteOffset+f.buffer.byteLength);p.port1.postMessage(g,[g])}}}}}function d(b){return new Promise(p=>{const w=b.onMessage(u=>{w.dispose();const f=JSON.parse(u.toString());b.send(S.createMessageOfType(0)),p({protocol:b,initData:f})});b.send(S.createMessageOfType(1))})}let c=b=>n();(function(){const p=new h;_.mark("code/extHost/willConnectToRenderer"),d(p.protocol).then(w=>{_.mark("code/extHost/didWaitForInitData");const u=new y.ExtensionHostMain(w.protocol,w.initData,o,null);c=f=>u.terminate(f)})})()})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/012b14606f75ec4fed90d7ab4154f63dffab9503/core/vs/workbench/services/extensions/worker/extensionHostWorker.js.map
